/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the AArch64 target                         *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 87;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(AArch64InstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(AArch64InstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static AArch64InstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static AArch64InstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(2),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_s8,
  GILLT_s16,
  GILLT_s32,
  GILLT_s64,
  GILLT_s128,
  GILLT_v2s32,
  GILLT_v2s64,
  GILLT_v4s16,
  GILLT_v4s32,
  GILLT_v8s8,
  GILLT_v8s16,
  GILLT_v16s8,
  GILLT_nxv1s1,
  GILLT_nxv2s1,
  GILLT_nxv2s16,
  GILLT_nxv2s32,
  GILLT_nxv2s64,
  GILLT_nxv4s1,
  GILLT_nxv4s16,
  GILLT_nxv4s32,
  GILLT_nxv8s1,
  GILLT_nxv8s16,
  GILLT_nxv16s1,
  GILLT_nxv16s8,
};
const static size_t NumTypeObjects = 24;
const static LLT TypeObjects[] = {
  LLT::scalar(8),
  LLT::scalar(16),
  LLT::scalar(32),
  LLT::scalar(64),
  LLT::scalar(128),
  LLT::vector(ElementCount::getFixed(2), 32),
  LLT::vector(ElementCount::getFixed(2), 64),
  LLT::vector(ElementCount::getFixed(4), 16),
  LLT::vector(ElementCount::getFixed(4), 32),
  LLT::vector(ElementCount::getFixed(8), 8),
  LLT::vector(ElementCount::getFixed(8), 16),
  LLT::vector(ElementCount::getFixed(16), 8),
  LLT::vector(ElementCount::getScalable(1), 1),
  LLT::vector(ElementCount::getScalable(2), 1),
  LLT::vector(ElementCount::getScalable(2), 16),
  LLT::vector(ElementCount::getScalable(2), 32),
  LLT::vector(ElementCount::getScalable(2), 64),
  LLT::vector(ElementCount::getScalable(4), 1),
  LLT::vector(ElementCount::getScalable(4), 16),
  LLT::vector(ElementCount::getScalable(4), 32),
  LLT::vector(ElementCount::getScalable(8), 1),
  LLT::vector(ElementCount::getScalable(8), 16),
  LLT::vector(ElementCount::getScalable(16), 1),
  LLT::vector(ElementCount::getScalable(16), 8),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_HasPAuthBit = 8,
  Feature_HasJSBit = 10,
  Feature_HasComplxNumBit = 60,
  Feature_HasRCPC_IMMOBit = 80,
  Feature_HasFPARMv8Bit = 9,
  Feature_HasNEONBit = 4,
  Feature_HasSM4Bit = 59,
  Feature_HasSHA3Bit = 58,
  Feature_HasSHA2Bit = 19,
  Feature_HasAESBit = 18,
  Feature_HasDotProdBit = 2,
  Feature_HasCRCBit = 12,
  Feature_HasCSSCBit = 20,
  Feature_HasNoCSSCBit = 26,
  Feature_HasLSEBit = 27,
  Feature_HasNoLSEBit = 86,
  Feature_HasRDMBit = 17,
  Feature_HasFullFP16Bit = 15,
  Feature_HasNoFullFP16Bit = 77,
  Feature_HasFP16FMLBit = 7,
  Feature_HasFuseAESBit = 71,
  Feature_HasSVEBit = 23,
  Feature_HasSVEB16B16Bit = 31,
  Feature_HasSVE2Bit = 24,
  Feature_HasSVE2p1Bit = 40,
  Feature_HasSVEAESBit = 34,
  Feature_HasSVE2SM4Bit = 37,
  Feature_HasSVE2SHA3Bit = 84,
  Feature_HasSVE2BitPermBit = 35,
  Feature_HasSMEandIsNonStreamingSafeBit = 52,
  Feature_HasSMEBit = 46,
  Feature_HasSMEF64F64Bit = 48,
  Feature_HasSMEI16I64Bit = 51,
  Feature_HasSMEB16B16Bit = 85,
  Feature_HasSME2andIsNonStreamingSafeBit = 55,
  Feature_HasSME2Bit = 54,
  Feature_HasSME2p1Bit = 57,
  Feature_HasFP8Bit = 21,
  Feature_HasFAMINMAXBit = 22,
  Feature_HasSSVE_FP8FMABit = 43,
  Feature_HasSSVE_FP8DOT2Bit = 38,
  Feature_HasSSVE_FP8DOT4Bit = 44,
  Feature_HasLUTBit = 45,
  Feature_HasSME_LUTv2Bit = 56,
  Feature_HasSMEF8F16Bit = 49,
  Feature_HasSMEF8F32Bit = 47,
  Feature_HasSVEorSMEBit = 0,
  Feature_HasNonStreamingSVEorSME2p2Bit = 36,
  Feature_HasSVE2orSMEBit = 29,
  Feature_HasSVE2orSME2Bit = 42,
  Feature_HasNonStreamingSVE2orSSVE_AESBit = 33,
  Feature_HasSVE2p1_or_HasSMEBit = 53,
  Feature_HasSVE2p1_or_HasSME2Bit = 25,
  Feature_HasSVE2p1_or_HasSME2p1Bit = 41,
  Feature_HasSVE2p2orSME2p2Bit = 28,
  Feature_HasSMEF16F16orSMEF8F16Bit = 50,
  Feature_HasNEONandIsStreamingSafeBit = 5,
  Feature_HasNEONandIsSME2p2StreamingSafeBit = 68,
  Feature_HasRCPCBit = 79,
  Feature_HasFRInt3264Bit = 16,
  Feature_HasMTEBit = 13,
  Feature_HasTMEBit = 11,
  Feature_HasBF16Bit = 3,
  Feature_HasNoBF16Bit = 78,
  Feature_HasMatMulInt8Bit = 6,
  Feature_HasMatMulFP32Bit = 83,
  Feature_HasMatMulFP64Bit = 39,
  Feature_HasLS64Bit = 75,
  Feature_HasHBCBit = 14,
  Feature_HasRCPC3Bit = 76,
  Feature_HasGCSBit = 1,
  Feature_IsLEBit = 66,
  Feature_IsBEBit = 72,
  Feature_UseExperimentalZeroingPseudosBit = 32,
  Feature_UseAlternateSExtLoadCVTF32Bit = 70,
  Feature_UseScalarIncVLBit = 30,
  Feature_NoUseScalarIncVLBit = 82,
  Feature_UseSVEFPLD1RBit = 81,
  Feature_NotForCodeSizeBit = 69,
  Feature_UseSTRQroBit = 67,
  Feature_TailCallX16X17Bit = 62,
  Feature_TailCallX17Bit = 73,
  Feature_TailCallNotX16Bit = 74,
  Feature_TailCallAnyBit = 61,
  Feature_SLSBLRMitigationBit = 65,
  Feature_NoSLSBLRMitigationBit = 64,
  Feature_OptimizedGISelOrOtherSelectorBit = 63,
};

PredicateBitset AArch64InstructionSelector::
computeAvailableModuleFeatures(const AArch64Subtarget *Subtarget) const {
  PredicateBitset Features{};
  if (Subtarget->hasPAuth())
    Features.set(Feature_HasPAuthBit);
  if (Subtarget->hasJS())
    Features.set(Feature_HasJSBit);
  if (Subtarget->hasComplxNum())
    Features.set(Feature_HasComplxNumBit);
  if (Subtarget->hasRCPC_IMMO())
    Features.set(Feature_HasRCPC_IMMOBit);
  if (Subtarget->hasFPARMv8())
    Features.set(Feature_HasFPARMv8Bit);
  if (Subtarget->isNeonAvailable())
    Features.set(Feature_HasNEONBit);
  if (Subtarget->hasSM4())
    Features.set(Feature_HasSM4Bit);
  if (Subtarget->hasSHA3())
    Features.set(Feature_HasSHA3Bit);
  if (Subtarget->hasSHA2())
    Features.set(Feature_HasSHA2Bit);
  if (Subtarget->hasAES())
    Features.set(Feature_HasAESBit);
  if (Subtarget->hasDotProd())
    Features.set(Feature_HasDotProdBit);
  if (Subtarget->hasCRC())
    Features.set(Feature_HasCRCBit);
  if (Subtarget->hasCSSC())
    Features.set(Feature_HasCSSCBit);
  if (!Subtarget->hasCSSC())
    Features.set(Feature_HasNoCSSCBit);
  if (Subtarget->hasLSE())
    Features.set(Feature_HasLSEBit);
  if (!Subtarget->hasLSE())
    Features.set(Feature_HasNoLSEBit);
  if (Subtarget->hasRDM())
    Features.set(Feature_HasRDMBit);
  if (Subtarget->hasFullFP16())
    Features.set(Feature_HasFullFP16Bit);
  if (!Subtarget->hasFullFP16())
    Features.set(Feature_HasNoFullFP16Bit);
  if (Subtarget->hasFP16FML())
    Features.set(Feature_HasFP16FMLBit);
  if (Subtarget->hasFuseAES())
    Features.set(Feature_HasFuseAESBit);
  if (Subtarget->isSVEAvailable())
    Features.set(Feature_HasSVEBit);
  if (Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSVEB16B16())
    Features.set(Feature_HasSVEB16B16Bit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2())
    Features.set(Feature_HasSVE2Bit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2p1())
    Features.set(Feature_HasSVE2p1Bit);
  if (Subtarget->hasSVEAES())
    Features.set(Feature_HasSVEAESBit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2SM4())
    Features.set(Feature_HasSVE2SM4Bit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2SHA3())
    Features.set(Feature_HasSVE2SHA3Bit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2BitPerm())
    Features.set(Feature_HasSVE2BitPermBit);
  if (Subtarget->hasSME())
    Features.set(Feature_HasSMEandIsNonStreamingSafeBit);
  if (Subtarget->isStreaming() && Subtarget->hasSME())
    Features.set(Feature_HasSMEBit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF64F64())
    Features.set(Feature_HasSMEF64F64Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEI16I64())
    Features.set(Feature_HasSMEI16I64Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEB16B16())
    Features.set(Feature_HasSMEB16B16Bit);
  if (Subtarget->hasSME2())
    Features.set(Feature_HasSME2andIsNonStreamingSafeBit);
  if (Subtarget->isStreaming() && Subtarget->hasSME2())
    Features.set(Feature_HasSME2Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSME2p1())
    Features.set(Feature_HasSME2p1Bit);
  if (Subtarget->hasFP8())
    Features.set(Feature_HasFP8Bit);
  if (Subtarget->hasFAMINMAX())
    Features.set(Feature_HasFAMINMAXBit);
  if (Subtarget->hasSSVE_FP8FMA() || (Subtarget->hasSVE2() && Subtarget->hasFP8FMA()))
    Features.set(Feature_HasSSVE_FP8FMABit);
  if (Subtarget->hasSSVE_FP8DOT2() || (Subtarget->hasSVE2() && Subtarget->hasFP8DOT2()))
    Features.set(Feature_HasSSVE_FP8DOT2Bit);
  if (Subtarget->hasSSVE_FP8DOT4() || (Subtarget->hasSVE2() && Subtarget->hasFP8DOT4()))
    Features.set(Feature_HasSSVE_FP8DOT4Bit);
  if (Subtarget->hasLUT())
    Features.set(Feature_HasLUTBit);
  if (Subtarget->isStreaming() && Subtarget->hasSME_LUTv2())
    Features.set(Feature_HasSME_LUTv2Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF8F16())
    Features.set(Feature_HasSMEF8F16Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF8F32())
    Features.set(Feature_HasSMEF8F32Bit);
  if (Subtarget->hasSVE() || (Subtarget->isStreaming() && Subtarget->hasSME()))
    Features.set(Feature_HasSVEorSMEBit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSME2p2()))
    Features.set(Feature_HasNonStreamingSVEorSME2p2Bit);
  if (Subtarget->hasSVE2() || (Subtarget->isStreaming() && Subtarget->hasSME()))
    Features.set(Feature_HasSVE2orSMEBit);
  if (Subtarget->hasSVE2() || (Subtarget->isStreaming() && Subtarget->hasSME2()))
    Features.set(Feature_HasSVE2orSME2Bit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE2()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSSVE_AES()))
    Features.set(Feature_HasNonStreamingSVE2orSSVE_AESBit);
  if (Subtarget->hasSVE2p1() || (Subtarget->isStreaming() && Subtarget->hasSME()))
    Features.set(Feature_HasSVE2p1_or_HasSMEBit);
  if (Subtarget->hasSVE2p1() || (Subtarget->isStreaming() && Subtarget->hasSME2()))
    Features.set(Feature_HasSVE2p1_or_HasSME2Bit);
  if (Subtarget->hasSVE2p1() || (Subtarget->isStreaming() && Subtarget->hasSME2p1()))
    Features.set(Feature_HasSVE2p1_or_HasSME2p1Bit);
  if (Subtarget->isSVEorStreamingSVEAvailable() && (Subtarget->hasSVE2p2() || Subtarget->hasSME2p2()))
    Features.set(Feature_HasSVE2p2orSME2p2Bit);
  if (Subtarget->isStreaming() && (Subtarget->hasSMEF16F16() || Subtarget->hasSMEF8F16()))
    Features.set(Feature_HasSMEF16F16orSMEF8F16Bit);
  if (Subtarget->hasNEON())
    Features.set(Feature_HasNEONandIsStreamingSafeBit);
  if (Subtarget->isNeonAvailable() || (Subtarget->hasNEON() && Subtarget->hasSME2p2()))
    Features.set(Feature_HasNEONandIsSME2p2StreamingSafeBit);
  if (Subtarget->hasRCPC())
    Features.set(Feature_HasRCPCBit);
  if (Subtarget->hasFRInt3264())
    Features.set(Feature_HasFRInt3264Bit);
  if (Subtarget->hasMTE())
    Features.set(Feature_HasMTEBit);
  if (Subtarget->hasTME())
    Features.set(Feature_HasTMEBit);
  if (Subtarget->hasBF16())
    Features.set(Feature_HasBF16Bit);
  if (!Subtarget->hasBF16())
    Features.set(Feature_HasNoBF16Bit);
  if (Subtarget->hasMatMulInt8())
    Features.set(Feature_HasMatMulInt8Bit);
  if (Subtarget->hasMatMulFP32())
    Features.set(Feature_HasMatMulFP32Bit);
  if (Subtarget->hasMatMulFP64())
    Features.set(Feature_HasMatMulFP64Bit);
  if (Subtarget->hasLS64())
    Features.set(Feature_HasLS64Bit);
  if (Subtarget->hasHBC())
    Features.set(Feature_HasHBCBit);
  if (Subtarget->hasRCPC3())
    Features.set(Feature_HasRCPC3Bit);
  if (Subtarget->hasGCS())
    Features.set(Feature_HasGCSBit);
  if (Subtarget->isLittleEndian())
    Features.set(Feature_IsLEBit);
  if (!Subtarget->isLittleEndian())
    Features.set(Feature_IsBEBit);
  if (Subtarget->useExperimentalZeroingPseudos())
    Features.set(Feature_UseExperimentalZeroingPseudosBit);
  if (Subtarget->useAlternateSExtLoadCVTF32Pattern())
    Features.set(Feature_UseAlternateSExtLoadCVTF32Bit);
  if (Subtarget->useScalarIncVL())
    Features.set(Feature_UseScalarIncVLBit);
  if (!Subtarget->useScalarIncVL())
    Features.set(Feature_NoUseScalarIncVLBit);
  if (!Subtarget->noSVEFPLD1R())
    Features.set(Feature_UseSVEFPLD1RBit);
  return Features;
}

void AArch64InstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const AArch64Subtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset AArch64InstructionSelector::
computeAvailableFunctionFeatures(const AArch64Subtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  if (!shouldOptForSize(MF))
    Features.set(Feature_NotForCodeSizeBit);
  if (!Subtarget->isSTRQroSlow() || shouldOptForSize(MF))
    Features.set(Feature_UseSTRQroBit);
  if (  MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && !MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallX16X17Bit);
  if ( MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallX17Bit);
  if ( !MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallNotX16Bit);
  if ( !MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && !MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallAnyBit);
  if ( MF->getSubtarget<AArch64Subtarget>().hardenSlsBlr() )
    Features.set(Feature_SLSBLRMitigationBit);
  if ( !MF->getSubtarget<AArch64Subtarget>().hardenSlsBlr() )
    Features.set(Feature_NoSLSBLRMitigationBit);
  if (!MF->getFunction().hasOptNone() || MF->getProperties().hasProperty(MachineFunctionProperties::Property::FailedISel) || !MF->getProperties().hasProperty(MachineFunctionProperties::Property::Legalized))
    Features.set(Feature_OptimizedGISelOrOtherSelectorBit);
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_HasAES,
  GIFBS_HasBF16,
  GIFBS_HasCRC,
  GIFBS_HasCSSC,
  GIFBS_HasDotProd,
  GIFBS_HasFP8,
  GIFBS_HasFPARMv8,
  GIFBS_HasFRInt3264,
  GIFBS_HasFullFP16,
  GIFBS_HasFuseAES,
  GIFBS_HasGCS,
  GIFBS_HasLSE,
  GIFBS_HasLUT,
  GIFBS_HasMTE,
  GIFBS_HasMatMulInt8,
  GIFBS_HasNEON,
  GIFBS_HasNEONandIsSME2p2StreamingSafe,
  GIFBS_HasNEONandIsStreamingSafe,
  GIFBS_HasNoBF16,
  GIFBS_HasNoCSSC,
  GIFBS_HasNoFullFP16,
  GIFBS_HasNoLSE,
  GIFBS_HasNonStreamingSVEorSME2p2,
  GIFBS_HasPAuth,
  GIFBS_HasRCPC,
  GIFBS_HasRCPC_IMMO,
  GIFBS_HasRDM,
  GIFBS_HasSHA2,
  GIFBS_HasSHA3,
  GIFBS_HasSM4,
  GIFBS_HasSME,
  GIFBS_HasSME2,
  GIFBS_HasSMEB16B16,
  GIFBS_HasSMEF16F16orSMEF8F16,
  GIFBS_HasSMEF64F64,
  GIFBS_HasSMEF8F16,
  GIFBS_HasSMEF8F32,
  GIFBS_HasSMEI16I64,
  GIFBS_HasSMEandIsNonStreamingSafe,
  GIFBS_HasSSVE_FP8DOT2,
  GIFBS_HasSSVE_FP8DOT4,
  GIFBS_HasSSVE_FP8FMA,
  GIFBS_HasSVE,
  GIFBS_HasSVE2,
  GIFBS_HasSVE2BitPerm,
  GIFBS_HasSVE2SHA3,
  GIFBS_HasSVE2SM4,
  GIFBS_HasSVE2orSME,
  GIFBS_HasSVE2p1_or_HasSME,
  GIFBS_HasSVE2p1_or_HasSME2,
  GIFBS_HasSVE2p1_or_HasSME2p1,
  GIFBS_HasSVEB16B16,
  GIFBS_HasSVEorSME,
  GIFBS_HasTME,
  GIFBS_IsBE,
  GIFBS_IsLE,
  GIFBS_OptimizedGISelOrOtherSelector,
  GIFBS_UseSTRQro,
  GIFBS_HasBF16_HasNEON,
  GIFBS_HasBF16_HasNEONandIsStreamingSafe,
  GIFBS_HasBF16_HasSVE,
  GIFBS_HasBF16_HasSVEorSME,
  GIFBS_HasComplxNum_HasNEON,
  GIFBS_HasFAMINMAX_HasNEON,
  GIFBS_HasFAMINMAX_HasSVE2orSME2,
  GIFBS_HasFP16FML_HasNEON,
  GIFBS_HasFP8_HasSVE2orSME2,
  GIFBS_HasFPARMv8_HasJS,
  GIFBS_HasFullFP16_HasNEON,
  GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe,
  GIFBS_HasFullFP16_HasNEONandIsStreamingSafe,
  GIFBS_HasLUT_HasSVE2orSME2,
  GIFBS_HasMatMulFP32_HasSVE,
  GIFBS_HasMatMulFP64_HasSVE,
  GIFBS_HasMatMulFP64_HasSVEorSME,
  GIFBS_HasMatMulInt8_HasSVE,
  GIFBS_HasMatMulInt8_HasSVEorSME,
  GIFBS_HasNEON_HasRCPC3,
  GIFBS_HasNEON_HasRDM,
  GIFBS_HasNonStreamingSVE2orSSVE_AES_HasSVEAES,
  GIFBS_HasSVEorSME_UseScalarIncVL,
  GIFBS_IsLE_UseSTRQro,
  GIFBS_HasComplxNum_HasFullFP16_HasNEON,
  GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_HasAESBit, },
  {Feature_HasBF16Bit, },
  {Feature_HasCRCBit, },
  {Feature_HasCSSCBit, },
  {Feature_HasDotProdBit, },
  {Feature_HasFP8Bit, },
  {Feature_HasFPARMv8Bit, },
  {Feature_HasFRInt3264Bit, },
  {Feature_HasFullFP16Bit, },
  {Feature_HasFuseAESBit, },
  {Feature_HasGCSBit, },
  {Feature_HasLSEBit, },
  {Feature_HasLUTBit, },
  {Feature_HasMTEBit, },
  {Feature_HasMatMulInt8Bit, },
  {Feature_HasNEONBit, },
  {Feature_HasNEONandIsSME2p2StreamingSafeBit, },
  {Feature_HasNEONandIsStreamingSafeBit, },
  {Feature_HasNoBF16Bit, },
  {Feature_HasNoCSSCBit, },
  {Feature_HasNoFullFP16Bit, },
  {Feature_HasNoLSEBit, },
  {Feature_HasNonStreamingSVEorSME2p2Bit, },
  {Feature_HasPAuthBit, },
  {Feature_HasRCPCBit, },
  {Feature_HasRCPC_IMMOBit, },
  {Feature_HasRDMBit, },
  {Feature_HasSHA2Bit, },
  {Feature_HasSHA3Bit, },
  {Feature_HasSM4Bit, },
  {Feature_HasSMEBit, },
  {Feature_HasSME2Bit, },
  {Feature_HasSMEB16B16Bit, },
  {Feature_HasSMEF16F16orSMEF8F16Bit, },
  {Feature_HasSMEF64F64Bit, },
  {Feature_HasSMEF8F16Bit, },
  {Feature_HasSMEF8F32Bit, },
  {Feature_HasSMEI16I64Bit, },
  {Feature_HasSMEandIsNonStreamingSafeBit, },
  {Feature_HasSSVE_FP8DOT2Bit, },
  {Feature_HasSSVE_FP8DOT4Bit, },
  {Feature_HasSSVE_FP8FMABit, },
  {Feature_HasSVEBit, },
  {Feature_HasSVE2Bit, },
  {Feature_HasSVE2BitPermBit, },
  {Feature_HasSVE2SHA3Bit, },
  {Feature_HasSVE2SM4Bit, },
  {Feature_HasSVE2orSMEBit, },
  {Feature_HasSVE2p1_or_HasSMEBit, },
  {Feature_HasSVE2p1_or_HasSME2Bit, },
  {Feature_HasSVE2p1_or_HasSME2p1Bit, },
  {Feature_HasSVEB16B16Bit, },
  {Feature_HasSVEorSMEBit, },
  {Feature_HasTMEBit, },
  {Feature_IsBEBit, },
  {Feature_IsLEBit, },
  {Feature_OptimizedGISelOrOtherSelectorBit, },
  {Feature_UseSTRQroBit, },
  {Feature_HasBF16Bit, Feature_HasNEONBit, },
  {Feature_HasBF16Bit, Feature_HasNEONandIsStreamingSafeBit, },
  {Feature_HasBF16Bit, Feature_HasSVEBit, },
  {Feature_HasBF16Bit, Feature_HasSVEorSMEBit, },
  {Feature_HasComplxNumBit, Feature_HasNEONBit, },
  {Feature_HasFAMINMAXBit, Feature_HasNEONBit, },
  {Feature_HasFAMINMAXBit, Feature_HasSVE2orSME2Bit, },
  {Feature_HasFP16FMLBit, Feature_HasNEONBit, },
  {Feature_HasFP8Bit, Feature_HasSVE2orSME2Bit, },
  {Feature_HasFPARMv8Bit, Feature_HasJSBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONandIsSME2p2StreamingSafeBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONandIsStreamingSafeBit, },
  {Feature_HasLUTBit, Feature_HasSVE2orSME2Bit, },
  {Feature_HasMatMulFP32Bit, Feature_HasSVEBit, },
  {Feature_HasMatMulFP64Bit, Feature_HasSVEBit, },
  {Feature_HasMatMulFP64Bit, Feature_HasSVEorSMEBit, },
  {Feature_HasMatMulInt8Bit, Feature_HasSVEBit, },
  {Feature_HasMatMulInt8Bit, Feature_HasSVEorSMEBit, },
  {Feature_HasNEONBit, Feature_HasRCPC3Bit, },
  {Feature_HasNEONBit, Feature_HasRDMBit, },
  {Feature_HasNonStreamingSVE2orSSVE_AESBit, Feature_HasSVEAESBit, },
  {Feature_HasSVEorSMEBit, Feature_UseScalarIncVLBit, },
  {Feature_IsLEBit, Feature_UseSTRQroBit, },
  {Feature_HasComplxNumBit, Feature_HasFullFP16Bit, Feature_HasNEONBit, },
  {Feature_HasNEONBit, Feature_NotForCodeSizeBit, Feature_UseAlternateSExtLoadCVTF32Bit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
  GICP_gi_addsub_shifted_imm32,
  GICP_gi_addsub_shifted_imm64,
  GICP_gi_am_indexed128,
  GICP_gi_am_indexed16,
  GICP_gi_am_indexed32,
  GICP_gi_am_indexed64,
  GICP_gi_am_indexed8,
  GICP_gi_am_unscaled128,
  GICP_gi_am_unscaled16,
  GICP_gi_am_unscaled32,
  GICP_gi_am_unscaled64,
  GICP_gi_am_unscaled8,
  GICP_gi_arith_extended_reg32_i32,
  GICP_gi_arith_extended_reg32_i64,
  GICP_gi_arith_extended_reg32to64_i64,
  GICP_gi_arith_shifted_reg32,
  GICP_gi_arith_shifted_reg64,
  GICP_gi_extract_high_v16i8,
  GICP_gi_extract_high_v4f32,
  GICP_gi_extract_high_v4i32,
  GICP_gi_extract_high_v8f16,
  GICP_gi_extract_high_v8i16,
  GICP_gi_logical_shifted_reg32,
  GICP_gi_logical_shifted_reg64,
  GICP_gi_neg_addsub_shifted_imm32,
  GICP_gi_neg_addsub_shifted_imm64,
  GICP_gi_ro_Windexed128,
  GICP_gi_ro_Windexed16,
  GICP_gi_ro_Windexed32,
  GICP_gi_ro_Windexed64,
  GICP_gi_ro_Windexed8,
  GICP_gi_ro_Xindexed128,
  GICP_gi_ro_Xindexed16,
  GICP_gi_ro_Xindexed32,
  GICP_gi_ro_Xindexed64,
  GICP_gi_ro_Xindexed8,
};
// See constructor for table contents

AArch64InstructionSelector::ComplexMatcherMemFn
AArch64InstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
  &AArch64InstructionSelector::selectArithImmed, // gi_addsub_shifted_imm32
  &AArch64InstructionSelector::selectArithImmed, // gi_addsub_shifted_imm64
  &AArch64InstructionSelector::selectAddrModeIndexed<128>, // gi_am_indexed128
  &AArch64InstructionSelector::selectAddrModeIndexed<16>, // gi_am_indexed16
  &AArch64InstructionSelector::selectAddrModeIndexed<32>, // gi_am_indexed32
  &AArch64InstructionSelector::selectAddrModeIndexed<64>, // gi_am_indexed64
  &AArch64InstructionSelector::selectAddrModeIndexed<8>, // gi_am_indexed8
  &AArch64InstructionSelector::selectAddrModeUnscaled128, // gi_am_unscaled128
  &AArch64InstructionSelector::selectAddrModeUnscaled16, // gi_am_unscaled16
  &AArch64InstructionSelector::selectAddrModeUnscaled32, // gi_am_unscaled32
  &AArch64InstructionSelector::selectAddrModeUnscaled64, // gi_am_unscaled64
  &AArch64InstructionSelector::selectAddrModeUnscaled8, // gi_am_unscaled8
  &AArch64InstructionSelector::selectArithExtendedRegister, // gi_arith_extended_reg32_i32
  &AArch64InstructionSelector::selectArithExtendedRegister, // gi_arith_extended_reg32_i64
  &AArch64InstructionSelector::selectArithExtendedRegister, // gi_arith_extended_reg32to64_i64
  &AArch64InstructionSelector::selectArithShiftedRegister, // gi_arith_shifted_reg32
  &AArch64InstructionSelector::selectArithShiftedRegister, // gi_arith_shifted_reg64
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v16i8
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v4f32
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v4i32
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v8f16
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v8i16
  &AArch64InstructionSelector::selectLogicalShiftedRegister, // gi_logical_shifted_reg32
  &AArch64InstructionSelector::selectLogicalShiftedRegister, // gi_logical_shifted_reg64
  &AArch64InstructionSelector::selectNegArithImmed, // gi_neg_addsub_shifted_imm32
  &AArch64InstructionSelector::selectNegArithImmed, // gi_neg_addsub_shifted_imm64
  &AArch64InstructionSelector::selectAddrModeWRO<128>, // gi_ro_Windexed128
  &AArch64InstructionSelector::selectAddrModeWRO<16>, // gi_ro_Windexed16
  &AArch64InstructionSelector::selectAddrModeWRO<32>, // gi_ro_Windexed32
  &AArch64InstructionSelector::selectAddrModeWRO<64>, // gi_ro_Windexed64
  &AArch64InstructionSelector::selectAddrModeWRO<8>, // gi_ro_Windexed8
  &AArch64InstructionSelector::selectAddrModeXRO<128>, // gi_ro_Xindexed128
  &AArch64InstructionSelector::selectAddrModeXRO<16>, // gi_ro_Xindexed16
  &AArch64InstructionSelector::selectAddrModeXRO<32>, // gi_ro_Xindexed32
  &AArch64InstructionSelector::selectAddrModeXRO<64>, // gi_ro_Xindexed64
  &AArch64InstructionSelector::selectAddrModeXRO<8>, // gi_ro_Xindexed8
};

// PatFrag predicates.
enum {
  GICXXPred_MI_Predicate_add_and_or_is_add = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_ldaxr_1,
  GICXXPred_MI_Predicate_ldaxr_2,
  GICXXPred_MI_Predicate_ldaxr_4,
  GICXXPred_MI_Predicate_ldaxr_8,
  GICXXPred_MI_Predicate_ldxr_1,
  GICXXPred_MI_Predicate_ldxr_2,
  GICXXPred_MI_Predicate_ldxr_4,
  GICXXPred_MI_Predicate_ldxr_8,
  GICXXPred_MI_Predicate_stlxr_1,
  GICXXPred_MI_Predicate_stlxr_2,
  GICXXPred_MI_Predicate_stlxr_4,
  GICXXPred_MI_Predicate_stlxr_8,
  GICXXPred_MI_Predicate_stxr_1,
  GICXXPred_MI_Predicate_stxr_2,
  GICXXPred_MI_Predicate_stxr_4,
  GICXXPred_MI_Predicate_stxr_8,
};
bool AArch64InstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_add_and_or_is_add: {
    
         // Only handle G_ADD for now. FIXME. build capability to compute whether
         // operands of G_OR have common bits set or not.
         return MI.getOpcode() == TargetOpcode::G_ADD;
      
    llvm_unreachable("add_and_or_is_add should have returned");
  }
  case GICXXPred_MI_Predicate_ldaxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_ldaxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_ldaxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_ldaxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  case GICXXPred_MI_Predicate_ldxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_ldxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_ldxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_ldxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  case GICXXPred_MI_Predicate_stlxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_stlxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_stlxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_stlxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  case GICXXPred_MI_Predicate_stxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_stxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_stxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_stxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_I64_Predicate_VectorIndex0 = GICXXPred_Invalid + 1,
  GICXXPred_I64_Predicate_VectorIndex0_timm,
  GICXXPred_I64_Predicate_VectorIndex1,
  GICXXPred_I64_Predicate_VectorIndex1_timm,
  GICXXPred_I64_Predicate_VectorIndex032b,
  GICXXPred_I64_Predicate_VectorIndex032b_timm,
  GICXXPred_I64_Predicate_VectorIndex132b,
  GICXXPred_I64_Predicate_VectorIndex132b_timm,
  GICXXPred_I64_Predicate_VectorIndexB,
  GICXXPred_I64_Predicate_VectorIndexB32b,
  GICXXPred_I64_Predicate_VectorIndexB32b_timm,
  GICXXPred_I64_Predicate_VectorIndexB_timm,
  GICXXPred_I64_Predicate_VectorIndexD,
  GICXXPred_I64_Predicate_VectorIndexD32b,
  GICXXPred_I64_Predicate_VectorIndexD32b_timm,
  GICXXPred_I64_Predicate_VectorIndexD_timm,
  GICXXPred_I64_Predicate_VectorIndexH,
  GICXXPred_I64_Predicate_VectorIndexH32b,
  GICXXPred_I64_Predicate_VectorIndexH32b_timm,
  GICXXPred_I64_Predicate_VectorIndexH_timm,
  GICXXPred_I64_Predicate_VectorIndexS,
  GICXXPred_I64_Predicate_VectorIndexS32b,
  GICXXPred_I64_Predicate_VectorIndexS32b_timm,
  GICXXPred_I64_Predicate_VectorIndexS_timm,
  GICXXPred_I64_Predicate_complexrotateop,
  GICXXPred_I64_Predicate_complexrotateopodd,
  GICXXPred_I64_Predicate_extq_timm32_0_1m8,
  GICXXPred_I64_Predicate_extq_timm32_0_3m4,
  GICXXPred_I64_Predicate_extq_timm32_0_7m2,
  GICXXPred_I64_Predicate_i64imm_32bit,
  GICXXPred_I64_Predicate_i64imm_32bit_tgt,
  GICXXPred_I64_Predicate_imm0_1,
  GICXXPred_I64_Predicate_imm0_3,
  GICXXPred_I64_Predicate_imm0_7,
  GICXXPred_I64_Predicate_imm0_15,
  GICXXPred_I64_Predicate_imm0_31,
  GICXXPred_I64_Predicate_imm0_63,
  GICXXPred_I64_Predicate_imm0_127,
  GICXXPred_I64_Predicate_imm0_127_64b,
  GICXXPred_I64_Predicate_imm0_255,
  GICXXPred_I64_Predicate_imm32_0_7,
  GICXXPred_I64_Predicate_imm32_0_15,
  GICXXPred_I64_Predicate_imm32_0_31,
  GICXXPred_I64_Predicate_imm64_0_65535,
  GICXXPred_I64_Predicate_maski8_or_more,
  GICXXPred_I64_Predicate_maski16_or_more,
  GICXXPred_I64_Predicate_rprfop,
  GICXXPred_I64_Predicate_s64imm_32bit,
  GICXXPred_I64_Predicate_simm4s1,
  GICXXPred_I64_Predicate_simm4s2,
  GICXXPred_I64_Predicate_simm4s3,
  GICXXPred_I64_Predicate_simm4s4,
  GICXXPred_I64_Predicate_simm4s16,
  GICXXPred_I64_Predicate_simm4s32,
  GICXXPred_I64_Predicate_simm5_8b,
  GICXXPred_I64_Predicate_simm5_8b_tgt,
  GICXXPred_I64_Predicate_simm5_16b,
  GICXXPred_I64_Predicate_simm5_16b_tgt,
  GICXXPred_I64_Predicate_simm5_32b,
  GICXXPred_I64_Predicate_simm5_32b_tgt,
  GICXXPred_I64_Predicate_simm5_64b,
  GICXXPred_I64_Predicate_simm5_64b_tgt,
  GICXXPred_I64_Predicate_simm6_32b,
  GICXXPred_I64_Predicate_simm6s1,
  GICXXPred_I64_Predicate_simm8_32b,
  GICXXPred_I64_Predicate_simm8_64b,
  GICXXPred_I64_Predicate_simm9,
  GICXXPred_I64_Predicate_sme_elm_idx0_0,
  GICXXPred_I64_Predicate_sme_elm_idx0_1,
  GICXXPred_I64_Predicate_sme_elm_idx0_3,
  GICXXPred_I64_Predicate_sme_elm_idx0_7,
  GICXXPred_I64_Predicate_sme_elm_idx0_15,
  GICXXPred_I64_Predicate_svcr_op,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_b,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_b_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_d,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_d_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_h,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_h_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_q,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_q_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_s,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_s_timm,
  GICXXPred_I64_Predicate_sve_incdec_imm,
  GICXXPred_I64_Predicate_sve_pred_enum,
  GICXXPred_I64_Predicate_sve_prfop,
  GICXXPred_I64_Predicate_sve_vec_len_specifier_enum,
  GICXXPred_I64_Predicate_tbz_imm0_31_diag,
  GICXXPred_I64_Predicate_tbz_imm0_31_nodiag,
  GICXXPred_I64_Predicate_tbz_imm32_63,
  GICXXPred_I64_Predicate_timm0_1,
  GICXXPred_I64_Predicate_timm0_31,
  GICXXPred_I64_Predicate_timm0_63,
  GICXXPred_I64_Predicate_timm32_0_0,
  GICXXPred_I64_Predicate_timm32_0_1,
  GICXXPred_I64_Predicate_timm32_0_3,
  GICXXPred_I64_Predicate_timm32_0_7,
  GICXXPred_I64_Predicate_timm32_0_15,
  GICXXPred_I64_Predicate_timm32_0_31,
  GICXXPred_I64_Predicate_timm32_0_255,
  GICXXPred_I64_Predicate_timm32_0_65535,
  GICXXPred_I64_Predicate_timm32_1_1,
  GICXXPred_I64_Predicate_timm32_1_3,
  GICXXPred_I64_Predicate_timm32_1_7,
  GICXXPred_I64_Predicate_timm64_0_65535,
  GICXXPred_I64_Predicate_tuimm5s2,
  GICXXPred_I64_Predicate_tuimm5s4,
  GICXXPred_I64_Predicate_tuimm5s8,
  GICXXPred_I64_Predicate_tvecshiftL8,
  GICXXPred_I64_Predicate_tvecshiftL16,
  GICXXPred_I64_Predicate_tvecshiftL32,
  GICXXPred_I64_Predicate_tvecshiftL64,
  GICXXPred_I64_Predicate_tvecshiftR8,
  GICXXPred_I64_Predicate_tvecshiftR16,
  GICXXPred_I64_Predicate_tvecshiftR32,
  GICXXPred_I64_Predicate_tvecshiftR64,
  GICXXPred_I64_Predicate_ubsan_trap_imm,
  GICXXPred_I64_Predicate_uimm0s2range,
  GICXXPred_I64_Predicate_uimm0s4range,
  GICXXPred_I64_Predicate_uimm1s2range,
  GICXXPred_I64_Predicate_uimm1s4range,
  GICXXPred_I64_Predicate_uimm2s2range,
  GICXXPred_I64_Predicate_uimm2s4range,
  GICXXPred_I64_Predicate_uimm3s2range,
  GICXXPred_I64_Predicate_uimm3s8,
  GICXXPred_I64_Predicate_uimm5s2,
  GICXXPred_I64_Predicate_uimm5s4,
  GICXXPred_I64_Predicate_uimm5s8,
  GICXXPred_I64_Predicate_uimm6,
  GICXXPred_I64_Predicate_uimm6_32b,
  GICXXPred_I64_Predicate_uimm6_64b,
  GICXXPred_I64_Predicate_uimm6s1,
  GICXXPred_I64_Predicate_uimm6s2,
  GICXXPred_I64_Predicate_uimm6s4,
  GICXXPred_I64_Predicate_uimm6s8,
  GICXXPred_I64_Predicate_uimm6s16,
  GICXXPred_I64_Predicate_uimm8_32b,
  GICXXPred_I64_Predicate_uimm8_64b,
  GICXXPred_I64_Predicate_uimm16,
  GICXXPred_I64_Predicate_vecshiftL8,
  GICXXPred_I64_Predicate_vecshiftL16,
  GICXXPred_I64_Predicate_vecshiftL32,
  GICXXPred_I64_Predicate_vecshiftL64,
  GICXXPred_I64_Predicate_vecshiftR8,
  GICXXPred_I64_Predicate_vecshiftR16,
  GICXXPred_I64_Predicate_vecshiftR16Narrow,
  GICXXPred_I64_Predicate_vecshiftR32,
  GICXXPred_I64_Predicate_vecshiftR32Narrow,
  GICXXPred_I64_Predicate_vecshiftR64,
  GICXXPred_I64_Predicate_vecshiftR64Narrow,
};
bool AArch64InstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GICXXPred_I64_Predicate_VectorIndex0: {
     return ((uint64_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex0_timm: {
     return ((uint64_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex1: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndex1_timm: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndex032b: {
     return ((uint32_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex032b_timm: {
     return ((uint32_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex132b: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndex132b_timm: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB32b: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB32b_timm: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB_timm: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD32b: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD32b_timm: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD_timm: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH32b: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH32b_timm: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH_timm: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS32b: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS32b_timm: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS_timm: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_complexrotateop: {
     return Imm >= 0 && Imm <= 270;  
  }
  case GICXXPred_I64_Predicate_complexrotateopodd: {
     return Imm >= 0 && Imm <= 270;  
  }
  case GICXXPred_I64_Predicate_extq_timm32_0_1m8: {
    
      return ((uint32_t)Imm) < 2;
  }
  case GICXXPred_I64_Predicate_extq_timm32_0_3m4: {
    
      return ((uint32_t)Imm) < 4;
  }
  case GICXXPred_I64_Predicate_extq_timm32_0_7m2: {
    
      return ((uint32_t)Imm) < 8;
  }
  case GICXXPred_I64_Predicate_i64imm_32bit: {
    
      return (Imm & 0xffffffffULL) == static_cast<uint64_t>(Imm);
    
  }
  case GICXXPred_I64_Predicate_i64imm_32bit_tgt: {
    
      return (Imm & 0xffffffffULL) == static_cast<uint64_t>(Imm);
    
  }
  case GICXXPred_I64_Predicate_imm0_1: {
    
      return ((uint64_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_imm0_3: {
    
      return ((uint64_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_imm0_7: {
    
      return ((uint64_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_imm0_15: {
    
      return ((uint64_t)Imm) < 16;
    
  }
  case GICXXPred_I64_Predicate_imm0_31: {
    
      return ((uint64_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_imm0_63: {
    
      return ((uint64_t)Imm) < 64;
    
  }
  case GICXXPred_I64_Predicate_imm0_127: {
    
      return ((uint32_t)Imm) < 128;
    
  }
  case GICXXPred_I64_Predicate_imm0_127_64b: {
    
      return ((uint64_t)Imm) < 128;
    
  }
  case GICXXPred_I64_Predicate_imm0_255: {
    
      return ((uint32_t)Imm) < 256;
    
  }
  case GICXXPred_I64_Predicate_imm32_0_7: {
    
      return ((uint32_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_imm32_0_15: {
    
      return ((uint32_t)Imm) < 16;
    
  }
  case GICXXPred_I64_Predicate_imm32_0_31: {
    
      return ((uint64_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_imm64_0_65535: {
    
      return ((uint64_t)Imm) < 65536;
    
  }
  case GICXXPred_I64_Predicate_maski8_or_more: {
     return (Imm & 0xff) == 0xff; 
  }
  case GICXXPred_I64_Predicate_maski16_or_more: {
     return (Imm & 0xffff) == 0xffff; 
  }
  case GICXXPred_I64_Predicate_rprfop: {
    
        return (((uint32_t)Imm) <= 63);
      
  }
  case GICXXPred_I64_Predicate_s64imm_32bit: {
    
      int64_t Imm64 = static_cast<int64_t>(Imm);
      return Imm64 >= std::numeric_limits<int32_t>::min() &&
             Imm64 <= std::numeric_limits<int32_t>::max();
    
    llvm_unreachable("s64imm_32bit should have returned");
  }
  case GICXXPred_I64_Predicate_simm4s1: {
     return Imm >=-8  && Imm <= 7; 
  }
  case GICXXPred_I64_Predicate_simm4s2: {
     return Imm >=-16  && Imm <= 14 && (Imm % 2) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s3: {
     return Imm >=-24  && Imm <= 21 && (Imm % 3) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s4: {
     return Imm >=-32  && Imm <= 28 && (Imm % 4) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s16: {
     return Imm >=-128  && Imm <= 112 && (Imm % 16) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s32: {
     return Imm >=-256  && Imm <= 224 && (Imm % 32) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm5_8b: {
     return (int8_t)Imm >= -16 && (int8_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_8b_tgt: {
     return (int8_t)Imm >= -16 && (int8_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_16b: {
     return (int16_t)Imm >= -16 && (int16_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_16b_tgt: {
     return (int16_t)Imm >= -16 && (int16_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_32b: {
     return Imm >= -16 && Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_32b_tgt: {
     return (int32_t)Imm >= -16 && (int32_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_64b: {
     return Imm >= -16 && Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_64b_tgt: {
     return (int64_t)Imm >= -16 && (int64_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm6_32b: {
     return Imm >= -32 && Imm < 32; 
  }
  case GICXXPred_I64_Predicate_simm6s1: {
     return Imm >= -32 && Imm < 32; 
  }
  case GICXXPred_I64_Predicate_simm8_32b: {
     return Imm >= -128 && Imm < 128; 
  }
  case GICXXPred_I64_Predicate_simm8_64b: {
     return Imm >= -128 && Imm < 128; 
  }
  case GICXXPred_I64_Predicate_simm9: {
     return Imm >= -256 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_0: {
    
      return ((uint32_t)Imm) == 0;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_1: {
    
      return ((uint32_t)Imm) <= 1;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_3: {
    
      return ((uint32_t)Imm) <= 3;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_7: {
    
      return ((uint32_t)Imm) <= 7;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_15: {
    
      return ((uint32_t)Imm) <= 15;
    
  }
  case GICXXPred_I64_Predicate_svcr_op: {
    
        return AArch64SVCR::lookupSVCRByEncoding(Imm) != nullptr;
      
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_b: {
     return ((uint64_t)Imm) < 64; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_b_timm: {
     return ((uint64_t)Imm) < 64; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_d: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_d_timm: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_h: {
     return ((uint64_t)Imm) < 32; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_h_timm: {
     return ((uint64_t)Imm) < 32; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_q: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_q_timm: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_s: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_s_timm: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_sve_incdec_imm: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_sve_pred_enum: {
    
      return (((uint32_t)Imm) < 32);
      
  }
  case GICXXPred_I64_Predicate_sve_prfop: {
    
        return (((uint32_t)Imm) <= 15);
      
  }
  case GICXXPred_I64_Predicate_sve_vec_len_specifier_enum: {
    
      return (((uint32_t)Imm) < 2);
      
  }
  case GICXXPred_I64_Predicate_tbz_imm0_31_diag: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_tbz_imm0_31_nodiag: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_tbz_imm32_63: {
    
      return (((uint32_t)Imm) > 31) && (((uint32_t)Imm) < 64);
    
  }
  case GICXXPred_I64_Predicate_timm0_1: {
    
      return ((uint64_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_timm0_31: {
    
      return ((uint64_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_timm0_63: {
    
      return ((uint64_t)Imm) < 64;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_0: {
    
      return ((uint32_t)Imm) == 0;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_1: {
    
      return ((uint32_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_3: {
    
      return ((uint32_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_7: {
    
      return ((uint32_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_15: {
    
      return ((uint32_t)Imm) < 16;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_31: {
    
      return ((uint32_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_255: {
    
      return ((uint32_t)Imm) < 256;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_65535: {
    
      return ((uint32_t)Imm) < 65536;
    
  }
  case GICXXPred_I64_Predicate_timm32_1_1: {
    
        return ((uint32_t)Imm) == 1;
    
  }
  case GICXXPred_I64_Predicate_timm32_1_3: {
    
      return ((uint32_t)Imm) > 0 && ((uint32_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_timm32_1_7: {
    
      return ((uint32_t)Imm) > 0 && ((uint32_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_timm64_0_65535: {
    
      return ((uint64_t)Imm) < 65536;
    
  }
  case GICXXPred_I64_Predicate_tuimm5s2: {
     return Imm >= 0 && Imm < (32*2) && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_tuimm5s4: {
     return Imm >= 0 && Imm < (32*4) && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_tuimm5s8: {
     return Imm >= 0 && Imm < (32*8) && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_tvecshiftL8: {
    
      return (((uint32_t)Imm) < 8);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftL16: {
    
      return (((uint32_t)Imm) < 16);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftL32: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftL64: {
    
      return (((uint32_t)Imm) < 64);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR8: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 9);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR16: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR32: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 33);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR64: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 65);
    
  }
  case GICXXPred_I64_Predicate_ubsan_trap_imm: {
    
      return isUInt<8>(Imm);
    
  }
  case GICXXPred_I64_Predicate_uimm0s2range: {
     return Imm == 0; 
  }
  case GICXXPred_I64_Predicate_uimm0s4range: {
     return Imm == 0; 
  }
  case GICXXPred_I64_Predicate_uimm1s2range: {
     return Imm >= 0 && Imm <= 2 && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm1s4range: {
     return Imm >= 0 && Imm <= 4 && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm2s2range: {
     return Imm >= 0 && Imm <= 6 && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm2s4range: {
     return Imm >= 0 && Imm <= 12 && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm3s2range: {
     return Imm >= 0 && Imm <= 14 && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm3s8: {
     return Imm >= 0 && Imm <= 56 && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm5s2: {
     return Imm >= 0 && Imm < (32*2) && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm5s4: {
     return Imm >= 0 && Imm < (32*4) && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm5s8: {
     return Imm >= 0 && Imm < (32*8) && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6_32b: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6_64b: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6s1: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6s2: {
     return Imm >= 0 && Imm < (64*2) && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6s4: {
     return Imm >= 0 && Imm < (64*4) && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6s8: {
     return Imm >= 0 && Imm < (64*8) && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6s16: {
     return Imm >= 0 && Imm < (64*16) && ((Imm % 16) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm8_32b: {
     return Imm >= 0 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_uimm8_64b: {
     return Imm >= 0 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_uimm16: {
    return Imm >= 0 && Imm < 65536;
  }
  case GICXXPred_I64_Predicate_vecshiftL8: {
    
      return (((uint32_t)Imm) < 8);
    
  }
  case GICXXPred_I64_Predicate_vecshiftL16: {
    
      return (((uint32_t)Imm) < 16);
    
  }
  case GICXXPred_I64_Predicate_vecshiftL32: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_vecshiftL64: {
    
      return (((uint32_t)Imm) < 64);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR8: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 9);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR16: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR16Narrow: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 9);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR32: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 33);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR32Narrow: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR64: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 65);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR64Narrow: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 33);
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APFloat_Predicate_fpimm0 = GICXXPred_Invalid + 1,
  GICXXPred_APFloat_Predicate_fpimm16,
  GICXXPred_APFloat_Predicate_fpimm32,
  GICXXPred_APFloat_Predicate_fpimm32SIMDModImmType4,
  GICXXPred_APFloat_Predicate_fpimm64,
  GICXXPred_APFloat_Predicate_fpimm_half,
  GICXXPred_APFloat_Predicate_fpimm_minus0,
  GICXXPred_APFloat_Predicate_fpimm_one,
  GICXXPred_APFloat_Predicate_fpimm_two,
  GICXXPred_APFloat_Predicate_fpimmbf16,
  GICXXPred_APFloat_Predicate_simdimmtype10,
};
bool AArch64InstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APFloat_Predicate_fpimm0: {
    
      return Imm.isExactlyValue(+0.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm16: {
    
          return AArch64_AM::getFP16Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_fpimm32: {
    
          return AArch64_AM::getFP32Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_fpimm32SIMDModImmType4: {
    
          uint64_t Enc = Imm.bitcastToAPInt().getZExtValue();
          return Enc != 0 && AArch64_AM::isAdvSIMDModImmType4(Enc << 32 | Enc);
        
    llvm_unreachable("fpimm32SIMDModImmType4 should have returned");
  }
  case GICXXPred_APFloat_Predicate_fpimm64: {
    
          return AArch64_AM::getFP64Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_fpimm_half: {
    
      return Imm.isExactlyValue(+0.5);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_minus0: {
    
      return Imm.isExactlyValue(-0.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_one: {
    
      return Imm.isExactlyValue(+1.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_two: {
    
      return Imm.isExactlyValue(+2.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimmbf16: {
    
          return AArch64_AM::getFP16Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_simdimmtype10: {
    
          return AArch64_AM::isAdvSIMDModImmType10(
                     Imm.bitcastToAPInt().getZExtValue());
        
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APInt_Predicate_logical_imm32 = GICXXPred_Invalid + 1,
  GICXXPred_APInt_Predicate_logical_imm64,
};
bool AArch64InstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APInt_Predicate_logical_imm32: {
    
      return AArch64_AM::isLogicalImmediate(Imm.getZExtValue(), 32);
    
  }
  case GICXXPred_APInt_Predicate_logical_imm64: {
    
      return AArch64_AM::isLogicalImmediate(Imm.getZExtValue(), 64);
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AArch64InstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("AArch64InstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
  GICR_renderFPImm16,
  GICR_renderFPImm32,
  GICR_renderFPImm32SIMDModImmType4,
  GICR_renderFPImm64,
  GICR_renderLogicalImm32,
  GICR_renderLogicalImm64,
  GICR_renderTruncImm,
  GICR_renderUbsanTrap,
};
AArch64InstructionSelector::CustomRendererFn
AArch64InstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
  &AArch64InstructionSelector::renderFPImm16,
  &AArch64InstructionSelector::renderFPImm32,
  &AArch64InstructionSelector::renderFPImm32SIMDModImmType4,
  &AArch64InstructionSelector::renderFPImm64,
  &AArch64InstructionSelector::renderLogicalImm32,
  &AArch64InstructionSelector::renderLogicalImm64,
  &AArch64InstructionSelector::renderTruncImm,
  &AArch64InstructionSelector::renderUbsanTrap,
};

bool AArch64InstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool AArch64InstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("AArch64InstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *AArch64InstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
    GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(836), /*)*//*default:*//*Label 154*/ GIMT_Encode4(432595),
    /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(3142),
    /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(34645),
    /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(47993),
    /*TargetOpcode::G_SDIV*//*Label 3*/ GIMT_Encode4(49822),
    /*TargetOpcode::G_UDIV*//*Label 4*/ GIMT_Encode4(49904), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_AND*//*Label 5*/ GIMT_Encode4(49986),
    /*TargetOpcode::G_OR*//*Label 6*/ GIMT_Encode4(57732),
    /*TargetOpcode::G_XOR*//*Label 7*/ GIMT_Encode4(69779), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_CONCAT_VECTORS*//*Label 8*/ GIMT_Encode4(75718), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_BITCAST*//*Label 9*/ GIMT_Encode4(83159), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_INTRINSIC_TRUNC*//*Label 10*/ GIMT_Encode4(95615),
    /*TargetOpcode::G_INTRINSIC_ROUND*//*Label 11*/ GIMT_Encode4(97038),
    /*TargetOpcode::G_INTRINSIC_LRINT*//*Label 12*/ GIMT_Encode4(98461),
    /*TargetOpcode::G_INTRINSIC_LLRINT*//*Label 13*/ GIMT_Encode4(98729),
    /*TargetOpcode::G_INTRINSIC_ROUNDEVEN*//*Label 14*/ GIMT_Encode4(98879),
    /*TargetOpcode::G_READCYCLECOUNTER*//*Label 15*/ GIMT_Encode4(100302), GIMT_Encode4(0),
    /*TargetOpcode::G_LOAD*//*Label 16*/ GIMT_Encode4(100335),
    /*TargetOpcode::G_SEXTLOAD*//*Label 17*/ GIMT_Encode4(109401),
    /*TargetOpcode::G_ZEXTLOAD*//*Label 18*/ GIMT_Encode4(110493), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_STORE*//*Label 19*/ GIMT_Encode4(113507), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_ATOMIC_CMPXCHG*//*Label 20*/ GIMT_Encode4(127584),
    /*TargetOpcode::G_ATOMICRMW_XCHG*//*Label 21*/ GIMT_Encode4(128935),
    /*TargetOpcode::G_ATOMICRMW_ADD*//*Label 22*/ GIMT_Encode4(129927),
    /*TargetOpcode::G_ATOMICRMW_SUB*//*Label 23*/ GIMT_Encode4(130919),
    /*TargetOpcode::G_ATOMICRMW_AND*//*Label 24*/ GIMT_Encode4(132411), GIMT_Encode4(0),
    /*TargetOpcode::G_ATOMICRMW_OR*//*Label 25*/ GIMT_Encode4(133903),
    /*TargetOpcode::G_ATOMICRMW_XOR*//*Label 26*/ GIMT_Encode4(134895),
    /*TargetOpcode::G_ATOMICRMW_MAX*//*Label 27*/ GIMT_Encode4(135887),
    /*TargetOpcode::G_ATOMICRMW_MIN*//*Label 28*/ GIMT_Encode4(136879),
    /*TargetOpcode::G_ATOMICRMW_UMAX*//*Label 29*/ GIMT_Encode4(137871),
    /*TargetOpcode::G_ATOMICRMW_UMIN*//*Label 30*/ GIMT_Encode4(138863), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_FENCE*//*Label 31*/ GIMT_Encode4(139855), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_INTRINSIC*//*Label 32*/ GIMT_Encode4(139906),
    /*TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS*//*Label 33*/ GIMT_Encode4(252761), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_ANYEXT*//*Label 34*/ GIMT_Encode4(261776),
    /*TargetOpcode::G_TRUNC*//*Label 35*/ GIMT_Encode4(262066),
    /*TargetOpcode::G_CONSTANT*//*Label 36*/ GIMT_Encode4(263269),
    /*TargetOpcode::G_FCONSTANT*//*Label 37*/ GIMT_Encode4(263389), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_SEXT*//*Label 38*/ GIMT_Encode4(263678),
    /*TargetOpcode::G_SEXT_INREG*//*Label 39*/ GIMT_Encode4(265576),
    /*TargetOpcode::G_ZEXT*//*Label 40*/ GIMT_Encode4(267230),
    /*TargetOpcode::G_SHL*//*Label 41*/ GIMT_Encode4(270009),
    /*TargetOpcode::G_LSHR*//*Label 42*/ GIMT_Encode4(270789),
    /*TargetOpcode::G_ASHR*//*Label 43*/ GIMT_Encode4(271182), GIMT_Encode4(0),
    /*TargetOpcode::G_FSHR*//*Label 44*/ GIMT_Encode4(271958),
    /*TargetOpcode::G_ROTR*//*Label 45*/ GIMT_Encode4(272088), GIMT_Encode4(0),
    /*TargetOpcode::G_ICMP*//*Label 46*/ GIMT_Encode4(272581), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_SELECT*//*Label 47*/ GIMT_Encode4(277157), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_UMULH*//*Label 48*/ GIMT_Encode4(277885),
    /*TargetOpcode::G_SMULH*//*Label 49*/ GIMT_Encode4(278369),
    /*TargetOpcode::G_UADDSAT*//*Label 50*/ GIMT_Encode4(278853),
    /*TargetOpcode::G_SADDSAT*//*Label 51*/ GIMT_Encode4(279283),
    /*TargetOpcode::G_USUBSAT*//*Label 52*/ GIMT_Encode4(279713),
    /*TargetOpcode::G_SSUBSAT*//*Label 53*/ GIMT_Encode4(280143), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_FADD*//*Label 54*/ GIMT_Encode4(280573),
    /*TargetOpcode::G_FSUB*//*Label 55*/ GIMT_Encode4(283737),
    /*TargetOpcode::G_FMUL*//*Label 56*/ GIMT_Encode4(285825),
    /*TargetOpcode::G_FMA*//*Label 57*/ GIMT_Encode4(291287), GIMT_Encode4(0),
    /*TargetOpcode::G_FDIV*//*Label 58*/ GIMT_Encode4(307560), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_FNEG*//*Label 59*/ GIMT_Encode4(309453),
    /*TargetOpcode::G_FPEXT*//*Label 60*/ GIMT_Encode4(313333),
    /*TargetOpcode::G_FPTRUNC*//*Label 61*/ GIMT_Encode4(313697),
    /*TargetOpcode::G_FPTOSI*//*Label 62*/ GIMT_Encode4(314017),
    /*TargetOpcode::G_FPTOUI*//*Label 63*/ GIMT_Encode4(315080),
    /*TargetOpcode::G_SITOFP*//*Label 64*/ GIMT_Encode4(316143),
    /*TargetOpcode::G_UITOFP*//*Label 65*/ GIMT_Encode4(320420),
    /*TargetOpcode::G_FPTOSI_SAT*//*Label 66*/ GIMT_Encode4(324075),
    /*TargetOpcode::G_FPTOUI_SAT*//*Label 67*/ GIMT_Encode4(324395),
    /*TargetOpcode::G_FABS*//*Label 68*/ GIMT_Encode4(324715), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_FCANONICALIZE*//*Label 69*/ GIMT_Encode4(325919),
    /*TargetOpcode::G_FMINNUM*//*Label 70*/ GIMT_Encode4(326201),
    /*TargetOpcode::G_FMAXNUM*//*Label 71*/ GIMT_Encode4(326579),
    /*TargetOpcode::G_FMINNUM_IEEE*//*Label 72*/ GIMT_Encode4(326957),
    /*TargetOpcode::G_FMAXNUM_IEEE*//*Label 73*/ GIMT_Encode4(327307),
    /*TargetOpcode::G_FMINIMUM*//*Label 74*/ GIMT_Encode4(327657),
    /*TargetOpcode::G_FMAXIMUM*//*Label 75*/ GIMT_Encode4(328360), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_SMIN*//*Label 76*/ GIMT_Encode4(329063),
    /*TargetOpcode::G_SMAX*//*Label 77*/ GIMT_Encode4(329467),
    /*TargetOpcode::G_UMIN*//*Label 78*/ GIMT_Encode4(329871),
    /*TargetOpcode::G_UMAX*//*Label 79*/ GIMT_Encode4(330275),
    /*TargetOpcode::G_ABS*//*Label 80*/ GIMT_Encode4(330679),
    /*TargetOpcode::G_LROUND*//*Label 81*/ GIMT_Encode4(331494),
    /*TargetOpcode::G_LLROUND*//*Label 82*/ GIMT_Encode4(331660),
    /*TargetOpcode::G_BR*//*Label 83*/ GIMT_Encode4(331759), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_EXTRACT_SUBVECTOR*//*Label 84*/ GIMT_Encode4(331775),
    /*TargetOpcode::G_INSERT_VECTOR_ELT*//*Label 85*/ GIMT_Encode4(337231),
    /*TargetOpcode::G_EXTRACT_VECTOR_ELT*//*Label 86*/ GIMT_Encode4(369084), GIMT_Encode4(0),
    /*TargetOpcode::G_SPLAT_VECTOR*//*Label 87*/ GIMT_Encode4(372635), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_CTTZ*//*Label 88*/ GIMT_Encode4(374925), GIMT_Encode4(0),
    /*TargetOpcode::G_CTLZ*//*Label 89*/ GIMT_Encode4(375077), GIMT_Encode4(0),
    /*TargetOpcode::G_CTPOP*//*Label 90*/ GIMT_Encode4(375751),
    /*TargetOpcode::G_BSWAP*//*Label 91*/ GIMT_Encode4(375911),
    /*TargetOpcode::G_BITREVERSE*//*Label 92*/ GIMT_Encode4(376225),
    /*TargetOpcode::G_FCEIL*//*Label 93*/ GIMT_Encode4(376379), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_FSQRT*//*Label 94*/ GIMT_Encode4(377802),
    /*TargetOpcode::G_FFLOOR*//*Label 95*/ GIMT_Encode4(378102),
    /*TargetOpcode::G_FRINT*//*Label 96*/ GIMT_Encode4(379525),
    /*TargetOpcode::G_FNEARBYINT*//*Label 97*/ GIMT_Encode4(380948), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_STRICT_FADD*//*Label 98*/ GIMT_Encode4(382371),
    /*TargetOpcode::G_STRICT_FSUB*//*Label 99*/ GIMT_Encode4(384774),
    /*TargetOpcode::G_STRICT_FMUL*//*Label 100*/ GIMT_Encode4(386667),
    /*TargetOpcode::G_STRICT_FDIV*//*Label 101*/ GIMT_Encode4(391682), GIMT_Encode4(0),
    /*TargetOpcode::G_STRICT_FMA*//*Label 102*/ GIMT_Encode4(393575),
    /*TargetOpcode::G_STRICT_FSQRT*//*Label 103*/ GIMT_Encode4(409182), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_TRAP*//*Label 104*/ GIMT_Encode4(409482),
    /*TargetOpcode::G_DEBUGTRAP*//*Label 105*/ GIMT_Encode4(409496),
    /*TargetOpcode::G_UBSANTRAP*//*Label 106*/ GIMT_Encode4(409517), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_VECREDUCE_FADD*//*Label 107*/ GIMT_Encode4(409542), GIMT_Encode4(0),
    /*TargetOpcode::G_VECREDUCE_FMAX*//*Label 108*/ GIMT_Encode4(409852),
    /*TargetOpcode::G_VECREDUCE_FMIN*//*Label 109*/ GIMT_Encode4(410023),
    /*TargetOpcode::G_VECREDUCE_FMAXIMUM*//*Label 110*/ GIMT_Encode4(410194),
    /*TargetOpcode::G_VECREDUCE_FMINIMUM*//*Label 111*/ GIMT_Encode4(410365),
    /*TargetOpcode::G_VECREDUCE_ADD*//*Label 112*/ GIMT_Encode4(410536), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_VECREDUCE_SMAX*//*Label 113*/ GIMT_Encode4(411665),
    /*TargetOpcode::G_VECREDUCE_SMIN*//*Label 114*/ GIMT_Encode4(411868),
    /*TargetOpcode::G_VECREDUCE_UMAX*//*Label 115*/ GIMT_Encode4(412071),
    /*TargetOpcode::G_VECREDUCE_UMIN*//*Label 116*/ GIMT_Encode4(412274), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*AArch64::G_AARCH64_PREFETCH*//*Label 117*/ GIMT_Encode4(412477), GIMT_Encode4(0),
    /*AArch64::G_BSP*//*Label 118*/ GIMT_Encode4(412617),
    /*AArch64::G_DUP*//*Label 119*/ GIMT_Encode4(413157),
    /*AArch64::G_DUPLANE16*//*Label 120*/ GIMT_Encode4(415248),
    /*AArch64::G_DUPLANE32*//*Label 121*/ GIMT_Encode4(415569),
    /*AArch64::G_DUPLANE64*//*Label 122*/ GIMT_Encode4(415824),
    /*AArch64::G_DUPLANE8*//*Label 123*/ GIMT_Encode4(415970),
    /*AArch64::G_EXT*//*Label 124*/ GIMT_Encode4(416149),
    /*AArch64::G_FCMEQ*//*Label 125*/ GIMT_Encode4(417980),
    /*AArch64::G_FCMEQZ*//*Label 126*/ GIMT_Encode4(418319),
    /*AArch64::G_FCMGE*//*Label 127*/ GIMT_Encode4(418549),
    /*AArch64::G_FCMGEZ*//*Label 128*/ GIMT_Encode4(419213),
    /*AArch64::G_FCMGT*//*Label 129*/ GIMT_Encode4(419443),
    /*AArch64::G_FCMGTZ*//*Label 130*/ GIMT_Encode4(420107),
    /*AArch64::G_FCMLEZ*//*Label 131*/ GIMT_Encode4(420337),
    /*AArch64::G_FCMLTZ*//*Label 132*/ GIMT_Encode4(420567),
    /*AArch64::G_REV16*//*Label 133*/ GIMT_Encode4(420797),
    /*AArch64::G_REV32*//*Label 134*/ GIMT_Encode4(420875),
    /*AArch64::G_REV64*//*Label 135*/ GIMT_Encode4(421075),
    /*AArch64::G_SADDLP*//*Label 136*/ GIMT_Encode4(421373),
    /*AArch64::G_SADDLV*//*Label 137*/ GIMT_Encode4(421579),
    /*AArch64::G_SDOT*//*Label 138*/ GIMT_Encode4(421978),
    /*AArch64::G_SITOF*//*Label 139*/ GIMT_Encode4(422348),
    /*AArch64::G_SMULL*//*Label 140*/ GIMT_Encode4(422465),
    /*AArch64::G_TRN1*//*Label 141*/ GIMT_Encode4(423698),
    /*AArch64::G_TRN2*//*Label 142*/ GIMT_Encode4(424523),
    /*AArch64::G_UADDLP*//*Label 143*/ GIMT_Encode4(425348),
    /*AArch64::G_UADDLV*//*Label 144*/ GIMT_Encode4(425554),
    /*AArch64::G_UDOT*//*Label 145*/ GIMT_Encode4(426421),
    /*AArch64::G_UITOF*//*Label 146*/ GIMT_Encode4(426791),
    /*AArch64::G_UMULL*//*Label 147*/ GIMT_Encode4(426908),
    /*AArch64::G_UZP1*//*Label 148*/ GIMT_Encode4(428141),
    /*AArch64::G_UZP2*//*Label 149*/ GIMT_Encode4(428966),
    /*AArch64::G_VASHR*//*Label 150*/ GIMT_Encode4(429791),
    /*AArch64::G_VLSHR*//*Label 151*/ GIMT_Encode4(430489),
    /*AArch64::G_ZIP1*//*Label 152*/ GIMT_Encode4(430945),
    /*AArch64::G_ZIP2*//*Label 153*/ GIMT_Encode4(431770),
    // Label 0: @3142
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 168*/ GIMT_Encode4(34644),
    /*GILLT_s32*//*Label 155*/ GIMT_Encode4(3241),
    /*GILLT_s64*//*Label 156*/ GIMT_Encode4(4764), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 157*/ GIMT_Encode4(9856),
    /*GILLT_v2s64*//*Label 158*/ GIMT_Encode4(13464),
    /*GILLT_v4s16*//*Label 159*/ GIMT_Encode4(19366),
    /*GILLT_v4s32*//*Label 160*/ GIMT_Encode4(22864),
    /*GILLT_v8s8*//*Label 161*/ GIMT_Encode4(29042),
    /*GILLT_v8s16*//*Label 162*/ GIMT_Encode4(29892),
    /*GILLT_v16s8*//*Label 163*/ GIMT_Encode4(33470), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s64*//*Label 164*/ GIMT_Encode4(34194), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv4s32*//*Label 165*/ GIMT_Encode4(34566), GIMT_Encode4(0),
    /*GILLT_nxv8s16*//*Label 166*/ GIMT_Encode4(34592), GIMT_Encode4(0),
    /*GILLT_nxv16s8*//*Label 167*/ GIMT_Encode4(34618),
    // Label 155: @3241
    GIM_Try, /*On fail goto*//*Label 169*/ GIMT_Encode4(4763),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(3285), // Rule ID 13282 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm32),
        // (add:{ *:[i32] } addsub_shifted_imm32:{ *:[i32] }:$imm, GPR32sp:{ *:[i32] }:$Rn)  =>  (ADDWri:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13282,
        GIR_EraseRootFromParent_Done,
      // Label 170: @3285
      GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(3437), // Rule ID 13709 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME_UseScalarIncVL),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
        // MIs[2] pattern
        GIM_CheckIsImm, /*MI*/2, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1212:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCB_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
        GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        // GIR_Coverage, 13709,
        GIR_EraseRootFromParent_Done,
      // Label 171: @3437
      GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(3589), // Rule ID 15570 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME_UseScalarIncVL),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
        // MIs[2] pattern
        GIM_CheckIsImm, /*MI*/2, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1214:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCH_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
        GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        // GIR_Coverage, 15570,
        GIR_EraseRootFromParent_Done,
      // Label 172: @3589
      GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(3741), // Rule ID 15582 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME_UseScalarIncVL),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
        // MIs[2] pattern
        GIM_CheckIsImm, /*MI*/2, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1220:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCW_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
        GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        // GIR_Coverage, 15582,
        GIR_EraseRootFromParent_Done,
      // Label 173: @3741
      GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(3893), // Rule ID 15594 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME_UseScalarIncVL),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
        // MIs[2] pattern
        GIM_CheckIsImm, /*MI*/2, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1213:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCD_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
        GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        // GIR_Coverage, 15594,
        GIR_EraseRootFromParent_Done,
      // Label 174: @3893
      GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(3926), // Rule ID 103 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm32),
        // (add:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (ADDWri:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 103,
        GIR_EraseRootFromParent_Done,
      // Label 175: @3926
      GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(4078), // Rule ID 2608 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME_UseScalarIncVL),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
        // MIs[2] pattern
        GIM_CheckIsImm, /*MI*/2, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1212:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCB_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
        GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        // GIR_Coverage, 2608,
        GIR_EraseRootFromParent_Done,
      // Label 176: @4078
      GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(4230), // Rule ID 10156 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME_UseScalarIncVL),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
        // MIs[2] pattern
        GIM_CheckIsImm, /*MI*/2, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1214:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCH_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
        GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        // GIR_Coverage, 10156,
        GIR_EraseRootFromParent_Done,
      // Label 177: @4230
      GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(4382), // Rule ID 10168 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME_UseScalarIncVL),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
        // MIs[2] pattern
        GIM_CheckIsImm, /*MI*/2, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1220:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCW_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
        GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        // GIR_Coverage, 10168,
        GIR_EraseRootFromParent_Done,
      // Label 178: @4382
      GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(4534), // Rule ID 10180 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME_UseScalarIncVL),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
        // MIs[2] pattern
        GIM_CheckIsImm, /*MI*/2, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1213:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCD_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
        GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        // GIR_Coverage, 10180,
        GIR_EraseRootFromParent_Done,
      // Label 179: @4534
      GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(4567), // Rule ID 13286 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32_i32),
        // (add:{ *:[i32] } arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend, GPR32sp:{ *:[i32] }:$Rn)  =>  (ADDWrx:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrx),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13286,
        GIR_EraseRootFromParent_Done,
      // Label 180: @4567
      GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(4603), // Rule ID 13849 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm32),
        // (add:{ *:[i32] } neg_addsub_shifted_imm32:{ *:[i32] }:$imm, GPR32:{ *:[i32] }:$Rn)  =>  (SUBSWri:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13849,
        GIR_EraseRootFromParent_Done,
      // Label 181: @4603
      GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(4636), // Rule ID 109 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32_i32),
        // (add:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend)  =>  (ADDWrx:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrx),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 109,
        GIR_EraseRootFromParent_Done,
      // Label 182: @4636
      GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(4672), // Rule ID 3901 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm32),
        // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (SUBSWri:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3901,
        GIR_EraseRootFromParent_Done,
      // Label 183: @4672
      GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(4705), // Rule ID 13284 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg32),
        // (add:{ *:[i32] } arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (ADDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13284,
        GIR_EraseRootFromParent_Done,
      // Label 184: @4705
      GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(4738), // Rule ID 107 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg32),
        // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (ADDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 107,
        GIR_EraseRootFromParent_Done,
      // Label 185: @4738
      GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(4762), // Rule ID 105 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (ADDWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDWrr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 105,
        GIR_Done,
      // Label 186: @4762
      GIM_Reject,
    // Label 169: @4763
    GIM_Reject,
    // Label 156: @4764
    GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(9855),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(4911), // Rule ID 5414 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5414,
        GIR_EraseRootFromParent_Done,
      // Label 188: @4911
      GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(5047), // Rule ID 5413 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5413,
        GIR_EraseRootFromParent_Done,
      // Label 189: @5047
      GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(5183), // Rule ID 5423 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLv2i32_v2i64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5423,
        GIR_EraseRootFromParent_Done,
      // Label 190: @5183
      GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(5319), // Rule ID 5412 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5412,
        GIR_EraseRootFromParent_Done,
      // Label 191: @5319
      GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(5455), // Rule ID 5411 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5411,
        GIR_EraseRootFromParent_Done,
      // Label 192: @5455
      GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(5523), // Rule ID 7068 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        // MIs[2] Rn
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[i64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }))  =>  (ADDPv2i64p:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7068,
        GIR_EraseRootFromParent_Done,
      // Label 193: @5523
      GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(5591), // Rule ID 14010 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        // MIs[2] Rn
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[i64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (ADDPv2i64p:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14010,
        GIR_EraseRootFromParent_Done,
      // Label 194: @5591
      GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(5624), // Rule ID 13283 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm64),
        // (add:{ *:[i64] } addsub_shifted_imm64:{ *:[i64] }:$imm, GPR64sp:{ *:[i64] }:$Rn)  =>  (ADDXri:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13283,
        GIR_EraseRootFromParent_Done,
      // Label 195: @5624
      GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(5757), // Rule ID 3953 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (add:{ *:[i64] } (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C), GPR64:{ *:[i64] }:$Ra)  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootToRootCopy, /*OpIdx*/2, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3953,
        GIR_EraseRootFromParent_Done,
      // Label 196: @5757
      GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(5852), // Rule ID 3951 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (add:{ *:[i64] } (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C), GPR64:{ *:[i64] }:$Ra)  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3951,
        GIR_EraseRootFromParent_Done,
      // Label 197: @5852
      GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(5947), // Rule ID 3952 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (add:{ *:[i64] } (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C), GPR64:{ *:[i64] }:$Ra)  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3952,
        GIR_EraseRootFromParent_Done,
      // Label 198: @5947
      GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(5980), // Rule ID 104 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm64),
        // (add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (ADDXri:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 104,
        GIR_EraseRootFromParent_Done,
      // Label 199: @5980
      GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(6113), // Rule ID 13859 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootToRootCopy, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13859,
        GIR_EraseRootFromParent_Done,
      // Label 200: @6113
      GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(6208), // Rule ID 13857 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13857,
        GIR_EraseRootFromParent_Done,
      // Label 201: @6208
      GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(6303), // Rule ID 13858 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C))  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13858,
        GIR_EraseRootFromParent_Done,
      // Label 202: @6303
      GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(6385), // Rule ID 13294 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (add:{ *:[i64] } (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)), GPR64:{ *:[i64] }:$Ra)  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_RootToRootCopy, /*OpIdx*/2, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13294,
        GIR_EraseRootFromParent_Done,
      // Label 203: @6385
      GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(6467), // Rule ID 13295 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (add:{ *:[i64] } (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)), GPR64:{ *:[i64] }:$Ra)  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_RootToRootCopy, /*OpIdx*/2, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13295,
        GIR_EraseRootFromParent_Done,
      // Label 204: @6467
      GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(6549), // Rule ID 135 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 135,
        GIR_EraseRootFromParent_Done,
      // Label 205: @6549
      GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(6631), // Rule ID 137 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 137,
        GIR_EraseRootFromParent_Done,
      // Label 206: @6631
      GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(6689), // Rule ID 13704 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME_UseScalarIncVL),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
        // MIs[1] pattern
        GIM_CheckIsImm, /*MI*/1, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1212:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCB_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13704,
        GIR_EraseRootFromParent_Done,
      // Label 207: @6689
      GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(6747), // Rule ID 15565 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME_UseScalarIncVL),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
        // MIs[1] pattern
        GIM_CheckIsImm, /*MI*/1, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1214:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCH_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15565,
        GIR_EraseRootFromParent_Done,
      // Label 208: @6747
      GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(6805), // Rule ID 15577 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME_UseScalarIncVL),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
        // MIs[1] pattern
        GIM_CheckIsImm, /*MI*/1, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1220:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCW_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15577,
        GIR_EraseRootFromParent_Done,
      // Label 209: @6805
      GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(6863), // Rule ID 15589 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME_UseScalarIncVL),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
        // MIs[1] pattern
        GIM_CheckIsImm, /*MI*/1, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1213:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCD_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15589,
        GIR_EraseRootFromParent_Done,
      // Label 210: @6863
      GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(6921), // Rule ID 2605 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME_UseScalarIncVL),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
        // MIs[1] pattern
        GIM_CheckIsImm, /*MI*/1, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1212:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCB_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2605,
        GIR_EraseRootFromParent_Done,
      // Label 211: @6921
      GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(6979), // Rule ID 10153 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME_UseScalarIncVL),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
        // MIs[1] pattern
        GIM_CheckIsImm, /*MI*/1, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1214:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCH_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10153,
        GIR_EraseRootFromParent_Done,
      // Label 212: @6979
      GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(7037), // Rule ID 10165 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME_UseScalarIncVL),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
        // MIs[1] pattern
        GIM_CheckIsImm, /*MI*/1, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1220:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCW_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10165,
        GIR_EraseRootFromParent_Done,
      // Label 213: @7037
      GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(7095), // Rule ID 10177 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME_UseScalarIncVL),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
        // MIs[1] pattern
        GIM_CheckIsImm, /*MI*/1, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1213:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCD_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10177,
        GIR_EraseRootFromParent_Done,
      // Label 214: @7095
      GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(7258), // Rule ID 13976 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 13976,
        GIR_EraseRootFromParent_Done,
      // Label 215: @7258
      GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(7421), // Rule ID 13973 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 13973,
        GIR_EraseRootFromParent_Done,
      // Label 216: @7421
      GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(7571), // Rule ID 13982 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 13982,
        GIR_EraseRootFromParent_Done,
      // Label 217: @7571
      GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(7721), // Rule ID 13985 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 13985,
        GIR_EraseRootFromParent_Done,
      // Label 218: @7721
      GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(7871), // Rule ID 13981 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 13981,
        GIR_EraseRootFromParent_Done,
      // Label 219: @7871
      GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(8034), // Rule ID 5396 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5396,
        GIR_EraseRootFromParent_Done,
      // Label 220: @8034
      GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(8197), // Rule ID 5393 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5393,
        GIR_EraseRootFromParent_Done,
      // Label 221: @8197
      GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(8347), // Rule ID 5420 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5420,
        GIR_EraseRootFromParent_Done,
      // Label 222: @8347
      GIM_Try, /*On fail goto*//*Label 223*/ GIMT_Encode4(8497), // Rule ID 5426 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5426,
        GIR_EraseRootFromParent_Done,
      // Label 223: @8497
      GIM_Try, /*On fail goto*//*Label 224*/ GIMT_Encode4(8647), // Rule ID 5419 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5419,
        GIR_EraseRootFromParent_Done,
      // Label 224: @8647
      GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(8680), // Rule ID 13287 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32to64_i64),
        // (add:{ *:[i64] } arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend, GPR64sp:{ *:[i64] }:$Rn)  =>  (ADDXrx:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrx),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13287,
        GIR_EraseRootFromParent_Done,
      // Label 225: @8680
      GIM_Try, /*On fail goto*//*Label 226*/ GIMT_Encode4(8716), // Rule ID 13850 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm64),
        // (add:{ *:[i64] } neg_addsub_shifted_imm64:{ *:[i64] }:$imm, GPR64:{ *:[i64] }:$Rn)  =>  (SUBSXri:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13850,
        GIR_EraseRootFromParent_Done,
      // Label 226: @8716
      GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(8749), // Rule ID 110 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32to64_i64),
        // (add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend)  =>  (ADDXrx:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrx),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 110,
        GIR_EraseRootFromParent_Done,
      // Label 227: @8749
      GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(8785), // Rule ID 3902 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm64),
        // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (SUBSXri:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3902,
        GIR_EraseRootFromParent_Done,
      // Label 228: @8785
      GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(8818), // Rule ID 13285 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg64),
        // (add:{ *:[i64] } arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (ADDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13285,
        GIR_EraseRootFromParent_Done,
      // Label 229: @8818
      GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(8851), // Rule ID 108 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg64),
        // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (ADDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 108,
        GIR_EraseRootFromParent_Done,
      // Label 230: @8851
      GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(8907), // Rule ID 13393 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v1i64] } (intrinsic_wo_chain:{ *:[v1i64] } 635:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13393,
        GIR_EraseRootFromParent_Done,
      // Label 231: @8907
      GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(8963), // Rule ID 13405 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v1i64] } (intrinsic_wo_chain:{ *:[v1i64] } 700:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13405,
        GIR_EraseRootFromParent_Done,
      // Label 232: @8963
      GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(9030), // Rule ID 13611 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[i64] } (AArch64vashr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13611,
        GIR_EraseRootFromParent_Done,
      // Label 233: @9030
      GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(9097), // Rule ID 13999 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v1i64] } (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13999,
        GIR_EraseRootFromParent_Done,
      // Label 234: @9097
      GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(9164), // Rule ID 13614 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[i64] } (AArch64vlshr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13614,
        GIR_EraseRootFromParent_Done,
      // Label 235: @9164
      GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(9231), // Rule ID 14002 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v1i64] } (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14002,
        GIR_EraseRootFromParent_Done,
      // Label 236: @9231
      GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(9287), // Rule ID 986 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (intrinsic_wo_chain:{ *:[v1i64] } 635:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn))  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 986,
        GIR_EraseRootFromParent_Done,
      // Label 237: @9287
      GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(9343), // Rule ID 1047 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (intrinsic_wo_chain:{ *:[v1i64] } 700:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn))  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1047,
        GIR_EraseRootFromParent_Done,
      // Label 238: @9343
      GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(9410), // Rule ID 2108 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, (AArch64vashr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2108,
        GIR_EraseRootFromParent_Done,
      // Label 239: @9410
      GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(9477), // Rule ID 6335 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6335,
        GIR_EraseRootFromParent_Done,
      // Label 240: @9477
      GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(9544), // Rule ID 2117 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, (AArch64vlshr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2117,
        GIR_EraseRootFromParent_Done,
      // Label 241: @9544
      GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(9611), // Rule ID 6341 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6341,
        GIR_EraseRootFromParent_Done,
      // Label 242: @9611
      GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(9659), // Rule ID 13392 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v1i64] } (AArch64saddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13392,
        GIR_EraseRootFromParent_Done,
      // Label 243: @9659
      GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(9707), // Rule ID 13404 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v1i64] } (AArch64uaddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13404,
        GIR_EraseRootFromParent_Done,
      // Label 244: @9707
      GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(9755), // Rule ID 985 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (AArch64saddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn))  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 985,
        GIR_EraseRootFromParent_Done,
      // Label 245: @9755
      GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(9803), // Rule ID 1046 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (AArch64uaddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn))  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1046,
        GIR_EraseRootFromParent_Done,
      // Label 246: @9803
      GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(9827), // Rule ID 106 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ADDXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDXrr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 106,
        GIR_Done,
      // Label 247: @9827
      GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(9854), // Rule ID 1596 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (add:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (ADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv1i64),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1596,
        GIR_Done,
      // Label 248: @9854
      GIM_Reject,
    // Label 187: @9855
    GIM_Reject,
    // Label 157: @9856
    GIM_Try, /*On fail goto*//*Label 249*/ GIMT_Encode4(13463),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_Try, /*On fail goto*//*Label 250*/ GIMT_Encode4(10055), // Rule ID 7089 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP1),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        // MIs[3] Rn
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(2),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_ZIP2),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        // MIs[5] Rn
        GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[5] Operand 2
        GIM_CheckLiteralInt, /*MI*/5, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/6, /*MI*/4, /*OpIdx*/2, // MIs[6]
        GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        // MIs[6] Rn
        GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[6] Operand 2
        GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(2),
        GIM_CheckIsSafeToFold, /*NumInsns*/6,
        // (add:{ *:[v2i32] } (AArch64zip1:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })), (AArch64zip2:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (ADDPv4i32:{ *:[f128] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 7089,
        GIR_EraseRootFromParent_Done,
      // Label 250: @10055
      GIM_Try, /*On fail goto*//*Label 251*/ GIMT_Encode4(10243), // Rule ID 14021 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP2),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        // MIs[3] Rn
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(2),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_ZIP1),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        // MIs[5] Rn
        GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[5] Operand 2
        GIM_CheckLiteralInt, /*MI*/5, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/6, /*MI*/4, /*OpIdx*/2, // MIs[6]
        GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        // MIs[6] Rn
        GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[6] Operand 2
        GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(2),
        GIM_CheckIsSafeToFold, /*NumInsns*/6,
        // (add:{ *:[v2i32] } (AArch64zip2:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })), (AArch64zip1:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (ADDPv4i32:{ *:[f128] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 14021,
        GIR_EraseRootFromParent_Done,
      // Label 251: @10243
      GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(10379), // Rule ID 5410 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5410,
        GIR_EraseRootFromParent_Done,
      // Label 252: @10379
      GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(10515), // Rule ID 5409 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5409,
        GIR_EraseRootFromParent_Done,
      // Label 253: @10515
      GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(10651), // Rule ID 5422 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLv4i16_v4i32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5422,
        GIR_EraseRootFromParent_Done,
      // Label 254: @10651
      GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(10787), // Rule ID 5408 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5408,
        GIR_EraseRootFromParent_Done,
      // Label 255: @10787
      GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(10923), // Rule ID 5407 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5407,
        GIR_EraseRootFromParent_Done,
      // Label 256: @10923
      GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(11086), // Rule ID 13975 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 13975,
        GIR_EraseRootFromParent_Done,
      // Label 257: @11086
      GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(11249), // Rule ID 13972 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 13972,
        GIR_EraseRootFromParent_Done,
      // Label 258: @11249
      GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(11399), // Rule ID 13980 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 13980,
        GIR_EraseRootFromParent_Done,
      // Label 259: @11399
      GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(11549), // Rule ID 13984 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 13984,
        GIR_EraseRootFromParent_Done,
      // Label 260: @11549
      GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(11699), // Rule ID 13979 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 13979,
        GIR_EraseRootFromParent_Done,
      // Label 261: @11699
      GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(11862), // Rule ID 5395 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5395,
        GIR_EraseRootFromParent_Done,
      // Label 262: @11862
      GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(12025), // Rule ID 5392 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5392,
        GIR_EraseRootFromParent_Done,
      // Label 263: @12025
      GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(12175), // Rule ID 5418 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5418,
        GIR_EraseRootFromParent_Done,
      // Label 264: @12175
      GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(12325), // Rule ID 5425 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5425,
        GIR_EraseRootFromParent_Done,
      // Label 265: @12325
      GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(12475), // Rule ID 5417 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5417,
        GIR_EraseRootFromParent_Done,
      // Label 266: @12475
      GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(12544), // Rule ID 13427 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 634:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V64:{ *:[v2i32] }:$Rd)  =>  (SABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13427,
        GIR_EraseRootFromParent_Done,
      // Label 267: @12544
      GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(12613), // Rule ID 13439 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 699:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V64:{ *:[v2i32] }:$Rd)  =>  (UABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13439,
        GIR_EraseRootFromParent_Done,
      // Label 268: @12613
      GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(12669), // Rule ID 13389 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 635:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13389,
        GIR_EraseRootFromParent_Done,
      // Label 269: @12669
      GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(12725), // Rule ID 13401 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 700:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13401,
        GIR_EraseRootFromParent_Done,
      // Label 270: @12725
      GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(12792), // Rule ID 13631 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v2i32] } (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13631,
        GIR_EraseRootFromParent_Done,
      // Label 271: @12792
      GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(12859), // Rule ID 13652 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13652,
        GIR_EraseRootFromParent_Done,
      // Label 272: @12859
      GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(12928), // Rule ID 1354 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 634:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1354,
        GIR_EraseRootFromParent_Done,
      // Label 273: @12928
      GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(12997), // Rule ID 1477 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 699:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1477,
        GIR_EraseRootFromParent_Done,
      // Label 274: @12997
      GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(13053), // Rule ID 982 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 635:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 982,
        GIR_EraseRootFromParent_Done,
      // Label 275: @13053
      GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(13109), // Rule ID 1043 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 700:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1043,
        GIR_EraseRootFromParent_Done,
      // Label 276: @13109
      GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(13176), // Rule ID 2225 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2225,
        GIR_EraseRootFromParent_Done,
      // Label 277: @13176
      GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(13243), // Rule ID 2284 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2284,
        GIR_EraseRootFromParent_Done,
      // Label 278: @13243
      GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(13291), // Rule ID 13388 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v2i32] } (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13388,
        GIR_EraseRootFromParent_Done,
      // Label 279: @13291
      GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(13339), // Rule ID 13400 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v2i32] } (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13400,
        GIR_EraseRootFromParent_Done,
      // Label 280: @13339
      GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(13387), // Rule ID 981 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 981,
        GIR_EraseRootFromParent_Done,
      // Label 281: @13387
      GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(13435), // Rule ID 1042 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1042,
        GIR_EraseRootFromParent_Done,
      // Label 282: @13435
      GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(13462), // Rule ID 1093 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv2i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1093,
        GIR_Done,
      // Label 283: @13462
      GIM_Reject,
    // Label 249: @13463
    GIM_Reject,
    // Label 158: @13464
    GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(19365),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(13593), // Rule ID 13566 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13566,
        GIR_EraseRootFromParent_Done,
      // Label 285: @13593
      GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(13711), // Rule ID 13567 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13567,
        GIR_EraseRootFromParent_Done,
      // Label 286: @13711
      GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(13829), // Rule ID 13596 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13596,
        GIR_EraseRootFromParent_Done,
      // Label 287: @13829
      GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(13947), // Rule ID 13597 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13597,
        GIR_EraseRootFromParent_Done,
      // Label 288: @13947
      GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(14065), // Rule ID 2031 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2031,
        GIR_EraseRootFromParent_Done,
      // Label 289: @14065
      GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(14183), // Rule ID 13565 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13565,
        GIR_EraseRootFromParent_Done,
      // Label 290: @14183
      GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(14301), // Rule ID 2083 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2083,
        GIR_EraseRootFromParent_Done,
      // Label 291: @14301
      GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(14419), // Rule ID 13595 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13595,
        GIR_EraseRootFromParent_Done,
      // Label 292: @14419
      GIM_Try, /*On fail goto*//*Label 293*/ GIMT_Encode4(14506), // Rule ID 13471 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 634:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))), V128:{ *:[v2i64] }:$Rd)  =>  (SABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13471,
        GIR_EraseRootFromParent_Done,
      // Label 293: @14506
      GIM_Try, /*On fail goto*//*Label 294*/ GIMT_Encode4(14593), // Rule ID 13495 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 699:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))), V128:{ *:[v2i64] }:$Rd)  =>  (UABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13495,
        GIR_EraseRootFromParent_Done,
      // Label 294: @14593
      GIM_Try, /*On fail goto*//*Label 295*/ GIMT_Encode4(14680), // Rule ID 1688 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 634:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))))  =>  (SABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1688,
        GIR_EraseRootFromParent_Done,
      // Label 295: @14680
      GIM_Try, /*On fail goto*//*Label 296*/ GIMT_Encode4(14767), // Rule ID 1766 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 699:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))))  =>  (UABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1766,
        GIR_EraseRootFromParent_Done,
      // Label 296: @14767
      GIM_Try, /*On fail goto*//*Label 297*/ GIMT_Encode4(14882), // Rule ID 13561 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13561,
        GIR_EraseRootFromParent_Done,
      // Label 297: @14882
      GIM_Try, /*On fail goto*//*Label 298*/ GIMT_Encode4(14997), // Rule ID 13560 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13560,
        GIR_EraseRootFromParent_Done,
      // Label 298: @14997
      GIM_Try, /*On fail goto*//*Label 299*/ GIMT_Encode4(15112), // Rule ID 13591 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13591,
        GIR_EraseRootFromParent_Done,
      // Label 299: @15112
      GIM_Try, /*On fail goto*//*Label 300*/ GIMT_Encode4(15227), // Rule ID 13590 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13590,
        GIR_EraseRootFromParent_Done,
      // Label 300: @15227
      GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(15296), // Rule ID 1790 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1790,
        GIR_EraseRootFromParent_Done,
      // Label 301: @15296
      GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(15365), // Rule ID 1789 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1789,
        GIR_EraseRootFromParent_Done,
      // Label 302: @15365
      GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(15434), // Rule ID 1706 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1706,
        GIR_EraseRootFromParent_Done,
      // Label 303: @15434
      GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(15503), // Rule ID 1788 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1788,
        GIR_EraseRootFromParent_Done,
      // Label 304: @15503
      GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(15572), // Rule ID 1787 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1787,
        GIR_EraseRootFromParent_Done,
      // Label 305: @15572
      GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(15687), // Rule ID 13559 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13559,
        GIR_EraseRootFromParent_Done,
      // Label 306: @15687
      GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(15802), // Rule ID 2029 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2029,
        GIR_EraseRootFromParent_Done,
      // Label 307: @15802
      GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(15917), // Rule ID 13589 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13589,
        GIR_EraseRootFromParent_Done,
      // Label 308: @15917
      GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(16032), // Rule ID 2081 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2081,
        GIR_EraseRootFromParent_Done,
      // Label 309: @16032
      GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(16099), // Rule ID 13483 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13483,
        GIR_EraseRootFromParent_Done,
      // Label 310: @16099
      GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(16166), // Rule ID 13513 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13513,
        GIR_EraseRootFromParent_Done,
      // Label 311: @16166
      GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(16233), // Rule ID 1718 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1718,
        GIR_EraseRootFromParent_Done,
      // Label 312: @16233
      GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(16300), // Rule ID 1808 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1808,
        GIR_EraseRootFromParent_Done,
      // Label 313: @16300
      GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(16381), // Rule ID 13469 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 634:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (SABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13469,
        GIR_EraseRootFromParent_Done,
      // Label 314: @16381
      GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(16462), // Rule ID 13493 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 699:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (UABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13493,
        GIR_EraseRootFromParent_Done,
      // Label 315: @16462
      GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(16543), // Rule ID 1686 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 634:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)))  =>  (SABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1686,
        GIR_EraseRootFromParent_Done,
      // Label 316: @16543
      GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(16624), // Rule ID 1764 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 699:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)))  =>  (UABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1764,
        GIR_EraseRootFromParent_Done,
      // Label 317: @16624
      GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(16716), // Rule ID 13564 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13564,
        GIR_EraseRootFromParent_Done,
      // Label 318: @16716
      GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(16808), // Rule ID 13563 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13563,
        GIR_EraseRootFromParent_Done,
      // Label 319: @16808
      GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(16900), // Rule ID 13594 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13594,
        GIR_EraseRootFromParent_Done,
      // Label 320: @16900
      GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(16992), // Rule ID 13593 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13593,
        GIR_EraseRootFromParent_Done,
      // Label 321: @16992
      GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(17084), // Rule ID 13562 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13562,
        GIR_EraseRootFromParent_Done,
      // Label 322: @17084
      GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(17176), // Rule ID 2030 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2030,
        GIR_EraseRootFromParent_Done,
      // Label 323: @17176
      GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(17268), // Rule ID 13592 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13592,
        GIR_EraseRootFromParent_Done,
      // Label 324: @17268
      GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(17360), // Rule ID 2082 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2082,
        GIR_EraseRootFromParent_Done,
      // Label 325: @17360
      GIM_Try, /*On fail goto*//*Label 326*/ GIMT_Encode4(17411), // Rule ID 13507 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13507,
        GIR_EraseRootFromParent_Done,
      // Label 326: @17411
      GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(17462), // Rule ID 13477 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rn)  =>  (SADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13477,
        GIR_EraseRootFromParent_Done,
      // Label 327: @17462
      GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(17513), // Rule ID 13506 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13506,
        GIR_EraseRootFromParent_Done,
      // Label 328: @17513
      GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(17564), // Rule ID 1802 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1802,
        GIR_EraseRootFromParent_Done,
      // Label 329: @17564
      GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(17615), // Rule ID 1712 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1712,
        GIR_EraseRootFromParent_Done,
      // Label 330: @17615
      GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(17666), // Rule ID 1801 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1801,
        GIR_EraseRootFromParent_Done,
      // Label 331: @17666
      GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(17722), // Rule ID 13395 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 635:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13395,
        GIR_EraseRootFromParent_Done,
      // Label 332: @17722
      GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(17778), // Rule ID 13407 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 700:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13407,
        GIR_EraseRootFromParent_Done,
      // Label 333: @17778
      GIM_Try, /*On fail goto*//*Label 334*/ GIMT_Encode4(17845), // Rule ID 13635 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v2i64] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13635,
        GIR_EraseRootFromParent_Done,
      // Label 334: @17845
      GIM_Try, /*On fail goto*//*Label 335*/ GIMT_Encode4(17912), // Rule ID 13656 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v2i64] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13656,
        GIR_EraseRootFromParent_Done,
      // Label 335: @17912
      GIM_Try, /*On fail goto*//*Label 336*/ GIMT_Encode4(17968), // Rule ID 988 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 635:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 988,
        GIR_EraseRootFromParent_Done,
      // Label 336: @17968
      GIM_Try, /*On fail goto*//*Label 337*/ GIMT_Encode4(18024), // Rule ID 1049 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 700:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1049,
        GIR_EraseRootFromParent_Done,
      // Label 337: @18024
      GIM_Try, /*On fail goto*//*Label 338*/ GIMT_Encode4(18091), // Rule ID 2229 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2229,
        GIR_EraseRootFromParent_Done,
      // Label 338: @18091
      GIM_Try, /*On fail goto*//*Label 339*/ GIMT_Encode4(18158), // Rule ID 2288 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2288,
        GIR_EraseRootFromParent_Done,
      // Label 339: @18158
      GIM_Try, /*On fail goto*//*Label 340*/ GIMT_Encode4(18228), // Rule ID 7085 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP1),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP2),
        // MIs[2] Rn
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[2] Rm
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v2i64] } (AArch64zip1:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm), (AArch64zip2:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm))  =>  (ADDPv2i64:{ *:[v2i64] } ?:{ *:[v2i64] }:$Rn, ?:{ *:[v2i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7085,
        GIR_EraseRootFromParent_Done,
      // Label 340: @18228
      GIM_Try, /*On fail goto*//*Label 341*/ GIMT_Encode4(18298), // Rule ID 14017 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP2),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP1),
        // MIs[2] Rn
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[2] Rm
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v2i64] } (AArch64zip2:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm), (AArch64zip1:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm))  =>  (ADDPv2i64:{ *:[v2i64] } ?:{ *:[v2i64] }:$Rn, ?:{ *:[v2i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14017,
        GIR_EraseRootFromParent_Done,
      // Label 341: @18298
      GIM_Try, /*On fail goto*//*Label 342*/ GIMT_Encode4(18361), // Rule ID 1786 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1786,
        GIR_EraseRootFromParent_Done,
      // Label 342: @18361
      GIM_Try, /*On fail goto*//*Label 343*/ GIMT_Encode4(18424), // Rule ID 1785 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1785,
        GIR_EraseRootFromParent_Done,
      // Label 343: @18424
      GIM_Try, /*On fail goto*//*Label 344*/ GIMT_Encode4(18487), // Rule ID 1705 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1705,
        GIR_EraseRootFromParent_Done,
      // Label 344: @18487
      GIM_Try, /*On fail goto*//*Label 345*/ GIMT_Encode4(18550), // Rule ID 1784 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1784,
        GIR_EraseRootFromParent_Done,
      // Label 345: @18550
      GIM_Try, /*On fail goto*//*Label 346*/ GIMT_Encode4(18613), // Rule ID 1783 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1783,
        GIR_EraseRootFromParent_Done,
      // Label 346: @18613
      GIM_Try, /*On fail goto*//*Label 347*/ GIMT_Encode4(18674), // Rule ID 13482 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13482,
        GIR_EraseRootFromParent_Done,
      // Label 347: @18674
      GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(18735), // Rule ID 13512 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13512,
        GIR_EraseRootFromParent_Done,
      // Label 348: @18735
      GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(18783), // Rule ID 13505 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13505,
        GIR_EraseRootFromParent_Done,
      // Label 349: @18783
      GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(18831), // Rule ID 13394 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v2i64] } (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13394,
        GIR_EraseRootFromParent_Done,
      // Label 350: @18831
      GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(18879), // Rule ID 13476 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rn)  =>  (SADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13476,
        GIR_EraseRootFromParent_Done,
      // Label 351: @18879
      GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(18927), // Rule ID 13406 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v2i64] } (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13406,
        GIR_EraseRootFromParent_Done,
      // Label 352: @18927
      GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(18975), // Rule ID 13504 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13504,
        GIR_EraseRootFromParent_Done,
      // Label 353: @18975
      GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(19036), // Rule ID 1717 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1717,
        GIR_EraseRootFromParent_Done,
      // Label 354: @19036
      GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(19097), // Rule ID 1807 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1807,
        GIR_EraseRootFromParent_Done,
      // Label 355: @19097
      GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(19145), // Rule ID 1800 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1800,
        GIR_EraseRootFromParent_Done,
      // Label 356: @19145
      GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(19193), // Rule ID 987 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 987,
        GIR_EraseRootFromParent_Done,
      // Label 357: @19193
      GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(19241), // Rule ID 1711 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1711,
        GIR_EraseRootFromParent_Done,
      // Label 358: @19241
      GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(19289), // Rule ID 1048 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1048,
        GIR_EraseRootFromParent_Done,
      // Label 359: @19289
      GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(19337), // Rule ID 1799 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1799,
        GIR_EraseRootFromParent_Done,
      // Label 360: @19337
      GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(19364), // Rule ID 1095 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv2i64),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1095,
        GIR_Done,
      // Label 361: @19364
      GIM_Reject,
    // Label 284: @19365
    GIM_Reject,
    // Label 159: @19366
    GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(22863),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(19513), // Rule ID 5406 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5406,
        GIR_EraseRootFromParent_Done,
      // Label 363: @19513
      GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(19649), // Rule ID 5405 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5405,
        GIR_EraseRootFromParent_Done,
      // Label 364: @19649
      GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(19785), // Rule ID 5421 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLv8i8_v8i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5421,
        GIR_EraseRootFromParent_Done,
      // Label 365: @19785
      GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(19921), // Rule ID 5404 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5404,
        GIR_EraseRootFromParent_Done,
      // Label 366: @19921
      GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(20057), // Rule ID 5403 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5403,
        GIR_EraseRootFromParent_Done,
      // Label 367: @20057
      GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(20190), // Rule ID 14022 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_TRUNC),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BITCAST),
        // MIs[5] Rn
        GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/5,
        // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, (undef:{ *:[v8i16] })), 0:{ *:[i64] }), (trunc:{ *:[v4i16] } (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$Rn)))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (ADDPv8i16:{ *:[f128] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rn), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 14022,
        GIR_EraseRootFromParent_Done,
      // Label 368: @20190
      GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(20323), // Rule ID 7090 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITCAST),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_UZP2),
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s16,
        // MIs[4] Rn
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/5,
        // (add:{ *:[v4i16] } (trunc:{ *:[v4i16] } (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$Rn)), (extract_subvector:{ *:[v4i16] } (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, (undef:{ *:[v8i16] })), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (ADDPv8i16:{ *:[f128] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rn), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 7090,
        GIR_EraseRootFromParent_Done,
      // Label 369: @20323
      GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(20486), // Rule ID 13974 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 13974,
        GIR_EraseRootFromParent_Done,
      // Label 370: @20486
      GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(20649), // Rule ID 13971 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 13971,
        GIR_EraseRootFromParent_Done,
      // Label 371: @20649
      GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(20799), // Rule ID 13978 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 13978,
        GIR_EraseRootFromParent_Done,
      // Label 372: @20799
      GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(20949), // Rule ID 13983 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 13983,
        GIR_EraseRootFromParent_Done,
      // Label 373: @20949
      GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(21099), // Rule ID 13977 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 13977,
        GIR_EraseRootFromParent_Done,
      // Label 374: @21099
      GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(21262), // Rule ID 5394 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5394,
        GIR_EraseRootFromParent_Done,
      // Label 375: @21262
      GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(21425), // Rule ID 5391 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5391,
        GIR_EraseRootFromParent_Done,
      // Label 376: @21425
      GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(21575), // Rule ID 5416 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5416,
        GIR_EraseRootFromParent_Done,
      // Label 377: @21575
      GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(21725), // Rule ID 5424 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5424,
        GIR_EraseRootFromParent_Done,
      // Label 378: @21725
      GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(21875), // Rule ID 5415 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5415,
        GIR_EraseRootFromParent_Done,
      // Label 379: @21875
      GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(21944), // Rule ID 13423 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 634:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V64:{ *:[v4i16] }:$Rd)  =>  (SABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13423,
        GIR_EraseRootFromParent_Done,
      // Label 380: @21944
      GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(22013), // Rule ID 13435 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 699:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V64:{ *:[v4i16] }:$Rd)  =>  (UABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13435,
        GIR_EraseRootFromParent_Done,
      // Label 381: @22013
      GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(22069), // Rule ID 13385 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 635:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13385,
        GIR_EraseRootFromParent_Done,
      // Label 382: @22069
      GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(22125), // Rule ID 13397 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 700:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13397,
        GIR_EraseRootFromParent_Done,
      // Label 383: @22125
      GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(22192), // Rule ID 13627 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v4i16] } (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13627,
        GIR_EraseRootFromParent_Done,
      // Label 384: @22192
      GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(22259), // Rule ID 13648 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13648,
        GIR_EraseRootFromParent_Done,
      // Label 385: @22259
      GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(22328), // Rule ID 1350 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 634:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1350,
        GIR_EraseRootFromParent_Done,
      // Label 386: @22328
      GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(22397), // Rule ID 1473 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 699:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1473,
        GIR_EraseRootFromParent_Done,
      // Label 387: @22397
      GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(22453), // Rule ID 978 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 635:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 978,
        GIR_EraseRootFromParent_Done,
      // Label 388: @22453
      GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(22509), // Rule ID 1039 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 700:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1039,
        GIR_EraseRootFromParent_Done,
      // Label 389: @22509
      GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(22576), // Rule ID 2221 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2221,
        GIR_EraseRootFromParent_Done,
      // Label 390: @22576
      GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(22643), // Rule ID 2280 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2280,
        GIR_EraseRootFromParent_Done,
      // Label 391: @22643
      GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(22691), // Rule ID 13384 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v4i16] } (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13384,
        GIR_EraseRootFromParent_Done,
      // Label 392: @22691
      GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(22739), // Rule ID 13396 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v4i16] } (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13396,
        GIR_EraseRootFromParent_Done,
      // Label 393: @22739
      GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(22787), // Rule ID 977 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 977,
        GIR_EraseRootFromParent_Done,
      // Label 394: @22787
      GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(22835), // Rule ID 1038 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1038,
        GIR_EraseRootFromParent_Done,
      // Label 395: @22835
      GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(22862), // Rule ID 1091 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1091,
        GIR_Done,
      // Label 396: @22862
      GIM_Reject,
    // Label 362: @22863
    GIM_Reject,
    // Label 160: @22864
    GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(29041),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(22993), // Rule ID 13557 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13557,
        GIR_EraseRootFromParent_Done,
      // Label 398: @22993
      GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(23111), // Rule ID 13558 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13558,
        GIR_EraseRootFromParent_Done,
      // Label 399: @23111
      GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(23229), // Rule ID 13587 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13587,
        GIR_EraseRootFromParent_Done,
      // Label 400: @23229
      GIM_Try, /*On fail goto*//*Label 401*/ GIMT_Encode4(23347), // Rule ID 13588 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13588,
        GIR_EraseRootFromParent_Done,
      // Label 401: @23347
      GIM_Try, /*On fail goto*//*Label 402*/ GIMT_Encode4(23465), // Rule ID 2028 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2028,
        GIR_EraseRootFromParent_Done,
      // Label 402: @23465
      GIM_Try, /*On fail goto*//*Label 403*/ GIMT_Encode4(23583), // Rule ID 13556 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13556,
        GIR_EraseRootFromParent_Done,
      // Label 403: @23583
      GIM_Try, /*On fail goto*//*Label 404*/ GIMT_Encode4(23701), // Rule ID 2080 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2080,
        GIR_EraseRootFromParent_Done,
      // Label 404: @23701
      GIM_Try, /*On fail goto*//*Label 405*/ GIMT_Encode4(23819), // Rule ID 13586 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13586,
        GIR_EraseRootFromParent_Done,
      // Label 405: @23819
      GIM_Try, /*On fail goto*//*Label 406*/ GIMT_Encode4(23906), // Rule ID 13467 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 634:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))), V128:{ *:[v4i32] }:$Rd)  =>  (SABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13467,
        GIR_EraseRootFromParent_Done,
      // Label 406: @23906
      GIM_Try, /*On fail goto*//*Label 407*/ GIMT_Encode4(23993), // Rule ID 13491 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 699:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))), V128:{ *:[v4i32] }:$Rd)  =>  (UABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13491,
        GIR_EraseRootFromParent_Done,
      // Label 407: @23993
      GIM_Try, /*On fail goto*//*Label 408*/ GIMT_Encode4(24080), // Rule ID 1684 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 634:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))))  =>  (SABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1684,
        GIR_EraseRootFromParent_Done,
      // Label 408: @24080
      GIM_Try, /*On fail goto*//*Label 409*/ GIMT_Encode4(24167), // Rule ID 1762 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 699:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))))  =>  (UABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1762,
        GIR_EraseRootFromParent_Done,
      // Label 409: @24167
      GIM_Try, /*On fail goto*//*Label 410*/ GIMT_Encode4(24282), // Rule ID 13552 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13552,
        GIR_EraseRootFromParent_Done,
      // Label 410: @24282
      GIM_Try, /*On fail goto*//*Label 411*/ GIMT_Encode4(24397), // Rule ID 13551 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13551,
        GIR_EraseRootFromParent_Done,
      // Label 411: @24397
      GIM_Try, /*On fail goto*//*Label 412*/ GIMT_Encode4(24512), // Rule ID 13582 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13582,
        GIR_EraseRootFromParent_Done,
      // Label 412: @24512
      GIM_Try, /*On fail goto*//*Label 413*/ GIMT_Encode4(24627), // Rule ID 13581 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13581,
        GIR_EraseRootFromParent_Done,
      // Label 413: @24627
      GIM_Try, /*On fail goto*//*Label 414*/ GIMT_Encode4(24696), // Rule ID 1782 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1782,
        GIR_EraseRootFromParent_Done,
      // Label 414: @24696
      GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(24765), // Rule ID 1781 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1781,
        GIR_EraseRootFromParent_Done,
      // Label 415: @24765
      GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(24834), // Rule ID 1704 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1704,
        GIR_EraseRootFromParent_Done,
      // Label 416: @24834
      GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(24903), // Rule ID 1780 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1780,
        GIR_EraseRootFromParent_Done,
      // Label 417: @24903
      GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(24972), // Rule ID 1779 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1779,
        GIR_EraseRootFromParent_Done,
      // Label 418: @24972
      GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(25087), // Rule ID 13550 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13550,
        GIR_EraseRootFromParent_Done,
      // Label 419: @25087
      GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(25202), // Rule ID 2026 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2026,
        GIR_EraseRootFromParent_Done,
      // Label 420: @25202
      GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(25317), // Rule ID 13580 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13580,
        GIR_EraseRootFromParent_Done,
      // Label 421: @25317
      GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(25432), // Rule ID 2078 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2078,
        GIR_EraseRootFromParent_Done,
      // Label 422: @25432
      GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(25499), // Rule ID 13481 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13481,
        GIR_EraseRootFromParent_Done,
      // Label 423: @25499
      GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(25566), // Rule ID 13511 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13511,
        GIR_EraseRootFromParent_Done,
      // Label 424: @25566
      GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(25633), // Rule ID 1716 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1716,
        GIR_EraseRootFromParent_Done,
      // Label 425: @25633
      GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(25700), // Rule ID 1806 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1806,
        GIR_EraseRootFromParent_Done,
      // Label 426: @25700
      GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(25781), // Rule ID 13465 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 634:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (SABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13465,
        GIR_EraseRootFromParent_Done,
      // Label 427: @25781
      GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(25862), // Rule ID 13489 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 699:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (UABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13489,
        GIR_EraseRootFromParent_Done,
      // Label 428: @25862
      GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(25943), // Rule ID 1682 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 634:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)))  =>  (SABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1682,
        GIR_EraseRootFromParent_Done,
      // Label 429: @25943
      GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(26024), // Rule ID 1760 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 699:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)))  =>  (UABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1760,
        GIR_EraseRootFromParent_Done,
      // Label 430: @26024
      GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(26116), // Rule ID 13555 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13555,
        GIR_EraseRootFromParent_Done,
      // Label 431: @26116
      GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(26208), // Rule ID 13554 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13554,
        GIR_EraseRootFromParent_Done,
      // Label 432: @26208
      GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(26300), // Rule ID 13585 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13585,
        GIR_EraseRootFromParent_Done,
      // Label 433: @26300
      GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(26392), // Rule ID 13584 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13584,
        GIR_EraseRootFromParent_Done,
      // Label 434: @26392
      GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(26484), // Rule ID 13553 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13553,
        GIR_EraseRootFromParent_Done,
      // Label 435: @26484
      GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(26576), // Rule ID 2027 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2027,
        GIR_EraseRootFromParent_Done,
      // Label 436: @26576
      GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(26668), // Rule ID 13583 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13583,
        GIR_EraseRootFromParent_Done,
      // Label 437: @26668
      GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(26760), // Rule ID 2079 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2079,
        GIR_EraseRootFromParent_Done,
      // Label 438: @26760
      GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(26811), // Rule ID 13503 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13503,
        GIR_EraseRootFromParent_Done,
      // Label 439: @26811
      GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(26862), // Rule ID 13475 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rn)  =>  (SADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13475,
        GIR_EraseRootFromParent_Done,
      // Label 440: @26862
      GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(26913), // Rule ID 13502 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13502,
        GIR_EraseRootFromParent_Done,
      // Label 441: @26913
      GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(26964), // Rule ID 1798 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1798,
        GIR_EraseRootFromParent_Done,
      // Label 442: @26964
      GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(27015), // Rule ID 1710 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1710,
        GIR_EraseRootFromParent_Done,
      // Label 443: @27015
      GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(27066), // Rule ID 1797 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1797,
        GIR_EraseRootFromParent_Done,
      // Label 444: @27066
      GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(27135), // Rule ID 13429 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 634:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (SABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13429,
        GIR_EraseRootFromParent_Done,
      // Label 445: @27135
      GIM_Try, /*On fail goto*//*Label 446*/ GIMT_Encode4(27204), // Rule ID 13441 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 699:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (UABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13441,
        GIR_EraseRootFromParent_Done,
      // Label 446: @27204
      GIM_Try, /*On fail goto*//*Label 447*/ GIMT_Encode4(27260), // Rule ID 13391 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 635:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13391,
        GIR_EraseRootFromParent_Done,
      // Label 447: @27260
      GIM_Try, /*On fail goto*//*Label 448*/ GIMT_Encode4(27316), // Rule ID 13403 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 700:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13403,
        GIR_EraseRootFromParent_Done,
      // Label 448: @27316
      GIM_Try, /*On fail goto*//*Label 449*/ GIMT_Encode4(27383), // Rule ID 13633 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v4i32] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13633,
        GIR_EraseRootFromParent_Done,
      // Label 449: @27383
      GIM_Try, /*On fail goto*//*Label 450*/ GIMT_Encode4(27450), // Rule ID 13654 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v4i32] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13654,
        GIR_EraseRootFromParent_Done,
      // Label 450: @27450
      GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(27519), // Rule ID 1356 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 634:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (SABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1356,
        GIR_EraseRootFromParent_Done,
      // Label 451: @27519
      GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(27588), // Rule ID 1479 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 699:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (UABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1479,
        GIR_EraseRootFromParent_Done,
      // Label 452: @27588
      GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(27644), // Rule ID 984 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 635:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 984,
        GIR_EraseRootFromParent_Done,
      // Label 453: @27644
      GIM_Try, /*On fail goto*//*Label 454*/ GIMT_Encode4(27700), // Rule ID 1045 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 700:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1045,
        GIR_EraseRootFromParent_Done,
      // Label 454: @27700
      GIM_Try, /*On fail goto*//*Label 455*/ GIMT_Encode4(27767), // Rule ID 2227 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2227,
        GIR_EraseRootFromParent_Done,
      // Label 455: @27767
      GIM_Try, /*On fail goto*//*Label 456*/ GIMT_Encode4(27834), // Rule ID 2286 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2286,
        GIR_EraseRootFromParent_Done,
      // Label 456: @27834
      GIM_Try, /*On fail goto*//*Label 457*/ GIMT_Encode4(27904), // Rule ID 7086 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
        // MIs[2] Rn
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[2] Rm
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v4i32] } (AArch64uzp1:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm), (AArch64uzp2:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm))  =>  (ADDPv4i32:{ *:[v4i32] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7086,
        GIR_EraseRootFromParent_Done,
      // Label 457: @27904
      GIM_Try, /*On fail goto*//*Label 458*/ GIMT_Encode4(27974), // Rule ID 14018 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
        // MIs[2] Rn
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[2] Rm
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v4i32] } (AArch64uzp2:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm), (AArch64uzp1:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm))  =>  (ADDPv4i32:{ *:[v4i32] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14018,
        GIR_EraseRootFromParent_Done,
      // Label 458: @27974
      GIM_Try, /*On fail goto*//*Label 459*/ GIMT_Encode4(28037), // Rule ID 1778 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1778,
        GIR_EraseRootFromParent_Done,
      // Label 459: @28037
      GIM_Try, /*On fail goto*//*Label 460*/ GIMT_Encode4(28100), // Rule ID 1777 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1777,
        GIR_EraseRootFromParent_Done,
      // Label 460: @28100
      GIM_Try, /*On fail goto*//*Label 461*/ GIMT_Encode4(28163), // Rule ID 1703 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1703,
        GIR_EraseRootFromParent_Done,
      // Label 461: @28163
      GIM_Try, /*On fail goto*//*Label 462*/ GIMT_Encode4(28226), // Rule ID 1776 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1776,
        GIR_EraseRootFromParent_Done,
      // Label 462: @28226
      GIM_Try, /*On fail goto*//*Label 463*/ GIMT_Encode4(28289), // Rule ID 1775 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1775,
        GIR_EraseRootFromParent_Done,
      // Label 463: @28289
      GIM_Try, /*On fail goto*//*Label 464*/ GIMT_Encode4(28350), // Rule ID 13480 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13480,
        GIR_EraseRootFromParent_Done,
      // Label 464: @28350
      GIM_Try, /*On fail goto*//*Label 465*/ GIMT_Encode4(28411), // Rule ID 13510 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13510,
        GIR_EraseRootFromParent_Done,
      // Label 465: @28411
      GIM_Try, /*On fail goto*//*Label 466*/ GIMT_Encode4(28459), // Rule ID 13501 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13501,
        GIR_EraseRootFromParent_Done,
      // Label 466: @28459
      GIM_Try, /*On fail goto*//*Label 467*/ GIMT_Encode4(28507), // Rule ID 13390 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v4i32] } (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13390,
        GIR_EraseRootFromParent_Done,
      // Label 467: @28507
      GIM_Try, /*On fail goto*//*Label 468*/ GIMT_Encode4(28555), // Rule ID 13474 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rn)  =>  (SADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13474,
        GIR_EraseRootFromParent_Done,
      // Label 468: @28555
      GIM_Try, /*On fail goto*//*Label 469*/ GIMT_Encode4(28603), // Rule ID 13402 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v4i32] } (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13402,
        GIR_EraseRootFromParent_Done,
      // Label 469: @28603
      GIM_Try, /*On fail goto*//*Label 470*/ GIMT_Encode4(28651), // Rule ID 13500 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13500,
        GIR_EraseRootFromParent_Done,
      // Label 470: @28651
      GIM_Try, /*On fail goto*//*Label 471*/ GIMT_Encode4(28712), // Rule ID 1715 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1715,
        GIR_EraseRootFromParent_Done,
      // Label 471: @28712
      GIM_Try, /*On fail goto*//*Label 472*/ GIMT_Encode4(28773), // Rule ID 1805 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1805,
        GIR_EraseRootFromParent_Done,
      // Label 472: @28773
      GIM_Try, /*On fail goto*//*Label 473*/ GIMT_Encode4(28821), // Rule ID 1796 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1796,
        GIR_EraseRootFromParent_Done,
      // Label 473: @28821
      GIM_Try, /*On fail goto*//*Label 474*/ GIMT_Encode4(28869), // Rule ID 983 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 983,
        GIR_EraseRootFromParent_Done,
      // Label 474: @28869
      GIM_Try, /*On fail goto*//*Label 475*/ GIMT_Encode4(28917), // Rule ID 1709 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1709,
        GIR_EraseRootFromParent_Done,
      // Label 475: @28917
      GIM_Try, /*On fail goto*//*Label 476*/ GIMT_Encode4(28965), // Rule ID 1044 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1044,
        GIR_EraseRootFromParent_Done,
      // Label 476: @28965
      GIM_Try, /*On fail goto*//*Label 477*/ GIMT_Encode4(29013), // Rule ID 1795 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1795,
        GIR_EraseRootFromParent_Done,
      // Label 477: @29013
      GIM_Try, /*On fail goto*//*Label 478*/ GIMT_Encode4(29040), // Rule ID 1094 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1094,
        GIR_Done,
      // Label 478: @29040
      GIM_Reject,
    // Label 397: @29041
    GIM_Reject,
    // Label 161: @29042
    GIM_Try, /*On fail goto*//*Label 479*/ GIMT_Encode4(29891),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_Try, /*On fail goto*//*Label 480*/ GIMT_Encode4(29186), // Rule ID 14023 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_TRUNC),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BITCAST),
        // MIs[5] Rn
        GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/5,
        // (add:{ *:[v8i8] } (extract_subvector:{ *:[v8i8] } (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, (undef:{ *:[v16i8] })), 0:{ *:[i64] }), (trunc:{ *:[v8i8] } (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$Rn)))  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (ADDPv16i8:{ *:[f128] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rn), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 14023,
        GIR_EraseRootFromParent_Done,
      // Label 480: @29186
      GIM_Try, /*On fail goto*//*Label 481*/ GIMT_Encode4(29319), // Rule ID 7091 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITCAST),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_UZP2),
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v16s8,
        // MIs[4] Rn
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/5,
        // (add:{ *:[v8i8] } (trunc:{ *:[v8i8] } (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$Rn)), (extract_subvector:{ *:[v8i8] } (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, (undef:{ *:[v16i8] })), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (ADDPv16i8:{ *:[f128] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rn), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 7091,
        GIR_EraseRootFromParent_Done,
      // Label 481: @29319
      GIM_Try, /*On fail goto*//*Label 482*/ GIMT_Encode4(29388), // Rule ID 13419 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v8i8] } (intrinsic_wo_chain:{ *:[v8i8] } 634:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V64:{ *:[v8i8] }:$Rd)  =>  (SABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13419,
        GIR_EraseRootFromParent_Done,
      // Label 482: @29388
      GIM_Try, /*On fail goto*//*Label 483*/ GIMT_Encode4(29457), // Rule ID 13431 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v8i8] } (intrinsic_wo_chain:{ *:[v8i8] } 699:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V64:{ *:[v8i8] }:$Rd)  =>  (UABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13431,
        GIR_EraseRootFromParent_Done,
      // Label 483: @29457
      GIM_Try, /*On fail goto*//*Label 484*/ GIMT_Encode4(29524), // Rule ID 13623 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v8i8] } (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13623,
        GIR_EraseRootFromParent_Done,
      // Label 484: @29524
      GIM_Try, /*On fail goto*//*Label 485*/ GIMT_Encode4(29591), // Rule ID 13644 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13644,
        GIR_EraseRootFromParent_Done,
      // Label 485: @29591
      GIM_Try, /*On fail goto*//*Label 486*/ GIMT_Encode4(29660), // Rule ID 1346 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 634:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1346,
        GIR_EraseRootFromParent_Done,
      // Label 486: @29660
      GIM_Try, /*On fail goto*//*Label 487*/ GIMT_Encode4(29729), // Rule ID 1469 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 699:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1469,
        GIR_EraseRootFromParent_Done,
      // Label 487: @29729
      GIM_Try, /*On fail goto*//*Label 488*/ GIMT_Encode4(29796), // Rule ID 2217 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2217,
        GIR_EraseRootFromParent_Done,
      // Label 488: @29796
      GIM_Try, /*On fail goto*//*Label 489*/ GIMT_Encode4(29863), // Rule ID 2276 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2276,
        GIR_EraseRootFromParent_Done,
      // Label 489: @29863
      GIM_Try, /*On fail goto*//*Label 490*/ GIMT_Encode4(29890), // Rule ID 1089 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv8i8),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1089,
        GIR_Done,
      // Label 490: @29890
      GIM_Reject,
    // Label 479: @29891
    GIM_Reject,
    // Label 162: @29892
    GIM_Try, /*On fail goto*//*Label 491*/ GIMT_Encode4(33469),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_Try, /*On fail goto*//*Label 492*/ GIMT_Encode4(29990), // Rule ID 13463 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 634:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))), V128:{ *:[v8i16] }:$Rd)  =>  (SABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13463,
        GIR_EraseRootFromParent_Done,
      // Label 492: @29990
      GIM_Try, /*On fail goto*//*Label 493*/ GIMT_Encode4(30077), // Rule ID 13487 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 699:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))), V128:{ *:[v8i16] }:$Rd)  =>  (UABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13487,
        GIR_EraseRootFromParent_Done,
      // Label 493: @30077
      GIM_Try, /*On fail goto*//*Label 494*/ GIMT_Encode4(30164), // Rule ID 1680 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 634:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))))  =>  (SABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1680,
        GIR_EraseRootFromParent_Done,
      // Label 494: @30164
      GIM_Try, /*On fail goto*//*Label 495*/ GIMT_Encode4(30251), // Rule ID 1758 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 699:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))))  =>  (UABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1758,
        GIR_EraseRootFromParent_Done,
      // Label 495: @30251
      GIM_Try, /*On fail goto*//*Label 496*/ GIMT_Encode4(30320), // Rule ID 1774 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1774,
        GIR_EraseRootFromParent_Done,
      // Label 496: @30320
      GIM_Try, /*On fail goto*//*Label 497*/ GIMT_Encode4(30389), // Rule ID 1773 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1773,
        GIR_EraseRootFromParent_Done,
      // Label 497: @30389
      GIM_Try, /*On fail goto*//*Label 498*/ GIMT_Encode4(30458), // Rule ID 1702 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1702,
        GIR_EraseRootFromParent_Done,
      // Label 498: @30458
      GIM_Try, /*On fail goto*//*Label 499*/ GIMT_Encode4(30527), // Rule ID 1772 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1772,
        GIR_EraseRootFromParent_Done,
      // Label 499: @30527
      GIM_Try, /*On fail goto*//*Label 500*/ GIMT_Encode4(30596), // Rule ID 1771 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1771,
        GIR_EraseRootFromParent_Done,
      // Label 500: @30596
      GIM_Try, /*On fail goto*//*Label 501*/ GIMT_Encode4(30663), // Rule ID 13479 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (add:{ *:[v8i16] } (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (SMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13479,
        GIR_EraseRootFromParent_Done,
      // Label 501: @30663
      GIM_Try, /*On fail goto*//*Label 502*/ GIMT_Encode4(30730), // Rule ID 13509 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (add:{ *:[v8i16] } (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (UMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13509,
        GIR_EraseRootFromParent_Done,
      // Label 502: @30730
      GIM_Try, /*On fail goto*//*Label 503*/ GIMT_Encode4(30797), // Rule ID 1714 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1714,
        GIR_EraseRootFromParent_Done,
      // Label 503: @30797
      GIM_Try, /*On fail goto*//*Label 504*/ GIMT_Encode4(30864), // Rule ID 1804 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1804,
        GIR_EraseRootFromParent_Done,
      // Label 504: @30864
      GIM_Try, /*On fail goto*//*Label 505*/ GIMT_Encode4(30945), // Rule ID 13461 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 634:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (SABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13461,
        GIR_EraseRootFromParent_Done,
      // Label 505: @30945
      GIM_Try, /*On fail goto*//*Label 506*/ GIMT_Encode4(31026), // Rule ID 13485 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 699:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (UABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13485,
        GIR_EraseRootFromParent_Done,
      // Label 506: @31026
      GIM_Try, /*On fail goto*//*Label 507*/ GIMT_Encode4(31107), // Rule ID 1678 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 634:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)))  =>  (SABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1678,
        GIR_EraseRootFromParent_Done,
      // Label 507: @31107
      GIM_Try, /*On fail goto*//*Label 508*/ GIMT_Encode4(31188), // Rule ID 1756 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 699:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)))  =>  (UABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1756,
        GIR_EraseRootFromParent_Done,
      // Label 508: @31188
      GIM_Try, /*On fail goto*//*Label 509*/ GIMT_Encode4(31239), // Rule ID 13499 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13499,
        GIR_EraseRootFromParent_Done,
      // Label 509: @31239
      GIM_Try, /*On fail goto*//*Label 510*/ GIMT_Encode4(31290), // Rule ID 13473 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rn)  =>  (SADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13473,
        GIR_EraseRootFromParent_Done,
      // Label 510: @31290
      GIM_Try, /*On fail goto*//*Label 511*/ GIMT_Encode4(31341), // Rule ID 13498 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13498,
        GIR_EraseRootFromParent_Done,
      // Label 511: @31341
      GIM_Try, /*On fail goto*//*Label 512*/ GIMT_Encode4(31392), // Rule ID 1794 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1794,
        GIR_EraseRootFromParent_Done,
      // Label 512: @31392
      GIM_Try, /*On fail goto*//*Label 513*/ GIMT_Encode4(31443), // Rule ID 1708 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1708,
        GIR_EraseRootFromParent_Done,
      // Label 513: @31443
      GIM_Try, /*On fail goto*//*Label 514*/ GIMT_Encode4(31494), // Rule ID 1793 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1793,
        GIR_EraseRootFromParent_Done,
      // Label 514: @31494
      GIM_Try, /*On fail goto*//*Label 515*/ GIMT_Encode4(31563), // Rule ID 13425 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 634:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (SABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13425,
        GIR_EraseRootFromParent_Done,
      // Label 515: @31563
      GIM_Try, /*On fail goto*//*Label 516*/ GIMT_Encode4(31632), // Rule ID 13437 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 699:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (UABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13437,
        GIR_EraseRootFromParent_Done,
      // Label 516: @31632
      GIM_Try, /*On fail goto*//*Label 517*/ GIMT_Encode4(31688), // Rule ID 13387 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 635:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13387,
        GIR_EraseRootFromParent_Done,
      // Label 517: @31688
      GIM_Try, /*On fail goto*//*Label 518*/ GIMT_Encode4(31744), // Rule ID 13399 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 700:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13399,
        GIR_EraseRootFromParent_Done,
      // Label 518: @31744
      GIM_Try, /*On fail goto*//*Label 519*/ GIMT_Encode4(31811), // Rule ID 13629 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v8i16] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13629,
        GIR_EraseRootFromParent_Done,
      // Label 519: @31811
      GIM_Try, /*On fail goto*//*Label 520*/ GIMT_Encode4(31878), // Rule ID 13650 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v8i16] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13650,
        GIR_EraseRootFromParent_Done,
      // Label 520: @31878
      GIM_Try, /*On fail goto*//*Label 521*/ GIMT_Encode4(31947), // Rule ID 1352 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 634:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (SABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1352,
        GIR_EraseRootFromParent_Done,
      // Label 521: @31947
      GIM_Try, /*On fail goto*//*Label 522*/ GIMT_Encode4(32016), // Rule ID 1475 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 699:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (UABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1475,
        GIR_EraseRootFromParent_Done,
      // Label 522: @32016
      GIM_Try, /*On fail goto*//*Label 523*/ GIMT_Encode4(32072), // Rule ID 980 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 635:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 980,
        GIR_EraseRootFromParent_Done,
      // Label 523: @32072
      GIM_Try, /*On fail goto*//*Label 524*/ GIMT_Encode4(32128), // Rule ID 1041 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 700:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1041,
        GIR_EraseRootFromParent_Done,
      // Label 524: @32128
      GIM_Try, /*On fail goto*//*Label 525*/ GIMT_Encode4(32195), // Rule ID 2223 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2223,
        GIR_EraseRootFromParent_Done,
      // Label 525: @32195
      GIM_Try, /*On fail goto*//*Label 526*/ GIMT_Encode4(32262), // Rule ID 2282 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2282,
        GIR_EraseRootFromParent_Done,
      // Label 526: @32262
      GIM_Try, /*On fail goto*//*Label 527*/ GIMT_Encode4(32332), // Rule ID 7087 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
        // MIs[2] Rn
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[2] Rm
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v8i16] } (AArch64uzp1:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm), (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm))  =>  (ADDPv8i16:{ *:[v8i16] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7087,
        GIR_EraseRootFromParent_Done,
      // Label 527: @32332
      GIM_Try, /*On fail goto*//*Label 528*/ GIMT_Encode4(32402), // Rule ID 14019 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
        // MIs[2] Rn
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[2] Rm
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v8i16] } (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm), (AArch64uzp1:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm))  =>  (ADDPv8i16:{ *:[v8i16] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14019,
        GIR_EraseRootFromParent_Done,
      // Label 528: @32402
      GIM_Try, /*On fail goto*//*Label 529*/ GIMT_Encode4(32465), // Rule ID 1770 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1770,
        GIR_EraseRootFromParent_Done,
      // Label 529: @32465
      GIM_Try, /*On fail goto*//*Label 530*/ GIMT_Encode4(32528), // Rule ID 1769 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1769,
        GIR_EraseRootFromParent_Done,
      // Label 530: @32528
      GIM_Try, /*On fail goto*//*Label 531*/ GIMT_Encode4(32591), // Rule ID 1701 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv8i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1701,
        GIR_EraseRootFromParent_Done,
      // Label 531: @32591
      GIM_Try, /*On fail goto*//*Label 532*/ GIMT_Encode4(32654), // Rule ID 1768 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1768,
        GIR_EraseRootFromParent_Done,
      // Label 532: @32654
      GIM_Try, /*On fail goto*//*Label 533*/ GIMT_Encode4(32717), // Rule ID 1767 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1767,
        GIR_EraseRootFromParent_Done,
      // Label 533: @32717
      GIM_Try, /*On fail goto*//*Label 534*/ GIMT_Encode4(32778), // Rule ID 13478 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v8i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (SMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13478,
        GIR_EraseRootFromParent_Done,
      // Label 534: @32778
      GIM_Try, /*On fail goto*//*Label 535*/ GIMT_Encode4(32839), // Rule ID 13508 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v8i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (UMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13508,
        GIR_EraseRootFromParent_Done,
      // Label 535: @32839
      GIM_Try, /*On fail goto*//*Label 536*/ GIMT_Encode4(32887), // Rule ID 13497 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13497,
        GIR_EraseRootFromParent_Done,
      // Label 536: @32887
      GIM_Try, /*On fail goto*//*Label 537*/ GIMT_Encode4(32935), // Rule ID 13386 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v8i16] } (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13386,
        GIR_EraseRootFromParent_Done,
      // Label 537: @32935
      GIM_Try, /*On fail goto*//*Label 538*/ GIMT_Encode4(32983), // Rule ID 13472 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rn)  =>  (SADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13472,
        GIR_EraseRootFromParent_Done,
      // Label 538: @32983
      GIM_Try, /*On fail goto*//*Label 539*/ GIMT_Encode4(33031), // Rule ID 13398 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v8i16] } (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13398,
        GIR_EraseRootFromParent_Done,
      // Label 539: @33031
      GIM_Try, /*On fail goto*//*Label 540*/ GIMT_Encode4(33079), // Rule ID 13496 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13496,
        GIR_EraseRootFromParent_Done,
      // Label 540: @33079
      GIM_Try, /*On fail goto*//*Label 541*/ GIMT_Encode4(33140), // Rule ID 1713 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1713,
        GIR_EraseRootFromParent_Done,
      // Label 541: @33140
      GIM_Try, /*On fail goto*//*Label 542*/ GIMT_Encode4(33201), // Rule ID 1803 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1803,
        GIR_EraseRootFromParent_Done,
      // Label 542: @33201
      GIM_Try, /*On fail goto*//*Label 543*/ GIMT_Encode4(33249), // Rule ID 1792 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1792,
        GIR_EraseRootFromParent_Done,
      // Label 543: @33249
      GIM_Try, /*On fail goto*//*Label 544*/ GIMT_Encode4(33297), // Rule ID 979 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 979,
        GIR_EraseRootFromParent_Done,
      // Label 544: @33297
      GIM_Try, /*On fail goto*//*Label 545*/ GIMT_Encode4(33345), // Rule ID 1707 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1707,
        GIR_EraseRootFromParent_Done,
      // Label 545: @33345
      GIM_Try, /*On fail goto*//*Label 546*/ GIMT_Encode4(33393), // Rule ID 1040 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1040,
        GIR_EraseRootFromParent_Done,
      // Label 546: @33393
      GIM_Try, /*On fail goto*//*Label 547*/ GIMT_Encode4(33441), // Rule ID 1791 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1791,
        GIR_EraseRootFromParent_Done,
      // Label 547: @33441
      GIM_Try, /*On fail goto*//*Label 548*/ GIMT_Encode4(33468), // Rule ID 1092 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv8i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1092,
        GIR_Done,
      // Label 548: @33468
      GIM_Reject,
    // Label 491: @33469
    GIM_Reject,
    // Label 163: @33470
    GIM_Try, /*On fail goto*//*Label 549*/ GIMT_Encode4(34193),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_Try, /*On fail goto*//*Label 550*/ GIMT_Encode4(33550), // Rule ID 13421 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v16i8] } (intrinsic_wo_chain:{ *:[v16i8] } 634:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm), V128:{ *:[v16i8] }:$Rd)  =>  (SABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13421,
        GIR_EraseRootFromParent_Done,
      // Label 550: @33550
      GIM_Try, /*On fail goto*//*Label 551*/ GIMT_Encode4(33619), // Rule ID 13433 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v16i8] } (intrinsic_wo_chain:{ *:[v16i8] } 699:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm), V128:{ *:[v16i8] }:$Rd)  =>  (UABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13433,
        GIR_EraseRootFromParent_Done,
      // Label 551: @33619
      GIM_Try, /*On fail goto*//*Label 552*/ GIMT_Encode4(33686), // Rule ID 13625 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v16i8] } (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13625,
        GIR_EraseRootFromParent_Done,
      // Label 552: @33686
      GIM_Try, /*On fail goto*//*Label 553*/ GIMT_Encode4(33753), // Rule ID 13646 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v16i8] } (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13646,
        GIR_EraseRootFromParent_Done,
      // Label 553: @33753
      GIM_Try, /*On fail goto*//*Label 554*/ GIMT_Encode4(33822), // Rule ID 1348 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (intrinsic_wo_chain:{ *:[v16i8] } 634:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))  =>  (SABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1348,
        GIR_EraseRootFromParent_Done,
      // Label 554: @33822
      GIM_Try, /*On fail goto*//*Label 555*/ GIMT_Encode4(33891), // Rule ID 1471 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (intrinsic_wo_chain:{ *:[v16i8] } 699:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))  =>  (UABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1471,
        GIR_EraseRootFromParent_Done,
      // Label 555: @33891
      GIM_Try, /*On fail goto*//*Label 556*/ GIMT_Encode4(33958), // Rule ID 2219 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2219,
        GIR_EraseRootFromParent_Done,
      // Label 556: @33958
      GIM_Try, /*On fail goto*//*Label 557*/ GIMT_Encode4(34025), // Rule ID 2278 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2278,
        GIR_EraseRootFromParent_Done,
      // Label 557: @34025
      GIM_Try, /*On fail goto*//*Label 558*/ GIMT_Encode4(34095), // Rule ID 7088 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
        // MIs[2] Rn
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[2] Rm
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v16i8] } (AArch64uzp1:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm), (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm))  =>  (ADDPv16i8:{ *:[v16i8] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7088,
        GIR_EraseRootFromParent_Done,
      // Label 558: @34095
      GIM_Try, /*On fail goto*//*Label 559*/ GIMT_Encode4(34165), // Rule ID 14020 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
        // MIs[2] Rn
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[2] Rm
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[v16i8] } (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm), (AArch64uzp1:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm))  =>  (ADDPv16i8:{ *:[v16i8] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14020,
        GIR_EraseRootFromParent_Done,
      // Label 559: @34165
      GIM_Try, /*On fail goto*//*Label 560*/ GIMT_Encode4(34192), // Rule ID 1090 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv16i8),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1090,
        GIR_Done,
      // Label 560: @34192
      GIM_Reject,
    // Label 549: @34193
    GIM_Reject,
    // Label 164: @34194
    GIM_Try, /*On fail goto*//*Label 561*/ GIMT_Encode4(34565),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 562*/ GIMT_Encode4(34271), // Rule ID 15208 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15208,
        GIR_EraseRootFromParent_Done,
      // Label 562: @34271
      GIM_Try, /*On fail goto*//*Label 563*/ GIMT_Encode4(34333), // Rule ID 15207 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15207,
        GIR_EraseRootFromParent_Done,
      // Label 563: @34333
      GIM_Try, /*On fail goto*//*Label 564*/ GIMT_Encode4(34395), // Rule ID 15206 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15206,
        GIR_EraseRootFromParent_Done,
      // Label 564: @34395
      GIM_Try, /*On fail goto*//*Label 565*/ GIMT_Encode4(34457), // Rule ID 9073 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] })))  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9073,
        GIR_EraseRootFromParent_Done,
      // Label 565: @34457
      GIM_Try, /*On fail goto*//*Label 566*/ GIMT_Encode4(34503), // Rule ID 15209 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[nxv2i64] } (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i32:{ *:[Other] }), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (ADR_SXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_SXTW_ZZZ_D_0),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15209,
        GIR_EraseRootFromParent_Done,
      // Label 566: @34503
      GIM_Try, /*On fail goto*//*Label 567*/ GIMT_Encode4(34549), // Rule ID 9074 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i32:{ *:[Other] }))  =>  (ADR_SXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_SXTW_ZZZ_D_0),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9074,
        GIR_EraseRootFromParent_Done,
      // Label 567: @34549
      GIM_Try, /*On fail goto*//*Label 568*/ GIMT_Encode4(34564), // Rule ID 2741 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADD_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2741,
        GIR_Done,
      // Label 568: @34564
      GIM_Reject,
    // Label 561: @34565
    GIM_Reject,
    // Label 165: @34566
    GIM_Try, /*On fail goto*//*Label 569*/ GIMT_Encode4(34591), // Rule ID 2740 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (add:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADD_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_S),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2740,
      GIR_Done,
    // Label 569: @34591
    GIM_Reject,
    // Label 166: @34592
    GIM_Try, /*On fail goto*//*Label 570*/ GIMT_Encode4(34617), // Rule ID 2739 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (add:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ADD_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_H),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2739,
      GIR_Done,
    // Label 570: @34617
    GIM_Reject,
    // Label 167: @34618
    GIM_Try, /*On fail goto*//*Label 571*/ GIMT_Encode4(34643), // Rule ID 2738 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (add:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ADD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_B),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2738,
      GIR_Done,
    // Label 571: @34643
    GIM_Reject,
    // Label 168: @34644
    GIM_Reject,
    // Label 1: @34645
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 585*/ GIMT_Encode4(47992),
    /*GILLT_s32*//*Label 572*/ GIMT_Encode4(34744),
    /*GILLT_s64*//*Label 573*/ GIMT_Encode4(35598), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 574*/ GIMT_Encode4(38628),
    /*GILLT_v2s64*//*Label 575*/ GIMT_Encode4(40119),
    /*GILLT_v4s16*//*Label 576*/ GIMT_Encode4(42579),
    /*GILLT_v4s32*//*Label 577*/ GIMT_Encode4(44070),
    /*GILLT_v8s8*//*Label 578*/ GIMT_Encode4(46530),
    /*GILLT_v8s16*//*Label 579*/ GIMT_Encode4(46605),
    /*GILLT_v16s8*//*Label 580*/ GIMT_Encode4(47813), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s64*//*Label 581*/ GIMT_Encode4(47888), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv4s32*//*Label 582*/ GIMT_Encode4(47914), GIMT_Encode4(0),
    /*GILLT_nxv8s16*//*Label 583*/ GIMT_Encode4(47940), GIMT_Encode4(0),
    /*GILLT_nxv16s8*//*Label 584*/ GIMT_Encode4(47966),
    // Label 572: @34744
    GIM_Try, /*On fail goto*//*Label 586*/ GIMT_Encode4(35597),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 587*/ GIMT_Encode4(34907), // Rule ID 10150 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME_UseScalarIncVL),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
        // MIs[2] pattern
        GIM_CheckIsImm, /*MI*/2, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1212:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECB_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECB_XPiI),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
        GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        // GIR_Coverage, 10150,
        GIR_EraseRootFromParent_Done,
      // Label 587: @34907
      GIM_Try, /*On fail goto*//*Label 588*/ GIMT_Encode4(35059), // Rule ID 10162 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME_UseScalarIncVL),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
        // MIs[2] pattern
        GIM_CheckIsImm, /*MI*/2, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1214:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECH_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECH_XPiI),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
        GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        // GIR_Coverage, 10162,
        GIR_EraseRootFromParent_Done,
      // Label 588: @35059
      GIM_Try, /*On fail goto*//*Label 589*/ GIMT_Encode4(35211), // Rule ID 10174 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME_UseScalarIncVL),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
        // MIs[2] pattern
        GIM_CheckIsImm, /*MI*/2, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1220:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECW_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECW_XPiI),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
        GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        // GIR_Coverage, 10174,
        GIR_EraseRootFromParent_Done,
      // Label 589: @35211
      GIM_Try, /*On fail goto*//*Label 590*/ GIMT_Encode4(35363), // Rule ID 10186 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME_UseScalarIncVL),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
        // MIs[2] pattern
        GIM_CheckIsImm, /*MI*/2, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1213:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECD_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECD_XPiI),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
        GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        // GIR_Coverage, 10186,
        GIR_EraseRootFromParent_Done,
      // Label 590: @35363
      GIM_Try, /*On fail goto*//*Label 591*/ GIMT_Encode4(35425), // Rule ID 3933 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sub:{ *:[i32] } 0:{ *:[i32] }, (mul:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm))  =>  (MSUBWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBWrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3933,
        GIR_EraseRootFromParent_Done,
      // Label 591: @35425
      GIM_Try, /*On fail goto*//*Label 592*/ GIMT_Encode4(35461), // Rule ID 3898 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32_i32),
        // (sub:{ *:[i32] } GPR32sp:{ *:[i32] }:$R2, arith_extended_reg32_i32:{ *:[i32] }:$R3)  =>  (SUBSWrx:{ *:[i32] }:{ *:[i32] } GPR32sp:{ *:[i32] }:$R2, arith_extended_reg32_i32:{ *:[i32] }:$R3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWrx),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // R2
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // R3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3898,
        GIR_EraseRootFromParent_Done,
      // Label 592: @35461
      GIM_Try, /*On fail goto*//*Label 593*/ GIMT_Encode4(35494), // Rule ID 3903 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm32),
        // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (ADDWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3903,
        GIR_EraseRootFromParent_Done,
      // Label 593: @35494
      GIM_Try, /*On fail goto*//*Label 594*/ GIMT_Encode4(35530), // Rule ID 3892 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm32),
        // (sub:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (SUBSWri:{ *:[i32] }:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3892,
        GIR_EraseRootFromParent_Done,
      // Label 594: @35530
      GIM_Try, /*On fail goto*//*Label 595*/ GIMT_Encode4(35566), // Rule ID 3896 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg32),
        // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm)  =>  (SUBSWrs:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3896,
        GIR_EraseRootFromParent_Done,
      // Label 595: @35566
      GIM_Try, /*On fail goto*//*Label 596*/ GIMT_Encode4(35596), // Rule ID 3894 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SUBSWrr:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBSWrr),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AArch64::NZCV), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3894,
        GIR_Done,
      // Label 596: @35596
      GIM_Reject,
    // Label 586: @35597
    GIM_Reject,
    // Label 573: @35598
    GIM_Try, /*On fail goto*//*Label 597*/ GIMT_Encode4(38627),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 598*/ GIMT_Encode4(35745), // Rule ID 5438 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5438,
        GIR_EraseRootFromParent_Done,
      // Label 598: @35745
      GIM_Try, /*On fail goto*//*Label 599*/ GIMT_Encode4(35881), // Rule ID 5437 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5437,
        GIR_EraseRootFromParent_Done,
      // Label 599: @35881
      GIM_Try, /*On fail goto*//*Label 600*/ GIMT_Encode4(36017), // Rule ID 5447 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SSUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv2i32_v2i64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5447,
        GIR_EraseRootFromParent_Done,
      // Label 600: @36017
      GIM_Try, /*On fail goto*//*Label 601*/ GIMT_Encode4(36153), // Rule ID 5436 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5436,
        GIR_EraseRootFromParent_Done,
      // Label 601: @36153
      GIM_Try, /*On fail goto*//*Label 602*/ GIMT_Encode4(36289), // Rule ID 5435 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5435,
        GIR_EraseRootFromParent_Done,
      // Label 602: @36289
      GIM_Try, /*On fail goto*//*Label 603*/ GIMT_Encode4(36426), // Rule ID 3950 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3950,
        GIR_EraseRootFromParent_Done,
      // Label 603: @36426
      GIM_Try, /*On fail goto*//*Label 604*/ GIMT_Encode4(36525), // Rule ID 3948 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3948,
        GIR_EraseRootFromParent_Done,
      // Label 604: @36525
      GIM_Try, /*On fail goto*//*Label 605*/ GIMT_Encode4(36624), // Rule ID 3949 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3949,
        GIR_EraseRootFromParent_Done,
      // Label 605: @36624
      GIM_Try, /*On fail goto*//*Label 606*/ GIMT_Encode4(36710), // Rule ID 3943 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3943,
        GIR_EraseRootFromParent_Done,
      // Label 606: @36710
      GIM_Try, /*On fail goto*//*Label 607*/ GIMT_Encode4(36796), // Rule ID 3944 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3944,
        GIR_EraseRootFromParent_Done,
      // Label 607: @36796
      GIM_Try, /*On fail goto*//*Label 608*/ GIMT_Encode4(36929), // Rule ID 3956 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootToRootCopy, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3956,
        GIR_EraseRootFromParent_Done,
      // Label 608: @36929
      GIM_Try, /*On fail goto*//*Label 609*/ GIMT_Encode4(37024), // Rule ID 3954 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3954,
        GIR_EraseRootFromParent_Done,
      // Label 609: @37024
      GIM_Try, /*On fail goto*//*Label 610*/ GIMT_Encode4(37119), // Rule ID 3955 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3955,
        GIR_EraseRootFromParent_Done,
      // Label 610: @37119
      GIM_Try, /*On fail goto*//*Label 611*/ GIMT_Encode4(37201), // Rule ID 136 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 136,
        GIR_EraseRootFromParent_Done,
      // Label 611: @37201
      GIM_Try, /*On fail goto*//*Label 612*/ GIMT_Encode4(37283), // Rule ID 138 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 138,
        GIR_EraseRootFromParent_Done,
      // Label 612: @37283
      GIM_Try, /*On fail goto*//*Label 613*/ GIMT_Encode4(37345), // Rule ID 3934 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm))  =>  (MSUBXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBXrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3934,
        GIR_EraseRootFromParent_Done,
      // Label 613: @37345
      GIM_Try, /*On fail goto*//*Label 614*/ GIMT_Encode4(37403), // Rule ID 10147 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME_UseScalarIncVL),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
        // MIs[1] pattern
        GIM_CheckIsImm, /*MI*/1, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1212:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECB_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECB_XPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10147,
        GIR_EraseRootFromParent_Done,
      // Label 614: @37403
      GIM_Try, /*On fail goto*//*Label 615*/ GIMT_Encode4(37461), // Rule ID 10159 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME_UseScalarIncVL),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
        // MIs[1] pattern
        GIM_CheckIsImm, /*MI*/1, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1214:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECH_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECH_XPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10159,
        GIR_EraseRootFromParent_Done,
      // Label 615: @37461
      GIM_Try, /*On fail goto*//*Label 616*/ GIMT_Encode4(37519), // Rule ID 10171 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME_UseScalarIncVL),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
        // MIs[1] pattern
        GIM_CheckIsImm, /*MI*/1, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1220:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECW_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECW_XPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10171,
        GIR_EraseRootFromParent_Done,
      // Label 616: @37519
      GIM_Try, /*On fail goto*//*Label 617*/ GIMT_Encode4(37577), // Rule ID 10183 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME_UseScalarIncVL),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
        // MIs[1] pattern
        GIM_CheckIsImm, /*MI*/1, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1213:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECD_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECD_XPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10183,
        GIR_EraseRootFromParent_Done,
      // Label 617: @37577
      GIM_Try, /*On fail goto*//*Label 618*/ GIMT_Encode4(37740), // Rule ID 5402 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SMLSLv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_v2i64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5402,
        GIR_EraseRootFromParent_Done,
      // Label 618: @37740
      GIM_Try, /*On fail goto*//*Label 619*/ GIMT_Encode4(37903), // Rule ID 5399 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UMLSLv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_v2i64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5399,
        GIR_EraseRootFromParent_Done,
      // Label 619: @37903
      GIM_Try, /*On fail goto*//*Label 620*/ GIMT_Encode4(38053), // Rule ID 5444 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5444,
        GIR_EraseRootFromParent_Done,
      // Label 620: @38053
      GIM_Try, /*On fail goto*//*Label 621*/ GIMT_Encode4(38203), // Rule ID 5450 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SSUBWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv2i32_v2i64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5450,
        GIR_EraseRootFromParent_Done,
      // Label 621: @38203
      GIM_Try, /*On fail goto*//*Label 622*/ GIMT_Encode4(38353), // Rule ID 5443 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5443,
        GIR_EraseRootFromParent_Done,
      // Label 622: @38353
      GIM_Try, /*On fail goto*//*Label 623*/ GIMT_Encode4(38389), // Rule ID 3899 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32to64_i64),
        // (sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$R2, arith_extended_reg32to64_i64:{ *:[i64] }:$R3)  =>  (SUBSXrx:{ *:[i64] }:{ *:[i32] } GPR64sp:{ *:[i64] }:$R2, arith_extended_reg32to64_i64:{ *:[i64] }:$R3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXrx),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // R2
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // R3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3899,
        GIR_EraseRootFromParent_Done,
      // Label 623: @38389
      GIM_Try, /*On fail goto*//*Label 624*/ GIMT_Encode4(38422), // Rule ID 3904 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm64),
        // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (ADDXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3904,
        GIR_EraseRootFromParent_Done,
      // Label 624: @38422
      GIM_Try, /*On fail goto*//*Label 625*/ GIMT_Encode4(38458), // Rule ID 3893 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm64),
        // (sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (SUBSXri:{ *:[i64] }:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3893,
        GIR_EraseRootFromParent_Done,
      // Label 625: @38458
      GIM_Try, /*On fail goto*//*Label 626*/ GIMT_Encode4(38494), // Rule ID 3897 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg64),
        // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm)  =>  (SUBSXrs:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3897,
        GIR_EraseRootFromParent_Done,
      // Label 626: @38494
      GIM_Try, /*On fail goto*//*Label 627*/ GIMT_Encode4(38533), // Rule ID 1644 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sub:{ *:[v1i64] } immAllZerosV:{ *:[v1i64] }, FPR64:{ *:[v1i64] }:$Rn)  =>  (NEGv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1644,
        GIR_EraseRootFromParent_Done,
      // Label 627: @38533
      GIM_Try, /*On fail goto*//*Label 628*/ GIMT_Encode4(38569), // Rule ID 5283 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sub:{ *:[i64] } immAllZerosV:{ *:[i64] }, FPR64:{ *:[i64] }:$Rn)  =>  (NEGv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5283,
        GIR_EraseRootFromParent_Done,
      // Label 628: @38569
      GIM_Try, /*On fail goto*//*Label 629*/ GIMT_Encode4(38596), // Rule ID 1633 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (sub:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SUBv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv1i64),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1633,
        GIR_Done,
      // Label 629: @38596
      GIM_Try, /*On fail goto*//*Label 630*/ GIMT_Encode4(38626), // Rule ID 3895 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SUBSXrr:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBSXrr),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AArch64::NZCV), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3895,
        GIR_Done,
      // Label 630: @38626
      GIM_Reject,
    // Label 597: @38627
    GIM_Reject,
    // Label 574: @38628
    GIM_Try, /*On fail goto*//*Label 631*/ GIMT_Encode4(40118),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 632*/ GIMT_Encode4(38775), // Rule ID 5434 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5434,
        GIR_EraseRootFromParent_Done,
      // Label 632: @38775
      GIM_Try, /*On fail goto*//*Label 633*/ GIMT_Encode4(38907), // Rule ID 5433 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5433,
        GIR_EraseRootFromParent_Done,
      // Label 633: @38907
      GIM_Try, /*On fail goto*//*Label 634*/ GIMT_Encode4(39039), // Rule ID 5446 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SSUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv4i16_v4i32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5446,
        GIR_EraseRootFromParent_Done,
      // Label 634: @39039
      GIM_Try, /*On fail goto*//*Label 635*/ GIMT_Encode4(39171), // Rule ID 5432 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5432,
        GIR_EraseRootFromParent_Done,
      // Label 635: @39171
      GIM_Try, /*On fail goto*//*Label 636*/ GIMT_Encode4(39303), // Rule ID 5431 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5431,
        GIR_EraseRootFromParent_Done,
      // Label 636: @39303
      GIM_Try, /*On fail goto*//*Label 637*/ GIMT_Encode4(39462), // Rule ID 5401 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SMLSLv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_v4i32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5401,
        GIR_EraseRootFromParent_Done,
      // Label 637: @39462
      GIM_Try, /*On fail goto*//*Label 638*/ GIMT_Encode4(39621), // Rule ID 5398 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UMLSLv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_v4i32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5398,
        GIR_EraseRootFromParent_Done,
      // Label 638: @39621
      GIM_Try, /*On fail goto*//*Label 639*/ GIMT_Encode4(39767), // Rule ID 5442 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5442,
        GIR_EraseRootFromParent_Done,
      // Label 639: @39767
      GIM_Try, /*On fail goto*//*Label 640*/ GIMT_Encode4(39913), // Rule ID 5449 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SSUBWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv4i16_v4i32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5449,
        GIR_EraseRootFromParent_Done,
      // Label 640: @39913
      GIM_Try, /*On fail goto*//*Label 641*/ GIMT_Encode4(40059), // Rule ID 5441 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5441,
        GIR_EraseRootFromParent_Done,
      // Label 641: @40059
      GIM_Try, /*On fail goto*//*Label 642*/ GIMT_Encode4(40094), // Rule ID 958 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sub:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn)  =>  (NEGv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 958,
        GIR_EraseRootFromParent_Done,
      // Label 642: @40094
      GIM_Try, /*On fail goto*//*Label 643*/ GIMT_Encode4(40117), // Rule ID 1465 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv2i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1465,
        GIR_Done,
      // Label 643: @40117
      GIM_Reject,
    // Label 631: @40118
    GIM_Reject,
    // Label 575: @40119
    GIM_Try, /*On fail goto*//*Label 644*/ GIMT_Encode4(42578),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 645*/ GIMT_Encode4(40248), // Rule ID 2037 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2037,
        GIR_EraseRootFromParent_Done,
      // Label 645: @40248
      GIM_Try, /*On fail goto*//*Label 646*/ GIMT_Encode4(40362), // Rule ID 13573 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (SMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13573,
        GIR_EraseRootFromParent_Done,
      // Label 646: @40362
      GIM_Try, /*On fail goto*//*Label 647*/ GIMT_Encode4(40476), // Rule ID 2089 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (UMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2089,
        GIR_EraseRootFromParent_Done,
      // Label 647: @40476
      GIM_Try, /*On fail goto*//*Label 648*/ GIMT_Encode4(40590), // Rule ID 13603 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (UMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13603,
        GIR_EraseRootFromParent_Done,
      // Label 648: @40590
      GIM_Try, /*On fail goto*//*Label 649*/ GIMT_Encode4(40655), // Rule ID 1844 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1844,
        GIR_EraseRootFromParent_Done,
      // Label 649: @40655
      GIM_Try, /*On fail goto*//*Label 650*/ GIMT_Encode4(40720), // Rule ID 1843 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1843,
        GIR_EraseRootFromParent_Done,
      // Label 650: @40720
      GIM_Try, /*On fail goto*//*Label 651*/ GIMT_Encode4(40785), // Rule ID 1748 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (sub:{ *:[v2i64] } (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SSUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1748,
        GIR_EraseRootFromParent_Done,
      // Label 651: @40785
      GIM_Try, /*On fail goto*//*Label 652*/ GIMT_Encode4(40850), // Rule ID 1842 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1842,
        GIR_EraseRootFromParent_Done,
      // Label 652: @40850
      GIM_Try, /*On fail goto*//*Label 653*/ GIMT_Encode4(40915), // Rule ID 1841 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1841,
        GIR_EraseRootFromParent_Done,
      // Label 653: @40915
      GIM_Try, /*On fail goto*//*Label 654*/ GIMT_Encode4(41026), // Rule ID 13571 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13571,
        GIR_EraseRootFromParent_Done,
      // Label 654: @41026
      GIM_Try, /*On fail goto*//*Label 655*/ GIMT_Encode4(41137), // Rule ID 2035 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2035,
        GIR_EraseRootFromParent_Done,
      // Label 655: @41137
      GIM_Try, /*On fail goto*//*Label 656*/ GIMT_Encode4(41248), // Rule ID 13601 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13601,
        GIR_EraseRootFromParent_Done,
      // Label 656: @41248
      GIM_Try, /*On fail goto*//*Label 657*/ GIMT_Encode4(41359), // Rule ID 2087 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2087,
        GIR_EraseRootFromParent_Done,
      // Label 657: @41359
      GIM_Try, /*On fail goto*//*Label 658*/ GIMT_Encode4(41422), // Rule ID 1724 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SMLSLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1724,
        GIR_EraseRootFromParent_Done,
      // Label 658: @41422
      GIM_Try, /*On fail goto*//*Label 659*/ GIMT_Encode4(41485), // Rule ID 1814 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UMLSLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1814,
        GIR_EraseRootFromParent_Done,
      // Label 659: @41485
      GIM_Try, /*On fail goto*//*Label 660*/ GIMT_Encode4(41573), // Rule ID 13572 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13572,
        GIR_EraseRootFromParent_Done,
      // Label 660: @41573
      GIM_Try, /*On fail goto*//*Label 661*/ GIMT_Encode4(41661), // Rule ID 2036 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2036,
        GIR_EraseRootFromParent_Done,
      // Label 661: @41661
      GIM_Try, /*On fail goto*//*Label 662*/ GIMT_Encode4(41749), // Rule ID 13602 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13602,
        GIR_EraseRootFromParent_Done,
      // Label 662: @41749
      GIM_Try, /*On fail goto*//*Label 663*/ GIMT_Encode4(41837), // Rule ID 2088 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2088,
        GIR_EraseRootFromParent_Done,
      // Label 663: @41837
      GIM_Try, /*On fail goto*//*Label 664*/ GIMT_Encode4(41884), // Rule ID 1856 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1856,
        GIR_EraseRootFromParent_Done,
      // Label 664: @41884
      GIM_Try, /*On fail goto*//*Label 665*/ GIMT_Encode4(41931), // Rule ID 1754 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SSUBWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1754,
        GIR_EraseRootFromParent_Done,
      // Label 665: @41931
      GIM_Try, /*On fail goto*//*Label 666*/ GIMT_Encode4(41978), // Rule ID 1855 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1855,
        GIR_EraseRootFromParent_Done,
      // Label 666: @41978
      GIM_Try, /*On fail goto*//*Label 667*/ GIMT_Encode4(42037), // Rule ID 1840 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1840,
        GIR_EraseRootFromParent_Done,
      // Label 667: @42037
      GIM_Try, /*On fail goto*//*Label 668*/ GIMT_Encode4(42096), // Rule ID 1839 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1839,
        GIR_EraseRootFromParent_Done,
      // Label 668: @42096
      GIM_Try, /*On fail goto*//*Label 669*/ GIMT_Encode4(42155), // Rule ID 1747 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sub:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SSUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1747,
        GIR_EraseRootFromParent_Done,
      // Label 669: @42155
      GIM_Try, /*On fail goto*//*Label 670*/ GIMT_Encode4(42214), // Rule ID 1838 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1838,
        GIR_EraseRootFromParent_Done,
      // Label 670: @42214
      GIM_Try, /*On fail goto*//*Label 671*/ GIMT_Encode4(42273), // Rule ID 1837 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1837,
        GIR_EraseRootFromParent_Done,
      // Label 671: @42273
      GIM_Try, /*On fail goto*//*Label 672*/ GIMT_Encode4(42308), // Rule ID 960 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sub:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn)  =>  (NEGv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 960,
        GIR_EraseRootFromParent_Done,
      // Label 672: @42308
      GIM_Try, /*On fail goto*//*Label 673*/ GIMT_Encode4(42365), // Rule ID 1723 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SMLSLv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1723,
        GIR_EraseRootFromParent_Done,
      // Label 673: @42365
      GIM_Try, /*On fail goto*//*Label 674*/ GIMT_Encode4(42422), // Rule ID 1813 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UMLSLv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1813,
        GIR_EraseRootFromParent_Done,
      // Label 674: @42422
      GIM_Try, /*On fail goto*//*Label 675*/ GIMT_Encode4(42466), // Rule ID 1854 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1854,
        GIR_EraseRootFromParent_Done,
      // Label 675: @42466
      GIM_Try, /*On fail goto*//*Label 676*/ GIMT_Encode4(42510), // Rule ID 1753 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SSUBWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1753,
        GIR_EraseRootFromParent_Done,
      // Label 676: @42510
      GIM_Try, /*On fail goto*//*Label 677*/ GIMT_Encode4(42554), // Rule ID 1853 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1853,
        GIR_EraseRootFromParent_Done,
      // Label 677: @42554
      GIM_Try, /*On fail goto*//*Label 678*/ GIMT_Encode4(42577), // Rule ID 1467 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv2i64),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1467,
        GIR_Done,
      // Label 678: @42577
      GIM_Reject,
    // Label 644: @42578
    GIM_Reject,
    // Label 576: @42579
    GIM_Try, /*On fail goto*//*Label 679*/ GIMT_Encode4(44069),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 680*/ GIMT_Encode4(42726), // Rule ID 5430 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5430,
        GIR_EraseRootFromParent_Done,
      // Label 680: @42726
      GIM_Try, /*On fail goto*//*Label 681*/ GIMT_Encode4(42858), // Rule ID 5429 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5429,
        GIR_EraseRootFromParent_Done,
      // Label 681: @42858
      GIM_Try, /*On fail goto*//*Label 682*/ GIMT_Encode4(42990), // Rule ID 5445 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SSUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv8i8_v8i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5445,
        GIR_EraseRootFromParent_Done,
      // Label 682: @42990
      GIM_Try, /*On fail goto*//*Label 683*/ GIMT_Encode4(43122), // Rule ID 5428 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5428,
        GIR_EraseRootFromParent_Done,
      // Label 683: @43122
      GIM_Try, /*On fail goto*//*Label 684*/ GIMT_Encode4(43254), // Rule ID 5427 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5427,
        GIR_EraseRootFromParent_Done,
      // Label 684: @43254
      GIM_Try, /*On fail goto*//*Label 685*/ GIMT_Encode4(43413), // Rule ID 5400 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SMLSLv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i8_v8i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5400,
        GIR_EraseRootFromParent_Done,
      // Label 685: @43413
      GIM_Try, /*On fail goto*//*Label 686*/ GIMT_Encode4(43572), // Rule ID 5397 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UMLSLv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i8_v8i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5397,
        GIR_EraseRootFromParent_Done,
      // Label 686: @43572
      GIM_Try, /*On fail goto*//*Label 687*/ GIMT_Encode4(43718), // Rule ID 5440 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5440,
        GIR_EraseRootFromParent_Done,
      // Label 687: @43718
      GIM_Try, /*On fail goto*//*Label 688*/ GIMT_Encode4(43864), // Rule ID 5448 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SSUBWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv8i8_v8i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5448,
        GIR_EraseRootFromParent_Done,
      // Label 688: @43864
      GIM_Try, /*On fail goto*//*Label 689*/ GIMT_Encode4(44010), // Rule ID 5439 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5439,
        GIR_EraseRootFromParent_Done,
      // Label 689: @44010
      GIM_Try, /*On fail goto*//*Label 690*/ GIMT_Encode4(44045), // Rule ID 956 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sub:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn)  =>  (NEGv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 956,
        GIR_EraseRootFromParent_Done,
      // Label 690: @44045
      GIM_Try, /*On fail goto*//*Label 691*/ GIMT_Encode4(44068), // Rule ID 1463 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv4i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1463,
        GIR_Done,
      // Label 691: @44068
      GIM_Reject,
    // Label 679: @44069
    GIM_Reject,
    // Label 577: @44070
    GIM_Try, /*On fail goto*//*Label 692*/ GIMT_Encode4(46529),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 693*/ GIMT_Encode4(44199), // Rule ID 2034 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2034,
        GIR_EraseRootFromParent_Done,
      // Label 693: @44199
      GIM_Try, /*On fail goto*//*Label 694*/ GIMT_Encode4(44313), // Rule ID 13570 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (SMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13570,
        GIR_EraseRootFromParent_Done,
      // Label 694: @44313
      GIM_Try, /*On fail goto*//*Label 695*/ GIMT_Encode4(44427), // Rule ID 2086 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (UMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2086,
        GIR_EraseRootFromParent_Done,
      // Label 695: @44427
      GIM_Try, /*On fail goto*//*Label 696*/ GIMT_Encode4(44541), // Rule ID 13600 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (UMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13600,
        GIR_EraseRootFromParent_Done,
      // Label 696: @44541
      GIM_Try, /*On fail goto*//*Label 697*/ GIMT_Encode4(44606), // Rule ID 1836 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1836,
        GIR_EraseRootFromParent_Done,
      // Label 697: @44606
      GIM_Try, /*On fail goto*//*Label 698*/ GIMT_Encode4(44671), // Rule ID 1835 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1835,
        GIR_EraseRootFromParent_Done,
      // Label 698: @44671
      GIM_Try, /*On fail goto*//*Label 699*/ GIMT_Encode4(44736), // Rule ID 1746 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (sub:{ *:[v4i32] } (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SSUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1746,
        GIR_EraseRootFromParent_Done,
      // Label 699: @44736
      GIM_Try, /*On fail goto*//*Label 700*/ GIMT_Encode4(44801), // Rule ID 1834 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1834,
        GIR_EraseRootFromParent_Done,
      // Label 700: @44801
      GIM_Try, /*On fail goto*//*Label 701*/ GIMT_Encode4(44866), // Rule ID 1833 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1833,
        GIR_EraseRootFromParent_Done,
      // Label 701: @44866
      GIM_Try, /*On fail goto*//*Label 702*/ GIMT_Encode4(44977), // Rule ID 13568 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13568,
        GIR_EraseRootFromParent_Done,
      // Label 702: @44977
      GIM_Try, /*On fail goto*//*Label 703*/ GIMT_Encode4(45088), // Rule ID 2032 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2032,
        GIR_EraseRootFromParent_Done,
      // Label 703: @45088
      GIM_Try, /*On fail goto*//*Label 704*/ GIMT_Encode4(45199), // Rule ID 13598 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13598,
        GIR_EraseRootFromParent_Done,
      // Label 704: @45199
      GIM_Try, /*On fail goto*//*Label 705*/ GIMT_Encode4(45310), // Rule ID 2084 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2084,
        GIR_EraseRootFromParent_Done,
      // Label 705: @45310
      GIM_Try, /*On fail goto*//*Label 706*/ GIMT_Encode4(45373), // Rule ID 1722 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SMLSLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1722,
        GIR_EraseRootFromParent_Done,
      // Label 706: @45373
      GIM_Try, /*On fail goto*//*Label 707*/ GIMT_Encode4(45436), // Rule ID 1812 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UMLSLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1812,
        GIR_EraseRootFromParent_Done,
      // Label 707: @45436
      GIM_Try, /*On fail goto*//*Label 708*/ GIMT_Encode4(45524), // Rule ID 13569 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13569,
        GIR_EraseRootFromParent_Done,
      // Label 708: @45524
      GIM_Try, /*On fail goto*//*Label 709*/ GIMT_Encode4(45612), // Rule ID 2033 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2033,
        GIR_EraseRootFromParent_Done,
      // Label 709: @45612
      GIM_Try, /*On fail goto*//*Label 710*/ GIMT_Encode4(45700), // Rule ID 13599 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13599,
        GIR_EraseRootFromParent_Done,
      // Label 710: @45700
      GIM_Try, /*On fail goto*//*Label 711*/ GIMT_Encode4(45788), // Rule ID 2085 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2085,
        GIR_EraseRootFromParent_Done,
      // Label 711: @45788
      GIM_Try, /*On fail goto*//*Label 712*/ GIMT_Encode4(45835), // Rule ID 1852 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1852,
        GIR_EraseRootFromParent_Done,
      // Label 712: @45835
      GIM_Try, /*On fail goto*//*Label 713*/ GIMT_Encode4(45882), // Rule ID 1752 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SSUBWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1752,
        GIR_EraseRootFromParent_Done,
      // Label 713: @45882
      GIM_Try, /*On fail goto*//*Label 714*/ GIMT_Encode4(45929), // Rule ID 1851 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1851,
        GIR_EraseRootFromParent_Done,
      // Label 714: @45929
      GIM_Try, /*On fail goto*//*Label 715*/ GIMT_Encode4(45988), // Rule ID 1832 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1832,
        GIR_EraseRootFromParent_Done,
      // Label 715: @45988
      GIM_Try, /*On fail goto*//*Label 716*/ GIMT_Encode4(46047), // Rule ID 1831 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1831,
        GIR_EraseRootFromParent_Done,
      // Label 716: @46047
      GIM_Try, /*On fail goto*//*Label 717*/ GIMT_Encode4(46106), // Rule ID 1745 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sub:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SSUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1745,
        GIR_EraseRootFromParent_Done,
      // Label 717: @46106
      GIM_Try, /*On fail goto*//*Label 718*/ GIMT_Encode4(46165), // Rule ID 1830 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1830,
        GIR_EraseRootFromParent_Done,
      // Label 718: @46165
      GIM_Try, /*On fail goto*//*Label 719*/ GIMT_Encode4(46224), // Rule ID 1829 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1829,
        GIR_EraseRootFromParent_Done,
      // Label 719: @46224
      GIM_Try, /*On fail goto*//*Label 720*/ GIMT_Encode4(46259), // Rule ID 959 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sub:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn)  =>  (NEGv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 959,
        GIR_EraseRootFromParent_Done,
      // Label 720: @46259
      GIM_Try, /*On fail goto*//*Label 721*/ GIMT_Encode4(46316), // Rule ID 1721 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SMLSLv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1721,
        GIR_EraseRootFromParent_Done,
      // Label 721: @46316
      GIM_Try, /*On fail goto*//*Label 722*/ GIMT_Encode4(46373), // Rule ID 1811 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UMLSLv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1811,
        GIR_EraseRootFromParent_Done,
      // Label 722: @46373
      GIM_Try, /*On fail goto*//*Label 723*/ GIMT_Encode4(46417), // Rule ID 1850 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1850,
        GIR_EraseRootFromParent_Done,
      // Label 723: @46417
      GIM_Try, /*On fail goto*//*Label 724*/ GIMT_Encode4(46461), // Rule ID 1751 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SSUBWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1751,
        GIR_EraseRootFromParent_Done,
      // Label 724: @46461
      GIM_Try, /*On fail goto*//*Label 725*/ GIMT_Encode4(46505), // Rule ID 1849 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1849,
        GIR_EraseRootFromParent_Done,
      // Label 725: @46505
      GIM_Try, /*On fail goto*//*Label 726*/ GIMT_Encode4(46528), // Rule ID 1466 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv4i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1466,
        GIR_Done,
      // Label 726: @46528
      GIM_Reject,
    // Label 692: @46529
    GIM_Reject,
    // Label 578: @46530
    GIM_Try, /*On fail goto*//*Label 727*/ GIMT_Encode4(46604),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 728*/ GIMT_Encode4(46580), // Rule ID 954 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sub:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn)  =>  (NEGv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 954,
        GIR_EraseRootFromParent_Done,
      // Label 728: @46580
      GIM_Try, /*On fail goto*//*Label 729*/ GIMT_Encode4(46603), // Rule ID 1461 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (sub:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv8i8),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1461,
        GIR_Done,
      // Label 729: @46603
      GIM_Reject,
    // Label 727: @46604
    GIM_Reject,
    // Label 579: @46605
    GIM_Try, /*On fail goto*//*Label 730*/ GIMT_Encode4(47812),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 731*/ GIMT_Encode4(46685), // Rule ID 1828 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1828,
        GIR_EraseRootFromParent_Done,
      // Label 731: @46685
      GIM_Try, /*On fail goto*//*Label 732*/ GIMT_Encode4(46750), // Rule ID 1827 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1827,
        GIR_EraseRootFromParent_Done,
      // Label 732: @46750
      GIM_Try, /*On fail goto*//*Label 733*/ GIMT_Encode4(46815), // Rule ID 1744 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (sub:{ *:[v8i16] } (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SSUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1744,
        GIR_EraseRootFromParent_Done,
      // Label 733: @46815
      GIM_Try, /*On fail goto*//*Label 734*/ GIMT_Encode4(46880), // Rule ID 1826 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1826,
        GIR_EraseRootFromParent_Done,
      // Label 734: @46880
      GIM_Try, /*On fail goto*//*Label 735*/ GIMT_Encode4(46945), // Rule ID 1825 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1825,
        GIR_EraseRootFromParent_Done,
      // Label 735: @46945
      GIM_Try, /*On fail goto*//*Label 736*/ GIMT_Encode4(47008), // Rule ID 1720 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SMLSLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1720,
        GIR_EraseRootFromParent_Done,
      // Label 736: @47008
      GIM_Try, /*On fail goto*//*Label 737*/ GIMT_Encode4(47071), // Rule ID 1810 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UMLSLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1810,
        GIR_EraseRootFromParent_Done,
      // Label 737: @47071
      GIM_Try, /*On fail goto*//*Label 738*/ GIMT_Encode4(47118), // Rule ID 1848 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1848,
        GIR_EraseRootFromParent_Done,
      // Label 738: @47118
      GIM_Try, /*On fail goto*//*Label 739*/ GIMT_Encode4(47165), // Rule ID 1750 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SSUBWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1750,
        GIR_EraseRootFromParent_Done,
      // Label 739: @47165
      GIM_Try, /*On fail goto*//*Label 740*/ GIMT_Encode4(47212), // Rule ID 1847 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1847,
        GIR_EraseRootFromParent_Done,
      // Label 740: @47212
      GIM_Try, /*On fail goto*//*Label 741*/ GIMT_Encode4(47271), // Rule ID 1824 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1824,
        GIR_EraseRootFromParent_Done,
      // Label 741: @47271
      GIM_Try, /*On fail goto*//*Label 742*/ GIMT_Encode4(47330), // Rule ID 1823 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1823,
        GIR_EraseRootFromParent_Done,
      // Label 742: @47330
      GIM_Try, /*On fail goto*//*Label 743*/ GIMT_Encode4(47389), // Rule ID 1743 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sub:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SSUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv8i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1743,
        GIR_EraseRootFromParent_Done,
      // Label 743: @47389
      GIM_Try, /*On fail goto*//*Label 744*/ GIMT_Encode4(47448), // Rule ID 1822 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1822,
        GIR_EraseRootFromParent_Done,
      // Label 744: @47448
      GIM_Try, /*On fail goto*//*Label 745*/ GIMT_Encode4(47507), // Rule ID 1821 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1821,
        GIR_EraseRootFromParent_Done,
      // Label 745: @47507
      GIM_Try, /*On fail goto*//*Label 746*/ GIMT_Encode4(47542), // Rule ID 957 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sub:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn)  =>  (NEGv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 957,
        GIR_EraseRootFromParent_Done,
      // Label 746: @47542
      GIM_Try, /*On fail goto*//*Label 747*/ GIMT_Encode4(47599), // Rule ID 1719 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SMLSLv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1719,
        GIR_EraseRootFromParent_Done,
      // Label 747: @47599
      GIM_Try, /*On fail goto*//*Label 748*/ GIMT_Encode4(47656), // Rule ID 1809 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UMLSLv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1809,
        GIR_EraseRootFromParent_Done,
      // Label 748: @47656
      GIM_Try, /*On fail goto*//*Label 749*/ GIMT_Encode4(47700), // Rule ID 1846 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1846,
        GIR_EraseRootFromParent_Done,
      // Label 749: @47700
      GIM_Try, /*On fail goto*//*Label 750*/ GIMT_Encode4(47744), // Rule ID 1749 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SSUBWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv8i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1749,
        GIR_EraseRootFromParent_Done,
      // Label 750: @47744
      GIM_Try, /*On fail goto*//*Label 751*/ GIMT_Encode4(47788), // Rule ID 1845 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1845,
        GIR_EraseRootFromParent_Done,
      // Label 751: @47788
      GIM_Try, /*On fail goto*//*Label 752*/ GIMT_Encode4(47811), // Rule ID 1464 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv8i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1464,
        GIR_Done,
      // Label 752: @47811
      GIM_Reject,
    // Label 730: @47812
    GIM_Reject,
    // Label 580: @47813
    GIM_Try, /*On fail goto*//*Label 753*/ GIMT_Encode4(47887),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 754*/ GIMT_Encode4(47863), // Rule ID 955 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sub:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn)  =>  (NEGv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 955,
        GIR_EraseRootFromParent_Done,
      // Label 754: @47863
      GIM_Try, /*On fail goto*//*Label 755*/ GIMT_Encode4(47886), // Rule ID 1462 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (sub:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv16i8),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1462,
        GIR_Done,
      // Label 755: @47886
      GIM_Reject,
    // Label 753: @47887
    GIM_Reject,
    // Label 581: @47888
    GIM_Try, /*On fail goto*//*Label 756*/ GIMT_Encode4(47913), // Rule ID 7572 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (sub:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SUB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_D),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7572,
      GIR_Done,
    // Label 756: @47913
    GIM_Reject,
    // Label 582: @47914
    GIM_Try, /*On fail goto*//*Label 757*/ GIMT_Encode4(47939), // Rule ID 7571 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (sub:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SUB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_S),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7571,
      GIR_Done,
    // Label 757: @47939
    GIM_Reject,
    // Label 583: @47940
    GIM_Try, /*On fail goto*//*Label 758*/ GIMT_Encode4(47965), // Rule ID 7570 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (sub:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SUB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_H),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7570,
      GIR_Done,
    // Label 758: @47965
    GIM_Reject,
    // Label 584: @47966
    GIM_Try, /*On fail goto*//*Label 759*/ GIMT_Encode4(47991), // Rule ID 7569 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (sub:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SUB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_B),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7569,
      GIR_Done,
    // Label 759: @47991
    GIM_Reject,
    // Label 585: @47992
    GIM_Reject,
    // Label 2: @47993
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 768*/ GIMT_Encode4(49821),
    /*GILLT_s32*//*Label 760*/ GIMT_Encode4(48044),
    /*GILLT_s64*//*Label 761*/ GIMT_Encode4(48201), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 762*/ GIMT_Encode4(48745), GIMT_Encode4(0),
    /*GILLT_v4s16*//*Label 763*/ GIMT_Encode4(49083),
    /*GILLT_v4s32*//*Label 764*/ GIMT_Encode4(49421),
    /*GILLT_v8s8*//*Label 765*/ GIMT_Encode4(49587),
    /*GILLT_v8s16*//*Label 766*/ GIMT_Encode4(49621),
    /*GILLT_v16s8*//*Label 767*/ GIMT_Encode4(49787),
    // Label 760: @48044
    GIM_Try, /*On fail goto*//*Label 769*/ GIMT_Encode4(48200),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 770*/ GIMT_Encode4(48114), // Rule ID 3935 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (mul:{ *:[i32] } (sub:{ *:[i32] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rn), GPR32:{ *:[i32] }:$Rm)  =>  (MSUBWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBWrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3935,
        GIR_EraseRootFromParent_Done,
      // Label 770: @48114
      GIM_Try, /*On fail goto*//*Label 771*/ GIMT_Encode4(48169), // Rule ID 13853 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (mul:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, (sub:{ *:[i32] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rn))  =>  (MSUBWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBWrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/1, // Rm
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13853,
        GIR_EraseRootFromParent_Done,
      // Label 771: @48169
      GIM_Try, /*On fail goto*//*Label 772*/ GIMT_Encode4(48199), // Rule ID 3931 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (mul:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (MADDWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MADDWrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3931,
        GIR_EraseRootFromParent_Done,
      // Label 772: @48199
      GIM_Reject,
    // Label 769: @48200
    GIM_Reject,
    // Label 761: @48201
    GIM_Try, /*On fail goto*//*Label 773*/ GIMT_Encode4(48744),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 774*/ GIMT_Encode4(48271), // Rule ID 3936 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (mul:{ *:[i64] } (sub:{ *:[i64] } 0:{ *:[i64] }, GPR64:{ *:[i64] }:$Rn), GPR64:{ *:[i64] }:$Rm)  =>  (MSUBXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBXrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3936,
        GIR_EraseRootFromParent_Done,
      // Label 774: @48271
      GIM_Try, /*On fail goto*//*Label 775*/ GIMT_Encode4(48326), // Rule ID 13854 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, (sub:{ *:[i64] } 0:{ *:[i64] }, GPR64:{ *:[i64] }:$Rn))  =>  (MSUBXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBXrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/1, // Rm
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13854,
        GIR_EraseRootFromParent_Done,
      // Label 775: @48326
      GIM_Try, /*On fail goto*//*Label 776*/ GIMT_Encode4(48439), // Rule ID 3947 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C)  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3947,
        GIR_EraseRootFromParent_Done,
      // Label 776: @48439
      GIM_Try, /*On fail goto*//*Label 777*/ GIMT_Encode4(48514), // Rule ID 3945 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C)  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3945,
        GIR_EraseRootFromParent_Done,
      // Label 777: @48514
      GIM_Try, /*On fail goto*//*Label 778*/ GIMT_Encode4(48589), // Rule ID 3946 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C)  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3946,
        GIR_EraseRootFromParent_Done,
      // Label 778: @48589
      GIM_Try, /*On fail goto*//*Label 779*/ GIMT_Encode4(48651), // Rule ID 3939 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3939,
        GIR_EraseRootFromParent_Done,
      // Label 779: @48651
      GIM_Try, /*On fail goto*//*Label 780*/ GIMT_Encode4(48713), // Rule ID 3942 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3942,
        GIR_EraseRootFromParent_Done,
      // Label 780: @48713
      GIM_Try, /*On fail goto*//*Label 781*/ GIMT_Encode4(48743), // Rule ID 3932 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (MADDXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MADDXrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3932,
        GIR_EraseRootFromParent_Done,
      // Label 781: @48743
      GIM_Reject,
    // Label 773: @48744
    GIM_Reject,
    // Label 762: @48745
    GIM_Try, /*On fail goto*//*Label 782*/ GIMT_Encode4(49082),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 783*/ GIMT_Encode4(48846), // Rule ID 13547 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (mul:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13547,
        GIR_EraseRootFromParent_Done,
      // Label 783: @48846
      GIM_Try, /*On fail goto*//*Label 784*/ GIMT_Encode4(48932), // Rule ID 2023 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (mul:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2023,
        GIR_EraseRootFromParent_Done,
      // Label 784: @48932
      GIM_Try, /*On fail goto*//*Label 785*/ GIMT_Encode4(48995), // Rule ID 13548 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (mul:{ *:[v2i32] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn)  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13548,
        GIR_EraseRootFromParent_Done,
      // Label 785: @48995
      GIM_Try, /*On fail goto*//*Label 786*/ GIMT_Encode4(49058), // Rule ID 2024 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (mul:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2024,
        GIR_EraseRootFromParent_Done,
      // Label 786: @49058
      GIM_Try, /*On fail goto*//*Label 787*/ GIMT_Encode4(49081), // Rule ID 1341 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (mul:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (MULv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1341,
        GIR_Done,
      // Label 787: @49081
      GIM_Reject,
    // Label 782: @49082
    GIM_Reject,
    // Label 763: @49083
    GIM_Try, /*On fail goto*//*Label 788*/ GIMT_Encode4(49420),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 789*/ GIMT_Encode4(49184), // Rule ID 13544 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (mul:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13544,
        GIR_EraseRootFromParent_Done,
      // Label 789: @49184
      GIM_Try, /*On fail goto*//*Label 790*/ GIMT_Encode4(49270), // Rule ID 2020 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (mul:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2020,
        GIR_EraseRootFromParent_Done,
      // Label 790: @49270
      GIM_Try, /*On fail goto*//*Label 791*/ GIMT_Encode4(49333), // Rule ID 13545 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (mul:{ *:[v4i16] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn)  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13545,
        GIR_EraseRootFromParent_Done,
      // Label 791: @49333
      GIM_Try, /*On fail goto*//*Label 792*/ GIMT_Encode4(49396), // Rule ID 2021 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (mul:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2021,
        GIR_EraseRootFromParent_Done,
      // Label 792: @49396
      GIM_Try, /*On fail goto*//*Label 793*/ GIMT_Encode4(49419), // Rule ID 1339 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (mul:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (MULv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1339,
        GIR_Done,
      // Label 793: @49419
      GIM_Reject,
    // Label 788: @49420
    GIM_Reject,
    // Label 764: @49421
    GIM_Try, /*On fail goto*//*Label 794*/ GIMT_Encode4(49586),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 795*/ GIMT_Encode4(49499), // Rule ID 13549 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (mul:{ *:[v4i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4i32] }:$Rn)  =>  (MULv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13549,
        GIR_EraseRootFromParent_Done,
      // Label 795: @49499
      GIM_Try, /*On fail goto*//*Label 796*/ GIMT_Encode4(49562), // Rule ID 2025 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (mul:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (MULv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2025,
        GIR_EraseRootFromParent_Done,
      // Label 796: @49562
      GIM_Try, /*On fail goto*//*Label 797*/ GIMT_Encode4(49585), // Rule ID 1342 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (mul:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (MULv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv4i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1342,
        GIR_Done,
      // Label 797: @49585
      GIM_Reject,
    // Label 794: @49586
    GIM_Reject,
    // Label 765: @49587
    GIM_Try, /*On fail goto*//*Label 798*/ GIMT_Encode4(49620), // Rule ID 1337 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (mul:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (MULv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1337,
      GIR_Done,
    // Label 798: @49620
    GIM_Reject,
    // Label 766: @49621
    GIM_Try, /*On fail goto*//*Label 799*/ GIMT_Encode4(49786),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 800*/ GIMT_Encode4(49699), // Rule ID 13546 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (mul:{ *:[v8i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8i16] }:$Rn)  =>  (MULv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13546,
        GIR_EraseRootFromParent_Done,
      // Label 800: @49699
      GIM_Try, /*On fail goto*//*Label 801*/ GIMT_Encode4(49762), // Rule ID 2022 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (mul:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (MULv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2022,
        GIR_EraseRootFromParent_Done,
      // Label 801: @49762
      GIM_Try, /*On fail goto*//*Label 802*/ GIMT_Encode4(49785), // Rule ID 1340 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (mul:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (MULv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv8i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1340,
        GIR_Done,
      // Label 802: @49785
      GIM_Reject,
    // Label 799: @49786
    GIM_Reject,
    // Label 767: @49787
    GIM_Try, /*On fail goto*//*Label 803*/ GIMT_Encode4(49820), // Rule ID 1338 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (mul:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (MULv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1338,
      GIR_Done,
    // Label 803: @49820
    GIM_Reject,
    // Label 768: @49821
    GIM_Reject,
    // Label 3: @49822
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 806*/ GIMT_Encode4(49903),
    /*GILLT_s32*//*Label 804*/ GIMT_Encode4(49841),
    /*GILLT_s64*//*Label 805*/ GIMT_Encode4(49872),
    // Label 804: @49841
    GIM_Try, /*On fail goto*//*Label 807*/ GIMT_Encode4(49871), // Rule ID 129 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // (sdiv:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDIVWr),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 129,
      GIR_Done,
    // Label 807: @49871
    GIM_Reject,
    // Label 805: @49872
    GIM_Try, /*On fail goto*//*Label 808*/ GIMT_Encode4(49902), // Rule ID 130 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (sdiv:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDIVXr),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 130,
      GIR_Done,
    // Label 808: @49902
    GIM_Reject,
    // Label 806: @49903
    GIM_Reject,
    // Label 4: @49904
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 811*/ GIMT_Encode4(49985),
    /*GILLT_s32*//*Label 809*/ GIMT_Encode4(49923),
    /*GILLT_s64*//*Label 810*/ GIMT_Encode4(49954),
    // Label 809: @49923
    GIM_Try, /*On fail goto*//*Label 812*/ GIMT_Encode4(49953), // Rule ID 127 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // (udiv:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDIVWr),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 127,
      GIR_Done,
    // Label 812: @49953
    GIM_Reject,
    // Label 810: @49954
    GIM_Try, /*On fail goto*//*Label 813*/ GIMT_Encode4(49984), // Rule ID 128 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (udiv:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDIVXr),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 128,
      GIR_Done,
    // Label 813: @49984
    GIM_Reject,
    // Label 811: @49985
    GIM_Reject,
    // Label 5: @49986
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 832*/ GIMT_Encode4(57731),
    /*GILLT_s32*//*Label 814*/ GIMT_Encode4(50085),
    /*GILLT_s64*//*Label 815*/ GIMT_Encode4(50583), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 816*/ GIMT_Encode4(52018),
    /*GILLT_v2s64*//*Label 817*/ GIMT_Encode4(52178),
    /*GILLT_v4s16*//*Label 818*/ GIMT_Encode4(52338),
    /*GILLT_v4s32*//*Label 819*/ GIMT_Encode4(52498),
    /*GILLT_v8s8*//*Label 820*/ GIMT_Encode4(52658),
    /*GILLT_v8s16*//*Label 821*/ GIMT_Encode4(52818),
    /*GILLT_v16s8*//*Label 822*/ GIMT_Encode4(52978),
    /*GILLT_nxv1s1*//*Label 823*/ GIMT_Encode4(53138),
    /*GILLT_nxv2s1*//*Label 824*/ GIMT_Encode4(53679), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s64*//*Label 825*/ GIMT_Encode4(54220),
    /*GILLT_nxv4s1*//*Label 826*/ GIMT_Encode4(54692), GIMT_Encode4(0),
    /*GILLT_nxv4s32*//*Label 827*/ GIMT_Encode4(55233),
    /*GILLT_nxv8s1*//*Label 828*/ GIMT_Encode4(55705),
    /*GILLT_nxv8s16*//*Label 829*/ GIMT_Encode4(56246),
    /*GILLT_nxv16s1*//*Label 830*/ GIMT_Encode4(56718),
    /*GILLT_nxv16s8*//*Label 831*/ GIMT_Encode4(57259),
    // Label 814: @50085
    GIM_Try, /*On fail goto*//*Label 833*/ GIMT_Encode4(50582),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 834*/ GIMT_Encode4(50151), // Rule ID 13306 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
        // (and:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (BICWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13306,
        GIR_EraseRootFromParent_Done,
      // Label 834: @50151
      GIM_Try, /*On fail goto*//*Label 835*/ GIMT_Encode4(50206), // Rule ID 174 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
        // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }))  =>  (BICWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 174,
        GIR_EraseRootFromParent_Done,
      // Label 835: @50206
      GIM_Try, /*On fail goto*//*Label 836*/ GIMT_Encode4(50275), // Rule ID 5710 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), 255:{ *:[i32] })  =>  (UMOVvi8:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5710,
        GIR_EraseRootFromParent_Done,
      // Label 836: @50275
      GIM_Try, /*On fail goto*//*Label 837*/ GIMT_Encode4(50344), // Rule ID 5711 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 65535:{ *:[i32] })  =>  (UMOVvi16:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5711,
        GIR_EraseRootFromParent_Done,
      // Label 837: @50344
      GIM_Try, /*On fail goto*//*Label 838*/ GIMT_Encode4(50397), // Rule ID 13304 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (and:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (BICWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13304,
        GIR_EraseRootFromParent_Done,
      // Label 838: @50397
      GIM_Try, /*On fail goto*//*Label 839*/ GIMT_Encode4(50450), // Rule ID 172 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (BICWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 172,
        GIR_EraseRootFromParent_Done,
      // Label 839: @50450
      GIM_Try, /*On fail goto*//*Label 840*/ GIMT_Encode4(50491), // Rule ID 154 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm32),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_logical_imm32>><<X:logical_imm32_XFORM>>:$imm)  =>  (ANDWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (logical_imm32_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDWri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 154,
        GIR_EraseRootFromParent_Done,
      // Label 840: @50491
      GIM_Try, /*On fail goto*//*Label 841*/ GIMT_Encode4(50524), // Rule ID 13302 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
        // (and:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (ANDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDWrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13302,
        GIR_EraseRootFromParent_Done,
      // Label 841: @50524
      GIM_Try, /*On fail goto*//*Label 842*/ GIMT_Encode4(50557), // Rule ID 170 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
        // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (ANDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDWrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 170,
        GIR_EraseRootFromParent_Done,
      // Label 842: @50557
      GIM_Try, /*On fail goto*//*Label 843*/ GIMT_Encode4(50581), // Rule ID 168 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (ANDWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDWrr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 168,
        GIR_Done,
      // Label 843: @50581
      GIM_Reject,
    // Label 833: @50582
    GIM_Reject,
    // Label 815: @50583
    GIM_Try, /*On fail goto*//*Label 844*/ GIMT_Encode4(52017),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 845*/ GIMT_Encode4(50649), // Rule ID 13307 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
        // (and:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (BICXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13307,
        GIR_EraseRootFromParent_Done,
      // Label 845: @50649
      GIM_Try, /*On fail goto*//*Label 846*/ GIMT_Encode4(50704), // Rule ID 175 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
        // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }))  =>  (BICXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 175,
        GIR_EraseRootFromParent_Done,
      // Label 846: @50704
      GIM_Try, /*On fail goto*//*Label 847*/ GIMT_Encode4(50817), // Rule ID 5712 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (and:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)), 255:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (UMOVvi8:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), sub_32:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // idx
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        // GIR_Coverage, 5712,
        GIR_EraseRootFromParent_Done,
      // Label 847: @50817
      GIM_Try, /*On fail goto*//*Label 848*/ GIMT_Encode4(50930), // Rule ID 5713 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (and:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), 65535:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (UMOVvi16:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), sub_32:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // idx
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        // GIR_Coverage, 5713,
        GIR_EraseRootFromParent_Done,
      // Label 848: @50930
      GIM_Try, /*On fail goto*//*Label 849*/ GIMT_Encode4(51029), // Rule ID 7291 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
        // MIs[1] addr
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_1),
        GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 558:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_1>>, 255:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRB),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        // GIR_Coverage, 7291,
        GIR_EraseRootFromParent_Done,
      // Label 849: @51029
      GIM_Try, /*On fail goto*//*Label 850*/ GIMT_Encode4(51128), // Rule ID 7292 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
        // MIs[1] addr
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_2),
        GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 558:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_2>>, 65535:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRH),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        // GIR_Coverage, 7292,
        GIR_EraseRootFromParent_Done,
      // Label 850: @51128
      GIM_Try, /*On fail goto*//*Label 851*/ GIMT_Encode4(51227), // Rule ID 7293 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
        // MIs[1] addr
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_4),
        GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 558:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_4>>, 4294967295:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        // GIR_Coverage, 7293,
        GIR_EraseRootFromParent_Done,
      // Label 851: @51227
      GIM_Try, /*On fail goto*//*Label 852*/ GIMT_Encode4(51326), // Rule ID 7298 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
        // MIs[1] addr
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_1),
        GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 555:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_1>>, 255:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRB),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        // GIR_Coverage, 7298,
        GIR_EraseRootFromParent_Done,
      // Label 852: @51326
      GIM_Try, /*On fail goto*//*Label 853*/ GIMT_Encode4(51425), // Rule ID 7299 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
        // MIs[1] addr
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_2),
        GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 555:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_2>>, 65535:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRH),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        // GIR_Coverage, 7299,
        GIR_EraseRootFromParent_Done,
      // Label 853: @51425
      GIM_Try, /*On fail goto*//*Label 854*/ GIMT_Encode4(51524), // Rule ID 7300 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
        // MIs[1] addr
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_4),
        GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 555:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_4>>, 4294967295:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        // GIR_Coverage, 7300,
        GIR_EraseRootFromParent_Done,
      // Label 854: @51524
      GIM_Try, /*On fail goto*//*Label 855*/ GIMT_Encode4(51577), // Rule ID 13305 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (and:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (BICXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13305,
        GIR_EraseRootFromParent_Done,
      // Label 855: @51577
      GIM_Try, /*On fail goto*//*Label 856*/ GIMT_Encode4(51630), // Rule ID 173 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }))  =>  (BICXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 173,
        GIR_EraseRootFromParent_Done,
      // Label 856: @51630
      GIM_Try, /*On fail goto*//*Label 857*/ GIMT_Encode4(51730), // Rule ID 3984 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
        // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 4294967295:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (ORRWrr:{ *:[i32] } WZR:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORRWrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        // GIR_Coverage, 3984,
        GIR_EraseRootFromParent_Done,
      // Label 857: @51730
      GIM_Try, /*On fail goto*//*Label 858*/ GIMT_Encode4(51771), // Rule ID 155 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm64),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_logical_imm64>><<X:logical_imm64_XFORM>>:$imm)  =>  (ANDXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (logical_imm64_XFORM:{ *:[i64] } (imm:{ *:[i64] }):$imm))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDXri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 155,
        GIR_EraseRootFromParent_Done,
      // Label 858: @51771
      GIM_Try, /*On fail goto*//*Label 859*/ GIMT_Encode4(51804), // Rule ID 13303 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
        // (and:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (ANDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDXrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13303,
        GIR_EraseRootFromParent_Done,
      // Label 859: @51804
      GIM_Try, /*On fail goto*//*Label 860*/ GIMT_Encode4(51837), // Rule ID 171 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
        // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (ANDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDXrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 171,
        GIR_EraseRootFromParent_Done,
      // Label 860: @51837
      GIM_Try, /*On fail goto*//*Label 861*/ GIMT_Encode4(51901), // Rule ID 13958 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$LHS)  =>  (BICv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13958,
        GIR_EraseRootFromParent_Done,
      // Label 861: @51901
      GIM_Try, /*On fail goto*//*Label 862*/ GIMT_Encode4(51965), // Rule ID 5080 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }))  =>  (BICv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5080,
        GIR_EraseRootFromParent_Done,
      // Label 862: @51965
      GIM_Try, /*On fail goto*//*Label 863*/ GIMT_Encode4(51989), // Rule ID 169 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ANDXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDXrr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 169,
        GIR_Done,
      // Label 863: @51989
      GIM_Try, /*On fail goto*//*Label 864*/ GIMT_Encode4(52016), // Rule ID 2453 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)  =>  (ANDv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2453,
        GIR_Done,
      // Label 864: @52016
      GIM_Reject,
    // Label 844: @52017
    GIM_Reject,
    // Label 816: @52018
    GIM_Try, /*On fail goto*//*Label 865*/ GIMT_Encode4(52177),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 866*/ GIMT_Encode4(52093), // Rule ID 13957 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$LHS)  =>  (BICv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13957,
        GIR_EraseRootFromParent_Done,
      // Label 866: @52093
      GIM_Try, /*On fail goto*//*Label 867*/ GIMT_Encode4(52153), // Rule ID 5079 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }))  =>  (BICv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5079,
        GIR_EraseRootFromParent_Done,
      // Label 867: @52153
      GIM_Try, /*On fail goto*//*Label 868*/ GIMT_Encode4(52176), // Rule ID 2452 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (ANDv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2452,
        GIR_Done,
      // Label 868: @52176
      GIM_Reject,
    // Label 865: @52177
    GIM_Reject,
    // Label 817: @52178
    GIM_Try, /*On fail goto*//*Label 869*/ GIMT_Encode4(52337),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 870*/ GIMT_Encode4(52253), // Rule ID 13961 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$LHS)  =>  (BICv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13961,
        GIR_EraseRootFromParent_Done,
      // Label 870: @52253
      GIM_Try, /*On fail goto*//*Label 871*/ GIMT_Encode4(52313), // Rule ID 5083 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }))  =>  (BICv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5083,
        GIR_EraseRootFromParent_Done,
      // Label 871: @52313
      GIM_Try, /*On fail goto*//*Label 872*/ GIMT_Encode4(52336), // Rule ID 2456 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (ANDv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2456,
        GIR_Done,
      // Label 872: @52336
      GIM_Reject,
    // Label 869: @52337
    GIM_Reject,
    // Label 818: @52338
    GIM_Try, /*On fail goto*//*Label 873*/ GIMT_Encode4(52497),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 874*/ GIMT_Encode4(52413), // Rule ID 13956 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$LHS)  =>  (BICv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13956,
        GIR_EraseRootFromParent_Done,
      // Label 874: @52413
      GIM_Try, /*On fail goto*//*Label 875*/ GIMT_Encode4(52473), // Rule ID 5078 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }))  =>  (BICv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5078,
        GIR_EraseRootFromParent_Done,
      // Label 875: @52473
      GIM_Try, /*On fail goto*//*Label 876*/ GIMT_Encode4(52496), // Rule ID 2451 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (ANDv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2451,
        GIR_Done,
      // Label 876: @52496
      GIM_Reject,
    // Label 873: @52497
    GIM_Reject,
    // Label 819: @52498
    GIM_Try, /*On fail goto*//*Label 877*/ GIMT_Encode4(52657),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 878*/ GIMT_Encode4(52573), // Rule ID 13960 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$LHS)  =>  (BICv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13960,
        GIR_EraseRootFromParent_Done,
      // Label 878: @52573
      GIM_Try, /*On fail goto*//*Label 879*/ GIMT_Encode4(52633), // Rule ID 5082 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }))  =>  (BICv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5082,
        GIR_EraseRootFromParent_Done,
      // Label 879: @52633
      GIM_Try, /*On fail goto*//*Label 880*/ GIMT_Encode4(52656), // Rule ID 2455 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (ANDv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2455,
        GIR_Done,
      // Label 880: @52656
      GIM_Reject,
    // Label 877: @52657
    GIM_Reject,
    // Label 820: @52658
    GIM_Try, /*On fail goto*//*Label 881*/ GIMT_Encode4(52817),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 882*/ GIMT_Encode4(52733), // Rule ID 13442 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rn)  =>  (BICv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13442,
        GIR_EraseRootFromParent_Done,
      // Label 882: @52733
      GIM_Try, /*On fail goto*//*Label 883*/ GIMT_Encode4(52793), // Rule ID 1586 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }))  =>  (BICv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1586,
        GIR_EraseRootFromParent_Done,
      // Label 883: @52793
      GIM_Try, /*On fail goto*//*Label 884*/ GIMT_Encode4(52816), // Rule ID 1584 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ANDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1584,
        GIR_Done,
      // Label 884: @52816
      GIM_Reject,
    // Label 881: @52817
    GIM_Reject,
    // Label 821: @52818
    GIM_Try, /*On fail goto*//*Label 885*/ GIMT_Encode4(52977),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 886*/ GIMT_Encode4(52893), // Rule ID 13959 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$LHS)  =>  (BICv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13959,
        GIR_EraseRootFromParent_Done,
      // Label 886: @52893
      GIM_Try, /*On fail goto*//*Label 887*/ GIMT_Encode4(52953), // Rule ID 5081 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }))  =>  (BICv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5081,
        GIR_EraseRootFromParent_Done,
      // Label 887: @52953
      GIM_Try, /*On fail goto*//*Label 888*/ GIMT_Encode4(52976), // Rule ID 2454 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (ANDv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2454,
        GIR_Done,
      // Label 888: @52976
      GIM_Reject,
    // Label 885: @52977
    GIM_Reject,
    // Label 822: @52978
    GIM_Try, /*On fail goto*//*Label 889*/ GIMT_Encode4(53137),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 890*/ GIMT_Encode4(53053), // Rule ID 13443 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rn)  =>  (BICv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13443,
        GIR_EraseRootFromParent_Done,
      // Label 890: @53053
      GIM_Try, /*On fail goto*//*Label 891*/ GIMT_Encode4(53113), // Rule ID 1587 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }))  =>  (BICv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1587,
        GIR_EraseRootFromParent_Done,
      // Label 891: @53113
      GIM_Try, /*On fail goto*//*Label 892*/ GIMT_Encode4(53136), // Rule ID 1585 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ANDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1585,
        GIR_Done,
      // Label 892: @53136
      GIM_Reject,
    // Label 889: @53137
    GIM_Reject,
    // Label 823: @53138
    GIM_Try, /*On fail goto*//*Label 893*/ GIMT_Encode4(53678),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
      GIM_Try, /*On fail goto*//*Label 894*/ GIMT_Encode4(53210), // Rule ID 15159 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] }), nxv1i1:{ *:[nxv1i1] }:$Op2), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15159,
        GIR_EraseRootFromParent_Done,
      // Label 894: @53210
      GIM_Try, /*On fail goto*//*Label 895*/ GIMT_Encode4(53267), // Rule ID 15162 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] }), nxv1i1:{ *:[nxv1i1] }:$Op2), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15162,
        GIR_EraseRootFromParent_Done,
      // Label 895: @53267
      GIM_Try, /*On fail goto*//*Label 896*/ GIMT_Encode4(53324), // Rule ID 15158 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] })), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15158,
        GIR_EraseRootFromParent_Done,
      // Label 896: @53324
      GIM_Try, /*On fail goto*//*Label 897*/ GIMT_Encode4(53381), // Rule ID 15161 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] })), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15161,
        GIR_EraseRootFromParent_Done,
      // Label 897: @53381
      GIM_Try, /*On fail goto*//*Label 898*/ GIMT_Encode4(53438), // Rule ID 15157 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] }), nxv1i1:{ *:[nxv1i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15157,
        GIR_EraseRootFromParent_Done,
      // Label 898: @53438
      GIM_Try, /*On fail goto*//*Label 899*/ GIMT_Encode4(53495), // Rule ID 15160 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] }), nxv1i1:{ *:[nxv1i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15160,
        GIR_EraseRootFromParent_Done,
      // Label 899: @53495
      GIM_Try, /*On fail goto*//*Label 900*/ GIMT_Encode4(53552), // Rule ID 8587 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8587,
        GIR_EraseRootFromParent_Done,
      // Label 900: @53552
      GIM_Try, /*On fail goto*//*Label 901*/ GIMT_Encode4(53609), // Rule ID 8588 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8588,
        GIR_EraseRootFromParent_Done,
      // Label 901: @53609
      GIM_Try, /*On fail goto*//*Label 902*/ GIMT_Encode4(53656), // Rule ID 10944 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (and:{ *:[nxv1i1] } PPR:{ *:[nxv1i1] }:$Ps1, PPR:{ *:[nxv1i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv1i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv1i1] }:$Ps1, PPR:{ *:[nxv1i1] }:$Ps2)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
        GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10944,
        GIR_EraseRootFromParent_Done,
      // Label 902: @53656
      GIM_Try, /*On fail goto*//*Label 903*/ GIMT_Encode4(53677), // Rule ID 2714 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_RootToRootCopy, /*OpIdx*/2, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2714,
        GIR_EraseRootFromParent_Done,
      // Label 903: @53677
      GIM_Reject,
    // Label 893: @53678
    GIM_Reject,
    // Label 824: @53679
    GIM_Try, /*On fail goto*//*Label 904*/ GIMT_Encode4(54219),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
      GIM_Try, /*On fail goto*//*Label 905*/ GIMT_Encode4(53751), // Rule ID 15150 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] }), nxv2i1:{ *:[nxv2i1] }:$Op2), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15150,
        GIR_EraseRootFromParent_Done,
      // Label 905: @53751
      GIM_Try, /*On fail goto*//*Label 906*/ GIMT_Encode4(53808), // Rule ID 15153 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] }), nxv2i1:{ *:[nxv2i1] }:$Op2), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15153,
        GIR_EraseRootFromParent_Done,
      // Label 906: @53808
      GIM_Try, /*On fail goto*//*Label 907*/ GIMT_Encode4(53865), // Rule ID 15149 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] })), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15149,
        GIR_EraseRootFromParent_Done,
      // Label 907: @53865
      GIM_Try, /*On fail goto*//*Label 908*/ GIMT_Encode4(53922), // Rule ID 15152 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] })), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15152,
        GIR_EraseRootFromParent_Done,
      // Label 908: @53922
      GIM_Try, /*On fail goto*//*Label 909*/ GIMT_Encode4(53979), // Rule ID 15148 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] }), nxv2i1:{ *:[nxv2i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15148,
        GIR_EraseRootFromParent_Done,
      // Label 909: @53979
      GIM_Try, /*On fail goto*//*Label 910*/ GIMT_Encode4(54036), // Rule ID 15151 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] }), nxv2i1:{ *:[nxv2i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15151,
        GIR_EraseRootFromParent_Done,
      // Label 910: @54036
      GIM_Try, /*On fail goto*//*Label 911*/ GIMT_Encode4(54093), // Rule ID 8583 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8583,
        GIR_EraseRootFromParent_Done,
      // Label 911: @54093
      GIM_Try, /*On fail goto*//*Label 912*/ GIMT_Encode4(54150), // Rule ID 8584 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8584,
        GIR_EraseRootFromParent_Done,
      // Label 912: @54150
      GIM_Try, /*On fail goto*//*Label 913*/ GIMT_Encode4(54197), // Rule ID 10943 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (and:{ *:[nxv2i1] } PPR:{ *:[nxv2i1] }:$Ps1, PPR:{ *:[nxv2i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv2i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv2i1] }:$Ps1, PPR:{ *:[nxv2i1] }:$Ps2)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
        GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10943,
        GIR_EraseRootFromParent_Done,
      // Label 913: @54197
      GIM_Try, /*On fail goto*//*Label 914*/ GIMT_Encode4(54218), // Rule ID 2713 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_RootToRootCopy, /*OpIdx*/2, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2713,
        GIR_EraseRootFromParent_Done,
      // Label 914: @54218
      GIM_Reject,
    // Label 904: @54219
    GIM_Reject,
    // Label 825: @54220
    GIM_Try, /*On fail goto*//*Label 915*/ GIMT_Encode4(54691),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 916*/ GIMT_Encode4(54290), // Rule ID 15090 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15090,
        GIR_EraseRootFromParent_Done,
      // Label 916: @54290
      GIM_Try, /*On fail goto*//*Label 917*/ GIMT_Encode4(54345), // Rule ID 15093 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15093,
        GIR_EraseRootFromParent_Done,
      // Label 917: @54345
      GIM_Try, /*On fail goto*//*Label 918*/ GIMT_Encode4(54400), // Rule ID 15089 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15089,
        GIR_EraseRootFromParent_Done,
      // Label 918: @54400
      GIM_Try, /*On fail goto*//*Label 919*/ GIMT_Encode4(54455), // Rule ID 15092 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15092,
        GIR_EraseRootFromParent_Done,
      // Label 919: @54455
      GIM_Try, /*On fail goto*//*Label 920*/ GIMT_Encode4(54510), // Rule ID 15088 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15088,
        GIR_EraseRootFromParent_Done,
      // Label 920: @54510
      GIM_Try, /*On fail goto*//*Label 921*/ GIMT_Encode4(54565), // Rule ID 15091 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15091,
        GIR_EraseRootFromParent_Done,
      // Label 921: @54565
      GIM_Try, /*On fail goto*//*Label 922*/ GIMT_Encode4(54620), // Rule ID 7609 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7609,
        GIR_EraseRootFromParent_Done,
      // Label 922: @54620
      GIM_Try, /*On fail goto*//*Label 923*/ GIMT_Encode4(54675), // Rule ID 7610 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7610,
        GIR_EraseRootFromParent_Done,
      // Label 923: @54675
      GIM_Try, /*On fail goto*//*Label 924*/ GIMT_Encode4(54690), // Rule ID 3124 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3124,
        GIR_Done,
      // Label 924: @54690
      GIM_Reject,
    // Label 915: @54691
    GIM_Reject,
    // Label 826: @54692
    GIM_Try, /*On fail goto*//*Label 925*/ GIMT_Encode4(55232),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
      GIM_Try, /*On fail goto*//*Label 926*/ GIMT_Encode4(54764), // Rule ID 15141 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] }), nxv4i1:{ *:[nxv4i1] }:$Op2), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15141,
        GIR_EraseRootFromParent_Done,
      // Label 926: @54764
      GIM_Try, /*On fail goto*//*Label 927*/ GIMT_Encode4(54821), // Rule ID 15144 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] }), nxv4i1:{ *:[nxv4i1] }:$Op2), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15144,
        GIR_EraseRootFromParent_Done,
      // Label 927: @54821
      GIM_Try, /*On fail goto*//*Label 928*/ GIMT_Encode4(54878), // Rule ID 15140 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] })), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15140,
        GIR_EraseRootFromParent_Done,
      // Label 928: @54878
      GIM_Try, /*On fail goto*//*Label 929*/ GIMT_Encode4(54935), // Rule ID 15143 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] })), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15143,
        GIR_EraseRootFromParent_Done,
      // Label 929: @54935
      GIM_Try, /*On fail goto*//*Label 930*/ GIMT_Encode4(54992), // Rule ID 15139 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] }), nxv4i1:{ *:[nxv4i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15139,
        GIR_EraseRootFromParent_Done,
      // Label 930: @54992
      GIM_Try, /*On fail goto*//*Label 931*/ GIMT_Encode4(55049), // Rule ID 15142 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] }), nxv4i1:{ *:[nxv4i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15142,
        GIR_EraseRootFromParent_Done,
      // Label 931: @55049
      GIM_Try, /*On fail goto*//*Label 932*/ GIMT_Encode4(55106), // Rule ID 8579 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8579,
        GIR_EraseRootFromParent_Done,
      // Label 932: @55106
      GIM_Try, /*On fail goto*//*Label 933*/ GIMT_Encode4(55163), // Rule ID 8580 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8580,
        GIR_EraseRootFromParent_Done,
      // Label 933: @55163
      GIM_Try, /*On fail goto*//*Label 934*/ GIMT_Encode4(55210), // Rule ID 10942 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (and:{ *:[nxv4i1] } PPR:{ *:[nxv4i1] }:$Ps1, PPR:{ *:[nxv4i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv4i1] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv4i1] }:$Ps1, PPR:{ *:[nxv4i1] }:$Ps2)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
        GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10942,
        GIR_EraseRootFromParent_Done,
      // Label 934: @55210
      GIM_Try, /*On fail goto*//*Label 935*/ GIMT_Encode4(55231), // Rule ID 2712 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_RootToRootCopy, /*OpIdx*/2, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2712,
        GIR_EraseRootFromParent_Done,
      // Label 935: @55231
      GIM_Reject,
    // Label 925: @55232
    GIM_Reject,
    // Label 827: @55233
    GIM_Try, /*On fail goto*//*Label 936*/ GIMT_Encode4(55704),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 937*/ GIMT_Encode4(55303), // Rule ID 15081 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15081,
        GIR_EraseRootFromParent_Done,
      // Label 937: @55303
      GIM_Try, /*On fail goto*//*Label 938*/ GIMT_Encode4(55358), // Rule ID 15084 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] }), nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15084,
        GIR_EraseRootFromParent_Done,
      // Label 938: @55358
      GIM_Try, /*On fail goto*//*Label 939*/ GIMT_Encode4(55413), // Rule ID 15080 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] })), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15080,
        GIR_EraseRootFromParent_Done,
      // Label 939: @55413
      GIM_Try, /*On fail goto*//*Label 940*/ GIMT_Encode4(55468), // Rule ID 15083 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] })), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15083,
        GIR_EraseRootFromParent_Done,
      // Label 940: @55468
      GIM_Try, /*On fail goto*//*Label 941*/ GIMT_Encode4(55523), // Rule ID 15079 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15079,
        GIR_EraseRootFromParent_Done,
      // Label 941: @55523
      GIM_Try, /*On fail goto*//*Label 942*/ GIMT_Encode4(55578), // Rule ID 15082 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15082,
        GIR_EraseRootFromParent_Done,
      // Label 942: @55578
      GIM_Try, /*On fail goto*//*Label 943*/ GIMT_Encode4(55633), // Rule ID 7605 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7605,
        GIR_EraseRootFromParent_Done,
      // Label 943: @55633
      GIM_Try, /*On fail goto*//*Label 944*/ GIMT_Encode4(55688), // Rule ID 7606 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7606,
        GIR_EraseRootFromParent_Done,
      // Label 944: @55688
      GIM_Try, /*On fail goto*//*Label 945*/ GIMT_Encode4(55703), // Rule ID 3123 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3123,
        GIR_Done,
      // Label 945: @55703
      GIM_Reject,
    // Label 936: @55704
    GIM_Reject,
    // Label 828: @55705
    GIM_Try, /*On fail goto*//*Label 946*/ GIMT_Encode4(56245),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
      GIM_Try, /*On fail goto*//*Label 947*/ GIMT_Encode4(55777), // Rule ID 15132 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] }), nxv8i1:{ *:[nxv8i1] }:$Op2), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15132,
        GIR_EraseRootFromParent_Done,
      // Label 947: @55777
      GIM_Try, /*On fail goto*//*Label 948*/ GIMT_Encode4(55834), // Rule ID 15135 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] }), nxv8i1:{ *:[nxv8i1] }:$Op2), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15135,
        GIR_EraseRootFromParent_Done,
      // Label 948: @55834
      GIM_Try, /*On fail goto*//*Label 949*/ GIMT_Encode4(55891), // Rule ID 15131 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] })), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15131,
        GIR_EraseRootFromParent_Done,
      // Label 949: @55891
      GIM_Try, /*On fail goto*//*Label 950*/ GIMT_Encode4(55948), // Rule ID 15134 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] })), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15134,
        GIR_EraseRootFromParent_Done,
      // Label 950: @55948
      GIM_Try, /*On fail goto*//*Label 951*/ GIMT_Encode4(56005), // Rule ID 15130 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] }), nxv8i1:{ *:[nxv8i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15130,
        GIR_EraseRootFromParent_Done,
      // Label 951: @56005
      GIM_Try, /*On fail goto*//*Label 952*/ GIMT_Encode4(56062), // Rule ID 15133 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] }), nxv8i1:{ *:[nxv8i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15133,
        GIR_EraseRootFromParent_Done,
      // Label 952: @56062
      GIM_Try, /*On fail goto*//*Label 953*/ GIMT_Encode4(56119), // Rule ID 8575 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8575,
        GIR_EraseRootFromParent_Done,
      // Label 953: @56119
      GIM_Try, /*On fail goto*//*Label 954*/ GIMT_Encode4(56176), // Rule ID 8576 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8576,
        GIR_EraseRootFromParent_Done,
      // Label 954: @56176
      GIM_Try, /*On fail goto*//*Label 955*/ GIMT_Encode4(56223), // Rule ID 10941 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (and:{ *:[nxv8i1] } PPR:{ *:[nxv8i1] }:$Ps1, PPR:{ *:[nxv8i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv8i1] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv8i1] }:$Ps1, PPR:{ *:[nxv8i1] }:$Ps2)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
        GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10941,
        GIR_EraseRootFromParent_Done,
      // Label 955: @56223
      GIM_Try, /*On fail goto*//*Label 956*/ GIMT_Encode4(56244), // Rule ID 2711 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_RootToRootCopy, /*OpIdx*/2, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2711,
        GIR_EraseRootFromParent_Done,
      // Label 956: @56244
      GIM_Reject,
    // Label 946: @56245
    GIM_Reject,
    // Label 829: @56246
    GIM_Try, /*On fail goto*//*Label 957*/ GIMT_Encode4(56717),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 958*/ GIMT_Encode4(56316), // Rule ID 15072 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] }), nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15072,
        GIR_EraseRootFromParent_Done,
      // Label 958: @56316
      GIM_Try, /*On fail goto*//*Label 959*/ GIMT_Encode4(56371), // Rule ID 15075 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] }), nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15075,
        GIR_EraseRootFromParent_Done,
      // Label 959: @56371
      GIM_Try, /*On fail goto*//*Label 960*/ GIMT_Encode4(56426), // Rule ID 15071 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] })), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15071,
        GIR_EraseRootFromParent_Done,
      // Label 960: @56426
      GIM_Try, /*On fail goto*//*Label 961*/ GIMT_Encode4(56481), // Rule ID 15074 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] })), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15074,
        GIR_EraseRootFromParent_Done,
      // Label 961: @56481
      GIM_Try, /*On fail goto*//*Label 962*/ GIMT_Encode4(56536), // Rule ID 15070 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15070,
        GIR_EraseRootFromParent_Done,
      // Label 962: @56536
      GIM_Try, /*On fail goto*//*Label 963*/ GIMT_Encode4(56591), // Rule ID 15073 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15073,
        GIR_EraseRootFromParent_Done,
      // Label 963: @56591
      GIM_Try, /*On fail goto*//*Label 964*/ GIMT_Encode4(56646), // Rule ID 7601 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7601,
        GIR_EraseRootFromParent_Done,
      // Label 964: @56646
      GIM_Try, /*On fail goto*//*Label 965*/ GIMT_Encode4(56701), // Rule ID 7602 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7602,
        GIR_EraseRootFromParent_Done,
      // Label 965: @56701
      GIM_Try, /*On fail goto*//*Label 966*/ GIMT_Encode4(56716), // Rule ID 3122 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3122,
        GIR_Done,
      // Label 966: @56716
      GIM_Reject,
    // Label 957: @56717
    GIM_Reject,
    // Label 830: @56718
    GIM_Try, /*On fail goto*//*Label 967*/ GIMT_Encode4(57258),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
      GIM_Try, /*On fail goto*//*Label 968*/ GIMT_Encode4(56790), // Rule ID 15123 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] }), nxv16i1:{ *:[nxv16i1] }:$Op2), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15123,
        GIR_EraseRootFromParent_Done,
      // Label 968: @56790
      GIM_Try, /*On fail goto*//*Label 969*/ GIMT_Encode4(56847), // Rule ID 15126 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] }), nxv16i1:{ *:[nxv16i1] }:$Op2), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15126,
        GIR_EraseRootFromParent_Done,
      // Label 969: @56847
      GIM_Try, /*On fail goto*//*Label 970*/ GIMT_Encode4(56904), // Rule ID 15122 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] })), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15122,
        GIR_EraseRootFromParent_Done,
      // Label 970: @56904
      GIM_Try, /*On fail goto*//*Label 971*/ GIMT_Encode4(56961), // Rule ID 15125 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] })), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15125,
        GIR_EraseRootFromParent_Done,
      // Label 971: @56961
      GIM_Try, /*On fail goto*//*Label 972*/ GIMT_Encode4(57018), // Rule ID 15121 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] }), nxv16i1:{ *:[nxv16i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15121,
        GIR_EraseRootFromParent_Done,
      // Label 972: @57018
      GIM_Try, /*On fail goto*//*Label 973*/ GIMT_Encode4(57075), // Rule ID 15124 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] }), nxv16i1:{ *:[nxv16i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15124,
        GIR_EraseRootFromParent_Done,
      // Label 973: @57075
      GIM_Try, /*On fail goto*//*Label 974*/ GIMT_Encode4(57132), // Rule ID 8571 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8571,
        GIR_EraseRootFromParent_Done,
      // Label 974: @57132
      GIM_Try, /*On fail goto*//*Label 975*/ GIMT_Encode4(57189), // Rule ID 8572 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8572,
        GIR_EraseRootFromParent_Done,
      // Label 975: @57189
      GIM_Try, /*On fail goto*//*Label 976*/ GIMT_Encode4(57236), // Rule ID 10940 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (and:{ *:[nxv16i1] } PPR:{ *:[nxv16i1] }:$Ps1, PPR:{ *:[nxv16i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv16i1] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv16i1] }:$Ps1, PPR:{ *:[nxv16i1] }:$Ps2)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
        GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10940,
        GIR_EraseRootFromParent_Done,
      // Label 976: @57236
      GIM_Try, /*On fail goto*//*Label 977*/ GIMT_Encode4(57257), // Rule ID 2710 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_RootToRootCopy, /*OpIdx*/2, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2710,
        GIR_EraseRootFromParent_Done,
      // Label 977: @57257
      GIM_Reject,
    // Label 967: @57258
    GIM_Reject,
    // Label 831: @57259
    GIM_Try, /*On fail goto*//*Label 978*/ GIMT_Encode4(57730),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 979*/ GIMT_Encode4(57329), // Rule ID 15063 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] }), nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15063,
        GIR_EraseRootFromParent_Done,
      // Label 979: @57329
      GIM_Try, /*On fail goto*//*Label 980*/ GIMT_Encode4(57384), // Rule ID 15066 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] }), nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15066,
        GIR_EraseRootFromParent_Done,
      // Label 980: @57384
      GIM_Try, /*On fail goto*//*Label 981*/ GIMT_Encode4(57439), // Rule ID 15062 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] })), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15062,
        GIR_EraseRootFromParent_Done,
      // Label 981: @57439
      GIM_Try, /*On fail goto*//*Label 982*/ GIMT_Encode4(57494), // Rule ID 15065 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] })), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15065,
        GIR_EraseRootFromParent_Done,
      // Label 982: @57494
      GIM_Try, /*On fail goto*//*Label 983*/ GIMT_Encode4(57549), // Rule ID 15061 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15061,
        GIR_EraseRootFromParent_Done,
      // Label 983: @57549
      GIM_Try, /*On fail goto*//*Label 984*/ GIMT_Encode4(57604), // Rule ID 15064 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15064,
        GIR_EraseRootFromParent_Done,
      // Label 984: @57604
      GIM_Try, /*On fail goto*//*Label 985*/ GIMT_Encode4(57659), // Rule ID 7597 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7597,
        GIR_EraseRootFromParent_Done,
      // Label 985: @57659
      GIM_Try, /*On fail goto*//*Label 986*/ GIMT_Encode4(57714), // Rule ID 7598 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7598,
        GIR_EraseRootFromParent_Done,
      // Label 986: @57714
      GIM_Try, /*On fail goto*//*Label 987*/ GIMT_Encode4(57729), // Rule ID 3121 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3121,
        GIR_Done,
      // Label 987: @57729
      GIM_Reject,
    // Label 978: @57730
    GIM_Reject,
    // Label 832: @57731
    GIM_Reject,
    // Label 6: @57732
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 1006*/ GIMT_Encode4(69778),
    /*GILLT_s32*//*Label 988*/ GIMT_Encode4(57831),
    /*GILLT_s64*//*Label 989*/ GIMT_Encode4(58191), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 990*/ GIMT_Encode4(60358),
    /*GILLT_v2s64*//*Label 991*/ GIMT_Encode4(61666),
    /*GILLT_v4s16*//*Label 992*/ GIMT_Encode4(62974),
    /*GILLT_v4s32*//*Label 993*/ GIMT_Encode4(64282),
    /*GILLT_v8s8*//*Label 994*/ GIMT_Encode4(65590),
    /*GILLT_v8s16*//*Label 995*/ GIMT_Encode4(66898),
    /*GILLT_v16s8*//*Label 996*/ GIMT_Encode4(68206),
    /*GILLT_nxv1s1*//*Label 997*/ GIMT_Encode4(69514),
    /*GILLT_nxv2s1*//*Label 998*/ GIMT_Encode4(69546), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s64*//*Label 999*/ GIMT_Encode4(69578),
    /*GILLT_nxv4s1*//*Label 1000*/ GIMT_Encode4(69604), GIMT_Encode4(0),
    /*GILLT_nxv4s32*//*Label 1001*/ GIMT_Encode4(69636),
    /*GILLT_nxv8s1*//*Label 1002*/ GIMT_Encode4(69662),
    /*GILLT_nxv8s16*//*Label 1003*/ GIMT_Encode4(69694),
    /*GILLT_nxv16s1*//*Label 1004*/ GIMT_Encode4(69720),
    /*GILLT_nxv16s8*//*Label 1005*/ GIMT_Encode4(69752),
    // Label 988: @57831
    GIM_Try, /*On fail goto*//*Label 1007*/ GIMT_Encode4(58190),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 1008*/ GIMT_Encode4(57897), // Rule ID 13326 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
        // (or:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (ORNWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13326,
        GIR_EraseRootFromParent_Done,
      // Label 1008: @57897
      GIM_Try, /*On fail goto*//*Label 1009*/ GIMT_Encode4(57952), // Rule ID 186 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
        // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }))  =>  (ORNWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 186,
        GIR_EraseRootFromParent_Done,
      // Label 1009: @57952
      GIM_Try, /*On fail goto*//*Label 1010*/ GIMT_Encode4(57993), // Rule ID 158 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm32),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_logical_imm32>><<X:logical_imm32_XFORM>>:$imm)  =>  (ORRWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (logical_imm32_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRWri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 158,
        GIR_EraseRootFromParent_Done,
      // Label 1010: @57993
      GIM_Try, /*On fail goto*//*Label 1011*/ GIMT_Encode4(58026), // Rule ID 13328 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
        // (or:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (ORRWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRWrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13328,
        GIR_EraseRootFromParent_Done,
      // Label 1011: @58026
      GIM_Try, /*On fail goto*//*Label 1012*/ GIMT_Encode4(58059), // Rule ID 190 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
        // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (ORRWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRWrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 190,
        GIR_EraseRootFromParent_Done,
      // Label 1012: @58059
      GIM_Try, /*On fail goto*//*Label 1013*/ GIMT_Encode4(58112), // Rule ID 13324 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (or:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (ORNWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13324,
        GIR_EraseRootFromParent_Done,
      // Label 1013: @58112
      GIM_Try, /*On fail goto*//*Label 1014*/ GIMT_Encode4(58165), // Rule ID 184 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (ORNWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 184,
        GIR_EraseRootFromParent_Done,
      // Label 1014: @58165
      GIM_Try, /*On fail goto*//*Label 1015*/ GIMT_Encode4(58189), // Rule ID 188 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (ORRWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRWrr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 188,
        GIR_Done,
      // Label 1015: @58189
      GIM_Reject,
    // Label 1007: @58190
    GIM_Reject,
    // Label 989: @58191
    GIM_Try, /*On fail goto*//*Label 1016*/ GIMT_Encode4(60357),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 1017*/ GIMT_Encode4(58324), // Rule ID 3997 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
        GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(71777214294589695),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
        // MIs[4] Rn
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
        GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(-71777214294589696),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[i64] } (and:{ *:[i64] } (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), 71777214294589695:{ *:[i64] }), (and:{ *:[i64] } (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), -71777214294589696:{ *:[i64] }))  =>  (REV16Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Xr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3997,
        GIR_EraseRootFromParent_Done,
      // Label 1017: @58324
      GIM_Try, /*On fail goto*//*Label 1018*/ GIMT_Encode4(58446), // Rule ID 13876 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
        GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(-71777214294589696),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
        // MIs[4] Rn
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
        GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(71777214294589695),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[i64] } (and:{ *:[i64] } (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), -71777214294589696:{ *:[i64] }), (and:{ *:[i64] } (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), 71777214294589695:{ *:[i64] }))  =>  (REV16Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Xr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13876,
        GIR_EraseRootFromParent_Done,
      // Label 1018: @58446
      GIM_Try, /*On fail goto*//*Label 1019*/ GIMT_Encode4(58501), // Rule ID 13327 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
        // (or:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (ORNXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13327,
        GIR_EraseRootFromParent_Done,
      // Label 1019: @58501
      GIM_Try, /*On fail goto*//*Label 1020*/ GIMT_Encode4(58556), // Rule ID 187 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
        // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }))  =>  (ORNXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 187,
        GIR_EraseRootFromParent_Done,
      // Label 1020: @58556
      GIM_Try, /*On fail goto*//*Label 1021*/ GIMT_Encode4(58665), // Rule ID 13676 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[4] LHS
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v1i64] } (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13676,
        GIR_EraseRootFromParent_Done,
      // Label 1021: @58665
      GIM_Try, /*On fail goto*//*Label 1022*/ GIMT_Encode4(58774), // Rule ID 13675 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
        // MIs[4] LHS
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v1i64] } (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13675,
        GIR_EraseRootFromParent_Done,
      // Label 1022: @58774
      GIM_Try, /*On fail goto*//*Label 1023*/ GIMT_Encode4(58883), // Rule ID 13678 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[4] LHS
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13678,
        GIR_EraseRootFromParent_Done,
      // Label 1023: @58883
      GIM_Try, /*On fail goto*//*Label 1024*/ GIMT_Encode4(58992), // Rule ID 13677 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
        // MIs[4] LHS
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13677,
        GIR_EraseRootFromParent_Done,
      // Label 1024: @58992
      GIM_Try, /*On fail goto*//*Label 1025*/ GIMT_Encode4(59101), // Rule ID 2440 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        // MIs[3] LHS
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS), (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2440,
        GIR_EraseRootFromParent_Done,
      // Label 1025: @59101
      GIM_Try, /*On fail goto*//*Label 1026*/ GIMT_Encode4(59210), // Rule ID 13673 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        // MIs[3] LHS
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS), (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13673,
        GIR_EraseRootFromParent_Done,
      // Label 1026: @59210
      GIM_Try, /*On fail goto*//*Label 1027*/ GIMT_Encode4(59319), // Rule ID 13672 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        // MIs[3] LHS
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13672,
        GIR_EraseRootFromParent_Done,
      // Label 1027: @59319
      GIM_Try, /*On fail goto*//*Label 1028*/ GIMT_Encode4(59428), // Rule ID 13674 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        // MIs[3] LHS
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13674,
        GIR_EraseRootFromParent_Done,
      // Label 1028: @59428
      GIM_Try, /*On fail goto*//*Label 1029*/ GIMT_Encode4(59469), // Rule ID 159 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm64),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_logical_imm64>><<X:logical_imm64_XFORM>>:$imm)  =>  (ORRXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (logical_imm64_XFORM:{ *:[i64] } (imm:{ *:[i64] }):$imm))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRXri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 159,
        GIR_EraseRootFromParent_Done,
      // Label 1029: @59469
      GIM_Try, /*On fail goto*//*Label 1030*/ GIMT_Encode4(59502), // Rule ID 13329 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
        // (or:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (ORRXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRXrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13329,
        GIR_EraseRootFromParent_Done,
      // Label 1030: @59502
      GIM_Try, /*On fail goto*//*Label 1031*/ GIMT_Encode4(59535), // Rule ID 191 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
        // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (ORRXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRXrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 191,
        GIR_EraseRootFromParent_Done,
      // Label 1031: @59535
      GIM_Try, /*On fail goto*//*Label 1032*/ GIMT_Encode4(59602), // Rule ID 13612 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[i64] } (AArch64vashr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13612,
        GIR_EraseRootFromParent_Done,
      // Label 1032: @59602
      GIM_Try, /*On fail goto*//*Label 1033*/ GIMT_Encode4(59669), // Rule ID 14000 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v1i64] } (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14000,
        GIR_EraseRootFromParent_Done,
      // Label 1033: @59669
      GIM_Try, /*On fail goto*//*Label 1034*/ GIMT_Encode4(59736), // Rule ID 13615 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[i64] } (AArch64vlshr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13615,
        GIR_EraseRootFromParent_Done,
      // Label 1034: @59736
      GIM_Try, /*On fail goto*//*Label 1035*/ GIMT_Encode4(59803), // Rule ID 14003 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v1i64] } (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14003,
        GIR_EraseRootFromParent_Done,
      // Label 1035: @59803
      GIM_Try, /*On fail goto*//*Label 1036*/ GIMT_Encode4(59856), // Rule ID 13325 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (or:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (ORNXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13325,
        GIR_EraseRootFromParent_Done,
      // Label 1036: @59856
      GIM_Try, /*On fail goto*//*Label 1037*/ GIMT_Encode4(59923), // Rule ID 2109 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, (AArch64vashr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2109,
        GIR_EraseRootFromParent_Done,
      // Label 1037: @59923
      GIM_Try, /*On fail goto*//*Label 1038*/ GIMT_Encode4(59990), // Rule ID 6336 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6336,
        GIR_EraseRootFromParent_Done,
      // Label 1038: @59990
      GIM_Try, /*On fail goto*//*Label 1039*/ GIMT_Encode4(60057), // Rule ID 2118 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, (AArch64vlshr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2118,
        GIR_EraseRootFromParent_Done,
      // Label 1039: @60057
      GIM_Try, /*On fail goto*//*Label 1040*/ GIMT_Encode4(60124), // Rule ID 6342 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6342,
        GIR_EraseRootFromParent_Done,
      // Label 1040: @60124
      GIM_Try, /*On fail goto*//*Label 1041*/ GIMT_Encode4(60177), // Rule ID 185 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }))  =>  (ORNXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 185,
        GIR_EraseRootFromParent_Done,
      // Label 1041: @60177
      GIM_Try, /*On fail goto*//*Label 1042*/ GIMT_Encode4(60241), // Rule ID 13964 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$LHS)  =>  (ORNv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13964,
        GIR_EraseRootFromParent_Done,
      // Label 1042: @60241
      GIM_Try, /*On fail goto*//*Label 1043*/ GIMT_Encode4(60305), // Rule ID 5092 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }))  =>  (ORNv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5092,
        GIR_EraseRootFromParent_Done,
      // Label 1043: @60305
      GIM_Try, /*On fail goto*//*Label 1044*/ GIMT_Encode4(60329), // Rule ID 189 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ORRXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRXrr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 189,
        GIR_Done,
      // Label 1044: @60329
      GIM_Try, /*On fail goto*//*Label 1045*/ GIMT_Encode4(60356), // Rule ID 5098 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (or:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)  =>  (ORRv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5098,
        GIR_Done,
      // Label 1045: @60356
      GIM_Reject,
    // Label 1016: @60357
    GIM_Reject,
    // Label 990: @60358
    GIM_Try, /*On fail goto*//*Label 1046*/ GIMT_Encode4(61665),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_Try, /*On fail goto*//*Label 1047*/ GIMT_Encode4(60478), // Rule ID 13669 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[4] LHS
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v2i32] } (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13669,
        GIR_EraseRootFromParent_Done,
      // Label 1047: @60478
      GIM_Try, /*On fail goto*//*Label 1048*/ GIMT_Encode4(60587), // Rule ID 13668 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
        // MIs[4] LHS
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v2i32] } (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13668,
        GIR_EraseRootFromParent_Done,
      // Label 1048: @60587
      GIM_Try, /*On fail goto*//*Label 1049*/ GIMT_Encode4(60696), // Rule ID 13671 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[4] LHS
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13671,
        GIR_EraseRootFromParent_Done,
      // Label 1049: @60696
      GIM_Try, /*On fail goto*//*Label 1050*/ GIMT_Encode4(60805), // Rule ID 13670 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
        // MIs[4] LHS
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13670,
        GIR_EraseRootFromParent_Done,
      // Label 1050: @60805
      GIM_Try, /*On fail goto*//*Label 1051*/ GIMT_Encode4(60914), // Rule ID 2439 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
        // MIs[3] LHS
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS), (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2439,
        GIR_EraseRootFromParent_Done,
      // Label 1051: @60914
      GIM_Try, /*On fail goto*//*Label 1052*/ GIMT_Encode4(61023), // Rule ID 13666 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
        // MIs[3] LHS
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS), (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13666,
        GIR_EraseRootFromParent_Done,
      // Label 1052: @61023
      GIM_Try, /*On fail goto*//*Label 1053*/ GIMT_Encode4(61132), // Rule ID 13665 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
        // MIs[3] LHS
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13665,
        GIR_EraseRootFromParent_Done,
      // Label 1053: @61132
      GIM_Try, /*On fail goto*//*Label 1054*/ GIMT_Encode4(61241), // Rule ID 13667 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
        // MIs[3] LHS
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13667,
        GIR_EraseRootFromParent_Done,
      // Label 1054: @61241
      GIM_Try, /*On fail goto*//*Label 1055*/ GIMT_Encode4(61308), // Rule ID 13632 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v2i32] } (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13632,
        GIR_EraseRootFromParent_Done,
      // Label 1055: @61308
      GIM_Try, /*On fail goto*//*Label 1056*/ GIMT_Encode4(61375), // Rule ID 13653 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13653,
        GIR_EraseRootFromParent_Done,
      // Label 1056: @61375
      GIM_Try, /*On fail goto*//*Label 1057*/ GIMT_Encode4(61442), // Rule ID 2226 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2226,
        GIR_EraseRootFromParent_Done,
      // Label 1057: @61442
      GIM_Try, /*On fail goto*//*Label 1058*/ GIMT_Encode4(61509), // Rule ID 2285 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2285,
        GIR_EraseRootFromParent_Done,
      // Label 1058: @61509
      GIM_Try, /*On fail goto*//*Label 1059*/ GIMT_Encode4(61573), // Rule ID 13963 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$LHS)  =>  (ORNv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13963,
        GIR_EraseRootFromParent_Done,
      // Label 1059: @61573
      GIM_Try, /*On fail goto*//*Label 1060*/ GIMT_Encode4(61637), // Rule ID 5091 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }))  =>  (ORNv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5091,
        GIR_EraseRootFromParent_Done,
      // Label 1060: @61637
      GIM_Try, /*On fail goto*//*Label 1061*/ GIMT_Encode4(61664), // Rule ID 5097 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (ORRv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5097,
        GIR_Done,
      // Label 1061: @61664
      GIM_Reject,
    // Label 1046: @61665
    GIM_Reject,
    // Label 991: @61666
    GIM_Try, /*On fail goto*//*Label 1062*/ GIMT_Encode4(62973),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_Try, /*On fail goto*//*Label 1063*/ GIMT_Encode4(61786), // Rule ID 13697 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[4] LHS
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13697,
        GIR_EraseRootFromParent_Done,
      // Label 1063: @61786
      GIM_Try, /*On fail goto*//*Label 1064*/ GIMT_Encode4(61895), // Rule ID 13696 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s64,
        // MIs[4] LHS
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13696,
        GIR_EraseRootFromParent_Done,
      // Label 1064: @61895
      GIM_Try, /*On fail goto*//*Label 1065*/ GIMT_Encode4(62004), // Rule ID 13699 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[4] LHS
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13699,
        GIR_EraseRootFromParent_Done,
      // Label 1065: @62004
      GIM_Try, /*On fail goto*//*Label 1066*/ GIMT_Encode4(62113), // Rule ID 13698 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s64,
        // MIs[4] LHS
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13698,
        GIR_EraseRootFromParent_Done,
      // Label 1066: @62113
      GIM_Try, /*On fail goto*//*Label 1067*/ GIMT_Encode4(62222), // Rule ID 2443 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
        // MIs[3] LHS
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2443,
        GIR_EraseRootFromParent_Done,
      // Label 1067: @62222
      GIM_Try, /*On fail goto*//*Label 1068*/ GIMT_Encode4(62331), // Rule ID 13694 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
        // MIs[3] LHS
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13694,
        GIR_EraseRootFromParent_Done,
      // Label 1068: @62331
      GIM_Try, /*On fail goto*//*Label 1069*/ GIMT_Encode4(62440), // Rule ID 13693 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
        // MIs[3] LHS
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13693,
        GIR_EraseRootFromParent_Done,
      // Label 1069: @62440
      GIM_Try, /*On fail goto*//*Label 1070*/ GIMT_Encode4(62549), // Rule ID 13695 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
        // MIs[3] LHS
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13695,
        GIR_EraseRootFromParent_Done,
      // Label 1070: @62549
      GIM_Try, /*On fail goto*//*Label 1071*/ GIMT_Encode4(62616), // Rule ID 13636 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v2i64] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13636,
        GIR_EraseRootFromParent_Done,
      // Label 1071: @62616
      GIM_Try, /*On fail goto*//*Label 1072*/ GIMT_Encode4(62683), // Rule ID 13657 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v2i64] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13657,
        GIR_EraseRootFromParent_Done,
      // Label 1072: @62683
      GIM_Try, /*On fail goto*//*Label 1073*/ GIMT_Encode4(62750), // Rule ID 2230 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2230,
        GIR_EraseRootFromParent_Done,
      // Label 1073: @62750
      GIM_Try, /*On fail goto*//*Label 1074*/ GIMT_Encode4(62817), // Rule ID 2289 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2289,
        GIR_EraseRootFromParent_Done,
      // Label 1074: @62817
      GIM_Try, /*On fail goto*//*Label 1075*/ GIMT_Encode4(62881), // Rule ID 13967 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$LHS)  =>  (ORNv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13967,
        GIR_EraseRootFromParent_Done,
      // Label 1075: @62881
      GIM_Try, /*On fail goto*//*Label 1076*/ GIMT_Encode4(62945), // Rule ID 5095 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }))  =>  (ORNv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5095,
        GIR_EraseRootFromParent_Done,
      // Label 1076: @62945
      GIM_Try, /*On fail goto*//*Label 1077*/ GIMT_Encode4(62972), // Rule ID 5101 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (ORRv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5101,
        GIR_Done,
      // Label 1077: @62972
      GIM_Reject,
    // Label 1062: @62973
    GIM_Reject,
    // Label 992: @62974
    GIM_Try, /*On fail goto*//*Label 1078*/ GIMT_Encode4(64281),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_Try, /*On fail goto*//*Label 1079*/ GIMT_Encode4(63094), // Rule ID 13662 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[4] LHS
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v4i16] } (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13662,
        GIR_EraseRootFromParent_Done,
      // Label 1079: @63094
      GIM_Try, /*On fail goto*//*Label 1080*/ GIMT_Encode4(63203), // Rule ID 13661 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s16,
        // MIs[4] LHS
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v4i16] } (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13661,
        GIR_EraseRootFromParent_Done,
      // Label 1080: @63203
      GIM_Try, /*On fail goto*//*Label 1081*/ GIMT_Encode4(63312), // Rule ID 13664 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[4] LHS
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13664,
        GIR_EraseRootFromParent_Done,
      // Label 1081: @63312
      GIM_Try, /*On fail goto*//*Label 1082*/ GIMT_Encode4(63421), // Rule ID 13663 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s16,
        // MIs[4] LHS
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13663,
        GIR_EraseRootFromParent_Done,
      // Label 1082: @63421
      GIM_Try, /*On fail goto*//*Label 1083*/ GIMT_Encode4(63530), // Rule ID 2438 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
        // MIs[3] LHS
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS), (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2438,
        GIR_EraseRootFromParent_Done,
      // Label 1083: @63530
      GIM_Try, /*On fail goto*//*Label 1084*/ GIMT_Encode4(63639), // Rule ID 13659 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
        // MIs[3] LHS
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS), (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13659,
        GIR_EraseRootFromParent_Done,
      // Label 1084: @63639
      GIM_Try, /*On fail goto*//*Label 1085*/ GIMT_Encode4(63748), // Rule ID 13658 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
        // MIs[3] LHS
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13658,
        GIR_EraseRootFromParent_Done,
      // Label 1085: @63748
      GIM_Try, /*On fail goto*//*Label 1086*/ GIMT_Encode4(63857), // Rule ID 13660 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
        // MIs[3] LHS
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13660,
        GIR_EraseRootFromParent_Done,
      // Label 1086: @63857
      GIM_Try, /*On fail goto*//*Label 1087*/ GIMT_Encode4(63924), // Rule ID 13628 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v4i16] } (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13628,
        GIR_EraseRootFromParent_Done,
      // Label 1087: @63924
      GIM_Try, /*On fail goto*//*Label 1088*/ GIMT_Encode4(63991), // Rule ID 13649 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13649,
        GIR_EraseRootFromParent_Done,
      // Label 1088: @63991
      GIM_Try, /*On fail goto*//*Label 1089*/ GIMT_Encode4(64058), // Rule ID 2222 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2222,
        GIR_EraseRootFromParent_Done,
      // Label 1089: @64058
      GIM_Try, /*On fail goto*//*Label 1090*/ GIMT_Encode4(64125), // Rule ID 2281 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2281,
        GIR_EraseRootFromParent_Done,
      // Label 1090: @64125
      GIM_Try, /*On fail goto*//*Label 1091*/ GIMT_Encode4(64189), // Rule ID 13962 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$LHS)  =>  (ORNv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13962,
        GIR_EraseRootFromParent_Done,
      // Label 1091: @64189
      GIM_Try, /*On fail goto*//*Label 1092*/ GIMT_Encode4(64253), // Rule ID 5090 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }))  =>  (ORNv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5090,
        GIR_EraseRootFromParent_Done,
      // Label 1092: @64253
      GIM_Try, /*On fail goto*//*Label 1093*/ GIMT_Encode4(64280), // Rule ID 5096 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (ORRv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5096,
        GIR_Done,
      // Label 1093: @64280
      GIM_Reject,
    // Label 1078: @64281
    GIM_Reject,
    // Label 993: @64282
    GIM_Try, /*On fail goto*//*Label 1094*/ GIMT_Encode4(65589),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_Try, /*On fail goto*//*Label 1095*/ GIMT_Encode4(64402), // Rule ID 13690 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[4] LHS
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13690,
        GIR_EraseRootFromParent_Done,
      // Label 1095: @64402
      GIM_Try, /*On fail goto*//*Label 1096*/ GIMT_Encode4(64511), // Rule ID 13689 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
        // MIs[4] LHS
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13689,
        GIR_EraseRootFromParent_Done,
      // Label 1096: @64511
      GIM_Try, /*On fail goto*//*Label 1097*/ GIMT_Encode4(64620), // Rule ID 13692 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[4] LHS
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13692,
        GIR_EraseRootFromParent_Done,
      // Label 1097: @64620
      GIM_Try, /*On fail goto*//*Label 1098*/ GIMT_Encode4(64729), // Rule ID 13691 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
        // MIs[4] LHS
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13691,
        GIR_EraseRootFromParent_Done,
      // Label 1098: @64729
      GIM_Try, /*On fail goto*//*Label 1099*/ GIMT_Encode4(64838), // Rule ID 2442 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
        // MIs[3] LHS
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2442,
        GIR_EraseRootFromParent_Done,
      // Label 1099: @64838
      GIM_Try, /*On fail goto*//*Label 1100*/ GIMT_Encode4(64947), // Rule ID 13687 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
        // MIs[3] LHS
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13687,
        GIR_EraseRootFromParent_Done,
      // Label 1100: @64947
      GIM_Try, /*On fail goto*//*Label 1101*/ GIMT_Encode4(65056), // Rule ID 13686 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
        // MIs[3] LHS
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13686,
        GIR_EraseRootFromParent_Done,
      // Label 1101: @65056
      GIM_Try, /*On fail goto*//*Label 1102*/ GIMT_Encode4(65165), // Rule ID 13688 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
        // MIs[3] LHS
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13688,
        GIR_EraseRootFromParent_Done,
      // Label 1102: @65165
      GIM_Try, /*On fail goto*//*Label 1103*/ GIMT_Encode4(65232), // Rule ID 13634 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v4i32] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13634,
        GIR_EraseRootFromParent_Done,
      // Label 1103: @65232
      GIM_Try, /*On fail goto*//*Label 1104*/ GIMT_Encode4(65299), // Rule ID 13655 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v4i32] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13655,
        GIR_EraseRootFromParent_Done,
      // Label 1104: @65299
      GIM_Try, /*On fail goto*//*Label 1105*/ GIMT_Encode4(65366), // Rule ID 2228 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2228,
        GIR_EraseRootFromParent_Done,
      // Label 1105: @65366
      GIM_Try, /*On fail goto*//*Label 1106*/ GIMT_Encode4(65433), // Rule ID 2287 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2287,
        GIR_EraseRootFromParent_Done,
      // Label 1106: @65433
      GIM_Try, /*On fail goto*//*Label 1107*/ GIMT_Encode4(65497), // Rule ID 13966 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$LHS)  =>  (ORNv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13966,
        GIR_EraseRootFromParent_Done,
      // Label 1107: @65497
      GIM_Try, /*On fail goto*//*Label 1108*/ GIMT_Encode4(65561), // Rule ID 5094 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }))  =>  (ORNv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5094,
        GIR_EraseRootFromParent_Done,
      // Label 1108: @65561
      GIM_Try, /*On fail goto*//*Label 1109*/ GIMT_Encode4(65588), // Rule ID 5100 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (ORRv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5100,
        GIR_Done,
      // Label 1109: @65588
      GIM_Reject,
    // Label 1094: @65589
    GIM_Reject,
    // Label 994: @65590
    GIM_Try, /*On fail goto*//*Label 1110*/ GIMT_Encode4(66897),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_Try, /*On fail goto*//*Label 1111*/ GIMT_Encode4(65710), // Rule ID 13450 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[4] Rd
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v8i8] } (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13450,
        GIR_EraseRootFromParent_Done,
      // Label 1111: @65710
      GIM_Try, /*On fail goto*//*Label 1112*/ GIMT_Encode4(65819), // Rule ID 13449 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s8,
        // MIs[4] Rd
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v8i8] } (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13449,
        GIR_EraseRootFromParent_Done,
      // Label 1112: @65819
      GIM_Try, /*On fail goto*//*Label 1113*/ GIMT_Encode4(65928), // Rule ID 13452 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[4] Rd
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13452,
        GIR_EraseRootFromParent_Done,
      // Label 1113: @65928
      GIM_Try, /*On fail goto*//*Label 1114*/ GIMT_Encode4(66037), // Rule ID 13451 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s8,
        // MIs[4] Rd
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13451,
        GIR_EraseRootFromParent_Done,
      // Label 1114: @66037
      GIM_Try, /*On fail goto*//*Label 1115*/ GIMT_Encode4(66146), // Rule ID 1594 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
        // MIs[3] Rd
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn), (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1594,
        GIR_EraseRootFromParent_Done,
      // Label 1115: @66146
      GIM_Try, /*On fail goto*//*Label 1116*/ GIMT_Encode4(66255), // Rule ID 13447 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
        // MIs[3] Rd
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd), (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13447,
        GIR_EraseRootFromParent_Done,
      // Label 1116: @66255
      GIM_Try, /*On fail goto*//*Label 1117*/ GIMT_Encode4(66364), // Rule ID 13446 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
        // MIs[3] Rd
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13446,
        GIR_EraseRootFromParent_Done,
      // Label 1117: @66364
      GIM_Try, /*On fail goto*//*Label 1118*/ GIMT_Encode4(66473), // Rule ID 13448 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
        // MIs[3] Rd
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13448,
        GIR_EraseRootFromParent_Done,
      // Label 1118: @66473
      GIM_Try, /*On fail goto*//*Label 1119*/ GIMT_Encode4(66540), // Rule ID 13624 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v8i8] } (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13624,
        GIR_EraseRootFromParent_Done,
      // Label 1119: @66540
      GIM_Try, /*On fail goto*//*Label 1120*/ GIMT_Encode4(66607), // Rule ID 13645 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13645,
        GIR_EraseRootFromParent_Done,
      // Label 1120: @66607
      GIM_Try, /*On fail goto*//*Label 1121*/ GIMT_Encode4(66674), // Rule ID 2218 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2218,
        GIR_EraseRootFromParent_Done,
      // Label 1121: @66674
      GIM_Try, /*On fail goto*//*Label 1122*/ GIMT_Encode4(66741), // Rule ID 2277 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2277,
        GIR_EraseRootFromParent_Done,
      // Label 1122: @66741
      GIM_Try, /*On fail goto*//*Label 1123*/ GIMT_Encode4(66805), // Rule ID 13444 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rn)  =>  (ORNv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13444,
        GIR_EraseRootFromParent_Done,
      // Label 1123: @66805
      GIM_Try, /*On fail goto*//*Label 1124*/ GIMT_Encode4(66869), // Rule ID 1590 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }))  =>  (ORNv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1590,
        GIR_EraseRootFromParent_Done,
      // Label 1124: @66869
      GIM_Try, /*On fail goto*//*Label 1125*/ GIMT_Encode4(66896), // Rule ID 1592 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ORRv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1592,
        GIR_Done,
      // Label 1125: @66896
      GIM_Reject,
    // Label 1110: @66897
    GIM_Reject,
    // Label 995: @66898
    GIM_Try, /*On fail goto*//*Label 1126*/ GIMT_Encode4(68205),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_Try, /*On fail goto*//*Label 1127*/ GIMT_Encode4(67018), // Rule ID 13683 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[4] LHS
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13683,
        GIR_EraseRootFromParent_Done,
      // Label 1127: @67018
      GIM_Try, /*On fail goto*//*Label 1128*/ GIMT_Encode4(67127), // Rule ID 13682 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s16,
        // MIs[4] LHS
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13682,
        GIR_EraseRootFromParent_Done,
      // Label 1128: @67127
      GIM_Try, /*On fail goto*//*Label 1129*/ GIMT_Encode4(67236), // Rule ID 13685 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[4] LHS
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13685,
        GIR_EraseRootFromParent_Done,
      // Label 1129: @67236
      GIM_Try, /*On fail goto*//*Label 1130*/ GIMT_Encode4(67345), // Rule ID 13684 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s16,
        // MIs[4] LHS
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13684,
        GIR_EraseRootFromParent_Done,
      // Label 1130: @67345
      GIM_Try, /*On fail goto*//*Label 1131*/ GIMT_Encode4(67454), // Rule ID 2441 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
        // MIs[3] LHS
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2441,
        GIR_EraseRootFromParent_Done,
      // Label 1131: @67454
      GIM_Try, /*On fail goto*//*Label 1132*/ GIMT_Encode4(67563), // Rule ID 13680 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
        // MIs[3] LHS
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13680,
        GIR_EraseRootFromParent_Done,
      // Label 1132: @67563
      GIM_Try, /*On fail goto*//*Label 1133*/ GIMT_Encode4(67672), // Rule ID 13679 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
        // MIs[3] LHS
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13679,
        GIR_EraseRootFromParent_Done,
      // Label 1133: @67672
      GIM_Try, /*On fail goto*//*Label 1134*/ GIMT_Encode4(67781), // Rule ID 13681 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
        // MIs[3] LHS
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13681,
        GIR_EraseRootFromParent_Done,
      // Label 1134: @67781
      GIM_Try, /*On fail goto*//*Label 1135*/ GIMT_Encode4(67848), // Rule ID 13630 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v8i16] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13630,
        GIR_EraseRootFromParent_Done,
      // Label 1135: @67848
      GIM_Try, /*On fail goto*//*Label 1136*/ GIMT_Encode4(67915), // Rule ID 13651 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v8i16] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13651,
        GIR_EraseRootFromParent_Done,
      // Label 1136: @67915
      GIM_Try, /*On fail goto*//*Label 1137*/ GIMT_Encode4(67982), // Rule ID 2224 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2224,
        GIR_EraseRootFromParent_Done,
      // Label 1137: @67982
      GIM_Try, /*On fail goto*//*Label 1138*/ GIMT_Encode4(68049), // Rule ID 2283 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2283,
        GIR_EraseRootFromParent_Done,
      // Label 1138: @68049
      GIM_Try, /*On fail goto*//*Label 1139*/ GIMT_Encode4(68113), // Rule ID 13965 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$LHS)  =>  (ORNv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13965,
        GIR_EraseRootFromParent_Done,
      // Label 1139: @68113
      GIM_Try, /*On fail goto*//*Label 1140*/ GIMT_Encode4(68177), // Rule ID 5093 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }))  =>  (ORNv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // LHS
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5093,
        GIR_EraseRootFromParent_Done,
      // Label 1140: @68177
      GIM_Try, /*On fail goto*//*Label 1141*/ GIMT_Encode4(68204), // Rule ID 5099 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (ORRv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5099,
        GIR_Done,
      // Label 1141: @68204
      GIM_Reject,
    // Label 1126: @68205
    GIM_Reject,
    // Label 996: @68206
    GIM_Try, /*On fail goto*//*Label 1142*/ GIMT_Encode4(69513),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_Try, /*On fail goto*//*Label 1143*/ GIMT_Encode4(68326), // Rule ID 13457 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[4] Rd
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13457,
        GIR_EraseRootFromParent_Done,
      // Label 1143: @68326
      GIM_Try, /*On fail goto*//*Label 1144*/ GIMT_Encode4(68435), // Rule ID 13456 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v16s8,
        // MIs[4] Rd
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13456,
        GIR_EraseRootFromParent_Done,
      // Label 1144: @68435
      GIM_Try, /*On fail goto*//*Label 1145*/ GIMT_Encode4(68544), // Rule ID 13459 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[4] Rd
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13459,
        GIR_EraseRootFromParent_Done,
      // Label 1145: @68544
      GIM_Try, /*On fail goto*//*Label 1146*/ GIMT_Encode4(68653), // Rule ID 13458 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v16s8,
        // MIs[4] Rd
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13458,
        GIR_EraseRootFromParent_Done,
      // Label 1146: @68653
      GIM_Try, /*On fail goto*//*Label 1147*/ GIMT_Encode4(68762), // Rule ID 1595 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
        // MIs[3] Rd
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1595,
        GIR_EraseRootFromParent_Done,
      // Label 1147: @68762
      GIM_Try, /*On fail goto*//*Label 1148*/ GIMT_Encode4(68871), // Rule ID 13454 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
        // MIs[3] Rd
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13454,
        GIR_EraseRootFromParent_Done,
      // Label 1148: @68871
      GIM_Try, /*On fail goto*//*Label 1149*/ GIMT_Encode4(68980), // Rule ID 13453 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
        // MIs[3] Rd
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13453,
        GIR_EraseRootFromParent_Done,
      // Label 1149: @68980
      GIM_Try, /*On fail goto*//*Label 1150*/ GIMT_Encode4(69089), // Rule ID 13455 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
        // MIs[3] Rd
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13455,
        GIR_EraseRootFromParent_Done,
      // Label 1150: @69089
      GIM_Try, /*On fail goto*//*Label 1151*/ GIMT_Encode4(69156), // Rule ID 13626 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v16i8] } (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13626,
        GIR_EraseRootFromParent_Done,
      // Label 1151: @69156
      GIM_Try, /*On fail goto*//*Label 1152*/ GIMT_Encode4(69223), // Rule ID 13647 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v16i8] } (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13647,
        GIR_EraseRootFromParent_Done,
      // Label 1152: @69223
      GIM_Try, /*On fail goto*//*Label 1153*/ GIMT_Encode4(69290), // Rule ID 2220 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2220,
        GIR_EraseRootFromParent_Done,
      // Label 1153: @69290
      GIM_Try, /*On fail goto*//*Label 1154*/ GIMT_Encode4(69357), // Rule ID 2279 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2279,
        GIR_EraseRootFromParent_Done,
      // Label 1154: @69357
      GIM_Try, /*On fail goto*//*Label 1155*/ GIMT_Encode4(69421), // Rule ID 13445 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rn)  =>  (ORNv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13445,
        GIR_EraseRootFromParent_Done,
      // Label 1155: @69421
      GIM_Try, /*On fail goto*//*Label 1156*/ GIMT_Encode4(69485), // Rule ID 1591 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }))  =>  (ORNv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1591,
        GIR_EraseRootFromParent_Done,
      // Label 1156: @69485
      GIM_Try, /*On fail goto*//*Label 1157*/ GIMT_Encode4(69512), // Rule ID 1593 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ORRv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1593,
        GIR_Done,
      // Label 1157: @69512
      GIM_Reject,
    // Label 1142: @69513
    GIM_Reject,
    // Label 997: @69514
    GIM_Try, /*On fail goto*//*Label 1158*/ GIMT_Encode4(69545), // Rule ID 8610 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
      // (or:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Op1
      GIR_RootToRootCopy, /*OpIdx*/1, // Op1
      GIR_RootToRootCopy, /*OpIdx*/2, // Op2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8610,
      GIR_EraseRootFromParent_Done,
    // Label 1158: @69545
    GIM_Reject,
    // Label 998: @69546
    GIM_Try, /*On fail goto*//*Label 1159*/ GIMT_Encode4(69577), // Rule ID 8609 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
      // (or:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Op1
      GIR_RootToRootCopy, /*OpIdx*/1, // Op1
      GIR_RootToRootCopy, /*OpIdx*/2, // Op2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8609,
      GIR_EraseRootFromParent_Done,
    // Label 1159: @69577
    GIM_Reject,
    // Label 999: @69578
    GIM_Try, /*On fail goto*//*Label 1160*/ GIMT_Encode4(69603), // Rule ID 7592 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7592,
      GIR_Done,
    // Label 1160: @69603
    GIM_Reject,
    // Label 1000: @69604
    GIM_Try, /*On fail goto*//*Label 1161*/ GIMT_Encode4(69635), // Rule ID 8608 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
      // (or:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Op1
      GIR_RootToRootCopy, /*OpIdx*/1, // Op1
      GIR_RootToRootCopy, /*OpIdx*/2, // Op2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8608,
      GIR_EraseRootFromParent_Done,
    // Label 1161: @69635
    GIM_Reject,
    // Label 1001: @69636
    GIM_Try, /*On fail goto*//*Label 1162*/ GIMT_Encode4(69661), // Rule ID 7591 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7591,
      GIR_Done,
    // Label 1162: @69661
    GIM_Reject,
    // Label 1002: @69662
    GIM_Try, /*On fail goto*//*Label 1163*/ GIMT_Encode4(69693), // Rule ID 8607 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
      // (or:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Op1
      GIR_RootToRootCopy, /*OpIdx*/1, // Op1
      GIR_RootToRootCopy, /*OpIdx*/2, // Op2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8607,
      GIR_EraseRootFromParent_Done,
    // Label 1163: @69693
    GIM_Reject,
    // Label 1003: @69694
    GIM_Try, /*On fail goto*//*Label 1164*/ GIMT_Encode4(69719), // Rule ID 7590 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7590,
      GIR_Done,
    // Label 1164: @69719
    GIM_Reject,
    // Label 1004: @69720
    GIM_Try, /*On fail goto*//*Label 1165*/ GIMT_Encode4(69751), // Rule ID 8606 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
      // (or:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Op1
      GIR_RootToRootCopy, /*OpIdx*/1, // Op1
      GIR_RootToRootCopy, /*OpIdx*/2, // Op2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8606,
      GIR_EraseRootFromParent_Done,
    // Label 1165: @69751
    GIM_Reject,
    // Label 1005: @69752
    GIM_Try, /*On fail goto*//*Label 1166*/ GIMT_Encode4(69777), // Rule ID 7589 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7589,
      GIR_Done,
    // Label 1166: @69777
    GIM_Reject,
    // Label 1006: @69778
    GIM_Reject,
    // Label 7: @69779
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 1185*/ GIMT_Encode4(75717),
    /*GILLT_s32*//*Label 1167*/ GIMT_Encode4(69878),
    /*GILLT_s64*//*Label 1168*/ GIMT_Encode4(70558), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 1169*/ GIMT_Encode4(71301),
    /*GILLT_v2s64*//*Label 1170*/ GIMT_Encode4(71369),
    /*GILLT_v4s16*//*Label 1171*/ GIMT_Encode4(71895),
    /*GILLT_v4s32*//*Label 1172*/ GIMT_Encode4(71963),
    /*GILLT_v8s8*//*Label 1173*/ GIMT_Encode4(72489),
    /*GILLT_v8s16*//*Label 1174*/ GIMT_Encode4(72560),
    /*GILLT_v16s8*//*Label 1175*/ GIMT_Encode4(73086),
    /*GILLT_nxv1s1*//*Label 1176*/ GIMT_Encode4(73615),
    /*GILLT_nxv2s1*//*Label 1177*/ GIMT_Encode4(73665), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s64*//*Label 1178*/ GIMT_Encode4(73715),
    /*GILLT_nxv4s1*//*Label 1179*/ GIMT_Encode4(74178), GIMT_Encode4(0),
    /*GILLT_nxv4s32*//*Label 1180*/ GIMT_Encode4(74228),
    /*GILLT_nxv8s1*//*Label 1181*/ GIMT_Encode4(74691),
    /*GILLT_nxv8s16*//*Label 1182*/ GIMT_Encode4(74741),
    /*GILLT_nxv16s1*//*Label 1183*/ GIMT_Encode4(75204),
    /*GILLT_nxv16s8*//*Label 1184*/ GIMT_Encode4(75254),
    // Label 1167: @69878
    GIM_Try, /*On fail goto*//*Label 1186*/ GIMT_Encode4(70557),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 1187*/ GIMT_Encode4(69947), // Rule ID 13315 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
        // (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }))  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13315,
        GIR_EraseRootFromParent_Done,
      // Label 1187: @69947
      GIM_Try, /*On fail goto*//*Label 1188*/ GIMT_Encode4(70002), // Rule ID 13314 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
        // (xor:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13314,
        GIR_EraseRootFromParent_Done,
      // Label 1188: @70002
      GIM_Try, /*On fail goto*//*Label 1189*/ GIMT_Encode4(70060), // Rule ID 13312 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
        // (xor:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn), -1:{ *:[i32] })  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13312,
        GIR_EraseRootFromParent_Done,
      // Label 1189: @70060
      GIM_Try, /*On fail goto*//*Label 1190*/ GIMT_Encode4(70118), // Rule ID 178 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
        // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift), -1:{ *:[i32] })  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 178,
        GIR_EraseRootFromParent_Done,
      // Label 1190: @70118
      GIM_Try, /*On fail goto*//*Label 1191*/ GIMT_Encode4(70176), // Rule ID 13313 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
        // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }), logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13313,
        GIR_EraseRootFromParent_Done,
      // Label 1191: @70176
      GIM_Try, /*On fail goto*//*Label 1192*/ GIMT_Encode4(70231), // Rule ID 13316 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
        // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }))  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13316,
        GIR_EraseRootFromParent_Done,
      // Label 1192: @70231
      GIM_Try, /*On fail goto*//*Label 1193*/ GIMT_Encode4(70272), // Rule ID 156 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm32),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_logical_imm32>><<X:logical_imm32_XFORM>>:$imm)  =>  (EORWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (logical_imm32_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORWri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 156,
        GIR_EraseRootFromParent_Done,
      // Label 1193: @70272
      GIM_Try, /*On fail goto*//*Label 1194*/ GIMT_Encode4(70305), // Rule ID 13322 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
        // (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (EORWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORWrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13322,
        GIR_EraseRootFromParent_Done,
      // Label 1194: @70305
      GIM_Try, /*On fail goto*//*Label 1195*/ GIMT_Encode4(70338), // Rule ID 182 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
        // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (EORWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORWrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 182,
        GIR_EraseRootFromParent_Done,
      // Label 1195: @70338
      GIM_Try, /*On fail goto*//*Label 1196*/ GIMT_Encode4(70391), // Rule ID 13308 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rm)  =>  (EONWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13308,
        GIR_EraseRootFromParent_Done,
      // Label 1196: @70391
      GIM_Try, /*On fail goto*//*Label 1197*/ GIMT_Encode4(70447), // Rule ID 176 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm), -1:{ *:[i32] })  =>  (EONWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 176,
        GIR_EraseRootFromParent_Done,
      // Label 1197: @70447
      GIM_Try, /*On fail goto*//*Label 1198*/ GIMT_Encode4(70500), // Rule ID 13309 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }))  =>  (EONWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13309,
        GIR_EraseRootFromParent_Done,
      // Label 1198: @70500
      GIM_Try, /*On fail goto*//*Label 1199*/ GIMT_Encode4(70532), // Rule ID 3982 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
        // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Wm, -1:{ *:[i32] })  =>  (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Wm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/1, // Wm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3982,
        GIR_EraseRootFromParent_Done,
      // Label 1199: @70532
      GIM_Try, /*On fail goto*//*Label 1200*/ GIMT_Encode4(70556), // Rule ID 180 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (EORWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORWrr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 180,
        GIR_Done,
      // Label 1200: @70556
      GIM_Reject,
    // Label 1186: @70557
    GIM_Reject,
    // Label 1168: @70558
    GIM_Try, /*On fail goto*//*Label 1201*/ GIMT_Encode4(71300),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 1202*/ GIMT_Encode4(70627), // Rule ID 13320 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
        // (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }))  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13320,
        GIR_EraseRootFromParent_Done,
      // Label 1202: @70627
      GIM_Try, /*On fail goto*//*Label 1203*/ GIMT_Encode4(70682), // Rule ID 13319 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
        // (xor:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13319,
        GIR_EraseRootFromParent_Done,
      // Label 1203: @70682
      GIM_Try, /*On fail goto*//*Label 1204*/ GIMT_Encode4(70740), // Rule ID 13317 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
        // (xor:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn), -1:{ *:[i64] })  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13317,
        GIR_EraseRootFromParent_Done,
      // Label 1204: @70740
      GIM_Try, /*On fail goto*//*Label 1205*/ GIMT_Encode4(70798), // Rule ID 179 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
        // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift), -1:{ *:[i64] })  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 179,
        GIR_EraseRootFromParent_Done,
      // Label 1205: @70798
      GIM_Try, /*On fail goto*//*Label 1206*/ GIMT_Encode4(70856), // Rule ID 13318 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
        // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }), logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13318,
        GIR_EraseRootFromParent_Done,
      // Label 1206: @70856
      GIM_Try, /*On fail goto*//*Label 1207*/ GIMT_Encode4(70911), // Rule ID 13321 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
        // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }))  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13321,
        GIR_EraseRootFromParent_Done,
      // Label 1207: @70911
      GIM_Try, /*On fail goto*//*Label 1208*/ GIMT_Encode4(70952), // Rule ID 157 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm64),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_logical_imm64>><<X:logical_imm64_XFORM>>:$imm)  =>  (EORXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (logical_imm64_XFORM:{ *:[i64] } (imm:{ *:[i64] }):$imm))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORXri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 157,
        GIR_EraseRootFromParent_Done,
      // Label 1208: @70952
      GIM_Try, /*On fail goto*//*Label 1209*/ GIMT_Encode4(70985), // Rule ID 13323 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
        // (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (EORXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORXrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13323,
        GIR_EraseRootFromParent_Done,
      // Label 1209: @70985
      GIM_Try, /*On fail goto*//*Label 1210*/ GIMT_Encode4(71018), // Rule ID 183 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
        // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (EORXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORXrs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 183,
        GIR_EraseRootFromParent_Done,
      // Label 1210: @71018
      GIM_Try, /*On fail goto*//*Label 1211*/ GIMT_Encode4(71071), // Rule ID 13310 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rm)  =>  (EONXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13310,
        GIR_EraseRootFromParent_Done,
      // Label 1211: @71071
      GIM_Try, /*On fail goto*//*Label 1212*/ GIMT_Encode4(71127), // Rule ID 177 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm), -1:{ *:[i64] })  =>  (EONXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 177,
        GIR_EraseRootFromParent_Done,
      // Label 1212: @71127
      GIM_Try, /*On fail goto*//*Label 1213*/ GIMT_Encode4(71180), // Rule ID 13311 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }))  =>  (EONXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13311,
        GIR_EraseRootFromParent_Done,
      // Label 1213: @71180
      GIM_Try, /*On fail goto*//*Label 1214*/ GIMT_Encode4(71212), // Rule ID 3983 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
        // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Xm, -1:{ *:[i64] })  =>  (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Xm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/1, // Xm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3983,
        GIR_EraseRootFromParent_Done,
      // Label 1214: @71212
      GIM_Try, /*On fail goto*//*Label 1215*/ GIMT_Encode4(71248), // Rule ID 4986 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, immAllOnesV:{ *:[v1i64] })  =>  (NOTv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4986,
        GIR_EraseRootFromParent_Done,
      // Label 1215: @71248
      GIM_Try, /*On fail goto*//*Label 1216*/ GIMT_Encode4(71272), // Rule ID 181 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (EORXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORXrr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 181,
        GIR_Done,
      // Label 1216: @71272
      GIM_Try, /*On fail goto*//*Label 1217*/ GIMT_Encode4(71299), // Rule ID 5086 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)  =>  (EORv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5086,
        GIR_Done,
      // Label 1217: @71299
      GIM_Reject,
    // Label 1201: @71300
    GIM_Reject,
    // Label 1169: @71301
    GIM_Try, /*On fail goto*//*Label 1218*/ GIMT_Encode4(71368),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 1219*/ GIMT_Encode4(71348), // Rule ID 4984 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllOnesV:{ *:[v2i32] })  =>  (NOTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4984,
        GIR_EraseRootFromParent_Done,
      // Label 1219: @71348
      GIM_Try, /*On fail goto*//*Label 1220*/ GIMT_Encode4(71367), // Rule ID 5085 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (EORv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5085,
        GIR_Done,
      // Label 1220: @71367
      GIM_Reject,
    // Label 1218: @71368
    GIM_Reject,
    // Label 1170: @71369
    GIM_Try, /*On fail goto*//*Label 1221*/ GIMT_Encode4(71894),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 1222*/ GIMT_Encode4(71469), // Rule ID 13845 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$Vm), V128:{ *:[v2i64] }:$Vn)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13845,
        GIR_EraseRootFromParent_Done,
      // Label 1222: @71469
      GIM_Try, /*On fail goto*//*Label 1223*/ GIMT_Encode4(71554), // Rule ID 13844 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (xor:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vm, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] })), V128:{ *:[v2i64] }:$Vn)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13844,
        GIR_EraseRootFromParent_Done,
      // Label 1223: @71554
      GIM_Try, /*On fail goto*//*Label 1224*/ GIMT_Encode4(71639), // Rule ID 13843 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$Vm))  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Vn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13843,
        GIR_EraseRootFromParent_Done,
      // Label 1224: @71639
      GIM_Try, /*On fail goto*//*Label 1225*/ GIMT_Encode4(71724), // Rule ID 3810 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vm, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] })))  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Vn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3810,
        GIR_EraseRootFromParent_Done,
      // Label 1225: @71724
      GIM_Try, /*On fail goto*//*Label 1226*/ GIMT_Encode4(71756), // Rule ID 4987 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] })  =>  (NOTv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4987,
        GIR_EraseRootFromParent_Done,
      // Label 1226: @71756
      GIM_Try, /*On fail goto*//*Label 1227*/ GIMT_Encode4(71813), // Rule ID 3806 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm), V128:{ *:[v2i64] }:$Va)  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
        GIR_RootToRootCopy, /*OpIdx*/2, // Va
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3806,
        GIR_EraseRootFromParent_Done,
      // Label 1227: @71813
      GIM_Try, /*On fail goto*//*Label 1228*/ GIMT_Encode4(71870), // Rule ID 13833 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm))  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
        GIR_RootToRootCopy, /*OpIdx*/1, // Va
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13833,
        GIR_EraseRootFromParent_Done,
      // Label 1228: @71870
      GIM_Try, /*On fail goto*//*Label 1229*/ GIMT_Encode4(71893), // Rule ID 5089 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (EORv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5089,
        GIR_Done,
      // Label 1229: @71893
      GIM_Reject,
    // Label 1221: @71894
    GIM_Reject,
    // Label 1171: @71895
    GIM_Try, /*On fail goto*//*Label 1230*/ GIMT_Encode4(71962),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 1231*/ GIMT_Encode4(71942), // Rule ID 4982 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllOnesV:{ *:[v4i16] })  =>  (NOTv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4982,
        GIR_EraseRootFromParent_Done,
      // Label 1231: @71942
      GIM_Try, /*On fail goto*//*Label 1232*/ GIMT_Encode4(71961), // Rule ID 5084 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (EORv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5084,
        GIR_Done,
      // Label 1232: @71961
      GIM_Reject,
    // Label 1230: @71962
    GIM_Reject,
    // Label 1172: @71963
    GIM_Try, /*On fail goto*//*Label 1233*/ GIMT_Encode4(72488),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 1234*/ GIMT_Encode4(72063), // Rule ID 13842 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$Vm), V128:{ *:[v4i32] }:$Vn)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13842,
        GIR_EraseRootFromParent_Done,
      // Label 1234: @72063
      GIM_Try, /*On fail goto*//*Label 1235*/ GIMT_Encode4(72148), // Rule ID 13841 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vm, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] })), V128:{ *:[v4i32] }:$Vn)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13841,
        GIR_EraseRootFromParent_Done,
      // Label 1235: @72148
      GIM_Try, /*On fail goto*//*Label 1236*/ GIMT_Encode4(72233), // Rule ID 13840 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$Vm))  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Vn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13840,
        GIR_EraseRootFromParent_Done,
      // Label 1236: @72233
      GIM_Try, /*On fail goto*//*Label 1237*/ GIMT_Encode4(72318), // Rule ID 3809 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vm, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] })))  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Vn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3809,
        GIR_EraseRootFromParent_Done,
      // Label 1237: @72318
      GIM_Try, /*On fail goto*//*Label 1238*/ GIMT_Encode4(72350), // Rule ID 4985 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] })  =>  (NOTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4985,
        GIR_EraseRootFromParent_Done,
      // Label 1238: @72350
      GIM_Try, /*On fail goto*//*Label 1239*/ GIMT_Encode4(72407), // Rule ID 3805 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm), V128:{ *:[v4i32] }:$Va)  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
        GIR_RootToRootCopy, /*OpIdx*/2, // Va
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3805,
        GIR_EraseRootFromParent_Done,
      // Label 1239: @72407
      GIM_Try, /*On fail goto*//*Label 1240*/ GIMT_Encode4(72464), // Rule ID 13832 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm))  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
        GIR_RootToRootCopy, /*OpIdx*/1, // Va
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13832,
        GIR_EraseRootFromParent_Done,
      // Label 1240: @72464
      GIM_Try, /*On fail goto*//*Label 1241*/ GIMT_Encode4(72487), // Rule ID 5088 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (EORv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5088,
        GIR_Done,
      // Label 1241: @72487
      GIM_Reject,
    // Label 1233: @72488
    GIM_Reject,
    // Label 1173: @72489
    GIM_Try, /*On fail goto*//*Label 1242*/ GIMT_Encode4(72559),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 1243*/ GIMT_Encode4(72539), // Rule ID 961 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllOnesV:{ *:[v8i8] })  =>  (NOTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 961,
        GIR_EraseRootFromParent_Done,
      // Label 1243: @72539
      GIM_Try, /*On fail goto*//*Label 1244*/ GIMT_Encode4(72558), // Rule ID 1588 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (EORv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1588,
        GIR_Done,
      // Label 1244: @72558
      GIM_Reject,
    // Label 1242: @72559
    GIM_Reject,
    // Label 1174: @72560
    GIM_Try, /*On fail goto*//*Label 1245*/ GIMT_Encode4(73085),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 1246*/ GIMT_Encode4(72660), // Rule ID 13839 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$Vm), V128:{ *:[v8i16] }:$Vn)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13839,
        GIR_EraseRootFromParent_Done,
      // Label 1246: @72660
      GIM_Try, /*On fail goto*//*Label 1247*/ GIMT_Encode4(72745), // Rule ID 13838 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (xor:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vm, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] })), V128:{ *:[v8i16] }:$Vn)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13838,
        GIR_EraseRootFromParent_Done,
      // Label 1247: @72745
      GIM_Try, /*On fail goto*//*Label 1248*/ GIMT_Encode4(72830), // Rule ID 13837 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$Vm))  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Vn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13837,
        GIR_EraseRootFromParent_Done,
      // Label 1248: @72830
      GIM_Try, /*On fail goto*//*Label 1249*/ GIMT_Encode4(72915), // Rule ID 3808 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vm, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] })))  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Vn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3808,
        GIR_EraseRootFromParent_Done,
      // Label 1249: @72915
      GIM_Try, /*On fail goto*//*Label 1250*/ GIMT_Encode4(72947), // Rule ID 4983 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] })  =>  (NOTv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4983,
        GIR_EraseRootFromParent_Done,
      // Label 1250: @72947
      GIM_Try, /*On fail goto*//*Label 1251*/ GIMT_Encode4(73004), // Rule ID 3804 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm), V128:{ *:[v8i16] }:$Va)  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
        GIR_RootToRootCopy, /*OpIdx*/2, // Va
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3804,
        GIR_EraseRootFromParent_Done,
      // Label 1251: @73004
      GIM_Try, /*On fail goto*//*Label 1252*/ GIMT_Encode4(73061), // Rule ID 13831 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm))  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
        GIR_RootToRootCopy, /*OpIdx*/1, // Va
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13831,
        GIR_EraseRootFromParent_Done,
      // Label 1252: @73061
      GIM_Try, /*On fail goto*//*Label 1253*/ GIMT_Encode4(73084), // Rule ID 5087 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (EORv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5087,
        GIR_Done,
      // Label 1253: @73084
      GIM_Reject,
    // Label 1245: @73085
    GIM_Reject,
    // Label 1175: @73086
    GIM_Try, /*On fail goto*//*Label 1254*/ GIMT_Encode4(73614),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 1255*/ GIMT_Encode4(73186), // Rule ID 13836 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Vm), V128:{ *:[v16i8] }:$Vn)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13836,
        GIR_EraseRootFromParent_Done,
      // Label 1255: @73186
      GIM_Try, /*On fail goto*//*Label 1256*/ GIMT_Encode4(73271), // Rule ID 13835 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (xor:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] })), V128:{ *:[v16i8] }:$Vn)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13835,
        GIR_EraseRootFromParent_Done,
      // Label 1256: @73271
      GIM_Try, /*On fail goto*//*Label 1257*/ GIMT_Encode4(73356), // Rule ID 13834 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Vm))  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Vn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13834,
        GIR_EraseRootFromParent_Done,
      // Label 1257: @73356
      GIM_Try, /*On fail goto*//*Label 1258*/ GIMT_Encode4(73441), // Rule ID 3807 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] })))  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Vn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3807,
        GIR_EraseRootFromParent_Done,
      // Label 1258: @73441
      GIM_Try, /*On fail goto*//*Label 1259*/ GIMT_Encode4(73476), // Rule ID 962 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllOnesV:{ *:[v16i8] })  =>  (NOTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 962,
        GIR_EraseRootFromParent_Done,
      // Label 1259: @73476
      GIM_Try, /*On fail goto*//*Label 1260*/ GIMT_Encode4(73533), // Rule ID 3803 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm), V128:{ *:[v16i8] }:$Va)  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
        GIR_RootToRootCopy, /*OpIdx*/2, // Va
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3803,
        GIR_EraseRootFromParent_Done,
      // Label 1260: @73533
      GIM_Try, /*On fail goto*//*Label 1261*/ GIMT_Encode4(73590), // Rule ID 13830 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm))  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
        GIR_RootToRootCopy, /*OpIdx*/1, // Va
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13830,
        GIR_EraseRootFromParent_Done,
      // Label 1261: @73590
      GIM_Try, /*On fail goto*//*Label 1262*/ GIMT_Encode4(73613), // Rule ID 1589 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (EORv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1589,
        GIR_Done,
      // Label 1262: @73613
      GIM_Reject,
    // Label 1254: @73614
    GIM_Reject,
    // Label 1176: @73615
    GIM_Try, /*On fail goto*//*Label 1263*/ GIMT_Encode4(73664), // Rule ID 8600 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
      // (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv1i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // Op1
      GIR_RootToRootCopy, /*OpIdx*/2, // Op2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8600,
      GIR_EraseRootFromParent_Done,
    // Label 1263: @73664
    GIM_Reject,
    // Label 1177: @73665
    GIM_Try, /*On fail goto*//*Label 1264*/ GIMT_Encode4(73714), // Rule ID 8599 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
      // (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv2i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // Op1
      GIR_RootToRootCopy, /*OpIdx*/2, // Op2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8599,
      GIR_EraseRootFromParent_Done,
    // Label 1264: @73714
    GIM_Reject,
    // Label 1178: @73715
    GIM_Try, /*On fail goto*//*Label 1265*/ GIMT_Encode4(74177),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1266*/ GIMT_Encode4(73801), // Rule ID 15692 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (xor:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15692,
        GIR_EraseRootFromParent_Done,
      // Label 1266: @73801
      GIM_Try, /*On fail goto*//*Label 1267*/ GIMT_Encode4(73872), // Rule ID 15691 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (xor:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15691,
        GIR_EraseRootFromParent_Done,
      // Label 1267: @73872
      GIM_Try, /*On fail goto*//*Label 1268*/ GIMT_Encode4(73943), // Rule ID 15690 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15690,
        GIR_EraseRootFromParent_Done,
      // Label 1268: @73943
      GIM_Try, /*On fail goto*//*Label 1269*/ GIMT_Encode4(74014), // Rule ID 12149 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })))  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12149,
        GIR_EraseRootFromParent_Done,
      // Label 1269: @74014
      GIM_Try, /*On fail goto*//*Label 1270*/ GIMT_Encode4(74075), // Rule ID 12173 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv2i64] } (AArch64bsp:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12173,
        GIR_EraseRootFromParent_Done,
      // Label 1270: @74075
      GIM_Try, /*On fail goto*//*Label 1271*/ GIMT_Encode4(74118), // Rule ID 13797 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
        GIR_RootToRootCopy, /*OpIdx*/2, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13797,
        GIR_EraseRootFromParent_Done,
      // Label 1271: @74118
      GIM_Try, /*On fail goto*//*Label 1272*/ GIMT_Encode4(74161), // Rule ID 3132 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3132,
        GIR_EraseRootFromParent_Done,
      // Label 1272: @74161
      GIM_Try, /*On fail goto*//*Label 1273*/ GIMT_Encode4(74176), // Rule ID 7596 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7596,
        GIR_Done,
      // Label 1273: @74176
      GIM_Reject,
    // Label 1265: @74177
    GIM_Reject,
    // Label 1179: @74178
    GIM_Try, /*On fail goto*//*Label 1274*/ GIMT_Encode4(74227), // Rule ID 8598 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
      // (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv4i1] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // Op1
      GIR_RootToRootCopy, /*OpIdx*/2, // Op2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8598,
      GIR_EraseRootFromParent_Done,
    // Label 1274: @74227
    GIM_Reject,
    // Label 1180: @74228
    GIM_Try, /*On fail goto*//*Label 1275*/ GIMT_Encode4(74690),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1276*/ GIMT_Encode4(74314), // Rule ID 15689 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (xor:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15689,
        GIR_EraseRootFromParent_Done,
      // Label 1276: @74314
      GIM_Try, /*On fail goto*//*Label 1277*/ GIMT_Encode4(74385), // Rule ID 15688 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (xor:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15688,
        GIR_EraseRootFromParent_Done,
      // Label 1277: @74385
      GIM_Try, /*On fail goto*//*Label 1278*/ GIMT_Encode4(74456), // Rule ID 15687 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15687,
        GIR_EraseRootFromParent_Done,
      // Label 1278: @74456
      GIM_Try, /*On fail goto*//*Label 1279*/ GIMT_Encode4(74527), // Rule ID 12147 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })))  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12147,
        GIR_EraseRootFromParent_Done,
      // Label 1279: @74527
      GIM_Try, /*On fail goto*//*Label 1280*/ GIMT_Encode4(74588), // Rule ID 12171 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv4i32] } (AArch64bsp:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12171,
        GIR_EraseRootFromParent_Done,
      // Label 1280: @74588
      GIM_Try, /*On fail goto*//*Label 1281*/ GIMT_Encode4(74631), // Rule ID 13796 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
        GIR_RootToRootCopy, /*OpIdx*/2, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13796,
        GIR_EraseRootFromParent_Done,
      // Label 1281: @74631
      GIM_Try, /*On fail goto*//*Label 1282*/ GIMT_Encode4(74674), // Rule ID 3130 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3130,
        GIR_EraseRootFromParent_Done,
      // Label 1282: @74674
      GIM_Try, /*On fail goto*//*Label 1283*/ GIMT_Encode4(74689), // Rule ID 7595 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7595,
        GIR_Done,
      // Label 1283: @74689
      GIM_Reject,
    // Label 1275: @74690
    GIM_Reject,
    // Label 1181: @74691
    GIM_Try, /*On fail goto*//*Label 1284*/ GIMT_Encode4(74740), // Rule ID 8597 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
      // (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv8i1] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // Op1
      GIR_RootToRootCopy, /*OpIdx*/2, // Op2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8597,
      GIR_EraseRootFromParent_Done,
    // Label 1284: @74740
    GIM_Reject,
    // Label 1182: @74741
    GIM_Try, /*On fail goto*//*Label 1285*/ GIMT_Encode4(75203),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1286*/ GIMT_Encode4(74827), // Rule ID 15686 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (xor:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15686,
        GIR_EraseRootFromParent_Done,
      // Label 1286: @74827
      GIM_Try, /*On fail goto*//*Label 1287*/ GIMT_Encode4(74898), // Rule ID 15685 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (xor:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15685,
        GIR_EraseRootFromParent_Done,
      // Label 1287: @74898
      GIM_Try, /*On fail goto*//*Label 1288*/ GIMT_Encode4(74969), // Rule ID 15684 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15684,
        GIR_EraseRootFromParent_Done,
      // Label 1288: @74969
      GIM_Try, /*On fail goto*//*Label 1289*/ GIMT_Encode4(75040), // Rule ID 12145 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })))  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12145,
        GIR_EraseRootFromParent_Done,
      // Label 1289: @75040
      GIM_Try, /*On fail goto*//*Label 1290*/ GIMT_Encode4(75101), // Rule ID 12169 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv8i16] } (AArch64bsp:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12169,
        GIR_EraseRootFromParent_Done,
      // Label 1290: @75101
      GIM_Try, /*On fail goto*//*Label 1291*/ GIMT_Encode4(75144), // Rule ID 13795 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
        GIR_RootToRootCopy, /*OpIdx*/2, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13795,
        GIR_EraseRootFromParent_Done,
      // Label 1291: @75144
      GIM_Try, /*On fail goto*//*Label 1292*/ GIMT_Encode4(75187), // Rule ID 3128 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3128,
        GIR_EraseRootFromParent_Done,
      // Label 1292: @75187
      GIM_Try, /*On fail goto*//*Label 1293*/ GIMT_Encode4(75202), // Rule ID 7594 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7594,
        GIR_Done,
      // Label 1293: @75202
      GIM_Reject,
    // Label 1285: @75203
    GIM_Reject,
    // Label 1183: @75204
    GIM_Try, /*On fail goto*//*Label 1294*/ GIMT_Encode4(75253), // Rule ID 8596 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
      // (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv16i1] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // Op1
      GIR_RootToRootCopy, /*OpIdx*/2, // Op2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8596,
      GIR_EraseRootFromParent_Done,
    // Label 1294: @75253
    GIM_Reject,
    // Label 1184: @75254
    GIM_Try, /*On fail goto*//*Label 1295*/ GIMT_Encode4(75716),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1296*/ GIMT_Encode4(75340), // Rule ID 15683 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (xor:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15683,
        GIR_EraseRootFromParent_Done,
      // Label 1296: @75340
      GIM_Try, /*On fail goto*//*Label 1297*/ GIMT_Encode4(75411), // Rule ID 15682 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (xor:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15682,
        GIR_EraseRootFromParent_Done,
      // Label 1297: @75411
      GIM_Try, /*On fail goto*//*Label 1298*/ GIMT_Encode4(75482), // Rule ID 15681 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15681,
        GIR_EraseRootFromParent_Done,
      // Label 1298: @75482
      GIM_Try, /*On fail goto*//*Label 1299*/ GIMT_Encode4(75553), // Rule ID 12143 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })))  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12143,
        GIR_EraseRootFromParent_Done,
      // Label 1299: @75553
      GIM_Try, /*On fail goto*//*Label 1300*/ GIMT_Encode4(75614), // Rule ID 12167 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[nxv16i8] } (AArch64bsp:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12167,
        GIR_EraseRootFromParent_Done,
      // Label 1300: @75614
      GIM_Try, /*On fail goto*//*Label 1301*/ GIMT_Encode4(75657), // Rule ID 13794 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
        GIR_RootToRootCopy, /*OpIdx*/2, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13794,
        GIR_EraseRootFromParent_Done,
      // Label 1301: @75657
      GIM_Try, /*On fail goto*//*Label 1302*/ GIMT_Encode4(75700), // Rule ID 3126 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3126,
        GIR_EraseRootFromParent_Done,
      // Label 1302: @75700
      GIM_Try, /*On fail goto*//*Label 1303*/ GIMT_Encode4(75715), // Rule ID 7593 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7593,
        GIR_Done,
      // Label 1303: @75715
      GIM_Reject,
    // Label 1295: @75716
    GIM_Reject,
    // Label 1185: @75717
    GIM_Reject,
    // Label 8: @75718
    GIM_Try, /*On fail goto*//*Label 1304*/ GIMT_Encode4(83158),
      GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
      GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(23), /*)*//*default:*//*Label 1316*/ GIMT_Encode4(83157),
      /*GILLT_v2s64*//*Label 1305*/ GIMT_Encode4(75805), GIMT_Encode4(0),
      /*GILLT_v4s32*//*Label 1306*/ GIMT_Encode4(76326), GIMT_Encode4(0),
      /*GILLT_v8s16*//*Label 1307*/ GIMT_Encode4(78609),
      /*GILLT_v16s8*//*Label 1308*/ GIMT_Encode4(81151), GIMT_Encode4(0),
      /*GILLT_nxv2s1*//*Label 1309*/ GIMT_Encode4(82933), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
      /*GILLT_nxv4s1*//*Label 1310*/ GIMT_Encode4(82959),
      /*GILLT_nxv4s16*//*Label 1311*/ GIMT_Encode4(82985),
      /*GILLT_nxv4s32*//*Label 1312*/ GIMT_Encode4(83032),
      /*GILLT_nxv8s1*//*Label 1313*/ GIMT_Encode4(83058),
      /*GILLT_nxv8s16*//*Label 1314*/ GIMT_Encode4(83084),
      /*GILLT_nxv16s1*//*Label 1315*/ GIMT_Encode4(83131),
      // Label 1305: @75805
      GIM_Try, /*On fail goto*//*Label 1317*/ GIMT_Encode4(76325),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_Try, /*On fail goto*//*Label 1318*/ GIMT_Encode4(75886), // Rule ID 5836 //
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
          GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v2i64] } V64:{ *:[v1i64] }:$Rn, immAllZerosV:{ *:[v1i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v1i64] }:$Rn), dsub:{ *:[i32] })
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
          GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          // GIR_Coverage, 5836,
          GIR_EraseRootFromParent_Done,
        // Label 1318: @75886
        GIM_Try, /*On fail goto*//*Label 1319*/ GIMT_Encode4(75948), // Rule ID 5840 //
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
          GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v2f64] } V64:{ *:[v1f64] }:$Rn, immAllZerosV:{ *:[v1f64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v1f64] }:$Rn), dsub:{ *:[i32] })
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
          GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          // GIR_Coverage, 5840,
          GIR_EraseRootFromParent_Done,
        // Label 1319: @75948
        GIM_Try, /*On fail goto*//*Label 1320*/ GIMT_Encode4(76006), // Rule ID 5837 //
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v2i64] } V64:{ *:[v1i64] }:$Rn, (undef:{ *:[v1i64] }))  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] })
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_RootToRootCopy, /*OpIdx*/1, // Rn
          GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          // GIR_Coverage, 5837,
          GIR_EraseRootFromParent_Done,
        // Label 1320: @76006
        GIM_Try, /*On fail goto*//*Label 1321*/ GIMT_Encode4(76064), // Rule ID 5841 //
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v2f64] } V64:{ *:[v1f64] }:$Rn, (undef:{ *:[v1f64] }))  =>  (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] })
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_RootToRootCopy, /*OpIdx*/1, // Rn
          GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          // GIR_Coverage, 5841,
          GIR_EraseRootFromParent_Done,
        // Label 1321: @76064
        GIM_Try, /*On fail goto*//*Label 1322*/ GIMT_Encode4(76194), // Rule ID 5835 //
          GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          // (concat_vectors:{ *:[v2i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v1i64] }:$Rn)  =>  (INSvi64lane:{ *:[v2i64] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1i64] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
          GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
          GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
          GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
          GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5835,
          GIR_EraseRootFromParent_Done,
        // Label 1322: @76194
        GIM_Try, /*On fail goto*//*Label 1323*/ GIMT_Encode4(76324), // Rule ID 5839 //
          GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          // (concat_vectors:{ *:[v2f64] } V64:{ *:[v1f64] }:$Rd, V64:{ *:[v1f64] }:$Rn)  =>  (INSvi64lane:{ *:[v2f64] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1f64] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
          GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
          GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
          GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
          GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5839,
          GIR_EraseRootFromParent_Done,
        // Label 1323: @76324
        GIM_Reject,
      // Label 1317: @76325
      GIM_Reject,
      // Label 1306: @76326
      GIM_Try, /*On fail goto*//*Label 1324*/ GIMT_Encode4(78608),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_Try, /*On fail goto*//*Label 1325*/ GIMT_Encode4(76463), // Rule ID 5456 //
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
          GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
          GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
          GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
          GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
          GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
          GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
          GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
          GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
          GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          // MIs[2] Operand 2
          GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
          GIM_CheckIsSafeToFold, /*NumInsns*/3,
          // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] })))  =>  (ADDHNv2i64_v4i32:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v4i32),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5456,
          GIR_EraseRootFromParent_Done,
        // Label 1325: @76463
        GIM_Try, /*On fail goto*//*Label 1326*/ GIMT_Encode4(76585), // Rule ID 5462 //
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
          GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
          GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
          GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
          GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
          GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
          GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
          GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
          GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
          GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          // MIs[2] Operand 2
          GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
          GIM_CheckIsSafeToFold, /*NumInsns*/3,
          // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] })))  =>  (SUBHNv2i64_v4i32:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v4i32),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5462,
          GIR_EraseRootFromParent_Done,
        // Label 1326: @76585
        GIM_Try, /*On fail goto*//*Label 1327*/ GIMT_Encode4(76687), // Rule ID 5623 //
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
          GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
          GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
          GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
          GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
          GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          // MIs[2] Operand 2
          GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
          GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
          GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
          GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
          GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
          GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_VLSHR),
          GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
          GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          // MIs[4] Operand 2
          GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(32),
          GIM_CheckIsSafeToFold, /*NumInsns*/4,
          // (concat_vectors:{ *:[v4i32] } (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, 32:{ *:[i32] })), (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vm, 32:{ *:[i32] })))  =>  (UZP2v4i32:{ *:[v4i32] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vn
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Vm
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5623,
          GIR_EraseRootFromParent_Done,
        // Label 1327: @76687
        GIM_Try, /*On fail goto*//*Label 1328*/ GIMT_Encode4(76816), // Rule ID 6389 //
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
          GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
          GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
          GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
          GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 32,
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Vd, (intrinsic_wo_chain:{ *:[v2i32] } 632:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, 32:{ *:[i32] }))  =>  (RADDHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Vd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Vn, (MOVIv2d_ns:{ *:[v2i64] } 0:{ *:[i32] }))
          GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
          GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
          GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
          GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v4i32),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 6389,
          GIR_EraseRootFromParent_Done,
        // Label 1328: @76816
        GIM_Try, /*On fail goto*//*Label 1329*/ GIMT_Encode4(76858), // Rule ID 5846 //
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
          // (concat_vectors:{ *:[v4i32] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (INSvi64lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v4i32] }:$Rn, 1:{ *:[i64] })
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
          GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5846,
          GIR_EraseRootFromParent_Done,
        // Label 1329: @76858
        GIM_Try, /*On fail goto*//*Label 1330*/ GIMT_Encode4(76900), // Rule ID 5850 //
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4f32),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4f32),
          // (concat_vectors:{ *:[v4f32] } (extract_high_v4f32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn), (extract_high_v4f32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm))  =>  (INSvi64lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] })
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
          GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5850,
          GIR_EraseRootFromParent_Done,
        // Label 1330: @76900
        GIM_Try, /*On fail goto*//*Label 1331*/ GIMT_Encode4(77023), // Rule ID 2537 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
          GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
          GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
          GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
          GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
          GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
          GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
          // MIs[2] Operand 1
          // No operand predicates
          GIM_CheckIsSafeToFold, /*NumInsns*/2,
          // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 632:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm))  =>  (RSHRNv4i32_shift:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv4i32_shift),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
          GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 2537,
          GIR_EraseRootFromParent_Done,
        // Label 1331: @77023
        GIM_Try, /*On fail goto*//*Label 1332*/ GIMT_Encode4(77146), // Rule ID 6357 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
          GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
          GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
          GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VASHR),
          GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
          GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          // MIs[2] imm
          GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
          GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
          GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
          // MIs[3] Operand 1
          // No operand predicates
          GIM_CheckIsSafeToFold, /*NumInsns*/3,
          // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)))  =>  (SHRNv4i32_shift:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i32_shift),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
          GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 6357,
          GIR_EraseRootFromParent_Done,
        // Label 1332: @77146
        GIM_Try, /*On fail goto*//*Label 1333*/ GIMT_Encode4(77266), // Rule ID 6395 //
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
          GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
          GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
          GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
          GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
          GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          // MIs[2] imm
          GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
          GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
          GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
          // MIs[3] Operand 1
          // No operand predicates
          GIM_CheckIsSafeToFold, /*NumInsns*/3,
          // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)))  =>  (SHRNv4i32_shift:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i32_shift),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
          GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 6395,
          GIR_EraseRootFromParent_Done,
        // Label 1333: @77266
        GIM_Try, /*On fail goto*//*Label 1334*/ GIMT_Encode4(77383), // Rule ID 2464 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
          GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
          GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
          GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
          GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 561:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (ADDHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v4i32),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 2464,
          GIR_EraseRootFromParent_Done,
        // Label 1334: @77383
        GIM_Try, /*On fail goto*//*Label 1335*/ GIMT_Encode4(77500), // Rule ID 5384 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
          GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
          GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
          GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
          GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 689:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (SUBHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v4i32),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5384,
          GIR_EraseRootFromParent_Done,
        // Label 1335: @77500
        GIM_Try, /*On fail goto*//*Label 1336*/ GIMT_Encode4(77617), // Rule ID 5387 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
          GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
          GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
          GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
          GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 631:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (RADDHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v4i32),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5387,
          GIR_EraseRootFromParent_Done,
        // Label 1336: @77617
        GIM_Try, /*On fail goto*//*Label 1337*/ GIMT_Encode4(77734), // Rule ID 5390 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
          GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
          GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
          GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
          GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 633:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (RSUBHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv2i64_v4i32),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5390,
          GIR_EraseRootFromParent_Done,
        // Label 1337: @77734
        GIM_Try, /*On fail goto*//*Label 1338*/ GIMT_Encode4(77838), // Rule ID 2460 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
          GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
          GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtxn),
          GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rd, (intrinsic_wo_chain:{ *:[v2f32] } 586:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn))  =>  (FCVTXNv4f32:{ *:[v4f32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rn)
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNv4f32),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 2460,
          GIR_EraseRootFromParent_Done,
        // Label 1338: @77838
        GIM_Try, /*On fail goto*//*Label 1339*/ GIMT_Encode4(77894), // Rule ID 5556 //
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
          GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
          GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
          GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
          GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckIsSafeToFold, /*NumInsns*/2,
          // (concat_vectors:{ *:[v4i32] } (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vn), (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vm))  =>  (UZP1v4i32:{ *:[v4i32] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5556,
          GIR_EraseRootFromParent_Done,
        // Label 1339: @77894
        GIM_Try, /*On fail goto*//*Label 1340*/ GIMT_Encode4(77960), // Rule ID 5844 //
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
          GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] })
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
          GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          // GIR_Coverage, 5844,
          GIR_EraseRootFromParent_Done,
        // Label 1340: @77960
        GIM_Try, /*On fail goto*//*Label 1341*/ GIMT_Encode4(78026), // Rule ID 5848 //
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
          GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rn, immAllZerosV:{ *:[v2f32] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v2f32] }:$Rn), dsub:{ *:[i32] })
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
          GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          // GIR_Coverage, 5848,
          GIR_EraseRootFromParent_Done,
        // Label 1341: @78026
        GIM_Try, /*On fail goto*//*Label 1342*/ GIMT_Encode4(78119), // Rule ID 4949 //
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
          GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rd, (fpround:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn))  =>  (FCVTNv4i32:{ *:[v4f32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rn)
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i32),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 4949,
          GIR_EraseRootFromParent_Done,
        // Label 1342: @78119
        GIM_Try, /*On fail goto*//*Label 1343*/ GIMT_Encode4(78215), // Rule ID 4996 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
          GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn))  =>  (XTNv4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn)
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv4i32),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 4996,
          GIR_EraseRootFromParent_Done,
        // Label 1343: @78215
        GIM_Try, /*On fail goto*//*Label 1344*/ GIMT_Encode4(78277), // Rule ID 5845 //
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rn, (undef:{ *:[v2i32] }))  =>  (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] })
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_RootToRootCopy, /*OpIdx*/1, // Rn
          GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          // GIR_Coverage, 5845,
          GIR_EraseRootFromParent_Done,
        // Label 1344: @78277
        GIM_Try, /*On fail goto*//*Label 1345*/ GIMT_Encode4(78339), // Rule ID 5849 //
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rn, (undef:{ *:[v2f32] }))  =>  (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] })
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_RootToRootCopy, /*OpIdx*/1, // Rn
          GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          // GIR_Coverage, 5849,
          GIR_EraseRootFromParent_Done,
        // Label 1345: @78339
        GIM_Try, /*On fail goto*//*Label 1346*/ GIMT_Encode4(78473), // Rule ID 5843 //
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)  =>  (INSvi64lane:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
          GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
          GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
          GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
          GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5843,
          GIR_EraseRootFromParent_Done,
        // Label 1346: @78473
        GIM_Try, /*On fail goto*//*Label 1347*/ GIMT_Encode4(78607), // Rule ID 5847 //
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn)  =>  (INSvi64lane:{ *:[v4f32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
          GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
          GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
          GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
          GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5847,
          GIR_EraseRootFromParent_Done,
        // Label 1347: @78607
        GIM_Reject,
      // Label 1324: @78608
      GIM_Reject,
      // Label 1307: @78609
      GIM_Try, /*On fail goto*//*Label 1348*/ GIMT_Encode4(81150),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_Try, /*On fail goto*//*Label 1349*/ GIMT_Encode4(78746), // Rule ID 5455 //
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
          GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
          GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
          GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
          GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
          GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
          GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
          GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
          GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
          GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          // MIs[2] Operand 2
          GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
          GIM_CheckIsSafeToFold, /*NumInsns*/3,
          // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] })))  =>  (ADDHNv4i32_v8i16:{ *:[v8i16] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v8i16),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5455,
          GIR_EraseRootFromParent_Done,
        // Label 1349: @78746
        GIM_Try, /*On fail goto*//*Label 1350*/ GIMT_Encode4(78868), // Rule ID 5461 //
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
          GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
          GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
          GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
          GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
          GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
          GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
          GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
          GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
          GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          // MIs[2] Operand 2
          GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
          GIM_CheckIsSafeToFold, /*NumInsns*/3,
          // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] })))  =>  (SUBHNv4i32_v8i16:{ *:[v8i16] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v8i16),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5461,
          GIR_EraseRootFromParent_Done,
        // Label 1350: @78868
        GIM_Try, /*On fail goto*//*Label 1351*/ GIMT_Encode4(78970), // Rule ID 5622 //
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
          GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
          GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
          GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
          GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
          GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          // MIs[2] Operand 2
          GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
          GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
          GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
          GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
          GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
          GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_VLSHR),
          GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
          GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          // MIs[4] Operand 2
          GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(16),
          GIM_CheckIsSafeToFold, /*NumInsns*/4,
          // (concat_vectors:{ *:[v8i16] } (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, 16:{ *:[i32] })), (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vm, 16:{ *:[i32] })))  =>  (UZP2v8i16:{ *:[v8i16] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vn
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Vm
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5622,
          GIR_EraseRootFromParent_Done,
        // Label 1351: @78970
        GIM_Try, /*On fail goto*//*Label 1352*/ GIMT_Encode4(79099), // Rule ID 6388 //
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
          GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
          GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
          GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
          GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 16,
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Vd, (intrinsic_wo_chain:{ *:[v4i16] } 632:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, 16:{ *:[i32] }))  =>  (RADDHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Vd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Vn, (MOVIv2d_ns:{ *:[v4i32] } 0:{ *:[i32] }))
          GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
          GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
          GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
          GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v8i16),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 6388,
          GIR_EraseRootFromParent_Done,
        // Label 1352: @79099
        GIM_Try, /*On fail goto*//*Label 1353*/ GIMT_Encode4(79141), // Rule ID 5854 //
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
          // (concat_vectors:{ *:[v8i16] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (INSvi64lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v8i16] }:$Rn, 1:{ *:[i64] })
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
          GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5854,
          GIR_EraseRootFromParent_Done,
        // Label 1353: @79141
        GIM_Try, /*On fail goto*//*Label 1354*/ GIMT_Encode4(79183), // Rule ID 5858 //
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8f16),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8f16),
          // (concat_vectors:{ *:[v8f16] } (extract_high_v8f16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn), (extract_high_v8f16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rm))  =>  (INSvi64lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] })
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
          GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5858,
          GIR_EraseRootFromParent_Done,
        // Label 1354: @79183
        GIM_Try, /*On fail goto*//*Label 1355*/ GIMT_Encode4(79306), // Rule ID 2535 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
          GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
          GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
          GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
          GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
          GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
          GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
          // MIs[2] Operand 1
          // No operand predicates
          GIM_CheckIsSafeToFold, /*NumInsns*/2,
          // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 632:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm))  =>  (RSHRNv8i16_shift:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv8i16_shift),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
          GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 2535,
          GIR_EraseRootFromParent_Done,
        // Label 1355: @79306
        GIM_Try, /*On fail goto*//*Label 1356*/ GIMT_Encode4(79429), // Rule ID 6356 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
          GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
          GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
          GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VASHR),
          GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
          GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          // MIs[2] imm
          GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
          GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
          GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
          // MIs[3] Operand 1
          // No operand predicates
          GIM_CheckIsSafeToFold, /*NumInsns*/3,
          // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)))  =>  (SHRNv8i16_shift:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i16_shift),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
          GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 6356,
          GIR_EraseRootFromParent_Done,
        // Label 1356: @79429
        GIM_Try, /*On fail goto*//*Label 1357*/ GIMT_Encode4(79549), // Rule ID 6394 //
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
          GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
          GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
          GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
          GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
          GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          // MIs[2] imm
          GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
          GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
          GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
          // MIs[3] Operand 1
          // No operand predicates
          GIM_CheckIsSafeToFold, /*NumInsns*/3,
          // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)))  =>  (SHRNv8i16_shift:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i16_shift),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
          GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 6394,
          GIR_EraseRootFromParent_Done,
        // Label 1357: @79549
        GIM_Try, /*On fail goto*//*Label 1358*/ GIMT_Encode4(79666), // Rule ID 2463 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
          GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
          GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
          GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
          GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 561:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (ADDHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v8i16),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 2463,
          GIR_EraseRootFromParent_Done,
        // Label 1358: @79666
        GIM_Try, /*On fail goto*//*Label 1359*/ GIMT_Encode4(79783), // Rule ID 5383 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
          GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
          GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
          GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
          GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 689:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (SUBHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v8i16),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5383,
          GIR_EraseRootFromParent_Done,
        // Label 1359: @79783
        GIM_Try, /*On fail goto*//*Label 1360*/ GIMT_Encode4(79900), // Rule ID 5386 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
          GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
          GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
          GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
          GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 631:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (RADDHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v8i16),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5386,
          GIR_EraseRootFromParent_Done,
        // Label 1360: @79900
        GIM_Try, /*On fail goto*//*Label 1361*/ GIMT_Encode4(80017), // Rule ID 5389 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
          GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
          GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
          GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
          GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 633:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (RSUBHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv4i32_v8i16),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5389,
          GIR_EraseRootFromParent_Done,
        // Label 1361: @80017
        GIM_Try, /*On fail goto*//*Label 1362*/ GIMT_Encode4(80118), // Rule ID 4943 //
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
          GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
          GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2hf),
          GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 739:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn))  =>  (FCVTNv8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rn)
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 4943,
          GIR_EraseRootFromParent_Done,
        // Label 1362: @80118
        GIM_Try, /*On fail goto*//*Label 1363*/ GIMT_Encode4(80174), // Rule ID 5547 //
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
          GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
          GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
          GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
          GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckIsSafeToFold, /*NumInsns*/2,
          // (concat_vectors:{ *:[v8i16] } (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vn), (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vm))  =>  (UZP1v8i16:{ *:[v8i16] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5547,
          GIR_EraseRootFromParent_Done,
        // Label 1363: @80174
        GIM_Try, /*On fail goto*//*Label 1364*/ GIMT_Encode4(80240), // Rule ID 5852 //
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
          GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v4i16] }:$Rn), dsub:{ *:[i32] })
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
          GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          // GIR_Coverage, 5852,
          GIR_EraseRootFromParent_Done,
        // Label 1364: @80240
        GIM_Try, /*On fail goto*//*Label 1365*/ GIMT_Encode4(80306), // Rule ID 5856 //
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
          GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rn, immAllZerosV:{ *:[v4f16] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v4f16] }:$Rn), dsub:{ *:[i32] })
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
          GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          // GIR_Coverage, 5856,
          GIR_EraseRootFromParent_Done,
        // Label 1365: @80306
        GIM_Try, /*On fail goto*//*Label 1366*/ GIMT_Encode4(80372), // Rule ID 5860 //
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
          GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v8bf16] } V64:{ *:[v4bf16] }:$Rn, immAllZerosV:{ *:[v4bf16] })  =>  (SUBREG_TO_REG:{ *:[v8bf16] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v4bf16] }:$Rn), dsub:{ *:[i32] })
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
          GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          // GIR_Coverage, 5860,
          GIR_EraseRootFromParent_Done,
        // Label 1366: @80372
        GIM_Try, /*On fail goto*//*Label 1367*/ GIMT_Encode4(80465), // Rule ID 4951 //
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
          GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rd, (fpround:{ *:[v4f16] } V128:{ *:[v4f32] }:$Rn))  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rn)
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 4951,
          GIR_EraseRootFromParent_Done,
        // Label 1367: @80465
        GIM_Try, /*On fail goto*//*Label 1368*/ GIMT_Encode4(80561), // Rule ID 4995 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
          GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn))  =>  (XTNv8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn)
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv8i16),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 4995,
          GIR_EraseRootFromParent_Done,
        // Label 1368: @80561
        GIM_Try, /*On fail goto*//*Label 1369*/ GIMT_Encode4(80623), // Rule ID 5853 //
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rn, (undef:{ *:[v4i16] }))  =>  (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] })
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_RootToRootCopy, /*OpIdx*/1, // Rn
          GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          // GIR_Coverage, 5853,
          GIR_EraseRootFromParent_Done,
        // Label 1369: @80623
        GIM_Try, /*On fail goto*//*Label 1370*/ GIMT_Encode4(80685), // Rule ID 5857 //
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rn, (undef:{ *:[v4f16] }))  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] })
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_RootToRootCopy, /*OpIdx*/1, // Rn
          GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          // GIR_Coverage, 5857,
          GIR_EraseRootFromParent_Done,
        // Label 1370: @80685
        GIM_Try, /*On fail goto*//*Label 1371*/ GIMT_Encode4(80747), // Rule ID 5861 //
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v8bf16] } V64:{ *:[v4bf16] }:$Rn, (undef:{ *:[v4bf16] }))  =>  (INSERT_SUBREG:{ *:[v8bf16] } (IMPLICIT_DEF:{ *:[v8bf16] }), V64:{ *:[v4bf16] }:$Rn, dsub:{ *:[i32] })
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_RootToRootCopy, /*OpIdx*/1, // Rn
          GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          // GIR_Coverage, 5861,
          GIR_EraseRootFromParent_Done,
        // Label 1371: @80747
        GIM_Try, /*On fail goto*//*Label 1372*/ GIMT_Encode4(80881), // Rule ID 5851 //
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)  =>  (INSvi64lane:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
          GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
          GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
          GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
          GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5851,
          GIR_EraseRootFromParent_Done,
        // Label 1372: @80881
        GIM_Try, /*On fail goto*//*Label 1373*/ GIMT_Encode4(81015), // Rule ID 5855 //
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn)  =>  (INSvi64lane:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
          GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
          GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
          GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
          GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5855,
          GIR_EraseRootFromParent_Done,
        // Label 1373: @81015
        GIM_Try, /*On fail goto*//*Label 1374*/ GIMT_Encode4(81149), // Rule ID 5859 //
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          // (concat_vectors:{ *:[v8bf16] } V64:{ *:[v4bf16] }:$Rd, V64:{ *:[v4bf16] }:$Rn)  =>  (INSvi64lane:{ *:[v8bf16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4bf16] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4bf16] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
          GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
          GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
          GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
          GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5859,
          GIR_EraseRootFromParent_Done,
        // Label 1374: @81149
        GIM_Reject,
      // Label 1348: @81150
      GIM_Reject,
      // Label 1308: @81151
      GIM_Try, /*On fail goto*//*Label 1375*/ GIMT_Encode4(82932),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_Try, /*On fail goto*//*Label 1376*/ GIMT_Encode4(81288), // Rule ID 5454 //
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
          GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
          GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
          GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
          GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
          GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
          GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
          GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
          GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
          GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          // MIs[2] Operand 2
          GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
          GIM_CheckIsSafeToFold, /*NumInsns*/3,
          // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] })))  =>  (ADDHNv8i16_v16i8:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v16i8),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5454,
          GIR_EraseRootFromParent_Done,
        // Label 1376: @81288
        GIM_Try, /*On fail goto*//*Label 1377*/ GIMT_Encode4(81410), // Rule ID 5460 //
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
          GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
          GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
          GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
          GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
          GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
          GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
          GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
          GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
          GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          // MIs[2] Operand 2
          GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
          GIM_CheckIsSafeToFold, /*NumInsns*/3,
          // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] })))  =>  (SUBHNv8i16_v16i8:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v16i8),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5460,
          GIR_EraseRootFromParent_Done,
        // Label 1377: @81410
        GIM_Try, /*On fail goto*//*Label 1378*/ GIMT_Encode4(81512), // Rule ID 5621 //
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
          GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
          GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
          GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
          GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
          GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          // MIs[2] Operand 2
          GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
          GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
          GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
          GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
          GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
          GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_VLSHR),
          GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
          GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          // MIs[4] Operand 2
          GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(8),
          GIM_CheckIsSafeToFold, /*NumInsns*/4,
          // (concat_vectors:{ *:[v16i8] } (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, 8:{ *:[i32] })), (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vm, 8:{ *:[i32] })))  =>  (UZP2v16i8:{ *:[v16i8] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vn
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Vm
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5621,
          GIR_EraseRootFromParent_Done,
        // Label 1378: @81512
        GIM_Try, /*On fail goto*//*Label 1379*/ GIMT_Encode4(81641), // Rule ID 6387 //
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
          GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
          GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
          GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
          GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 8,
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Vd, (intrinsic_wo_chain:{ *:[v8i8] } 632:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vn, 8:{ *:[i32] }))  =>  (RADDHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Vd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Vn, (MOVIv2d_ns:{ *:[v8i16] } 0:{ *:[i32] }))
          GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
          GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
          GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
          GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v16i8),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 6387,
          GIR_EraseRootFromParent_Done,
        // Label 1379: @81641
        GIM_Try, /*On fail goto*//*Label 1380*/ GIMT_Encode4(81683), // Rule ID 5866 //
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
          // (concat_vectors:{ *:[v16i8] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))  =>  (INSvi64lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v16i8] }:$Rn, 1:{ *:[i64] })
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
          GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5866,
          GIR_EraseRootFromParent_Done,
        // Label 1380: @81683
        GIM_Try, /*On fail goto*//*Label 1381*/ GIMT_Encode4(81806), // Rule ID 2533 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
          GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
          GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
          GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
          GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
          GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
          GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
          // MIs[2] Operand 1
          // No operand predicates
          GIM_CheckIsSafeToFold, /*NumInsns*/2,
          // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 632:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm))  =>  (RSHRNv16i8_shift:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv16i8_shift),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
          GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 2533,
          GIR_EraseRootFromParent_Done,
        // Label 1381: @81806
        GIM_Try, /*On fail goto*//*Label 1382*/ GIMT_Encode4(81929), // Rule ID 6355 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
          GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
          GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
          GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VASHR),
          GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
          GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          // MIs[2] imm
          GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
          GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
          GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
          // MIs[3] Operand 1
          // No operand predicates
          GIM_CheckIsSafeToFold, /*NumInsns*/3,
          // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)))  =>  (SHRNv16i8_shift:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv16i8_shift),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
          GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 6355,
          GIR_EraseRootFromParent_Done,
        // Label 1382: @81929
        GIM_Try, /*On fail goto*//*Label 1383*/ GIMT_Encode4(82049), // Rule ID 6393 //
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
          GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
          GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
          GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
          GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
          GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          // MIs[2] imm
          GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
          GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
          GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
          // MIs[3] Operand 1
          // No operand predicates
          GIM_CheckIsSafeToFold, /*NumInsns*/3,
          // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)))  =>  (SHRNv16i8_shift:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv16i8_shift),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
          GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 6393,
          GIR_EraseRootFromParent_Done,
        // Label 1383: @82049
        GIM_Try, /*On fail goto*//*Label 1384*/ GIMT_Encode4(82166), // Rule ID 2462 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
          GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
          GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
          GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
          GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 561:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (ADDHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v16i8),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 2462,
          GIR_EraseRootFromParent_Done,
        // Label 1384: @82166
        GIM_Try, /*On fail goto*//*Label 1385*/ GIMT_Encode4(82283), // Rule ID 5382 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
          GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
          GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
          GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
          GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 689:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (SUBHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v16i8),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5382,
          GIR_EraseRootFromParent_Done,
        // Label 1385: @82283
        GIM_Try, /*On fail goto*//*Label 1386*/ GIMT_Encode4(82400), // Rule ID 5385 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
          GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
          GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
          GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
          GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 631:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (RADDHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v16i8),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5385,
          GIR_EraseRootFromParent_Done,
        // Label 1386: @82400
        GIM_Try, /*On fail goto*//*Label 1387*/ GIMT_Encode4(82517), // Rule ID 5388 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
          GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
          GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
          GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
          GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 633:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (RSUBHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv8i16_v16i8),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5388,
          GIR_EraseRootFromParent_Done,
        // Label 1387: @82517
        GIM_Try, /*On fail goto*//*Label 1388*/ GIMT_Encode4(82573), // Rule ID 5538 //
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
          GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
          GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
          GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
          GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckIsSafeToFold, /*NumInsns*/2,
          // (concat_vectors:{ *:[v16i8] } (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Vn), (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Vm))  =>  (UZP1v16i8:{ *:[v16i8] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v16i8),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5538,
          GIR_EraseRootFromParent_Done,
        // Label 1388: @82573
        GIM_Try, /*On fail goto*//*Label 1389*/ GIMT_Encode4(82639), // Rule ID 5864 //
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
          GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v8i8] }:$Rn), dsub:{ *:[i32] })
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
          GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          // GIR_Coverage, 5864,
          GIR_EraseRootFromParent_Done,
        // Label 1389: @82639
        GIM_Try, /*On fail goto*//*Label 1390*/ GIMT_Encode4(82735), // Rule ID 4994 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
          GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
          GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn))  =>  (XTNv16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn)
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv16i8),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 4994,
          GIR_EraseRootFromParent_Done,
        // Label 1390: @82735
        GIM_Try, /*On fail goto*//*Label 1391*/ GIMT_Encode4(82797), // Rule ID 5865 //
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rn, (undef:{ *:[v8i8] }))  =>  (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] })
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_RootToRootCopy, /*OpIdx*/1, // Rn
          GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          // GIR_Coverage, 5865,
          GIR_EraseRootFromParent_Done,
        // Label 1391: @82797
        GIM_Try, /*On fail goto*//*Label 1392*/ GIMT_Encode4(82931), // Rule ID 5863 //
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
          // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)  =>  (INSvi64lane:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
          GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
          GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
          GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
          GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
          GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5863,
          GIR_EraseRootFromParent_Done,
        // Label 1392: @82931
        GIM_Reject,
      // Label 1375: @82932
      GIM_Reject,
      // Label 1309: @82933
      GIM_Try, /*On fail goto*//*Label 1393*/ GIMT_Encode4(82958), // Rule ID 9277 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (concat_vectors:{ *:[nxv2i1] } nxv1i1:{ *:[nxv1i1] }:$p1, nxv1i1:{ *:[nxv1i1] }:$p2)  =>  (UZP1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv1i1] }:$p1, ?:{ *:[nxv1i1] }:$p2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9277,
        GIR_Done,
      // Label 1393: @82958
      GIM_Reject,
      // Label 1310: @82959
      GIM_Try, /*On fail goto*//*Label 1394*/ GIMT_Encode4(82984), // Rule ID 9278 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (concat_vectors:{ *:[nxv4i1] } nxv2i1:{ *:[nxv2i1] }:$p1, nxv2i1:{ *:[nxv2i1] }:$p2)  =>  (UZP1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv2i1] }:$p1, ?:{ *:[nxv2i1] }:$p2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_S),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9278,
        GIR_Done,
      // Label 1394: @82984
      GIM_Reject,
      // Label 1311: @82985
      GIM_Try, /*On fail goto*//*Label 1395*/ GIMT_Encode4(83031),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_Try, /*On fail goto*//*Label 1396*/ GIMT_Encode4(83015), // Rule ID 9281 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
          // (concat_vectors:{ *:[nxv4f16] } nxv2f16:{ *:[nxv2f16] }:$v1, nxv2f16:{ *:[nxv2f16] }:$v2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv2f16] }:$v1, ?:{ *:[nxv2f16] }:$v2)
          GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 9281,
          GIR_Done,
        // Label 1396: @83015
        GIM_Try, /*On fail goto*//*Label 1397*/ GIMT_Encode4(83030), // Rule ID 9284 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
          // (concat_vectors:{ *:[nxv4bf16] } nxv2bf16:{ *:[nxv2bf16] }:$v1, nxv2bf16:{ *:[nxv2bf16] }:$v2)  =>  (UZP1_ZZZ_S:{ *:[nxv4bf16] } ?:{ *:[nxv2bf16] }:$v1, ?:{ *:[nxv2bf16] }:$v2)
          GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 9284,
          GIR_Done,
        // Label 1397: @83030
        GIM_Reject,
      // Label 1395: @83031
      GIM_Reject,
      // Label 1312: @83032
      GIM_Try, /*On fail goto*//*Label 1398*/ GIMT_Encode4(83057), // Rule ID 9283 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (concat_vectors:{ *:[nxv4f32] } nxv2f32:{ *:[nxv2f32] }:$v1, nxv2f32:{ *:[nxv2f32] }:$v2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv2f32] }:$v1, ?:{ *:[nxv2f32] }:$v2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9283,
        GIR_Done,
      // Label 1398: @83057
      GIM_Reject,
      // Label 1313: @83058
      GIM_Try, /*On fail goto*//*Label 1399*/ GIMT_Encode4(83083), // Rule ID 9279 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (concat_vectors:{ *:[nxv8i1] } nxv4i1:{ *:[nxv4i1] }:$p1, nxv4i1:{ *:[nxv4i1] }:$p2)  =>  (UZP1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv4i1] }:$p1, ?:{ *:[nxv4i1] }:$p2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9279,
        GIR_Done,
      // Label 1399: @83083
      GIM_Reject,
      // Label 1314: @83084
      GIM_Try, /*On fail goto*//*Label 1400*/ GIMT_Encode4(83130),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_Try, /*On fail goto*//*Label 1401*/ GIMT_Encode4(83114), // Rule ID 9282 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
          // (concat_vectors:{ *:[nxv8f16] } nxv4f16:{ *:[nxv4f16] }:$v1, nxv4f16:{ *:[nxv4f16] }:$v2)  =>  (UZP1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv4f16] }:$v1, ?:{ *:[nxv4f16] }:$v2)
          GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 9282,
          GIR_Done,
        // Label 1401: @83114
        GIM_Try, /*On fail goto*//*Label 1402*/ GIMT_Encode4(83129), // Rule ID 9285 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
          // (concat_vectors:{ *:[nxv8bf16] } nxv4bf16:{ *:[nxv4bf16] }:$v1, nxv4bf16:{ *:[nxv4bf16] }:$v2)  =>  (UZP1_ZZZ_H:{ *:[nxv8bf16] } ?:{ *:[nxv4bf16] }:$v1, ?:{ *:[nxv4bf16] }:$v2)
          GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 9285,
          GIR_Done,
        // Label 1402: @83129
        GIM_Reject,
      // Label 1400: @83130
      GIM_Reject,
      // Label 1315: @83131
      GIM_Try, /*On fail goto*//*Label 1403*/ GIMT_Encode4(83156), // Rule ID 9280 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (concat_vectors:{ *:[nxv16i1] } nxv8i1:{ *:[nxv8i1] }:$p1, nxv8i1:{ *:[nxv8i1] }:$p2)  =>  (UZP1_PPP_B:{ *:[nxv16i1] } ?:{ *:[nxv8i1] }:$p1, ?:{ *:[nxv8i1] }:$p2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9280,
        GIR_Done,
      // Label 1403: @83156
      GIM_Reject,
      // Label 1316: @83157
      GIM_Reject,
    // Label 1304: @83158
    GIM_Reject,
    // Label 9: @83159
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(24), /*)*//*default:*//*Label 1421*/ GIMT_Encode4(95614),
    /*GILLT_s16*//*Label 1404*/ GIMT_Encode4(83262),
    /*GILLT_s32*//*Label 1405*/ GIMT_Encode4(83316),
    /*GILLT_s64*//*Label 1406*/ GIMT_Encode4(83697),
    /*GILLT_s128*//*Label 1407*/ GIMT_Encode4(85926),
    /*GILLT_v2s32*//*Label 1408*/ GIMT_Encode4(86675),
    /*GILLT_v2s64*//*Label 1409*/ GIMT_Encode4(87706),
    /*GILLT_v4s16*//*Label 1410*/ GIMT_Encode4(88591),
    /*GILLT_v4s32*//*Label 1411*/ GIMT_Encode4(89992),
    /*GILLT_v8s8*//*Label 1412*/ GIMT_Encode4(90953),
    /*GILLT_v8s16*//*Label 1413*/ GIMT_Encode4(91572),
    /*GILLT_v16s8*//*Label 1414*/ GIMT_Encode4(92868), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s16*//*Label 1415*/ GIMT_Encode4(93378), GIMT_Encode4(0),
    /*GILLT_nxv2s64*//*Label 1416*/ GIMT_Encode4(93438), GIMT_Encode4(0),
    /*GILLT_nxv4s16*//*Label 1417*/ GIMT_Encode4(93951),
    /*GILLT_nxv4s32*//*Label 1418*/ GIMT_Encode4(94011), GIMT_Encode4(0),
    /*GILLT_nxv8s16*//*Label 1419*/ GIMT_Encode4(94524), GIMT_Encode4(0),
    /*GILLT_nxv16s8*//*Label 1420*/ GIMT_Encode4(95389),
    // Label 1404: @83262
    GIM_Try, /*On fail goto*//*Label 1422*/ GIMT_Encode4(83315),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_Try, /*On fail goto*//*Label 1423*/ GIMT_Encode4(83296), // Rule ID 6778 //
        // (bitconvert:{ *:[f16] } FPR16:{ *:[bf16] }:$src)  =>  FPR16:{ *:[f16] }:$src
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // dst
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 6778,
        GIR_EraseRootFromParent_Done,
      // Label 1423: @83296
      GIM_Try, /*On fail goto*//*Label 1424*/ GIMT_Encode4(83314), // Rule ID 6779 //
        // (bitconvert:{ *:[bf16] } FPR16:{ *:[f16] }:$src)  =>  FPR16:{ *:[bf16] }:$src
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // dst
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 6779,
        GIR_EraseRootFromParent_Done,
      // Label 1424: @83314
      GIM_Reject,
    // Label 1422: @83315
    GIM_Reject,
    // Label 1405: @83316
    GIM_Try, /*On fail goto*//*Label 1425*/ GIMT_Encode4(83696),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 1426*/ GIMT_Encode4(83394), // Rule ID 7251 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
        // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15338>>)  =>  (LDRSroW:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7251,
        GIR_EraseRootFromParent_Done,
      // Label 1426: @83394
      GIM_Try, /*On fail goto*//*Label 1427*/ GIMT_Encode4(83464), // Rule ID 7252 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
        // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15338>>)  =>  (LDRSroX:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7252,
        GIR_EraseRootFromParent_Done,
      // Label 1427: @83464
      GIM_Try, /*On fail goto*//*Label 1428*/ GIMT_Encode4(83529), // Rule ID 7253 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
        // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15338>>)  =>  (LDRSui:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7253,
        GIR_EraseRootFromParent_Done,
      // Label 1428: @83529
      GIM_Try, /*On fail goto*//*Label 1429*/ GIMT_Encode4(83594), // Rule ID 7254 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
        // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15338>>)  =>  (LDURSi:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7254,
        GIR_EraseRootFromParent_Done,
      // Label 1429: @83594
      GIM_Try, /*On fail goto*//*Label 1430*/ GIMT_Encode4(83647), // Rule ID 5824 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (bitconvert:{ *:[f32] } (vector_extract:{ *:[i32] } v4i32:{ *:[v4i32] }:$src, 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4i32] }:$src, ssub:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // src
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5824,
        GIR_EraseRootFromParent_Done,
      // Label 1430: @83647
      GIM_Try, /*On fail goto*//*Label 1431*/ GIMT_Encode4(83671), // Rule ID 6773 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (bitconvert:{ *:[f32] } GPR32:{ *:[i32] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Xn, FPR32:{ *:[i32] })
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 6773,
        GIR_Done,
      // Label 1431: @83671
      GIM_Try, /*On fail goto*//*Label 1432*/ GIMT_Encode4(83695), // Rule ID 6774 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[i32] } FPR32:{ *:[f32] }:$Xn, GPR32:{ *:[i32] })
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        // GIR_Coverage, 6774,
        GIR_Done,
      // Label 1432: @83695
      GIM_Reject,
    // Label 1425: @83696
    GIM_Reject,
    // Label 1406: @83697
    GIM_Try, /*On fail goto*//*Label 1433*/ GIMT_Encode4(83770), // Rule ID 7255 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
      // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15346>>)  =>  (LDRDroW:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7255,
      GIR_EraseRootFromParent_Done,
    // Label 1433: @83770
    GIM_Try, /*On fail goto*//*Label 1434*/ GIMT_Encode4(83843), // Rule ID 7256 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
      // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15346>>)  =>  (LDRDroX:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7256,
      GIR_EraseRootFromParent_Done,
    // Label 1434: @83843
    GIM_Try, /*On fail goto*//*Label 1435*/ GIMT_Encode4(83911), // Rule ID 7257 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
      // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15346>>)  =>  (LDRDui:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7257,
      GIR_EraseRootFromParent_Done,
    // Label 1435: @83911
    GIM_Try, /*On fail goto*//*Label 1436*/ GIMT_Encode4(83979), // Rule ID 7258 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
      // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15346>>)  =>  (LDURDi:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7258,
      GIR_EraseRootFromParent_Done,
    // Label 1436: @83979
    GIM_Try, /*On fail goto*//*Label 1437*/ GIMT_Encode4(84035), // Rule ID 5826 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (bitconvert:{ *:[f64] } (vector_extract:{ *:[i64] } v2i64:{ *:[v2i64] }:$src, 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2i64] }:$src, dsub:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 5826,
      GIR_EraseRootFromParent_Done,
    // Label 1437: @84035
    GIM_Try, /*On fail goto*//*Label 1438*/ GIMT_Encode4(84065), // Rule ID 6745 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[i64] } V64:{ *:[v8i8] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v8i8] }:$Vn, GPR64:{ *:[i32] })
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
      // GIR_Coverage, 6745,
      GIR_Done,
    // Label 1438: @84065
    GIM_Try, /*On fail goto*//*Label 1439*/ GIMT_Encode4(84095), // Rule ID 6746 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[i64] } V64:{ *:[v4i16] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4i16] }:$Vn, GPR64:{ *:[i32] })
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
      // GIR_Coverage, 6746,
      GIR_Done,
    // Label 1439: @84095
    GIM_Try, /*On fail goto*//*Label 1440*/ GIMT_Encode4(84125), // Rule ID 6747 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[i64] } V64:{ *:[v2i32] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2i32] }:$Vn, GPR64:{ *:[i32] })
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
      // GIR_Coverage, 6747,
      GIR_Done,
    // Label 1440: @84125
    GIM_Try, /*On fail goto*//*Label 1441*/ GIMT_Encode4(84155), // Rule ID 6748 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[i64] } V64:{ *:[v4f16] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4f16] }:$Vn, GPR64:{ *:[i32] })
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
      // GIR_Coverage, 6748,
      GIR_Done,
    // Label 1441: @84155
    GIM_Try, /*On fail goto*//*Label 1442*/ GIMT_Encode4(84185), // Rule ID 6749 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[i64] } V64:{ *:[v4bf16] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4bf16] }:$Vn, GPR64:{ *:[i32] })
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
      // GIR_Coverage, 6749,
      GIR_Done,
    // Label 1442: @84185
    GIM_Try, /*On fail goto*//*Label 1443*/ GIMT_Encode4(84215), // Rule ID 6750 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[i64] } V64:{ *:[v2f32] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2f32] }:$Vn, GPR64:{ *:[i32] })
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
      // GIR_Coverage, 6750,
      GIR_Done,
    // Label 1443: @84215
    GIM_Try, /*On fail goto*//*Label 1444*/ GIMT_Encode4(84245), // Rule ID 6751 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[i64] } V64:{ *:[v1f64] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v1f64] }:$Vn, GPR64:{ *:[i32] })
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
      // GIR_Coverage, 6751,
      GIR_Done,
    // Label 1444: @84245
    GIM_Try, /*On fail goto*//*Label 1445*/ GIMT_Encode4(84295), // Rule ID 6758 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[i64] } V64:{ *:[v8i8] }:$Vn)  =>  (REV64v8i8:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v8i8] }:$Vn, GPR64:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6758,
      GIR_EraseRootFromParent_Done,
    // Label 1445: @84295
    GIM_Try, /*On fail goto*//*Label 1446*/ GIMT_Encode4(84345), // Rule ID 6759 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[i64] } V64:{ *:[v4i16] }:$Vn)  =>  (REV64v4i16:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4i16] }:$Vn, GPR64:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6759,
      GIR_EraseRootFromParent_Done,
    // Label 1446: @84345
    GIM_Try, /*On fail goto*//*Label 1447*/ GIMT_Encode4(84395), // Rule ID 6760 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[i64] } V64:{ *:[v2i32] }:$Vn)  =>  (REV64v2i32:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2i32] }:$Vn, GPR64:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6760,
      GIR_EraseRootFromParent_Done,
    // Label 1447: @84395
    GIM_Try, /*On fail goto*//*Label 1448*/ GIMT_Encode4(84445), // Rule ID 6761 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[i64] } V64:{ *:[v4f16] }:$Vn)  =>  (REV64v4i16:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4f16] }:$Vn, GPR64:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6761,
      GIR_EraseRootFromParent_Done,
    // Label 1448: @84445
    GIM_Try, /*On fail goto*//*Label 1449*/ GIMT_Encode4(84495), // Rule ID 6762 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[i64] } V64:{ *:[v4bf16] }:$Vn)  =>  (REV64v4i16:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4bf16] }:$Vn, GPR64:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6762,
      GIR_EraseRootFromParent_Done,
    // Label 1449: @84495
    GIM_Try, /*On fail goto*//*Label 1450*/ GIMT_Encode4(84545), // Rule ID 6763 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[i64] } V64:{ *:[v2f32] }:$Vn)  =>  (REV64v2i32:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2f32] }:$Vn, GPR64:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6763,
      GIR_EraseRootFromParent_Done,
    // Label 1450: @84545
    GIM_Try, /*On fail goto*//*Label 1451*/ GIMT_Encode4(84572), // Rule ID 6764 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (bitconvert:{ *:[v1i64] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v1i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6764,
      GIR_Done,
    // Label 1451: @84572
    GIM_Try, /*On fail goto*//*Label 1452*/ GIMT_Encode4(84599), // Rule ID 6765 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (bitconvert:{ *:[v1f64] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v1f64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6765,
      GIR_Done,
    // Label 1452: @84599
    GIM_Try, /*On fail goto*//*Label 1453*/ GIMT_Encode4(84626), // Rule ID 6766 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[i64] } V64:{ *:[v1i64] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v1i64] }:$Vn, GPR64:{ *:[i32] })
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
      // GIR_Coverage, 6766,
      GIR_Done,
    // Label 1453: @84626
    GIM_Try, /*On fail goto*//*Label 1454*/ GIMT_Encode4(84653), // Rule ID 6775 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (bitconvert:{ *:[f64] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[f64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6775,
      GIR_Done,
    // Label 1454: @84653
    GIM_Try, /*On fail goto*//*Label 1455*/ GIMT_Encode4(84680), // Rule ID 6776 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[i64] } FPR64:{ *:[f64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } FPR64:{ *:[f64] }:$Xn, GPR64:{ *:[i32] })
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
      // GIR_Coverage, 6776,
      GIR_Done,
    // Label 1455: @84680
    GIM_Try, /*On fail goto*//*Label 1456*/ GIMT_Encode4(84707), // Rule ID 6777 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[i64] } V64:{ *:[v1f64] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v1f64] }:$Vn, GPR64:{ *:[i32] })
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
      // GIR_Coverage, 6777,
      GIR_Done,
    // Label 1456: @84707
    GIM_Try, /*On fail goto*//*Label 1457*/ GIMT_Encode4(84739), // Rule ID 6780 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6780,
      GIR_EraseRootFromParent_Done,
    // Label 1457: @84739
    GIM_Try, /*On fail goto*//*Label 1458*/ GIMT_Encode4(84771), // Rule ID 6781 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6781,
      GIR_EraseRootFromParent_Done,
    // Label 1458: @84771
    GIM_Try, /*On fail goto*//*Label 1459*/ GIMT_Encode4(84803), // Rule ID 6782 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6782,
      GIR_EraseRootFromParent_Done,
    // Label 1459: @84803
    GIM_Try, /*On fail goto*//*Label 1460*/ GIMT_Encode4(84835), // Rule ID 6783 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6783,
      GIR_EraseRootFromParent_Done,
    // Label 1460: @84835
    GIM_Try, /*On fail goto*//*Label 1461*/ GIMT_Encode4(84867), // Rule ID 6784 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4bf16] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6784,
      GIR_EraseRootFromParent_Done,
    // Label 1461: @84867
    GIM_Try, /*On fail goto*//*Label 1462*/ GIMT_Encode4(84899), // Rule ID 6785 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6785,
      GIR_EraseRootFromParent_Done,
    // Label 1462: @84899
    GIM_Try, /*On fail goto*//*Label 1463*/ GIMT_Encode4(84925), // Rule ID 6786 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2i32] }:$src)  =>  (REV64v2i32:{ *:[v1i64] } FPR64:{ *:[v2i32] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6786,
      GIR_Done,
    // Label 1463: @84925
    GIM_Try, /*On fail goto*//*Label 1464*/ GIMT_Encode4(84951), // Rule ID 6787 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4i16] }:$src)  =>  (REV64v4i16:{ *:[v1i64] } FPR64:{ *:[v4i16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6787,
      GIR_Done,
    // Label 1464: @84951
    GIM_Try, /*On fail goto*//*Label 1465*/ GIMT_Encode4(84977), // Rule ID 6788 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v8i8] }:$src)  =>  (REV64v8i8:{ *:[v1i64] } FPR64:{ *:[v8i8] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6788,
      GIR_Done,
    // Label 1465: @84977
    GIM_Try, /*On fail goto*//*Label 1466*/ GIMT_Encode4(85003), // Rule ID 6789 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4f16] }:$src)  =>  (REV64v4i16:{ *:[v1i64] } FPR64:{ *:[v4f16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6789,
      GIR_Done,
    // Label 1466: @85003
    GIM_Try, /*On fail goto*//*Label 1467*/ GIMT_Encode4(85029), // Rule ID 6790 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4bf16] }:$src)  =>  (REV64v4i16:{ *:[v1i64] } FPR64:{ *:[v4bf16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6790,
      GIR_Done,
    // Label 1467: @85029
    GIM_Try, /*On fail goto*//*Label 1468*/ GIMT_Encode4(85055), // Rule ID 6791 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2f32] }:$src)  =>  (REV64v2i32:{ *:[v1i64] } FPR64:{ *:[v2f32] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6791,
      GIR_Done,
    // Label 1468: @85055
    GIM_Try, /*On fail goto*//*Label 1469*/ GIMT_Encode4(85084), // Rule ID 6792 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6792,
      GIR_EraseRootFromParent_Done,
    // Label 1469: @85084
    GIM_Try, /*On fail goto*//*Label 1470*/ GIMT_Encode4(85113), // Rule ID 6793 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v1i64] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6793,
      GIR_EraseRootFromParent_Done,
    // Label 1470: @85113
    GIM_Try, /*On fail goto*//*Label 1471*/ GIMT_Encode4(85145), // Rule ID 6865 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[f64] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[f64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6865,
      GIR_EraseRootFromParent_Done,
    // Label 1471: @85145
    GIM_Try, /*On fail goto*//*Label 1472*/ GIMT_Encode4(85177), // Rule ID 6866 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[f64] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[f64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6866,
      GIR_EraseRootFromParent_Done,
    // Label 1472: @85177
    GIM_Try, /*On fail goto*//*Label 1473*/ GIMT_Encode4(85209), // Rule ID 6867 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[f64] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[f64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6867,
      GIR_EraseRootFromParent_Done,
    // Label 1473: @85209
    GIM_Try, /*On fail goto*//*Label 1474*/ GIMT_Encode4(85241), // Rule ID 6868 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[f64] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[f64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6868,
      GIR_EraseRootFromParent_Done,
    // Label 1474: @85241
    GIM_Try, /*On fail goto*//*Label 1475*/ GIMT_Encode4(85273), // Rule ID 6869 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[f64] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[f64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6869,
      GIR_EraseRootFromParent_Done,
    // Label 1475: @85273
    GIM_Try, /*On fail goto*//*Label 1476*/ GIMT_Encode4(85305), // Rule ID 6870 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[f64] } FPR64:{ *:[v4bf16] }:$src)  =>  FPR64:{ *:[f64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6870,
      GIR_EraseRootFromParent_Done,
    // Label 1476: @85305
    GIM_Try, /*On fail goto*//*Label 1477*/ GIMT_Encode4(85331), // Rule ID 6871 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[f64] } FPR64:{ *:[v2i32] }:$src)  =>  (REV64v2i32:{ *:[f64] } FPR64:{ *:[v2i32] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6871,
      GIR_Done,
    // Label 1477: @85331
    GIM_Try, /*On fail goto*//*Label 1478*/ GIMT_Encode4(85357), // Rule ID 6872 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[f64] } FPR64:{ *:[v4i16] }:$src)  =>  (REV64v4i16:{ *:[f64] } FPR64:{ *:[v4i16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6872,
      GIR_Done,
    // Label 1478: @85357
    GIM_Try, /*On fail goto*//*Label 1479*/ GIMT_Encode4(85383), // Rule ID 6873 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[f64] } FPR64:{ *:[v2f32] }:$src)  =>  (REV64v2i32:{ *:[f64] } FPR64:{ *:[v2f32] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6873,
      GIR_Done,
    // Label 1479: @85383
    GIM_Try, /*On fail goto*//*Label 1480*/ GIMT_Encode4(85409), // Rule ID 6874 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[f64] } FPR64:{ *:[v8i8] }:$src)  =>  (REV64v8i8:{ *:[f64] } FPR64:{ *:[v8i8] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6874,
      GIR_Done,
    // Label 1480: @85409
    GIM_Try, /*On fail goto*//*Label 1481*/ GIMT_Encode4(85435), // Rule ID 6875 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[f64] } FPR64:{ *:[v4f16] }:$src)  =>  (REV64v4i16:{ *:[f64] } FPR64:{ *:[v4f16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6875,
      GIR_Done,
    // Label 1481: @85435
    GIM_Try, /*On fail goto*//*Label 1482*/ GIMT_Encode4(85461), // Rule ID 6876 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[f64] } FPR64:{ *:[v4bf16] }:$src)  =>  (REV64v4i16:{ *:[f64] } FPR64:{ *:[v4bf16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6876,
      GIR_Done,
    // Label 1482: @85461
    GIM_Try, /*On fail goto*//*Label 1483*/ GIMT_Encode4(85490), // Rule ID 6877 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[f64] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[f64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6877,
      GIR_EraseRootFromParent_Done,
    // Label 1483: @85490
    GIM_Try, /*On fail goto*//*Label 1484*/ GIMT_Encode4(85519), // Rule ID 6878 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[f64] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[f64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6878,
      GIR_EraseRootFromParent_Done,
    // Label 1484: @85519
    GIM_Try, /*On fail goto*//*Label 1485*/ GIMT_Encode4(85551), // Rule ID 6879 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6879,
      GIR_EraseRootFromParent_Done,
    // Label 1485: @85551
    GIM_Try, /*On fail goto*//*Label 1486*/ GIMT_Encode4(85583), // Rule ID 6880 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6880,
      GIR_EraseRootFromParent_Done,
    // Label 1486: @85583
    GIM_Try, /*On fail goto*//*Label 1487*/ GIMT_Encode4(85615), // Rule ID 6881 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6881,
      GIR_EraseRootFromParent_Done,
    // Label 1487: @85615
    GIM_Try, /*On fail goto*//*Label 1488*/ GIMT_Encode4(85647), // Rule ID 6882 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6882,
      GIR_EraseRootFromParent_Done,
    // Label 1488: @85647
    GIM_Try, /*On fail goto*//*Label 1489*/ GIMT_Encode4(85679), // Rule ID 6883 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6883,
      GIR_EraseRootFromParent_Done,
    // Label 1489: @85679
    GIM_Try, /*On fail goto*//*Label 1490*/ GIMT_Encode4(85711), // Rule ID 6884 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4bf16] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6884,
      GIR_EraseRootFromParent_Done,
    // Label 1490: @85711
    GIM_Try, /*On fail goto*//*Label 1491*/ GIMT_Encode4(85737), // Rule ID 6885 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2i32] }:$src)  =>  (REV64v2i32:{ *:[v1f64] } FPR64:{ *:[v2i32] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6885,
      GIR_Done,
    // Label 1491: @85737
    GIM_Try, /*On fail goto*//*Label 1492*/ GIMT_Encode4(85763), // Rule ID 6886 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4i16] }:$src)  =>  (REV64v4i16:{ *:[v1f64] } FPR64:{ *:[v4i16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6886,
      GIR_Done,
    // Label 1492: @85763
    GIM_Try, /*On fail goto*//*Label 1493*/ GIMT_Encode4(85789), // Rule ID 6887 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v8i8] }:$src)  =>  (REV64v8i8:{ *:[v1f64] } FPR64:{ *:[v8i8] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6887,
      GIR_Done,
    // Label 1493: @85789
    GIM_Try, /*On fail goto*//*Label 1494*/ GIMT_Encode4(85815), // Rule ID 6888 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2f32] }:$src)  =>  (REV64v2i32:{ *:[v1f64] } FPR64:{ *:[v2f32] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6888,
      GIR_Done,
    // Label 1494: @85815
    GIM_Try, /*On fail goto*//*Label 1495*/ GIMT_Encode4(85841), // Rule ID 6889 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4f16] }:$src)  =>  (REV64v4i16:{ *:[v1f64] } FPR64:{ *:[v4f16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6889,
      GIR_Done,
    // Label 1495: @85841
    GIM_Try, /*On fail goto*//*Label 1496*/ GIMT_Encode4(85867), // Rule ID 6890 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4bf16] }:$src)  =>  (REV64v4i16:{ *:[v1f64] } FPR64:{ *:[v4bf16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6890,
      GIR_Done,
    // Label 1496: @85867
    GIM_Try, /*On fail goto*//*Label 1497*/ GIMT_Encode4(85896), // Rule ID 6891 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6891,
      GIR_EraseRootFromParent_Done,
    // Label 1497: @85896
    GIM_Try, /*On fail goto*//*Label 1498*/ GIMT_Encode4(85925), // Rule ID 6892 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v1f64] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6892,
      GIR_EraseRootFromParent_Done,
    // Label 1498: @85925
    GIM_Reject,
    // Label 1407: @85926
    GIM_Try, /*On fail goto*//*Label 1499*/ GIMT_Encode4(85958), // Rule ID 6908 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[f128] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[f128] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6908,
      GIR_EraseRootFromParent_Done,
    // Label 1499: @85958
    GIM_Try, /*On fail goto*//*Label 1500*/ GIMT_Encode4(85990), // Rule ID 6909 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[f128] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[f128] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6909,
      GIR_EraseRootFromParent_Done,
    // Label 1500: @85990
    GIM_Try, /*On fail goto*//*Label 1501*/ GIMT_Encode4(86022), // Rule ID 6910 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[f128] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[f128] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6910,
      GIR_EraseRootFromParent_Done,
    // Label 1501: @86022
    GIM_Try, /*On fail goto*//*Label 1502*/ GIMT_Encode4(86054), // Rule ID 6911 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[f128] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[f128] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6911,
      GIR_EraseRootFromParent_Done,
    // Label 1502: @86054
    GIM_Try, /*On fail goto*//*Label 1503*/ GIMT_Encode4(86086), // Rule ID 6912 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[f128] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[f128] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6912,
      GIR_EraseRootFromParent_Done,
    // Label 1503: @86086
    GIM_Try, /*On fail goto*//*Label 1504*/ GIMT_Encode4(86118), // Rule ID 6913 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[f128] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[f128] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6913,
      GIR_EraseRootFromParent_Done,
    // Label 1504: @86118
    GIM_Try, /*On fail goto*//*Label 1505*/ GIMT_Encode4(86150), // Rule ID 6914 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[f128] } FPR128:{ *:[v8bf16] }:$src)  =>  FPR128:{ *:[f128] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6914,
      GIR_EraseRootFromParent_Done,
    // Label 1505: @86150
    GIM_Try, /*On fail goto*//*Label 1506*/ GIMT_Encode4(86182), // Rule ID 6915 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[f128] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[f128] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6915,
      GIR_EraseRootFromParent_Done,
    // Label 1506: @86182
    GIM_Try, /*On fail goto*//*Label 1507*/ GIMT_Encode4(86215), // Rule ID 6916 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[f128] } FPR128:{ *:[v2i64] }:$src)  =>  (EXTv16i8:{ *:[f128] } FPR128:{ *:[v2i64] }:$src, FPR128:{ *:[v2i64] }:$src, 8:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6916,
      GIR_EraseRootFromParent_Done,
    // Label 1507: @86215
    GIM_Try, /*On fail goto*//*Label 1508*/ GIMT_Encode4(86286), // Rule ID 6917 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[f128] } FPR128:{ *:[v4i32] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4i32] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4i32] }:$src), 8:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6917,
      GIR_EraseRootFromParent_Done,
    // Label 1508: @86286
    GIM_Try, /*On fail goto*//*Label 1509*/ GIMT_Encode4(86357), // Rule ID 6918 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[f128] } FPR128:{ *:[v8i16] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8i16] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8i16] }:$src), 8:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6918,
      GIR_EraseRootFromParent_Done,
    // Label 1509: @86357
    GIM_Try, /*On fail goto*//*Label 1510*/ GIMT_Encode4(86428), // Rule ID 6919 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[f128] } FPR128:{ *:[v8f16] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8f16] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8f16] }:$src), 8:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6919,
      GIR_EraseRootFromParent_Done,
    // Label 1510: @86428
    GIM_Try, /*On fail goto*//*Label 1511*/ GIMT_Encode4(86499), // Rule ID 6920 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[f128] } FPR128:{ *:[v8bf16] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8bf16] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8bf16] }:$src), 8:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6920,
      GIR_EraseRootFromParent_Done,
    // Label 1511: @86499
    GIM_Try, /*On fail goto*//*Label 1512*/ GIMT_Encode4(86532), // Rule ID 6921 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[f128] } FPR128:{ *:[v2f64] }:$src)  =>  (EXTv16i8:{ *:[f128] } FPR128:{ *:[v2f64] }:$src, FPR128:{ *:[v2f64] }:$src, 8:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6921,
      GIR_EraseRootFromParent_Done,
    // Label 1512: @86532
    GIM_Try, /*On fail goto*//*Label 1513*/ GIMT_Encode4(86603), // Rule ID 6922 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[f128] } FPR128:{ *:[v4f32] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4f32] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4f32] }:$src), 8:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6922,
      GIR_EraseRootFromParent_Done,
    // Label 1513: @86603
    GIM_Try, /*On fail goto*//*Label 1514*/ GIMT_Encode4(86674), // Rule ID 6923 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[f128] } FPR128:{ *:[v16i8] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v16i8:{ *:[f128] } FPR128:{ *:[v16i8] }:$src), (REV64v16i8:{ *:[f128] } FPR128:{ *:[v16i8] }:$src), 8:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6923,
      GIR_EraseRootFromParent_Done,
    // Label 1514: @86674
    GIM_Reject,
    // Label 1408: @86675
    GIM_Try, /*On fail goto*//*Label 1515*/ GIMT_Encode4(86705), // Rule ID 6741 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (bitconvert:{ *:[v2i32] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v2i32] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6741,
      GIR_Done,
    // Label 1515: @86705
    GIM_Try, /*On fail goto*//*Label 1516*/ GIMT_Encode4(86735), // Rule ID 6744 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (bitconvert:{ *:[v2f32] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v2f32] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6744,
      GIR_Done,
    // Label 1516: @86735
    GIM_Try, /*On fail goto*//*Label 1517*/ GIMT_Encode4(86785), // Rule ID 6754 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (bitconvert:{ *:[v2i32] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v2i32:{ *:[v2i32] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6754,
      GIR_EraseRootFromParent_Done,
    // Label 1517: @86785
    GIM_Try, /*On fail goto*//*Label 1518*/ GIMT_Encode4(86835), // Rule ID 6757 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (bitconvert:{ *:[v2f32] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v2i32:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6757,
      GIR_EraseRootFromParent_Done,
    // Label 1518: @86835
    GIM_Try, /*On fail goto*//*Label 1519*/ GIMT_Encode4(86867), // Rule ID 6794 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6794,
      GIR_EraseRootFromParent_Done,
    // Label 1519: @86867
    GIM_Try, /*On fail goto*//*Label 1520*/ GIMT_Encode4(86899), // Rule ID 6795 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6795,
      GIR_EraseRootFromParent_Done,
    // Label 1520: @86899
    GIM_Try, /*On fail goto*//*Label 1521*/ GIMT_Encode4(86931), // Rule ID 6796 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6796,
      GIR_EraseRootFromParent_Done,
    // Label 1521: @86931
    GIM_Try, /*On fail goto*//*Label 1522*/ GIMT_Encode4(86963), // Rule ID 6797 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v2i32] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6797,
      GIR_EraseRootFromParent_Done,
    // Label 1522: @86963
    GIM_Try, /*On fail goto*//*Label 1523*/ GIMT_Encode4(86995), // Rule ID 6798 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6798,
      GIR_EraseRootFromParent_Done,
    // Label 1523: @86995
    GIM_Try, /*On fail goto*//*Label 1524*/ GIMT_Encode4(87027), // Rule ID 6799 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6799,
      GIR_EraseRootFromParent_Done,
    // Label 1524: @87027
    GIM_Try, /*On fail goto*//*Label 1525*/ GIMT_Encode4(87059), // Rule ID 6800 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4bf16] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6800,
      GIR_EraseRootFromParent_Done,
    // Label 1525: @87059
    GIM_Try, /*On fail goto*//*Label 1526*/ GIMT_Encode4(87085), // Rule ID 6801 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v2i32:{ *:[v2i32] } FPR64:{ *:[v1i64] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6801,
      GIR_Done,
    // Label 1526: @87085
    GIM_Try, /*On fail goto*//*Label 1527*/ GIMT_Encode4(87111), // Rule ID 6802 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4i16] }:$src)  =>  (REV32v4i16:{ *:[v2i32] } FPR64:{ *:[v4i16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6802,
      GIR_Done,
    // Label 1527: @87111
    GIM_Try, /*On fail goto*//*Label 1528*/ GIMT_Encode4(87137), // Rule ID 6803 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v8i8] }:$src)  =>  (REV32v8i8:{ *:[v2i32] } FPR64:{ *:[v8i8] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6803,
      GIR_Done,
    // Label 1528: @87137
    GIM_Try, /*On fail goto*//*Label 1529*/ GIMT_Encode4(87163), // Rule ID 6804 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v2i32] } FPR64:{ *:[f64] }:$src)  =>  (REV64v2i32:{ *:[v2i32] } FPR64:{ *:[f64] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6804,
      GIR_Done,
    // Label 1529: @87163
    GIM_Try, /*On fail goto*//*Label 1530*/ GIMT_Encode4(87189), // Rule ID 6805 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v2i32:{ *:[v2i32] } FPR64:{ *:[v1f64] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6805,
      GIR_Done,
    // Label 1530: @87189
    GIM_Try, /*On fail goto*//*Label 1531*/ GIMT_Encode4(87215), // Rule ID 6806 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4f16] }:$src)  =>  (REV32v4i16:{ *:[v2i32] } FPR64:{ *:[v4f16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6806,
      GIR_Done,
    // Label 1531: @87215
    GIM_Try, /*On fail goto*//*Label 1532*/ GIMT_Encode4(87241), // Rule ID 6807 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4bf16] }:$src)  =>  (REV32v4i16:{ *:[v2i32] } FPR64:{ *:[v4bf16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6807,
      GIR_Done,
    // Label 1532: @87241
    GIM_Try, /*On fail goto*//*Label 1533*/ GIMT_Encode4(87270), // Rule ID 6808 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6808,
      GIR_EraseRootFromParent_Done,
    // Label 1533: @87270
    GIM_Try, /*On fail goto*//*Label 1534*/ GIMT_Encode4(87302), // Rule ID 6893 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6893,
      GIR_EraseRootFromParent_Done,
    // Label 1534: @87302
    GIM_Try, /*On fail goto*//*Label 1535*/ GIMT_Encode4(87334), // Rule ID 6894 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6894,
      GIR_EraseRootFromParent_Done,
    // Label 1535: @87334
    GIM_Try, /*On fail goto*//*Label 1536*/ GIMT_Encode4(87366), // Rule ID 6895 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6895,
      GIR_EraseRootFromParent_Done,
    // Label 1536: @87366
    GIM_Try, /*On fail goto*//*Label 1537*/ GIMT_Encode4(87398), // Rule ID 6896 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6896,
      GIR_EraseRootFromParent_Done,
    // Label 1537: @87398
    GIM_Try, /*On fail goto*//*Label 1538*/ GIMT_Encode4(87430), // Rule ID 6897 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v2f32] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6897,
      GIR_EraseRootFromParent_Done,
    // Label 1538: @87430
    GIM_Try, /*On fail goto*//*Label 1539*/ GIMT_Encode4(87462), // Rule ID 6898 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6898,
      GIR_EraseRootFromParent_Done,
    // Label 1539: @87462
    GIM_Try, /*On fail goto*//*Label 1540*/ GIMT_Encode4(87494), // Rule ID 6899 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4bf16] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6899,
      GIR_EraseRootFromParent_Done,
    // Label 1540: @87494
    GIM_Try, /*On fail goto*//*Label 1541*/ GIMT_Encode4(87520), // Rule ID 6900 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v2i32:{ *:[v2f32] } FPR64:{ *:[v1i64] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6900,
      GIR_Done,
    // Label 1541: @87520
    GIM_Try, /*On fail goto*//*Label 1542*/ GIMT_Encode4(87546), // Rule ID 6901 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4i16] }:$src)  =>  (REV32v4i16:{ *:[v2f32] } FPR64:{ *:[v4i16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6901,
      GIR_Done,
    // Label 1542: @87546
    GIM_Try, /*On fail goto*//*Label 1543*/ GIMT_Encode4(87572), // Rule ID 6902 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v8i8] }:$src)  =>  (REV32v8i8:{ *:[v2f32] } FPR64:{ *:[v8i8] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6902,
      GIR_Done,
    // Label 1543: @87572
    GIM_Try, /*On fail goto*//*Label 1544*/ GIMT_Encode4(87598), // Rule ID 6903 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v2i32:{ *:[v2f32] } FPR64:{ *:[v1f64] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6903,
      GIR_Done,
    // Label 1544: @87598
    GIM_Try, /*On fail goto*//*Label 1545*/ GIMT_Encode4(87624), // Rule ID 6904 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v2f32] } FPR64:{ *:[f64] }:$src)  =>  (REV64v2i32:{ *:[v2f32] } FPR64:{ *:[f64] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6904,
      GIR_Done,
    // Label 1545: @87624
    GIM_Try, /*On fail goto*//*Label 1546*/ GIMT_Encode4(87650), // Rule ID 6905 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4f16] }:$src)  =>  (REV32v4i16:{ *:[v2f32] } FPR64:{ *:[v4f16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6905,
      GIR_Done,
    // Label 1546: @87650
    GIM_Try, /*On fail goto*//*Label 1547*/ GIMT_Encode4(87676), // Rule ID 6906 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4bf16] }:$src)  =>  (REV32v4i16:{ *:[v2f32] } FPR64:{ *:[v4bf16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6906,
      GIR_Done,
    // Label 1547: @87676
    GIM_Try, /*On fail goto*//*Label 1548*/ GIMT_Encode4(87705), // Rule ID 6907 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6907,
      GIR_EraseRootFromParent_Done,
    // Label 1548: @87705
    GIM_Reject,
    // Label 1409: @87706
    GIM_Try, /*On fail goto*//*Label 1549*/ GIMT_Encode4(87738), // Rule ID 6924 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v2f64] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6924,
      GIR_EraseRootFromParent_Done,
    // Label 1549: @87738
    GIM_Try, /*On fail goto*//*Label 1550*/ GIMT_Encode4(87770), // Rule ID 6925 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6925,
      GIR_EraseRootFromParent_Done,
    // Label 1550: @87770
    GIM_Try, /*On fail goto*//*Label 1551*/ GIMT_Encode4(87802), // Rule ID 6926 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6926,
      GIR_EraseRootFromParent_Done,
    // Label 1551: @87802
    GIM_Try, /*On fail goto*//*Label 1552*/ GIMT_Encode4(87834), // Rule ID 6927 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6927,
      GIR_EraseRootFromParent_Done,
    // Label 1552: @87834
    GIM_Try, /*On fail goto*//*Label 1553*/ GIMT_Encode4(87866), // Rule ID 6928 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8bf16] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6928,
      GIR_EraseRootFromParent_Done,
    // Label 1553: @87866
    GIM_Try, /*On fail goto*//*Label 1554*/ GIMT_Encode4(87898), // Rule ID 6929 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6929,
      GIR_EraseRootFromParent_Done,
    // Label 1554: @87898
    GIM_Try, /*On fail goto*//*Label 1555*/ GIMT_Encode4(87930), // Rule ID 6930 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6930,
      GIR_EraseRootFromParent_Done,
    // Label 1555: @87930
    GIM_Try, /*On fail goto*//*Label 1556*/ GIMT_Encode4(87963), // Rule ID 6931 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v2f64] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v2f64] } FPR128:{ *:[f128] }:$src, FPR128:{ *:[f128] }:$src, 8:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6931,
      GIR_EraseRootFromParent_Done,
    // Label 1556: @87963
    GIM_Try, /*On fail goto*//*Label 1557*/ GIMT_Encode4(87989), // Rule ID 6932 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4i32] }:$src)  =>  (REV64v4i32:{ *:[v2f64] } FPR128:{ *:[v4i32] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6932,
      GIR_Done,
    // Label 1557: @87989
    GIM_Try, /*On fail goto*//*Label 1558*/ GIMT_Encode4(88015), // Rule ID 6933 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8i16] }:$src)  =>  (REV64v8i16:{ *:[v2f64] } FPR128:{ *:[v8i16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6933,
      GIR_Done,
    // Label 1558: @88015
    GIM_Try, /*On fail goto*//*Label 1559*/ GIMT_Encode4(88041), // Rule ID 6934 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8f16] }:$src)  =>  (REV64v8i16:{ *:[v2f64] } FPR128:{ *:[v8f16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6934,
      GIR_Done,
    // Label 1559: @88041
    GIM_Try, /*On fail goto*//*Label 1560*/ GIMT_Encode4(88067), // Rule ID 6935 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8bf16] }:$src)  =>  (REV64v8i16:{ *:[v2f64] } FPR128:{ *:[v8bf16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6935,
      GIR_Done,
    // Label 1560: @88067
    GIM_Try, /*On fail goto*//*Label 1561*/ GIMT_Encode4(88093), // Rule ID 6936 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v16i8] }:$src)  =>  (REV64v16i8:{ *:[v2f64] } FPR128:{ *:[v16i8] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6936,
      GIR_Done,
    // Label 1561: @88093
    GIM_Try, /*On fail goto*//*Label 1562*/ GIMT_Encode4(88119), // Rule ID 6937 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4f32] }:$src)  =>  (REV64v4i32:{ *:[v2f64] } FPR128:{ *:[v4f32] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6937,
      GIR_Done,
    // Label 1562: @88119
    GIM_Try, /*On fail goto*//*Label 1563*/ GIMT_Encode4(88148), // Rule ID 6938 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6938,
      GIR_EraseRootFromParent_Done,
    // Label 1563: @88148
    GIM_Try, /*On fail goto*//*Label 1564*/ GIMT_Encode4(88180), // Rule ID 6954 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v2i64] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6954,
      GIR_EraseRootFromParent_Done,
    // Label 1564: @88180
    GIM_Try, /*On fail goto*//*Label 1565*/ GIMT_Encode4(88212), // Rule ID 6955 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6955,
      GIR_EraseRootFromParent_Done,
    // Label 1565: @88212
    GIM_Try, /*On fail goto*//*Label 1566*/ GIMT_Encode4(88244), // Rule ID 6956 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6956,
      GIR_EraseRootFromParent_Done,
    // Label 1566: @88244
    GIM_Try, /*On fail goto*//*Label 1567*/ GIMT_Encode4(88276), // Rule ID 6957 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6957,
      GIR_EraseRootFromParent_Done,
    // Label 1567: @88276
    GIM_Try, /*On fail goto*//*Label 1568*/ GIMT_Encode4(88308), // Rule ID 6958 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6958,
      GIR_EraseRootFromParent_Done,
    // Label 1568: @88308
    GIM_Try, /*On fail goto*//*Label 1569*/ GIMT_Encode4(88340), // Rule ID 6959 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6959,
      GIR_EraseRootFromParent_Done,
    // Label 1569: @88340
    GIM_Try, /*On fail goto*//*Label 1570*/ GIMT_Encode4(88372), // Rule ID 6960 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8bf16] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6960,
      GIR_EraseRootFromParent_Done,
    // Label 1570: @88372
    GIM_Try, /*On fail goto*//*Label 1571*/ GIMT_Encode4(88405), // Rule ID 6961 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v2i64] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v2i64] } FPR128:{ *:[f128] }:$src, FPR128:{ *:[f128] }:$src, 8:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6961,
      GIR_EraseRootFromParent_Done,
    // Label 1571: @88405
    GIM_Try, /*On fail goto*//*Label 1572*/ GIMT_Encode4(88431), // Rule ID 6962 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4i32] }:$src)  =>  (REV64v4i32:{ *:[v2i64] } FPR128:{ *:[v4i32] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6962,
      GIR_Done,
    // Label 1572: @88431
    GIM_Try, /*On fail goto*//*Label 1573*/ GIMT_Encode4(88457), // Rule ID 6963 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8i16] }:$src)  =>  (REV64v8i16:{ *:[v2i64] } FPR128:{ *:[v8i16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6963,
      GIR_Done,
    // Label 1573: @88457
    GIM_Try, /*On fail goto*//*Label 1574*/ GIMT_Encode4(88483), // Rule ID 6964 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v16i8] }:$src)  =>  (REV64v16i8:{ *:[v2i64] } FPR128:{ *:[v16i8] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6964,
      GIR_Done,
    // Label 1574: @88483
    GIM_Try, /*On fail goto*//*Label 1575*/ GIMT_Encode4(88509), // Rule ID 6965 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4f32] }:$src)  =>  (REV64v4i32:{ *:[v2i64] } FPR128:{ *:[v4f32] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6965,
      GIR_Done,
    // Label 1575: @88509
    GIM_Try, /*On fail goto*//*Label 1576*/ GIMT_Encode4(88535), // Rule ID 6966 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8f16] }:$src)  =>  (REV64v8i16:{ *:[v2i64] } FPR128:{ *:[v8f16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6966,
      GIR_Done,
    // Label 1576: @88535
    GIM_Try, /*On fail goto*//*Label 1577*/ GIMT_Encode4(88561), // Rule ID 6967 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8bf16] }:$src)  =>  (REV64v8i16:{ *:[v2i64] } FPR128:{ *:[v8bf16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6967,
      GIR_Done,
    // Label 1577: @88561
    GIM_Try, /*On fail goto*//*Label 1578*/ GIMT_Encode4(88590), // Rule ID 6968 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6968,
      GIR_EraseRootFromParent_Done,
    // Label 1578: @88590
    GIM_Reject,
    // Label 1410: @88591
    GIM_Try, /*On fail goto*//*Label 1579*/ GIMT_Encode4(88621), // Rule ID 6740 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (bitconvert:{ *:[v4i16] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v4i16] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6740,
      GIR_Done,
    // Label 1579: @88621
    GIM_Try, /*On fail goto*//*Label 1580*/ GIMT_Encode4(88651), // Rule ID 6742 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (bitconvert:{ *:[v4f16] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v4f16] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6742,
      GIR_Done,
    // Label 1580: @88651
    GIM_Try, /*On fail goto*//*Label 1581*/ GIMT_Encode4(88681), // Rule ID 6743 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (bitconvert:{ *:[v4bf16] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v4bf16] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6743,
      GIR_Done,
    // Label 1581: @88681
    GIM_Try, /*On fail goto*//*Label 1582*/ GIMT_Encode4(88731), // Rule ID 6753 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (bitconvert:{ *:[v4i16] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v4i16:{ *:[v4i16] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6753,
      GIR_EraseRootFromParent_Done,
    // Label 1582: @88731
    GIM_Try, /*On fail goto*//*Label 1583*/ GIMT_Encode4(88781), // Rule ID 6755 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (bitconvert:{ *:[v4f16] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v4i16:{ *:[v4f16] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6755,
      GIR_EraseRootFromParent_Done,
    // Label 1583: @88781
    GIM_Try, /*On fail goto*//*Label 1584*/ GIMT_Encode4(88831), // Rule ID 6756 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (bitconvert:{ *:[v4bf16] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v4i16:{ *:[v4bf16] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6756,
      GIR_EraseRootFromParent_Done,
    // Label 1584: @88831
    GIM_Try, /*On fail goto*//*Label 1585*/ GIMT_Encode4(88863), // Rule ID 6809 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6809,
      GIR_EraseRootFromParent_Done,
    // Label 1585: @88863
    GIM_Try, /*On fail goto*//*Label 1586*/ GIMT_Encode4(88895), // Rule ID 6810 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6810,
      GIR_EraseRootFromParent_Done,
    // Label 1586: @88895
    GIM_Try, /*On fail goto*//*Label 1587*/ GIMT_Encode4(88927), // Rule ID 6811 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6811,
      GIR_EraseRootFromParent_Done,
    // Label 1587: @88927
    GIM_Try, /*On fail goto*//*Label 1588*/ GIMT_Encode4(88959), // Rule ID 6812 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4i16] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6812,
      GIR_EraseRootFromParent_Done,
    // Label 1588: @88959
    GIM_Try, /*On fail goto*//*Label 1589*/ GIMT_Encode4(88991), // Rule ID 6813 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6813,
      GIR_EraseRootFromParent_Done,
    // Label 1589: @88991
    GIM_Try, /*On fail goto*//*Label 1590*/ GIMT_Encode4(89023), // Rule ID 6814 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6814,
      GIR_EraseRootFromParent_Done,
    // Label 1590: @89023
    GIM_Try, /*On fail goto*//*Label 1591*/ GIMT_Encode4(89049), // Rule ID 6815 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v4i16:{ *:[v4i16] } FPR64:{ *:[v1i64] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6815,
      GIR_Done,
    // Label 1591: @89049
    GIM_Try, /*On fail goto*//*Label 1592*/ GIMT_Encode4(89075), // Rule ID 6816 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2i32] }:$src)  =>  (REV32v4i16:{ *:[v4i16] } FPR64:{ *:[v2i32] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6816,
      GIR_Done,
    // Label 1592: @89075
    GIM_Try, /*On fail goto*//*Label 1593*/ GIMT_Encode4(89101), // Rule ID 6817 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v8i8] }:$src)  =>  (REV16v8i8:{ *:[v4i16] } FPR64:{ *:[v8i8] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6817,
      GIR_Done,
    // Label 1593: @89101
    GIM_Try, /*On fail goto*//*Label 1594*/ GIMT_Encode4(89127), // Rule ID 6818 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4i16] } FPR64:{ *:[f64] }:$src)  =>  (REV64v4i16:{ *:[v4i16] } FPR64:{ *:[f64] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6818,
      GIR_Done,
    // Label 1594: @89127
    GIM_Try, /*On fail goto*//*Label 1595*/ GIMT_Encode4(89153), // Rule ID 6819 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2f32] }:$src)  =>  (REV32v4i16:{ *:[v4i16] } FPR64:{ *:[v2f32] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6819,
      GIR_Done,
    // Label 1595: @89153
    GIM_Try, /*On fail goto*//*Label 1596*/ GIMT_Encode4(89179), // Rule ID 6820 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v4i16:{ *:[v4i16] } FPR64:{ *:[v1f64] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6820,
      GIR_Done,
    // Label 1596: @89179
    GIM_Try, /*On fail goto*//*Label 1597*/ GIMT_Encode4(89208), // Rule ID 6821 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6821,
      GIR_EraseRootFromParent_Done,
    // Label 1597: @89208
    GIM_Try, /*On fail goto*//*Label 1598*/ GIMT_Encode4(89237), // Rule ID 6822 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v4bf16] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6822,
      GIR_EraseRootFromParent_Done,
    // Label 1598: @89237
    GIM_Try, /*On fail goto*//*Label 1599*/ GIMT_Encode4(89269), // Rule ID 6823 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6823,
      GIR_EraseRootFromParent_Done,
    // Label 1599: @89269
    GIM_Try, /*On fail goto*//*Label 1600*/ GIMT_Encode4(89301), // Rule ID 6824 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6824,
      GIR_EraseRootFromParent_Done,
    // Label 1600: @89301
    GIM_Try, /*On fail goto*//*Label 1601*/ GIMT_Encode4(89333), // Rule ID 6825 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6825,
      GIR_EraseRootFromParent_Done,
    // Label 1601: @89333
    GIM_Try, /*On fail goto*//*Label 1602*/ GIMT_Encode4(89365), // Rule ID 6826 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4f16] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6826,
      GIR_EraseRootFromParent_Done,
    // Label 1602: @89365
    GIM_Try, /*On fail goto*//*Label 1603*/ GIMT_Encode4(89397), // Rule ID 6827 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6827,
      GIR_EraseRootFromParent_Done,
    // Label 1603: @89397
    GIM_Try, /*On fail goto*//*Label 1604*/ GIMT_Encode4(89429), // Rule ID 6828 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6828,
      GIR_EraseRootFromParent_Done,
    // Label 1604: @89429
    GIM_Try, /*On fail goto*//*Label 1605*/ GIMT_Encode4(89461), // Rule ID 6829 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4bf16] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v4bf16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6829,
      GIR_EraseRootFromParent_Done,
    // Label 1605: @89461
    GIM_Try, /*On fail goto*//*Label 1606*/ GIMT_Encode4(89493), // Rule ID 6830 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4bf16] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v4bf16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6830,
      GIR_EraseRootFromParent_Done,
    // Label 1606: @89493
    GIM_Try, /*On fail goto*//*Label 1607*/ GIMT_Encode4(89525), // Rule ID 6831 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4bf16] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v4bf16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6831,
      GIR_EraseRootFromParent_Done,
    // Label 1607: @89525
    GIM_Try, /*On fail goto*//*Label 1608*/ GIMT_Encode4(89557), // Rule ID 6832 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4bf16] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v4bf16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6832,
      GIR_EraseRootFromParent_Done,
    // Label 1608: @89557
    GIM_Try, /*On fail goto*//*Label 1609*/ GIMT_Encode4(89589), // Rule ID 6833 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4bf16] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v4bf16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6833,
      GIR_EraseRootFromParent_Done,
    // Label 1609: @89589
    GIM_Try, /*On fail goto*//*Label 1610*/ GIMT_Encode4(89621), // Rule ID 6834 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4bf16] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v4bf16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6834,
      GIR_EraseRootFromParent_Done,
    // Label 1610: @89621
    GIM_Try, /*On fail goto*//*Label 1611*/ GIMT_Encode4(89647), // Rule ID 6835 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v4i16:{ *:[v4f16] } FPR64:{ *:[v1i64] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6835,
      GIR_Done,
    // Label 1611: @89647
    GIM_Try, /*On fail goto*//*Label 1612*/ GIMT_Encode4(89673), // Rule ID 6836 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2i32] }:$src)  =>  (REV32v4i16:{ *:[v4f16] } FPR64:{ *:[v2i32] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6836,
      GIR_Done,
    // Label 1612: @89673
    GIM_Try, /*On fail goto*//*Label 1613*/ GIMT_Encode4(89699), // Rule ID 6837 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v8i8] }:$src)  =>  (REV16v8i8:{ *:[v4f16] } FPR64:{ *:[v8i8] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6837,
      GIR_Done,
    // Label 1613: @89699
    GIM_Try, /*On fail goto*//*Label 1614*/ GIMT_Encode4(89725), // Rule ID 6838 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4f16] } FPR64:{ *:[f64] }:$src)  =>  (REV64v4i16:{ *:[v4f16] } FPR64:{ *:[f64] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6838,
      GIR_Done,
    // Label 1614: @89725
    GIM_Try, /*On fail goto*//*Label 1615*/ GIMT_Encode4(89751), // Rule ID 6839 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2f32] }:$src)  =>  (REV32v4i16:{ *:[v4f16] } FPR64:{ *:[v2f32] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6839,
      GIR_Done,
    // Label 1615: @89751
    GIM_Try, /*On fail goto*//*Label 1616*/ GIMT_Encode4(89777), // Rule ID 6840 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v4i16:{ *:[v4f16] } FPR64:{ *:[v1f64] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6840,
      GIR_Done,
    // Label 1616: @89777
    GIM_Try, /*On fail goto*//*Label 1617*/ GIMT_Encode4(89803), // Rule ID 6841 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4bf16] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v4i16:{ *:[v4bf16] } FPR64:{ *:[v1i64] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6841,
      GIR_Done,
    // Label 1617: @89803
    GIM_Try, /*On fail goto*//*Label 1618*/ GIMT_Encode4(89829), // Rule ID 6842 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4bf16] } FPR64:{ *:[v2i32] }:$src)  =>  (REV32v4i16:{ *:[v4bf16] } FPR64:{ *:[v2i32] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6842,
      GIR_Done,
    // Label 1618: @89829
    GIM_Try, /*On fail goto*//*Label 1619*/ GIMT_Encode4(89855), // Rule ID 6843 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4bf16] } FPR64:{ *:[v8i8] }:$src)  =>  (REV16v8i8:{ *:[v4bf16] } FPR64:{ *:[v8i8] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6843,
      GIR_Done,
    // Label 1619: @89855
    GIM_Try, /*On fail goto*//*Label 1620*/ GIMT_Encode4(89881), // Rule ID 6844 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4bf16] } FPR64:{ *:[f64] }:$src)  =>  (REV64v4i16:{ *:[v4bf16] } FPR64:{ *:[f64] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6844,
      GIR_Done,
    // Label 1620: @89881
    GIM_Try, /*On fail goto*//*Label 1621*/ GIMT_Encode4(89907), // Rule ID 6845 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4bf16] } FPR64:{ *:[v2f32] }:$src)  =>  (REV32v4i16:{ *:[v4bf16] } FPR64:{ *:[v2f32] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6845,
      GIR_Done,
    // Label 1621: @89907
    GIM_Try, /*On fail goto*//*Label 1622*/ GIMT_Encode4(89933), // Rule ID 6846 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4bf16] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v4i16:{ *:[v4bf16] } FPR64:{ *:[v1f64] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6846,
      GIR_Done,
    // Label 1622: @89933
    GIM_Try, /*On fail goto*//*Label 1623*/ GIMT_Encode4(89962), // Rule ID 6847 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6847,
      GIR_EraseRootFromParent_Done,
    // Label 1623: @89962
    GIM_Try, /*On fail goto*//*Label 1624*/ GIMT_Encode4(89991), // Rule ID 6848 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v4bf16] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v4bf16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6848,
      GIR_EraseRootFromParent_Done,
    // Label 1624: @89991
    GIM_Reject,
    // Label 1411: @89992
    GIM_Try, /*On fail goto*//*Label 1625*/ GIMT_Encode4(90024), // Rule ID 6939 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v4f32] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6939,
      GIR_EraseRootFromParent_Done,
    // Label 1625: @90024
    GIM_Try, /*On fail goto*//*Label 1626*/ GIMT_Encode4(90056), // Rule ID 6940 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6940,
      GIR_EraseRootFromParent_Done,
    // Label 1626: @90056
    GIM_Try, /*On fail goto*//*Label 1627*/ GIMT_Encode4(90088), // Rule ID 6941 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6941,
      GIR_EraseRootFromParent_Done,
    // Label 1627: @90088
    GIM_Try, /*On fail goto*//*Label 1628*/ GIMT_Encode4(90120), // Rule ID 6942 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8bf16] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6942,
      GIR_EraseRootFromParent_Done,
    // Label 1628: @90120
    GIM_Try, /*On fail goto*//*Label 1629*/ GIMT_Encode4(90152), // Rule ID 6943 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6943,
      GIR_EraseRootFromParent_Done,
    // Label 1629: @90152
    GIM_Try, /*On fail goto*//*Label 1630*/ GIMT_Encode4(90184), // Rule ID 6944 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6944,
      GIR_EraseRootFromParent_Done,
    // Label 1630: @90184
    GIM_Try, /*On fail goto*//*Label 1631*/ GIMT_Encode4(90216), // Rule ID 6945 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6945,
      GIR_EraseRootFromParent_Done,
    // Label 1631: @90216
    GIM_Try, /*On fail goto*//*Label 1632*/ GIMT_Encode4(90287), // Rule ID 6946 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v4f32] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v4f32] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6946,
      GIR_EraseRootFromParent_Done,
    // Label 1632: @90287
    GIM_Try, /*On fail goto*//*Label 1633*/ GIMT_Encode4(90313), // Rule ID 6947 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8i16] }:$src)  =>  (REV32v8i16:{ *:[v4f32] } FPR128:{ *:[v8i16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6947,
      GIR_Done,
    // Label 1633: @90313
    GIM_Try, /*On fail goto*//*Label 1634*/ GIMT_Encode4(90339), // Rule ID 6948 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8f16] }:$src)  =>  (REV32v8i16:{ *:[v4f32] } FPR128:{ *:[v8f16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6948,
      GIR_Done,
    // Label 1634: @90339
    GIM_Try, /*On fail goto*//*Label 1635*/ GIMT_Encode4(90365), // Rule ID 6949 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8bf16] }:$src)  =>  (REV32v8i16:{ *:[v4f32] } FPR128:{ *:[v8bf16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6949,
      GIR_Done,
    // Label 1635: @90365
    GIM_Try, /*On fail goto*//*Label 1636*/ GIMT_Encode4(90391), // Rule ID 6950 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v16i8] }:$src)  =>  (REV32v16i8:{ *:[v4f32] } FPR128:{ *:[v16i8] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6950,
      GIR_Done,
    // Label 1636: @90391
    GIM_Try, /*On fail goto*//*Label 1637*/ GIMT_Encode4(90417), // Rule ID 6951 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v4i32:{ *:[v4f32] } FPR128:{ *:[v2i64] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6951,
      GIR_Done,
    // Label 1637: @90417
    GIM_Try, /*On fail goto*//*Label 1638*/ GIMT_Encode4(90443), // Rule ID 6952 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v4i32:{ *:[v4f32] } FPR128:{ *:[v2f64] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6952,
      GIR_Done,
    // Label 1638: @90443
    GIM_Try, /*On fail goto*//*Label 1639*/ GIMT_Encode4(90472), // Rule ID 6953 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6953,
      GIR_EraseRootFromParent_Done,
    // Label 1639: @90472
    GIM_Try, /*On fail goto*//*Label 1640*/ GIMT_Encode4(90504), // Rule ID 6969 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v4i32] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6969,
      GIR_EraseRootFromParent_Done,
    // Label 1640: @90504
    GIM_Try, /*On fail goto*//*Label 1641*/ GIMT_Encode4(90536), // Rule ID 6970 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6970,
      GIR_EraseRootFromParent_Done,
    // Label 1641: @90536
    GIM_Try, /*On fail goto*//*Label 1642*/ GIMT_Encode4(90568), // Rule ID 6971 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6971,
      GIR_EraseRootFromParent_Done,
    // Label 1642: @90568
    GIM_Try, /*On fail goto*//*Label 1643*/ GIMT_Encode4(90600), // Rule ID 6972 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6972,
      GIR_EraseRootFromParent_Done,
    // Label 1643: @90600
    GIM_Try, /*On fail goto*//*Label 1644*/ GIMT_Encode4(90632), // Rule ID 6973 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6973,
      GIR_EraseRootFromParent_Done,
    // Label 1644: @90632
    GIM_Try, /*On fail goto*//*Label 1645*/ GIMT_Encode4(90664), // Rule ID 6974 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6974,
      GIR_EraseRootFromParent_Done,
    // Label 1645: @90664
    GIM_Try, /*On fail goto*//*Label 1646*/ GIMT_Encode4(90696), // Rule ID 6975 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8bf16] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6975,
      GIR_EraseRootFromParent_Done,
    // Label 1646: @90696
    GIM_Try, /*On fail goto*//*Label 1647*/ GIMT_Encode4(90767), // Rule ID 6976 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v4i32] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v4i32] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6976,
      GIR_EraseRootFromParent_Done,
    // Label 1647: @90767
    GIM_Try, /*On fail goto*//*Label 1648*/ GIMT_Encode4(90793), // Rule ID 6977 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v4i32:{ *:[v4i32] } FPR128:{ *:[v2i64] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6977,
      GIR_Done,
    // Label 1648: @90793
    GIM_Try, /*On fail goto*//*Label 1649*/ GIMT_Encode4(90819), // Rule ID 6978 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$src)  =>  (REV32v8i16:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6978,
      GIR_Done,
    // Label 1649: @90819
    GIM_Try, /*On fail goto*//*Label 1650*/ GIMT_Encode4(90845), // Rule ID 6979 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v16i8] }:$src)  =>  (REV32v16i8:{ *:[v4i32] } FPR128:{ *:[v16i8] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6979,
      GIR_Done,
    // Label 1650: @90845
    GIM_Try, /*On fail goto*//*Label 1651*/ GIMT_Encode4(90871), // Rule ID 6980 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v4i32:{ *:[v4i32] } FPR128:{ *:[v2f64] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6980,
      GIR_Done,
    // Label 1651: @90871
    GIM_Try, /*On fail goto*//*Label 1652*/ GIMT_Encode4(90897), // Rule ID 6981 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8f16] }:$src)  =>  (REV32v8i16:{ *:[v4i32] } FPR128:{ *:[v8f16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6981,
      GIR_Done,
    // Label 1652: @90897
    GIM_Try, /*On fail goto*//*Label 1653*/ GIMT_Encode4(90923), // Rule ID 6982 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8bf16] }:$src)  =>  (REV32v8i16:{ *:[v4i32] } FPR128:{ *:[v8bf16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6982,
      GIR_Done,
    // Label 1653: @90923
    GIM_Try, /*On fail goto*//*Label 1654*/ GIMT_Encode4(90952), // Rule ID 6983 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6983,
      GIR_EraseRootFromParent_Done,
    // Label 1654: @90952
    GIM_Reject,
    // Label 1412: @90953
    GIM_Try, /*On fail goto*//*Label 1655*/ GIMT_Encode4(91027), // Rule ID 5718 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (bitconvert:{ *:[v8i8] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn))  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i32] }, (FMOVWSr:{ *:[f32] } GPR32:{ *:[i32] }:$Rn), ssub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVWSr),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
      // GIR_Coverage, 5718,
      GIR_EraseRootFromParent_Done,
    // Label 1655: @91027
    GIM_Try, /*On fail goto*//*Label 1656*/ GIMT_Encode4(91057), // Rule ID 6739 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (bitconvert:{ *:[v8i8] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v8i8] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6739,
      GIR_Done,
    // Label 1656: @91057
    GIM_Try, /*On fail goto*//*Label 1657*/ GIMT_Encode4(91107), // Rule ID 6752 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (bitconvert:{ *:[v8i8] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v8i8:{ *:[v8i8] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6752,
      GIR_EraseRootFromParent_Done,
    // Label 1657: @91107
    GIM_Try, /*On fail goto*//*Label 1658*/ GIMT_Encode4(91139), // Rule ID 6849 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6849,
      GIR_EraseRootFromParent_Done,
    // Label 1658: @91139
    GIM_Try, /*On fail goto*//*Label 1659*/ GIMT_Encode4(91171), // Rule ID 6850 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6850,
      GIR_EraseRootFromParent_Done,
    // Label 1659: @91171
    GIM_Try, /*On fail goto*//*Label 1660*/ GIMT_Encode4(91203), // Rule ID 6851 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6851,
      GIR_EraseRootFromParent_Done,
    // Label 1660: @91203
    GIM_Try, /*On fail goto*//*Label 1661*/ GIMT_Encode4(91235), // Rule ID 6852 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v8i8] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6852,
      GIR_EraseRootFromParent_Done,
    // Label 1661: @91235
    GIM_Try, /*On fail goto*//*Label 1662*/ GIMT_Encode4(91267), // Rule ID 6853 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6853,
      GIR_EraseRootFromParent_Done,
    // Label 1662: @91267
    GIM_Try, /*On fail goto*//*Label 1663*/ GIMT_Encode4(91299), // Rule ID 6854 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6854,
      GIR_EraseRootFromParent_Done,
    // Label 1663: @91299
    GIM_Try, /*On fail goto*//*Label 1664*/ GIMT_Encode4(91331), // Rule ID 6855 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6855,
      GIR_EraseRootFromParent_Done,
    // Label 1664: @91331
    GIM_Try, /*On fail goto*//*Label 1665*/ GIMT_Encode4(91363), // Rule ID 6856 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4bf16] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6856,
      GIR_EraseRootFromParent_Done,
    // Label 1665: @91363
    GIM_Try, /*On fail goto*//*Label 1666*/ GIMT_Encode4(91389), // Rule ID 6857 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v8i8:{ *:[v8i8] } FPR64:{ *:[v1i64] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6857,
      GIR_Done,
    // Label 1666: @91389
    GIM_Try, /*On fail goto*//*Label 1667*/ GIMT_Encode4(91415), // Rule ID 6858 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2i32] }:$src)  =>  (REV32v8i8:{ *:[v8i8] } FPR64:{ *:[v2i32] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6858,
      GIR_Done,
    // Label 1667: @91415
    GIM_Try, /*On fail goto*//*Label 1668*/ GIMT_Encode4(91441), // Rule ID 6859 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4i16] }:$src)  =>  (REV16v8i8:{ *:[v8i8] } FPR64:{ *:[v4i16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6859,
      GIR_Done,
    // Label 1668: @91441
    GIM_Try, /*On fail goto*//*Label 1669*/ GIMT_Encode4(91467), // Rule ID 6860 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v8i8] } FPR64:{ *:[f64] }:$src)  =>  (REV64v8i8:{ *:[v8i8] } FPR64:{ *:[f64] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6860,
      GIR_Done,
    // Label 1669: @91467
    GIM_Try, /*On fail goto*//*Label 1670*/ GIMT_Encode4(91493), // Rule ID 6861 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2f32] }:$src)  =>  (REV32v8i8:{ *:[v8i8] } FPR64:{ *:[v2f32] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6861,
      GIR_Done,
    // Label 1670: @91493
    GIM_Try, /*On fail goto*//*Label 1671*/ GIMT_Encode4(91519), // Rule ID 6862 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v8i8:{ *:[v8i8] } FPR64:{ *:[v1f64] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6862,
      GIR_Done,
    // Label 1671: @91519
    GIM_Try, /*On fail goto*//*Label 1672*/ GIMT_Encode4(91545), // Rule ID 6863 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4f16] }:$src)  =>  (REV16v8i8:{ *:[v8i8] } FPR64:{ *:[v4f16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6863,
      GIR_Done,
    // Label 1672: @91545
    GIM_Try, /*On fail goto*//*Label 1673*/ GIMT_Encode4(91571), // Rule ID 6864 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4bf16] }:$src)  =>  (REV16v8i8:{ *:[v8i8] } FPR64:{ *:[v4bf16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6864,
      GIR_Done,
    // Label 1673: @91571
    GIM_Reject,
    // Label 1413: @91572
    GIM_Try, /*On fail goto*//*Label 1674*/ GIMT_Encode4(91604), // Rule ID 6984 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8i16] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6984,
      GIR_EraseRootFromParent_Done,
    // Label 1674: @91604
    GIM_Try, /*On fail goto*//*Label 1675*/ GIMT_Encode4(91636), // Rule ID 6985 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6985,
      GIR_EraseRootFromParent_Done,
    // Label 1675: @91636
    GIM_Try, /*On fail goto*//*Label 1676*/ GIMT_Encode4(91668), // Rule ID 6986 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6986,
      GIR_EraseRootFromParent_Done,
    // Label 1676: @91668
    GIM_Try, /*On fail goto*//*Label 1677*/ GIMT_Encode4(91700), // Rule ID 6987 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6987,
      GIR_EraseRootFromParent_Done,
    // Label 1677: @91700
    GIM_Try, /*On fail goto*//*Label 1678*/ GIMT_Encode4(91732), // Rule ID 6988 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6988,
      GIR_EraseRootFromParent_Done,
    // Label 1678: @91732
    GIM_Try, /*On fail goto*//*Label 1679*/ GIMT_Encode4(91764), // Rule ID 6989 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6989,
      GIR_EraseRootFromParent_Done,
    // Label 1679: @91764
    GIM_Try, /*On fail goto*//*Label 1680*/ GIMT_Encode4(91835), // Rule ID 6990 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8i16] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v8i16] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6990,
      GIR_EraseRootFromParent_Done,
    // Label 1680: @91835
    GIM_Try, /*On fail goto*//*Label 1681*/ GIMT_Encode4(91861), // Rule ID 6991 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v8i16:{ *:[v8i16] } FPR128:{ *:[v2i64] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6991,
      GIR_Done,
    // Label 1681: @91861
    GIM_Try, /*On fail goto*//*Label 1682*/ GIMT_Encode4(91887), // Rule ID 6992 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4i32] }:$src)  =>  (REV32v8i16:{ *:[v8i16] } FPR128:{ *:[v4i32] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6992,
      GIR_Done,
    // Label 1682: @91887
    GIM_Try, /*On fail goto*//*Label 1683*/ GIMT_Encode4(91913), // Rule ID 6993 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$src)  =>  (REV16v16i8:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6993,
      GIR_Done,
    // Label 1683: @91913
    GIM_Try, /*On fail goto*//*Label 1684*/ GIMT_Encode4(91939), // Rule ID 6994 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v8i16:{ *:[v8i16] } FPR128:{ *:[v2f64] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6994,
      GIR_Done,
    // Label 1684: @91939
    GIM_Try, /*On fail goto*//*Label 1685*/ GIMT_Encode4(91965), // Rule ID 6995 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4f32] }:$src)  =>  (REV32v8i16:{ *:[v8i16] } FPR128:{ *:[v4f32] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6995,
      GIR_Done,
    // Label 1685: @91965
    GIM_Try, /*On fail goto*//*Label 1686*/ GIMT_Encode4(91994), // Rule ID 6996 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6996,
      GIR_EraseRootFromParent_Done,
    // Label 1686: @91994
    GIM_Try, /*On fail goto*//*Label 1687*/ GIMT_Encode4(92023), // Rule ID 6997 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v8bf16] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6997,
      GIR_EraseRootFromParent_Done,
    // Label 1687: @92023
    GIM_Try, /*On fail goto*//*Label 1688*/ GIMT_Encode4(92055), // Rule ID 6998 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8f16] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6998,
      GIR_EraseRootFromParent_Done,
    // Label 1688: @92055
    GIM_Try, /*On fail goto*//*Label 1689*/ GIMT_Encode4(92087), // Rule ID 6999 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 6999,
      GIR_EraseRootFromParent_Done,
    // Label 1689: @92087
    GIM_Try, /*On fail goto*//*Label 1690*/ GIMT_Encode4(92119), // Rule ID 7000 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 7000,
      GIR_EraseRootFromParent_Done,
    // Label 1690: @92119
    GIM_Try, /*On fail goto*//*Label 1691*/ GIMT_Encode4(92151), // Rule ID 7001 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 7001,
      GIR_EraseRootFromParent_Done,
    // Label 1691: @92151
    GIM_Try, /*On fail goto*//*Label 1692*/ GIMT_Encode4(92183), // Rule ID 7002 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 7002,
      GIR_EraseRootFromParent_Done,
    // Label 1692: @92183
    GIM_Try, /*On fail goto*//*Label 1693*/ GIMT_Encode4(92215), // Rule ID 7003 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 7003,
      GIR_EraseRootFromParent_Done,
    // Label 1693: @92215
    GIM_Try, /*On fail goto*//*Label 1694*/ GIMT_Encode4(92247), // Rule ID 7004 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8bf16] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v8bf16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 7004,
      GIR_EraseRootFromParent_Done,
    // Label 1694: @92247
    GIM_Try, /*On fail goto*//*Label 1695*/ GIMT_Encode4(92279), // Rule ID 7005 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8bf16] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v8bf16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 7005,
      GIR_EraseRootFromParent_Done,
    // Label 1695: @92279
    GIM_Try, /*On fail goto*//*Label 1696*/ GIMT_Encode4(92311), // Rule ID 7006 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8bf16] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v8bf16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 7006,
      GIR_EraseRootFromParent_Done,
    // Label 1696: @92311
    GIM_Try, /*On fail goto*//*Label 1697*/ GIMT_Encode4(92343), // Rule ID 7007 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8bf16] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v8bf16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 7007,
      GIR_EraseRootFromParent_Done,
    // Label 1697: @92343
    GIM_Try, /*On fail goto*//*Label 1698*/ GIMT_Encode4(92375), // Rule ID 7008 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8bf16] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v8bf16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 7008,
      GIR_EraseRootFromParent_Done,
    // Label 1698: @92375
    GIM_Try, /*On fail goto*//*Label 1699*/ GIMT_Encode4(92407), // Rule ID 7009 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8bf16] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v8bf16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 7009,
      GIR_EraseRootFromParent_Done,
    // Label 1699: @92407
    GIM_Try, /*On fail goto*//*Label 1700*/ GIMT_Encode4(92478), // Rule ID 7010 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8f16] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v8f16] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7010,
      GIR_EraseRootFromParent_Done,
    // Label 1700: @92478
    GIM_Try, /*On fail goto*//*Label 1701*/ GIMT_Encode4(92504), // Rule ID 7011 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v8i16:{ *:[v8f16] } FPR128:{ *:[v2i64] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7011,
      GIR_Done,
    // Label 1701: @92504
    GIM_Try, /*On fail goto*//*Label 1702*/ GIMT_Encode4(92530), // Rule ID 7012 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4i32] }:$src)  =>  (REV32v8i16:{ *:[v8f16] } FPR128:{ *:[v4i32] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7012,
      GIR_Done,
    // Label 1702: @92530
    GIM_Try, /*On fail goto*//*Label 1703*/ GIMT_Encode4(92556), // Rule ID 7013 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v16i8] }:$src)  =>  (REV16v16i8:{ *:[v8f16] } FPR128:{ *:[v16i8] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7013,
      GIR_Done,
    // Label 1703: @92556
    GIM_Try, /*On fail goto*//*Label 1704*/ GIMT_Encode4(92582), // Rule ID 7014 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v8i16:{ *:[v8f16] } FPR128:{ *:[v2f64] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7014,
      GIR_Done,
    // Label 1704: @92582
    GIM_Try, /*On fail goto*//*Label 1705*/ GIMT_Encode4(92608), // Rule ID 7015 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4f32] }:$src)  =>  (REV32v8i16:{ *:[v8f16] } FPR128:{ *:[v4f32] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7015,
      GIR_Done,
    // Label 1705: @92608
    GIM_Try, /*On fail goto*//*Label 1706*/ GIMT_Encode4(92679), // Rule ID 7016 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8bf16] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v8bf16] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7016,
      GIR_EraseRootFromParent_Done,
    // Label 1706: @92679
    GIM_Try, /*On fail goto*//*Label 1707*/ GIMT_Encode4(92705), // Rule ID 7017 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8bf16] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v8i16:{ *:[v8bf16] } FPR128:{ *:[v2i64] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7017,
      GIR_Done,
    // Label 1707: @92705
    GIM_Try, /*On fail goto*//*Label 1708*/ GIMT_Encode4(92731), // Rule ID 7018 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8bf16] } FPR128:{ *:[v4i32] }:$src)  =>  (REV32v8i16:{ *:[v8bf16] } FPR128:{ *:[v4i32] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7018,
      GIR_Done,
    // Label 1708: @92731
    GIM_Try, /*On fail goto*//*Label 1709*/ GIMT_Encode4(92757), // Rule ID 7019 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8bf16] } FPR128:{ *:[v16i8] }:$src)  =>  (REV16v16i8:{ *:[v8bf16] } FPR128:{ *:[v16i8] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7019,
      GIR_Done,
    // Label 1709: @92757
    GIM_Try, /*On fail goto*//*Label 1710*/ GIMT_Encode4(92783), // Rule ID 7020 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8bf16] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v8i16:{ *:[v8bf16] } FPR128:{ *:[v2f64] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7020,
      GIR_Done,
    // Label 1710: @92783
    GIM_Try, /*On fail goto*//*Label 1711*/ GIMT_Encode4(92809), // Rule ID 7021 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8bf16] } FPR128:{ *:[v4f32] }:$src)  =>  (REV32v8i16:{ *:[v8bf16] } FPR128:{ *:[v4f32] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7021,
      GIR_Done,
    // Label 1711: @92809
    GIM_Try, /*On fail goto*//*Label 1712*/ GIMT_Encode4(92838), // Rule ID 7022 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 7022,
      GIR_EraseRootFromParent_Done,
    // Label 1712: @92838
    GIM_Try, /*On fail goto*//*Label 1713*/ GIMT_Encode4(92867), // Rule ID 7023 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v8bf16] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v8bf16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 7023,
      GIR_EraseRootFromParent_Done,
    // Label 1713: @92867
    GIM_Reject,
    // Label 1414: @92868
    GIM_Try, /*On fail goto*//*Label 1714*/ GIMT_Encode4(92900), // Rule ID 7024 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v16i8] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 7024,
      GIR_EraseRootFromParent_Done,
    // Label 1714: @92900
    GIM_Try, /*On fail goto*//*Label 1715*/ GIMT_Encode4(92932), // Rule ID 7025 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 7025,
      GIR_EraseRootFromParent_Done,
    // Label 1715: @92932
    GIM_Try, /*On fail goto*//*Label 1716*/ GIMT_Encode4(92964), // Rule ID 7026 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 7026,
      GIR_EraseRootFromParent_Done,
    // Label 1716: @92964
    GIM_Try, /*On fail goto*//*Label 1717*/ GIMT_Encode4(92996), // Rule ID 7027 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 7027,
      GIR_EraseRootFromParent_Done,
    // Label 1717: @92996
    GIM_Try, /*On fail goto*//*Label 1718*/ GIMT_Encode4(93028), // Rule ID 7028 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 7028,
      GIR_EraseRootFromParent_Done,
    // Label 1718: @93028
    GIM_Try, /*On fail goto*//*Label 1719*/ GIMT_Encode4(93060), // Rule ID 7029 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 7029,
      GIR_EraseRootFromParent_Done,
    // Label 1719: @93060
    GIM_Try, /*On fail goto*//*Label 1720*/ GIMT_Encode4(93092), // Rule ID 7030 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 7030,
      GIR_EraseRootFromParent_Done,
    // Label 1720: @93092
    GIM_Try, /*On fail goto*//*Label 1721*/ GIMT_Encode4(93124), // Rule ID 7031 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8bf16] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 7031,
      GIR_EraseRootFromParent_Done,
    // Label 1721: @93124
    GIM_Try, /*On fail goto*//*Label 1722*/ GIMT_Encode4(93195), // Rule ID 7032 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v16i8] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v16i8] } (REV64v16i8:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v16i8:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7032,
      GIR_EraseRootFromParent_Done,
    // Label 1722: @93195
    GIM_Try, /*On fail goto*//*Label 1723*/ GIMT_Encode4(93221), // Rule ID 7033 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v16i8:{ *:[v16i8] } FPR128:{ *:[v2i64] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7033,
      GIR_Done,
    // Label 1723: @93221
    GIM_Try, /*On fail goto*//*Label 1724*/ GIMT_Encode4(93247), // Rule ID 7034 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4i32] }:$src)  =>  (REV32v16i8:{ *:[v16i8] } FPR128:{ *:[v4i32] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7034,
      GIR_Done,
    // Label 1724: @93247
    GIM_Try, /*On fail goto*//*Label 1725*/ GIMT_Encode4(93273), // Rule ID 7035 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8i16] }:$src)  =>  (REV16v16i8:{ *:[v16i8] } FPR128:{ *:[v8i16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7035,
      GIR_Done,
    // Label 1725: @93273
    GIM_Try, /*On fail goto*//*Label 1726*/ GIMT_Encode4(93299), // Rule ID 7036 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v16i8:{ *:[v16i8] } FPR128:{ *:[v2f64] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7036,
      GIR_Done,
    // Label 1726: @93299
    GIM_Try, /*On fail goto*//*Label 1727*/ GIMT_Encode4(93325), // Rule ID 7037 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4f32] }:$src)  =>  (REV32v16i8:{ *:[v16i8] } FPR128:{ *:[v4f32] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7037,
      GIR_Done,
    // Label 1727: @93325
    GIM_Try, /*On fail goto*//*Label 1728*/ GIMT_Encode4(93351), // Rule ID 7038 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8f16] }:$src)  =>  (REV16v16i8:{ *:[v16i8] } FPR128:{ *:[v8f16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7038,
      GIR_Done,
    // Label 1728: @93351
    GIM_Try, /*On fail goto*//*Label 1729*/ GIMT_Encode4(93377), // Rule ID 7039 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8bf16] }:$src)  =>  (REV16v16i8:{ *:[v16i8] } FPR128:{ *:[v8bf16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7039,
      GIR_Done,
    // Label 1729: @93377
    GIM_Reject,
    // Label 1415: @93378
    GIM_Try, /*On fail goto*//*Label 1730*/ GIMT_Encode4(93437),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1731*/ GIMT_Encode4(93415), // Rule ID 10825 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (bitconvert:{ *:[nxv2bf16] } ZPR:{ *:[nxv2f16] }:$src)  =>  ZPR:{ *:[nxv2bf16] }:$src
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // dst
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        // GIR_Coverage, 10825,
        GIR_EraseRootFromParent_Done,
      // Label 1731: @93415
      GIM_Try, /*On fail goto*//*Label 1732*/ GIMT_Encode4(93436), // Rule ID 10826 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (bitconvert:{ *:[nxv2f16] } ZPR:{ *:[nxv2bf16] }:$src)  =>  ZPR:{ *:[nxv2f16] }:$src
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // dst
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        // GIR_Coverage, 10826,
        GIR_EraseRootFromParent_Done,
      // Label 1732: @93436
      GIM_Reject,
    // Label 1730: @93437
    GIM_Reject,
    // Label 1416: @93438
    GIM_Try, /*On fail goto*//*Label 1733*/ GIMT_Encode4(93470), // Rule ID 10778 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10778,
      GIR_EraseRootFromParent_Done,
    // Label 1733: @93470
    GIM_Try, /*On fail goto*//*Label 1734*/ GIMT_Encode4(93502), // Rule ID 10779 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10779,
      GIR_EraseRootFromParent_Done,
    // Label 1734: @93502
    GIM_Try, /*On fail goto*//*Label 1735*/ GIMT_Encode4(93534), // Rule ID 10780 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10780,
      GIR_EraseRootFromParent_Done,
    // Label 1735: @93534
    GIM_Try, /*On fail goto*//*Label 1736*/ GIMT_Encode4(93566), // Rule ID 10781 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10781,
      GIR_EraseRootFromParent_Done,
    // Label 1736: @93566
    GIM_Try, /*On fail goto*//*Label 1737*/ GIMT_Encode4(93598), // Rule ID 10782 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10782,
      GIR_EraseRootFromParent_Done,
    // Label 1737: @93598
    GIM_Try, /*On fail goto*//*Label 1738*/ GIMT_Encode4(93630), // Rule ID 10783 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10783,
      GIR_EraseRootFromParent_Done,
    // Label 1738: @93630
    GIM_Try, /*On fail goto*//*Label 1739*/ GIMT_Encode4(93662), // Rule ID 10784 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv8bf16] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10784,
      GIR_EraseRootFromParent_Done,
    // Label 1739: @93662
    GIM_Try, /*On fail goto*//*Label 1740*/ GIMT_Encode4(93694), // Rule ID 10799 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10799,
      GIR_EraseRootFromParent_Done,
    // Label 1740: @93694
    GIM_Try, /*On fail goto*//*Label 1741*/ GIMT_Encode4(93726), // Rule ID 10800 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10800,
      GIR_EraseRootFromParent_Done,
    // Label 1741: @93726
    GIM_Try, /*On fail goto*//*Label 1742*/ GIMT_Encode4(93758), // Rule ID 10801 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10801,
      GIR_EraseRootFromParent_Done,
    // Label 1742: @93758
    GIM_Try, /*On fail goto*//*Label 1743*/ GIMT_Encode4(93790), // Rule ID 10802 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10802,
      GIR_EraseRootFromParent_Done,
    // Label 1743: @93790
    GIM_Try, /*On fail goto*//*Label 1744*/ GIMT_Encode4(93822), // Rule ID 10803 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10803,
      GIR_EraseRootFromParent_Done,
    // Label 1744: @93822
    GIM_Try, /*On fail goto*//*Label 1745*/ GIMT_Encode4(93854), // Rule ID 10804 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10804,
      GIR_EraseRootFromParent_Done,
    // Label 1745: @93854
    GIM_Try, /*On fail goto*//*Label 1746*/ GIMT_Encode4(93886), // Rule ID 10805 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv8bf16] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10805,
      GIR_EraseRootFromParent_Done,
    // Label 1746: @93886
    GIM_Try, /*On fail goto*//*Label 1747*/ GIMT_Encode4(93918), // Rule ID 10817 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10817,
      GIR_EraseRootFromParent_Done,
    // Label 1747: @93918
    GIM_Try, /*On fail goto*//*Label 1748*/ GIMT_Encode4(93950), // Rule ID 10818 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10818,
      GIR_EraseRootFromParent_Done,
    // Label 1748: @93950
    GIM_Reject,
    // Label 1417: @93951
    GIM_Try, /*On fail goto*//*Label 1749*/ GIMT_Encode4(94010),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 1750*/ GIMT_Encode4(93988), // Rule ID 10823 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (bitconvert:{ *:[nxv4bf16] } ZPR:{ *:[nxv4f16] }:$src)  =>  ZPR:{ *:[nxv4bf16] }:$src
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // dst
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        // GIR_Coverage, 10823,
        GIR_EraseRootFromParent_Done,
      // Label 1750: @93988
      GIM_Try, /*On fail goto*//*Label 1751*/ GIMT_Encode4(94009), // Rule ID 10824 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (bitconvert:{ *:[nxv4f16] } ZPR:{ *:[nxv4bf16] }:$src)  =>  ZPR:{ *:[nxv4f16] }:$src
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // dst
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        // GIR_Coverage, 10824,
        GIR_EraseRootFromParent_Done,
      // Label 1751: @94009
      GIM_Reject,
    // Label 1749: @94010
    GIM_Reject,
    // Label 1418: @94011
    GIM_Try, /*On fail goto*//*Label 1752*/ GIMT_Encode4(94043), // Rule ID 10771 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10771,
      GIR_EraseRootFromParent_Done,
    // Label 1752: @94043
    GIM_Try, /*On fail goto*//*Label 1753*/ GIMT_Encode4(94075), // Rule ID 10772 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10772,
      GIR_EraseRootFromParent_Done,
    // Label 1753: @94075
    GIM_Try, /*On fail goto*//*Label 1754*/ GIMT_Encode4(94107), // Rule ID 10773 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10773,
      GIR_EraseRootFromParent_Done,
    // Label 1754: @94107
    GIM_Try, /*On fail goto*//*Label 1755*/ GIMT_Encode4(94139), // Rule ID 10774 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10774,
      GIR_EraseRootFromParent_Done,
    // Label 1755: @94139
    GIM_Try, /*On fail goto*//*Label 1756*/ GIMT_Encode4(94171), // Rule ID 10775 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10775,
      GIR_EraseRootFromParent_Done,
    // Label 1756: @94171
    GIM_Try, /*On fail goto*//*Label 1757*/ GIMT_Encode4(94203), // Rule ID 10776 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10776,
      GIR_EraseRootFromParent_Done,
    // Label 1757: @94203
    GIM_Try, /*On fail goto*//*Label 1758*/ GIMT_Encode4(94235), // Rule ID 10777 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv8bf16] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10777,
      GIR_EraseRootFromParent_Done,
    // Label 1758: @94235
    GIM_Try, /*On fail goto*//*Label 1759*/ GIMT_Encode4(94267), // Rule ID 10792 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10792,
      GIR_EraseRootFromParent_Done,
    // Label 1759: @94267
    GIM_Try, /*On fail goto*//*Label 1760*/ GIMT_Encode4(94299), // Rule ID 10793 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10793,
      GIR_EraseRootFromParent_Done,
    // Label 1760: @94299
    GIM_Try, /*On fail goto*//*Label 1761*/ GIMT_Encode4(94331), // Rule ID 10794 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10794,
      GIR_EraseRootFromParent_Done,
    // Label 1761: @94331
    GIM_Try, /*On fail goto*//*Label 1762*/ GIMT_Encode4(94363), // Rule ID 10795 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10795,
      GIR_EraseRootFromParent_Done,
    // Label 1762: @94363
    GIM_Try, /*On fail goto*//*Label 1763*/ GIMT_Encode4(94395), // Rule ID 10796 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10796,
      GIR_EraseRootFromParent_Done,
    // Label 1763: @94395
    GIM_Try, /*On fail goto*//*Label 1764*/ GIMT_Encode4(94427), // Rule ID 10797 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10797,
      GIR_EraseRootFromParent_Done,
    // Label 1764: @94427
    GIM_Try, /*On fail goto*//*Label 1765*/ GIMT_Encode4(94459), // Rule ID 10798 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv8bf16] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10798,
      GIR_EraseRootFromParent_Done,
    // Label 1765: @94459
    GIM_Try, /*On fail goto*//*Label 1766*/ GIMT_Encode4(94491), // Rule ID 10815 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10815,
      GIR_EraseRootFromParent_Done,
    // Label 1766: @94491
    GIM_Try, /*On fail goto*//*Label 1767*/ GIMT_Encode4(94523), // Rule ID 10816 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10816,
      GIR_EraseRootFromParent_Done,
    // Label 1767: @94523
    GIM_Reject,
    // Label 1419: @94524
    GIM_Try, /*On fail goto*//*Label 1768*/ GIMT_Encode4(94556), // Rule ID 10764 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10764,
      GIR_EraseRootFromParent_Done,
    // Label 1768: @94556
    GIM_Try, /*On fail goto*//*Label 1769*/ GIMT_Encode4(94588), // Rule ID 10765 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10765,
      GIR_EraseRootFromParent_Done,
    // Label 1769: @94588
    GIM_Try, /*On fail goto*//*Label 1770*/ GIMT_Encode4(94620), // Rule ID 10766 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10766,
      GIR_EraseRootFromParent_Done,
    // Label 1770: @94620
    GIM_Try, /*On fail goto*//*Label 1771*/ GIMT_Encode4(94652), // Rule ID 10767 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10767,
      GIR_EraseRootFromParent_Done,
    // Label 1771: @94652
    GIM_Try, /*On fail goto*//*Label 1772*/ GIMT_Encode4(94684), // Rule ID 10768 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10768,
      GIR_EraseRootFromParent_Done,
    // Label 1772: @94684
    GIM_Try, /*On fail goto*//*Label 1773*/ GIMT_Encode4(94716), // Rule ID 10769 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10769,
      GIR_EraseRootFromParent_Done,
    // Label 1773: @94716
    GIM_Try, /*On fail goto*//*Label 1774*/ GIMT_Encode4(94748), // Rule ID 10770 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv8bf16] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10770,
      GIR_EraseRootFromParent_Done,
    // Label 1774: @94748
    GIM_Try, /*On fail goto*//*Label 1775*/ GIMT_Encode4(94780), // Rule ID 10785 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10785,
      GIR_EraseRootFromParent_Done,
    // Label 1775: @94780
    GIM_Try, /*On fail goto*//*Label 1776*/ GIMT_Encode4(94812), // Rule ID 10786 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10786,
      GIR_EraseRootFromParent_Done,
    // Label 1776: @94812
    GIM_Try, /*On fail goto*//*Label 1777*/ GIMT_Encode4(94844), // Rule ID 10787 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10787,
      GIR_EraseRootFromParent_Done,
    // Label 1777: @94844
    GIM_Try, /*On fail goto*//*Label 1778*/ GIMT_Encode4(94876), // Rule ID 10788 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10788,
      GIR_EraseRootFromParent_Done,
    // Label 1778: @94876
    GIM_Try, /*On fail goto*//*Label 1779*/ GIMT_Encode4(94908), // Rule ID 10789 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10789,
      GIR_EraseRootFromParent_Done,
    // Label 1779: @94908
    GIM_Try, /*On fail goto*//*Label 1780*/ GIMT_Encode4(94940), // Rule ID 10790 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10790,
      GIR_EraseRootFromParent_Done,
    // Label 1780: @94940
    GIM_Try, /*On fail goto*//*Label 1781*/ GIMT_Encode4(94972), // Rule ID 10791 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv8bf16] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10791,
      GIR_EraseRootFromParent_Done,
    // Label 1781: @94972
    GIM_Try, /*On fail goto*//*Label 1782*/ GIMT_Encode4(95004), // Rule ID 10806 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv8bf16] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv8bf16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10806,
      GIR_EraseRootFromParent_Done,
    // Label 1782: @95004
    GIM_Try, /*On fail goto*//*Label 1783*/ GIMT_Encode4(95036), // Rule ID 10807 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv8bf16] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv8bf16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10807,
      GIR_EraseRootFromParent_Done,
    // Label 1783: @95036
    GIM_Try, /*On fail goto*//*Label 1784*/ GIMT_Encode4(95068), // Rule ID 10808 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv8bf16] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv8bf16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10808,
      GIR_EraseRootFromParent_Done,
    // Label 1784: @95068
    GIM_Try, /*On fail goto*//*Label 1785*/ GIMT_Encode4(95100), // Rule ID 10809 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv8bf16] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv8bf16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10809,
      GIR_EraseRootFromParent_Done,
    // Label 1785: @95100
    GIM_Try, /*On fail goto*//*Label 1786*/ GIMT_Encode4(95132), // Rule ID 10810 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv8bf16] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv8bf16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10810,
      GIR_EraseRootFromParent_Done,
    // Label 1786: @95132
    GIM_Try, /*On fail goto*//*Label 1787*/ GIMT_Encode4(95164), // Rule ID 10811 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv8bf16] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv8bf16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10811,
      GIR_EraseRootFromParent_Done,
    // Label 1787: @95164
    GIM_Try, /*On fail goto*//*Label 1788*/ GIMT_Encode4(95196), // Rule ID 10812 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv8bf16] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv8bf16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10812,
      GIR_EraseRootFromParent_Done,
    // Label 1788: @95196
    GIM_Try, /*On fail goto*//*Label 1789*/ GIMT_Encode4(95228), // Rule ID 10813 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10813,
      GIR_EraseRootFromParent_Done,
    // Label 1789: @95228
    GIM_Try, /*On fail goto*//*Label 1790*/ GIMT_Encode4(95260), // Rule ID 10814 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10814,
      GIR_EraseRootFromParent_Done,
    // Label 1790: @95260
    GIM_Try, /*On fail goto*//*Label 1791*/ GIMT_Encode4(95292), // Rule ID 10819 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv8bf16] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10819,
      GIR_EraseRootFromParent_Done,
    // Label 1791: @95292
    GIM_Try, /*On fail goto*//*Label 1792*/ GIMT_Encode4(95324), // Rule ID 10820 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv8bf16] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv8bf16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10820,
      GIR_EraseRootFromParent_Done,
    // Label 1792: @95324
    GIM_Try, /*On fail goto*//*Label 1793*/ GIMT_Encode4(95356), // Rule ID 10821 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv8bf16] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv8bf16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10821,
      GIR_EraseRootFromParent_Done,
    // Label 1793: @95356
    GIM_Try, /*On fail goto*//*Label 1794*/ GIMT_Encode4(95388), // Rule ID 10822 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv8bf16] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10822,
      GIR_EraseRootFromParent_Done,
    // Label 1794: @95388
    GIM_Reject,
    // Label 1420: @95389
    GIM_Try, /*On fail goto*//*Label 1795*/ GIMT_Encode4(95421), // Rule ID 10757 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10757,
      GIR_EraseRootFromParent_Done,
    // Label 1795: @95421
    GIM_Try, /*On fail goto*//*Label 1796*/ GIMT_Encode4(95453), // Rule ID 10758 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10758,
      GIR_EraseRootFromParent_Done,
    // Label 1796: @95453
    GIM_Try, /*On fail goto*//*Label 1797*/ GIMT_Encode4(95485), // Rule ID 10759 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10759,
      GIR_EraseRootFromParent_Done,
    // Label 1797: @95485
    GIM_Try, /*On fail goto*//*Label 1798*/ GIMT_Encode4(95517), // Rule ID 10760 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10760,
      GIR_EraseRootFromParent_Done,
    // Label 1798: @95517
    GIM_Try, /*On fail goto*//*Label 1799*/ GIMT_Encode4(95549), // Rule ID 10761 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10761,
      GIR_EraseRootFromParent_Done,
    // Label 1799: @95549
    GIM_Try, /*On fail goto*//*Label 1800*/ GIMT_Encode4(95581), // Rule ID 10762 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10762,
      GIR_EraseRootFromParent_Done,
    // Label 1800: @95581
    GIM_Try, /*On fail goto*//*Label 1801*/ GIMT_Encode4(95613), // Rule ID 10763 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv8bf16] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 10763,
      GIR_EraseRootFromParent_Done,
    // Label 1801: @95613
    GIM_Reject,
    // Label 1421: @95614
    GIM_Reject,
    // Label 10: @95615
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 1810*/ GIMT_Encode4(97037),
    /*GILLT_s16*//*Label 1802*/ GIMT_Encode4(95666),
    /*GILLT_s32*//*Label 1803*/ GIMT_Encode4(95697),
    /*GILLT_s64*//*Label 1804*/ GIMT_Encode4(95728), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 1805*/ GIMT_Encode4(95759),
    /*GILLT_v2s64*//*Label 1806*/ GIMT_Encode4(95790),
    /*GILLT_v4s16*//*Label 1807*/ GIMT_Encode4(95821),
    /*GILLT_v4s32*//*Label 1808*/ GIMT_Encode4(95852), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 1809*/ GIMT_Encode4(95883),
    // Label 1802: @95666
    GIM_Try, /*On fail goto*//*Label 1811*/ GIMT_Encode4(95696), // Rule ID 560 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // (ftrunc:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTZHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZHr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 560,
      GIR_Done,
    // Label 1811: @95696
    GIM_Reject,
    // Label 1803: @95697
    GIM_Try, /*On fail goto*//*Label 1812*/ GIMT_Encode4(95727), // Rule ID 562 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      // (ftrunc:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTZSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZSr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 562,
      GIR_Done,
    // Label 1812: @95727
    GIM_Reject,
    // Label 1804: @95728
    GIM_Try, /*On fail goto*//*Label 1813*/ GIMT_Encode4(95758), // Rule ID 564 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (ftrunc:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTZDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZDr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 564,
      GIR_Done,
    // Label 1813: @95758
    GIM_Reject,
    // Label 1805: @95759
    GIM_Try, /*On fail goto*//*Label 1814*/ GIMT_Encode4(95789), // Rule ID 922 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (ftrunc:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTZv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv2f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 922,
      GIR_Done,
    // Label 1814: @95789
    GIM_Reject,
    // Label 1806: @95790
    GIM_Try, /*On fail goto*//*Label 1815*/ GIMT_Encode4(95820), // Rule ID 926 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (ftrunc:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTZv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv2f64),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 926,
      GIR_Done,
    // Label 1815: @95820
    GIM_Reject,
    // Label 1807: @95821
    GIM_Try, /*On fail goto*//*Label 1816*/ GIMT_Encode4(95851), // Rule ID 918 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (ftrunc:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTZv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 918,
      GIR_Done,
    // Label 1816: @95851
    GIM_Reject,
    // Label 1808: @95852
    GIM_Try, /*On fail goto*//*Label 1817*/ GIMT_Encode4(95882), // Rule ID 924 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (ftrunc:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTZv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 924,
      GIR_Done,
    // Label 1817: @95882
    GIM_Reject,
    // Label 1809: @95883
    GIM_Try, /*On fail goto*//*Label 1818*/ GIMT_Encode4(97036),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 1819*/ GIMT_Encode4(95918), // Rule ID 920 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        // (ftrunc:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTZv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv8f16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 920,
        GIR_Done,
      // Label 1819: @95918
      GIM_Try, /*On fail goto*//*Label 1820*/ GIMT_Encode4(96103), // Rule ID 7179 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
        // (ftrunc:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTZv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTZv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7179,
        GIR_EraseRootFromParent_Done,
      // Label 1820: @96103
      GIM_Try, /*On fail goto*//*Label 1821*/ GIMT_Encode4(96238), // Rule ID 7181 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16),
        // (ftrunc:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn)  =>  (BFCVTN2:{ *:[v8bf16] } (BFCVTN:{ *:[v8bf16] } (FRINTZv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })))), (FRINTZv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn)))
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::BFCVTN),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFCVTN2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7181,
        GIR_EraseRootFromParent_Done,
      // Label 1821: @96238
      GIM_Try, /*On fail goto*//*Label 1822*/ GIMT_Encode4(97035), // Rule ID 7183 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoBF16),
        // (ftrunc:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn)  =>  (UZP2v8i16:{ *:[v8bf16] } (BSPv16i8:{ *:[f128] } (FCMEQv4f32:{ *:[f128] } (FRINTZv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] }))), (FRINTZv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })))), (ADDv4i32:{ *:[f128] } (ADDv4i32:{ *:[f128] } (FRINTZv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] }))), (ANDv16i8:{ *:[f128] } (USHRv4i32_shift:{ *:[f128] } V128:{ *:[v8bf16] }:$Rn, 16:{ *:[i32] }), (MOVIv4i32:{ *:[f128] } 1:{ *:[i32] }, 0:{ *:[i32] }))), (MOVIv4s_msl:{ *:[f128] } 127:{ *:[i32] }, 264:{ *:[i32] })), (ORRv4i32:{ *:[f128] } (FRINTZv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] }))), 64:{ *:[i32] }, 16:{ *:[i32] })), (BSPv16i8:{ *:[f128] } (FCMEQv4f32:{ *:[f128] } (FRINTZv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn)), (FRINTZv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn))), (ADDv4i32:{ *:[f128] } (ADDv4i32:{ *:[f128] } (FRINTZv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn)), (ANDv16i8:{ *:[f128] } (USHRv4i32_shift:{ *:[f128] } V128:{ *:[v8bf16] }:$Rn, 16:{ *:[i32] }), (MOVIv4i32:{ *:[f128] } 1:{ *:[i32] }, 0:{ *:[i32] }))), (MOVIv4s_msl:{ *:[f128] } 127:{ *:[i32] }, 264:{ *:[i32] })), (ORRv4i32:{ *:[f128] } (FRINTZv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn)), 64:{ *:[i32] }, 16:{ *:[i32] })))
        GIR_MakeTempReg, /*TempRegID*/37, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/38, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/38, /*TempRegID*/37, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/38, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/38,
        GIR_MakeTempReg, /*TempRegID*/36, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/37, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
        GIR_AddTempRegister, /*InsnID*/37, /*TempRegID*/36, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/37, /*TempRegID*/37,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/37,
        GIR_MakeTempReg, /*TempRegID*/35, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/36, /*Opcode*/GIMT_Encode2(AArch64::ORRv4i32),
        GIR_AddTempRegister, /*InsnID*/36, /*TempRegID*/35, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/36, /*TempRegID*/36,
        GIR_AddImm8, /*InsnID*/36, /*Imm*/64,
        GIR_AddImm8, /*InsnID*/36, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/36,
        GIR_MakeTempReg, /*TempRegID*/34, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/35, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4s_msl),
        GIR_AddTempRegister, /*InsnID*/35, /*TempRegID*/34, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/35, /*Imm*/127,
        GIR_AddImm, /*InsnID*/35, /*Imm*/GIMT_Encode8(264),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/35,
        GIR_MakeTempReg, /*TempRegID*/33, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/34, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i32),
        GIR_AddTempRegister, /*InsnID*/34, /*TempRegID*/33, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/34, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/34, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/34,
        GIR_MakeTempReg, /*TempRegID*/32, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/33, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
        GIR_AddTempRegister, /*InsnID*/33, /*TempRegID*/32, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/33, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/33, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/33,
        GIR_MakeTempReg, /*TempRegID*/31, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/32, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
        GIR_AddTempRegister, /*InsnID*/32, /*TempRegID*/31, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/32, /*TempRegID*/32,
        GIR_AddSimpleTempRegister, /*InsnID*/32, /*TempRegID*/33,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/32,
        GIR_MakeTempReg, /*TempRegID*/30, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/31, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/31, /*TempRegID*/30, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/31, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/31,
        GIR_MakeTempReg, /*TempRegID*/29, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/30, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
        GIR_AddTempRegister, /*InsnID*/30, /*TempRegID*/29, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/30, /*TempRegID*/30,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/30,
        GIR_MakeTempReg, /*TempRegID*/28, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/29, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/29, /*TempRegID*/28, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/29, /*TempRegID*/29,
        GIR_AddSimpleTempRegister, /*InsnID*/29, /*TempRegID*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/29,
        GIR_MakeTempReg, /*TempRegID*/27, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/28, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/28, /*TempRegID*/27, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/28, /*TempRegID*/28,
        GIR_AddSimpleTempRegister, /*InsnID*/28, /*TempRegID*/34,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/28,
        GIR_MakeTempReg, /*TempRegID*/26, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/27, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/27, /*TempRegID*/26, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/27, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/27,
        GIR_MakeTempReg, /*TempRegID*/25, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/26, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
        GIR_AddTempRegister, /*InsnID*/26, /*TempRegID*/25, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/26, /*TempRegID*/26,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/26,
        GIR_MakeTempReg, /*TempRegID*/24, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/25, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/25, /*TempRegID*/24, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/25, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/25,
        GIR_MakeTempReg, /*TempRegID*/23, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/24, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
        GIR_AddTempRegister, /*InsnID*/24, /*TempRegID*/23, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/24, /*TempRegID*/24,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/24,
        GIR_MakeTempReg, /*TempRegID*/22, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/23, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
        GIR_AddTempRegister, /*InsnID*/23, /*TempRegID*/22, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/23, /*TempRegID*/23,
        GIR_AddSimpleTempRegister, /*InsnID*/23, /*TempRegID*/25,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/23,
        GIR_MakeTempReg, /*TempRegID*/21, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/22, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_AddTempRegister, /*InsnID*/22, /*TempRegID*/21, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/22, /*TempRegID*/22,
        GIR_AddSimpleTempRegister, /*InsnID*/22, /*TempRegID*/27,
        GIR_AddSimpleTempRegister, /*InsnID*/22, /*TempRegID*/35,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/22,
        GIR_MakeTempReg, /*TempRegID*/20, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/21, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/21, /*TempRegID*/20, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/21, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/21, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/21, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/19, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/20, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/20, /*TempRegID*/19, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/20, /*TempRegID*/20,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/20,
        GIR_MakeTempReg, /*TempRegID*/18, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/19, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
        GIR_AddTempRegister, /*InsnID*/19, /*TempRegID*/18, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/19, /*TempRegID*/19,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/19,
        GIR_MakeTempReg, /*TempRegID*/17, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/18, /*Opcode*/GIMT_Encode2(AArch64::ORRv4i32),
        GIR_AddTempRegister, /*InsnID*/18, /*TempRegID*/17, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/18, /*TempRegID*/18,
        GIR_AddImm8, /*InsnID*/18, /*Imm*/64,
        GIR_AddImm8, /*InsnID*/18, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/18,
        GIR_MakeTempReg, /*TempRegID*/16, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/17, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4s_msl),
        GIR_AddTempRegister, /*InsnID*/17, /*TempRegID*/16, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/17, /*Imm*/127,
        GIR_AddImm, /*InsnID*/17, /*Imm*/GIMT_Encode8(264),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/17,
        GIR_MakeTempReg, /*TempRegID*/15, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/16, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i32),
        GIR_AddTempRegister, /*InsnID*/16, /*TempRegID*/15, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/16, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/16, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/16,
        GIR_MakeTempReg, /*TempRegID*/14, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/15, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
        GIR_AddTempRegister, /*InsnID*/15, /*TempRegID*/14, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/15, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/15, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/15,
        GIR_MakeTempReg, /*TempRegID*/13, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/14, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
        GIR_AddTempRegister, /*InsnID*/14, /*TempRegID*/13, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/14,
        GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/15,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/14,
        GIR_MakeTempReg, /*TempRegID*/12, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/13, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/13, /*TempRegID*/12, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/13, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/13, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/13, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/12, /*TempRegID*/12,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/12,
        GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
        GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/11, /*TempRegID*/11,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
        GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
        GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/13,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/8,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/17,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/21,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7183,
        GIR_EraseRootFromParent_Done,
      // Label 1822: @97035
      GIM_Reject,
    // Label 1818: @97036
    GIM_Reject,
    // Label 1810: @97037
    GIM_Reject,
    // Label 11: @97038
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 1831*/ GIMT_Encode4(98460),
    /*GILLT_s16*//*Label 1823*/ GIMT_Encode4(97089),
    /*GILLT_s32*//*Label 1824*/ GIMT_Encode4(97120),
    /*GILLT_s64*//*Label 1825*/ GIMT_Encode4(97151), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 1826*/ GIMT_Encode4(97182),
    /*GILLT_v2s64*//*Label 1827*/ GIMT_Encode4(97213),
    /*GILLT_v4s16*//*Label 1828*/ GIMT_Encode4(97244),
    /*GILLT_v4s32*//*Label 1829*/ GIMT_Encode4(97275), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 1830*/ GIMT_Encode4(97306),
    // Label 1823: @97089
    GIM_Try, /*On fail goto*//*Label 1832*/ GIMT_Encode4(97119), // Rule ID 524 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // (fround:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTAHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAHr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 524,
      GIR_Done,
    // Label 1832: @97119
    GIM_Reject,
    // Label 1824: @97120
    GIM_Try, /*On fail goto*//*Label 1833*/ GIMT_Encode4(97150), // Rule ID 526 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      // (fround:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTASr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTASr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 526,
      GIR_Done,
    // Label 1833: @97150
    GIM_Reject,
    // Label 1825: @97151
    GIM_Try, /*On fail goto*//*Label 1834*/ GIMT_Encode4(97181), // Rule ID 528 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fround:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTADr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTADr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 528,
      GIR_Done,
    // Label 1834: @97181
    GIM_Reject,
    // Label 1826: @97182
    GIM_Try, /*On fail goto*//*Label 1835*/ GIMT_Encode4(97212), // Rule ID 862 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fround:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTAv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv2f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 862,
      GIR_Done,
    // Label 1835: @97212
    GIM_Reject,
    // Label 1827: @97213
    GIM_Try, /*On fail goto*//*Label 1836*/ GIMT_Encode4(97243), // Rule ID 866 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fround:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTAv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv2f64),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 866,
      GIR_Done,
    // Label 1836: @97243
    GIM_Reject,
    // Label 1828: @97244
    GIM_Try, /*On fail goto*//*Label 1837*/ GIMT_Encode4(97274), // Rule ID 858 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fround:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTAv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 858,
      GIR_Done,
    // Label 1837: @97274
    GIM_Reject,
    // Label 1829: @97275
    GIM_Try, /*On fail goto*//*Label 1838*/ GIMT_Encode4(97305), // Rule ID 864 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fround:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTAv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 864,
      GIR_Done,
    // Label 1838: @97305
    GIM_Reject,
    // Label 1830: @97306
    GIM_Try, /*On fail goto*//*Label 1839*/ GIMT_Encode4(98459),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 1840*/ GIMT_Encode4(97341), // Rule ID 860 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        // (fround:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTAv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv8f16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 860,
        GIR_Done,
      // Label 1840: @97341
      GIM_Try, /*On fail goto*//*Label 1841*/ GIMT_Encode4(97526), // Rule ID 7161 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
        // (fround:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTAv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTAv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7161,
        GIR_EraseRootFromParent_Done,
      // Label 1841: @97526
      GIM_Try, /*On fail goto*//*Label 1842*/ GIMT_Encode4(97661), // Rule ID 7163 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16),
        // (fround:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn)  =>  (BFCVTN2:{ *:[v8bf16] } (BFCVTN:{ *:[v8bf16] } (FRINTAv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })))), (FRINTAv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn)))
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::BFCVTN),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFCVTN2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7163,
        GIR_EraseRootFromParent_Done,
      // Label 1842: @97661
      GIM_Try, /*On fail goto*//*Label 1843*/ GIMT_Encode4(98458), // Rule ID 7165 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoBF16),
        // (fround:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn)  =>  (UZP2v8i16:{ *:[v8bf16] } (BSPv16i8:{ *:[f128] } (FCMEQv4f32:{ *:[f128] } (FRINTAv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] }))), (FRINTAv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })))), (ADDv4i32:{ *:[f128] } (ADDv4i32:{ *:[f128] } (FRINTAv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] }))), (ANDv16i8:{ *:[f128] } (USHRv4i32_shift:{ *:[f128] } V128:{ *:[v8bf16] }:$Rn, 16:{ *:[i32] }), (MOVIv4i32:{ *:[f128] } 1:{ *:[i32] }, 0:{ *:[i32] }))), (MOVIv4s_msl:{ *:[f128] } 127:{ *:[i32] }, 264:{ *:[i32] })), (ORRv4i32:{ *:[f128] } (FRINTAv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] }))), 64:{ *:[i32] }, 16:{ *:[i32] })), (BSPv16i8:{ *:[f128] } (FCMEQv4f32:{ *:[f128] } (FRINTAv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn)), (FRINTAv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn))), (ADDv4i32:{ *:[f128] } (ADDv4i32:{ *:[f128] } (FRINTAv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn)), (ANDv16i8:{ *:[f128] } (USHRv4i32_shift:{ *:[f128] } V128:{ *:[v8bf16] }:$Rn, 16:{ *:[i32] }), (MOVIv4i32:{ *:[f128] } 1:{ *:[i32] }, 0:{ *:[i32] }))), (MOVIv4s_msl:{ *:[f128] } 127:{ *:[i32] }, 264:{ *:[i32] })), (ORRv4i32:{ *:[f128] } (FRINTAv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn)), 64:{ *:[i32] }, 16:{ *:[i32] })))
        GIR_MakeTempReg, /*TempRegID*/37, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/38, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/38, /*TempRegID*/37, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/38, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/38,
        GIR_MakeTempReg, /*TempRegID*/36, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/37, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
        GIR_AddTempRegister, /*InsnID*/37, /*TempRegID*/36, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/37, /*TempRegID*/37,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/37,
        GIR_MakeTempReg, /*TempRegID*/35, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/36, /*Opcode*/GIMT_Encode2(AArch64::ORRv4i32),
        GIR_AddTempRegister, /*InsnID*/36, /*TempRegID*/35, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/36, /*TempRegID*/36,
        GIR_AddImm8, /*InsnID*/36, /*Imm*/64,
        GIR_AddImm8, /*InsnID*/36, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/36,
        GIR_MakeTempReg, /*TempRegID*/34, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/35, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4s_msl),
        GIR_AddTempRegister, /*InsnID*/35, /*TempRegID*/34, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/35, /*Imm*/127,
        GIR_AddImm, /*InsnID*/35, /*Imm*/GIMT_Encode8(264),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/35,
        GIR_MakeTempReg, /*TempRegID*/33, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/34, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i32),
        GIR_AddTempRegister, /*InsnID*/34, /*TempRegID*/33, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/34, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/34, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/34,
        GIR_MakeTempReg, /*TempRegID*/32, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/33, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
        GIR_AddTempRegister, /*InsnID*/33, /*TempRegID*/32, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/33, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/33, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/33,
        GIR_MakeTempReg, /*TempRegID*/31, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/32, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
        GIR_AddTempRegister, /*InsnID*/32, /*TempRegID*/31, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/32, /*TempRegID*/32,
        GIR_AddSimpleTempRegister, /*InsnID*/32, /*TempRegID*/33,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/32,
        GIR_MakeTempReg, /*TempRegID*/30, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/31, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/31, /*TempRegID*/30, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/31, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/31,
        GIR_MakeTempReg, /*TempRegID*/29, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/30, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
        GIR_AddTempRegister, /*InsnID*/30, /*TempRegID*/29, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/30, /*TempRegID*/30,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/30,
        GIR_MakeTempReg, /*TempRegID*/28, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/29, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/29, /*TempRegID*/28, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/29, /*TempRegID*/29,
        GIR_AddSimpleTempRegister, /*InsnID*/29, /*TempRegID*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/29,
        GIR_MakeTempReg, /*TempRegID*/27, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/28, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/28, /*TempRegID*/27, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/28, /*TempRegID*/28,
        GIR_AddSimpleTempRegister, /*InsnID*/28, /*TempRegID*/34,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/28,
        GIR_MakeTempReg, /*TempRegID*/26, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/27, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/27, /*TempRegID*/26, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/27, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/27,
        GIR_MakeTempReg, /*TempRegID*/25, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/26, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
        GIR_AddTempRegister, /*InsnID*/26, /*TempRegID*/25, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/26, /*TempRegID*/26,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/26,
        GIR_MakeTempReg, /*TempRegID*/24, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/25, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/25, /*TempRegID*/24, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/25, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/25,
        GIR_MakeTempReg, /*TempRegID*/23, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/24, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
        GIR_AddTempRegister, /*InsnID*/24, /*TempRegID*/23, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/24, /*TempRegID*/24,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/24,
        GIR_MakeTempReg, /*TempRegID*/22, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/23, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
        GIR_AddTempRegister, /*InsnID*/23, /*TempRegID*/22, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/23, /*TempRegID*/23,
        GIR_AddSimpleTempRegister, /*InsnID*/23, /*TempRegID*/25,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/23,
        GIR_MakeTempReg, /*TempRegID*/21, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/22, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_AddTempRegister, /*InsnID*/22, /*TempRegID*/21, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/22, /*TempRegID*/22,
        GIR_AddSimpleTempRegister, /*InsnID*/22, /*TempRegID*/27,
        GIR_AddSimpleTempRegister, /*InsnID*/22, /*TempRegID*/35,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/22,
        GIR_MakeTempReg, /*TempRegID*/20, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/21, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/21, /*TempRegID*/20, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/21, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/21, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/21, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/19, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/20, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/20, /*TempRegID*/19, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/20, /*TempRegID*/20,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/20,
        GIR_MakeTempReg, /*TempRegID*/18, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/19, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
        GIR_AddTempRegister, /*InsnID*/19, /*TempRegID*/18, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/19, /*TempRegID*/19,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/19,
        GIR_MakeTempReg, /*TempRegID*/17, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/18, /*Opcode*/GIMT_Encode2(AArch64::ORRv4i32),
        GIR_AddTempRegister, /*InsnID*/18, /*TempRegID*/17, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/18, /*TempRegID*/18,
        GIR_AddImm8, /*InsnID*/18, /*Imm*/64,
        GIR_AddImm8, /*InsnID*/18, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/18,
        GIR_MakeTempReg, /*TempRegID*/16, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/17, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4s_msl),
        GIR_AddTempRegister, /*InsnID*/17, /*TempRegID*/16, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/17, /*Imm*/127,
        GIR_AddImm, /*InsnID*/17, /*Imm*/GIMT_Encode8(264),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/17,
        GIR_MakeTempReg, /*TempRegID*/15, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/16, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i32),
        GIR_AddTempRegister, /*InsnID*/16, /*TempRegID*/15, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/16, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/16, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/16,
        GIR_MakeTempReg, /*TempRegID*/14, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/15, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
        GIR_AddTempRegister, /*InsnID*/15, /*TempRegID*/14, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/15, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/15, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/15,
        GIR_MakeTempReg, /*TempRegID*/13, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/14, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
        GIR_AddTempRegister, /*InsnID*/14, /*TempRegID*/13, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/14,
        GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/15,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/14,
        GIR_MakeTempReg, /*TempRegID*/12, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/13, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/13, /*TempRegID*/12, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/13, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/13, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/13, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/12, /*TempRegID*/12,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/12,
        GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
        GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/11, /*TempRegID*/11,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
        GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
        GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/13,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/8,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/17,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/21,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7165,
        GIR_EraseRootFromParent_Done,
      // Label 1843: @98458
      GIM_Reject,
    // Label 1839: @98459
    GIM_Reject,
    // Label 1831: @98460
    GIM_Reject,
    // Label 12: @98461
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 1846*/ GIMT_Encode4(98728),
    /*GILLT_s32*//*Label 1844*/ GIMT_Encode4(98480),
    /*GILLT_s64*//*Label 1845*/ GIMT_Encode4(98604),
    // Label 1844: @98480
    GIM_Try, /*On fail goto*//*Label 1847*/ GIMT_Encode4(98523), // Rule ID 4818 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // (lrint:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } (FRINTXHr:{ *:[i16] } f16:{ *:[f16] }:$Rn))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4818,
      GIR_EraseRootFromParent_Done,
    // Label 1847: @98523
    GIM_Try, /*On fail goto*//*Label 1848*/ GIMT_Encode4(98563), // Rule ID 4824 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // (lrint:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } (FRINTXSr:{ *:[i32] } f32:{ *:[f32] }:$Rn))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4824,
      GIR_EraseRootFromParent_Done,
    // Label 1848: @98563
    GIM_Try, /*On fail goto*//*Label 1849*/ GIMT_Encode4(98603), // Rule ID 4826 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // (lrint:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } (FRINTXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4826,
      GIR_EraseRootFromParent_Done,
    // Label 1849: @98603
    GIM_Reject,
    // Label 1845: @98604
    GIM_Try, /*On fail goto*//*Label 1850*/ GIMT_Encode4(98647), // Rule ID 4820 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (lrint:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } (FRINTXHr:{ *:[i16] } f16:{ *:[f16] }:$Rn))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4820,
      GIR_EraseRootFromParent_Done,
    // Label 1850: @98647
    GIM_Try, /*On fail goto*//*Label 1851*/ GIMT_Encode4(98687), // Rule ID 4828 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (lrint:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } (FRINTXSr:{ *:[i32] } f32:{ *:[f32] }:$Rn))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4828,
      GIR_EraseRootFromParent_Done,
    // Label 1851: @98687
    GIM_Try, /*On fail goto*//*Label 1852*/ GIMT_Encode4(98727), // Rule ID 4830 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (lrint:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } (FRINTXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4830,
      GIR_EraseRootFromParent_Done,
    // Label 1852: @98727
    GIM_Reject,
    // Label 1846: @98728
    GIM_Reject,
    // Label 13: @98729
    GIM_Try, /*On fail goto*//*Label 1853*/ GIMT_Encode4(98878),
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
      GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 1857*/ GIMT_Encode4(98877),
      /*GILLT_s16*//*Label 1854*/ GIMT_Encode4(98760),
      /*GILLT_s32*//*Label 1855*/ GIMT_Encode4(98801),
      /*GILLT_s64*//*Label 1856*/ GIMT_Encode4(98839),
      // Label 1854: @98760
      GIM_Try, /*On fail goto*//*Label 1858*/ GIMT_Encode4(98800), // Rule ID 4822 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (llrint:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } (FRINTXHr:{ *:[i16] } f16:{ *:[f16] }:$Rn))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4822,
        GIR_EraseRootFromParent_Done,
      // Label 1858: @98800
      GIM_Reject,
      // Label 1855: @98801
      GIM_Try, /*On fail goto*//*Label 1859*/ GIMT_Encode4(98838), // Rule ID 4832 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (llrint:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } (FRINTXSr:{ *:[i32] } f32:{ *:[f32] }:$Rn))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4832,
        GIR_EraseRootFromParent_Done,
      // Label 1859: @98838
      GIM_Reject,
      // Label 1856: @98839
      GIM_Try, /*On fail goto*//*Label 1860*/ GIMT_Encode4(98876), // Rule ID 4834 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (llrint:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } (FRINTXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4834,
        GIR_EraseRootFromParent_Done,
      // Label 1860: @98876
      GIM_Reject,
      // Label 1857: @98877
      GIM_Reject,
    // Label 1853: @98878
    GIM_Reject,
    // Label 14: @98879
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 1869*/ GIMT_Encode4(100301),
    /*GILLT_s16*//*Label 1861*/ GIMT_Encode4(98930),
    /*GILLT_s32*//*Label 1862*/ GIMT_Encode4(98961),
    /*GILLT_s64*//*Label 1863*/ GIMT_Encode4(98992), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 1864*/ GIMT_Encode4(99023),
    /*GILLT_v2s64*//*Label 1865*/ GIMT_Encode4(99054),
    /*GILLT_v4s16*//*Label 1866*/ GIMT_Encode4(99085),
    /*GILLT_v4s32*//*Label 1867*/ GIMT_Encode4(99116), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 1868*/ GIMT_Encode4(99147),
    // Label 1861: @98930
    GIM_Try, /*On fail goto*//*Label 1870*/ GIMT_Encode4(98960), // Rule ID 542 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // (froundeven:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTNHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNHr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 542,
      GIR_Done,
    // Label 1870: @98960
    GIM_Reject,
    // Label 1862: @98961
    GIM_Try, /*On fail goto*//*Label 1871*/ GIMT_Encode4(98991), // Rule ID 544 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      // (froundeven:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTNSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNSr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 544,
      GIR_Done,
    // Label 1871: @98991
    GIM_Reject,
    // Label 1863: @98992
    GIM_Try, /*On fail goto*//*Label 1872*/ GIMT_Encode4(99022), // Rule ID 546 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (froundeven:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTNDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNDr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 546,
      GIR_Done,
    // Label 1872: @99022
    GIM_Reject,
    // Label 1864: @99023
    GIM_Try, /*On fail goto*//*Label 1873*/ GIMT_Encode4(99053), // Rule ID 892 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (froundeven:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTNv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv2f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 892,
      GIR_Done,
    // Label 1873: @99053
    GIM_Reject,
    // Label 1865: @99054
    GIM_Try, /*On fail goto*//*Label 1874*/ GIMT_Encode4(99084), // Rule ID 896 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (froundeven:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTNv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv2f64),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 896,
      GIR_Done,
    // Label 1874: @99084
    GIM_Reject,
    // Label 1866: @99085
    GIM_Try, /*On fail goto*//*Label 1875*/ GIMT_Encode4(99115), // Rule ID 888 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (froundeven:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTNv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 888,
      GIR_Done,
    // Label 1875: @99115
    GIM_Reject,
    // Label 1867: @99116
    GIM_Try, /*On fail goto*//*Label 1876*/ GIMT_Encode4(99146), // Rule ID 894 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (froundeven:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTNv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 894,
      GIR_Done,
    // Label 1876: @99146
    GIM_Reject,
    // Label 1868: @99147
    GIM_Try, /*On fail goto*//*Label 1877*/ GIMT_Encode4(100300),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 1878*/ GIMT_Encode4(99182), // Rule ID 890 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        // (froundeven:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTNv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv8f16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 890,
        GIR_Done,
      // Label 1878: @99182
      GIM_Try, /*On fail goto*//*Label 1879*/ GIMT_Encode4(99367), // Rule ID 7167 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
        // (froundeven:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTNv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTNv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7167,
        GIR_EraseRootFromParent_Done,
      // Label 1879: @99367
      GIM_Try, /*On fail goto*//*Label 1880*/ GIMT_Encode4(99502), // Rule ID 7169 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16),
        // (froundeven:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn)  =>  (BFCVTN2:{ *:[v8bf16] } (BFCVTN:{ *:[v8bf16] } (FRINTNv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })))), (FRINTNv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn)))
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::BFCVTN),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFCVTN2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7169,
        GIR_EraseRootFromParent_Done,
      // Label 1880: @99502
      GIM_Try, /*On fail goto*//*Label 1881*/ GIMT_Encode4(100299), // Rule ID 7171 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoBF16),
        // (froundeven:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn)  =>  (UZP2v8i16:{ *:[v8bf16] } (BSPv16i8:{ *:[f128] } (FCMEQv4f32:{ *:[f128] } (FRINTNv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] }))), (FRINTNv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })))), (ADDv4i32:{ *:[f128] } (ADDv4i32:{ *:[f128] } (FRINTNv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] }))), (ANDv16i8:{ *:[f128] } (USHRv4i32_shift:{ *:[f128] } V128:{ *:[v8bf16] }:$Rn, 16:{ *:[i32] }), (MOVIv4i32:{ *:[f128] } 1:{ *:[i32] }, 0:{ *:[i32] }))), (MOVIv4s_msl:{ *:[f128] } 127:{ *:[i32] }, 264:{ *:[i32] })), (ORRv4i32:{ *:[f128] } (FRINTNv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] }))), 64:{ *:[i32] }, 16:{ *:[i32] })), (BSPv16i8:{ *:[f128] } (FCMEQv4f32:{ *:[f128] } (FRINTNv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn)), (FRINTNv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn))), (ADDv4i32:{ *:[f128] } (ADDv4i32:{ *:[f128] } (FRINTNv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn)), (ANDv16i8:{ *:[f128] } (USHRv4i32_shift:{ *:[f128] } V128:{ *:[v8bf16] }:$Rn, 16:{ *:[i32] }), (MOVIv4i32:{ *:[f128] } 1:{ *:[i32] }, 0:{ *:[i32] }))), (MOVIv4s_msl:{ *:[f128] } 127:{ *:[i32] }, 264:{ *:[i32] })), (ORRv4i32:{ *:[f128] } (FRINTNv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn)), 64:{ *:[i32] }, 16:{ *:[i32] })))
        GIR_MakeTempReg, /*TempRegID*/37, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/38, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/38, /*TempRegID*/37, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/38, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/38,
        GIR_MakeTempReg, /*TempRegID*/36, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/37, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
        GIR_AddTempRegister, /*InsnID*/37, /*TempRegID*/36, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/37, /*TempRegID*/37,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/37,
        GIR_MakeTempReg, /*TempRegID*/35, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/36, /*Opcode*/GIMT_Encode2(AArch64::ORRv4i32),
        GIR_AddTempRegister, /*InsnID*/36, /*TempRegID*/35, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/36, /*TempRegID*/36,
        GIR_AddImm8, /*InsnID*/36, /*Imm*/64,
        GIR_AddImm8, /*InsnID*/36, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/36,
        GIR_MakeTempReg, /*TempRegID*/34, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/35, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4s_msl),
        GIR_AddTempRegister, /*InsnID*/35, /*TempRegID*/34, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/35, /*Imm*/127,
        GIR_AddImm, /*InsnID*/35, /*Imm*/GIMT_Encode8(264),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/35,
        GIR_MakeTempReg, /*TempRegID*/33, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/34, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i32),
        GIR_AddTempRegister, /*InsnID*/34, /*TempRegID*/33, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/34, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/34, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/34,
        GIR_MakeTempReg, /*TempRegID*/32, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/33, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
        GIR_AddTempRegister, /*InsnID*/33, /*TempRegID*/32, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/33, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/33, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/33,
        GIR_MakeTempReg, /*TempRegID*/31, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/32, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
        GIR_AddTempRegister, /*InsnID*/32, /*TempRegID*/31, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/32, /*TempRegID*/32,
        GIR_AddSimpleTempRegister, /*InsnID*/32, /*TempRegID*/33,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/32,
        GIR_MakeTempReg, /*TempRegID*/30, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/31, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/31, /*TempRegID*/30, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/31, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/31,
        GIR_MakeTempReg, /*TempRegID*/29, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/30, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
        GIR_AddTempRegister, /*InsnID*/30, /*TempRegID*/29, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/30, /*TempRegID*/30,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/30,
        GIR_MakeTempReg, /*TempRegID*/28, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/29, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/29, /*TempRegID*/28, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/29, /*TempRegID*/29,
        GIR_AddSimpleTempRegister, /*InsnID*/29, /*TempRegID*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/29,
        GIR_MakeTempReg, /*TempRegID*/27, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/28, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/28, /*TempRegID*/27, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/28, /*TempRegID*/28,
        GIR_AddSimpleTempRegister, /*InsnID*/28, /*TempRegID*/34,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/28,
        GIR_MakeTempReg, /*TempRegID*/26, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/27, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/27, /*TempRegID*/26, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/27, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/27,
        GIR_MakeTempReg, /*TempRegID*/25, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/26, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
        GIR_AddTempRegister, /*InsnID*/26, /*TempRegID*/25, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/26, /*TempRegID*/26,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/26,
        GIR_MakeTempReg, /*TempRegID*/24, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/25, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/25, /*TempRegID*/24, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/25, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/25,
        GIR_MakeTempReg, /*TempRegID*/23, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/24, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
        GIR_AddTempRegister, /*InsnID*/24, /*TempRegID*/23, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/24, /*TempRegID*/24,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/24,
        GIR_MakeTempReg, /*TempRegID*/22, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/23, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
        GIR_AddTempRegister, /*InsnID*/23, /*TempRegID*/22, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/23, /*TempRegID*/23,
        GIR_AddSimpleTempRegister, /*InsnID*/23, /*TempRegID*/25,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/23,
        GIR_MakeTempReg, /*TempRegID*/21, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/22, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_AddTempRegister, /*InsnID*/22, /*TempRegID*/21, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/22, /*TempRegID*/22,
        GIR_AddSimpleTempRegister, /*InsnID*/22, /*TempRegID*/27,
        GIR_AddSimpleTempRegister, /*InsnID*/22, /*TempRegID*/35,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/22,
        GIR_MakeTempReg, /*TempRegID*/20, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/21, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/21, /*TempRegID*/20, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/21, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/21, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/21, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/19, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/20, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/20, /*TempRegID*/19, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/20, /*TempRegID*/20,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/20,
        GIR_MakeTempReg, /*TempRegID*/18, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/19, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
        GIR_AddTempRegister, /*InsnID*/19, /*TempRegID*/18, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/19, /*TempRegID*/19,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/19,
        GIR_MakeTempReg, /*TempRegID*/17, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/18, /*Opcode*/GIMT_Encode2(AArch64::ORRv4i32),
        GIR_AddTempRegister, /*InsnID*/18, /*TempRegID*/17, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/18, /*TempRegID*/18,
        GIR_AddImm8, /*InsnID*/18, /*Imm*/64,
        GIR_AddImm8, /*InsnID*/18, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/18,
        GIR_MakeTempReg, /*TempRegID*/16, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/17, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4s_msl),
        GIR_AddTempRegister, /*InsnID*/17, /*TempRegID*/16, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/17, /*Imm*/127,
        GIR_AddImm, /*InsnID*/17, /*Imm*/GIMT_Encode8(264),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/17,
        GIR_MakeTempReg, /*TempRegID*/15, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/16, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i32),
        GIR_AddTempRegister, /*InsnID*/16, /*TempRegID*/15, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/16, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/16, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/16,
        GIR_MakeTempReg, /*TempRegID*/14, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/15, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
        GIR_AddTempRegister, /*InsnID*/15, /*TempRegID*/14, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/15, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/15, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/15,
        GIR_MakeTempReg, /*TempRegID*/13, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/14, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
        GIR_AddTempRegister, /*InsnID*/14, /*TempRegID*/13, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/14,
        GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/15,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/14,
        GIR_MakeTempReg, /*TempRegID*/12, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/13, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/13, /*TempRegID*/12, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/13, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/13, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/13, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/12, /*TempRegID*/12,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/12,
        GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
        GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/11, /*TempRegID*/11,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
        GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
        GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/13,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/8,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/17,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/21,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7171,
        GIR_EraseRootFromParent_Done,
      // Label 1881: @100299
      GIM_Reject,
    // Label 1877: @100300
    GIM_Reject,
    // Label 1869: @100301
    GIM_Reject,
    // Label 15: @100302
    GIM_Try, /*On fail goto*//*Label 1882*/ GIMT_Encode4(100334), // Rule ID 3884 //
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (readcyclecounter:{ *:[i64] })  =>  (MRS:{ *:[i64] }:{ *:[i32] } 57090:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(57090),
      GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3884,
      GIR_EraseRootFromParent_Done,
    // Label 1882: @100334
    GIM_Reject,
    // Label 16: @100335
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(24), /*)*//*default:*//*Label 1903*/ GIMT_Encode4(109400),
    /*GILLT_s8*//*Label 1883*/ GIMT_Encode4(100442),
    /*GILLT_s16*//*Label 1884*/ GIMT_Encode4(100618),
    /*GILLT_s32*//*Label 1885*/ GIMT_Encode4(100860),
    /*GILLT_s64*//*Label 1886*/ GIMT_Encode4(103158),
    /*GILLT_s128*//*Label 1887*/ GIMT_Encode4(105839),
    /*GILLT_v2s32*//*Label 1888*/ GIMT_Encode4(106048),
    /*GILLT_v2s64*//*Label 1889*/ GIMT_Encode4(106426),
    /*GILLT_v4s16*//*Label 1890*/ GIMT_Encode4(106804),
    /*GILLT_v4s32*//*Label 1891*/ GIMT_Encode4(107312),
    /*GILLT_v8s8*//*Label 1892*/ GIMT_Encode4(107690),
    /*GILLT_v8s16*//*Label 1893*/ GIMT_Encode4(107898),
    /*GILLT_v16s8*//*Label 1894*/ GIMT_Encode4(108406), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s16*//*Label 1895*/ GIMT_Encode4(108614),
    /*GILLT_nxv2s32*//*Label 1896*/ GIMT_Encode4(108728),
    /*GILLT_nxv2s64*//*Label 1897*/ GIMT_Encode4(108792), GIMT_Encode4(0),
    /*GILLT_nxv4s16*//*Label 1898*/ GIMT_Encode4(108906),
    /*GILLT_nxv4s32*//*Label 1899*/ GIMT_Encode4(109020), GIMT_Encode4(0),
    /*GILLT_nxv8s16*//*Label 1900*/ GIMT_Encode4(109134),
    /*GILLT_nxv16s1*//*Label 1901*/ GIMT_Encode4(109292),
    /*GILLT_nxv16s8*//*Label 1902*/ GIMT_Encode4(109336),
    // Label 1883: @100442
    GIM_Try, /*On fail goto*//*Label 1904*/ GIMT_Encode4(100617),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_Try, /*On fail goto*//*Label 1905*/ GIMT_Encode4(100503), // Rule ID 249 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
        // (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 249,
        GIR_EraseRootFromParent_Done,
      // Label 1905: @100503
      GIM_Try, /*On fail goto*//*Label 1906*/ GIMT_Encode4(100544), // Rule ID 250 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
        // (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 250,
        GIR_EraseRootFromParent_Done,
      // Label 1906: @100544
      GIM_Try, /*On fail goto*//*Label 1907*/ GIMT_Encode4(100580), // Rule ID 273 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
        // (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 273,
        GIR_EraseRootFromParent_Done,
      // Label 1907: @100580
      GIM_Try, /*On fail goto*//*Label 1908*/ GIMT_Encode4(100616), // Rule ID 294 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
        // (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 294,
        GIR_EraseRootFromParent_Done,
      // Label 1908: @100616
      GIM_Reject,
    // Label 1904: @100617
    GIM_Reject,
    // Label 1884: @100618
    GIM_Try, /*On fail goto*//*Label 1909*/ GIMT_Encode4(100859),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_Try, /*On fail goto*//*Label 1910*/ GIMT_Encode4(100679), // Rule ID 251 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
        // (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRHroW:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 251,
        GIR_EraseRootFromParent_Done,
      // Label 1910: @100679
      GIM_Try, /*On fail goto*//*Label 1911*/ GIMT_Encode4(100720), // Rule ID 252 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
        // (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRHroX:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 252,
        GIR_EraseRootFromParent_Done,
      // Label 1911: @100720
      GIM_Try, /*On fail goto*//*Label 1912*/ GIMT_Encode4(100756), // Rule ID 274 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
        // (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRHui:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 274,
        GIR_EraseRootFromParent_Done,
      // Label 1912: @100756
      GIM_Try, /*On fail goto*//*Label 1913*/ GIMT_Encode4(100792), // Rule ID 295 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
        // (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURHi:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 295,
        GIR_EraseRootFromParent_Done,
      // Label 1913: @100792
      GIM_Try, /*On fail goto*//*Label 1914*/ GIMT_Encode4(100825), // Rule ID 4112 //
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
        // (ld:{ *:[bf16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRHui:{ *:[bf16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4112,
        GIR_EraseRootFromParent_Done,
      // Label 1914: @100825
      GIM_Try, /*On fail goto*//*Label 1915*/ GIMT_Encode4(100858), // Rule ID 4143 //
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
        // (ld:{ *:[bf16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURHi:{ *:[bf16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4143,
        GIR_EraseRootFromParent_Done,
      // Label 1915: @100858
      GIM_Reject,
    // Label 1909: @100859
    GIM_Reject,
    // Label 1885: @100860
    GIM_Try, /*On fail goto*//*Label 1916*/ GIMT_Encode4(100913), // Rule ID 245 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
      // (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 245,
      GIR_EraseRootFromParent_Done,
    // Label 1916: @100913
    GIM_Try, /*On fail goto*//*Label 1917*/ GIMT_Encode4(100966), // Rule ID 246 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
      // (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 246,
      GIR_EraseRootFromParent_Done,
    // Label 1917: @100966
    GIM_Try, /*On fail goto*//*Label 1918*/ GIMT_Encode4(101022), // Rule ID 253 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
      // (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRSroW:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 253,
      GIR_EraseRootFromParent_Done,
    // Label 1918: @101022
    GIM_Try, /*On fail goto*//*Label 1919*/ GIMT_Encode4(101078), // Rule ID 254 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
      // (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRSroX:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 254,
      GIR_EraseRootFromParent_Done,
    // Label 1919: @101078
    GIM_Try, /*On fail goto*//*Label 1920*/ GIMT_Encode4(101138), // Rule ID 4104 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
      // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4104,
      GIR_EraseRootFromParent_Done,
    // Label 1920: @101138
    GIM_Try, /*On fail goto*//*Label 1921*/ GIMT_Encode4(101198), // Rule ID 4105 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
      // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4105,
      GIR_EraseRootFromParent_Done,
    // Label 1921: @101198
    GIM_Try, /*On fail goto*//*Label 1922*/ GIMT_Encode4(101258), // Rule ID 4106 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
      // (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4106,
      GIR_EraseRootFromParent_Done,
    // Label 1922: @101258
    GIM_Try, /*On fail goto*//*Label 1923*/ GIMT_Encode4(101318), // Rule ID 4107 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
      // (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4107,
      GIR_EraseRootFromParent_Done,
    // Label 1923: @101318
    GIM_Try, /*On fail goto*//*Label 1924*/ GIMT_Encode4(101378), // Rule ID 4108 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
      // (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4108,
      GIR_EraseRootFromParent_Done,
    // Label 1924: @101378
    GIM_Try, /*On fail goto*//*Label 1925*/ GIMT_Encode4(101438), // Rule ID 4109 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
      // (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4109,
      GIR_EraseRootFromParent_Done,
    // Label 1925: @101438
    GIM_Try, /*On fail goto*//*Label 1926*/ GIMT_Encode4(101486), // Rule ID 272 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
      // (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 272,
      GIR_EraseRootFromParent_Done,
    // Label 1926: @101486
    GIM_Try, /*On fail goto*//*Label 1927*/ GIMT_Encode4(101537), // Rule ID 275 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
      // (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRSui:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 275,
      GIR_EraseRootFromParent_Done,
    // Label 1927: @101537
    GIM_Try, /*On fail goto*//*Label 1928*/ GIMT_Encode4(101596), // Rule ID 7219 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
      // (atomic_load:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15321>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7219,
      GIR_EraseRootFromParent_Done,
    // Label 1928: @101596
    GIM_Try, /*On fail goto*//*Label 1929*/ GIMT_Encode4(101655), // Rule ID 7221 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
      // (atomic_load:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15321>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7221,
      GIR_EraseRootFromParent_Done,
    // Label 1929: @101655
    GIM_Try, /*On fail goto*//*Label 1930*/ GIMT_Encode4(101714), // Rule ID 7231 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
      // (atomic_load:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15330>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7231,
      GIR_EraseRootFromParent_Done,
    // Label 1930: @101714
    GIM_Try, /*On fail goto*//*Label 1931*/ GIMT_Encode4(101773), // Rule ID 7233 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
      // (atomic_load:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15330>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7233,
      GIR_EraseRootFromParent_Done,
    // Label 1931: @101773
    GIM_Try, /*On fail goto*//*Label 1932*/ GIMT_Encode4(101832), // Rule ID 7241 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
      // (atomic_load:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15338>>  =>  (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7241,
      GIR_EraseRootFromParent_Done,
    // Label 1932: @101832
    GIM_Try, /*On fail goto*//*Label 1933*/ GIMT_Encode4(101891), // Rule ID 7242 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
      // (atomic_load:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15338>>  =>  (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7242,
      GIR_EraseRootFromParent_Done,
    // Label 1933: @101891
    GIM_Try, /*On fail goto*//*Label 1934*/ GIMT_Encode4(101939), // Rule ID 293 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
      // (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 293,
      GIR_EraseRootFromParent_Done,
    // Label 1934: @101939
    GIM_Try, /*On fail goto*//*Label 1935*/ GIMT_Encode4(101990), // Rule ID 296 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
      // (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURSi:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 296,
      GIR_EraseRootFromParent_Done,
    // Label 1935: @101990
    GIM_Try, /*On fail goto*//*Label 1936*/ GIMT_Encode4(102044), // Rule ID 7223 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
      // (atomic_load:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15321>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7223,
      GIR_EraseRootFromParent_Done,
    // Label 1936: @102044
    GIM_Try, /*On fail goto*//*Label 1937*/ GIMT_Encode4(102098), // Rule ID 7225 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
      // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15321>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7225,
      GIR_EraseRootFromParent_Done,
    // Label 1937: @102098
    GIM_Try, /*On fail goto*//*Label 1938*/ GIMT_Encode4(102152), // Rule ID 7235 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
      // (atomic_load:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15330>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7235,
      GIR_EraseRootFromParent_Done,
    // Label 1938: @102152
    GIM_Try, /*On fail goto*//*Label 1939*/ GIMT_Encode4(102206), // Rule ID 7237 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
      // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15330>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7237,
      GIR_EraseRootFromParent_Done,
    // Label 1939: @102206
    GIM_Try, /*On fail goto*//*Label 1940*/ GIMT_Encode4(102260), // Rule ID 7243 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
      // (atomic_load:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15338>>  =>  (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7243,
      GIR_EraseRootFromParent_Done,
    // Label 1940: @102260
    GIM_Try, /*On fail goto*//*Label 1941*/ GIMT_Encode4(102314), // Rule ID 7244 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
      // (atomic_load:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15338>>  =>  (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7244,
      GIR_EraseRootFromParent_Done,
    // Label 1941: @102314
    GIM_Try, /*On fail goto*//*Label 1942*/ GIMT_Encode4(102371), // Rule ID 7559 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
      // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15319>>  =>  (LDAPURBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURBi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7559,
      GIR_EraseRootFromParent_Done,
    // Label 1942: @102371
    GIM_Try, /*On fail goto*//*Label 1943*/ GIMT_Encode4(102428), // Rule ID 7561 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
      // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15328>>  =>  (LDAPURHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURHi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7561,
      GIR_EraseRootFromParent_Done,
    // Label 1943: @102428
    GIM_Try, /*On fail goto*//*Label 1944*/ GIMT_Encode4(102485), // Rule ID 7563 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
      // (atomic_load:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15313>>  =>  (LDAPURi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7563,
      GIR_EraseRootFromParent_Done,
    // Label 1944: @102485
    GIM_Try, /*On fail goto*//*Label 1945*/ GIMT_Encode4(102540), // Rule ID 4134 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
      // (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4134,
      GIR_EraseRootFromParent_Done,
    // Label 1945: @102540
    GIM_Try, /*On fail goto*//*Label 1946*/ GIMT_Encode4(102595), // Rule ID 4135 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
      // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4135,
      GIR_EraseRootFromParent_Done,
    // Label 1946: @102595
    GIM_Try, /*On fail goto*//*Label 1947*/ GIMT_Encode4(102650), // Rule ID 4136 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
      // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4136,
      GIR_EraseRootFromParent_Done,
    // Label 1947: @102650
    GIM_Try, /*On fail goto*//*Label 1948*/ GIMT_Encode4(102705), // Rule ID 4158 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
      // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4158,
      GIR_EraseRootFromParent_Done,
    // Label 1948: @102705
    GIM_Try, /*On fail goto*//*Label 1949*/ GIMT_Encode4(102760), // Rule ID 4159 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
      // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4159,
      GIR_EraseRootFromParent_Done,
    // Label 1949: @102760
    GIM_Try, /*On fail goto*//*Label 1950*/ GIMT_Encode4(102815), // Rule ID 4160 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
      // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4160,
      GIR_EraseRootFromParent_Done,
    // Label 1950: @102815
    GIM_Try, /*On fail goto*//*Label 1951*/ GIMT_Encode4(102855), // Rule ID 7211 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // MIs[0] ptr
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15309>>  =>  (LDAPRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRB),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7211,
      GIR_Done,
    // Label 1951: @102855
    GIM_Try, /*On fail goto*//*Label 1952*/ GIMT_Encode4(102895), // Rule ID 7212 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // MIs[0] ptr
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15311>>  =>  (LDAPRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRH),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7212,
      GIR_Done,
    // Label 1952: @102895
    GIM_Try, /*On fail goto*//*Label 1953*/ GIMT_Encode4(102935), // Rule ID 7213 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // MIs[0] ptr
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15313>>  =>  (LDAPRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRW),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7213,
      GIR_Done,
    // Label 1953: @102935
    GIM_Try, /*On fail goto*//*Label 1954*/ GIMT_Encode4(102972), // Rule ID 7215 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // MIs[0] ptr
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15317>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7215,
      GIR_Done,
    // Label 1954: @102972
    GIM_Try, /*On fail goto*//*Label 1955*/ GIMT_Encode4(103009), // Rule ID 7217 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // MIs[0] ptr
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15319>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7217,
      GIR_Done,
    // Label 1955: @103009
    GIM_Try, /*On fail goto*//*Label 1956*/ GIMT_Encode4(103046), // Rule ID 7227 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // MIs[0] ptr
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15326>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7227,
      GIR_Done,
    // Label 1956: @103046
    GIM_Try, /*On fail goto*//*Label 1957*/ GIMT_Encode4(103083), // Rule ID 7229 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // MIs[0] ptr
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15328>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7229,
      GIR_Done,
    // Label 1957: @103083
    GIM_Try, /*On fail goto*//*Label 1958*/ GIMT_Encode4(103120), // Rule ID 7239 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // MIs[0] ptr
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15335>>  =>  (LDARW:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARW),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7239,
      GIR_Done,
    // Label 1958: @103120
    GIM_Try, /*On fail goto*//*Label 1959*/ GIMT_Encode4(103157), // Rule ID 7240 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // MIs[0] ptr
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15313>>  =>  (LDARW:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARW),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7240,
      GIR_Done,
    // Label 1959: @103157
    GIM_Reject,
    // Label 1886: @103158
    GIM_Try, /*On fail goto*//*Label 1960*/ GIMT_Encode4(103211), // Rule ID 247 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
      // (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 247,
      GIR_EraseRootFromParent_Done,
    // Label 1960: @103211
    GIM_Try, /*On fail goto*//*Label 1961*/ GIMT_Encode4(103264), // Rule ID 248 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
      // (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 248,
      GIR_EraseRootFromParent_Done,
    // Label 1961: @103264
    GIM_Try, /*On fail goto*//*Label 1962*/ GIMT_Encode4(103320), // Rule ID 255 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
      // (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 255,
      GIR_EraseRootFromParent_Done,
    // Label 1962: @103320
    GIM_Try, /*On fail goto*//*Label 1963*/ GIMT_Encode4(103376), // Rule ID 256 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
      // (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 256,
      GIR_EraseRootFromParent_Done,
    // Label 1963: @103376
    GIM_Try, /*On fail goto*//*Label 1964*/ GIMT_Encode4(103429), // Rule ID 4068 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
      // (ld:{ *:[v1i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4068,
      GIR_EraseRootFromParent_Done,
    // Label 1964: @103429
    GIM_Try, /*On fail goto*//*Label 1965*/ GIMT_Encode4(103482), // Rule ID 4069 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
      // (ld:{ *:[v1i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4069,
      GIR_EraseRootFromParent_Done,
    // Label 1965: @103482
    GIM_Try, /*On fail goto*//*Label 1966*/ GIMT_Encode4(103535), // Rule ID 4070 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
      // (ld:{ *:[v1f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4070,
      GIR_EraseRootFromParent_Done,
    // Label 1966: @103535
    GIM_Try, /*On fail goto*//*Label 1967*/ GIMT_Encode4(103588), // Rule ID 4071 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
      // (ld:{ *:[v1f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4071,
      GIR_EraseRootFromParent_Done,
    // Label 1967: @103588
    GIM_Try, /*On fail goto*//*Label 1968*/ GIMT_Encode4(103680), // Rule ID 4096 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
      // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 4096,
      GIR_EraseRootFromParent_Done,
    // Label 1968: @103680
    GIM_Try, /*On fail goto*//*Label 1969*/ GIMT_Encode4(103772), // Rule ID 4097 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
      // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 4097,
      GIR_EraseRootFromParent_Done,
    // Label 1969: @103772
    GIM_Try, /*On fail goto*//*Label 1970*/ GIMT_Encode4(103864), // Rule ID 4098 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
      // (ld:{ *:[i64] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 4098,
      GIR_EraseRootFromParent_Done,
    // Label 1970: @103864
    GIM_Try, /*On fail goto*//*Label 1971*/ GIMT_Encode4(103956), // Rule ID 4099 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
      // (ld:{ *:[i64] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 4099,
      GIR_EraseRootFromParent_Done,
    // Label 1971: @103956
    GIM_Try, /*On fail goto*//*Label 1972*/ GIMT_Encode4(104048), // Rule ID 4100 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
      // (ld:{ *:[i64] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 4100,
      GIR_EraseRootFromParent_Done,
    // Label 1972: @104048
    GIM_Try, /*On fail goto*//*Label 1973*/ GIMT_Encode4(104140), // Rule ID 4101 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
      // (ld:{ *:[i64] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 4101,
      GIR_EraseRootFromParent_Done,
    // Label 1973: @104140
    GIM_Try, /*On fail goto*//*Label 1974*/ GIMT_Encode4(104232), // Rule ID 4102 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
      // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 4102,
      GIR_EraseRootFromParent_Done,
    // Label 1974: @104232
    GIM_Try, /*On fail goto*//*Label 1975*/ GIMT_Encode4(104324), // Rule ID 4103 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
      // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 4103,
      GIR_EraseRootFromParent_Done,
    // Label 1975: @104324
    GIM_Try, /*On fail goto*//*Label 1976*/ GIMT_Encode4(104372), // Rule ID 271 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
      // (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXui),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 271,
      GIR_EraseRootFromParent_Done,
    // Label 1976: @104372
    GIM_Try, /*On fail goto*//*Label 1977*/ GIMT_Encode4(104423), // Rule ID 276 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
      // (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 276,
      GIR_EraseRootFromParent_Done,
    // Label 1977: @104423
    GIM_Try, /*On fail goto*//*Label 1978*/ GIMT_Encode4(104482), // Rule ID 7247 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
      // (atomic_load:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15346>>  =>  (LDRXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7247,
      GIR_EraseRootFromParent_Done,
    // Label 1978: @104482
    GIM_Try, /*On fail goto*//*Label 1979*/ GIMT_Encode4(104541), // Rule ID 7248 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
      // (atomic_load:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15346>>  =>  (LDRXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7248,
      GIR_EraseRootFromParent_Done,
    // Label 1979: @104541
    GIM_Try, /*On fail goto*//*Label 1980*/ GIMT_Encode4(104589), // Rule ID 292 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
      // (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURXi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 292,
      GIR_EraseRootFromParent_Done,
    // Label 1980: @104589
    GIM_Try, /*On fail goto*//*Label 1981*/ GIMT_Encode4(104640), // Rule ID 297 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
      // (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 297,
      GIR_EraseRootFromParent_Done,
    // Label 1981: @104640
    GIM_Try, /*On fail goto*//*Label 1982*/ GIMT_Encode4(104694), // Rule ID 7249 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
      // (atomic_load:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15346>>  =>  (LDRXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXui),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7249,
      GIR_EraseRootFromParent_Done,
    // Label 1982: @104694
    GIM_Try, /*On fail goto*//*Label 1983*/ GIMT_Encode4(104748), // Rule ID 7250 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
      // (atomic_load:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15346>>  =>  (LDURXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURXi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7250,
      GIR_EraseRootFromParent_Done,
    // Label 1983: @104748
    GIM_Try, /*On fail goto*//*Label 1984*/ GIMT_Encode4(104805), // Rule ID 7564 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
      // (atomic_load:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15315>>  =>  (LDAPURXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURXi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7564,
      GIR_EraseRootFromParent_Done,
    // Label 1984: @104805
    GIM_Try, /*On fail goto*//*Label 1985*/ GIMT_Encode4(104853), // Rule ID 4119 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
      // (ld:{ *:[v1f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4119,
      GIR_EraseRootFromParent_Done,
    // Label 1985: @104853
    GIM_Try, /*On fail goto*//*Label 1986*/ GIMT_Encode4(104901), // Rule ID 4120 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
      // (ld:{ *:[v1i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4120,
      GIR_EraseRootFromParent_Done,
    // Label 1986: @104901
    GIM_Try, /*On fail goto*//*Label 1987*/ GIMT_Encode4(104949), // Rule ID 4149 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
      // (ld:{ *:[v1f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4149,
      GIR_EraseRootFromParent_Done,
    // Label 1987: @104949
    GIM_Try, /*On fail goto*//*Label 1988*/ GIMT_Encode4(104997), // Rule ID 4150 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
      // (ld:{ *:[v1i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4150,
      GIR_EraseRootFromParent_Done,
    // Label 1988: @104997
    GIM_Try, /*On fail goto*//*Label 1989*/ GIMT_Encode4(105084), // Rule ID 4137 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
      // (ld:{ *:[i64] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 4137,
      GIR_EraseRootFromParent_Done,
    // Label 1989: @105084
    GIM_Try, /*On fail goto*//*Label 1990*/ GIMT_Encode4(105171), // Rule ID 4138 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
      // (ld:{ *:[i64] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 4138,
      GIR_EraseRootFromParent_Done,
    // Label 1990: @105171
    GIM_Try, /*On fail goto*//*Label 1991*/ GIMT_Encode4(105258), // Rule ID 4139 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
      // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 4139,
      GIR_EraseRootFromParent_Done,
    // Label 1991: @105258
    GIM_Try, /*On fail goto*//*Label 1992*/ GIMT_Encode4(105345), // Rule ID 4140 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
      // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 4140,
      GIR_EraseRootFromParent_Done,
    // Label 1992: @105345
    GIM_Try, /*On fail goto*//*Label 1993*/ GIMT_Encode4(105432), // Rule ID 4161 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
      // (ld:{ *:[i64] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 4161,
      GIR_EraseRootFromParent_Done,
    // Label 1993: @105432
    GIM_Try, /*On fail goto*//*Label 1994*/ GIMT_Encode4(105519), // Rule ID 4162 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
      // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 4162,
      GIR_EraseRootFromParent_Done,
    // Label 1994: @105519
    GIM_Try, /*On fail goto*//*Label 1995*/ GIMT_Encode4(105606), // Rule ID 4163 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
      // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 4163,
      GIR_EraseRootFromParent_Done,
    // Label 1995: @105606
    GIM_Try, /*On fail goto*//*Label 1996*/ GIMT_Encode4(105693), // Rule ID 4164 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
      // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 4164,
      GIR_EraseRootFromParent_Done,
    // Label 1996: @105693
    GIM_Try, /*On fail goto*//*Label 1997*/ GIMT_Encode4(105733), // Rule ID 7214 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // MIs[0] ptr
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      // (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15315>>  =>  (LDAPRX:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRX),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7214,
      GIR_Done,
    // Label 1997: @105733
    GIM_Try, /*On fail goto*//*Label 1998*/ GIMT_Encode4(105770), // Rule ID 7245 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // MIs[0] ptr
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      // (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15343>>  =>  (LDARX:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARX),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7245,
      GIR_Done,
    // Label 1998: @105770
    GIM_Try, /*On fail goto*//*Label 1999*/ GIMT_Encode4(105807), // Rule ID 7246 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // MIs[0] ptr
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      // (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15315>>  =>  (LDARX:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARX),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7246,
      GIR_Done,
    // Label 1999: @105807
    GIM_Try, /*On fail goto*//*Label 2000*/ GIMT_Encode4(105838), // Rule ID 6457 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // MIs[0] Rn
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      // (ld:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev1d:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev1d),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6457,
      GIR_Done,
    // Label 2000: @105838
    GIM_Reject,
    // Label 1887: @105839
    GIM_Try, /*On fail goto*//*Label 2001*/ GIMT_Encode4(106047),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_Try, /*On fail goto*//*Label 2002*/ GIMT_Encode4(105900), // Rule ID 257 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
        // (ld:{ *:[f128] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 257,
        GIR_EraseRootFromParent_Done,
      // Label 2002: @105900
      GIM_Try, /*On fail goto*//*Label 2003*/ GIMT_Encode4(105941), // Rule ID 258 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
        // (ld:{ *:[f128] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 258,
        GIR_EraseRootFromParent_Done,
      // Label 2003: @105941
      GIM_Try, /*On fail goto*//*Label 2004*/ GIMT_Encode4(105977), // Rule ID 277 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
        // (ld:{ *:[f128] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 277,
        GIR_EraseRootFromParent_Done,
      // Label 2004: @105977
      GIM_Try, /*On fail goto*//*Label 2005*/ GIMT_Encode4(106013), // Rule ID 298 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
        // (ld:{ *:[f128] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 298,
        GIR_EraseRootFromParent_Done,
      // Label 2005: @106013
      GIM_Try, /*On fail goto*//*Label 2006*/ GIMT_Encode4(106046), // Rule ID 4129 //
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
        // (ld:{ *:[f128] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4129,
        GIR_EraseRootFromParent_Done,
      // Label 2006: @106046
      GIM_Reject,
    // Label 2001: @106047
    GIM_Reject,
    // Label 1888: @106048
    GIM_Try, /*On fail goto*//*Label 2007*/ GIMT_Encode4(106425),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 2008*/ GIMT_Encode4(106109), // Rule ID 4056 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
        // (ld:{ *:[v2i32] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4056,
        GIR_EraseRootFromParent_Done,
      // Label 2008: @106109
      GIM_Try, /*On fail goto*//*Label 2009*/ GIMT_Encode4(106154), // Rule ID 4057 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
        // (ld:{ *:[v2i32] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4057,
        GIR_EraseRootFromParent_Done,
      // Label 2009: @106154
      GIM_Try, /*On fail goto*//*Label 2010*/ GIMT_Encode4(106199), // Rule ID 4058 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
        // (ld:{ *:[v2f32] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4058,
        GIR_EraseRootFromParent_Done,
      // Label 2010: @106199
      GIM_Try, /*On fail goto*//*Label 2011*/ GIMT_Encode4(106244), // Rule ID 4059 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
        // (ld:{ *:[v2f32] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4059,
        GIR_EraseRootFromParent_Done,
      // Label 2011: @106244
      GIM_Try, /*On fail goto*//*Label 2012*/ GIMT_Encode4(106284), // Rule ID 4113 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
        // (ld:{ *:[v2f32] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4113,
        GIR_EraseRootFromParent_Done,
      // Label 2012: @106284
      GIM_Try, /*On fail goto*//*Label 2013*/ GIMT_Encode4(106324), // Rule ID 4116 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
        // (ld:{ *:[v2i32] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4116,
        GIR_EraseRootFromParent_Done,
      // Label 2013: @106324
      GIM_Try, /*On fail goto*//*Label 2014*/ GIMT_Encode4(106364), // Rule ID 4144 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
        // (ld:{ *:[v2f32] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4144,
        GIR_EraseRootFromParent_Done,
      // Label 2014: @106364
      GIM_Try, /*On fail goto*//*Label 2015*/ GIMT_Encode4(106404), // Rule ID 4145 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
        // (ld:{ *:[v2i32] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4145,
        GIR_EraseRootFromParent_Done,
      // Label 2015: @106404
      GIM_Try, /*On fail goto*//*Label 2016*/ GIMT_Encode4(106424), // Rule ID 6456 //
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        // (ld:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev2s:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev2s),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6456,
        GIR_Done,
      // Label 2016: @106424
      GIM_Reject,
    // Label 2007: @106425
    GIM_Reject,
    // Label 1889: @106426
    GIM_Try, /*On fail goto*//*Label 2017*/ GIMT_Encode4(106803),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 2018*/ GIMT_Encode4(106487), // Rule ID 4072 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
        // (ld:{ *:[v2i64] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4072,
        GIR_EraseRootFromParent_Done,
      // Label 2018: @106487
      GIM_Try, /*On fail goto*//*Label 2019*/ GIMT_Encode4(106532), // Rule ID 4073 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
        // (ld:{ *:[v2i64] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4073,
        GIR_EraseRootFromParent_Done,
      // Label 2019: @106532
      GIM_Try, /*On fail goto*//*Label 2020*/ GIMT_Encode4(106577), // Rule ID 4074 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
        // (ld:{ *:[v2f64] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4074,
        GIR_EraseRootFromParent_Done,
      // Label 2020: @106577
      GIM_Try, /*On fail goto*//*Label 2021*/ GIMT_Encode4(106622), // Rule ID 4075 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
        // (ld:{ *:[v2f64] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4075,
        GIR_EraseRootFromParent_Done,
      // Label 2021: @106622
      GIM_Try, /*On fail goto*//*Label 2022*/ GIMT_Encode4(106662), // Rule ID 4122 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
        // (ld:{ *:[v2f64] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4122,
        GIR_EraseRootFromParent_Done,
      // Label 2022: @106662
      GIM_Try, /*On fail goto*//*Label 2023*/ GIMT_Encode4(106702), // Rule ID 4126 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
        // (ld:{ *:[v2i64] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4126,
        GIR_EraseRootFromParent_Done,
      // Label 2023: @106702
      GIM_Try, /*On fail goto*//*Label 2024*/ GIMT_Encode4(106742), // Rule ID 4151 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
        // (ld:{ *:[v2f64] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4151,
        GIR_EraseRootFromParent_Done,
      // Label 2024: @106742
      GIM_Try, /*On fail goto*//*Label 2025*/ GIMT_Encode4(106782), // Rule ID 4152 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
        // (ld:{ *:[v2i64] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4152,
        GIR_EraseRootFromParent_Done,
      // Label 2025: @106782
      GIM_Try, /*On fail goto*//*Label 2026*/ GIMT_Encode4(106802), // Rule ID 6453 //
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        // (ld:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev2d),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6453,
        GIR_Done,
      // Label 2026: @106802
      GIM_Reject,
    // Label 2017: @106803
    GIM_Reject,
    // Label 1890: @106804
    GIM_Try, /*On fail goto*//*Label 2027*/ GIMT_Encode4(107311),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 2028*/ GIMT_Encode4(106865), // Rule ID 4062 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
        // (ld:{ *:[v4i16] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4062,
        GIR_EraseRootFromParent_Done,
      // Label 2028: @106865
      GIM_Try, /*On fail goto*//*Label 2029*/ GIMT_Encode4(106910), // Rule ID 4063 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
        // (ld:{ *:[v4i16] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4063,
        GIR_EraseRootFromParent_Done,
      // Label 2029: @106910
      GIM_Try, /*On fail goto*//*Label 2030*/ GIMT_Encode4(106955), // Rule ID 4064 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
        // (ld:{ *:[v4f16] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4064,
        GIR_EraseRootFromParent_Done,
      // Label 2030: @106955
      GIM_Try, /*On fail goto*//*Label 2031*/ GIMT_Encode4(107000), // Rule ID 4065 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
        // (ld:{ *:[v4f16] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4065,
        GIR_EraseRootFromParent_Done,
      // Label 2031: @107000
      GIM_Try, /*On fail goto*//*Label 2032*/ GIMT_Encode4(107045), // Rule ID 4066 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
        // (ld:{ *:[v4bf16] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v4bf16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4066,
        GIR_EraseRootFromParent_Done,
      // Label 2032: @107045
      GIM_Try, /*On fail goto*//*Label 2033*/ GIMT_Encode4(107090), // Rule ID 4067 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
        // (ld:{ *:[v4bf16] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v4bf16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4067,
        GIR_EraseRootFromParent_Done,
      // Label 2033: @107090
      GIM_Try, /*On fail goto*//*Label 2034*/ GIMT_Encode4(107130), // Rule ID 4115 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
        // (ld:{ *:[v4i16] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4115,
        GIR_EraseRootFromParent_Done,
      // Label 2034: @107130
      GIM_Try, /*On fail goto*//*Label 2035*/ GIMT_Encode4(107170), // Rule ID 4117 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
        // (ld:{ *:[v4f16] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4117,
        GIR_EraseRootFromParent_Done,
      // Label 2035: @107170
      GIM_Try, /*On fail goto*//*Label 2036*/ GIMT_Encode4(107210), // Rule ID 4118 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
        // (ld:{ *:[v4bf16] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v4bf16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4118,
        GIR_EraseRootFromParent_Done,
      // Label 2036: @107210
      GIM_Try, /*On fail goto*//*Label 2037*/ GIMT_Encode4(107250), // Rule ID 4146 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
        // (ld:{ *:[v4i16] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4146,
        GIR_EraseRootFromParent_Done,
      // Label 2037: @107250
      GIM_Try, /*On fail goto*//*Label 2038*/ GIMT_Encode4(107290), // Rule ID 4148 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
        // (ld:{ *:[v4f16] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4148,
        GIR_EraseRootFromParent_Done,
      // Label 2038: @107290
      GIM_Try, /*On fail goto*//*Label 2039*/ GIMT_Encode4(107310), // Rule ID 6455 //
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        // (ld:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev4h:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev4h),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6455,
        GIR_Done,
      // Label 2039: @107310
      GIM_Reject,
    // Label 2027: @107311
    GIM_Reject,
    // Label 1891: @107312
    GIM_Try, /*On fail goto*//*Label 2040*/ GIMT_Encode4(107689),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 2041*/ GIMT_Encode4(107373), // Rule ID 4076 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
        // (ld:{ *:[v4i32] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4076,
        GIR_EraseRootFromParent_Done,
      // Label 2041: @107373
      GIM_Try, /*On fail goto*//*Label 2042*/ GIMT_Encode4(107418), // Rule ID 4077 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
        // (ld:{ *:[v4i32] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4077,
        GIR_EraseRootFromParent_Done,
      // Label 2042: @107418
      GIM_Try, /*On fail goto*//*Label 2043*/ GIMT_Encode4(107463), // Rule ID 4078 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
        // (ld:{ *:[v4f32] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4078,
        GIR_EraseRootFromParent_Done,
      // Label 2043: @107463
      GIM_Try, /*On fail goto*//*Label 2044*/ GIMT_Encode4(107508), // Rule ID 4079 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
        // (ld:{ *:[v4f32] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4079,
        GIR_EraseRootFromParent_Done,
      // Label 2044: @107508
      GIM_Try, /*On fail goto*//*Label 2045*/ GIMT_Encode4(107548), // Rule ID 4121 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
        // (ld:{ *:[v4f32] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4121,
        GIR_EraseRootFromParent_Done,
      // Label 2045: @107548
      GIM_Try, /*On fail goto*//*Label 2046*/ GIMT_Encode4(107588), // Rule ID 4125 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
        // (ld:{ *:[v4i32] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4125,
        GIR_EraseRootFromParent_Done,
      // Label 2046: @107588
      GIM_Try, /*On fail goto*//*Label 2047*/ GIMT_Encode4(107628), // Rule ID 4153 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
        // (ld:{ *:[v4f32] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4153,
        GIR_EraseRootFromParent_Done,
      // Label 2047: @107628
      GIM_Try, /*On fail goto*//*Label 2048*/ GIMT_Encode4(107668), // Rule ID 4154 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
        // (ld:{ *:[v4i32] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4154,
        GIR_EraseRootFromParent_Done,
      // Label 2048: @107668
      GIM_Try, /*On fail goto*//*Label 2049*/ GIMT_Encode4(107688), // Rule ID 6452 //
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        // (ld:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev4s),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6452,
        GIR_Done,
      // Label 2049: @107688
      GIM_Reject,
    // Label 2040: @107689
    GIM_Reject,
    // Label 1892: @107690
    GIM_Try, /*On fail goto*//*Label 2050*/ GIMT_Encode4(107897),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 2051*/ GIMT_Encode4(107751), // Rule ID 4060 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
        // (ld:{ *:[v8i8] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4060,
        GIR_EraseRootFromParent_Done,
      // Label 2051: @107751
      GIM_Try, /*On fail goto*//*Label 2052*/ GIMT_Encode4(107796), // Rule ID 4061 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
        // (ld:{ *:[v8i8] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4061,
        GIR_EraseRootFromParent_Done,
      // Label 2052: @107796
      GIM_Try, /*On fail goto*//*Label 2053*/ GIMT_Encode4(107836), // Rule ID 4114 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
        // (ld:{ *:[v8i8] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4114,
        GIR_EraseRootFromParent_Done,
      // Label 2053: @107836
      GIM_Try, /*On fail goto*//*Label 2054*/ GIMT_Encode4(107876), // Rule ID 4147 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
        // (ld:{ *:[v8i8] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4147,
        GIR_EraseRootFromParent_Done,
      // Label 2054: @107876
      GIM_Try, /*On fail goto*//*Label 2055*/ GIMT_Encode4(107896), // Rule ID 6454 //
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        // (ld:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev8b:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev8b),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6454,
        GIR_Done,
      // Label 2055: @107896
      GIM_Reject,
    // Label 2050: @107897
    GIM_Reject,
    // Label 1893: @107898
    GIM_Try, /*On fail goto*//*Label 2056*/ GIMT_Encode4(108405),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 2057*/ GIMT_Encode4(107959), // Rule ID 4080 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
        // (ld:{ *:[v8i16] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4080,
        GIR_EraseRootFromParent_Done,
      // Label 2057: @107959
      GIM_Try, /*On fail goto*//*Label 2058*/ GIMT_Encode4(108004), // Rule ID 4081 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
        // (ld:{ *:[v8i16] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4081,
        GIR_EraseRootFromParent_Done,
      // Label 2058: @108004
      GIM_Try, /*On fail goto*//*Label 2059*/ GIMT_Encode4(108049), // Rule ID 4082 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
        // (ld:{ *:[v8f16] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4082,
        GIR_EraseRootFromParent_Done,
      // Label 2059: @108049
      GIM_Try, /*On fail goto*//*Label 2060*/ GIMT_Encode4(108094), // Rule ID 4083 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
        // (ld:{ *:[v8f16] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4083,
        GIR_EraseRootFromParent_Done,
      // Label 2060: @108094
      GIM_Try, /*On fail goto*//*Label 2061*/ GIMT_Encode4(108139), // Rule ID 4084 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
        // (ld:{ *:[v8bf16] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v8bf16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4084,
        GIR_EraseRootFromParent_Done,
      // Label 2061: @108139
      GIM_Try, /*On fail goto*//*Label 2062*/ GIMT_Encode4(108184), // Rule ID 4085 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
        // (ld:{ *:[v8bf16] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v8bf16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4085,
        GIR_EraseRootFromParent_Done,
      // Label 2062: @108184
      GIM_Try, /*On fail goto*//*Label 2063*/ GIMT_Encode4(108224), // Rule ID 4124 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
        // (ld:{ *:[v8i16] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4124,
        GIR_EraseRootFromParent_Done,
      // Label 2063: @108224
      GIM_Try, /*On fail goto*//*Label 2064*/ GIMT_Encode4(108264), // Rule ID 4127 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
        // (ld:{ *:[v8f16] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4127,
        GIR_EraseRootFromParent_Done,
      // Label 2064: @108264
      GIM_Try, /*On fail goto*//*Label 2065*/ GIMT_Encode4(108304), // Rule ID 4128 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
        // (ld:{ *:[v8bf16] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v8bf16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4128,
        GIR_EraseRootFromParent_Done,
      // Label 2065: @108304
      GIM_Try, /*On fail goto*//*Label 2066*/ GIMT_Encode4(108344), // Rule ID 4155 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
        // (ld:{ *:[v8i16] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4155,
        GIR_EraseRootFromParent_Done,
      // Label 2066: @108344
      GIM_Try, /*On fail goto*//*Label 2067*/ GIMT_Encode4(108384), // Rule ID 4157 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
        // (ld:{ *:[v8f16] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4157,
        GIR_EraseRootFromParent_Done,
      // Label 2067: @108384
      GIM_Try, /*On fail goto*//*Label 2068*/ GIMT_Encode4(108404), // Rule ID 6451 //
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        // (ld:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev8h),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6451,
        GIR_Done,
      // Label 2068: @108404
      GIM_Reject,
    // Label 2056: @108405
    GIM_Reject,
    // Label 1894: @108406
    GIM_Try, /*On fail goto*//*Label 2069*/ GIMT_Encode4(108613),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 2070*/ GIMT_Encode4(108467), // Rule ID 4086 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
        // (ld:{ *:[v16i8] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4086,
        GIR_EraseRootFromParent_Done,
      // Label 2070: @108467
      GIM_Try, /*On fail goto*//*Label 2071*/ GIMT_Encode4(108512), // Rule ID 4087 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
        // (ld:{ *:[v16i8] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4087,
        GIR_EraseRootFromParent_Done,
      // Label 2071: @108512
      GIM_Try, /*On fail goto*//*Label 2072*/ GIMT_Encode4(108552), // Rule ID 4123 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
        // (ld:{ *:[v16i8] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4123,
        GIR_EraseRootFromParent_Done,
      // Label 2072: @108552
      GIM_Try, /*On fail goto*//*Label 2073*/ GIMT_Encode4(108592), // Rule ID 4156 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
        // (ld:{ *:[v16i8] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4156,
        GIR_EraseRootFromParent_Done,
      // Label 2073: @108592
      GIM_Try, /*On fail goto*//*Label 2074*/ GIMT_Encode4(108612), // Rule ID 6450 //
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        // (ld:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev16b),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6450,
        GIR_Done,
      // Label 2074: @108612
      GIM_Reject,
    // Label 2069: @108613
    GIM_Reject,
    // Label 1895: @108614
    GIM_Try, /*On fail goto*//*Label 2075*/ GIMT_Encode4(108727),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 2076*/ GIMT_Encode4(108682), // Rule ID 11238 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (ld:{ *:[nxv2f16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_D_IMM:{ *:[nxv2f16] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_D_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // base
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11238,
        GIR_EraseRootFromParent_Done,
      // Label 2076: @108682
      GIM_Try, /*On fail goto*//*Label 2077*/ GIMT_Encode4(108726), // Rule ID 11241 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (ld:{ *:[nxv2bf16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_D_IMM:{ *:[nxv2bf16] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_D_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // base
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11241,
        GIR_EraseRootFromParent_Done,
      // Label 2077: @108726
      GIM_Reject,
    // Label 2075: @108727
    GIM_Reject,
    // Label 1896: @108728
    GIM_Try, /*On fail goto*//*Label 2078*/ GIMT_Encode4(108791), // Rule ID 11247 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // MIs[0] base
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (ld:{ *:[nxv2f32] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1W_D_IMM:{ *:[nxv2f32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_D_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // base
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 11247,
      GIR_EraseRootFromParent_Done,
    // Label 2078: @108791
    GIM_Reject,
    // Label 1897: @108792
    GIM_Try, /*On fail goto*//*Label 2079*/ GIMT_Encode4(108905),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 2080*/ GIMT_Encode4(108860), // Rule ID 11223 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (ld:{ *:[nxv2i64] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1D_IMM:{ *:[nxv2i64] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // base
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11223,
        GIR_EraseRootFromParent_Done,
      // Label 2080: @108860
      GIM_Try, /*On fail goto*//*Label 2081*/ GIMT_Encode4(108904), // Rule ID 11250 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (ld:{ *:[nxv2f64] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1D_IMM:{ *:[nxv2f64] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // base
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11250,
        GIR_EraseRootFromParent_Done,
      // Label 2081: @108904
      GIM_Reject,
    // Label 2079: @108905
    GIM_Reject,
    // Label 1898: @108906
    GIM_Try, /*On fail goto*//*Label 2082*/ GIMT_Encode4(109019),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 2083*/ GIMT_Encode4(108974), // Rule ID 11232 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (ld:{ *:[nxv4f16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_S_IMM:{ *:[nxv4f16] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_S_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // base
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11232,
        GIR_EraseRootFromParent_Done,
      // Label 2083: @108974
      GIM_Try, /*On fail goto*//*Label 2084*/ GIMT_Encode4(109018), // Rule ID 11235 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (ld:{ *:[nxv4bf16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_S_IMM:{ *:[nxv4bf16] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_S_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // base
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11235,
        GIR_EraseRootFromParent_Done,
      // Label 2084: @109018
      GIM_Reject,
    // Label 2082: @109019
    GIM_Reject,
    // Label 1899: @109020
    GIM_Try, /*On fail goto*//*Label 2085*/ GIMT_Encode4(109133),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 2086*/ GIMT_Encode4(109088), // Rule ID 11211 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (ld:{ *:[nxv4i32] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1W_IMM:{ *:[nxv4i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // base
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11211,
        GIR_EraseRootFromParent_Done,
      // Label 2086: @109088
      GIM_Try, /*On fail goto*//*Label 2087*/ GIMT_Encode4(109132), // Rule ID 11244 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (ld:{ *:[nxv4f32] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1W_IMM:{ *:[nxv4f32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // base
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11244,
        GIR_EraseRootFromParent_Done,
      // Label 2087: @109132
      GIM_Reject,
    // Label 2085: @109133
    GIM_Reject,
    // Label 1900: @109134
    GIM_Try, /*On fail goto*//*Label 2088*/ GIMT_Encode4(109291),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 2089*/ GIMT_Encode4(109202), // Rule ID 11190 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (ld:{ *:[nxv8i16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_IMM:{ *:[nxv8i16] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // base
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11190,
        GIR_EraseRootFromParent_Done,
      // Label 2089: @109202
      GIM_Try, /*On fail goto*//*Label 2090*/ GIMT_Encode4(109246), // Rule ID 11226 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (ld:{ *:[nxv8f16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_IMM:{ *:[nxv8f16] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // base
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11226,
        GIR_EraseRootFromParent_Done,
      // Label 2090: @109246
      GIM_Try, /*On fail goto*//*Label 2091*/ GIMT_Encode4(109290), // Rule ID 11229 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (ld:{ *:[nxv8bf16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_IMM:{ *:[nxv8bf16] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // base
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11229,
        GIR_EraseRootFromParent_Done,
      // Label 2091: @109290
      GIM_Reject,
    // Label 2088: @109291
    GIM_Reject,
    // Label 1901: @109292
    GIM_Try, /*On fail goto*//*Label 2092*/ GIMT_Encode4(109335), // Rule ID 2405 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
      // MIs[0] base
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (ld:{ *:[nxv16i1] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_PXI:{ *:[nxv16i1] } GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_PXI),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pt]
      GIR_RootToRootCopy, /*OpIdx*/1, // base
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2405,
      GIR_EraseRootFromParent_Done,
    // Label 2092: @109335
    GIM_Reject,
    // Label 1902: @109336
    GIM_Try, /*On fail goto*//*Label 2093*/ GIMT_Encode4(109399), // Rule ID 11158 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // MIs[0] base
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (ld:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1B_IMM:{ *:[nxv16i8] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1B_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // base
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 11158,
      GIR_EraseRootFromParent_Done,
    // Label 2093: @109399
    GIM_Reject,
    // Label 1903: @109400
    GIM_Reject,
    // Label 17: @109401
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2096*/ GIMT_Encode4(110492),
    /*GILLT_s32*//*Label 2094*/ GIMT_Encode4(109420),
    /*GILLT_s64*//*Label 2095*/ GIMT_Encode4(109849),
    // Label 2094: @109420
    GIM_Try, /*On fail goto*//*Label 2097*/ GIMT_Encode4(109476), // Rule ID 259 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
      // (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHWroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 259,
      GIR_EraseRootFromParent_Done,
    // Label 2097: @109476
    GIM_Try, /*On fail goto*//*Label 2098*/ GIMT_Encode4(109532), // Rule ID 260 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
      // (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHWroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 260,
      GIR_EraseRootFromParent_Done,
    // Label 2098: @109532
    GIM_Try, /*On fail goto*//*Label 2099*/ GIMT_Encode4(109588), // Rule ID 263 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
      // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBWroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 263,
      GIR_EraseRootFromParent_Done,
    // Label 2099: @109588
    GIM_Try, /*On fail goto*//*Label 2100*/ GIMT_Encode4(109644), // Rule ID 264 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
      // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBWroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 264,
      GIR_EraseRootFromParent_Done,
    // Label 2100: @109644
    GIM_Try, /*On fail goto*//*Label 2101*/ GIMT_Encode4(109695), // Rule ID 280 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
      // (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHWui),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 280,
      GIR_EraseRootFromParent_Done,
    // Label 2101: @109695
    GIM_Try, /*On fail goto*//*Label 2102*/ GIMT_Encode4(109746), // Rule ID 282 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
      // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBWui),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 282,
      GIR_EraseRootFromParent_Done,
    // Label 2102: @109746
    GIM_Try, /*On fail goto*//*Label 2103*/ GIMT_Encode4(109797), // Rule ID 301 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
      // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDURSHWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSHWi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 301,
      GIR_EraseRootFromParent_Done,
    // Label 2103: @109797
    GIM_Try, /*On fail goto*//*Label 2104*/ GIMT_Encode4(109848), // Rule ID 303 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
      // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDURSBWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSBWi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 303,
      GIR_EraseRootFromParent_Done,
    // Label 2104: @109848
    GIM_Reject,
    // Label 2095: @109849
    GIM_Try, /*On fail goto*//*Label 2105*/ GIMT_Encode4(109905), // Rule ID 261 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
      // (ld:{ *:[i64] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHXroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 261,
      GIR_EraseRootFromParent_Done,
    // Label 2105: @109905
    GIM_Try, /*On fail goto*//*Label 2106*/ GIMT_Encode4(109961), // Rule ID 262 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
      // (ld:{ *:[i64] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHXroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 262,
      GIR_EraseRootFromParent_Done,
    // Label 2106: @109961
    GIM_Try, /*On fail goto*//*Label 2107*/ GIMT_Encode4(110017), // Rule ID 265 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
      // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBXroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 265,
      GIR_EraseRootFromParent_Done,
    // Label 2107: @110017
    GIM_Try, /*On fail goto*//*Label 2108*/ GIMT_Encode4(110073), // Rule ID 266 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
      // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBXroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 266,
      GIR_EraseRootFromParent_Done,
    // Label 2108: @110073
    GIM_Try, /*On fail goto*//*Label 2109*/ GIMT_Encode4(110129), // Rule ID 267 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
      // (ld:{ *:[i64] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDRSWroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSWroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 267,
      GIR_EraseRootFromParent_Done,
    // Label 2109: @110129
    GIM_Try, /*On fail goto*//*Label 2110*/ GIMT_Encode4(110185), // Rule ID 268 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
      // (ld:{ *:[i64] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDRSWroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSWroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 268,
      GIR_EraseRootFromParent_Done,
    // Label 2110: @110185
    GIM_Try, /*On fail goto*//*Label 2111*/ GIMT_Encode4(110236), // Rule ID 281 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
      // (ld:{ *:[i64] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHXui),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 281,
      GIR_EraseRootFromParent_Done,
    // Label 2111: @110236
    GIM_Try, /*On fail goto*//*Label 2112*/ GIMT_Encode4(110287), // Rule ID 283 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
      // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBXui),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 283,
      GIR_EraseRootFromParent_Done,
    // Label 2112: @110287
    GIM_Try, /*On fail goto*//*Label 2113*/ GIMT_Encode4(110338), // Rule ID 284 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
      // (ld:{ *:[i64] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDRSWui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSWui),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 284,
      GIR_EraseRootFromParent_Done,
    // Label 2113: @110338
    GIM_Try, /*On fail goto*//*Label 2114*/ GIMT_Encode4(110389), // Rule ID 302 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
      // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDURSHXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSHXi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 302,
      GIR_EraseRootFromParent_Done,
    // Label 2114: @110389
    GIM_Try, /*On fail goto*//*Label 2115*/ GIMT_Encode4(110440), // Rule ID 304 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
      // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDURSBXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSBXi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 304,
      GIR_EraseRootFromParent_Done,
    // Label 2115: @110440
    GIM_Try, /*On fail goto*//*Label 2116*/ GIMT_Encode4(110491), // Rule ID 305 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
      // (ld:{ *:[i64] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDURSWi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSWi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 305,
      GIR_EraseRootFromParent_Done,
    // Label 2116: @110491
    GIM_Reject,
    // Label 2096: @110492
    GIM_Reject,
    // Label 18: @110493
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2119*/ GIMT_Encode4(113506),
    /*GILLT_s32*//*Label 2117*/ GIMT_Encode4(110512),
    /*GILLT_s64*//*Label 2118*/ GIMT_Encode4(111971),
    // Label 2117: @110512
    GIM_Try, /*On fail goto*//*Label 2120*/ GIMT_Encode4(110568), // Rule ID 241 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
      // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 241,
      GIR_EraseRootFromParent_Done,
    // Label 2120: @110568
    GIM_Try, /*On fail goto*//*Label 2121*/ GIMT_Encode4(110624), // Rule ID 242 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
      // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 242,
      GIR_EraseRootFromParent_Done,
    // Label 2121: @110624
    GIM_Try, /*On fail goto*//*Label 2122*/ GIMT_Encode4(110680), // Rule ID 243 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
      // (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 243,
      GIR_EraseRootFromParent_Done,
    // Label 2122: @110680
    GIM_Try, /*On fail goto*//*Label 2123*/ GIMT_Encode4(110736), // Rule ID 244 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
      // (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 244,
      GIR_EraseRootFromParent_Done,
    // Label 2123: @110736
    GIM_Try, /*On fail goto*//*Label 2124*/ GIMT_Encode4(110792), // Rule ID 4110 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
      // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4110,
      GIR_EraseRootFromParent_Done,
    // Label 2124: @110792
    GIM_Try, /*On fail goto*//*Label 2125*/ GIMT_Encode4(110848), // Rule ID 4111 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
      // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4111,
      GIR_EraseRootFromParent_Done,
    // Label 2125: @110848
    GIM_Try, /*On fail goto*//*Label 2126*/ GIMT_Encode4(110899), // Rule ID 278 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
      // (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 278,
      GIR_EraseRootFromParent_Done,
    // Label 2126: @110899
    GIM_Try, /*On fail goto*//*Label 2127*/ GIMT_Encode4(110950), // Rule ID 279 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
      // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 279,
      GIR_EraseRootFromParent_Done,
    // Label 2127: @110950
    GIM_Try, /*On fail goto*//*Label 2128*/ GIMT_Encode4(111009), // Rule ID 7220 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
      // (atomic_load:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15321>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7220,
      GIR_EraseRootFromParent_Done,
    // Label 2128: @111009
    GIM_Try, /*On fail goto*//*Label 2129*/ GIMT_Encode4(111068), // Rule ID 7222 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
      // (atomic_load:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15321>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7222,
      GIR_EraseRootFromParent_Done,
    // Label 2129: @111068
    GIM_Try, /*On fail goto*//*Label 2130*/ GIMT_Encode4(111127), // Rule ID 7232 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
      // (atomic_load:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15330>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7232,
      GIR_EraseRootFromParent_Done,
    // Label 2130: @111127
    GIM_Try, /*On fail goto*//*Label 2131*/ GIMT_Encode4(111186), // Rule ID 7234 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
      // (atomic_load:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15330>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7234,
      GIR_EraseRootFromParent_Done,
    // Label 2131: @111186
    GIM_Try, /*On fail goto*//*Label 2132*/ GIMT_Encode4(111237), // Rule ID 299 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
      // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 299,
      GIR_EraseRootFromParent_Done,
    // Label 2132: @111237
    GIM_Try, /*On fail goto*//*Label 2133*/ GIMT_Encode4(111288), // Rule ID 300 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
      // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 300,
      GIR_EraseRootFromParent_Done,
    // Label 2133: @111288
    GIM_Try, /*On fail goto*//*Label 2134*/ GIMT_Encode4(111339), // Rule ID 4132 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
      // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4132,
      GIR_EraseRootFromParent_Done,
    // Label 2134: @111339
    GIM_Try, /*On fail goto*//*Label 2135*/ GIMT_Encode4(111390), // Rule ID 4165 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
      // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4165,
      GIR_EraseRootFromParent_Done,
    // Label 2135: @111390
    GIM_Try, /*On fail goto*//*Label 2136*/ GIMT_Encode4(111441), // Rule ID 4166 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
      // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4166,
      GIR_EraseRootFromParent_Done,
    // Label 2136: @111441
    GIM_Try, /*On fail goto*//*Label 2137*/ GIMT_Encode4(111492), // Rule ID 4167 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
      // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4167,
      GIR_EraseRootFromParent_Done,
    // Label 2137: @111492
    GIM_Try, /*On fail goto*//*Label 2138*/ GIMT_Encode4(111546), // Rule ID 7224 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
      // (atomic_load:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15321>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7224,
      GIR_EraseRootFromParent_Done,
    // Label 2138: @111546
    GIM_Try, /*On fail goto*//*Label 2139*/ GIMT_Encode4(111600), // Rule ID 7226 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
      // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15321>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7226,
      GIR_EraseRootFromParent_Done,
    // Label 2139: @111600
    GIM_Try, /*On fail goto*//*Label 2140*/ GIMT_Encode4(111654), // Rule ID 7236 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
      // (atomic_load:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15330>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7236,
      GIR_EraseRootFromParent_Done,
    // Label 2140: @111654
    GIM_Try, /*On fail goto*//*Label 2141*/ GIMT_Encode4(111708), // Rule ID 7238 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
      // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15330>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7238,
      GIR_EraseRootFromParent_Done,
    // Label 2141: @111708
    GIM_Try, /*On fail goto*//*Label 2142*/ GIMT_Encode4(111765), // Rule ID 7560 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
      // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15319>>  =>  (LDAPURBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURBi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7560,
      GIR_EraseRootFromParent_Done,
    // Label 2142: @111765
    GIM_Try, /*On fail goto*//*Label 2143*/ GIMT_Encode4(111822), // Rule ID 7562 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
      // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15328>>  =>  (LDAPURHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURHi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7562,
      GIR_EraseRootFromParent_Done,
    // Label 2143: @111822
    GIM_Try, /*On fail goto*//*Label 2144*/ GIMT_Encode4(111859), // Rule ID 7216 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // MIs[0] ptr
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15317>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7216,
      GIR_Done,
    // Label 2144: @111859
    GIM_Try, /*On fail goto*//*Label 2145*/ GIMT_Encode4(111896), // Rule ID 7218 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // MIs[0] ptr
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15319>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7218,
      GIR_Done,
    // Label 2145: @111896
    GIM_Try, /*On fail goto*//*Label 2146*/ GIMT_Encode4(111933), // Rule ID 7228 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // MIs[0] ptr
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15326>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7228,
      GIR_Done,
    // Label 2146: @111933
    GIM_Try, /*On fail goto*//*Label 2147*/ GIMT_Encode4(111970), // Rule ID 7230 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // MIs[0] ptr
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15328>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7230,
      GIR_Done,
    // Label 2147: @111970
    GIM_Reject,
    // Label 2118: @111971
    GIM_Try, /*On fail goto*//*Label 2148*/ GIMT_Encode4(112059), // Rule ID 4088 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
      // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 4088,
      GIR_EraseRootFromParent_Done,
    // Label 2148: @112059
    GIM_Try, /*On fail goto*//*Label 2149*/ GIMT_Encode4(112147), // Rule ID 4089 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
      // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 4089,
      GIR_EraseRootFromParent_Done,
    // Label 2149: @112147
    GIM_Try, /*On fail goto*//*Label 2150*/ GIMT_Encode4(112235), // Rule ID 4090 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
      // (ld:{ *:[i64] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 4090,
      GIR_EraseRootFromParent_Done,
    // Label 2150: @112235
    GIM_Try, /*On fail goto*//*Label 2151*/ GIMT_Encode4(112323), // Rule ID 4091 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
      // (ld:{ *:[i64] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 4091,
      GIR_EraseRootFromParent_Done,
    // Label 2151: @112323
    GIM_Try, /*On fail goto*//*Label 2152*/ GIMT_Encode4(112411), // Rule ID 4092 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
      // (ld:{ *:[i64] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 4092,
      GIR_EraseRootFromParent_Done,
    // Label 2152: @112411
    GIM_Try, /*On fail goto*//*Label 2153*/ GIMT_Encode4(112499), // Rule ID 4093 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
      // (ld:{ *:[i64] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 4093,
      GIR_EraseRootFromParent_Done,
    // Label 2153: @112499
    GIM_Try, /*On fail goto*//*Label 2154*/ GIMT_Encode4(112587), // Rule ID 4094 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
      // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 4094,
      GIR_EraseRootFromParent_Done,
    // Label 2154: @112587
    GIM_Try, /*On fail goto*//*Label 2155*/ GIMT_Encode4(112675), // Rule ID 4095 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
      // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 4095,
      GIR_EraseRootFromParent_Done,
    // Label 2155: @112675
    GIM_Try, /*On fail goto*//*Label 2156*/ GIMT_Encode4(112758), // Rule ID 4130 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
      // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 4130,
      GIR_EraseRootFromParent_Done,
    // Label 2156: @112758
    GIM_Try, /*On fail goto*//*Label 2157*/ GIMT_Encode4(112841), // Rule ID 4131 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
      // (ld:{ *:[i64] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 4131,
      GIR_EraseRootFromParent_Done,
    // Label 2157: @112841
    GIM_Try, /*On fail goto*//*Label 2158*/ GIMT_Encode4(112924), // Rule ID 4133 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
      // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 4133,
      GIR_EraseRootFromParent_Done,
    // Label 2158: @112924
    GIM_Try, /*On fail goto*//*Label 2159*/ GIMT_Encode4(113007), // Rule ID 4141 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
      // (ld:{ *:[i64] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 4141,
      GIR_EraseRootFromParent_Done,
    // Label 2159: @113007
    GIM_Try, /*On fail goto*//*Label 2160*/ GIMT_Encode4(113090), // Rule ID 4168 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
      // (ld:{ *:[i64] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 4168,
      GIR_EraseRootFromParent_Done,
    // Label 2160: @113090
    GIM_Try, /*On fail goto*//*Label 2161*/ GIMT_Encode4(113173), // Rule ID 4169 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
      // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 4169,
      GIR_EraseRootFromParent_Done,
    // Label 2161: @113173
    GIM_Try, /*On fail goto*//*Label 2162*/ GIMT_Encode4(113256), // Rule ID 4170 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
      // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 4170,
      GIR_EraseRootFromParent_Done,
    // Label 2162: @113256
    GIM_Try, /*On fail goto*//*Label 2163*/ GIMT_Encode4(113339), // Rule ID 4171 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
      // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 4171,
      GIR_EraseRootFromParent_Done,
    // Label 2163: @113339
    GIM_Try, /*On fail goto*//*Label 2164*/ GIMT_Encode4(113422), // Rule ID 4172 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
      // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 4172,
      GIR_EraseRootFromParent_Done,
    // Label 2164: @113422
    GIM_Try, /*On fail goto*//*Label 2165*/ GIMT_Encode4(113505), // Rule ID 4173 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
      // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 4173,
      GIR_EraseRootFromParent_Done,
    // Label 2165: @113505
    GIM_Reject,
    // Label 2119: @113506
    GIM_Reject,
    // Label 19: @113507
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(24), /*)*//*default:*//*Label 2186*/ GIMT_Encode4(127583),
    /*GILLT_s8*//*Label 2166*/ GIMT_Encode4(113614),
    /*GILLT_s16*//*Label 2167*/ GIMT_Encode4(113981),
    /*GILLT_s32*//*Label 2168*/ GIMT_Encode4(115369),
    /*GILLT_s64*//*Label 2169*/ GIMT_Encode4(119964),
    /*GILLT_s128*//*Label 2170*/ GIMT_Encode4(123733),
    /*GILLT_v2s32*//*Label 2171*/ GIMT_Encode4(123939),
    /*GILLT_v2s64*//*Label 2172*/ GIMT_Encode4(124345),
    /*GILLT_v4s16*//*Label 2173*/ GIMT_Encode4(124795),
    /*GILLT_v4s32*//*Label 2174*/ GIMT_Encode4(125387),
    /*GILLT_v8s8*//*Label 2175*/ GIMT_Encode4(125793),
    /*GILLT_v8s16*//*Label 2176*/ GIMT_Encode4(126013),
    /*GILLT_v16s8*//*Label 2177*/ GIMT_Encode4(126605), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s16*//*Label 2178*/ GIMT_Encode4(126825),
    /*GILLT_nxv2s32*//*Label 2179*/ GIMT_Encode4(126935),
    /*GILLT_nxv2s64*//*Label 2180*/ GIMT_Encode4(126995), GIMT_Encode4(0),
    /*GILLT_nxv4s16*//*Label 2181*/ GIMT_Encode4(127105),
    /*GILLT_nxv4s32*//*Label 2182*/ GIMT_Encode4(127215), GIMT_Encode4(0),
    /*GILLT_nxv8s16*//*Label 2183*/ GIMT_Encode4(127325),
    /*GILLT_nxv16s1*//*Label 2184*/ GIMT_Encode4(127479),
    /*GILLT_nxv16s8*//*Label 2185*/ GIMT_Encode4(127523),
    // Label 2166: @113614
    GIM_Try, /*On fail goto*//*Label 2187*/ GIMT_Encode4(113980),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_Try, /*On fail goto*//*Label 2188*/ GIMT_Encode4(113694), // Rule ID 13267 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
        // MIs[2] Operand 1
        // No operand predicates
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (st (vector_extract:{ *:[i8] } VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i8 VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13267,
        GIR_EraseRootFromParent_Done,
      // Label 2188: @113694
      GIM_Try, /*On fail goto*//*Label 2189*/ GIMT_Encode4(113793), // Rule ID 13268 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
        // MIs[2] Operand 1
        // No operand predicates
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (st (vector_extract:{ *:[i8] } VecListOne64:{ *:[v8i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i8 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13268,
        GIR_EraseRootFromParent_Done,
      // Label 2189: @113793
      GIM_Try, /*On fail goto*//*Label 2190*/ GIMT_Encode4(113842), // Rule ID 315 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
        // (st FPR8Op:{ *:[i8] }:$Rt, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRBroW FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 315,
        GIR_EraseRootFromParent_Done,
      // Label 2190: @113842
      GIM_Try, /*On fail goto*//*Label 2191*/ GIMT_Encode4(113891), // Rule ID 316 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
        // (st FPR8Op:{ *:[i8] }:$Rt, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRBroX FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 316,
        GIR_EraseRootFromParent_Done,
      // Label 2191: @113891
      GIM_Try, /*On fail goto*//*Label 2192*/ GIMT_Encode4(113935), // Rule ID 325 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
        // (st FPR8Op:{ *:[i8] }:$Rt, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRBui FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBui),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 325,
        GIR_EraseRootFromParent_Done,
      // Label 2192: @113935
      GIM_Try, /*On fail goto*//*Label 2193*/ GIMT_Encode4(113979), // Rule ID 333 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
        // (st FPR8Op:{ *:[i8] }:$Rt, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURBi FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBi),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 333,
        GIR_EraseRootFromParent_Done,
      // Label 2193: @113979
      GIM_Reject,
    // Label 2187: @113980
    GIM_Reject,
    // Label 2167: @113981
    GIM_Try, /*On fail goto*//*Label 2194*/ GIMT_Encode4(115368),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_Try, /*On fail goto*//*Label 2195*/ GIMT_Encode4(114092), // Rule ID 4510 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
        // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroW (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4510,
        GIR_EraseRootFromParent_Done,
      // Label 2195: @114092
      GIM_Try, /*On fail goto*//*Label 2196*/ GIMT_Encode4(114191), // Rule ID 4511 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
        // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroX (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4511,
        GIR_EraseRootFromParent_Done,
      // Label 2196: @114191
      GIM_Try, /*On fail goto*//*Label 2197*/ GIMT_Encode4(114290), // Rule ID 13265 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
        // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroW (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13265,
        GIR_EraseRootFromParent_Done,
      // Label 2197: @114290
      GIM_Try, /*On fail goto*//*Label 2198*/ GIMT_Encode4(114389), // Rule ID 13266 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
        // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroX (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13266,
        GIR_EraseRootFromParent_Done,
      // Label 2198: @114389
      GIM_Try, /*On fail goto*//*Label 2199*/ GIMT_Encode4(114483), // Rule ID 4542 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
        // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHui (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4542,
        GIR_EraseRootFromParent_Done,
      // Label 2199: @114483
      GIM_Try, /*On fail goto*//*Label 2200*/ GIMT_Encode4(114577), // Rule ID 4570 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
        // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURHi (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4570,
        GIR_EraseRootFromParent_Done,
      // Label 2200: @114577
      GIM_Try, /*On fail goto*//*Label 2201*/ GIMT_Encode4(114671), // Rule ID 13264 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
        // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHui (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13264,
        GIR_EraseRootFromParent_Done,
      // Label 2201: @114671
      GIM_Try, /*On fail goto*//*Label 2202*/ GIMT_Encode4(114765), // Rule ID 13270 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
        // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURHi (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13270,
        GIR_EraseRootFromParent_Done,
      // Label 2202: @114765
      GIM_Try, /*On fail goto*//*Label 2203*/ GIMT_Encode4(114833), // Rule ID 6521 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i16 VecListOne128:{ *:[v8f16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6521,
        GIR_EraseRootFromParent_Done,
      // Label 2203: @114833
      GIM_Try, /*On fail goto*//*Label 2204*/ GIMT_Encode4(114901), // Rule ID 6522 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (st (vector_extract:{ *:[bf16] } VecListOne128:{ *:[v8bf16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i16 VecListOne128:{ *:[v8bf16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6522,
        GIR_EraseRootFromParent_Done,
      // Label 2204: @114901
      GIM_Try, /*On fail goto*//*Label 2205*/ GIMT_Encode4(115000), // Rule ID 6527 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (st (vector_extract:{ *:[f16] } VecListOne64:{ *:[v4f16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i16 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4f16] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6527,
        GIR_EraseRootFromParent_Done,
      // Label 2205: @115000
      GIM_Try, /*On fail goto*//*Label 2206*/ GIMT_Encode4(115099), // Rule ID 6528 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (st (vector_extract:{ *:[bf16] } VecListOne64:{ *:[v4bf16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i16 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4bf16] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6528,
        GIR_EraseRootFromParent_Done,
      // Label 2206: @115099
      GIM_Try, /*On fail goto*//*Label 2207*/ GIMT_Encode4(115148), // Rule ID 317 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
        // (st FPR16Op:{ *:[f16] }:$Rt, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroW FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 317,
        GIR_EraseRootFromParent_Done,
      // Label 2207: @115148
      GIM_Try, /*On fail goto*//*Label 2208*/ GIMT_Encode4(115197), // Rule ID 318 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
        // (st FPR16Op:{ *:[f16] }:$Rt, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroX FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 318,
        GIR_EraseRootFromParent_Done,
      // Label 2208: @115197
      GIM_Try, /*On fail goto*//*Label 2209*/ GIMT_Encode4(115241), // Rule ID 326 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
        // (st FPR16Op:{ *:[f16] }:$Rt, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHui FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 326,
        GIR_EraseRootFromParent_Done,
      // Label 2209: @115241
      GIM_Try, /*On fail goto*//*Label 2210*/ GIMT_Encode4(115285), // Rule ID 334 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
        // (st FPR16Op:{ *:[f16] }:$Rt, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURHi FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 334,
        GIR_EraseRootFromParent_Done,
      // Label 2210: @115285
      GIM_Try, /*On fail goto*//*Label 2211*/ GIMT_Encode4(115326), // Rule ID 4520 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
        // (st FPR16Op:{ *:[bf16] }:$Rt, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHui FPR16:{ *:[bf16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4520,
        GIR_EraseRootFromParent_Done,
      // Label 2211: @115326
      GIM_Try, /*On fail goto*//*Label 2212*/ GIMT_Encode4(115367), // Rule ID 4547 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
        // (st FPR16Op:{ *:[bf16] }:$Rt, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURHi FPR16:{ *:[bf16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4547,
        GIR_EraseRootFromParent_Done,
      // Label 2212: @115367
      GIM_Reject,
    // Label 2194: @115368
    GIM_Reject,
    // Label 2168: @115369
    GIM_Try, /*On fail goto*//*Label 2213*/ GIMT_Encode4(115475), // Rule ID 4512 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
      // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4512,
      GIR_EraseRootFromParent_Done,
    // Label 2213: @115475
    GIM_Try, /*On fail goto*//*Label 2214*/ GIMT_Encode4(115581), // Rule ID 4513 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
      // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4513,
      GIR_EraseRootFromParent_Done,
    // Label 2214: @115581
    GIM_Try, /*On fail goto*//*Label 2215*/ GIMT_Encode4(115687), // Rule ID 4514 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
      // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4514,
      GIR_EraseRootFromParent_Done,
    // Label 2215: @115687
    GIM_Try, /*On fail goto*//*Label 2216*/ GIMT_Encode4(115793), // Rule ID 4515 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
      // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4515,
      GIR_EraseRootFromParent_Done,
    // Label 2216: @115793
    GIM_Try, /*On fail goto*//*Label 2217*/ GIMT_Encode4(115899), // Rule ID 13272 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
      // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 13272,
      GIR_EraseRootFromParent_Done,
    // Label 2217: @115899
    GIM_Try, /*On fail goto*//*Label 2218*/ GIMT_Encode4(116005), // Rule ID 13273 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
      // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 13273,
      GIR_EraseRootFromParent_Done,
    // Label 2218: @116005
    GIM_Try, /*On fail goto*//*Label 2219*/ GIMT_Encode4(116118), // Rule ID 4508 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
      // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHroW (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4508,
      GIR_EraseRootFromParent_Done,
    // Label 2219: @116118
    GIM_Try, /*On fail goto*//*Label 2220*/ GIMT_Encode4(116231), // Rule ID 4509 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
      // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHroX (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4509,
      GIR_EraseRootFromParent_Done,
    // Label 2220: @116231
    GIM_Try, /*On fail goto*//*Label 2221*/ GIMT_Encode4(116332), // Rule ID 4543 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
      // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4543,
      GIR_EraseRootFromParent_Done,
    // Label 2221: @116332
    GIM_Try, /*On fail goto*//*Label 2222*/ GIMT_Encode4(116433), // Rule ID 4544 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
      // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4544,
      GIR_EraseRootFromParent_Done,
    // Label 2222: @116433
    GIM_Try, /*On fail goto*//*Label 2223*/ GIMT_Encode4(116534), // Rule ID 4571 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
      // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4571,
      GIR_EraseRootFromParent_Done,
    // Label 2223: @116534
    GIM_Try, /*On fail goto*//*Label 2224*/ GIMT_Encode4(116635), // Rule ID 4572 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
      // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4572,
      GIR_EraseRootFromParent_Done,
    // Label 2224: @116635
    GIM_Try, /*On fail goto*//*Label 2225*/ GIMT_Encode4(116736), // Rule ID 13269 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
      // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 13269,
      GIR_EraseRootFromParent_Done,
    // Label 2225: @116736
    GIM_Try, /*On fail goto*//*Label 2226*/ GIMT_Encode4(116837), // Rule ID 13271 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
      // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 13271,
      GIR_EraseRootFromParent_Done,
    // Label 2226: @116837
    GIM_Try, /*On fail goto*//*Label 2227*/ GIMT_Encode4(116945), // Rule ID 4541 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
      // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHui (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4541,
      GIR_EraseRootFromParent_Done,
    // Label 2227: @116945
    GIM_Try, /*On fail goto*//*Label 2228*/ GIMT_Encode4(117053), // Rule ID 4569 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
      // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STURHi (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4569,
      GIR_EraseRootFromParent_Done,
    // Label 2228: @117053
    GIM_Try, /*On fail goto*//*Label 2229*/ GIMT_Encode4(117128), // Rule ID 6517 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
      GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
      // MIs[2] Operand 1
      // No operand predicates
      // MIs[0] Rn
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/2,
      // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 VecListOne128:{ *:[v4i32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6517,
      GIR_EraseRootFromParent_Done,
    // Label 2229: @117128
    GIM_Try, /*On fail goto*//*Label 2230*/ GIMT_Encode4(117203), // Rule ID 6518 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
      GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
      // MIs[2] Operand 1
      // No operand predicates
      // MIs[0] Rn
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/2,
      // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 VecListOne128:{ *:[v4f32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6518,
      GIR_EraseRootFromParent_Done,
    // Label 2230: @117203
    GIM_Try, /*On fail goto*//*Label 2231*/ GIMT_Encode4(117309), // Rule ID 6525 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
      GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
      // MIs[2] Operand 1
      // No operand predicates
      // MIs[0] Rn
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/2,
      // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2i32] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
      GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6525,
      GIR_EraseRootFromParent_Done,
    // Label 2231: @117309
    GIM_Try, /*On fail goto*//*Label 2232*/ GIMT_Encode4(117415), // Rule ID 6526 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
      GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
      // MIs[2] Operand 1
      // No operand predicates
      // MIs[0] Rn
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/2,
      // (st (vector_extract:{ *:[f32] } VecListOne64:{ *:[v2f32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2f32] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
      GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6526,
      GIR_EraseRootFromParent_Done,
    // Label 2232: @117415
    GIM_Try, /*On fail goto*//*Label 2233*/ GIMT_Encode4(117497), // Rule ID 6515 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
      GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
      // MIs[2] Operand 1
      // No operand predicates
      // MIs[0] Rn
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/2,
      // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (ST1i8 VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6515,
      GIR_EraseRootFromParent_Done,
    // Label 2233: @117497
    GIM_Try, /*On fail goto*//*Label 2234*/ GIMT_Encode4(117579), // Rule ID 6516 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
      GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
      // MIs[2] Operand 1
      // No operand predicates
      // MIs[0] Rn
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/2,
      // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (ST1i16 VecListOne128:{ *:[v8i16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6516,
      GIR_EraseRootFromParent_Done,
    // Label 2234: @117579
    GIM_Try, /*On fail goto*//*Label 2235*/ GIMT_Encode4(117692), // Rule ID 6523 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
      GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
      // MIs[2] Operand 1
      // No operand predicates
      // MIs[0] Rn
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/2,
      // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v8i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (ST1i8 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
      GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6523,
      GIR_EraseRootFromParent_Done,
    // Label 2235: @117692
    GIM_Try, /*On fail goto*//*Label 2236*/ GIMT_Encode4(117805), // Rule ID 6524 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
      GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
      // MIs[2] Operand 1
      // No operand predicates
      // MIs[0] Rn
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/2,
      // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v4i16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (ST1i16 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4i16] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
      GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6524,
      GIR_EraseRootFromParent_Done,
    // Label 2236: @117805
    GIM_Try, /*On fail goto*//*Label 2237*/ GIMT_Encode4(117858), // Rule ID 311 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
      // (st GPR32:{ *:[i32] }:$Rt, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRWroW GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // Rt
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 311,
      GIR_EraseRootFromParent_Done,
    // Label 2237: @117858
    GIM_Try, /*On fail goto*//*Label 2238*/ GIMT_Encode4(117911), // Rule ID 312 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
      // (st GPR32:{ *:[i32] }:$Rt, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRWroX GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // Rt
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 312,
      GIR_EraseRootFromParent_Done,
    // Label 2238: @117911
    GIM_Try, /*On fail goto*//*Label 2239*/ GIMT_Encode4(117967), // Rule ID 319 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
      // (st FPR32Op:{ *:[f32] }:$Rt, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // Rt
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 319,
      GIR_EraseRootFromParent_Done,
    // Label 2239: @117967
    GIM_Try, /*On fail goto*//*Label 2240*/ GIMT_Encode4(118023), // Rule ID 320 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
      // (st FPR32Op:{ *:[f32] }:$Rt, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // Rt
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 320,
      GIR_EraseRootFromParent_Done,
    // Label 2240: @118023
    GIM_Try, /*On fail goto*//*Label 2241*/ GIMT_Encode4(118083), // Rule ID 307 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
      // (st GPR32:{ *:[i32] }:$Rt, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroW GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // Rt
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 307,
      GIR_EraseRootFromParent_Done,
    // Label 2241: @118083
    GIM_Try, /*On fail goto*//*Label 2242*/ GIMT_Encode4(118143), // Rule ID 308 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
      // (st GPR32:{ *:[i32] }:$Rt, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroX GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // Rt
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 308,
      GIR_EraseRootFromParent_Done,
    // Label 2242: @118143
    GIM_Try, /*On fail goto*//*Label 2243*/ GIMT_Encode4(118203), // Rule ID 309 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
      // (st GPR32:{ *:[i32] }:$Rt, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroW GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // Rt
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 309,
      GIR_EraseRootFromParent_Done,
    // Label 2243: @118203
    GIM_Try, /*On fail goto*//*Label 2244*/ GIMT_Encode4(118263), // Rule ID 310 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
      // (st GPR32:{ *:[i32] }:$Rt, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroX GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // Rt
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 310,
      GIR_EraseRootFromParent_Done,
    // Label 2244: @118263
    GIM_Try, /*On fail goto*//*Label 2245*/ GIMT_Encode4(118315), // Rule ID 324 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
      // (st GPR32z:{ *:[i32] }:$Rt, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRWui GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWui),
      GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 324,
      GIR_EraseRootFromParent_Done,
    // Label 2245: @118315
    GIM_Try, /*On fail goto*//*Label 2246*/ GIMT_Encode4(118366), // Rule ID 327 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
      // (st FPR32Op:{ *:[f32] }:$Rt, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
      GIR_RootToRootCopy, /*OpIdx*/0, // Rt
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 327,
      GIR_EraseRootFromParent_Done,
    // Label 2246: @118366
    GIM_Try, /*On fail goto*//*Label 2247*/ GIMT_Encode4(118425), // Rule ID 329 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
      // (st GPR32z:{ *:[i32] }:$Rt, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHui GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHui),
      GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 329,
      GIR_EraseRootFromParent_Done,
    // Label 2247: @118425
    GIM_Try, /*On fail goto*//*Label 2248*/ GIMT_Encode4(118484), // Rule ID 330 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
      // (st GPR32z:{ *:[i32] }:$Rt, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBui GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBui),
      GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 330,
      GIR_EraseRootFromParent_Done,
    // Label 2248: @118484
    GIM_Try, /*On fail goto*//*Label 2249*/ GIMT_Encode4(118561), // Rule ID 7279 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
      // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15375>>  =>  (STRSroW FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7279,
      GIR_EraseRootFromParent_Done,
    // Label 2249: @118561
    GIM_Try, /*On fail goto*//*Label 2250*/ GIMT_Encode4(118638), // Rule ID 7280 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
      // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15375>>  =>  (STRSroX FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7280,
      GIR_EraseRootFromParent_Done,
    // Label 2250: @118638
    GIM_Try, /*On fail goto*//*Label 2251*/ GIMT_Encode4(118697), // Rule ID 7260 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
      // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15361>>  =>  (STRBBroW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // val
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7260,
      GIR_EraseRootFromParent_Done,
    // Label 2251: @118697
    GIM_Try, /*On fail goto*//*Label 2252*/ GIMT_Encode4(118756), // Rule ID 7261 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
      // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15361>>  =>  (STRBBroX GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // val
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7261,
      GIR_EraseRootFromParent_Done,
    // Label 2252: @118756
    GIM_Try, /*On fail goto*//*Label 2253*/ GIMT_Encode4(118815), // Rule ID 7265 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
      // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15368>>  =>  (STRHHroW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // val
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7265,
      GIR_EraseRootFromParent_Done,
    // Label 2253: @118815
    GIM_Try, /*On fail goto*//*Label 2254*/ GIMT_Encode4(118874), // Rule ID 7266 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
      // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15368>>  =>  (STRHHroX GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // val
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7266,
      GIR_EraseRootFromParent_Done,
    // Label 2254: @118874
    GIM_Try, /*On fail goto*//*Label 2255*/ GIMT_Encode4(118933), // Rule ID 7270 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
      // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15375>>  =>  (STRWroW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // val
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7270,
      GIR_EraseRootFromParent_Done,
    // Label 2255: @118933
    GIM_Try, /*On fail goto*//*Label 2256*/ GIMT_Encode4(118992), // Rule ID 7271 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
      // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15375>>  =>  (STRWroX GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // val
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7271,
      GIR_EraseRootFromParent_Done,
    // Label 2256: @118992
    GIM_Try, /*On fail goto*//*Label 2257*/ GIMT_Encode4(119064), // Rule ID 7281 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
      // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15375>>  =>  (STRSui FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7281,
      GIR_EraseRootFromParent_Done,
    // Label 2257: @119064
    GIM_Try, /*On fail goto*//*Label 2258*/ GIMT_Encode4(119136), // Rule ID 7282 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
      // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15375>>  =>  (STURSi FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7282,
      GIR_EraseRootFromParent_Done,
    // Label 2258: @119136
    GIM_Try, /*On fail goto*//*Label 2259*/ GIMT_Encode4(119188), // Rule ID 332 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
      // (st GPR32z:{ *:[i32] }:$Rt, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURWi GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURWi),
      GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 332,
      GIR_EraseRootFromParent_Done,
    // Label 2259: @119188
    GIM_Try, /*On fail goto*//*Label 2260*/ GIMT_Encode4(119239), // Rule ID 335 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
      // (st FPR32Op:{ *:[f32] }:$Rt, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
      GIR_RootToRootCopy, /*OpIdx*/0, // Rt
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 335,
      GIR_EraseRootFromParent_Done,
    // Label 2260: @119239
    GIM_Try, /*On fail goto*//*Label 2261*/ GIMT_Encode4(119298), // Rule ID 338 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
      // (st GPR32z:{ *:[i32] }:$Rt, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STURHHi GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHHi),
      GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 338,
      GIR_EraseRootFromParent_Done,
    // Label 2261: @119298
    GIM_Try, /*On fail goto*//*Label 2262*/ GIMT_Encode4(119357), // Rule ID 339 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
      // (st GPR32z:{ *:[i32] }:$Rt, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STURBBi GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBBi),
      GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 339,
      GIR_EraseRootFromParent_Done,
    // Label 2262: @119357
    GIM_Try, /*On fail goto*//*Label 2263*/ GIMT_Encode4(119411), // Rule ID 7262 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
      // (atomic_store GPR32:{ *:[i32] }:$val, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15361>>  =>  (STRBBui GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBui),
      GIR_RootToRootCopy, /*OpIdx*/0, // val
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7262,
      GIR_EraseRootFromParent_Done,
    // Label 2263: @119411
    GIM_Try, /*On fail goto*//*Label 2264*/ GIMT_Encode4(119465), // Rule ID 7263 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
      // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15361>>  =>  (STURBBi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBBi),
      GIR_RootToRootCopy, /*OpIdx*/0, // val
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7263,
      GIR_EraseRootFromParent_Done,
    // Label 2264: @119465
    GIM_Try, /*On fail goto*//*Label 2265*/ GIMT_Encode4(119519), // Rule ID 7267 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
      // (atomic_store GPR32:{ *:[i32] }:$val, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15368>>  =>  (STRHHui GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHui),
      GIR_RootToRootCopy, /*OpIdx*/0, // val
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7267,
      GIR_EraseRootFromParent_Done,
    // Label 2265: @119519
    GIM_Try, /*On fail goto*//*Label 2266*/ GIMT_Encode4(119573), // Rule ID 7268 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
      // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15368>>  =>  (STURHHi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHHi),
      GIR_RootToRootCopy, /*OpIdx*/0, // val
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7268,
      GIR_EraseRootFromParent_Done,
    // Label 2266: @119573
    GIM_Try, /*On fail goto*//*Label 2267*/ GIMT_Encode4(119627), // Rule ID 7272 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
      // (atomic_store GPR32:{ *:[i32] }:$val, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15375>>  =>  (STRWui GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWui),
      GIR_RootToRootCopy, /*OpIdx*/0, // val
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7272,
      GIR_EraseRootFromParent_Done,
    // Label 2267: @119627
    GIM_Try, /*On fail goto*//*Label 2268*/ GIMT_Encode4(119681), // Rule ID 7273 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
      // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15375>>  =>  (STURWi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURWi),
      GIR_RootToRootCopy, /*OpIdx*/0, // val
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7273,
      GIR_EraseRootFromParent_Done,
    // Label 2268: @119681
    GIM_Try, /*On fail goto*//*Label 2269*/ GIMT_Encode4(119738), // Rule ID 7565 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
      // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15359>>  =>  (STLURBi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURBi),
      GIR_RootToRootCopy, /*OpIdx*/0, // val
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7565,
      GIR_EraseRootFromParent_Done,
    // Label 2269: @119738
    GIM_Try, /*On fail goto*//*Label 2270*/ GIMT_Encode4(119795), // Rule ID 7566 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
      // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15366>>  =>  (STLURHi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURHi),
      GIR_RootToRootCopy, /*OpIdx*/0, // val
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7566,
      GIR_EraseRootFromParent_Done,
    // Label 2270: @119795
    GIM_Try, /*On fail goto*//*Label 2271*/ GIMT_Encode4(119852), // Rule ID 7567 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
      // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15373>>  =>  (STLURWi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURWi),
      GIR_RootToRootCopy, /*OpIdx*/0, // val
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7567,
      GIR_EraseRootFromParent_Done,
    // Label 2271: @119852
    GIM_Try, /*On fail goto*//*Label 2272*/ GIMT_Encode4(119889), // Rule ID 7259 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // MIs[0] ptr
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      // (atomic_store GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15359>>  =>  (STLRB GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRB),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7259,
      GIR_Done,
    // Label 2272: @119889
    GIM_Try, /*On fail goto*//*Label 2273*/ GIMT_Encode4(119926), // Rule ID 7264 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // MIs[0] ptr
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      // (atomic_store GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15366>>  =>  (STLRH GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRH),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7264,
      GIR_Done,
    // Label 2273: @119926
    GIM_Try, /*On fail goto*//*Label 2274*/ GIMT_Encode4(119963), // Rule ID 7269 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // MIs[0] ptr
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      // (atomic_store GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15373>>  =>  (STLRW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRW),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7269,
      GIR_Done,
    // Label 2274: @119963
    GIM_Reject,
    // Label 2169: @119964
    GIM_Try, /*On fail goto*//*Label 2275*/ GIMT_Encode4(120070), // Rule ID 4516 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
      // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4516,
      GIR_EraseRootFromParent_Done,
    // Label 2275: @120070
    GIM_Try, /*On fail goto*//*Label 2276*/ GIMT_Encode4(120176), // Rule ID 4517 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
      // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4517,
      GIR_EraseRootFromParent_Done,
    // Label 2276: @120176
    GIM_Try, /*On fail goto*//*Label 2277*/ GIMT_Encode4(120282), // Rule ID 4518 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
      // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4518,
      GIR_EraseRootFromParent_Done,
    // Label 2277: @120282
    GIM_Try, /*On fail goto*//*Label 2278*/ GIMT_Encode4(120388), // Rule ID 4519 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
      // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4519,
      GIR_EraseRootFromParent_Done,
    // Label 2278: @120388
    GIM_Try, /*On fail goto*//*Label 2279*/ GIMT_Encode4(120489), // Rule ID 4545 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
      // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4545,
      GIR_EraseRootFromParent_Done,
    // Label 2279: @120489
    GIM_Try, /*On fail goto*//*Label 2280*/ GIMT_Encode4(120590), // Rule ID 4546 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
      // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4546,
      GIR_EraseRootFromParent_Done,
    // Label 2280: @120590
    GIM_Try, /*On fail goto*//*Label 2281*/ GIMT_Encode4(120691), // Rule ID 4573 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
      // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4573,
      GIR_EraseRootFromParent_Done,
    // Label 2281: @120691
    GIM_Try, /*On fail goto*//*Label 2282*/ GIMT_Encode4(120792), // Rule ID 4574 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
      // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4574,
      GIR_EraseRootFromParent_Done,
    // Label 2282: @120792
    GIM_Try, /*On fail goto*//*Label 2283*/ GIMT_Encode4(120867), // Rule ID 6519 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
      GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
      // MIs[2] Operand 1
      // No operand predicates
      // MIs[0] Rn
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/2,
      // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i64 VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i64),
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6519,
      GIR_EraseRootFromParent_Done,
    // Label 2283: @120867
    GIM_Try, /*On fail goto*//*Label 2284*/ GIMT_Encode4(120942), // Rule ID 6520 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
      GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
      // MIs[2] Operand 1
      // No operand predicates
      // MIs[0] Rn
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/2,
      // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i64 VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i64),
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6520,
      GIR_EraseRootFromParent_Done,
    // Label 2284: @120942
    GIM_Try, /*On fail goto*//*Label 2285*/ GIMT_Encode4(120995), // Rule ID 313 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
      // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRXroW GPR64:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // Rt
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 313,
      GIR_EraseRootFromParent_Done,
    // Label 2285: @120995
    GIM_Try, /*On fail goto*//*Label 2286*/ GIMT_Encode4(121048), // Rule ID 314 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
      // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRXroX GPR64:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // Rt
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 314,
      GIR_EraseRootFromParent_Done,
    // Label 2286: @121048
    GIM_Try, /*On fail goto*//*Label 2287*/ GIMT_Encode4(121104), // Rule ID 321 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
      // (st FPR64Op:{ *:[f64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // Rt
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 321,
      GIR_EraseRootFromParent_Done,
    // Label 2287: @121104
    GIM_Try, /*On fail goto*//*Label 2288*/ GIMT_Encode4(121160), // Rule ID 322 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
      // (st FPR64Op:{ *:[f64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // Rt
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 322,
      GIR_EraseRootFromParent_Done,
    // Label 2288: @121160
    GIM_Try, /*On fail goto*//*Label 2289*/ GIMT_Encode4(121213), // Rule ID 4488 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
      // (st FPR64:{ *:[v1i64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // Rt
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4488,
      GIR_EraseRootFromParent_Done,
    // Label 2289: @121213
    GIM_Try, /*On fail goto*//*Label 2290*/ GIMT_Encode4(121266), // Rule ID 4489 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
      // (st FPR64:{ *:[v1i64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // Rt
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4489,
      GIR_EraseRootFromParent_Done,
    // Label 2290: @121266
    GIM_Try, /*On fail goto*//*Label 2291*/ GIMT_Encode4(121319), // Rule ID 4490 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
      // (st FPR64:{ *:[v1f64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // Rt
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4490,
      GIR_EraseRootFromParent_Done,
    // Label 2291: @121319
    GIM_Try, /*On fail goto*//*Label 2292*/ GIMT_Encode4(121372), // Rule ID 4491 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
      // (st FPR64:{ *:[v1f64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // Rt
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4491,
      GIR_EraseRootFromParent_Done,
    // Label 2292: @121372
    GIM_Try, /*On fail goto*//*Label 2293*/ GIMT_Encode4(121461), // Rule ID 4470 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
      // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroW (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroW),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4470,
      GIR_EraseRootFromParent_Done,
    // Label 2293: @121461
    GIM_Try, /*On fail goto*//*Label 2294*/ GIMT_Encode4(121550), // Rule ID 4471 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
      // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroX (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroX),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4471,
      GIR_EraseRootFromParent_Done,
    // Label 2294: @121550
    GIM_Try, /*On fail goto*//*Label 2295*/ GIMT_Encode4(121639), // Rule ID 4472 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
      // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroW (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroW),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4472,
      GIR_EraseRootFromParent_Done,
    // Label 2295: @121639
    GIM_Try, /*On fail goto*//*Label 2296*/ GIMT_Encode4(121728), // Rule ID 4473 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
      // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroX (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroX),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4473,
      GIR_EraseRootFromParent_Done,
    // Label 2296: @121728
    GIM_Try, /*On fail goto*//*Label 2297*/ GIMT_Encode4(121817), // Rule ID 4474 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
      // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STRWroW (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroW),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4474,
      GIR_EraseRootFromParent_Done,
    // Label 2297: @121817
    GIM_Try, /*On fail goto*//*Label 2298*/ GIMT_Encode4(121906), // Rule ID 4475 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
      // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STRWroX (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroX),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4475,
      GIR_EraseRootFromParent_Done,
    // Label 2298: @121906
    GIM_Try, /*On fail goto*//*Label 2299*/ GIMT_Encode4(121958), // Rule ID 323 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
      // (st GPR64z:{ *:[i64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRXui GPR64z:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXui),
      GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::XZR), // Rt
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 323,
      GIR_EraseRootFromParent_Done,
    // Label 2299: @121958
    GIM_Try, /*On fail goto*//*Label 2300*/ GIMT_Encode4(122009), // Rule ID 328 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
      // (st FPR64Op:{ *:[f64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
      GIR_RootToRootCopy, /*OpIdx*/0, // Rt
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 328,
      GIR_EraseRootFromParent_Done,
    // Label 2300: @122009
    GIM_Try, /*On fail goto*//*Label 2301*/ GIMT_Encode4(122057), // Rule ID 4521 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
      // (st FPR64:{ *:[v1i64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
      GIR_RootToRootCopy, /*OpIdx*/0, // Rt
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4521,
      GIR_EraseRootFromParent_Done,
    // Label 2301: @122057
    GIM_Try, /*On fail goto*//*Label 2302*/ GIMT_Encode4(122105), // Rule ID 4522 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
      // (st FPR64:{ *:[v1f64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
      GIR_RootToRootCopy, /*OpIdx*/0, // Rt
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4522,
      GIR_EraseRootFromParent_Done,
    // Label 2302: @122105
    GIM_Try, /*On fail goto*//*Label 2303*/ GIMT_Encode4(122189), // Rule ID 4538 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
      // (st GPR64:{ *:[i64] }:$Rt, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STRWui (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWui),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4538,
      GIR_EraseRootFromParent_Done,
    // Label 2303: @122189
    GIM_Try, /*On fail goto*//*Label 2304*/ GIMT_Encode4(122273), // Rule ID 4539 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
      // (st GPR64:{ *:[i64] }:$Rt, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHui (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHui),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4539,
      GIR_EraseRootFromParent_Done,
    // Label 2304: @122273
    GIM_Try, /*On fail goto*//*Label 2305*/ GIMT_Encode4(122357), // Rule ID 4540 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
      // (st GPR64:{ *:[i64] }:$Rt, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBui (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBui),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4540,
      GIR_EraseRootFromParent_Done,
    // Label 2305: @122357
    GIM_Try, /*On fail goto*//*Label 2306*/ GIMT_Encode4(122434), // Rule ID 7283 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
      // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15382>>  =>  (STRDroW FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7283,
      GIR_EraseRootFromParent_Done,
    // Label 2306: @122434
    GIM_Try, /*On fail goto*//*Label 2307*/ GIMT_Encode4(122511), // Rule ID 7284 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
      // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15382>>  =>  (STRDroX FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7284,
      GIR_EraseRootFromParent_Done,
    // Label 2307: @122511
    GIM_Try, /*On fail goto*//*Label 2308*/ GIMT_Encode4(122570), // Rule ID 7275 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
      // (atomic_store GPR64:{ *:[i64] }:$val, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15382>>  =>  (STRXroW GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroW),
      GIR_RootToRootCopy, /*OpIdx*/0, // val
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7275,
      GIR_EraseRootFromParent_Done,
    // Label 2308: @122570
    GIM_Try, /*On fail goto*//*Label 2309*/ GIMT_Encode4(122629), // Rule ID 7276 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
      // (atomic_store GPR64:{ *:[i64] }:$val, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15382>>  =>  (STRXroX GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroX),
      GIR_RootToRootCopy, /*OpIdx*/0, // val
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7276,
      GIR_EraseRootFromParent_Done,
    // Label 2309: @122629
    GIM_Try, /*On fail goto*//*Label 2310*/ GIMT_Encode4(122701), // Rule ID 7285 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
      // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15382>>  =>  (STRDui FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7285,
      GIR_EraseRootFromParent_Done,
    // Label 2310: @122701
    GIM_Try, /*On fail goto*//*Label 2311*/ GIMT_Encode4(122773), // Rule ID 7286 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
      // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15382>>  =>  (STURDi FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7286,
      GIR_EraseRootFromParent_Done,
    // Label 2311: @122773
    GIM_Try, /*On fail goto*//*Label 2312*/ GIMT_Encode4(122870), // Rule ID 7557 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
      GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
      GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
      // MIs[3] Operand 1
      // No operand predicates
      // MIs[0] Rn
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/3,
      // (atomic_store (bitconvert:{ *:[i64] } (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15380>>  =>  (STL1 VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STL1),
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vt
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7557,
      GIR_EraseRootFromParent_Done,
    // Label 2312: @122870
    GIM_Try, /*On fail goto*//*Label 2313*/ GIMT_Encode4(122922), // Rule ID 331 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
      // (st GPR64z:{ *:[i64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURXi GPR64z:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURXi),
      GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::XZR), // Rt
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 331,
      GIR_EraseRootFromParent_Done,
    // Label 2313: @122922
    GIM_Try, /*On fail goto*//*Label 2314*/ GIMT_Encode4(122973), // Rule ID 336 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
      // (st FPR64Op:{ *:[f64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
      GIR_RootToRootCopy, /*OpIdx*/0, // Rt
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 336,
      GIR_EraseRootFromParent_Done,
    // Label 2314: @122973
    GIM_Try, /*On fail goto*//*Label 2315*/ GIMT_Encode4(123027), // Rule ID 7277 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
      // (atomic_store GPR64:{ *:[i64] }:$val, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15382>>  =>  (STRXui GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXui),
      GIR_RootToRootCopy, /*OpIdx*/0, // val
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7277,
      GIR_EraseRootFromParent_Done,
    // Label 2315: @123027
    GIM_Try, /*On fail goto*//*Label 2316*/ GIMT_Encode4(123081), // Rule ID 7278 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
      // (atomic_store GPR64:{ *:[i64] }:$val, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15382>>  =>  (STURXi GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURXi),
      GIR_RootToRootCopy, /*OpIdx*/0, // val
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7278,
      GIR_EraseRootFromParent_Done,
    // Label 2316: @123081
    GIM_Try, /*On fail goto*//*Label 2317*/ GIMT_Encode4(123138), // Rule ID 7568 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
      // (atomic_store GPR64:{ *:[i64] }:$val, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15380>>  =>  (STLURXi GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURXi),
      GIR_RootToRootCopy, /*OpIdx*/0, // val
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7568,
      GIR_EraseRootFromParent_Done,
    // Label 2317: @123138
    GIM_Try, /*On fail goto*//*Label 2318*/ GIMT_Encode4(123186), // Rule ID 4548 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
      // (st FPR64:{ *:[v1f64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
      GIR_RootToRootCopy, /*OpIdx*/0, // Rt
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4548,
      GIR_EraseRootFromParent_Done,
    // Label 2318: @123186
    GIM_Try, /*On fail goto*//*Label 2319*/ GIMT_Encode4(123234), // Rule ID 4549 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
      // (st FPR64:{ *:[v1i64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
      GIR_RootToRootCopy, /*OpIdx*/0, // Rt
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4549,
      GIR_EraseRootFromParent_Done,
    // Label 2319: @123234
    GIM_Try, /*On fail goto*//*Label 2320*/ GIMT_Encode4(123318), // Rule ID 4566 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
      // (st GPR64:{ *:[i64] }:$Rt, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STURWi (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURWi),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4566,
      GIR_EraseRootFromParent_Done,
    // Label 2320: @123318
    GIM_Try, /*On fail goto*//*Label 2321*/ GIMT_Encode4(123402), // Rule ID 4567 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
      // (st GPR64:{ *:[i64] }:$Rt, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STURHHi (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHHi),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4567,
      GIR_EraseRootFromParent_Done,
    // Label 2321: @123402
    GIM_Try, /*On fail goto*//*Label 2322*/ GIMT_Encode4(123486), // Rule ID 4568 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
      // (st GPR64:{ *:[i64] }:$Rt, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STURBBi (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBBi),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4568,
      GIR_EraseRootFromParent_Done,
    // Label 2322: @123486
    GIM_Try, /*On fail goto*//*Label 2323*/ GIMT_Encode4(123570), // Rule ID 7556 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
      GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
      // MIs[2] Operand 1
      // No operand predicates
      // MIs[0] Rn
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/2,
      // (atomic_store (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15380>>  =>  (STL1 VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STL1),
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7556,
      GIR_EraseRootFromParent_Done,
    // Label 2323: @123570
    GIM_Try, /*On fail goto*//*Label 2324*/ GIMT_Encode4(123668), // Rule ID 7558 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // MIs[0] Rn
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (atomic_store (bitconvert:{ *:[i64] } VecListOne64:{ *:[v1f64] }:$Vt), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15380>>  =>  (STL1 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, VecListOne64:{ *:[v1f64] }:$Vt, dsub:{ *:[i32] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
      GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STL1),
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7558,
      GIR_EraseRootFromParent_Done,
    // Label 2324: @123668
    GIM_Try, /*On fail goto*//*Label 2325*/ GIMT_Encode4(123705), // Rule ID 7274 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // MIs[0] ptr
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      // (atomic_store GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15380>>  =>  (STLRX GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$ptr)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRX),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7274,
      GIR_Done,
    // Label 2325: @123705
    GIM_Try, /*On fail goto*//*Label 2326*/ GIMT_Encode4(123732), // Rule ID 6465 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      // MIs[0] Rn
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      // (st v1i64:{ *:[v1i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev1d v1i64:{ *:[v1i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev1d),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6465,
      GIR_Done,
    // Label 2326: @123732
    GIM_Reject,
    // Label 2170: @123733
    GIM_Try, /*On fail goto*//*Label 2327*/ GIMT_Encode4(123938),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_Try, /*On fail goto*//*Label 2328*/ GIMT_Encode4(123794), // Rule ID 4468 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSTRQro),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
        // (st FPR128:{ *:[f128] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4468,
        GIR_EraseRootFromParent_Done,
      // Label 2328: @123794
      GIM_Try, /*On fail goto*//*Label 2329*/ GIMT_Encode4(123835), // Rule ID 4469 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSTRQro),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
        // (st FPR128:{ *:[f128] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4469,
        GIR_EraseRootFromParent_Done,
      // Label 2329: @123835
      GIM_Try, /*On fail goto*//*Label 2330*/ GIMT_Encode4(123868), // Rule ID 4529 //
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
        // (st FPR128:{ *:[f128] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4529,
        GIR_EraseRootFromParent_Done,
      // Label 2330: @123868
      GIM_Try, /*On fail goto*//*Label 2331*/ GIMT_Encode4(123901), // Rule ID 4556 //
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
        // (st FPR128:{ *:[f128] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4556,
        GIR_EraseRootFromParent_Done,
      // Label 2331: @123901
      GIM_Try, /*On fail goto*//*Label 2332*/ GIMT_Encode4(123937), // Rule ID 337 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
        // (st FPR128Op:{ *:[f128] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128Op:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 337,
        GIR_EraseRootFromParent_Done,
      // Label 2332: @123937
      GIM_Reject,
    // Label 2327: @123938
    GIM_Reject,
    // Label 2171: @123939
    GIM_Try, /*On fail goto*//*Label 2333*/ GIMT_Encode4(124344),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_Try, /*On fail goto*//*Label 2334*/ GIMT_Encode4(124000), // Rule ID 4476 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
        // (st FPR64:{ *:[v2i32] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4476,
        GIR_EraseRootFromParent_Done,
      // Label 2334: @124000
      GIM_Try, /*On fail goto*//*Label 2335*/ GIMT_Encode4(124049), // Rule ID 4477 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
        // (st FPR64:{ *:[v2i32] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4477,
        GIR_EraseRootFromParent_Done,
      // Label 2335: @124049
      GIM_Try, /*On fail goto*//*Label 2336*/ GIMT_Encode4(124098), // Rule ID 4478 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
        // (st FPR64:{ *:[v2f32] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4478,
        GIR_EraseRootFromParent_Done,
      // Label 2336: @124098
      GIM_Try, /*On fail goto*//*Label 2337*/ GIMT_Encode4(124147), // Rule ID 4479 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
        // (st FPR64:{ *:[v2f32] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4479,
        GIR_EraseRootFromParent_Done,
      // Label 2337: @124147
      GIM_Try, /*On fail goto*//*Label 2338*/ GIMT_Encode4(124191), // Rule ID 4523 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
        // (st FPR64:{ *:[v2f32] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4523,
        GIR_EraseRootFromParent_Done,
      // Label 2338: @124191
      GIM_Try, /*On fail goto*//*Label 2339*/ GIMT_Encode4(124235), // Rule ID 4526 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
        // (st FPR64:{ *:[v2i32] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4526,
        GIR_EraseRootFromParent_Done,
      // Label 2339: @124235
      GIM_Try, /*On fail goto*//*Label 2340*/ GIMT_Encode4(124279), // Rule ID 4550 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
        // (st FPR64:{ *:[v2f32] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4550,
        GIR_EraseRootFromParent_Done,
      // Label 2340: @124279
      GIM_Try, /*On fail goto*//*Label 2341*/ GIMT_Encode4(124323), // Rule ID 4553 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
        // (st FPR64:{ *:[v2i32] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4553,
        GIR_EraseRootFromParent_Done,
      // Label 2341: @124323
      GIM_Try, /*On fail goto*//*Label 2342*/ GIMT_Encode4(124343), // Rule ID 6464 //
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        // (st v2i32:{ *:[v2i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev2s v2i32:{ *:[v2i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev2s),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6464,
        GIR_Done,
      // Label 2342: @124343
      GIM_Reject,
    // Label 2333: @124344
    GIM_Reject,
    // Label 2172: @124345
    GIM_Try, /*On fail goto*//*Label 2343*/ GIMT_Encode4(124794),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_Try, /*On fail goto*//*Label 2344*/ GIMT_Encode4(124406), // Rule ID 4492 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
        // (st FPR128:{ *:[v2i64] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4492,
        GIR_EraseRootFromParent_Done,
      // Label 2344: @124406
      GIM_Try, /*On fail goto*//*Label 2345*/ GIMT_Encode4(124455), // Rule ID 4493 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
        // (st FPR128:{ *:[v2i64] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4493,
        GIR_EraseRootFromParent_Done,
      // Label 2345: @124455
      GIM_Try, /*On fail goto*//*Label 2346*/ GIMT_Encode4(124504), // Rule ID 4494 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
        // (st FPR128:{ *:[v2f64] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4494,
        GIR_EraseRootFromParent_Done,
      // Label 2346: @124504
      GIM_Try, /*On fail goto*//*Label 2347*/ GIMT_Encode4(124553), // Rule ID 4495 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
        // (st FPR128:{ *:[v2f64] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4495,
        GIR_EraseRootFromParent_Done,
      // Label 2347: @124553
      GIM_Try, /*On fail goto*//*Label 2348*/ GIMT_Encode4(124597), // Rule ID 4531 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
        // (st FPR128:{ *:[v2f64] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4531,
        GIR_EraseRootFromParent_Done,
      // Label 2348: @124597
      GIM_Try, /*On fail goto*//*Label 2349*/ GIMT_Encode4(124641), // Rule ID 4535 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
        // (st FPR128:{ *:[v2i64] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4535,
        GIR_EraseRootFromParent_Done,
      // Label 2349: @124641
      GIM_Try, /*On fail goto*//*Label 2350*/ GIMT_Encode4(124685), // Rule ID 4558 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
        // (st FPR128:{ *:[v2f64] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4558,
        GIR_EraseRootFromParent_Done,
      // Label 2350: @124685
      GIM_Try, /*On fail goto*//*Label 2351*/ GIMT_Encode4(124729), // Rule ID 4562 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
        // (st FPR128:{ *:[v2i64] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4562,
        GIR_EraseRootFromParent_Done,
      // Label 2351: @124729
      GIM_Try, /*On fail goto*//*Label 2352*/ GIMT_Encode4(124773), // Rule ID 4563 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
        // (st FPR128:{ *:[v2f64] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4563,
        GIR_EraseRootFromParent_Done,
      // Label 2352: @124773
      GIM_Try, /*On fail goto*//*Label 2353*/ GIMT_Encode4(124793), // Rule ID 6461 //
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        // (st v2i64:{ *:[v2i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev2d v2i64:{ *:[v2i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev2d),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6461,
        GIR_Done,
      // Label 2353: @124793
      GIM_Reject,
    // Label 2343: @124794
    GIM_Reject,
    // Label 2173: @124795
    GIM_Try, /*On fail goto*//*Label 2354*/ GIMT_Encode4(125386),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_Try, /*On fail goto*//*Label 2355*/ GIMT_Encode4(124856), // Rule ID 4480 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
        // (st FPR64:{ *:[v4i16] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4480,
        GIR_EraseRootFromParent_Done,
      // Label 2355: @124856
      GIM_Try, /*On fail goto*//*Label 2356*/ GIMT_Encode4(124905), // Rule ID 4481 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
        // (st FPR64:{ *:[v4i16] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4481,
        GIR_EraseRootFromParent_Done,
      // Label 2356: @124905
      GIM_Try, /*On fail goto*//*Label 2357*/ GIMT_Encode4(124954), // Rule ID 4484 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
        // (st FPR64:{ *:[v4f16] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4484,
        GIR_EraseRootFromParent_Done,
      // Label 2357: @124954
      GIM_Try, /*On fail goto*//*Label 2358*/ GIMT_Encode4(125003), // Rule ID 4485 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
        // (st FPR64:{ *:[v4f16] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4485,
        GIR_EraseRootFromParent_Done,
      // Label 2358: @125003
      GIM_Try, /*On fail goto*//*Label 2359*/ GIMT_Encode4(125052), // Rule ID 4486 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
        // (st FPR64:{ *:[v4bf16] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v4bf16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4486,
        GIR_EraseRootFromParent_Done,
      // Label 2359: @125052
      GIM_Try, /*On fail goto*//*Label 2360*/ GIMT_Encode4(125101), // Rule ID 4487 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
        // (st FPR64:{ *:[v4bf16] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v4bf16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4487,
        GIR_EraseRootFromParent_Done,
      // Label 2360: @125101
      GIM_Try, /*On fail goto*//*Label 2361*/ GIMT_Encode4(125145), // Rule ID 4525 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
        // (st FPR64:{ *:[v4i16] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4525,
        GIR_EraseRootFromParent_Done,
      // Label 2361: @125145
      GIM_Try, /*On fail goto*//*Label 2362*/ GIMT_Encode4(125189), // Rule ID 4527 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
        // (st FPR64:{ *:[v4f16] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4527,
        GIR_EraseRootFromParent_Done,
      // Label 2362: @125189
      GIM_Try, /*On fail goto*//*Label 2363*/ GIMT_Encode4(125233), // Rule ID 4528 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
        // (st FPR64:{ *:[v4bf16] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v4bf16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4528,
        GIR_EraseRootFromParent_Done,
      // Label 2363: @125233
      GIM_Try, /*On fail goto*//*Label 2364*/ GIMT_Encode4(125277), // Rule ID 4552 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
        // (st FPR64:{ *:[v4i16] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4552,
        GIR_EraseRootFromParent_Done,
      // Label 2364: @125277
      GIM_Try, /*On fail goto*//*Label 2365*/ GIMT_Encode4(125321), // Rule ID 4554 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
        // (st FPR64:{ *:[v4f16] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4554,
        GIR_EraseRootFromParent_Done,
      // Label 2365: @125321
      GIM_Try, /*On fail goto*//*Label 2366*/ GIMT_Encode4(125365), // Rule ID 4555 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
        // (st FPR64:{ *:[v4bf16] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v4bf16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4555,
        GIR_EraseRootFromParent_Done,
      // Label 2366: @125365
      GIM_Try, /*On fail goto*//*Label 2367*/ GIMT_Encode4(125385), // Rule ID 6463 //
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        // (st v4i16:{ *:[v4i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev4h v4i16:{ *:[v4i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev4h),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6463,
        GIR_Done,
      // Label 2367: @125385
      GIM_Reject,
    // Label 2354: @125386
    GIM_Reject,
    // Label 2174: @125387
    GIM_Try, /*On fail goto*//*Label 2368*/ GIMT_Encode4(125792),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_Try, /*On fail goto*//*Label 2369*/ GIMT_Encode4(125448), // Rule ID 4496 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
        // (st FPR128:{ *:[v4i32] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4496,
        GIR_EraseRootFromParent_Done,
      // Label 2369: @125448
      GIM_Try, /*On fail goto*//*Label 2370*/ GIMT_Encode4(125497), // Rule ID 4497 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
        // (st FPR128:{ *:[v4i32] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4497,
        GIR_EraseRootFromParent_Done,
      // Label 2370: @125497
      GIM_Try, /*On fail goto*//*Label 2371*/ GIMT_Encode4(125546), // Rule ID 4498 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
        // (st FPR128:{ *:[v4f32] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4498,
        GIR_EraseRootFromParent_Done,
      // Label 2371: @125546
      GIM_Try, /*On fail goto*//*Label 2372*/ GIMT_Encode4(125595), // Rule ID 4499 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
        // (st FPR128:{ *:[v4f32] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4499,
        GIR_EraseRootFromParent_Done,
      // Label 2372: @125595
      GIM_Try, /*On fail goto*//*Label 2373*/ GIMT_Encode4(125639), // Rule ID 4530 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
        // (st FPR128:{ *:[v4f32] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4530,
        GIR_EraseRootFromParent_Done,
      // Label 2373: @125639
      GIM_Try, /*On fail goto*//*Label 2374*/ GIMT_Encode4(125683), // Rule ID 4534 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
        // (st FPR128:{ *:[v4i32] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4534,
        GIR_EraseRootFromParent_Done,
      // Label 2374: @125683
      GIM_Try, /*On fail goto*//*Label 2375*/ GIMT_Encode4(125727), // Rule ID 4557 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
        // (st FPR128:{ *:[v4f32] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4557,
        GIR_EraseRootFromParent_Done,
      // Label 2375: @125727
      GIM_Try, /*On fail goto*//*Label 2376*/ GIMT_Encode4(125771), // Rule ID 4561 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
        // (st FPR128:{ *:[v4i32] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4561,
        GIR_EraseRootFromParent_Done,
      // Label 2376: @125771
      GIM_Try, /*On fail goto*//*Label 2377*/ GIMT_Encode4(125791), // Rule ID 6460 //
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        // (st v4i32:{ *:[v4i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev4s v4i32:{ *:[v4i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev4s),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6460,
        GIR_Done,
      // Label 2377: @125791
      GIM_Reject,
    // Label 2368: @125792
    GIM_Reject,
    // Label 2175: @125793
    GIM_Try, /*On fail goto*//*Label 2378*/ GIMT_Encode4(126012),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_Try, /*On fail goto*//*Label 2379*/ GIMT_Encode4(125854), // Rule ID 4482 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
        // (st FPR64:{ *:[v8i8] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4482,
        GIR_EraseRootFromParent_Done,
      // Label 2379: @125854
      GIM_Try, /*On fail goto*//*Label 2380*/ GIMT_Encode4(125903), // Rule ID 4483 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
        // (st FPR64:{ *:[v8i8] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4483,
        GIR_EraseRootFromParent_Done,
      // Label 2380: @125903
      GIM_Try, /*On fail goto*//*Label 2381*/ GIMT_Encode4(125947), // Rule ID 4524 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
        // (st FPR64:{ *:[v8i8] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4524,
        GIR_EraseRootFromParent_Done,
      // Label 2381: @125947
      GIM_Try, /*On fail goto*//*Label 2382*/ GIMT_Encode4(125991), // Rule ID 4551 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
        // (st FPR64:{ *:[v8i8] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4551,
        GIR_EraseRootFromParent_Done,
      // Label 2382: @125991
      GIM_Try, /*On fail goto*//*Label 2383*/ GIMT_Encode4(126011), // Rule ID 6462 //
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        // (st v8i8:{ *:[v8i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev8b v8i8:{ *:[v8i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev8b),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6462,
        GIR_Done,
      // Label 2383: @126011
      GIM_Reject,
    // Label 2378: @126012
    GIM_Reject,
    // Label 2176: @126013
    GIM_Try, /*On fail goto*//*Label 2384*/ GIMT_Encode4(126604),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_Try, /*On fail goto*//*Label 2385*/ GIMT_Encode4(126074), // Rule ID 4500 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
        // (st FPR128:{ *:[v8i16] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4500,
        GIR_EraseRootFromParent_Done,
      // Label 2385: @126074
      GIM_Try, /*On fail goto*//*Label 2386*/ GIMT_Encode4(126123), // Rule ID 4501 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
        // (st FPR128:{ *:[v8i16] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4501,
        GIR_EraseRootFromParent_Done,
      // Label 2386: @126123
      GIM_Try, /*On fail goto*//*Label 2387*/ GIMT_Encode4(126172), // Rule ID 4504 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
        // (st FPR128:{ *:[v8f16] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4504,
        GIR_EraseRootFromParent_Done,
      // Label 2387: @126172
      GIM_Try, /*On fail goto*//*Label 2388*/ GIMT_Encode4(126221), // Rule ID 4505 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
        // (st FPR128:{ *:[v8f16] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4505,
        GIR_EraseRootFromParent_Done,
      // Label 2388: @126221
      GIM_Try, /*On fail goto*//*Label 2389*/ GIMT_Encode4(126270), // Rule ID 4506 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
        // (st FPR128:{ *:[v8bf16] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v8bf16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4506,
        GIR_EraseRootFromParent_Done,
      // Label 2389: @126270
      GIM_Try, /*On fail goto*//*Label 2390*/ GIMT_Encode4(126319), // Rule ID 4507 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
        // (st FPR128:{ *:[v8bf16] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v8bf16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4507,
        GIR_EraseRootFromParent_Done,
      // Label 2390: @126319
      GIM_Try, /*On fail goto*//*Label 2391*/ GIMT_Encode4(126363), // Rule ID 4533 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
        // (st FPR128:{ *:[v8i16] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4533,
        GIR_EraseRootFromParent_Done,
      // Label 2391: @126363
      GIM_Try, /*On fail goto*//*Label 2392*/ GIMT_Encode4(126407), // Rule ID 4536 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
        // (st FPR128:{ *:[v8f16] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4536,
        GIR_EraseRootFromParent_Done,
      // Label 2392: @126407
      GIM_Try, /*On fail goto*//*Label 2393*/ GIMT_Encode4(126451), // Rule ID 4537 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
        // (st FPR128:{ *:[v8bf16] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v8bf16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4537,
        GIR_EraseRootFromParent_Done,
      // Label 2393: @126451
      GIM_Try, /*On fail goto*//*Label 2394*/ GIMT_Encode4(126495), // Rule ID 4560 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
        // (st FPR128:{ *:[v8i16] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4560,
        GIR_EraseRootFromParent_Done,
      // Label 2394: @126495
      GIM_Try, /*On fail goto*//*Label 2395*/ GIMT_Encode4(126539), // Rule ID 4564 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
        // (st FPR128:{ *:[v8f16] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4564,
        GIR_EraseRootFromParent_Done,
      // Label 2395: @126539
      GIM_Try, /*On fail goto*//*Label 2396*/ GIMT_Encode4(126583), // Rule ID 4565 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
        // (st FPR128:{ *:[v8bf16] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v8bf16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4565,
        GIR_EraseRootFromParent_Done,
      // Label 2396: @126583
      GIM_Try, /*On fail goto*//*Label 2397*/ GIMT_Encode4(126603), // Rule ID 6459 //
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        // (st v8i16:{ *:[v8i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev8h v8i16:{ *:[v8i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev8h),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6459,
        GIR_Done,
      // Label 2397: @126603
      GIM_Reject,
    // Label 2384: @126604
    GIM_Reject,
    // Label 2177: @126605
    GIM_Try, /*On fail goto*//*Label 2398*/ GIMT_Encode4(126824),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_Try, /*On fail goto*//*Label 2399*/ GIMT_Encode4(126666), // Rule ID 4502 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
        // (st FPR128:{ *:[v16i8] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4502,
        GIR_EraseRootFromParent_Done,
      // Label 2399: @126666
      GIM_Try, /*On fail goto*//*Label 2400*/ GIMT_Encode4(126715), // Rule ID 4503 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
        // (st FPR128:{ *:[v16i8] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4503,
        GIR_EraseRootFromParent_Done,
      // Label 2400: @126715
      GIM_Try, /*On fail goto*//*Label 2401*/ GIMT_Encode4(126759), // Rule ID 4532 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
        // (st FPR128:{ *:[v16i8] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4532,
        GIR_EraseRootFromParent_Done,
      // Label 2401: @126759
      GIM_Try, /*On fail goto*//*Label 2402*/ GIMT_Encode4(126803), // Rule ID 4559 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
        // (st FPR128:{ *:[v16i8] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4559,
        GIR_EraseRootFromParent_Done,
      // Label 2402: @126803
      GIM_Try, /*On fail goto*//*Label 2403*/ GIMT_Encode4(126823), // Rule ID 6458 //
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        // (st v16i8:{ *:[v16i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev16b v16i8:{ *:[v16i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev16b),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6458,
        GIR_Done,
      // Label 2403: @126823
      GIM_Reject,
    // Label 2398: @126824
    GIM_Reject,
    // Label 2178: @126825
    GIM_Try, /*On fail goto*//*Label 2404*/ GIMT_Encode4(126934),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 2405*/ GIMT_Encode4(126889), // Rule ID 11145 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (st nxv2f16:{ *:[nxv2f16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_D_IMM ZPR:{ *:[nxv2f16] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_D_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // val
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // base
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11145,
        GIR_EraseRootFromParent_Done,
      // Label 2405: @126889
      GIM_Try, /*On fail goto*//*Label 2406*/ GIMT_Encode4(126933), // Rule ID 11148 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (st nxv2bf16:{ *:[nxv2bf16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_D_IMM ZPR:{ *:[nxv2bf16] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_D_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // val
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // base
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11148,
        GIR_EraseRootFromParent_Done,
      // Label 2406: @126933
      GIM_Reject,
    // Label 2404: @126934
    GIM_Reject,
    // Label 2179: @126935
    GIM_Try, /*On fail goto*//*Label 2407*/ GIMT_Encode4(126994), // Rule ID 11154 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      // MIs[0] base
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (st nxv2f32:{ *:[nxv2f32] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1W_D_IMM ZPR:{ *:[nxv2f32] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_D_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // val
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // base
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 11154,
      GIR_EraseRootFromParent_Done,
    // Label 2407: @126994
    GIM_Reject,
    // Label 2180: @126995
    GIM_Try, /*On fail goto*//*Label 2408*/ GIMT_Encode4(127104),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 2409*/ GIMT_Encode4(127059), // Rule ID 11130 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (st nxv2i64:{ *:[nxv2i64] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1D_IMM ZPR:{ *:[nxv2i64] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // val
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // base
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11130,
        GIR_EraseRootFromParent_Done,
      // Label 2409: @127059
      GIM_Try, /*On fail goto*//*Label 2410*/ GIMT_Encode4(127103), // Rule ID 11157 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (st nxv2f64:{ *:[nxv2f64] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1D_IMM ZPR:{ *:[nxv2f64] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // val
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // base
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11157,
        GIR_EraseRootFromParent_Done,
      // Label 2410: @127103
      GIM_Reject,
    // Label 2408: @127104
    GIM_Reject,
    // Label 2181: @127105
    GIM_Try, /*On fail goto*//*Label 2411*/ GIMT_Encode4(127214),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 2412*/ GIMT_Encode4(127169), // Rule ID 11139 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (st nxv4f16:{ *:[nxv4f16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_S_IMM ZPR:{ *:[nxv4f16] }:$val, (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_S_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // val
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // base
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11139,
        GIR_EraseRootFromParent_Done,
      // Label 2412: @127169
      GIM_Try, /*On fail goto*//*Label 2413*/ GIMT_Encode4(127213), // Rule ID 11142 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (st nxv4bf16:{ *:[nxv4bf16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_S_IMM ZPR:{ *:[nxv4bf16] }:$val, (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_S_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // val
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // base
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11142,
        GIR_EraseRootFromParent_Done,
      // Label 2413: @127213
      GIM_Reject,
    // Label 2411: @127214
    GIM_Reject,
    // Label 2182: @127215
    GIM_Try, /*On fail goto*//*Label 2414*/ GIMT_Encode4(127324),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 2415*/ GIMT_Encode4(127279), // Rule ID 11124 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (st nxv4i32:{ *:[nxv4i32] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1W_IMM ZPR:{ *:[nxv4i32] }:$val, (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // val
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // base
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11124,
        GIR_EraseRootFromParent_Done,
      // Label 2415: @127279
      GIM_Try, /*On fail goto*//*Label 2416*/ GIMT_Encode4(127323), // Rule ID 11151 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (st nxv4f32:{ *:[nxv4f32] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1W_IMM ZPR:{ *:[nxv4f32] }:$val, (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // val
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // base
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11151,
        GIR_EraseRootFromParent_Done,
      // Label 2416: @127323
      GIM_Reject,
    // Label 2414: @127324
    GIM_Reject,
    // Label 2183: @127325
    GIM_Try, /*On fail goto*//*Label 2417*/ GIMT_Encode4(127478),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 2418*/ GIMT_Encode4(127389), // Rule ID 11115 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (st nxv8i16:{ *:[nxv8i16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_IMM ZPR:{ *:[nxv8i16] }:$val, (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // val
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // base
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11115,
        GIR_EraseRootFromParent_Done,
      // Label 2418: @127389
      GIM_Try, /*On fail goto*//*Label 2419*/ GIMT_Encode4(127433), // Rule ID 11133 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (st nxv8f16:{ *:[nxv8f16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_IMM ZPR:{ *:[nxv8f16] }:$val, (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // val
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // base
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11133,
        GIR_EraseRootFromParent_Done,
      // Label 2419: @127433
      GIM_Try, /*On fail goto*//*Label 2420*/ GIMT_Encode4(127477), // Rule ID 11136 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (st nxv8bf16:{ *:[nxv8bf16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_IMM ZPR:{ *:[nxv8bf16] }:$val, (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // val
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // base
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11136,
        GIR_EraseRootFromParent_Done,
      // Label 2420: @127477
      GIM_Reject,
    // Label 2417: @127478
    GIM_Reject,
    // Label 2184: @127479
    GIM_Try, /*On fail goto*//*Label 2421*/ GIMT_Encode4(127522), // Rule ID 2407 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] base
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (st PPR:{ *:[nxv16i1] }:$Val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_PXI PPR:{ *:[nxv16i1] }:$Val, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_PXI),
      GIR_RootToRootCopy, /*OpIdx*/0, // Val
      GIR_RootToRootCopy, /*OpIdx*/1, // base
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2407,
      GIR_EraseRootFromParent_Done,
    // Label 2421: @127522
    GIM_Reject,
    // Label 2185: @127523
    GIM_Try, /*On fail goto*//*Label 2422*/ GIMT_Encode4(127582), // Rule ID 11101 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      // MIs[0] base
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (st nxv16i8:{ *:[nxv16i8] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1B_IMM ZPR:{ *:[nxv16i8] }:$val, (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1B_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // val
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // base
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 11101,
      GIR_EraseRootFromParent_Done,
    // Label 2422: @127582
    GIM_Reject,
    // Label 2186: @127583
    GIM_Reject,
    // Label 20: @127584
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2425*/ GIMT_Encode4(128934),
    /*GILLT_s32*//*Label 2423*/ GIMT_Encode4(127603),
    /*GILLT_s64*//*Label 2424*/ GIMT_Encode4(128621),
    // Label 2423: @127603
    GIM_Try, /*On fail goto*//*Label 2426*/ GIMT_Encode4(128620),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 2427*/ GIMT_Encode4(127669), // Rule ID 7497 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (CASW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rold
        GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7497,
        GIR_EraseRootFromParent_Done,
      // Label 2427: @127669
      GIM_Try, /*On fail goto*//*Label 2428*/ GIMT_Encode4(127724), // Rule ID 7498 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (CASAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rold
        GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7498,
        GIR_EraseRootFromParent_Done,
      // Label 2428: @127724
      GIM_Try, /*On fail goto*//*Label 2429*/ GIMT_Encode4(127779), // Rule ID 7499 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (CASLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rold
        GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7499,
        GIR_EraseRootFromParent_Done,
      // Label 2429: @127779
      GIM_Try, /*On fail goto*//*Label 2430*/ GIMT_Encode4(127834), // Rule ID 7500 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (CASALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rold
        GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7500,
        GIR_EraseRootFromParent_Done,
      // Label 2430: @127834
      GIM_Try, /*On fail goto*//*Label 2431*/ GIMT_Encode4(127889), // Rule ID 7501 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (CASALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rold
        GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7501,
        GIR_EraseRootFromParent_Done,
      // Label 2431: @127889
      GIM_Try, /*On fail goto*//*Label 2432*/ GIMT_Encode4(127944), // Rule ID 7502 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_monotonic>>  =>  (CASH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rold
        GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7502,
        GIR_EraseRootFromParent_Done,
      // Label 2432: @127944
      GIM_Try, /*On fail goto*//*Label 2433*/ GIMT_Encode4(127999), // Rule ID 7503 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acquire>>  =>  (CASAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rold
        GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7503,
        GIR_EraseRootFromParent_Done,
      // Label 2433: @127999
      GIM_Try, /*On fail goto*//*Label 2434*/ GIMT_Encode4(128054), // Rule ID 7504 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_release>>  =>  (CASLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rold
        GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7504,
        GIR_EraseRootFromParent_Done,
      // Label 2434: @128054
      GIM_Try, /*On fail goto*//*Label 2435*/ GIMT_Encode4(128109), // Rule ID 7505 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acq_rel>>  =>  (CASALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rold
        GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7505,
        GIR_EraseRootFromParent_Done,
      // Label 2435: @128109
      GIM_Try, /*On fail goto*//*Label 2436*/ GIMT_Encode4(128164), // Rule ID 7506 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_seq_cst>>  =>  (CASALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rold
        GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7506,
        GIR_EraseRootFromParent_Done,
      // Label 2436: @128164
      GIM_Try, /*On fail goto*//*Label 2437*/ GIMT_Encode4(128219), // Rule ID 7507 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_monotonic>>  =>  (CASB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rold
        GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7507,
        GIR_EraseRootFromParent_Done,
      // Label 2437: @128219
      GIM_Try, /*On fail goto*//*Label 2438*/ GIMT_Encode4(128274), // Rule ID 7508 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acquire>>  =>  (CASAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rold
        GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7508,
        GIR_EraseRootFromParent_Done,
      // Label 2438: @128274
      GIM_Try, /*On fail goto*//*Label 2439*/ GIMT_Encode4(128329), // Rule ID 7509 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_release>>  =>  (CASLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rold
        GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7509,
        GIR_EraseRootFromParent_Done,
      // Label 2439: @128329
      GIM_Try, /*On fail goto*//*Label 2440*/ GIMT_Encode4(128384), // Rule ID 7510 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acq_rel>>  =>  (CASALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rold
        GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7510,
        GIR_EraseRootFromParent_Done,
      // Label 2440: @128384
      GIM_Try, /*On fail goto*//*Label 2441*/ GIMT_Encode4(128439), // Rule ID 7511 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_seq_cst>>  =>  (CASALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rold
        GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7511,
        GIR_EraseRootFromParent_Done,
      // Label 2441: @128439
      GIM_Try, /*On fail goto*//*Label 2442*/ GIMT_Encode4(128499), // Rule ID 13196 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>>  =>  (CMP_SWAP_8:{ *:[i32] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/2, // desired
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13196,
        GIR_EraseRootFromParent_Done,
      // Label 2442: @128499
      GIM_Try, /*On fail goto*//*Label 2443*/ GIMT_Encode4(128559), // Rule ID 13197 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>>  =>  (CMP_SWAP_16:{ *:[i32] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/2, // desired
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13197,
        GIR_EraseRootFromParent_Done,
      // Label 2443: @128559
      GIM_Try, /*On fail goto*//*Label 2444*/ GIMT_Encode4(128619), // Rule ID 13198 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_cmp_swap:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>>  =>  (CMP_SWAP_32:{ *:[i32] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/2, // desired
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13198,
        GIR_EraseRootFromParent_Done,
      // Label 2444: @128619
      GIM_Reject,
    // Label 2426: @128620
    GIM_Reject,
    // Label 2424: @128621
    GIM_Try, /*On fail goto*//*Label 2445*/ GIMT_Encode4(128933),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_Try, /*On fail goto*//*Label 2446*/ GIMT_Encode4(128687), // Rule ID 2543 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_monotonic>>  =>  (CASX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rold
        GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2543,
        GIR_EraseRootFromParent_Done,
      // Label 2446: @128687
      GIM_Try, /*On fail goto*//*Label 2447*/ GIMT_Encode4(128735), // Rule ID 2544 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acquire>>  =>  (CASAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rold
        GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2544,
        GIR_EraseRootFromParent_Done,
      // Label 2447: @128735
      GIM_Try, /*On fail goto*//*Label 2448*/ GIMT_Encode4(128783), // Rule ID 2545 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_release>>  =>  (CASLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rold
        GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2545,
        GIR_EraseRootFromParent_Done,
      // Label 2448: @128783
      GIM_Try, /*On fail goto*//*Label 2449*/ GIMT_Encode4(128831), // Rule ID 2546 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acq_rel>>  =>  (CASALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rold
        GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2546,
        GIR_EraseRootFromParent_Done,
      // Label 2449: @128831
      GIM_Try, /*On fail goto*//*Label 2450*/ GIMT_Encode4(128879), // Rule ID 2547 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_seq_cst>>  =>  (CASALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rold
        GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2547,
        GIR_EraseRootFromParent_Done,
      // Label 2450: @128879
      GIM_Try, /*On fail goto*//*Label 2451*/ GIMT_Encode4(128932), // Rule ID 13199 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_cmp_swap:{ *:[i64] } GPR64:{ *:[i64] }:$addr, GPR64:{ *:[i64] }:$desired, GPR64:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>>  =>  (CMP_SWAP_64:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR64:{ *:[i64] }:$desired, GPR64:{ *:[i64] }:$new)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_RootToRootCopy, /*OpIdx*/1, // addr
        GIR_RootToRootCopy, /*OpIdx*/2, // desired
        GIR_RootToRootCopy, /*OpIdx*/3, // new
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13199,
        GIR_EraseRootFromParent_Done,
      // Label 2451: @128932
      GIM_Reject,
    // Label 2445: @128933
    GIM_Reject,
    // Label 2425: @128934
    GIM_Reject,
    // Label 21: @128935
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2454*/ GIMT_Encode4(129926),
    /*GILLT_s32*//*Label 2452*/ GIMT_Encode4(128954),
    /*GILLT_s64*//*Label 2453*/ GIMT_Encode4(129699),
    // Label 2452: @128954
    GIM_Try, /*On fail goto*//*Label 2455*/ GIMT_Encode4(129698),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 2456*/ GIMT_Encode4(129011), // Rule ID 7482 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_monotonic>>  =>  (SWPW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7482,
        GIR_EraseRootFromParent_Done,
      // Label 2456: @129011
      GIM_Try, /*On fail goto*//*Label 2457*/ GIMT_Encode4(129060), // Rule ID 7483 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acquire>>  =>  (SWPAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7483,
        GIR_EraseRootFromParent_Done,
      // Label 2457: @129060
      GIM_Try, /*On fail goto*//*Label 2458*/ GIMT_Encode4(129109), // Rule ID 7484 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_release>>  =>  (SWPLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7484,
        GIR_EraseRootFromParent_Done,
      // Label 2458: @129109
      GIM_Try, /*On fail goto*//*Label 2459*/ GIMT_Encode4(129158), // Rule ID 7485 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acq_rel>>  =>  (SWPALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7485,
        GIR_EraseRootFromParent_Done,
      // Label 2459: @129158
      GIM_Try, /*On fail goto*//*Label 2460*/ GIMT_Encode4(129207), // Rule ID 7486 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_seq_cst>>  =>  (SWPALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7486,
        GIR_EraseRootFromParent_Done,
      // Label 2460: @129207
      GIM_Try, /*On fail goto*//*Label 2461*/ GIMT_Encode4(129256), // Rule ID 7487 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_monotonic>>  =>  (SWPH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7487,
        GIR_EraseRootFromParent_Done,
      // Label 2461: @129256
      GIM_Try, /*On fail goto*//*Label 2462*/ GIMT_Encode4(129305), // Rule ID 7488 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acquire>>  =>  (SWPAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7488,
        GIR_EraseRootFromParent_Done,
      // Label 2462: @129305
      GIM_Try, /*On fail goto*//*Label 2463*/ GIMT_Encode4(129354), // Rule ID 7489 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_release>>  =>  (SWPLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7489,
        GIR_EraseRootFromParent_Done,
      // Label 2463: @129354
      GIM_Try, /*On fail goto*//*Label 2464*/ GIMT_Encode4(129403), // Rule ID 7490 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acq_rel>>  =>  (SWPALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7490,
        GIR_EraseRootFromParent_Done,
      // Label 2464: @129403
      GIM_Try, /*On fail goto*//*Label 2465*/ GIMT_Encode4(129452), // Rule ID 7491 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_seq_cst>>  =>  (SWPALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7491,
        GIR_EraseRootFromParent_Done,
      // Label 2465: @129452
      GIM_Try, /*On fail goto*//*Label 2466*/ GIMT_Encode4(129501), // Rule ID 7492 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_monotonic>>  =>  (SWPB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7492,
        GIR_EraseRootFromParent_Done,
      // Label 2466: @129501
      GIM_Try, /*On fail goto*//*Label 2467*/ GIMT_Encode4(129550), // Rule ID 7493 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acquire>>  =>  (SWPAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7493,
        GIR_EraseRootFromParent_Done,
      // Label 2467: @129550
      GIM_Try, /*On fail goto*//*Label 2468*/ GIMT_Encode4(129599), // Rule ID 7494 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_release>>  =>  (SWPLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7494,
        GIR_EraseRootFromParent_Done,
      // Label 2468: @129599
      GIM_Try, /*On fail goto*//*Label 2469*/ GIMT_Encode4(129648), // Rule ID 7495 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acq_rel>>  =>  (SWPALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7495,
        GIR_EraseRootFromParent_Done,
      // Label 2469: @129648
      GIM_Try, /*On fail goto*//*Label 2470*/ GIMT_Encode4(129697), // Rule ID 7496 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_seq_cst>>  =>  (SWPALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7496,
        GIR_EraseRootFromParent_Done,
      // Label 2470: @129697
      GIM_Reject,
    // Label 2455: @129698
    GIM_Reject,
    // Label 2453: @129699
    GIM_Try, /*On fail goto*//*Label 2471*/ GIMT_Encode4(129925),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_Try, /*On fail goto*//*Label 2472*/ GIMT_Encode4(129756), // Rule ID 7477 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_monotonic>>  =>  (SWPX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7477,
        GIR_EraseRootFromParent_Done,
      // Label 2472: @129756
      GIM_Try, /*On fail goto*//*Label 2473*/ GIMT_Encode4(129798), // Rule ID 7478 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acquire>>  =>  (SWPAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7478,
        GIR_EraseRootFromParent_Done,
      // Label 2473: @129798
      GIM_Try, /*On fail goto*//*Label 2474*/ GIMT_Encode4(129840), // Rule ID 7479 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_release>>  =>  (SWPLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7479,
        GIR_EraseRootFromParent_Done,
      // Label 2474: @129840
      GIM_Try, /*On fail goto*//*Label 2475*/ GIMT_Encode4(129882), // Rule ID 7480 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acq_rel>>  =>  (SWPALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7480,
        GIR_EraseRootFromParent_Done,
      // Label 2475: @129882
      GIM_Try, /*On fail goto*//*Label 2476*/ GIMT_Encode4(129924), // Rule ID 7481 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_seq_cst>>  =>  (SWPALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7481,
        GIR_EraseRootFromParent_Done,
      // Label 2476: @129924
      GIM_Reject,
    // Label 2471: @129925
    GIM_Reject,
    // Label 2454: @129926
    GIM_Reject,
    // Label 22: @129927
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2479*/ GIMT_Encode4(130918),
    /*GILLT_s32*//*Label 2477*/ GIMT_Encode4(129946),
    /*GILLT_s64*//*Label 2478*/ GIMT_Encode4(130691),
    // Label 2477: @129946
    GIM_Try, /*On fail goto*//*Label 2480*/ GIMT_Encode4(130690),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 2481*/ GIMT_Encode4(130003), // Rule ID 7322 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_monotonic>>  =>  (LDADDW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7322,
        GIR_EraseRootFromParent_Done,
      // Label 2481: @130003
      GIM_Try, /*On fail goto*//*Label 2482*/ GIMT_Encode4(130052), // Rule ID 7323 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acquire>>  =>  (LDADDAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7323,
        GIR_EraseRootFromParent_Done,
      // Label 2482: @130052
      GIM_Try, /*On fail goto*//*Label 2483*/ GIMT_Encode4(130101), // Rule ID 7324 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_release>>  =>  (LDADDLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7324,
        GIR_EraseRootFromParent_Done,
      // Label 2483: @130101
      GIM_Try, /*On fail goto*//*Label 2484*/ GIMT_Encode4(130150), // Rule ID 7325 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acq_rel>>  =>  (LDADDALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7325,
        GIR_EraseRootFromParent_Done,
      // Label 2484: @130150
      GIM_Try, /*On fail goto*//*Label 2485*/ GIMT_Encode4(130199), // Rule ID 7326 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_seq_cst>>  =>  (LDADDALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7326,
        GIR_EraseRootFromParent_Done,
      // Label 2485: @130199
      GIM_Try, /*On fail goto*//*Label 2486*/ GIMT_Encode4(130248), // Rule ID 7327 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_monotonic>>  =>  (LDADDH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7327,
        GIR_EraseRootFromParent_Done,
      // Label 2486: @130248
      GIM_Try, /*On fail goto*//*Label 2487*/ GIMT_Encode4(130297), // Rule ID 7328 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acquire>>  =>  (LDADDAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7328,
        GIR_EraseRootFromParent_Done,
      // Label 2487: @130297
      GIM_Try, /*On fail goto*//*Label 2488*/ GIMT_Encode4(130346), // Rule ID 7329 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_release>>  =>  (LDADDLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7329,
        GIR_EraseRootFromParent_Done,
      // Label 2488: @130346
      GIM_Try, /*On fail goto*//*Label 2489*/ GIMT_Encode4(130395), // Rule ID 7330 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acq_rel>>  =>  (LDADDALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7330,
        GIR_EraseRootFromParent_Done,
      // Label 2489: @130395
      GIM_Try, /*On fail goto*//*Label 2490*/ GIMT_Encode4(130444), // Rule ID 7331 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_seq_cst>>  =>  (LDADDALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7331,
        GIR_EraseRootFromParent_Done,
      // Label 2490: @130444
      GIM_Try, /*On fail goto*//*Label 2491*/ GIMT_Encode4(130493), // Rule ID 7332 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_monotonic>>  =>  (LDADDB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7332,
        GIR_EraseRootFromParent_Done,
      // Label 2491: @130493
      GIM_Try, /*On fail goto*//*Label 2492*/ GIMT_Encode4(130542), // Rule ID 7333 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acquire>>  =>  (LDADDAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7333,
        GIR_EraseRootFromParent_Done,
      // Label 2492: @130542
      GIM_Try, /*On fail goto*//*Label 2493*/ GIMT_Encode4(130591), // Rule ID 7334 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_release>>  =>  (LDADDLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7334,
        GIR_EraseRootFromParent_Done,
      // Label 2493: @130591
      GIM_Try, /*On fail goto*//*Label 2494*/ GIMT_Encode4(130640), // Rule ID 7335 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acq_rel>>  =>  (LDADDALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7335,
        GIR_EraseRootFromParent_Done,
      // Label 2494: @130640
      GIM_Try, /*On fail goto*//*Label 2495*/ GIMT_Encode4(130689), // Rule ID 7336 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_seq_cst>>  =>  (LDADDALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7336,
        GIR_EraseRootFromParent_Done,
      // Label 2495: @130689
      GIM_Reject,
    // Label 2480: @130690
    GIM_Reject,
    // Label 2478: @130691
    GIM_Try, /*On fail goto*//*Label 2496*/ GIMT_Encode4(130917),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_Try, /*On fail goto*//*Label 2497*/ GIMT_Encode4(130748), // Rule ID 2538 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_monotonic>>  =>  (LDADDX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2538,
        GIR_EraseRootFromParent_Done,
      // Label 2497: @130748
      GIM_Try, /*On fail goto*//*Label 2498*/ GIMT_Encode4(130790), // Rule ID 2539 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acquire>>  =>  (LDADDAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2539,
        GIR_EraseRootFromParent_Done,
      // Label 2498: @130790
      GIM_Try, /*On fail goto*//*Label 2499*/ GIMT_Encode4(130832), // Rule ID 2540 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_release>>  =>  (LDADDLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2540,
        GIR_EraseRootFromParent_Done,
      // Label 2499: @130832
      GIM_Try, /*On fail goto*//*Label 2500*/ GIMT_Encode4(130874), // Rule ID 2541 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acq_rel>>  =>  (LDADDALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2541,
        GIR_EraseRootFromParent_Done,
      // Label 2500: @130874
      GIM_Try, /*On fail goto*//*Label 2501*/ GIMT_Encode4(130916), // Rule ID 2542 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_seq_cst>>  =>  (LDADDALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2542,
        GIR_EraseRootFromParent_Done,
      // Label 2501: @130916
      GIM_Reject,
    // Label 2496: @130917
    GIM_Reject,
    // Label 2479: @130918
    GIM_Reject,
    // Label 23: @130919
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2504*/ GIMT_Encode4(132410),
    /*GILLT_s32*//*Label 2502*/ GIMT_Encode4(130938),
    /*GILLT_s64*//*Label 2503*/ GIMT_Encode4(132058),
    // Label 2502: @130938
    GIM_Try, /*On fail goto*//*Label 2505*/ GIMT_Encode4(132057),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 2506*/ GIMT_Encode4(131020), // Rule ID 7517 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_monotonic>>  =>  (LDADDW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7517,
        GIR_EraseRootFromParent_Done,
      // Label 2506: @131020
      GIM_Try, /*On fail goto*//*Label 2507*/ GIMT_Encode4(131094), // Rule ID 7518 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_acquire>>  =>  (LDADDAW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7518,
        GIR_EraseRootFromParent_Done,
      // Label 2507: @131094
      GIM_Try, /*On fail goto*//*Label 2508*/ GIMT_Encode4(131168), // Rule ID 7519 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_release>>  =>  (LDADDLW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7519,
        GIR_EraseRootFromParent_Done,
      // Label 2508: @131168
      GIM_Try, /*On fail goto*//*Label 2509*/ GIMT_Encode4(131242), // Rule ID 7520 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_acq_rel>>  =>  (LDADDALW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7520,
        GIR_EraseRootFromParent_Done,
      // Label 2509: @131242
      GIM_Try, /*On fail goto*//*Label 2510*/ GIMT_Encode4(131316), // Rule ID 7521 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_seq_cst>>  =>  (LDADDALW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7521,
        GIR_EraseRootFromParent_Done,
      // Label 2510: @131316
      GIM_Try, /*On fail goto*//*Label 2511*/ GIMT_Encode4(131390), // Rule ID 7522 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_monotonic>>  =>  (LDADDH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7522,
        GIR_EraseRootFromParent_Done,
      // Label 2511: @131390
      GIM_Try, /*On fail goto*//*Label 2512*/ GIMT_Encode4(131464), // Rule ID 7523 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_acquire>>  =>  (LDADDAH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7523,
        GIR_EraseRootFromParent_Done,
      // Label 2512: @131464
      GIM_Try, /*On fail goto*//*Label 2513*/ GIMT_Encode4(131538), // Rule ID 7524 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_release>>  =>  (LDADDLH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7524,
        GIR_EraseRootFromParent_Done,
      // Label 2513: @131538
      GIM_Try, /*On fail goto*//*Label 2514*/ GIMT_Encode4(131612), // Rule ID 7525 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_acq_rel>>  =>  (LDADDALH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7525,
        GIR_EraseRootFromParent_Done,
      // Label 2514: @131612
      GIM_Try, /*On fail goto*//*Label 2515*/ GIMT_Encode4(131686), // Rule ID 7526 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_seq_cst>>  =>  (LDADDALH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7526,
        GIR_EraseRootFromParent_Done,
      // Label 2515: @131686
      GIM_Try, /*On fail goto*//*Label 2516*/ GIMT_Encode4(131760), // Rule ID 7527 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_monotonic>>  =>  (LDADDB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7527,
        GIR_EraseRootFromParent_Done,
      // Label 2516: @131760
      GIM_Try, /*On fail goto*//*Label 2517*/ GIMT_Encode4(131834), // Rule ID 7528 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_acquire>>  =>  (LDADDAB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7528,
        GIR_EraseRootFromParent_Done,
      // Label 2517: @131834
      GIM_Try, /*On fail goto*//*Label 2518*/ GIMT_Encode4(131908), // Rule ID 7529 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_release>>  =>  (LDADDLB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7529,
        GIR_EraseRootFromParent_Done,
      // Label 2518: @131908
      GIM_Try, /*On fail goto*//*Label 2519*/ GIMT_Encode4(131982), // Rule ID 7530 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_acq_rel>>  =>  (LDADDALB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7530,
        GIR_EraseRootFromParent_Done,
      // Label 2519: @131982
      GIM_Try, /*On fail goto*//*Label 2520*/ GIMT_Encode4(132056), // Rule ID 7531 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_seq_cst>>  =>  (LDADDALB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7531,
        GIR_EraseRootFromParent_Done,
      // Label 2520: @132056
      GIM_Reject,
    // Label 2505: @132057
    GIM_Reject,
    // Label 2503: @132058
    GIM_Try, /*On fail goto*//*Label 2521*/ GIMT_Encode4(132409),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_Try, /*On fail goto*//*Label 2522*/ GIMT_Encode4(132140), // Rule ID 7512 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_monotonic>>  =>  (LDADDX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7512,
        GIR_EraseRootFromParent_Done,
      // Label 2522: @132140
      GIM_Try, /*On fail goto*//*Label 2523*/ GIMT_Encode4(132207), // Rule ID 7513 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_acquire>>  =>  (LDADDAX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7513,
        GIR_EraseRootFromParent_Done,
      // Label 2523: @132207
      GIM_Try, /*On fail goto*//*Label 2524*/ GIMT_Encode4(132274), // Rule ID 7514 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_release>>  =>  (LDADDLX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7514,
        GIR_EraseRootFromParent_Done,
      // Label 2524: @132274
      GIM_Try, /*On fail goto*//*Label 2525*/ GIMT_Encode4(132341), // Rule ID 7515 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_acq_rel>>  =>  (LDADDALX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7515,
        GIR_EraseRootFromParent_Done,
      // Label 2525: @132341
      GIM_Try, /*On fail goto*//*Label 2526*/ GIMT_Encode4(132408), // Rule ID 7516 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_seq_cst>>  =>  (LDADDALX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7516,
        GIR_EraseRootFromParent_Done,
      // Label 2526: @132408
      GIM_Reject,
    // Label 2521: @132409
    GIM_Reject,
    // Label 2504: @132410
    GIM_Reject,
    // Label 24: @132411
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2529*/ GIMT_Encode4(133902),
    /*GILLT_s32*//*Label 2527*/ GIMT_Encode4(132430),
    /*GILLT_s64*//*Label 2528*/ GIMT_Encode4(133550),
    // Label 2527: @132430
    GIM_Try, /*On fail goto*//*Label 2530*/ GIMT_Encode4(133549),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 2531*/ GIMT_Encode4(132512), // Rule ID 7537 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_monotonic>>  =>  (LDCLRW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7537,
        GIR_EraseRootFromParent_Done,
      // Label 2531: @132512
      GIM_Try, /*On fail goto*//*Label 2532*/ GIMT_Encode4(132586), // Rule ID 7538 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acquire>>  =>  (LDCLRAW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7538,
        GIR_EraseRootFromParent_Done,
      // Label 2532: @132586
      GIM_Try, /*On fail goto*//*Label 2533*/ GIMT_Encode4(132660), // Rule ID 7539 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_release>>  =>  (LDCLRLW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7539,
        GIR_EraseRootFromParent_Done,
      // Label 2533: @132660
      GIM_Try, /*On fail goto*//*Label 2534*/ GIMT_Encode4(132734), // Rule ID 7540 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acq_rel>>  =>  (LDCLRALW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7540,
        GIR_EraseRootFromParent_Done,
      // Label 2534: @132734
      GIM_Try, /*On fail goto*//*Label 2535*/ GIMT_Encode4(132808), // Rule ID 7541 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_seq_cst>>  =>  (LDCLRALW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7541,
        GIR_EraseRootFromParent_Done,
      // Label 2535: @132808
      GIM_Try, /*On fail goto*//*Label 2536*/ GIMT_Encode4(132882), // Rule ID 7542 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_monotonic>>  =>  (LDCLRH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7542,
        GIR_EraseRootFromParent_Done,
      // Label 2536: @132882
      GIM_Try, /*On fail goto*//*Label 2537*/ GIMT_Encode4(132956), // Rule ID 7543 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acquire>>  =>  (LDCLRAH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7543,
        GIR_EraseRootFromParent_Done,
      // Label 2537: @132956
      GIM_Try, /*On fail goto*//*Label 2538*/ GIMT_Encode4(133030), // Rule ID 7544 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_release>>  =>  (LDCLRLH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7544,
        GIR_EraseRootFromParent_Done,
      // Label 2538: @133030
      GIM_Try, /*On fail goto*//*Label 2539*/ GIMT_Encode4(133104), // Rule ID 7545 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acq_rel>>  =>  (LDCLRALH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7545,
        GIR_EraseRootFromParent_Done,
      // Label 2539: @133104
      GIM_Try, /*On fail goto*//*Label 2540*/ GIMT_Encode4(133178), // Rule ID 7546 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_seq_cst>>  =>  (LDCLRALH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7546,
        GIR_EraseRootFromParent_Done,
      // Label 2540: @133178
      GIM_Try, /*On fail goto*//*Label 2541*/ GIMT_Encode4(133252), // Rule ID 7547 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_monotonic>>  =>  (LDCLRB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7547,
        GIR_EraseRootFromParent_Done,
      // Label 2541: @133252
      GIM_Try, /*On fail goto*//*Label 2542*/ GIMT_Encode4(133326), // Rule ID 7548 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acquire>>  =>  (LDCLRAB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7548,
        GIR_EraseRootFromParent_Done,
      // Label 2542: @133326
      GIM_Try, /*On fail goto*//*Label 2543*/ GIMT_Encode4(133400), // Rule ID 7549 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_release>>  =>  (LDCLRLB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7549,
        GIR_EraseRootFromParent_Done,
      // Label 2543: @133400
      GIM_Try, /*On fail goto*//*Label 2544*/ GIMT_Encode4(133474), // Rule ID 7550 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acq_rel>>  =>  (LDCLRALB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7550,
        GIR_EraseRootFromParent_Done,
      // Label 2544: @133474
      GIM_Try, /*On fail goto*//*Label 2545*/ GIMT_Encode4(133548), // Rule ID 7551 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_seq_cst>>  =>  (LDCLRALB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7551,
        GIR_EraseRootFromParent_Done,
      // Label 2545: @133548
      GIM_Reject,
    // Label 2530: @133549
    GIM_Reject,
    // Label 2528: @133550
    GIM_Try, /*On fail goto*//*Label 2546*/ GIMT_Encode4(133901),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_Try, /*On fail goto*//*Label 2547*/ GIMT_Encode4(133632), // Rule ID 7532 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_monotonic>>  =>  (LDCLRX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7532,
        GIR_EraseRootFromParent_Done,
      // Label 2547: @133632
      GIM_Try, /*On fail goto*//*Label 2548*/ GIMT_Encode4(133699), // Rule ID 7533 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acquire>>  =>  (LDCLRAX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7533,
        GIR_EraseRootFromParent_Done,
      // Label 2548: @133699
      GIM_Try, /*On fail goto*//*Label 2549*/ GIMT_Encode4(133766), // Rule ID 7534 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_release>>  =>  (LDCLRLX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7534,
        GIR_EraseRootFromParent_Done,
      // Label 2549: @133766
      GIM_Try, /*On fail goto*//*Label 2550*/ GIMT_Encode4(133833), // Rule ID 7535 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acq_rel>>  =>  (LDCLRALX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7535,
        GIR_EraseRootFromParent_Done,
      // Label 2550: @133833
      GIM_Try, /*On fail goto*//*Label 2551*/ GIMT_Encode4(133900), // Rule ID 7536 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_seq_cst>>  =>  (LDCLRALX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7536,
        GIR_EraseRootFromParent_Done,
      // Label 2551: @133900
      GIM_Reject,
    // Label 2546: @133901
    GIM_Reject,
    // Label 2529: @133902
    GIM_Reject,
    // Label 25: @133903
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2554*/ GIMT_Encode4(134894),
    /*GILLT_s32*//*Label 2552*/ GIMT_Encode4(133922),
    /*GILLT_s64*//*Label 2553*/ GIMT_Encode4(134667),
    // Label 2552: @133922
    GIM_Try, /*On fail goto*//*Label 2555*/ GIMT_Encode4(134666),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 2556*/ GIMT_Encode4(133979), // Rule ID 7342 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_monotonic>>  =>  (LDSETW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7342,
        GIR_EraseRootFromParent_Done,
      // Label 2556: @133979
      GIM_Try, /*On fail goto*//*Label 2557*/ GIMT_Encode4(134028), // Rule ID 7343 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acquire>>  =>  (LDSETAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7343,
        GIR_EraseRootFromParent_Done,
      // Label 2557: @134028
      GIM_Try, /*On fail goto*//*Label 2558*/ GIMT_Encode4(134077), // Rule ID 7344 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_release>>  =>  (LDSETLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7344,
        GIR_EraseRootFromParent_Done,
      // Label 2558: @134077
      GIM_Try, /*On fail goto*//*Label 2559*/ GIMT_Encode4(134126), // Rule ID 7345 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acq_rel>>  =>  (LDSETALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7345,
        GIR_EraseRootFromParent_Done,
      // Label 2559: @134126
      GIM_Try, /*On fail goto*//*Label 2560*/ GIMT_Encode4(134175), // Rule ID 7346 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_seq_cst>>  =>  (LDSETALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7346,
        GIR_EraseRootFromParent_Done,
      // Label 2560: @134175
      GIM_Try, /*On fail goto*//*Label 2561*/ GIMT_Encode4(134224), // Rule ID 7347 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_monotonic>>  =>  (LDSETH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7347,
        GIR_EraseRootFromParent_Done,
      // Label 2561: @134224
      GIM_Try, /*On fail goto*//*Label 2562*/ GIMT_Encode4(134273), // Rule ID 7348 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acquire>>  =>  (LDSETAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7348,
        GIR_EraseRootFromParent_Done,
      // Label 2562: @134273
      GIM_Try, /*On fail goto*//*Label 2563*/ GIMT_Encode4(134322), // Rule ID 7349 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_release>>  =>  (LDSETLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7349,
        GIR_EraseRootFromParent_Done,
      // Label 2563: @134322
      GIM_Try, /*On fail goto*//*Label 2564*/ GIMT_Encode4(134371), // Rule ID 7350 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acq_rel>>  =>  (LDSETALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7350,
        GIR_EraseRootFromParent_Done,
      // Label 2564: @134371
      GIM_Try, /*On fail goto*//*Label 2565*/ GIMT_Encode4(134420), // Rule ID 7351 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_seq_cst>>  =>  (LDSETALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7351,
        GIR_EraseRootFromParent_Done,
      // Label 2565: @134420
      GIM_Try, /*On fail goto*//*Label 2566*/ GIMT_Encode4(134469), // Rule ID 7352 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_monotonic>>  =>  (LDSETB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7352,
        GIR_EraseRootFromParent_Done,
      // Label 2566: @134469
      GIM_Try, /*On fail goto*//*Label 2567*/ GIMT_Encode4(134518), // Rule ID 7353 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acquire>>  =>  (LDSETAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7353,
        GIR_EraseRootFromParent_Done,
      // Label 2567: @134518
      GIM_Try, /*On fail goto*//*Label 2568*/ GIMT_Encode4(134567), // Rule ID 7354 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_release>>  =>  (LDSETLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7354,
        GIR_EraseRootFromParent_Done,
      // Label 2568: @134567
      GIM_Try, /*On fail goto*//*Label 2569*/ GIMT_Encode4(134616), // Rule ID 7355 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acq_rel>>  =>  (LDSETALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7355,
        GIR_EraseRootFromParent_Done,
      // Label 2569: @134616
      GIM_Try, /*On fail goto*//*Label 2570*/ GIMT_Encode4(134665), // Rule ID 7356 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_seq_cst>>  =>  (LDSETALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7356,
        GIR_EraseRootFromParent_Done,
      // Label 2570: @134665
      GIM_Reject,
    // Label 2555: @134666
    GIM_Reject,
    // Label 2553: @134667
    GIM_Try, /*On fail goto*//*Label 2571*/ GIMT_Encode4(134893),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_Try, /*On fail goto*//*Label 2572*/ GIMT_Encode4(134724), // Rule ID 7337 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_monotonic>>  =>  (LDSETX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7337,
        GIR_EraseRootFromParent_Done,
      // Label 2572: @134724
      GIM_Try, /*On fail goto*//*Label 2573*/ GIMT_Encode4(134766), // Rule ID 7338 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acquire>>  =>  (LDSETAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7338,
        GIR_EraseRootFromParent_Done,
      // Label 2573: @134766
      GIM_Try, /*On fail goto*//*Label 2574*/ GIMT_Encode4(134808), // Rule ID 7339 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_release>>  =>  (LDSETLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7339,
        GIR_EraseRootFromParent_Done,
      // Label 2574: @134808
      GIM_Try, /*On fail goto*//*Label 2575*/ GIMT_Encode4(134850), // Rule ID 7340 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acq_rel>>  =>  (LDSETALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7340,
        GIR_EraseRootFromParent_Done,
      // Label 2575: @134850
      GIM_Try, /*On fail goto*//*Label 2576*/ GIMT_Encode4(134892), // Rule ID 7341 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_seq_cst>>  =>  (LDSETALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7341,
        GIR_EraseRootFromParent_Done,
      // Label 2576: @134892
      GIM_Reject,
    // Label 2571: @134893
    GIM_Reject,
    // Label 2554: @134894
    GIM_Reject,
    // Label 26: @134895
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2579*/ GIMT_Encode4(135886),
    /*GILLT_s32*//*Label 2577*/ GIMT_Encode4(134914),
    /*GILLT_s64*//*Label 2578*/ GIMT_Encode4(135659),
    // Label 2577: @134914
    GIM_Try, /*On fail goto*//*Label 2580*/ GIMT_Encode4(135658),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 2581*/ GIMT_Encode4(134971), // Rule ID 7362 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_monotonic>>  =>  (LDEORW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7362,
        GIR_EraseRootFromParent_Done,
      // Label 2581: @134971
      GIM_Try, /*On fail goto*//*Label 2582*/ GIMT_Encode4(135020), // Rule ID 7363 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acquire>>  =>  (LDEORAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7363,
        GIR_EraseRootFromParent_Done,
      // Label 2582: @135020
      GIM_Try, /*On fail goto*//*Label 2583*/ GIMT_Encode4(135069), // Rule ID 7364 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_release>>  =>  (LDEORLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7364,
        GIR_EraseRootFromParent_Done,
      // Label 2583: @135069
      GIM_Try, /*On fail goto*//*Label 2584*/ GIMT_Encode4(135118), // Rule ID 7365 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acq_rel>>  =>  (LDEORALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7365,
        GIR_EraseRootFromParent_Done,
      // Label 2584: @135118
      GIM_Try, /*On fail goto*//*Label 2585*/ GIMT_Encode4(135167), // Rule ID 7366 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_seq_cst>>  =>  (LDEORALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7366,
        GIR_EraseRootFromParent_Done,
      // Label 2585: @135167
      GIM_Try, /*On fail goto*//*Label 2586*/ GIMT_Encode4(135216), // Rule ID 7367 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_monotonic>>  =>  (LDEORH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7367,
        GIR_EraseRootFromParent_Done,
      // Label 2586: @135216
      GIM_Try, /*On fail goto*//*Label 2587*/ GIMT_Encode4(135265), // Rule ID 7368 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acquire>>  =>  (LDEORAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7368,
        GIR_EraseRootFromParent_Done,
      // Label 2587: @135265
      GIM_Try, /*On fail goto*//*Label 2588*/ GIMT_Encode4(135314), // Rule ID 7369 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_release>>  =>  (LDEORLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7369,
        GIR_EraseRootFromParent_Done,
      // Label 2588: @135314
      GIM_Try, /*On fail goto*//*Label 2589*/ GIMT_Encode4(135363), // Rule ID 7370 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acq_rel>>  =>  (LDEORALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7370,
        GIR_EraseRootFromParent_Done,
      // Label 2589: @135363
      GIM_Try, /*On fail goto*//*Label 2590*/ GIMT_Encode4(135412), // Rule ID 7371 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_seq_cst>>  =>  (LDEORALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7371,
        GIR_EraseRootFromParent_Done,
      // Label 2590: @135412
      GIM_Try, /*On fail goto*//*Label 2591*/ GIMT_Encode4(135461), // Rule ID 7372 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_monotonic>>  =>  (LDEORB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7372,
        GIR_EraseRootFromParent_Done,
      // Label 2591: @135461
      GIM_Try, /*On fail goto*//*Label 2592*/ GIMT_Encode4(135510), // Rule ID 7373 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acquire>>  =>  (LDEORAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7373,
        GIR_EraseRootFromParent_Done,
      // Label 2592: @135510
      GIM_Try, /*On fail goto*//*Label 2593*/ GIMT_Encode4(135559), // Rule ID 7374 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_release>>  =>  (LDEORLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7374,
        GIR_EraseRootFromParent_Done,
      // Label 2593: @135559
      GIM_Try, /*On fail goto*//*Label 2594*/ GIMT_Encode4(135608), // Rule ID 7375 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acq_rel>>  =>  (LDEORALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7375,
        GIR_EraseRootFromParent_Done,
      // Label 2594: @135608
      GIM_Try, /*On fail goto*//*Label 2595*/ GIMT_Encode4(135657), // Rule ID 7376 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_seq_cst>>  =>  (LDEORALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7376,
        GIR_EraseRootFromParent_Done,
      // Label 2595: @135657
      GIM_Reject,
    // Label 2580: @135658
    GIM_Reject,
    // Label 2578: @135659
    GIM_Try, /*On fail goto*//*Label 2596*/ GIMT_Encode4(135885),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_Try, /*On fail goto*//*Label 2597*/ GIMT_Encode4(135716), // Rule ID 7357 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_monotonic>>  =>  (LDEORX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7357,
        GIR_EraseRootFromParent_Done,
      // Label 2597: @135716
      GIM_Try, /*On fail goto*//*Label 2598*/ GIMT_Encode4(135758), // Rule ID 7358 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acquire>>  =>  (LDEORAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7358,
        GIR_EraseRootFromParent_Done,
      // Label 2598: @135758
      GIM_Try, /*On fail goto*//*Label 2599*/ GIMT_Encode4(135800), // Rule ID 7359 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_release>>  =>  (LDEORLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7359,
        GIR_EraseRootFromParent_Done,
      // Label 2599: @135800
      GIM_Try, /*On fail goto*//*Label 2600*/ GIMT_Encode4(135842), // Rule ID 7360 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acq_rel>>  =>  (LDEORALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7360,
        GIR_EraseRootFromParent_Done,
      // Label 2600: @135842
      GIM_Try, /*On fail goto*//*Label 2601*/ GIMT_Encode4(135884), // Rule ID 7361 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_seq_cst>>  =>  (LDEORALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7361,
        GIR_EraseRootFromParent_Done,
      // Label 2601: @135884
      GIM_Reject,
    // Label 2596: @135885
    GIM_Reject,
    // Label 2579: @135886
    GIM_Reject,
    // Label 27: @135887
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2604*/ GIMT_Encode4(136878),
    /*GILLT_s32*//*Label 2602*/ GIMT_Encode4(135906),
    /*GILLT_s64*//*Label 2603*/ GIMT_Encode4(136651),
    // Label 2602: @135906
    GIM_Try, /*On fail goto*//*Label 2605*/ GIMT_Encode4(136650),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 2606*/ GIMT_Encode4(135963), // Rule ID 7402 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_monotonic>>  =>  (LDSMAXW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7402,
        GIR_EraseRootFromParent_Done,
      // Label 2606: @135963
      GIM_Try, /*On fail goto*//*Label 2607*/ GIMT_Encode4(136012), // Rule ID 7403 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acquire>>  =>  (LDSMAXAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7403,
        GIR_EraseRootFromParent_Done,
      // Label 2607: @136012
      GIM_Try, /*On fail goto*//*Label 2608*/ GIMT_Encode4(136061), // Rule ID 7404 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_release>>  =>  (LDSMAXLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7404,
        GIR_EraseRootFromParent_Done,
      // Label 2608: @136061
      GIM_Try, /*On fail goto*//*Label 2609*/ GIMT_Encode4(136110), // Rule ID 7405 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acq_rel>>  =>  (LDSMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7405,
        GIR_EraseRootFromParent_Done,
      // Label 2609: @136110
      GIM_Try, /*On fail goto*//*Label 2610*/ GIMT_Encode4(136159), // Rule ID 7406 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_seq_cst>>  =>  (LDSMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7406,
        GIR_EraseRootFromParent_Done,
      // Label 2610: @136159
      GIM_Try, /*On fail goto*//*Label 2611*/ GIMT_Encode4(136208), // Rule ID 7407 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_monotonic>>  =>  (LDSMAXH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7407,
        GIR_EraseRootFromParent_Done,
      // Label 2611: @136208
      GIM_Try, /*On fail goto*//*Label 2612*/ GIMT_Encode4(136257), // Rule ID 7408 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acquire>>  =>  (LDSMAXAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7408,
        GIR_EraseRootFromParent_Done,
      // Label 2612: @136257
      GIM_Try, /*On fail goto*//*Label 2613*/ GIMT_Encode4(136306), // Rule ID 7409 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_release>>  =>  (LDSMAXLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7409,
        GIR_EraseRootFromParent_Done,
      // Label 2613: @136306
      GIM_Try, /*On fail goto*//*Label 2614*/ GIMT_Encode4(136355), // Rule ID 7410 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acq_rel>>  =>  (LDSMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7410,
        GIR_EraseRootFromParent_Done,
      // Label 2614: @136355
      GIM_Try, /*On fail goto*//*Label 2615*/ GIMT_Encode4(136404), // Rule ID 7411 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_seq_cst>>  =>  (LDSMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7411,
        GIR_EraseRootFromParent_Done,
      // Label 2615: @136404
      GIM_Try, /*On fail goto*//*Label 2616*/ GIMT_Encode4(136453), // Rule ID 7412 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_monotonic>>  =>  (LDSMAXB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7412,
        GIR_EraseRootFromParent_Done,
      // Label 2616: @136453
      GIM_Try, /*On fail goto*//*Label 2617*/ GIMT_Encode4(136502), // Rule ID 7413 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acquire>>  =>  (LDSMAXAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7413,
        GIR_EraseRootFromParent_Done,
      // Label 2617: @136502
      GIM_Try, /*On fail goto*//*Label 2618*/ GIMT_Encode4(136551), // Rule ID 7414 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_release>>  =>  (LDSMAXLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7414,
        GIR_EraseRootFromParent_Done,
      // Label 2618: @136551
      GIM_Try, /*On fail goto*//*Label 2619*/ GIMT_Encode4(136600), // Rule ID 7415 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acq_rel>>  =>  (LDSMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7415,
        GIR_EraseRootFromParent_Done,
      // Label 2619: @136600
      GIM_Try, /*On fail goto*//*Label 2620*/ GIMT_Encode4(136649), // Rule ID 7416 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_seq_cst>>  =>  (LDSMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7416,
        GIR_EraseRootFromParent_Done,
      // Label 2620: @136649
      GIM_Reject,
    // Label 2605: @136650
    GIM_Reject,
    // Label 2603: @136651
    GIM_Try, /*On fail goto*//*Label 2621*/ GIMT_Encode4(136877),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_Try, /*On fail goto*//*Label 2622*/ GIMT_Encode4(136708), // Rule ID 7397 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_monotonic>>  =>  (LDSMAXX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7397,
        GIR_EraseRootFromParent_Done,
      // Label 2622: @136708
      GIM_Try, /*On fail goto*//*Label 2623*/ GIMT_Encode4(136750), // Rule ID 7398 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acquire>>  =>  (LDSMAXAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7398,
        GIR_EraseRootFromParent_Done,
      // Label 2623: @136750
      GIM_Try, /*On fail goto*//*Label 2624*/ GIMT_Encode4(136792), // Rule ID 7399 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_release>>  =>  (LDSMAXLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7399,
        GIR_EraseRootFromParent_Done,
      // Label 2624: @136792
      GIM_Try, /*On fail goto*//*Label 2625*/ GIMT_Encode4(136834), // Rule ID 7400 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acq_rel>>  =>  (LDSMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7400,
        GIR_EraseRootFromParent_Done,
      // Label 2625: @136834
      GIM_Try, /*On fail goto*//*Label 2626*/ GIMT_Encode4(136876), // Rule ID 7401 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_seq_cst>>  =>  (LDSMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7401,
        GIR_EraseRootFromParent_Done,
      // Label 2626: @136876
      GIM_Reject,
    // Label 2621: @136877
    GIM_Reject,
    // Label 2604: @136878
    GIM_Reject,
    // Label 28: @136879
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2629*/ GIMT_Encode4(137870),
    /*GILLT_s32*//*Label 2627*/ GIMT_Encode4(136898),
    /*GILLT_s64*//*Label 2628*/ GIMT_Encode4(137643),
    // Label 2627: @136898
    GIM_Try, /*On fail goto*//*Label 2630*/ GIMT_Encode4(137642),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 2631*/ GIMT_Encode4(136955), // Rule ID 7422 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_monotonic>>  =>  (LDSMINW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7422,
        GIR_EraseRootFromParent_Done,
      // Label 2631: @136955
      GIM_Try, /*On fail goto*//*Label 2632*/ GIMT_Encode4(137004), // Rule ID 7423 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acquire>>  =>  (LDSMINAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7423,
        GIR_EraseRootFromParent_Done,
      // Label 2632: @137004
      GIM_Try, /*On fail goto*//*Label 2633*/ GIMT_Encode4(137053), // Rule ID 7424 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_release>>  =>  (LDSMINLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7424,
        GIR_EraseRootFromParent_Done,
      // Label 2633: @137053
      GIM_Try, /*On fail goto*//*Label 2634*/ GIMT_Encode4(137102), // Rule ID 7425 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acq_rel>>  =>  (LDSMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7425,
        GIR_EraseRootFromParent_Done,
      // Label 2634: @137102
      GIM_Try, /*On fail goto*//*Label 2635*/ GIMT_Encode4(137151), // Rule ID 7426 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_seq_cst>>  =>  (LDSMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7426,
        GIR_EraseRootFromParent_Done,
      // Label 2635: @137151
      GIM_Try, /*On fail goto*//*Label 2636*/ GIMT_Encode4(137200), // Rule ID 7427 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_monotonic>>  =>  (LDSMINH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7427,
        GIR_EraseRootFromParent_Done,
      // Label 2636: @137200
      GIM_Try, /*On fail goto*//*Label 2637*/ GIMT_Encode4(137249), // Rule ID 7428 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acquire>>  =>  (LDSMINAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7428,
        GIR_EraseRootFromParent_Done,
      // Label 2637: @137249
      GIM_Try, /*On fail goto*//*Label 2638*/ GIMT_Encode4(137298), // Rule ID 7429 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_release>>  =>  (LDSMINLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7429,
        GIR_EraseRootFromParent_Done,
      // Label 2638: @137298
      GIM_Try, /*On fail goto*//*Label 2639*/ GIMT_Encode4(137347), // Rule ID 7430 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acq_rel>>  =>  (LDSMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7430,
        GIR_EraseRootFromParent_Done,
      // Label 2639: @137347
      GIM_Try, /*On fail goto*//*Label 2640*/ GIMT_Encode4(137396), // Rule ID 7431 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_seq_cst>>  =>  (LDSMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7431,
        GIR_EraseRootFromParent_Done,
      // Label 2640: @137396
      GIM_Try, /*On fail goto*//*Label 2641*/ GIMT_Encode4(137445), // Rule ID 7432 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_monotonic>>  =>  (LDSMINB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7432,
        GIR_EraseRootFromParent_Done,
      // Label 2641: @137445
      GIM_Try, /*On fail goto*//*Label 2642*/ GIMT_Encode4(137494), // Rule ID 7433 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acquire>>  =>  (LDSMINAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7433,
        GIR_EraseRootFromParent_Done,
      // Label 2642: @137494
      GIM_Try, /*On fail goto*//*Label 2643*/ GIMT_Encode4(137543), // Rule ID 7434 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_release>>  =>  (LDSMINLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7434,
        GIR_EraseRootFromParent_Done,
      // Label 2643: @137543
      GIM_Try, /*On fail goto*//*Label 2644*/ GIMT_Encode4(137592), // Rule ID 7435 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acq_rel>>  =>  (LDSMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7435,
        GIR_EraseRootFromParent_Done,
      // Label 2644: @137592
      GIM_Try, /*On fail goto*//*Label 2645*/ GIMT_Encode4(137641), // Rule ID 7436 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_seq_cst>>  =>  (LDSMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7436,
        GIR_EraseRootFromParent_Done,
      // Label 2645: @137641
      GIM_Reject,
    // Label 2630: @137642
    GIM_Reject,
    // Label 2628: @137643
    GIM_Try, /*On fail goto*//*Label 2646*/ GIMT_Encode4(137869),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_Try, /*On fail goto*//*Label 2647*/ GIMT_Encode4(137700), // Rule ID 7417 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_monotonic>>  =>  (LDSMINX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7417,
        GIR_EraseRootFromParent_Done,
      // Label 2647: @137700
      GIM_Try, /*On fail goto*//*Label 2648*/ GIMT_Encode4(137742), // Rule ID 7418 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acquire>>  =>  (LDSMINAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7418,
        GIR_EraseRootFromParent_Done,
      // Label 2648: @137742
      GIM_Try, /*On fail goto*//*Label 2649*/ GIMT_Encode4(137784), // Rule ID 7419 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_release>>  =>  (LDSMINLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7419,
        GIR_EraseRootFromParent_Done,
      // Label 2649: @137784
      GIM_Try, /*On fail goto*//*Label 2650*/ GIMT_Encode4(137826), // Rule ID 7420 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acq_rel>>  =>  (LDSMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7420,
        GIR_EraseRootFromParent_Done,
      // Label 2650: @137826
      GIM_Try, /*On fail goto*//*Label 2651*/ GIMT_Encode4(137868), // Rule ID 7421 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_seq_cst>>  =>  (LDSMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7421,
        GIR_EraseRootFromParent_Done,
      // Label 2651: @137868
      GIM_Reject,
    // Label 2646: @137869
    GIM_Reject,
    // Label 2629: @137870
    GIM_Reject,
    // Label 29: @137871
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2654*/ GIMT_Encode4(138862),
    /*GILLT_s32*//*Label 2652*/ GIMT_Encode4(137890),
    /*GILLT_s64*//*Label 2653*/ GIMT_Encode4(138635),
    // Label 2652: @137890
    GIM_Try, /*On fail goto*//*Label 2655*/ GIMT_Encode4(138634),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 2656*/ GIMT_Encode4(137947), // Rule ID 7442 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_monotonic>>  =>  (LDUMAXW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7442,
        GIR_EraseRootFromParent_Done,
      // Label 2656: @137947
      GIM_Try, /*On fail goto*//*Label 2657*/ GIMT_Encode4(137996), // Rule ID 7443 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acquire>>  =>  (LDUMAXAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7443,
        GIR_EraseRootFromParent_Done,
      // Label 2657: @137996
      GIM_Try, /*On fail goto*//*Label 2658*/ GIMT_Encode4(138045), // Rule ID 7444 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_release>>  =>  (LDUMAXLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7444,
        GIR_EraseRootFromParent_Done,
      // Label 2658: @138045
      GIM_Try, /*On fail goto*//*Label 2659*/ GIMT_Encode4(138094), // Rule ID 7445 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acq_rel>>  =>  (LDUMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7445,
        GIR_EraseRootFromParent_Done,
      // Label 2659: @138094
      GIM_Try, /*On fail goto*//*Label 2660*/ GIMT_Encode4(138143), // Rule ID 7446 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_seq_cst>>  =>  (LDUMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7446,
        GIR_EraseRootFromParent_Done,
      // Label 2660: @138143
      GIM_Try, /*On fail goto*//*Label 2661*/ GIMT_Encode4(138192), // Rule ID 7447 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_monotonic>>  =>  (LDUMAXH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7447,
        GIR_EraseRootFromParent_Done,
      // Label 2661: @138192
      GIM_Try, /*On fail goto*//*Label 2662*/ GIMT_Encode4(138241), // Rule ID 7448 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acquire>>  =>  (LDUMAXAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7448,
        GIR_EraseRootFromParent_Done,
      // Label 2662: @138241
      GIM_Try, /*On fail goto*//*Label 2663*/ GIMT_Encode4(138290), // Rule ID 7449 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_release>>  =>  (LDUMAXLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7449,
        GIR_EraseRootFromParent_Done,
      // Label 2663: @138290
      GIM_Try, /*On fail goto*//*Label 2664*/ GIMT_Encode4(138339), // Rule ID 7450 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acq_rel>>  =>  (LDUMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7450,
        GIR_EraseRootFromParent_Done,
      // Label 2664: @138339
      GIM_Try, /*On fail goto*//*Label 2665*/ GIMT_Encode4(138388), // Rule ID 7451 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_seq_cst>>  =>  (LDUMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7451,
        GIR_EraseRootFromParent_Done,
      // Label 2665: @138388
      GIM_Try, /*On fail goto*//*Label 2666*/ GIMT_Encode4(138437), // Rule ID 7452 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_monotonic>>  =>  (LDUMAXB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7452,
        GIR_EraseRootFromParent_Done,
      // Label 2666: @138437
      GIM_Try, /*On fail goto*//*Label 2667*/ GIMT_Encode4(138486), // Rule ID 7453 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acquire>>  =>  (LDUMAXAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7453,
        GIR_EraseRootFromParent_Done,
      // Label 2667: @138486
      GIM_Try, /*On fail goto*//*Label 2668*/ GIMT_Encode4(138535), // Rule ID 7454 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_release>>  =>  (LDUMAXLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7454,
        GIR_EraseRootFromParent_Done,
      // Label 2668: @138535
      GIM_Try, /*On fail goto*//*Label 2669*/ GIMT_Encode4(138584), // Rule ID 7455 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acq_rel>>  =>  (LDUMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7455,
        GIR_EraseRootFromParent_Done,
      // Label 2669: @138584
      GIM_Try, /*On fail goto*//*Label 2670*/ GIMT_Encode4(138633), // Rule ID 7456 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_seq_cst>>  =>  (LDUMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7456,
        GIR_EraseRootFromParent_Done,
      // Label 2670: @138633
      GIM_Reject,
    // Label 2655: @138634
    GIM_Reject,
    // Label 2653: @138635
    GIM_Try, /*On fail goto*//*Label 2671*/ GIMT_Encode4(138861),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_Try, /*On fail goto*//*Label 2672*/ GIMT_Encode4(138692), // Rule ID 7437 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_monotonic>>  =>  (LDUMAXX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7437,
        GIR_EraseRootFromParent_Done,
      // Label 2672: @138692
      GIM_Try, /*On fail goto*//*Label 2673*/ GIMT_Encode4(138734), // Rule ID 7438 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acquire>>  =>  (LDUMAXAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7438,
        GIR_EraseRootFromParent_Done,
      // Label 2673: @138734
      GIM_Try, /*On fail goto*//*Label 2674*/ GIMT_Encode4(138776), // Rule ID 7439 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_release>>  =>  (LDUMAXLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7439,
        GIR_EraseRootFromParent_Done,
      // Label 2674: @138776
      GIM_Try, /*On fail goto*//*Label 2675*/ GIMT_Encode4(138818), // Rule ID 7440 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acq_rel>>  =>  (LDUMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7440,
        GIR_EraseRootFromParent_Done,
      // Label 2675: @138818
      GIM_Try, /*On fail goto*//*Label 2676*/ GIMT_Encode4(138860), // Rule ID 7441 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_seq_cst>>  =>  (LDUMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7441,
        GIR_EraseRootFromParent_Done,
      // Label 2676: @138860
      GIM_Reject,
    // Label 2671: @138861
    GIM_Reject,
    // Label 2654: @138862
    GIM_Reject,
    // Label 30: @138863
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2679*/ GIMT_Encode4(139854),
    /*GILLT_s32*//*Label 2677*/ GIMT_Encode4(138882),
    /*GILLT_s64*//*Label 2678*/ GIMT_Encode4(139627),
    // Label 2677: @138882
    GIM_Try, /*On fail goto*//*Label 2680*/ GIMT_Encode4(139626),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 2681*/ GIMT_Encode4(138939), // Rule ID 7462 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_monotonic>>  =>  (LDUMINW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7462,
        GIR_EraseRootFromParent_Done,
      // Label 2681: @138939
      GIM_Try, /*On fail goto*//*Label 2682*/ GIMT_Encode4(138988), // Rule ID 7463 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acquire>>  =>  (LDUMINAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7463,
        GIR_EraseRootFromParent_Done,
      // Label 2682: @138988
      GIM_Try, /*On fail goto*//*Label 2683*/ GIMT_Encode4(139037), // Rule ID 7464 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_release>>  =>  (LDUMINLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7464,
        GIR_EraseRootFromParent_Done,
      // Label 2683: @139037
      GIM_Try, /*On fail goto*//*Label 2684*/ GIMT_Encode4(139086), // Rule ID 7465 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acq_rel>>  =>  (LDUMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7465,
        GIR_EraseRootFromParent_Done,
      // Label 2684: @139086
      GIM_Try, /*On fail goto*//*Label 2685*/ GIMT_Encode4(139135), // Rule ID 7466 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_seq_cst>>  =>  (LDUMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7466,
        GIR_EraseRootFromParent_Done,
      // Label 2685: @139135
      GIM_Try, /*On fail goto*//*Label 2686*/ GIMT_Encode4(139184), // Rule ID 7467 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_monotonic>>  =>  (LDUMINH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7467,
        GIR_EraseRootFromParent_Done,
      // Label 2686: @139184
      GIM_Try, /*On fail goto*//*Label 2687*/ GIMT_Encode4(139233), // Rule ID 7468 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acquire>>  =>  (LDUMINAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7468,
        GIR_EraseRootFromParent_Done,
      // Label 2687: @139233
      GIM_Try, /*On fail goto*//*Label 2688*/ GIMT_Encode4(139282), // Rule ID 7469 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_release>>  =>  (LDUMINLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7469,
        GIR_EraseRootFromParent_Done,
      // Label 2688: @139282
      GIM_Try, /*On fail goto*//*Label 2689*/ GIMT_Encode4(139331), // Rule ID 7470 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acq_rel>>  =>  (LDUMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7470,
        GIR_EraseRootFromParent_Done,
      // Label 2689: @139331
      GIM_Try, /*On fail goto*//*Label 2690*/ GIMT_Encode4(139380), // Rule ID 7471 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_seq_cst>>  =>  (LDUMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7471,
        GIR_EraseRootFromParent_Done,
      // Label 2690: @139380
      GIM_Try, /*On fail goto*//*Label 2691*/ GIMT_Encode4(139429), // Rule ID 7472 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_monotonic>>  =>  (LDUMINB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7472,
        GIR_EraseRootFromParent_Done,
      // Label 2691: @139429
      GIM_Try, /*On fail goto*//*Label 2692*/ GIMT_Encode4(139478), // Rule ID 7473 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acquire>>  =>  (LDUMINAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7473,
        GIR_EraseRootFromParent_Done,
      // Label 2692: @139478
      GIM_Try, /*On fail goto*//*Label 2693*/ GIMT_Encode4(139527), // Rule ID 7474 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_release>>  =>  (LDUMINLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7474,
        GIR_EraseRootFromParent_Done,
      // Label 2693: @139527
      GIM_Try, /*On fail goto*//*Label 2694*/ GIMT_Encode4(139576), // Rule ID 7475 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acq_rel>>  =>  (LDUMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7475,
        GIR_EraseRootFromParent_Done,
      // Label 2694: @139576
      GIM_Try, /*On fail goto*//*Label 2695*/ GIMT_Encode4(139625), // Rule ID 7476 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_seq_cst>>  =>  (LDUMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7476,
        GIR_EraseRootFromParent_Done,
      // Label 2695: @139625
      GIM_Reject,
    // Label 2680: @139626
    GIM_Reject,
    // Label 2678: @139627
    GIM_Try, /*On fail goto*//*Label 2696*/ GIMT_Encode4(139853),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_Try, /*On fail goto*//*Label 2697*/ GIMT_Encode4(139684), // Rule ID 7457 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_monotonic>>  =>  (LDUMINX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7457,
        GIR_EraseRootFromParent_Done,
      // Label 2697: @139684
      GIM_Try, /*On fail goto*//*Label 2698*/ GIMT_Encode4(139726), // Rule ID 7458 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acquire>>  =>  (LDUMINAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7458,
        GIR_EraseRootFromParent_Done,
      // Label 2698: @139726
      GIM_Try, /*On fail goto*//*Label 2699*/ GIMT_Encode4(139768), // Rule ID 7459 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_release>>  =>  (LDUMINLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7459,
        GIR_EraseRootFromParent_Done,
      // Label 2699: @139768
      GIM_Try, /*On fail goto*//*Label 2700*/ GIMT_Encode4(139810), // Rule ID 7460 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acq_rel>>  =>  (LDUMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7460,
        GIR_EraseRootFromParent_Done,
      // Label 2700: @139810
      GIM_Try, /*On fail goto*//*Label 2701*/ GIMT_Encode4(139852), // Rule ID 7461 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_seq_cst>>  =>  (LDUMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7461,
        GIR_EraseRootFromParent_Done,
      // Label 2701: @139852
      GIM_Reject,
    // Label 2696: @139853
    GIM_Reject,
    // Label 2679: @139854
    GIM_Reject,
    // Label 31: @139855
    GIM_Try, /*On fail goto*//*Label 2702*/ GIMT_Encode4(139882), // Rule ID 7209 //
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
      GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 4,
      // MIs[0] Operand 1
      GIM_CheckIsImm, /*MI*/0, /*Op*/1,
      // (atomic_fence 4:{ *:[i64] }, (timm:{ *:[i64] }))  =>  (DMB 9:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DMB),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7209,
      GIR_EraseRootFromParent_Done,
    // Label 2702: @139882
    GIM_Try, /*On fail goto*//*Label 2703*/ GIMT_Encode4(139905), // Rule ID 7210 //
      // MIs[0] Operand 0
      GIM_CheckIsImm, /*MI*/0, /*Op*/0,
      // MIs[0] Operand 1
      GIM_CheckIsImm, /*MI*/0, /*Op*/1,
      // (atomic_fence (timm:{ *:[iPTR] }), (timm:{ *:[iPTR] }))  =>  (DMB 11:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DMB),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/11,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7210,
      GIR_EraseRootFromParent_Done,
    // Label 2703: @139905
    GIM_Reject,
    // Label 32: @139906
    GIM_Try, /*On fail goto*//*Label 2704*/ GIMT_Encode4(152505),
      GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
      GIM_Try, /*On fail goto*//*Label 2705*/ GIMT_Encode4(140005), // Rule ID 6561 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFuseAES),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesmc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aese),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[v16i8] } 506:{ *:[iPTR] }, (intrinsic_wo_chain:{ *:[v16i8] } 504:{ *:[iPTR] }, V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))  =>  (AESMCrrTied:{ *:[v16i8] } (AESErr:{ *:[v16i8] } V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::AESErr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // src2
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESMCrrTied),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6561,
        GIR_EraseRootFromParent_Done,
      // Label 2705: @140005
      GIM_Try, /*On fail goto*//*Label 2706*/ GIMT_Encode4(140096), // Rule ID 6562 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFuseAES),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesimc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[v16i8] } 505:{ *:[iPTR] }, (intrinsic_wo_chain:{ *:[v16i8] } 503:{ *:[iPTR] }, V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))  =>  (AESIMCrrTied:{ *:[v16i8] } (AESDrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::AESDrr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // src2
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESIMCrrTied),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6562,
        GIR_EraseRootFromParent_Done,
      // Label 2706: @140096
      GIM_Try, /*On fail goto*//*Label 2707*/ GIMT_Encode4(140157), // Rule ID 4933 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvthf2fp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[v4f32] } 742:{ *:[iPTR] }, (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] }))  =>  (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4933,
        GIR_EraseRootFromParent_Done,
      // Label 2707: @140157
      GIM_Try, /*On fail goto*//*Label 2708*/ GIMT_Encode4(140197), // Rule ID 2603 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // (intrinsic_wo_chain:{ *:[i64] } 1212:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTB_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTB_XPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // pattern
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2603,
        GIR_EraseRootFromParent_Done,
      // Label 2708: @140197
      GIM_Try, /*On fail goto*//*Label 2709*/ GIMT_Encode4(140237), // Rule ID 10136 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // (intrinsic_wo_chain:{ *:[i64] } 1214:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTH_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTH_XPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // pattern
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10136,
        GIR_EraseRootFromParent_Done,
      // Label 2709: @140237
      GIM_Try, /*On fail goto*//*Label 2710*/ GIMT_Encode4(140277), // Rule ID 10139 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // (intrinsic_wo_chain:{ *:[i64] } 1220:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTW_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTW_XPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // pattern
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10139,
        GIR_EraseRootFromParent_Done,
      // Label 2710: @140277
      GIM_Try, /*On fail goto*//*Label 2711*/ GIMT_Encode4(140317), // Rule ID 10142 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // (intrinsic_wo_chain:{ *:[i64] } 1213:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTD_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTD_XPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // pattern
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10142,
        GIR_EraseRootFromParent_Done,
      // Label 2711: @140317
      GIM_Try, /*On fail goto*//*Label 2712*/ GIMT_Encode4(140353), // Rule ID 39 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_bfcvtn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8bf16] } 564:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (BFCVTN:{ *:[v8bf16] } V128:{ *:[v4f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFCVTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 39,
        GIR_EraseRootFromParent_Done,
      // Label 2712: @140353
      GIM_Try, /*On fail goto*//*Label 2713*/ GIMT_Encode4(140389), // Rule ID 41 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16_HasNEONandIsStreamingSafe),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_bfcvt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[bf16] } 563:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (BFCVT:{ *:[bf16] } FPR32:{ *:[f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFCVT),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 41,
        GIR_EraseRootFromParent_Done,
      // Label 2713: @140389
      GIM_Try, /*On fail goto*//*Label 2714*/ GIMT_Encode4(140428), // Rule ID 78 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasJS),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_fjcvtzs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 538:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FJCVTZS:{ *:[i32] }:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FJCVTZS),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 78,
        GIR_EraseRootFromParent_Done,
      // Label 2714: @140428
      GIM_Try, /*On fail goto*//*Label 2715*/ GIMT_Encode4(140464), // Rule ID 358 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 578:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTASUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWHr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 358,
        GIR_EraseRootFromParent_Done,
      // Label 2715: @140464
      GIM_Try, /*On fail goto*//*Label 2716*/ GIMT_Encode4(140500), // Rule ID 359 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 578:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTASUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXHr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 359,
        GIR_EraseRootFromParent_Done,
      // Label 2716: @140500
      GIM_Try, /*On fail goto*//*Label 2717*/ GIMT_Encode4(140536), // Rule ID 360 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 578:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTASUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWSr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 360,
        GIR_EraseRootFromParent_Done,
      // Label 2717: @140536
      GIM_Try, /*On fail goto*//*Label 2718*/ GIMT_Encode4(140572), // Rule ID 361 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 578:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTASUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 361,
        GIR_EraseRootFromParent_Done,
      // Label 2718: @140572
      GIM_Try, /*On fail goto*//*Label 2719*/ GIMT_Encode4(140608), // Rule ID 362 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 578:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTASUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWDr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 362,
        GIR_EraseRootFromParent_Done,
      // Label 2719: @140608
      GIM_Try, /*On fail goto*//*Label 2720*/ GIMT_Encode4(140644), // Rule ID 363 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 578:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTASUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 363,
        GIR_EraseRootFromParent_Done,
      // Label 2720: @140644
      GIM_Try, /*On fail goto*//*Label 2721*/ GIMT_Encode4(140680), // Rule ID 364 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 579:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTAUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWHr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 364,
        GIR_EraseRootFromParent_Done,
      // Label 2721: @140680
      GIM_Try, /*On fail goto*//*Label 2722*/ GIMT_Encode4(140716), // Rule ID 365 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 579:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTAUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXHr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 365,
        GIR_EraseRootFromParent_Done,
      // Label 2722: @140716
      GIM_Try, /*On fail goto*//*Label 2723*/ GIMT_Encode4(140752), // Rule ID 366 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 579:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTAUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWSr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 366,
        GIR_EraseRootFromParent_Done,
      // Label 2723: @140752
      GIM_Try, /*On fail goto*//*Label 2724*/ GIMT_Encode4(140788), // Rule ID 367 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 579:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTAUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXSr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 367,
        GIR_EraseRootFromParent_Done,
      // Label 2724: @140788
      GIM_Try, /*On fail goto*//*Label 2725*/ GIMT_Encode4(140824), // Rule ID 368 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 579:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTAUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWDr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 368,
        GIR_EraseRootFromParent_Done,
      // Label 2725: @140824
      GIM_Try, /*On fail goto*//*Label 2726*/ GIMT_Encode4(140860), // Rule ID 369 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 579:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTAUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXDr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 369,
        GIR_EraseRootFromParent_Done,
      // Label 2726: @140860
      GIM_Try, /*On fail goto*//*Label 2727*/ GIMT_Encode4(140896), // Rule ID 370 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 580:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWHr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 370,
        GIR_EraseRootFromParent_Done,
      // Label 2727: @140896
      GIM_Try, /*On fail goto*//*Label 2728*/ GIMT_Encode4(140932), // Rule ID 371 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 580:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXHr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 371,
        GIR_EraseRootFromParent_Done,
      // Label 2728: @140932
      GIM_Try, /*On fail goto*//*Label 2729*/ GIMT_Encode4(140968), // Rule ID 372 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 580:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWSr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 372,
        GIR_EraseRootFromParent_Done,
      // Label 2729: @140968
      GIM_Try, /*On fail goto*//*Label 2730*/ GIMT_Encode4(141004), // Rule ID 373 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 580:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXSr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 373,
        GIR_EraseRootFromParent_Done,
      // Label 2730: @141004
      GIM_Try, /*On fail goto*//*Label 2731*/ GIMT_Encode4(141040), // Rule ID 374 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 580:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWDr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 374,
        GIR_EraseRootFromParent_Done,
      // Label 2731: @141040
      GIM_Try, /*On fail goto*//*Label 2732*/ GIMT_Encode4(141076), // Rule ID 375 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 580:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXDr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 375,
        GIR_EraseRootFromParent_Done,
      // Label 2732: @141076
      GIM_Try, /*On fail goto*//*Label 2733*/ GIMT_Encode4(141112), // Rule ID 376 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 581:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWHr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 376,
        GIR_EraseRootFromParent_Done,
      // Label 2733: @141112
      GIM_Try, /*On fail goto*//*Label 2734*/ GIMT_Encode4(141148), // Rule ID 377 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 581:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXHr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 377,
        GIR_EraseRootFromParent_Done,
      // Label 2734: @141148
      GIM_Try, /*On fail goto*//*Label 2735*/ GIMT_Encode4(141184), // Rule ID 378 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 581:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWSr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 378,
        GIR_EraseRootFromParent_Done,
      // Label 2735: @141184
      GIM_Try, /*On fail goto*//*Label 2736*/ GIMT_Encode4(141220), // Rule ID 379 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 581:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXSr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 379,
        GIR_EraseRootFromParent_Done,
      // Label 2736: @141220
      GIM_Try, /*On fail goto*//*Label 2737*/ GIMT_Encode4(141256), // Rule ID 380 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 581:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWDr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 380,
        GIR_EraseRootFromParent_Done,
      // Label 2737: @141256
      GIM_Try, /*On fail goto*//*Label 2738*/ GIMT_Encode4(141292), // Rule ID 381 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 581:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXDr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 381,
        GIR_EraseRootFromParent_Done,
      // Label 2738: @141292
      GIM_Try, /*On fail goto*//*Label 2739*/ GIMT_Encode4(141328), // Rule ID 382 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 582:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUWHr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 382,
        GIR_EraseRootFromParent_Done,
      // Label 2739: @141328
      GIM_Try, /*On fail goto*//*Label 2740*/ GIMT_Encode4(141364), // Rule ID 383 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 582:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUXHr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 383,
        GIR_EraseRootFromParent_Done,
      // Label 2740: @141364
      GIM_Try, /*On fail goto*//*Label 2741*/ GIMT_Encode4(141400), // Rule ID 384 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 582:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUWSr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 384,
        GIR_EraseRootFromParent_Done,
      // Label 2741: @141400
      GIM_Try, /*On fail goto*//*Label 2742*/ GIMT_Encode4(141436), // Rule ID 385 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 582:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUXSr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 385,
        GIR_EraseRootFromParent_Done,
      // Label 2742: @141436
      GIM_Try, /*On fail goto*//*Label 2743*/ GIMT_Encode4(141472), // Rule ID 386 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 582:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUWDr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 386,
        GIR_EraseRootFromParent_Done,
      // Label 2743: @141472
      GIM_Try, /*On fail goto*//*Label 2744*/ GIMT_Encode4(141508), // Rule ID 387 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 582:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUXDr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 387,
        GIR_EraseRootFromParent_Done,
      // Label 2744: @141508
      GIM_Try, /*On fail goto*//*Label 2745*/ GIMT_Encode4(141544), // Rule ID 388 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 583:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUWHr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 388,
        GIR_EraseRootFromParent_Done,
      // Label 2745: @141544
      GIM_Try, /*On fail goto*//*Label 2746*/ GIMT_Encode4(141580), // Rule ID 389 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 583:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUXHr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 389,
        GIR_EraseRootFromParent_Done,
      // Label 2746: @141580
      GIM_Try, /*On fail goto*//*Label 2747*/ GIMT_Encode4(141616), // Rule ID 390 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 583:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUWSr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 390,
        GIR_EraseRootFromParent_Done,
      // Label 2747: @141616
      GIM_Try, /*On fail goto*//*Label 2748*/ GIMT_Encode4(141652), // Rule ID 391 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 583:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUXSr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 391,
        GIR_EraseRootFromParent_Done,
      // Label 2748: @141652
      GIM_Try, /*On fail goto*//*Label 2749*/ GIMT_Encode4(141688), // Rule ID 392 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 583:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUWDr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 392,
        GIR_EraseRootFromParent_Done,
      // Label 2749: @141688
      GIM_Try, /*On fail goto*//*Label 2750*/ GIMT_Encode4(141724), // Rule ID 393 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 583:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUXDr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 393,
        GIR_EraseRootFromParent_Done,
      // Label 2750: @141724
      GIM_Try, /*On fail goto*//*Label 2751*/ GIMT_Encode4(141760), // Rule ID 394 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 584:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWHr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 394,
        GIR_EraseRootFromParent_Done,
      // Label 2751: @141760
      GIM_Try, /*On fail goto*//*Label 2752*/ GIMT_Encode4(141796), // Rule ID 395 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 584:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXHr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 395,
        GIR_EraseRootFromParent_Done,
      // Label 2752: @141796
      GIM_Try, /*On fail goto*//*Label 2753*/ GIMT_Encode4(141832), // Rule ID 396 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 584:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWSr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 396,
        GIR_EraseRootFromParent_Done,
      // Label 2753: @141832
      GIM_Try, /*On fail goto*//*Label 2754*/ GIMT_Encode4(141868), // Rule ID 397 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 584:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXSr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 397,
        GIR_EraseRootFromParent_Done,
      // Label 2754: @141868
      GIM_Try, /*On fail goto*//*Label 2755*/ GIMT_Encode4(141904), // Rule ID 398 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 584:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWDr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 398,
        GIR_EraseRootFromParent_Done,
      // Label 2755: @141904
      GIM_Try, /*On fail goto*//*Label 2756*/ GIMT_Encode4(141940), // Rule ID 399 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 584:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXDr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 399,
        GIR_EraseRootFromParent_Done,
      // Label 2756: @141940
      GIM_Try, /*On fail goto*//*Label 2757*/ GIMT_Encode4(141976), // Rule ID 400 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 585:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWHr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 400,
        GIR_EraseRootFromParent_Done,
      // Label 2757: @141976
      GIM_Try, /*On fail goto*//*Label 2758*/ GIMT_Encode4(142012), // Rule ID 401 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 585:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXHr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 401,
        GIR_EraseRootFromParent_Done,
      // Label 2758: @142012
      GIM_Try, /*On fail goto*//*Label 2759*/ GIMT_Encode4(142048), // Rule ID 402 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 585:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWSr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 402,
        GIR_EraseRootFromParent_Done,
      // Label 2759: @142048
      GIM_Try, /*On fail goto*//*Label 2760*/ GIMT_Encode4(142084), // Rule ID 403 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 585:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXSr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 403,
        GIR_EraseRootFromParent_Done,
      // Label 2760: @142084
      GIM_Try, /*On fail goto*//*Label 2761*/ GIMT_Encode4(142120), // Rule ID 404 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 585:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWDr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 404,
        GIR_EraseRootFromParent_Done,
      // Label 2761: @142120
      GIM_Try, /*On fail goto*//*Label 2762*/ GIMT_Encode4(142156), // Rule ID 405 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 585:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXDr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 405,
        GIR_EraseRootFromParent_Done,
      // Label 2762: @142156
      GIM_Try, /*On fail goto*//*Label 2763*/ GIMT_Encode4(142192), // Rule ID 571 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[f32] } 540:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT32ZSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32ZSr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 571,
        GIR_EraseRootFromParent_Done,
      // Label 2763: @142192
      GIM_Try, /*On fail goto*//*Label 2764*/ GIMT_Encode4(142228), // Rule ID 572 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[f64] } 540:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT32ZDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32ZDr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 572,
        GIR_EraseRootFromParent_Done,
      // Label 2764: @142228
      GIM_Try, /*On fail goto*//*Label 2765*/ GIMT_Encode4(142264), // Rule ID 573 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[f32] } 542:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT64ZSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64ZSr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 573,
        GIR_EraseRootFromParent_Done,
      // Label 2765: @142264
      GIM_Try, /*On fail goto*//*Label 2766*/ GIMT_Encode4(142300), // Rule ID 574 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[f64] } 542:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT64ZDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64ZDr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 574,
        GIR_EraseRootFromParent_Done,
      // Label 2766: @142300
      GIM_Try, /*On fail goto*//*Label 2767*/ GIMT_Encode4(142336), // Rule ID 575 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[f32] } 539:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT32XSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32XSr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 575,
        GIR_EraseRootFromParent_Done,
      // Label 2767: @142336
      GIM_Try, /*On fail goto*//*Label 2768*/ GIMT_Encode4(142372), // Rule ID 576 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[f64] } 539:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT32XDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32XDr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 576,
        GIR_EraseRootFromParent_Done,
      // Label 2768: @142372
      GIM_Try, /*On fail goto*//*Label 2769*/ GIMT_Encode4(142408), // Rule ID 577 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[f32] } 541:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT64XSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64XSr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 577,
        GIR_EraseRootFromParent_Done,
      // Label 2769: @142408
      GIM_Try, /*On fail goto*//*Label 2770*/ GIMT_Encode4(142444), // Rule ID 578 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[f64] } 541:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT64XDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64XDr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 578,
        GIR_EraseRootFromParent_Done,
      // Label 2770: @142444
      GIM_Try, /*On fail goto*//*Label 2771*/ GIMT_Encode4(142480), // Rule ID 706 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i8] } 570:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (CLSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 706,
        GIR_EraseRootFromParent_Done,
      // Label 2771: @142480
      GIM_Try, /*On fail goto*//*Label 2772*/ GIMT_Encode4(142516), // Rule ID 707 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 570:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (CLSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 707,
        GIR_EraseRootFromParent_Done,
      // Label 2772: @142516
      GIM_Try, /*On fail goto*//*Label 2773*/ GIMT_Encode4(142552), // Rule ID 708 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 570:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (CLSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 708,
        GIR_EraseRootFromParent_Done,
      // Label 2773: @142552
      GIM_Try, /*On fail goto*//*Label 2774*/ GIMT_Encode4(142588), // Rule ID 709 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 570:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (CLSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 709,
        GIR_EraseRootFromParent_Done,
      // Label 2774: @142588
      GIM_Try, /*On fail goto*//*Label 2775*/ GIMT_Encode4(142624), // Rule ID 710 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 570:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (CLSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 710,
        GIR_EraseRootFromParent_Done,
      // Label 2775: @142624
      GIM_Try, /*On fail goto*//*Label 2776*/ GIMT_Encode4(142660), // Rule ID 711 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 570:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (CLSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 711,
        GIR_EraseRootFromParent_Done,
      // Label 2776: @142660
      GIM_Try, /*On fail goto*//*Label 2777*/ GIMT_Encode4(142696), // Rule ID 785 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 578:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTASv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 785,
        GIR_EraseRootFromParent_Done,
      // Label 2777: @142696
      GIM_Try, /*On fail goto*//*Label 2778*/ GIMT_Encode4(142732), // Rule ID 786 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 578:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTASv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 786,
        GIR_EraseRootFromParent_Done,
      // Label 2778: @142732
      GIM_Try, /*On fail goto*//*Label 2779*/ GIMT_Encode4(142768), // Rule ID 787 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 578:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTASv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 787,
        GIR_EraseRootFromParent_Done,
      // Label 2779: @142768
      GIM_Try, /*On fail goto*//*Label 2780*/ GIMT_Encode4(142804), // Rule ID 788 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 578:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTASv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 788,
        GIR_EraseRootFromParent_Done,
      // Label 2780: @142804
      GIM_Try, /*On fail goto*//*Label 2781*/ GIMT_Encode4(142840), // Rule ID 789 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 578:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTASv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 789,
        GIR_EraseRootFromParent_Done,
      // Label 2781: @142840
      GIM_Try, /*On fail goto*//*Label 2782*/ GIMT_Encode4(142876), // Rule ID 790 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 579:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTAUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 790,
        GIR_EraseRootFromParent_Done,
      // Label 2782: @142876
      GIM_Try, /*On fail goto*//*Label 2783*/ GIMT_Encode4(142912), // Rule ID 791 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 579:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTAUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 791,
        GIR_EraseRootFromParent_Done,
      // Label 2783: @142912
      GIM_Try, /*On fail goto*//*Label 2784*/ GIMT_Encode4(142948), // Rule ID 792 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 579:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTAUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 792,
        GIR_EraseRootFromParent_Done,
      // Label 2784: @142948
      GIM_Try, /*On fail goto*//*Label 2785*/ GIMT_Encode4(142984), // Rule ID 793 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 579:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTAUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 793,
        GIR_EraseRootFromParent_Done,
      // Label 2785: @142984
      GIM_Try, /*On fail goto*//*Label 2786*/ GIMT_Encode4(143020), // Rule ID 794 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 579:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTAUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 794,
        GIR_EraseRootFromParent_Done,
      // Label 2786: @143020
      GIM_Try, /*On fail goto*//*Label 2787*/ GIMT_Encode4(143056), // Rule ID 795 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 580:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTMSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 795,
        GIR_EraseRootFromParent_Done,
      // Label 2787: @143056
      GIM_Try, /*On fail goto*//*Label 2788*/ GIMT_Encode4(143092), // Rule ID 796 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 580:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTMSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 796,
        GIR_EraseRootFromParent_Done,
      // Label 2788: @143092
      GIM_Try, /*On fail goto*//*Label 2789*/ GIMT_Encode4(143128), // Rule ID 797 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 580:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTMSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 797,
        GIR_EraseRootFromParent_Done,
      // Label 2789: @143128
      GIM_Try, /*On fail goto*//*Label 2790*/ GIMT_Encode4(143164), // Rule ID 798 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 580:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTMSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 798,
        GIR_EraseRootFromParent_Done,
      // Label 2790: @143164
      GIM_Try, /*On fail goto*//*Label 2791*/ GIMT_Encode4(143200), // Rule ID 799 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 580:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTMSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 799,
        GIR_EraseRootFromParent_Done,
      // Label 2791: @143200
      GIM_Try, /*On fail goto*//*Label 2792*/ GIMT_Encode4(143236), // Rule ID 800 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 581:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTMUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 800,
        GIR_EraseRootFromParent_Done,
      // Label 2792: @143236
      GIM_Try, /*On fail goto*//*Label 2793*/ GIMT_Encode4(143272), // Rule ID 801 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 581:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTMUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 801,
        GIR_EraseRootFromParent_Done,
      // Label 2793: @143272
      GIM_Try, /*On fail goto*//*Label 2794*/ GIMT_Encode4(143308), // Rule ID 802 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 581:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTMUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 802,
        GIR_EraseRootFromParent_Done,
      // Label 2794: @143308
      GIM_Try, /*On fail goto*//*Label 2795*/ GIMT_Encode4(143344), // Rule ID 803 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 581:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTMUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 803,
        GIR_EraseRootFromParent_Done,
      // Label 2795: @143344
      GIM_Try, /*On fail goto*//*Label 2796*/ GIMT_Encode4(143380), // Rule ID 804 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 581:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTMUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 804,
        GIR_EraseRootFromParent_Done,
      // Label 2796: @143380
      GIM_Try, /*On fail goto*//*Label 2797*/ GIMT_Encode4(143416), // Rule ID 805 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 582:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTNSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 805,
        GIR_EraseRootFromParent_Done,
      // Label 2797: @143416
      GIM_Try, /*On fail goto*//*Label 2798*/ GIMT_Encode4(143452), // Rule ID 806 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 582:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 806,
        GIR_EraseRootFromParent_Done,
      // Label 2798: @143452
      GIM_Try, /*On fail goto*//*Label 2799*/ GIMT_Encode4(143488), // Rule ID 807 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 582:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTNSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 807,
        GIR_EraseRootFromParent_Done,
      // Label 2799: @143488
      GIM_Try, /*On fail goto*//*Label 2800*/ GIMT_Encode4(143524), // Rule ID 808 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 582:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 808,
        GIR_EraseRootFromParent_Done,
      // Label 2800: @143524
      GIM_Try, /*On fail goto*//*Label 2801*/ GIMT_Encode4(143560), // Rule ID 809 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 582:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTNSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 809,
        GIR_EraseRootFromParent_Done,
      // Label 2801: @143560
      GIM_Try, /*On fail goto*//*Label 2802*/ GIMT_Encode4(143596), // Rule ID 810 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 583:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTNUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 810,
        GIR_EraseRootFromParent_Done,
      // Label 2802: @143596
      GIM_Try, /*On fail goto*//*Label 2803*/ GIMT_Encode4(143632), // Rule ID 811 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 583:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 811,
        GIR_EraseRootFromParent_Done,
      // Label 2803: @143632
      GIM_Try, /*On fail goto*//*Label 2804*/ GIMT_Encode4(143668), // Rule ID 812 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 583:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTNUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 812,
        GIR_EraseRootFromParent_Done,
      // Label 2804: @143668
      GIM_Try, /*On fail goto*//*Label 2805*/ GIMT_Encode4(143704), // Rule ID 813 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 583:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 813,
        GIR_EraseRootFromParent_Done,
      // Label 2805: @143704
      GIM_Try, /*On fail goto*//*Label 2806*/ GIMT_Encode4(143740), // Rule ID 814 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 583:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTNUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 814,
        GIR_EraseRootFromParent_Done,
      // Label 2806: @143740
      GIM_Try, /*On fail goto*//*Label 2807*/ GIMT_Encode4(143776), // Rule ID 815 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 584:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTPSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 815,
        GIR_EraseRootFromParent_Done,
      // Label 2807: @143776
      GIM_Try, /*On fail goto*//*Label 2808*/ GIMT_Encode4(143812), // Rule ID 816 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 584:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTPSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 816,
        GIR_EraseRootFromParent_Done,
      // Label 2808: @143812
      GIM_Try, /*On fail goto*//*Label 2809*/ GIMT_Encode4(143848), // Rule ID 817 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 584:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTPSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 817,
        GIR_EraseRootFromParent_Done,
      // Label 2809: @143848
      GIM_Try, /*On fail goto*//*Label 2810*/ GIMT_Encode4(143884), // Rule ID 818 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 584:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTPSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 818,
        GIR_EraseRootFromParent_Done,
      // Label 2810: @143884
      GIM_Try, /*On fail goto*//*Label 2811*/ GIMT_Encode4(143920), // Rule ID 819 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 584:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTPSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 819,
        GIR_EraseRootFromParent_Done,
      // Label 2811: @143920
      GIM_Try, /*On fail goto*//*Label 2812*/ GIMT_Encode4(143956), // Rule ID 820 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 585:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTPUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 820,
        GIR_EraseRootFromParent_Done,
      // Label 2812: @143956
      GIM_Try, /*On fail goto*//*Label 2813*/ GIMT_Encode4(143992), // Rule ID 821 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 585:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTPUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 821,
        GIR_EraseRootFromParent_Done,
      // Label 2813: @143992
      GIM_Try, /*On fail goto*//*Label 2814*/ GIMT_Encode4(144028), // Rule ID 822 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 585:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTPUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 822,
        GIR_EraseRootFromParent_Done,
      // Label 2814: @144028
      GIM_Try, /*On fail goto*//*Label 2815*/ GIMT_Encode4(144064), // Rule ID 823 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 585:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTPUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 823,
        GIR_EraseRootFromParent_Done,
      // Label 2815: @144064
      GIM_Try, /*On fail goto*//*Label 2816*/ GIMT_Encode4(144100), // Rule ID 824 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 585:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTPUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 824,
        GIR_EraseRootFromParent_Done,
      // Label 2816: @144100
      GIM_Try, /*On fail goto*//*Label 2817*/ GIMT_Encode4(144136), // Rule ID 825 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtxn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f32] } 586:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTXNv2f32:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 825,
        GIR_EraseRootFromParent_Done,
      // Label 2817: @144136
      GIM_Try, /*On fail goto*//*Label 2818*/ GIMT_Encode4(144172), // Rule ID 852 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f16] } 607:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FRECPEv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 852,
        GIR_EraseRootFromParent_Done,
      // Label 2818: @144172
      GIM_Try, /*On fail goto*//*Label 2819*/ GIMT_Encode4(144208), // Rule ID 853 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8f16] } 607:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FRECPEv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 853,
        GIR_EraseRootFromParent_Done,
      // Label 2819: @144208
      GIM_Try, /*On fail goto*//*Label 2820*/ GIMT_Encode4(144244), // Rule ID 854 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f32] } 607:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRECPEv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 854,
        GIR_EraseRootFromParent_Done,
      // Label 2820: @144244
      GIM_Try, /*On fail goto*//*Label 2821*/ GIMT_Encode4(144280), // Rule ID 855 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 607:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRECPEv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 855,
        GIR_EraseRootFromParent_Done,
      // Label 2821: @144280
      GIM_Try, /*On fail goto*//*Label 2822*/ GIMT_Encode4(144316), // Rule ID 856 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f64] } 607:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRECPEv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 856,
        GIR_EraseRootFromParent_Done,
      // Label 2822: @144316
      GIM_Try, /*On fail goto*//*Label 2823*/ GIMT_Encode4(144352), // Rule ID 927 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f32] } 611:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT32Zv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Zv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 927,
        GIR_EraseRootFromParent_Done,
      // Label 2823: @144352
      GIM_Try, /*On fail goto*//*Label 2824*/ GIMT_Encode4(144388), // Rule ID 928 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 611:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT32Zv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Zv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 928,
        GIR_EraseRootFromParent_Done,
      // Label 2824: @144388
      GIM_Try, /*On fail goto*//*Label 2825*/ GIMT_Encode4(144424), // Rule ID 929 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f64] } 611:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT32Zv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Zv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 929,
        GIR_EraseRootFromParent_Done,
      // Label 2825: @144424
      GIM_Try, /*On fail goto*//*Label 2826*/ GIMT_Encode4(144460), // Rule ID 930 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f32] } 613:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT64Zv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Zv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 930,
        GIR_EraseRootFromParent_Done,
      // Label 2826: @144460
      GIM_Try, /*On fail goto*//*Label 2827*/ GIMT_Encode4(144496), // Rule ID 931 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 613:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT64Zv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Zv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 931,
        GIR_EraseRootFromParent_Done,
      // Label 2827: @144496
      GIM_Try, /*On fail goto*//*Label 2828*/ GIMT_Encode4(144532), // Rule ID 932 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f64] } 613:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT64Zv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Zv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 932,
        GIR_EraseRootFromParent_Done,
      // Label 2828: @144532
      GIM_Try, /*On fail goto*//*Label 2829*/ GIMT_Encode4(144568), // Rule ID 933 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f32] } 610:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT32Xv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Xv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 933,
        GIR_EraseRootFromParent_Done,
      // Label 2829: @144568
      GIM_Try, /*On fail goto*//*Label 2830*/ GIMT_Encode4(144604), // Rule ID 934 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 610:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT32Xv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Xv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 934,
        GIR_EraseRootFromParent_Done,
      // Label 2830: @144604
      GIM_Try, /*On fail goto*//*Label 2831*/ GIMT_Encode4(144640), // Rule ID 935 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f64] } 610:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT32Xv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Xv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 935,
        GIR_EraseRootFromParent_Done,
      // Label 2831: @144640
      GIM_Try, /*On fail goto*//*Label 2832*/ GIMT_Encode4(144676), // Rule ID 936 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f32] } 612:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT64Xv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Xv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 936,
        GIR_EraseRootFromParent_Done,
      // Label 2832: @144676
      GIM_Try, /*On fail goto*//*Label 2833*/ GIMT_Encode4(144712), // Rule ID 937 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 612:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT64Xv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Xv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 937,
        GIR_EraseRootFromParent_Done,
      // Label 2833: @144712
      GIM_Try, /*On fail goto*//*Label 2834*/ GIMT_Encode4(144748), // Rule ID 938 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f64] } 612:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT64Xv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Xv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 938,
        GIR_EraseRootFromParent_Done,
      // Label 2834: @144748
      GIM_Try, /*On fail goto*//*Label 2835*/ GIMT_Encode4(144784), // Rule ID 939 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f16] } 614:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FRSQRTEv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 939,
        GIR_EraseRootFromParent_Done,
      // Label 2835: @144784
      GIM_Try, /*On fail goto*//*Label 2836*/ GIMT_Encode4(144820), // Rule ID 940 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8f16] } 614:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FRSQRTEv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 940,
        GIR_EraseRootFromParent_Done,
      // Label 2836: @144820
      GIM_Try, /*On fail goto*//*Label 2837*/ GIMT_Encode4(144856), // Rule ID 941 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f32] } 614:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRSQRTEv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 941,
        GIR_EraseRootFromParent_Done,
      // Label 2837: @144856
      GIM_Try, /*On fail goto*//*Label 2838*/ GIMT_Encode4(144892), // Rule ID 942 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 614:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRSQRTEv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 942,
        GIR_EraseRootFromParent_Done,
      // Label 2838: @144892
      GIM_Try, /*On fail goto*//*Label 2839*/ GIMT_Encode4(144928), // Rule ID 943 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f64] } 614:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRSQRTEv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 943,
        GIR_EraseRootFromParent_Done,
      // Label 2839: @144928
      GIM_Try, /*On fail goto*//*Label 2840*/ GIMT_Encode4(144964), // Rule ID 990 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 635:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i8_v4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 990,
        GIR_EraseRootFromParent_Done,
      // Label 2840: @144964
      GIM_Try, /*On fail goto*//*Label 2841*/ GIMT_Encode4(145000), // Rule ID 992 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 635:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 992,
        GIR_EraseRootFromParent_Done,
      // Label 2841: @145000
      GIM_Try, /*On fail goto*//*Label 2842*/ GIMT_Encode4(145036), // Rule ID 994 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 635:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i16_v2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 994,
        GIR_EraseRootFromParent_Done,
      // Label 2842: @145036
      GIM_Try, /*On fail goto*//*Label 2843*/ GIMT_Encode4(145072), // Rule ID 996 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 635:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 996,
        GIR_EraseRootFromParent_Done,
      // Label 2843: @145072
      GIM_Try, /*On fail goto*//*Label 2844*/ GIMT_Encode4(145108), // Rule ID 998 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1i64] } 635:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (SADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv2i32_v1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 998,
        GIR_EraseRootFromParent_Done,
      // Label 2844: @145108
      GIM_Try, /*On fail goto*//*Label 2845*/ GIMT_Encode4(145144), // Rule ID 1000 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 635:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (SADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1000,
        GIR_EraseRootFromParent_Done,
      // Label 2845: @145144
      GIM_Try, /*On fail goto*//*Label 2846*/ GIMT_Encode4(145180), // Rule ID 1011 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i8] } 653:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SQABSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1011,
        GIR_EraseRootFromParent_Done,
      // Label 2846: @145180
      GIM_Try, /*On fail goto*//*Label 2847*/ GIMT_Encode4(145216), // Rule ID 1012 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 653:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SQABSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1012,
        GIR_EraseRootFromParent_Done,
      // Label 2847: @145216
      GIM_Try, /*On fail goto*//*Label 2848*/ GIMT_Encode4(145252), // Rule ID 1013 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 653:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SQABSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1013,
        GIR_EraseRootFromParent_Done,
      // Label 2848: @145252
      GIM_Try, /*On fail goto*//*Label 2849*/ GIMT_Encode4(145288), // Rule ID 1014 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 653:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SQABSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1014,
        GIR_EraseRootFromParent_Done,
      // Label 2849: @145288
      GIM_Try, /*On fail goto*//*Label 2850*/ GIMT_Encode4(145324), // Rule ID 1015 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 653:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (SQABSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1015,
        GIR_EraseRootFromParent_Done,
      // Label 2850: @145324
      GIM_Try, /*On fail goto*//*Label 2851*/ GIMT_Encode4(145360), // Rule ID 1016 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 653:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (SQABSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1016,
        GIR_EraseRootFromParent_Done,
      // Label 2851: @145360
      GIM_Try, /*On fail goto*//*Label 2852*/ GIMT_Encode4(145396), // Rule ID 1017 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 653:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (SQABSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1017,
        GIR_EraseRootFromParent_Done,
      // Label 2852: @145396
      GIM_Try, /*On fail goto*//*Label 2853*/ GIMT_Encode4(145432), // Rule ID 1018 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i8] } 660:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SQNEGv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1018,
        GIR_EraseRootFromParent_Done,
      // Label 2853: @145432
      GIM_Try, /*On fail goto*//*Label 2854*/ GIMT_Encode4(145468), // Rule ID 1019 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 660:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SQNEGv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1019,
        GIR_EraseRootFromParent_Done,
      // Label 2854: @145468
      GIM_Try, /*On fail goto*//*Label 2855*/ GIMT_Encode4(145504), // Rule ID 1020 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 660:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SQNEGv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1020,
        GIR_EraseRootFromParent_Done,
      // Label 2855: @145504
      GIM_Try, /*On fail goto*//*Label 2856*/ GIMT_Encode4(145540), // Rule ID 1021 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 660:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SQNEGv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1021,
        GIR_EraseRootFromParent_Done,
      // Label 2856: @145540
      GIM_Try, /*On fail goto*//*Label 2857*/ GIMT_Encode4(145576), // Rule ID 1022 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 660:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (SQNEGv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1022,
        GIR_EraseRootFromParent_Done,
      // Label 2857: @145576
      GIM_Try, /*On fail goto*//*Label 2858*/ GIMT_Encode4(145612), // Rule ID 1023 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 660:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (SQNEGv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1023,
        GIR_EraseRootFromParent_Done,
      // Label 2858: @145612
      GIM_Try, /*On fail goto*//*Label 2859*/ GIMT_Encode4(145648), // Rule ID 1024 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 660:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (SQNEGv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1024,
        GIR_EraseRootFromParent_Done,
      // Label 2859: @145648
      GIM_Try, /*On fail goto*//*Label 2860*/ GIMT_Encode4(145684), // Rule ID 1051 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 700:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (UADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i8_v4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1051,
        GIR_EraseRootFromParent_Done,
      // Label 2860: @145684
      GIM_Try, /*On fail goto*//*Label 2861*/ GIMT_Encode4(145720), // Rule ID 1053 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 700:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (UADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1053,
        GIR_EraseRootFromParent_Done,
      // Label 2861: @145720
      GIM_Try, /*On fail goto*//*Label 2862*/ GIMT_Encode4(145756), // Rule ID 1055 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 700:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (UADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i16_v2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1055,
        GIR_EraseRootFromParent_Done,
      // Label 2862: @145756
      GIM_Try, /*On fail goto*//*Label 2863*/ GIMT_Encode4(145792), // Rule ID 1057 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 700:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (UADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1057,
        GIR_EraseRootFromParent_Done,
      // Label 2863: @145792
      GIM_Try, /*On fail goto*//*Label 2864*/ GIMT_Encode4(145828), // Rule ID 1059 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1i64] } 700:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (UADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv2i32_v1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1059,
        GIR_EraseRootFromParent_Done,
      // Label 2864: @145828
      GIM_Try, /*On fail goto*//*Label 2865*/ GIMT_Encode4(145864), // Rule ID 1061 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 700:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (UADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1061,
        GIR_EraseRootFromParent_Done,
      // Label 2865: @145864
      GIM_Try, /*On fail goto*//*Label 2866*/ GIMT_Encode4(145900), // Rule ID 1075 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urecpe),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 721:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (URECPEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPEv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1075,
        GIR_EraseRootFromParent_Done,
      // Label 2866: @145900
      GIM_Try, /*On fail goto*//*Label 2867*/ GIMT_Encode4(145936), // Rule ID 1076 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urecpe),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 721:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (URECPEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPEv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1076,
        GIR_EraseRootFromParent_Done,
      // Label 2867: @145936
      GIM_Try, /*On fail goto*//*Label 2868*/ GIMT_Encode4(145972), // Rule ID 1077 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ursqrte),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (URSQRTEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTEv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1077,
        GIR_EraseRootFromParent_Done,
      // Label 2868: @145972
      GIM_Try, /*On fail goto*//*Label 2869*/ GIMT_Encode4(146008), // Rule ID 1078 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ursqrte),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 724:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (URSQRTEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTEv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1078,
        GIR_EraseRootFromParent_Done,
      // Label 2869: @146008
      GIM_Try, /*On fail goto*//*Label 2870*/ GIMT_Encode4(146044), // Rule ID 1642 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fcvtxn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[f32] } 761:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTXNv1i64:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1642,
        GIR_EraseRootFromParent_Done,
      // Label 2870: @146044
      GIM_Try, /*On fail goto*//*Label 2871*/ GIMT_Encode4(146080), // Rule ID 1648 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 653:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn)  =>  (SQABSv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1648,
        GIR_EraseRootFromParent_Done,
      // Label 2871: @146080
      GIM_Try, /*On fail goto*//*Label 2872*/ GIMT_Encode4(146116), // Rule ID 1649 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 653:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn)  =>  (SQABSv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv1i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1649,
        GIR_EraseRootFromParent_Done,
      // Label 2872: @146116
      GIM_Try, /*On fail goto*//*Label 2873*/ GIMT_Encode4(146152), // Rule ID 1650 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 660:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn)  =>  (SQNEGv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1650,
        GIR_EraseRootFromParent_Done,
      // Label 2873: @146152
      GIM_Try, /*On fail goto*//*Label 2874*/ GIMT_Encode4(146188), // Rule ID 1651 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 660:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn)  =>  (SQNEGv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv1i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1651,
        GIR_EraseRootFromParent_Done,
      // Label 2874: @146188
      GIM_Try, /*On fail goto*//*Label 2875*/ GIMT_Encode4(146224), // Rule ID 1652 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_scalar_sqxtn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[f32] } 638:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (SQXTNv1i32:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNv1i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1652,
        GIR_EraseRootFromParent_Done,
      // Label 2875: @146224
      GIM_Try, /*On fail goto*//*Label 2876*/ GIMT_Encode4(146260), // Rule ID 1653 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_scalar_sqxtun),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[f32] } 639:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (SQXTUNv1i32:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNv1i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1653,
        GIR_EraseRootFromParent_Done,
      // Label 2876: @146260
      GIM_Try, /*On fail goto*//*Label 2877*/ GIMT_Encode4(146296), // Rule ID 1659 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_scalar_uqxtn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[f32] } 640:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (UQXTNv1i32:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNv1i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1659,
        GIR_EraseRootFromParent_Done,
      // Label 2877: @146296
      GIM_Try, /*On fail goto*//*Label 2878*/ GIMT_Encode4(146332), // Rule ID 1932 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[f16] } 592:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMAXNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i16v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1932,
        GIR_EraseRootFromParent_Done,
      // Label 2878: @146332
      GIM_Try, /*On fail goto*//*Label 2879*/ GIMT_Encode4(146368), // Rule ID 1934 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[f16] } 592:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMAXNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv8i16v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1934,
        GIR_EraseRootFromParent_Done,
      // Label 2879: @146368
      GIM_Try, /*On fail goto*//*Label 2880*/ GIMT_Encode4(146404), // Rule ID 1936 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[f32] } 592:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMAXNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i32v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1936,
        GIR_EraseRootFromParent_Done,
      // Label 2880: @146404
      GIM_Try, /*On fail goto*//*Label 2881*/ GIMT_Encode4(146440), // Rule ID 1938 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[f16] } 594:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMAXVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i16v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1938,
        GIR_EraseRootFromParent_Done,
      // Label 2881: @146440
      GIM_Try, /*On fail goto*//*Label 2882*/ GIMT_Encode4(146476), // Rule ID 1940 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[f16] } 594:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMAXVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv8i16v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1940,
        GIR_EraseRootFromParent_Done,
      // Label 2882: @146476
      GIM_Try, /*On fail goto*//*Label 2883*/ GIMT_Encode4(146512), // Rule ID 1942 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[f32] } 594:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMAXVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i32v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1942,
        GIR_EraseRootFromParent_Done,
      // Label 2883: @146512
      GIM_Try, /*On fail goto*//*Label 2884*/ GIMT_Encode4(146548), // Rule ID 1944 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[f16] } 598:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMINNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i16v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1944,
        GIR_EraseRootFromParent_Done,
      // Label 2884: @146548
      GIM_Try, /*On fail goto*//*Label 2885*/ GIMT_Encode4(146584), // Rule ID 1946 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[f16] } 598:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMINNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv8i16v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1946,
        GIR_EraseRootFromParent_Done,
      // Label 2885: @146584
      GIM_Try, /*On fail goto*//*Label 2886*/ GIMT_Encode4(146620), // Rule ID 1948 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[f32] } 598:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMINNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i32v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1948,
        GIR_EraseRootFromParent_Done,
      // Label 2886: @146620
      GIM_Try, /*On fail goto*//*Label 2887*/ GIMT_Encode4(146656), // Rule ID 1950 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[f16] } 600:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMINVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i16v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1950,
        GIR_EraseRootFromParent_Done,
      // Label 2887: @146656
      GIM_Try, /*On fail goto*//*Label 2888*/ GIMT_Encode4(146692), // Rule ID 1952 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[f16] } 600:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMINVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINVv8i16v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1952,
        GIR_EraseRootFromParent_Done,
      // Label 2888: @146692
      GIM_Try, /*On fail goto*//*Label 2889*/ GIMT_Encode4(146728), // Rule ID 1954 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[f32] } 600:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMINVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i32v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1954,
        GIR_EraseRootFromParent_Done,
      // Label 2889: @146728
      GIM_Try, /*On fail goto*//*Label 2890*/ GIMT_Encode4(146764), // Rule ID 2292 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesmc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 506:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (AESMCrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESMCrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2292,
        GIR_EraseRootFromParent_Done,
      // Label 2890: @146764
      GIM_Try, /*On fail goto*//*Label 2891*/ GIMT_Encode4(146800), // Rule ID 2293 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesimc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 505:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (AESIMCrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESIMCrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2293,
        GIR_EraseRootFromParent_Done,
      // Label 2891: @146800
      GIM_Try, /*On fail goto*//*Label 2892*/ GIMT_Encode4(146836), // Rule ID 2301 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1h),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 513:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn)  =>  (SHA1Hrr:{ *:[i32] } FPR32:{ *:[i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Hrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2301,
        GIR_EraseRootFromParent_Done,
      // Label 2892: @146836
      GIM_Try, /*On fail goto*//*Label 2893*/ GIMT_Encode4(146872), // Rule ID 2480 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1i64] } 653:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn)  =>  (SQABSv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2480,
        GIR_EraseRootFromParent_Done,
      // Label 2893: @146872
      GIM_Try, /*On fail goto*//*Label 2894*/ GIMT_Encode4(146911), // Rule ID 3544 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1507:{ *:[iPTR] }, ZPRAny:{ *:[nxv16i8] }:$Zn)  =>  (PMOV_PZI_B:{ *:[nxv16i1] } ZPRAny:{ *:[nxv16i8] }:$Zn, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Zn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3544,
        GIR_EraseRootFromParent_Done,
      // Label 2894: @146911
      GIM_Try, /*On fail goto*//*Label 2895*/ GIMT_Encode4(146950), // Rule ID 3545 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1507:{ *:[iPTR] }, ZPRAny:{ *:[nxv8i16] }:$Zn)  =>  (PMOV_PZI_H:{ *:[nxv8i1] } ZPRAny:{ *:[nxv8i16] }:$Zn, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Zn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3545,
        GIR_EraseRootFromParent_Done,
      // Label 2895: @146950
      GIM_Try, /*On fail goto*//*Label 2896*/ GIMT_Encode4(146989), // Rule ID 3546 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1507:{ *:[iPTR] }, ZPRAny:{ *:[nxv4i32] }:$Zn)  =>  (PMOV_PZI_S:{ *:[nxv4i1] } ZPRAny:{ *:[nxv4i32] }:$Zn, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Zn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3546,
        GIR_EraseRootFromParent_Done,
      // Label 2896: @146989
      GIM_Try, /*On fail goto*//*Label 2897*/ GIMT_Encode4(147028), // Rule ID 3547 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 1507:{ *:[iPTR] }, ZPRAny:{ *:[nxv2i64] }:$Zn)  =>  (PMOV_PZI_D:{ *:[nxv2i1] } ZPRAny:{ *:[nxv2i64] }:$Zn, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Zn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3547,
        GIR_EraseRootFromParent_Done,
      // Label 2897: @147028
      GIM_Try, /*On fail goto*//*Label 2898*/ GIMT_Encode4(147084), // Rule ID 3551 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1509:{ *:[iPTR] }, PPR8:{ *:[nxv16i1] }:$Pn)  =>  (PMOV_ZIP_B:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i64] }, PPR8:{ *:[nxv16i1] }:$Pn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3551,
        GIR_EraseRootFromParent_Done,
      // Label 2898: @147084
      GIM_Try, /*On fail goto*//*Label 2899*/ GIMT_Encode4(147140), // Rule ID 3552 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1509:{ *:[iPTR] }, PPR16:{ *:[nxv8i1] }:$Pn)  =>  (PMOV_ZIP_H:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i32] }, PPR16:{ *:[nxv8i1] }:$Pn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3552,
        GIR_EraseRootFromParent_Done,
      // Label 2899: @147140
      GIM_Try, /*On fail goto*//*Label 2900*/ GIMT_Encode4(147196), // Rule ID 3553 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1509:{ *:[iPTR] }, PPR32:{ *:[nxv4i1] }:$Pn)  =>  (PMOV_ZIP_S:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i32] }, PPR32:{ *:[nxv4i1] }:$Pn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3553,
        GIR_EraseRootFromParent_Done,
      // Label 2900: @147196
      GIM_Try, /*On fail goto*//*Label 2901*/ GIMT_Encode4(147252), // Rule ID 3554 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1509:{ *:[iPTR] }, PPR64:{ *:[nxv2i1] }:$Pn)  =>  (PMOV_ZIP_D:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i32] }, PPR64:{ *:[nxv2i1] }:$Pn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3554,
        GIR_EraseRootFromParent_Done,
      // Label 2901: @147252
      GIM_Try, /*On fail goto*//*Label 2902*/ GIMT_Encode4(147285), // Rule ID 3989 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_cls),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 493:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn)  =>  (CLSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSWr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3989,
        GIR_EraseRootFromParent_Done,
      // Label 2902: @147285
      GIM_Try, /*On fail goto*//*Label 2903*/ GIMT_Encode4(147350), // Rule ID 3990 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_cls64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 494:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rm)  =>  (EXTRACT_SUBREG:{ *:[i32] } (CLSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rm), sub_32:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CLSXr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        // GIR_Coverage, 3990,
        GIR_EraseRootFromParent_Done,
      // Label 2903: @147350
      GIM_Try, /*On fail goto*//*Label 2904*/ GIMT_Encode4(147383), // Rule ID 4813 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1f64] } 611:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT32ZDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32ZDr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4813,
        GIR_EraseRootFromParent_Done,
      // Label 2904: @147383
      GIM_Try, /*On fail goto*//*Label 2905*/ GIMT_Encode4(147416), // Rule ID 4814 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1f64] } 613:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT64ZDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64ZDr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4814,
        GIR_EraseRootFromParent_Done,
      // Label 2905: @147416
      GIM_Try, /*On fail goto*//*Label 2906*/ GIMT_Encode4(147449), // Rule ID 4815 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1f64] } 610:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT32XDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32XDr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4815,
        GIR_EraseRootFromParent_Done,
      // Label 2906: @147449
      GIM_Try, /*On fail goto*//*Label 2907*/ GIMT_Encode4(147482), // Rule ID 4816 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1f64] } 612:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT64XDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64XDr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4816,
        GIR_EraseRootFromParent_Done,
      // Label 2907: @147482
      GIM_Try, /*On fail goto*//*Label 2908*/ GIMT_Encode4(147515), // Rule ID 4932 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvthf2fp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 742:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (FCVTLv4i16:{ *:[v4f32] } V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4932,
        GIR_EraseRootFromParent_Done,
      // Label 2908: @147515
      GIM_Try, /*On fail goto*//*Label 2909*/ GIMT_Encode4(147548), // Rule ID 4942 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2hf),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 739:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNv4i16:{ *:[v4i16] } V128:{ *:[v4f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4942,
        GIR_EraseRootFromParent_Done,
      // Label 2909: @147548
      GIM_Try, /*On fail goto*//*Label 2910*/ GIMT_Encode4(147584), // Rule ID 5284 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1i64] } 660:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn)  =>  (SQNEGv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5284,
        GIR_EraseRootFromParent_Done,
      // Label 2910: @147584
      GIM_Try, /*On fail goto*//*Label 2911*/ GIMT_Encode4(147617), // Rule ID 5289 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1i64] } 578:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTASv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5289,
        GIR_EraseRootFromParent_Done,
      // Label 2911: @147617
      GIM_Try, /*On fail goto*//*Label 2912*/ GIMT_Encode4(147650), // Rule ID 5290 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1i64] } 579:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTAUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5290,
        GIR_EraseRootFromParent_Done,
      // Label 2912: @147650
      GIM_Try, /*On fail goto*//*Label 2913*/ GIMT_Encode4(147683), // Rule ID 5291 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1i64] } 580:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTMSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5291,
        GIR_EraseRootFromParent_Done,
      // Label 2913: @147683
      GIM_Try, /*On fail goto*//*Label 2914*/ GIMT_Encode4(147716), // Rule ID 5292 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1i64] } 581:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTMUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5292,
        GIR_EraseRootFromParent_Done,
      // Label 2914: @147716
      GIM_Try, /*On fail goto*//*Label 2915*/ GIMT_Encode4(147749), // Rule ID 5293 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1i64] } 582:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTNSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5293,
        GIR_EraseRootFromParent_Done,
      // Label 2915: @147749
      GIM_Try, /*On fail goto*//*Label 2916*/ GIMT_Encode4(147782), // Rule ID 5294 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1i64] } 583:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTNUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5294,
        GIR_EraseRootFromParent_Done,
      // Label 2916: @147782
      GIM_Try, /*On fail goto*//*Label 2917*/ GIMT_Encode4(147815), // Rule ID 5295 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1i64] } 584:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTPSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5295,
        GIR_EraseRootFromParent_Done,
      // Label 2917: @147815
      GIM_Try, /*On fail goto*//*Label 2918*/ GIMT_Encode4(147848), // Rule ID 5296 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1i64] } 585:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTPUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5296,
        GIR_EraseRootFromParent_Done,
      // Label 2918: @147848
      GIM_Try, /*On fail goto*//*Label 2919*/ GIMT_Encode4(147881), // Rule ID 5297 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1i64] } 587:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTZSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5297,
        GIR_EraseRootFromParent_Done,
      // Label 2919: @147881
      GIM_Try, /*On fail goto*//*Label 2920*/ GIMT_Encode4(147914), // Rule ID 5298 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1i64] } 588:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTZUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5298,
        GIR_EraseRootFromParent_Done,
      // Label 2920: @147914
      GIM_Try, /*On fail goto*//*Label 2921*/ GIMT_Encode4(147947), // Rule ID 5299 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (intrinsic_wo_chain:{ *:[f16] } 607:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FRECPEv1f16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5299,
        GIR_EraseRootFromParent_Done,
      // Label 2921: @147947
      GIM_Try, /*On fail goto*//*Label 2922*/ GIMT_Encode4(147980), // Rule ID 5300 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[f32] } 607:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRECPEv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5300,
        GIR_EraseRootFromParent_Done,
      // Label 2922: @147980
      GIM_Try, /*On fail goto*//*Label 2923*/ GIMT_Encode4(148013), // Rule ID 5301 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[f64] } 607:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRECPEv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5301,
        GIR_EraseRootFromParent_Done,
      // Label 2923: @148013
      GIM_Try, /*On fail goto*//*Label 2924*/ GIMT_Encode4(148046), // Rule ID 5302 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1f64] } 607:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRECPEv1i64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5302,
        GIR_EraseRootFromParent_Done,
      // Label 2924: @148046
      GIM_Try, /*On fail goto*//*Label 2925*/ GIMT_Encode4(148079), // Rule ID 5314 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (intrinsic_wo_chain:{ *:[f16] } 609:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FRECPXv1f16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPXv1f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5314,
        GIR_EraseRootFromParent_Done,
      // Label 2925: @148079
      GIM_Try, /*On fail goto*//*Label 2926*/ GIMT_Encode4(148112), // Rule ID 5315 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[f32] } 609:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRECPXv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPXv1i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5315,
        GIR_EraseRootFromParent_Done,
      // Label 2926: @148112
      GIM_Try, /*On fail goto*//*Label 2927*/ GIMT_Encode4(148145), // Rule ID 5316 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[f64] } 609:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRECPXv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPXv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5316,
        GIR_EraseRootFromParent_Done,
      // Label 2927: @148145
      GIM_Try, /*On fail goto*//*Label 2928*/ GIMT_Encode4(148178), // Rule ID 5317 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (intrinsic_wo_chain:{ *:[f16] } 614:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FRSQRTEv1f16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5317,
        GIR_EraseRootFromParent_Done,
      // Label 2928: @148178
      GIM_Try, /*On fail goto*//*Label 2929*/ GIMT_Encode4(148211), // Rule ID 5318 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[f32] } 614:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRSQRTEv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5318,
        GIR_EraseRootFromParent_Done,
      // Label 2929: @148211
      GIM_Try, /*On fail goto*//*Label 2930*/ GIMT_Encode4(148244), // Rule ID 5319 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[f64] } 614:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRSQRTEv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5319,
        GIR_EraseRootFromParent_Done,
      // Label 2930: @148244
      GIM_Try, /*On fail goto*//*Label 2931*/ GIMT_Encode4(148277), // Rule ID 5320 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1f64] } 614:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRSQRTEv1i64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5320,
        GIR_EraseRootFromParent_Done,
      // Label 2931: @148277
      GIM_Try, /*On fail goto*//*Label 2932*/ GIMT_Encode4(148310), // Rule ID 5659 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[f32] } 575:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5659,
        GIR_EraseRootFromParent_Done,
      // Label 2932: @148310
      GIM_Try, /*On fail goto*//*Label 2933*/ GIMT_Encode4(148395), // Rule ID 5660 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[f32] } 575:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } (FADDPv4f32:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn), dsub:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5660,
        GIR_EraseRootFromParent_Done,
      // Label 2933: @148395
      GIM_Try, /*On fail goto*//*Label 2934*/ GIMT_Encode4(148428), // Rule ID 5661 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[f64] } 575:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FADDPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5661,
        GIR_EraseRootFromParent_Done,
      // Label 2934: @148428
      GIM_Try, /*On fail goto*//*Label 2935*/ GIMT_Encode4(148461), // Rule ID 5663 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[f32] } 592:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMAXNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i32p),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5663,
        GIR_EraseRootFromParent_Done,
      // Label 2935: @148461
      GIM_Try, /*On fail goto*//*Label 2936*/ GIMT_Encode4(148494), // Rule ID 5665 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[f64] } 592:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMAXNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i64p),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5665,
        GIR_EraseRootFromParent_Done,
      // Label 2936: @148494
      GIM_Try, /*On fail goto*//*Label 2937*/ GIMT_Encode4(148527), // Rule ID 5667 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[f32] } 594:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMAXPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i32p),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5667,
        GIR_EraseRootFromParent_Done,
      // Label 2937: @148527
      GIM_Try, /*On fail goto*//*Label 2938*/ GIMT_Encode4(148560), // Rule ID 5669 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[f64] } 594:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMAXPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i64p),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5669,
        GIR_EraseRootFromParent_Done,
      // Label 2938: @148560
      GIM_Try, /*On fail goto*//*Label 2939*/ GIMT_Encode4(148593), // Rule ID 5671 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[f32] } 598:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMINNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i32p),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5671,
        GIR_EraseRootFromParent_Done,
      // Label 2939: @148593
      GIM_Try, /*On fail goto*//*Label 2940*/ GIMT_Encode4(148626), // Rule ID 5673 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[f64] } 598:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMINNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i64p),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5673,
        GIR_EraseRootFromParent_Done,
      // Label 2940: @148626
      GIM_Try, /*On fail goto*//*Label 2941*/ GIMT_Encode4(148659), // Rule ID 5675 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[f32] } 600:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMINPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i32p),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5675,
        GIR_EraseRootFromParent_Done,
      // Label 2941: @148659
      GIM_Try, /*On fail goto*//*Label 2942*/ GIMT_Encode4(148692), // Rule ID 5677 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[f64] } 600:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMINPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i64p),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5677,
        GIR_EraseRootFromParent_Done,
      // Label 2942: @148692
      GIM_Try, /*On fail goto*//*Label 2943*/ GIMT_Encode4(148725), // Rule ID 13203 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i8] } 637:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13203,
        GIR_EraseRootFromParent_Done,
      // Label 2943: @148725
      GIM_Try, /*On fail goto*//*Label 2944*/ GIMT_Encode4(148758), // Rule ID 13205 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[i8] } 637:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13205,
        GIR_EraseRootFromParent_Done,
      // Label 2944: @148758
      GIM_Try, /*On fail goto*//*Label 2945*/ GIMT_Encode4(148791), // Rule ID 13207 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i16] } 637:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13207,
        GIR_EraseRootFromParent_Done,
      // Label 2945: @148791
      GIM_Try, /*On fail goto*//*Label 2946*/ GIMT_Encode4(148824), // Rule ID 13209 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[i16] } 637:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13209,
        GIR_EraseRootFromParent_Done,
      // Label 2946: @148824
      GIM_Try, /*On fail goto*//*Label 2947*/ GIMT_Encode4(148939), // Rule ID 13210 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 637:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i32v),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 13210,
        GIR_EraseRootFromParent_Done,
      // Label 2947: @148939
      GIM_Try, /*On fail goto*//*Label 2948*/ GIMT_Encode4(148972), // Rule ID 13212 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i8] } 702:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13212,
        GIR_EraseRootFromParent_Done,
      // Label 2948: @148972
      GIM_Try, /*On fail goto*//*Label 2949*/ GIMT_Encode4(149005), // Rule ID 13214 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[i8] } 702:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13214,
        GIR_EraseRootFromParent_Done,
      // Label 2949: @149005
      GIM_Try, /*On fail goto*//*Label 2950*/ GIMT_Encode4(149038), // Rule ID 13216 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i16] } 702:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13216,
        GIR_EraseRootFromParent_Done,
      // Label 2950: @149038
      GIM_Try, /*On fail goto*//*Label 2951*/ GIMT_Encode4(149071), // Rule ID 13218 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[i16] } 702:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13218,
        GIR_EraseRootFromParent_Done,
      // Label 2951: @149071
      GIM_Try, /*On fail goto*//*Label 2952*/ GIMT_Encode4(149186), // Rule ID 13219 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 702:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i32v),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 13219,
        GIR_EraseRootFromParent_Done,
      // Label 2952: @149186
      GIM_Try, /*On fail goto*//*Label 2953*/ GIMT_Encode4(149305), // Rule ID 13220 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 637:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 13220,
        GIR_EraseRootFromParent_Done,
      // Label 2953: @149305
      GIM_Try, /*On fail goto*//*Label 2954*/ GIMT_Encode4(149420), // Rule ID 13221 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 637:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (ADDPv2i64p:{ *:[i64] } V128:{ *:[v2i64] }:$Rn), dsub:{ *:[i32] }), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 13221,
        GIR_EraseRootFromParent_Done,
      // Label 2954: @149420
      GIM_Try, /*On fail goto*//*Label 2955*/ GIMT_Encode4(149539), // Rule ID 13222 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 702:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 13222,
        GIR_EraseRootFromParent_Done,
      // Label 2955: @149539
      GIM_Try, /*On fail goto*//*Label 2956*/ GIMT_Encode4(149654), // Rule ID 13223 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 702:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (ADDPv2i64p:{ *:[i64] } V128:{ *:[v2i64] }:$Rn), dsub:{ *:[i32] }), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 13223,
        GIR_EraseRootFromParent_Done,
      // Label 2956: @149654
      GIM_Try, /*On fail goto*//*Label 2957*/ GIMT_Encode4(149687), // Rule ID 13225 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i8] } 647:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i8v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13225,
        GIR_EraseRootFromParent_Done,
      // Label 2957: @149687
      GIM_Try, /*On fail goto*//*Label 2958*/ GIMT_Encode4(149720), // Rule ID 13227 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[i8] } 647:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv16i8v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13227,
        GIR_EraseRootFromParent_Done,
      // Label 2958: @149720
      GIM_Try, /*On fail goto*//*Label 2959*/ GIMT_Encode4(149753), // Rule ID 13229 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i16] } 647:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i16v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13229,
        GIR_EraseRootFromParent_Done,
      // Label 2959: @149753
      GIM_Try, /*On fail goto*//*Label 2960*/ GIMT_Encode4(149786), // Rule ID 13231 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[i16] } 647:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i16v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13231,
        GIR_EraseRootFromParent_Done,
      // Label 2960: @149786
      GIM_Try, /*On fail goto*//*Label 2961*/ GIMT_Encode4(149901), // Rule ID 13232 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 647:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i32v),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 13232,
        GIR_EraseRootFromParent_Done,
      // Label 2961: @149901
      GIM_Try, /*On fail goto*//*Label 2962*/ GIMT_Encode4(150020), // Rule ID 13233 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 647:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv2i32),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 13233,
        GIR_EraseRootFromParent_Done,
      // Label 2962: @150020
      GIM_Try, /*On fail goto*//*Label 2963*/ GIMT_Encode4(150053), // Rule ID 13235 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i8] } 650:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i8v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13235,
        GIR_EraseRootFromParent_Done,
      // Label 2963: @150053
      GIM_Try, /*On fail goto*//*Label 2964*/ GIMT_Encode4(150086), // Rule ID 13237 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[i8] } 650:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv16i8v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13237,
        GIR_EraseRootFromParent_Done,
      // Label 2964: @150086
      GIM_Try, /*On fail goto*//*Label 2965*/ GIMT_Encode4(150119), // Rule ID 13239 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i16] } 650:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i16v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13239,
        GIR_EraseRootFromParent_Done,
      // Label 2965: @150119
      GIM_Try, /*On fail goto*//*Label 2966*/ GIMT_Encode4(150152), // Rule ID 13241 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[i16] } 650:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i16v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13241,
        GIR_EraseRootFromParent_Done,
      // Label 2966: @150152
      GIM_Try, /*On fail goto*//*Label 2967*/ GIMT_Encode4(150267), // Rule ID 13242 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 650:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i32v),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 13242,
        GIR_EraseRootFromParent_Done,
      // Label 2967: @150267
      GIM_Try, /*On fail goto*//*Label 2968*/ GIMT_Encode4(150386), // Rule ID 13243 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 650:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINPv2i32),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 13243,
        GIR_EraseRootFromParent_Done,
      // Label 2968: @150386
      GIM_Try, /*On fail goto*//*Label 2969*/ GIMT_Encode4(150419), // Rule ID 13245 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i8] } 708:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (UMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i8v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13245,
        GIR_EraseRootFromParent_Done,
      // Label 2969: @150419
      GIM_Try, /*On fail goto*//*Label 2970*/ GIMT_Encode4(150452), // Rule ID 13247 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[i8] } 708:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (UMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv16i8v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13247,
        GIR_EraseRootFromParent_Done,
      // Label 2970: @150452
      GIM_Try, /*On fail goto*//*Label 2971*/ GIMT_Encode4(150485), // Rule ID 13249 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i16] } 708:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (UMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i16v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13249,
        GIR_EraseRootFromParent_Done,
      // Label 2971: @150485
      GIM_Try, /*On fail goto*//*Label 2972*/ GIMT_Encode4(150518), // Rule ID 13251 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[i16] } 708:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (UMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i16v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13251,
        GIR_EraseRootFromParent_Done,
      // Label 2972: @150518
      GIM_Try, /*On fail goto*//*Label 2973*/ GIMT_Encode4(150633), // Rule ID 13252 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 708:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i32v),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 13252,
        GIR_EraseRootFromParent_Done,
      // Label 2973: @150633
      GIM_Try, /*On fail goto*//*Label 2974*/ GIMT_Encode4(150752), // Rule ID 13253 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 708:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv2i32),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 13253,
        GIR_EraseRootFromParent_Done,
      // Label 2974: @150752
      GIM_Try, /*On fail goto*//*Label 2975*/ GIMT_Encode4(150785), // Rule ID 13255 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i8] } 711:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (UMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i8v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13255,
        GIR_EraseRootFromParent_Done,
      // Label 2975: @150785
      GIM_Try, /*On fail goto*//*Label 2976*/ GIMT_Encode4(150818), // Rule ID 13257 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[i8] } 711:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (UMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv16i8v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13257,
        GIR_EraseRootFromParent_Done,
      // Label 2976: @150818
      GIM_Try, /*On fail goto*//*Label 2977*/ GIMT_Encode4(150851), // Rule ID 13259 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i16] } 711:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (UMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i16v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13259,
        GIR_EraseRootFromParent_Done,
      // Label 2977: @150851
      GIM_Try, /*On fail goto*//*Label 2978*/ GIMT_Encode4(150884), // Rule ID 13261 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[i16] } 711:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (UMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i16v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13261,
        GIR_EraseRootFromParent_Done,
      // Label 2978: @150884
      GIM_Try, /*On fail goto*//*Label 2979*/ GIMT_Encode4(150999), // Rule ID 13262 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 711:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i32v),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 13262,
        GIR_EraseRootFromParent_Done,
      // Label 2979: @150999
      GIM_Try, /*On fail goto*//*Label 2980*/ GIMT_Encode4(151118), // Rule ID 13263 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 711:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMINPv2i32),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 13263,
        GIR_EraseRootFromParent_Done,
      // Label 2980: @151118
      GIM_Try, /*On fail goto*//*Label 2981*/ GIMT_Encode4(151150), // Rule ID 2370 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rev_b16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1549:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn)  =>  (REV_PP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV_PP_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2370,
        GIR_EraseRootFromParent_Done,
      // Label 2981: @151150
      GIM_Try, /*On fail goto*//*Label 2982*/ GIMT_Encode4(151182), // Rule ID 2371 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rev_b32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1550:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn)  =>  (REV_PP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV_PP_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2371,
        GIR_EraseRootFromParent_Done,
      // Label 2982: @151182
      GIM_Try, /*On fail goto*//*Label 2983*/ GIMT_Encode4(151214), // Rule ID 2372 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rev_b64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1551:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn)  =>  (REV_PP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV_PP_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2372,
        GIR_EraseRootFromParent_Done,
      // Label 2983: @151214
      GIM_Try, /*On fail goto*//*Label 2984*/ GIMT_Encode4(151246), // Rule ID 3071 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1731:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (SQXTNB_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNB_ZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3071,
        GIR_EraseRootFromParent_Done,
      // Label 2984: @151246
      GIM_Try, /*On fail goto*//*Label 2985*/ GIMT_Encode4(151278), // Rule ID 3072 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1731:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (SQXTNB_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNB_ZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3072,
        GIR_EraseRootFromParent_Done,
      // Label 2985: @151278
      GIM_Try, /*On fail goto*//*Label 2986*/ GIMT_Encode4(151310), // Rule ID 3073 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1731:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (SQXTNB_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNB_ZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3073,
        GIR_EraseRootFromParent_Done,
      // Label 2986: @151310
      GIM_Try, /*On fail goto*//*Label 2987*/ GIMT_Encode4(151342), // Rule ID 3321 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpklo),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1541:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (PUNPKLO_PP:{ *:[nxv8i1] } ?:{ *:[nxv16i1] }:$Op1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3321,
        GIR_EraseRootFromParent_Done,
      // Label 2987: @151342
      GIM_Try, /*On fail goto*//*Label 2988*/ GIMT_Encode4(151374), // Rule ID 3322 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpklo),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1541:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (PUNPKLO_PP:{ *:[nxv4i1] } ?:{ *:[nxv8i1] }:$Op1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3322,
        GIR_EraseRootFromParent_Done,
      // Label 2988: @151374
      GIM_Try, /*On fail goto*//*Label 2989*/ GIMT_Encode4(151406), // Rule ID 3323 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpklo),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 1541:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (PUNPKLO_PP:{ *:[nxv2i1] } ?:{ *:[nxv4i1] }:$Op1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3323,
        GIR_EraseRootFromParent_Done,
      // Label 2989: @151406
      GIM_Try, /*On fail goto*//*Label 2990*/ GIMT_Encode4(151438), // Rule ID 3406 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVEorSME2p2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fexpa_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1302:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (FEXPA_ZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i16] }:$Op1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FEXPA_ZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3406,
        GIR_EraseRootFromParent_Done,
      // Label 2990: @151438
      GIM_Try, /*On fail goto*//*Label 2991*/ GIMT_Encode4(151470), // Rule ID 3407 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVEorSME2p2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fexpa_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1302:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (FEXPA_ZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i32] }:$Op1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FEXPA_ZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3407,
        GIR_EraseRootFromParent_Done,
      // Label 2991: @151470
      GIM_Try, /*On fail goto*//*Label 2992*/ GIMT_Encode4(151502), // Rule ID 3408 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVEorSME2p2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fexpa_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1302:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (FEXPA_ZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i64] }:$Op1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FEXPA_ZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3408,
        GIR_EraseRootFromParent_Done,
      // Label 2992: @151502
      GIM_Try, /*On fail goto*//*Label 2993*/ GIMT_Encode4(151534), // Rule ID 3434 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2orSSVE_AES_HasSVEAES),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aesmc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1141:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (AESMC_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESMC_ZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3434,
        GIR_EraseRootFromParent_Done,
      // Label 2993: @151534
      GIM_Try, /*On fail goto*//*Label 2994*/ GIMT_Encode4(151566), // Rule ID 4660 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 587:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } ?:{ *:[f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4660,
        GIR_EraseRootFromParent_Done,
      // Label 2994: @151566
      GIM_Try, /*On fail goto*//*Label 2995*/ GIMT_Encode4(151598), // Rule ID 4661 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 587:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } ?:{ *:[f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4661,
        GIR_EraseRootFromParent_Done,
      // Label 2995: @151598
      GIM_Try, /*On fail goto*//*Label 2996*/ GIMT_Encode4(151627), // Rule ID 4662 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 587:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } ?:{ *:[f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4662,
        GIR_EraseRootFromParent_Done,
      // Label 2996: @151627
      GIM_Try, /*On fail goto*//*Label 2997*/ GIMT_Encode4(151656), // Rule ID 4663 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 587:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } ?:{ *:[f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4663,
        GIR_EraseRootFromParent_Done,
      // Label 2997: @151656
      GIM_Try, /*On fail goto*//*Label 2998*/ GIMT_Encode4(151685), // Rule ID 4664 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 587:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } ?:{ *:[f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4664,
        GIR_EraseRootFromParent_Done,
      // Label 2998: @151685
      GIM_Try, /*On fail goto*//*Label 2999*/ GIMT_Encode4(151714), // Rule ID 4665 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 587:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } ?:{ *:[f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4665,
        GIR_EraseRootFromParent_Done,
      // Label 2999: @151714
      GIM_Try, /*On fail goto*//*Label 3000*/ GIMT_Encode4(151746), // Rule ID 4672 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 588:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUWHr:{ *:[i32] } ?:{ *:[f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWHr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4672,
        GIR_EraseRootFromParent_Done,
      // Label 3000: @151746
      GIM_Try, /*On fail goto*//*Label 3001*/ GIMT_Encode4(151778), // Rule ID 4673 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 588:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUXHr:{ *:[i64] } ?:{ *:[f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXHr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4673,
        GIR_EraseRootFromParent_Done,
      // Label 3001: @151778
      GIM_Try, /*On fail goto*//*Label 3002*/ GIMT_Encode4(151807), // Rule ID 4674 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 588:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUWSr:{ *:[i32] } ?:{ *:[f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4674,
        GIR_EraseRootFromParent_Done,
      // Label 3002: @151807
      GIM_Try, /*On fail goto*//*Label 3003*/ GIMT_Encode4(151836), // Rule ID 4675 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 588:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUXSr:{ *:[i64] } ?:{ *:[f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4675,
        GIR_EraseRootFromParent_Done,
      // Label 3003: @151836
      GIM_Try, /*On fail goto*//*Label 3004*/ GIMT_Encode4(151865), // Rule ID 4676 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 588:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUWDr:{ *:[i32] } ?:{ *:[f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4676,
        GIR_EraseRootFromParent_Done,
      // Label 3004: @151865
      GIM_Try, /*On fail goto*//*Label 3005*/ GIMT_Encode4(151894), // Rule ID 4677 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 588:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUXDr:{ *:[i64] } ?:{ *:[f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4677,
        GIR_EraseRootFromParent_Done,
      // Label 3005: @151894
      GIM_Try, /*On fail goto*//*Label 3006*/ GIMT_Encode4(151923), // Rule ID 4972 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 587:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZSv4f16:{ *:[v4i16] } ?:{ *:[v4f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4972,
        GIR_EraseRootFromParent_Done,
      // Label 3006: @151923
      GIM_Try, /*On fail goto*//*Label 3007*/ GIMT_Encode4(151952), // Rule ID 4973 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 587:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZSv8f16:{ *:[v8i16] } ?:{ *:[v8f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4973,
        GIR_EraseRootFromParent_Done,
      // Label 3007: @151952
      GIM_Try, /*On fail goto*//*Label 3008*/ GIMT_Encode4(151981), // Rule ID 4974 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 587:{ *:[iPTR] }, v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZSv2f32:{ *:[v2i32] } ?:{ *:[v2f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4974,
        GIR_EraseRootFromParent_Done,
      // Label 3008: @151981
      GIM_Try, /*On fail goto*//*Label 3009*/ GIMT_Encode4(152010), // Rule ID 4975 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 587:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZSv4f32:{ *:[v4i32] } ?:{ *:[v4f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4975,
        GIR_EraseRootFromParent_Done,
      // Label 3009: @152010
      GIM_Try, /*On fail goto*//*Label 3010*/ GIMT_Encode4(152039), // Rule ID 4976 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 587:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZSv2f64:{ *:[v2i64] } ?:{ *:[v2f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4976,
        GIR_EraseRootFromParent_Done,
      // Label 3010: @152039
      GIM_Try, /*On fail goto*//*Label 3011*/ GIMT_Encode4(152068), // Rule ID 4977 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 588:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZUv4f16:{ *:[v4i16] } ?:{ *:[v4f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4977,
        GIR_EraseRootFromParent_Done,
      // Label 3011: @152068
      GIM_Try, /*On fail goto*//*Label 3012*/ GIMT_Encode4(152097), // Rule ID 4978 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 588:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZUv8f16:{ *:[v8i16] } ?:{ *:[v8f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4978,
        GIR_EraseRootFromParent_Done,
      // Label 3012: @152097
      GIM_Try, /*On fail goto*//*Label 3013*/ GIMT_Encode4(152126), // Rule ID 4979 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 588:{ *:[iPTR] }, v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZUv2f32:{ *:[v2i32] } ?:{ *:[v2f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4979,
        GIR_EraseRootFromParent_Done,
      // Label 3013: @152126
      GIM_Try, /*On fail goto*//*Label 3014*/ GIMT_Encode4(152155), // Rule ID 4980 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 588:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZUv4f32:{ *:[v4i32] } ?:{ *:[v4f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4980,
        GIR_EraseRootFromParent_Done,
      // Label 3014: @152155
      GIM_Try, /*On fail goto*//*Label 3015*/ GIMT_Encode4(152184), // Rule ID 4981 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 588:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZUv2f64:{ *:[v2i64] } ?:{ *:[v2f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4981,
        GIR_EraseRootFromParent_Done,
      // Label 3015: @152184
      GIM_Try, /*On fail goto*//*Label 3016*/ GIMT_Encode4(152216), // Rule ID 8559 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpkhi),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1540:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (PUNPKHI_PP:{ *:[nxv8i1] } ?:{ *:[nxv16i1] }:$Op1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8559,
        GIR_EraseRootFromParent_Done,
      // Label 3016: @152216
      GIM_Try, /*On fail goto*//*Label 3017*/ GIMT_Encode4(152248), // Rule ID 8560 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpkhi),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1540:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (PUNPKHI_PP:{ *:[nxv4i1] } ?:{ *:[nxv8i1] }:$Op1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8560,
        GIR_EraseRootFromParent_Done,
      // Label 3017: @152248
      GIM_Try, /*On fail goto*//*Label 3018*/ GIMT_Encode4(152280), // Rule ID 8561 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpkhi),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 1540:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (PUNPKHI_PP:{ *:[nxv2i1] } ?:{ *:[nxv4i1] }:$Op1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8561,
        GIR_EraseRootFromParent_Done,
      // Label 3018: @152280
      GIM_Try, /*On fail goto*//*Label 3019*/ GIMT_Encode4(152312), // Rule ID 12089 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1924:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (UQXTNB_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNB_ZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12089,
        GIR_EraseRootFromParent_Done,
      // Label 3019: @152312
      GIM_Try, /*On fail goto*//*Label 3020*/ GIMT_Encode4(152344), // Rule ID 12090 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1924:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (UQXTNB_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNB_ZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12090,
        GIR_EraseRootFromParent_Done,
      // Label 3020: @152344
      GIM_Try, /*On fail goto*//*Label 3021*/ GIMT_Encode4(152376), // Rule ID 12091 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1924:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (UQXTNB_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNB_ZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12091,
        GIR_EraseRootFromParent_Done,
      // Label 3021: @152376
      GIM_Try, /*On fail goto*//*Label 3022*/ GIMT_Encode4(152408), // Rule ID 12092 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1733:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (SQXTUNB_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNB_ZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12092,
        GIR_EraseRootFromParent_Done,
      // Label 3022: @152408
      GIM_Try, /*On fail goto*//*Label 3023*/ GIMT_Encode4(152440), // Rule ID 12093 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1733:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (SQXTUNB_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNB_ZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12093,
        GIR_EraseRootFromParent_Done,
      // Label 3023: @152440
      GIM_Try, /*On fail goto*//*Label 3024*/ GIMT_Encode4(152472), // Rule ID 12094 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1733:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (SQXTUNB_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNB_ZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12094,
        GIR_EraseRootFromParent_Done,
      // Label 3024: @152472
      GIM_Try, /*On fail goto*//*Label 3025*/ GIMT_Encode4(152504), // Rule ID 12252 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2orSSVE_AES_HasSVEAES),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aesimc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1140:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (AESIMC_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESIMC_ZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12252,
        GIR_EraseRootFromParent_Done,
      // Label 3025: @152504
      GIM_Reject,
    // Label 2704: @152505
    GIM_Try, /*On fail goto*//*Label 3026*/ GIMT_Encode4(199310),
      GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
      GIM_Try, /*On fail goto*//*Label 3027*/ GIMT_Encode4(152697), // Rule ID 2527 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[5] Operand 1
        // No operand predicates
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/5,
        // (intrinsic_wo_chain:{ *:[i32] } 654:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 658:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), 0:{ *:[i64] }))  =>  (SQDMLALv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/5, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2527,
        GIR_EraseRootFromParent_Done,
      // Label 3027: @152697
      GIM_Try, /*On fail goto*//*Label 3028*/ GIMT_Encode4(152881), // Rule ID 6305 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[5] Operand 1
        // No operand predicates
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/5,
        // (intrinsic_wo_chain:{ *:[i32] } 673:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 658:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), 0:{ *:[i64] }))  =>  (SQDMLSLv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/5, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6305,
        GIR_EraseRootFromParent_Done,
      // Label 3028: @152881
      GIM_Try, /*On fail goto*//*Label 3029*/ GIMT_Encode4(153021), // Rule ID 2046 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (intrinsic_wo_chain:{ *:[v4i32] } 654:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 658:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SQDMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2046,
        GIR_EraseRootFromParent_Done,
      // Label 3029: @153021
      GIM_Try, /*On fail goto*//*Label 3030*/ GIMT_Encode4(153161), // Rule ID 2053 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (intrinsic_wo_chain:{ *:[v4i32] } 673:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 658:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SQDMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2053,
        GIR_EraseRootFromParent_Done,
      // Label 3030: @153161
      GIM_Try, /*On fail goto*//*Label 3031*/ GIMT_Encode4(153301), // Rule ID 2049 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (intrinsic_wo_chain:{ *:[v2i64] } 654:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 658:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SQDMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2049,
        GIR_EraseRootFromParent_Done,
      // Label 3031: @153301
      GIM_Try, /*On fail goto*//*Label 3032*/ GIMT_Encode4(153441), // Rule ID 2056 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (intrinsic_wo_chain:{ *:[v2i64] } 673:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 658:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SQDMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2056,
        GIR_EraseRootFromParent_Done,
      // Label 3032: @153441
      GIM_Try, /*On fail goto*//*Label 3033*/ GIMT_Encode4(153578), // Rule ID 2044 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (intrinsic_wo_chain:{ *:[v4i32] } 654:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 658:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2044,
        GIR_EraseRootFromParent_Done,
      // Label 3033: @153578
      GIM_Try, /*On fail goto*//*Label 3034*/ GIMT_Encode4(153715), // Rule ID 2051 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (intrinsic_wo_chain:{ *:[v4i32] } 673:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 658:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2051,
        GIR_EraseRootFromParent_Done,
      // Label 3034: @153715
      GIM_Try, /*On fail goto*//*Label 3035*/ GIMT_Encode4(153852), // Rule ID 2047 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (intrinsic_wo_chain:{ *:[v2i64] } 654:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 658:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2047,
        GIR_EraseRootFromParent_Done,
      // Label 3035: @153852
      GIM_Try, /*On fail goto*//*Label 3036*/ GIMT_Encode4(153989), // Rule ID 2054 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[4] Operand 1
        // No operand predicates
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (intrinsic_wo_chain:{ *:[v2i64] } 673:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 658:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2054,
        GIR_EraseRootFromParent_Done,
      // Label 3036: @153989
      GIM_Try, /*On fail goto*//*Label 3037*/ GIMT_Encode4(154150), // Rule ID 2528 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[4] Operand 1
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (intrinsic_wo_chain:{ *:[i32] } 654:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 658:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), 0:{ *:[i64] }))  =>  (SQDMLALv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2528,
        GIR_EraseRootFromParent_Done,
      // Label 3037: @154150
      GIM_Try, /*On fail goto*//*Label 3038*/ GIMT_Encode4(154311), // Rule ID 6306 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[4] Operand 1
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (intrinsic_wo_chain:{ *:[i32] } 673:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 658:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), 0:{ *:[i64] }))  =>  (SQDMLSLv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6306,
        GIR_EraseRootFromParent_Done,
      // Label 3038: @154311
      GIM_Try, /*On fail goto*//*Label 3039*/ GIMT_Encode4(154421), // Rule ID 2074 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (intrinsic_wo_chain:{ *:[v4i32] } 658:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }))  =>  (SQDMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2074,
        GIR_EraseRootFromParent_Done,
      // Label 3039: @154421
      GIM_Try, /*On fail goto*//*Label 3040*/ GIMT_Encode4(154531), // Rule ID 2077 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (intrinsic_wo_chain:{ *:[v2i64] } 658:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }))  =>  (SQDMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2077,
        GIR_EraseRootFromParent_Done,
      // Label 3040: @154531
      GIM_Try, /*On fail goto*//*Label 3041*/ GIMT_Encode4(154620), // Rule ID 1732 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (intrinsic_wo_chain:{ *:[v4i32] } 654:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 658:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SQDMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1732,
        GIR_EraseRootFromParent_Done,
      // Label 3041: @154620
      GIM_Try, /*On fail goto*//*Label 3042*/ GIMT_Encode4(154709), // Rule ID 1734 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (intrinsic_wo_chain:{ *:[v2i64] } 654:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 658:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SQDMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1734,
        GIR_EraseRootFromParent_Done,
      // Label 3042: @154709
      GIM_Try, /*On fail goto*//*Label 3043*/ GIMT_Encode4(154798), // Rule ID 1736 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (intrinsic_wo_chain:{ *:[v4i32] } 673:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 658:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SQDMLSLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1736,
        GIR_EraseRootFromParent_Done,
      // Label 3043: @154798
      GIM_Try, /*On fail goto*//*Label 3044*/ GIMT_Encode4(154887), // Rule ID 1738 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (intrinsic_wo_chain:{ *:[v2i64] } 673:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 658:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SQDMLSLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1738,
        GIR_EraseRootFromParent_Done,
      // Label 3044: @154887
      GIM_Try, /*On fail goto*//*Label 3045*/ GIMT_Encode4(155009), // Rule ID 7076 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        // MIs[2] Rn
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v2i32] } 562:{ *:[iPTR] }, (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (ADDPv4i32:{ *:[f128] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 7076,
        GIR_EraseRootFromParent_Done,
      // Label 3045: @155009
      GIM_Try, /*On fail goto*//*Label 3046*/ GIMT_Encode4(155131), // Rule ID 7078 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        // MIs[2] Rn
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v4i16] } 562:{ *:[iPTR] }, (extract_subvector:{ *:[v4i16] } FPR128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } FPR128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (ADDPv8i16:{ *:[f128] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rn), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 7078,
        GIR_EraseRootFromParent_Done,
      // Label 3046: @155131
      GIM_Try, /*On fail goto*//*Label 3047*/ GIMT_Encode4(155253), // Rule ID 7080 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        // MIs[2] Rn
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v8i8] } 562:{ *:[iPTR] }, (extract_subvector:{ *:[v8i8] } FPR128:{ *:[v16i8] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v8i8] } FPR128:{ *:[v16i8] }:$Rn, 8:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (ADDPv16i8:{ *:[f128] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rn), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 7080,
        GIR_EraseRootFromParent_Done,
      // Label 3047: @155253
      GIM_Try, /*On fail goto*//*Label 3048*/ GIMT_Encode4(155375), // Rule ID 7082 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        // MIs[2] Rn
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v2f32] } 574:{ *:[iPTR] }, (extract_subvector:{ *:[v2f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2f32] } FPR128:{ *:[v4f32] }:$Rn, 2:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (FADDPv4f32:{ *:[f128] } ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rn), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 7082,
        GIR_EraseRootFromParent_Done,
      // Label 3048: @155375
      GIM_Try, /*On fail goto*//*Label 3049*/ GIMT_Encode4(155497), // Rule ID 7084 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        // MIs[2] Rn
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v4f16] } 574:{ *:[iPTR] }, (extract_subvector:{ *:[v4f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4f16] } FPR128:{ *:[v8f16] }:$Rn, 4:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (FADDPv8f16:{ *:[f128] } ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rn), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 7084,
        GIR_EraseRootFromParent_Done,
      // Label 3049: @155497
      GIM_Try, /*On fail goto*//*Label 3050*/ GIMT_Encode4(155680), // Rule ID 2526 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[i32] } 654:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 658:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (SQDMLALv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v4i16] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/3, // Rm
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2526,
        GIR_EraseRootFromParent_Done,
      // Label 3050: @155680
      GIM_Try, /*On fail goto*//*Label 3051*/ GIMT_Encode4(155863), // Rule ID 6304 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[i32] } 673:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 658:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (SQDMLSLv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v4i16] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/3, // Rm
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6304,
        GIR_EraseRootFromParent_Done,
      // Label 3051: @155863
      GIM_Try, /*On fail goto*//*Label 3052*/ GIMT_Encode4(155967), // Rule ID 13514 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (intrinsic_wo_chain:{ *:[v4f16] } 605:{ *:[iPTR] }, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4f16] }:$Rn)  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13514,
        GIR_EraseRootFromParent_Done,
      // Label 3052: @155967
      GIM_Try, /*On fail goto*//*Label 3053*/ GIMT_Encode4(156071), // Rule ID 13517 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (intrinsic_wo_chain:{ *:[v2f32] } 605:{ *:[iPTR] }, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2f32] }:$Rn)  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13517,
        GIR_EraseRootFromParent_Done,
      // Label 3053: @156071
      GIM_Try, /*On fail goto*//*Label 3054*/ GIMT_Encode4(156202), // Rule ID 2483 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (intrinsic_wo_chain:{ *:[f16] } 605:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2483,
        GIR_EraseRootFromParent_Done,
      // Label 3054: @156202
      GIM_Try, /*On fail goto*//*Label 3055*/ GIMT_Encode4(156333), // Rule ID 2484 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (intrinsic_wo_chain:{ *:[f32] } 605:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2484,
        GIR_EraseRootFromParent_Done,
      // Label 3055: @156333
      GIM_Try, /*On fail goto*//*Label 3056*/ GIMT_Encode4(156464), // Rule ID 2485 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (intrinsic_wo_chain:{ *:[f64] } 605:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULXv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2485,
        GIR_EraseRootFromParent_Done,
      // Label 3056: @156464
      GIM_Try, /*On fail goto*//*Label 3057*/ GIMT_Encode4(156595), // Rule ID 13700 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (intrinsic_wo_chain:{ *:[f16] } 605:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FMULXv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13700,
        GIR_EraseRootFromParent_Done,
      // Label 3057: @156595
      GIM_Try, /*On fail goto*//*Label 3058*/ GIMT_Encode4(156726), // Rule ID 13701 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (intrinsic_wo_chain:{ *:[f32] } 605:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FMULXv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13701,
        GIR_EraseRootFromParent_Done,
      // Label 3058: @156726
      GIM_Try, /*On fail goto*//*Label 3059*/ GIMT_Encode4(156857), // Rule ID 13702 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (intrinsic_wo_chain:{ *:[f64] } 605:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FMULXv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13702,
        GIR_EraseRootFromParent_Done,
      // Label 3059: @156857
      GIM_Try, /*On fail goto*//*Label 3060*/ GIMT_Encode4(156971), // Rule ID 2045 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (intrinsic_wo_chain:{ *:[v4i32] } 654:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 658:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SQDMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2045,
        GIR_EraseRootFromParent_Done,
      // Label 3060: @156971
      GIM_Try, /*On fail goto*//*Label 3061*/ GIMT_Encode4(157085), // Rule ID 2052 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (intrinsic_wo_chain:{ *:[v4i32] } 673:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 658:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SQDMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2052,
        GIR_EraseRootFromParent_Done,
      // Label 3061: @157085
      GIM_Try, /*On fail goto*//*Label 3062*/ GIMT_Encode4(157199), // Rule ID 2048 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (intrinsic_wo_chain:{ *:[v2i64] } 654:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 658:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2048,
        GIR_EraseRootFromParent_Done,
      // Label 3062: @157199
      GIM_Try, /*On fail goto*//*Label 3063*/ GIMT_Encode4(157313), // Rule ID 2055 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (intrinsic_wo_chain:{ *:[v2i64] } 673:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 658:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2055,
        GIR_EraseRootFromParent_Done,
      // Label 3063: @157313
      GIM_Try, /*On fail goto*//*Label 3064*/ GIMT_Encode4(157427), // Rule ID 2050 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (intrinsic_wo_chain:{ *:[i64] } 654:{ *:[iPTR] }, FPR64Op:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 659:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLALv1i64_indexed:{ *:[i64] } FPR64Op:{ *:[i64] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2050,
        GIR_EraseRootFromParent_Done,
      // Label 3064: @157427
      GIM_Try, /*On fail goto*//*Label 3065*/ GIMT_Encode4(157541), // Rule ID 2057 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (intrinsic_wo_chain:{ *:[i64] } 673:{ *:[iPTR] }, FPR64Op:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 659:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLSLv1i64_indexed:{ *:[i64] } FPR64Op:{ *:[i64] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2057,
        GIR_EraseRootFromParent_Done,
      // Label 3065: @157541
      GIM_Try, /*On fail goto*//*Label 3066*/ GIMT_Encode4(157645), // Rule ID 1976 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (intrinsic_wo_chain:{ *:[v4f16] } 605:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1976,
        GIR_EraseRootFromParent_Done,
      // Label 3066: @157645
      GIM_Try, /*On fail goto*//*Label 3067*/ GIMT_Encode4(157749), // Rule ID 2006 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (intrinsic_wo_chain:{ *:[v4i16] } 655:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2006,
        GIR_EraseRootFromParent_Done,
      // Label 3067: @157749
      GIM_Try, /*On fail goto*//*Label 3068*/ GIMT_Encode4(157853), // Rule ID 2013 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (intrinsic_wo_chain:{ *:[v4i16] } 663:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2013,
        GIR_EraseRootFromParent_Done,
      // Label 3068: @157853
      GIM_Try, /*On fail goto*//*Label 3069*/ GIMT_Encode4(157957), // Rule ID 2072 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (intrinsic_wo_chain:{ *:[v4i32] } 658:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2072,
        GIR_EraseRootFromParent_Done,
      // Label 3069: @157957
      GIM_Try, /*On fail goto*//*Label 3070*/ GIMT_Encode4(158061), // Rule ID 1979 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (intrinsic_wo_chain:{ *:[v2f32] } 605:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1979,
        GIR_EraseRootFromParent_Done,
      // Label 3070: @158061
      GIM_Try, /*On fail goto*//*Label 3071*/ GIMT_Encode4(158165), // Rule ID 2009 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (intrinsic_wo_chain:{ *:[v2i32] } 655:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2009,
        GIR_EraseRootFromParent_Done,
      // Label 3071: @158165
      GIM_Try, /*On fail goto*//*Label 3072*/ GIMT_Encode4(158269), // Rule ID 2016 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (intrinsic_wo_chain:{ *:[v2i32] } 663:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2016,
        GIR_EraseRootFromParent_Done,
      // Label 3072: @158269
      GIM_Try, /*On fail goto*//*Label 3073*/ GIMT_Encode4(158373), // Rule ID 2075 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (intrinsic_wo_chain:{ *:[v2i64] } 658:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2075,
        GIR_EraseRootFromParent_Done,
      // Label 3073: @158373
      GIM_Try, /*On fail goto*//*Label 3074*/ GIMT_Encode4(158430), // Rule ID 1740 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (intrinsic_wo_chain:{ *:[v4i32] } 658:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (SQDMULLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1740,
        GIR_EraseRootFromParent_Done,
      // Label 3074: @158430
      GIM_Try, /*On fail goto*//*Label 3075*/ GIMT_Encode4(158487), // Rule ID 1742 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (intrinsic_wo_chain:{ *:[v2i64] } 658:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (SQDMULLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1742,
        GIR_EraseRootFromParent_Done,
      // Label 3075: @158487
      GIM_Try, /*On fail goto*//*Label 3076*/ GIMT_Encode4(158597), // Rule ID 6323 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[f16] } 741:{ *:[iPTR] }, (and:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, 65535:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (UCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFh),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6323,
        GIR_EraseRootFromParent_Done,
      // Label 3076: @158597
      GIM_Try, /*On fail goto*//*Label 3077*/ GIMT_Encode4(158694), // Rule ID 13968 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[f16] } 605:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rn)  =>  (FMULX16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13968,
        GIR_EraseRootFromParent_Done,
      // Label 3077: @158694
      GIM_Try, /*On fail goto*//*Label 3078*/ GIMT_Encode4(158791), // Rule ID 13969 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[f32] } 605:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rn)  =>  (FMULX32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13969,
        GIR_EraseRootFromParent_Done,
      // Label 3078: @158791
      GIM_Try, /*On fail goto*//*Label 3079*/ GIMT_Encode4(158888), // Rule ID 13970 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[f64] } 605:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rn)  =>  (FMULX64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13970,
        GIR_EraseRootFromParent_Done,
      // Label 3079: @158888
      GIM_Try, /*On fail goto*//*Label 3080*/ GIMT_Encode4(158971), // Rule ID 1731 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[v4i32] } 654:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 658:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SQDMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1731,
        GIR_EraseRootFromParent_Done,
      // Label 3080: @158971
      GIM_Try, /*On fail goto*//*Label 3081*/ GIMT_Encode4(159054), // Rule ID 1733 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[v2i64] } 654:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 658:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SQDMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1733,
        GIR_EraseRootFromParent_Done,
      // Label 3081: @159054
      GIM_Try, /*On fail goto*//*Label 3082*/ GIMT_Encode4(159137), // Rule ID 1735 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[v4i32] } 673:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 658:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SQDMLSLv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1735,
        GIR_EraseRootFromParent_Done,
      // Label 3082: @159137
      GIM_Try, /*On fail goto*//*Label 3083*/ GIMT_Encode4(159220), // Rule ID 1737 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[v2i64] } 673:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 658:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SQDMLSLv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1737,
        GIR_EraseRootFromParent_Done,
      // Label 3083: @159220
      GIM_Try, /*On fail goto*//*Label 3084*/ GIMT_Encode4(159300), // Rule ID 5273 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[i64] } 654:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 659:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm))  =>  (SQDMLALi32:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALi32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5273,
        GIR_EraseRootFromParent_Done,
      // Label 3084: @159300
      GIM_Try, /*On fail goto*//*Label 3085*/ GIMT_Encode4(159380), // Rule ID 5274 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[i64] } 673:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 659:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm))  =>  (SQDMLSLi32:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLi32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5274,
        GIR_EraseRootFromParent_Done,
      // Label 3085: @159380
      GIM_Try, /*On fail goto*//*Label 3086*/ GIMT_Encode4(159477), // Rule ID 5270 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[f16] } 605:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }))  =>  (FMULX16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5270,
        GIR_EraseRootFromParent_Done,
      // Label 3086: @159477
      GIM_Try, /*On fail goto*//*Label 3087*/ GIMT_Encode4(159574), // Rule ID 5271 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[f32] } 605:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }))  =>  (FMULX32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5271,
        GIR_EraseRootFromParent_Done,
      // Label 3087: @159574
      GIM_Try, /*On fail goto*//*Label 3088*/ GIMT_Encode4(159671), // Rule ID 5272 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[f64] } 605:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }))  =>  (FMULX64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5272,
        GIR_EraseRootFromParent_Done,
      // Label 3088: @159671
      GIM_Try, /*On fail goto*//*Label 3089*/ GIMT_Encode4(159752), // Rule ID 13515 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v4f16] } 605:{ *:[iPTR] }, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn)  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13515,
        GIR_EraseRootFromParent_Done,
      // Label 3089: @159752
      GIM_Try, /*On fail goto*//*Label 3090*/ GIMT_Encode4(159833), // Rule ID 13516 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v8f16] } 605:{ *:[iPTR] }, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn)  =>  (FMULXv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13516,
        GIR_EraseRootFromParent_Done,
      // Label 3090: @159833
      GIM_Try, /*On fail goto*//*Label 3091*/ GIMT_Encode4(159914), // Rule ID 13518 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v2f32] } 605:{ *:[iPTR] }, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn)  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13518,
        GIR_EraseRootFromParent_Done,
      // Label 3091: @159914
      GIM_Try, /*On fail goto*//*Label 3092*/ GIMT_Encode4(159995), // Rule ID 13519 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v4f32] } 605:{ *:[iPTR] }, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn)  =>  (FMULXv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13519,
        GIR_EraseRootFromParent_Done,
      // Label 3092: @159995
      GIM_Try, /*On fail goto*//*Label 3093*/ GIMT_Encode4(160076), // Rule ID 13520 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v2f64] } 605:{ *:[iPTR] }, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn)  =>  (FMULXv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13520,
        GIR_EraseRootFromParent_Done,
      // Label 3093: @160076
      GIM_Try, /*On fail goto*//*Label 3094*/ GIMT_Encode4(160157), // Rule ID 13521 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[f16] } 605:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16Op:{ *:[f16] }:$Rn)  =>  (FMULXv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13521,
        GIR_EraseRootFromParent_Done,
      // Label 3094: @160157
      GIM_Try, /*On fail goto*//*Label 3095*/ GIMT_Encode4(160238), // Rule ID 13522 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[f32] } 605:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32Op:{ *:[f32] }:$Rn)  =>  (FMULXv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13522,
        GIR_EraseRootFromParent_Done,
      // Label 3095: @160238
      GIM_Try, /*On fail goto*//*Label 3096*/ GIMT_Encode4(160319), // Rule ID 13523 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[f64] } 605:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64Op:{ *:[f64] }:$Rn)  =>  (FMULXv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13523,
        GIR_EraseRootFromParent_Done,
      // Label 3096: @160319
      GIM_Try, /*On fail goto*//*Label 3097*/ GIMT_Encode4(160425), // Rule ID 6320 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[f16] } 740:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFh),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6320,
        GIR_EraseRootFromParent_Done,
      // Label 3097: @160425
      GIM_Try, /*On fail goto*//*Label 3098*/ GIMT_Encode4(160506), // Rule ID 1977 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v4f16] } 605:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1977,
        GIR_EraseRootFromParent_Done,
      // Label 3098: @160506
      GIM_Try, /*On fail goto*//*Label 3099*/ GIMT_Encode4(160587), // Rule ID 1978 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v8f16] } 605:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1978,
        GIR_EraseRootFromParent_Done,
      // Label 3099: @160587
      GIM_Try, /*On fail goto*//*Label 3100*/ GIMT_Encode4(160668), // Rule ID 2007 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v4i16] } 655:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2007,
        GIR_EraseRootFromParent_Done,
      // Label 3100: @160668
      GIM_Try, /*On fail goto*//*Label 3101*/ GIMT_Encode4(160749), // Rule ID 2008 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v8i16] } 655:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQDMULHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2008,
        GIR_EraseRootFromParent_Done,
      // Label 3101: @160749
      GIM_Try, /*On fail goto*//*Label 3102*/ GIMT_Encode4(160830), // Rule ID 2014 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v4i16] } 663:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2014,
        GIR_EraseRootFromParent_Done,
      // Label 3102: @160830
      GIM_Try, /*On fail goto*//*Label 3103*/ GIMT_Encode4(160911), // Rule ID 2015 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v8i16] } 663:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMULHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2015,
        GIR_EraseRootFromParent_Done,
      // Label 3103: @160911
      GIM_Try, /*On fail goto*//*Label 3104*/ GIMT_Encode4(160992), // Rule ID 2073 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v4i32] } 658:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQDMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2073,
        GIR_EraseRootFromParent_Done,
      // Label 3104: @160992
      GIM_Try, /*On fail goto*//*Label 3105*/ GIMT_Encode4(161073), // Rule ID 1980 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v2f32] } 605:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1980,
        GIR_EraseRootFromParent_Done,
      // Label 3105: @161073
      GIM_Try, /*On fail goto*//*Label 3106*/ GIMT_Encode4(161154), // Rule ID 1981 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v4f32] } 605:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1981,
        GIR_EraseRootFromParent_Done,
      // Label 3106: @161154
      GIM_Try, /*On fail goto*//*Label 3107*/ GIMT_Encode4(161235), // Rule ID 2010 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v2i32] } 655:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2010,
        GIR_EraseRootFromParent_Done,
      // Label 3107: @161235
      GIM_Try, /*On fail goto*//*Label 3108*/ GIMT_Encode4(161316), // Rule ID 2011 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v4i32] } 655:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2011,
        GIR_EraseRootFromParent_Done,
      // Label 3108: @161316
      GIM_Try, /*On fail goto*//*Label 3109*/ GIMT_Encode4(161397), // Rule ID 2017 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v2i32] } 663:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2017,
        GIR_EraseRootFromParent_Done,
      // Label 3109: @161397
      GIM_Try, /*On fail goto*//*Label 3110*/ GIMT_Encode4(161478), // Rule ID 2018 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v4i32] } 663:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMULHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2018,
        GIR_EraseRootFromParent_Done,
      // Label 3110: @161478
      GIM_Try, /*On fail goto*//*Label 3111*/ GIMT_Encode4(161559), // Rule ID 2076 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v2i64] } 658:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2076,
        GIR_EraseRootFromParent_Done,
      // Label 3111: @161559
      GIM_Try, /*On fail goto*//*Label 3112*/ GIMT_Encode4(161640), // Rule ID 1982 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v2f64] } 605:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULXv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1982,
        GIR_EraseRootFromParent_Done,
      // Label 3112: @161640
      GIM_Try, /*On fail goto*//*Label 3113*/ GIMT_Encode4(161721), // Rule ID 1983 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[f16] } 605:{ *:[iPTR] }, FPR16Op:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1983,
        GIR_EraseRootFromParent_Done,
      // Label 3113: @161721
      GIM_Try, /*On fail goto*//*Label 3114*/ GIMT_Encode4(161802), // Rule ID 1984 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[f32] } 605:{ *:[iPTR] }, FPR32Op:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1984,
        GIR_EraseRootFromParent_Done,
      // Label 3114: @161802
      GIM_Try, /*On fail goto*//*Label 3115*/ GIMT_Encode4(161883), // Rule ID 1985 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[f64] } 605:{ *:[iPTR] }, FPR64Op:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULXv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1985,
        GIR_EraseRootFromParent_Done,
      // Label 3115: @161883
      GIM_Try, /*On fail goto*//*Label 3116*/ GIMT_Encode4(161964), // Rule ID 2012 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[i32] } 655:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2012,
        GIR_EraseRootFromParent_Done,
      // Label 3116: @161964
      GIM_Try, /*On fail goto*//*Label 3117*/ GIMT_Encode4(162045), // Rule ID 2019 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[i32] } 663:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMULHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2019,
        GIR_EraseRootFromParent_Done,
      // Label 3117: @162045
      GIM_Try, /*On fail goto*//*Label 3118*/ GIMT_Encode4(162123), // Rule ID 6307 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[i64] } 659:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Vm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULLv1i64_indexed:{ *:[i64] } FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Vm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6307,
        GIR_EraseRootFromParent_Done,
      // Label 3118: @162123
      GIM_Try, /*On fail goto*//*Label 3119*/ GIMT_Encode4(162183), // Rule ID 6381 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 8,
        // (intrinsic_wo_chain:{ *:[v8i8] } 632:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vn, 8:{ *:[i32] })  =>  (RADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Vn, (MOVIv2d_ns:{ *:[v8i16] } 0:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6381,
        GIR_EraseRootFromParent_Done,
      // Label 3119: @162183
      GIM_Try, /*On fail goto*//*Label 3120*/ GIMT_Encode4(162243), // Rule ID 6382 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 16,
        // (intrinsic_wo_chain:{ *:[v4i16] } 632:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, 16:{ *:[i32] })  =>  (RADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vn, (MOVIv2d_ns:{ *:[v4i32] } 0:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6382,
        GIR_EraseRootFromParent_Done,
      // Label 3120: @162243
      GIM_Try, /*On fail goto*//*Label 3121*/ GIMT_Encode4(162303), // Rule ID 6383 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 32,
        // (intrinsic_wo_chain:{ *:[v2i32] } 632:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, 32:{ *:[i32] })  =>  (RADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vn, (MOVIv2d_ns:{ *:[v2i64] } 0:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6383,
        GIR_EraseRootFromParent_Done,
      // Label 3121: @162303
      GIM_Try, /*On fail goto*//*Label 3122*/ GIMT_Encode4(162350), // Rule ID 3877 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Operand 3
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
        // (intrinsic_wo_chain:{ *:[i64] } 297:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 0:{ *:[i32] })  =>  (XPACI:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3877,
        GIR_EraseRootFromParent_Done,
      // Label 3122: @162350
      GIM_Try, /*On fail goto*//*Label 3123*/ GIMT_Encode4(162397), // Rule ID 3878 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Operand 3
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
        // (intrinsic_wo_chain:{ *:[i64] } 297:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 1:{ *:[i32] })  =>  (XPACI:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3878,
        GIR_EraseRootFromParent_Done,
      // Label 3123: @162397
      GIM_Try, /*On fail goto*//*Label 3124*/ GIMT_Encode4(162444), // Rule ID 3879 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Operand 3
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
        // (intrinsic_wo_chain:{ *:[i64] } 297:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 2:{ *:[i32] })  =>  (XPACD:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACD),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3879,
        GIR_EraseRootFromParent_Done,
      // Label 3124: @162444
      GIM_Try, /*On fail goto*//*Label 3125*/ GIMT_Encode4(162491), // Rule ID 3880 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Operand 3
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
        // (intrinsic_wo_chain:{ *:[i64] } 297:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 3:{ *:[i32] })  =>  (XPACD:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACD),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3880,
        GIR_EraseRootFromParent_Done,
      // Label 3125: @162491
      GIM_Try, /*On fail goto*//*Label 3126*/ GIMT_Encode4(162537), // Rule ID 3540 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Idx
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_0),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1506:{ *:[iPTR] }, ZPRAny:{ *:[nxv16i8] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_0>>:$Idx)  =>  (PMOV_PZI_B:{ *:[nxv16i1] } ZPRAny:{ *:[nxv16i8] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_0>>:$Idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Zn
        GIR_RootToRootCopy, /*OpIdx*/3, // Idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3540,
        GIR_EraseRootFromParent_Done,
      // Label 3126: @162537
      GIM_Try, /*On fail goto*//*Label 3127*/ GIMT_Encode4(162583), // Rule ID 3541 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Idx
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1506:{ *:[iPTR] }, ZPRAny:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Idx)  =>  (PMOV_PZI_H:{ *:[nxv8i1] } ZPRAny:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Zn
        GIR_RootToRootCopy, /*OpIdx*/3, // Idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3541,
        GIR_EraseRootFromParent_Done,
      // Label 3127: @162583
      GIM_Try, /*On fail goto*//*Label 3128*/ GIMT_Encode4(162629), // Rule ID 3542 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Idx
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1506:{ *:[iPTR] }, ZPRAny:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Idx)  =>  (PMOV_PZI_S:{ *:[nxv4i1] } ZPRAny:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Zn
        GIR_RootToRootCopy, /*OpIdx*/3, // Idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3542,
        GIR_EraseRootFromParent_Done,
      // Label 3128: @162629
      GIM_Try, /*On fail goto*//*Label 3129*/ GIMT_Encode4(162675), // Rule ID 3543 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Idx
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 1506:{ *:[iPTR] }, ZPRAny:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Idx)  =>  (PMOV_PZI_D:{ *:[nxv2i1] } ZPRAny:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Zn
        GIR_RootToRootCopy, /*OpIdx*/3, // Idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3543,
        GIR_EraseRootFromParent_Done,
      // Label 3129: @162675
      GIM_Try, /*On fail goto*//*Label 3130*/ GIMT_Encode4(162731), // Rule ID 2097 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshrn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[i32] } 667:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQRSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2097,
        GIR_EraseRootFromParent_Done,
      // Label 3130: @162731
      GIM_Try, /*On fail goto*//*Label 3131*/ GIMT_Encode4(162787), // Rule ID 2098 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshrun),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[i32] } 668:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQRSHRUNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2098,
        GIR_EraseRootFromParent_Done,
      // Label 3131: @162787
      GIM_Try, /*On fail goto*//*Label 3132*/ GIMT_Encode4(162843), // Rule ID 2103 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshrn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[i32] } 671:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2103,
        GIR_EraseRootFromParent_Done,
      // Label 3132: @162843
      GIM_Try, /*On fail goto*//*Label 3133*/ GIMT_Encode4(162899), // Rule ID 2104 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshrun),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[i32] } 672:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQSHRUNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2104,
        GIR_EraseRootFromParent_Done,
      // Label 3133: @162899
      GIM_Try, /*On fail goto*//*Label 3134*/ GIMT_Encode4(162955), // Rule ID 2110 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshrn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[i32] } 716:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (UQRSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2110,
        GIR_EraseRootFromParent_Done,
      // Label 3134: @162955
      GIM_Try, /*On fail goto*//*Label 3135*/ GIMT_Encode4(163011), // Rule ID 2113 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshrn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[i32] } 718:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (UQSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2113,
        GIR_EraseRootFromParent_Done,
      // Label 3135: @163011
      GIM_Try, /*On fail goto*//*Label 3136*/ GIMT_Encode4(163067), // Rule ID 2135 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[v8i8] } 632:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)  =>  (RSHRNv8i8_shift:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv8i8_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2135,
        GIR_EraseRootFromParent_Done,
      // Label 3136: @163067
      GIM_Try, /*On fail goto*//*Label 3137*/ GIMT_Encode4(163123), // Rule ID 2137 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[v4i16] } 632:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)  =>  (RSHRNv4i16_shift:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv4i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2137,
        GIR_EraseRootFromParent_Done,
      // Label 3137: @163123
      GIM_Try, /*On fail goto*//*Label 3138*/ GIMT_Encode4(163179), // Rule ID 2139 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[v2i32] } 632:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)  =>  (RSHRNv2i32_shift:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv2i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2139,
        GIR_EraseRootFromParent_Done,
      // Label 3138: @163179
      GIM_Try, /*On fail goto*//*Label 3139*/ GIMT_Encode4(163232), // Rule ID 6308 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[i32] } 737:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (FCVTZSs:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6308,
        GIR_EraseRootFromParent_Done,
      // Label 3139: @163232
      GIM_Try, /*On fail goto*//*Label 3140*/ GIMT_Encode4(163285), // Rule ID 6309 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[i32] } 738:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (FCVTZUs:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6309,
        GIR_EraseRootFromParent_Done,
      // Label 3140: @163285
      GIM_Try, /*On fail goto*//*Label 3141*/ GIMT_Encode4(163338), // Rule ID 6310 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[i64] } 737:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZSd:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSd),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6310,
        GIR_EraseRootFromParent_Done,
      // Label 3141: @163338
      GIM_Try, /*On fail goto*//*Label 3142*/ GIMT_Encode4(163391), // Rule ID 6311 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[i64] } 738:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZUd:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUd),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6311,
        GIR_EraseRootFromParent_Done,
      // Label 3142: @163391
      GIM_Try, /*On fail goto*//*Label 3143*/ GIMT_Encode4(163444), // Rule ID 6312 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[v1i64] } 737:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZSd:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSd),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6312,
        GIR_EraseRootFromParent_Done,
      // Label 3143: @163444
      GIM_Try, /*On fail goto*//*Label 3144*/ GIMT_Encode4(163497), // Rule ID 6313 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[v1i64] } 738:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZUd:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUd),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6313,
        GIR_EraseRootFromParent_Done,
      // Label 3144: @163497
      GIM_Try, /*On fail goto*//*Label 3145*/ GIMT_Encode4(163550), // Rule ID 6314 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[f32] } 741:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (UCVTFs:{ *:[f32] } FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6314,
        GIR_EraseRootFromParent_Done,
      // Label 3145: @163550
      GIM_Try, /*On fail goto*//*Label 3146*/ GIMT_Encode4(163603), // Rule ID 6315 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[f64] } 741:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (UCVTFd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFd),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6315,
        GIR_EraseRootFromParent_Done,
      // Label 3146: @163603
      GIM_Try, /*On fail goto*//*Label 3147*/ GIMT_Encode4(163656), // Rule ID 6316 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[v1f64] } 740:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SCVTFd:{ *:[v1f64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFd),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6316,
        GIR_EraseRootFromParent_Done,
      // Label 3147: @163656
      GIM_Try, /*On fail goto*//*Label 3148*/ GIMT_Encode4(163709), // Rule ID 6317 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[f64] } 740:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SCVTFd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFd),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6317,
        GIR_EraseRootFromParent_Done,
      // Label 3148: @163709
      GIM_Try, /*On fail goto*//*Label 3149*/ GIMT_Encode4(163762), // Rule ID 6318 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[v1f64] } 741:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (UCVTFd:{ *:[v1f64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFd),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6318,
        GIR_EraseRootFromParent_Done,
      // Label 3149: @163762
      GIM_Try, /*On fail goto*//*Label 3150*/ GIMT_Encode4(163815), // Rule ID 6319 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[f32] } 740:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SCVTFs:{ *:[f32] } FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFs),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6319,
        GIR_EraseRootFromParent_Done,
      // Label 3150: @163815
      GIM_Try, /*On fail goto*//*Label 3151*/ GIMT_Encode4(163897), // Rule ID 6321 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[f16] } 740:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFh),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6321,
        GIR_EraseRootFromParent_Done,
      // Label 3151: @163897
      GIM_Try, /*On fail goto*//*Label 3152*/ GIMT_Encode4(163979), // Rule ID 6322 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[f16] } 740:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFh),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6322,
        GIR_EraseRootFromParent_Done,
      // Label 3152: @163979
      GIM_Try, /*On fail goto*//*Label 3153*/ GIMT_Encode4(164061), // Rule ID 6324 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[f16] } 741:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (UCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFh),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6324,
        GIR_EraseRootFromParent_Done,
      // Label 3153: @164061
      GIM_Try, /*On fail goto*//*Label 3154*/ GIMT_Encode4(164143), // Rule ID 6325 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[f16] } 741:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (UCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFh),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6325,
        GIR_EraseRootFromParent_Done,
      // Label 3154: @164143
      GIM_Try, /*On fail goto*//*Label 3155*/ GIMT_Encode4(164249), // Rule ID 6326 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[i32] } 737:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FCVTZSh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSh),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 6326,
        GIR_EraseRootFromParent_Done,
      // Label 3155: @164249
      GIM_Try, /*On fail goto*//*Label 3156*/ GIMT_Encode4(164355), // Rule ID 6327 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[i64] } 737:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (FCVTZSh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSh),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 6327,
        GIR_EraseRootFromParent_Done,
      // Label 3156: @164355
      GIM_Try, /*On fail goto*//*Label 3157*/ GIMT_Encode4(164461), // Rule ID 6328 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[i32] } 738:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FCVTZUh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUh),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 6328,
        GIR_EraseRootFromParent_Done,
      // Label 3157: @164461
      GIM_Try, /*On fail goto*//*Label 3158*/ GIMT_Encode4(164567), // Rule ID 6329 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[i64] } 738:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (FCVTZUh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUh),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 6329,
        GIR_EraseRootFromParent_Done,
      // Label 3158: @164567
      GIM_Try, /*On fail goto*//*Label 3159*/ GIMT_Encode4(164622), // Rule ID 7137 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_blend),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64_0_65535),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[i64] } 293:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_imm64_0_65535>>:$imm)  =>  (PAUTH_BLEND:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, (trunc_imm:{ *:[i32] } (imm:{ *:[i64] })<<P:Predicate_imm64_0_65535>>:$imm))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PAUTH_BLEND),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[disc]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7137,
        GIR_EraseRootFromParent_Done,
      // Label 3159: @164622
      GIM_Try, /*On fail goto*//*Label 3160*/ GIMT_Encode4(164664), // Rule ID 3023 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1744:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (SSHLLB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLB_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3023,
        GIR_EraseRootFromParent_Done,
      // Label 3160: @164664
      GIM_Try, /*On fail goto*//*Label 3161*/ GIMT_Encode4(164706), // Rule ID 3024 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1744:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (SSHLLB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLB_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3024,
        GIR_EraseRootFromParent_Done,
      // Label 3161: @164706
      GIM_Try, /*On fail goto*//*Label 3162*/ GIMT_Encode4(164748), // Rule ID 3025 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1744:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (SSHLLB_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLB_ZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3025,
        GIR_EraseRootFromParent_Done,
      // Label 3162: @164748
      GIM_Try, /*On fail goto*//*Label 3163*/ GIMT_Encode4(164790), // Rule ID 3059 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1725:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQSHRUNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNB_ZZI_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3059,
        GIR_EraseRootFromParent_Done,
      // Label 3163: @164790
      GIM_Try, /*On fail goto*//*Label 3164*/ GIMT_Encode4(164832), // Rule ID 3060 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1725:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQSHRUNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNB_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3060,
        GIR_EraseRootFromParent_Done,
      // Label 3164: @164832
      GIM_Try, /*On fail goto*//*Label 3165*/ GIMT_Encode4(164874), // Rule ID 3061 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1725:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQSHRUNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNB_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3061,
        GIR_EraseRootFromParent_Done,
      // Label 3165: @164874
      GIM_Try, /*On fail goto*//*Label 3166*/ GIMT_Encode4(164916), // Rule ID 3524 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1225:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Op2)  =>  (DUPQ_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3524,
        GIR_EraseRootFromParent_Done,
      // Label 3166: @164916
      GIM_Try, /*On fail goto*//*Label 3167*/ GIMT_Encode4(164958), // Rule ID 3525 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1225:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)  =>  (DUPQ_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3525,
        GIR_EraseRootFromParent_Done,
      // Label 3167: @164958
      GIM_Try, /*On fail goto*//*Label 3168*/ GIMT_Encode4(165000), // Rule ID 3526 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1225:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)  =>  (DUPQ_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3526,
        GIR_EraseRootFromParent_Done,
      // Label 3168: @165000
      GIM_Try, /*On fail goto*//*Label 3169*/ GIMT_Encode4(165042), // Rule ID 3527 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1225:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)  =>  (DUPQ_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3527,
        GIR_EraseRootFromParent_Done,
      // Label 3169: @165042
      GIM_Try, /*On fail goto*//*Label 3170*/ GIMT_Encode4(165084), // Rule ID 3528 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1225:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)  =>  (DUPQ_ZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3528,
        GIR_EraseRootFromParent_Done,
      // Label 3170: @165084
      GIM_Try, /*On fail goto*//*Label 3171*/ GIMT_Encode4(165126), // Rule ID 3529 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1225:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)  =>  (DUPQ_ZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3529,
        GIR_EraseRootFromParent_Done,
      // Label 3171: @165126
      GIM_Try, /*On fail goto*//*Label 3172*/ GIMT_Encode4(165168), // Rule ID 3530 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1225:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)  =>  (DUPQ_ZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3530,
        GIR_EraseRootFromParent_Done,
      // Label 3172: @165168
      GIM_Try, /*On fail goto*//*Label 3173*/ GIMT_Encode4(165210), // Rule ID 3531 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv8bf16] } 1225:{ *:[iPTR] }, nxv8bf16:{ *:[nxv8bf16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)  =>  (DUPQ_ZZI_H:{ *:[nxv8bf16] } ?:{ *:[nxv8bf16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3531,
        GIR_EraseRootFromParent_Done,
      // Label 3173: @165210
      GIM_Try, /*On fail goto*//*Label 3174*/ GIMT_Encode4(165252), // Rule ID 12026 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1719:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQRSHRUNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNB_ZZI_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12026,
        GIR_EraseRootFromParent_Done,
      // Label 3174: @165252
      GIM_Try, /*On fail goto*//*Label 3175*/ GIMT_Encode4(165294), // Rule ID 12027 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1719:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQRSHRUNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNB_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12027,
        GIR_EraseRootFromParent_Done,
      // Label 3175: @165294
      GIM_Try, /*On fail goto*//*Label 3176*/ GIMT_Encode4(165336), // Rule ID 12028 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1719:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQRSHRUNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNB_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12028,
        GIR_EraseRootFromParent_Done,
      // Label 3176: @165336
      GIM_Try, /*On fail goto*//*Label 3177*/ GIMT_Encode4(165378), // Rule ID 12029 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1598:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNB_ZZI_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12029,
        GIR_EraseRootFromParent_Done,
      // Label 3177: @165378
      GIM_Try, /*On fail goto*//*Label 3178*/ GIMT_Encode4(165420), // Rule ID 12030 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1598:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNB_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12030,
        GIR_EraseRootFromParent_Done,
      // Label 3178: @165420
      GIM_Try, /*On fail goto*//*Label 3179*/ GIMT_Encode4(165462), // Rule ID 12031 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1598:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNB_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12031,
        GIR_EraseRootFromParent_Done,
      // Label 3179: @165462
      GIM_Try, /*On fail goto*//*Label 3180*/ GIMT_Encode4(165504), // Rule ID 12033 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1556:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (RSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNB_ZZI_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12033,
        GIR_EraseRootFromParent_Done,
      // Label 3180: @165504
      GIM_Try, /*On fail goto*//*Label 3181*/ GIMT_Encode4(165546), // Rule ID 12035 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1556:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (RSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNB_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12035,
        GIR_EraseRootFromParent_Done,
      // Label 3181: @165546
      GIM_Try, /*On fail goto*//*Label 3182*/ GIMT_Encode4(165588), // Rule ID 12037 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1556:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (RSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNB_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12037,
        GIR_EraseRootFromParent_Done,
      // Label 3182: @165588
      GIM_Try, /*On fail goto*//*Label 3183*/ GIMT_Encode4(165630), // Rule ID 12038 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1723:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNB_ZZI_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12038,
        GIR_EraseRootFromParent_Done,
      // Label 3183: @165630
      GIM_Try, /*On fail goto*//*Label 3184*/ GIMT_Encode4(165672), // Rule ID 12039 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1723:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNB_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12039,
        GIR_EraseRootFromParent_Done,
      // Label 3184: @165672
      GIM_Try, /*On fail goto*//*Label 3185*/ GIMT_Encode4(165714), // Rule ID 12040 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1723:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNB_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12040,
        GIR_EraseRootFromParent_Done,
      // Label 3185: @165714
      GIM_Try, /*On fail goto*//*Label 3186*/ GIMT_Encode4(165756), // Rule ID 12041 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1713:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQRSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNB_ZZI_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12041,
        GIR_EraseRootFromParent_Done,
      // Label 3186: @165756
      GIM_Try, /*On fail goto*//*Label 3187*/ GIMT_Encode4(165798), // Rule ID 12042 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1713:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQRSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNB_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12042,
        GIR_EraseRootFromParent_Done,
      // Label 3187: @165798
      GIM_Try, /*On fail goto*//*Label 3188*/ GIMT_Encode4(165840), // Rule ID 12043 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1713:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQRSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNB_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12043,
        GIR_EraseRootFromParent_Done,
      // Label 3188: @165840
      GIM_Try, /*On fail goto*//*Label 3189*/ GIMT_Encode4(165882), // Rule ID 12044 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1918:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (UQSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNB_ZZI_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12044,
        GIR_EraseRootFromParent_Done,
      // Label 3189: @165882
      GIM_Try, /*On fail goto*//*Label 3190*/ GIMT_Encode4(165924), // Rule ID 12045 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1918:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (UQSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNB_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12045,
        GIR_EraseRootFromParent_Done,
      // Label 3190: @165924
      GIM_Try, /*On fail goto*//*Label 3191*/ GIMT_Encode4(165966), // Rule ID 12046 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1918:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (UQSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNB_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12046,
        GIR_EraseRootFromParent_Done,
      // Label 3191: @165966
      GIM_Try, /*On fail goto*//*Label 3192*/ GIMT_Encode4(166008), // Rule ID 12047 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1915:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (UQRSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNB_ZZI_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12047,
        GIR_EraseRootFromParent_Done,
      // Label 3192: @166008
      GIM_Try, /*On fail goto*//*Label 3193*/ GIMT_Encode4(166050), // Rule ID 12048 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1915:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (UQRSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNB_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12048,
        GIR_EraseRootFromParent_Done,
      // Label 3193: @166050
      GIM_Try, /*On fail goto*//*Label 3194*/ GIMT_Encode4(166092), // Rule ID 12049 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1915:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (UQRSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNB_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12049,
        GIR_EraseRootFromParent_Done,
      // Label 3194: @166092
      GIM_Try, /*On fail goto*//*Label 3195*/ GIMT_Encode4(166134), // Rule ID 12107 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1745:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (SSHLLT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLT_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12107,
        GIR_EraseRootFromParent_Done,
      // Label 3195: @166134
      GIM_Try, /*On fail goto*//*Label 3196*/ GIMT_Encode4(166176), // Rule ID 12108 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1745:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (SSHLLT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLT_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12108,
        GIR_EraseRootFromParent_Done,
      // Label 3196: @166176
      GIM_Try, /*On fail goto*//*Label 3197*/ GIMT_Encode4(166218), // Rule ID 12109 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1745:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (SSHLLT_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLT_ZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12109,
        GIR_EraseRootFromParent_Done,
      // Label 3197: @166218
      GIM_Try, /*On fail goto*//*Label 3198*/ GIMT_Encode4(166260), // Rule ID 12110 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1938:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (USHLLB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLB_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12110,
        GIR_EraseRootFromParent_Done,
      // Label 3198: @166260
      GIM_Try, /*On fail goto*//*Label 3199*/ GIMT_Encode4(166302), // Rule ID 12111 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1938:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (USHLLB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLB_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12111,
        GIR_EraseRootFromParent_Done,
      // Label 3199: @166302
      GIM_Try, /*On fail goto*//*Label 3200*/ GIMT_Encode4(166344), // Rule ID 12112 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1938:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (USHLLB_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLB_ZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12112,
        GIR_EraseRootFromParent_Done,
      // Label 3200: @166344
      GIM_Try, /*On fail goto*//*Label 3201*/ GIMT_Encode4(166386), // Rule ID 12113 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1939:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (USHLLT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLT_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12113,
        GIR_EraseRootFromParent_Done,
      // Label 3201: @166386
      GIM_Try, /*On fail goto*//*Label 3202*/ GIMT_Encode4(166428), // Rule ID 12114 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1939:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (USHLLT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLT_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12114,
        GIR_EraseRootFromParent_Done,
      // Label 3202: @166428
      GIM_Try, /*On fail goto*//*Label 3203*/ GIMT_Encode4(166470), // Rule ID 12115 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op2
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1939:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (USHLLT_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLT_ZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12115,
        GIR_EraseRootFromParent_Done,
      // Label 3203: @166470
      GIM_Try, /*On fail goto*//*Label 3204*/ GIMT_Encode4(166522), // Rule ID 2119 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[v4i16] } 737:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv4i16_shift:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2119,
        GIR_EraseRootFromParent_Done,
      // Label 3204: @166522
      GIM_Try, /*On fail goto*//*Label 3205*/ GIMT_Encode4(166574), // Rule ID 2120 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[v8i16] } 737:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv8i16_shift:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2120,
        GIR_EraseRootFromParent_Done,
      // Label 3205: @166574
      GIM_Try, /*On fail goto*//*Label 3206*/ GIMT_Encode4(166626), // Rule ID 2121 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[v2i32] } 737:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv2i32_shift:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2121,
        GIR_EraseRootFromParent_Done,
      // Label 3206: @166626
      GIM_Try, /*On fail goto*//*Label 3207*/ GIMT_Encode4(166678), // Rule ID 2122 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[v4i32] } 737:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv4i32_shift:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2122,
        GIR_EraseRootFromParent_Done,
      // Label 3207: @166678
      GIM_Try, /*On fail goto*//*Label 3208*/ GIMT_Encode4(166730), // Rule ID 2123 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[v2i64] } 737:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv2i64_shift:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2i64_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2123,
        GIR_EraseRootFromParent_Done,
      // Label 3208: @166730
      GIM_Try, /*On fail goto*//*Label 3209*/ GIMT_Encode4(166782), // Rule ID 2124 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[v4i16] } 738:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv4i16_shift:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2124,
        GIR_EraseRootFromParent_Done,
      // Label 3209: @166782
      GIM_Try, /*On fail goto*//*Label 3210*/ GIMT_Encode4(166834), // Rule ID 2125 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[v8i16] } 738:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv8i16_shift:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2125,
        GIR_EraseRootFromParent_Done,
      // Label 3210: @166834
      GIM_Try, /*On fail goto*//*Label 3211*/ GIMT_Encode4(166886), // Rule ID 2126 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[v2i32] } 738:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv2i32_shift:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2126,
        GIR_EraseRootFromParent_Done,
      // Label 3211: @166886
      GIM_Try, /*On fail goto*//*Label 3212*/ GIMT_Encode4(166938), // Rule ID 2127 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[v4i32] } 738:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv4i32_shift:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2127,
        GIR_EraseRootFromParent_Done,
      // Label 3212: @166938
      GIM_Try, /*On fail goto*//*Label 3213*/ GIMT_Encode4(166990), // Rule ID 2128 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[v2i64] } 738:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv2i64_shift:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2i64_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2128,
        GIR_EraseRootFromParent_Done,
      // Label 3213: @166990
      GIM_Try, /*On fail goto*//*Label 3214*/ GIMT_Encode4(167042), // Rule ID 2129 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[v4f16] } 740:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv4i16_shift:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2129,
        GIR_EraseRootFromParent_Done,
      // Label 3214: @167042
      GIM_Try, /*On fail goto*//*Label 3215*/ GIMT_Encode4(167094), // Rule ID 2130 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[v8f16] } 740:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv8i16_shift:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv8i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2130,
        GIR_EraseRootFromParent_Done,
      // Label 3215: @167094
      GIM_Try, /*On fail goto*//*Label 3216*/ GIMT_Encode4(167146), // Rule ID 2131 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[v2f32] } 740:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv2i32_shift:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2131,
        GIR_EraseRootFromParent_Done,
      // Label 3216: @167146
      GIM_Try, /*On fail goto*//*Label 3217*/ GIMT_Encode4(167198), // Rule ID 2132 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[v4f32] } 740:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv4i32_shift:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2132,
        GIR_EraseRootFromParent_Done,
      // Label 3217: @167198
      GIM_Try, /*On fail goto*//*Label 3218*/ GIMT_Encode4(167250), // Rule ID 2133 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[v2f64] } 740:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv2i64_shift:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2i64_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2133,
        GIR_EraseRootFromParent_Done,
      // Label 3218: @167250
      GIM_Try, /*On fail goto*//*Label 3219*/ GIMT_Encode4(167302), // Rule ID 2231 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[v4f16] } 741:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv4i16_shift:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2231,
        GIR_EraseRootFromParent_Done,
      // Label 3219: @167302
      GIM_Try, /*On fail goto*//*Label 3220*/ GIMT_Encode4(167354), // Rule ID 2232 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[v8f16] } 741:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv8i16_shift:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv8i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2232,
        GIR_EraseRootFromParent_Done,
      // Label 3220: @167354
      GIM_Try, /*On fail goto*//*Label 3221*/ GIMT_Encode4(167406), // Rule ID 2233 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[v2f32] } 741:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv2i32_shift:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2233,
        GIR_EraseRootFromParent_Done,
      // Label 3221: @167406
      GIM_Try, /*On fail goto*//*Label 3222*/ GIMT_Encode4(167458), // Rule ID 2234 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[v4f32] } 741:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv4i32_shift:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2234,
        GIR_EraseRootFromParent_Done,
      // Label 3222: @167458
      GIM_Try, /*On fail goto*//*Label 3223*/ GIMT_Encode4(167510), // Rule ID 2235 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[v2f64] } 741:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv2i64_shift:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2i64_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2235,
        GIR_EraseRootFromParent_Done,
      // Label 3223: @167510
      GIM_Try, /*On fail goto*//*Label 3224*/ GIMT_Encode4(167555), // Rule ID 40 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_bfcvtn2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8bf16] } 565:{ *:[iPTR] }, V128:{ *:[v8bf16] }:$Rd, V128:{ *:[v4f32] }:$Rn)  =>  (BFCVTN2:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rd, V128:{ *:[v4f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFCVTN2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 40,
        GIR_EraseRootFromParent_Done,
      // Label 3224: @167555
      GIM_Try, /*On fail goto*//*Label 3225*/ GIMT_Encode4(167600), // Rule ID 75 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign_generic),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)  =>  (PACGA:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACGA),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 75,
        GIR_EraseRootFromParent_Done,
      // Label 3225: @167600
      GIM_Try, /*On fail goto*//*Label 3226*/ GIMT_Encode4(167645), // Rule ID 141 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32b),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 495:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32Brr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Brr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 141,
        GIR_EraseRootFromParent_Done,
      // Label 3226: @167645
      GIM_Try, /*On fail goto*//*Label 3227*/ GIMT_Encode4(167690), // Rule ID 142 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32h),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 500:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32Hrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Hrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 142,
        GIR_EraseRootFromParent_Done,
      // Label 3227: @167690
      GIM_Try, /*On fail goto*//*Label 3228*/ GIMT_Encode4(167735), // Rule ID 143 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32w),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 501:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32Wrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Wrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 143,
        GIR_EraseRootFromParent_Done,
      // Label 3228: @167735
      GIM_Try, /*On fail goto*//*Label 3229*/ GIMT_Encode4(167780), // Rule ID 144 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 502:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (CRC32Xrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Xrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 144,
        GIR_EraseRootFromParent_Done,
      // Label 3229: @167780
      GIM_Try, /*On fail goto*//*Label 3230*/ GIMT_Encode4(167825), // Rule ID 145 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32cb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 496:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32CBrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CBrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 145,
        GIR_EraseRootFromParent_Done,
      // Label 3230: @167825
      GIM_Try, /*On fail goto*//*Label 3231*/ GIMT_Encode4(167870), // Rule ID 146 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32ch),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 497:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32CHrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CHrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 146,
        GIR_EraseRootFromParent_Done,
      // Label 3231: @167870
      GIM_Try, /*On fail goto*//*Label 3232*/ GIMT_Encode4(167915), // Rule ID 147 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32cw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 498:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32CWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CWrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 147,
        GIR_EraseRootFromParent_Done,
      // Label 3232: @167915
      GIM_Try, /*On fail goto*//*Label 3233*/ GIMT_Encode4(167960), // Rule ID 148 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32cx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 499:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (CRC32CXrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CXrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 148,
        GIR_EraseRootFromParent_Done,
      // Label 3233: @167960
      GIM_Try, /*On fail goto*//*Label 3234*/ GIMT_Encode4(168005), // Rule ID 1031 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i8] } 690:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)  =>  (SUQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1031,
        GIR_EraseRootFromParent_Done,
      // Label 3234: @168005
      GIM_Try, /*On fail goto*//*Label 3235*/ GIMT_Encode4(168050), // Rule ID 1032 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 690:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (SUQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1032,
        GIR_EraseRootFromParent_Done,
      // Label 3235: @168050
      GIM_Try, /*On fail goto*//*Label 3236*/ GIMT_Encode4(168095), // Rule ID 1033 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 690:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)  =>  (SUQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1033,
        GIR_EraseRootFromParent_Done,
      // Label 3236: @168095
      GIM_Try, /*On fail goto*//*Label 3237*/ GIMT_Encode4(168140), // Rule ID 1034 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 690:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)  =>  (SUQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1034,
        GIR_EraseRootFromParent_Done,
      // Label 3237: @168140
      GIM_Try, /*On fail goto*//*Label 3238*/ GIMT_Encode4(168185), // Rule ID 1035 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 690:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)  =>  (SUQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1035,
        GIR_EraseRootFromParent_Done,
      // Label 3238: @168185
      GIM_Try, /*On fail goto*//*Label 3239*/ GIMT_Encode4(168230), // Rule ID 1036 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (SUQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1036,
        GIR_EraseRootFromParent_Done,
      // Label 3239: @168230
      GIM_Try, /*On fail goto*//*Label 3240*/ GIMT_Encode4(168275), // Rule ID 1037 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 690:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)  =>  (SUQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1037,
        GIR_EraseRootFromParent_Done,
      // Label 3240: @168275
      GIM_Try, /*On fail goto*//*Label 3241*/ GIMT_Encode4(168320), // Rule ID 1079 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i8] } 729:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)  =>  (USQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1079,
        GIR_EraseRootFromParent_Done,
      // Label 3241: @168320
      GIM_Try, /*On fail goto*//*Label 3242*/ GIMT_Encode4(168365), // Rule ID 1080 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 729:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (USQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1080,
        GIR_EraseRootFromParent_Done,
      // Label 3242: @168365
      GIM_Try, /*On fail goto*//*Label 3243*/ GIMT_Encode4(168410), // Rule ID 1081 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 729:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)  =>  (USQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1081,
        GIR_EraseRootFromParent_Done,
      // Label 3243: @168410
      GIM_Try, /*On fail goto*//*Label 3244*/ GIMT_Encode4(168455), // Rule ID 1082 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 729:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)  =>  (USQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1082,
        GIR_EraseRootFromParent_Done,
      // Label 3244: @168455
      GIM_Try, /*On fail goto*//*Label 3245*/ GIMT_Encode4(168500), // Rule ID 1083 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 729:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)  =>  (USQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1083,
        GIR_EraseRootFromParent_Done,
      // Label 3245: @168500
      GIM_Try, /*On fail goto*//*Label 3246*/ GIMT_Encode4(168545), // Rule ID 1084 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 729:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (USQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1084,
        GIR_EraseRootFromParent_Done,
      // Label 3246: @168545
      GIM_Try, /*On fail goto*//*Label 3247*/ GIMT_Encode4(168590), // Rule ID 1085 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 729:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)  =>  (USQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1085,
        GIR_EraseRootFromParent_Done,
      // Label 3247: @168590
      GIM_Try, /*On fail goto*//*Label 3248*/ GIMT_Encode4(168635), // Rule ID 1097 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i8] } 562:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ADDPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1097,
        GIR_EraseRootFromParent_Done,
      // Label 3248: @168635
      GIM_Try, /*On fail goto*//*Label 3249*/ GIMT_Encode4(168680), // Rule ID 1099 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 562:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ADDPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1099,
        GIR_EraseRootFromParent_Done,
      // Label 3249: @168680
      GIM_Try, /*On fail goto*//*Label 3250*/ GIMT_Encode4(168725), // Rule ID 1101 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 562:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ADDPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1101,
        GIR_EraseRootFromParent_Done,
      // Label 3250: @168725
      GIM_Try, /*On fail goto*//*Label 3251*/ GIMT_Encode4(168770), // Rule ID 1103 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 562:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ADDPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1103,
        GIR_EraseRootFromParent_Done,
      // Label 3251: @168770
      GIM_Try, /*On fail goto*//*Label 3252*/ GIMT_Encode4(168815), // Rule ID 1105 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 562:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ADDPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1105,
        GIR_EraseRootFromParent_Done,
      // Label 3252: @168815
      GIM_Try, /*On fail goto*//*Label 3253*/ GIMT_Encode4(168860), // Rule ID 1107 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 562:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ADDPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1107,
        GIR_EraseRootFromParent_Done,
      // Label 3253: @168860
      GIM_Try, /*On fail goto*//*Label 3254*/ GIMT_Encode4(168905), // Rule ID 1109 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 562:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ADDPv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1109,
        GIR_EraseRootFromParent_Done,
      // Label 3254: @168905
      GIM_Try, /*On fail goto*//*Label 3255*/ GIMT_Encode4(168950), // Rule ID 1152 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f16] } 571:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FABDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1152,
        GIR_EraseRootFromParent_Done,
      // Label 3255: @168950
      GIM_Try, /*On fail goto*//*Label 3256*/ GIMT_Encode4(168995), // Rule ID 1153 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8f16] } 571:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FABDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1153,
        GIR_EraseRootFromParent_Done,
      // Label 3256: @168995
      GIM_Try, /*On fail goto*//*Label 3257*/ GIMT_Encode4(169040), // Rule ID 1154 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f32] } 571:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FABDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1154,
        GIR_EraseRootFromParent_Done,
      // Label 3257: @169040
      GIM_Try, /*On fail goto*//*Label 3258*/ GIMT_Encode4(169085), // Rule ID 1155 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 571:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FABDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1155,
        GIR_EraseRootFromParent_Done,
      // Label 3258: @169085
      GIM_Try, /*On fail goto*//*Label 3259*/ GIMT_Encode4(169130), // Rule ID 1156 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f64] } 571:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FABDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1156,
        GIR_EraseRootFromParent_Done,
      // Label 3259: @169130
      GIM_Try, /*On fail goto*//*Label 3260*/ GIMT_Encode4(169175), // Rule ID 1158 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 572:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FACGEv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1158,
        GIR_EraseRootFromParent_Done,
      // Label 3260: @169175
      GIM_Try, /*On fail goto*//*Label 3261*/ GIMT_Encode4(169220), // Rule ID 1160 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 572:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FACGEv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1160,
        GIR_EraseRootFromParent_Done,
      // Label 3261: @169220
      GIM_Try, /*On fail goto*//*Label 3262*/ GIMT_Encode4(169265), // Rule ID 1162 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 572:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FACGEv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1162,
        GIR_EraseRootFromParent_Done,
      // Label 3262: @169265
      GIM_Try, /*On fail goto*//*Label 3263*/ GIMT_Encode4(169310), // Rule ID 1164 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 572:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FACGEv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1164,
        GIR_EraseRootFromParent_Done,
      // Label 3263: @169310
      GIM_Try, /*On fail goto*//*Label 3264*/ GIMT_Encode4(169355), // Rule ID 1166 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 572:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FACGEv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1166,
        GIR_EraseRootFromParent_Done,
      // Label 3264: @169355
      GIM_Try, /*On fail goto*//*Label 3265*/ GIMT_Encode4(169400), // Rule ID 1168 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 573:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FACGTv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1168,
        GIR_EraseRootFromParent_Done,
      // Label 3265: @169400
      GIM_Try, /*On fail goto*//*Label 3266*/ GIMT_Encode4(169445), // Rule ID 1170 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 573:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FACGTv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1170,
        GIR_EraseRootFromParent_Done,
      // Label 3266: @169445
      GIM_Try, /*On fail goto*//*Label 3267*/ GIMT_Encode4(169490), // Rule ID 1172 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 573:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FACGTv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1172,
        GIR_EraseRootFromParent_Done,
      // Label 3267: @169490
      GIM_Try, /*On fail goto*//*Label 3268*/ GIMT_Encode4(169535), // Rule ID 1174 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 573:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FACGTv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1174,
        GIR_EraseRootFromParent_Done,
      // Label 3268: @169535
      GIM_Try, /*On fail goto*//*Label 3269*/ GIMT_Encode4(169580), // Rule ID 1176 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 573:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FACGTv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1176,
        GIR_EraseRootFromParent_Done,
      // Label 3269: @169580
      GIM_Try, /*On fail goto*//*Label 3270*/ GIMT_Encode4(169625), // Rule ID 1178 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f16] } 574:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FADDPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1178,
        GIR_EraseRootFromParent_Done,
      // Label 3270: @169625
      GIM_Try, /*On fail goto*//*Label 3271*/ GIMT_Encode4(169670), // Rule ID 1180 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8f16] } 574:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FADDPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1180,
        GIR_EraseRootFromParent_Done,
      // Label 3271: @169670
      GIM_Try, /*On fail goto*//*Label 3272*/ GIMT_Encode4(169715), // Rule ID 1182 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f32] } 574:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FADDPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1182,
        GIR_EraseRootFromParent_Done,
      // Label 3272: @169715
      GIM_Try, /*On fail goto*//*Label 3273*/ GIMT_Encode4(169760), // Rule ID 1184 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 574:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FADDPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1184,
        GIR_EraseRootFromParent_Done,
      // Label 3273: @169760
      GIM_Try, /*On fail goto*//*Label 3274*/ GIMT_Encode4(169805), // Rule ID 1186 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f64] } 574:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FADDPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1186,
        GIR_EraseRootFromParent_Done,
      // Label 3274: @169805
      GIM_Try, /*On fail goto*//*Label 3275*/ GIMT_Encode4(169850), // Rule ID 1222 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f16] } 591:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXNMPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1222,
        GIR_EraseRootFromParent_Done,
      // Label 3275: @169850
      GIM_Try, /*On fail goto*//*Label 3276*/ GIMT_Encode4(169895), // Rule ID 1223 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8f16] } 591:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXNMPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1223,
        GIR_EraseRootFromParent_Done,
      // Label 3276: @169895
      GIM_Try, /*On fail goto*//*Label 3277*/ GIMT_Encode4(169940), // Rule ID 1224 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f32] } 591:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXNMPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1224,
        GIR_EraseRootFromParent_Done,
      // Label 3277: @169940
      GIM_Try, /*On fail goto*//*Label 3278*/ GIMT_Encode4(169985), // Rule ID 1225 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 591:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXNMPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1225,
        GIR_EraseRootFromParent_Done,
      // Label 3278: @169985
      GIM_Try, /*On fail goto*//*Label 3279*/ GIMT_Encode4(170030), // Rule ID 1226 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f64] } 591:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXNMPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1226,
        GIR_EraseRootFromParent_Done,
      // Label 3279: @170030
      GIM_Try, /*On fail goto*//*Label 3280*/ GIMT_Encode4(170075), // Rule ID 1237 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f16] } 593:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1237,
        GIR_EraseRootFromParent_Done,
      // Label 3280: @170075
      GIM_Try, /*On fail goto*//*Label 3281*/ GIMT_Encode4(170120), // Rule ID 1238 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8f16] } 593:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1238,
        GIR_EraseRootFromParent_Done,
      // Label 3281: @170120
      GIM_Try, /*On fail goto*//*Label 3282*/ GIMT_Encode4(170165), // Rule ID 1239 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f32] } 593:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1239,
        GIR_EraseRootFromParent_Done,
      // Label 3282: @170165
      GIM_Try, /*On fail goto*//*Label 3283*/ GIMT_Encode4(170210), // Rule ID 1240 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 593:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1240,
        GIR_EraseRootFromParent_Done,
      // Label 3283: @170210
      GIM_Try, /*On fail goto*//*Label 3284*/ GIMT_Encode4(170255), // Rule ID 1241 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f64] } 593:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1241,
        GIR_EraseRootFromParent_Done,
      // Label 3284: @170255
      GIM_Try, /*On fail goto*//*Label 3285*/ GIMT_Encode4(170300), // Rule ID 1252 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f16] } 597:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINNMPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1252,
        GIR_EraseRootFromParent_Done,
      // Label 3285: @170300
      GIM_Try, /*On fail goto*//*Label 3286*/ GIMT_Encode4(170345), // Rule ID 1253 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8f16] } 597:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINNMPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1253,
        GIR_EraseRootFromParent_Done,
      // Label 3286: @170345
      GIM_Try, /*On fail goto*//*Label 3287*/ GIMT_Encode4(170390), // Rule ID 1254 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f32] } 597:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINNMPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1254,
        GIR_EraseRootFromParent_Done,
      // Label 3287: @170390
      GIM_Try, /*On fail goto*//*Label 3288*/ GIMT_Encode4(170435), // Rule ID 1255 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 597:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINNMPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1255,
        GIR_EraseRootFromParent_Done,
      // Label 3288: @170435
      GIM_Try, /*On fail goto*//*Label 3289*/ GIMT_Encode4(170480), // Rule ID 1256 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f64] } 597:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINNMPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1256,
        GIR_EraseRootFromParent_Done,
      // Label 3289: @170480
      GIM_Try, /*On fail goto*//*Label 3290*/ GIMT_Encode4(170525), // Rule ID 1267 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f16] } 599:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1267,
        GIR_EraseRootFromParent_Done,
      // Label 3290: @170525
      GIM_Try, /*On fail goto*//*Label 3291*/ GIMT_Encode4(170570), // Rule ID 1268 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8f16] } 599:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1268,
        GIR_EraseRootFromParent_Done,
      // Label 3291: @170570
      GIM_Try, /*On fail goto*//*Label 3292*/ GIMT_Encode4(170615), // Rule ID 1269 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f32] } 599:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1269,
        GIR_EraseRootFromParent_Done,
      // Label 3292: @170615
      GIM_Try, /*On fail goto*//*Label 3293*/ GIMT_Encode4(170660), // Rule ID 1270 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 599:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1270,
        GIR_EraseRootFromParent_Done,
      // Label 3293: @170660
      GIM_Try, /*On fail goto*//*Label 3294*/ GIMT_Encode4(170705), // Rule ID 1271 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f64] } 599:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1271,
        GIR_EraseRootFromParent_Done,
      // Label 3294: @170705
      GIM_Try, /*On fail goto*//*Label 3295*/ GIMT_Encode4(170750), // Rule ID 1302 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f16] } 605:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMULXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1302,
        GIR_EraseRootFromParent_Done,
      // Label 3295: @170750
      GIM_Try, /*On fail goto*//*Label 3296*/ GIMT_Encode4(170795), // Rule ID 1303 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8f16] } 605:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMULXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1303,
        GIR_EraseRootFromParent_Done,
      // Label 3296: @170795
      GIM_Try, /*On fail goto*//*Label 3297*/ GIMT_Encode4(170840), // Rule ID 1304 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f32] } 605:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMULXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1304,
        GIR_EraseRootFromParent_Done,
      // Label 3297: @170840
      GIM_Try, /*On fail goto*//*Label 3298*/ GIMT_Encode4(170885), // Rule ID 1305 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 605:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMULXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1305,
        GIR_EraseRootFromParent_Done,
      // Label 3298: @170885
      GIM_Try, /*On fail goto*//*Label 3299*/ GIMT_Encode4(170930), // Rule ID 1306 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f64] } 605:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMULXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1306,
        GIR_EraseRootFromParent_Done,
      // Label 3299: @170930
      GIM_Try, /*On fail goto*//*Label 3300*/ GIMT_Encode4(170975), // Rule ID 1317 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f16] } 608:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FRECPSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1317,
        GIR_EraseRootFromParent_Done,
      // Label 3300: @170975
      GIM_Try, /*On fail goto*//*Label 3301*/ GIMT_Encode4(171020), // Rule ID 1318 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8f16] } 608:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FRECPSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1318,
        GIR_EraseRootFromParent_Done,
      // Label 3301: @171020
      GIM_Try, /*On fail goto*//*Label 3302*/ GIMT_Encode4(171065), // Rule ID 1319 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f32] } 608:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FRECPSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1319,
        GIR_EraseRootFromParent_Done,
      // Label 3302: @171065
      GIM_Try, /*On fail goto*//*Label 3303*/ GIMT_Encode4(171110), // Rule ID 1320 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 608:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FRECPSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1320,
        GIR_EraseRootFromParent_Done,
      // Label 3303: @171110
      GIM_Try, /*On fail goto*//*Label 3304*/ GIMT_Encode4(171155), // Rule ID 1321 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f64] } 608:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FRECPSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1321,
        GIR_EraseRootFromParent_Done,
      // Label 3304: @171155
      GIM_Try, /*On fail goto*//*Label 3305*/ GIMT_Encode4(171200), // Rule ID 1322 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f16] } 615:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FRSQRTSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1322,
        GIR_EraseRootFromParent_Done,
      // Label 3305: @171200
      GIM_Try, /*On fail goto*//*Label 3306*/ GIMT_Encode4(171245), // Rule ID 1323 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8f16] } 615:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FRSQRTSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1323,
        GIR_EraseRootFromParent_Done,
      // Label 3306: @171245
      GIM_Try, /*On fail goto*//*Label 3307*/ GIMT_Encode4(171290), // Rule ID 1324 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f32] } 615:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FRSQRTSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1324,
        GIR_EraseRootFromParent_Done,
      // Label 3307: @171290
      GIM_Try, /*On fail goto*//*Label 3308*/ GIMT_Encode4(171335), // Rule ID 1325 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 615:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FRSQRTSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1325,
        GIR_EraseRootFromParent_Done,
      // Label 3308: @171335
      GIM_Try, /*On fail goto*//*Label 3309*/ GIMT_Encode4(171380), // Rule ID 1326 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f64] } 615:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FRSQRTSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1326,
        GIR_EraseRootFromParent_Done,
      // Label 3309: @171380
      GIM_Try, /*On fail goto*//*Label 3310*/ GIMT_Encode4(171425), // Rule ID 1343 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_pmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i8] } 628:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (PMULv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1343,
        GIR_EraseRootFromParent_Done,
      // Label 3310: @171425
      GIM_Try, /*On fail goto*//*Label 3311*/ GIMT_Encode4(171470), // Rule ID 1344 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_pmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 628:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (PMULv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1344,
        GIR_EraseRootFromParent_Done,
      // Label 3311: @171470
      GIM_Try, /*On fail goto*//*Label 3312*/ GIMT_Encode4(171515), // Rule ID 1358 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i8] } 634:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SABDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1358,
        GIR_EraseRootFromParent_Done,
      // Label 3312: @171515
      GIM_Try, /*On fail goto*//*Label 3313*/ GIMT_Encode4(171560), // Rule ID 1360 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 634:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SABDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1360,
        GIR_EraseRootFromParent_Done,
      // Label 3313: @171560
      GIM_Try, /*On fail goto*//*Label 3314*/ GIMT_Encode4(171605), // Rule ID 1362 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 634:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SABDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1362,
        GIR_EraseRootFromParent_Done,
      // Label 3314: @171605
      GIM_Try, /*On fail goto*//*Label 3315*/ GIMT_Encode4(171650), // Rule ID 1364 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 634:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SABDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1364,
        GIR_EraseRootFromParent_Done,
      // Label 3315: @171650
      GIM_Try, /*On fail goto*//*Label 3316*/ GIMT_Encode4(171695), // Rule ID 1366 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 634:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SABDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1366,
        GIR_EraseRootFromParent_Done,
      // Label 3316: @171695
      GIM_Try, /*On fail goto*//*Label 3317*/ GIMT_Encode4(171740), // Rule ID 1368 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 634:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SABDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1368,
        GIR_EraseRootFromParent_Done,
      // Label 3317: @171740
      GIM_Try, /*On fail goto*//*Label 3318*/ GIMT_Encode4(171785), // Rule ID 1375 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i8] } 644:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SHSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1375,
        GIR_EraseRootFromParent_Done,
      // Label 3318: @171785
      GIM_Try, /*On fail goto*//*Label 3319*/ GIMT_Encode4(171830), // Rule ID 1376 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 644:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SHSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1376,
        GIR_EraseRootFromParent_Done,
      // Label 3319: @171830
      GIM_Try, /*On fail goto*//*Label 3320*/ GIMT_Encode4(171875), // Rule ID 1377 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 644:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SHSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1377,
        GIR_EraseRootFromParent_Done,
      // Label 3320: @171875
      GIM_Try, /*On fail goto*//*Label 3321*/ GIMT_Encode4(171920), // Rule ID 1378 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 644:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SHSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1378,
        GIR_EraseRootFromParent_Done,
      // Label 3321: @171920
      GIM_Try, /*On fail goto*//*Label 3322*/ GIMT_Encode4(171965), // Rule ID 1379 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 644:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SHSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1379,
        GIR_EraseRootFromParent_Done,
      // Label 3322: @171965
      GIM_Try, /*On fail goto*//*Label 3323*/ GIMT_Encode4(172010), // Rule ID 1380 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 644:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1380,
        GIR_EraseRootFromParent_Done,
      // Label 3323: @172010
      GIM_Try, /*On fail goto*//*Label 3324*/ GIMT_Encode4(172055), // Rule ID 1381 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i8] } 646:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMAXPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1381,
        GIR_EraseRootFromParent_Done,
      // Label 3324: @172055
      GIM_Try, /*On fail goto*//*Label 3325*/ GIMT_Encode4(172100), // Rule ID 1382 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 646:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMAXPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1382,
        GIR_EraseRootFromParent_Done,
      // Label 3325: @172100
      GIM_Try, /*On fail goto*//*Label 3326*/ GIMT_Encode4(172145), // Rule ID 1383 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 646:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMAXPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1383,
        GIR_EraseRootFromParent_Done,
      // Label 3326: @172145
      GIM_Try, /*On fail goto*//*Label 3327*/ GIMT_Encode4(172190), // Rule ID 1384 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 646:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMAXPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1384,
        GIR_EraseRootFromParent_Done,
      // Label 3327: @172190
      GIM_Try, /*On fail goto*//*Label 3328*/ GIMT_Encode4(172235), // Rule ID 1385 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 646:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMAXPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1385,
        GIR_EraseRootFromParent_Done,
      // Label 3328: @172235
      GIM_Try, /*On fail goto*//*Label 3329*/ GIMT_Encode4(172280), // Rule ID 1386 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 646:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMAXPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1386,
        GIR_EraseRootFromParent_Done,
      // Label 3329: @172280
      GIM_Try, /*On fail goto*//*Label 3330*/ GIMT_Encode4(172325), // Rule ID 1393 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i8] } 649:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMINPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1393,
        GIR_EraseRootFromParent_Done,
      // Label 3330: @172325
      GIM_Try, /*On fail goto*//*Label 3331*/ GIMT_Encode4(172370), // Rule ID 1394 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 649:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMINPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1394,
        GIR_EraseRootFromParent_Done,
      // Label 3331: @172370
      GIM_Try, /*On fail goto*//*Label 3332*/ GIMT_Encode4(172415), // Rule ID 1395 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 649:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMINPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1395,
        GIR_EraseRootFromParent_Done,
      // Label 3332: @172415
      GIM_Try, /*On fail goto*//*Label 3333*/ GIMT_Encode4(172460), // Rule ID 1396 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 649:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMINPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1396,
        GIR_EraseRootFromParent_Done,
      // Label 3333: @172460
      GIM_Try, /*On fail goto*//*Label 3334*/ GIMT_Encode4(172505), // Rule ID 1397 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 649:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMINPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1397,
        GIR_EraseRootFromParent_Done,
      // Label 3334: @172505
      GIM_Try, /*On fail goto*//*Label 3335*/ GIMT_Encode4(172550), // Rule ID 1398 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 649:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMINPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1398,
        GIR_EraseRootFromParent_Done,
      // Label 3335: @172550
      GIM_Try, /*On fail goto*//*Label 3336*/ GIMT_Encode4(172595), // Rule ID 1405 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i8] } 654:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1405,
        GIR_EraseRootFromParent_Done,
      // Label 3336: @172595
      GIM_Try, /*On fail goto*//*Label 3337*/ GIMT_Encode4(172640), // Rule ID 1406 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 654:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1406,
        GIR_EraseRootFromParent_Done,
      // Label 3337: @172640
      GIM_Try, /*On fail goto*//*Label 3338*/ GIMT_Encode4(172685), // Rule ID 1407 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 654:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1407,
        GIR_EraseRootFromParent_Done,
      // Label 3338: @172685
      GIM_Try, /*On fail goto*//*Label 3339*/ GIMT_Encode4(172730), // Rule ID 1408 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 654:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1408,
        GIR_EraseRootFromParent_Done,
      // Label 3339: @172730
      GIM_Try, /*On fail goto*//*Label 3340*/ GIMT_Encode4(172775), // Rule ID 1409 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 654:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1409,
        GIR_EraseRootFromParent_Done,
      // Label 3340: @172775
      GIM_Try, /*On fail goto*//*Label 3341*/ GIMT_Encode4(172820), // Rule ID 1410 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 654:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1410,
        GIR_EraseRootFromParent_Done,
      // Label 3341: @172820
      GIM_Try, /*On fail goto*//*Label 3342*/ GIMT_Encode4(172865), // Rule ID 1411 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 654:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1411,
        GIR_EraseRootFromParent_Done,
      // Label 3342: @172865
      GIM_Try, /*On fail goto*//*Label 3343*/ GIMT_Encode4(172910), // Rule ID 1412 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 655:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQDMULHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1412,
        GIR_EraseRootFromParent_Done,
      // Label 3343: @172910
      GIM_Try, /*On fail goto*//*Label 3344*/ GIMT_Encode4(172955), // Rule ID 1413 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 655:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQDMULHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1413,
        GIR_EraseRootFromParent_Done,
      // Label 3344: @172955
      GIM_Try, /*On fail goto*//*Label 3345*/ GIMT_Encode4(173000), // Rule ID 1414 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 655:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQDMULHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1414,
        GIR_EraseRootFromParent_Done,
      // Label 3345: @173000
      GIM_Try, /*On fail goto*//*Label 3346*/ GIMT_Encode4(173045), // Rule ID 1415 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 655:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQDMULHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1415,
        GIR_EraseRootFromParent_Done,
      // Label 3346: @173045
      GIM_Try, /*On fail goto*//*Label 3347*/ GIMT_Encode4(173090), // Rule ID 1416 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 663:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRDMULHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1416,
        GIR_EraseRootFromParent_Done,
      // Label 3347: @173090
      GIM_Try, /*On fail goto*//*Label 3348*/ GIMT_Encode4(173135), // Rule ID 1417 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 663:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRDMULHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1417,
        GIR_EraseRootFromParent_Done,
      // Label 3348: @173135
      GIM_Try, /*On fail goto*//*Label 3349*/ GIMT_Encode4(173180), // Rule ID 1418 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 663:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRDMULHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1418,
        GIR_EraseRootFromParent_Done,
      // Label 3349: @173180
      GIM_Try, /*On fail goto*//*Label 3350*/ GIMT_Encode4(173225), // Rule ID 1419 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 663:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRDMULHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1419,
        GIR_EraseRootFromParent_Done,
      // Label 3350: @173225
      GIM_Try, /*On fail goto*//*Label 3351*/ GIMT_Encode4(173270), // Rule ID 1420 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i8] } 666:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQRSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1420,
        GIR_EraseRootFromParent_Done,
      // Label 3351: @173270
      GIM_Try, /*On fail goto*//*Label 3352*/ GIMT_Encode4(173315), // Rule ID 1421 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 666:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQRSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1421,
        GIR_EraseRootFromParent_Done,
      // Label 3352: @173315
      GIM_Try, /*On fail goto*//*Label 3353*/ GIMT_Encode4(173360), // Rule ID 1422 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 666:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1422,
        GIR_EraseRootFromParent_Done,
      // Label 3353: @173360
      GIM_Try, /*On fail goto*//*Label 3354*/ GIMT_Encode4(173405), // Rule ID 1423 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 666:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1423,
        GIR_EraseRootFromParent_Done,
      // Label 3354: @173405
      GIM_Try, /*On fail goto*//*Label 3355*/ GIMT_Encode4(173450), // Rule ID 1424 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 666:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1424,
        GIR_EraseRootFromParent_Done,
      // Label 3355: @173450
      GIM_Try, /*On fail goto*//*Label 3356*/ GIMT_Encode4(173495), // Rule ID 1425 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 666:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1425,
        GIR_EraseRootFromParent_Done,
      // Label 3356: @173495
      GIM_Try, /*On fail goto*//*Label 3357*/ GIMT_Encode4(173540), // Rule ID 1426 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 666:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQRSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1426,
        GIR_EraseRootFromParent_Done,
      // Label 3357: @173540
      GIM_Try, /*On fail goto*//*Label 3358*/ GIMT_Encode4(173585), // Rule ID 1427 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i8] } 669:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1427,
        GIR_EraseRootFromParent_Done,
      // Label 3358: @173585
      GIM_Try, /*On fail goto*//*Label 3359*/ GIMT_Encode4(173630), // Rule ID 1428 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 669:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1428,
        GIR_EraseRootFromParent_Done,
      // Label 3359: @173630
      GIM_Try, /*On fail goto*//*Label 3360*/ GIMT_Encode4(173675), // Rule ID 1429 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 669:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1429,
        GIR_EraseRootFromParent_Done,
      // Label 3360: @173675
      GIM_Try, /*On fail goto*//*Label 3361*/ GIMT_Encode4(173720), // Rule ID 1430 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 669:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1430,
        GIR_EraseRootFromParent_Done,
      // Label 3361: @173720
      GIM_Try, /*On fail goto*//*Label 3362*/ GIMT_Encode4(173765), // Rule ID 1431 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 669:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1431,
        GIR_EraseRootFromParent_Done,
      // Label 3362: @173765
      GIM_Try, /*On fail goto*//*Label 3363*/ GIMT_Encode4(173810), // Rule ID 1432 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 669:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1432,
        GIR_EraseRootFromParent_Done,
      // Label 3363: @173810
      GIM_Try, /*On fail goto*//*Label 3364*/ GIMT_Encode4(173855), // Rule ID 1433 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 669:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1433,
        GIR_EraseRootFromParent_Done,
      // Label 3364: @173855
      GIM_Try, /*On fail goto*//*Label 3365*/ GIMT_Encode4(173900), // Rule ID 1434 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i8] } 673:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1434,
        GIR_EraseRootFromParent_Done,
      // Label 3365: @173900
      GIM_Try, /*On fail goto*//*Label 3366*/ GIMT_Encode4(173945), // Rule ID 1435 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 673:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1435,
        GIR_EraseRootFromParent_Done,
      // Label 3366: @173945
      GIM_Try, /*On fail goto*//*Label 3367*/ GIMT_Encode4(173990), // Rule ID 1436 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 673:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1436,
        GIR_EraseRootFromParent_Done,
      // Label 3367: @173990
      GIM_Try, /*On fail goto*//*Label 3368*/ GIMT_Encode4(174035), // Rule ID 1437 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 673:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1437,
        GIR_EraseRootFromParent_Done,
      // Label 3368: @174035
      GIM_Try, /*On fail goto*//*Label 3369*/ GIMT_Encode4(174080), // Rule ID 1438 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 673:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1438,
        GIR_EraseRootFromParent_Done,
      // Label 3369: @174080
      GIM_Try, /*On fail goto*//*Label 3370*/ GIMT_Encode4(174125), // Rule ID 1439 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 673:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1439,
        GIR_EraseRootFromParent_Done,
      // Label 3370: @174125
      GIM_Try, /*On fail goto*//*Label 3371*/ GIMT_Encode4(174170), // Rule ID 1440 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 673:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1440,
        GIR_EraseRootFromParent_Done,
      // Label 3371: @174170
      GIM_Try, /*On fail goto*//*Label 3372*/ GIMT_Encode4(174215), // Rule ID 1447 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i8] } 677:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SRSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1447,
        GIR_EraseRootFromParent_Done,
      // Label 3372: @174215
      GIM_Try, /*On fail goto*//*Label 3373*/ GIMT_Encode4(174260), // Rule ID 1448 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 677:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SRSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1448,
        GIR_EraseRootFromParent_Done,
      // Label 3373: @174260
      GIM_Try, /*On fail goto*//*Label 3374*/ GIMT_Encode4(174305), // Rule ID 1449 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 677:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SRSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1449,
        GIR_EraseRootFromParent_Done,
      // Label 3374: @174305
      GIM_Try, /*On fail goto*//*Label 3375*/ GIMT_Encode4(174350), // Rule ID 1450 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 677:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SRSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1450,
        GIR_EraseRootFromParent_Done,
      // Label 3375: @174350
      GIM_Try, /*On fail goto*//*Label 3376*/ GIMT_Encode4(174395), // Rule ID 1451 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 677:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SRSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1451,
        GIR_EraseRootFromParent_Done,
      // Label 3376: @174395
      GIM_Try, /*On fail goto*//*Label 3377*/ GIMT_Encode4(174440), // Rule ID 1452 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 677:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SRSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1452,
        GIR_EraseRootFromParent_Done,
      // Label 3377: @174440
      GIM_Try, /*On fail goto*//*Label 3378*/ GIMT_Encode4(174485), // Rule ID 1453 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 677:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SRSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1453,
        GIR_EraseRootFromParent_Done,
      // Label 3378: @174485
      GIM_Try, /*On fail goto*//*Label 3379*/ GIMT_Encode4(174530), // Rule ID 1454 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i8] } 678:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1454,
        GIR_EraseRootFromParent_Done,
      // Label 3379: @174530
      GIM_Try, /*On fail goto*//*Label 3380*/ GIMT_Encode4(174575), // Rule ID 1455 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 678:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1455,
        GIR_EraseRootFromParent_Done,
      // Label 3380: @174575
      GIM_Try, /*On fail goto*//*Label 3381*/ GIMT_Encode4(174620), // Rule ID 1456 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 678:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1456,
        GIR_EraseRootFromParent_Done,
      // Label 3381: @174620
      GIM_Try, /*On fail goto*//*Label 3382*/ GIMT_Encode4(174665), // Rule ID 1457 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 678:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1457,
        GIR_EraseRootFromParent_Done,
      // Label 3382: @174665
      GIM_Try, /*On fail goto*//*Label 3383*/ GIMT_Encode4(174710), // Rule ID 1458 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 678:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1458,
        GIR_EraseRootFromParent_Done,
      // Label 3383: @174710
      GIM_Try, /*On fail goto*//*Label 3384*/ GIMT_Encode4(174755), // Rule ID 1459 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 678:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1459,
        GIR_EraseRootFromParent_Done,
      // Label 3384: @174755
      GIM_Try, /*On fail goto*//*Label 3385*/ GIMT_Encode4(174800), // Rule ID 1460 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 678:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1460,
        GIR_EraseRootFromParent_Done,
      // Label 3385: @174800
      GIM_Try, /*On fail goto*//*Label 3386*/ GIMT_Encode4(174845), // Rule ID 1481 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i8] } 699:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UABDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1481,
        GIR_EraseRootFromParent_Done,
      // Label 3386: @174845
      GIM_Try, /*On fail goto*//*Label 3387*/ GIMT_Encode4(174890), // Rule ID 1483 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 699:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UABDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1483,
        GIR_EraseRootFromParent_Done,
      // Label 3387: @174890
      GIM_Try, /*On fail goto*//*Label 3388*/ GIMT_Encode4(174935), // Rule ID 1485 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 699:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UABDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1485,
        GIR_EraseRootFromParent_Done,
      // Label 3388: @174935
      GIM_Try, /*On fail goto*//*Label 3389*/ GIMT_Encode4(174980), // Rule ID 1487 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 699:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UABDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1487,
        GIR_EraseRootFromParent_Done,
      // Label 3389: @174980
      GIM_Try, /*On fail goto*//*Label 3390*/ GIMT_Encode4(175025), // Rule ID 1489 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 699:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UABDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1489,
        GIR_EraseRootFromParent_Done,
      // Label 3390: @175025
      GIM_Try, /*On fail goto*//*Label 3391*/ GIMT_Encode4(175070), // Rule ID 1491 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 699:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UABDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1491,
        GIR_EraseRootFromParent_Done,
      // Label 3391: @175070
      GIM_Try, /*On fail goto*//*Label 3392*/ GIMT_Encode4(175115), // Rule ID 1498 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i8] } 705:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UHSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1498,
        GIR_EraseRootFromParent_Done,
      // Label 3392: @175115
      GIM_Try, /*On fail goto*//*Label 3393*/ GIMT_Encode4(175160), // Rule ID 1499 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 705:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UHSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1499,
        GIR_EraseRootFromParent_Done,
      // Label 3393: @175160
      GIM_Try, /*On fail goto*//*Label 3394*/ GIMT_Encode4(175205), // Rule ID 1500 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 705:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UHSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1500,
        GIR_EraseRootFromParent_Done,
      // Label 3394: @175205
      GIM_Try, /*On fail goto*//*Label 3395*/ GIMT_Encode4(175250), // Rule ID 1501 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 705:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UHSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1501,
        GIR_EraseRootFromParent_Done,
      // Label 3395: @175250
      GIM_Try, /*On fail goto*//*Label 3396*/ GIMT_Encode4(175295), // Rule ID 1502 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 705:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UHSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1502,
        GIR_EraseRootFromParent_Done,
      // Label 3396: @175295
      GIM_Try, /*On fail goto*//*Label 3397*/ GIMT_Encode4(175340), // Rule ID 1503 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 705:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UHSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1503,
        GIR_EraseRootFromParent_Done,
      // Label 3397: @175340
      GIM_Try, /*On fail goto*//*Label 3398*/ GIMT_Encode4(175385), // Rule ID 1504 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i8] } 707:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMAXPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1504,
        GIR_EraseRootFromParent_Done,
      // Label 3398: @175385
      GIM_Try, /*On fail goto*//*Label 3399*/ GIMT_Encode4(175430), // Rule ID 1505 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 707:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMAXPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1505,
        GIR_EraseRootFromParent_Done,
      // Label 3399: @175430
      GIM_Try, /*On fail goto*//*Label 3400*/ GIMT_Encode4(175475), // Rule ID 1506 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 707:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMAXPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1506,
        GIR_EraseRootFromParent_Done,
      // Label 3400: @175475
      GIM_Try, /*On fail goto*//*Label 3401*/ GIMT_Encode4(175520), // Rule ID 1507 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 707:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMAXPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1507,
        GIR_EraseRootFromParent_Done,
      // Label 3401: @175520
      GIM_Try, /*On fail goto*//*Label 3402*/ GIMT_Encode4(175565), // Rule ID 1508 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 707:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMAXPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1508,
        GIR_EraseRootFromParent_Done,
      // Label 3402: @175565
      GIM_Try, /*On fail goto*//*Label 3403*/ GIMT_Encode4(175610), // Rule ID 1509 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 707:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMAXPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1509,
        GIR_EraseRootFromParent_Done,
      // Label 3403: @175610
      GIM_Try, /*On fail goto*//*Label 3404*/ GIMT_Encode4(175655), // Rule ID 1516 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i8] } 710:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMINPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1516,
        GIR_EraseRootFromParent_Done,
      // Label 3404: @175655
      GIM_Try, /*On fail goto*//*Label 3405*/ GIMT_Encode4(175700), // Rule ID 1517 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 710:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMINPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1517,
        GIR_EraseRootFromParent_Done,
      // Label 3405: @175700
      GIM_Try, /*On fail goto*//*Label 3406*/ GIMT_Encode4(175745), // Rule ID 1518 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 710:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMINPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1518,
        GIR_EraseRootFromParent_Done,
      // Label 3406: @175745
      GIM_Try, /*On fail goto*//*Label 3407*/ GIMT_Encode4(175790), // Rule ID 1519 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 710:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMINPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1519,
        GIR_EraseRootFromParent_Done,
      // Label 3407: @175790
      GIM_Try, /*On fail goto*//*Label 3408*/ GIMT_Encode4(175835), // Rule ID 1520 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 710:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMINPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1520,
        GIR_EraseRootFromParent_Done,
      // Label 3408: @175835
      GIM_Try, /*On fail goto*//*Label 3409*/ GIMT_Encode4(175880), // Rule ID 1521 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 710:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMINPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1521,
        GIR_EraseRootFromParent_Done,
      // Label 3409: @175880
      GIM_Try, /*On fail goto*//*Label 3410*/ GIMT_Encode4(175925), // Rule ID 1528 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i8] } 714:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1528,
        GIR_EraseRootFromParent_Done,
      // Label 3410: @175925
      GIM_Try, /*On fail goto*//*Label 3411*/ GIMT_Encode4(175970), // Rule ID 1529 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 714:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1529,
        GIR_EraseRootFromParent_Done,
      // Label 3411: @175970
      GIM_Try, /*On fail goto*//*Label 3412*/ GIMT_Encode4(176015), // Rule ID 1530 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 714:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1530,
        GIR_EraseRootFromParent_Done,
      // Label 3412: @176015
      GIM_Try, /*On fail goto*//*Label 3413*/ GIMT_Encode4(176060), // Rule ID 1531 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 714:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1531,
        GIR_EraseRootFromParent_Done,
      // Label 3413: @176060
      GIM_Try, /*On fail goto*//*Label 3414*/ GIMT_Encode4(176105), // Rule ID 1532 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 714:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1532,
        GIR_EraseRootFromParent_Done,
      // Label 3414: @176105
      GIM_Try, /*On fail goto*//*Label 3415*/ GIMT_Encode4(176150), // Rule ID 1533 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 714:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1533,
        GIR_EraseRootFromParent_Done,
      // Label 3415: @176150
      GIM_Try, /*On fail goto*//*Label 3416*/ GIMT_Encode4(176195), // Rule ID 1534 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 714:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1534,
        GIR_EraseRootFromParent_Done,
      // Label 3416: @176195
      GIM_Try, /*On fail goto*//*Label 3417*/ GIMT_Encode4(176240), // Rule ID 1535 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i8] } 715:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQRSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1535,
        GIR_EraseRootFromParent_Done,
      // Label 3417: @176240
      GIM_Try, /*On fail goto*//*Label 3418*/ GIMT_Encode4(176285), // Rule ID 1536 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 715:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQRSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1536,
        GIR_EraseRootFromParent_Done,
      // Label 3418: @176285
      GIM_Try, /*On fail goto*//*Label 3419*/ GIMT_Encode4(176330), // Rule ID 1537 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 715:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQRSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1537,
        GIR_EraseRootFromParent_Done,
      // Label 3419: @176330
      GIM_Try, /*On fail goto*//*Label 3420*/ GIMT_Encode4(176375), // Rule ID 1538 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 715:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQRSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1538,
        GIR_EraseRootFromParent_Done,
      // Label 3420: @176375
      GIM_Try, /*On fail goto*//*Label 3421*/ GIMT_Encode4(176420), // Rule ID 1539 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 715:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQRSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1539,
        GIR_EraseRootFromParent_Done,
      // Label 3421: @176420
      GIM_Try, /*On fail goto*//*Label 3422*/ GIMT_Encode4(176465), // Rule ID 1540 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 715:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQRSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1540,
        GIR_EraseRootFromParent_Done,
      // Label 3422: @176465
      GIM_Try, /*On fail goto*//*Label 3423*/ GIMT_Encode4(176510), // Rule ID 1541 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 715:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQRSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1541,
        GIR_EraseRootFromParent_Done,
      // Label 3423: @176510
      GIM_Try, /*On fail goto*//*Label 3424*/ GIMT_Encode4(176555), // Rule ID 1542 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i8] } 717:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1542,
        GIR_EraseRootFromParent_Done,
      // Label 3424: @176555
      GIM_Try, /*On fail goto*//*Label 3425*/ GIMT_Encode4(176600), // Rule ID 1543 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 717:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1543,
        GIR_EraseRootFromParent_Done,
      // Label 3425: @176600
      GIM_Try, /*On fail goto*//*Label 3426*/ GIMT_Encode4(176645), // Rule ID 1544 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 717:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1544,
        GIR_EraseRootFromParent_Done,
      // Label 3426: @176645
      GIM_Try, /*On fail goto*//*Label 3427*/ GIMT_Encode4(176690), // Rule ID 1545 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 717:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1545,
        GIR_EraseRootFromParent_Done,
      // Label 3427: @176690
      GIM_Try, /*On fail goto*//*Label 3428*/ GIMT_Encode4(176735), // Rule ID 1546 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 717:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1546,
        GIR_EraseRootFromParent_Done,
      // Label 3428: @176735
      GIM_Try, /*On fail goto*//*Label 3429*/ GIMT_Encode4(176780), // Rule ID 1547 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 717:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1547,
        GIR_EraseRootFromParent_Done,
      // Label 3429: @176780
      GIM_Try, /*On fail goto*//*Label 3430*/ GIMT_Encode4(176825), // Rule ID 1548 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 717:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1548,
        GIR_EraseRootFromParent_Done,
      // Label 3430: @176825
      GIM_Try, /*On fail goto*//*Label 3431*/ GIMT_Encode4(176870), // Rule ID 1549 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i8] } 719:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1549,
        GIR_EraseRootFromParent_Done,
      // Label 3431: @176870
      GIM_Try, /*On fail goto*//*Label 3432*/ GIMT_Encode4(176915), // Rule ID 1550 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 719:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1550,
        GIR_EraseRootFromParent_Done,
      // Label 3432: @176915
      GIM_Try, /*On fail goto*//*Label 3433*/ GIMT_Encode4(176960), // Rule ID 1551 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 719:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1551,
        GIR_EraseRootFromParent_Done,
      // Label 3433: @176960
      GIM_Try, /*On fail goto*//*Label 3434*/ GIMT_Encode4(177005), // Rule ID 1552 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 719:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1552,
        GIR_EraseRootFromParent_Done,
      // Label 3434: @177005
      GIM_Try, /*On fail goto*//*Label 3435*/ GIMT_Encode4(177050), // Rule ID 1553 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 719:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1553,
        GIR_EraseRootFromParent_Done,
      // Label 3435: @177050
      GIM_Try, /*On fail goto*//*Label 3436*/ GIMT_Encode4(177095), // Rule ID 1554 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 719:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1554,
        GIR_EraseRootFromParent_Done,
      // Label 3436: @177095
      GIM_Try, /*On fail goto*//*Label 3437*/ GIMT_Encode4(177140), // Rule ID 1555 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 719:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1555,
        GIR_EraseRootFromParent_Done,
      // Label 3437: @177140
      GIM_Try, /*On fail goto*//*Label 3438*/ GIMT_Encode4(177185), // Rule ID 1562 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i8] } 723:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (URSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1562,
        GIR_EraseRootFromParent_Done,
      // Label 3438: @177185
      GIM_Try, /*On fail goto*//*Label 3439*/ GIMT_Encode4(177230), // Rule ID 1563 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 723:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (URSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1563,
        GIR_EraseRootFromParent_Done,
      // Label 3439: @177230
      GIM_Try, /*On fail goto*//*Label 3440*/ GIMT_Encode4(177275), // Rule ID 1564 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 723:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (URSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1564,
        GIR_EraseRootFromParent_Done,
      // Label 3440: @177275
      GIM_Try, /*On fail goto*//*Label 3441*/ GIMT_Encode4(177320), // Rule ID 1565 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 723:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (URSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1565,
        GIR_EraseRootFromParent_Done,
      // Label 3441: @177320
      GIM_Try, /*On fail goto*//*Label 3442*/ GIMT_Encode4(177365), // Rule ID 1566 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 723:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (URSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1566,
        GIR_EraseRootFromParent_Done,
      // Label 3442: @177365
      GIM_Try, /*On fail goto*//*Label 3443*/ GIMT_Encode4(177410), // Rule ID 1567 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 723:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (URSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1567,
        GIR_EraseRootFromParent_Done,
      // Label 3443: @177410
      GIM_Try, /*On fail goto*//*Label 3444*/ GIMT_Encode4(177455), // Rule ID 1568 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 723:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (URSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1568,
        GIR_EraseRootFromParent_Done,
      // Label 3444: @177455
      GIM_Try, /*On fail goto*//*Label 3445*/ GIMT_Encode4(177500), // Rule ID 1569 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i8] } 726:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (USHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1569,
        GIR_EraseRootFromParent_Done,
      // Label 3445: @177500
      GIM_Try, /*On fail goto*//*Label 3446*/ GIMT_Encode4(177545), // Rule ID 1570 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 726:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (USHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1570,
        GIR_EraseRootFromParent_Done,
      // Label 3446: @177545
      GIM_Try, /*On fail goto*//*Label 3447*/ GIMT_Encode4(177590), // Rule ID 1571 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 726:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (USHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1571,
        GIR_EraseRootFromParent_Done,
      // Label 3447: @177590
      GIM_Try, /*On fail goto*//*Label 3448*/ GIMT_Encode4(177635), // Rule ID 1572 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 726:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (USHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1572,
        GIR_EraseRootFromParent_Done,
      // Label 3448: @177635
      GIM_Try, /*On fail goto*//*Label 3449*/ GIMT_Encode4(177680), // Rule ID 1573 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 726:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (USHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1573,
        GIR_EraseRootFromParent_Done,
      // Label 3449: @177680
      GIM_Try, /*On fail goto*//*Label 3450*/ GIMT_Encode4(177725), // Rule ID 1574 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 726:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (USHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1574,
        GIR_EraseRootFromParent_Done,
      // Label 3450: @177725
      GIM_Try, /*On fail goto*//*Label 3451*/ GIMT_Encode4(177770), // Rule ID 1575 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 726:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (USHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1575,
        GIR_EraseRootFromParent_Done,
      // Label 3451: @177770
      GIM_Try, /*On fail goto*//*Label 3452*/ GIMT_Encode4(177815), // Rule ID 1603 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[f64] } 760:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FABD64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1603,
        GIR_EraseRootFromParent_Done,
      // Label 3452: @177815
      GIM_Try, /*On fail goto*//*Label 3453*/ GIMT_Encode4(177860), // Rule ID 1604 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[f32] } 760:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FABD32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1604,
        GIR_EraseRootFromParent_Done,
      // Label 3453: @177860
      GIM_Try, /*On fail goto*//*Label 3454*/ GIMT_Encode4(177905), // Rule ID 1605 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (intrinsic_wo_chain:{ *:[f16] } 760:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FABD16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1605,
        GIR_EraseRootFromParent_Done,
      // Label 3454: @177905
      GIM_Try, /*On fail goto*//*Label 3455*/ GIMT_Encode4(177950), // Rule ID 1606 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 572:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FACGE64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1606,
        GIR_EraseRootFromParent_Done,
      // Label 3455: @177950
      GIM_Try, /*On fail goto*//*Label 3456*/ GIMT_Encode4(177995), // Rule ID 1607 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 572:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FACGE32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1607,
        GIR_EraseRootFromParent_Done,
      // Label 3456: @177995
      GIM_Try, /*On fail goto*//*Label 3457*/ GIMT_Encode4(178040), // Rule ID 1608 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 573:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FACGT64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1608,
        GIR_EraseRootFromParent_Done,
      // Label 3457: @178040
      GIM_Try, /*On fail goto*//*Label 3458*/ GIMT_Encode4(178085), // Rule ID 1609 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 573:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FACGT32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1609,
        GIR_EraseRootFromParent_Done,
      // Label 3458: @178085
      GIM_Try, /*On fail goto*//*Label 3459*/ GIMT_Encode4(178130), // Rule ID 1616 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[f64] } 605:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMULX64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1616,
        GIR_EraseRootFromParent_Done,
      // Label 3459: @178130
      GIM_Try, /*On fail goto*//*Label 3460*/ GIMT_Encode4(178175), // Rule ID 1617 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[f32] } 605:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMULX32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1617,
        GIR_EraseRootFromParent_Done,
      // Label 3460: @178175
      GIM_Try, /*On fail goto*//*Label 3461*/ GIMT_Encode4(178220), // Rule ID 1618 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (intrinsic_wo_chain:{ *:[f16] } 605:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMULX16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1618,
        GIR_EraseRootFromParent_Done,
      // Label 3461: @178220
      GIM_Try, /*On fail goto*//*Label 3462*/ GIMT_Encode4(178265), // Rule ID 1619 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[f64] } 608:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FRECPS64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1619,
        GIR_EraseRootFromParent_Done,
      // Label 3462: @178265
      GIM_Try, /*On fail goto*//*Label 3463*/ GIMT_Encode4(178310), // Rule ID 1620 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[f32] } 608:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FRECPS32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1620,
        GIR_EraseRootFromParent_Done,
      // Label 3463: @178310
      GIM_Try, /*On fail goto*//*Label 3464*/ GIMT_Encode4(178355), // Rule ID 1621 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (intrinsic_wo_chain:{ *:[f16] } 608:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FRECPS16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1621,
        GIR_EraseRootFromParent_Done,
      // Label 3464: @178355
      GIM_Try, /*On fail goto*//*Label 3465*/ GIMT_Encode4(178400), // Rule ID 1622 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[f64] } 615:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FRSQRTS64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1622,
        GIR_EraseRootFromParent_Done,
      // Label 3465: @178400
      GIM_Try, /*On fail goto*//*Label 3466*/ GIMT_Encode4(178445), // Rule ID 1623 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[f32] } 615:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FRSQRTS32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1623,
        GIR_EraseRootFromParent_Done,
      // Label 3466: @178445
      GIM_Try, /*On fail goto*//*Label 3467*/ GIMT_Encode4(178490), // Rule ID 1624 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (intrinsic_wo_chain:{ *:[f16] } 615:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FRSQRTS16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1624,
        GIR_EraseRootFromParent_Done,
      // Label 3467: @178490
      GIM_Try, /*On fail goto*//*Label 3468*/ GIMT_Encode4(178535), // Rule ID 1625 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1i64] } 654:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1625,
        GIR_EraseRootFromParent_Done,
      // Label 3468: @178535
      GIM_Try, /*On fail goto*//*Label 3469*/ GIMT_Encode4(178580), // Rule ID 1626 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 655:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQDMULHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv1i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1626,
        GIR_EraseRootFromParent_Done,
      // Label 3469: @178580
      GIM_Try, /*On fail goto*//*Label 3470*/ GIMT_Encode4(178625), // Rule ID 1627 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 663:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRDMULHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv1i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1627,
        GIR_EraseRootFromParent_Done,
      // Label 3470: @178625
      GIM_Try, /*On fail goto*//*Label 3471*/ GIMT_Encode4(178670), // Rule ID 1628 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1i64] } 666:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQRSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1628,
        GIR_EraseRootFromParent_Done,
      // Label 3471: @178670
      GIM_Try, /*On fail goto*//*Label 3472*/ GIMT_Encode4(178715), // Rule ID 1629 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1i64] } 669:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1629,
        GIR_EraseRootFromParent_Done,
      // Label 3472: @178715
      GIM_Try, /*On fail goto*//*Label 3473*/ GIMT_Encode4(178760), // Rule ID 1630 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1i64] } 673:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQSUBv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1630,
        GIR_EraseRootFromParent_Done,
      // Label 3473: @178760
      GIM_Try, /*On fail goto*//*Label 3474*/ GIMT_Encode4(178805), // Rule ID 1631 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1i64] } 677:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SRSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1631,
        GIR_EraseRootFromParent_Done,
      // Label 3474: @178805
      GIM_Try, /*On fail goto*//*Label 3475*/ GIMT_Encode4(178850), // Rule ID 1632 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1i64] } 678:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1632,
        GIR_EraseRootFromParent_Done,
      // Label 3475: @178850
      GIM_Try, /*On fail goto*//*Label 3476*/ GIMT_Encode4(178895), // Rule ID 1634 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1i64] } 714:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1634,
        GIR_EraseRootFromParent_Done,
      // Label 3476: @178895
      GIM_Try, /*On fail goto*//*Label 3477*/ GIMT_Encode4(178940), // Rule ID 1635 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1i64] } 715:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQRSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1635,
        GIR_EraseRootFromParent_Done,
      // Label 3477: @178940
      GIM_Try, /*On fail goto*//*Label 3478*/ GIMT_Encode4(178985), // Rule ID 1636 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1i64] } 717:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1636,
        GIR_EraseRootFromParent_Done,
      // Label 3478: @178985
      GIM_Try, /*On fail goto*//*Label 3479*/ GIMT_Encode4(179030), // Rule ID 1637 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1i64] } 719:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQSUBv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1637,
        GIR_EraseRootFromParent_Done,
      // Label 3479: @179030
      GIM_Try, /*On fail goto*//*Label 3480*/ GIMT_Encode4(179075), // Rule ID 1638 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1i64] } 723:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (URSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1638,
        GIR_EraseRootFromParent_Done,
      // Label 3480: @179075
      GIM_Try, /*On fail goto*//*Label 3481*/ GIMT_Encode4(179120), // Rule ID 1639 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1i64] } 726:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (USHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1639,
        GIR_EraseRootFromParent_Done,
      // Label 3481: @179120
      GIM_Try, /*On fail goto*//*Label 3482*/ GIMT_Encode4(179165), // Rule ID 1640 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 659:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQDMULLi32:{ *:[i64] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLi32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1640,
        GIR_EraseRootFromParent_Done,
      // Label 3482: @179165
      GIM_Try, /*On fail goto*//*Label 3483*/ GIMT_Encode4(179210), // Rule ID 1654 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 690:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)  =>  (SUQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1654,
        GIR_EraseRootFromParent_Done,
      // Label 3483: @179210
      GIM_Try, /*On fail goto*//*Label 3484*/ GIMT_Encode4(179255), // Rule ID 1655 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 690:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)  =>  (SUQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv1i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1655,
        GIR_EraseRootFromParent_Done,
      // Label 3484: @179255
      GIM_Try, /*On fail goto*//*Label 3485*/ GIMT_Encode4(179300), // Rule ID 1660 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 729:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)  =>  (USQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1660,
        GIR_EraseRootFromParent_Done,
      // Label 3485: @179300
      GIM_Try, /*On fail goto*//*Label 3486*/ GIMT_Encode4(179345), // Rule ID 1661 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 729:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)  =>  (USQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv1i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1661,
        GIR_EraseRootFromParent_Done,
      // Label 3486: @179345
      GIM_Try, /*On fail goto*//*Label 3487*/ GIMT_Encode4(179390), // Rule ID 1662 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i8] } 561:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1662,
        GIR_EraseRootFromParent_Done,
      // Label 3487: @179390
      GIM_Try, /*On fail goto*//*Label 3488*/ GIMT_Encode4(179435), // Rule ID 1663 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 561:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1663,
        GIR_EraseRootFromParent_Done,
      // Label 3488: @179435
      GIM_Try, /*On fail goto*//*Label 3489*/ GIMT_Encode4(179480), // Rule ID 1664 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 561:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1664,
        GIR_EraseRootFromParent_Done,
      // Label 3489: @179480
      GIM_Try, /*On fail goto*//*Label 3490*/ GIMT_Encode4(179525), // Rule ID 1665 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i8] } 689:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1665,
        GIR_EraseRootFromParent_Done,
      // Label 3490: @179525
      GIM_Try, /*On fail goto*//*Label 3491*/ GIMT_Encode4(179570), // Rule ID 1666 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 689:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1666,
        GIR_EraseRootFromParent_Done,
      // Label 3491: @179570
      GIM_Try, /*On fail goto*//*Label 3492*/ GIMT_Encode4(179615), // Rule ID 1667 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 689:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1667,
        GIR_EraseRootFromParent_Done,
      // Label 3492: @179615
      GIM_Try, /*On fail goto*//*Label 3493*/ GIMT_Encode4(179660), // Rule ID 1668 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i8] } 631:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (RADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1668,
        GIR_EraseRootFromParent_Done,
      // Label 3493: @179660
      GIM_Try, /*On fail goto*//*Label 3494*/ GIMT_Encode4(179705), // Rule ID 1669 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 631:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (RADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1669,
        GIR_EraseRootFromParent_Done,
      // Label 3494: @179705
      GIM_Try, /*On fail goto*//*Label 3495*/ GIMT_Encode4(179750), // Rule ID 1670 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 631:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (RADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1670,
        GIR_EraseRootFromParent_Done,
      // Label 3495: @179750
      GIM_Try, /*On fail goto*//*Label 3496*/ GIMT_Encode4(179795), // Rule ID 1671 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i8] } 633:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (RSUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv8i16_v8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1671,
        GIR_EraseRootFromParent_Done,
      // Label 3496: @179795
      GIM_Try, /*On fail goto*//*Label 3497*/ GIMT_Encode4(179840), // Rule ID 1672 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 633:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (RSUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv4i32_v4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1672,
        GIR_EraseRootFromParent_Done,
      // Label 3497: @179840
      GIM_Try, /*On fail goto*//*Label 3498*/ GIMT_Encode4(179885), // Rule ID 1673 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 633:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (RSUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv2i64_v2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1673,
        GIR_EraseRootFromParent_Done,
      // Label 3498: @179885
      GIM_Try, /*On fail goto*//*Label 3499*/ GIMT_Encode4(179930), // Rule ID 1739 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 658:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQDMULLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1739,
        GIR_EraseRootFromParent_Done,
      // Label 3499: @179930
      GIM_Try, /*On fail goto*//*Label 3500*/ GIMT_Encode4(179975), // Rule ID 1741 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 658:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQDMULLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1741,
        GIR_EraseRootFromParent_Done,
      // Label 3500: @179975
      GIM_Try, /*On fail goto*//*Label 3501*/ GIMT_Encode4(180020), // Rule ID 2290 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aese),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 504:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (AESErr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESErr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2290,
        GIR_EraseRootFromParent_Done,
      // Label 3501: @180020
      GIM_Try, /*On fail goto*//*Label 3502*/ GIMT_Encode4(180065), // Rule ID 2291 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 503:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (AESDrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESDrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2291,
        GIR_EraseRootFromParent_Done,
      // Label 3502: @180065
      GIM_Try, /*On fail goto*//*Label 3503*/ GIMT_Encode4(180110), // Rule ID 2302 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1su1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 517:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (SHA1SU1rr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1SU1rr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2302,
        GIR_EraseRootFromParent_Done,
      // Label 3503: @180110
      GIM_Try, /*On fail goto*//*Label 3504*/ GIMT_Encode4(180155), // Rule ID 2303 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256su0),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 520:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (SHA256SU0rr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256SU0rr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2303,
        GIR_EraseRootFromParent_Done,
      // Label 3504: @180155
      GIM_Try, /*On fail goto*//*Label 3505*/ GIMT_Encode4(180200), // Rule ID 2326 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f16] } 606:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (FSCALEv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2326,
        GIR_EraseRootFromParent_Done,
      // Label 3505: @180200
      GIM_Try, /*On fail goto*//*Label 3506*/ GIMT_Encode4(180245), // Rule ID 2327 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8f16] } 606:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (FSCALEv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2327,
        GIR_EraseRootFromParent_Done,
      // Label 3506: @180245
      GIM_Try, /*On fail goto*//*Label 3507*/ GIMT_Encode4(180290), // Rule ID 2328 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f32] } 606:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (FSCALEv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2328,
        GIR_EraseRootFromParent_Done,
      // Label 3507: @180290
      GIM_Try, /*On fail goto*//*Label 3508*/ GIMT_Encode4(180335), // Rule ID 2329 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 606:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (FSCALEv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2329,
        GIR_EraseRootFromParent_Done,
      // Label 3508: @180335
      GIM_Try, /*On fail goto*//*Label 3509*/ GIMT_Encode4(180380), // Rule ID 2330 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f64] } 606:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (FSCALEv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2330,
        GIR_EraseRootFromParent_Done,
      // Label 3509: @180380
      GIM_Try, /*On fail goto*//*Label 3510*/ GIMT_Encode4(180425), // Rule ID 2331 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f16] } 576:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FAMAXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2331,
        GIR_EraseRootFromParent_Done,
      // Label 3510: @180425
      GIM_Try, /*On fail goto*//*Label 3511*/ GIMT_Encode4(180470), // Rule ID 2334 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8f16] } 576:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FAMAXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2334,
        GIR_EraseRootFromParent_Done,
      // Label 3511: @180470
      GIM_Try, /*On fail goto*//*Label 3512*/ GIMT_Encode4(180515), // Rule ID 2337 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f32] } 576:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FAMAXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2337,
        GIR_EraseRootFromParent_Done,
      // Label 3512: @180515
      GIM_Try, /*On fail goto*//*Label 3513*/ GIMT_Encode4(180560), // Rule ID 2340 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 576:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FAMAXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2340,
        GIR_EraseRootFromParent_Done,
      // Label 3513: @180560
      GIM_Try, /*On fail goto*//*Label 3514*/ GIMT_Encode4(180605), // Rule ID 2343 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f64] } 576:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FAMAXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2343,
        GIR_EraseRootFromParent_Done,
      // Label 3514: @180605
      GIM_Try, /*On fail goto*//*Label 3515*/ GIMT_Encode4(180650), // Rule ID 2346 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f16] } 577:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FAMINv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2346,
        GIR_EraseRootFromParent_Done,
      // Label 3515: @180650
      GIM_Try, /*On fail goto*//*Label 3516*/ GIMT_Encode4(180695), // Rule ID 2349 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8f16] } 577:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FAMINv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2349,
        GIR_EraseRootFromParent_Done,
      // Label 3516: @180695
      GIM_Try, /*On fail goto*//*Label 3517*/ GIMT_Encode4(180740), // Rule ID 2352 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f32] } 577:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FAMINv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2352,
        GIR_EraseRootFromParent_Done,
      // Label 3517: @180740
      GIM_Try, /*On fail goto*//*Label 3518*/ GIMT_Encode4(180785), // Rule ID 2355 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 577:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FAMINv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2355,
        GIR_EraseRootFromParent_Done,
      // Label 3518: @180785
      GIM_Try, /*On fail goto*//*Label 3519*/ GIMT_Encode4(180830), // Rule ID 2358 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f64] } 577:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FAMINv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2358,
        GIR_EraseRootFromParent_Done,
      // Label 3519: @180830
      GIM_Try, /*On fail goto*//*Label 3520*/ GIMT_Encode4(180875), // Rule ID 2473 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 654:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2473,
        GIR_EraseRootFromParent_Done,
      // Label 3520: @180875
      GIM_Try, /*On fail goto*//*Label 3521*/ GIMT_Encode4(180920), // Rule ID 2474 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 654:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv1i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2474,
        GIR_EraseRootFromParent_Done,
      // Label 3521: @180920
      GIM_Try, /*On fail goto*//*Label 3522*/ GIMT_Encode4(180965), // Rule ID 2475 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1f64] } 760:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FABD64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2475,
        GIR_EraseRootFromParent_Done,
      // Label 3522: @180965
      GIM_Try, /*On fail goto*//*Label 3523*/ GIMT_Encode4(181010), // Rule ID 2476 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1i64] } 572:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FACGE64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2476,
        GIR_EraseRootFromParent_Done,
      // Label 3523: @181010
      GIM_Try, /*On fail goto*//*Label 3524*/ GIMT_Encode4(181055), // Rule ID 2481 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1i64] } 690:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)  =>  (SUQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2481,
        GIR_EraseRootFromParent_Done,
      // Label 3524: @181055
      GIM_Try, /*On fail goto*//*Label 3525*/ GIMT_Encode4(181100), // Rule ID 2586 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 1905:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQINCP_WP_B:{ *:[i32] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/3, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2586,
        GIR_EraseRootFromParent_Done,
      // Label 3525: @181100
      GIM_Try, /*On fail goto*//*Label 3526*/ GIMT_Encode4(181145), // Rule ID 2587 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 1905:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQINCP_WP_H:{ *:[i32] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/3, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2587,
        GIR_EraseRootFromParent_Done,
      // Label 3526: @181145
      GIM_Try, /*On fail goto*//*Label 3527*/ GIMT_Encode4(181190), // Rule ID 2588 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 1905:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQINCP_WP_S:{ *:[i32] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/3, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2588,
        GIR_EraseRootFromParent_Done,
      // Label 3527: @181190
      GIM_Try, /*On fail goto*//*Label 3528*/ GIMT_Encode4(181235), // Rule ID 2589 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 1905:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQINCP_WP_D:{ *:[i32] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/3, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2589,
        GIR_EraseRootFromParent_Done,
      // Label 3528: @181235
      GIM_Try, /*On fail goto*//*Label 3529*/ GIMT_Encode4(181280), // Rule ID 2590 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 1695:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (SQINCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/3, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2590,
        GIR_EraseRootFromParent_Done,
      // Label 3529: @181280
      GIM_Try, /*On fail goto*//*Label 3530*/ GIMT_Encode4(181325), // Rule ID 2591 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 1695:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (SQINCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/3, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2591,
        GIR_EraseRootFromParent_Done,
      // Label 3530: @181325
      GIM_Try, /*On fail goto*//*Label 3531*/ GIMT_Encode4(181370), // Rule ID 2592 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 1695:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (SQINCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/3, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2592,
        GIR_EraseRootFromParent_Done,
      // Label 3531: @181370
      GIM_Try, /*On fail goto*//*Label 3532*/ GIMT_Encode4(181415), // Rule ID 2593 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 1695:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (SQINCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/3, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2593,
        GIR_EraseRootFromParent_Done,
      // Label 3532: @181415
      GIM_Try, /*On fail goto*//*Label 3533*/ GIMT_Encode4(181460), // Rule ID 3795 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512su0),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 524:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512SU0:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512SU0),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vn
        GIR_RootToRootCopy, /*OpIdx*/3, // Vm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3795,
        GIR_EraseRootFromParent_Done,
      // Label 3533: @181460
      GIM_Try, /*On fail goto*//*Label 3534*/ GIMT_Encode4(181505), // Rule ID 3823 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_rax1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 511:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (RAX1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RAX1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vn
        GIR_RootToRootCopy, /*OpIdx*/3, // Vm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3823,
        GIR_EraseRootFromParent_Done,
      // Label 3534: @181505
      GIM_Try, /*On fail goto*//*Label 3535*/ GIMT_Encode4(181550), // Rule ID 3833 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm4ekey),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 534:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM4ENCKEY:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4ENCKEY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vn
        GIR_RootToRootCopy, /*OpIdx*/3, // Vm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3833,
        GIR_EraseRootFromParent_Done,
      // Label 3535: @181550
      GIM_Try, /*On fail goto*//*Label 3536*/ GIMT_Encode4(181595), // Rule ID 3834 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm4e),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 533:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM4E:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4E),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vn
        GIR_RootToRootCopy, /*OpIdx*/3, // Vm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3834,
        GIR_EraseRootFromParent_Done,
      // Label 3536: @181595
      GIM_Try, /*On fail goto*//*Label 3537*/ GIMT_Encode4(181643), // Rule ID 3835 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f16] } 731:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3835,
        GIR_EraseRootFromParent_Done,
      // Label 3537: @181643
      GIM_Try, /*On fail goto*//*Label 3538*/ GIMT_Encode4(181691), // Rule ID 3836 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f16] } 730:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3836,
        GIR_EraseRootFromParent_Done,
      // Label 3538: @181691
      GIM_Try, /*On fail goto*//*Label 3539*/ GIMT_Encode4(181739), // Rule ID 3837 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8f16] } 731:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3837,
        GIR_EraseRootFromParent_Done,
      // Label 3539: @181739
      GIM_Try, /*On fail goto*//*Label 3540*/ GIMT_Encode4(181787), // Rule ID 3838 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8f16] } 730:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3838,
        GIR_EraseRootFromParent_Done,
      // Label 3540: @181787
      GIM_Try, /*On fail goto*//*Label 3541*/ GIMT_Encode4(181835), // Rule ID 3839 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f32] } 731:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3839,
        GIR_EraseRootFromParent_Done,
      // Label 3541: @181835
      GIM_Try, /*On fail goto*//*Label 3542*/ GIMT_Encode4(181883), // Rule ID 3840 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f32] } 730:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3840,
        GIR_EraseRootFromParent_Done,
      // Label 3542: @181883
      GIM_Try, /*On fail goto*//*Label 3543*/ GIMT_Encode4(181931), // Rule ID 3841 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 731:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3841,
        GIR_EraseRootFromParent_Done,
      // Label 3543: @181931
      GIM_Try, /*On fail goto*//*Label 3544*/ GIMT_Encode4(181979), // Rule ID 3842 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 730:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3842,
        GIR_EraseRootFromParent_Done,
      // Label 3544: @181979
      GIM_Try, /*On fail goto*//*Label 3545*/ GIMT_Encode4(182027), // Rule ID 3843 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f64] } 731:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3843,
        GIR_EraseRootFromParent_Done,
      // Label 3545: @182027
      GIM_Try, /*On fail goto*//*Label 3546*/ GIMT_Encode4(182075), // Rule ID 3844 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f64] } 730:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3844,
        GIR_EraseRootFromParent_Done,
      // Label 3546: @182075
      GIM_Try, /*On fail goto*//*Label 3547*/ GIMT_Encode4(182117), // Rule ID 3909 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_udiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 2049:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVWr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3909,
        GIR_EraseRootFromParent_Done,
      // Label 3547: @182117
      GIM_Try, /*On fail goto*//*Label 3548*/ GIMT_Encode4(182159), // Rule ID 3910 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_udiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 2049:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVXr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3910,
        GIR_EraseRootFromParent_Done,
      // Label 3548: @182159
      GIM_Try, /*On fail goto*//*Label 3549*/ GIMT_Encode4(182201), // Rule ID 3911 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 754:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVWr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3911,
        GIR_EraseRootFromParent_Done,
      // Label 3549: @182201
      GIM_Try, /*On fail goto*//*Label 3550*/ GIMT_Encode4(182243), // Rule ID 3912 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 754:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVXr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3912,
        GIR_EraseRootFromParent_Done,
      // Label 3550: @182243
      GIM_Try, /*On fail goto*//*Label 3551*/ GIMT_Encode4(182285), // Rule ID 5243 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1f64] } 571:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FABD64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5243,
        GIR_EraseRootFromParent_Done,
      // Label 3551: @182285
      GIM_Try, /*On fail goto*//*Label 3552*/ GIMT_Encode4(182330), // Rule ID 5247 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1i64] } 573:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FACGT64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5247,
        GIR_EraseRootFromParent_Done,
      // Label 3552: @182330
      GIM_Try, /*On fail goto*//*Label 3553*/ GIMT_Encode4(182375), // Rule ID 5251 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1f64] } 605:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMULX64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5251,
        GIR_EraseRootFromParent_Done,
      // Label 3553: @182375
      GIM_Try, /*On fail goto*//*Label 3554*/ GIMT_Encode4(182420), // Rule ID 5252 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1f64] } 608:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FRECPS64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5252,
        GIR_EraseRootFromParent_Done,
      // Label 3554: @182420
      GIM_Try, /*On fail goto*//*Label 3555*/ GIMT_Encode4(182465), // Rule ID 5253 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1f64] } 615:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FRSQRTS64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5253,
        GIR_EraseRootFromParent_Done,
      // Label 3555: @182465
      GIM_Try, /*On fail goto*//*Label 3556*/ GIMT_Encode4(182510), // Rule ID 5254 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 666:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQRSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5254,
        GIR_EraseRootFromParent_Done,
      // Label 3556: @182510
      GIM_Try, /*On fail goto*//*Label 3557*/ GIMT_Encode4(182555), // Rule ID 5255 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 666:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv1i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5255,
        GIR_EraseRootFromParent_Done,
      // Label 3557: @182555
      GIM_Try, /*On fail goto*//*Label 3558*/ GIMT_Encode4(182600), // Rule ID 5256 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 669:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5256,
        GIR_EraseRootFromParent_Done,
      // Label 3558: @182600
      GIM_Try, /*On fail goto*//*Label 3559*/ GIMT_Encode4(182645), // Rule ID 5257 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 669:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv1i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5257,
        GIR_EraseRootFromParent_Done,
      // Label 3559: @182645
      GIM_Try, /*On fail goto*//*Label 3560*/ GIMT_Encode4(182690), // Rule ID 5258 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 673:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQSUBv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5258,
        GIR_EraseRootFromParent_Done,
      // Label 3560: @182690
      GIM_Try, /*On fail goto*//*Label 3561*/ GIMT_Encode4(182735), // Rule ID 5259 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 673:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQSUBv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv1i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5259,
        GIR_EraseRootFromParent_Done,
      // Label 3561: @182735
      GIM_Try, /*On fail goto*//*Label 3562*/ GIMT_Encode4(182780), // Rule ID 5260 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 714:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5260,
        GIR_EraseRootFromParent_Done,
      // Label 3562: @182780
      GIM_Try, /*On fail goto*//*Label 3563*/ GIMT_Encode4(182825), // Rule ID 5261 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 714:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv1i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5261,
        GIR_EraseRootFromParent_Done,
      // Label 3563: @182825
      GIM_Try, /*On fail goto*//*Label 3564*/ GIMT_Encode4(182870), // Rule ID 5262 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 715:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQRSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5262,
        GIR_EraseRootFromParent_Done,
      // Label 3564: @182870
      GIM_Try, /*On fail goto*//*Label 3565*/ GIMT_Encode4(182915), // Rule ID 5263 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 715:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQRSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv1i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5263,
        GIR_EraseRootFromParent_Done,
      // Label 3565: @182915
      GIM_Try, /*On fail goto*//*Label 3566*/ GIMT_Encode4(182960), // Rule ID 5264 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 717:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5264,
        GIR_EraseRootFromParent_Done,
      // Label 3566: @182960
      GIM_Try, /*On fail goto*//*Label 3567*/ GIMT_Encode4(183005), // Rule ID 5265 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 717:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv1i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5265,
        GIR_EraseRootFromParent_Done,
      // Label 3567: @183005
      GIM_Try, /*On fail goto*//*Label 3568*/ GIMT_Encode4(183050), // Rule ID 5266 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 719:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQSUBv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5266,
        GIR_EraseRootFromParent_Done,
      // Label 3568: @183050
      GIM_Try, /*On fail goto*//*Label 3569*/ GIMT_Encode4(183095), // Rule ID 5267 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 719:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQSUBv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv1i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5267,
        GIR_EraseRootFromParent_Done,
      // Label 3569: @183095
      GIM_Try, /*On fail goto*//*Label 3570*/ GIMT_Encode4(183140), // Rule ID 5285 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v1i64] } 729:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)  =>  (USQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5285,
        GIR_EraseRootFromParent_Done,
      // Label 3570: @183140
      GIM_Try, /*On fail goto*//*Label 3571*/ GIMT_Encode4(183182), // Rule ID 5624 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbl1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i8] } 691:{ *:[iPTR] }, VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)  =>  (TBLv8i8One:{ *:[v8i8] } VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLv8i8One),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Ri
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5624,
        GIR_EraseRootFromParent_Done,
      // Label 3571: @183182
      GIM_Try, /*On fail goto*//*Label 3572*/ GIMT_Encode4(183224), // Rule ID 5625 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbl1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 691:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)  =>  (TBLv16i8One:{ *:[v16i8] } V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLv16i8One),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Ri
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5625,
        GIR_EraseRootFromParent_Done,
      // Label 3572: @183224
      GIM_Try, /*On fail goto*//*Label 3573*/ GIMT_Encode4(183321), // Rule ID 6330 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 572:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FACGE16:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FACGE16),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 6330,
        GIR_EraseRootFromParent_Done,
      // Label 3573: @183321
      GIM_Try, /*On fail goto*//*Label 3574*/ GIMT_Encode4(183418), // Rule ID 6331 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 573:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FACGT16:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FACGT16),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 6331,
        GIR_EraseRootFromParent_Done,
      // Label 3574: @183418
      GIM_Try, /*On fail goto*//*Label 3575*/ GIMT_Encode4(183460), // Rule ID 7095 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 678:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7095,
        GIR_EraseRootFromParent_Done,
      // Label 3575: @183460
      GIM_Try, /*On fail goto*//*Label 3576*/ GIMT_Encode4(183502), // Rule ID 7096 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 726:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (USHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7096,
        GIR_EraseRootFromParent_Done,
      // Label 3576: @183502
      GIM_Try, /*On fail goto*//*Label 3577*/ GIMT_Encode4(183544), // Rule ID 7097 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 677:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SRSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7097,
        GIR_EraseRootFromParent_Done,
      // Label 3577: @183544
      GIM_Try, /*On fail goto*//*Label 3578*/ GIMT_Encode4(183586), // Rule ID 7098 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 723:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (URSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7098,
        GIR_EraseRootFromParent_Done,
      // Label 3578: @183586
      GIM_Try, /*On fail goto*//*Label 3579*/ GIMT_Encode4(183634), // Rule ID 7138 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_blend),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 293:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, GPR64:{ *:[i64] }:$Rn)  =>  (BFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64:{ *:[i64] }:$Rn, 16:{ *:[i64] }, 15:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMXri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7138,
        GIR_EraseRootFromParent_Done,
      // Label 3579: @183634
      GIM_Try, /*On fail goto*//*Label 3580*/ GIMT_Encode4(183679), // Rule ID 10236 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 1906:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQINCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/3, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10236,
        GIR_EraseRootFromParent_Done,
      // Label 3580: @183679
      GIM_Try, /*On fail goto*//*Label 3581*/ GIMT_Encode4(183724), // Rule ID 10237 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 1906:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQINCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/3, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10237,
        GIR_EraseRootFromParent_Done,
      // Label 3581: @183724
      GIM_Try, /*On fail goto*//*Label 3582*/ GIMT_Encode4(183769), // Rule ID 10238 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 1906:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQINCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/3, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10238,
        GIR_EraseRootFromParent_Done,
      // Label 3582: @183769
      GIM_Try, /*On fail goto*//*Label 3583*/ GIMT_Encode4(183814), // Rule ID 10239 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 1906:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQINCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/3, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10239,
        GIR_EraseRootFromParent_Done,
      // Label 3583: @183814
      GIM_Try, /*On fail goto*//*Label 3584*/ GIMT_Encode4(183859), // Rule ID 10248 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 1661:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (SQDECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/3, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10248,
        GIR_EraseRootFromParent_Done,
      // Label 3584: @183859
      GIM_Try, /*On fail goto*//*Label 3585*/ GIMT_Encode4(183904), // Rule ID 10249 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 1661:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (SQDECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/3, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10249,
        GIR_EraseRootFromParent_Done,
      // Label 3585: @183904
      GIM_Try, /*On fail goto*//*Label 3586*/ GIMT_Encode4(183949), // Rule ID 10250 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 1661:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (SQDECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/3, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10250,
        GIR_EraseRootFromParent_Done,
      // Label 3586: @183949
      GIM_Try, /*On fail goto*//*Label 3587*/ GIMT_Encode4(183994), // Rule ID 10251 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 1661:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (SQDECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/3, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10251,
        GIR_EraseRootFromParent_Done,
      // Label 3587: @183994
      GIM_Try, /*On fail goto*//*Label 3588*/ GIMT_Encode4(184039), // Rule ID 10252 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 1891:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQDECP_WP_B:{ *:[i32] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/3, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10252,
        GIR_EraseRootFromParent_Done,
      // Label 3588: @184039
      GIM_Try, /*On fail goto*//*Label 3589*/ GIMT_Encode4(184084), // Rule ID 10253 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 1891:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQDECP_WP_H:{ *:[i32] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/3, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10253,
        GIR_EraseRootFromParent_Done,
      // Label 3589: @184084
      GIM_Try, /*On fail goto*//*Label 3590*/ GIMT_Encode4(184129), // Rule ID 10254 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 1891:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQDECP_WP_S:{ *:[i32] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/3, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10254,
        GIR_EraseRootFromParent_Done,
      // Label 3590: @184129
      GIM_Try, /*On fail goto*//*Label 3591*/ GIMT_Encode4(184174), // Rule ID 10255 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 1891:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQDECP_WP_D:{ *:[i32] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/3, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10255,
        GIR_EraseRootFromParent_Done,
      // Label 3591: @184174
      GIM_Try, /*On fail goto*//*Label 3592*/ GIMT_Encode4(184219), // Rule ID 10256 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 1892:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQDECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/3, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10256,
        GIR_EraseRootFromParent_Done,
      // Label 3592: @184219
      GIM_Try, /*On fail goto*//*Label 3593*/ GIMT_Encode4(184264), // Rule ID 10257 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 1892:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQDECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/3, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10257,
        GIR_EraseRootFromParent_Done,
      // Label 3593: @184264
      GIM_Try, /*On fail goto*//*Label 3594*/ GIMT_Encode4(184309), // Rule ID 10258 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 1892:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQDECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/3, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10258,
        GIR_EraseRootFromParent_Done,
      // Label 3594: @184309
      GIM_Try, /*On fail goto*//*Label 3595*/ GIMT_Encode4(184354), // Rule ID 10259 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 1892:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQDECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/3, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10259,
        GIR_EraseRootFromParent_Done,
      // Label 3595: @184354
      GIM_Try, /*On fail goto*//*Label 3596*/ GIMT_Encode4(184400), // Rule ID 150 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_gmi),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 547:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (GMI:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::GMI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 150,
        GIR_EraseRootFromParent_Done,
      // Label 3596: @184400
      GIM_Try, /*On fail goto*//*Label 3597*/ GIMT_Encode4(184447), // Rule ID 151 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_subp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        // MIs[0] Rm
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 1122:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)  =>  (SUBP:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 151,
        GIR_EraseRootFromParent_Done,
      // Label 3597: @184447
      GIM_Try, /*On fail goto*//*Label 3598*/ GIMT_Encode4(184484), // Rule ID 2376 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1_b16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 2031:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2376,
        GIR_EraseRootFromParent_Done,
      // Label 3598: @184484
      GIM_Try, /*On fail goto*//*Label 3599*/ GIMT_Encode4(184521), // Rule ID 2377 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1_b32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 2032:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2377,
        GIR_EraseRootFromParent_Done,
      // Label 3599: @184521
      GIM_Try, /*On fail goto*//*Label 3600*/ GIMT_Encode4(184558), // Rule ID 2378 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1_b64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 2033:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2378,
        GIR_EraseRootFromParent_Done,
      // Label 3600: @184558
      GIM_Try, /*On fail goto*//*Label 3601*/ GIMT_Encode4(184595), // Rule ID 2380 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2_b16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 2036:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2380,
        GIR_EraseRootFromParent_Done,
      // Label 3601: @184595
      GIM_Try, /*On fail goto*//*Label 3602*/ GIMT_Encode4(184632), // Rule ID 2381 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2_b32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 2037:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2381,
        GIR_EraseRootFromParent_Done,
      // Label 3602: @184632
      GIM_Try, /*On fail goto*//*Label 3603*/ GIMT_Encode4(184669), // Rule ID 2382 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2_b64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 2038:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2382,
        GIR_EraseRootFromParent_Done,
      // Label 3603: @184669
      GIM_Try, /*On fail goto*//*Label 3604*/ GIMT_Encode4(184706), // Rule ID 2384 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1_b16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1957:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2384,
        GIR_EraseRootFromParent_Done,
      // Label 3604: @184706
      GIM_Try, /*On fail goto*//*Label 3605*/ GIMT_Encode4(184743), // Rule ID 2385 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1_b32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1958:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2385,
        GIR_EraseRootFromParent_Done,
      // Label 3605: @184743
      GIM_Try, /*On fail goto*//*Label 3606*/ GIMT_Encode4(184780), // Rule ID 2386 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1_b64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1959:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2386,
        GIR_EraseRootFromParent_Done,
      // Label 3606: @184780
      GIM_Try, /*On fail goto*//*Label 3607*/ GIMT_Encode4(184817), // Rule ID 2388 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2_b16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1962:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2388,
        GIR_EraseRootFromParent_Done,
      // Label 3607: @184817
      GIM_Try, /*On fail goto*//*Label 3608*/ GIMT_Encode4(184854), // Rule ID 2389 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2_b32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1963:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2389,
        GIR_EraseRootFromParent_Done,
      // Label 3608: @184854
      GIM_Try, /*On fail goto*//*Label 3609*/ GIMT_Encode4(184891), // Rule ID 2390 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2_b64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1964:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2390,
        GIR_EraseRootFromParent_Done,
      // Label 3609: @184891
      GIM_Try, /*On fail goto*//*Label 3610*/ GIMT_Encode4(184928), // Rule ID 2392 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1_b16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1801:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2392,
        GIR_EraseRootFromParent_Done,
      // Label 3610: @184928
      GIM_Try, /*On fail goto*//*Label 3611*/ GIMT_Encode4(184965), // Rule ID 2393 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1_b32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1802:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2393,
        GIR_EraseRootFromParent_Done,
      // Label 3611: @184965
      GIM_Try, /*On fail goto*//*Label 3612*/ GIMT_Encode4(185002), // Rule ID 2394 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1_b64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1803:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2394,
        GIR_EraseRootFromParent_Done,
      // Label 3612: @185002
      GIM_Try, /*On fail goto*//*Label 3613*/ GIMT_Encode4(185039), // Rule ID 2396 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2_b16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1806:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2396,
        GIR_EraseRootFromParent_Done,
      // Label 3613: @185039
      GIM_Try, /*On fail goto*//*Label 3614*/ GIMT_Encode4(185076), // Rule ID 2397 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2_b32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1807:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2397,
        GIR_EraseRootFromParent_Done,
      // Label 3614: @185076
      GIM_Try, /*On fail goto*//*Label 3615*/ GIMT_Encode4(185113), // Rule ID 2398 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2_b64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1808:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2398,
        GIR_EraseRootFromParent_Done,
      // Label 3615: @185113
      GIM_Try, /*On fail goto*//*Label 3616*/ GIMT_Encode4(185150), // Rule ID 2399 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_histseg),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1426:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (HISTSEG_ZZZ:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HISTSEG_ZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Zn
        GIR_RootToRootCopy, /*OpIdx*/3, // Zm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2399,
        GIR_EraseRootFromParent_Done,
      // Label 3616: @185150
      GIM_Try, /*On fail goto*//*Label 3617*/ GIMT_Encode4(185190), // Rule ID 2573 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pfirst),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1505:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (PFIRST_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PFIRST_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2573,
        GIR_EraseRootFromParent_Done,
      // Label 3617: @185190
      GIM_Try, /*On fail goto*//*Label 3618*/ GIMT_Encode4(185230), // Rule ID 2574 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1513:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (PNEXT_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2574,
        GIR_EraseRootFromParent_Done,
      // Label 3618: @185230
      GIM_Try, /*On fail goto*//*Label 3619*/ GIMT_Encode4(185270), // Rule ID 2575 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1513:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (PNEXT_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2575,
        GIR_EraseRootFromParent_Done,
      // Label 3619: @185270
      GIM_Try, /*On fail goto*//*Label 3620*/ GIMT_Encode4(185310), // Rule ID 2576 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1513:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (PNEXT_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2576,
        GIR_EraseRootFromParent_Done,
      // Label 3620: @185310
      GIM_Try, /*On fail goto*//*Label 3621*/ GIMT_Encode4(185350), // Rule ID 2577 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 1513:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (PNEXT_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2577,
        GIR_EraseRootFromParent_Done,
      // Label 3621: @185350
      GIM_Try, /*On fail goto*//*Label 3622*/ GIMT_Encode4(185387), // Rule ID 2594 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1693:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (SQINCP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_ZP_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2594,
        GIR_EraseRootFromParent_Done,
      // Label 3622: @185387
      GIM_Try, /*On fail goto*//*Label 3623*/ GIMT_Encode4(185424), // Rule ID 2595 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1693:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (SQINCP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_ZP_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2595,
        GIR_EraseRootFromParent_Done,
      // Label 3623: @185424
      GIM_Try, /*On fail goto*//*Label 3624*/ GIMT_Encode4(185461), // Rule ID 2596 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1693:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (SQINCP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_ZP_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2596,
        GIR_EraseRootFromParent_Done,
      // Label 3624: @185461
      GIM_Try, /*On fail goto*//*Label 3625*/ GIMT_Encode4(185498), // Rule ID 2597 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 1215:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (CNTP_XPP_B:{ *:[i64] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2597,
        GIR_EraseRootFromParent_Done,
      // Label 3625: @185498
      GIM_Try, /*On fail goto*//*Label 3626*/ GIMT_Encode4(185535), // Rule ID 2598 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 1215:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (CNTP_XPP_H:{ *:[i64] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2598,
        GIR_EraseRootFromParent_Done,
      // Label 3626: @185535
      GIM_Try, /*On fail goto*//*Label 3627*/ GIMT_Encode4(185572), // Rule ID 2599 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 1215:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (CNTP_XPP_S:{ *:[i64] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2599,
        GIR_EraseRootFromParent_Done,
      // Label 3627: @185572
      GIM_Try, /*On fail goto*//*Label 3628*/ GIMT_Encode4(185609), // Rule ID 2600 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 1215:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (CNTP_XPP_D:{ *:[i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2600,
        GIR_EraseRootFromParent_Done,
      // Label 3628: @185609
      GIM_Try, /*On fail goto*//*Label 3629*/ GIMT_Encode4(185646), // Rule ID 2796 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftsmul_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1423:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (FTSMUL_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSMUL_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2796,
        GIR_EraseRootFromParent_Done,
      // Label 3629: @185646
      GIM_Try, /*On fail goto*//*Label 3630*/ GIMT_Encode4(185683), // Rule ID 2797 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftsmul_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1423:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (FTSMUL_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSMUL_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2797,
        GIR_EraseRootFromParent_Done,
      // Label 3630: @185683
      GIM_Try, /*On fail goto*//*Label 3631*/ GIMT_Encode4(185720), // Rule ID 2798 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftsmul_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1423:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (FTSMUL_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSMUL_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2798,
        GIR_EraseRootFromParent_Done,
      // Label 3631: @185720
      GIM_Try, /*On fail goto*//*Label 3632*/ GIMT_Encode4(185757), // Rule ID 2977 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1675:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQDMULH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2977,
        GIR_EraseRootFromParent_Done,
      // Label 3632: @185757
      GIM_Try, /*On fail goto*//*Label 3633*/ GIMT_Encode4(185794), // Rule ID 2978 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1675:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQDMULH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2978,
        GIR_EraseRootFromParent_Done,
      // Label 3633: @185794
      GIM_Try, /*On fail goto*//*Label 3634*/ GIMT_Encode4(185831), // Rule ID 2979 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1675:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQDMULH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2979,
        GIR_EraseRootFromParent_Done,
      // Label 3634: @185831
      GIM_Try, /*On fail goto*//*Label 3635*/ GIMT_Encode4(185868), // Rule ID 2980 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1675:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQDMULH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2980,
        GIR_EraseRootFromParent_Done,
      // Label 3635: @185868
      GIM_Try, /*On fail goto*//*Label 3636*/ GIMT_Encode4(185905), // Rule ID 2981 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1510:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (PMUL_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMUL_ZZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2981,
        GIR_EraseRootFromParent_Done,
      // Label 3636: @185905
      GIM_Try, /*On fail goto*//*Label 3637*/ GIMT_Encode4(185942), // Rule ID 3003 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1568:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SADDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLB_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3003,
        GIR_EraseRootFromParent_Done,
      // Label 3637: @185942
      GIM_Try, /*On fail goto*//*Label 3638*/ GIMT_Encode4(185979), // Rule ID 3004 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1568:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SADDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLB_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3004,
        GIR_EraseRootFromParent_Done,
      // Label 3638: @185979
      GIM_Try, /*On fail goto*//*Label 3639*/ GIMT_Encode4(186016), // Rule ID 3005 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1568:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SADDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLB_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3005,
        GIR_EraseRootFromParent_Done,
      // Label 3639: @186016
      GIM_Try, /*On fail goto*//*Label 3640*/ GIMT_Encode4(186053), // Rule ID 3009 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2orSSVE_AES_HasSVEAES),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullb_pair),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1511:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (PMULLB_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLB_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3009,
        GIR_EraseRootFromParent_Done,
      // Label 3640: @186053
      GIM_Try, /*On fail goto*//*Label 3641*/ GIMT_Encode4(186090), // Rule ID 3010 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullb_pair),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1511:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (PMULLB_ZZZ_H:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLB_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3010,
        GIR_EraseRootFromParent_Done,
      // Label 3641: @186090
      GIM_Try, /*On fail goto*//*Label 3642*/ GIMT_Encode4(186127), // Rule ID 3011 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullb_pair),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1511:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (PMULLB_ZZZ_D:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLB_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3011,
        GIR_EraseRootFromParent_Done,
      // Label 3642: @186127
      GIM_Try, /*On fail goto*//*Label 3643*/ GIMT_Encode4(186164), // Rule ID 3012 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2BitPerm),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1153:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BEXT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3012,
        GIR_EraseRootFromParent_Done,
      // Label 3643: @186164
      GIM_Try, /*On fail goto*//*Label 3644*/ GIMT_Encode4(186201), // Rule ID 3013 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2BitPerm),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1153:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BEXT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3013,
        GIR_EraseRootFromParent_Done,
      // Label 3644: @186201
      GIM_Try, /*On fail goto*//*Label 3645*/ GIMT_Encode4(186238), // Rule ID 3014 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2BitPerm),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1153:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BEXT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3014,
        GIR_EraseRootFromParent_Done,
      // Label 3645: @186238
      GIM_Try, /*On fail goto*//*Label 3646*/ GIMT_Encode4(186275), // Rule ID 3015 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2BitPerm),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1153:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BEXT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3015,
        GIR_EraseRootFromParent_Done,
      // Label 3646: @186275
      GIM_Try, /*On fail goto*//*Label 3647*/ GIMT_Encode4(186312), // Rule ID 3016 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlbt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1569:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SADDLBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLBT_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3016,
        GIR_EraseRootFromParent_Done,
      // Label 3647: @186312
      GIM_Try, /*On fail goto*//*Label 3648*/ GIMT_Encode4(186349), // Rule ID 3017 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlbt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1569:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SADDLBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLBT_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3017,
        GIR_EraseRootFromParent_Done,
      // Label 3648: @186349
      GIM_Try, /*On fail goto*//*Label 3649*/ GIMT_Encode4(186386), // Rule ID 3018 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlbt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1569:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SADDLBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLBT_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3018,
        GIR_EraseRootFromParent_Done,
      // Label 3649: @186386
      GIM_Try, /*On fail goto*//*Label 3650*/ GIMT_Encode4(186423), // Rule ID 3065 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1130:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ADDHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNB_ZZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3065,
        GIR_EraseRootFromParent_Done,
      // Label 3650: @186423
      GIM_Try, /*On fail goto*//*Label 3651*/ GIMT_Encode4(186460), // Rule ID 3066 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1130:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADDHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNB_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3066,
        GIR_EraseRootFromParent_Done,
      // Label 3651: @186460
      GIM_Try, /*On fail goto*//*Label 3652*/ GIMT_Encode4(186497), // Rule ID 3067 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1130:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADDHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNB_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3067,
        GIR_EraseRootFromParent_Done,
      // Label 3652: @186497
      GIM_Try, /*On fail goto*//*Label 3653*/ GIMT_Encode4(186534), // Rule ID 3074 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1732:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQXTNT_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNT_ZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3074,
        GIR_EraseRootFromParent_Done,
      // Label 3653: @186534
      GIM_Try, /*On fail goto*//*Label 3654*/ GIMT_Encode4(186571), // Rule ID 3075 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1732:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQXTNT_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNT_ZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3075,
        GIR_EraseRootFromParent_Done,
      // Label 3654: @186571
      GIM_Try, /*On fail goto*//*Label 3655*/ GIMT_Encode4(186608), // Rule ID 3076 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1732:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQXTNT_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNT_ZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3076,
        GIR_EraseRootFromParent_Done,
      // Label 3655: @186608
      GIM_Try, /*On fail goto*//*Label 3656*/ GIMT_Encode4(186648), // Rule ID 3174 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 2012:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3174,
        GIR_EraseRootFromParent_Done,
      // Label 3656: @186648
      GIM_Try, /*On fail goto*//*Label 3657*/ GIMT_Encode4(186688), // Rule ID 3175 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 2012:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3175,
        GIR_EraseRootFromParent_Done,
      // Label 3657: @186688
      GIM_Try, /*On fail goto*//*Label 3658*/ GIMT_Encode4(186728), // Rule ID 3176 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 2012:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3176,
        GIR_EraseRootFromParent_Done,
      // Label 3658: @186728
      GIM_Try, /*On fail goto*//*Label 3659*/ GIMT_Encode4(186768), // Rule ID 3177 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 2012:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3177,
        GIR_EraseRootFromParent_Done,
      // Label 3659: @186768
      GIM_Try, /*On fail goto*//*Label 3660*/ GIMT_Encode4(186808), // Rule ID 3182 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 2012:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3182,
        GIR_EraseRootFromParent_Done,
      // Label 3660: @186808
      GIM_Try, /*On fail goto*//*Label 3661*/ GIMT_Encode4(186848), // Rule ID 3183 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 2012:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3183,
        GIR_EraseRootFromParent_Done,
      // Label 3661: @186848
      GIM_Try, /*On fail goto*//*Label 3662*/ GIMT_Encode4(186888), // Rule ID 3184 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 2012:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3184,
        GIR_EraseRootFromParent_Done,
      // Label 3662: @186888
      GIM_Try, /*On fail goto*//*Label 3663*/ GIMT_Encode4(186928), // Rule ID 3185 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 2012:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3185,
        GIR_EraseRootFromParent_Done,
      // Label 3663: @186928
      GIM_Try, /*On fail goto*//*Label 3664*/ GIMT_Encode4(186965), // Rule ID 3378 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVEorSME2p2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1221:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (COMPACT_ZPZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3378,
        GIR_EraseRootFromParent_Done,
      // Label 3664: @186965
      GIM_Try, /*On fail goto*//*Label 3665*/ GIMT_Encode4(187002), // Rule ID 3379 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVEorSME2p2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1221:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (COMPACT_ZPZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3379,
        GIR_EraseRootFromParent_Done,
      // Label 3665: @187002
      GIM_Try, /*On fail goto*//*Label 3666*/ GIMT_Encode4(187039), // Rule ID 3380 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVEorSME2p2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1221:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (COMPACT_ZPZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3380,
        GIR_EraseRootFromParent_Done,
      // Label 3666: @187039
      GIM_Try, /*On fail goto*//*Label 3667*/ GIMT_Encode4(187076), // Rule ID 3381 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVEorSME2p2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1221:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (COMPACT_ZPZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3381,
        GIR_EraseRootFromParent_Done,
      // Label 3667: @187076
      GIM_Try, /*On fail goto*//*Label 3668*/ GIMT_Encode4(187113), // Rule ID 3403 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftssel_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1424:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (FTSSEL_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSSEL_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3403,
        GIR_EraseRootFromParent_Done,
      // Label 3668: @187113
      GIM_Try, /*On fail goto*//*Label 3669*/ GIMT_Encode4(187150), // Rule ID 3404 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftssel_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1424:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (FTSSEL_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSSEL_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3404,
        GIR_EraseRootFromParent_Done,
      // Label 3669: @187150
      GIM_Try, /*On fail goto*//*Label 3670*/ GIMT_Encode4(187187), // Rule ID 3405 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftssel_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1424:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (FTSSEL_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSSEL_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3405,
        GIR_EraseRootFromParent_Done,
      // Label 3670: @187187
      GIM_Try, /*On fail goto*//*Label 3671*/ GIMT_Encode4(187224), // Rule ID 3427 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brka_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1174:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (BRKA_PPzP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKA_PPzP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3427,
        GIR_EraseRootFromParent_Done,
      // Label 3671: @187224
      GIM_Try, /*On fail goto*//*Label 3672*/ GIMT_Encode4(187261), // Rule ID 3432 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2SM4),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sm4ekey),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1604:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SM4EKEY_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4EKEY_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3432,
        GIR_EraseRootFromParent_Done,
      // Label 3672: @187261
      GIM_Try, /*On fail goto*//*Label 3673*/ GIMT_Encode4(187298), // Rule ID 3433 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2orSSVE_AES_HasSVEAES),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aese),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1139:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (AESE_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESE_ZZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3433,
        GIR_EraseRootFromParent_Done,
      // Label 3673: @187298
      GIM_Try, /*On fail goto*//*Label 3674*/ GIMT_Encode4(187335), // Rule ID 3449 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 2034:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3449,
        GIR_EraseRootFromParent_Done,
      // Label 3674: @187335
      GIM_Try, /*On fail goto*//*Label 3675*/ GIMT_Encode4(187372), // Rule ID 3450 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 2034:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3450,
        GIR_EraseRootFromParent_Done,
      // Label 3675: @187372
      GIM_Try, /*On fail goto*//*Label 3676*/ GIMT_Encode4(187409), // Rule ID 3451 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 2034:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3451,
        GIR_EraseRootFromParent_Done,
      // Label 3676: @187409
      GIM_Try, /*On fail goto*//*Label 3677*/ GIMT_Encode4(187446), // Rule ID 3452 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 2034:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3452,
        GIR_EraseRootFromParent_Done,
      // Label 3677: @187446
      GIM_Try, /*On fail goto*//*Label 3678*/ GIMT_Encode4(187483), // Rule ID 3453 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 2034:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3453,
        GIR_EraseRootFromParent_Done,
      // Label 3678: @187483
      GIM_Try, /*On fail goto*//*Label 3679*/ GIMT_Encode4(187520), // Rule ID 3454 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 2034:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3454,
        GIR_EraseRootFromParent_Done,
      // Label 3679: @187520
      GIM_Try, /*On fail goto*//*Label 3680*/ GIMT_Encode4(187557), // Rule ID 3455 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 2034:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3455,
        GIR_EraseRootFromParent_Done,
      // Label 3680: @187557
      GIM_Try, /*On fail goto*//*Label 3681*/ GIMT_Encode4(187594), // Rule ID 3456 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8bf16] } 2034:{ *:[iPTR] }, nxv8bf16:{ *:[nxv8bf16] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv8bf16] } ?:{ *:[nxv8bf16] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3456,
        GIR_EraseRootFromParent_Done,
      // Label 3681: @187594
      GIM_Try, /*On fail goto*//*Label 3682*/ GIMT_Encode4(187631), // Rule ID 3521 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8f16] } 1247:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FADDQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDQV_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3521,
        GIR_EraseRootFromParent_Done,
      // Label 3682: @187631
      GIM_Try, /*On fail goto*//*Label 3683*/ GIMT_Encode4(187668), // Rule ID 3522 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 1247:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FADDQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDQV_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3522,
        GIR_EraseRootFromParent_Done,
      // Label 3683: @187668
      GIM_Try, /*On fail goto*//*Label 3684*/ GIMT_Encode4(187705), // Rule ID 3523 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f64] } 1247:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FADDQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDQV_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3523,
        GIR_EraseRootFromParent_Done,
      // Label 3684: @187705
      GIM_Try, /*On fail goto*//*Label 3685*/ GIMT_Encode4(187742), // Rule ID 3555 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 1498:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ORQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3555,
        GIR_EraseRootFromParent_Done,
      // Label 3685: @187742
      GIM_Try, /*On fail goto*//*Label 3686*/ GIMT_Encode4(187779), // Rule ID 3556 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 1498:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ORQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3556,
        GIR_EraseRootFromParent_Done,
      // Label 3686: @187779
      GIM_Try, /*On fail goto*//*Label 3687*/ GIMT_Encode4(187816), // Rule ID 3557 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 1498:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ORQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3557,
        GIR_EraseRootFromParent_Done,
      // Label 3687: @187816
      GIM_Try, /*On fail goto*//*Label 3688*/ GIMT_Encode4(187853), // Rule ID 3558 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 1498:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ORQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3558,
        GIR_EraseRootFromParent_Done,
      // Label 3688: @187853
      GIM_Try, /*On fail goto*//*Label 3689*/ GIMT_Encode4(187890), // Rule ID 3559 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 2042:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIPQ1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3559,
        GIR_EraseRootFromParent_Done,
      // Label 3689: @187890
      GIM_Try, /*On fail goto*//*Label 3690*/ GIMT_Encode4(187927), // Rule ID 3560 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 2042:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIPQ1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3560,
        GIR_EraseRootFromParent_Done,
      // Label 3690: @187927
      GIM_Try, /*On fail goto*//*Label 3691*/ GIMT_Encode4(187964), // Rule ID 3561 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 2042:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIPQ1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3561,
        GIR_EraseRootFromParent_Done,
      // Label 3691: @187964
      GIM_Try, /*On fail goto*//*Label 3692*/ GIMT_Encode4(188001), // Rule ID 3562 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 2042:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIPQ1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3562,
        GIR_EraseRootFromParent_Done,
      // Label 3692: @188001
      GIM_Try, /*On fail goto*//*Label 3693*/ GIMT_Encode4(188038), // Rule ID 3563 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 2042:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIPQ1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3563,
        GIR_EraseRootFromParent_Done,
      // Label 3693: @188038
      GIM_Try, /*On fail goto*//*Label 3694*/ GIMT_Encode4(188075), // Rule ID 3564 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 2042:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIPQ1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3564,
        GIR_EraseRootFromParent_Done,
      // Label 3694: @188075
      GIM_Try, /*On fail goto*//*Label 3695*/ GIMT_Encode4(188112), // Rule ID 3565 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 2042:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIPQ1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3565,
        GIR_EraseRootFromParent_Done,
      // Label 3695: @188112
      GIM_Try, /*On fail goto*//*Label 3696*/ GIMT_Encode4(188149), // Rule ID 3566 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8bf16] } 2042:{ *:[iPTR] }, nxv8bf16:{ *:[nxv8bf16] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2)  =>  (ZIPQ1_ZZZ_H:{ *:[nxv8bf16] } ?:{ *:[nxv8bf16] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3566,
        GIR_EraseRootFromParent_Done,
      // Label 3696: @188149
      GIM_Try, /*On fail goto*//*Label 3697*/ GIMT_Encode4(188186), // Rule ID 3567 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1797:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TBLQ_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3567,
        GIR_EraseRootFromParent_Done,
      // Label 3697: @188186
      GIM_Try, /*On fail goto*//*Label 3698*/ GIMT_Encode4(188223), // Rule ID 3568 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1797:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TBLQ_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3568,
        GIR_EraseRootFromParent_Done,
      // Label 3698: @188223
      GIM_Try, /*On fail goto*//*Label 3699*/ GIMT_Encode4(188260), // Rule ID 3569 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1797:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TBLQ_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3569,
        GIR_EraseRootFromParent_Done,
      // Label 3699: @188260
      GIM_Try, /*On fail goto*//*Label 3700*/ GIMT_Encode4(188297), // Rule ID 3570 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1797:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TBLQ_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3570,
        GIR_EraseRootFromParent_Done,
      // Label 3700: @188297
      GIM_Try, /*On fail goto*//*Label 3701*/ GIMT_Encode4(188334), // Rule ID 3571 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1797:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TBLQ_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3571,
        GIR_EraseRootFromParent_Done,
      // Label 3701: @188334
      GIM_Try, /*On fail goto*//*Label 3702*/ GIMT_Encode4(188371), // Rule ID 3572 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1797:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TBLQ_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3572,
        GIR_EraseRootFromParent_Done,
      // Label 3702: @188371
      GIM_Try, /*On fail goto*//*Label 3703*/ GIMT_Encode4(188408), // Rule ID 3573 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1797:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TBLQ_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3573,
        GIR_EraseRootFromParent_Done,
      // Label 3703: @188408
      GIM_Try, /*On fail goto*//*Label 3704*/ GIMT_Encode4(188445), // Rule ID 3574 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8bf16] } 1797:{ *:[iPTR] }, nxv8bf16:{ *:[nxv8bf16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TBLQ_ZZZ_H:{ *:[nxv8bf16] } ?:{ *:[nxv8bf16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3574,
        GIR_EraseRootFromParent_Done,
      // Label 3704: @188445
      GIM_Try, /*On fail goto*//*Label 3705*/ GIMT_Encode4(188482), // Rule ID 8564 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkb_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1176:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (BRKB_PPzP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKB_PPzP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8564,
        GIR_EraseRootFromParent_Done,
      // Label 3705: @188482
      GIM_Try, /*On fail goto*//*Label 3706*/ GIMT_Encode4(188519), // Rule ID 9065 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1134:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_0:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_0),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9065,
        GIR_EraseRootFromParent_Done,
      // Label 3706: @188519
      GIM_Try, /*On fail goto*//*Label 3707*/ GIMT_Encode4(188556), // Rule ID 9066 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1136:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_1:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9066,
        GIR_EraseRootFromParent_Done,
      // Label 3707: @188556
      GIM_Try, /*On fail goto*//*Label 3708*/ GIMT_Encode4(188593), // Rule ID 9067 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1137:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_2:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9067,
        GIR_EraseRootFromParent_Done,
      // Label 3708: @188593
      GIM_Try, /*On fail goto*//*Label 3709*/ GIMT_Encode4(188630), // Rule ID 9068 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1135:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_3:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_3),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9068,
        GIR_EraseRootFromParent_Done,
      // Label 3709: @188630
      GIM_Try, /*On fail goto*//*Label 3710*/ GIMT_Encode4(188667), // Rule ID 9069 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1134:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_0),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9069,
        GIR_EraseRootFromParent_Done,
      // Label 3710: @188667
      GIM_Try, /*On fail goto*//*Label 3711*/ GIMT_Encode4(188704), // Rule ID 9070 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1136:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_1:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9070,
        GIR_EraseRootFromParent_Done,
      // Label 3711: @188704
      GIM_Try, /*On fail goto*//*Label 3712*/ GIMT_Encode4(188741), // Rule ID 9071 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1137:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_2:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9071,
        GIR_EraseRootFromParent_Done,
      // Label 3712: @188741
      GIM_Try, /*On fail goto*//*Label 3713*/ GIMT_Encode4(188778), // Rule ID 9072 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1135:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_3:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_3),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9072,
        GIR_EraseRootFromParent_Done,
      // Label 3713: @188778
      GIM_Try, /*On fail goto*//*Label 3714*/ GIMT_Encode4(188818), // Rule ID 10102 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1994:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10102,
        GIR_EraseRootFromParent_Done,
      // Label 3714: @188818
      GIM_Try, /*On fail goto*//*Label 3715*/ GIMT_Encode4(188858), // Rule ID 10103 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1994:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10103,
        GIR_EraseRootFromParent_Done,
      // Label 3715: @188858
      GIM_Try, /*On fail goto*//*Label 3716*/ GIMT_Encode4(188898), // Rule ID 10104 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1994:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10104,
        GIR_EraseRootFromParent_Done,
      // Label 3716: @188898
      GIM_Try, /*On fail goto*//*Label 3717*/ GIMT_Encode4(188938), // Rule ID 10105 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 1994:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10105,
        GIR_EraseRootFromParent_Done,
      // Label 3717: @188938
      GIM_Try, /*On fail goto*//*Label 3718*/ GIMT_Encode4(188978), // Rule ID 10106 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 2000:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELO_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PWW_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10106,
        GIR_EraseRootFromParent_Done,
      // Label 3718: @188978
      GIM_Try, /*On fail goto*//*Label 3719*/ GIMT_Encode4(189018), // Rule ID 10107 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 2000:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELO_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PWW_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10107,
        GIR_EraseRootFromParent_Done,
      // Label 3719: @189018
      GIM_Try, /*On fail goto*//*Label 3720*/ GIMT_Encode4(189058), // Rule ID 10108 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 2000:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELO_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PWW_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10108,
        GIR_EraseRootFromParent_Done,
      // Label 3720: @189058
      GIM_Try, /*On fail goto*//*Label 3721*/ GIMT_Encode4(189098), // Rule ID 10109 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 2000:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELO_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PWW_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10109,
        GIR_EraseRootFromParent_Done,
      // Label 3721: @189098
      GIM_Try, /*On fail goto*//*Label 3722*/ GIMT_Encode4(189138), // Rule ID 10114 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 2006:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10114,
        GIR_EraseRootFromParent_Done,
      // Label 3722: @189138
      GIM_Try, /*On fail goto*//*Label 3723*/ GIMT_Encode4(189178), // Rule ID 10115 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 2006:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10115,
        GIR_EraseRootFromParent_Done,
      // Label 3723: @189178
      GIM_Try, /*On fail goto*//*Label 3724*/ GIMT_Encode4(189218), // Rule ID 10116 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 2006:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10116,
        GIR_EraseRootFromParent_Done,
      // Label 3724: @189218
      GIM_Try, /*On fail goto*//*Label 3725*/ GIMT_Encode4(189258), // Rule ID 10117 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 2006:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10117,
        GIR_EraseRootFromParent_Done,
      // Label 3725: @189258
      GIM_Try, /*On fail goto*//*Label 3726*/ GIMT_Encode4(189298), // Rule ID 10118 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1994:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10118,
        GIR_EraseRootFromParent_Done,
      // Label 3726: @189298
      GIM_Try, /*On fail goto*//*Label 3727*/ GIMT_Encode4(189338), // Rule ID 10119 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1994:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10119,
        GIR_EraseRootFromParent_Done,
      // Label 3727: @189338
      GIM_Try, /*On fail goto*//*Label 3728*/ GIMT_Encode4(189378), // Rule ID 10120 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1994:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10120,
        GIR_EraseRootFromParent_Done,
      // Label 3728: @189378
      GIM_Try, /*On fail goto*//*Label 3729*/ GIMT_Encode4(189418), // Rule ID 10121 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 1994:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10121,
        GIR_EraseRootFromParent_Done,
      // Label 3729: @189418
      GIM_Try, /*On fail goto*//*Label 3730*/ GIMT_Encode4(189458), // Rule ID 10122 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 2000:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELO_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PXX_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10122,
        GIR_EraseRootFromParent_Done,
      // Label 3730: @189458
      GIM_Try, /*On fail goto*//*Label 3731*/ GIMT_Encode4(189498), // Rule ID 10123 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 2000:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELO_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PXX_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10123,
        GIR_EraseRootFromParent_Done,
      // Label 3731: @189498
      GIM_Try, /*On fail goto*//*Label 3732*/ GIMT_Encode4(189538), // Rule ID 10124 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 2000:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELO_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PXX_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10124,
        GIR_EraseRootFromParent_Done,
      // Label 3732: @189538
      GIM_Try, /*On fail goto*//*Label 3733*/ GIMT_Encode4(189578), // Rule ID 10125 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 2000:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELO_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PXX_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10125,
        GIR_EraseRootFromParent_Done,
      // Label 3733: @189578
      GIM_Try, /*On fail goto*//*Label 3734*/ GIMT_Encode4(189618), // Rule ID 10130 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 2006:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10130,
        GIR_EraseRootFromParent_Done,
      // Label 3734: @189618
      GIM_Try, /*On fail goto*//*Label 3735*/ GIMT_Encode4(189658), // Rule ID 10131 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 2006:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10131,
        GIR_EraseRootFromParent_Done,
      // Label 3735: @189658
      GIM_Try, /*On fail goto*//*Label 3736*/ GIMT_Encode4(189698), // Rule ID 10132 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 2006:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10132,
        GIR_EraseRootFromParent_Done,
      // Label 3736: @189698
      GIM_Try, /*On fail goto*//*Label 3737*/ GIMT_Encode4(189738), // Rule ID 10133 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 2006:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10133,
        GIR_EraseRootFromParent_Done,
      // Label 3737: @189738
      GIM_Try, /*On fail goto*//*Label 3738*/ GIMT_Encode4(189775), // Rule ID 10292 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1904:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UQINCP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_ZP_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10292,
        GIR_EraseRootFromParent_Done,
      // Label 3738: @189775
      GIM_Try, /*On fail goto*//*Label 3739*/ GIMT_Encode4(189812), // Rule ID 10293 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1904:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UQINCP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_ZP_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10293,
        GIR_EraseRootFromParent_Done,
      // Label 3739: @189812
      GIM_Try, /*On fail goto*//*Label 3740*/ GIMT_Encode4(189849), // Rule ID 10294 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1904:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UQINCP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_ZP_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10294,
        GIR_EraseRootFromParent_Done,
      // Label 3740: @189849
      GIM_Try, /*On fail goto*//*Label 3741*/ GIMT_Encode4(189886), // Rule ID 10295 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1659:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (SQDECP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_ZP_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10295,
        GIR_EraseRootFromParent_Done,
      // Label 3741: @189886
      GIM_Try, /*On fail goto*//*Label 3742*/ GIMT_Encode4(189923), // Rule ID 10296 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1659:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (SQDECP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_ZP_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10296,
        GIR_EraseRootFromParent_Done,
      // Label 3742: @189923
      GIM_Try, /*On fail goto*//*Label 3743*/ GIMT_Encode4(189960), // Rule ID 10297 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1659:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (SQDECP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_ZP_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10297,
        GIR_EraseRootFromParent_Done,
      // Label 3743: @189960
      GIM_Try, /*On fail goto*//*Label 3744*/ GIMT_Encode4(189997), // Rule ID 10298 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1890:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UQDECP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_ZP_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10298,
        GIR_EraseRootFromParent_Done,
      // Label 3744: @189997
      GIM_Try, /*On fail goto*//*Label 3745*/ GIMT_Encode4(190034), // Rule ID 10299 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1890:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UQDECP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_ZP_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10299,
        GIR_EraseRootFromParent_Done,
      // Label 3745: @190034
      GIM_Try, /*On fail goto*//*Label 3746*/ GIMT_Encode4(190071), // Rule ID 10300 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1890:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UQDECP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_ZP_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10300,
        GIR_EraseRootFromParent_Done,
      // Label 3746: @190071
      GIM_Try, /*On fail goto*//*Label 3747*/ GIMT_Encode4(190108), // Rule ID 11547 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 2039:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11547,
        GIR_EraseRootFromParent_Done,
      // Label 3747: @190108
      GIM_Try, /*On fail goto*//*Label 3748*/ GIMT_Encode4(190145), // Rule ID 11548 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 2039:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11548,
        GIR_EraseRootFromParent_Done,
      // Label 3748: @190145
      GIM_Try, /*On fail goto*//*Label 3749*/ GIMT_Encode4(190182), // Rule ID 11549 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 2039:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11549,
        GIR_EraseRootFromParent_Done,
      // Label 3749: @190182
      GIM_Try, /*On fail goto*//*Label 3750*/ GIMT_Encode4(190219), // Rule ID 11550 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 2039:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11550,
        GIR_EraseRootFromParent_Done,
      // Label 3750: @190219
      GIM_Try, /*On fail goto*//*Label 3751*/ GIMT_Encode4(190256), // Rule ID 11551 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 2039:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11551,
        GIR_EraseRootFromParent_Done,
      // Label 3751: @190256
      GIM_Try, /*On fail goto*//*Label 3752*/ GIMT_Encode4(190293), // Rule ID 11552 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 2039:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11552,
        GIR_EraseRootFromParent_Done,
      // Label 3752: @190293
      GIM_Try, /*On fail goto*//*Label 3753*/ GIMT_Encode4(190330), // Rule ID 11553 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 2039:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11553,
        GIR_EraseRootFromParent_Done,
      // Label 3753: @190330
      GIM_Try, /*On fail goto*//*Label 3754*/ GIMT_Encode4(190367), // Rule ID 11554 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8bf16] } 2039:{ *:[iPTR] }, nxv8bf16:{ *:[nxv8bf16] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv8bf16] } ?:{ *:[nxv8bf16] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11554,
        GIR_EraseRootFromParent_Done,
      // Label 3754: @190367
      GIM_Try, /*On fail goto*//*Label 3755*/ GIMT_Encode4(190404), // Rule ID 11555 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1960:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11555,
        GIR_EraseRootFromParent_Done,
      // Label 3755: @190404
      GIM_Try, /*On fail goto*//*Label 3756*/ GIMT_Encode4(190441), // Rule ID 11556 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1960:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11556,
        GIR_EraseRootFromParent_Done,
      // Label 3756: @190441
      GIM_Try, /*On fail goto*//*Label 3757*/ GIMT_Encode4(190478), // Rule ID 11557 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1960:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11557,
        GIR_EraseRootFromParent_Done,
      // Label 3757: @190478
      GIM_Try, /*On fail goto*//*Label 3758*/ GIMT_Encode4(190515), // Rule ID 11558 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1960:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11558,
        GIR_EraseRootFromParent_Done,
      // Label 3758: @190515
      GIM_Try, /*On fail goto*//*Label 3759*/ GIMT_Encode4(190552), // Rule ID 11559 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1960:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11559,
        GIR_EraseRootFromParent_Done,
      // Label 3759: @190552
      GIM_Try, /*On fail goto*//*Label 3760*/ GIMT_Encode4(190589), // Rule ID 11560 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1960:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11560,
        GIR_EraseRootFromParent_Done,
      // Label 3760: @190589
      GIM_Try, /*On fail goto*//*Label 3761*/ GIMT_Encode4(190626), // Rule ID 11561 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1960:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11561,
        GIR_EraseRootFromParent_Done,
      // Label 3761: @190626
      GIM_Try, /*On fail goto*//*Label 3762*/ GIMT_Encode4(190663), // Rule ID 11562 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8bf16] } 1960:{ *:[iPTR] }, nxv8bf16:{ *:[nxv8bf16] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv8bf16] } ?:{ *:[nxv8bf16] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11562,
        GIR_EraseRootFromParent_Done,
      // Label 3762: @190663
      GIM_Try, /*On fail goto*//*Label 3763*/ GIMT_Encode4(190700), // Rule ID 11563 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1965:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11563,
        GIR_EraseRootFromParent_Done,
      // Label 3763: @190700
      GIM_Try, /*On fail goto*//*Label 3764*/ GIMT_Encode4(190737), // Rule ID 11564 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1965:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11564,
        GIR_EraseRootFromParent_Done,
      // Label 3764: @190737
      GIM_Try, /*On fail goto*//*Label 3765*/ GIMT_Encode4(190774), // Rule ID 11565 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1965:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11565,
        GIR_EraseRootFromParent_Done,
      // Label 3765: @190774
      GIM_Try, /*On fail goto*//*Label 3766*/ GIMT_Encode4(190811), // Rule ID 11566 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1965:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11566,
        GIR_EraseRootFromParent_Done,
      // Label 3766: @190811
      GIM_Try, /*On fail goto*//*Label 3767*/ GIMT_Encode4(190848), // Rule ID 11567 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1965:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11567,
        GIR_EraseRootFromParent_Done,
      // Label 3767: @190848
      GIM_Try, /*On fail goto*//*Label 3768*/ GIMT_Encode4(190885), // Rule ID 11568 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1965:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11568,
        GIR_EraseRootFromParent_Done,
      // Label 3768: @190885
      GIM_Try, /*On fail goto*//*Label 3769*/ GIMT_Encode4(190922), // Rule ID 11569 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1965:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11569,
        GIR_EraseRootFromParent_Done,
      // Label 3769: @190922
      GIM_Try, /*On fail goto*//*Label 3770*/ GIMT_Encode4(190959), // Rule ID 11570 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8bf16] } 1965:{ *:[iPTR] }, nxv8bf16:{ *:[nxv8bf16] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv8bf16] } ?:{ *:[nxv8bf16] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11570,
        GIR_EraseRootFromParent_Done,
      // Label 3770: @190959
      GIM_Try, /*On fail goto*//*Label 3771*/ GIMT_Encode4(190996), // Rule ID 11571 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1804:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11571,
        GIR_EraseRootFromParent_Done,
      // Label 3771: @190996
      GIM_Try, /*On fail goto*//*Label 3772*/ GIMT_Encode4(191033), // Rule ID 11572 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1804:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11572,
        GIR_EraseRootFromParent_Done,
      // Label 3772: @191033
      GIM_Try, /*On fail goto*//*Label 3773*/ GIMT_Encode4(191070), // Rule ID 11573 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1804:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11573,
        GIR_EraseRootFromParent_Done,
      // Label 3773: @191070
      GIM_Try, /*On fail goto*//*Label 3774*/ GIMT_Encode4(191107), // Rule ID 11574 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1804:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11574,
        GIR_EraseRootFromParent_Done,
      // Label 3774: @191107
      GIM_Try, /*On fail goto*//*Label 3775*/ GIMT_Encode4(191144), // Rule ID 11575 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1804:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11575,
        GIR_EraseRootFromParent_Done,
      // Label 3775: @191144
      GIM_Try, /*On fail goto*//*Label 3776*/ GIMT_Encode4(191181), // Rule ID 11576 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1804:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11576,
        GIR_EraseRootFromParent_Done,
      // Label 3776: @191181
      GIM_Try, /*On fail goto*//*Label 3777*/ GIMT_Encode4(191218), // Rule ID 11577 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1804:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11577,
        GIR_EraseRootFromParent_Done,
      // Label 3777: @191218
      GIM_Try, /*On fail goto*//*Label 3778*/ GIMT_Encode4(191255), // Rule ID 11578 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8bf16] } 1804:{ *:[iPTR] }, nxv8bf16:{ *:[nxv8bf16] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv8bf16] } ?:{ *:[nxv8bf16] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11578,
        GIR_EraseRootFromParent_Done,
      // Label 3778: @191255
      GIM_Try, /*On fail goto*//*Label 3779*/ GIMT_Encode4(191292), // Rule ID 11579 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1809:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11579,
        GIR_EraseRootFromParent_Done,
      // Label 3779: @191292
      GIM_Try, /*On fail goto*//*Label 3780*/ GIMT_Encode4(191329), // Rule ID 11580 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1809:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11580,
        GIR_EraseRootFromParent_Done,
      // Label 3780: @191329
      GIM_Try, /*On fail goto*//*Label 3781*/ GIMT_Encode4(191366), // Rule ID 11581 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1809:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11581,
        GIR_EraseRootFromParent_Done,
      // Label 3781: @191366
      GIM_Try, /*On fail goto*//*Label 3782*/ GIMT_Encode4(191403), // Rule ID 11582 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1809:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11582,
        GIR_EraseRootFromParent_Done,
      // Label 3782: @191403
      GIM_Try, /*On fail goto*//*Label 3783*/ GIMT_Encode4(191440), // Rule ID 11583 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1809:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11583,
        GIR_EraseRootFromParent_Done,
      // Label 3783: @191440
      GIM_Try, /*On fail goto*//*Label 3784*/ GIMT_Encode4(191477), // Rule ID 11584 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1809:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11584,
        GIR_EraseRootFromParent_Done,
      // Label 3784: @191477
      GIM_Try, /*On fail goto*//*Label 3785*/ GIMT_Encode4(191514), // Rule ID 11585 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1809:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11585,
        GIR_EraseRootFromParent_Done,
      // Label 3785: @191514
      GIM_Try, /*On fail goto*//*Label 3786*/ GIMT_Encode4(191551), // Rule ID 11586 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8bf16] } 1809:{ *:[iPTR] }, nxv8bf16:{ *:[nxv8bf16] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv8bf16] } ?:{ *:[nxv8bf16] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11586,
        GIR_EraseRootFromParent_Done,
      // Label 3786: @191551
      GIM_Try, /*On fail goto*//*Label 3787*/ GIMT_Encode4(191588), // Rule ID 11606 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1706:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQRDMULH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11606,
        GIR_EraseRootFromParent_Done,
      // Label 3787: @191588
      GIM_Try, /*On fail goto*//*Label 3788*/ GIMT_Encode4(191625), // Rule ID 11607 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1706:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQRDMULH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11607,
        GIR_EraseRootFromParent_Done,
      // Label 3788: @191625
      GIM_Try, /*On fail goto*//*Label 3789*/ GIMT_Encode4(191662), // Rule ID 11608 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1706:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQRDMULH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11608,
        GIR_EraseRootFromParent_Done,
      // Label 3789: @191662
      GIM_Try, /*On fail goto*//*Label 3790*/ GIMT_Encode4(191699), // Rule ID 11609 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1706:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQRDMULH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11609,
        GIR_EraseRootFromParent_Done,
      // Label 3790: @191699
      GIM_Try, /*On fail goto*//*Label 3791*/ GIMT_Encode4(191736), // Rule ID 11897 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1570:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SADDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLT_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11897,
        GIR_EraseRootFromParent_Done,
      // Label 3791: @191736
      GIM_Try, /*On fail goto*//*Label 3792*/ GIMT_Encode4(191773), // Rule ID 11898 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1570:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SADDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLT_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11898,
        GIR_EraseRootFromParent_Done,
      // Label 3792: @191773
      GIM_Try, /*On fail goto*//*Label 3793*/ GIMT_Encode4(191810), // Rule ID 11899 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1570:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SADDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLT_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11899,
        GIR_EraseRootFromParent_Done,
      // Label 3793: @191810
      GIM_Try, /*On fail goto*//*Label 3794*/ GIMT_Encode4(191847), // Rule ID 11900 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1818:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UADDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLB_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11900,
        GIR_EraseRootFromParent_Done,
      // Label 3794: @191847
      GIM_Try, /*On fail goto*//*Label 3795*/ GIMT_Encode4(191884), // Rule ID 11901 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1818:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UADDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLB_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11901,
        GIR_EraseRootFromParent_Done,
      // Label 3795: @191884
      GIM_Try, /*On fail goto*//*Label 3796*/ GIMT_Encode4(191921), // Rule ID 11902 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1818:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UADDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLB_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11902,
        GIR_EraseRootFromParent_Done,
      // Label 3796: @191921
      GIM_Try, /*On fail goto*//*Label 3797*/ GIMT_Encode4(191958), // Rule ID 11903 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1819:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UADDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLT_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11903,
        GIR_EraseRootFromParent_Done,
      // Label 3797: @191958
      GIM_Try, /*On fail goto*//*Label 3798*/ GIMT_Encode4(191995), // Rule ID 11904 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1819:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UADDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLT_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11904,
        GIR_EraseRootFromParent_Done,
      // Label 3798: @191995
      GIM_Try, /*On fail goto*//*Label 3799*/ GIMT_Encode4(192032), // Rule ID 11905 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1819:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UADDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLT_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11905,
        GIR_EraseRootFromParent_Done,
      // Label 3799: @192032
      GIM_Try, /*On fail goto*//*Label 3800*/ GIMT_Encode4(192069), // Rule ID 11906 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1747:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLB_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11906,
        GIR_EraseRootFromParent_Done,
      // Label 3800: @192069
      GIM_Try, /*On fail goto*//*Label 3801*/ GIMT_Encode4(192106), // Rule ID 11907 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1747:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLB_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11907,
        GIR_EraseRootFromParent_Done,
      // Label 3801: @192106
      GIM_Try, /*On fail goto*//*Label 3802*/ GIMT_Encode4(192143), // Rule ID 11908 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1747:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLB_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11908,
        GIR_EraseRootFromParent_Done,
      // Label 3802: @192143
      GIM_Try, /*On fail goto*//*Label 3803*/ GIMT_Encode4(192180), // Rule ID 11909 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1749:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLT_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11909,
        GIR_EraseRootFromParent_Done,
      // Label 3803: @192180
      GIM_Try, /*On fail goto*//*Label 3804*/ GIMT_Encode4(192217), // Rule ID 11910 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1749:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLT_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11910,
        GIR_EraseRootFromParent_Done,
      // Label 3804: @192217
      GIM_Try, /*On fail goto*//*Label 3805*/ GIMT_Encode4(192254), // Rule ID 11911 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1749:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLT_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11911,
        GIR_EraseRootFromParent_Done,
      // Label 3805: @192254
      GIM_Try, /*On fail goto*//*Label 3806*/ GIMT_Encode4(192291), // Rule ID 11912 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1943:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLB_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11912,
        GIR_EraseRootFromParent_Done,
      // Label 3806: @192291
      GIM_Try, /*On fail goto*//*Label 3807*/ GIMT_Encode4(192328), // Rule ID 11913 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1943:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLB_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11913,
        GIR_EraseRootFromParent_Done,
      // Label 3807: @192328
      GIM_Try, /*On fail goto*//*Label 3808*/ GIMT_Encode4(192365), // Rule ID 11914 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1943:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLB_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11914,
        GIR_EraseRootFromParent_Done,
      // Label 3808: @192365
      GIM_Try, /*On fail goto*//*Label 3809*/ GIMT_Encode4(192402), // Rule ID 11915 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1944:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLT_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11915,
        GIR_EraseRootFromParent_Done,
      // Label 3809: @192402
      GIM_Try, /*On fail goto*//*Label 3810*/ GIMT_Encode4(192439), // Rule ID 11916 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1944:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLT_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11916,
        GIR_EraseRootFromParent_Done,
      // Label 3810: @192439
      GIM_Try, /*On fail goto*//*Label 3811*/ GIMT_Encode4(192476), // Rule ID 11917 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1944:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLT_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11917,
        GIR_EraseRootFromParent_Done,
      // Label 3811: @192476
      GIM_Try, /*On fail goto*//*Label 3812*/ GIMT_Encode4(192513), // Rule ID 11918 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1565:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SABDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLB_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11918,
        GIR_EraseRootFromParent_Done,
      // Label 3812: @192513
      GIM_Try, /*On fail goto*//*Label 3813*/ GIMT_Encode4(192550), // Rule ID 11919 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1565:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SABDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLB_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11919,
        GIR_EraseRootFromParent_Done,
      // Label 3813: @192550
      GIM_Try, /*On fail goto*//*Label 3814*/ GIMT_Encode4(192587), // Rule ID 11920 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1565:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SABDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLB_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11920,
        GIR_EraseRootFromParent_Done,
      // Label 3814: @192587
      GIM_Try, /*On fail goto*//*Label 3815*/ GIMT_Encode4(192624), // Rule ID 11921 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1566:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SABDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLT_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11921,
        GIR_EraseRootFromParent_Done,
      // Label 3815: @192624
      GIM_Try, /*On fail goto*//*Label 3816*/ GIMT_Encode4(192661), // Rule ID 11922 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1566:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SABDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLT_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11922,
        GIR_EraseRootFromParent_Done,
      // Label 3816: @192661
      GIM_Try, /*On fail goto*//*Label 3817*/ GIMT_Encode4(192698), // Rule ID 11923 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1566:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SABDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLT_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11923,
        GIR_EraseRootFromParent_Done,
      // Label 3817: @192698
      GIM_Try, /*On fail goto*//*Label 3818*/ GIMT_Encode4(192735), // Rule ID 11924 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1815:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UABDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLB_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11924,
        GIR_EraseRootFromParent_Done,
      // Label 3818: @192735
      GIM_Try, /*On fail goto*//*Label 3819*/ GIMT_Encode4(192772), // Rule ID 11925 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1815:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UABDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLB_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11925,
        GIR_EraseRootFromParent_Done,
      // Label 3819: @192772
      GIM_Try, /*On fail goto*//*Label 3820*/ GIMT_Encode4(192809), // Rule ID 11926 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1815:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UABDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLB_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11926,
        GIR_EraseRootFromParent_Done,
      // Label 3820: @192809
      GIM_Try, /*On fail goto*//*Label 3821*/ GIMT_Encode4(192846), // Rule ID 11927 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1816:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UABDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLT_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11927,
        GIR_EraseRootFromParent_Done,
      // Label 3821: @192846
      GIM_Try, /*On fail goto*//*Label 3822*/ GIMT_Encode4(192883), // Rule ID 11928 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1816:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UABDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLT_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11928,
        GIR_EraseRootFromParent_Done,
      // Label 3822: @192883
      GIM_Try, /*On fail goto*//*Label 3823*/ GIMT_Encode4(192920), // Rule ID 11929 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1816:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UABDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLT_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11929,
        GIR_EraseRootFromParent_Done,
      // Label 3823: @192920
      GIM_Try, /*On fail goto*//*Label 3824*/ GIMT_Encode4(192957), // Rule ID 11939 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1751:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBWB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWB_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11939,
        GIR_EraseRootFromParent_Done,
      // Label 3824: @192957
      GIM_Try, /*On fail goto*//*Label 3825*/ GIMT_Encode4(192994), // Rule ID 11940 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1751:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBWB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWB_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11940,
        GIR_EraseRootFromParent_Done,
      // Label 3825: @192994
      GIM_Try, /*On fail goto*//*Label 3826*/ GIMT_Encode4(193031), // Rule ID 11941 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1751:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBWB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWB_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11941,
        GIR_EraseRootFromParent_Done,
      // Label 3826: @193031
      GIM_Try, /*On fail goto*//*Label 3827*/ GIMT_Encode4(193068), // Rule ID 11942 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1752:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBWT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWT_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11942,
        GIR_EraseRootFromParent_Done,
      // Label 3827: @193068
      GIM_Try, /*On fail goto*//*Label 3828*/ GIMT_Encode4(193105), // Rule ID 11943 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1752:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBWT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWT_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11943,
        GIR_EraseRootFromParent_Done,
      // Label 3828: @193105
      GIM_Try, /*On fail goto*//*Label 3829*/ GIMT_Encode4(193142), // Rule ID 11944 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1752:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBWT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWT_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11944,
        GIR_EraseRootFromParent_Done,
      // Label 3829: @193142
      GIM_Try, /*On fail goto*//*Label 3830*/ GIMT_Encode4(193179), // Rule ID 11945 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1945:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBWB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWB_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11945,
        GIR_EraseRootFromParent_Done,
      // Label 3830: @193179
      GIM_Try, /*On fail goto*//*Label 3831*/ GIMT_Encode4(193216), // Rule ID 11946 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1945:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBWB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWB_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11946,
        GIR_EraseRootFromParent_Done,
      // Label 3831: @193216
      GIM_Try, /*On fail goto*//*Label 3832*/ GIMT_Encode4(193253), // Rule ID 11947 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1945:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBWB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWB_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11947,
        GIR_EraseRootFromParent_Done,
      // Label 3832: @193253
      GIM_Try, /*On fail goto*//*Label 3833*/ GIMT_Encode4(193290), // Rule ID 11948 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1946:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBWT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWT_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11948,
        GIR_EraseRootFromParent_Done,
      // Label 3833: @193290
      GIM_Try, /*On fail goto*//*Label 3834*/ GIMT_Encode4(193327), // Rule ID 11949 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1946:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBWT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWT_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11949,
        GIR_EraseRootFromParent_Done,
      // Label 3834: @193327
      GIM_Try, /*On fail goto*//*Label 3835*/ GIMT_Encode4(193364), // Rule ID 11950 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1946:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBWT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWT_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11950,
        GIR_EraseRootFromParent_Done,
      // Label 3835: @193364
      GIM_Try, /*On fail goto*//*Label 3836*/ GIMT_Encode4(193401), // Rule ID 11951 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1681:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQDMULLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11951,
        GIR_EraseRootFromParent_Done,
      // Label 3836: @193401
      GIM_Try, /*On fail goto*//*Label 3837*/ GIMT_Encode4(193438), // Rule ID 11952 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1681:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQDMULLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11952,
        GIR_EraseRootFromParent_Done,
      // Label 3837: @193438
      GIM_Try, /*On fail goto*//*Label 3838*/ GIMT_Encode4(193475), // Rule ID 11953 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1681:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQDMULLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11953,
        GIR_EraseRootFromParent_Done,
      // Label 3838: @193475
      GIM_Try, /*On fail goto*//*Label 3839*/ GIMT_Encode4(193512), // Rule ID 11954 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1683:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQDMULLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11954,
        GIR_EraseRootFromParent_Done,
      // Label 3839: @193512
      GIM_Try, /*On fail goto*//*Label 3840*/ GIMT_Encode4(193549), // Rule ID 11955 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1683:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQDMULLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11955,
        GIR_EraseRootFromParent_Done,
      // Label 3840: @193549
      GIM_Try, /*On fail goto*//*Label 3841*/ GIMT_Encode4(193586), // Rule ID 11956 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1683:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQDMULLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11956,
        GIR_EraseRootFromParent_Done,
      // Label 3841: @193586
      GIM_Try, /*On fail goto*//*Label 3842*/ GIMT_Encode4(193623), // Rule ID 11957 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1634:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMULLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11957,
        GIR_EraseRootFromParent_Done,
      // Label 3842: @193623
      GIM_Try, /*On fail goto*//*Label 3843*/ GIMT_Encode4(193660), // Rule ID 11958 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1634:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMULLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11958,
        GIR_EraseRootFromParent_Done,
      // Label 3843: @193660
      GIM_Try, /*On fail goto*//*Label 3844*/ GIMT_Encode4(193697), // Rule ID 11959 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1634:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMULLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11959,
        GIR_EraseRootFromParent_Done,
      // Label 3844: @193697
      GIM_Try, /*On fail goto*//*Label 3845*/ GIMT_Encode4(193734), // Rule ID 11960 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1636:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMULLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11960,
        GIR_EraseRootFromParent_Done,
      // Label 3845: @193734
      GIM_Try, /*On fail goto*//*Label 3846*/ GIMT_Encode4(193771), // Rule ID 11961 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1636:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMULLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11961,
        GIR_EraseRootFromParent_Done,
      // Label 3846: @193771
      GIM_Try, /*On fail goto*//*Label 3847*/ GIMT_Encode4(193808), // Rule ID 11962 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1636:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMULLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11962,
        GIR_EraseRootFromParent_Done,
      // Label 3847: @193808
      GIM_Try, /*On fail goto*//*Label 3848*/ GIMT_Encode4(193845), // Rule ID 11963 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1872:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMULLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11963,
        GIR_EraseRootFromParent_Done,
      // Label 3848: @193845
      GIM_Try, /*On fail goto*//*Label 3849*/ GIMT_Encode4(193882), // Rule ID 11964 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1872:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMULLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11964,
        GIR_EraseRootFromParent_Done,
      // Label 3849: @193882
      GIM_Try, /*On fail goto*//*Label 3850*/ GIMT_Encode4(193919), // Rule ID 11965 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1872:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMULLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11965,
        GIR_EraseRootFromParent_Done,
      // Label 3850: @193919
      GIM_Try, /*On fail goto*//*Label 3851*/ GIMT_Encode4(193956), // Rule ID 11966 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1874:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMULLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11966,
        GIR_EraseRootFromParent_Done,
      // Label 3851: @193956
      GIM_Try, /*On fail goto*//*Label 3852*/ GIMT_Encode4(193993), // Rule ID 11967 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1874:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMULLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11967,
        GIR_EraseRootFromParent_Done,
      // Label 3852: @193993
      GIM_Try, /*On fail goto*//*Label 3853*/ GIMT_Encode4(194030), // Rule ID 11968 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1874:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMULLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11968,
        GIR_EraseRootFromParent_Done,
      // Label 3853: @194030
      GIM_Try, /*On fail goto*//*Label 3854*/ GIMT_Encode4(194067), // Rule ID 11969 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullt_pair),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1512:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (PMULLT_ZZZ_H:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLT_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11969,
        GIR_EraseRootFromParent_Done,
      // Label 3854: @194067
      GIM_Try, /*On fail goto*//*Label 3855*/ GIMT_Encode4(194104), // Rule ID 11970 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullt_pair),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1512:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (PMULLT_ZZZ_D:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLT_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11970,
        GIR_EraseRootFromParent_Done,
      // Label 3855: @194104
      GIM_Try, /*On fail goto*//*Label 3856*/ GIMT_Encode4(194141), // Rule ID 12071 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1542:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (RADDHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNB_ZZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12071,
        GIR_EraseRootFromParent_Done,
      // Label 3856: @194141
      GIM_Try, /*On fail goto*//*Label 3857*/ GIMT_Encode4(194178), // Rule ID 12072 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1542:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (RADDHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNB_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12072,
        GIR_EraseRootFromParent_Done,
      // Label 3857: @194178
      GIM_Try, /*On fail goto*//*Label 3858*/ GIMT_Encode4(194215), // Rule ID 12073 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1542:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (RADDHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNB_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12073,
        GIR_EraseRootFromParent_Done,
      // Label 3858: @194215
      GIM_Try, /*On fail goto*//*Label 3859*/ GIMT_Encode4(194252), // Rule ID 12074 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1783:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SUBHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNB_ZZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12074,
        GIR_EraseRootFromParent_Done,
      // Label 3859: @194252
      GIM_Try, /*On fail goto*//*Label 3860*/ GIMT_Encode4(194289), // Rule ID 12075 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1783:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SUBHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNB_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12075,
        GIR_EraseRootFromParent_Done,
      // Label 3860: @194289
      GIM_Try, /*On fail goto*//*Label 3861*/ GIMT_Encode4(194326), // Rule ID 12076 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1783:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SUBHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNB_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12076,
        GIR_EraseRootFromParent_Done,
      // Label 3861: @194326
      GIM_Try, /*On fail goto*//*Label 3862*/ GIMT_Encode4(194363), // Rule ID 12077 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1558:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (RSUBHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNB_ZZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12077,
        GIR_EraseRootFromParent_Done,
      // Label 3862: @194363
      GIM_Try, /*On fail goto*//*Label 3863*/ GIMT_Encode4(194400), // Rule ID 12078 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1558:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (RSUBHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNB_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12078,
        GIR_EraseRootFromParent_Done,
      // Label 3863: @194400
      GIM_Try, /*On fail goto*//*Label 3864*/ GIMT_Encode4(194437), // Rule ID 12079 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1558:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (RSUBHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNB_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12079,
        GIR_EraseRootFromParent_Done,
      // Label 3864: @194437
      GIM_Try, /*On fail goto*//*Label 3865*/ GIMT_Encode4(194474), // Rule ID 12095 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1925:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UQXTNT_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNT_ZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12095,
        GIR_EraseRootFromParent_Done,
      // Label 3865: @194474
      GIM_Try, /*On fail goto*//*Label 3866*/ GIMT_Encode4(194511), // Rule ID 12096 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1925:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UQXTNT_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNT_ZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12096,
        GIR_EraseRootFromParent_Done,
      // Label 3866: @194511
      GIM_Try, /*On fail goto*//*Label 3867*/ GIMT_Encode4(194548), // Rule ID 12097 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1925:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UQXTNT_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNT_ZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12097,
        GIR_EraseRootFromParent_Done,
      // Label 3867: @194548
      GIM_Try, /*On fail goto*//*Label 3868*/ GIMT_Encode4(194585), // Rule ID 12098 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1734:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQXTUNT_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNT_ZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12098,
        GIR_EraseRootFromParent_Done,
      // Label 3868: @194585
      GIM_Try, /*On fail goto*//*Label 3869*/ GIMT_Encode4(194622), // Rule ID 12099 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1734:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQXTUNT_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNT_ZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12099,
        GIR_EraseRootFromParent_Done,
      // Label 3869: @194622
      GIM_Try, /*On fail goto*//*Label 3870*/ GIMT_Encode4(194659), // Rule ID 12100 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1734:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQXTUNT_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNT_ZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12100,
        GIR_EraseRootFromParent_Done,
      // Label 3870: @194659
      GIM_Try, /*On fail goto*//*Label 3871*/ GIMT_Encode4(194696), // Rule ID 12116 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublbt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1748:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLBT_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12116,
        GIR_EraseRootFromParent_Done,
      // Label 3871: @194696
      GIM_Try, /*On fail goto*//*Label 3872*/ GIMT_Encode4(194733), // Rule ID 12117 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublbt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1748:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLBT_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12117,
        GIR_EraseRootFromParent_Done,
      // Label 3872: @194733
      GIM_Try, /*On fail goto*//*Label 3873*/ GIMT_Encode4(194770), // Rule ID 12118 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublbt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1748:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLBT_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12118,
        GIR_EraseRootFromParent_Done,
      // Label 3873: @194770
      GIM_Try, /*On fail goto*//*Label 3874*/ GIMT_Encode4(194807), // Rule ID 12119 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubltb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1750:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLTB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLTB_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12119,
        GIR_EraseRootFromParent_Done,
      // Label 3874: @194807
      GIM_Try, /*On fail goto*//*Label 3875*/ GIMT_Encode4(194844), // Rule ID 12120 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubltb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1750:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLTB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLTB_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12120,
        GIR_EraseRootFromParent_Done,
      // Label 3875: @194844
      GIM_Try, /*On fail goto*//*Label 3876*/ GIMT_Encode4(194881), // Rule ID 12121 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubltb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1750:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLTB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLTB_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12121,
        GIR_EraseRootFromParent_Done,
      // Label 3876: @194881
      GIM_Try, /*On fail goto*//*Label 3877*/ GIMT_Encode4(194921), // Rule ID 12199 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1970:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12199,
        GIR_EraseRootFromParent_Done,
      // Label 3877: @194921
      GIM_Try, /*On fail goto*//*Label 3878*/ GIMT_Encode4(194961), // Rule ID 12200 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1970:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12200,
        GIR_EraseRootFromParent_Done,
      // Label 3878: @194961
      GIM_Try, /*On fail goto*//*Label 3879*/ GIMT_Encode4(195001), // Rule ID 12201 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1970:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12201,
        GIR_EraseRootFromParent_Done,
      // Label 3879: @195001
      GIM_Try, /*On fail goto*//*Label 3880*/ GIMT_Encode4(195041), // Rule ID 12202 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 1970:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12202,
        GIR_EraseRootFromParent_Done,
      // Label 3880: @195041
      GIM_Try, /*On fail goto*//*Label 3881*/ GIMT_Encode4(195081), // Rule ID 12203 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1976:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12203,
        GIR_EraseRootFromParent_Done,
      // Label 3881: @195081
      GIM_Try, /*On fail goto*//*Label 3882*/ GIMT_Encode4(195121), // Rule ID 12204 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1976:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12204,
        GIR_EraseRootFromParent_Done,
      // Label 3882: @195121
      GIM_Try, /*On fail goto*//*Label 3883*/ GIMT_Encode4(195161), // Rule ID 12205 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1976:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12205,
        GIR_EraseRootFromParent_Done,
      // Label 3883: @195161
      GIM_Try, /*On fail goto*//*Label 3884*/ GIMT_Encode4(195201), // Rule ID 12206 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 1976:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12206,
        GIR_EraseRootFromParent_Done,
      // Label 3884: @195201
      GIM_Try, /*On fail goto*//*Label 3885*/ GIMT_Encode4(195241), // Rule ID 12211 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1988:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12211,
        GIR_EraseRootFromParent_Done,
      // Label 3885: @195241
      GIM_Try, /*On fail goto*//*Label 3886*/ GIMT_Encode4(195281), // Rule ID 12212 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1988:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12212,
        GIR_EraseRootFromParent_Done,
      // Label 3886: @195281
      GIM_Try, /*On fail goto*//*Label 3887*/ GIMT_Encode4(195321), // Rule ID 12213 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1988:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12213,
        GIR_EraseRootFromParent_Done,
      // Label 3887: @195321
      GIM_Try, /*On fail goto*//*Label 3888*/ GIMT_Encode4(195361), // Rule ID 12214 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 1988:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12214,
        GIR_EraseRootFromParent_Done,
      // Label 3888: @195361
      GIM_Try, /*On fail goto*//*Label 3889*/ GIMT_Encode4(195401), // Rule ID 12215 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1982:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12215,
        GIR_EraseRootFromParent_Done,
      // Label 3889: @195401
      GIM_Try, /*On fail goto*//*Label 3890*/ GIMT_Encode4(195441), // Rule ID 12216 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1982:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12216,
        GIR_EraseRootFromParent_Done,
      // Label 3890: @195441
      GIM_Try, /*On fail goto*//*Label 3891*/ GIMT_Encode4(195481), // Rule ID 12217 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1982:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12217,
        GIR_EraseRootFromParent_Done,
      // Label 3891: @195481
      GIM_Try, /*On fail goto*//*Label 3892*/ GIMT_Encode4(195521), // Rule ID 12218 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 1982:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12218,
        GIR_EraseRootFromParent_Done,
      // Label 3892: @195521
      GIM_Try, /*On fail goto*//*Label 3893*/ GIMT_Encode4(195561), // Rule ID 12223 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1970:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12223,
        GIR_EraseRootFromParent_Done,
      // Label 3893: @195561
      GIM_Try, /*On fail goto*//*Label 3894*/ GIMT_Encode4(195601), // Rule ID 12224 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1970:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12224,
        GIR_EraseRootFromParent_Done,
      // Label 3894: @195601
      GIM_Try, /*On fail goto*//*Label 3895*/ GIMT_Encode4(195641), // Rule ID 12225 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1970:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12225,
        GIR_EraseRootFromParent_Done,
      // Label 3895: @195641
      GIM_Try, /*On fail goto*//*Label 3896*/ GIMT_Encode4(195681), // Rule ID 12226 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 1970:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12226,
        GIR_EraseRootFromParent_Done,
      // Label 3896: @195681
      GIM_Try, /*On fail goto*//*Label 3897*/ GIMT_Encode4(195721), // Rule ID 12227 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1976:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12227,
        GIR_EraseRootFromParent_Done,
      // Label 3897: @195721
      GIM_Try, /*On fail goto*//*Label 3898*/ GIMT_Encode4(195761), // Rule ID 12228 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1976:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12228,
        GIR_EraseRootFromParent_Done,
      // Label 3898: @195761
      GIM_Try, /*On fail goto*//*Label 3899*/ GIMT_Encode4(195801), // Rule ID 12229 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1976:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12229,
        GIR_EraseRootFromParent_Done,
      // Label 3899: @195801
      GIM_Try, /*On fail goto*//*Label 3900*/ GIMT_Encode4(195841), // Rule ID 12230 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 1976:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12230,
        GIR_EraseRootFromParent_Done,
      // Label 3900: @195841
      GIM_Try, /*On fail goto*//*Label 3901*/ GIMT_Encode4(195881), // Rule ID 12235 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1988:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12235,
        GIR_EraseRootFromParent_Done,
      // Label 3901: @195881
      GIM_Try, /*On fail goto*//*Label 3902*/ GIMT_Encode4(195921), // Rule ID 12236 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1988:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12236,
        GIR_EraseRootFromParent_Done,
      // Label 3902: @195921
      GIM_Try, /*On fail goto*//*Label 3903*/ GIMT_Encode4(195961), // Rule ID 12237 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1988:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12237,
        GIR_EraseRootFromParent_Done,
      // Label 3903: @195961
      GIM_Try, /*On fail goto*//*Label 3904*/ GIMT_Encode4(196001), // Rule ID 12238 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 1988:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12238,
        GIR_EraseRootFromParent_Done,
      // Label 3904: @196001
      GIM_Try, /*On fail goto*//*Label 3905*/ GIMT_Encode4(196041), // Rule ID 12239 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1982:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12239,
        GIR_EraseRootFromParent_Done,
      // Label 3905: @196041
      GIM_Try, /*On fail goto*//*Label 3906*/ GIMT_Encode4(196081), // Rule ID 12240 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1982:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12240,
        GIR_EraseRootFromParent_Done,
      // Label 3906: @196081
      GIM_Try, /*On fail goto*//*Label 3907*/ GIMT_Encode4(196121), // Rule ID 12241 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1982:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12241,
        GIR_EraseRootFromParent_Done,
      // Label 3907: @196121
      GIM_Try, /*On fail goto*//*Label 3908*/ GIMT_Encode4(196161), // Rule ID 12242 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 1982:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12242,
        GIR_EraseRootFromParent_Done,
      // Label 3908: @196161
      GIM_Try, /*On fail goto*//*Label 3909*/ GIMT_Encode4(196198), // Rule ID 12251 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2orSSVE_AES_HasSVEAES),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aesd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1138:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (AESD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESD_ZZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12251,
        GIR_EraseRootFromParent_Done,
      // Label 3909: @196198
      GIM_Try, /*On fail goto*//*Label 3910*/ GIMT_Encode4(196235), // Rule ID 12253 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2orSSVE_AES_HasSVEAES),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullt_pair),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1512:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (PMULLT_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLT_ZZZ_Q),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12253,
        GIR_EraseRootFromParent_Done,
      // Label 3910: @196235
      GIM_Try, /*On fail goto*//*Label 3911*/ GIMT_Encode4(196272), // Rule ID 12254 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2SM4),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sm4e),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1603:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SM4E_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4E_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12254,
        GIR_EraseRootFromParent_Done,
      // Label 3911: @196272
      GIM_Try, /*On fail goto*//*Label 3912*/ GIMT_Encode4(196309), // Rule ID 12255 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2SHA3),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rax1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1544:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (RAX1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RAX1_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12255,
        GIR_EraseRootFromParent_Done,
      // Label 3912: @196309
      GIM_Try, /*On fail goto*//*Label 3913*/ GIMT_Encode4(196346), // Rule ID 12256 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2BitPerm),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1152:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BDEP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12256,
        GIR_EraseRootFromParent_Done,
      // Label 3913: @196346
      GIM_Try, /*On fail goto*//*Label 3914*/ GIMT_Encode4(196383), // Rule ID 12257 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2BitPerm),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1152:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BDEP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12257,
        GIR_EraseRootFromParent_Done,
      // Label 3914: @196383
      GIM_Try, /*On fail goto*//*Label 3915*/ GIMT_Encode4(196420), // Rule ID 12258 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2BitPerm),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1152:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BDEP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12258,
        GIR_EraseRootFromParent_Done,
      // Label 3915: @196420
      GIM_Try, /*On fail goto*//*Label 3916*/ GIMT_Encode4(196457), // Rule ID 12259 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2BitPerm),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1152:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BDEP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12259,
        GIR_EraseRootFromParent_Done,
      // Label 3916: @196457
      GIM_Try, /*On fail goto*//*Label 3917*/ GIMT_Encode4(196494), // Rule ID 12260 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2BitPerm),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1169:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BGRP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12260,
        GIR_EraseRootFromParent_Done,
      // Label 3917: @196494
      GIM_Try, /*On fail goto*//*Label 3918*/ GIMT_Encode4(196531), // Rule ID 12261 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2BitPerm),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1169:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BGRP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12261,
        GIR_EraseRootFromParent_Done,
      // Label 3918: @196531
      GIM_Try, /*On fail goto*//*Label 3919*/ GIMT_Encode4(196568), // Rule ID 12262 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2BitPerm),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1169:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BGRP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12262,
        GIR_EraseRootFromParent_Done,
      // Label 3919: @196568
      GIM_Try, /*On fail goto*//*Label 3920*/ GIMT_Encode4(196605), // Rule ID 12263 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2BitPerm),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1169:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BGRP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12263,
        GIR_EraseRootFromParent_Done,
      // Label 3920: @196605
      GIM_Try, /*On fail goto*//*Label 3921*/ GIMT_Encode4(196642), // Rule ID 12441 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8f16] } 1318:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMAXNMQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMQV_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12441,
        GIR_EraseRootFromParent_Done,
      // Label 3921: @196642
      GIM_Try, /*On fail goto*//*Label 3922*/ GIMT_Encode4(196679), // Rule ID 12442 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 1318:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMAXNMQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMQV_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12442,
        GIR_EraseRootFromParent_Done,
      // Label 3922: @196679
      GIM_Try, /*On fail goto*//*Label 3923*/ GIMT_Encode4(196716), // Rule ID 12443 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f64] } 1318:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMAXNMQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMQV_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12443,
        GIR_EraseRootFromParent_Done,
      // Label 3923: @196716
      GIM_Try, /*On fail goto*//*Label 3924*/ GIMT_Encode4(196753), // Rule ID 12444 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8f16] } 1336:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMINNMQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMQV_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12444,
        GIR_EraseRootFromParent_Done,
      // Label 3924: @196753
      GIM_Try, /*On fail goto*//*Label 3925*/ GIMT_Encode4(196790), // Rule ID 12445 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 1336:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMINNMQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMQV_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12445,
        GIR_EraseRootFromParent_Done,
      // Label 3925: @196790
      GIM_Try, /*On fail goto*//*Label 3926*/ GIMT_Encode4(196827), // Rule ID 12446 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f64] } 1336:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMINNMQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMQV_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12446,
        GIR_EraseRootFromParent_Done,
      // Label 3926: @196827
      GIM_Try, /*On fail goto*//*Label 3927*/ GIMT_Encode4(196864), // Rule ID 12447 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8f16] } 1321:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMAXQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXQV_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12447,
        GIR_EraseRootFromParent_Done,
      // Label 3927: @196864
      GIM_Try, /*On fail goto*//*Label 3928*/ GIMT_Encode4(196901), // Rule ID 12448 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 1321:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMAXQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXQV_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12448,
        GIR_EraseRootFromParent_Done,
      // Label 3928: @196901
      GIM_Try, /*On fail goto*//*Label 3929*/ GIMT_Encode4(196938), // Rule ID 12449 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f64] } 1321:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMAXQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXQV_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12449,
        GIR_EraseRootFromParent_Done,
      // Label 3929: @196938
      GIM_Try, /*On fail goto*//*Label 3930*/ GIMT_Encode4(196975), // Rule ID 12450 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8f16] } 1339:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMINQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINQV_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12450,
        GIR_EraseRootFromParent_Done,
      // Label 3930: @196975
      GIM_Try, /*On fail goto*//*Label 3931*/ GIMT_Encode4(197012), // Rule ID 12451 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 1339:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMINQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINQV_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12451,
        GIR_EraseRootFromParent_Done,
      // Label 3931: @197012
      GIM_Try, /*On fail goto*//*Label 3932*/ GIMT_Encode4(197049), // Rule ID 12452 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f64] } 1339:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMINQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINQV_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12452,
        GIR_EraseRootFromParent_Done,
      // Label 3932: @197049
      GIM_Try, /*On fail goto*//*Label 3933*/ GIMT_Encode4(197086), // Rule ID 12453 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 1233:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (EORQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12453,
        GIR_EraseRootFromParent_Done,
      // Label 3933: @197086
      GIM_Try, /*On fail goto*//*Label 3934*/ GIMT_Encode4(197123), // Rule ID 12454 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 1233:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (EORQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12454,
        GIR_EraseRootFromParent_Done,
      // Label 3934: @197123
      GIM_Try, /*On fail goto*//*Label 3935*/ GIMT_Encode4(197160), // Rule ID 12455 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 1233:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (EORQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12455,
        GIR_EraseRootFromParent_Done,
      // Label 3935: @197160
      GIM_Try, /*On fail goto*//*Label 3936*/ GIMT_Encode4(197197), // Rule ID 12456 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 1233:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (EORQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12456,
        GIR_EraseRootFromParent_Done,
      // Label 3936: @197197
      GIM_Try, /*On fail goto*//*Label 3937*/ GIMT_Encode4(197234), // Rule ID 12457 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 1145:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ANDQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12457,
        GIR_EraseRootFromParent_Done,
      // Label 3937: @197234
      GIM_Try, /*On fail goto*//*Label 3938*/ GIMT_Encode4(197271), // Rule ID 12458 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 1145:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ANDQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12458,
        GIR_EraseRootFromParent_Done,
      // Label 3938: @197271
      GIM_Try, /*On fail goto*//*Label 3939*/ GIMT_Encode4(197308), // Rule ID 12459 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 1145:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ANDQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12459,
        GIR_EraseRootFromParent_Done,
      // Label 3939: @197308
      GIM_Try, /*On fail goto*//*Label 3940*/ GIMT_Encode4(197345), // Rule ID 12460 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 1145:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ANDQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12460,
        GIR_EraseRootFromParent_Done,
      // Label 3940: @197345
      GIM_Try, /*On fail goto*//*Label 3941*/ GIMT_Encode4(197382), // Rule ID 12461 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 1133:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ADDQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12461,
        GIR_EraseRootFromParent_Done,
      // Label 3941: @197382
      GIM_Try, /*On fail goto*//*Label 3942*/ GIMT_Encode4(197419), // Rule ID 12462 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 1133:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ADDQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12462,
        GIR_EraseRootFromParent_Done,
      // Label 3942: @197419
      GIM_Try, /*On fail goto*//*Label 3943*/ GIMT_Encode4(197456), // Rule ID 12463 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 1133:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADDQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12463,
        GIR_EraseRootFromParent_Done,
      // Label 3943: @197456
      GIM_Try, /*On fail goto*//*Label 3944*/ GIMT_Encode4(197493), // Rule ID 12464 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 1133:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADDQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12464,
        GIR_EraseRootFromParent_Done,
      // Label 3944: @197493
      GIM_Try, /*On fail goto*//*Label 3945*/ GIMT_Encode4(197530), // Rule ID 12465 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 1612:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMAXQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12465,
        GIR_EraseRootFromParent_Done,
      // Label 3945: @197530
      GIM_Try, /*On fail goto*//*Label 3946*/ GIMT_Encode4(197567), // Rule ID 12466 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 1612:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMAXQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12466,
        GIR_EraseRootFromParent_Done,
      // Label 3946: @197567
      GIM_Try, /*On fail goto*//*Label 3947*/ GIMT_Encode4(197604), // Rule ID 12467 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 1612:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMAXQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12467,
        GIR_EraseRootFromParent_Done,
      // Label 3947: @197604
      GIM_Try, /*On fail goto*//*Label 3948*/ GIMT_Encode4(197641), // Rule ID 12468 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 1612:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SMAXQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12468,
        GIR_EraseRootFromParent_Done,
      // Label 3948: @197641
      GIM_Try, /*On fail goto*//*Label 3949*/ GIMT_Encode4(197678), // Rule ID 12469 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 1850:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMAXQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12469,
        GIR_EraseRootFromParent_Done,
      // Label 3949: @197678
      GIM_Try, /*On fail goto*//*Label 3950*/ GIMT_Encode4(197715), // Rule ID 12470 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 1850:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMAXQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12470,
        GIR_EraseRootFromParent_Done,
      // Label 3950: @197715
      GIM_Try, /*On fail goto*//*Label 3951*/ GIMT_Encode4(197752), // Rule ID 12471 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 1850:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMAXQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12471,
        GIR_EraseRootFromParent_Done,
      // Label 3951: @197752
      GIM_Try, /*On fail goto*//*Label 3952*/ GIMT_Encode4(197789), // Rule ID 12472 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 1850:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UMAXQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12472,
        GIR_EraseRootFromParent_Done,
      // Label 3952: @197789
      GIM_Try, /*On fail goto*//*Label 3953*/ GIMT_Encode4(197826), // Rule ID 12473 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 1621:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMINQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12473,
        GIR_EraseRootFromParent_Done,
      // Label 3953: @197826
      GIM_Try, /*On fail goto*//*Label 3954*/ GIMT_Encode4(197863), // Rule ID 12474 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 1621:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMINQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12474,
        GIR_EraseRootFromParent_Done,
      // Label 3954: @197863
      GIM_Try, /*On fail goto*//*Label 3955*/ GIMT_Encode4(197900), // Rule ID 12475 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 1621:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMINQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12475,
        GIR_EraseRootFromParent_Done,
      // Label 3955: @197900
      GIM_Try, /*On fail goto*//*Label 3956*/ GIMT_Encode4(197937), // Rule ID 12476 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 1621:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SMINQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12476,
        GIR_EraseRootFromParent_Done,
      // Label 3956: @197937
      GIM_Try, /*On fail goto*//*Label 3957*/ GIMT_Encode4(197974), // Rule ID 12477 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 1859:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMINQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12477,
        GIR_EraseRootFromParent_Done,
      // Label 3957: @197974
      GIM_Try, /*On fail goto*//*Label 3958*/ GIMT_Encode4(198011), // Rule ID 12478 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 1859:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMINQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12478,
        GIR_EraseRootFromParent_Done,
      // Label 3958: @198011
      GIM_Try, /*On fail goto*//*Label 3959*/ GIMT_Encode4(198048), // Rule ID 12479 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 1859:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMINQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12479,
        GIR_EraseRootFromParent_Done,
      // Label 3959: @198048
      GIM_Try, /*On fail goto*//*Label 3960*/ GIMT_Encode4(198085), // Rule ID 12480 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 1859:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UMINQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12480,
        GIR_EraseRootFromParent_Done,
      // Label 3960: @198085
      GIM_Try, /*On fail goto*//*Label 3961*/ GIMT_Encode4(198122), // Rule ID 12481 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 2043:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIPQ2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12481,
        GIR_EraseRootFromParent_Done,
      // Label 3961: @198122
      GIM_Try, /*On fail goto*//*Label 3962*/ GIMT_Encode4(198159), // Rule ID 12482 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 2043:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIPQ2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12482,
        GIR_EraseRootFromParent_Done,
      // Label 3962: @198159
      GIM_Try, /*On fail goto*//*Label 3963*/ GIMT_Encode4(198196), // Rule ID 12483 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 2043:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIPQ2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12483,
        GIR_EraseRootFromParent_Done,
      // Label 3963: @198196
      GIM_Try, /*On fail goto*//*Label 3964*/ GIMT_Encode4(198233), // Rule ID 12484 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 2043:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIPQ2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12484,
        GIR_EraseRootFromParent_Done,
      // Label 3964: @198233
      GIM_Try, /*On fail goto*//*Label 3965*/ GIMT_Encode4(198270), // Rule ID 12485 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 2043:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIPQ2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12485,
        GIR_EraseRootFromParent_Done,
      // Label 3965: @198270
      GIM_Try, /*On fail goto*//*Label 3966*/ GIMT_Encode4(198307), // Rule ID 12486 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 2043:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIPQ2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12486,
        GIR_EraseRootFromParent_Done,
      // Label 3966: @198307
      GIM_Try, /*On fail goto*//*Label 3967*/ GIMT_Encode4(198344), // Rule ID 12487 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 2043:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIPQ2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12487,
        GIR_EraseRootFromParent_Done,
      // Label 3967: @198344
      GIM_Try, /*On fail goto*//*Label 3968*/ GIMT_Encode4(198381), // Rule ID 12488 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8bf16] } 2043:{ *:[iPTR] }, nxv8bf16:{ *:[nxv8bf16] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2)  =>  (ZIPQ2_ZZZ_H:{ *:[nxv8bf16] } ?:{ *:[nxv8bf16] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12488,
        GIR_EraseRootFromParent_Done,
      // Label 3968: @198381
      GIM_Try, /*On fail goto*//*Label 3969*/ GIMT_Encode4(198418), // Rule ID 12489 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1968:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZPQ1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12489,
        GIR_EraseRootFromParent_Done,
      // Label 3969: @198418
      GIM_Try, /*On fail goto*//*Label 3970*/ GIMT_Encode4(198455), // Rule ID 12490 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1968:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZPQ1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12490,
        GIR_EraseRootFromParent_Done,
      // Label 3970: @198455
      GIM_Try, /*On fail goto*//*Label 3971*/ GIMT_Encode4(198492), // Rule ID 12491 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1968:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZPQ1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12491,
        GIR_EraseRootFromParent_Done,
      // Label 3971: @198492
      GIM_Try, /*On fail goto*//*Label 3972*/ GIMT_Encode4(198529), // Rule ID 12492 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1968:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZPQ1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12492,
        GIR_EraseRootFromParent_Done,
      // Label 3972: @198529
      GIM_Try, /*On fail goto*//*Label 3973*/ GIMT_Encode4(198566), // Rule ID 12493 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1968:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZPQ1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12493,
        GIR_EraseRootFromParent_Done,
      // Label 3973: @198566
      GIM_Try, /*On fail goto*//*Label 3974*/ GIMT_Encode4(198603), // Rule ID 12494 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1968:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZPQ1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12494,
        GIR_EraseRootFromParent_Done,
      // Label 3974: @198603
      GIM_Try, /*On fail goto*//*Label 3975*/ GIMT_Encode4(198640), // Rule ID 12495 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1968:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZPQ1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12495,
        GIR_EraseRootFromParent_Done,
      // Label 3975: @198640
      GIM_Try, /*On fail goto*//*Label 3976*/ GIMT_Encode4(198677), // Rule ID 12496 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8bf16] } 1968:{ *:[iPTR] }, nxv8bf16:{ *:[nxv8bf16] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2)  =>  (UZPQ1_ZZZ_H:{ *:[nxv8bf16] } ?:{ *:[nxv8bf16] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12496,
        GIR_EraseRootFromParent_Done,
      // Label 3976: @198677
      GIM_Try, /*On fail goto*//*Label 3977*/ GIMT_Encode4(198714), // Rule ID 12497 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1969:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZPQ2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12497,
        GIR_EraseRootFromParent_Done,
      // Label 3977: @198714
      GIM_Try, /*On fail goto*//*Label 3978*/ GIMT_Encode4(198751), // Rule ID 12498 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1969:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZPQ2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12498,
        GIR_EraseRootFromParent_Done,
      // Label 3978: @198751
      GIM_Try, /*On fail goto*//*Label 3979*/ GIMT_Encode4(198788), // Rule ID 12499 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1969:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZPQ2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12499,
        GIR_EraseRootFromParent_Done,
      // Label 3979: @198788
      GIM_Try, /*On fail goto*//*Label 3980*/ GIMT_Encode4(198825), // Rule ID 12500 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1969:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZPQ2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12500,
        GIR_EraseRootFromParent_Done,
      // Label 3980: @198825
      GIM_Try, /*On fail goto*//*Label 3981*/ GIMT_Encode4(198862), // Rule ID 12501 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1969:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZPQ2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12501,
        GIR_EraseRootFromParent_Done,
      // Label 3981: @198862
      GIM_Try, /*On fail goto*//*Label 3982*/ GIMT_Encode4(198899), // Rule ID 12502 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1969:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZPQ2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12502,
        GIR_EraseRootFromParent_Done,
      // Label 3982: @198899
      GIM_Try, /*On fail goto*//*Label 3983*/ GIMT_Encode4(198936), // Rule ID 12503 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1969:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZPQ2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12503,
        GIR_EraseRootFromParent_Done,
      // Label 3983: @198936
      GIM_Try, /*On fail goto*//*Label 3984*/ GIMT_Encode4(198973), // Rule ID 12504 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8bf16] } 1969:{ *:[iPTR] }, nxv8bf16:{ *:[nxv8bf16] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2)  =>  (UZPQ2_ZZZ_H:{ *:[nxv8bf16] } ?:{ *:[nxv8bf16] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12504,
        GIR_EraseRootFromParent_Done,
      // Label 3984: @198973
      GIM_Try, /*On fail goto*//*Label 3985*/ GIMT_Encode4(199015), // Rule ID 3190 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_b),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // MIs[0] Op1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        // MIs[0] Op2
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 2022:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3190,
        GIR_EraseRootFromParent_Done,
      // Label 3985: @199015
      GIM_Try, /*On fail goto*//*Label 3986*/ GIMT_Encode4(199057), // Rule ID 3191 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_h),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // MIs[0] Op1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        // MIs[0] Op2
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 2024:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3191,
        GIR_EraseRootFromParent_Done,
      // Label 3986: @199057
      GIM_Try, /*On fail goto*//*Label 3987*/ GIMT_Encode4(199099), // Rule ID 3192 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_s),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // MIs[0] Op1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        // MIs[0] Op2
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 2025:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3192,
        GIR_EraseRootFromParent_Done,
      // Label 3987: @199099
      GIM_Try, /*On fail goto*//*Label 3988*/ GIMT_Encode4(199141), // Rule ID 3193 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_d),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // MIs[0] Op1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        // MIs[0] Op2
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 2023:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3193,
        GIR_EraseRootFromParent_Done,
      // Label 3988: @199141
      GIM_Try, /*On fail goto*//*Label 3989*/ GIMT_Encode4(199183), // Rule ID 12247 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_b),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // MIs[0] Op1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        // MIs[0] Op2
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 2018:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12247,
        GIR_EraseRootFromParent_Done,
      // Label 3989: @199183
      GIM_Try, /*On fail goto*//*Label 3990*/ GIMT_Encode4(199225), // Rule ID 12248 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_h),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // MIs[0] Op1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        // MIs[0] Op2
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 2020:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12248,
        GIR_EraseRootFromParent_Done,
      // Label 3990: @199225
      GIM_Try, /*On fail goto*//*Label 3991*/ GIMT_Encode4(199267), // Rule ID 12249 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_s),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // MIs[0] Op1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        // MIs[0] Op2
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 2021:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12249,
        GIR_EraseRootFromParent_Done,
      // Label 3991: @199267
      GIM_Try, /*On fail goto*//*Label 3992*/ GIMT_Encode4(199309), // Rule ID 12250 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_d),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // MIs[0] Op1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        // MIs[0] Op2
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 2019:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12250,
        GIR_EraseRootFromParent_Done,
      // Label 3992: @199309
      GIM_Reject,
    // Label 3026: @199310
    GIM_Try, /*On fail goto*//*Label 3993*/ GIMT_Encode4(245050),
      GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
      GIM_Try, /*On fail goto*//*Label 3994*/ GIMT_Encode4(199431), // Rule ID 2058 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (intrinsic_wo_chain:{ *:[v4i16] } 661:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLAHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2058,
        GIR_EraseRootFromParent_Done,
      // Label 3994: @199431
      GIM_Try, /*On fail goto*//*Label 3995*/ GIMT_Encode4(199544), // Rule ID 2065 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (intrinsic_wo_chain:{ *:[v4i16] } 662:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLSHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2065,
        GIR_EraseRootFromParent_Done,
      // Label 3995: @199544
      GIM_Try, /*On fail goto*//*Label 3996*/ GIMT_Encode4(199657), // Rule ID 2061 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (intrinsic_wo_chain:{ *:[v2i32] } 661:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLAHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2061,
        GIR_EraseRootFromParent_Done,
      // Label 3996: @199657
      GIM_Try, /*On fail goto*//*Label 3997*/ GIMT_Encode4(199770), // Rule ID 2068 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (intrinsic_wo_chain:{ *:[v2i32] } 662:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLSHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2068,
        GIR_EraseRootFromParent_Done,
      // Label 3997: @199770
      GIM_Try, /*On fail goto*//*Label 3998*/ GIMT_Encode4(199872), // Rule ID 32 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_bfdot),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (intrinsic_wo_chain:{ *:[v2f32] } 566:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4bf16] }:$Rn, (bitconvert:{ *:[v4bf16] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (BF16DOTlanev4bf16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4bf16] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BF16DOTlanev4bf16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 32,
        GIR_EraseRootFromParent_Done,
      // Label 3998: @199872
      GIM_Try, /*On fail goto*//*Label 3999*/ GIMT_Encode4(199974), // Rule ID 33 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_bfdot),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (intrinsic_wo_chain:{ *:[v4f32] } 566:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8bf16] }:$Rn, (bitconvert:{ *:[v8bf16] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (BF16DOTlanev8bf16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BF16DOTlanev8bf16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 33,
        GIR_EraseRootFromParent_Done,
      // Label 3999: @199974
      GIM_Try, /*On fail goto*//*Label 4000*/ GIMT_Encode4(200079), // Rule ID 3849 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (intrinsic_wo_chain:{ *:[v4f16] } 732:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3849,
        GIR_EraseRootFromParent_Done,
      // Label 4000: @200079
      GIM_Try, /*On fail goto*//*Label 4001*/ GIMT_Encode4(200184), // Rule ID 3850 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (intrinsic_wo_chain:{ *:[v4f16] } 735:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3850,
        GIR_EraseRootFromParent_Done,
      // Label 4001: @200184
      GIM_Try, /*On fail goto*//*Label 4002*/ GIMT_Encode4(200289), // Rule ID 3851 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (intrinsic_wo_chain:{ *:[v4f16] } 733:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 2:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3851,
        GIR_EraseRootFromParent_Done,
      // Label 4002: @200289
      GIM_Try, /*On fail goto*//*Label 4003*/ GIMT_Encode4(200394), // Rule ID 3852 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (intrinsic_wo_chain:{ *:[v4f16] } 734:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3852,
        GIR_EraseRootFromParent_Done,
      // Label 4003: @200394
      GIM_Try, /*On fail goto*//*Label 4004*/ GIMT_Encode4(200499), // Rule ID 3857 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (intrinsic_wo_chain:{ *:[v8f16] } 732:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3857,
        GIR_EraseRootFromParent_Done,
      // Label 4004: @200499
      GIM_Try, /*On fail goto*//*Label 4005*/ GIMT_Encode4(200604), // Rule ID 3858 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (intrinsic_wo_chain:{ *:[v8f16] } 735:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3858,
        GIR_EraseRootFromParent_Done,
      // Label 4005: @200604
      GIM_Try, /*On fail goto*//*Label 4006*/ GIMT_Encode4(200709), // Rule ID 3859 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (intrinsic_wo_chain:{ *:[v8f16] } 733:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 2:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3859,
        GIR_EraseRootFromParent_Done,
      // Label 4006: @200709
      GIM_Try, /*On fail goto*//*Label 4007*/ GIMT_Encode4(200814), // Rule ID 3860 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (intrinsic_wo_chain:{ *:[v8f16] } 734:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3860,
        GIR_EraseRootFromParent_Done,
      // Label 4007: @200814
      GIM_Try, /*On fail goto*//*Label 4008*/ GIMT_Encode4(200919), // Rule ID 3873 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (intrinsic_wo_chain:{ *:[v4f32] } 732:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3873,
        GIR_EraseRootFromParent_Done,
      // Label 4008: @200919
      GIM_Try, /*On fail goto*//*Label 4009*/ GIMT_Encode4(201024), // Rule ID 3874 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (intrinsic_wo_chain:{ *:[v4f32] } 735:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3874,
        GIR_EraseRootFromParent_Done,
      // Label 4009: @201024
      GIM_Try, /*On fail goto*//*Label 4010*/ GIMT_Encode4(201129), // Rule ID 3875 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (intrinsic_wo_chain:{ *:[v4f32] } 733:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 2:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3875,
        GIR_EraseRootFromParent_Done,
      // Label 4010: @201129
      GIM_Try, /*On fail goto*//*Label 4011*/ GIMT_Encode4(201234), // Rule ID 3876 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (intrinsic_wo_chain:{ *:[v4f32] } 734:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3876,
        GIR_EraseRootFromParent_Done,
      // Label 4011: @201234
      GIM_Try, /*On fail goto*//*Label 4012*/ GIMT_Encode4(201288), // Rule ID 71 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Operand 3
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // (intrinsic_wo_chain:{ *:[i64] } 295:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 0:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACIZA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIZA),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71,
        GIR_EraseRootFromParent_Done,
      // Label 4012: @201288
      GIM_Try, /*On fail goto*//*Label 4013*/ GIMT_Encode4(201342), // Rule ID 72 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Operand 3
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // (intrinsic_wo_chain:{ *:[i64] } 295:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 2:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACDZA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDZA),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 72,
        GIR_EraseRootFromParent_Done,
      // Label 4013: @201342
      GIM_Try, /*On fail goto*//*Label 4014*/ GIMT_Encode4(201396), // Rule ID 73 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Operand 3
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // (intrinsic_wo_chain:{ *:[i64] } 295:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 1:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACIZB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIZB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 73,
        GIR_EraseRootFromParent_Done,
      // Label 4014: @201396
      GIM_Try, /*On fail goto*//*Label 4015*/ GIMT_Encode4(201450), // Rule ID 74 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Operand 3
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // (intrinsic_wo_chain:{ *:[i64] } 295:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 3:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACDZB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDZB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 74,
        GIR_EraseRootFromParent_Done,
      // Label 4015: @201450
      GIM_Try, /*On fail goto*//*Label 4016*/ GIMT_Encode4(201506), // Rule ID 2604 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqinch),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1690:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCH_ZPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Zn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2604,
        GIR_EraseRootFromParent_Done,
      // Label 4016: @201506
      GIM_Try, /*On fail goto*//*Label 4017*/ GIMT_Encode4(201562), // Rule ID 2613 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincb_n32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[i32] } 1896:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCB_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCB_WPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2613,
        GIR_EraseRootFromParent_Done,
      // Label 4017: @201562
      GIM_Try, /*On fail goto*//*Label 4018*/ GIMT_Encode4(201618), // Rule ID 2614 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincb_n64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[i64] } 1686:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCB_XPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2614,
        GIR_EraseRootFromParent_Done,
      // Label 4018: @201618
      GIM_Try, /*On fail goto*//*Label 4019*/ GIMT_Encode4(201674), // Rule ID 10191 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecb_n32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[i32] } 1882:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECB_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECB_WPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10191,
        GIR_EraseRootFromParent_Done,
      // Label 4019: @201674
      GIM_Try, /*On fail goto*//*Label 4020*/ GIMT_Encode4(201730), // Rule ID 10192 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincb_n64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[i64] } 1897:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCB_XPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10192,
        GIR_EraseRootFromParent_Done,
      // Label 4020: @201730
      GIM_Try, /*On fail goto*//*Label 4021*/ GIMT_Encode4(201786), // Rule ID 10193 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecb_n64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[i64] } 1652:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECB_XPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10193,
        GIR_EraseRootFromParent_Done,
      // Label 4021: @201786
      GIM_Try, /*On fail goto*//*Label 4022*/ GIMT_Encode4(201842), // Rule ID 10194 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecb_n64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[i64] } 1883:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECB_XPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10194,
        GIR_EraseRootFromParent_Done,
      // Label 4022: @201842
      GIM_Try, /*On fail goto*//*Label 4023*/ GIMT_Encode4(201898), // Rule ID 10197 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqinch_n32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[i32] } 1902:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCH_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCH_WPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10197,
        GIR_EraseRootFromParent_Done,
      // Label 4023: @201898
      GIM_Try, /*On fail goto*//*Label 4024*/ GIMT_Encode4(201954), // Rule ID 10200 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdech_n32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[i32] } 1888:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECH_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECH_WPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10200,
        GIR_EraseRootFromParent_Done,
      // Label 4024: @201954
      GIM_Try, /*On fail goto*//*Label 4025*/ GIMT_Encode4(202010), // Rule ID 10201 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqinch_n64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[i64] } 1692:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCH_XPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10201,
        GIR_EraseRootFromParent_Done,
      // Label 4025: @202010
      GIM_Try, /*On fail goto*//*Label 4026*/ GIMT_Encode4(202066), // Rule ID 10202 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqinch_n64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[i64] } 1903:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCH_XPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10202,
        GIR_EraseRootFromParent_Done,
      // Label 4026: @202066
      GIM_Try, /*On fail goto*//*Label 4027*/ GIMT_Encode4(202122), // Rule ID 10203 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdech_n64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[i64] } 1658:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECH_XPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10203,
        GIR_EraseRootFromParent_Done,
      // Label 4027: @202122
      GIM_Try, /*On fail goto*//*Label 4028*/ GIMT_Encode4(202178), // Rule ID 10204 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdech_n64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[i64] } 1889:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECH_XPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10204,
        GIR_EraseRootFromParent_Done,
      // Label 4028: @202178
      GIM_Try, /*On fail goto*//*Label 4029*/ GIMT_Encode4(202234), // Rule ID 10207 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincw_n32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[i32] } 1908:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCW_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCW_WPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10207,
        GIR_EraseRootFromParent_Done,
      // Label 4029: @202234
      GIM_Try, /*On fail goto*//*Label 4030*/ GIMT_Encode4(202290), // Rule ID 10210 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecw_n32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[i32] } 1894:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECW_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECW_WPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10210,
        GIR_EraseRootFromParent_Done,
      // Label 4030: @202290
      GIM_Try, /*On fail goto*//*Label 4031*/ GIMT_Encode4(202346), // Rule ID 10211 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincw_n64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[i64] } 1698:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCW_XPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10211,
        GIR_EraseRootFromParent_Done,
      // Label 4031: @202346
      GIM_Try, /*On fail goto*//*Label 4032*/ GIMT_Encode4(202402), // Rule ID 10212 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincw_n64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[i64] } 1909:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCW_XPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10212,
        GIR_EraseRootFromParent_Done,
      // Label 4032: @202402
      GIM_Try, /*On fail goto*//*Label 4033*/ GIMT_Encode4(202458), // Rule ID 10213 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecw_n64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[i64] } 1664:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECW_XPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10213,
        GIR_EraseRootFromParent_Done,
      // Label 4033: @202458
      GIM_Try, /*On fail goto*//*Label 4034*/ GIMT_Encode4(202514), // Rule ID 10214 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecw_n64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[i64] } 1895:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECW_XPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10214,
        GIR_EraseRootFromParent_Done,
      // Label 4034: @202514
      GIM_Try, /*On fail goto*//*Label 4035*/ GIMT_Encode4(202570), // Rule ID 10217 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincd_n32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[i32] } 1899:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCD_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCD_WPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10217,
        GIR_EraseRootFromParent_Done,
      // Label 4035: @202570
      GIM_Try, /*On fail goto*//*Label 4036*/ GIMT_Encode4(202626), // Rule ID 10220 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecd_n32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[i32] } 1885:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECD_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECD_WPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10220,
        GIR_EraseRootFromParent_Done,
      // Label 4036: @202626
      GIM_Try, /*On fail goto*//*Label 4037*/ GIMT_Encode4(202682), // Rule ID 10221 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincd_n64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[i64] } 1689:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCD_XPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10221,
        GIR_EraseRootFromParent_Done,
      // Label 4037: @202682
      GIM_Try, /*On fail goto*//*Label 4038*/ GIMT_Encode4(202738), // Rule ID 10222 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincd_n64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[i64] } 1900:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCD_XPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10222,
        GIR_EraseRootFromParent_Done,
      // Label 4038: @202738
      GIM_Try, /*On fail goto*//*Label 4039*/ GIMT_Encode4(202794), // Rule ID 10223 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecd_n64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[i64] } 1655:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECD_XPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10223,
        GIR_EraseRootFromParent_Done,
      // Label 4039: @202794
      GIM_Try, /*On fail goto*//*Label 4040*/ GIMT_Encode4(202850), // Rule ID 10224 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecd_n64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[i64] } 1886:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECD_XPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10224,
        GIR_EraseRootFromParent_Done,
      // Label 4040: @202850
      GIM_Try, /*On fail goto*//*Label 4041*/ GIMT_Encode4(202906), // Rule ID 10225 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqinch),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1901:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCH_ZPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Zn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10225,
        GIR_EraseRootFromParent_Done,
      // Label 4041: @202906
      GIM_Try, /*On fail goto*//*Label 4042*/ GIMT_Encode4(202962), // Rule ID 10226 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdech),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1656:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECH_ZPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Zn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10226,
        GIR_EraseRootFromParent_Done,
      // Label 4042: @202962
      GIM_Try, /*On fail goto*//*Label 4043*/ GIMT_Encode4(203018), // Rule ID 10227 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdech),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1887:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECH_ZPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Zn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10227,
        GIR_EraseRootFromParent_Done,
      // Label 4043: @203018
      GIM_Try, /*On fail goto*//*Label 4044*/ GIMT_Encode4(203074), // Rule ID 10228 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1696:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCW_ZPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Zn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10228,
        GIR_EraseRootFromParent_Done,
      // Label 4044: @203074
      GIM_Try, /*On fail goto*//*Label 4045*/ GIMT_Encode4(203130), // Rule ID 10229 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1907:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCW_ZPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Zn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10229,
        GIR_EraseRootFromParent_Done,
      // Label 4045: @203130
      GIM_Try, /*On fail goto*//*Label 4046*/ GIMT_Encode4(203186), // Rule ID 10230 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1662:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECW_ZPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Zn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10230,
        GIR_EraseRootFromParent_Done,
      // Label 4046: @203186
      GIM_Try, /*On fail goto*//*Label 4047*/ GIMT_Encode4(203242), // Rule ID 10231 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecw),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1893:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECW_ZPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Zn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10231,
        GIR_EraseRootFromParent_Done,
      // Label 4047: @203242
      GIM_Try, /*On fail goto*//*Label 4048*/ GIMT_Encode4(203298), // Rule ID 10232 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1687:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCD_ZPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Zn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10232,
        GIR_EraseRootFromParent_Done,
      // Label 4048: @203298
      GIM_Try, /*On fail goto*//*Label 4049*/ GIMT_Encode4(203354), // Rule ID 10233 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1898:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCD_ZPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Zn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10233,
        GIR_EraseRootFromParent_Done,
      // Label 4049: @203354
      GIM_Try, /*On fail goto*//*Label 4050*/ GIMT_Encode4(203410), // Rule ID 10234 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1653:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECD_ZPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Zn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10234,
        GIR_EraseRootFromParent_Done,
      // Label 4050: @203410
      GIM_Try, /*On fail goto*//*Label 4051*/ GIMT_Encode4(203466), // Rule ID 10235 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] pattern
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
        // MIs[0] imm4
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1884:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECD_ZPiI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Zn
        GIR_RootToRootCopy, /*OpIdx*/3, // pattern
        GIR_RootToRootCopy, /*OpIdx*/4, // imm4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10235,
        GIR_EraseRootFromParent_Done,
      // Label 4051: @203466
      GIM_Try, /*On fail goto*//*Label 4052*/ GIMT_Encode4(203556), // Rule ID 37 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_bfmlalb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v4f32] } 567:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8bf16] }:$Rn, (AArch64duplane16:{ *:[v8bf16] } V128_lo:{ *:[v8bf16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (BFMLALBIdx:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8bf16] }:$Rn, V128_lo:{ *:[v8bf16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMLALBIdx),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 37,
        GIR_EraseRootFromParent_Done,
      // Label 4052: @203556
      GIM_Try, /*On fail goto*//*Label 4053*/ GIMT_Encode4(203646), // Rule ID 38 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_bfmlalt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v4f32] } 568:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8bf16] }:$Rn, (AArch64duplane16:{ *:[v8bf16] } V128_lo:{ *:[v8bf16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (BFMLALTIdx:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8bf16] }:$Rn, V128_lo:{ *:[v8bf16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMLALTIdx),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 38,
        GIR_EraseRootFromParent_Done,
      // Label 4053: @203646
      GIM_Try, /*On fail goto*//*Label 4054*/ GIMT_Encode4(203736), // Rule ID 59 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v2f32] } 601:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLALlanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALlanev4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 59,
        GIR_EraseRootFromParent_Done,
      // Label 4054: @203736
      GIM_Try, /*On fail goto*//*Label 4055*/ GIMT_Encode4(203826), // Rule ID 60 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v4f32] } 601:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLALlanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALlanev8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60,
        GIR_EraseRootFromParent_Done,
      // Label 4055: @203826
      GIM_Try, /*On fail goto*//*Label 4056*/ GIMT_Encode4(203916), // Rule ID 61 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v2f32] } 603:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSLlanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLlanev4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61,
        GIR_EraseRootFromParent_Done,
      // Label 4056: @203916
      GIM_Try, /*On fail goto*//*Label 4057*/ GIMT_Encode4(204006), // Rule ID 62 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v4f32] } 603:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSLlanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLlanev8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62,
        GIR_EraseRootFromParent_Done,
      // Label 4057: @204006
      GIM_Try, /*On fail goto*//*Label 4058*/ GIMT_Encode4(204096), // Rule ID 63 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v2f32] } 602:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLAL2lanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2lanev4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63,
        GIR_EraseRootFromParent_Done,
      // Label 4058: @204096
      GIM_Try, /*On fail goto*//*Label 4059*/ GIMT_Encode4(204186), // Rule ID 64 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v4f32] } 602:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLAL2lanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2lanev8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64,
        GIR_EraseRootFromParent_Done,
      // Label 4059: @204186
      GIM_Try, /*On fail goto*//*Label 4060*/ GIMT_Encode4(204276), // Rule ID 65 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v2f32] } 604:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSL2lanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2lanev4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 65,
        GIR_EraseRootFromParent_Done,
      // Label 4060: @204276
      GIM_Try, /*On fail goto*//*Label 4061*/ GIMT_Encode4(204366), // Rule ID 66 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v4f32] } 604:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSL2lanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2lanev8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 66,
        GIR_EraseRootFromParent_Done,
      // Label 4061: @204366
      GIM_Try, /*On fail goto*//*Label 4062*/ GIMT_Encode4(204456), // Rule ID 2059 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v4i16] } 661:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLAHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2059,
        GIR_EraseRootFromParent_Done,
      // Label 4062: @204456
      GIM_Try, /*On fail goto*//*Label 4063*/ GIMT_Encode4(204546), // Rule ID 2060 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v8i16] } 661:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLAHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2060,
        GIR_EraseRootFromParent_Done,
      // Label 4063: @204546
      GIM_Try, /*On fail goto*//*Label 4064*/ GIMT_Encode4(204636), // Rule ID 2066 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v4i16] } 662:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLSHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2066,
        GIR_EraseRootFromParent_Done,
      // Label 4064: @204636
      GIM_Try, /*On fail goto*//*Label 4065*/ GIMT_Encode4(204726), // Rule ID 2067 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v8i16] } 662:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLSHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2067,
        GIR_EraseRootFromParent_Done,
      // Label 4065: @204726
      GIM_Try, /*On fail goto*//*Label 4066*/ GIMT_Encode4(204816), // Rule ID 2062 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v2i32] } 661:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLAHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2062,
        GIR_EraseRootFromParent_Done,
      // Label 4066: @204816
      GIM_Try, /*On fail goto*//*Label 4067*/ GIMT_Encode4(204906), // Rule ID 2063 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v4i32] } 661:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLAHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2063,
        GIR_EraseRootFromParent_Done,
      // Label 4067: @204906
      GIM_Try, /*On fail goto*//*Label 4068*/ GIMT_Encode4(204996), // Rule ID 2069 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v2i32] } 662:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLSHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2069,
        GIR_EraseRootFromParent_Done,
      // Label 4068: @204996
      GIM_Try, /*On fail goto*//*Label 4069*/ GIMT_Encode4(205086), // Rule ID 2070 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v4i32] } 662:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLSHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2070,
        GIR_EraseRootFromParent_Done,
      // Label 4069: @205086
      GIM_Try, /*On fail goto*//*Label 4070*/ GIMT_Encode4(205176), // Rule ID 2064 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[i32] } 661:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLAHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2064,
        GIR_EraseRootFromParent_Done,
      // Label 4070: @205176
      GIM_Try, /*On fail goto*//*Label 4071*/ GIMT_Encode4(205266), // Rule ID 2071 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[i32] } 662:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLSHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2071,
        GIR_EraseRootFromParent_Done,
      // Label 4071: @205266
      GIM_Try, /*On fail goto*//*Label 4072*/ GIMT_Encode4(205343), // Rule ID 2742 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1243:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FADD_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2742,
        GIR_EraseRootFromParent_Done,
      // Label 4072: @205343
      GIM_Try, /*On fail goto*//*Label 4073*/ GIMT_Encode4(205420), // Rule ID 2743 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1243:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FADD_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2743,
        GIR_EraseRootFromParent_Done,
      // Label 4073: @205420
      GIM_Try, /*On fail goto*//*Label 4074*/ GIMT_Encode4(205497), // Rule ID 2744 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1243:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FADD_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2744,
        GIR_EraseRootFromParent_Done,
      // Label 4074: @205497
      GIM_Try, /*On fail goto*//*Label 4075*/ GIMT_Encode4(205574), // Rule ID 2745 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1243:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FADD_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2745,
        GIR_EraseRootFromParent_Done,
      // Label 4075: @205574
      GIM_Try, /*On fail goto*//*Label 4076*/ GIMT_Encode4(205651), // Rule ID 2746 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1243:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FADD_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2746,
        GIR_EraseRootFromParent_Done,
      // Label 4076: @205651
      GIM_Try, /*On fail goto*//*Label 4077*/ GIMT_Encode4(205728), // Rule ID 2747 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1243:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FADD_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2747,
        GIR_EraseRootFromParent_Done,
      // Label 4077: @205728
      GIM_Try, /*On fail goto*//*Label 4078*/ GIMT_Encode4(205805), // Rule ID 8002 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1419:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FSUB_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8002,
        GIR_EraseRootFromParent_Done,
      // Label 4078: @205805
      GIM_Try, /*On fail goto*//*Label 4079*/ GIMT_Encode4(205882), // Rule ID 8003 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1419:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FSUB_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8003,
        GIR_EraseRootFromParent_Done,
      // Label 4079: @205882
      GIM_Try, /*On fail goto*//*Label 4080*/ GIMT_Encode4(205959), // Rule ID 8004 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1419:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FSUB_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8004,
        GIR_EraseRootFromParent_Done,
      // Label 4080: @205959
      GIM_Try, /*On fail goto*//*Label 4081*/ GIMT_Encode4(206036), // Rule ID 8005 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1419:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FSUB_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8005,
        GIR_EraseRootFromParent_Done,
      // Label 4081: @206036
      GIM_Try, /*On fail goto*//*Label 4082*/ GIMT_Encode4(206113), // Rule ID 8006 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1419:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FSUB_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8006,
        GIR_EraseRootFromParent_Done,
      // Label 4082: @206113
      GIM_Try, /*On fail goto*//*Label 4083*/ GIMT_Encode4(206190), // Rule ID 8007 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1419:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FSUB_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8007,
        GIR_EraseRootFromParent_Done,
      // Label 4083: @206190
      GIM_Try, /*On fail goto*//*Label 4084*/ GIMT_Encode4(206267), // Rule ID 8008 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1357:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FMUL_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8008,
        GIR_EraseRootFromParent_Done,
      // Label 4084: @206267
      GIM_Try, /*On fail goto*//*Label 4085*/ GIMT_Encode4(206344), // Rule ID 8009 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_two),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1357:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_two>>))  =>  (FMUL_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8009,
        GIR_EraseRootFromParent_Done,
      // Label 4085: @206344
      GIM_Try, /*On fail goto*//*Label 4086*/ GIMT_Encode4(206421), // Rule ID 8010 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1357:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FMUL_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8010,
        GIR_EraseRootFromParent_Done,
      // Label 4086: @206421
      GIM_Try, /*On fail goto*//*Label 4087*/ GIMT_Encode4(206498), // Rule ID 8011 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_two),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1357:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_two>>))  =>  (FMUL_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8011,
        GIR_EraseRootFromParent_Done,
      // Label 4087: @206498
      GIM_Try, /*On fail goto*//*Label 4088*/ GIMT_Encode4(206575), // Rule ID 8012 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1357:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FMUL_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8012,
        GIR_EraseRootFromParent_Done,
      // Label 4088: @206575
      GIM_Try, /*On fail goto*//*Label 4089*/ GIMT_Encode4(206652), // Rule ID 8013 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_two),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1357:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_two>>))  =>  (FMUL_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8013,
        GIR_EraseRootFromParent_Done,
      // Label 4089: @206652
      GIM_Try, /*On fail goto*//*Label 4090*/ GIMT_Encode4(206729), // Rule ID 8014 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1421:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FSUBR_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8014,
        GIR_EraseRootFromParent_Done,
      // Label 4090: @206729
      GIM_Try, /*On fail goto*//*Label 4091*/ GIMT_Encode4(206806), // Rule ID 8015 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1421:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FSUBR_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8015,
        GIR_EraseRootFromParent_Done,
      // Label 4091: @206806
      GIM_Try, /*On fail goto*//*Label 4092*/ GIMT_Encode4(206883), // Rule ID 8016 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1421:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FSUBR_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8016,
        GIR_EraseRootFromParent_Done,
      // Label 4092: @206883
      GIM_Try, /*On fail goto*//*Label 4093*/ GIMT_Encode4(206960), // Rule ID 8017 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1421:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FSUBR_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8017,
        GIR_EraseRootFromParent_Done,
      // Label 4093: @206960
      GIM_Try, /*On fail goto*//*Label 4094*/ GIMT_Encode4(207037), // Rule ID 8018 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1421:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FSUBR_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8018,
        GIR_EraseRootFromParent_Done,
      // Label 4094: @207037
      GIM_Try, /*On fail goto*//*Label 4095*/ GIMT_Encode4(207114), // Rule ID 8019 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1421:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FSUBR_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8019,
        GIR_EraseRootFromParent_Done,
      // Label 4095: @207114
      GIM_Try, /*On fail goto*//*Label 4096*/ GIMT_Encode4(207191), // Rule ID 8020 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1311:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMAXNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8020,
        GIR_EraseRootFromParent_Done,
      // Label 4096: @207191
      GIM_Try, /*On fail goto*//*Label 4097*/ GIMT_Encode4(207268), // Rule ID 8021 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1311:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMAXNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8021,
        GIR_EraseRootFromParent_Done,
      // Label 4097: @207268
      GIM_Try, /*On fail goto*//*Label 4098*/ GIMT_Encode4(207345), // Rule ID 8022 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1311:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMAXNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8022,
        GIR_EraseRootFromParent_Done,
      // Label 4098: @207345
      GIM_Try, /*On fail goto*//*Label 4099*/ GIMT_Encode4(207422), // Rule ID 8023 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1311:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMAXNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8023,
        GIR_EraseRootFromParent_Done,
      // Label 4099: @207422
      GIM_Try, /*On fail goto*//*Label 4100*/ GIMT_Encode4(207499), // Rule ID 8024 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1311:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMAXNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8024,
        GIR_EraseRootFromParent_Done,
      // Label 4100: @207499
      GIM_Try, /*On fail goto*//*Label 4101*/ GIMT_Encode4(207576), // Rule ID 8025 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1311:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMAXNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8025,
        GIR_EraseRootFromParent_Done,
      // Label 4101: @207576
      GIM_Try, /*On fail goto*//*Label 4102*/ GIMT_Encode4(207653), // Rule ID 8026 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1329:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMINNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8026,
        GIR_EraseRootFromParent_Done,
      // Label 4102: @207653
      GIM_Try, /*On fail goto*//*Label 4103*/ GIMT_Encode4(207730), // Rule ID 8027 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1329:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMINNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8027,
        GIR_EraseRootFromParent_Done,
      // Label 4103: @207730
      GIM_Try, /*On fail goto*//*Label 4104*/ GIMT_Encode4(207807), // Rule ID 8028 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1329:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMINNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8028,
        GIR_EraseRootFromParent_Done,
      // Label 4104: @207807
      GIM_Try, /*On fail goto*//*Label 4105*/ GIMT_Encode4(207884), // Rule ID 8029 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1329:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMINNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8029,
        GIR_EraseRootFromParent_Done,
      // Label 4105: @207884
      GIM_Try, /*On fail goto*//*Label 4106*/ GIMT_Encode4(207961), // Rule ID 8030 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1329:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMINNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8030,
        GIR_EraseRootFromParent_Done,
      // Label 4106: @207961
      GIM_Try, /*On fail goto*//*Label 4107*/ GIMT_Encode4(208038), // Rule ID 8031 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1329:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMINNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8031,
        GIR_EraseRootFromParent_Done,
      // Label 4107: @208038
      GIM_Try, /*On fail goto*//*Label 4108*/ GIMT_Encode4(208115), // Rule ID 8032 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1305:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMAX_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8032,
        GIR_EraseRootFromParent_Done,
      // Label 4108: @208115
      GIM_Try, /*On fail goto*//*Label 4109*/ GIMT_Encode4(208192), // Rule ID 8033 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1305:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMAX_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8033,
        GIR_EraseRootFromParent_Done,
      // Label 4109: @208192
      GIM_Try, /*On fail goto*//*Label 4110*/ GIMT_Encode4(208269), // Rule ID 8034 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1305:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMAX_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8034,
        GIR_EraseRootFromParent_Done,
      // Label 4110: @208269
      GIM_Try, /*On fail goto*//*Label 4111*/ GIMT_Encode4(208346), // Rule ID 8035 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1305:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMAX_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8035,
        GIR_EraseRootFromParent_Done,
      // Label 4111: @208346
      GIM_Try, /*On fail goto*//*Label 4112*/ GIMT_Encode4(208423), // Rule ID 8036 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1305:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMAX_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8036,
        GIR_EraseRootFromParent_Done,
      // Label 4112: @208423
      GIM_Try, /*On fail goto*//*Label 4113*/ GIMT_Encode4(208500), // Rule ID 8037 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1305:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMAX_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8037,
        GIR_EraseRootFromParent_Done,
      // Label 4113: @208500
      GIM_Try, /*On fail goto*//*Label 4114*/ GIMT_Encode4(208577), // Rule ID 8038 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1323:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMIN_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8038,
        GIR_EraseRootFromParent_Done,
      // Label 4114: @208577
      GIM_Try, /*On fail goto*//*Label 4115*/ GIMT_Encode4(208654), // Rule ID 8039 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1323:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMIN_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8039,
        GIR_EraseRootFromParent_Done,
      // Label 4115: @208654
      GIM_Try, /*On fail goto*//*Label 4116*/ GIMT_Encode4(208731), // Rule ID 8040 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1323:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMIN_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8040,
        GIR_EraseRootFromParent_Done,
      // Label 4116: @208731
      GIM_Try, /*On fail goto*//*Label 4117*/ GIMT_Encode4(208808), // Rule ID 8041 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1323:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMIN_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8041,
        GIR_EraseRootFromParent_Done,
      // Label 4117: @208808
      GIM_Try, /*On fail goto*//*Label 4118*/ GIMT_Encode4(208885), // Rule ID 8042 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1323:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMIN_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8042,
        GIR_EraseRootFromParent_Done,
      // Label 4118: @208885
      GIM_Try, /*On fail goto*//*Label 4119*/ GIMT_Encode4(208962), // Rule ID 8043 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1323:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMIN_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8043,
        GIR_EraseRootFromParent_Done,
      // Label 4119: @208962
      GIM_Try, /*On fail goto*//*Label 4120*/ GIMT_Encode4(209018), // Rule ID 67 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Operand 3
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 295:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 0:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACIA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIA),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/4, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 67,
        GIR_EraseRootFromParent_Done,
      // Label 4120: @209018
      GIM_Try, /*On fail goto*//*Label 4121*/ GIMT_Encode4(209074), // Rule ID 68 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Operand 3
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 295:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 1:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACIB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/4, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 68,
        GIR_EraseRootFromParent_Done,
      // Label 4121: @209074
      GIM_Try, /*On fail goto*//*Label 4122*/ GIMT_Encode4(209130), // Rule ID 69 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Operand 3
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 295:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 2:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACDA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDA),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/4, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 69,
        GIR_EraseRootFromParent_Done,
      // Label 4122: @209130
      GIM_Try, /*On fail goto*//*Label 4123*/ GIMT_Encode4(209186), // Rule ID 70 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Operand 3
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 295:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 3:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACDB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/4, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70,
        GIR_EraseRootFromParent_Done,
      // Label 4123: @209186
      GIM_Try, /*On fail goto*//*Label 4124*/ GIMT_Encode4(209241), // Rule ID 2763 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftmad_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] imm
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1422:{ *:[iPTR] }, ZPR16:{ *:[nxv8f16] }:$Zn, ZPR16:{ *:[nxv8f16] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)  =>  (FTMAD_ZZI_H:{ *:[nxv8f16] } ZPR16:{ *:[nxv8f16] }:$Zn, ZPR16:{ *:[nxv8f16] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTMAD_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Zn
        GIR_RootToRootCopy, /*OpIdx*/3, // Zm
        GIR_RootToRootCopy, /*OpIdx*/4, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2763,
        GIR_EraseRootFromParent_Done,
      // Label 4124: @209241
      GIM_Try, /*On fail goto*//*Label 4125*/ GIMT_Encode4(209296), // Rule ID 2764 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftmad_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] imm
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1422:{ *:[iPTR] }, ZPR32:{ *:[nxv4f32] }:$Zn, ZPR32:{ *:[nxv4f32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)  =>  (FTMAD_ZZI_S:{ *:[nxv4f32] } ZPR32:{ *:[nxv4f32] }:$Zn, ZPR32:{ *:[nxv4f32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTMAD_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Zn
        GIR_RootToRootCopy, /*OpIdx*/3, // Zm
        GIR_RootToRootCopy, /*OpIdx*/4, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2764,
        GIR_EraseRootFromParent_Done,
      // Label 4125: @209296
      GIM_Try, /*On fail goto*//*Label 4126*/ GIMT_Encode4(209351), // Rule ID 2765 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftmad_x),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] imm
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1422:{ *:[iPTR] }, ZPR64:{ *:[nxv2f64] }:$Zn, ZPR64:{ *:[nxv2f64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)  =>  (FTMAD_ZZI_D:{ *:[nxv2f64] } ZPR64:{ *:[nxv2f64] }:$Zn, ZPR64:{ *:[nxv2f64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTMAD_ZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Zn
        GIR_RootToRootCopy, /*OpIdx*/3, // Zm
        GIR_RootToRootCopy, /*OpIdx*/4, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2765,
        GIR_EraseRootFromParent_Done,
      // Label 4126: @209351
      GIM_Try, /*On fail goto*//*Label 4127*/ GIMT_Encode4(209406), // Rule ID 3548 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_merging),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // MIs[0] Idx
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_1_1),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1508:{ *:[iPTR] }, ZPRAny:{ *:[nxv8i16] }:$Zd, PPR16:{ *:[nxv8i1] }:$Pn, (timm:{ *:[i32] })<<P:Predicate_timm32_1_1>>:$Idx)  =>  (PMOV_ZIP_H:{ *:[nxv8i16] } ZPRAny:{ *:[nxv8i16] }:$Zd, (timm:{ *:[i32] })<<P:Predicate_timm32_1_1>>:$Idx, PPR16:{ *:[nxv8i1] }:$Pn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Zd
        GIR_RootToRootCopy, /*OpIdx*/4, // Idx
        GIR_RootToRootCopy, /*OpIdx*/3, // Pn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3548,
        GIR_EraseRootFromParent_Done,
      // Label 4127: @209406
      GIM_Try, /*On fail goto*//*Label 4128*/ GIMT_Encode4(209461), // Rule ID 3549 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_merging),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // MIs[0] Idx
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_1_3),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1508:{ *:[iPTR] }, ZPRAny:{ *:[nxv4i32] }:$Zd, PPR32:{ *:[nxv4i1] }:$Pn, (timm:{ *:[i32] })<<P:Predicate_timm32_1_3>>:$Idx)  =>  (PMOV_ZIP_S:{ *:[nxv4i32] } ZPRAny:{ *:[nxv4i32] }:$Zd, (timm:{ *:[i32] })<<P:Predicate_timm32_1_3>>:$Idx, PPR32:{ *:[nxv4i1] }:$Pn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Zd
        GIR_RootToRootCopy, /*OpIdx*/4, // Idx
        GIR_RootToRootCopy, /*OpIdx*/3, // Pn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3549,
        GIR_EraseRootFromParent_Done,
      // Label 4128: @209461
      GIM_Try, /*On fail goto*//*Label 4129*/ GIMT_Encode4(209516), // Rule ID 3550 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_merging),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // MIs[0] Idx
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_1_7),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1508:{ *:[iPTR] }, ZPRAny:{ *:[nxv2i64] }:$Zd, PPR64:{ *:[nxv2i1] }:$Pn, (timm:{ *:[i32] })<<P:Predicate_timm32_1_7>>:$Idx)  =>  (PMOV_ZIP_D:{ *:[nxv2i64] } ZPRAny:{ *:[nxv2i64] }:$Zd, (timm:{ *:[i32] })<<P:Predicate_timm32_1_7>>:$Idx, PPR64:{ *:[nxv2i1] }:$Pn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Zd
        GIR_RootToRootCopy, /*OpIdx*/4, // Idx
        GIR_RootToRootCopy, /*OpIdx*/3, // Pn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3550,
        GIR_EraseRootFromParent_Done,
      // Label 4129: @209516
      GIM_Try, /*On fail goto*//*Label 4130*/ GIMT_Encode4(209571), // Rule ID 3824 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_xar),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[0] imm
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm0_63),
        // (intrinsic_wo_chain:{ *:[v2i64] } 535:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_timm0_63>>:$imm)  =>  (XAR:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_timm0_63>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vn
        GIR_RootToRootCopy, /*OpIdx*/3, // Vm
        GIR_RootToRootCopy, /*OpIdx*/4, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3824,
        GIR_EraseRootFromParent_Done,
      // Label 4130: @209571
      GIM_Try, /*On fail goto*//*Label 4131*/ GIMT_Encode4(209618), // Rule ID 2827 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] idx
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1358:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (FMUL_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2827,
        GIR_EraseRootFromParent_Done,
      // Label 4131: @209618
      GIM_Try, /*On fail goto*//*Label 4132*/ GIMT_Encode4(209665), // Rule ID 2828 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] idx
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1358:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)  =>  (FMUL_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2828,
        GIR_EraseRootFromParent_Done,
      // Label 4132: @209665
      GIM_Try, /*On fail goto*//*Label 4133*/ GIMT_Encode4(209712), // Rule ID 2829 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] idx
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1358:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)  =>  (FMUL_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2829,
        GIR_EraseRootFromParent_Done,
      // Label 4133: @209712
      GIM_Try, /*On fail goto*//*Label 4134*/ GIMT_Encode4(209759), // Rule ID 2830 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEB16B16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] idx
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv8bf16] } 1358:{ *:[iPTR] }, nxv8bf16:{ *:[nxv8bf16] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (BFMUL_ZZZI:{ *:[nxv8bf16] } ?:{ *:[nxv8bf16] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMUL_ZZZI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2830,
        GIR_EraseRootFromParent_Done,
      // Label 4134: @209759
      GIM_Try, /*On fail goto*//*Label 4135*/ GIMT_Encode4(209806), // Rule ID 2982 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mul_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1489:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (MUL_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MUL_ZZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2982,
        GIR_EraseRootFromParent_Done,
      // Label 4135: @209806
      GIM_Try, /*On fail goto*//*Label 4136*/ GIMT_Encode4(209853), // Rule ID 2983 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mul_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1489:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (MUL_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MUL_ZZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2983,
        GIR_EraseRootFromParent_Done,
      // Label 4136: @209853
      GIM_Try, /*On fail goto*//*Label 4137*/ GIMT_Encode4(209900), // Rule ID 2984 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mul_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1489:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)  =>  (MUL_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MUL_ZZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2984,
        GIR_EraseRootFromParent_Done,
      // Label 4137: @209900
      GIM_Try, /*On fail goto*//*Label 4138*/ GIMT_Encode4(209947), // Rule ID 2985 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1635:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SMULLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2985,
        GIR_EraseRootFromParent_Done,
      // Label 4138: @209947
      GIM_Try, /*On fail goto*//*Label 4139*/ GIMT_Encode4(209994), // Rule ID 2986 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1635:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SMULLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2986,
        GIR_EraseRootFromParent_Done,
      // Label 4139: @209994
      GIM_Try, /*On fail goto*//*Label 4140*/ GIMT_Encode4(210041), // Rule ID 3034 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1746:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SSRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3034,
        GIR_EraseRootFromParent_Done,
      // Label 4140: @210041
      GIM_Try, /*On fail goto*//*Label 4141*/ GIMT_Encode4(210088), // Rule ID 3036 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1746:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SSRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3036,
        GIR_EraseRootFromParent_Done,
      // Label 4141: @210088
      GIM_Try, /*On fail goto*//*Label 4142*/ GIMT_Encode4(210135), // Rule ID 3038 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1746:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SSRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3038,
        GIR_EraseRootFromParent_Done,
      // Label 4142: @210135
      GIM_Try, /*On fail goto*//*Label 4143*/ GIMT_Encode4(210182), // Rule ID 3040 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1746:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (SSRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3040,
        GIR_EraseRootFromParent_Done,
      // Label 4143: @210182
      GIM_Try, /*On fail goto*//*Label 4144*/ GIMT_Encode4(210229), // Rule ID 3062 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1726:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQSHRUNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNT_ZZI_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3062,
        GIR_EraseRootFromParent_Done,
      // Label 4144: @210229
      GIM_Try, /*On fail goto*//*Label 4145*/ GIMT_Encode4(210276), // Rule ID 3063 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1726:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQSHRUNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNT_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3063,
        GIR_EraseRootFromParent_Done,
      // Label 4145: @210276
      GIM_Try, /*On fail goto*//*Label 4146*/ GIMT_Encode4(210323), // Rule ID 3064 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1726:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQSHRUNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNT_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3064,
        GIR_EraseRootFromParent_Done,
      // Label 4146: @210323
      GIM_Try, /*On fail goto*//*Label 4147*/ GIMT_Encode4(210370), // Rule ID 3133 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 2027:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (XAR_ZZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3133,
        GIR_EraseRootFromParent_Done,
      // Label 4147: @210370
      GIM_Try, /*On fail goto*//*Label 4148*/ GIMT_Encode4(210417), // Rule ID 3134 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 2027:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (XAR_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3134,
        GIR_EraseRootFromParent_Done,
      // Label 4148: @210417
      GIM_Try, /*On fail goto*//*Label 4149*/ GIMT_Encode4(210464), // Rule ID 3135 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 2027:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (XAR_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3135,
        GIR_EraseRootFromParent_Done,
      // Label 4149: @210464
      GIM_Try, /*On fail goto*//*Label 4150*/ GIMT_Encode4(210511), // Rule ID 3136 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 2027:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (XAR_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3136,
        GIR_EraseRootFromParent_Done,
      // Label 4150: @210511
      GIM_Try, /*On fail goto*//*Label 4151*/ GIMT_Encode4(210558), // Rule ID 3532 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_extq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_15),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1237:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_15>>:$Op3)  =>  (EXTQ_ZZI:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_15>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTQ_ZZI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3532,
        GIR_EraseRootFromParent_Done,
      // Label 4151: @210558
      GIM_Try, /*On fail goto*//*Label 4152*/ GIMT_Encode4(210605), // Rule ID 3583 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2orSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti2_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1476:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)  =>  (LUTI2_ZZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI2_ZZZI_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3583,
        GIR_EraseRootFromParent_Done,
      // Label 4152: @210605
      GIM_Try, /*On fail goto*//*Label 4153*/ GIMT_Encode4(210652), // Rule ID 3584 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2orSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti2_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1476:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)  =>  (LUTI2_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI2_ZZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3584,
        GIR_EraseRootFromParent_Done,
      // Label 4153: @210652
      GIM_Try, /*On fail goto*//*Label 4154*/ GIMT_Encode4(210699), // Rule ID 3585 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2orSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti2_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1476:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)  =>  (LUTI2_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI2_ZZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3585,
        GIR_EraseRootFromParent_Done,
      // Label 4154: @210699
      GIM_Try, /*On fail goto*//*Label 4155*/ GIMT_Encode4(210746), // Rule ID 3586 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2orSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti2_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
        // (intrinsic_wo_chain:{ *:[nxv8bf16] } 1476:{ *:[iPTR] }, nxv8bf16:{ *:[nxv8bf16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)  =>  (LUTI2_ZZZI_H:{ *:[nxv8bf16] } ?:{ *:[nxv8bf16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI2_ZZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3586,
        GIR_EraseRootFromParent_Done,
      // Label 4155: @210746
      GIM_Try, /*On fail goto*//*Label 4156*/ GIMT_Encode4(210793), // Rule ID 3587 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2orSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti4_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1477:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Op3)  =>  (LUTI4_ZZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI4_ZZZI_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3587,
        GIR_EraseRootFromParent_Done,
      // Label 4156: @210793
      GIM_Try, /*On fail goto*//*Label 4157*/ GIMT_Encode4(210840), // Rule ID 3588 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2orSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti4_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1477:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)  =>  (LUTI4_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI4_ZZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3588,
        GIR_EraseRootFromParent_Done,
      // Label 4157: @210840
      GIM_Try, /*On fail goto*//*Label 4158*/ GIMT_Encode4(210887), // Rule ID 3589 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2orSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti4_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1477:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)  =>  (LUTI4_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI4_ZZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3589,
        GIR_EraseRootFromParent_Done,
      // Label 4158: @210887
      GIM_Try, /*On fail goto*//*Label 4159*/ GIMT_Encode4(210934), // Rule ID 3590 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2orSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti4_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
        // (intrinsic_wo_chain:{ *:[nxv8bf16] } 1477:{ *:[iPTR] }, nxv8bf16:{ *:[nxv8bf16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)  =>  (LUTI4_ZZZI_H:{ *:[nxv8bf16] } ?:{ *:[nxv8bf16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI4_ZZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3590,
        GIR_EraseRootFromParent_Done,
      // Label 4159: @210934
      GIM_Try, /*On fail goto*//*Label 4160*/ GIMT_Encode4(210981), // Rule ID 11600 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1676:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQDMULH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11600,
        GIR_EraseRootFromParent_Done,
      // Label 4160: @210981
      GIM_Try, /*On fail goto*//*Label 4161*/ GIMT_Encode4(211028), // Rule ID 11601 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1676:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQDMULH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11601,
        GIR_EraseRootFromParent_Done,
      // Label 4161: @211028
      GIM_Try, /*On fail goto*//*Label 4162*/ GIMT_Encode4(211075), // Rule ID 11602 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1676:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)  =>  (SQDMULH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11602,
        GIR_EraseRootFromParent_Done,
      // Label 4162: @211075
      GIM_Try, /*On fail goto*//*Label 4163*/ GIMT_Encode4(211122), // Rule ID 11603 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1707:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQRDMULH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11603,
        GIR_EraseRootFromParent_Done,
      // Label 4163: @211122
      GIM_Try, /*On fail goto*//*Label 4164*/ GIMT_Encode4(211169), // Rule ID 11604 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1707:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQRDMULH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11604,
        GIR_EraseRootFromParent_Done,
      // Label 4164: @211169
      GIM_Try, /*On fail goto*//*Label 4165*/ GIMT_Encode4(211216), // Rule ID 11605 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1707:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)  =>  (SQRDMULH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11605,
        GIR_EraseRootFromParent_Done,
      // Label 4165: @211216
      GIM_Try, /*On fail goto*//*Label 4166*/ GIMT_Encode4(211263), // Rule ID 11628 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1637:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SMULLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11628,
        GIR_EraseRootFromParent_Done,
      // Label 4166: @211263
      GIM_Try, /*On fail goto*//*Label 4167*/ GIMT_Encode4(211310), // Rule ID 11629 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1637:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SMULLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11629,
        GIR_EraseRootFromParent_Done,
      // Label 4167: @211310
      GIM_Try, /*On fail goto*//*Label 4168*/ GIMT_Encode4(211357), // Rule ID 11630 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1873:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (UMULLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11630,
        GIR_EraseRootFromParent_Done,
      // Label 4168: @211357
      GIM_Try, /*On fail goto*//*Label 4169*/ GIMT_Encode4(211404), // Rule ID 11631 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1873:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (UMULLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11631,
        GIR_EraseRootFromParent_Done,
      // Label 4169: @211404
      GIM_Try, /*On fail goto*//*Label 4170*/ GIMT_Encode4(211451), // Rule ID 11632 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1875:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (UMULLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11632,
        GIR_EraseRootFromParent_Done,
      // Label 4170: @211451
      GIM_Try, /*On fail goto*//*Label 4171*/ GIMT_Encode4(211498), // Rule ID 11633 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1875:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (UMULLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11633,
        GIR_EraseRootFromParent_Done,
      // Label 4171: @211498
      GIM_Try, /*On fail goto*//*Label 4172*/ GIMT_Encode4(211545), // Rule ID 11634 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1682:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQDMULLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11634,
        GIR_EraseRootFromParent_Done,
      // Label 4172: @211545
      GIM_Try, /*On fail goto*//*Label 4173*/ GIMT_Encode4(211592), // Rule ID 11635 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1682:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQDMULLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11635,
        GIR_EraseRootFromParent_Done,
      // Label 4173: @211592
      GIM_Try, /*On fail goto*//*Label 4174*/ GIMT_Encode4(211639), // Rule ID 11636 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1684:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQDMULLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11636,
        GIR_EraseRootFromParent_Done,
      // Label 4174: @211639
      GIM_Try, /*On fail goto*//*Label 4175*/ GIMT_Encode4(211686), // Rule ID 11637 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1684:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQDMULLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11637,
        GIR_EraseRootFromParent_Done,
      // Label 4175: @211686
      GIM_Try, /*On fail goto*//*Label 4176*/ GIMT_Encode4(211733), // Rule ID 11881 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1742:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SRSHR_ZPmI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11881,
        GIR_EraseRootFromParent_Done,
      // Label 4176: @211733
      GIM_Try, /*On fail goto*//*Label 4177*/ GIMT_Encode4(211780), // Rule ID 11882 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1742:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SRSHR_ZPmI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11882,
        GIR_EraseRootFromParent_Done,
      // Label 4177: @211780
      GIM_Try, /*On fail goto*//*Label 4178*/ GIMT_Encode4(211827), // Rule ID 11883 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1742:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SRSHR_ZPmI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11883,
        GIR_EraseRootFromParent_Done,
      // Label 4178: @211827
      GIM_Try, /*On fail goto*//*Label 4179*/ GIMT_Encode4(211874), // Rule ID 11884 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1742:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (SRSHR_ZPmI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11884,
        GIR_EraseRootFromParent_Done,
      // Label 4179: @211874
      GIM_Try, /*On fail goto*//*Label 4180*/ GIMT_Encode4(211921), // Rule ID 11885 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1933:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (URSHR_ZPmI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11885,
        GIR_EraseRootFromParent_Done,
      // Label 4180: @211921
      GIM_Try, /*On fail goto*//*Label 4181*/ GIMT_Encode4(211968), // Rule ID 11887 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1933:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (URSHR_ZPmI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11887,
        GIR_EraseRootFromParent_Done,
      // Label 4181: @211968
      GIM_Try, /*On fail goto*//*Label 4182*/ GIMT_Encode4(212015), // Rule ID 11889 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1933:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (URSHR_ZPmI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11889,
        GIR_EraseRootFromParent_Done,
      // Label 4182: @212015
      GIM_Try, /*On fail goto*//*Label 4183*/ GIMT_Encode4(212062), // Rule ID 11891 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1933:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (URSHR_ZPmI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11891,
        GIR_EraseRootFromParent_Done,
      // Label 4183: @212062
      GIM_Try, /*On fail goto*//*Label 4184*/ GIMT_Encode4(212109), // Rule ID 11893 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1722:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op3)  =>  (SQSHLU_ZPmI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11893,
        GIR_EraseRootFromParent_Done,
      // Label 4184: @212109
      GIM_Try, /*On fail goto*//*Label 4185*/ GIMT_Encode4(212156), // Rule ID 11894 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1722:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op3)  =>  (SQSHLU_ZPmI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11894,
        GIR_EraseRootFromParent_Done,
      // Label 4185: @212156
      GIM_Try, /*On fail goto*//*Label 4186*/ GIMT_Encode4(212203), // Rule ID 11895 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1722:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op3)  =>  (SQSHLU_ZPmI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11895,
        GIR_EraseRootFromParent_Done,
      // Label 4186: @212203
      GIM_Try, /*On fail goto*//*Label 4187*/ GIMT_Encode4(212250), // Rule ID 11896 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL64),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1722:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL64>>:$Op3)  =>  (SQSHLU_ZPmI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL64>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11896,
        GIR_EraseRootFromParent_Done,
      // Label 4187: @212250
      GIM_Try, /*On fail goto*//*Label 4188*/ GIMT_Encode4(212297), // Rule ID 11971 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1942:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (USRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11971,
        GIR_EraseRootFromParent_Done,
      // Label 4188: @212297
      GIM_Try, /*On fail goto*//*Label 4189*/ GIMT_Encode4(212344), // Rule ID 11973 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1942:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (USRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11973,
        GIR_EraseRootFromParent_Done,
      // Label 4189: @212344
      GIM_Try, /*On fail goto*//*Label 4190*/ GIMT_Encode4(212391), // Rule ID 11975 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1942:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (USRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11975,
        GIR_EraseRootFromParent_Done,
      // Label 4190: @212391
      GIM_Try, /*On fail goto*//*Label 4191*/ GIMT_Encode4(212438), // Rule ID 11977 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1942:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (USRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11977,
        GIR_EraseRootFromParent_Done,
      // Label 4191: @212438
      GIM_Try, /*On fail goto*//*Label 4192*/ GIMT_Encode4(212485), // Rule ID 11979 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1743:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SRSRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11979,
        GIR_EraseRootFromParent_Done,
      // Label 4192: @212485
      GIM_Try, /*On fail goto*//*Label 4193*/ GIMT_Encode4(212532), // Rule ID 11980 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1743:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SRSRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11980,
        GIR_EraseRootFromParent_Done,
      // Label 4193: @212532
      GIM_Try, /*On fail goto*//*Label 4194*/ GIMT_Encode4(212579), // Rule ID 11981 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1743:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SRSRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11981,
        GIR_EraseRootFromParent_Done,
      // Label 4194: @212579
      GIM_Try, /*On fail goto*//*Label 4195*/ GIMT_Encode4(212626), // Rule ID 11982 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1743:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (SRSRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11982,
        GIR_EraseRootFromParent_Done,
      // Label 4195: @212626
      GIM_Try, /*On fail goto*//*Label 4196*/ GIMT_Encode4(212673), // Rule ID 11987 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1935:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (URSRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11987,
        GIR_EraseRootFromParent_Done,
      // Label 4196: @212673
      GIM_Try, /*On fail goto*//*Label 4197*/ GIMT_Encode4(212720), // Rule ID 11988 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1935:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (URSRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11988,
        GIR_EraseRootFromParent_Done,
      // Label 4197: @212720
      GIM_Try, /*On fail goto*//*Label 4198*/ GIMT_Encode4(212767), // Rule ID 11989 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1935:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (URSRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11989,
        GIR_EraseRootFromParent_Done,
      // Label 4198: @212767
      GIM_Try, /*On fail goto*//*Label 4199*/ GIMT_Encode4(212814), // Rule ID 11990 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1935:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (URSRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11990,
        GIR_EraseRootFromParent_Done,
      // Label 4199: @212814
      GIM_Try, /*On fail goto*//*Label 4200*/ GIMT_Encode4(212861), // Rule ID 12050 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1720:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQRSHRUNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNT_ZZI_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12050,
        GIR_EraseRootFromParent_Done,
      // Label 4200: @212861
      GIM_Try, /*On fail goto*//*Label 4201*/ GIMT_Encode4(212908), // Rule ID 12051 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1720:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQRSHRUNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNT_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12051,
        GIR_EraseRootFromParent_Done,
      // Label 4201: @212908
      GIM_Try, /*On fail goto*//*Label 4202*/ GIMT_Encode4(212955), // Rule ID 12052 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1720:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQRSHRUNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNT_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12052,
        GIR_EraseRootFromParent_Done,
      // Label 4202: @212955
      GIM_Try, /*On fail goto*//*Label 4203*/ GIMT_Encode4(213002), // Rule ID 12053 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1599:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNT_ZZI_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12053,
        GIR_EraseRootFromParent_Done,
      // Label 4203: @213002
      GIM_Try, /*On fail goto*//*Label 4204*/ GIMT_Encode4(213049), // Rule ID 12054 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1599:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNT_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12054,
        GIR_EraseRootFromParent_Done,
      // Label 4204: @213049
      GIM_Try, /*On fail goto*//*Label 4205*/ GIMT_Encode4(213096), // Rule ID 12055 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1599:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNT_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12055,
        GIR_EraseRootFromParent_Done,
      // Label 4205: @213096
      GIM_Try, /*On fail goto*//*Label 4206*/ GIMT_Encode4(213143), // Rule ID 12056 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1557:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (RSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNT_ZZI_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12056,
        GIR_EraseRootFromParent_Done,
      // Label 4206: @213143
      GIM_Try, /*On fail goto*//*Label 4207*/ GIMT_Encode4(213190), // Rule ID 12057 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1557:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (RSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNT_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12057,
        GIR_EraseRootFromParent_Done,
      // Label 4207: @213190
      GIM_Try, /*On fail goto*//*Label 4208*/ GIMT_Encode4(213237), // Rule ID 12058 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1557:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (RSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNT_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12058,
        GIR_EraseRootFromParent_Done,
      // Label 4208: @213237
      GIM_Try, /*On fail goto*//*Label 4209*/ GIMT_Encode4(213284), // Rule ID 12059 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1724:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNT_ZZI_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12059,
        GIR_EraseRootFromParent_Done,
      // Label 4209: @213284
      GIM_Try, /*On fail goto*//*Label 4210*/ GIMT_Encode4(213331), // Rule ID 12060 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1724:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNT_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12060,
        GIR_EraseRootFromParent_Done,
      // Label 4210: @213331
      GIM_Try, /*On fail goto*//*Label 4211*/ GIMT_Encode4(213378), // Rule ID 12061 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1724:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNT_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12061,
        GIR_EraseRootFromParent_Done,
      // Label 4211: @213378
      GIM_Try, /*On fail goto*//*Label 4212*/ GIMT_Encode4(213425), // Rule ID 12062 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1714:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQRSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNT_ZZI_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12062,
        GIR_EraseRootFromParent_Done,
      // Label 4212: @213425
      GIM_Try, /*On fail goto*//*Label 4213*/ GIMT_Encode4(213472), // Rule ID 12063 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1714:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQRSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNT_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12063,
        GIR_EraseRootFromParent_Done,
      // Label 4213: @213472
      GIM_Try, /*On fail goto*//*Label 4214*/ GIMT_Encode4(213519), // Rule ID 12064 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1714:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQRSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNT_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12064,
        GIR_EraseRootFromParent_Done,
      // Label 4214: @213519
      GIM_Try, /*On fail goto*//*Label 4215*/ GIMT_Encode4(213566), // Rule ID 12065 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1919:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (UQSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNT_ZZI_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12065,
        GIR_EraseRootFromParent_Done,
      // Label 4215: @213566
      GIM_Try, /*On fail goto*//*Label 4216*/ GIMT_Encode4(213613), // Rule ID 12066 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1919:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (UQSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNT_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12066,
        GIR_EraseRootFromParent_Done,
      // Label 4216: @213613
      GIM_Try, /*On fail goto*//*Label 4217*/ GIMT_Encode4(213660), // Rule ID 12067 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1919:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (UQSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNT_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12067,
        GIR_EraseRootFromParent_Done,
      // Label 4217: @213660
      GIM_Try, /*On fail goto*//*Label 4218*/ GIMT_Encode4(213707), // Rule ID 12068 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1916:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (UQRSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNT_ZZI_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12068,
        GIR_EraseRootFromParent_Done,
      // Label 4218: @213707
      GIM_Try, /*On fail goto*//*Label 4219*/ GIMT_Encode4(213754), // Rule ID 12069 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1916:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (UQRSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNT_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12069,
        GIR_EraseRootFromParent_Done,
      // Label 4219: @213754
      GIM_Try, /*On fail goto*//*Label 4220*/ GIMT_Encode4(213801), // Rule ID 12070 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op3
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1916:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (UQRSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNT_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12070,
        GIR_EraseRootFromParent_Done,
      // Label 4220: @213801
      GIM_Try, /*On fail goto*//*Label 4221*/ GIMT_Encode4(213868), // Rule ID 2558 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urecpe),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1926:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (URECPE_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPE_ZPmZ_S_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Op1
        GIR_RootToRootCopy, /*OpIdx*/4, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2558,
        GIR_EraseRootFromParent_Done,
      // Label 4221: @213868
      GIM_Try, /*On fail goto*//*Label 4222*/ GIMT_Encode4(213935), // Rule ID 7835 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1190:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CLS_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_B_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Op1
        GIR_RootToRootCopy, /*OpIdx*/4, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7835,
        GIR_EraseRootFromParent_Done,
      // Label 4222: @213935
      GIM_Try, /*On fail goto*//*Label 4223*/ GIMT_Encode4(214002), // Rule ID 7837 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1190:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CLS_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_H_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Op1
        GIR_RootToRootCopy, /*OpIdx*/4, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7837,
        GIR_EraseRootFromParent_Done,
      // Label 4223: @214002
      GIM_Try, /*On fail goto*//*Label 4224*/ GIMT_Encode4(214069), // Rule ID 7839 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1190:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CLS_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_S_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Op1
        GIR_RootToRootCopy, /*OpIdx*/4, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7839,
        GIR_EraseRootFromParent_Done,
      // Label 4224: @214069
      GIM_Try, /*On fail goto*//*Label 4225*/ GIMT_Encode4(214136), // Rule ID 7841 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1190:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CLS_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_D_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Op1
        GIR_RootToRootCopy, /*OpIdx*/4, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7841,
        GIR_EraseRootFromParent_Done,
      // Label 4225: @214136
      GIM_Try, /*On fail goto*//*Label 4226*/ GIMT_Encode4(214203), // Rule ID 7871 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1210:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CNOT_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_B_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Op1
        GIR_RootToRootCopy, /*OpIdx*/4, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7871,
        GIR_EraseRootFromParent_Done,
      // Label 4226: @214203
      GIM_Try, /*On fail goto*//*Label 4227*/ GIMT_Encode4(214270), // Rule ID 7873 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1210:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CNOT_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_H_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Op1
        GIR_RootToRootCopy, /*OpIdx*/4, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7873,
        GIR_EraseRootFromParent_Done,
      // Label 4227: @214270
      GIM_Try, /*On fail goto*//*Label 4228*/ GIMT_Encode4(214337), // Rule ID 7875 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1210:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CNOT_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_S_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Op1
        GIR_RootToRootCopy, /*OpIdx*/4, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7875,
        GIR_EraseRootFromParent_Done,
      // Label 4228: @214337
      GIM_Try, /*On fail goto*//*Label 4229*/ GIMT_Encode4(214404), // Rule ID 7877 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1210:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CNOT_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_D_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Op1
        GIR_RootToRootCopy, /*OpIdx*/4, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7877,
        GIR_EraseRootFromParent_Done,
      // Label 4229: @214404
      GIM_Try, /*On fail goto*//*Label 4230*/ GIMT_Encode4(214471), // Rule ID 7883 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1496:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (NOT_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_B_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Op1
        GIR_RootToRootCopy, /*OpIdx*/4, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7883,
        GIR_EraseRootFromParent_Done,
      // Label 4230: @214471
      GIM_Try, /*On fail goto*//*Label 4231*/ GIMT_Encode4(214538), // Rule ID 7885 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1496:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (NOT_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_H_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Op1
        GIR_RootToRootCopy, /*OpIdx*/4, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7885,
        GIR_EraseRootFromParent_Done,
      // Label 4231: @214538
      GIM_Try, /*On fail goto*//*Label 4232*/ GIMT_Encode4(214605), // Rule ID 7887 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1496:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (NOT_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_S_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Op1
        GIR_RootToRootCopy, /*OpIdx*/4, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7887,
        GIR_EraseRootFromParent_Done,
      // Label 4232: @214605
      GIM_Try, /*On fail goto*//*Label 4233*/ GIMT_Encode4(214672), // Rule ID 7889 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1496:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (NOT_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_D_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Op1
        GIR_RootToRootCopy, /*OpIdx*/4, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7889,
        GIR_EraseRootFromParent_Done,
      // Label 4233: @214672
      GIM_Try, /*On fail goto*//*Label 4234*/ GIMT_Encode4(214739), // Rule ID 11763 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursqrte),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1934:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (URSQRTE_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTE_ZPmZ_S_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Op1
        GIR_RootToRootCopy, /*OpIdx*/4, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11763,
        GIR_EraseRootFromParent_Done,
      // Label 4234: @214739
      GIM_Try, /*On fail goto*//*Label 4235*/ GIMT_Encode4(214806), // Rule ID 11765 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1639:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQABS_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_B_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Op1
        GIR_RootToRootCopy, /*OpIdx*/4, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11765,
        GIR_EraseRootFromParent_Done,
      // Label 4235: @214806
      GIM_Try, /*On fail goto*//*Label 4236*/ GIMT_Encode4(214873), // Rule ID 11767 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1639:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQABS_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_H_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Op1
        GIR_RootToRootCopy, /*OpIdx*/4, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11767,
        GIR_EraseRootFromParent_Done,
      // Label 4236: @214873
      GIM_Try, /*On fail goto*//*Label 4237*/ GIMT_Encode4(214940), // Rule ID 11769 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1639:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQABS_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_S_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Op1
        GIR_RootToRootCopy, /*OpIdx*/4, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11769,
        GIR_EraseRootFromParent_Done,
      // Label 4237: @214940
      GIM_Try, /*On fail goto*//*Label 4238*/ GIMT_Encode4(215007), // Rule ID 11771 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1639:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQABS_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_D_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Op1
        GIR_RootToRootCopy, /*OpIdx*/4, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11771,
        GIR_EraseRootFromParent_Done,
      // Label 4238: @215007
      GIM_Try, /*On fail goto*//*Label 4239*/ GIMT_Encode4(215074), // Rule ID 11777 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1699:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQNEG_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_B_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Op1
        GIR_RootToRootCopy, /*OpIdx*/4, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11777,
        GIR_EraseRootFromParent_Done,
      // Label 4239: @215074
      GIM_Try, /*On fail goto*//*Label 4240*/ GIMT_Encode4(215141), // Rule ID 11779 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1699:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQNEG_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_H_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Op1
        GIR_RootToRootCopy, /*OpIdx*/4, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11779,
        GIR_EraseRootFromParent_Done,
      // Label 4240: @215141
      GIM_Try, /*On fail goto*//*Label 4241*/ GIMT_Encode4(215208), // Rule ID 11781 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1699:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQNEG_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_S_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Op1
        GIR_RootToRootCopy, /*OpIdx*/4, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11781,
        GIR_EraseRootFromParent_Done,
      // Label 4241: @215208
      GIM_Try, /*On fail goto*//*Label 4242*/ GIMT_Encode4(215275), // Rule ID 11783 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1699:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQNEG_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_D_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Op1
        GIR_RootToRootCopy, /*OpIdx*/4, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11783,
        GIR_EraseRootFromParent_Done,
      // Label 4242: @215275
      GIM_Try, /*On fail goto*//*Label 4243*/ GIMT_Encode4(215329), // Rule ID 30 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_bfdot),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f32] } 566:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4bf16] }:$Rn, V64:{ *:[v4bf16] }:$Rm)  =>  (BFDOTv4bf16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4bf16] }:$Rn, V64:{ *:[v4bf16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFDOTv4bf16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 30,
        GIR_EraseRootFromParent_Done,
      // Label 4243: @215329
      GIM_Try, /*On fail goto*//*Label 4244*/ GIMT_Encode4(215383), // Rule ID 31 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_bfdot),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 566:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)  =>  (BFDOTv8bf16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFDOTv8bf16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 31,
        GIR_EraseRootFromParent_Done,
      // Label 4244: @215383
      GIM_Try, /*On fail goto*//*Label 4245*/ GIMT_Encode4(215437), // Rule ID 34 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_bfmmla),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 569:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)  =>  (BFMMLA:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMMLA),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 34,
        GIR_EraseRootFromParent_Done,
      // Label 4245: @215437
      GIM_Try, /*On fail goto*//*Label 4246*/ GIMT_Encode4(215491), // Rule ID 35 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_bfmlalb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 567:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)  =>  (BFMLALB:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMLALB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 35,
        GIR_EraseRootFromParent_Done,
      // Label 4246: @215491
      GIM_Try, /*On fail goto*//*Label 4247*/ GIMT_Encode4(215545), // Rule ID 36 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_bfmlalt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 568:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)  =>  (BFMLALT:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMLALT),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 36,
        GIR_EraseRootFromParent_Done,
      // Label 4247: @215545
      GIM_Try, /*On fail goto*//*Label 4248*/ GIMT_Encode4(215599), // Rule ID 42 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smmla),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 651:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMMLA:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMMLA),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 42,
        GIR_EraseRootFromParent_Done,
      // Label 4248: @215599
      GIM_Try, /*On fail goto*//*Label 4249*/ GIMT_Encode4(215653), // Rule ID 43 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ummla),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 712:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMMLA:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMMLA),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 43,
        GIR_EraseRootFromParent_Done,
      // Label 4249: @215653
      GIM_Try, /*On fail goto*//*Label 4250*/ GIMT_Encode4(215707), // Rule ID 44 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usmmla),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 728:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (USMMLA:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMMLA),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 44,
        GIR_EraseRootFromParent_Done,
      // Label 4250: @215707
      GIM_Try, /*On fail goto*//*Label 4251*/ GIMT_Encode4(215761), // Rule ID 51 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f32] } 601:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLALv4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 51,
        GIR_EraseRootFromParent_Done,
      // Label 4251: @215761
      GIM_Try, /*On fail goto*//*Label 4252*/ GIMT_Encode4(215815), // Rule ID 52 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 601:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLALv8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52,
        GIR_EraseRootFromParent_Done,
      // Label 4252: @215815
      GIM_Try, /*On fail goto*//*Label 4253*/ GIMT_Encode4(215869), // Rule ID 53 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f32] } 603:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLSLv4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53,
        GIR_EraseRootFromParent_Done,
      // Label 4253: @215869
      GIM_Try, /*On fail goto*//*Label 4254*/ GIMT_Encode4(215923), // Rule ID 54 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 603:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLSLv8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54,
        GIR_EraseRootFromParent_Done,
      // Label 4254: @215923
      GIM_Try, /*On fail goto*//*Label 4255*/ GIMT_Encode4(215977), // Rule ID 55 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f32] } 602:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLAL2v4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2v4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55,
        GIR_EraseRootFromParent_Done,
      // Label 4255: @215977
      GIM_Try, /*On fail goto*//*Label 4256*/ GIMT_Encode4(216031), // Rule ID 56 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 602:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLAL2v8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2v8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56,
        GIR_EraseRootFromParent_Done,
      // Label 4256: @216031
      GIM_Try, /*On fail goto*//*Label 4257*/ GIMT_Encode4(216085), // Rule ID 57 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f32] } 604:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLSL2v4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2v4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 57,
        GIR_EraseRootFromParent_Done,
      // Label 4257: @216085
      GIM_Try, /*On fail goto*//*Label 4258*/ GIMT_Encode4(216139), // Rule ID 58 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 604:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLSL2v8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2v8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58,
        GIR_EraseRootFromParent_Done,
      // Label 4258: @216139
      GIM_Try, /*On fail goto*//*Label 4259*/ GIMT_Encode4(216193), // Rule ID 1576 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 661:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRDMLAHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1576,
        GIR_EraseRootFromParent_Done,
      // Label 4259: @216193
      GIM_Try, /*On fail goto*//*Label 4260*/ GIMT_Encode4(216247), // Rule ID 1577 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 661:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRDMLAHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1577,
        GIR_EraseRootFromParent_Done,
      // Label 4260: @216247
      GIM_Try, /*On fail goto*//*Label 4261*/ GIMT_Encode4(216301), // Rule ID 1578 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 661:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRDMLAHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1578,
        GIR_EraseRootFromParent_Done,
      // Label 4261: @216301
      GIM_Try, /*On fail goto*//*Label 4262*/ GIMT_Encode4(216355), // Rule ID 1579 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 661:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRDMLAHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1579,
        GIR_EraseRootFromParent_Done,
      // Label 4262: @216355
      GIM_Try, /*On fail goto*//*Label 4263*/ GIMT_Encode4(216409), // Rule ID 1580 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i16] } 662:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRDMLSHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1580,
        GIR_EraseRootFromParent_Done,
      // Label 4263: @216409
      GIM_Try, /*On fail goto*//*Label 4264*/ GIMT_Encode4(216463), // Rule ID 1581 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 662:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRDMLSHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1581,
        GIR_EraseRootFromParent_Done,
      // Label 4264: @216463
      GIM_Try, /*On fail goto*//*Label 4265*/ GIMT_Encode4(216517), // Rule ID 1582 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i32] } 662:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRDMLSHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1582,
        GIR_EraseRootFromParent_Done,
      // Label 4265: @216517
      GIM_Try, /*On fail goto*//*Label 4266*/ GIMT_Encode4(216571), // Rule ID 1583 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 662:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRDMLSHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1583,
        GIR_EraseRootFromParent_Done,
      // Label 4266: @216571
      GIM_Try, /*On fail goto*//*Label 4267*/ GIMT_Encode4(216625), // Rule ID 2294 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1c),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 512:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1Crrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Crrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2294,
        GIR_EraseRootFromParent_Done,
      // Label 4267: @216625
      GIM_Try, /*On fail goto*//*Label 4268*/ GIMT_Encode4(216679), // Rule ID 2295 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1p),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 515:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1Prrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Prrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2295,
        GIR_EraseRootFromParent_Done,
      // Label 4268: @216679
      GIM_Try, /*On fail goto*//*Label 4269*/ GIMT_Encode4(216733), // Rule ID 2296 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1m),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 514:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1Mrrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Mrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2296,
        GIR_EraseRootFromParent_Done,
      // Label 4269: @216733
      GIM_Try, /*On fail goto*//*Label 4270*/ GIMT_Encode4(216787), // Rule ID 2297 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1su0),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 516:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1SU0rrr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1SU0rrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2297,
        GIR_EraseRootFromParent_Done,
      // Label 4270: @216787
      GIM_Try, /*On fail goto*//*Label 4271*/ GIMT_Encode4(216841), // Rule ID 2298 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256h),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 518:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA256Hrrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256Hrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2298,
        GIR_EraseRootFromParent_Done,
      // Label 4271: @216841
      GIM_Try, /*On fail goto*//*Label 4272*/ GIMT_Encode4(216895), // Rule ID 2299 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256h2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 519:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA256H2rrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256H2rrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2299,
        GIR_EraseRootFromParent_Done,
      // Label 4272: @216895
      GIM_Try, /*On fail goto*//*Label 4273*/ GIMT_Encode4(216949), // Rule ID 2300 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256su1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 521:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA256SU1rrr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256SU1rrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2300,
        GIR_EraseRootFromParent_Done,
      // Label 4273: @216949
      GIM_Try, /*On fail goto*//*Label 4274*/ GIMT_Encode4(217006), // Rule ID 3631 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1531:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR8:{ *:[nxv16i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_B:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // idx
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3631,
        GIR_EraseRootFromParent_Done,
      // Label 4274: @217006
      GIM_Try, /*On fail goto*//*Label 4275*/ GIMT_Encode4(217063), // Rule ID 3632 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1531:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR16:{ *:[nxv8i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_H:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // idx
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3632,
        GIR_EraseRootFromParent_Done,
      // Label 4275: @217063
      GIM_Try, /*On fail goto*//*Label 4276*/ GIMT_Encode4(217120), // Rule ID 3633 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1531:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR32:{ *:[nxv4i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_S:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // idx
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3633,
        GIR_EraseRootFromParent_Done,
      // Label 4276: @217120
      GIM_Try, /*On fail goto*//*Label 4277*/ GIMT_Encode4(217177), // Rule ID 3634 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1531:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR64:{ *:[nxv2i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_D:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv2i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // idx
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3634,
        GIR_EraseRootFromParent_Done,
      // Label 4277: @217177
      GIM_Try, /*On fail goto*//*Label 4278*/ GIMT_Encode4(217231), // Rule ID 3796 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512h),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 522:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512H:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vd
        GIR_RootToRootCopy, /*OpIdx*/3, // Vn
        GIR_RootToRootCopy, /*OpIdx*/4, // Vm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3796,
        GIR_EraseRootFromParent_Done,
      // Label 4278: @217231
      GIM_Try, /*On fail goto*//*Label 4279*/ GIMT_Encode4(217285), // Rule ID 3797 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512h2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 523:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512H2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512H2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vd
        GIR_RootToRootCopy, /*OpIdx*/3, // Vn
        GIR_RootToRootCopy, /*OpIdx*/4, // Vm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3797,
        GIR_EraseRootFromParent_Done,
      // Label 4279: @217285
      GIM_Try, /*On fail goto*//*Label 4280*/ GIMT_Encode4(217339), // Rule ID 3798 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512su1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 525:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512SU1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512SU1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vd
        GIR_RootToRootCopy, /*OpIdx*/3, // Vn
        GIR_RootToRootCopy, /*OpIdx*/4, // Vm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3798,
        GIR_EraseRootFromParent_Done,
      // Label 4280: @217339
      GIM_Try, /*On fail goto*//*Label 4281*/ GIMT_Encode4(217393), // Rule ID 3799 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 510:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vd
        GIR_RootToRootCopy, /*OpIdx*/3, // Vn
        GIR_RootToRootCopy, /*OpIdx*/4, // Vm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3799,
        GIR_EraseRootFromParent_Done,
      // Label 4281: @217393
      GIM_Try, /*On fail goto*//*Label 4282*/ GIMT_Encode4(217447), // Rule ID 3800 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 510:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vd
        GIR_RootToRootCopy, /*OpIdx*/3, // Vn
        GIR_RootToRootCopy, /*OpIdx*/4, // Vm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3800,
        GIR_EraseRootFromParent_Done,
      // Label 4282: @217447
      GIM_Try, /*On fail goto*//*Label 4283*/ GIMT_Encode4(217501), // Rule ID 3801 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 510:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vd
        GIR_RootToRootCopy, /*OpIdx*/3, // Vn
        GIR_RootToRootCopy, /*OpIdx*/4, // Vm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3801,
        GIR_EraseRootFromParent_Done,
      // Label 4283: @217501
      GIM_Try, /*On fail goto*//*Label 4284*/ GIMT_Encode4(217555), // Rule ID 3802 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 510:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vd
        GIR_RootToRootCopy, /*OpIdx*/3, // Vn
        GIR_RootToRootCopy, /*OpIdx*/4, // Vm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3802,
        GIR_EraseRootFromParent_Done,
      // Label 4284: @217555
      GIM_Try, /*On fail goto*//*Label 4285*/ GIMT_Encode4(217609), // Rule ID 3811 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 508:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vd
        GIR_RootToRootCopy, /*OpIdx*/3, // Vn
        GIR_RootToRootCopy, /*OpIdx*/4, // Vm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3811,
        GIR_EraseRootFromParent_Done,
      // Label 4285: @217609
      GIM_Try, /*On fail goto*//*Label 4286*/ GIMT_Encode4(217663), // Rule ID 3812 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 508:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vd
        GIR_RootToRootCopy, /*OpIdx*/3, // Vn
        GIR_RootToRootCopy, /*OpIdx*/4, // Vm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3812,
        GIR_EraseRootFromParent_Done,
      // Label 4286: @217663
      GIM_Try, /*On fail goto*//*Label 4287*/ GIMT_Encode4(217717), // Rule ID 3813 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 508:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vd
        GIR_RootToRootCopy, /*OpIdx*/3, // Vn
        GIR_RootToRootCopy, /*OpIdx*/4, // Vm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3813,
        GIR_EraseRootFromParent_Done,
      // Label 4287: @217717
      GIM_Try, /*On fail goto*//*Label 4288*/ GIMT_Encode4(217771), // Rule ID 3814 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 508:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vd
        GIR_RootToRootCopy, /*OpIdx*/3, // Vn
        GIR_RootToRootCopy, /*OpIdx*/4, // Vm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3814,
        GIR_EraseRootFromParent_Done,
      // Label 4288: @217771
      GIM_Try, /*On fail goto*//*Label 4289*/ GIMT_Encode4(217825), // Rule ID 3815 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 509:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vd
        GIR_RootToRootCopy, /*OpIdx*/3, // Vn
        GIR_RootToRootCopy, /*OpIdx*/4, // Vm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3815,
        GIR_EraseRootFromParent_Done,
      // Label 4289: @217825
      GIM_Try, /*On fail goto*//*Label 4290*/ GIMT_Encode4(217879), // Rule ID 3816 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 509:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vd
        GIR_RootToRootCopy, /*OpIdx*/3, // Vn
        GIR_RootToRootCopy, /*OpIdx*/4, // Vm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3816,
        GIR_EraseRootFromParent_Done,
      // Label 4290: @217879
      GIM_Try, /*On fail goto*//*Label 4291*/ GIMT_Encode4(217933), // Rule ID 3817 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 509:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vd
        GIR_RootToRootCopy, /*OpIdx*/3, // Vn
        GIR_RootToRootCopy, /*OpIdx*/4, // Vm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3817,
        GIR_EraseRootFromParent_Done,
      // Label 4291: @217933
      GIM_Try, /*On fail goto*//*Label 4292*/ GIMT_Encode4(217987), // Rule ID 3818 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 509:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vd
        GIR_RootToRootCopy, /*OpIdx*/3, // Vn
        GIR_RootToRootCopy, /*OpIdx*/4, // Vm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3818,
        GIR_EraseRootFromParent_Done,
      // Label 4292: @217987
      GIM_Try, /*On fail goto*//*Label 4293*/ GIMT_Encode4(218041), // Rule ID 3819 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 507:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vd
        GIR_RootToRootCopy, /*OpIdx*/3, // Vn
        GIR_RootToRootCopy, /*OpIdx*/4, // Vm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3819,
        GIR_EraseRootFromParent_Done,
      // Label 4293: @218041
      GIM_Try, /*On fail goto*//*Label 4294*/ GIMT_Encode4(218095), // Rule ID 3820 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i16] } 507:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vd
        GIR_RootToRootCopy, /*OpIdx*/3, // Vn
        GIR_RootToRootCopy, /*OpIdx*/4, // Vm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3820,
        GIR_EraseRootFromParent_Done,
      // Label 4294: @218095
      GIM_Try, /*On fail goto*//*Label 4295*/ GIMT_Encode4(218149), // Rule ID 3821 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 507:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vd
        GIR_RootToRootCopy, /*OpIdx*/3, // Vn
        GIR_RootToRootCopy, /*OpIdx*/4, // Vm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3821,
        GIR_EraseRootFromParent_Done,
      // Label 4295: @218149
      GIM_Try, /*On fail goto*//*Label 4296*/ GIMT_Encode4(218203), // Rule ID 3822 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i64] } 507:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vd
        GIR_RootToRootCopy, /*OpIdx*/3, // Vn
        GIR_RootToRootCopy, /*OpIdx*/4, // Vm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3822,
        GIR_EraseRootFromParent_Done,
      // Label 4296: @218203
      GIM_Try, /*On fail goto*//*Label 4297*/ GIMT_Encode4(218257), // Rule ID 3826 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3ss1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 528:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)  =>  (SM3SS1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3SS1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vn
        GIR_RootToRootCopy, /*OpIdx*/3, // Vm
        GIR_RootToRootCopy, /*OpIdx*/4, // Va
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3826,
        GIR_EraseRootFromParent_Done,
      // Label 4297: @218257
      GIM_Try, /*On fail goto*//*Label 4298*/ GIMT_Encode4(218311), // Rule ID 3827 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3partw1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 526:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM3PARTW1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3PARTW1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vd
        GIR_RootToRootCopy, /*OpIdx*/3, // Vn
        GIR_RootToRootCopy, /*OpIdx*/4, // Vm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3827,
        GIR_EraseRootFromParent_Done,
      // Label 4298: @218311
      GIM_Try, /*On fail goto*//*Label 4299*/ GIMT_Encode4(218365), // Rule ID 3828 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3partw2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 527:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM3PARTW2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3PARTW2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vd
        GIR_RootToRootCopy, /*OpIdx*/3, // Vn
        GIR_RootToRootCopy, /*OpIdx*/4, // Vm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3828,
        GIR_EraseRootFromParent_Done,
      // Label 4299: @218365
      GIM_Try, /*On fail goto*//*Label 4300*/ GIMT_Encode4(218422), // Rule ID 3845 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f16] } 732:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3845,
        GIR_EraseRootFromParent_Done,
      // Label 4300: @218422
      GIM_Try, /*On fail goto*//*Label 4301*/ GIMT_Encode4(218479), // Rule ID 3846 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f16] } 735:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3846,
        GIR_EraseRootFromParent_Done,
      // Label 4301: @218479
      GIM_Try, /*On fail goto*//*Label 4302*/ GIMT_Encode4(218536), // Rule ID 3847 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f16] } 733:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 2:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3847,
        GIR_EraseRootFromParent_Done,
      // Label 4302: @218536
      GIM_Try, /*On fail goto*//*Label 4303*/ GIMT_Encode4(218593), // Rule ID 3848 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f16] } 734:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3848,
        GIR_EraseRootFromParent_Done,
      // Label 4303: @218593
      GIM_Try, /*On fail goto*//*Label 4304*/ GIMT_Encode4(218650), // Rule ID 3853 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8f16] } 732:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3853,
        GIR_EraseRootFromParent_Done,
      // Label 4304: @218650
      GIM_Try, /*On fail goto*//*Label 4305*/ GIMT_Encode4(218707), // Rule ID 3854 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8f16] } 735:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3854,
        GIR_EraseRootFromParent_Done,
      // Label 4305: @218707
      GIM_Try, /*On fail goto*//*Label 4306*/ GIMT_Encode4(218764), // Rule ID 3855 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8f16] } 733:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 2:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3855,
        GIR_EraseRootFromParent_Done,
      // Label 4306: @218764
      GIM_Try, /*On fail goto*//*Label 4307*/ GIMT_Encode4(218821), // Rule ID 3856 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v8f16] } 734:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3856,
        GIR_EraseRootFromParent_Done,
      // Label 4307: @218821
      GIM_Try, /*On fail goto*//*Label 4308*/ GIMT_Encode4(218878), // Rule ID 3861 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f32] } 732:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3861,
        GIR_EraseRootFromParent_Done,
      // Label 4308: @218878
      GIM_Try, /*On fail goto*//*Label 4309*/ GIMT_Encode4(218935), // Rule ID 3862 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f32] } 735:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3862,
        GIR_EraseRootFromParent_Done,
      // Label 4309: @218935
      GIM_Try, /*On fail goto*//*Label 4310*/ GIMT_Encode4(218992), // Rule ID 3863 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f32] } 733:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 2:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3863,
        GIR_EraseRootFromParent_Done,
      // Label 4310: @218992
      GIM_Try, /*On fail goto*//*Label 4311*/ GIMT_Encode4(219049), // Rule ID 3864 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f32] } 734:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3864,
        GIR_EraseRootFromParent_Done,
      // Label 4311: @219049
      GIM_Try, /*On fail goto*//*Label 4312*/ GIMT_Encode4(219106), // Rule ID 3865 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 732:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3865,
        GIR_EraseRootFromParent_Done,
      // Label 4312: @219106
      GIM_Try, /*On fail goto*//*Label 4313*/ GIMT_Encode4(219163), // Rule ID 3866 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 735:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3866,
        GIR_EraseRootFromParent_Done,
      // Label 4313: @219163
      GIM_Try, /*On fail goto*//*Label 4314*/ GIMT_Encode4(219220), // Rule ID 3867 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 733:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 2:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3867,
        GIR_EraseRootFromParent_Done,
      // Label 4314: @219220
      GIM_Try, /*On fail goto*//*Label 4315*/ GIMT_Encode4(219277), // Rule ID 3868 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4f32] } 734:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3868,
        GIR_EraseRootFromParent_Done,
      // Label 4315: @219277
      GIM_Try, /*On fail goto*//*Label 4316*/ GIMT_Encode4(219334), // Rule ID 3869 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f64] } 732:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3869,
        GIR_EraseRootFromParent_Done,
      // Label 4316: @219334
      GIM_Try, /*On fail goto*//*Label 4317*/ GIMT_Encode4(219391), // Rule ID 3870 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f64] } 735:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3870,
        GIR_EraseRootFromParent_Done,
      // Label 4317: @219391
      GIM_Try, /*On fail goto*//*Label 4318*/ GIMT_Encode4(219448), // Rule ID 3871 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f64] } 733:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 2:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3871,
        GIR_EraseRootFromParent_Done,
      // Label 4318: @219448
      GIM_Try, /*On fail goto*//*Label 4319*/ GIMT_Encode4(219505), // Rule ID 3872 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f64] } 734:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3872,
        GIR_EraseRootFromParent_Done,
      // Label 4319: @219505
      GIM_Try, /*On fail goto*//*Label 4320*/ GIMT_Encode4(219559), // Rule ID 5268 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRDM),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 661:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRDMLAHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv1i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5268,
        GIR_EraseRootFromParent_Done,
      // Label 4320: @219559
      GIM_Try, /*On fail goto*//*Label 4321*/ GIMT_Encode4(219613), // Rule ID 5269 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRDM),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 662:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRDMLSHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv1i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5269,
        GIR_EraseRootFromParent_Done,
      // Label 4321: @219613
      GIM_Try, /*On fail goto*//*Label 4322*/ GIMT_Encode4(219664), // Rule ID 5626 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbx1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (intrinsic_wo_chain:{ *:[v8i8] } 695:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rd, VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)  =>  (TBXv8i8One:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXv8i8One),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootToRootCopy, /*OpIdx*/4, // Ri
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5626,
        GIR_EraseRootFromParent_Done,
      // Label 4322: @219664
      GIM_Try, /*On fail goto*//*Label 4323*/ GIMT_Encode4(219715), // Rule ID 5627 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbx1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (intrinsic_wo_chain:{ *:[v16i8] } 695:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)  =>  (TBXv16i8One:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXv16i8One),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rd
        GIR_RootToRootCopy, /*OpIdx*/3, // Ri
        GIR_RootToRootCopy, /*OpIdx*/4, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5627,
        GIR_EraseRootFromParent_Done,
      // Label 4323: @219715
      GIM_Try, /*On fail goto*//*Label 4324*/ GIMT_Encode4(219757), // Rule ID 2654 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1798:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (TBX_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2654,
        GIR_EraseRootFromParent_Done,
      // Label 4324: @219757
      GIM_Try, /*On fail goto*//*Label 4325*/ GIMT_Encode4(219799), // Rule ID 2655 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1798:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBX_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2655,
        GIR_EraseRootFromParent_Done,
      // Label 4325: @219799
      GIM_Try, /*On fail goto*//*Label 4326*/ GIMT_Encode4(219841), // Rule ID 2656 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1798:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBX_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2656,
        GIR_EraseRootFromParent_Done,
      // Label 4326: @219841
      GIM_Try, /*On fail goto*//*Label 4327*/ GIMT_Encode4(219883), // Rule ID 2657 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1798:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBX_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2657,
        GIR_EraseRootFromParent_Done,
      // Label 4327: @219883
      GIM_Try, /*On fail goto*//*Label 4328*/ GIMT_Encode4(219925), // Rule ID 2658 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1798:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBX_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2658,
        GIR_EraseRootFromParent_Done,
      // Label 4328: @219925
      GIM_Try, /*On fail goto*//*Label 4329*/ GIMT_Encode4(219967), // Rule ID 2659 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1798:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBX_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2659,
        GIR_EraseRootFromParent_Done,
      // Label 4329: @219967
      GIM_Try, /*On fail goto*//*Label 4330*/ GIMT_Encode4(220009), // Rule ID 2660 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1798:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBX_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2660,
        GIR_EraseRootFromParent_Done,
      // Label 4330: @220009
      GIM_Try, /*On fail goto*//*Label 4331*/ GIMT_Encode4(220051), // Rule ID 2661 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8bf16] } 1798:{ *:[iPTR] }, nxv8bf16:{ *:[nxv8bf16] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBX_ZZZ_H:{ *:[nxv8bf16] } ?:{ *:[nxv8bf16] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2661,
        GIR_EraseRootFromParent_Done,
      // Label 4331: @220051
      GIM_Try, /*On fail goto*//*Label 4332*/ GIMT_Encode4(220093), // Rule ID 2705 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1144:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2705,
        GIR_EraseRootFromParent_Done,
      // Label 4332: @220093
      GIM_Try, /*On fail goto*//*Label 4333*/ GIMT_Encode4(220135), // Rule ID 2706 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1144:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2706,
        GIR_EraseRootFromParent_Done,
      // Label 4333: @220135
      GIM_Try, /*On fail goto*//*Label 4334*/ GIMT_Encode4(220177), // Rule ID 2707 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1144:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2707,
        GIR_EraseRootFromParent_Done,
      // Label 4334: @220177
      GIM_Try, /*On fail goto*//*Label 4335*/ GIMT_Encode4(220219), // Rule ID 2708 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 1144:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2708,
        GIR_EraseRootFromParent_Done,
      // Label 4335: @220219
      GIM_Try, /*On fail goto*//*Label 4336*/ GIMT_Encode4(220261), // Rule ID 2709 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 1144:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2709,
        GIR_EraseRootFromParent_Done,
      // Label 4336: @220261
      GIM_Try, /*On fail goto*//*Label 4337*/ GIMT_Encode4(220303), // Rule ID 2748 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1243:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FADD_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2748,
        GIR_EraseRootFromParent_Done,
      // Label 4337: @220303
      GIM_Try, /*On fail goto*//*Label 4338*/ GIMT_Encode4(220345), // Rule ID 2750 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1243:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FADD_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2750,
        GIR_EraseRootFromParent_Done,
      // Label 4338: @220345
      GIM_Try, /*On fail goto*//*Label 4339*/ GIMT_Encode4(220387), // Rule ID 2752 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1243:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FADD_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2752,
        GIR_EraseRootFromParent_Done,
      // Label 4339: @220387
      GIM_Try, /*On fail goto*//*Label 4340*/ GIMT_Encode4(220429), // Rule ID 2754 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fscale),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1417:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (FSCALE_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALE_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2754,
        GIR_EraseRootFromParent_Done,
      // Label 4340: @220429
      GIM_Try, /*On fail goto*//*Label 4341*/ GIMT_Encode4(220471), // Rule ID 2755 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fscale),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1417:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (FSCALE_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALE_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2755,
        GIR_EraseRootFromParent_Done,
      // Label 4341: @220471
      GIM_Try, /*On fail goto*//*Label 4342*/ GIMT_Encode4(220513), // Rule ID 2756 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fscale),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1417:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (FSCALE_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALE_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2756,
        GIR_EraseRootFromParent_Done,
      // Label 4342: @220513
      GIM_Try, /*On fail goto*//*Label 4343*/ GIMT_Encode4(220555), // Rule ID 2757 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEB16B16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8bf16] } 1243:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2, nxv8bf16:{ *:[nxv8bf16] }:$Op3)  =>  (BFADD_ZPmZZ:{ *:[nxv8bf16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2, ?:{ *:[nxv8bf16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFADD_ZPmZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2757,
        GIR_EraseRootFromParent_Done,
      // Label 4343: @220555
      GIM_Try, /*On fail goto*//*Label 4344*/ GIMT_Encode4(220597), // Rule ID 2839 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtnt_f16f32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1279:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTNT_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNT_ZPmZ_StoH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2839,
        GIR_EraseRootFromParent_Done,
      // Label 4344: @220597
      GIM_Try, /*On fail goto*//*Label 4345*/ GIMT_Encode4(220639), // Rule ID 2840 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtnt_f32f64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1280:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTNT_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNT_ZPmZ_DtoS),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2840,
        GIR_EraseRootFromParent_Done,
      // Label 4345: @220639
      GIM_Try, /*On fail goto*//*Label 4346*/ GIMT_Encode4(220681), // Rule ID 2841 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtlt_f32f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1275:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTLT_ZPmZ_HtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLT_ZPmZ_HtoS),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2841,
        GIR_EraseRootFromParent_Done,
      // Label 4346: @220681
      GIM_Try, /*On fail goto*//*Label 4347*/ GIMT_Encode4(220723), // Rule ID 2842 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtlt_f64f32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1276:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTLT_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLT_ZPmZ_StoD),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2842,
        GIR_EraseRootFromParent_Done,
      // Label 4347: @220723
      GIM_Try, /*On fail goto*//*Label 4348*/ GIMT_Encode4(220765), // Rule ID 2843 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtxnt_f32f64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1282:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTXNT_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNT_ZPmZ_DtoS),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2843,
        GIR_EraseRootFromParent_Done,
      // Label 4348: @220765
      GIM_Try, /*On fail goto*//*Label 4349*/ GIMT_Encode4(220807), // Rule ID 2844 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1246:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FADDP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDP_ZPmZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2844,
        GIR_EraseRootFromParent_Done,
      // Label 4349: @220807
      GIM_Try, /*On fail goto*//*Label 4350*/ GIMT_Encode4(220849), // Rule ID 2845 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1246:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FADDP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDP_ZPmZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2845,
        GIR_EraseRootFromParent_Done,
      // Label 4350: @220849
      GIM_Try, /*On fail goto*//*Label 4351*/ GIMT_Encode4(220891), // Rule ID 2846 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1246:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FADDP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDP_ZPmZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2846,
        GIR_EraseRootFromParent_Done,
      // Label 4351: @220891
      GIM_Try, /*On fail goto*//*Label 4352*/ GIMT_Encode4(220933), // Rule ID 2848 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bfmlalb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1160:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2, nxv8bf16:{ *:[nxv8bf16] }:$Op3)  =>  (BFMLALB_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2, ?:{ *:[nxv8bf16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMLALB_ZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2848,
        GIR_EraseRootFromParent_Done,
      // Label 4352: @220933
      GIM_Try, /*On fail goto*//*Label 4353*/ GIMT_Encode4(220975), // Rule ID 2860 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f32f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1268:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVT_ZPmZ_HtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_HtoS),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2860,
        GIR_EraseRootFromParent_Done,
      // Label 4353: @220975
      GIM_Try, /*On fail goto*//*Label 4354*/ GIMT_Encode4(221017), // Rule ID 2862 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f16f32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1266:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVT_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_StoH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2862,
        GIR_EraseRootFromParent_Done,
      // Label 4354: @221017
      GIM_Try, /*On fail goto*//*Label 4355*/ GIMT_Encode4(221059), // Rule ID 2870 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_flogb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1303:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FLOGB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FLOGB_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2870,
        GIR_EraseRootFromParent_Done,
      // Label 4355: @221059
      GIM_Try, /*On fail goto*//*Label 4356*/ GIMT_Encode4(221101), // Rule ID 2871 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_flogb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1303:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FLOGB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FLOGB_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2871,
        GIR_EraseRootFromParent_Done,
      // Label 4356: @221101
      GIM_Try, /*On fail goto*//*Label 4357*/ GIMT_Encode4(221143), // Rule ID 2872 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_flogb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1303:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FLOGB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FLOGB_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2872,
        GIR_EraseRootFromParent_Done,
      // Label 4357: @221143
      GIM_Try, /*On fail goto*//*Label 4358*/ GIMT_Encode4(221185), // Rule ID 2876 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtx_f32f64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1281:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTX_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTX_ZPmZ_DtoS),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2876,
        GIR_EraseRootFromParent_Done,
      // Label 4358: @221185
      GIM_Try, /*On fail goto*//*Label 4359*/ GIMT_Encode4(221227), // Rule ID 2921 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1586:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SDIV_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIV_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2921,
        GIR_EraseRootFromParent_Done,
      // Label 4359: @221227
      GIM_Try, /*On fail goto*//*Label 4360*/ GIMT_Encode4(221269), // Rule ID 2922 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1586:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SDIV_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIV_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2922,
        GIR_EraseRootFromParent_Done,
      // Label 4360: @221269
      GIM_Try, /*On fail goto*//*Label 4361*/ GIMT_Encode4(221311), // Rule ID 2951 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1702:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQRDMLAH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2951,
        GIR_EraseRootFromParent_Done,
      // Label 4361: @221311
      GIM_Try, /*On fail goto*//*Label 4362*/ GIMT_Encode4(221353), // Rule ID 2952 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1702:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQRDMLAH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2952,
        GIR_EraseRootFromParent_Done,
      // Label 4362: @221353
      GIM_Try, /*On fail goto*//*Label 4363*/ GIMT_Encode4(221395), // Rule ID 2953 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1702:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQRDMLAH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2953,
        GIR_EraseRootFromParent_Done,
      // Label 4363: @221395
      GIM_Try, /*On fail goto*//*Label 4364*/ GIMT_Encode4(221437), // Rule ID 2954 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1702:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQRDMLAH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2954,
        GIR_EraseRootFromParent_Done,
      // Label 4364: @221437
      GIM_Try, /*On fail goto*//*Label 4365*/ GIMT_Encode4(221479), // Rule ID 2955 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1623:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2955,
        GIR_EraseRootFromParent_Done,
      // Label 4365: @221479
      GIM_Try, /*On fail goto*//*Label 4366*/ GIMT_Encode4(221521), // Rule ID 2956 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1623:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2956,
        GIR_EraseRootFromParent_Done,
      // Label 4366: @221521
      GIM_Try, /*On fail goto*//*Label 4367*/ GIMT_Encode4(221563), // Rule ID 2957 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1623:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2957,
        GIR_EraseRootFromParent_Done,
      // Label 4367: @221563
      GIM_Try, /*On fail goto*//*Label 4368*/ GIMT_Encode4(221605), // Rule ID 2987 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1597:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2987,
        GIR_EraseRootFromParent_Done,
      // Label 4368: @221605
      GIM_Try, /*On fail goto*//*Label 4369*/ GIMT_Encode4(221647), // Rule ID 2989 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1597:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2989,
        GIR_EraseRootFromParent_Done,
      // Label 4369: @221647
      GIM_Try, /*On fail goto*//*Label 4370*/ GIMT_Encode4(221689), // Rule ID 2991 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1597:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2991,
        GIR_EraseRootFromParent_Done,
      // Label 4370: @221689
      GIM_Try, /*On fail goto*//*Label 4371*/ GIMT_Encode4(221731), // Rule ID 2993 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1597:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2993,
        GIR_EraseRootFromParent_Done,
      // Label 4371: @221731
      GIM_Try, /*On fail goto*//*Label 4372*/ GIMT_Encode4(221773), // Rule ID 2995 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sadalp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1567:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SADALP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALP_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2995,
        GIR_EraseRootFromParent_Done,
      // Label 4372: @221773
      GIM_Try, /*On fail goto*//*Label 4373*/ GIMT_Encode4(221815), // Rule ID 2996 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sadalp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1567:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SADALP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALP_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2996,
        GIR_EraseRootFromParent_Done,
      // Label 4373: @221815
      GIM_Try, /*On fail goto*//*Label 4374*/ GIMT_Encode4(221857), // Rule ID 2997 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sadalp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1567:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SADALP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALP_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2997,
        GIR_EraseRootFromParent_Done,
      // Label 4374: @221857
      GIM_Try, /*On fail goto*//*Label 4375*/ GIMT_Encode4(221899), // Rule ID 2998 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urecpe),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1926:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URECPE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPE_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2998,
        GIR_EraseRootFromParent_Done,
      // Label 4375: @221899
      GIM_Try, /*On fail goto*//*Label 4376*/ GIMT_Encode4(221941), // Rule ID 2999 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1639:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQABS_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2999,
        GIR_EraseRootFromParent_Done,
      // Label 4376: @221941
      GIM_Try, /*On fail goto*//*Label 4377*/ GIMT_Encode4(221983), // Rule ID 3000 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1639:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQABS_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3000,
        GIR_EraseRootFromParent_Done,
      // Label 4377: @221983
      GIM_Try, /*On fail goto*//*Label 4378*/ GIMT_Encode4(222025), // Rule ID 3001 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1639:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQABS_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3001,
        GIR_EraseRootFromParent_Done,
      // Label 4378: @222025
      GIM_Try, /*On fail goto*//*Label 4379*/ GIMT_Encode4(222067), // Rule ID 3002 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1639:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQABS_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3002,
        GIR_EraseRootFromParent_Done,
      // Label 4379: @222067
      GIM_Try, /*On fail goto*//*Label 4380*/ GIMT_Encode4(222109), // Rule ID 3019 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1232:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EORBT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3019,
        GIR_EraseRootFromParent_Done,
      // Label 4380: @222109
      GIM_Try, /*On fail goto*//*Label 4381*/ GIMT_Encode4(222151), // Rule ID 3020 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1232:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EORBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3020,
        GIR_EraseRootFromParent_Done,
      // Label 4381: @222151
      GIM_Try, /*On fail goto*//*Label 4382*/ GIMT_Encode4(222193), // Rule ID 3021 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1232:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EORBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3021,
        GIR_EraseRootFromParent_Done,
      // Label 4382: @222193
      GIM_Try, /*On fail goto*//*Label 4383*/ GIMT_Encode4(222235), // Rule ID 3022 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1232:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EORBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3022,
        GIR_EraseRootFromParent_Done,
      // Label 4383: @222235
      GIM_Try, /*On fail goto*//*Label 4384*/ GIMT_Encode4(222277), // Rule ID 3046 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1560:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABA_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3046,
        GIR_EraseRootFromParent_Done,
      // Label 4384: @222277
      GIM_Try, /*On fail goto*//*Label 4385*/ GIMT_Encode4(222319), // Rule ID 3048 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1560:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABA_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3048,
        GIR_EraseRootFromParent_Done,
      // Label 4385: @222319
      GIM_Try, /*On fail goto*//*Label 4386*/ GIMT_Encode4(222361), // Rule ID 3050 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1560:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABA_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3050,
        GIR_EraseRootFromParent_Done,
      // Label 4386: @222361
      GIM_Try, /*On fail goto*//*Label 4387*/ GIMT_Encode4(222403), // Rule ID 3052 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1560:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SABA_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3052,
        GIR_EraseRootFromParent_Done,
      // Label 4387: @222403
      GIM_Try, /*On fail goto*//*Label 4388*/ GIMT_Encode4(222445), // Rule ID 3054 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1561:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALB_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3054,
        GIR_EraseRootFromParent_Done,
      // Label 4388: @222445
      GIM_Try, /*On fail goto*//*Label 4389*/ GIMT_Encode4(222487), // Rule ID 3055 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1561:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALB_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3055,
        GIR_EraseRootFromParent_Done,
      // Label 4389: @222487
      GIM_Try, /*On fail goto*//*Label 4390*/ GIMT_Encode4(222529), // Rule ID 3056 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1561:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALB_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3056,
        GIR_EraseRootFromParent_Done,
      // Label 4390: @222529
      GIM_Try, /*On fail goto*//*Label 4391*/ GIMT_Encode4(222571), // Rule ID 3057 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1124:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADCLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLB_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3057,
        GIR_EraseRootFromParent_Done,
      // Label 4391: @222571
      GIM_Try, /*On fail goto*//*Label 4392*/ GIMT_Encode4(222613), // Rule ID 3058 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1124:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADCLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLB_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3058,
        GIR_EraseRootFromParent_Done,
      // Label 4392: @222613
      GIM_Try, /*On fail goto*//*Label 4393*/ GIMT_Encode4(222655), // Rule ID 3068 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1131:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (ADDHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNT_ZZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3068,
        GIR_EraseRootFromParent_Done,
      // Label 4393: @222655
      GIM_Try, /*On fail goto*//*Label 4394*/ GIMT_Encode4(222697), // Rule ID 3069 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1131:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADDHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNT_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3069,
        GIR_EraseRootFromParent_Done,
      // Label 4394: @222697
      GIM_Try, /*On fail goto*//*Label 4395*/ GIMT_Encode4(222739), // Rule ID 3070 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1131:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADDHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNT_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3070,
        GIR_EraseRootFromParent_Done,
      // Label 4395: @222739
      GIM_Try, /*On fail goto*//*Label 4396*/ GIMT_Encode4(222781), // Rule ID 3087 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1190:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CLS_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op3
        GIR_RootToRootCopy, /*OpIdx*/3, // Op1
        GIR_RootToRootCopy, /*OpIdx*/4, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3087,
        GIR_EraseRootFromParent_Done,
      // Label 4396: @222781
      GIM_Try, /*On fail goto*//*Label 4397*/ GIMT_Encode4(222823), // Rule ID 3088 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1190:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CLS_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op3
        GIR_RootToRootCopy, /*OpIdx*/3, // Op1
        GIR_RootToRootCopy, /*OpIdx*/4, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3088,
        GIR_EraseRootFromParent_Done,
      // Label 4397: @222823
      GIM_Try, /*On fail goto*//*Label 4398*/ GIMT_Encode4(222865), // Rule ID 3089 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1190:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CLS_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op3
        GIR_RootToRootCopy, /*OpIdx*/3, // Op1
        GIR_RootToRootCopy, /*OpIdx*/4, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3089,
        GIR_EraseRootFromParent_Done,
      // Label 4398: @222865
      GIM_Try, /*On fail goto*//*Label 4399*/ GIMT_Encode4(222907), // Rule ID 3090 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1190:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CLS_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op3
        GIR_RootToRootCopy, /*OpIdx*/3, // Op1
        GIR_RootToRootCopy, /*OpIdx*/4, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3090,
        GIR_EraseRootFromParent_Done,
      // Label 4399: @222907
      GIM_Try, /*On fail goto*//*Label 4400*/ GIMT_Encode4(222949), // Rule ID 3125 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1231:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3125,
        GIR_EraseRootFromParent_Done,
      // Label 4400: @222949
      GIM_Try, /*On fail goto*//*Label 4401*/ GIMT_Encode4(222991), // Rule ID 3127 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1231:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3127,
        GIR_EraseRootFromParent_Done,
      // Label 4401: @222991
      GIM_Try, /*On fail goto*//*Label 4402*/ GIMT_Encode4(223033), // Rule ID 3129 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1231:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3129,
        GIR_EraseRootFromParent_Done,
      // Label 4402: @223033
      GIM_Try, /*On fail goto*//*Label 4403*/ GIMT_Encode4(223075), // Rule ID 3131 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1231:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3131,
        GIR_EraseRootFromParent_Done,
      // Label 4403: @223075
      GIM_Try, /*On fail goto*//*Label 4404*/ GIMT_Encode4(223120), // Rule ID 3164 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpeq_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1195:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPEQ_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_WIDE_PPzZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3164,
        GIR_EraseRootFromParent_Done,
      // Label 4404: @223120
      GIM_Try, /*On fail goto*//*Label 4405*/ GIMT_Encode4(223165), // Rule ID 3165 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpeq_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1195:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPEQ_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_WIDE_PPzZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3165,
        GIR_EraseRootFromParent_Done,
      // Label 4405: @223165
      GIM_Try, /*On fail goto*//*Label 4406*/ GIMT_Encode4(223210), // Rule ID 3166 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpeq_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1195:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPEQ_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_WIDE_PPzZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3166,
        GIR_EraseRootFromParent_Done,
      // Label 4406: @223210
      GIM_Try, /*On fail goto*//*Label 4407*/ GIMT_Encode4(223255), // Rule ID 3167 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpge_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1197:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGE_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGE_WIDE_PPzZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3167,
        GIR_EraseRootFromParent_Done,
      // Label 4407: @223255
      GIM_Try, /*On fail goto*//*Label 4408*/ GIMT_Encode4(223300), // Rule ID 3168 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpge_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1197:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGE_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGE_WIDE_PPzZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3168,
        GIR_EraseRootFromParent_Done,
      // Label 4408: @223300
      GIM_Try, /*On fail goto*//*Label 4409*/ GIMT_Encode4(223345), // Rule ID 3169 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpge_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1197:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGE_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGE_WIDE_PPzZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3169,
        GIR_EraseRootFromParent_Done,
      // Label 4409: @223345
      GIM_Try, /*On fail goto*//*Label 4410*/ GIMT_Encode4(223387), // Rule ID 3224 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1241:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FACGE_PPzZZ_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE_PPzZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3224,
        GIR_EraseRootFromParent_Done,
      // Label 4410: @223387
      GIM_Try, /*On fail goto*//*Label 4411*/ GIMT_Encode4(223429), // Rule ID 3225 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1241:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FACGE_PPzZZ_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE_PPzZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3225,
        GIR_EraseRootFromParent_Done,
      // Label 4411: @223429
      GIM_Try, /*On fail goto*//*Label 4412*/ GIMT_Encode4(223471), // Rule ID 3226 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facge),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 1241:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FACGE_PPzZZ_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE_PPzZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3226,
        GIR_EraseRootFromParent_Done,
      // Label 4412: @223471
      GIM_Try, /*On fail goto*//*Label 4413*/ GIMT_Encode4(223513), // Rule ID 3278 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1147:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (ASR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3278,
        GIR_EraseRootFromParent_Done,
      // Label 4413: @223513
      GIM_Try, /*On fail goto*//*Label 4414*/ GIMT_Encode4(223555), // Rule ID 3279 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1147:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (ASR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3279,
        GIR_EraseRootFromParent_Done,
      // Label 4414: @223555
      GIM_Try, /*On fail goto*//*Label 4415*/ GIMT_Encode4(223597), // Rule ID 3280 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1147:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ASR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3280,
        GIR_EraseRootFromParent_Done,
      // Label 4415: @223597
      GIM_Try, /*On fail goto*//*Label 4416*/ GIMT_Encode4(223639), // Rule ID 3281 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1147:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3281,
        GIR_EraseRootFromParent_Done,
      // Label 4416: @223639
      GIM_Try, /*On fail goto*//*Label 4417*/ GIMT_Encode4(223681), // Rule ID 3290 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1149:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_WIDE_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_WIDE_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3290,
        GIR_EraseRootFromParent_Done,
      // Label 4417: @223681
      GIM_Try, /*On fail goto*//*Label 4418*/ GIMT_Encode4(223723), // Rule ID 3291 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1149:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_WIDE_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_WIDE_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3291,
        GIR_EraseRootFromParent_Done,
      // Label 4418: @223723
      GIM_Try, /*On fail goto*//*Label 4419*/ GIMT_Encode4(223765), // Rule ID 3292 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1149:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_WIDE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_WIDE_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3292,
        GIR_EraseRootFromParent_Done,
      // Label 4419: @223765
      GIM_Try, /*On fail goto*//*Label 4420*/ GIMT_Encode4(223807), // Rule ID 3332 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1186:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (CLASTA_ZPZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3332,
        GIR_EraseRootFromParent_Done,
      // Label 4420: @223807
      GIM_Try, /*On fail goto*//*Label 4421*/ GIMT_Encode4(223849), // Rule ID 3333 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1186:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (CLASTA_ZPZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3333,
        GIR_EraseRootFromParent_Done,
      // Label 4421: @223849
      GIM_Try, /*On fail goto*//*Label 4422*/ GIMT_Encode4(223891), // Rule ID 3334 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1186:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (CLASTA_ZPZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3334,
        GIR_EraseRootFromParent_Done,
      // Label 4422: @223891
      GIM_Try, /*On fail goto*//*Label 4423*/ GIMT_Encode4(223933), // Rule ID 3335 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1186:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CLASTA_ZPZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3335,
        GIR_EraseRootFromParent_Done,
      // Label 4423: @223933
      GIM_Try, /*On fail goto*//*Label 4424*/ GIMT_Encode4(223975), // Rule ID 3336 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1186:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (CLASTA_ZPZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3336,
        GIR_EraseRootFromParent_Done,
      // Label 4424: @223975
      GIM_Try, /*On fail goto*//*Label 4425*/ GIMT_Encode4(224017), // Rule ID 3337 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1186:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (CLASTA_ZPZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3337,
        GIR_EraseRootFromParent_Done,
      // Label 4425: @224017
      GIM_Try, /*On fail goto*//*Label 4426*/ GIMT_Encode4(224059), // Rule ID 3338 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1186:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (CLASTA_ZPZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3338,
        GIR_EraseRootFromParent_Done,
      // Label 4426: @224059
      GIM_Try, /*On fail goto*//*Label 4427*/ GIMT_Encode4(224101), // Rule ID 3339 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8bf16] } 1186:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2, nxv8bf16:{ *:[nxv8bf16] }:$Op3)  =>  (CLASTA_ZPZ_H:{ *:[nxv8bf16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2, ?:{ *:[nxv8bf16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3339,
        GIR_EraseRootFromParent_Done,
      // Label 4427: @224101
      GIM_Try, /*On fail goto*//*Label 4428*/ GIMT_Encode4(224143), // Rule ID 3424 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkpa_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1178:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKPA_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKPA_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3424,
        GIR_EraseRootFromParent_Done,
      // Label 4428: @224143
      GIM_Try, /*On fail goto*//*Label 4429*/ GIMT_Encode4(224185), // Rule ID 3425 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkn_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1177:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKN_PPzP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKN_PPzP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdm]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3425,
        GIR_EraseRootFromParent_Done,
      // Label 4429: @224185
      GIM_Try, /*On fail goto*//*Label 4430*/ GIMT_Encode4(224227), // Rule ID 3426 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brka),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1173:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKA_PPmP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKA_PPmP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3426,
        GIR_EraseRootFromParent_Done,
      // Label 4430: @224227
      GIM_Try, /*On fail goto*//*Label 4431*/ GIMT_Encode4(224272), // Rule ID 3428 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_match),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1480:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (MATCH_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MATCH_PPzZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3428,
        GIR_EraseRootFromParent_Done,
      // Label 4431: @224272
      GIM_Try, /*On fail goto*//*Label 4432*/ GIMT_Encode4(224317), // Rule ID 3429 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_match),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1480:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (MATCH_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MATCH_PPzZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3429,
        GIR_EraseRootFromParent_Done,
      // Label 4432: @224317
      GIM_Try, /*On fail goto*//*Label 4433*/ GIMT_Encode4(224359), // Rule ID 3430 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_histcnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1425:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (HISTCNT_ZPzZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HISTCNT_ZPzZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3430,
        GIR_EraseRootFromParent_Done,
      // Label 4433: @224359
      GIM_Try, /*On fail goto*//*Label 4434*/ GIMT_Encode4(224401), // Rule ID 3431 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_histcnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1425:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (HISTCNT_ZPzZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HISTCNT_ZPzZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3431,
        GIR_EraseRootFromParent_Done,
      // Label 4434: @224401
      GIM_Try, /*On fail goto*//*Label 4435*/ GIMT_Encode4(224443), // Rule ID 3435 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bfdot),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1158:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2, nxv8bf16:{ *:[nxv8bf16] }:$Op3)  =>  (BFDOT_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2, ?:{ *:[nxv8bf16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFDOT_ZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3435,
        GIR_EraseRootFromParent_Done,
      // Label 4435: @224443
      GIM_Try, /*On fail goto*//*Label 4436*/ GIMT_Encode4(224485), // Rule ID 3438 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_bf16f32_v2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8bf16] } 1265:{ *:[iPTR] }, nxv8bf16:{ *:[nxv8bf16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (BFCVT_ZPmZ:{ *:[nxv8bf16] } ?:{ *:[nxv8bf16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFCVT_ZPmZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3438,
        GIR_EraseRootFromParent_Done,
      // Label 4436: @224485
      GIM_Try, /*On fail goto*//*Label 4437*/ GIMT_Encode4(224527), // Rule ID 3441 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtnt_bf16f32_v2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8bf16] } 1278:{ *:[iPTR] }, nxv8bf16:{ *:[nxv8bf16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (BFCVTNT_ZPmZ:{ *:[nxv8bf16] } ?:{ *:[nxv8bf16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFCVTNT_ZPmZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3441,
        GIR_EraseRootFromParent_Done,
      // Label 4437: @224527
      GIM_Try, /*On fail goto*//*Label 4438*/ GIMT_Encode4(224569), // Rule ID 3442 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smmla),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1631:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMMLA_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMMLA_ZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3442,
        GIR_EraseRootFromParent_Done,
      // Label 4438: @224569
      GIM_Try, /*On fail goto*//*Label 4439*/ GIMT_Encode4(224611), // Rule ID 3445 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bfmmla),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1168:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2, nxv8bf16:{ *:[nxv8bf16] }:$Op3)  =>  (BFMMLA_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2, ?:{ *:[nxv8bf16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMMLA_ZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3445,
        GIR_EraseRootFromParent_Done,
      // Label 4439: @224611
      GIM_Try, /*On fail goto*//*Label 4440*/ GIMT_Encode4(224653), // Rule ID 3489 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fclamp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1254:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCLAMP_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCLAMP_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3489,
        GIR_EraseRootFromParent_Done,
      // Label 4440: @224653
      GIM_Try, /*On fail goto*//*Label 4441*/ GIMT_Encode4(224695), // Rule ID 3491 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fclamp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1254:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCLAMP_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCLAMP_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3491,
        GIR_EraseRootFromParent_Done,
      // Label 4441: @224695
      GIM_Try, /*On fail goto*//*Label 4442*/ GIMT_Encode4(224737), // Rule ID 3493 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fclamp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1254:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCLAMP_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCLAMP_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3493,
        GIR_EraseRootFromParent_Done,
      // Label 4442: @224737
      GIM_Try, /*On fail goto*//*Label 4443*/ GIMT_Encode4(224779), // Rule ID 3495 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEB16B16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fclamp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8bf16] } 1254:{ *:[iPTR] }, nxv8bf16:{ *:[nxv8bf16] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2, nxv8bf16:{ *:[nxv8bf16] }:$Op3)  =>  (BFCLAMP_ZZZ:{ *:[nxv8bf16] } ?:{ *:[nxv8bf16] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2, ?:{ *:[nxv8bf16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFCLAMP_ZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3495,
        GIR_EraseRootFromParent_Done,
      // Label 4443: @224779
      GIM_Try, /*On fail goto*//*Label 4444*/ GIMT_Encode4(224821), // Rule ID 3497 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_x2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1592:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SDOT_ZZZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZ_HtoS),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3497,
        GIR_EraseRootFromParent_Done,
      // Label 4444: @224821
      GIM_Try, /*On fail goto*//*Label 4445*/ GIMT_Encode4(224863), // Rule ID 3623 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1576:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SCLAMP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3623,
        GIR_EraseRootFromParent_Done,
      // Label 4445: @224863
      GIM_Try, /*On fail goto*//*Label 4446*/ GIMT_Encode4(224905), // Rule ID 3625 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1576:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SCLAMP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3625,
        GIR_EraseRootFromParent_Done,
      // Label 4446: @224905
      GIM_Try, /*On fail goto*//*Label 4447*/ GIMT_Encode4(224947), // Rule ID 3627 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1576:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SCLAMP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3627,
        GIR_EraseRootFromParent_Done,
      // Label 4447: @224947
      GIM_Try, /*On fail goto*//*Label 4448*/ GIMT_Encode4(224989), // Rule ID 3629 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1576:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SCLAMP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3629,
        GIR_EraseRootFromParent_Done,
      // Label 4448: @224989
      GIM_Try, /*On fail goto*//*Label 4449*/ GIMT_Encode4(225031), // Rule ID 7621 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1785:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7621,
        GIR_EraseRootFromParent_Done,
      // Label 4449: @225031
      GIM_Try, /*On fail goto*//*Label 4450*/ GIMT_Encode4(225073), // Rule ID 7623 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1785:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7623,
        GIR_EraseRootFromParent_Done,
      // Label 4450: @225073
      GIM_Try, /*On fail goto*//*Label 4451*/ GIMT_Encode4(225115), // Rule ID 7625 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1785:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7625,
        GIR_EraseRootFromParent_Done,
      // Label 4451: @225115
      GIM_Try, /*On fail goto*//*Label 4452*/ GIMT_Encode4(225157), // Rule ID 7627 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1785:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7627,
        GIR_EraseRootFromParent_Done,
      // Label 4452: @225157
      GIM_Try, /*On fail goto*//*Label 4453*/ GIMT_Encode4(225199), // Rule ID 7645 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1170:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BIC_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7645,
        GIR_EraseRootFromParent_Done,
      // Label 4453: @225199
      GIM_Try, /*On fail goto*//*Label 4454*/ GIMT_Encode4(225241), // Rule ID 7646 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1170:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BIC_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7646,
        GIR_EraseRootFromParent_Done,
      // Label 4454: @225241
      GIM_Try, /*On fail goto*//*Label 4455*/ GIMT_Encode4(225283), // Rule ID 7647 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1170:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BIC_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7647,
        GIR_EraseRootFromParent_Done,
      // Label 4455: @225283
      GIM_Try, /*On fail goto*//*Label 4456*/ GIMT_Encode4(225325), // Rule ID 7648 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1170:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BIC_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7648,
        GIR_EraseRootFromParent_Done,
      // Label 4456: @225325
      GIM_Try, /*On fail goto*//*Label 4457*/ GIMT_Encode4(225367), // Rule ID 7761 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1632:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMULH_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7761,
        GIR_EraseRootFromParent_Done,
      // Label 4457: @225367
      GIM_Try, /*On fail goto*//*Label 4458*/ GIMT_Encode4(225409), // Rule ID 7762 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1632:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMULH_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7762,
        GIR_EraseRootFromParent_Done,
      // Label 4458: @225409
      GIM_Try, /*On fail goto*//*Label 4459*/ GIMT_Encode4(225451), // Rule ID 7763 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1632:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMULH_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7763,
        GIR_EraseRootFromParent_Done,
      // Label 4459: @225451
      GIM_Try, /*On fail goto*//*Label 4460*/ GIMT_Encode4(225493), // Rule ID 7764 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1632:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SMULH_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7764,
        GIR_EraseRootFromParent_Done,
      // Label 4460: @225493
      GIM_Try, /*On fail goto*//*Label 4461*/ GIMT_Encode4(225535), // Rule ID 7765 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1870:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMULH_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7765,
        GIR_EraseRootFromParent_Done,
      // Label 4461: @225535
      GIM_Try, /*On fail goto*//*Label 4462*/ GIMT_Encode4(225577), // Rule ID 7766 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1870:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMULH_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7766,
        GIR_EraseRootFromParent_Done,
      // Label 4462: @225577
      GIM_Try, /*On fail goto*//*Label 4463*/ GIMT_Encode4(225619), // Rule ID 7767 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1870:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMULH_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7767,
        GIR_EraseRootFromParent_Done,
      // Label 4463: @225619
      GIM_Try, /*On fail goto*//*Label 4464*/ GIMT_Encode4(225661), // Rule ID 7768 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1870:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UMULH_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7768,
        GIR_EraseRootFromParent_Done,
      // Label 4464: @225661
      GIM_Try, /*On fail goto*//*Label 4465*/ GIMT_Encode4(225703), // Rule ID 7777 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1833:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UDIV_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIV_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7777,
        GIR_EraseRootFromParent_Done,
      // Label 4465: @225703
      GIM_Try, /*On fail goto*//*Label 4466*/ GIMT_Encode4(225745), // Rule ID 7778 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1833:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UDIV_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIV_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7778,
        GIR_EraseRootFromParent_Done,
      // Label 4466: @225745
      GIM_Try, /*On fail goto*//*Label 4467*/ GIMT_Encode4(225787), // Rule ID 7779 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdivr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1588:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SDIVR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVR_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7779,
        GIR_EraseRootFromParent_Done,
      // Label 4467: @225787
      GIM_Try, /*On fail goto*//*Label 4468*/ GIMT_Encode4(225829), // Rule ID 7780 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdivr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1588:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SDIVR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVR_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7780,
        GIR_EraseRootFromParent_Done,
      // Label 4468: @225829
      GIM_Try, /*On fail goto*//*Label 4469*/ GIMT_Encode4(225871), // Rule ID 7781 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udivr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1835:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UDIVR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVR_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7781,
        GIR_EraseRootFromParent_Done,
      // Label 4469: @225871
      GIM_Try, /*On fail goto*//*Label 4470*/ GIMT_Encode4(225913), // Rule ID 7782 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udivr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1835:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UDIVR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVR_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7782,
        GIR_EraseRootFromParent_Done,
      // Label 4470: @225913
      GIM_Try, /*On fail goto*//*Label 4471*/ GIMT_Encode4(225955), // Rule ID 7867 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1210:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CNOT_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op3
        GIR_RootToRootCopy, /*OpIdx*/3, // Op1
        GIR_RootToRootCopy, /*OpIdx*/4, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7867,
        GIR_EraseRootFromParent_Done,
      // Label 4471: @225955
      GIM_Try, /*On fail goto*//*Label 4472*/ GIMT_Encode4(225997), // Rule ID 7868 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1210:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CNOT_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op3
        GIR_RootToRootCopy, /*OpIdx*/3, // Op1
        GIR_RootToRootCopy, /*OpIdx*/4, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7868,
        GIR_EraseRootFromParent_Done,
      // Label 4472: @225997
      GIM_Try, /*On fail goto*//*Label 4473*/ GIMT_Encode4(226039), // Rule ID 7869 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1210:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CNOT_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op3
        GIR_RootToRootCopy, /*OpIdx*/3, // Op1
        GIR_RootToRootCopy, /*OpIdx*/4, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7869,
        GIR_EraseRootFromParent_Done,
      // Label 4473: @226039
      GIM_Try, /*On fail goto*//*Label 4474*/ GIMT_Encode4(226081), // Rule ID 7870 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1210:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CNOT_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op3
        GIR_RootToRootCopy, /*OpIdx*/3, // Op1
        GIR_RootToRootCopy, /*OpIdx*/4, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7870,
        GIR_EraseRootFromParent_Done,
      // Label 4474: @226081
      GIM_Try, /*On fail goto*//*Label 4475*/ GIMT_Encode4(226123), // Rule ID 7879 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1496:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (NOT_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op3
        GIR_RootToRootCopy, /*OpIdx*/3, // Op1
        GIR_RootToRootCopy, /*OpIdx*/4, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7879,
        GIR_EraseRootFromParent_Done,
      // Label 4475: @226123
      GIM_Try, /*On fail goto*//*Label 4476*/ GIMT_Encode4(226165), // Rule ID 7880 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1496:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (NOT_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op3
        GIR_RootToRootCopy, /*OpIdx*/3, // Op1
        GIR_RootToRootCopy, /*OpIdx*/4, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7880,
        GIR_EraseRootFromParent_Done,
      // Label 4476: @226165
      GIM_Try, /*On fail goto*//*Label 4477*/ GIMT_Encode4(226207), // Rule ID 7881 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1496:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (NOT_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op3
        GIR_RootToRootCopy, /*OpIdx*/3, // Op1
        GIR_RootToRootCopy, /*OpIdx*/4, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7881,
        GIR_EraseRootFromParent_Done,
      // Label 4477: @226207
      GIM_Try, /*On fail goto*//*Label 4478*/ GIMT_Encode4(226249), // Rule ID 7882 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1496:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (NOT_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op3
        GIR_RootToRootCopy, /*OpIdx*/3, // Op1
        GIR_RootToRootCopy, /*OpIdx*/4, // Op2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7882,
        GIR_EraseRootFromParent_Done,
      // Label 4478: @226249
      GIM_Try, /*On fail goto*//*Label 4479*/ GIMT_Encode4(226291), // Rule ID 7967 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1563:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7967,
        GIR_EraseRootFromParent_Done,
      // Label 4479: @226291
      GIM_Try, /*On fail goto*//*Label 4480*/ GIMT_Encode4(226333), // Rule ID 7968 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1563:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7968,
        GIR_EraseRootFromParent_Done,
      // Label 4480: @226333
      GIM_Try, /*On fail goto*//*Label 4481*/ GIMT_Encode4(226375), // Rule ID 7969 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1563:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7969,
        GIR_EraseRootFromParent_Done,
      // Label 4481: @226375
      GIM_Try, /*On fail goto*//*Label 4482*/ GIMT_Encode4(226417), // Rule ID 7970 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1563:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SABD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7970,
        GIR_EraseRootFromParent_Done,
      // Label 4482: @226417
      GIM_Try, /*On fail goto*//*Label 4483*/ GIMT_Encode4(226459), // Rule ID 7971 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1813:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7971,
        GIR_EraseRootFromParent_Done,
      // Label 4483: @226459
      GIM_Try, /*On fail goto*//*Label 4484*/ GIMT_Encode4(226501), // Rule ID 7972 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1813:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7972,
        GIR_EraseRootFromParent_Done,
      // Label 4484: @226501
      GIM_Try, /*On fail goto*//*Label 4485*/ GIMT_Encode4(226543), // Rule ID 7973 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1813:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7973,
        GIR_EraseRootFromParent_Done,
      // Label 4485: @226543
      GIM_Try, /*On fail goto*//*Label 4486*/ GIMT_Encode4(226585), // Rule ID 7974 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1813:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UABD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7974,
        GIR_EraseRootFromParent_Done,
      // Label 4486: @226585
      GIM_Try, /*On fail goto*//*Label 4487*/ GIMT_Encode4(226627), // Rule ID 8170 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1419:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FSUB_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8170,
        GIR_EraseRootFromParent_Done,
      // Label 4487: @226627
      GIM_Try, /*On fail goto*//*Label 4488*/ GIMT_Encode4(226669), // Rule ID 8172 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1419:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FSUB_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8172,
        GIR_EraseRootFromParent_Done,
      // Label 4488: @226669
      GIM_Try, /*On fail goto*//*Label 4489*/ GIMT_Encode4(226711), // Rule ID 8174 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1419:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FSUB_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8174,
        GIR_EraseRootFromParent_Done,
      // Label 4489: @226711
      GIM_Try, /*On fail goto*//*Label 4490*/ GIMT_Encode4(226753), // Rule ID 8182 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1421:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FSUBR_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8182,
        GIR_EraseRootFromParent_Done,
      // Label 4490: @226753
      GIM_Try, /*On fail goto*//*Label 4491*/ GIMT_Encode4(226795), // Rule ID 8184 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1421:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FSUBR_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8184,
        GIR_EraseRootFromParent_Done,
      // Label 4491: @226795
      GIM_Try, /*On fail goto*//*Label 4492*/ GIMT_Encode4(226837), // Rule ID 8186 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1421:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FSUBR_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8186,
        GIR_EraseRootFromParent_Done,
      // Label 4492: @226837
      GIM_Try, /*On fail goto*//*Label 4493*/ GIMT_Encode4(226879), // Rule ID 8224 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1238:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FABD_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8224,
        GIR_EraseRootFromParent_Done,
      // Label 4493: @226879
      GIM_Try, /*On fail goto*//*Label 4494*/ GIMT_Encode4(226921), // Rule ID 8225 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1238:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FABD_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8225,
        GIR_EraseRootFromParent_Done,
      // Label 4494: @226921
      GIM_Try, /*On fail goto*//*Label 4495*/ GIMT_Encode4(226963), // Rule ID 8226 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1238:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FABD_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8226,
        GIR_EraseRootFromParent_Done,
      // Label 4495: @226963
      GIM_Try, /*On fail goto*//*Label 4496*/ GIMT_Encode4(227005), // Rule ID 8227 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1360:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMULX_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8227,
        GIR_EraseRootFromParent_Done,
      // Label 4496: @227005
      GIM_Try, /*On fail goto*//*Label 4497*/ GIMT_Encode4(227047), // Rule ID 8228 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1360:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMULX_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8228,
        GIR_EraseRootFromParent_Done,
      // Label 4497: @227047
      GIM_Try, /*On fail goto*//*Label 4498*/ GIMT_Encode4(227089), // Rule ID 8229 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1360:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMULX_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8229,
        GIR_EraseRootFromParent_Done,
      // Label 4498: @227089
      GIM_Try, /*On fail goto*//*Label 4499*/ GIMT_Encode4(227131), // Rule ID 8230 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdivr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1299:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FDIVR_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIVR_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8230,
        GIR_EraseRootFromParent_Done,
      // Label 4499: @227131
      GIM_Try, /*On fail goto*//*Label 4500*/ GIMT_Encode4(227173), // Rule ID 8231 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdivr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1299:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FDIVR_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIVR_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8231,
        GIR_EraseRootFromParent_Done,
      // Label 4500: @227173
      GIM_Try, /*On fail goto*//*Label 4501*/ GIMT_Encode4(227215), // Rule ID 8232 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdivr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1299:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FDIVR_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIVR_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8232,
        GIR_EraseRootFromParent_Done,
      // Label 4501: @227215
      GIM_Try, /*On fail goto*//*Label 4502*/ GIMT_Encode4(227257), // Rule ID 8233 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1297:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FDIV_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIV_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8233,
        GIR_EraseRootFromParent_Done,
      // Label 4502: @227257
      GIM_Try, /*On fail goto*//*Label 4503*/ GIMT_Encode4(227299), // Rule ID 8234 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1297:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FDIV_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIV_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8234,
        GIR_EraseRootFromParent_Done,
      // Label 4503: @227299
      GIM_Try, /*On fail goto*//*Label 4504*/ GIMT_Encode4(227341), // Rule ID 8235 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdiv),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1297:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FDIV_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIV_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8235,
        GIR_EraseRootFromParent_Done,
      // Label 4504: @227341
      GIM_Try, /*On fail goto*//*Label 4505*/ GIMT_Encode4(227383), // Rule ID 8272 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1239:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FABD_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_H_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8272,
        GIR_EraseRootFromParent_Done,
      // Label 4505: @227383
      GIM_Try, /*On fail goto*//*Label 4506*/ GIMT_Encode4(227425), // Rule ID 8274 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 1239:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FABD_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_H_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8274,
        GIR_EraseRootFromParent_Done,
      // Label 4506: @227425
      GIM_Try, /*On fail goto*//*Label 4507*/ GIMT_Encode4(227467), // Rule ID 8276 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 1239:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FABD_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_H_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8276,
        GIR_EraseRootFromParent_Done,
      // Label 4507: @227467
      GIM_Try, /*On fail goto*//*Label 4508*/ GIMT_Encode4(227509), // Rule ID 8278 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1239:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FABD_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_S_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8278,
        GIR_EraseRootFromParent_Done,
      // Label 4508: @227509
      GIM_Try, /*On fail goto*//*Label 4509*/ GIMT_Encode4(227551), // Rule ID 8280 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 1239:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FABD_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_S_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8280,
        GIR_EraseRootFromParent_Done,
      // Label 4509: @227551
      GIM_Try, /*On fail goto*//*Label 4510*/ GIMT_Encode4(227593), // Rule ID 8282 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1239:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FABD_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_D_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8282,
        GIR_EraseRootFromParent_Done,
      // Label 4510: @227593
      GIM_Try, /*On fail goto*//*Label 4511*/ GIMT_Encode4(227635), // Rule ID 8284 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1361:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMULX_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_H_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8284,
        GIR_EraseRootFromParent_Done,
      // Label 4511: @227635
      GIM_Try, /*On fail goto*//*Label 4512*/ GIMT_Encode4(227677), // Rule ID 8285 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 1361:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FMULX_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_H_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8285,
        GIR_EraseRootFromParent_Done,
      // Label 4512: @227677
      GIM_Try, /*On fail goto*//*Label 4513*/ GIMT_Encode4(227719), // Rule ID 8286 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 1361:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FMULX_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_H_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8286,
        GIR_EraseRootFromParent_Done,
      // Label 4513: @227719
      GIM_Try, /*On fail goto*//*Label 4514*/ GIMT_Encode4(227761), // Rule ID 8287 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1361:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMULX_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_S_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8287,
        GIR_EraseRootFromParent_Done,
      // Label 4514: @227761
      GIM_Try, /*On fail goto*//*Label 4515*/ GIMT_Encode4(227803), // Rule ID 8288 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 1361:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FMULX_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_S_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8288,
        GIR_EraseRootFromParent_Done,
      // Label 4515: @227803
      GIM_Try, /*On fail goto*//*Label 4516*/ GIMT_Encode4(227845), // Rule ID 8289 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1361:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMULX_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_D_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8289,
        GIR_EraseRootFromParent_Done,
      // Label 4516: @227845
      GIM_Try, /*On fail goto*//*Label 4517*/ GIMT_Encode4(227887), // Rule ID 8563 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkpb_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1179:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKPB_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKPB_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8563,
        GIR_EraseRootFromParent_Done,
      // Label 4517: @227887
      GIM_Try, /*On fail goto*//*Label 4518*/ GIMT_Encode4(227929), // Rule ID 8565 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1175:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKB_PPmP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKB_PPmP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8565,
        GIR_EraseRootFromParent_Done,
      // Label 4518: @227929
      GIM_Try, /*On fail goto*//*Label 4519*/ GIMT_Encode4(227971), // Rule ID 8566 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1172:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8566,
        GIR_EraseRootFromParent_Done,
      // Label 4519: @227971
      GIM_Try, /*On fail goto*//*Label 4520*/ GIMT_Encode4(228013), // Rule ID 8567 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1172:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8567,
        GIR_EraseRootFromParent_Done,
      // Label 4520: @228013
      GIM_Try, /*On fail goto*//*Label 4521*/ GIMT_Encode4(228055), // Rule ID 8568 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1172:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8568,
        GIR_EraseRootFromParent_Done,
      // Label 4521: @228055
      GIM_Try, /*On fail goto*//*Label 4522*/ GIMT_Encode4(228097), // Rule ID 8569 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 1172:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8569,
        GIR_EraseRootFromParent_Done,
      // Label 4522: @228097
      GIM_Try, /*On fail goto*//*Label 4523*/ GIMT_Encode4(228139), // Rule ID 8570 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 1172:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8570,
        GIR_EraseRootFromParent_Done,
      // Label 4523: @228139
      GIM_Try, /*On fail goto*//*Label 4524*/ GIMT_Encode4(228181), // Rule ID 8591 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1230:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8591,
        GIR_EraseRootFromParent_Done,
      // Label 4524: @228181
      GIM_Try, /*On fail goto*//*Label 4525*/ GIMT_Encode4(228223), // Rule ID 8592 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1230:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8592,
        GIR_EraseRootFromParent_Done,
      // Label 4525: @228223
      GIM_Try, /*On fail goto*//*Label 4526*/ GIMT_Encode4(228265), // Rule ID 8593 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1230:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8593,
        GIR_EraseRootFromParent_Done,
      // Label 4526: @228265
      GIM_Try, /*On fail goto*//*Label 4527*/ GIMT_Encode4(228307), // Rule ID 8594 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 1230:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8594,
        GIR_EraseRootFromParent_Done,
      // Label 4527: @228307
      GIM_Try, /*On fail goto*//*Label 4528*/ GIMT_Encode4(228349), // Rule ID 8595 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 1230:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8595,
        GIR_EraseRootFromParent_Done,
      // Label 4528: @228349
      GIM_Try, /*On fail goto*//*Label 4529*/ GIMT_Encode4(228391), // Rule ID 8611 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1501:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8611,
        GIR_EraseRootFromParent_Done,
      // Label 4529: @228391
      GIM_Try, /*On fail goto*//*Label 4530*/ GIMT_Encode4(228433), // Rule ID 8612 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1501:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8612,
        GIR_EraseRootFromParent_Done,
      // Label 4530: @228433
      GIM_Try, /*On fail goto*//*Label 4531*/ GIMT_Encode4(228475), // Rule ID 8613 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1501:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8613,
        GIR_EraseRootFromParent_Done,
      // Label 4531: @228475
      GIM_Try, /*On fail goto*//*Label 4532*/ GIMT_Encode4(228517), // Rule ID 8614 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 1501:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8614,
        GIR_EraseRootFromParent_Done,
      // Label 4532: @228517
      GIM_Try, /*On fail goto*//*Label 4533*/ GIMT_Encode4(228559), // Rule ID 8615 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 1501:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8615,
        GIR_EraseRootFromParent_Done,
      // Label 4533: @228559
      GIM_Try, /*On fail goto*//*Label 4534*/ GIMT_Encode4(228601), // Rule ID 8616 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1497:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8616,
        GIR_EraseRootFromParent_Done,
      // Label 4534: @228601
      GIM_Try, /*On fail goto*//*Label 4535*/ GIMT_Encode4(228643), // Rule ID 8617 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1497:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8617,
        GIR_EraseRootFromParent_Done,
      // Label 4535: @228643
      GIM_Try, /*On fail goto*//*Label 4536*/ GIMT_Encode4(228685), // Rule ID 8618 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1497:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8618,
        GIR_EraseRootFromParent_Done,
      // Label 4536: @228685
      GIM_Try, /*On fail goto*//*Label 4537*/ GIMT_Encode4(228727), // Rule ID 8619 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 1497:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8619,
        GIR_EraseRootFromParent_Done,
      // Label 4537: @228727
      GIM_Try, /*On fail goto*//*Label 4538*/ GIMT_Encode4(228769), // Rule ID 8620 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 1497:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8620,
        GIR_EraseRootFromParent_Done,
      // Label 4538: @228769
      GIM_Try, /*On fail goto*//*Label 4539*/ GIMT_Encode4(228811), // Rule ID 8621 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1495:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8621,
        GIR_EraseRootFromParent_Done,
      // Label 4539: @228811
      GIM_Try, /*On fail goto*//*Label 4540*/ GIMT_Encode4(228853), // Rule ID 8622 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1495:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8622,
        GIR_EraseRootFromParent_Done,
      // Label 4540: @228853
      GIM_Try, /*On fail goto*//*Label 4541*/ GIMT_Encode4(228895), // Rule ID 8623 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1495:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8623,
        GIR_EraseRootFromParent_Done,
      // Label 4541: @228895
      GIM_Try, /*On fail goto*//*Label 4542*/ GIMT_Encode4(228937), // Rule ID 8624 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 1495:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8624,
        GIR_EraseRootFromParent_Done,
      // Label 4542: @228937
      GIM_Try, /*On fail goto*//*Label 4543*/ GIMT_Encode4(228979), // Rule ID 8625 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 1495:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8625,
        GIR_EraseRootFromParent_Done,
      // Label 4543: @228979
      GIM_Try, /*On fail goto*//*Label 4544*/ GIMT_Encode4(229021), // Rule ID 8626 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1491:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8626,
        GIR_EraseRootFromParent_Done,
      // Label 4544: @229021
      GIM_Try, /*On fail goto*//*Label 4545*/ GIMT_Encode4(229063), // Rule ID 8627 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1491:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8627,
        GIR_EraseRootFromParent_Done,
      // Label 4545: @229063
      GIM_Try, /*On fail goto*//*Label 4546*/ GIMT_Encode4(229105), // Rule ID 8628 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1491:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8628,
        GIR_EraseRootFromParent_Done,
      // Label 4546: @229105
      GIM_Try, /*On fail goto*//*Label 4547*/ GIMT_Encode4(229147), // Rule ID 8629 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 1491:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8629,
        GIR_EraseRootFromParent_Done,
      // Label 4547: @229147
      GIM_Try, /*On fail goto*//*Label 4548*/ GIMT_Encode4(229189), // Rule ID 8630 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv1i1] } 1491:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8630,
        GIR_EraseRootFromParent_Done,
      // Label 4548: @229189
      GIM_Try, /*On fail goto*//*Label 4549*/ GIMT_Encode4(229231), // Rule ID 8639 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1188:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (CLASTB_ZPZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8639,
        GIR_EraseRootFromParent_Done,
      // Label 4549: @229231
      GIM_Try, /*On fail goto*//*Label 4550*/ GIMT_Encode4(229273), // Rule ID 8640 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1188:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (CLASTB_ZPZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8640,
        GIR_EraseRootFromParent_Done,
      // Label 4550: @229273
      GIM_Try, /*On fail goto*//*Label 4551*/ GIMT_Encode4(229315), // Rule ID 8641 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1188:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (CLASTB_ZPZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8641,
        GIR_EraseRootFromParent_Done,
      // Label 4551: @229315
      GIM_Try, /*On fail goto*//*Label 4552*/ GIMT_Encode4(229357), // Rule ID 8642 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1188:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CLASTB_ZPZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8642,
        GIR_EraseRootFromParent_Done,
      // Label 4552: @229357
      GIM_Try, /*On fail goto*//*Label 4553*/ GIMT_Encode4(229399), // Rule ID 8643 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1188:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (CLASTB_ZPZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8643,
        GIR_EraseRootFromParent_Done,
      // Label 4553: @229399
      GIM_Try, /*On fail goto*//*Label 4554*/ GIMT_Encode4(229441), // Rule ID 8644 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1188:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (CLASTB_ZPZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8644,
        GIR_EraseRootFromParent_Done,
      // Label 4554: @229441
      GIM_Try, /*On fail goto*//*Label 4555*/ GIMT_Encode4(229483), // Rule ID 8645 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1188:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (CLASTB_ZPZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8645,
        GIR_EraseRootFromParent_Done,
      // Label 4555: @229483
      GIM_Try, /*On fail goto*//*Label 4556*/ GIMT_Encode4(229525), // Rule ID 8646 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8bf16] } 1188:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2, nxv8bf16:{ *:[nxv8bf16] }:$Op3)  =>  (CLASTB_ZPZ_H:{ *:[nxv8bf16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2, ?:{ *:[nxv8bf16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8646,
        GIR_EraseRootFromParent_Done,
      // Label 4556: @229525
      GIM_Try, /*On fail goto*//*Label 4557*/ GIMT_Encode4(229570), // Rule ID 9395 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpne_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1209:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPNE_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPNE_WIDE_PPzZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9395,
        GIR_EraseRootFromParent_Done,
      // Label 4557: @229570
      GIM_Try, /*On fail goto*//*Label 4558*/ GIMT_Encode4(229615), // Rule ID 9396 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpne_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1209:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPNE_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPNE_WIDE_PPzZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9396,
        GIR_EraseRootFromParent_Done,
      // Label 4558: @229615
      GIM_Try, /*On fail goto*//*Label 4559*/ GIMT_Encode4(229660), // Rule ID 9397 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpne_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1209:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPNE_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPNE_WIDE_PPzZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9397,
        GIR_EraseRootFromParent_Done,
      // Label 4559: @229660
      GIM_Try, /*On fail goto*//*Label 4560*/ GIMT_Encode4(229705), // Rule ID 9398 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpgt_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1199:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGT_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGT_WIDE_PPzZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9398,
        GIR_EraseRootFromParent_Done,
      // Label 4560: @229705
      GIM_Try, /*On fail goto*//*Label 4561*/ GIMT_Encode4(229750), // Rule ID 9399 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpgt_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1199:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGT_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGT_WIDE_PPzZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9399,
        GIR_EraseRootFromParent_Done,
      // Label 4561: @229750
      GIM_Try, /*On fail goto*//*Label 4562*/ GIMT_Encode4(229795), // Rule ID 9400 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpgt_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1199:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGT_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGT_WIDE_PPzZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9400,
        GIR_EraseRootFromParent_Done,
      // Label 4562: @229795
      GIM_Try, /*On fail goto*//*Label 4563*/ GIMT_Encode4(229840), // Rule ID 9401 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplt_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1207:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLT_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLT_WIDE_PPzZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9401,
        GIR_EraseRootFromParent_Done,
      // Label 4563: @229840
      GIM_Try, /*On fail goto*//*Label 4564*/ GIMT_Encode4(229885), // Rule ID 9402 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplt_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1207:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLT_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLT_WIDE_PPzZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9402,
        GIR_EraseRootFromParent_Done,
      // Label 4564: @229885
      GIM_Try, /*On fail goto*//*Label 4565*/ GIMT_Encode4(229930), // Rule ID 9403 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplt_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1207:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLT_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLT_WIDE_PPzZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9403,
        GIR_EraseRootFromParent_Done,
      // Label 4565: @229930
      GIM_Try, /*On fail goto*//*Label 4566*/ GIMT_Encode4(229975), // Rule ID 9404 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmple_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1204:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLE_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLE_WIDE_PPzZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9404,
        GIR_EraseRootFromParent_Done,
      // Label 4566: @229975
      GIM_Try, /*On fail goto*//*Label 4567*/ GIMT_Encode4(230020), // Rule ID 9405 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmple_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1204:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLE_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLE_WIDE_PPzZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9405,
        GIR_EraseRootFromParent_Done,
      // Label 4567: @230020
      GIM_Try, /*On fail goto*//*Label 4568*/ GIMT_Encode4(230065), // Rule ID 9406 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmple_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1204:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLE_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLE_WIDE_PPzZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9406,
        GIR_EraseRootFromParent_Done,
      // Label 4568: @230065
      GIM_Try, /*On fail goto*//*Label 4569*/ GIMT_Encode4(230110), // Rule ID 9407 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphs_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1203:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHS_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHS_WIDE_PPzZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9407,
        GIR_EraseRootFromParent_Done,
      // Label 4569: @230110
      GIM_Try, /*On fail goto*//*Label 4570*/ GIMT_Encode4(230155), // Rule ID 9408 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphs_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1203:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHS_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHS_WIDE_PPzZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9408,
        GIR_EraseRootFromParent_Done,
      // Label 4570: @230155
      GIM_Try, /*On fail goto*//*Label 4571*/ GIMT_Encode4(230200), // Rule ID 9409 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphs_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1203:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHS_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHS_WIDE_PPzZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9409,
        GIR_EraseRootFromParent_Done,
      // Label 4571: @230200
      GIM_Try, /*On fail goto*//*Label 4572*/ GIMT_Encode4(230245), // Rule ID 9410 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphi_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1201:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHI_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHI_WIDE_PPzZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9410,
        GIR_EraseRootFromParent_Done,
      // Label 4572: @230245
      GIM_Try, /*On fail goto*//*Label 4573*/ GIMT_Encode4(230290), // Rule ID 9411 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphi_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1201:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHI_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHI_WIDE_PPzZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9411,
        GIR_EraseRootFromParent_Done,
      // Label 4573: @230290
      GIM_Try, /*On fail goto*//*Label 4574*/ GIMT_Encode4(230335), // Rule ID 9412 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphi_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1201:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHI_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHI_WIDE_PPzZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9412,
        GIR_EraseRootFromParent_Done,
      // Label 4574: @230335
      GIM_Try, /*On fail goto*//*Label 4575*/ GIMT_Encode4(230380), // Rule ID 9413 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplo_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1205:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLO_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLO_WIDE_PPzZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9413,
        GIR_EraseRootFromParent_Done,
      // Label 4575: @230380
      GIM_Try, /*On fail goto*//*Label 4576*/ GIMT_Encode4(230425), // Rule ID 9414 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplo_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1205:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLO_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLO_WIDE_PPzZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9414,
        GIR_EraseRootFromParent_Done,
      // Label 4576: @230425
      GIM_Try, /*On fail goto*//*Label 4577*/ GIMT_Encode4(230470), // Rule ID 9415 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplo_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1205:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLO_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLO_WIDE_PPzZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9415,
        GIR_EraseRootFromParent_Done,
      // Label 4577: @230470
      GIM_Try, /*On fail goto*//*Label 4578*/ GIMT_Encode4(230515), // Rule ID 9416 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpls_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1206:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLS_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLS_WIDE_PPzZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9416,
        GIR_EraseRootFromParent_Done,
      // Label 4578: @230515
      GIM_Try, /*On fail goto*//*Label 4579*/ GIMT_Encode4(230560), // Rule ID 9417 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpls_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1206:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLS_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLS_WIDE_PPzZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9417,
        GIR_EraseRootFromParent_Done,
      // Label 4579: @230560
      GIM_Try, /*On fail goto*//*Label 4580*/ GIMT_Encode4(230605), // Rule ID 9418 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpls_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1206:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLS_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLS_WIDE_PPzZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9418,
        GIR_EraseRootFromParent_Done,
      // Label 4580: @230605
      GIM_Try, /*On fail goto*//*Label 4581*/ GIMT_Encode4(230647), // Rule ID 9815 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1242:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FACGT_PPzZZ_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT_PPzZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9815,
        GIR_EraseRootFromParent_Done,
      // Label 4581: @230647
      GIM_Try, /*On fail goto*//*Label 4582*/ GIMT_Encode4(230689), // Rule ID 9816 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i1] } 1242:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FACGT_PPzZZ_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT_PPzZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9816,
        GIR_EraseRootFromParent_Done,
      // Label 4582: @230689
      GIM_Try, /*On fail goto*//*Label 4583*/ GIMT_Encode4(230731), // Rule ID 9817 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facgt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i1] } 1242:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FACGT_PPzZZ_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT_PPzZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9817,
        GIR_EraseRootFromParent_Done,
      // Label 4583: @230731
      GIM_Try, /*On fail goto*//*Label 4584*/ GIMT_Encode4(230773), // Rule ID 10355 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1473:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (LSR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10355,
        GIR_EraseRootFromParent_Done,
      // Label 4584: @230773
      GIM_Try, /*On fail goto*//*Label 4585*/ GIMT_Encode4(230815), // Rule ID 10356 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1473:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (LSR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10356,
        GIR_EraseRootFromParent_Done,
      // Label 4585: @230815
      GIM_Try, /*On fail goto*//*Label 4586*/ GIMT_Encode4(230857), // Rule ID 10357 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1473:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (LSR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10357,
        GIR_EraseRootFromParent_Done,
      // Label 4586: @230857
      GIM_Try, /*On fail goto*//*Label 4587*/ GIMT_Encode4(230899), // Rule ID 10358 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1473:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10358,
        GIR_EraseRootFromParent_Done,
      // Label 4587: @230899
      GIM_Try, /*On fail goto*//*Label 4588*/ GIMT_Encode4(230941), // Rule ID 10359 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1470:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (LSL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10359,
        GIR_EraseRootFromParent_Done,
      // Label 4588: @230941
      GIM_Try, /*On fail goto*//*Label 4589*/ GIMT_Encode4(230983), // Rule ID 10360 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1470:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (LSL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10360,
        GIR_EraseRootFromParent_Done,
      // Label 4589: @230983
      GIM_Try, /*On fail goto*//*Label 4590*/ GIMT_Encode4(231025), // Rule ID 10361 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1470:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (LSL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10361,
        GIR_EraseRootFromParent_Done,
      // Label 4590: @231025
      GIM_Try, /*On fail goto*//*Label 4591*/ GIMT_Encode4(231067), // Rule ID 10362 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1470:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10362,
        GIR_EraseRootFromParent_Done,
      // Label 4591: @231067
      GIM_Try, /*On fail goto*//*Label 4592*/ GIMT_Encode4(231109), // Rule ID 10375 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1475:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_WIDE_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_WIDE_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10375,
        GIR_EraseRootFromParent_Done,
      // Label 4592: @231109
      GIM_Try, /*On fail goto*//*Label 4593*/ GIMT_Encode4(231151), // Rule ID 10376 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1475:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_WIDE_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_WIDE_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10376,
        GIR_EraseRootFromParent_Done,
      // Label 4593: @231151
      GIM_Try, /*On fail goto*//*Label 4594*/ GIMT_Encode4(231193), // Rule ID 10377 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1475:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_WIDE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_WIDE_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10377,
        GIR_EraseRootFromParent_Done,
      // Label 4594: @231193
      GIM_Try, /*On fail goto*//*Label 4595*/ GIMT_Encode4(231235), // Rule ID 10378 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1472:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_WIDE_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_WIDE_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10378,
        GIR_EraseRootFromParent_Done,
      // Label 4595: @231235
      GIM_Try, /*On fail goto*//*Label 4596*/ GIMT_Encode4(231277), // Rule ID 10379 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1472:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_WIDE_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_WIDE_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10379,
        GIR_EraseRootFromParent_Done,
      // Label 4596: @231277
      GIM_Try, /*On fail goto*//*Label 4597*/ GIMT_Encode4(231319), // Rule ID 10380 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl_wide),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1472:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_WIDE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_WIDE_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10380,
        GIR_EraseRootFromParent_Done,
      // Label 4597: @231319
      GIM_Try, /*On fail goto*//*Label 4598*/ GIMT_Encode4(231361), // Rule ID 10407 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f16f64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1267:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVT_ZPmZ_DtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_DtoH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10407,
        GIR_EraseRootFromParent_Done,
      // Label 4598: @231361
      GIM_Try, /*On fail goto*//*Label 4599*/ GIMT_Encode4(231403), // Rule ID 10411 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f64f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1270:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVT_ZPmZ_HtoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_HtoD),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10411,
        GIR_EraseRootFromParent_Done,
      // Label 4599: @231403
      GIM_Try, /*On fail goto*//*Label 4600*/ GIMT_Encode4(231445), // Rule ID 10415 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f32f64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1269:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVT_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_DtoS),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10415,
        GIR_EraseRootFromParent_Done,
      // Label 4600: @231445
      GIM_Try, /*On fail goto*//*Label 4601*/ GIMT_Encode4(231487), // Rule ID 10419 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f64f32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1271:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVT_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_StoD),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10419,
        GIR_EraseRootFromParent_Done,
      // Label 4601: @231487
      GIM_Try, /*On fail goto*//*Label 4602*/ GIMT_Encode4(231529), // Rule ID 10423 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f64i32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1583:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SCVTF_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_StoD),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10423,
        GIR_EraseRootFromParent_Done,
      // Label 4602: @231529
      GIM_Try, /*On fail goto*//*Label 4603*/ GIMT_Encode4(231571), // Rule ID 10424 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f64i32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1830:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UCVTF_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_StoD),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10424,
        GIR_EraseRootFromParent_Done,
      // Label 4603: @231571
      GIM_Try, /*On fail goto*//*Label 4604*/ GIMT_Encode4(231613), // Rule ID 10425 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f16i32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1827:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UCVTF_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_StoH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10425,
        GIR_EraseRootFromParent_Done,
      // Label 4604: @231613
      GIM_Try, /*On fail goto*//*Label 4605*/ GIMT_Encode4(231655), // Rule ID 10429 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f32i64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1582:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SCVTF_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_DtoS),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10429,
        GIR_EraseRootFromParent_Done,
      // Label 4605: @231655
      GIM_Try, /*On fail goto*//*Label 4606*/ GIMT_Encode4(231697), // Rule ID 10433 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f16i32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1580:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SCVTF_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_StoH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10433,
        GIR_EraseRootFromParent_Done,
      // Label 4606: @231697
      GIM_Try, /*On fail goto*//*Label 4607*/ GIMT_Encode4(231739), // Rule ID 10437 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f16i64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1581:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SCVTF_ZPmZ_DtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_DtoH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10437,
        GIR_EraseRootFromParent_Done,
      // Label 4607: @231739
      GIM_Try, /*On fail goto*//*Label 4608*/ GIMT_Encode4(231781), // Rule ID 10441 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f32i64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1829:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UCVTF_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_DtoS),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10441,
        GIR_EraseRootFromParent_Done,
      // Label 4608: @231781
      GIM_Try, /*On fail goto*//*Label 4609*/ GIMT_Encode4(231823), // Rule ID 10445 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f16i64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1828:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UCVTF_ZPmZ_DtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_DtoH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10445,
        GIR_EraseRootFromParent_Done,
      // Label 4609: @231823
      GIM_Try, /*On fail goto*//*Label 4610*/ GIMT_Encode4(231865), // Rule ID 10455 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i32f64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1285:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTZS_ZPmZ_DtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_DtoS),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10455,
        GIR_EraseRootFromParent_Done,
      // Label 4610: @231865
      GIM_Try, /*On fail goto*//*Label 4611*/ GIMT_Encode4(231907), // Rule ID 10456 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i32f64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1292:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTZU_ZPmZ_DtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_DtoS),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10456,
        GIR_EraseRootFromParent_Done,
      // Label 4611: @231907
      GIM_Try, /*On fail goto*//*Label 4612*/ GIMT_Encode4(231949), // Rule ID 10457 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i64f32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1287:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTZS_ZPmZ_StoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_StoD),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10457,
        GIR_EraseRootFromParent_Done,
      // Label 4612: @231949
      GIM_Try, /*On fail goto*//*Label 4613*/ GIMT_Encode4(231991), // Rule ID 10461 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i32f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1284:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZS_ZPmZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_HtoS),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10461,
        GIR_EraseRootFromParent_Done,
      // Label 4613: @231991
      GIM_Try, /*On fail goto*//*Label 4614*/ GIMT_Encode4(232033), // Rule ID 10465 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i64f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1286:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZS_ZPmZ_HtoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_HtoD),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10465,
        GIR_EraseRootFromParent_Done,
      // Label 4614: @232033
      GIM_Try, /*On fail goto*//*Label 4615*/ GIMT_Encode4(232075), // Rule ID 10469 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i32f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1291:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZU_ZPmZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_HtoS),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10469,
        GIR_EraseRootFromParent_Done,
      // Label 4615: @232075
      GIM_Try, /*On fail goto*//*Label 4616*/ GIMT_Encode4(232117), // Rule ID 10473 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i64f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1293:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZU_ZPmZ_HtoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_HtoD),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10473,
        GIR_EraseRootFromParent_Done,
      // Label 4616: @232117
      GIM_Try, /*On fail goto*//*Label 4617*/ GIMT_Encode4(232159), // Rule ID 10477 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i64f32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1294:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTZU_ZPmZ_StoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_StoD),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10477,
        GIR_EraseRootFromParent_Done,
      // Label 4617: @232159
      GIM_Try, /*On fail goto*//*Label 4618*/ GIMT_Encode4(232201), // Rule ID 10657 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bfmlalt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1162:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2, nxv8bf16:{ *:[nxv8bf16] }:$Op3)  =>  (BFMLALT_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2, ?:{ *:[nxv8bf16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMLALT_ZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10657,
        GIR_EraseRootFromParent_Done,
      // Label 4618: @232201
      GIM_Try, /*On fail goto*//*Label 4619*/ GIMT_Encode4(232243), // Rule ID 11533 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ummla),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1869:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMMLA_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMMLA_ZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11533,
        GIR_EraseRootFromParent_Done,
      // Label 4619: @232243
      GIM_Try, /*On fail goto*//*Label 4620*/ GIMT_Encode4(232285), // Rule ID 11534 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usmmla),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1940:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (USMMLA_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMMLA_ZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11534,
        GIR_EraseRootFromParent_Done,
      // Label 4620: @232285
      GIM_Try, /*On fail goto*//*Label 4621*/ GIMT_Encode4(232327), // Rule ID 11536 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP32_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmmla),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1355:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMMLA_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMMLA_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11536,
        GIR_EraseRootFromParent_Done,
      // Label 4621: @232327
      GIM_Try, /*On fail goto*//*Label 4622*/ GIMT_Encode4(232369), // Rule ID 11537 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmmla),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1355:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMMLA_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMMLA_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11537,
        GIR_EraseRootFromParent_Done,
      // Label 4622: @232369
      GIM_Try, /*On fail goto*//*Label 4623*/ GIMT_Encode4(232411), // Rule ID 11596 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1704:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQRDMLSH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11596,
        GIR_EraseRootFromParent_Done,
      // Label 4623: @232411
      GIM_Try, /*On fail goto*//*Label 4624*/ GIMT_Encode4(232453), // Rule ID 11597 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1704:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQRDMLSH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11597,
        GIR_EraseRootFromParent_Done,
      // Label 4624: @232453
      GIM_Try, /*On fail goto*//*Label 4625*/ GIMT_Encode4(232495), // Rule ID 11598 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1704:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQRDMLSH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11598,
        GIR_EraseRootFromParent_Done,
      // Label 4625: @232495
      GIM_Try, /*On fail goto*//*Label 4626*/ GIMT_Encode4(232537), // Rule ID 11599 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1704:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQRDMLSH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11599,
        GIR_EraseRootFromParent_Done,
      // Label 4626: @232537
      GIM_Try, /*On fail goto*//*Label 4627*/ GIMT_Encode4(232579), // Rule ID 11652 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1625:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11652,
        GIR_EraseRootFromParent_Done,
      // Label 4627: @232579
      GIM_Try, /*On fail goto*//*Label 4628*/ GIMT_Encode4(232621), // Rule ID 11653 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1625:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11653,
        GIR_EraseRootFromParent_Done,
      // Label 4628: @232621
      GIM_Try, /*On fail goto*//*Label 4629*/ GIMT_Encode4(232663), // Rule ID 11654 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1625:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11654,
        GIR_EraseRootFromParent_Done,
      // Label 4629: @232663
      GIM_Try, /*On fail goto*//*Label 4630*/ GIMT_Encode4(232705), // Rule ID 11655 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1861:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11655,
        GIR_EraseRootFromParent_Done,
      // Label 4630: @232705
      GIM_Try, /*On fail goto*//*Label 4631*/ GIMT_Encode4(232747), // Rule ID 11656 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1861:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11656,
        GIR_EraseRootFromParent_Done,
      // Label 4631: @232747
      GIM_Try, /*On fail goto*//*Label 4632*/ GIMT_Encode4(232789), // Rule ID 11657 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1861:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11657,
        GIR_EraseRootFromParent_Done,
      // Label 4632: @232789
      GIM_Try, /*On fail goto*//*Label 4633*/ GIMT_Encode4(232831), // Rule ID 11658 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1863:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11658,
        GIR_EraseRootFromParent_Done,
      // Label 4633: @232831
      GIM_Try, /*On fail goto*//*Label 4634*/ GIMT_Encode4(232873), // Rule ID 11659 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1863:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11659,
        GIR_EraseRootFromParent_Done,
      // Label 4634: @232873
      GIM_Try, /*On fail goto*//*Label 4635*/ GIMT_Encode4(232915), // Rule ID 11660 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1863:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11660,
        GIR_EraseRootFromParent_Done,
      // Label 4635: @232915
      GIM_Try, /*On fail goto*//*Label 4636*/ GIMT_Encode4(232957), // Rule ID 11661 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1627:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLSLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11661,
        GIR_EraseRootFromParent_Done,
      // Label 4636: @232957
      GIM_Try, /*On fail goto*//*Label 4637*/ GIMT_Encode4(232999), // Rule ID 11662 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1627:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLSLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11662,
        GIR_EraseRootFromParent_Done,
      // Label 4637: @232999
      GIM_Try, /*On fail goto*//*Label 4638*/ GIMT_Encode4(233041), // Rule ID 11663 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1627:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLSLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11663,
        GIR_EraseRootFromParent_Done,
      // Label 4638: @233041
      GIM_Try, /*On fail goto*//*Label 4639*/ GIMT_Encode4(233083), // Rule ID 11664 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1629:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLSLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11664,
        GIR_EraseRootFromParent_Done,
      // Label 4639: @233083
      GIM_Try, /*On fail goto*//*Label 4640*/ GIMT_Encode4(233125), // Rule ID 11665 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1629:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLSLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11665,
        GIR_EraseRootFromParent_Done,
      // Label 4640: @233125
      GIM_Try, /*On fail goto*//*Label 4641*/ GIMT_Encode4(233167), // Rule ID 11666 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1629:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLSLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11666,
        GIR_EraseRootFromParent_Done,
      // Label 4641: @233167
      GIM_Try, /*On fail goto*//*Label 4642*/ GIMT_Encode4(233209), // Rule ID 11667 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1865:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLSLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11667,
        GIR_EraseRootFromParent_Done,
      // Label 4642: @233209
      GIM_Try, /*On fail goto*//*Label 4643*/ GIMT_Encode4(233251), // Rule ID 11668 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1865:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLSLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11668,
        GIR_EraseRootFromParent_Done,
      // Label 4643: @233251
      GIM_Try, /*On fail goto*//*Label 4644*/ GIMT_Encode4(233293), // Rule ID 11669 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1865:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLSLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11669,
        GIR_EraseRootFromParent_Done,
      // Label 4644: @233293
      GIM_Try, /*On fail goto*//*Label 4645*/ GIMT_Encode4(233335), // Rule ID 11670 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1867:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLSLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11670,
        GIR_EraseRootFromParent_Done,
      // Label 4645: @233335
      GIM_Try, /*On fail goto*//*Label 4646*/ GIMT_Encode4(233377), // Rule ID 11671 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1867:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLSLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11671,
        GIR_EraseRootFromParent_Done,
      // Label 4646: @233377
      GIM_Try, /*On fail goto*//*Label 4647*/ GIMT_Encode4(233419), // Rule ID 11672 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1867:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLSLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11672,
        GIR_EraseRootFromParent_Done,
      // Label 4647: @233419
      GIM_Try, /*On fail goto*//*Label 4648*/ GIMT_Encode4(233461), // Rule ID 11681 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1665:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11681,
        GIR_EraseRootFromParent_Done,
      // Label 4648: @233461
      GIM_Try, /*On fail goto*//*Label 4649*/ GIMT_Encode4(233503), // Rule ID 11682 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1665:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11682,
        GIR_EraseRootFromParent_Done,
      // Label 4649: @233503
      GIM_Try, /*On fail goto*//*Label 4650*/ GIMT_Encode4(233545), // Rule ID 11683 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1665:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11683,
        GIR_EraseRootFromParent_Done,
      // Label 4650: @233545
      GIM_Try, /*On fail goto*//*Label 4651*/ GIMT_Encode4(233587), // Rule ID 11684 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1668:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11684,
        GIR_EraseRootFromParent_Done,
      // Label 4651: @233587
      GIM_Try, /*On fail goto*//*Label 4652*/ GIMT_Encode4(233629), // Rule ID 11685 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1668:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11685,
        GIR_EraseRootFromParent_Done,
      // Label 4652: @233629
      GIM_Try, /*On fail goto*//*Label 4653*/ GIMT_Encode4(233671), // Rule ID 11686 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1668:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11686,
        GIR_EraseRootFromParent_Done,
      // Label 4653: @233671
      GIM_Try, /*On fail goto*//*Label 4654*/ GIMT_Encode4(233713), // Rule ID 11687 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1670:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLSLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11687,
        GIR_EraseRootFromParent_Done,
      // Label 4654: @233713
      GIM_Try, /*On fail goto*//*Label 4655*/ GIMT_Encode4(233755), // Rule ID 11688 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1670:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLSLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11688,
        GIR_EraseRootFromParent_Done,
      // Label 4655: @233755
      GIM_Try, /*On fail goto*//*Label 4656*/ GIMT_Encode4(233797), // Rule ID 11689 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1670:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLSLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11689,
        GIR_EraseRootFromParent_Done,
      // Label 4656: @233797
      GIM_Try, /*On fail goto*//*Label 4657*/ GIMT_Encode4(233839), // Rule ID 11690 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1673:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLSLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11690,
        GIR_EraseRootFromParent_Done,
      // Label 4657: @233839
      GIM_Try, /*On fail goto*//*Label 4658*/ GIMT_Encode4(233881), // Rule ID 11691 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1673:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLSLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11691,
        GIR_EraseRootFromParent_Done,
      // Label 4658: @233881
      GIM_Try, /*On fail goto*//*Label 4659*/ GIMT_Encode4(233923), // Rule ID 11692 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1673:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLSLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11692,
        GIR_EraseRootFromParent_Done,
      // Label 4659: @233923
      GIM_Try, /*On fail goto*//*Label 4660*/ GIMT_Encode4(233965), // Rule ID 11693 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalbt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1667:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLALBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALBT_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11693,
        GIR_EraseRootFromParent_Done,
      // Label 4660: @233965
      GIM_Try, /*On fail goto*//*Label 4661*/ GIMT_Encode4(234007), // Rule ID 11694 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalbt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1667:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLALBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALBT_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11694,
        GIR_EraseRootFromParent_Done,
      // Label 4661: @234007
      GIM_Try, /*On fail goto*//*Label 4662*/ GIMT_Encode4(234049), // Rule ID 11695 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalbt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1667:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLALBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALBT_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11695,
        GIR_EraseRootFromParent_Done,
      // Label 4662: @234049
      GIM_Try, /*On fail goto*//*Label 4663*/ GIMT_Encode4(234091), // Rule ID 11696 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslbt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1672:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLSLBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLBT_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11696,
        GIR_EraseRootFromParent_Done,
      // Label 4663: @234091
      GIM_Try, /*On fail goto*//*Label 4664*/ GIMT_Encode4(234133), // Rule ID 11697 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslbt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1672:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLSLBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLBT_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11697,
        GIR_EraseRootFromParent_Done,
      // Label 4664: @234133
      GIM_Try, /*On fail goto*//*Label 4665*/ GIMT_Encode4(234175), // Rule ID 11698 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslbt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1672:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLSLBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLBT_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11698,
        GIR_EraseRootFromParent_Done,
      // Label 4665: @234175
      GIM_Try, /*On fail goto*//*Label 4666*/ GIMT_Encode4(234217), // Rule ID 11699 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1840:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11699,
        GIR_EraseRootFromParent_Done,
      // Label 4666: @234217
      GIM_Try, /*On fail goto*//*Label 4667*/ GIMT_Encode4(234259), // Rule ID 11701 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1840:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11701,
        GIR_EraseRootFromParent_Done,
      // Label 4667: @234259
      GIM_Try, /*On fail goto*//*Label 4668*/ GIMT_Encode4(234301), // Rule ID 11703 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1840:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11703,
        GIR_EraseRootFromParent_Done,
      // Label 4668: @234301
      GIM_Try, /*On fail goto*//*Label 4669*/ GIMT_Encode4(234343), // Rule ID 11705 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1840:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11705,
        GIR_EraseRootFromParent_Done,
      // Label 4669: @234343
      GIM_Try, /*On fail goto*//*Label 4670*/ GIMT_Encode4(234385), // Rule ID 11707 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1600:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SHSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11707,
        GIR_EraseRootFromParent_Done,
      // Label 4670: @234385
      GIM_Try, /*On fail goto*//*Label 4671*/ GIMT_Encode4(234427), // Rule ID 11708 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1600:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SHSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11708,
        GIR_EraseRootFromParent_Done,
      // Label 4671: @234427
      GIM_Try, /*On fail goto*//*Label 4672*/ GIMT_Encode4(234469), // Rule ID 11709 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1600:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SHSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11709,
        GIR_EraseRootFromParent_Done,
      // Label 4672: @234469
      GIM_Try, /*On fail goto*//*Label 4673*/ GIMT_Encode4(234511), // Rule ID 11710 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1600:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SHSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11710,
        GIR_EraseRootFromParent_Done,
      // Label 4673: @234511
      GIM_Try, /*On fail goto*//*Label 4674*/ GIMT_Encode4(234553), // Rule ID 11711 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1841:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UHSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11711,
        GIR_EraseRootFromParent_Done,
      // Label 4674: @234553
      GIM_Try, /*On fail goto*//*Label 4675*/ GIMT_Encode4(234595), // Rule ID 11712 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1841:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UHSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11712,
        GIR_EraseRootFromParent_Done,
      // Label 4675: @234595
      GIM_Try, /*On fail goto*//*Label 4676*/ GIMT_Encode4(234637), // Rule ID 11713 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1841:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UHSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11713,
        GIR_EraseRootFromParent_Done,
      // Label 4676: @234637
      GIM_Try, /*On fail goto*//*Label 4677*/ GIMT_Encode4(234679), // Rule ID 11714 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1841:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UHSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11714,
        GIR_EraseRootFromParent_Done,
      // Label 4677: @234679
      GIM_Try, /*On fail goto*//*Label 4678*/ GIMT_Encode4(234721), // Rule ID 11715 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1735:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SRHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11715,
        GIR_EraseRootFromParent_Done,
      // Label 4678: @234721
      GIM_Try, /*On fail goto*//*Label 4679*/ GIMT_Encode4(234763), // Rule ID 11717 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1735:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SRHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11717,
        GIR_EraseRootFromParent_Done,
      // Label 4679: @234763
      GIM_Try, /*On fail goto*//*Label 4680*/ GIMT_Encode4(234805), // Rule ID 11719 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1735:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SRHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11719,
        GIR_EraseRootFromParent_Done,
      // Label 4680: @234805
      GIM_Try, /*On fail goto*//*Label 4681*/ GIMT_Encode4(234847), // Rule ID 11721 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1735:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SRHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11721,
        GIR_EraseRootFromParent_Done,
      // Label 4681: @234847
      GIM_Try, /*On fail goto*//*Label 4682*/ GIMT_Encode4(234889), // Rule ID 11723 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1927:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (URHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11723,
        GIR_EraseRootFromParent_Done,
      // Label 4682: @234889
      GIM_Try, /*On fail goto*//*Label 4683*/ GIMT_Encode4(234931), // Rule ID 11725 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1927:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (URHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11725,
        GIR_EraseRootFromParent_Done,
      // Label 4683: @234931
      GIM_Try, /*On fail goto*//*Label 4684*/ GIMT_Encode4(234973), // Rule ID 11727 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1927:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11727,
        GIR_EraseRootFromParent_Done,
      // Label 4684: @234973
      GIM_Try, /*On fail goto*//*Label 4685*/ GIMT_Encode4(235015), // Rule ID 11729 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1927:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (URHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11729,
        GIR_EraseRootFromParent_Done,
      // Label 4685: @235015
      GIM_Try, /*On fail goto*//*Label 4686*/ GIMT_Encode4(235057), // Rule ID 11731 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1601:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SHSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11731,
        GIR_EraseRootFromParent_Done,
      // Label 4686: @235057
      GIM_Try, /*On fail goto*//*Label 4687*/ GIMT_Encode4(235099), // Rule ID 11732 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1601:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SHSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11732,
        GIR_EraseRootFromParent_Done,
      // Label 4687: @235099
      GIM_Try, /*On fail goto*//*Label 4688*/ GIMT_Encode4(235141), // Rule ID 11733 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1601:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SHSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11733,
        GIR_EraseRootFromParent_Done,
      // Label 4688: @235141
      GIM_Try, /*On fail goto*//*Label 4689*/ GIMT_Encode4(235183), // Rule ID 11734 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1601:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SHSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11734,
        GIR_EraseRootFromParent_Done,
      // Label 4689: @235183
      GIM_Try, /*On fail goto*//*Label 4690*/ GIMT_Encode4(235225), // Rule ID 11735 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1842:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UHSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11735,
        GIR_EraseRootFromParent_Done,
      // Label 4690: @235225
      GIM_Try, /*On fail goto*//*Label 4691*/ GIMT_Encode4(235267), // Rule ID 11736 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1842:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UHSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11736,
        GIR_EraseRootFromParent_Done,
      // Label 4691: @235267
      GIM_Try, /*On fail goto*//*Label 4692*/ GIMT_Encode4(235309), // Rule ID 11737 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1842:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UHSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11737,
        GIR_EraseRootFromParent_Done,
      // Label 4692: @235309
      GIM_Try, /*On fail goto*//*Label 4693*/ GIMT_Encode4(235351), // Rule ID 11738 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1842:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UHSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11738,
        GIR_EraseRootFromParent_Done,
      // Label 4693: @235351
      GIM_Try, /*On fail goto*//*Label 4694*/ GIMT_Encode4(235393), // Rule ID 11739 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uadalp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1817:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UADALP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALP_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11739,
        GIR_EraseRootFromParent_Done,
      // Label 4694: @235393
      GIM_Try, /*On fail goto*//*Label 4695*/ GIMT_Encode4(235435), // Rule ID 11740 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uadalp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1817:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UADALP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALP_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11740,
        GIR_EraseRootFromParent_Done,
      // Label 4695: @235435
      GIM_Try, /*On fail goto*//*Label 4696*/ GIMT_Encode4(235477), // Rule ID 11741 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uadalp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1817:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UADALP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALP_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11741,
        GIR_EraseRootFromParent_Done,
      // Label 4696: @235477
      GIM_Try, /*On fail goto*//*Label 4697*/ GIMT_Encode4(235519), // Rule ID 11742 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1132:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (ADDP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11742,
        GIR_EraseRootFromParent_Done,
      // Label 4697: @235519
      GIM_Try, /*On fail goto*//*Label 4698*/ GIMT_Encode4(235561), // Rule ID 11743 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1132:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (ADDP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11743,
        GIR_EraseRootFromParent_Done,
      // Label 4698: @235561
      GIM_Try, /*On fail goto*//*Label 4699*/ GIMT_Encode4(235603), // Rule ID 11744 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1132:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADDP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11744,
        GIR_EraseRootFromParent_Done,
      // Label 4699: @235603
      GIM_Try, /*On fail goto*//*Label 4700*/ GIMT_Encode4(235645), // Rule ID 11745 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1132:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADDP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11745,
        GIR_EraseRootFromParent_Done,
      // Label 4700: @235645
      GIM_Try, /*On fail goto*//*Label 4701*/ GIMT_Encode4(235687), // Rule ID 11746 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1611:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMAXP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11746,
        GIR_EraseRootFromParent_Done,
      // Label 4701: @235687
      GIM_Try, /*On fail goto*//*Label 4702*/ GIMT_Encode4(235729), // Rule ID 11747 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1611:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMAXP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11747,
        GIR_EraseRootFromParent_Done,
      // Label 4702: @235729
      GIM_Try, /*On fail goto*//*Label 4703*/ GIMT_Encode4(235771), // Rule ID 11748 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1611:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMAXP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11748,
        GIR_EraseRootFromParent_Done,
      // Label 4703: @235771
      GIM_Try, /*On fail goto*//*Label 4704*/ GIMT_Encode4(235813), // Rule ID 11749 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1611:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SMAXP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11749,
        GIR_EraseRootFromParent_Done,
      // Label 4704: @235813
      GIM_Try, /*On fail goto*//*Label 4705*/ GIMT_Encode4(235855), // Rule ID 11750 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1849:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMAXP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11750,
        GIR_EraseRootFromParent_Done,
      // Label 4705: @235855
      GIM_Try, /*On fail goto*//*Label 4706*/ GIMT_Encode4(235897), // Rule ID 11751 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1849:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMAXP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11751,
        GIR_EraseRootFromParent_Done,
      // Label 4706: @235897
      GIM_Try, /*On fail goto*//*Label 4707*/ GIMT_Encode4(235939), // Rule ID 11752 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1849:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMAXP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11752,
        GIR_EraseRootFromParent_Done,
      // Label 4707: @235939
      GIM_Try, /*On fail goto*//*Label 4708*/ GIMT_Encode4(235981), // Rule ID 11753 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1849:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UMAXP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11753,
        GIR_EraseRootFromParent_Done,
      // Label 4708: @235981
      GIM_Try, /*On fail goto*//*Label 4709*/ GIMT_Encode4(236023), // Rule ID 11754 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1620:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMINP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11754,
        GIR_EraseRootFromParent_Done,
      // Label 4709: @236023
      GIM_Try, /*On fail goto*//*Label 4710*/ GIMT_Encode4(236065), // Rule ID 11755 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1620:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMINP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11755,
        GIR_EraseRootFromParent_Done,
      // Label 4710: @236065
      GIM_Try, /*On fail goto*//*Label 4711*/ GIMT_Encode4(236107), // Rule ID 11756 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1620:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMINP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11756,
        GIR_EraseRootFromParent_Done,
      // Label 4711: @236107
      GIM_Try, /*On fail goto*//*Label 4712*/ GIMT_Encode4(236149), // Rule ID 11757 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1620:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SMINP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11757,
        GIR_EraseRootFromParent_Done,
      // Label 4712: @236149
      GIM_Try, /*On fail goto*//*Label 4713*/ GIMT_Encode4(236191), // Rule ID 11758 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1858:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMINP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11758,
        GIR_EraseRootFromParent_Done,
      // Label 4713: @236191
      GIM_Try, /*On fail goto*//*Label 4714*/ GIMT_Encode4(236233), // Rule ID 11759 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1858:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMINP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11759,
        GIR_EraseRootFromParent_Done,
      // Label 4714: @236233
      GIM_Try, /*On fail goto*//*Label 4715*/ GIMT_Encode4(236275), // Rule ID 11760 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1858:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMINP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11760,
        GIR_EraseRootFromParent_Done,
      // Label 4715: @236275
      GIM_Try, /*On fail goto*//*Label 4716*/ GIMT_Encode4(236317), // Rule ID 11761 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1858:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UMINP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11761,
        GIR_EraseRootFromParent_Done,
      // Label 4716: @236317
      GIM_Try, /*On fail goto*//*Label 4717*/ GIMT_Encode4(236359), // Rule ID 11762 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursqrte),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1934:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URSQRTE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTE_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11762,
        GIR_EraseRootFromParent_Done,
      // Label 4717: @236359
      GIM_Try, /*On fail goto*//*Label 4718*/ GIMT_Encode4(236401), // Rule ID 11773 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1699:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQNEG_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11773,
        GIR_EraseRootFromParent_Done,
      // Label 4718: @236401
      GIM_Try, /*On fail goto*//*Label 4719*/ GIMT_Encode4(236443), // Rule ID 11774 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1699:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQNEG_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11774,
        GIR_EraseRootFromParent_Done,
      // Label 4719: @236443
      GIM_Try, /*On fail goto*//*Label 4720*/ GIMT_Encode4(236485), // Rule ID 11775 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1699:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQNEG_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11775,
        GIR_EraseRootFromParent_Done,
      // Label 4720: @236485
      GIM_Try, /*On fail goto*//*Label 4721*/ GIMT_Encode4(236527), // Rule ID 11776 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1699:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQNEG_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11776,
        GIR_EraseRootFromParent_Done,
      // Label 4721: @236527
      GIM_Try, /*On fail goto*//*Label 4722*/ GIMT_Encode4(236569), // Rule ID 11785 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1640:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11785,
        GIR_EraseRootFromParent_Done,
      // Label 4722: @236569
      GIM_Try, /*On fail goto*//*Label 4723*/ GIMT_Encode4(236611), // Rule ID 11786 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1640:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11786,
        GIR_EraseRootFromParent_Done,
      // Label 4723: @236611
      GIM_Try, /*On fail goto*//*Label 4724*/ GIMT_Encode4(236653), // Rule ID 11787 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1640:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11787,
        GIR_EraseRootFromParent_Done,
      // Label 4724: @236653
      GIM_Try, /*On fail goto*//*Label 4725*/ GIMT_Encode4(236695), // Rule ID 11788 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1640:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11788,
        GIR_EraseRootFromParent_Done,
      // Label 4725: @236695
      GIM_Try, /*On fail goto*//*Label 4726*/ GIMT_Encode4(236737), // Rule ID 11789 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1876:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11789,
        GIR_EraseRootFromParent_Done,
      // Label 4726: @236737
      GIM_Try, /*On fail goto*//*Label 4727*/ GIMT_Encode4(236779), // Rule ID 11790 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1876:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11790,
        GIR_EraseRootFromParent_Done,
      // Label 4727: @236779
      GIM_Try, /*On fail goto*//*Label 4728*/ GIMT_Encode4(236821), // Rule ID 11791 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1876:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11791,
        GIR_EraseRootFromParent_Done,
      // Label 4728: @236821
      GIM_Try, /*On fail goto*//*Label 4729*/ GIMT_Encode4(236863), // Rule ID 11792 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1876:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11792,
        GIR_EraseRootFromParent_Done,
      // Label 4729: @236863
      GIM_Try, /*On fail goto*//*Label 4730*/ GIMT_Encode4(236905), // Rule ID 11793 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1727:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11793,
        GIR_EraseRootFromParent_Done,
      // Label 4730: @236905
      GIM_Try, /*On fail goto*//*Label 4731*/ GIMT_Encode4(236947), // Rule ID 11794 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1727:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11794,
        GIR_EraseRootFromParent_Done,
      // Label 4731: @236947
      GIM_Try, /*On fail goto*//*Label 4732*/ GIMT_Encode4(236989), // Rule ID 11795 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1727:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11795,
        GIR_EraseRootFromParent_Done,
      // Label 4732: @236989
      GIM_Try, /*On fail goto*//*Label 4733*/ GIMT_Encode4(237031), // Rule ID 11796 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1727:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11796,
        GIR_EraseRootFromParent_Done,
      // Label 4733: @237031
      GIM_Try, /*On fail goto*//*Label 4734*/ GIMT_Encode4(237073), // Rule ID 11797 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1920:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11797,
        GIR_EraseRootFromParent_Done,
      // Label 4734: @237073
      GIM_Try, /*On fail goto*//*Label 4735*/ GIMT_Encode4(237115), // Rule ID 11798 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1920:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11798,
        GIR_EraseRootFromParent_Done,
      // Label 4735: @237115
      GIM_Try, /*On fail goto*//*Label 4736*/ GIMT_Encode4(237157), // Rule ID 11799 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1920:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11799,
        GIR_EraseRootFromParent_Done,
      // Label 4736: @237157
      GIM_Try, /*On fail goto*//*Label 4737*/ GIMT_Encode4(237199), // Rule ID 11800 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1920:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11800,
        GIR_EraseRootFromParent_Done,
      // Label 4737: @237199
      GIM_Try, /*On fail goto*//*Label 4738*/ GIMT_Encode4(237241), // Rule ID 11801 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1791:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SUQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11801,
        GIR_EraseRootFromParent_Done,
      // Label 4738: @237241
      GIM_Try, /*On fail goto*//*Label 4739*/ GIMT_Encode4(237283), // Rule ID 11802 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1791:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SUQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11802,
        GIR_EraseRootFromParent_Done,
      // Label 4739: @237283
      GIM_Try, /*On fail goto*//*Label 4740*/ GIMT_Encode4(237325), // Rule ID 11803 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1791:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SUQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11803,
        GIR_EraseRootFromParent_Done,
      // Label 4740: @237325
      GIM_Try, /*On fail goto*//*Label 4741*/ GIMT_Encode4(237367), // Rule ID 11804 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1791:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SUQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11804,
        GIR_EraseRootFromParent_Done,
      // Label 4741: @237367
      GIM_Try, /*On fail goto*//*Label 4742*/ GIMT_Encode4(237409), // Rule ID 11805 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1941:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (USQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11805,
        GIR_EraseRootFromParent_Done,
      // Label 4742: @237409
      GIM_Try, /*On fail goto*//*Label 4743*/ GIMT_Encode4(237451), // Rule ID 11806 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1941:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (USQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11806,
        GIR_EraseRootFromParent_Done,
      // Label 4743: @237451
      GIM_Try, /*On fail goto*//*Label 4744*/ GIMT_Encode4(237493), // Rule ID 11807 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1941:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (USQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11807,
        GIR_EraseRootFromParent_Done,
      // Label 4744: @237493
      GIM_Try, /*On fail goto*//*Label 4745*/ GIMT_Encode4(237535), // Rule ID 11808 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1941:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (USQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11808,
        GIR_EraseRootFromParent_Done,
      // Label 4745: @237535
      GIM_Try, /*On fail goto*//*Label 4746*/ GIMT_Encode4(237577), // Rule ID 11809 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1730:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11809,
        GIR_EraseRootFromParent_Done,
      // Label 4746: @237577
      GIM_Try, /*On fail goto*//*Label 4747*/ GIMT_Encode4(237619), // Rule ID 11810 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1730:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11810,
        GIR_EraseRootFromParent_Done,
      // Label 4747: @237619
      GIM_Try, /*On fail goto*//*Label 4748*/ GIMT_Encode4(237661), // Rule ID 11811 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1730:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11811,
        GIR_EraseRootFromParent_Done,
      // Label 4748: @237661
      GIM_Try, /*On fail goto*//*Label 4749*/ GIMT_Encode4(237703), // Rule ID 11812 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1730:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11812,
        GIR_EraseRootFromParent_Done,
      // Label 4749: @237703
      GIM_Try, /*On fail goto*//*Label 4750*/ GIMT_Encode4(237745), // Rule ID 11813 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1923:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11813,
        GIR_EraseRootFromParent_Done,
      // Label 4750: @237745
      GIM_Try, /*On fail goto*//*Label 4751*/ GIMT_Encode4(237787), // Rule ID 11814 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1923:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11814,
        GIR_EraseRootFromParent_Done,
      // Label 4751: @237787
      GIM_Try, /*On fail goto*//*Label 4752*/ GIMT_Encode4(237829), // Rule ID 11815 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1923:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11815,
        GIR_EraseRootFromParent_Done,
      // Label 4752: @237829
      GIM_Try, /*On fail goto*//*Label 4753*/ GIMT_Encode4(237871), // Rule ID 11816 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1923:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11816,
        GIR_EraseRootFromParent_Done,
      // Label 4753: @237871
      GIM_Try, /*On fail goto*//*Label 4754*/ GIMT_Encode4(237913), // Rule ID 11817 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1737:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SRSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11817,
        GIR_EraseRootFromParent_Done,
      // Label 4754: @237913
      GIM_Try, /*On fail goto*//*Label 4755*/ GIMT_Encode4(237955), // Rule ID 11818 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1737:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SRSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11818,
        GIR_EraseRootFromParent_Done,
      // Label 4755: @237955
      GIM_Try, /*On fail goto*//*Label 4756*/ GIMT_Encode4(237997), // Rule ID 11819 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1737:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SRSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11819,
        GIR_EraseRootFromParent_Done,
      // Label 4756: @237997
      GIM_Try, /*On fail goto*//*Label 4757*/ GIMT_Encode4(238039), // Rule ID 11820 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1737:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SRSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11820,
        GIR_EraseRootFromParent_Done,
      // Label 4757: @238039
      GIM_Try, /*On fail goto*//*Label 4758*/ GIMT_Encode4(238081), // Rule ID 11821 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1928:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (URSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11821,
        GIR_EraseRootFromParent_Done,
      // Label 4758: @238081
      GIM_Try, /*On fail goto*//*Label 4759*/ GIMT_Encode4(238123), // Rule ID 11822 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1928:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (URSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11822,
        GIR_EraseRootFromParent_Done,
      // Label 4759: @238123
      GIM_Try, /*On fail goto*//*Label 4760*/ GIMT_Encode4(238165), // Rule ID 11823 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1928:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11823,
        GIR_EraseRootFromParent_Done,
      // Label 4760: @238165
      GIM_Try, /*On fail goto*//*Label 4761*/ GIMT_Encode4(238207), // Rule ID 11824 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1928:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (URSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11824,
        GIR_EraseRootFromParent_Done,
      // Label 4761: @238207
      GIM_Try, /*On fail goto*//*Label 4762*/ GIMT_Encode4(238249), // Rule ID 11825 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1721:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11825,
        GIR_EraseRootFromParent_Done,
      // Label 4762: @238249
      GIM_Try, /*On fail goto*//*Label 4763*/ GIMT_Encode4(238291), // Rule ID 11826 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1721:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11826,
        GIR_EraseRootFromParent_Done,
      // Label 4763: @238291
      GIM_Try, /*On fail goto*//*Label 4764*/ GIMT_Encode4(238333), // Rule ID 11827 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1721:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11827,
        GIR_EraseRootFromParent_Done,
      // Label 4764: @238333
      GIM_Try, /*On fail goto*//*Label 4765*/ GIMT_Encode4(238375), // Rule ID 11828 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1721:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11828,
        GIR_EraseRootFromParent_Done,
      // Label 4765: @238375
      GIM_Try, /*On fail goto*//*Label 4766*/ GIMT_Encode4(238417), // Rule ID 11829 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1917:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11829,
        GIR_EraseRootFromParent_Done,
      // Label 4766: @238417
      GIM_Try, /*On fail goto*//*Label 4767*/ GIMT_Encode4(238459), // Rule ID 11830 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1917:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11830,
        GIR_EraseRootFromParent_Done,
      // Label 4767: @238459
      GIM_Try, /*On fail goto*//*Label 4768*/ GIMT_Encode4(238501), // Rule ID 11831 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1917:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11831,
        GIR_EraseRootFromParent_Done,
      // Label 4768: @238501
      GIM_Try, /*On fail goto*//*Label 4769*/ GIMT_Encode4(238543), // Rule ID 11832 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1917:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11832,
        GIR_EraseRootFromParent_Done,
      // Label 4769: @238543
      GIM_Try, /*On fail goto*//*Label 4770*/ GIMT_Encode4(238585), // Rule ID 11833 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1708:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQRSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11833,
        GIR_EraseRootFromParent_Done,
      // Label 4770: @238585
      GIM_Try, /*On fail goto*//*Label 4771*/ GIMT_Encode4(238627), // Rule ID 11834 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1708:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQRSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11834,
        GIR_EraseRootFromParent_Done,
      // Label 4771: @238627
      GIM_Try, /*On fail goto*//*Label 4772*/ GIMT_Encode4(238669), // Rule ID 11835 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1708:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQRSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11835,
        GIR_EraseRootFromParent_Done,
      // Label 4772: @238669
      GIM_Try, /*On fail goto*//*Label 4773*/ GIMT_Encode4(238711), // Rule ID 11836 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1708:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQRSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11836,
        GIR_EraseRootFromParent_Done,
      // Label 4773: @238711
      GIM_Try, /*On fail goto*//*Label 4774*/ GIMT_Encode4(238753), // Rule ID 11837 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1910:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQRSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11837,
        GIR_EraseRootFromParent_Done,
      // Label 4774: @238753
      GIM_Try, /*On fail goto*//*Label 4775*/ GIMT_Encode4(238795), // Rule ID 11838 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1910:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQRSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11838,
        GIR_EraseRootFromParent_Done,
      // Label 4775: @238795
      GIM_Try, /*On fail goto*//*Label 4776*/ GIMT_Encode4(238837), // Rule ID 11839 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1910:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQRSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11839,
        GIR_EraseRootFromParent_Done,
      // Label 4776: @238837
      GIM_Try, /*On fail goto*//*Label 4777*/ GIMT_Encode4(238879), // Rule ID 11840 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1910:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQRSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11840,
        GIR_EraseRootFromParent_Done,
      // Label 4777: @238879
      GIM_Try, /*On fail goto*//*Label 4778*/ GIMT_Encode4(238921), // Rule ID 12003 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1810:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABA_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12003,
        GIR_EraseRootFromParent_Done,
      // Label 4778: @238921
      GIM_Try, /*On fail goto*//*Label 4779*/ GIMT_Encode4(238963), // Rule ID 12005 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1810:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABA_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12005,
        GIR_EraseRootFromParent_Done,
      // Label 4779: @238963
      GIM_Try, /*On fail goto*//*Label 4780*/ GIMT_Encode4(239005), // Rule ID 12007 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1810:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABA_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12007,
        GIR_EraseRootFromParent_Done,
      // Label 4780: @239005
      GIM_Try, /*On fail goto*//*Label 4781*/ GIMT_Encode4(239047), // Rule ID 12009 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1810:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UABA_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12009,
        GIR_EraseRootFromParent_Done,
      // Label 4781: @239047
      GIM_Try, /*On fail goto*//*Label 4782*/ GIMT_Encode4(239089), // Rule ID 12011 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1562:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALT_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12011,
        GIR_EraseRootFromParent_Done,
      // Label 4782: @239089
      GIM_Try, /*On fail goto*//*Label 4783*/ GIMT_Encode4(239131), // Rule ID 12012 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1562:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALT_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12012,
        GIR_EraseRootFromParent_Done,
      // Label 4783: @239131
      GIM_Try, /*On fail goto*//*Label 4784*/ GIMT_Encode4(239173), // Rule ID 12013 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1562:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALT_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12013,
        GIR_EraseRootFromParent_Done,
      // Label 4784: @239173
      GIM_Try, /*On fail goto*//*Label 4785*/ GIMT_Encode4(239215), // Rule ID 12014 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1811:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALB_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12014,
        GIR_EraseRootFromParent_Done,
      // Label 4785: @239215
      GIM_Try, /*On fail goto*//*Label 4786*/ GIMT_Encode4(239257), // Rule ID 12015 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1811:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALB_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12015,
        GIR_EraseRootFromParent_Done,
      // Label 4786: @239257
      GIM_Try, /*On fail goto*//*Label 4787*/ GIMT_Encode4(239299), // Rule ID 12016 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1811:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALB_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12016,
        GIR_EraseRootFromParent_Done,
      // Label 4787: @239299
      GIM_Try, /*On fail goto*//*Label 4788*/ GIMT_Encode4(239341), // Rule ID 12017 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1812:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALT_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12017,
        GIR_EraseRootFromParent_Done,
      // Label 4788: @239341
      GIM_Try, /*On fail goto*//*Label 4789*/ GIMT_Encode4(239383), // Rule ID 12018 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1812:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALT_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12018,
        GIR_EraseRootFromParent_Done,
      // Label 4789: @239383
      GIM_Try, /*On fail goto*//*Label 4790*/ GIMT_Encode4(239425), // Rule ID 12019 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1812:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALT_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12019,
        GIR_EraseRootFromParent_Done,
      // Label 4790: @239425
      GIM_Try, /*On fail goto*//*Label 4791*/ GIMT_Encode4(239467), // Rule ID 12020 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1125:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADCLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLT_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12020,
        GIR_EraseRootFromParent_Done,
      // Label 4791: @239467
      GIM_Try, /*On fail goto*//*Label 4792*/ GIMT_Encode4(239509), // Rule ID 12021 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1125:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADCLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLT_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12021,
        GIR_EraseRootFromParent_Done,
      // Label 4792: @239509
      GIM_Try, /*On fail goto*//*Label 4793*/ GIMT_Encode4(239551), // Rule ID 12022 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1574:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SBCLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLB_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12022,
        GIR_EraseRootFromParent_Done,
      // Label 4793: @239551
      GIM_Try, /*On fail goto*//*Label 4794*/ GIMT_Encode4(239593), // Rule ID 12023 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1574:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SBCLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLB_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12023,
        GIR_EraseRootFromParent_Done,
      // Label 4794: @239593
      GIM_Try, /*On fail goto*//*Label 4795*/ GIMT_Encode4(239635), // Rule ID 12024 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1575:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SBCLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLT_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12024,
        GIR_EraseRootFromParent_Done,
      // Label 4795: @239635
      GIM_Try, /*On fail goto*//*Label 4796*/ GIMT_Encode4(239677), // Rule ID 12025 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1575:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SBCLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLT_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12025,
        GIR_EraseRootFromParent_Done,
      // Label 4796: @239677
      GIM_Try, /*On fail goto*//*Label 4797*/ GIMT_Encode4(239719), // Rule ID 12080 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1543:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (RADDHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNT_ZZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12080,
        GIR_EraseRootFromParent_Done,
      // Label 4797: @239719
      GIM_Try, /*On fail goto*//*Label 4798*/ GIMT_Encode4(239761), // Rule ID 12081 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1543:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (RADDHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNT_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12081,
        GIR_EraseRootFromParent_Done,
      // Label 4798: @239761
      GIM_Try, /*On fail goto*//*Label 4799*/ GIMT_Encode4(239803), // Rule ID 12082 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1543:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (RADDHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNT_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12082,
        GIR_EraseRootFromParent_Done,
      // Label 4799: @239803
      GIM_Try, /*On fail goto*//*Label 4800*/ GIMT_Encode4(239845), // Rule ID 12083 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1784:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SUBHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNT_ZZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12083,
        GIR_EraseRootFromParent_Done,
      // Label 4800: @239845
      GIM_Try, /*On fail goto*//*Label 4801*/ GIMT_Encode4(239887), // Rule ID 12084 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1784:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SUBHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNT_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12084,
        GIR_EraseRootFromParent_Done,
      // Label 4801: @239887
      GIM_Try, /*On fail goto*//*Label 4802*/ GIMT_Encode4(239929), // Rule ID 12085 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1784:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SUBHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNT_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12085,
        GIR_EraseRootFromParent_Done,
      // Label 4802: @239929
      GIM_Try, /*On fail goto*//*Label 4803*/ GIMT_Encode4(239971), // Rule ID 12086 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1559:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (RSUBHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNT_ZZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12086,
        GIR_EraseRootFromParent_Done,
      // Label 4803: @239971
      GIM_Try, /*On fail goto*//*Label 4804*/ GIMT_Encode4(240013), // Rule ID 12087 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1559:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (RSUBHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNT_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12087,
        GIR_EraseRootFromParent_Done,
      // Label 4804: @240013
      GIM_Try, /*On fail goto*//*Label 4805*/ GIMT_Encode4(240055), // Rule ID 12088 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1559:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (RSUBHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNT_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12088,
        GIR_EraseRootFromParent_Done,
      // Label 4805: @240055
      GIM_Try, /*On fail goto*//*Label 4806*/ GIMT_Encode4(240100), // Rule ID 12101 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nmatch),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i1] } 1494:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (NMATCH_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NMATCH_PPzZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12101,
        GIR_EraseRootFromParent_Done,
      // Label 4806: @240100
      GIM_Try, /*On fail goto*//*Label 4807*/ GIMT_Encode4(240145), // Rule ID 12102 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nmatch),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i1] } 1494:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (NMATCH_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NMATCH_PPzZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12102,
        GIR_EraseRootFromParent_Done,
      // Label 4807: @240145
      GIM_Try, /*On fail goto*//*Label 4808*/ GIMT_Encode4(240187), // Rule ID 12103 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1234:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EORTB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12103,
        GIR_EraseRootFromParent_Done,
      // Label 4808: @240187
      GIM_Try, /*On fail goto*//*Label 4809*/ GIMT_Encode4(240229), // Rule ID 12104 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1234:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EORTB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12104,
        GIR_EraseRootFromParent_Done,
      // Label 4809: @240229
      GIM_Try, /*On fail goto*//*Label 4810*/ GIMT_Encode4(240271), // Rule ID 12105 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1234:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EORTB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12105,
        GIR_EraseRootFromParent_Done,
      // Label 4810: @240271
      GIM_Try, /*On fail goto*//*Label 4811*/ GIMT_Encode4(240313), // Rule ID 12106 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1234:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EORTB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12106,
        GIR_EraseRootFromParent_Done,
      // Label 4811: @240313
      GIM_Try, /*On fail goto*//*Label 4812*/ GIMT_Encode4(240355), // Rule ID 12122 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1317:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMAXNMP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMP_ZPmZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12122,
        GIR_EraseRootFromParent_Done,
      // Label 4812: @240355
      GIM_Try, /*On fail goto*//*Label 4813*/ GIMT_Encode4(240397), // Rule ID 12123 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1317:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMAXNMP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMP_ZPmZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12123,
        GIR_EraseRootFromParent_Done,
      // Label 4813: @240397
      GIM_Try, /*On fail goto*//*Label 4814*/ GIMT_Encode4(240439), // Rule ID 12124 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1317:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMAXNMP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMP_ZPmZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12124,
        GIR_EraseRootFromParent_Done,
      // Label 4814: @240439
      GIM_Try, /*On fail goto*//*Label 4815*/ GIMT_Encode4(240481), // Rule ID 12125 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1335:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMINNMP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMP_ZPmZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12125,
        GIR_EraseRootFromParent_Done,
      // Label 4815: @240481
      GIM_Try, /*On fail goto*//*Label 4816*/ GIMT_Encode4(240523), // Rule ID 12126 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1335:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMINNMP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMP_ZPmZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12126,
        GIR_EraseRootFromParent_Done,
      // Label 4816: @240523
      GIM_Try, /*On fail goto*//*Label 4817*/ GIMT_Encode4(240565), // Rule ID 12127 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1335:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMINNMP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMP_ZPmZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12127,
        GIR_EraseRootFromParent_Done,
      // Label 4817: @240565
      GIM_Try, /*On fail goto*//*Label 4818*/ GIMT_Encode4(240607), // Rule ID 12128 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1320:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMAXP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXP_ZPmZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12128,
        GIR_EraseRootFromParent_Done,
      // Label 4818: @240607
      GIM_Try, /*On fail goto*//*Label 4819*/ GIMT_Encode4(240649), // Rule ID 12129 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1320:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMAXP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXP_ZPmZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12129,
        GIR_EraseRootFromParent_Done,
      // Label 4819: @240649
      GIM_Try, /*On fail goto*//*Label 4820*/ GIMT_Encode4(240691), // Rule ID 12130 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1320:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMAXP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXP_ZPmZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12130,
        GIR_EraseRootFromParent_Done,
      // Label 4820: @240691
      GIM_Try, /*On fail goto*//*Label 4821*/ GIMT_Encode4(240733), // Rule ID 12131 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1338:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMINP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINP_ZPmZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12131,
        GIR_EraseRootFromParent_Done,
      // Label 4821: @240733
      GIM_Try, /*On fail goto*//*Label 4822*/ GIMT_Encode4(240775), // Rule ID 12132 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1338:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMINP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINP_ZPmZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12132,
        GIR_EraseRootFromParent_Done,
      // Label 4822: @240775
      GIM_Try, /*On fail goto*//*Label 4823*/ GIMT_Encode4(240817), // Rule ID 12133 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1338:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMINP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINP_ZPmZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12133,
        GIR_EraseRootFromParent_Done,
      // Label 4823: @240817
      GIM_Try, /*On fail goto*//*Label 4824*/ GIMT_Encode4(240859), // Rule ID 12138 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1344:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLALB_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZ_SHH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12138,
        GIR_EraseRootFromParent_Done,
      // Label 4824: @240859
      GIM_Try, /*On fail goto*//*Label 4825*/ GIMT_Encode4(240901), // Rule ID 12139 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1346:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLALT_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZ_SHH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12139,
        GIR_EraseRootFromParent_Done,
      // Label 4825: @240901
      GIM_Try, /*On fail goto*//*Label 4826*/ GIMT_Encode4(240943), // Rule ID 12140 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1351:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLSLB_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLB_ZZZ_SHH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12140,
        GIR_EraseRootFromParent_Done,
      // Label 4826: @240943
      GIM_Try, /*On fail goto*//*Label 4827*/ GIMT_Encode4(240985), // Rule ID 12141 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1353:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLSLT_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLT_ZZZ_SHH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12141,
        GIR_EraseRootFromParent_Done,
      // Label 4827: @240985
      GIM_Try, /*On fail goto*//*Label 4828*/ GIMT_Encode4(241027), // Rule ID 12142 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1151:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12142,
        GIR_EraseRootFromParent_Done,
      // Label 4828: @241027
      GIM_Try, /*On fail goto*//*Label 4829*/ GIMT_Encode4(241069), // Rule ID 12144 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1151:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12144,
        GIR_EraseRootFromParent_Done,
      // Label 4829: @241069
      GIM_Try, /*On fail goto*//*Label 4830*/ GIMT_Encode4(241111), // Rule ID 12146 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1151:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12146,
        GIR_EraseRootFromParent_Done,
      // Label 4830: @241111
      GIM_Try, /*On fail goto*//*Label 4831*/ GIMT_Encode4(241153), // Rule ID 12148 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1151:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12148,
        GIR_EraseRootFromParent_Done,
      // Label 4831: @241153
      GIM_Try, /*On fail goto*//*Label 4832*/ GIMT_Encode4(241195), // Rule ID 12150 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1180:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12150,
        GIR_EraseRootFromParent_Done,
      // Label 4832: @241195
      GIM_Try, /*On fail goto*//*Label 4833*/ GIMT_Encode4(241237), // Rule ID 12152 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1180:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12152,
        GIR_EraseRootFromParent_Done,
      // Label 4833: @241237
      GIM_Try, /*On fail goto*//*Label 4834*/ GIMT_Encode4(241279), // Rule ID 12154 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1180:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12154,
        GIR_EraseRootFromParent_Done,
      // Label 4834: @241279
      GIM_Try, /*On fail goto*//*Label 4835*/ GIMT_Encode4(241321), // Rule ID 12156 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1180:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12156,
        GIR_EraseRootFromParent_Done,
      // Label 4835: @241321
      GIM_Try, /*On fail goto*//*Label 4836*/ GIMT_Encode4(241363), // Rule ID 12158 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl1n),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1181:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12158,
        GIR_EraseRootFromParent_Done,
      // Label 4836: @241363
      GIM_Try, /*On fail goto*//*Label 4837*/ GIMT_Encode4(241405), // Rule ID 12159 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl1n),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1181:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12159,
        GIR_EraseRootFromParent_Done,
      // Label 4837: @241405
      GIM_Try, /*On fail goto*//*Label 4838*/ GIMT_Encode4(241447), // Rule ID 12160 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl1n),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1181:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12160,
        GIR_EraseRootFromParent_Done,
      // Label 4838: @241447
      GIM_Try, /*On fail goto*//*Label 4839*/ GIMT_Encode4(241489), // Rule ID 12161 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl1n),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1181:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12161,
        GIR_EraseRootFromParent_Done,
      // Label 4839: @241489
      GIM_Try, /*On fail goto*//*Label 4840*/ GIMT_Encode4(241531), // Rule ID 12162 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl2n),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1182:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12162,
        GIR_EraseRootFromParent_Done,
      // Label 4840: @241531
      GIM_Try, /*On fail goto*//*Label 4841*/ GIMT_Encode4(241573), // Rule ID 12163 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl2n),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1182:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12163,
        GIR_EraseRootFromParent_Done,
      // Label 4841: @241573
      GIM_Try, /*On fail goto*//*Label 4842*/ GIMT_Encode4(241615), // Rule ID 12164 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl2n),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1182:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12164,
        GIR_EraseRootFromParent_Done,
      // Label 4842: @241615
      GIM_Try, /*On fail goto*//*Label 4843*/ GIMT_Encode4(241657), // Rule ID 12165 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl2n),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1182:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12165,
        GIR_EraseRootFromParent_Done,
      // Label 4843: @241657
      GIM_Try, /*On fail goto*//*Label 4844*/ GIMT_Encode4(241699), // Rule ID 12166 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nbsl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1492:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12166,
        GIR_EraseRootFromParent_Done,
      // Label 4844: @241699
      GIM_Try, /*On fail goto*//*Label 4845*/ GIMT_Encode4(241741), // Rule ID 12168 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nbsl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1492:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12168,
        GIR_EraseRootFromParent_Done,
      // Label 4845: @241741
      GIM_Try, /*On fail goto*//*Label 4846*/ GIMT_Encode4(241783), // Rule ID 12170 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nbsl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1492:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12170,
        GIR_EraseRootFromParent_Done,
      // Label 4846: @241783
      GIM_Try, /*On fail goto*//*Label 4847*/ GIMT_Encode4(241825), // Rule ID 12172 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nbsl),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1492:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12172,
        GIR_EraseRootFromParent_Done,
      // Label 4847: @241825
      GIM_Try, /*On fail goto*//*Label 4848*/ GIMT_Encode4(241867), // Rule ID 12264 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1823:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UCLAMP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12264,
        GIR_EraseRootFromParent_Done,
      // Label 4848: @241867
      GIM_Try, /*On fail goto*//*Label 4849*/ GIMT_Encode4(241909), // Rule ID 12266 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1823:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UCLAMP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12266,
        GIR_EraseRootFromParent_Done,
      // Label 4849: @241909
      GIM_Try, /*On fail goto*//*Label 4850*/ GIMT_Encode4(241951), // Rule ID 12268 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1823:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UCLAMP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12268,
        GIR_EraseRootFromParent_Done,
      // Label 4850: @241951
      GIM_Try, /*On fail goto*//*Label 4851*/ GIMT_Encode4(241993), // Rule ID 12270 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1823:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UCLAMP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12270,
        GIR_EraseRootFromParent_Done,
      // Label 4851: @241993
      GIM_Try, /*On fail goto*//*Label 4852*/ GIMT_Encode4(242035), // Rule ID 12272 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdot_x2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1301:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FDOT_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12272,
        GIR_EraseRootFromParent_Done,
      // Label 4852: @242035
      GIM_Try, /*On fail goto*//*Label 4853*/ GIMT_Encode4(242077), // Rule ID 12274 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bfmlslb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1164:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2, nxv8bf16:{ *:[nxv8bf16] }:$Op3)  =>  (BFMLSLB_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2, ?:{ *:[nxv8bf16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMLSLB_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12274,
        GIR_EraseRootFromParent_Done,
      // Label 4853: @242077
      GIM_Try, /*On fail goto*//*Label 4854*/ GIMT_Encode4(242119), // Rule ID 12275 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bfmlslt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1166:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2, nxv8bf16:{ *:[nxv8bf16] }:$Op3)  =>  (BFMLSLT_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2, ?:{ *:[nxv8bf16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMLSLT_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12275,
        GIR_EraseRootFromParent_Done,
      // Label 4854: @242119
      GIM_Try, /*On fail goto*//*Label 4855*/ GIMT_Encode4(242161), // Rule ID 12278 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_x2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1839:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UDOT_ZZZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZ_HtoS),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12278,
        GIR_EraseRootFromParent_Done,
      // Label 4855: @242161
      GIM_Try, /*On fail goto*//*Label 4856*/ GIMT_Encode4(242203), // Rule ID 12396 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEB16B16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8bf16] } 1419:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2, nxv8bf16:{ *:[nxv8bf16] }:$Op3)  =>  (BFSUB_ZPmZZ:{ *:[nxv8bf16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2, ?:{ *:[nxv8bf16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFSUB_ZPmZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12396,
        GIR_EraseRootFromParent_Done,
      // Label 4856: @242203
      GIM_Try, /*On fail goto*//*Label 4857*/ GIMT_Encode4(242245), // Rule ID 12400 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEB16B16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8bf16] } 1311:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2, nxv8bf16:{ *:[nxv8bf16] }:$Op3)  =>  (BFMAXNM_ZPmZZ:{ *:[nxv8bf16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2, ?:{ *:[nxv8bf16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMAXNM_ZPmZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12400,
        GIR_EraseRootFromParent_Done,
      // Label 4857: @242245
      GIM_Try, /*On fail goto*//*Label 4858*/ GIMT_Encode4(242287), // Rule ID 12401 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEB16B16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8bf16] } 1329:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2, nxv8bf16:{ *:[nxv8bf16] }:$Op3)  =>  (BFMINNM_ZPmZZ:{ *:[nxv8bf16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2, ?:{ *:[nxv8bf16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMINNM_ZPmZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12401,
        GIR_EraseRootFromParent_Done,
      // Label 4858: @242287
      GIM_Try, /*On fail goto*//*Label 4859*/ GIMT_Encode4(242329), // Rule ID 12402 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEB16B16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8bf16] } 1305:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2, nxv8bf16:{ *:[nxv8bf16] }:$Op3)  =>  (BFMAX_ZPmZZ:{ *:[nxv8bf16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2, ?:{ *:[nxv8bf16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMAX_ZPmZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12402,
        GIR_EraseRootFromParent_Done,
      // Label 4859: @242329
      GIM_Try, /*On fail goto*//*Label 4860*/ GIMT_Encode4(242371), // Rule ID 12403 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEB16B16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8bf16] } 1323:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2, nxv8bf16:{ *:[nxv8bf16] }:$Op3)  =>  (BFMIN_ZPmZZ:{ *:[nxv8bf16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2, ?:{ *:[nxv8bf16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMIN_ZPmZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12403,
        GIR_EraseRootFromParent_Done,
      // Label 4860: @242371
      GIM_Try, /*On fail goto*//*Label 4861*/ GIMT_Encode4(242413), // Rule ID 12505 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1799:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (TBXQ_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12505,
        GIR_EraseRootFromParent_Done,
      // Label 4861: @242413
      GIM_Try, /*On fail goto*//*Label 4862*/ GIMT_Encode4(242455), // Rule ID 12506 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1799:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBXQ_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12506,
        GIR_EraseRootFromParent_Done,
      // Label 4862: @242455
      GIM_Try, /*On fail goto*//*Label 4863*/ GIMT_Encode4(242497), // Rule ID 12507 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1799:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBXQ_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12507,
        GIR_EraseRootFromParent_Done,
      // Label 4863: @242497
      GIM_Try, /*On fail goto*//*Label 4864*/ GIMT_Encode4(242539), // Rule ID 12508 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1799:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBXQ_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12508,
        GIR_EraseRootFromParent_Done,
      // Label 4864: @242539
      GIM_Try, /*On fail goto*//*Label 4865*/ GIMT_Encode4(242581), // Rule ID 12509 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1799:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBXQ_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12509,
        GIR_EraseRootFromParent_Done,
      // Label 4865: @242581
      GIM_Try, /*On fail goto*//*Label 4866*/ GIMT_Encode4(242623), // Rule ID 12510 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1799:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBXQ_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12510,
        GIR_EraseRootFromParent_Done,
      // Label 4866: @242623
      GIM_Try, /*On fail goto*//*Label 4867*/ GIMT_Encode4(242665), // Rule ID 12511 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1799:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBXQ_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12511,
        GIR_EraseRootFromParent_Done,
      // Label 4867: @242665
      GIM_Try, /*On fail goto*//*Label 4868*/ GIMT_Encode4(242707), // Rule ID 12512 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2p1),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8bf16] } 1799:{ *:[iPTR] }, nxv8bf16:{ *:[nxv8bf16] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBXQ_ZZZ_H:{ *:[nxv8bf16] } ?:{ *:[nxv8bf16] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12512,
        GIR_EraseRootFromParent_Done,
      // Label 4868: @242707
      GIM_Try, /*On fail goto*//*Label 4869*/ GIMT_Encode4(242749), // Rule ID 12606 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2orSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1251:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMIN_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12606,
        GIR_EraseRootFromParent_Done,
      // Label 4869: @242749
      GIM_Try, /*On fail goto*//*Label 4870*/ GIMT_Encode4(242791), // Rule ID 12607 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2orSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1251:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMIN_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12607,
        GIR_EraseRootFromParent_Done,
      // Label 4870: @242791
      GIM_Try, /*On fail goto*//*Label 4871*/ GIMT_Encode4(242833), // Rule ID 12608 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2orSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1251:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMIN_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12608,
        GIR_EraseRootFromParent_Done,
      // Label 4871: @242833
      GIM_Try, /*On fail goto*//*Label 4872*/ GIMT_Encode4(242875), // Rule ID 12609 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2orSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1249:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMAX_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12609,
        GIR_EraseRootFromParent_Done,
      // Label 4872: @242875
      GIM_Try, /*On fail goto*//*Label 4873*/ GIMT_Encode4(242917), // Rule ID 12610 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2orSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1249:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMAX_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12610,
        GIR_EraseRootFromParent_Done,
      // Label 4873: @242917
      GIM_Try, /*On fail goto*//*Label 4874*/ GIMT_Encode4(242959), // Rule ID 12611 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2orSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1249:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMAX_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12611,
        GIR_EraseRootFromParent_Done,
      // Label 4874: @242959
      GIM_Try, /*On fail goto*//*Label 4875*/ GIMT_Encode4(243001), // Rule ID 12612 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2orSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1250:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMAX_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_H_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12612,
        GIR_EraseRootFromParent_Done,
      // Label 4875: @243001
      GIM_Try, /*On fail goto*//*Label 4876*/ GIMT_Encode4(243043), // Rule ID 12615 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2orSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 1250:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FAMAX_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_H_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12615,
        GIR_EraseRootFromParent_Done,
      // Label 4876: @243043
      GIM_Try, /*On fail goto*//*Label 4877*/ GIMT_Encode4(243085), // Rule ID 12618 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2orSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 1250:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FAMAX_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_H_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12618,
        GIR_EraseRootFromParent_Done,
      // Label 4877: @243085
      GIM_Try, /*On fail goto*//*Label 4878*/ GIMT_Encode4(243127), // Rule ID 12621 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2orSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1250:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMAX_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_S_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12621,
        GIR_EraseRootFromParent_Done,
      // Label 4878: @243127
      GIM_Try, /*On fail goto*//*Label 4879*/ GIMT_Encode4(243169), // Rule ID 12624 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2orSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 1250:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FAMAX_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_S_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12624,
        GIR_EraseRootFromParent_Done,
      // Label 4879: @243169
      GIM_Try, /*On fail goto*//*Label 4880*/ GIMT_Encode4(243211), // Rule ID 12627 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2orSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1250:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMAX_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_D_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12627,
        GIR_EraseRootFromParent_Done,
      // Label 4880: @243211
      GIM_Try, /*On fail goto*//*Label 4881*/ GIMT_Encode4(243253), // Rule ID 12630 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2orSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1252:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMIN_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_H_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12630,
        GIR_EraseRootFromParent_Done,
      // Label 4881: @243253
      GIM_Try, /*On fail goto*//*Label 4882*/ GIMT_Encode4(243295), // Rule ID 12633 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2orSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 1252:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FAMIN_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_H_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12633,
        GIR_EraseRootFromParent_Done,
      // Label 4882: @243295
      GIM_Try, /*On fail goto*//*Label 4883*/ GIMT_Encode4(243337), // Rule ID 12636 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2orSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 1252:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FAMIN_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_H_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12636,
        GIR_EraseRootFromParent_Done,
      // Label 4883: @243337
      GIM_Try, /*On fail goto*//*Label 4884*/ GIMT_Encode4(243379), // Rule ID 12639 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2orSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1252:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMIN_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_S_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12639,
        GIR_EraseRootFromParent_Done,
      // Label 4884: @243379
      GIM_Try, /*On fail goto*//*Label 4885*/ GIMT_Encode4(243421), // Rule ID 12642 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2orSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 1252:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FAMIN_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_S_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12642,
        GIR_EraseRootFromParent_Done,
      // Label 4885: @243421
      GIM_Try, /*On fail goto*//*Label 4886*/ GIMT_Encode4(243463), // Rule ID 12645 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2orSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1252:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMIN_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_D_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12645,
        GIR_EraseRootFromParent_Done,
      // Label 4886: @243463
      GIM_Try, /*On fail goto*//*Label 4887*/ GIMT_Encode4(243606), // Rule ID 5628 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[0] idx
        // No operand predicates
        // (intrinsic_wo_chain:{ *:[v16i8] } 743:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // Rm
        GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
        GIR_RootToRootCopy, /*OpIdx*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5628,
        GIR_EraseRootFromParent_Done,
      // Label 4887: @243606
      GIM_Try, /*On fail goto*//*Label 4888*/ GIMT_Encode4(243697), // Rule ID 5629 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[0] idx
        // No operand predicates
        // (intrinsic_wo_chain:{ *:[v16i8] } 744:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5629,
        GIR_EraseRootFromParent_Done,
      // Label 4888: @243697
      GIM_Try, /*On fail goto*//*Label 4889*/ GIMT_Encode4(243788), // Rule ID 5630 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[0] idx
        // No operand predicates
        // (intrinsic_wo_chain:{ *:[v16i8] } 743:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5630,
        GIR_EraseRootFromParent_Done,
      // Label 4889: @243788
      GIM_Try, /*On fail goto*//*Label 4890*/ GIMT_Encode4(243827), // Rule ID 5631 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[0] idx
        // No operand predicates
        // (intrinsic_wo_chain:{ *:[v16i8] } 744:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5631,
        GIR_EraseRootFromParent_Done,
      // Label 4890: @243827
      GIM_Try, /*On fail goto*//*Label 4891*/ GIMT_Encode4(243970), // Rule ID 5632 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[0] idx
        // No operand predicates
        // (intrinsic_wo_chain:{ *:[v8i16] } 743:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // Rm
        GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
        GIR_RootToRootCopy, /*OpIdx*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5632,
        GIR_EraseRootFromParent_Done,
      // Label 4891: @243970
      GIM_Try, /*On fail goto*//*Label 4892*/ GIMT_Encode4(244061), // Rule ID 5633 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[0] idx
        // No operand predicates
        // (intrinsic_wo_chain:{ *:[v8i16] } 744:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5633,
        GIR_EraseRootFromParent_Done,
      // Label 4892: @244061
      GIM_Try, /*On fail goto*//*Label 4893*/ GIMT_Encode4(244152), // Rule ID 5634 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[0] idx
        // No operand predicates
        // (intrinsic_wo_chain:{ *:[v8i16] } 743:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5634,
        GIR_EraseRootFromParent_Done,
      // Label 4893: @244152
      GIM_Try, /*On fail goto*//*Label 4894*/ GIMT_Encode4(244191), // Rule ID 5635 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[0] idx
        // No operand predicates
        // (intrinsic_wo_chain:{ *:[v8i16] } 744:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5635,
        GIR_EraseRootFromParent_Done,
      // Label 4894: @244191
      GIM_Try, /*On fail goto*//*Label 4895*/ GIMT_Encode4(244334), // Rule ID 5636 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[0] idx
        // No operand predicates
        // (intrinsic_wo_chain:{ *:[v8f16] } 743:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // Rm
        GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
        GIR_RootToRootCopy, /*OpIdx*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5636,
        GIR_EraseRootFromParent_Done,
      // Label 4895: @244334
      GIM_Try, /*On fail goto*//*Label 4896*/ GIMT_Encode4(244425), // Rule ID 5637 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[0] idx
        // No operand predicates
        // (intrinsic_wo_chain:{ *:[v8f16] } 744:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5637,
        GIR_EraseRootFromParent_Done,
      // Label 4896: @244425
      GIM_Try, /*On fail goto*//*Label 4897*/ GIMT_Encode4(244516), // Rule ID 5638 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[0] idx
        // No operand predicates
        // (intrinsic_wo_chain:{ *:[v8f16] } 743:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5638,
        GIR_EraseRootFromParent_Done,
      // Label 4897: @244516
      GIM_Try, /*On fail goto*//*Label 4898*/ GIMT_Encode4(244555), // Rule ID 5639 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[0] idx
        // No operand predicates
        // (intrinsic_wo_chain:{ *:[v8f16] } 744:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5639,
        GIR_EraseRootFromParent_Done,
      // Label 4898: @244555
      GIM_Try, /*On fail goto*//*Label 4899*/ GIMT_Encode4(244698), // Rule ID 5640 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[0] idx
        // No operand predicates
        // (intrinsic_wo_chain:{ *:[v8bf16] } 743:{ *:[iPTR] }, v4bf16:{ *:[v4bf16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8bf16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4bf16] }:$Rn, dsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // Rm
        GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
        GIR_RootToRootCopy, /*OpIdx*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5640,
        GIR_EraseRootFromParent_Done,
      // Label 4899: @244698
      GIM_Try, /*On fail goto*//*Label 4900*/ GIMT_Encode4(244789), // Rule ID 5641 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[0] idx
        // No operand predicates
        // (intrinsic_wo_chain:{ *:[v8bf16] } 744:{ *:[iPTR] }, v4bf16:{ *:[v4bf16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8bf16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4bf16] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5641,
        GIR_EraseRootFromParent_Done,
      // Label 4900: @244789
      GIM_Try, /*On fail goto*//*Label 4901*/ GIMT_Encode4(244880), // Rule ID 5642 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[0] idx
        // No operand predicates
        // (intrinsic_wo_chain:{ *:[v8bf16] } 743:{ *:[iPTR] }, v8bf16:{ *:[v8bf16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5642,
        GIR_EraseRootFromParent_Done,
      // Label 4901: @244880
      GIM_Try, /*On fail goto*//*Label 4902*/ GIMT_Encode4(244919), // Rule ID 5643 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[0] idx
        // No operand predicates
        // (intrinsic_wo_chain:{ *:[v8bf16] } 744:{ *:[iPTR] }, v8bf16:{ *:[v8bf16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5643,
        GIR_EraseRootFromParent_Done,
      // Label 4902: @244919
      GIM_Try, /*On fail goto*//*Label 4903*/ GIMT_Encode4(244958), // Rule ID 5644 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti4q_laneq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[0] idx
        // No operand predicates
        // (intrinsic_wo_chain:{ *:[v16i8] } 747:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT4_B:{ *:[v16i8] } VecListOne16b:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT4_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5644,
        GIR_EraseRootFromParent_Done,
      // Label 4903: @244958
      GIM_Try, /*On fail goto*//*Label 4904*/ GIMT_Encode4(245049), // Rule ID 5645 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti4q_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[0] idx
        // No operand predicates
        // (intrinsic_wo_chain:{ *:[v16i8] } 745:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT4_B:{ *:[v16i8] } VecListOne16b:{ *:[v16i8] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT4_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5645,
        GIR_EraseRootFromParent_Done,
      // Label 4904: @245049
      GIM_Reject,
    // Label 3993: @245050
    GIM_Try, /*On fail goto*//*Label 4905*/ GIMT_Encode4(252760),
      GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
      GIM_Try, /*On fail goto*//*Label 4906*/ GIMT_Encode4(245105), // Rule ID 2943 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1483:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLA_ZPZZZ_B_UNDEF:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_B_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2943,
        GIR_EraseRootFromParent_Done,
      // Label 4906: @245105
      GIM_Try, /*On fail goto*//*Label 4907*/ GIMT_Encode4(245152), // Rule ID 2945 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1483:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLA_ZPZZZ_H_UNDEF:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_H_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2945,
        GIR_EraseRootFromParent_Done,
      // Label 4907: @245152
      GIM_Try, /*On fail goto*//*Label 4908*/ GIMT_Encode4(245199), // Rule ID 2947 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1483:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLA_ZPZZZ_S_UNDEF:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_S_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2947,
        GIR_EraseRootFromParent_Done,
      // Label 4908: @245199
      GIM_Try, /*On fail goto*//*Label 4909*/ GIMT_Encode4(245246), // Rule ID 2949 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1483:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLA_ZPZZZ_D_UNDEF:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_D_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2949,
        GIR_EraseRootFromParent_Done,
      // Label 4909: @245246
      GIM_Try, /*On fail goto*//*Label 4910*/ GIMT_Encode4(245293), // Rule ID 7717 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1486:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLS_ZPZZZ_B_UNDEF:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_B_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7717,
        GIR_EraseRootFromParent_Done,
      // Label 4910: @245293
      GIM_Try, /*On fail goto*//*Label 4911*/ GIMT_Encode4(245340), // Rule ID 7719 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1486:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLS_ZPZZZ_H_UNDEF:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_H_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7719,
        GIR_EraseRootFromParent_Done,
      // Label 4911: @245340
      GIM_Try, /*On fail goto*//*Label 4912*/ GIMT_Encode4(245387), // Rule ID 7721 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1486:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLS_ZPZZZ_S_UNDEF:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_S_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7721,
        GIR_EraseRootFromParent_Done,
      // Label 4912: @245387
      GIM_Try, /*On fail goto*//*Label 4913*/ GIMT_Encode4(245434), // Rule ID 7723 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1486:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLS_ZPZZZ_D_UNDEF:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_D_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7723,
        GIR_EraseRootFromParent_Done,
      // Label 4913: @245434
      GIM_Try, /*On fail goto*//*Label 4914*/ GIMT_Encode4(245514), // Rule ID 5768 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v16i8] } 736:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, V128:{ *:[v16i8] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx2)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, V128:{ *:[v16i8] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vd
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
        GIR_RootToRootCopy, /*OpIdx*/4, // Vs
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5768,
        GIR_EraseRootFromParent_Done,
      // Label 4914: @245514
      GIM_Try, /*On fail goto*//*Label 4915*/ GIMT_Encode4(245594), // Rule ID 5769 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v8i16] } 736:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, V128:{ *:[v8i16] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx2)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, V128:{ *:[v8i16] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vd
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
        GIR_RootToRootCopy, /*OpIdx*/4, // Vs
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5769,
        GIR_EraseRootFromParent_Done,
      // Label 4915: @245594
      GIM_Try, /*On fail goto*//*Label 4916*/ GIMT_Encode4(245674), // Rule ID 5770 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v4i32] } 736:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, V128:{ *:[v4i32] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx2)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, V128:{ *:[v4i32] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vd
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
        GIR_RootToRootCopy, /*OpIdx*/4, // Vs
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5770,
        GIR_EraseRootFromParent_Done,
      // Label 4916: @245674
      GIM_Try, /*On fail goto*//*Label 4917*/ GIMT_Encode4(245754), // Rule ID 5771 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_wo_chain:{ *:[v2i64] } 736:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, V128:{ *:[v2i64] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx2)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, V128:{ *:[v2i64] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vd
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
        GIR_RootToRootCopy, /*OpIdx*/4, // Vs
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5771,
        GIR_EraseRootFromParent_Done,
      // Label 4917: @245754
      GIM_Try, /*On fail goto*//*Label 4918*/ GIMT_Encode4(245818), // Rule ID 3829 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt1a),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[0] imm
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
        // (intrinsic_wo_chain:{ *:[v4i32] } 529:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT1A:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT1A),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vd
        GIR_RootToRootCopy, /*OpIdx*/3, // Vn
        GIR_RootToRootCopy, /*OpIdx*/4, // Vm
        GIR_RootToRootCopy, /*OpIdx*/5, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3829,
        GIR_EraseRootFromParent_Done,
      // Label 4918: @245818
      GIM_Try, /*On fail goto*//*Label 4919*/ GIMT_Encode4(245882), // Rule ID 3830 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt1b),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[0] imm
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
        // (intrinsic_wo_chain:{ *:[v4i32] } 530:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT1B:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT1B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vd
        GIR_RootToRootCopy, /*OpIdx*/3, // Vn
        GIR_RootToRootCopy, /*OpIdx*/4, // Vm
        GIR_RootToRootCopy, /*OpIdx*/5, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3830,
        GIR_EraseRootFromParent_Done,
      // Label 4919: @245882
      GIM_Try, /*On fail goto*//*Label 4920*/ GIMT_Encode4(245946), // Rule ID 3831 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt2a),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[0] imm
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
        // (intrinsic_wo_chain:{ *:[v4i32] } 531:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT2A:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT2A),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vd
        GIR_RootToRootCopy, /*OpIdx*/3, // Vn
        GIR_RootToRootCopy, /*OpIdx*/4, // Vm
        GIR_RootToRootCopy, /*OpIdx*/5, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3831,
        GIR_EraseRootFromParent_Done,
      // Label 4920: @245946
      GIM_Try, /*On fail goto*//*Label 4921*/ GIMT_Encode4(246010), // Rule ID 3832 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt2b),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[0] imm
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
        // (intrinsic_wo_chain:{ *:[v4i32] } 532:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT2B:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT2B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Vd
        GIR_RootToRootCopy, /*OpIdx*/3, // Vn
        GIR_RootToRootCopy, /*OpIdx*/4, // Vm
        GIR_RootToRootCopy, /*OpIdx*/5, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3832,
        GIR_EraseRootFromParent_Done,
      // Label 4921: @246010
      GIM_Try, /*On fail goto*//*Label 4922*/ GIMT_Encode4(246062), // Rule ID 2823 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] idx
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1342:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (FMLA_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2823,
        GIR_EraseRootFromParent_Done,
      // Label 4922: @246062
      GIM_Try, /*On fail goto*//*Label 4923*/ GIMT_Encode4(246114), // Rule ID 2824 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] idx
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1342:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)  =>  (FMLA_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2824,
        GIR_EraseRootFromParent_Done,
      // Label 4923: @246114
      GIM_Try, /*On fail goto*//*Label 4924*/ GIMT_Encode4(246166), // Rule ID 2825 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] idx
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1342:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)  =>  (FMLA_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2825,
        GIR_EraseRootFromParent_Done,
      // Label 4924: @246166
      GIM_Try, /*On fail goto*//*Label 4925*/ GIMT_Encode4(246218), // Rule ID 2826 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEB16B16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] idx
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv8bf16] } 1342:{ *:[iPTR] }, nxv8bf16:{ *:[nxv8bf16] }:$op1, nxv8bf16:{ *:[nxv8bf16] }:$op2, nxv8bf16:{ *:[nxv8bf16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (BFMLA_ZZZI:{ *:[nxv8bf16] } ?:{ *:[nxv8bf16] }:$op1, ?:{ *:[nxv8bf16] }:$op2, ?:{ *:[nxv8bf16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMLA_ZZZI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2826,
        GIR_EraseRootFromParent_Done,
      // Label 4925: @246218
      GIM_Try, /*On fail goto*//*Label 4926*/ GIMT_Encode4(246270), // Rule ID 2847 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bfmlalb_lane_v2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1161:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2, nxv8bf16:{ *:[nxv8bf16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (BFMLALB_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2, ?:{ *:[nxv8bf16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMLALB_ZZZI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2847,
        GIR_EraseRootFromParent_Done,
      // Label 4926: @246270
      GIM_Try, /*On fail goto*//*Label 4927*/ GIMT_Encode4(246322), // Rule ID 2958 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1482:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (MLA_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2958,
        GIR_EraseRootFromParent_Done,
      // Label 4927: @246322
      GIM_Try, /*On fail goto*//*Label 4928*/ GIMT_Encode4(246374), // Rule ID 2959 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1482:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (MLA_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2959,
        GIR_EraseRootFromParent_Done,
      // Label 4928: @246374
      GIM_Try, /*On fail goto*//*Label 4929*/ GIMT_Encode4(246426), // Rule ID 2960 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1482:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (MLA_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2960,
        GIR_EraseRootFromParent_Done,
      // Label 4929: @246426
      GIM_Try, /*On fail goto*//*Label 4930*/ GIMT_Encode4(246478), // Rule ID 2961 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1624:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLALB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2961,
        GIR_EraseRootFromParent_Done,
      // Label 4930: @246478
      GIM_Try, /*On fail goto*//*Label 4931*/ GIMT_Encode4(246530), // Rule ID 2962 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1624:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLALB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2962,
        GIR_EraseRootFromParent_Done,
      // Label 4931: @246530
      GIM_Try, /*On fail goto*//*Label 4932*/ GIMT_Encode4(246582), // Rule ID 2965 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1590:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SDOT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2965,
        GIR_EraseRootFromParent_Done,
      // Label 4932: @246582
      GIM_Try, /*On fail goto*//*Label 4933*/ GIMT_Encode4(246634), // Rule ID 2966 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1590:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (SDOT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2966,
        GIR_EraseRootFromParent_Done,
      // Label 4933: @246634
      GIM_Try, /*On fail goto*//*Label 4934*/ GIMT_Encode4(246686), // Rule ID 3437 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bfdot_lane_v2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1159:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2, nxv8bf16:{ *:[nxv8bf16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (BFDOT_ZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2, ?:{ *:[nxv8bf16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFDOT_ZZI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3437,
        GIR_EraseRootFromParent_Done,
      // Label 4934: @246686
      GIM_Try, /*On fail goto*//*Label 4935*/ GIMT_Encode4(246738), // Rule ID 3444 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usdot_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1937:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (USDOT_ZZZI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USDOT_ZZZI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3444,
        GIR_EraseRootFromParent_Done,
      // Label 4935: @246738
      GIM_Try, /*On fail goto*//*Label 4936*/ GIMT_Encode4(246790), // Rule ID 3498 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_lane_x2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1591:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SDOT_ZZZI_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZI_HtoS),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3498,
        GIR_EraseRootFromParent_Done,
      // Label 4936: @246790
      GIM_Try, /*On fail goto*//*Label 4937*/ GIMT_Encode4(246842), // Rule ID 7787 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1837:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UDOT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7787,
        GIR_EraseRootFromParent_Done,
      // Label 4937: @246842
      GIM_Try, /*On fail goto*//*Label 4938*/ GIMT_Encode4(246894), // Rule ID 7788 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1837:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (UDOT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7788,
        GIR_EraseRootFromParent_Done,
      // Label 4938: @246894
      GIM_Try, /*On fail goto*//*Label 4939*/ GIMT_Encode4(246946), // Rule ID 8434 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] idx
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1349:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (FMLS_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8434,
        GIR_EraseRootFromParent_Done,
      // Label 4939: @246946
      GIM_Try, /*On fail goto*//*Label 4940*/ GIMT_Encode4(246998), // Rule ID 8435 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] idx
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1349:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)  =>  (FMLS_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8435,
        GIR_EraseRootFromParent_Done,
      // Label 4940: @246998
      GIM_Try, /*On fail goto*//*Label 4941*/ GIMT_Encode4(247050), // Rule ID 8436 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] idx
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1349:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)  =>  (FMLS_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8436,
        GIR_EraseRootFromParent_Done,
      // Label 4941: @247050
      GIM_Try, /*On fail goto*//*Label 4942*/ GIMT_Encode4(247102), // Rule ID 10658 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bfmlalt_lane_v2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1163:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2, nxv8bf16:{ *:[nxv8bf16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (BFMLALT_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2, ?:{ *:[nxv8bf16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMLALT_ZZZI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10658,
        GIR_EraseRootFromParent_Done,
      // Label 4942: @247102
      GIM_Try, /*On fail goto*//*Label 4943*/ GIMT_Encode4(247154), // Rule ID 11535 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sudot_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1786:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SUDOT_ZZZI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUDOT_ZZZI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11535,
        GIR_EraseRootFromParent_Done,
      // Label 4943: @247154
      GIM_Try, /*On fail goto*//*Label 4944*/ GIMT_Encode4(247206), // Rule ID 11587 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1485:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (MLS_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11587,
        GIR_EraseRootFromParent_Done,
      // Label 4944: @247206
      GIM_Try, /*On fail goto*//*Label 4945*/ GIMT_Encode4(247258), // Rule ID 11588 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1485:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (MLS_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11588,
        GIR_EraseRootFromParent_Done,
      // Label 4945: @247258
      GIM_Try, /*On fail goto*//*Label 4946*/ GIMT_Encode4(247310), // Rule ID 11589 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1485:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (MLS_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11589,
        GIR_EraseRootFromParent_Done,
      // Label 4946: @247310
      GIM_Try, /*On fail goto*//*Label 4947*/ GIMT_Encode4(247362), // Rule ID 11590 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1703:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQRDMLAH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11590,
        GIR_EraseRootFromParent_Done,
      // Label 4947: @247362
      GIM_Try, /*On fail goto*//*Label 4948*/ GIMT_Encode4(247414), // Rule ID 11591 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1703:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQRDMLAH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11591,
        GIR_EraseRootFromParent_Done,
      // Label 4948: @247414
      GIM_Try, /*On fail goto*//*Label 4949*/ GIMT_Encode4(247466), // Rule ID 11592 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1703:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (SQRDMLAH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11592,
        GIR_EraseRootFromParent_Done,
      // Label 4949: @247466
      GIM_Try, /*On fail goto*//*Label 4950*/ GIMT_Encode4(247518), // Rule ID 11593 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1705:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQRDMLSH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11593,
        GIR_EraseRootFromParent_Done,
      // Label 4950: @247518
      GIM_Try, /*On fail goto*//*Label 4951*/ GIMT_Encode4(247570), // Rule ID 11594 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1705:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQRDMLSH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11594,
        GIR_EraseRootFromParent_Done,
      // Label 4951: @247570
      GIM_Try, /*On fail goto*//*Label 4952*/ GIMT_Encode4(247622), // Rule ID 11595 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1705:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (SQRDMLSH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11595,
        GIR_EraseRootFromParent_Done,
      // Label 4952: @247622
      GIM_Try, /*On fail goto*//*Label 4953*/ GIMT_Encode4(247674), // Rule ID 11638 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1626:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLALT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11638,
        GIR_EraseRootFromParent_Done,
      // Label 4953: @247674
      GIM_Try, /*On fail goto*//*Label 4954*/ GIMT_Encode4(247726), // Rule ID 11639 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1626:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLALT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11639,
        GIR_EraseRootFromParent_Done,
      // Label 4954: @247726
      GIM_Try, /*On fail goto*//*Label 4955*/ GIMT_Encode4(247778), // Rule ID 11640 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1862:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLALB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11640,
        GIR_EraseRootFromParent_Done,
      // Label 4955: @247778
      GIM_Try, /*On fail goto*//*Label 4956*/ GIMT_Encode4(247830), // Rule ID 11641 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1862:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLALB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11641,
        GIR_EraseRootFromParent_Done,
      // Label 4956: @247830
      GIM_Try, /*On fail goto*//*Label 4957*/ GIMT_Encode4(247882), // Rule ID 11642 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1864:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLALT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11642,
        GIR_EraseRootFromParent_Done,
      // Label 4957: @247882
      GIM_Try, /*On fail goto*//*Label 4958*/ GIMT_Encode4(247934), // Rule ID 11643 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1864:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLALT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11643,
        GIR_EraseRootFromParent_Done,
      // Label 4958: @247934
      GIM_Try, /*On fail goto*//*Label 4959*/ GIMT_Encode4(247986), // Rule ID 11644 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1628:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLSLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11644,
        GIR_EraseRootFromParent_Done,
      // Label 4959: @247986
      GIM_Try, /*On fail goto*//*Label 4960*/ GIMT_Encode4(248038), // Rule ID 11645 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1628:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLSLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11645,
        GIR_EraseRootFromParent_Done,
      // Label 4960: @248038
      GIM_Try, /*On fail goto*//*Label 4961*/ GIMT_Encode4(248090), // Rule ID 11646 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1630:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLSLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11646,
        GIR_EraseRootFromParent_Done,
      // Label 4961: @248090
      GIM_Try, /*On fail goto*//*Label 4962*/ GIMT_Encode4(248142), // Rule ID 11647 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1630:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLSLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11647,
        GIR_EraseRootFromParent_Done,
      // Label 4962: @248142
      GIM_Try, /*On fail goto*//*Label 4963*/ GIMT_Encode4(248194), // Rule ID 11648 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1866:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLSLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11648,
        GIR_EraseRootFromParent_Done,
      // Label 4963: @248194
      GIM_Try, /*On fail goto*//*Label 4964*/ GIMT_Encode4(248246), // Rule ID 11649 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1866:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLSLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11649,
        GIR_EraseRootFromParent_Done,
      // Label 4964: @248246
      GIM_Try, /*On fail goto*//*Label 4965*/ GIMT_Encode4(248298), // Rule ID 11650 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1868:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLSLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11650,
        GIR_EraseRootFromParent_Done,
      // Label 4965: @248298
      GIM_Try, /*On fail goto*//*Label 4966*/ GIMT_Encode4(248350), // Rule ID 11651 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1868:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLSLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11651,
        GIR_EraseRootFromParent_Done,
      // Label 4966: @248350
      GIM_Try, /*On fail goto*//*Label 4967*/ GIMT_Encode4(248402), // Rule ID 11673 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1666:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLALB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11673,
        GIR_EraseRootFromParent_Done,
      // Label 4967: @248402
      GIM_Try, /*On fail goto*//*Label 4968*/ GIMT_Encode4(248454), // Rule ID 11674 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1666:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLALB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11674,
        GIR_EraseRootFromParent_Done,
      // Label 4968: @248454
      GIM_Try, /*On fail goto*//*Label 4969*/ GIMT_Encode4(248506), // Rule ID 11675 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1669:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLALT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11675,
        GIR_EraseRootFromParent_Done,
      // Label 4969: @248506
      GIM_Try, /*On fail goto*//*Label 4970*/ GIMT_Encode4(248558), // Rule ID 11676 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1669:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLALT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11676,
        GIR_EraseRootFromParent_Done,
      // Label 4970: @248558
      GIM_Try, /*On fail goto*//*Label 4971*/ GIMT_Encode4(248610), // Rule ID 11677 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1671:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLSLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11677,
        GIR_EraseRootFromParent_Done,
      // Label 4971: @248610
      GIM_Try, /*On fail goto*//*Label 4972*/ GIMT_Encode4(248662), // Rule ID 11678 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1671:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLSLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11678,
        GIR_EraseRootFromParent_Done,
      // Label 4972: @248662
      GIM_Try, /*On fail goto*//*Label 4973*/ GIMT_Encode4(248714), // Rule ID 11679 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1674:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLSLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11679,
        GIR_EraseRootFromParent_Done,
      // Label 4973: @248714
      GIM_Try, /*On fail goto*//*Label 4974*/ GIMT_Encode4(248766), // Rule ID 11680 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1674:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLSLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11680,
        GIR_EraseRootFromParent_Done,
      // Label 4974: @248766
      GIM_Try, /*On fail goto*//*Label 4975*/ GIMT_Encode4(248818), // Rule ID 12134 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalb_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1345:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLALB_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZI_SHH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12134,
        GIR_EraseRootFromParent_Done,
      // Label 4975: @248818
      GIM_Try, /*On fail goto*//*Label 4976*/ GIMT_Encode4(248870), // Rule ID 12135 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalt_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1347:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLALT_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZI_SHH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12135,
        GIR_EraseRootFromParent_Done,
      // Label 4976: @248870
      GIM_Try, /*On fail goto*//*Label 4977*/ GIMT_Encode4(248922), // Rule ID 12136 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslb_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1352:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLSLB_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLB_ZZZI_SHH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12136,
        GIR_EraseRootFromParent_Done,
      // Label 4977: @248922
      GIM_Try, /*On fail goto*//*Label 4978*/ GIMT_Encode4(248974), // Rule ID 12137 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslt_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1354:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLSLT_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLT_ZZZI_SHH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12137,
        GIR_EraseRootFromParent_Done,
      // Label 4978: @248974
      GIM_Try, /*On fail goto*//*Label 4979*/ GIMT_Encode4(249026), // Rule ID 12273 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdot_lane_x2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1300:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (FDOT_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12273,
        GIR_EraseRootFromParent_Done,
      // Label 4979: @249026
      GIM_Try, /*On fail goto*//*Label 4980*/ GIMT_Encode4(249078), // Rule ID 12276 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bfmlslb_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1165:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2, nxv8bf16:{ *:[nxv8bf16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (BFMLSLB_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2, ?:{ *:[nxv8bf16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMLSLB_ZZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12276,
        GIR_EraseRootFromParent_Done,
      // Label 4980: @249078
      GIM_Try, /*On fail goto*//*Label 4981*/ GIMT_Encode4(249130), // Rule ID 12277 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bfmlslt_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1167:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2, nxv8bf16:{ *:[nxv8bf16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (BFMLSLT_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2, ?:{ *:[nxv8bf16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMLSLT_ZZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12277,
        GIR_EraseRootFromParent_Done,
      // Label 4981: @249130
      GIM_Try, /*On fail goto*//*Label 4982*/ GIMT_Encode4(249182), // Rule ID 12279 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_HasSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_lane_x2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1838:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UDOT_ZZZI_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZI_HtoS),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12279,
        GIR_EraseRootFromParent_Done,
      // Label 4982: @249182
      GIM_Try, /*On fail goto*//*Label 4983*/ GIMT_Encode4(249234), // Rule ID 12434 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEB16B16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] idx
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
        // (intrinsic_wo_chain:{ *:[nxv8bf16] } 1349:{ *:[iPTR] }, nxv8bf16:{ *:[nxv8bf16] }:$op1, nxv8bf16:{ *:[nxv8bf16] }:$op2, nxv8bf16:{ *:[nxv8bf16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (BFMLS_ZZZI:{ *:[nxv8bf16] } ?:{ *:[nxv8bf16] }:$op1, ?:{ *:[nxv8bf16] }:$op2, ?:{ *:[nxv8bf16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMLS_ZZZI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // op1
        GIR_RootToRootCopy, /*OpIdx*/3, // op2
        GIR_RootToRootCopy, /*OpIdx*/4, // op3
        GIR_RootToRootCopy, /*OpIdx*/5, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12434,
        GIR_EraseRootFromParent_Done,
      // Label 4983: @249234
      GIM_Try, /*On fail goto*//*Label 4984*/ GIMT_Encode4(249281), // Rule ID 2799 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1341:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMLA_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2799,
        GIR_EraseRootFromParent_Done,
      // Label 4984: @249281
      GIM_Try, /*On fail goto*//*Label 4985*/ GIMT_Encode4(249328), // Rule ID 2802 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 1341:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FMLA_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2802,
        GIR_EraseRootFromParent_Done,
      // Label 4985: @249328
      GIM_Try, /*On fail goto*//*Label 4986*/ GIMT_Encode4(249375), // Rule ID 2805 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 1341:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FMLA_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2805,
        GIR_EraseRootFromParent_Done,
      // Label 4986: @249375
      GIM_Try, /*On fail goto*//*Label 4987*/ GIMT_Encode4(249422), // Rule ID 2808 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1341:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMLA_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2808,
        GIR_EraseRootFromParent_Done,
      // Label 4987: @249422
      GIM_Try, /*On fail goto*//*Label 4988*/ GIMT_Encode4(249469), // Rule ID 2811 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 1341:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FMLA_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2811,
        GIR_EraseRootFromParent_Done,
      // Label 4988: @249469
      GIM_Try, /*On fail goto*//*Label 4989*/ GIMT_Encode4(249516), // Rule ID 2814 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1341:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMLA_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2814,
        GIR_EraseRootFromParent_Done,
      // Label 4989: @249516
      GIM_Try, /*On fail goto*//*Label 4990*/ GIMT_Encode4(249563), // Rule ID 2817 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEB16B16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8bf16] } 1341:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2, nxv8bf16:{ *:[nxv8bf16] }:$Op3, nxv8bf16:{ *:[nxv8bf16] }:$Op4)  =>  (BFMLA_ZPmZZ:{ *:[nxv8bf16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2, ?:{ *:[nxv8bf16] }:$Op3, ?:{ *:[nxv8bf16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMLA_ZPmZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2817,
        GIR_EraseRootFromParent_Done,
      // Label 4990: @249563
      GIM_Try, /*On fail goto*//*Label 4991*/ GIMT_Encode4(249610), // Rule ID 2820 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmad),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1304:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMAD_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAD_ZPmZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2820,
        GIR_EraseRootFromParent_Done,
      // Label 4991: @249610
      GIM_Try, /*On fail goto*//*Label 4992*/ GIMT_Encode4(249657), // Rule ID 2821 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmad),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1304:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMAD_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAD_ZPmZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2821,
        GIR_EraseRootFromParent_Done,
      // Label 4992: @249657
      GIM_Try, /*On fail goto*//*Label 4993*/ GIMT_Encode4(249704), // Rule ID 2822 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmad),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1304:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMAD_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAD_ZPmZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2822,
        GIR_EraseRootFromParent_Done,
      // Label 4993: @249704
      GIM_Try, /*On fail goto*//*Label 4994*/ GIMT_Encode4(249751), // Rule ID 2923 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1479:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MAD_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2923,
        GIR_EraseRootFromParent_Done,
      // Label 4994: @249751
      GIM_Try, /*On fail goto*//*Label 4995*/ GIMT_Encode4(249798), // Rule ID 2926 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1479:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MAD_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2926,
        GIR_EraseRootFromParent_Done,
      // Label 4995: @249798
      GIM_Try, /*On fail goto*//*Label 4996*/ GIMT_Encode4(249845), // Rule ID 2929 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1479:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MAD_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2929,
        GIR_EraseRootFromParent_Done,
      // Label 4996: @249845
      GIM_Try, /*On fail goto*//*Label 4997*/ GIMT_Encode4(249892), // Rule ID 2932 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1479:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MAD_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2932,
        GIR_EraseRootFromParent_Done,
      // Label 4997: @249892
      GIM_Try, /*On fail goto*//*Label 4998*/ GIMT_Encode4(249939), // Rule ID 2935 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1481:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLA_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2935,
        GIR_EraseRootFromParent_Done,
      // Label 4998: @249939
      GIM_Try, /*On fail goto*//*Label 4999*/ GIMT_Encode4(249986), // Rule ID 2937 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1481:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLA_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2937,
        GIR_EraseRootFromParent_Done,
      // Label 4999: @249986
      GIM_Try, /*On fail goto*//*Label 5000*/ GIMT_Encode4(250033), // Rule ID 2939 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1481:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLA_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2939,
        GIR_EraseRootFromParent_Done,
      // Label 5000: @250033
      GIM_Try, /*On fail goto*//*Label 5001*/ GIMT_Encode4(250080), // Rule ID 2941 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1481:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLA_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2941,
        GIR_EraseRootFromParent_Done,
      // Label 5001: @250080
      GIM_Try, /*On fail goto*//*Label 5002*/ GIMT_Encode4(250127), // Rule ID 7697 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1487:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MSB_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7697,
        GIR_EraseRootFromParent_Done,
      // Label 5002: @250127
      GIM_Try, /*On fail goto*//*Label 5003*/ GIMT_Encode4(250174), // Rule ID 7700 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1487:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MSB_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7700,
        GIR_EraseRootFromParent_Done,
      // Label 5003: @250174
      GIM_Try, /*On fail goto*//*Label 5004*/ GIMT_Encode4(250221), // Rule ID 7703 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1487:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MSB_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7703,
        GIR_EraseRootFromParent_Done,
      // Label 5004: @250221
      GIM_Try, /*On fail goto*//*Label 5005*/ GIMT_Encode4(250268), // Rule ID 7706 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1487:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MSB_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7706,
        GIR_EraseRootFromParent_Done,
      // Label 5005: @250268
      GIM_Try, /*On fail goto*//*Label 5006*/ GIMT_Encode4(250315), // Rule ID 7709 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv16i8] } 1484:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLS_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7709,
        GIR_EraseRootFromParent_Done,
      // Label 5006: @250315
      GIM_Try, /*On fail goto*//*Label 5007*/ GIMT_Encode4(250362), // Rule ID 7711 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8i16] } 1484:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLS_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7711,
        GIR_EraseRootFromParent_Done,
      // Label 5007: @250362
      GIM_Try, /*On fail goto*//*Label 5008*/ GIMT_Encode4(250409), // Rule ID 7713 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4i32] } 1484:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLS_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7713,
        GIR_EraseRootFromParent_Done,
      // Label 5008: @250409
      GIM_Try, /*On fail goto*//*Label 5009*/ GIMT_Encode4(250456), // Rule ID 7715 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2i64] } 1484:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLS_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7715,
        GIR_EraseRootFromParent_Done,
      // Label 5009: @250456
      GIM_Try, /*On fail goto*//*Label 5010*/ GIMT_Encode4(250503), // Rule ID 8347 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1348:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMLS_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8347,
        GIR_EraseRootFromParent_Done,
      // Label 5010: @250503
      GIM_Try, /*On fail goto*//*Label 5011*/ GIMT_Encode4(250550), // Rule ID 8350 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 1348:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FMLS_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8350,
        GIR_EraseRootFromParent_Done,
      // Label 5011: @250550
      GIM_Try, /*On fail goto*//*Label 5012*/ GIMT_Encode4(250597), // Rule ID 8353 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 1348:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FMLS_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8353,
        GIR_EraseRootFromParent_Done,
      // Label 5012: @250597
      GIM_Try, /*On fail goto*//*Label 5013*/ GIMT_Encode4(250644), // Rule ID 8356 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1348:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMLS_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8356,
        GIR_EraseRootFromParent_Done,
      // Label 5013: @250644
      GIM_Try, /*On fail goto*//*Label 5014*/ GIMT_Encode4(250691), // Rule ID 8359 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 1348:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FMLS_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8359,
        GIR_EraseRootFromParent_Done,
      // Label 5014: @250691
      GIM_Try, /*On fail goto*//*Label 5015*/ GIMT_Encode4(250738), // Rule ID 8362 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1348:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMLS_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8362,
        GIR_EraseRootFromParent_Done,
      // Label 5015: @250738
      GIM_Try, /*On fail goto*//*Label 5016*/ GIMT_Encode4(250785), // Rule ID 8365 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1364:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLA_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8365,
        GIR_EraseRootFromParent_Done,
      // Label 5016: @250785
      GIM_Try, /*On fail goto*//*Label 5017*/ GIMT_Encode4(250832), // Rule ID 8366 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 1364:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLA_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8366,
        GIR_EraseRootFromParent_Done,
      // Label 5017: @250832
      GIM_Try, /*On fail goto*//*Label 5018*/ GIMT_Encode4(250879), // Rule ID 8367 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 1364:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLA_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8367,
        GIR_EraseRootFromParent_Done,
      // Label 5018: @250879
      GIM_Try, /*On fail goto*//*Label 5019*/ GIMT_Encode4(250926), // Rule ID 8368 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1364:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLA_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8368,
        GIR_EraseRootFromParent_Done,
      // Label 5019: @250926
      GIM_Try, /*On fail goto*//*Label 5020*/ GIMT_Encode4(250973), // Rule ID 8369 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 1364:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLA_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8369,
        GIR_EraseRootFromParent_Done,
      // Label 5020: @250973
      GIM_Try, /*On fail goto*//*Label 5021*/ GIMT_Encode4(251020), // Rule ID 8370 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1364:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLA_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8370,
        GIR_EraseRootFromParent_Done,
      // Label 5021: @251020
      GIM_Try, /*On fail goto*//*Label 5022*/ GIMT_Encode4(251067), // Rule ID 8371 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1366:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLS_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8371,
        GIR_EraseRootFromParent_Done,
      // Label 5022: @251067
      GIM_Try, /*On fail goto*//*Label 5023*/ GIMT_Encode4(251114), // Rule ID 8372 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 1366:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLS_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8372,
        GIR_EraseRootFromParent_Done,
      // Label 5023: @251114
      GIM_Try, /*On fail goto*//*Label 5024*/ GIMT_Encode4(251161), // Rule ID 8373 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 1366:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLS_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8373,
        GIR_EraseRootFromParent_Done,
      // Label 5024: @251161
      GIM_Try, /*On fail goto*//*Label 5025*/ GIMT_Encode4(251208), // Rule ID 8374 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1366:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLS_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8374,
        GIR_EraseRootFromParent_Done,
      // Label 5025: @251208
      GIM_Try, /*On fail goto*//*Label 5026*/ GIMT_Encode4(251255), // Rule ID 8375 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 1366:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLS_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8375,
        GIR_EraseRootFromParent_Done,
      // Label 5026: @251255
      GIM_Try, /*On fail goto*//*Label 5027*/ GIMT_Encode4(251302), // Rule ID 8376 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1366:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLS_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8376,
        GIR_EraseRootFromParent_Done,
      // Label 5027: @251302
      GIM_Try, /*On fail goto*//*Label 5028*/ GIMT_Encode4(251349), // Rule ID 8377 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmsb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1356:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMSB_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSB_ZPmZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8377,
        GIR_EraseRootFromParent_Done,
      // Label 5028: @251349
      GIM_Try, /*On fail goto*//*Label 5029*/ GIMT_Encode4(251396), // Rule ID 8378 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmsb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1356:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMSB_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSB_ZPmZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8378,
        GIR_EraseRootFromParent_Done,
      // Label 5029: @251396
      GIM_Try, /*On fail goto*//*Label 5030*/ GIMT_Encode4(251443), // Rule ID 8379 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmsb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1356:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMSB_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSB_ZPmZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8379,
        GIR_EraseRootFromParent_Done,
      // Label 5030: @251443
      GIM_Try, /*On fail goto*//*Label 5031*/ GIMT_Encode4(251490), // Rule ID 8380 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmad),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1363:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMAD_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMAD_ZPmZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8380,
        GIR_EraseRootFromParent_Done,
      // Label 5031: @251490
      GIM_Try, /*On fail goto*//*Label 5032*/ GIMT_Encode4(251537), // Rule ID 8381 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmad),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1363:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMAD_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMAD_ZPmZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8381,
        GIR_EraseRootFromParent_Done,
      // Label 5032: @251537
      GIM_Try, /*On fail goto*//*Label 5033*/ GIMT_Encode4(251584), // Rule ID 8382 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmad),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1363:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMAD_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMAD_ZPmZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8382,
        GIR_EraseRootFromParent_Done,
      // Label 5033: @251584
      GIM_Try, /*On fail goto*//*Label 5034*/ GIMT_Encode4(251631), // Rule ID 8383 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmsb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1368:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMSB_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSB_ZPmZZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8383,
        GIR_EraseRootFromParent_Done,
      // Label 5034: @251631
      GIM_Try, /*On fail goto*//*Label 5035*/ GIMT_Encode4(251678), // Rule ID 8384 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmsb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1368:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMSB_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSB_ZPmZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8384,
        GIR_EraseRootFromParent_Done,
      // Label 5035: @251678
      GIM_Try, /*On fail goto*//*Label 5036*/ GIMT_Encode4(251725), // Rule ID 8385 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmsb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1368:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMSB_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSB_ZPmZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8385,
        GIR_EraseRootFromParent_Done,
      // Label 5036: @251725
      GIM_Try, /*On fail goto*//*Label 5037*/ GIMT_Encode4(251772), // Rule ID 8386 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1350:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMLS_ZPZZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_H_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8386,
        GIR_EraseRootFromParent_Done,
      // Label 5037: @251772
      GIM_Try, /*On fail goto*//*Label 5038*/ GIMT_Encode4(251819), // Rule ID 8389 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 1350:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FMLS_ZPZZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_H_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8389,
        GIR_EraseRootFromParent_Done,
      // Label 5038: @251819
      GIM_Try, /*On fail goto*//*Label 5039*/ GIMT_Encode4(251866), // Rule ID 8392 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 1350:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FMLS_ZPZZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_H_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8392,
        GIR_EraseRootFromParent_Done,
      // Label 5039: @251866
      GIM_Try, /*On fail goto*//*Label 5040*/ GIMT_Encode4(251913), // Rule ID 8395 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1350:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMLS_ZPZZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_S_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8395,
        GIR_EraseRootFromParent_Done,
      // Label 5040: @251913
      GIM_Try, /*On fail goto*//*Label 5041*/ GIMT_Encode4(251960), // Rule ID 8398 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 1350:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FMLS_ZPZZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_S_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8398,
        GIR_EraseRootFromParent_Done,
      // Label 5041: @251960
      GIM_Try, /*On fail goto*//*Label 5042*/ GIMT_Encode4(252007), // Rule ID 8401 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1350:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMLS_ZPZZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_D_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8401,
        GIR_EraseRootFromParent_Done,
      // Label 5042: @252007
      GIM_Try, /*On fail goto*//*Label 5043*/ GIMT_Encode4(252054), // Rule ID 8404 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1365:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLA_ZPZZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_H_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8404,
        GIR_EraseRootFromParent_Done,
      // Label 5043: @252054
      GIM_Try, /*On fail goto*//*Label 5044*/ GIMT_Encode4(252101), // Rule ID 8407 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 1365:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLA_ZPZZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_H_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8407,
        GIR_EraseRootFromParent_Done,
      // Label 5044: @252101
      GIM_Try, /*On fail goto*//*Label 5045*/ GIMT_Encode4(252148), // Rule ID 8410 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 1365:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLA_ZPZZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_H_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8410,
        GIR_EraseRootFromParent_Done,
      // Label 5045: @252148
      GIM_Try, /*On fail goto*//*Label 5046*/ GIMT_Encode4(252195), // Rule ID 8413 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1365:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLA_ZPZZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_S_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8413,
        GIR_EraseRootFromParent_Done,
      // Label 5046: @252195
      GIM_Try, /*On fail goto*//*Label 5047*/ GIMT_Encode4(252242), // Rule ID 8416 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 1365:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLA_ZPZZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_S_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8416,
        GIR_EraseRootFromParent_Done,
      // Label 5047: @252242
      GIM_Try, /*On fail goto*//*Label 5048*/ GIMT_Encode4(252289), // Rule ID 8419 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1365:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLA_ZPZZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_D_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8419,
        GIR_EraseRootFromParent_Done,
      // Label 5048: @252289
      GIM_Try, /*On fail goto*//*Label 5049*/ GIMT_Encode4(252336), // Rule ID 8422 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8f16] } 1367:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLS_ZPZZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_H_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8422,
        GIR_EraseRootFromParent_Done,
      // Label 5049: @252336
      GIM_Try, /*On fail goto*//*Label 5050*/ GIMT_Encode4(252383), // Rule ID 8424 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f16] } 1367:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLS_ZPZZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_H_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8424,
        GIR_EraseRootFromParent_Done,
      // Label 5050: @252383
      GIM_Try, /*On fail goto*//*Label 5051*/ GIMT_Encode4(252430), // Rule ID 8426 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f16] } 1367:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLS_ZPZZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_H_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8426,
        GIR_EraseRootFromParent_Done,
      // Label 5051: @252430
      GIM_Try, /*On fail goto*//*Label 5052*/ GIMT_Encode4(252477), // Rule ID 8428 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4f32] } 1367:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLS_ZPZZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_S_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8428,
        GIR_EraseRootFromParent_Done,
      // Label 5052: @252477
      GIM_Try, /*On fail goto*//*Label 5053*/ GIMT_Encode4(252524), // Rule ID 8430 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f32] } 1367:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLS_ZPZZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_S_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8430,
        GIR_EraseRootFromParent_Done,
      // Label 5053: @252524
      GIM_Try, /*On fail goto*//*Label 5054*/ GIMT_Encode4(252571), // Rule ID 8432 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2f64] } 1367:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLS_ZPZZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_D_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8432,
        GIR_EraseRootFromParent_Done,
      // Label 5054: @252571
      GIM_Try, /*On fail goto*//*Label 5055*/ GIMT_Encode4(252618), // Rule ID 12422 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEB16B16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8bf16] } 1348:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2, nxv8bf16:{ *:[nxv8bf16] }:$Op3, nxv8bf16:{ *:[nxv8bf16] }:$Op4)  =>  (BFMLS_ZPmZZ:{ *:[nxv8bf16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2, ?:{ *:[nxv8bf16] }:$Op3, ?:{ *:[nxv8bf16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMLS_ZPmZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12422,
        GIR_EraseRootFromParent_Done,
      // Label 5055: @252618
      GIM_Try, /*On fail goto*//*Label 5056*/ GIMT_Encode4(252665), // Rule ID 12425 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEB16B16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv8bf16] } 1350:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2, nxv8bf16:{ *:[nxv8bf16] }:$Op3, nxv8bf16:{ *:[nxv8bf16] }:$Op4)  =>  (BFMLS_ZPZZZ_UNDEF:{ *:[nxv8bf16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2, ?:{ *:[nxv8bf16] }:$Op3, ?:{ *:[nxv8bf16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMLS_ZPZZZ_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12425,
        GIR_EraseRootFromParent_Done,
      // Label 5056: @252665
      GIM_Try, /*On fail goto*//*Label 5057*/ GIMT_Encode4(252712), // Rule ID 12428 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEB16B16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv4bf16] } 1350:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4bf16:{ *:[nxv4bf16] }:$Op2, nxv4bf16:{ *:[nxv4bf16] }:$Op3, nxv4bf16:{ *:[nxv4bf16] }:$Op4)  =>  (BFMLS_ZPZZZ_UNDEF:{ *:[nxv4bf16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4bf16] }:$Op2, ?:{ *:[nxv4bf16] }:$Op3, ?:{ *:[nxv4bf16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMLS_ZPZZZ_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12428,
        GIR_EraseRootFromParent_Done,
      // Label 5057: @252712
      GIM_Try, /*On fail goto*//*Label 5058*/ GIMT_Encode4(252759), // Rule ID 12431 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEB16B16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_wo_chain:{ *:[nxv2bf16] } 1350:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2bf16:{ *:[nxv2bf16] }:$Op2, nxv2bf16:{ *:[nxv2bf16] }:$Op3, nxv2bf16:{ *:[nxv2bf16] }:$Op4)  =>  (BFMLS_ZPZZZ_UNDEF:{ *:[nxv2bf16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2bf16] }:$Op2, ?:{ *:[nxv2bf16] }:$Op3, ?:{ *:[nxv2bf16] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMLS_ZPZZZ_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12431,
        GIR_EraseRootFromParent_Done,
      // Label 5058: @252759
      GIM_Reject,
    // Label 4905: @252760
    GIM_Reject,
    // Label 33: @252761
    GIM_Try, /*On fail goto*//*Label 5059*/ GIMT_Encode4(252839),
      GIM_CheckNumOperands, /*MI*/0, /*Expected*/1,
      GIM_Try, /*On fail goto*//*Label 5060*/ GIMT_Encode4(252791), // Rule ID 90 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_tcommit),
        // (intrinsic_void 2046:{ *:[iPTR] })  =>  (TCOMMIT)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TCOMMIT),
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 90,
        GIR_EraseRootFromParent_Done,
      // Label 5060: @252791
      GIM_Try, /*On fail goto*//*Label 5061*/ GIMT_Encode4(252816), // Rule ID 2363 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_setffr),
        // (intrinsic_void 1596:{ *:[iPTR] })  =>  (SETFFR:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SETFFR),
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FFR*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2363,
        GIR_EraseRootFromParent_Done,
      // Label 5061: @252816
      GIM_Try, /*On fail goto*//*Label 5062*/ GIMT_Encode4(252838), // Rule ID 7321 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_clrex),
        // (intrinsic_void 492:{ *:[iPTR] })  =>  (CLREX 15:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLREX),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7321,
        GIR_EraseRootFromParent_Done,
      // Label 5062: @252838
      GIM_Reject,
    // Label 5059: @252839
    GIM_Try, /*On fail goto*//*Label 5063*/ GIMT_Encode4(253439),
      GIM_CheckNumOperands, /*MI*/0, /*Expected*/2,
      GIM_Try, /*On fail goto*//*Label 5064*/ GIMT_Encode4(252879), // Rule ID 91 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_tcancel),
        // MIs[0] imm
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm64_0_65535),
        // (intrinsic_void 2045:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_timm64_0_65535>>:$imm)  =>  (TCANCEL (timm:{ *:[i64] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TCANCEL),
        GIR_RootToRootCopy, /*OpIdx*/1, // imm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 91,
        GIR_EraseRootFromParent_Done,
      // Label 5064: @252879
      GIM_Try, /*On fail goto*//*Label 5065*/ GIMT_Encode4(252904), // Rule ID 239 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_break),
        // MIs[0] imm
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_65535),
        // (intrinsic_void 490:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_65535>>:$imm)  =>  (BRK (timm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
        GIR_RootToRootCopy, /*OpIdx*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 239,
        GIR_EraseRootFromParent_Done,
      // Label 5065: @252904
      GIM_Try, /*On fail goto*//*Label 5066*/ GIMT_Encode4(252929), // Rule ID 240 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_hlt),
        // MIs[0] imm
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_65535),
        // (intrinsic_void 549:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_65535>>:$imm)  =>  (HLT (timm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HLT),
        GIR_RootToRootCopy, /*OpIdx*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 240,
        GIR_EraseRootFromParent_Done,
      // Label 5066: @252929
      GIM_Try, /*On fail goto*//*Label 5067*/ GIMT_Encode4(252961), // Rule ID 3614 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEandIsNonStreamingSafe),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_zero),
        // MIs[0] imm
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_255),
        // (intrinsic_void 1102:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_255>>:$imm)  =>  (ZERO_M_PSEUDO (timm:{ *:[i32] })<<P:Predicate_timm32_0_255>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZERO_M_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // imm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3614,
        GIR_EraseRootFromParent_Done,
      // Label 5067: @252961
      GIM_Try, /*On fail goto*//*Label 5068*/ GIMT_Encode4(253001), // Rule ID 16 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_hint),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_127),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_void 548:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_127>>:$imm)  =>  (HINT (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HINT),
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16,
        GIR_EraseRootFromParent_Done,
      // Label 5068: @253001
      GIM_Try, /*On fail goto*//*Label 5069*/ GIMT_Encode4(253041), // Rule ID 17 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_dmb),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_void 536:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$CRm)  =>  (DMB (imm:{ *:[i32] }):$CRm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DMB),
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // CRm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 17,
        GIR_EraseRootFromParent_Done,
      // Label 5069: @253041
      GIM_Try, /*On fail goto*//*Label 5070*/ GIMT_Encode4(253081), // Rule ID 18 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_dsb),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_void 537:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$CRm)  =>  (DSB (imm:{ *:[i32] }):$CRm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DSB),
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // CRm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 18,
        GIR_EraseRootFromParent_Done,
      // Label 5070: @253081
      GIM_Try, /*On fail goto*//*Label 5071*/ GIMT_Encode4(253121), // Rule ID 19 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_isb),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_void 552:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$CRm)  =>  (ISB (imm:{ *:[i32] }):$CRm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ISB),
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // CRm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 19,
        GIR_EraseRootFromParent_Done,
      // Label 5071: @253121
      GIM_Try, /*On fail goto*//*Label 5072*/ GIMT_Encode4(253145), // Rule ID 84 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_get_fpcr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (intrinsic_w_chain:{ *:[i64] } 545:{ *:[iPTR] })  =>  (MRS_FPCR:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS_FPCR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 84,
        GIR_EraseRootFromParent_Done,
      // Label 5072: @253145
      GIM_Try, /*On fail goto*//*Label 5073*/ GIMT_Encode4(253169), // Rule ID 86 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_get_fpsr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (intrinsic_w_chain:{ *:[i64] } 546:{ *:[iPTR] })  =>  (MRS_FPSR:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS_FPSR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 86,
        GIR_EraseRootFromParent_Done,
      // Label 5073: @253169
      GIM_Try, /*On fail goto*//*Label 5074*/ GIMT_Encode4(253200), // Rule ID 89 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_tstart),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (intrinsic_w_chain:{ *:[i64] } 2047:{ *:[iPTR] })  =>  (TSTART:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TSTART),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 89,
        GIR_EraseRootFromParent_Done,
      // Label 5074: @253200
      GIM_Try, /*On fail goto*//*Label 5075*/ GIMT_Encode4(253227), // Rule ID 92 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ttest),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (intrinsic_w_chain:{ *:[i64] } 2048:{ *:[iPTR] })  =>  (TTEST:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TTEST),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 92,
        GIR_EraseRootFromParent_Done,
      // Label 5075: @253227
      GIM_Try, /*On fail goto*//*Label 5076*/ GIMT_Encode4(253258), // Rule ID 2362 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rdffr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_w_chain:{ *:[nxv16i1] } 1546:{ *:[iPTR] })  =>  (RDFFR_P:{ *:[nxv16i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RDFFR_P),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2362,
        GIR_EraseRootFromParent_Done,
      // Label 5076: @253258
      GIM_Try, /*On fail goto*//*Label 5077*/ GIMT_Encode4(253298), // Rule ID 12813 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEandIsNonStreamingSafe),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sme_get_tpidr2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (intrinsic_w_chain:{ *:[i64] } 856:{ *:[iPTR] })  =>  (MRS:{ *:[i64] }:{ *:[i32] } 56965:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(56965),
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12813,
        GIR_EraseRootFromParent_Done,
      // Label 5077: @253298
      GIM_Try, /*On fail goto*//*Label 5078*/ GIMT_Encode4(253332), // Rule ID 2364 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_wrffr),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_void 2026:{ *:[iPTR] }, PPR8:{ *:[nxv16i1] }:$Pn)  =>  (WRFFR:{ *:[i64] } PPR8:{ *:[nxv16i1] }:$Pn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WRFFR),
        GIR_RootToRootCopy, /*OpIdx*/1, // Pn
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FFR*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2364,
        GIR_EraseRootFromParent_Done,
      // Label 5078: @253332
      GIM_Try, /*On fail goto*//*Label 5079*/ GIMT_Encode4(253355), // Rule ID 85 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_set_fpcr),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
        // (intrinsic_void 755:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR_FPCR i64:{ *:[i64] }:$val)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR_FPCR),
        GIR_RootToRootCopy, /*OpIdx*/1, // val
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FPCR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 85,
        GIR_EraseRootFromParent_Done,
      // Label 5079: @253355
      GIM_Try, /*On fail goto*//*Label 5080*/ GIMT_Encode4(253378), // Rule ID 87 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_set_fpsr),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
        // (intrinsic_void 757:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR_FPSR i64:{ *:[i64] }:$val)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR_FPSR),
        GIR_RootToRootCopy, /*OpIdx*/1, // val
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FPSR*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 87,
        GIR_EraseRootFromParent_Done,
      // Label 5080: @253378
      GIM_Try, /*On fail goto*//*Label 5081*/ GIMT_Encode4(253405), // Rule ID 88 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_set_fpmr),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
        // (intrinsic_void 756:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR_FPMR i64:{ *:[i64] }:$val)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR_FPMR),
        GIR_RootToRootCopy, /*OpIdx*/1, // val
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FPMR*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 88,
        GIR_EraseRootFromParent_Done,
      // Label 5081: @253405
      GIM_Try, /*On fail goto*//*Label 5082*/ GIMT_Encode4(253438), // Rule ID 12812 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEandIsNonStreamingSafe),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_set_tpidr2),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
        // (intrinsic_void 914:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR 56965:{ *:[i32] }, GPR64:{ *:[i64] }:$val)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR),
        GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(56965),
        GIR_RootToRootCopy, /*OpIdx*/1, // val
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12812,
        GIR_EraseRootFromParent_Done,
      // Label 5082: @253438
      GIM_Reject,
    // Label 5063: @253439
    GIM_Try, /*On fail goto*//*Label 5083*/ GIMT_Encode4(254394),
      GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
      GIM_Try, /*On fail goto*//*Label 5084*/ GIMT_Encode4(253523), // Rule ID 7287 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_1),
        // (intrinsic_w_chain:{ *:[i64] } 558:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRB),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        // GIR_Coverage, 7287,
        GIR_EraseRootFromParent_Done,
      // Label 5084: @253523
      GIM_Try, /*On fail goto*//*Label 5085*/ GIMT_Encode4(253599), // Rule ID 7288 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_2),
        // (intrinsic_w_chain:{ *:[i64] } 558:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_2>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRH),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        // GIR_Coverage, 7288,
        GIR_EraseRootFromParent_Done,
      // Label 5085: @253599
      GIM_Try, /*On fail goto*//*Label 5086*/ GIMT_Encode4(253675), // Rule ID 7289 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_4),
        // (intrinsic_w_chain:{ *:[i64] } 558:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_4>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        // GIR_Coverage, 7289,
        GIR_EraseRootFromParent_Done,
      // Label 5086: @253675
      GIM_Try, /*On fail goto*//*Label 5087*/ GIMT_Encode4(253717), // Rule ID 7290 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_8),
        // (intrinsic_w_chain:{ *:[i64] } 558:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_8>>  =>  (LDXRX:{ *:[i64] } GPR64sp:{ *:[i64] }:$addr)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDXRX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // addr
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7290,
        GIR_EraseRootFromParent_Done,
      // Label 5087: @253717
      GIM_Try, /*On fail goto*//*Label 5088*/ GIMT_Encode4(253793), // Rule ID 7294 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_1),
        // (intrinsic_w_chain:{ *:[i64] } 555:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRB),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        // GIR_Coverage, 7294,
        GIR_EraseRootFromParent_Done,
      // Label 5088: @253793
      GIM_Try, /*On fail goto*//*Label 5089*/ GIMT_Encode4(253869), // Rule ID 7295 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_2),
        // (intrinsic_w_chain:{ *:[i64] } 555:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_2>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRH),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        // GIR_Coverage, 7295,
        GIR_EraseRootFromParent_Done,
      // Label 5089: @253869
      GIM_Try, /*On fail goto*//*Label 5090*/ GIMT_Encode4(253945), // Rule ID 7296 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_4),
        // (intrinsic_w_chain:{ *:[i64] } 555:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_4>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        // GIR_Coverage, 7296,
        GIR_EraseRootFromParent_Done,
      // Label 5090: @253945
      GIM_Try, /*On fail goto*//*Label 5091*/ GIMT_Encode4(253987), // Rule ID 7297 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_8),
        // (intrinsic_w_chain:{ *:[i64] } 555:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_8>>  =>  (LDAXRX:{ *:[i64] } GPR64sp:{ *:[i64] }:$addr)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAXRX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // addr
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7297,
        GIR_EraseRootFromParent_Done,
      // Label 5091: @253987
      GIM_Try, /*On fail goto*//*Label 5092*/ GIMT_Encode4(254027), // Rule ID 20 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGCS),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_gcspopm),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (intrinsic_w_chain:{ *:[i64] } 543:{ *:[iPTR] }, GPR64:{ *:[i64] }:$src)  =>  (GCSPOPM:{ *:[i64] } GPR64:{ *:[i64] }:$src)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::GCSPOPM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20,
        GIR_EraseRootFromParent_Done,
      // Label 5092: @254027
      GIM_Try, /*On fail goto*//*Label 5093*/ GIMT_Encode4(254067), // Rule ID 2361 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rdffr_z),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
        // (intrinsic_w_chain:{ *:[nxv16i1] } 1547:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (RDFFR_PPz:{ *:[nxv16i1] } PPRAny:{ *:[nxv16i1] }:$Pg)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RDFFR_PPz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2361,
        GIR_EraseRootFromParent_Done,
      // Label 5093: @254067
      GIM_Try, /*On fail goto*//*Label 5094*/ GIMT_Encode4(254103), // Rule ID 3575 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2orSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvt1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_w_chain:{ *:[nxv8f16] } 1371:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F1CVT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVT_ZZ_BtoH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3575,
        GIR_EraseRootFromParent_Done,
      // Label 5094: @254103
      GIM_Try, /*On fail goto*//*Label 5095*/ GIMT_Encode4(254141), // Rule ID 3981 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_irg_sp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        // (intrinsic_w_chain:{ *:[i64] } 551:{ *:[iPTR] }, i64:{ *:[i64] }:$Rm)  =>  (IRGstack:{ *:[i64] } SP:{ *:[i64] }, i64:{ *:[i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::IRGstack),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::SP), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3981,
        GIR_EraseRootFromParent_Done,
      // Label 5095: @254141
      GIM_Try, /*On fail goto*//*Label 5096*/ GIMT_Encode4(254177), // Rule ID 12597 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2orSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvt2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_w_chain:{ *:[nxv8f16] } 1373:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F2CVT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVT_ZZ_BtoH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12597,
        GIR_EraseRootFromParent_Done,
      // Label 5096: @254177
      GIM_Try, /*On fail goto*//*Label 5097*/ GIMT_Encode4(254213), // Rule ID 12598 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2orSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvt1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_w_chain:{ *:[nxv8bf16] } 1371:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BF1CVT_ZZ_BtoH:{ *:[nxv8bf16] } ?:{ *:[nxv16i8] }:$Op1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BF1CVT_ZZ_BtoH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12598,
        GIR_EraseRootFromParent_Done,
      // Label 5097: @254213
      GIM_Try, /*On fail goto*//*Label 5098*/ GIMT_Encode4(254249), // Rule ID 12599 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2orSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvt2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_w_chain:{ *:[nxv8bf16] } 1373:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BF2CVT_ZZ_BtoH:{ *:[nxv8bf16] } ?:{ *:[nxv16i8] }:$Op1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BF2CVT_ZZ_BtoH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12599,
        GIR_EraseRootFromParent_Done,
      // Label 5098: @254249
      GIM_Try, /*On fail goto*//*Label 5099*/ GIMT_Encode4(254285), // Rule ID 12600 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2orSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvtlt1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_w_chain:{ *:[nxv8f16] } 1377:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F1CVTLT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVTLT_ZZ_BtoH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12600,
        GIR_EraseRootFromParent_Done,
      // Label 5099: @254285
      GIM_Try, /*On fail goto*//*Label 5100*/ GIMT_Encode4(254321), // Rule ID 12601 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2orSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvtlt2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_w_chain:{ *:[nxv8f16] } 1378:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F2CVTLT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVTLT_ZZ_BtoH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12601,
        GIR_EraseRootFromParent_Done,
      // Label 5100: @254321
      GIM_Try, /*On fail goto*//*Label 5101*/ GIMT_Encode4(254357), // Rule ID 12602 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2orSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvtlt1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_w_chain:{ *:[nxv8bf16] } 1377:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BF1CVTLT_ZZ_BtoH:{ *:[nxv8bf16] } ?:{ *:[nxv16i8] }:$Op1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BF1CVTLT_ZZ_BtoH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12602,
        GIR_EraseRootFromParent_Done,
      // Label 5101: @254357
      GIM_Try, /*On fail goto*//*Label 5102*/ GIMT_Encode4(254393), // Rule ID 12603 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2orSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvtlt2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_w_chain:{ *:[nxv8bf16] } 1378:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BF2CVTLT_ZZ_BtoH:{ *:[nxv8bf16] } ?:{ *:[nxv16i8] }:$Op1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BF2CVTLT_ZZ_BtoH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12603,
        GIR_EraseRootFromParent_Done,
      // Label 5102: @254393
      GIM_Reject,
    // Label 5083: @254394
    GIM_Try, /*On fail goto*//*Label 5103*/ GIMT_Encode4(257155),
      GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
      GIM_Try, /*On fail goto*//*Label 5104*/ GIMT_Encode4(254499), // Rule ID 7305 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(255),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_w_chain:{ *:[i32] } 1121:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 255:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_1>>  =>  (STXRB:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
        GIR_RootToRootCopy, /*OpIdx*/3, // addr
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7305,
        GIR_EraseRootFromParent_Done,
      // Label 5104: @254499
      GIM_Try, /*On fail goto*//*Label 5105*/ GIMT_Encode4(254596), // Rule ID 7306 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_2),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_w_chain:{ *:[i32] } 1121:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 65535:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_2>>  =>  (STXRH:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
        GIR_RootToRootCopy, /*OpIdx*/3, // addr
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7306,
        GIR_EraseRootFromParent_Done,
      // Label 5105: @254596
      GIM_Try, /*On fail goto*//*Label 5106*/ GIMT_Encode4(254693), // Rule ID 7315 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(255),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_1),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_w_chain:{ *:[i32] } 1119:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 255:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_1>>  =>  (STLXRB:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
        GIR_RootToRootCopy, /*OpIdx*/3, // addr
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7315,
        GIR_EraseRootFromParent_Done,
      // Label 5106: @254693
      GIM_Try, /*On fail goto*//*Label 5107*/ GIMT_Encode4(254790), // Rule ID 7316 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_2),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (intrinsic_w_chain:{ *:[i32] } 1119:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 65535:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_2>>  =>  (STLXRH:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
        GIR_RootToRootCopy, /*OpIdx*/3, // addr
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7316,
        GIR_EraseRootFromParent_Done,
      // Label 5107: @254790
      GIM_Try, /*On fail goto*//*Label 5108*/ GIMT_Encode4(254901), // Rule ID 7308 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_1),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_w_chain:{ *:[i32] } 1121:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 255:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_1>>  =>  (STXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // addr
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7308,
        GIR_EraseRootFromParent_Done,
      // Label 5108: @254901
      GIM_Try, /*On fail goto*//*Label 5109*/ GIMT_Encode4(255012), // Rule ID 7309 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_2),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_w_chain:{ *:[i32] } 1121:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 65535:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_2>>  =>  (STXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // addr
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7309,
        GIR_EraseRootFromParent_Done,
      // Label 5109: @255012
      GIM_Try, /*On fail goto*//*Label 5110*/ GIMT_Encode4(255123), // Rule ID 7310 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_4),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_w_chain:{ *:[i32] } 1121:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 4294967295:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_4>>  =>  (STXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // addr
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7310,
        GIR_EraseRootFromParent_Done,
      // Label 5110: @255123
      GIM_Try, /*On fail goto*//*Label 5111*/ GIMT_Encode4(255234), // Rule ID 7318 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_1),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_w_chain:{ *:[i32] } 1119:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 255:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_1>>  =>  (STLXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // addr
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7318,
        GIR_EraseRootFromParent_Done,
      // Label 5111: @255234
      GIM_Try, /*On fail goto*//*Label 5112*/ GIMT_Encode4(255345), // Rule ID 7319 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_2),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_w_chain:{ *:[i32] } 1119:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 65535:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_2>>  =>  (STLXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // addr
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7319,
        GIR_EraseRootFromParent_Done,
      // Label 5112: @255345
      GIM_Try, /*On fail goto*//*Label 5113*/ GIMT_Encode4(255456), // Rule ID 7320 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_4),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_w_chain:{ *:[i32] } 1119:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 4294967295:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_4>>  =>  (STLXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // addr
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7320,
        GIR_EraseRootFromParent_Done,
      // Label 5113: @255456
      GIM_Try, /*On fail goto*//*Label 5114*/ GIMT_Encode4(255507), // Rule ID 82 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_fixedshadow),
        // MIs[0] ptr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
        // MIs[0] accessinfo
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        // MIs[0] fixed_shadow
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        // (intrinsic_void 191:{ *:[iPTR] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)  =>  (HWASAN_CHECK_MEMACCESS_FIXEDSHADOW:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS_FIXEDSHADOW),
        GIR_RootToRootCopy, /*OpIdx*/1, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // accessinfo
        GIR_RootToRootCopy, /*OpIdx*/3, // fixed_shadow
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 82,
        GIR_EraseRootFromParent_Done,
      // Label 5114: @255507
      GIM_Try, /*On fail goto*//*Label 5115*/ GIMT_Encode4(255558), // Rule ID 83 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_shortgranules_fixedshadow),
        // MIs[0] ptr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
        // MIs[0] accessinfo
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        // MIs[0] fixed_shadow
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        // (intrinsic_void 193:{ *:[iPTR] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)  =>  (HWASAN_CHECK_MEMACCESS_SHORTGRANULES_FIXEDSHADOW:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS_SHORTGRANULES_FIXEDSHADOW),
        GIR_RootToRootCopy, /*OpIdx*/1, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // accessinfo
        GIR_RootToRootCopy, /*OpIdx*/3, // fixed_shadow
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 83,
        GIR_EraseRootFromParent_Done,
      // Label 5115: @255558
      GIM_Try, /*On fail goto*//*Label 5116*/ GIMT_Encode4(255627), // Rule ID 7307 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_4),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_w_chain:{ *:[i32] } 1121:{ *:[iPTR] }, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$val), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_4>>  =>  (STXRW:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
        GIR_RootToRootCopy, /*OpIdx*/3, // addr
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7307,
        GIR_EraseRootFromParent_Done,
      // Label 5116: @255627
      GIM_Try, /*On fail goto*//*Label 5117*/ GIMT_Encode4(255696), // Rule ID 7317 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_4),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_w_chain:{ *:[i32] } 1119:{ *:[iPTR] }, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$val), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_4>>  =>  (STLXRW:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
        GIR_RootToRootCopy, /*OpIdx*/3, // addr
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7317,
        GIR_EraseRootFromParent_Done,
      // Label 5117: @255696
      GIM_Try, /*On fail goto*//*Label 5118*/ GIMT_Encode4(255750), // Rule ID 9032 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // MIs[0] base
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] prfop
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
        // (intrinsic_void 1514:{ *:[iPTR] }, PPR_3b:{ *:[nxv16i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv16i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_PRI),
        GIR_RootToRootCopy, /*OpIdx*/3, // prfop
        GIR_RootToRootCopy, /*OpIdx*/1, // gp
        GIR_RootToRootCopy, /*OpIdx*/2, // base
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9032,
        GIR_EraseRootFromParent_Done,
      // Label 5118: @255750
      GIM_Try, /*On fail goto*//*Label 5119*/ GIMT_Encode4(255804), // Rule ID 9035 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // MIs[0] base
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] prfop
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
        // (intrinsic_void 1514:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv8i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_PRI),
        GIR_RootToRootCopy, /*OpIdx*/3, // prfop
        GIR_RootToRootCopy, /*OpIdx*/1, // gp
        GIR_RootToRootCopy, /*OpIdx*/2, // base
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9035,
        GIR_EraseRootFromParent_Done,
      // Label 5119: @255804
      GIM_Try, /*On fail goto*//*Label 5120*/ GIMT_Encode4(255858), // Rule ID 9038 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // MIs[0] base
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] prfop
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
        // (intrinsic_void 1514:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv4i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_PRI),
        GIR_RootToRootCopy, /*OpIdx*/3, // prfop
        GIR_RootToRootCopy, /*OpIdx*/1, // gp
        GIR_RootToRootCopy, /*OpIdx*/2, // base
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9038,
        GIR_EraseRootFromParent_Done,
      // Label 5120: @255858
      GIM_Try, /*On fail goto*//*Label 5121*/ GIMT_Encode4(255912), // Rule ID 9041 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // MIs[0] base
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] prfop
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
        // (intrinsic_void 1514:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv2i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_PRI),
        GIR_RootToRootCopy, /*OpIdx*/3, // prfop
        GIR_RootToRootCopy, /*OpIdx*/1, // gp
        GIR_RootToRootCopy, /*OpIdx*/2, // base
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9041,
        GIR_EraseRootFromParent_Done,
      // Label 5121: @255912
      GIM_Try, /*On fail goto*//*Label 5122*/ GIMT_Encode4(255966), // Rule ID 15 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_space),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_w_chain:{ *:[i64] } 1112:{ *:[iPTR] }, (imm:{ *:[i32] }):$size, GPR64:{ *:[i64] }:$Rn)  =>  (SPACE:{ *:[i64] } (imm:{ *:[i32] }):$size, GPR64:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SPACE),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // size
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15,
        GIR_EraseRootFromParent_Done,
      // Label 5122: @255966
      GIM_Try, /*On fail goto*//*Label 5123*/ GIMT_Encode4(256034), // Rule ID 80 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess),
        // MIs[0] Operand 1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64_with_sub_32_in_MatrixIndexGPR32_8_11RegClassID),
        // MIs[0] ptr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
        // MIs[0] accessinfo
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        // (intrinsic_void 190:{ *:[iPTR] }, X9:{ *:[i64] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)  =>  (HWASAN_CHECK_MEMACCESS:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::X9), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // X9
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS),
        GIR_RootToRootCopy, /*OpIdx*/2, // ptr
        GIR_RootToRootCopy, /*OpIdx*/3, // accessinfo
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 80,
        GIR_EraseRootFromParent_Done,
      // Label 5123: @256034
      GIM_Try, /*On fail goto*//*Label 5124*/ GIMT_Encode4(256102), // Rule ID 81 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_shortgranules),
        // MIs[0] Operand 1
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64common_and_GPR64noipRegClassID),
        // MIs[0] ptr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
        // MIs[0] accessinfo
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        // (intrinsic_void 192:{ *:[iPTR] }, X20:{ *:[i64] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)  =>  (HWASAN_CHECK_MEMACCESS_SHORTGRANULES:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::X20), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // X20
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS_SHORTGRANULES),
        GIR_RootToRootCopy, /*OpIdx*/2, // ptr
        GIR_RootToRootCopy, /*OpIdx*/3, // accessinfo
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 81,
        GIR_EraseRootFromParent_Done,
      // Label 5124: @256102
      GIM_Try, /*On fail goto*//*Label 5125*/ GIMT_Encode4(256182), // Rule ID 7301 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_1),
        // (intrinsic_w_chain:{ *:[i32] } 1121:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_1>>  =>  (STXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // addr
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7301,
        GIR_EraseRootFromParent_Done,
      // Label 5125: @256182
      GIM_Try, /*On fail goto*//*Label 5126*/ GIMT_Encode4(256262), // Rule ID 7302 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_2),
        // (intrinsic_w_chain:{ *:[i32] } 1121:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_2>>  =>  (STXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // addr
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7302,
        GIR_EraseRootFromParent_Done,
      // Label 5126: @256262
      GIM_Try, /*On fail goto*//*Label 5127*/ GIMT_Encode4(256342), // Rule ID 7303 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_4),
        // (intrinsic_w_chain:{ *:[i32] } 1121:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_4>>  =>  (STXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // addr
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7303,
        GIR_EraseRootFromParent_Done,
      // Label 5127: @256342
      GIM_Try, /*On fail goto*//*Label 5128*/ GIMT_Encode4(256393), // Rule ID 7304 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_8),
        // (intrinsic_w_chain:{ *:[i32] } 1121:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_8>>  =>  (STXRX:{ *:[i32] } GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
        GIR_RootToRootCopy, /*OpIdx*/2, // val
        GIR_RootToRootCopy, /*OpIdx*/3, // addr
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7304,
        GIR_EraseRootFromParent_Done,
      // Label 5128: @256393
      GIM_Try, /*On fail goto*//*Label 5129*/ GIMT_Encode4(256473), // Rule ID 7311 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_1),
        // (intrinsic_w_chain:{ *:[i32] } 1119:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_1>>  =>  (STLXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRB),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // addr
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7311,
        GIR_EraseRootFromParent_Done,
      // Label 5129: @256473
      GIM_Try, /*On fail goto*//*Label 5130*/ GIMT_Encode4(256553), // Rule ID 7312 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_2),
        // (intrinsic_w_chain:{ *:[i32] } 1119:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_2>>  =>  (STLXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // addr
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7312,
        GIR_EraseRootFromParent_Done,
      // Label 5130: @256553
      GIM_Try, /*On fail goto*//*Label 5131*/ GIMT_Encode4(256633), // Rule ID 7313 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_4),
        // (intrinsic_w_chain:{ *:[i32] } 1119:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_4>>  =>  (STLXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRW),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // addr
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7313,
        GIR_EraseRootFromParent_Done,
      // Label 5131: @256633
      GIM_Try, /*On fail goto*//*Label 5132*/ GIMT_Encode4(256684), // Rule ID 7314 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_8),
        // (intrinsic_w_chain:{ *:[i32] } 1119:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_8>>  =>  (STLXRX:{ *:[i32] } GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
        GIR_RootToRootCopy, /*OpIdx*/2, // val
        GIR_RootToRootCopy, /*OpIdx*/3, // addr
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7314,
        GIR_EraseRootFromParent_Done,
      // Label 5132: @256684
      GIM_Try, /*On fail goto*//*Label 5133*/ GIMT_Encode4(256737), // Rule ID 8907 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1uwq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // MIs[0] base
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        // (intrinsic_w_chain:{ *:[nxv4i32] } 1447:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1W_Q_IMM:{ *:[nxv4i32] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_Q_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // base
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8907,
        GIR_EraseRootFromParent_Done,
      // Label 5133: @256737
      GIM_Try, /*On fail goto*//*Label 5134*/ GIMT_Encode4(256790), // Rule ID 8910 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1uwq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // MIs[0] base
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        // (intrinsic_w_chain:{ *:[nxv4f32] } 1447:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1W_Q_IMM:{ *:[nxv4f32] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_Q_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // base
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8910,
        GIR_EraseRootFromParent_Done,
      // Label 5134: @256790
      GIM_Try, /*On fail goto*//*Label 5135*/ GIMT_Encode4(256843), // Rule ID 8919 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1udq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // MIs[0] base
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        // (intrinsic_w_chain:{ *:[nxv2i64] } 1446:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1D_Q_IMM:{ *:[nxv2i64] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_Q_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // base
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8919,
        GIR_EraseRootFromParent_Done,
      // Label 5135: @256843
      GIM_Try, /*On fail goto*//*Label 5136*/ GIMT_Encode4(256896), // Rule ID 8922 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1udq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // MIs[0] base
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        // (intrinsic_w_chain:{ *:[nxv2f64] } 1446:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1D_Q_IMM:{ *:[nxv2f64] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_Q_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // base
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8922,
        GIR_EraseRootFromParent_Done,
      // Label 5136: @256896
      GIM_Try, /*On fail goto*//*Label 5137*/ GIMT_Encode4(256942), // Rule ID 149 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_irg),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (intrinsic_w_chain:{ *:[i64] } 550:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (IRG:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::IRG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 149,
        GIR_EraseRootFromParent_Done,
      // Label 5137: @256942
      GIM_Try, /*On fail goto*//*Label 5138*/ GIMT_Encode4(256995), // Rule ID 8913 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1wq),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // MIs[0] base
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        // (intrinsic_void 1767:{ *:[iPTR] }, ZPR128:{ *:[nxv4i32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1W_Q_IMM Z_q:{ *:[nxv4i32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_Q_IMM),
        GIR_RootToRootCopy, /*OpIdx*/1, // Zt
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // base
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8913,
        GIR_EraseRootFromParent_Done,
      // Label 5138: @256995
      GIM_Try, /*On fail goto*//*Label 5139*/ GIMT_Encode4(257048), // Rule ID 8916 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1wq),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // MIs[0] base
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        // (intrinsic_void 1767:{ *:[iPTR] }, ZPR128:{ *:[nxv4f32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1W_Q_IMM Z_q:{ *:[nxv4f32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_Q_IMM),
        GIR_RootToRootCopy, /*OpIdx*/1, // Zt
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // base
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8916,
        GIR_EraseRootFromParent_Done,
      // Label 5139: @257048
      GIM_Try, /*On fail goto*//*Label 5140*/ GIMT_Encode4(257101), // Rule ID 8925 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1dq),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // MIs[0] base
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        // (intrinsic_void 1763:{ *:[iPTR] }, ZPR128:{ *:[nxv2i64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1D_Q_IMM Z_q:{ *:[nxv2i64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_Q_IMM),
        GIR_RootToRootCopy, /*OpIdx*/1, // Zt
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // base
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8925,
        GIR_EraseRootFromParent_Done,
      // Label 5140: @257101
      GIM_Try, /*On fail goto*//*Label 5141*/ GIMT_Encode4(257154), // Rule ID 8928 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1dq),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // MIs[0] base
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        // (intrinsic_void 1763:{ *:[iPTR] }, ZPR128:{ *:[nxv2f64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1D_Q_IMM Z_q:{ *:[nxv2f64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_Q_IMM),
        GIR_RootToRootCopy, /*OpIdx*/1, // Zt
        GIR_RootToRootCopy, /*OpIdx*/2, // Pg
        GIR_RootToRootCopy, /*OpIdx*/3, // base
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8928,
        GIR_EraseRootFromParent_Done,
      // Label 5141: @257154
      GIM_Reject,
    // Label 5103: @257155
    GIM_Try, /*On fail goto*//*Label 5142*/ GIMT_Encode4(259222),
      GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
      GIM_Try, /*On fail goto*//*Label 5143*/ GIMT_Encode4(257234), // Rule ID 3389 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_scalar_offset),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] prfop
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_void 1516:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR32:{ *:[nxv4i32] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_S_PZI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR32:{ *:[nxv4i32] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_S_PZI),
        GIR_RootToRootCopy, /*OpIdx*/4, // prfop
        GIR_RootToRootCopy, /*OpIdx*/1, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Zn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3389,
        GIR_EraseRootFromParent_Done,
      // Label 5143: @257234
      GIM_Try, /*On fail goto*//*Label 5144*/ GIMT_Encode4(257305), // Rule ID 3402 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_scalar_offset),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
        // MIs[1] Operand 1
        // No operand predicates
        // MIs[0] prfop
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_void 1516:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR32:{ *:[nxv2i64] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_PZI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR32:{ *:[nxv2i64] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_PZI),
        GIR_RootToRootCopy, /*OpIdx*/4, // prfop
        GIR_RootToRootCopy, /*OpIdx*/1, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Zn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3402,
        GIR_EraseRootFromParent_Done,
      // Label 5144: @257305
      GIM_Try, /*On fail goto*//*Label 5145*/ GIMT_Encode4(257364), // Rule ID 3603 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addha),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_void 772:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$pn, PPR3bAny:{ *:[nxv4i1] }:$pm, ZPR32:{ *:[nxv4i32] }:$zn)  =>  (ADDHA_MPPZ_S_PSEUDO_S (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, ?:{ *:[nxv4i1] }:$pn, ?:{ *:[nxv4i1] }:$pm, ?:{ *:[nxv4i32] }:$zn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHA_MPPZ_S_PSEUDO_S),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // pn
        GIR_RootToRootCopy, /*OpIdx*/3, // pm
        GIR_RootToRootCopy, /*OpIdx*/4, // zn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3603,
        GIR_EraseRootFromParent_Done,
      // Label 5145: @257364
      GIM_Try, /*On fail goto*//*Label 5146*/ GIMT_Encode4(257423), // Rule ID 3604 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addha),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_void 772:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$pn, PPR3bAny:{ *:[nxv2i1] }:$pm, ZPR64:{ *:[nxv2i64] }:$zn)  =>  (ADDHA_MPPZ_D_PSEUDO_D (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, ?:{ *:[nxv2i1] }:$pn, ?:{ *:[nxv2i1] }:$pm, ?:{ *:[nxv2i64] }:$zn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHA_MPPZ_D_PSEUDO_D),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // pn
        GIR_RootToRootCopy, /*OpIdx*/3, // pm
        GIR_RootToRootCopy, /*OpIdx*/4, // zn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3604,
        GIR_EraseRootFromParent_Done,
      // Label 5146: @257423
      GIM_Try, /*On fail goto*//*Label 5147*/ GIMT_Encode4(257482), // Rule ID 12662 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addva),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_void 773:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$pn, PPR3bAny:{ *:[nxv4i1] }:$pm, ZPR32:{ *:[nxv4i32] }:$zn)  =>  (ADDVA_MPPZ_S_PSEUDO_S (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, ?:{ *:[nxv4i1] }:$pn, ?:{ *:[nxv4i1] }:$pm, ?:{ *:[nxv4i32] }:$zn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVA_MPPZ_S_PSEUDO_S),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // pn
        GIR_RootToRootCopy, /*OpIdx*/3, // pm
        GIR_RootToRootCopy, /*OpIdx*/4, // zn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12662,
        GIR_EraseRootFromParent_Done,
      // Label 5147: @257482
      GIM_Try, /*On fail goto*//*Label 5148*/ GIMT_Encode4(257541), // Rule ID 12663 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addva),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_void 773:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$pn, PPR3bAny:{ *:[nxv2i1] }:$pm, ZPR64:{ *:[nxv2i64] }:$zn)  =>  (ADDVA_MPPZ_D_PSEUDO_D (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, ?:{ *:[nxv2i1] }:$pn, ?:{ *:[nxv2i1] }:$pm, ?:{ *:[nxv2i64] }:$zn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVA_MPPZ_D_PSEUDO_D),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // pn
        GIR_RootToRootCopy, /*OpIdx*/3, // pm
        GIR_RootToRootCopy, /*OpIdx*/4, // zn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12663,
        GIR_EraseRootFromParent_Done,
      // Label 5148: @257541
      GIM_Try, /*On fail goto*//*Label 5149*/ GIMT_Encode4(257601), // Rule ID 3387 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_uxtw_index),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] prfop
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
        // (intrinsic_void 1518:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW8Only:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW8Only:{ *:[nxv4i32] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_S_UXTW_SCALED),
        GIR_RootToRootCopy, /*OpIdx*/4, // prfop
        GIR_RootToRootCopy, /*OpIdx*/1, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3387,
        GIR_EraseRootFromParent_Done,
      // Label 5149: @257601
      GIM_Try, /*On fail goto*//*Label 5150*/ GIMT_Encode4(257661), // Rule ID 3388 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_sxtw_index),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] prfop
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
        // (intrinsic_void 1517:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW8Only:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW8Only:{ *:[nxv4i32] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_S_SXTW_SCALED),
        GIR_RootToRootCopy, /*OpIdx*/4, // prfop
        GIR_RootToRootCopy, /*OpIdx*/1, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3388,
        GIR_EraseRootFromParent_Done,
      // Label 5150: @257661
      GIM_Try, /*On fail goto*//*Label 5151*/ GIMT_Encode4(257721), // Rule ID 3399 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_uxtw_index),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] prfop
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
        // (intrinsic_void 1518:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW8Only:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW8Only:{ *:[nxv2i64] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_UXTW_SCALED),
        GIR_RootToRootCopy, /*OpIdx*/4, // prfop
        GIR_RootToRootCopy, /*OpIdx*/1, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3399,
        GIR_EraseRootFromParent_Done,
      // Label 5151: @257721
      GIM_Try, /*On fail goto*//*Label 5152*/ GIMT_Encode4(257781), // Rule ID 3400 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_sxtw_index),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] prfop
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
        // (intrinsic_void 1517:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW8Only:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW8Only:{ *:[nxv2i64] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_SXTW_SCALED),
        GIR_RootToRootCopy, /*OpIdx*/4, // prfop
        GIR_RootToRootCopy, /*OpIdx*/1, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3400,
        GIR_EraseRootFromParent_Done,
      // Label 5152: @257781
      GIM_Try, /*On fail goto*//*Label 5153*/ GIMT_Encode4(257841), // Rule ID 3401 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_index),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] prfop
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
        // (intrinsic_void 1515:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL8:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL8:{ *:[nxv2i64] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_SCALED),
        GIR_RootToRootCopy, /*OpIdx*/4, // prfop
        GIR_RootToRootCopy, /*OpIdx*/1, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3401,
        GIR_EraseRootFromParent_Done,
      // Label 5153: @257841
      GIM_Try, /*On fail goto*//*Label 5154*/ GIMT_Encode4(257901), // Rule ID 9044 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_uxtw_index),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] prfop
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
        // (intrinsic_void 1526:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW16:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW16:{ *:[nxv4i32] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_S_UXTW_SCALED),
        GIR_RootToRootCopy, /*OpIdx*/4, // prfop
        GIR_RootToRootCopy, /*OpIdx*/1, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9044,
        GIR_EraseRootFromParent_Done,
      // Label 5154: @257901
      GIM_Try, /*On fail goto*//*Label 5155*/ GIMT_Encode4(257961), // Rule ID 9045 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_sxtw_index),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] prfop
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
        // (intrinsic_void 1525:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW16:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW16:{ *:[nxv4i32] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_S_SXTW_SCALED),
        GIR_RootToRootCopy, /*OpIdx*/4, // prfop
        GIR_RootToRootCopy, /*OpIdx*/1, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9045,
        GIR_EraseRootFromParent_Done,
      // Label 5155: @257961
      GIM_Try, /*On fail goto*//*Label 5156*/ GIMT_Encode4(258021), // Rule ID 9046 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_uxtw_index),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] prfop
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
        // (intrinsic_void 1530:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW32:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW32:{ *:[nxv4i32] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_S_UXTW_SCALED),
        GIR_RootToRootCopy, /*OpIdx*/4, // prfop
        GIR_RootToRootCopy, /*OpIdx*/1, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9046,
        GIR_EraseRootFromParent_Done,
      // Label 5156: @258021
      GIM_Try, /*On fail goto*//*Label 5157*/ GIMT_Encode4(258081), // Rule ID 9047 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_sxtw_index),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] prfop
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
        // (intrinsic_void 1529:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW32:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW32:{ *:[nxv4i32] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_S_SXTW_SCALED),
        GIR_RootToRootCopy, /*OpIdx*/4, // prfop
        GIR_RootToRootCopy, /*OpIdx*/1, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9047,
        GIR_EraseRootFromParent_Done,
      // Label 5157: @258081
      GIM_Try, /*On fail goto*//*Label 5158*/ GIMT_Encode4(258141), // Rule ID 9048 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_uxtw_index),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] prfop
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
        // (intrinsic_void 1522:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW64:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW64:{ *:[nxv4i32] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_S_UXTW_SCALED),
        GIR_RootToRootCopy, /*OpIdx*/4, // prfop
        GIR_RootToRootCopy, /*OpIdx*/1, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9048,
        GIR_EraseRootFromParent_Done,
      // Label 5158: @258141
      GIM_Try, /*On fail goto*//*Label 5159*/ GIMT_Encode4(258201), // Rule ID 9049 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_sxtw_index),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] prfop
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
        // (intrinsic_void 1521:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW64:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW64:{ *:[nxv4i32] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_S_SXTW_SCALED),
        GIR_RootToRootCopy, /*OpIdx*/4, // prfop
        GIR_RootToRootCopy, /*OpIdx*/1, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9049,
        GIR_EraseRootFromParent_Done,
      // Label 5159: @258201
      GIM_Try, /*On fail goto*//*Label 5160*/ GIMT_Encode4(258261), // Rule ID 9050 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_uxtw_index),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] prfop
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
        // (intrinsic_void 1526:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW16:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW16:{ *:[nxv2i64] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_D_UXTW_SCALED),
        GIR_RootToRootCopy, /*OpIdx*/4, // prfop
        GIR_RootToRootCopy, /*OpIdx*/1, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9050,
        GIR_EraseRootFromParent_Done,
      // Label 5160: @258261
      GIM_Try, /*On fail goto*//*Label 5161*/ GIMT_Encode4(258321), // Rule ID 9051 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_sxtw_index),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] prfop
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
        // (intrinsic_void 1525:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW16:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW16:{ *:[nxv2i64] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_D_SXTW_SCALED),
        GIR_RootToRootCopy, /*OpIdx*/4, // prfop
        GIR_RootToRootCopy, /*OpIdx*/1, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9051,
        GIR_EraseRootFromParent_Done,
      // Label 5161: @258321
      GIM_Try, /*On fail goto*//*Label 5162*/ GIMT_Encode4(258381), // Rule ID 9052 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_uxtw_index),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] prfop
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
        // (intrinsic_void 1530:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW32:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW32:{ *:[nxv2i64] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_D_UXTW_SCALED),
        GIR_RootToRootCopy, /*OpIdx*/4, // prfop
        GIR_RootToRootCopy, /*OpIdx*/1, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9052,
        GIR_EraseRootFromParent_Done,
      // Label 5162: @258381
      GIM_Try, /*On fail goto*//*Label 5163*/ GIMT_Encode4(258441), // Rule ID 9053 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_sxtw_index),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] prfop
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
        // (intrinsic_void 1529:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW32:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW32:{ *:[nxv2i64] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_D_SXTW_SCALED),
        GIR_RootToRootCopy, /*OpIdx*/4, // prfop
        GIR_RootToRootCopy, /*OpIdx*/1, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9053,
        GIR_EraseRootFromParent_Done,
      // Label 5163: @258441
      GIM_Try, /*On fail goto*//*Label 5164*/ GIMT_Encode4(258501), // Rule ID 9054 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_uxtw_index),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] prfop
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
        // (intrinsic_void 1522:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW64:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW64:{ *:[nxv2i64] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_D_UXTW_SCALED),
        GIR_RootToRootCopy, /*OpIdx*/4, // prfop
        GIR_RootToRootCopy, /*OpIdx*/1, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9054,
        GIR_EraseRootFromParent_Done,
      // Label 5164: @258501
      GIM_Try, /*On fail goto*//*Label 5165*/ GIMT_Encode4(258561), // Rule ID 9055 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_sxtw_index),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] prfop
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
        // (intrinsic_void 1521:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW64:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW64:{ *:[nxv2i64] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_D_SXTW_SCALED),
        GIR_RootToRootCopy, /*OpIdx*/4, // prfop
        GIR_RootToRootCopy, /*OpIdx*/1, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9055,
        GIR_EraseRootFromParent_Done,
      // Label 5165: @258561
      GIM_Try, /*On fail goto*//*Label 5166*/ GIMT_Encode4(258621), // Rule ID 9056 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_index),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] prfop
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
        // (intrinsic_void 1523:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL16:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL16:{ *:[nxv2i64] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_D_SCALED),
        GIR_RootToRootCopy, /*OpIdx*/4, // prfop
        GIR_RootToRootCopy, /*OpIdx*/1, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9056,
        GIR_EraseRootFromParent_Done,
      // Label 5166: @258621
      GIM_Try, /*On fail goto*//*Label 5167*/ GIMT_Encode4(258681), // Rule ID 9057 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_index),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] prfop
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
        // (intrinsic_void 1527:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL32:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL32:{ *:[nxv2i64] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_D_SCALED),
        GIR_RootToRootCopy, /*OpIdx*/4, // prfop
        GIR_RootToRootCopy, /*OpIdx*/1, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9057,
        GIR_EraseRootFromParent_Done,
      // Label 5167: @258681
      GIM_Try, /*On fail goto*//*Label 5168*/ GIMT_Encode4(258741), // Rule ID 9058 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_index),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // MIs[0] Rn
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] prfop
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
        // (intrinsic_void 1519:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL64:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL64:{ *:[nxv2i64] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_D_SCALED),
        GIR_RootToRootCopy, /*OpIdx*/4, // prfop
        GIR_RootToRootCopy, /*OpIdx*/1, // Pg
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9058,
        GIR_EraseRootFromParent_Done,
      // Label 5168: @258741
      GIM_Try, /*On fail goto*//*Label 5169*/ GIMT_Encode4(258797), // Rule ID 13200 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/4, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (intrinsic_w_chain:{ *:[i32] } 1118:{ *:[iPTR] }, GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)  =>  (STLXPX:{ *:[i32] } GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXPX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
        GIR_RootToRootCopy, /*OpIdx*/2, // lo
        GIR_RootToRootCopy, /*OpIdx*/3, // hi
        GIR_RootToRootCopy, /*OpIdx*/4, // addr
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13200,
        GIR_EraseRootFromParent_Done,
      // Label 5169: @258797
      GIM_Try, /*On fail goto*//*Label 5170*/ GIMT_Encode4(258853), // Rule ID 13201 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] addr
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/4, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (intrinsic_w_chain:{ *:[i32] } 1120:{ *:[iPTR] }, GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)  =>  (STXPX:{ *:[i32] } GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXPX),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
        GIR_RootToRootCopy, /*OpIdx*/2, // lo
        GIR_RootToRootCopy, /*OpIdx*/3, // hi
        GIR_RootToRootCopy, /*OpIdx*/4, // addr
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13201,
        GIR_EraseRootFromParent_Done,
      // Label 5170: @258853
      GIM_Try, /*On fail goto*//*Label 5171*/ GIMT_Encode4(258899), // Rule ID 3436 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_w_chain:{ *:[nxv8f16] } 1383:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FDOT_ZZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZ_BtoH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3436,
        GIR_EraseRootFromParent_Done,
      // Label 5171: @258899
      GIM_Try, /*On fail goto*//*Label 5172*/ GIMT_Encode4(258945), // Rule ID 3579 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_w_chain:{ *:[nxv8f16] } 1385:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALB_ZZZ:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3579,
        GIR_EraseRootFromParent_Done,
      // Label 5172: @258945
      GIM_Try, /*On fail goto*//*Label 5173*/ GIMT_Encode4(258991), // Rule ID 12649 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_w_chain:{ *:[nxv8f16] } 1395:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALT_ZZZ:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12649,
        GIR_EraseRootFromParent_Done,
      // Label 5173: @258991
      GIM_Try, /*On fail goto*//*Label 5174*/ GIMT_Encode4(259037), // Rule ID 12653 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_w_chain:{ *:[nxv4f32] } 1387:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLBB_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBB_ZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12653,
        GIR_EraseRootFromParent_Done,
      // Label 5174: @259037
      GIM_Try, /*On fail goto*//*Label 5175*/ GIMT_Encode4(259083), // Rule ID 12654 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_w_chain:{ *:[nxv4f32] } 1389:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLBT_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBT_ZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12654,
        GIR_EraseRootFromParent_Done,
      // Label 5175: @259083
      GIM_Try, /*On fail goto*//*Label 5176*/ GIMT_Encode4(259129), // Rule ID 12655 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltb),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_w_chain:{ *:[nxv4f32] } 1391:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLTB_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTB_ZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12655,
        GIR_EraseRootFromParent_Done,
      // Label 5176: @259129
      GIM_Try, /*On fail goto*//*Label 5177*/ GIMT_Encode4(259175), // Rule ID 12656 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_w_chain:{ *:[nxv4f32] } 1393:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLTT_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTT_ZZZ),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12656,
        GIR_EraseRootFromParent_Done,
      // Label 5177: @259175
      GIM_Try, /*On fail goto*//*Label 5178*/ GIMT_Encode4(259221), // Rule ID 12657 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT4),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (intrinsic_w_chain:{ *:[nxv4f32] } 1383:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FDOT_ZZZ_BtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZ_BtoS),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12657,
        GIR_EraseRootFromParent_Done,
      // Label 5178: @259221
      GIM_Reject,
    // Label 5142: @259222
    GIM_Try, /*On fail goto*//*Label 5179*/ GIMT_Encode4(261775),
      GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
      GIM_Try, /*On fail goto*//*Label 5180*/ GIMT_Encode4(259290), // Rule ID 3594 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 876:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_S_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3594,
        GIR_EraseRootFromParent_Done,
      // Label 5180: @259290
      GIM_Try, /*On fail goto*//*Label 5181*/ GIMT_Encode4(259350), // Rule ID 3595 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF8F32),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_fp8_fmopa_za32),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 847:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (FMOPA_MPPZZ_BtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_BtoS_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3595,
        GIR_EraseRootFromParent_Done,
      // Label 5181: @259350
      GIM_Try, /*On fail goto*//*Label 5182*/ GIMT_Encode4(259410), // Rule ID 3596 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 876:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$Pn, PPR3bAny:{ *:[nxv2i1] }:$Pm, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2i1] }:$Pn, ?:{ *:[nxv2i1] }:$Pm, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_D_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3596,
        GIR_EraseRootFromParent_Done,
      // Label 5182: @259410
      GIM_Try, /*On fail goto*//*Label 5183*/ GIMT_Encode4(259470), // Rule ID 3597 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF8F16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_fp8_fmopa_za16),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 846:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (FMOPA_MPPZZ_BtoH_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_BtoH_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3597,
        GIR_EraseRootFromParent_Done,
      // Label 5183: @259470
      GIM_Try, /*On fail goto*//*Label 5184*/ GIMT_Encode4(259530), // Rule ID 3598 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16orSMEF8F16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 876:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPA_MPPZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_H_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3598,
        GIR_EraseRootFromParent_Done,
      // Label 5184: @259530
      GIM_Try, /*On fail goto*//*Label 5185*/ GIMT_Encode4(259590), // Rule ID 3599 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smopa_wide),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 963:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPA_MPPZZ_S_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3599,
        GIR_EraseRootFromParent_Done,
      // Label 5185: @259590
      GIM_Try, /*On fail goto*//*Label 5186*/ GIMT_Encode4(259650), // Rule ID 3600 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smopa_wide),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 963:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPA_MPPZZ_D_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3600,
        GIR_EraseRootFromParent_Done,
      // Label 5186: @259650
      GIM_Try, /*On fail goto*//*Label 5187*/ GIMT_Encode4(259710), // Rule ID 3601 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa_wide),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 878:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8bf16:{ *:[nxv8bf16] }:$Zn, nxv8bf16:{ *:[nxv8bf16] }:$Zm)  =>  (BFMOPA_MPPZZ_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8bf16] }:$Zn, ?:{ *:[nxv8bf16] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMOPA_MPPZZ_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3601,
        GIR_EraseRootFromParent_Done,
      // Label 5187: @259710
      GIM_Try, /*On fail goto*//*Label 5188*/ GIMT_Encode4(259770), // Rule ID 3602 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa_wide),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 878:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPAL_MPPZZ_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPAL_MPPZZ_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3602,
        GIR_EraseRootFromParent_Done,
      // Label 5188: @259770
      GIM_Try, /*On fail goto*//*Label 5189*/ GIMT_Encode4(259830), // Rule ID 3685 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smopa_za32),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 964:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPA_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPA_MPPZZ_HtoS_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3685,
        GIR_EraseRootFromParent_Done,
      // Label 5189: @259830
      GIM_Try, /*On fail goto*//*Label 5190*/ GIMT_Encode4(259890), // Rule ID 3686 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_bmopa_za32),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 774:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4i32:{ *:[nxv4i32] }:$Zn, nxv4i32:{ *:[nxv4i32] }:$Zm)  =>  (BMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4i32] }:$Zn, ?:{ *:[nxv4i32] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BMOPA_MPPZZ_S_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3686,
        GIR_EraseRootFromParent_Done,
      // Label 5190: @259890
      GIM_Try, /*On fail goto*//*Label 5191*/ GIMT_Encode4(259950), // Rule ID 12664 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops_wide),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 881:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8bf16:{ *:[nxv8bf16] }:$Zn, nxv8bf16:{ *:[nxv8bf16] }:$Zm)  =>  (BFMOPS_MPPZZ_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8bf16] }:$Zn, ?:{ *:[nxv8bf16] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMOPS_MPPZZ_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12664,
        GIR_EraseRootFromParent_Done,
      // Label 5191: @259950
      GIM_Try, /*On fail goto*//*Label 5192*/ GIMT_Encode4(260010), // Rule ID 12665 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 879:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPS_MPPZZ_S_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12665,
        GIR_EraseRootFromParent_Done,
      // Label 5192: @260010
      GIM_Try, /*On fail goto*//*Label 5193*/ GIMT_Encode4(260070), // Rule ID 12666 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 879:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$Pn, PPR3bAny:{ *:[nxv2i1] }:$Pm, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2i1] }:$Pn, ?:{ *:[nxv2i1] }:$Pm, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPS_MPPZZ_D_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12666,
        GIR_EraseRootFromParent_Done,
      // Label 5193: @260070
      GIM_Try, /*On fail goto*//*Label 5194*/ GIMT_Encode4(260130), // Rule ID 12667 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops_wide),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 881:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPSL_MPPZZ_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPSL_MPPZZ_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12667,
        GIR_EraseRootFromParent_Done,
      // Label 5194: @260130
      GIM_Try, /*On fail goto*//*Label 5195*/ GIMT_Encode4(260190), // Rule ID 12668 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smops_wide),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 965:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPS_MPPZZ_S_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12668,
        GIR_EraseRootFromParent_Done,
      // Label 5195: @260190
      GIM_Try, /*On fail goto*//*Label 5196*/ GIMT_Encode4(260250), // Rule ID 12669 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umopa_wide),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 1064:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPA_MPPZZ_S_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12669,
        GIR_EraseRootFromParent_Done,
      // Label 5196: @260250
      GIM_Try, /*On fail goto*//*Label 5197*/ GIMT_Encode4(260310), // Rule ID 12670 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umops_wide),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 1066:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPS_MPPZZ_S_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12670,
        GIR_EraseRootFromParent_Done,
      // Label 5197: @260310
      GIM_Try, /*On fail goto*//*Label 5198*/ GIMT_Encode4(260370), // Rule ID 12671 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumopa_wide),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 998:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPA_MPPZZ_S_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12671,
        GIR_EraseRootFromParent_Done,
      // Label 5198: @260370
      GIM_Try, /*On fail goto*//*Label 5199*/ GIMT_Encode4(260430), // Rule ID 12672 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumops_wide),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 999:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPS_MPPZZ_S_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12672,
        GIR_EraseRootFromParent_Done,
      // Label 5199: @260430
      GIM_Try, /*On fail goto*//*Label 5200*/ GIMT_Encode4(260490), // Rule ID 12673 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmopa_wide),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 1082:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPA_MPPZZ_S_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12673,
        GIR_EraseRootFromParent_Done,
      // Label 5200: @260490
      GIM_Try, /*On fail goto*//*Label 5201*/ GIMT_Encode4(260550), // Rule ID 12674 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmops_wide),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 1083:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPS_MPPZZ_S_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12674,
        GIR_EraseRootFromParent_Done,
      // Label 5201: @260550
      GIM_Try, /*On fail goto*//*Label 5202*/ GIMT_Encode4(260610), // Rule ID 12675 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smops_wide),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 965:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPS_MPPZZ_D_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12675,
        GIR_EraseRootFromParent_Done,
      // Label 5202: @260610
      GIM_Try, /*On fail goto*//*Label 5203*/ GIMT_Encode4(260670), // Rule ID 12676 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umopa_wide),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 1064:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPA_MPPZZ_D_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12676,
        GIR_EraseRootFromParent_Done,
      // Label 5203: @260670
      GIM_Try, /*On fail goto*//*Label 5204*/ GIMT_Encode4(260730), // Rule ID 12677 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umops_wide),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 1066:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPS_MPPZZ_D_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12677,
        GIR_EraseRootFromParent_Done,
      // Label 5204: @260730
      GIM_Try, /*On fail goto*//*Label 5205*/ GIMT_Encode4(260790), // Rule ID 12678 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumopa_wide),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 998:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPA_MPPZZ_D_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12678,
        GIR_EraseRootFromParent_Done,
      // Label 5205: @260790
      GIM_Try, /*On fail goto*//*Label 5206*/ GIMT_Encode4(260850), // Rule ID 12679 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumops_wide),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 999:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPS_MPPZZ_D_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12679,
        GIR_EraseRootFromParent_Done,
      // Label 5206: @260850
      GIM_Try, /*On fail goto*//*Label 5207*/ GIMT_Encode4(260910), // Rule ID 12680 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmopa_wide),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 1082:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPA_MPPZZ_D_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12680,
        GIR_EraseRootFromParent_Done,
      // Label 5207: @260910
      GIM_Try, /*On fail goto*//*Label 5208*/ GIMT_Encode4(260970), // Rule ID 12681 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmops_wide),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 1083:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPS_MPPZZ_D_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12681,
        GIR_EraseRootFromParent_Done,
      // Label 5208: @260970
      GIM_Try, /*On fail goto*//*Label 5209*/ GIMT_Encode4(261030), // Rule ID 13018 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_bmops_za32),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 775:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4i32:{ *:[nxv4i32] }:$Zn, nxv4i32:{ *:[nxv4i32] }:$Zm)  =>  (BMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4i32] }:$Zn, ?:{ *:[nxv4i32] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BMOPS_MPPZZ_S_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13018,
        GIR_EraseRootFromParent_Done,
      // Label 5209: @261030
      GIM_Try, /*On fail goto*//*Label 5210*/ GIMT_Encode4(261090), // Rule ID 13019 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smops_za32),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 966:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPS_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPS_MPPZZ_HtoS_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13019,
        GIR_EraseRootFromParent_Done,
      // Label 5210: @261090
      GIM_Try, /*On fail goto*//*Label 5211*/ GIMT_Encode4(261150), // Rule ID 13020 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umopa_za32),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 1065:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPA_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPA_MPPZZ_HtoS_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13020,
        GIR_EraseRootFromParent_Done,
      // Label 5211: @261150
      GIM_Try, /*On fail goto*//*Label 5212*/ GIMT_Encode4(261210), // Rule ID 13021 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umops_za32),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 1067:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPS_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPS_MPPZZ_HtoS_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13021,
        GIR_EraseRootFromParent_Done,
      // Label 5212: @261210
      GIM_Try, /*On fail goto*//*Label 5213*/ GIMT_Encode4(261270), // Rule ID 13134 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16orSMEF8F16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 879:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPS_MPPZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPS_MPPZZ_H_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13134,
        GIR_EraseRootFromParent_Done,
      // Label 5213: @261270
      GIM_Try, /*On fail goto*//*Label 5214*/ GIMT_Encode4(261330), // Rule ID 13151 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEB16B16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 876:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8bf16:{ *:[nxv8bf16] }:$Zn, nxv8bf16:{ *:[nxv8bf16] }:$Zm)  =>  (BFMOPA_MPPZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8bf16] }:$Zn, ?:{ *:[nxv8bf16] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMOPA_MPPZZ_H_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13151,
        GIR_EraseRootFromParent_Done,
      // Label 5214: @261330
      GIM_Try, /*On fail goto*//*Label 5215*/ GIMT_Encode4(261390), // Rule ID 13152 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEB16B16),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
        // MIs[0] tile
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
        // (intrinsic_void 879:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8bf16:{ *:[nxv8bf16] }:$Zn, nxv8bf16:{ *:[nxv8bf16] }:$Zm)  =>  (BFMOPS_MPPZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8bf16] }:$Zn, ?:{ *:[nxv8bf16] }:$Zm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMOPS_MPPZZ_H_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // tile
        GIR_RootToRootCopy, /*OpIdx*/2, // Pn
        GIR_RootToRootCopy, /*OpIdx*/3, // Pm
        GIR_RootToRootCopy, /*OpIdx*/4, // Zn
        GIR_RootToRootCopy, /*OpIdx*/5, // Zm
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13152,
        GIR_EraseRootFromParent_Done,
      // Label 5215: @261390
      GIM_Try, /*On fail goto*//*Label 5216*/ GIMT_Encode4(261438), // Rule ID 3578 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalb_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        // No operand predicates
        // (intrinsic_w_chain:{ *:[nxv8f16] } 1386:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALB_ZZZI:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3578,
        GIR_EraseRootFromParent_Done,
      // Label 5216: @261438
      GIM_Try, /*On fail goto*//*Label 5217*/ GIMT_Encode4(261486), // Rule ID 3580 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbb_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        // No operand predicates
        // (intrinsic_w_chain:{ *:[nxv4f32] } 1388:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLBB_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBB_ZZZI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3580,
        GIR_EraseRootFromParent_Done,
      // Label 5217: @261486
      GIM_Try, /*On fail goto*//*Label 5218*/ GIMT_Encode4(261534), // Rule ID 3581 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT2),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        // No operand predicates
        // (intrinsic_w_chain:{ *:[nxv8f16] } 1384:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FDOT_ZZZI_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZI_BtoH),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3581,
        GIR_EraseRootFromParent_Done,
      // Label 5218: @261534
      GIM_Try, /*On fail goto*//*Label 5219*/ GIMT_Encode4(261582), // Rule ID 3582 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT4),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        // No operand predicates
        // (intrinsic_w_chain:{ *:[nxv4f32] } 1384:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FDOT_ZZZI_BtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZI_BtoS),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3582,
        GIR_EraseRootFromParent_Done,
      // Label 5219: @261582
      GIM_Try, /*On fail goto*//*Label 5220*/ GIMT_Encode4(261630), // Rule ID 12648 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalt_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        // No operand predicates
        // (intrinsic_w_chain:{ *:[nxv8f16] } 1396:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALT_ZZZI:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12648,
        GIR_EraseRootFromParent_Done,
      // Label 5220: @261630
      GIM_Try, /*On fail goto*//*Label 5221*/ GIMT_Encode4(261678), // Rule ID 12650 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbt_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        // No operand predicates
        // (intrinsic_w_chain:{ *:[nxv4f32] } 1390:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLBT_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBT_ZZZI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12650,
        GIR_EraseRootFromParent_Done,
      // Label 5221: @261678
      GIM_Try, /*On fail goto*//*Label 5222*/ GIMT_Encode4(261726), // Rule ID 12651 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltb_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        // No operand predicates
        // (intrinsic_w_chain:{ *:[nxv4f32] } 1392:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLTB_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTB_ZZZI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12651,
        GIR_EraseRootFromParent_Done,
      // Label 5222: @261726
      GIM_Try, /*On fail goto*//*Label 5223*/ GIMT_Encode4(261774), // Rule ID 12652 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltt_lane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // MIs[0] Op4
        // No operand predicates
        // (intrinsic_w_chain:{ *:[nxv4f32] } 1394:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLTT_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTT_ZZZI),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
        GIR_RootToRootCopy, /*OpIdx*/2, // Op1
        GIR_RootToRootCopy, /*OpIdx*/3, // Op2
        GIR_RootToRootCopy, /*OpIdx*/4, // Op3
        GIR_RootToRootCopy, /*OpIdx*/5, // Op4
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12652,
        GIR_EraseRootFromParent_Done,
      // Label 5223: @261774
      GIM_Reject,
    // Label 5179: @261775
    GIM_Reject,
    // Label 34: @261776
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 5228*/ GIMT_Encode4(262065),
    /*GILLT_s64*//*Label 5224*/ GIMT_Encode4(261819), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_v2s64*//*Label 5225*/ GIMT_Encode4(261879), GIMT_Encode4(0),
    /*GILLT_v4s32*//*Label 5226*/ GIMT_Encode4(261941), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 5227*/ GIMT_Encode4(262003),
    // Label 5224: @261819
    GIM_Try, /*On fail goto*//*Label 5229*/ GIMT_Encode4(261878), // Rule ID 6563 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$src, sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 6563,
      GIR_EraseRootFromParent_Done,
    // Label 5229: @261878
    GIM_Reject,
    // Label 5225: @261879
    GIM_Try, /*On fail goto*//*Label 5230*/ GIMT_Encode4(261940),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 5231*/ GIMT_Encode4(261918), // Rule ID 6419 //
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (USHLLv4i32_shift:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6419,
        GIR_EraseRootFromParent_Done,
      // Label 5231: @261918
      GIM_Try, /*On fail goto*//*Label 5232*/ GIMT_Encode4(261939), // Rule ID 6410 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (USHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6410,
        GIR_EraseRootFromParent_Done,
      // Label 5232: @261939
      GIM_Reject,
    // Label 5230: @261940
    GIM_Reject,
    // Label 5226: @261941
    GIM_Try, /*On fail goto*//*Label 5233*/ GIMT_Encode4(262002),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 5234*/ GIMT_Encode4(261980), // Rule ID 6416 //
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (USHLLv8i16_shift:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6416,
        GIR_EraseRootFromParent_Done,
      // Label 5234: @261980
      GIM_Try, /*On fail goto*//*Label 5235*/ GIMT_Encode4(262001), // Rule ID 6407 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (USHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6407,
        GIR_EraseRootFromParent_Done,
      // Label 5235: @262001
      GIM_Reject,
    // Label 5233: @262002
    GIM_Reject,
    // Label 5227: @262003
    GIM_Try, /*On fail goto*//*Label 5236*/ GIMT_Encode4(262064),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 5237*/ GIMT_Encode4(262042), // Rule ID 6413 //
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn))  =>  (USHLLv16i8_shift:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv16i8_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6413,
        GIR_EraseRootFromParent_Done,
      // Label 5237: @262042
      GIM_Try, /*On fail goto*//*Label 5238*/ GIMT_Encode4(262063), // Rule ID 6404 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn)  =>  (USHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i8_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6404,
        GIR_EraseRootFromParent_Done,
      // Label 5238: @262063
      GIM_Reject,
    // Label 5236: @262064
    GIM_Reject,
    // Label 5228: @262065
    GIM_Reject,
    // Label 35: @262066
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(10), /*)*//*default:*//*Label 5243*/ GIMT_Encode4(263268),
    /*GILLT_s32*//*Label 5239*/ GIMT_Encode4(262109), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 5240*/ GIMT_Encode4(262148), GIMT_Encode4(0),
    /*GILLT_v4s16*//*Label 5241*/ GIMT_Encode4(262426), GIMT_Encode4(0),
    /*GILLT_v8s8*//*Label 5242*/ GIMT_Encode4(262847),
    // Label 5239: @262109
    GIM_Try, /*On fail goto*//*Label 5244*/ GIMT_Encode4(262147), // Rule ID 6584 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      // (trunc:{ *:[i32] } GPR64sp:{ *:[i64] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i32] } GPR64sp:{ *:[i64] }:$src, sub_32:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32spRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64spRegClassID),
      // GIR_Coverage, 6584,
      GIR_EraseRootFromParent_Done,
    // Label 5244: @262147
    GIM_Reject,
    // Label 5240: @262148
    GIM_Try, /*On fail goto*//*Label 5245*/ GIMT_Encode4(262425),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 5246*/ GIMT_Encode4(262231), // Rule ID 5453 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] }))  =>  (ADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5453,
        GIR_EraseRootFromParent_Done,
      // Label 5246: @262231
      GIM_Try, /*On fail goto*//*Label 5247*/ GIMT_Encode4(262302), // Rule ID 5459 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] }))  =>  (SUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5459,
        GIR_EraseRootFromParent_Done,
      // Label 5247: @262302
      GIM_Try, /*On fail goto*//*Label 5248*/ GIMT_Encode4(262355), // Rule ID 2149 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (trunc:{ *:[v2i32] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm))  =>  (SHRNv2i32_shift:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv2i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2149,
        GIR_EraseRootFromParent_Done,
      // Label 5248: @262355
      GIM_Try, /*On fail goto*//*Label 5249*/ GIMT_Encode4(262405), // Rule ID 6392 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm))  =>  (SHRNv2i32_shift:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv2i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6392,
        GIR_EraseRootFromParent_Done,
      // Label 5249: @262405
      GIM_Try, /*On fail goto*//*Label 5250*/ GIMT_Encode4(262424), // Rule ID 1088 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn)  =>  (XTNv2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::XTNv2i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1088,
        GIR_Done,
      // Label 5250: @262424
      GIM_Reject,
    // Label 5245: @262425
    GIM_Reject,
    // Label 5241: @262426
    GIM_Try, /*On fail goto*//*Label 5251*/ GIMT_Encode4(262846),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 5252*/ GIMT_Encode4(262509), // Rule ID 5452 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] }))  =>  (ADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5452,
        GIR_EraseRootFromParent_Done,
      // Label 5252: @262509
      GIM_Try, /*On fail goto*//*Label 5253*/ GIMT_Encode4(262580), // Rule ID 5458 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] }))  =>  (SUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5458,
        GIR_EraseRootFromParent_Done,
      // Label 5253: @262580
      GIM_Try, /*On fail goto*//*Label 5254*/ GIMT_Encode4(262672), // Rule ID 5592 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (trunc:{ *:[v4i16] } (concat_vectors:{ *:[v4i32] } (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vn), (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vm)))  =>  (XTNv4i16:{ *:[v4i16] } (UZP1v4i32:{ *:[f128] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Vn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, // Vm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5592,
        GIR_EraseRootFromParent_Done,
      // Label 5254: @262672
      GIM_Try, /*On fail goto*//*Label 5255*/ GIMT_Encode4(262725), // Rule ID 2148 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (trunc:{ *:[v4i16] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm))  =>  (SHRNv4i16_shift:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2148,
        GIR_EraseRootFromParent_Done,
      // Label 5255: @262725
      GIM_Try, /*On fail goto*//*Label 5256*/ GIMT_Encode4(262775), // Rule ID 6391 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm))  =>  (SHRNv4i16_shift:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6391,
        GIR_EraseRootFromParent_Done,
      // Label 5256: @262775
      GIM_Try, /*On fail goto*//*Label 5257*/ GIMT_Encode4(262826), // Rule ID 5620 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (trunc:{ *:[v4i16] } (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vm))  =>  (UZP1v4i16:{ *:[v4i16] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5620,
        GIR_EraseRootFromParent_Done,
      // Label 5257: @262826
      GIM_Try, /*On fail goto*//*Label 5258*/ GIMT_Encode4(262845), // Rule ID 1087 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn)  =>  (XTNv4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::XTNv4i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1087,
        GIR_Done,
      // Label 5258: @262845
      GIM_Reject,
    // Label 5251: @262846
    GIM_Reject,
    // Label 5242: @262847
    GIM_Try, /*On fail goto*//*Label 5259*/ GIMT_Encode4(263267),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 5260*/ GIMT_Encode4(262930), // Rule ID 5451 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] }))  =>  (ADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5451,
        GIR_EraseRootFromParent_Done,
      // Label 5260: @262930
      GIM_Try, /*On fail goto*//*Label 5261*/ GIMT_Encode4(263001), // Rule ID 5457 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] }))  =>  (SUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5457,
        GIR_EraseRootFromParent_Done,
      // Label 5261: @263001
      GIM_Try, /*On fail goto*//*Label 5262*/ GIMT_Encode4(263093), // Rule ID 5565 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (trunc:{ *:[v8i8] } (concat_vectors:{ *:[v8i16] } (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vn), (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vm)))  =>  (XTNv8i8:{ *:[v8i8] } (UZP1v8i16:{ *:[f128] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Vn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, // Vm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5565,
        GIR_EraseRootFromParent_Done,
      // Label 5262: @263093
      GIM_Try, /*On fail goto*//*Label 5263*/ GIMT_Encode4(263146), // Rule ID 2147 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (trunc:{ *:[v8i8] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm))  =>  (SHRNv8i8_shift:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i8_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2147,
        GIR_EraseRootFromParent_Done,
      // Label 5263: @263146
      GIM_Try, /*On fail goto*//*Label 5264*/ GIMT_Encode4(263196), // Rule ID 6390 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] imm
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm))  =>  (SHRNv8i8_shift:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i8_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6390,
        GIR_EraseRootFromParent_Done,
      // Label 5264: @263196
      GIM_Try, /*On fail goto*//*Label 5265*/ GIMT_Encode4(263247), // Rule ID 5619 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (trunc:{ *:[v8i8] } (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vm))  =>  (UZP1v8i8:{ *:[v8i8] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5619,
        GIR_EraseRootFromParent_Done,
      // Label 5265: @263247
      GIM_Try, /*On fail goto*//*Label 5266*/ GIMT_Encode4(263266), // Rule ID 1086 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn)  =>  (XTNv8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::XTNv8i8),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1086,
        GIR_Done,
      // Label 5266: @263266
      GIM_Reject,
    // Label 5259: @263267
    GIM_Reject,
    // Label 5243: @263268
    GIM_Reject,
    // Label 36: @263269
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5269*/ GIMT_Encode4(263388),
    /*GILLT_s32*//*Label 5267*/ GIMT_Encode4(263288),
    /*GILLT_s64*//*Label 5268*/ GIMT_Encode4(263308),
    // Label 5267: @263288
    GIM_Try, /*On fail goto*//*Label 5270*/ GIMT_Encode4(263307), // Rule ID 93 //
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      // (imm:{ *:[i32] }):$src  =>  (MOVi32imm:{ *:[i32] } (imm:{ *:[i32] }):$src)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 93,
      GIR_EraseRootFromParent_Done,
    // Label 5270: @263307
    GIM_Reject,
    // Label 5268: @263308
    GIM_Try, /*On fail goto*//*Label 5271*/ GIMT_Encode4(263368), // Rule ID 3885 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptimizedGISelOrOtherSelector),
      GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      // (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$src  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$src)), sub_32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 3885,
      GIR_EraseRootFromParent_Done,
    // Label 5271: @263368
    GIM_Try, /*On fail goto*//*Label 5272*/ GIMT_Encode4(263387), // Rule ID 94 //
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      // (imm:{ *:[i64] }):$src  =>  (MOVi64imm:{ *:[i64] } (imm:{ *:[i64] }):$src)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MOVi64imm),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 94,
      GIR_EraseRootFromParent_Done,
    // Label 5272: @263387
    GIM_Reject,
    // Label 5269: @263388
    GIM_Reject,
    // Label 37: @263389
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 5276*/ GIMT_Encode4(263677),
    /*GILLT_s16*//*Label 5273*/ GIMT_Encode4(263412),
    /*GILLT_s32*//*Label 5274*/ GIMT_Encode4(263512),
    /*GILLT_s64*//*Label 5275*/ GIMT_Encode4(263625),
    // Label 5273: @263412
    GIM_Try, /*On fail goto*//*Label 5277*/ GIMT_Encode4(263435), // Rule ID 502 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      // (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>  =>  (FMOVH0:{ *:[f16] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVH0),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 502,
      GIR_EraseRootFromParent_Done,
    // Label 5277: @263435
    GIM_Try, /*On fail goto*//*Label 5278*/ GIMT_Encode4(263463), // Rule ID 684 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      // (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm  =>  (FMOVHi:{ *:[f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] }):$imm))
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVHi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 684,
      GIR_EraseRootFromParent_Done,
    // Label 5278: @263463
    GIM_Try, /*On fail goto*//*Label 5279*/ GIMT_Encode4(263483), // Rule ID 4806 //
      GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      // (fpimm:{ *:[bf16] })<<P:Predicate_fpimm0>>  =>  (FMOVH0:{ *:[bf16] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVH0),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4806,
      GIR_EraseRootFromParent_Done,
    // Label 5279: @263483
    GIM_Try, /*On fail goto*//*Label 5280*/ GIMT_Encode4(263511), // Rule ID 4918 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimmbf16),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      // (fpimm:{ *:[bf16] })<<P:Predicate_fpimmbf16>><<X:fpimm16XForm>>:$in  =>  (FMOVHi:{ *:[bf16] } (fpimm16XForm:{ *:[f16] } bf16:{ *:[bf16] }:$in))
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVHi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // in
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4918,
      GIR_EraseRootFromParent_Done,
    // Label 5280: @263511
    GIM_Reject,
    // Label 5274: @263512
    GIM_Try, /*On fail goto*//*Label 5281*/ GIMT_Encode4(263535), // Rule ID 503 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      // (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>  =>  (FMOVS0:{ *:[f32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVS0),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 503,
      GIR_EraseRootFromParent_Done,
    // Label 5281: @263535
    GIM_Try, /*On fail goto*//*Label 5282*/ GIMT_Encode4(263563), // Rule ID 685 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      // (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm  =>  (FMOVSi:{ *:[f32] } (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] }):$imm))
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVSi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 685,
      GIR_EraseRootFromParent_Done,
    // Label 5282: @263563
    GIM_Try, /*On fail goto*//*Label 5283*/ GIMT_Encode4(263624), // Rule ID 6071 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32SIMDModImmType4),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      // (fpimm:{ *:[f32] })<<P:Predicate_fpimm32SIMDModImmType4>><<X:fpimm32SIMDModImmType4XForm>>:$in  =>  (EXTRACT_SUBREG:{ *:[f32] } (MOVIv2i32:{ *:[i64] } (fpimm32SIMDModImmType4XForm:{ *:[i32] } f32:{ *:[f32] }:$in), 24:{ *:[i32] }), ssub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2i32),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32SIMDModImmType4), // in
      GIR_AddImm8, /*InsnID*/1, /*Imm*/24,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6071,
      GIR_EraseRootFromParent_Done,
    // Label 5283: @263624
    GIM_Reject,
    // Label 5275: @263625
    GIM_Try, /*On fail goto*//*Label 5284*/ GIMT_Encode4(263648), // Rule ID 504 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      // (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>  =>  (FMOVD0:{ *:[f64] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVD0),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 504,
      GIR_EraseRootFromParent_Done,
    // Label 5284: @263648
    GIM_Try, /*On fail goto*//*Label 5285*/ GIMT_Encode4(263676), // Rule ID 686 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm64),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      // (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>><<X:fpimm64XForm>>:$imm  =>  (FMOVDi:{ *:[f64] } (fpimm64XForm:{ *:[f64] } (fpimm:{ *:[f64] }):$imm))
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVDi),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm64), // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 686,
      GIR_EraseRootFromParent_Done,
    // Label 5285: @263676
    GIM_Reject,
    // Label 5276: @263677
    GIM_Reject,
    // Label 38: @263678
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 5291*/ GIMT_Encode4(265575),
    /*GILLT_s32*//*Label 5286*/ GIMT_Encode4(263725),
    /*GILLT_s64*//*Label 5287*/ GIMT_Encode4(265166), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_v2s64*//*Label 5288*/ GIMT_Encode4(265389), GIMT_Encode4(0),
    /*GILLT_v4s32*//*Label 5289*/ GIMT_Encode4(265451), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 5290*/ GIMT_Encode4(265513),
    // Label 5286: @263725
    GIM_Try, /*On fail goto*//*Label 5292*/ GIMT_Encode4(263845), // Rule ID 13202 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 637:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 13202,
      GIR_EraseRootFromParent_Done,
    // Label 5292: @263845
    GIM_Try, /*On fail goto*//*Label 5293*/ GIMT_Encode4(263965), // Rule ID 13204 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 637:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 13204,
      GIR_EraseRootFromParent_Done,
    // Label 5293: @263965
    GIM_Try, /*On fail goto*//*Label 5294*/ GIMT_Encode4(264085), // Rule ID 13206 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 637:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 13206,
      GIR_EraseRootFromParent_Done,
    // Label 5294: @264085
    GIM_Try, /*On fail goto*//*Label 5295*/ GIMT_Encode4(264205), // Rule ID 13208 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 637:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 13208,
      GIR_EraseRootFromParent_Done,
    // Label 5295: @264205
    GIM_Try, /*On fail goto*//*Label 5296*/ GIMT_Encode4(264325), // Rule ID 13224 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 647:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i8v),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 13224,
      GIR_EraseRootFromParent_Done,
    // Label 5296: @264325
    GIM_Try, /*On fail goto*//*Label 5297*/ GIMT_Encode4(264445), // Rule ID 13226 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 647:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv16i8v),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 13226,
      GIR_EraseRootFromParent_Done,
    // Label 5297: @264445
    GIM_Try, /*On fail goto*//*Label 5298*/ GIMT_Encode4(264565), // Rule ID 13228 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 647:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i16v),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 13228,
      GIR_EraseRootFromParent_Done,
    // Label 5298: @264565
    GIM_Try, /*On fail goto*//*Label 5299*/ GIMT_Encode4(264685), // Rule ID 13230 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 647:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i16v),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 13230,
      GIR_EraseRootFromParent_Done,
    // Label 5299: @264685
    GIM_Try, /*On fail goto*//*Label 5300*/ GIMT_Encode4(264805), // Rule ID 13234 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 650:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i8v),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 13234,
      GIR_EraseRootFromParent_Done,
    // Label 5300: @264805
    GIM_Try, /*On fail goto*//*Label 5301*/ GIMT_Encode4(264925), // Rule ID 13236 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 650:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv16i8v),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 13236,
      GIR_EraseRootFromParent_Done,
    // Label 5301: @264925
    GIM_Try, /*On fail goto*//*Label 5302*/ GIMT_Encode4(265045), // Rule ID 13238 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 650:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i16v),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 13238,
      GIR_EraseRootFromParent_Done,
    // Label 5302: @265045
    GIM_Try, /*On fail goto*//*Label 5303*/ GIMT_Encode4(265165), // Rule ID 13240 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 650:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i16v),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 13240,
      GIR_EraseRootFromParent_Done,
    // Label 5303: @265165
    GIM_Reject,
    // Label 5287: @265166
    GIM_Try, /*On fail goto*//*Label 5304*/ GIMT_Encode4(265388),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 5305*/ GIMT_Encode4(265232), // Rule ID 5707 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SMOVvi32to64:{ *:[i64] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi32to64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5707,
        GIR_EraseRootFromParent_Done,
      // Label 5305: @265232
      GIM_Try, /*On fail goto*//*Label 5306*/ GIMT_Encode4(265311), // Rule ID 11507 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sext:{ *:[i64] } (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index))  =>  (SMOVvi32to64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v4i32] } ZPR:{ *:[nxv4i32] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi32to64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11507,
        GIR_EraseRootFromParent_Done,
      // Label 5306: @265311
      GIM_Try, /*On fail goto*//*Label 5307*/ GIMT_Encode4(265387), // Rule ID 6565 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (sext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (SBFMXri:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$src, sub_32:{ *:[i32] }), 0:{ *:[i64] }, 31:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6565,
        GIR_EraseRootFromParent_Done,
      // Label 5307: @265387
      GIM_Reject,
    // Label 5304: @265388
    GIM_Reject,
    // Label 5288: @265389
    GIM_Try, /*On fail goto*//*Label 5308*/ GIMT_Encode4(265450),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 5309*/ GIMT_Encode4(265428), // Rule ID 6421 //
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (SSHLLv4i32_shift:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6421,
        GIR_EraseRootFromParent_Done,
      // Label 5309: @265428
      GIM_Try, /*On fail goto*//*Label 5310*/ GIMT_Encode4(265449), // Rule ID 6408 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (SSHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6408,
        GIR_EraseRootFromParent_Done,
      // Label 5310: @265449
      GIM_Reject,
    // Label 5308: @265450
    GIM_Reject,
    // Label 5289: @265451
    GIM_Try, /*On fail goto*//*Label 5311*/ GIMT_Encode4(265512),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 5312*/ GIMT_Encode4(265490), // Rule ID 6418 //
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (SSHLLv8i16_shift:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6418,
        GIR_EraseRootFromParent_Done,
      // Label 5312: @265490
      GIM_Try, /*On fail goto*//*Label 5313*/ GIMT_Encode4(265511), // Rule ID 6405 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SSHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6405,
        GIR_EraseRootFromParent_Done,
      // Label 5313: @265511
      GIM_Reject,
    // Label 5311: @265512
    GIM_Reject,
    // Label 5290: @265513
    GIM_Try, /*On fail goto*//*Label 5314*/ GIMT_Encode4(265574),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 5315*/ GIMT_Encode4(265552), // Rule ID 6415 //
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn))  =>  (SSHLLv16i8_shift:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv16i8_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6415,
        GIR_EraseRootFromParent_Done,
      // Label 5315: @265552
      GIM_Try, /*On fail goto*//*Label 5316*/ GIMT_Encode4(265573), // Rule ID 6402 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn)  =>  (SSHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6402,
        GIR_EraseRootFromParent_Done,
      // Label 5316: @265573
      GIM_Reject,
    // Label 5314: @265574
    GIM_Reject,
    // Label 5291: @265575
    GIM_Reject,
    // Label 39: @265576
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(22), /*)*//*default:*//*Label 5322*/ GIMT_Encode4(267229),
    /*GILLT_s32*//*Label 5317*/ GIMT_Encode4(265667),
    /*GILLT_s64*//*Label 5318*/ GIMT_Encode4(266161), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s64*//*Label 5319*/ GIMT_Encode4(266803), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv4s32*//*Label 5320*/ GIMT_Encode4(267012), GIMT_Encode4(0),
    /*GILLT_nxv8s16*//*Label 5321*/ GIMT_Encode4(267156),
    // Label 5317: @265667
    GIM_Try, /*On fail goto*//*Label 5323*/ GIMT_Encode4(266160),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 5324*/ GIMT_Encode4(265744), // Rule ID 5702 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
        // MIs[2] Operand 1
        // No operand predicates
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), i8:{ *:[Other] })  =>  (SMOVvi8to32:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5702,
        GIR_EraseRootFromParent_Done,
      // Label 5324: @265744
      GIM_Try, /*On fail goto*//*Label 5325*/ GIMT_Encode4(265809), // Rule ID 5704 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), i16:{ *:[Other] })  =>  (SMOVvi16to32:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5704,
        GIR_EraseRootFromParent_Done,
      // Label 5325: @265809
      GIM_Try, /*On fail goto*//*Label 5326*/ GIMT_Encode4(265874), // Rule ID 5706 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), i16:{ *:[Other] })  =>  (SMOVvi16to32:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5706,
        GIR_EraseRootFromParent_Done,
      // Label 5326: @265874
      GIM_Try, /*On fail goto*//*Label 5327*/ GIMT_Encode4(265964), // Rule ID 11503 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
        // MIs[2] Operand 1
        // No operand predicates
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index), i8:{ *:[Other] })  =>  (SMOVvi8to32:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11503,
        GIR_EraseRootFromParent_Done,
      // Label 5327: @265964
      GIM_Try, /*On fail goto*//*Label 5328*/ GIMT_Encode4(266054), // Rule ID 11505 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index), i16:{ *:[Other] })  =>  (SMOVvi16to32:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11505,
        GIR_EraseRootFromParent_Done,
      // Label 5328: @266054
      GIM_Try, /*On fail goto*//*Label 5329*/ GIMT_Encode4(266089), // Rule ID 6570 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
        // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i16:{ *:[Other] })  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$src, 0:{ *:[i64] }, 15:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6570,
        GIR_EraseRootFromParent_Done,
      // Label 5329: @266089
      GIM_Try, /*On fail goto*//*Label 5330*/ GIMT_Encode4(266124), // Rule ID 6571 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
        // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i8:{ *:[Other] })  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$src, 0:{ *:[i64] }, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6571,
        GIR_EraseRootFromParent_Done,
      // Label 5330: @266124
      GIM_Try, /*On fail goto*//*Label 5331*/ GIMT_Encode4(266159), // Rule ID 6572 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
        // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i1:{ *:[Other] })  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$src, 0:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6572,
        GIR_EraseRootFromParent_Done,
      // Label 5331: @266159
      GIM_Reject,
    // Label 5323: @266160
    GIM_Reject,
    // Label 5318: @266161
    GIM_Try, /*On fail goto*//*Label 5332*/ GIMT_Encode4(266802),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 5333*/ GIMT_Encode4(266250), // Rule ID 5708 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)), i8:{ *:[Other] })  =>  (SMOVvi8to64:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5708,
        GIR_EraseRootFromParent_Done,
      // Label 5333: @266250
      GIM_Try, /*On fail goto*//*Label 5334*/ GIMT_Encode4(266327), // Rule ID 5709 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), i16:{ *:[Other] })  =>  (SMOVvi16to64:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5709,
        GIR_EraseRootFromParent_Done,
      // Label 5334: @266327
      GIM_Try, /*On fail goto*//*Label 5335*/ GIMT_Encode4(266429), // Rule ID 11504 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)), i8:{ *:[Other] })  =>  (SMOVvi8to64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // index
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11504,
        GIR_EraseRootFromParent_Done,
      // Label 5335: @266429
      GIM_Try, /*On fail goto*//*Label 5336*/ GIMT_Encode4(266531), // Rule ID 11506 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)), i16:{ *:[Other] })  =>  (SMOVvi16to64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // index
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11506,
        GIR_EraseRootFromParent_Done,
      // Label 5336: @266531
      GIM_Try, /*On fail goto*//*Label 5337*/ GIMT_Encode4(266596), // Rule ID 5703 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
        // MIs[2] Operand 1
        // No operand predicates
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sext_inreg:{ *:[i64] } (vector_extract:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), i8:{ *:[Other] })  =>  (SMOVvi8to64:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5703,
        GIR_EraseRootFromParent_Done,
      // Label 5337: @266596
      GIM_Try, /*On fail goto*//*Label 5338*/ GIMT_Encode4(266661), // Rule ID 5705 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sext_inreg:{ *:[i64] } (vector_extract:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), i16:{ *:[Other] })  =>  (SMOVvi16to64:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5705,
        GIR_EraseRootFromParent_Done,
      // Label 5338: @266661
      GIM_Try, /*On fail goto*//*Label 5339*/ GIMT_Encode4(266696), // Rule ID 6566 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
        // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i32:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 31:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6566,
        GIR_EraseRootFromParent_Done,
      // Label 5339: @266696
      GIM_Try, /*On fail goto*//*Label 5340*/ GIMT_Encode4(266731), // Rule ID 6567 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
        // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i16:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 15:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6567,
        GIR_EraseRootFromParent_Done,
      // Label 5340: @266731
      GIM_Try, /*On fail goto*//*Label 5341*/ GIMT_Encode4(266766), // Rule ID 6568 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
        // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i8:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6568,
        GIR_EraseRootFromParent_Done,
      // Label 5341: @266766
      GIM_Try, /*On fail goto*//*Label 5342*/ GIMT_Encode4(266801), // Rule ID 6569 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
        // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i1:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 0:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6569,
        GIR_EraseRootFromParent_Done,
      // Label 5342: @266801
      GIM_Reject,
    // Label 5332: @266802
    GIM_Reject,
    // Label 5319: @266803
    GIM_Try, /*On fail goto*//*Label 5343*/ GIMT_Encode4(267011),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 5344*/ GIMT_Encode4(266880), // Rule ID 10715 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
        // (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, nxv2i32:{ *:[Other] })  =>  (SXTW_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv2i64] }:$Zs)
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTW_ZPmZ_D_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootToRootCopy, /*OpIdx*/1, // Zs
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10715,
        GIR_EraseRootFromParent_Done,
      // Label 5344: @266880
      GIM_Try, /*On fail goto*//*Label 5345*/ GIMT_Encode4(266945), // Rule ID 10716 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
        // (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, nxv2i16:{ *:[Other] })  =>  (SXTH_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv2i64] }:$Zs)
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTH_ZPmZ_D_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootToRootCopy, /*OpIdx*/1, // Zs
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10716,
        GIR_EraseRootFromParent_Done,
      // Label 5345: @266945
      GIM_Try, /*On fail goto*//*Label 5346*/ GIMT_Encode4(267010), // Rule ID 10717 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
        // (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, nxv2i8:{ *:[Other] })  =>  (SXTB_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv2i64] }:$Zs)
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTB_ZPmZ_D_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootToRootCopy, /*OpIdx*/1, // Zs
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10717,
        GIR_EraseRootFromParent_Done,
      // Label 5346: @267010
      GIM_Reject,
    // Label 5343: @267011
    GIM_Reject,
    // Label 5320: @267012
    GIM_Try, /*On fail goto*//*Label 5347*/ GIMT_Encode4(267155),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 5348*/ GIMT_Encode4(267089), // Rule ID 10718 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
        // (sext_inreg:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Zs, nxv4i16:{ *:[Other] })  =>  (SXTH_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv4i32] }:$Zs)
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTH_ZPmZ_S_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootToRootCopy, /*OpIdx*/1, // Zs
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10718,
        GIR_EraseRootFromParent_Done,
      // Label 5348: @267089
      GIM_Try, /*On fail goto*//*Label 5349*/ GIMT_Encode4(267154), // Rule ID 10719 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
        // (sext_inreg:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Zs, nxv4i8:{ *:[Other] })  =>  (SXTB_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv4i32] }:$Zs)
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTB_ZPmZ_S_UNDEF),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootToRootCopy, /*OpIdx*/1, // Zs
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10719,
        GIR_EraseRootFromParent_Done,
      // Label 5349: @267154
      GIM_Reject,
    // Label 5347: @267155
    GIM_Reject,
    // Label 5321: @267156
    GIM_Try, /*On fail goto*//*Label 5350*/ GIMT_Encode4(267228), // Rule ID 10720 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
      // (sext_inreg:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Zs, nxv8i8:{ *:[Other] })  =>  (SXTB_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv8i16] }:$Zs)
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTB_ZPmZ_H_UNDEF),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_RootToRootCopy, /*OpIdx*/1, // Zs
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 10720,
      GIR_EraseRootFromParent_Done,
    // Label 5350: @267228
    GIM_Reject,
    // Label 5322: @267229
    GIM_Reject,
    // Label 40: @267230
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 5355*/ GIMT_Encode4(270008),
    /*GILLT_s32*//*Label 5351*/ GIMT_Encode4(267277), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_v2s64*//*Label 5352*/ GIMT_Encode4(269078), GIMT_Encode4(0),
    /*GILLT_v4s32*//*Label 5353*/ GIMT_Encode4(269388), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 5354*/ GIMT_Encode4(269698),
    // Label 5351: @267277
    GIM_Try, /*On fail goto*//*Label 5356*/ GIMT_Encode4(267427), // Rule ID 13211 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 702:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
      GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 13211,
      GIR_EraseRootFromParent_Done,
    // Label 5356: @267427
    GIM_Try, /*On fail goto*//*Label 5357*/ GIMT_Encode4(267577), // Rule ID 13213 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 702:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
      GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 13213,
      GIR_EraseRootFromParent_Done,
    // Label 5357: @267577
    GIM_Try, /*On fail goto*//*Label 5358*/ GIMT_Encode4(267727), // Rule ID 13215 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 702:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
      GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 13215,
      GIR_EraseRootFromParent_Done,
    // Label 5358: @267727
    GIM_Try, /*On fail goto*//*Label 5359*/ GIMT_Encode4(267877), // Rule ID 13217 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 702:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
      GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 13217,
      GIR_EraseRootFromParent_Done,
    // Label 5359: @267877
    GIM_Try, /*On fail goto*//*Label 5360*/ GIMT_Encode4(268027), // Rule ID 13244 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 708:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i8v),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
      GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 13244,
      GIR_EraseRootFromParent_Done,
    // Label 5360: @268027
    GIM_Try, /*On fail goto*//*Label 5361*/ GIMT_Encode4(268177), // Rule ID 13246 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 708:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv16i8v),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
      GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 13246,
      GIR_EraseRootFromParent_Done,
    // Label 5361: @268177
    GIM_Try, /*On fail goto*//*Label 5362*/ GIMT_Encode4(268327), // Rule ID 13248 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 708:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i16v),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
      GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 13248,
      GIR_EraseRootFromParent_Done,
    // Label 5362: @268327
    GIM_Try, /*On fail goto*//*Label 5363*/ GIMT_Encode4(268477), // Rule ID 13250 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 708:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i16v),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
      GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 13250,
      GIR_EraseRootFromParent_Done,
    // Label 5363: @268477
    GIM_Try, /*On fail goto*//*Label 5364*/ GIMT_Encode4(268627), // Rule ID 13254 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 711:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i8v),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
      GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 13254,
      GIR_EraseRootFromParent_Done,
    // Label 5364: @268627
    GIM_Try, /*On fail goto*//*Label 5365*/ GIMT_Encode4(268777), // Rule ID 13256 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 711:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv16i8v),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
      GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 13256,
      GIR_EraseRootFromParent_Done,
    // Label 5365: @268777
    GIM_Try, /*On fail goto*//*Label 5366*/ GIMT_Encode4(268927), // Rule ID 13258 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 711:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i16v),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
      GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 13258,
      GIR_EraseRootFromParent_Done,
    // Label 5366: @268927
    GIM_Try, /*On fail goto*//*Label 5367*/ GIMT_Encode4(269077), // Rule ID 13260 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 711:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i16v),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
      GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
      // GIR_Coverage, 13260,
      GIR_EraseRootFromParent_Done,
    // Label 5367: @269077
    GIM_Reject,
    // Label 5352: @269078
    GIM_Try, /*On fail goto*//*Label 5368*/ GIMT_Encode4(269387),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 5369*/ GIMT_Encode4(269155), // Rule ID 698 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 699:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UABDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 698,
        GIR_EraseRootFromParent_Done,
      // Label 5369: @269155
      GIM_Try, /*On fail goto*//*Label 5370*/ GIMT_Encode4(269220), // Rule ID 1700 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 634:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SABDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1700,
        GIR_EraseRootFromParent_Done,
      // Label 5370: @269220
      GIM_Try, /*On fail goto*//*Label 5371*/ GIMT_Encode4(269279), // Rule ID 696 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 699:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UABDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 696,
        GIR_EraseRootFromParent_Done,
      // Label 5371: @269279
      GIM_Try, /*On fail goto*//*Label 5372*/ GIMT_Encode4(269338), // Rule ID 1698 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 634:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SABDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1698,
        GIR_EraseRootFromParent_Done,
      // Label 5372: @269338
      GIM_Try, /*On fail goto*//*Label 5373*/ GIMT_Encode4(269365), // Rule ID 6420 //
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (USHLLv4i32_shift:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6420,
        GIR_EraseRootFromParent_Done,
      // Label 5373: @269365
      GIM_Try, /*On fail goto*//*Label 5374*/ GIMT_Encode4(269386), // Rule ID 6409 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (USHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6409,
        GIR_EraseRootFromParent_Done,
      // Label 5374: @269386
      GIM_Reject,
    // Label 5368: @269387
    GIM_Reject,
    // Label 5353: @269388
    GIM_Try, /*On fail goto*//*Label 5375*/ GIMT_Encode4(269697),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 5376*/ GIMT_Encode4(269465), // Rule ID 694 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 699:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UABDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 694,
        GIR_EraseRootFromParent_Done,
      // Label 5376: @269465
      GIM_Try, /*On fail goto*//*Label 5377*/ GIMT_Encode4(269530), // Rule ID 1696 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 634:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SABDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1696,
        GIR_EraseRootFromParent_Done,
      // Label 5377: @269530
      GIM_Try, /*On fail goto*//*Label 5378*/ GIMT_Encode4(269589), // Rule ID 692 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 699:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UABDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 692,
        GIR_EraseRootFromParent_Done,
      // Label 5378: @269589
      GIM_Try, /*On fail goto*//*Label 5379*/ GIMT_Encode4(269648), // Rule ID 1694 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 634:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SABDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1694,
        GIR_EraseRootFromParent_Done,
      // Label 5379: @269648
      GIM_Try, /*On fail goto*//*Label 5380*/ GIMT_Encode4(269675), // Rule ID 6417 //
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (USHLLv8i16_shift:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6417,
        GIR_EraseRootFromParent_Done,
      // Label 5380: @269675
      GIM_Try, /*On fail goto*//*Label 5381*/ GIMT_Encode4(269696), // Rule ID 6406 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (USHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6406,
        GIR_EraseRootFromParent_Done,
      // Label 5381: @269696
      GIM_Reject,
    // Label 5375: @269697
    GIM_Reject,
    // Label 5354: @269698
    GIM_Try, /*On fail goto*//*Label 5382*/ GIMT_Encode4(270007),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 5383*/ GIMT_Encode4(269775), // Rule ID 690 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 699:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UABDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 690,
        GIR_EraseRootFromParent_Done,
      // Label 5383: @269775
      GIM_Try, /*On fail goto*//*Label 5384*/ GIMT_Encode4(269840), // Rule ID 1692 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 634:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SABDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1692,
        GIR_EraseRootFromParent_Done,
      // Label 5384: @269840
      GIM_Try, /*On fail goto*//*Label 5385*/ GIMT_Encode4(269899), // Rule ID 688 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 699:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UABDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 688,
        GIR_EraseRootFromParent_Done,
      // Label 5385: @269899
      GIM_Try, /*On fail goto*//*Label 5386*/ GIMT_Encode4(269958), // Rule ID 1690 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 634:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SABDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv8i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1690,
        GIR_EraseRootFromParent_Done,
      // Label 5386: @269958
      GIM_Try, /*On fail goto*//*Label 5387*/ GIMT_Encode4(269985), // Rule ID 6414 //
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn))  =>  (USHLLv16i8_shift:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv16i8_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6414,
        GIR_EraseRootFromParent_Done,
      // Label 5387: @269985
      GIM_Try, /*On fail goto*//*Label 5388*/ GIMT_Encode4(270006), // Rule ID 6403 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn)  =>  (USHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i8_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6403,
        GIR_EraseRootFromParent_Done,
      // Label 5388: @270006
      GIM_Reject,
    // Label 5382: @270007
    GIM_Reject,
    // Label 5355: @270008
    GIM_Reject,
    // Label 41: @270009
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 5394*/ GIMT_Encode4(270788),
    /*GILLT_s32*//*Label 5389*/ GIMT_Encode4(270056),
    /*GILLT_s64*//*Label 5390*/ GIMT_Encode4(270188), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_v2s64*//*Label 5391*/ GIMT_Encode4(270361), GIMT_Encode4(0),
    /*GILLT_v4s32*//*Label 5392*/ GIMT_Encode4(270506), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 5393*/ GIMT_Encode4(270647),
    // Label 5389: @270056
    GIM_Try, /*On fail goto*//*Label 5395*/ GIMT_Encode4(270187),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 5396*/ GIMT_Encode4(270112), // Rule ID 3915 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3915,
        GIR_EraseRootFromParent_Done,
      // Label 5396: @270112
      GIM_Try, /*On fail goto*//*Label 5397*/ GIMT_Encode4(270149), // Rule ID 3916 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3916,
        GIR_EraseRootFromParent_Done,
      // Label 5397: @270149
      GIM_Try, /*On fail goto*//*Label 5398*/ GIMT_Encode4(270186), // Rule ID 3914 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3914,
        GIR_EraseRootFromParent_Done,
      // Label 5398: @270186
      GIM_Reject,
    // Label 5395: @270187
    GIM_Reject,
    // Label 5390: @270188
    GIM_Try, /*On fail goto*//*Label 5399*/ GIMT_Encode4(270360),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 5400*/ GIMT_Encode4(270275), // Rule ID 3917 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVXr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3917,
        GIR_EraseRootFromParent_Done,
      // Label 5400: @270275
      GIM_Try, /*On fail goto*//*Label 5401*/ GIMT_Encode4(270343), // Rule ID 3918 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVXr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3918,
        GIR_EraseRootFromParent_Done,
      // Label 5401: @270343
      GIM_Try, /*On fail goto*//*Label 5402*/ GIMT_Encode4(270359), // Rule ID 132 //
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (LSLVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LSLVXr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 132,
        GIR_Done,
      // Label 5402: @270359
      GIM_Reject,
    // Label 5399: @270360
    GIM_Reject,
    // Label 5391: @270361
    GIM_Try, /*On fail goto*//*Label 5403*/ GIMT_Encode4(270505),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 5404*/ GIMT_Encode4(270440), // Rule ID 6401 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (shl:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), (AArch64dup:{ *:[v2i64] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))  =>  (SSHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm, (trunc_imm:{ *:[i32] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // size
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6401,
        GIR_EraseRootFromParent_Done,
      // Label 5404: @270440
      GIM_Try, /*On fail goto*//*Label 5405*/ GIMT_Encode4(270504), // Rule ID 6398 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (shl:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), (AArch64dup:{ *:[v2i64] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))  =>  (USHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm, (trunc_imm:{ *:[i32] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // size
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6398,
        GIR_EraseRootFromParent_Done,
      // Label 5405: @270504
      GIM_Reject,
    // Label 5403: @270505
    GIM_Reject,
    // Label 5392: @270506
    GIM_Try, /*On fail goto*//*Label 5406*/ GIMT_Encode4(270646),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 5407*/ GIMT_Encode4(270583), // Rule ID 6400 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (shl:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), (AArch64dup:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size))  =>  (SSHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6400,
        GIR_EraseRootFromParent_Done,
      // Label 5407: @270583
      GIM_Try, /*On fail goto*//*Label 5408*/ GIMT_Encode4(270645), // Rule ID 6397 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (shl:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), (AArch64dup:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size))  =>  (USHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6397,
        GIR_EraseRootFromParent_Done,
      // Label 5408: @270645
      GIM_Reject,
    // Label 5406: @270646
    GIM_Reject,
    // Label 5393: @270647
    GIM_Try, /*On fail goto*//*Label 5409*/ GIMT_Encode4(270787),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 5410*/ GIMT_Encode4(270724), // Rule ID 6399 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_7),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (shl:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), (AArch64dup:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size))  =>  (SSHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6399,
        GIR_EraseRootFromParent_Done,
      // Label 5410: @270724
      GIM_Try, /*On fail goto*//*Label 5411*/ GIMT_Encode4(270786), // Rule ID 6396 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_7),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (shl:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), (AArch64dup:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size))  =>  (USHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i8_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6396,
        GIR_EraseRootFromParent_Done,
      // Label 5411: @270786
      GIM_Reject,
    // Label 5409: @270787
    GIM_Reject,
    // Label 5394: @270788
    GIM_Reject,
    // Label 42: @270789
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5414*/ GIMT_Encode4(271181),
    /*GILLT_s32*//*Label 5412*/ GIMT_Encode4(270808),
    /*GILLT_s64*//*Label 5413*/ GIMT_Encode4(270974),
    // Label 5412: @270808
    GIM_Try, /*On fail goto*//*Label 5415*/ GIMT_Encode4(270973),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 5416*/ GIMT_Encode4(270861), // Rule ID 4004 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (UBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, 31:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UBFMWri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4004,
        GIR_EraseRootFromParent_Done,
      // Label 5416: @270861
      GIM_Try, /*On fail goto*//*Label 5417*/ GIMT_Encode4(270898), // Rule ID 3921 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3921,
        GIR_EraseRootFromParent_Done,
      // Label 5417: @270898
      GIM_Try, /*On fail goto*//*Label 5418*/ GIMT_Encode4(270935), // Rule ID 3922 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3922,
        GIR_EraseRootFromParent_Done,
      // Label 5418: @270935
      GIM_Try, /*On fail goto*//*Label 5419*/ GIMT_Encode4(270972), // Rule ID 3920 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3920,
        GIR_EraseRootFromParent_Done,
      // Label 5419: @270972
      GIM_Reject,
    // Label 5415: @270973
    GIM_Reject,
    // Label 5413: @270974
    GIM_Try, /*On fail goto*//*Label 5420*/ GIMT_Encode4(271180),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 5421*/ GIMT_Encode4(271027), // Rule ID 4005 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (UBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm, 63:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UBFMXri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4005,
        GIR_EraseRootFromParent_Done,
      // Label 5421: @271027
      GIM_Try, /*On fail goto*//*Label 5422*/ GIMT_Encode4(271095), // Rule ID 3923 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVXr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3923,
        GIR_EraseRootFromParent_Done,
      // Label 5422: @271095
      GIM_Try, /*On fail goto*//*Label 5423*/ GIMT_Encode4(271163), // Rule ID 3924 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVXr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3924,
        GIR_EraseRootFromParent_Done,
      // Label 5423: @271163
      GIM_Try, /*On fail goto*//*Label 5424*/ GIMT_Encode4(271179), // Rule ID 133 //
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (LSRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LSRVXr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 133,
        GIR_Done,
      // Label 5424: @271179
      GIM_Reject,
    // Label 5420: @271180
    GIM_Reject,
    // Label 5414: @271181
    GIM_Reject,
    // Label 43: @271182
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5427*/ GIMT_Encode4(271957),
    /*GILLT_s32*//*Label 5425*/ GIMT_Encode4(271201),
    /*GILLT_s64*//*Label 5426*/ GIMT_Encode4(271507),
    // Label 5425: @271201
    GIM_Try, /*On fail goto*//*Label 5428*/ GIMT_Encode4(271506),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 5429*/ GIMT_Encode4(271280), // Rule ID 6579 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sra:{ *:[i32] } (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i8:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm)  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6579,
        GIR_EraseRootFromParent_Done,
      // Label 5429: @271280
      GIM_Try, /*On fail goto*//*Label 5430*/ GIMT_Encode4(271344), // Rule ID 6581 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sra:{ *:[i32] } (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm)  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm, 15:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6581,
        GIR_EraseRootFromParent_Done,
      // Label 5430: @271344
      GIM_Try, /*On fail goto*//*Label 5431*/ GIMT_Encode4(271382), // Rule ID 4002 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, 31:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4002,
        GIR_EraseRootFromParent_Done,
      // Label 5431: @271382
      GIM_Try, /*On fail goto*//*Label 5432*/ GIMT_Encode4(271423), // Rule ID 2412 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2412,
        GIR_EraseRootFromParent_Done,
      // Label 5432: @271423
      GIM_Try, /*On fail goto*//*Label 5433*/ GIMT_Encode4(271464), // Rule ID 2413 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2413,
        GIR_EraseRootFromParent_Done,
      // Label 5433: @271464
      GIM_Try, /*On fail goto*//*Label 5434*/ GIMT_Encode4(271505), // Rule ID 2411 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2411,
        GIR_EraseRootFromParent_Done,
      // Label 5434: @271505
      GIM_Reject,
    // Label 5428: @271506
    GIM_Reject,
    // Label 5426: @271507
    GIM_Try, /*On fail goto*//*Label 5435*/ GIMT_Encode4(271956),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 5436*/ GIMT_Encode4(271586), // Rule ID 6580 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sra:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i8:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm)  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm, 7:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6580,
        GIR_EraseRootFromParent_Done,
      // Label 5436: @271586
      GIM_Try, /*On fail goto*//*Label 5437*/ GIMT_Encode4(271650), // Rule ID 6582 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sra:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i16:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm)  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm, 15:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6582,
        GIR_EraseRootFromParent_Done,
      // Label 5437: @271650
      GIM_Try, /*On fail goto*//*Label 5438*/ GIMT_Encode4(271753), // Rule ID 6583 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sra:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (SBFMXri:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, 31:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6583,
        GIR_EraseRootFromParent_Done,
      // Label 5438: @271753
      GIM_Try, /*On fail goto*//*Label 5439*/ GIMT_Encode4(271791), // Rule ID 4003 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm, 63:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4003,
        GIR_EraseRootFromParent_Done,
      // Label 5439: @271791
      GIM_Try, /*On fail goto*//*Label 5440*/ GIMT_Encode4(271863), // Rule ID 2414 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVXr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2414,
        GIR_EraseRootFromParent_Done,
      // Label 5440: @271863
      GIM_Try, /*On fail goto*//*Label 5441*/ GIMT_Encode4(271935), // Rule ID 2415 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVXr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2415,
        GIR_EraseRootFromParent_Done,
      // Label 5441: @271935
      GIM_Try, /*On fail goto*//*Label 5442*/ GIMT_Encode4(271955), // Rule ID 131 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ASRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ASRVXr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 131,
        GIR_Done,
      // Label 5442: @271955
      GIM_Reject,
    // Label 5435: @271956
    GIM_Reject,
    // Label 5427: @271957
    GIM_Reject,
    // Label 44: @271958
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5445*/ GIMT_Encode4(272087),
    /*GILLT_s32*//*Label 5443*/ GIMT_Encode4(271977),
    /*GILLT_s64*//*Label 5444*/ GIMT_Encode4(272032),
    // Label 5443: @271977
    GIM_Try, /*On fail goto*//*Label 5446*/ GIMT_Encode4(272031), // Rule ID 200 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (fshr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (EXTRWrri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] }):$imm)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRWrri),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_RootToRootCopy, /*OpIdx*/2, // Rm
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 200,
      GIR_EraseRootFromParent_Done,
    // Label 5446: @272031
    GIM_Reject,
    // Label 5444: @272032
    GIM_Try, /*On fail goto*//*Label 5447*/ GIMT_Encode4(272086), // Rule ID 201 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (fshr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (EXTRXrri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, (imm:{ *:[i64] }):$imm)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRXrri),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_RootToRootCopy, /*OpIdx*/2, // Rm
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 201,
      GIR_EraseRootFromParent_Done,
    // Label 5447: @272086
    GIM_Reject,
    // Label 5445: @272087
    GIM_Reject,
    // Label 45: @272088
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5450*/ GIMT_Encode4(272580),
    /*GILLT_s32*//*Label 5448*/ GIMT_Encode4(272107),
    /*GILLT_s64*//*Label 5449*/ GIMT_Encode4(272323),
    // Label 5448: @272107
    GIM_Try, /*On fail goto*//*Label 5451*/ GIMT_Encode4(272322),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 5452*/ GIMT_Encode4(272161), // Rule ID 196 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (rotr:{ *:[i32] } (bswap:{ *:[i32] } GPR32:{ *:[i32] }:$Rn), 16:{ *:[i64] })  =>  (REV16Wr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Wr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 196,
        GIR_EraseRootFromParent_Done,
      // Label 5452: @272161
      GIM_Try, /*On fail goto*//*Label 5453*/ GIMT_Encode4(272198), // Rule ID 3998 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (EXTRWrri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRWrri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3998,
        GIR_EraseRootFromParent_Done,
      // Label 5453: @272198
      GIM_Try, /*On fail goto*//*Label 5454*/ GIMT_Encode4(272239), // Rule ID 3927 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3927,
        GIR_EraseRootFromParent_Done,
      // Label 5454: @272239
      GIM_Try, /*On fail goto*//*Label 5455*/ GIMT_Encode4(272280), // Rule ID 3928 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3928,
        GIR_EraseRootFromParent_Done,
      // Label 5455: @272280
      GIM_Try, /*On fail goto*//*Label 5456*/ GIMT_Encode4(272321), // Rule ID 3926 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3926,
        GIR_EraseRootFromParent_Done,
      // Label 5456: @272321
      GIM_Reject,
    // Label 5451: @272322
    GIM_Reject,
    // Label 5449: @272323
    GIM_Try, /*On fail goto*//*Label 5457*/ GIMT_Encode4(272579),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 5458*/ GIMT_Encode4(272377), // Rule ID 199 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 32,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (rotr:{ *:[i64] } (bswap:{ *:[i64] } GPR64:{ *:[i64] }:$Rn), 32:{ *:[i64] })  =>  (REV32Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV32Xr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 199,
        GIR_EraseRootFromParent_Done,
      // Label 5458: @272377
      GIM_Try, /*On fail goto*//*Label 5459*/ GIMT_Encode4(272414), // Rule ID 3999 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (EXTRXrri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRXrri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3999,
        GIR_EraseRootFromParent_Done,
      // Label 5459: @272414
      GIM_Try, /*On fail goto*//*Label 5460*/ GIMT_Encode4(272486), // Rule ID 3929 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVXr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3929,
        GIR_EraseRootFromParent_Done,
      // Label 5460: @272486
      GIM_Try, /*On fail goto*//*Label 5461*/ GIMT_Encode4(272558), // Rule ID 3930 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVXr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3930,
        GIR_EraseRootFromParent_Done,
      // Label 5461: @272558
      GIM_Try, /*On fail goto*//*Label 5462*/ GIMT_Encode4(272578), // Rule ID 134 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (RORVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RORVXr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 134,
        GIR_Done,
      // Label 5462: @272578
      GIM_Reject,
    // Label 5457: @272579
    GIM_Reject,
    // Label 5450: @272580
    GIM_Reject,
    // Label 46: @272581
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(12), /*)*//*default:*//*Label 5470*/ GIMT_Encode4(277156),
    /*GILLT_v2s32*//*Label 5463*/ GIMT_Encode4(272620),
    /*GILLT_v2s64*//*Label 5464*/ GIMT_Encode4(273268),
    /*GILLT_v4s16*//*Label 5465*/ GIMT_Encode4(273916),
    /*GILLT_v4s32*//*Label 5466*/ GIMT_Encode4(274564),
    /*GILLT_v8s8*//*Label 5467*/ GIMT_Encode4(275212),
    /*GILLT_v8s16*//*Label 5468*/ GIMT_Encode4(275860),
    /*GILLT_v16s8*//*Label 5469*/ GIMT_Encode4(276508),
    // Label 5463: @272620
    GIM_Try, /*On fail goto*//*Label 5471*/ GIMT_Encode4(273267),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 5472*/ GIMT_Encode4(272672), // Rule ID 5212 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5212,
        GIR_EraseRootFromParent_Done,
      // Label 5472: @272672
      GIM_Try, /*On fail goto*//*Label 5473*/ GIMT_Encode4(272709), // Rule ID 5219 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5219,
        GIR_EraseRootFromParent_Done,
      // Label 5473: @272709
      GIM_Try, /*On fail goto*//*Label 5474*/ GIMT_Encode4(272746), // Rule ID 5226 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i32rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5226,
        GIR_EraseRootFromParent_Done,
      // Label 5474: @272746
      GIM_Try, /*On fail goto*//*Label 5475*/ GIMT_Encode4(272783), // Rule ID 5233 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5233,
        GIR_EraseRootFromParent_Done,
      // Label 5475: @272783
      GIM_Try, /*On fail goto*//*Label 5476*/ GIMT_Encode4(272820), // Rule ID 5240 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5240,
        GIR_EraseRootFromParent_Done,
      // Label 5476: @272820
      GIM_Try, /*On fail goto*//*Label 5477*/ GIMT_Encode4(272857), // Rule ID 5177 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5177,
        GIR_EraseRootFromParent_Done,
      // Label 5477: @272857
      GIM_Try, /*On fail goto*//*Label 5478*/ GIMT_Encode4(272894), // Rule ID 5184 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGT:{ *:[Other] })  =>  (CMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5184,
        GIR_EraseRootFromParent_Done,
      // Label 5478: @272894
      GIM_Try, /*On fail goto*//*Label 5479*/ GIMT_Encode4(272931), // Rule ID 5191 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGE:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5191,
        GIR_EraseRootFromParent_Done,
      // Label 5479: @272931
      GIM_Try, /*On fail goto*//*Label 5480*/ GIMT_Encode4(272968), // Rule ID 5198 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETLT:{ *:[Other] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5198,
        GIR_EraseRootFromParent_Done,
      // Label 5480: @272968
      GIM_Try, /*On fail goto*//*Label 5481*/ GIMT_Encode4(273005), // Rule ID 5205 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETLE:{ *:[Other] })  =>  (CMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i32rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5205,
        GIR_EraseRootFromParent_Done,
      // Label 5481: @273005
      GIM_Try, /*On fail goto*//*Label 5482*/ GIMT_Encode4(273034), // Rule ID 5114 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5114,
        GIR_EraseRootFromParent_Done,
      // Label 5482: @273034
      GIM_Try, /*On fail goto*//*Label 5483*/ GIMT_Encode4(273063), // Rule ID 5121 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5121,
        GIR_EraseRootFromParent_Done,
      // Label 5483: @273063
      GIM_Try, /*On fail goto*//*Label 5484*/ GIMT_Encode4(273092), // Rule ID 5128 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5128,
        GIR_EraseRootFromParent_Done,
      // Label 5484: @273092
      GIM_Try, /*On fail goto*//*Label 5485*/ GIMT_Encode4(273121), // Rule ID 5135 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5135,
        GIR_EraseRootFromParent_Done,
      // Label 5485: @273121
      GIM_Try, /*On fail goto*//*Label 5486*/ GIMT_Encode4(273150), // Rule ID 5142 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5142,
        GIR_EraseRootFromParent_Done,
      // Label 5486: @273150
      GIM_Try, /*On fail goto*//*Label 5487*/ GIMT_Encode4(273179), // Rule ID 5149 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5149,
        GIR_EraseRootFromParent_Done,
      // Label 5487: @273179
      GIM_Try, /*On fail goto*//*Label 5488*/ GIMT_Encode4(273208), // Rule ID 5156 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5156,
        GIR_EraseRootFromParent_Done,
      // Label 5488: @273208
      GIM_Try, /*On fail goto*//*Label 5489*/ GIMT_Encode4(273237), // Rule ID 5163 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5163,
        GIR_EraseRootFromParent_Done,
      // Label 5489: @273237
      GIM_Try, /*On fail goto*//*Label 5490*/ GIMT_Encode4(273266), // Rule ID 5170 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5170,
        GIR_EraseRootFromParent_Done,
      // Label 5490: @273266
      GIM_Reject,
    // Label 5471: @273267
    GIM_Reject,
    // Label 5464: @273268
    GIM_Try, /*On fail goto*//*Label 5491*/ GIMT_Encode4(273915),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 5492*/ GIMT_Encode4(273320), // Rule ID 5214 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5214,
        GIR_EraseRootFromParent_Done,
      // Label 5492: @273320
      GIM_Try, /*On fail goto*//*Label 5493*/ GIMT_Encode4(273357), // Rule ID 5221 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5221,
        GIR_EraseRootFromParent_Done,
      // Label 5493: @273357
      GIM_Try, /*On fail goto*//*Label 5494*/ GIMT_Encode4(273394), // Rule ID 5228 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i64rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5228,
        GIR_EraseRootFromParent_Done,
      // Label 5494: @273394
      GIM_Try, /*On fail goto*//*Label 5495*/ GIMT_Encode4(273431), // Rule ID 5235 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5235,
        GIR_EraseRootFromParent_Done,
      // Label 5495: @273431
      GIM_Try, /*On fail goto*//*Label 5496*/ GIMT_Encode4(273468), // Rule ID 5242 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5242,
        GIR_EraseRootFromParent_Done,
      // Label 5496: @273468
      GIM_Try, /*On fail goto*//*Label 5497*/ GIMT_Encode4(273505), // Rule ID 5179 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5179,
        GIR_EraseRootFromParent_Done,
      // Label 5497: @273505
      GIM_Try, /*On fail goto*//*Label 5498*/ GIMT_Encode4(273542), // Rule ID 5186 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGT:{ *:[Other] })  =>  (CMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5186,
        GIR_EraseRootFromParent_Done,
      // Label 5498: @273542
      GIM_Try, /*On fail goto*//*Label 5499*/ GIMT_Encode4(273579), // Rule ID 5193 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGE:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5193,
        GIR_EraseRootFromParent_Done,
      // Label 5499: @273579
      GIM_Try, /*On fail goto*//*Label 5500*/ GIMT_Encode4(273616), // Rule ID 5200 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETLT:{ *:[Other] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5200,
        GIR_EraseRootFromParent_Done,
      // Label 5500: @273616
      GIM_Try, /*On fail goto*//*Label 5501*/ GIMT_Encode4(273653), // Rule ID 5207 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETLE:{ *:[Other] })  =>  (CMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i64rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5207,
        GIR_EraseRootFromParent_Done,
      // Label 5501: @273653
      GIM_Try, /*On fail goto*//*Label 5502*/ GIMT_Encode4(273682), // Rule ID 5116 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5116,
        GIR_EraseRootFromParent_Done,
      // Label 5502: @273682
      GIM_Try, /*On fail goto*//*Label 5503*/ GIMT_Encode4(273711), // Rule ID 5123 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5123,
        GIR_EraseRootFromParent_Done,
      // Label 5503: @273711
      GIM_Try, /*On fail goto*//*Label 5504*/ GIMT_Encode4(273740), // Rule ID 5130 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5130,
        GIR_EraseRootFromParent_Done,
      // Label 5504: @273740
      GIM_Try, /*On fail goto*//*Label 5505*/ GIMT_Encode4(273769), // Rule ID 5137 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5137,
        GIR_EraseRootFromParent_Done,
      // Label 5505: @273769
      GIM_Try, /*On fail goto*//*Label 5506*/ GIMT_Encode4(273798), // Rule ID 5144 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5144,
        GIR_EraseRootFromParent_Done,
      // Label 5506: @273798
      GIM_Try, /*On fail goto*//*Label 5507*/ GIMT_Encode4(273827), // Rule ID 5151 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5151,
        GIR_EraseRootFromParent_Done,
      // Label 5507: @273827
      GIM_Try, /*On fail goto*//*Label 5508*/ GIMT_Encode4(273856), // Rule ID 5158 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5158,
        GIR_EraseRootFromParent_Done,
      // Label 5508: @273856
      GIM_Try, /*On fail goto*//*Label 5509*/ GIMT_Encode4(273885), // Rule ID 5165 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5165,
        GIR_EraseRootFromParent_Done,
      // Label 5509: @273885
      GIM_Try, /*On fail goto*//*Label 5510*/ GIMT_Encode4(273914), // Rule ID 5172 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5172,
        GIR_EraseRootFromParent_Done,
      // Label 5510: @273914
      GIM_Reject,
    // Label 5491: @273915
    GIM_Reject,
    // Label 5465: @273916
    GIM_Try, /*On fail goto*//*Label 5511*/ GIMT_Encode4(274563),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 5512*/ GIMT_Encode4(273968), // Rule ID 5210 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5210,
        GIR_EraseRootFromParent_Done,
      // Label 5512: @273968
      GIM_Try, /*On fail goto*//*Label 5513*/ GIMT_Encode4(274005), // Rule ID 5217 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5217,
        GIR_EraseRootFromParent_Done,
      // Label 5513: @274005
      GIM_Try, /*On fail goto*//*Label 5514*/ GIMT_Encode4(274042), // Rule ID 5224 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i16rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5224,
        GIR_EraseRootFromParent_Done,
      // Label 5514: @274042
      GIM_Try, /*On fail goto*//*Label 5515*/ GIMT_Encode4(274079), // Rule ID 5231 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5231,
        GIR_EraseRootFromParent_Done,
      // Label 5515: @274079
      GIM_Try, /*On fail goto*//*Label 5516*/ GIMT_Encode4(274116), // Rule ID 5238 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5238,
        GIR_EraseRootFromParent_Done,
      // Label 5516: @274116
      GIM_Try, /*On fail goto*//*Label 5517*/ GIMT_Encode4(274153), // Rule ID 5175 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5175,
        GIR_EraseRootFromParent_Done,
      // Label 5517: @274153
      GIM_Try, /*On fail goto*//*Label 5518*/ GIMT_Encode4(274190), // Rule ID 5182 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGT:{ *:[Other] })  =>  (CMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5182,
        GIR_EraseRootFromParent_Done,
      // Label 5518: @274190
      GIM_Try, /*On fail goto*//*Label 5519*/ GIMT_Encode4(274227), // Rule ID 5189 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGE:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5189,
        GIR_EraseRootFromParent_Done,
      // Label 5519: @274227
      GIM_Try, /*On fail goto*//*Label 5520*/ GIMT_Encode4(274264), // Rule ID 5196 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETLT:{ *:[Other] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5196,
        GIR_EraseRootFromParent_Done,
      // Label 5520: @274264
      GIM_Try, /*On fail goto*//*Label 5521*/ GIMT_Encode4(274301), // Rule ID 5203 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETLE:{ *:[Other] })  =>  (CMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i16rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5203,
        GIR_EraseRootFromParent_Done,
      // Label 5521: @274301
      GIM_Try, /*On fail goto*//*Label 5522*/ GIMT_Encode4(274330), // Rule ID 5112 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5112,
        GIR_EraseRootFromParent_Done,
      // Label 5522: @274330
      GIM_Try, /*On fail goto*//*Label 5523*/ GIMT_Encode4(274359), // Rule ID 5119 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5119,
        GIR_EraseRootFromParent_Done,
      // Label 5523: @274359
      GIM_Try, /*On fail goto*//*Label 5524*/ GIMT_Encode4(274388), // Rule ID 5126 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5126,
        GIR_EraseRootFromParent_Done,
      // Label 5524: @274388
      GIM_Try, /*On fail goto*//*Label 5525*/ GIMT_Encode4(274417), // Rule ID 5133 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5133,
        GIR_EraseRootFromParent_Done,
      // Label 5525: @274417
      GIM_Try, /*On fail goto*//*Label 5526*/ GIMT_Encode4(274446), // Rule ID 5140 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5140,
        GIR_EraseRootFromParent_Done,
      // Label 5526: @274446
      GIM_Try, /*On fail goto*//*Label 5527*/ GIMT_Encode4(274475), // Rule ID 5147 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5147,
        GIR_EraseRootFromParent_Done,
      // Label 5527: @274475
      GIM_Try, /*On fail goto*//*Label 5528*/ GIMT_Encode4(274504), // Rule ID 5154 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5154,
        GIR_EraseRootFromParent_Done,
      // Label 5528: @274504
      GIM_Try, /*On fail goto*//*Label 5529*/ GIMT_Encode4(274533), // Rule ID 5161 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5161,
        GIR_EraseRootFromParent_Done,
      // Label 5529: @274533
      GIM_Try, /*On fail goto*//*Label 5530*/ GIMT_Encode4(274562), // Rule ID 5168 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5168,
        GIR_EraseRootFromParent_Done,
      // Label 5530: @274562
      GIM_Reject,
    // Label 5511: @274563
    GIM_Reject,
    // Label 5466: @274564
    GIM_Try, /*On fail goto*//*Label 5531*/ GIMT_Encode4(275211),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 5532*/ GIMT_Encode4(274616), // Rule ID 5213 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5213,
        GIR_EraseRootFromParent_Done,
      // Label 5532: @274616
      GIM_Try, /*On fail goto*//*Label 5533*/ GIMT_Encode4(274653), // Rule ID 5220 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5220,
        GIR_EraseRootFromParent_Done,
      // Label 5533: @274653
      GIM_Try, /*On fail goto*//*Label 5534*/ GIMT_Encode4(274690), // Rule ID 5227 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i32rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5227,
        GIR_EraseRootFromParent_Done,
      // Label 5534: @274690
      GIM_Try, /*On fail goto*//*Label 5535*/ GIMT_Encode4(274727), // Rule ID 5234 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5234,
        GIR_EraseRootFromParent_Done,
      // Label 5535: @274727
      GIM_Try, /*On fail goto*//*Label 5536*/ GIMT_Encode4(274764), // Rule ID 5241 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5241,
        GIR_EraseRootFromParent_Done,
      // Label 5536: @274764
      GIM_Try, /*On fail goto*//*Label 5537*/ GIMT_Encode4(274801), // Rule ID 5178 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5178,
        GIR_EraseRootFromParent_Done,
      // Label 5537: @274801
      GIM_Try, /*On fail goto*//*Label 5538*/ GIMT_Encode4(274838), // Rule ID 5185 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGT:{ *:[Other] })  =>  (CMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5185,
        GIR_EraseRootFromParent_Done,
      // Label 5538: @274838
      GIM_Try, /*On fail goto*//*Label 5539*/ GIMT_Encode4(274875), // Rule ID 5192 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGE:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5192,
        GIR_EraseRootFromParent_Done,
      // Label 5539: @274875
      GIM_Try, /*On fail goto*//*Label 5540*/ GIMT_Encode4(274912), // Rule ID 5199 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETLT:{ *:[Other] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5199,
        GIR_EraseRootFromParent_Done,
      // Label 5540: @274912
      GIM_Try, /*On fail goto*//*Label 5541*/ GIMT_Encode4(274949), // Rule ID 5206 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETLE:{ *:[Other] })  =>  (CMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i32rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5206,
        GIR_EraseRootFromParent_Done,
      // Label 5541: @274949
      GIM_Try, /*On fail goto*//*Label 5542*/ GIMT_Encode4(274978), // Rule ID 5115 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5115,
        GIR_EraseRootFromParent_Done,
      // Label 5542: @274978
      GIM_Try, /*On fail goto*//*Label 5543*/ GIMT_Encode4(275007), // Rule ID 5122 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5122,
        GIR_EraseRootFromParent_Done,
      // Label 5543: @275007
      GIM_Try, /*On fail goto*//*Label 5544*/ GIMT_Encode4(275036), // Rule ID 5129 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5129,
        GIR_EraseRootFromParent_Done,
      // Label 5544: @275036
      GIM_Try, /*On fail goto*//*Label 5545*/ GIMT_Encode4(275065), // Rule ID 5136 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5136,
        GIR_EraseRootFromParent_Done,
      // Label 5545: @275065
      GIM_Try, /*On fail goto*//*Label 5546*/ GIMT_Encode4(275094), // Rule ID 5143 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5143,
        GIR_EraseRootFromParent_Done,
      // Label 5546: @275094
      GIM_Try, /*On fail goto*//*Label 5547*/ GIMT_Encode4(275123), // Rule ID 5150 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5150,
        GIR_EraseRootFromParent_Done,
      // Label 5547: @275123
      GIM_Try, /*On fail goto*//*Label 5548*/ GIMT_Encode4(275152), // Rule ID 5157 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5157,
        GIR_EraseRootFromParent_Done,
      // Label 5548: @275152
      GIM_Try, /*On fail goto*//*Label 5549*/ GIMT_Encode4(275181), // Rule ID 5164 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5164,
        GIR_EraseRootFromParent_Done,
      // Label 5549: @275181
      GIM_Try, /*On fail goto*//*Label 5550*/ GIMT_Encode4(275210), // Rule ID 5171 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5171,
        GIR_EraseRootFromParent_Done,
      // Label 5550: @275210
      GIM_Reject,
    // Label 5531: @275211
    GIM_Reject,
    // Label 5467: @275212
    GIM_Try, /*On fail goto*//*Label 5551*/ GIMT_Encode4(275859),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 5552*/ GIMT_Encode4(275264), // Rule ID 5208 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5208,
        GIR_EraseRootFromParent_Done,
      // Label 5552: @275264
      GIM_Try, /*On fail goto*//*Label 5553*/ GIMT_Encode4(275301), // Rule ID 5215 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5215,
        GIR_EraseRootFromParent_Done,
      // Label 5553: @275301
      GIM_Try, /*On fail goto*//*Label 5554*/ GIMT_Encode4(275338), // Rule ID 5222 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i8rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5222,
        GIR_EraseRootFromParent_Done,
      // Label 5554: @275338
      GIM_Try, /*On fail goto*//*Label 5555*/ GIMT_Encode4(275375), // Rule ID 5229 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5229,
        GIR_EraseRootFromParent_Done,
      // Label 5555: @275375
      GIM_Try, /*On fail goto*//*Label 5556*/ GIMT_Encode4(275412), // Rule ID 5236 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5236,
        GIR_EraseRootFromParent_Done,
      // Label 5556: @275412
      GIM_Try, /*On fail goto*//*Label 5557*/ GIMT_Encode4(275449), // Rule ID 5173 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5173,
        GIR_EraseRootFromParent_Done,
      // Label 5557: @275449
      GIM_Try, /*On fail goto*//*Label 5558*/ GIMT_Encode4(275486), // Rule ID 5180 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGT:{ *:[Other] })  =>  (CMGTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5180,
        GIR_EraseRootFromParent_Done,
      // Label 5558: @275486
      GIM_Try, /*On fail goto*//*Label 5559*/ GIMT_Encode4(275523), // Rule ID 5187 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGE:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5187,
        GIR_EraseRootFromParent_Done,
      // Label 5559: @275523
      GIM_Try, /*On fail goto*//*Label 5560*/ GIMT_Encode4(275560), // Rule ID 5194 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETLT:{ *:[Other] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5194,
        GIR_EraseRootFromParent_Done,
      // Label 5560: @275560
      GIM_Try, /*On fail goto*//*Label 5561*/ GIMT_Encode4(275597), // Rule ID 5201 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETLE:{ *:[Other] })  =>  (CMLEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i8rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5201,
        GIR_EraseRootFromParent_Done,
      // Label 5561: @275597
      GIM_Try, /*On fail goto*//*Label 5562*/ GIMT_Encode4(275626), // Rule ID 5110 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5110,
        GIR_EraseRootFromParent_Done,
      // Label 5562: @275626
      GIM_Try, /*On fail goto*//*Label 5563*/ GIMT_Encode4(275655), // Rule ID 5117 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5117,
        GIR_EraseRootFromParent_Done,
      // Label 5563: @275655
      GIM_Try, /*On fail goto*//*Label 5564*/ GIMT_Encode4(275684), // Rule ID 5124 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5124,
        GIR_EraseRootFromParent_Done,
      // Label 5564: @275684
      GIM_Try, /*On fail goto*//*Label 5565*/ GIMT_Encode4(275713), // Rule ID 5131 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5131,
        GIR_EraseRootFromParent_Done,
      // Label 5565: @275713
      GIM_Try, /*On fail goto*//*Label 5566*/ GIMT_Encode4(275742), // Rule ID 5138 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5138,
        GIR_EraseRootFromParent_Done,
      // Label 5566: @275742
      GIM_Try, /*On fail goto*//*Label 5567*/ GIMT_Encode4(275771), // Rule ID 5145 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5145,
        GIR_EraseRootFromParent_Done,
      // Label 5567: @275771
      GIM_Try, /*On fail goto*//*Label 5568*/ GIMT_Encode4(275800), // Rule ID 5152 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5152,
        GIR_EraseRootFromParent_Done,
      // Label 5568: @275800
      GIM_Try, /*On fail goto*//*Label 5569*/ GIMT_Encode4(275829), // Rule ID 5159 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5159,
        GIR_EraseRootFromParent_Done,
      // Label 5569: @275829
      GIM_Try, /*On fail goto*//*Label 5570*/ GIMT_Encode4(275858), // Rule ID 5166 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5166,
        GIR_EraseRootFromParent_Done,
      // Label 5570: @275858
      GIM_Reject,
    // Label 5551: @275859
    GIM_Reject,
    // Label 5468: @275860
    GIM_Try, /*On fail goto*//*Label 5571*/ GIMT_Encode4(276507),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 5572*/ GIMT_Encode4(275912), // Rule ID 5211 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5211,
        GIR_EraseRootFromParent_Done,
      // Label 5572: @275912
      GIM_Try, /*On fail goto*//*Label 5573*/ GIMT_Encode4(275949), // Rule ID 5218 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5218,
        GIR_EraseRootFromParent_Done,
      // Label 5573: @275949
      GIM_Try, /*On fail goto*//*Label 5574*/ GIMT_Encode4(275986), // Rule ID 5225 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i16rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5225,
        GIR_EraseRootFromParent_Done,
      // Label 5574: @275986
      GIM_Try, /*On fail goto*//*Label 5575*/ GIMT_Encode4(276023), // Rule ID 5232 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5232,
        GIR_EraseRootFromParent_Done,
      // Label 5575: @276023
      GIM_Try, /*On fail goto*//*Label 5576*/ GIMT_Encode4(276060), // Rule ID 5239 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5239,
        GIR_EraseRootFromParent_Done,
      // Label 5576: @276060
      GIM_Try, /*On fail goto*//*Label 5577*/ GIMT_Encode4(276097), // Rule ID 5176 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5176,
        GIR_EraseRootFromParent_Done,
      // Label 5577: @276097
      GIM_Try, /*On fail goto*//*Label 5578*/ GIMT_Encode4(276134), // Rule ID 5183 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGT:{ *:[Other] })  =>  (CMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5183,
        GIR_EraseRootFromParent_Done,
      // Label 5578: @276134
      GIM_Try, /*On fail goto*//*Label 5579*/ GIMT_Encode4(276171), // Rule ID 5190 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGE:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5190,
        GIR_EraseRootFromParent_Done,
      // Label 5579: @276171
      GIM_Try, /*On fail goto*//*Label 5580*/ GIMT_Encode4(276208), // Rule ID 5197 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETLT:{ *:[Other] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5197,
        GIR_EraseRootFromParent_Done,
      // Label 5580: @276208
      GIM_Try, /*On fail goto*//*Label 5581*/ GIMT_Encode4(276245), // Rule ID 5204 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETLE:{ *:[Other] })  =>  (CMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i16rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5204,
        GIR_EraseRootFromParent_Done,
      // Label 5581: @276245
      GIM_Try, /*On fail goto*//*Label 5582*/ GIMT_Encode4(276274), // Rule ID 5113 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5113,
        GIR_EraseRootFromParent_Done,
      // Label 5582: @276274
      GIM_Try, /*On fail goto*//*Label 5583*/ GIMT_Encode4(276303), // Rule ID 5120 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5120,
        GIR_EraseRootFromParent_Done,
      // Label 5583: @276303
      GIM_Try, /*On fail goto*//*Label 5584*/ GIMT_Encode4(276332), // Rule ID 5127 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5127,
        GIR_EraseRootFromParent_Done,
      // Label 5584: @276332
      GIM_Try, /*On fail goto*//*Label 5585*/ GIMT_Encode4(276361), // Rule ID 5134 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5134,
        GIR_EraseRootFromParent_Done,
      // Label 5585: @276361
      GIM_Try, /*On fail goto*//*Label 5586*/ GIMT_Encode4(276390), // Rule ID 5141 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5141,
        GIR_EraseRootFromParent_Done,
      // Label 5586: @276390
      GIM_Try, /*On fail goto*//*Label 5587*/ GIMT_Encode4(276419), // Rule ID 5148 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5148,
        GIR_EraseRootFromParent_Done,
      // Label 5587: @276419
      GIM_Try, /*On fail goto*//*Label 5588*/ GIMT_Encode4(276448), // Rule ID 5155 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5155,
        GIR_EraseRootFromParent_Done,
      // Label 5588: @276448
      GIM_Try, /*On fail goto*//*Label 5589*/ GIMT_Encode4(276477), // Rule ID 5162 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5162,
        GIR_EraseRootFromParent_Done,
      // Label 5589: @276477
      GIM_Try, /*On fail goto*//*Label 5590*/ GIMT_Encode4(276506), // Rule ID 5169 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5169,
        GIR_EraseRootFromParent_Done,
      // Label 5590: @276506
      GIM_Reject,
    // Label 5571: @276507
    GIM_Reject,
    // Label 5469: @276508
    GIM_Try, /*On fail goto*//*Label 5591*/ GIMT_Encode4(277155),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 5592*/ GIMT_Encode4(276560), // Rule ID 5209 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5209,
        GIR_EraseRootFromParent_Done,
      // Label 5592: @276560
      GIM_Try, /*On fail goto*//*Label 5593*/ GIMT_Encode4(276597), // Rule ID 5216 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5216,
        GIR_EraseRootFromParent_Done,
      // Label 5593: @276597
      GIM_Try, /*On fail goto*//*Label 5594*/ GIMT_Encode4(276634), // Rule ID 5223 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv16i8rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5223,
        GIR_EraseRootFromParent_Done,
      // Label 5594: @276634
      GIM_Try, /*On fail goto*//*Label 5595*/ GIMT_Encode4(276671), // Rule ID 5230 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5230,
        GIR_EraseRootFromParent_Done,
      // Label 5595: @276671
      GIM_Try, /*On fail goto*//*Label 5596*/ GIMT_Encode4(276708), // Rule ID 5237 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5237,
        GIR_EraseRootFromParent_Done,
      // Label 5596: @276708
      GIM_Try, /*On fail goto*//*Label 5597*/ GIMT_Encode4(276745), // Rule ID 5174 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5174,
        GIR_EraseRootFromParent_Done,
      // Label 5597: @276745
      GIM_Try, /*On fail goto*//*Label 5598*/ GIMT_Encode4(276782), // Rule ID 5181 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGT:{ *:[Other] })  =>  (CMGTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5181,
        GIR_EraseRootFromParent_Done,
      // Label 5598: @276782
      GIM_Try, /*On fail goto*//*Label 5599*/ GIMT_Encode4(276819), // Rule ID 5188 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGE:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5188,
        GIR_EraseRootFromParent_Done,
      // Label 5599: @276819
      GIM_Try, /*On fail goto*//*Label 5600*/ GIMT_Encode4(276856), // Rule ID 5195 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETLT:{ *:[Other] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5195,
        GIR_EraseRootFromParent_Done,
      // Label 5600: @276856
      GIM_Try, /*On fail goto*//*Label 5601*/ GIMT_Encode4(276893), // Rule ID 5202 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETLE:{ *:[Other] })  =>  (CMLEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv16i8rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5202,
        GIR_EraseRootFromParent_Done,
      // Label 5601: @276893
      GIM_Try, /*On fail goto*//*Label 5602*/ GIMT_Encode4(276922), // Rule ID 5111 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5111,
        GIR_EraseRootFromParent_Done,
      // Label 5602: @276922
      GIM_Try, /*On fail goto*//*Label 5603*/ GIMT_Encode4(276951), // Rule ID 5118 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5118,
        GIR_EraseRootFromParent_Done,
      // Label 5603: @276951
      GIM_Try, /*On fail goto*//*Label 5604*/ GIMT_Encode4(276980), // Rule ID 5125 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5125,
        GIR_EraseRootFromParent_Done,
      // Label 5604: @276980
      GIM_Try, /*On fail goto*//*Label 5605*/ GIMT_Encode4(277009), // Rule ID 5132 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5132,
        GIR_EraseRootFromParent_Done,
      // Label 5605: @277009
      GIM_Try, /*On fail goto*//*Label 5606*/ GIMT_Encode4(277038), // Rule ID 5139 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5139,
        GIR_EraseRootFromParent_Done,
      // Label 5606: @277038
      GIM_Try, /*On fail goto*//*Label 5607*/ GIMT_Encode4(277067), // Rule ID 5146 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5146,
        GIR_EraseRootFromParent_Done,
      // Label 5607: @277067
      GIM_Try, /*On fail goto*//*Label 5608*/ GIMT_Encode4(277096), // Rule ID 5153 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5153,
        GIR_EraseRootFromParent_Done,
      // Label 5608: @277096
      GIM_Try, /*On fail goto*//*Label 5609*/ GIMT_Encode4(277125), // Rule ID 5160 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5160,
        GIR_EraseRootFromParent_Done,
      // Label 5609: @277125
      GIM_Try, /*On fail goto*//*Label 5610*/ GIMT_Encode4(277154), // Rule ID 5167 //
        // MIs[0] Operand 1
        GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rm
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5167,
        GIR_EraseRootFromParent_Done,
      // Label 5610: @277154
      GIM_Reject,
    // Label 5591: @277155
    GIM_Reject,
    // Label 5470: @277156
    GIM_Reject,
    // Label 47: @277157
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(12), GIMT_Encode2(24), /*)*//*default:*//*Label 5623*/ GIMT_Encode4(277884),
    /*GILLT_nxv1s1*//*Label 5611*/ GIMT_Encode4(277216),
    /*GILLT_nxv2s1*//*Label 5612*/ GIMT_Encode4(277245),
    /*GILLT_nxv2s16*//*Label 5613*/ GIMT_Encode4(277274),
    /*GILLT_nxv2s32*//*Label 5614*/ GIMT_Encode4(277303),
    /*GILLT_nxv2s64*//*Label 5615*/ GIMT_Encode4(277332),
    /*GILLT_nxv4s1*//*Label 5616*/ GIMT_Encode4(277441),
    /*GILLT_nxv4s16*//*Label 5617*/ GIMT_Encode4(277470),
    /*GILLT_nxv4s32*//*Label 5618*/ GIMT_Encode4(277499),
    /*GILLT_nxv8s1*//*Label 5619*/ GIMT_Encode4(277608),
    /*GILLT_nxv8s16*//*Label 5620*/ GIMT_Encode4(277637),
    /*GILLT_nxv16s1*//*Label 5621*/ GIMT_Encode4(277768),
    /*GILLT_nxv16s8*//*Label 5622*/ GIMT_Encode4(277797),
    // Label 5611: @277216
    GIM_Try, /*On fail goto*//*Label 5624*/ GIMT_Encode4(277244), // Rule ID 8605 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
      // (vselect:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8605,
      GIR_Done,
    // Label 5624: @277244
    GIM_Reject,
    // Label 5612: @277245
    GIM_Try, /*On fail goto*//*Label 5625*/ GIMT_Encode4(277273), // Rule ID 8604 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
      // (vselect:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8604,
      GIR_Done,
    // Label 5625: @277273
    GIM_Reject,
    // Label 5613: @277274
    GIM_Try, /*On fail goto*//*Label 5626*/ GIMT_Encode4(277302), // Rule ID 2701 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (vselect:{ *:[nxv2f16] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2701,
      GIR_Done,
    // Label 5626: @277302
    GIM_Reject,
    // Label 5614: @277303
    GIM_Try, /*On fail goto*//*Label 5627*/ GIMT_Encode4(277331), // Rule ID 2702 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (vselect:{ *:[nxv2f32] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2702,
      GIR_Done,
    // Label 5627: @277331
    GIM_Reject,
    // Label 5615: @277332
    GIM_Try, /*On fail goto*//*Label 5628*/ GIMT_Encode4(277440),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_Try, /*On fail goto*//*Label 5629*/ GIMT_Encode4(277395), // Rule ID 7628 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
        // MIs[0] Op2
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vselect:{ *:[nxv2i64] } nxv2i1:{ *:[nxv2i1] }:$Op1, (sub:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7628,
        GIR_EraseRootFromParent_Done,
      // Label 5629: @277395
      GIM_Try, /*On fail goto*//*Label 5630*/ GIMT_Encode4(277417), // Rule ID 2697 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (vselect:{ *:[nxv2i64] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2697,
        GIR_Done,
      // Label 5630: @277417
      GIM_Try, /*On fail goto*//*Label 5631*/ GIMT_Encode4(277439), // Rule ID 2703 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (vselect:{ *:[nxv2f64] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2703,
        GIR_Done,
      // Label 5631: @277439
      GIM_Reject,
    // Label 5628: @277440
    GIM_Reject,
    // Label 5616: @277441
    GIM_Try, /*On fail goto*//*Label 5632*/ GIMT_Encode4(277469), // Rule ID 8603 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
      // (vselect:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8603,
      GIR_Done,
    // Label 5632: @277469
    GIM_Reject,
    // Label 5617: @277470
    GIM_Try, /*On fail goto*//*Label 5633*/ GIMT_Encode4(277498), // Rule ID 2699 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (vselect:{ *:[nxv4f16] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (SEL_ZPZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_S),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2699,
      GIR_Done,
    // Label 5633: @277498
    GIM_Reject,
    // Label 5618: @277499
    GIM_Try, /*On fail goto*//*Label 5634*/ GIMT_Encode4(277607),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_Try, /*On fail goto*//*Label 5635*/ GIMT_Encode4(277562), // Rule ID 7626 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
        // MIs[0] Op2
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vselect:{ *:[nxv4i32] } nxv4i1:{ *:[nxv4i1] }:$Op1, (sub:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7626,
        GIR_EraseRootFromParent_Done,
      // Label 5635: @277562
      GIM_Try, /*On fail goto*//*Label 5636*/ GIMT_Encode4(277584), // Rule ID 2696 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (vselect:{ *:[nxv4i32] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SEL_ZPZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_S),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2696,
        GIR_Done,
      // Label 5636: @277584
      GIM_Try, /*On fail goto*//*Label 5637*/ GIMT_Encode4(277606), // Rule ID 2700 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (vselect:{ *:[nxv4f32] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (SEL_ZPZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_S),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2700,
        GIR_Done,
      // Label 5637: @277606
      GIM_Reject,
    // Label 5634: @277607
    GIM_Reject,
    // Label 5619: @277608
    GIM_Try, /*On fail goto*//*Label 5638*/ GIMT_Encode4(277636), // Rule ID 8602 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
      // (vselect:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8602,
      GIR_Done,
    // Label 5638: @277636
    GIM_Reject,
    // Label 5620: @277637
    GIM_Try, /*On fail goto*//*Label 5639*/ GIMT_Encode4(277767),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_Try, /*On fail goto*//*Label 5640*/ GIMT_Encode4(277700), // Rule ID 7624 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
        // MIs[0] Op2
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vselect:{ *:[nxv8i16] } nxv8i1:{ *:[nxv8i1] }:$Op1, (sub:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7624,
        GIR_EraseRootFromParent_Done,
      // Label 5640: @277700
      GIM_Try, /*On fail goto*//*Label 5641*/ GIMT_Encode4(277722), // Rule ID 2695 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (vselect:{ *:[nxv8i16] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SEL_ZPZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2695,
        GIR_Done,
      // Label 5641: @277722
      GIM_Try, /*On fail goto*//*Label 5642*/ GIMT_Encode4(277744), // Rule ID 2698 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (vselect:{ *:[nxv8f16] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (SEL_ZPZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2698,
        GIR_Done,
      // Label 5642: @277744
      GIM_Try, /*On fail goto*//*Label 5643*/ GIMT_Encode4(277766), // Rule ID 2704 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (vselect:{ *:[nxv8bf16] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2, nxv8bf16:{ *:[nxv8bf16] }:$Op3)  =>  (SEL_ZPZZ_H:{ *:[nxv8bf16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2, ?:{ *:[nxv8bf16] }:$Op3)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2704,
        GIR_Done,
      // Label 5643: @277766
      GIM_Reject,
    // Label 5639: @277767
    GIM_Reject,
    // Label 5621: @277768
    GIM_Try, /*On fail goto*//*Label 5644*/ GIMT_Encode4(277796), // Rule ID 8601 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
      // (vselect:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8601,
      GIR_Done,
    // Label 5644: @277796
    GIM_Reject,
    // Label 5622: @277797
    GIM_Try, /*On fail goto*//*Label 5645*/ GIMT_Encode4(277883),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_Try, /*On fail goto*//*Label 5646*/ GIMT_Encode4(277860), // Rule ID 7622 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
        // MIs[0] Op2
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vselect:{ *:[nxv16i8] } nxv16i1:{ *:[nxv16i1] }:$Op1, (sub:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
        GIR_RootToRootCopy, /*OpIdx*/1, // Op1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7622,
        GIR_EraseRootFromParent_Done,
      // Label 5646: @277860
      GIM_Try, /*On fail goto*//*Label 5647*/ GIMT_Encode4(277882), // Rule ID 2694 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        // (vselect:{ *:[nxv16i8] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SEL_ZPZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2694,
        GIR_Done,
      // Label 5647: @277882
      GIM_Reject,
    // Label 5645: @277883
    GIM_Reject,
    // Label 5623: @277884
    GIM_Reject,
    // Label 48: @277885
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 5652*/ GIMT_Encode4(278368),
    /*GILLT_s64*//*Label 5648*/ GIMT_Encode4(277932), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_v4s32*//*Label 5649*/ GIMT_Encode4(277963), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 5650*/ GIMT_Encode4(278098),
    /*GILLT_v16s8*//*Label 5651*/ GIMT_Encode4(278233),
    // Label 5648: @277932
    GIM_Try, /*On fail goto*//*Label 5653*/ GIMT_Encode4(277962), // Rule ID 140 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (mulhu:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UMULHrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULHrr),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 140,
      GIR_Done,
    // Label 5653: @277962
    GIM_Reject,
    // Label 5649: @277963
    GIM_Try, /*On fail goto*//*Label 5654*/ GIMT_Encode4(278097), // Rule ID 6593 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (mulhu:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4i32] } (UMULLv2i32_v2i64:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rm, dsub:{ *:[i32] })), (UMULLv4i32_v2i64:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_v2i64),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_v2i64),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6593,
      GIR_EraseRootFromParent_Done,
    // Label 5654: @278097
    GIM_Reject,
    // Label 5650: @278098
    GIM_Try, /*On fail goto*//*Label 5655*/ GIMT_Encode4(278232), // Rule ID 6592 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (mulhu:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8i16] } (UMULLv4i16_v4i32:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rm, dsub:{ *:[i32] })), (UMULLv8i16_v4i32:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_v4i32),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_v4i32),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6592,
      GIR_EraseRootFromParent_Done,
    // Label 5655: @278232
    GIM_Reject,
    // Label 5651: @278233
    GIM_Try, /*On fail goto*//*Label 5656*/ GIMT_Encode4(278367), // Rule ID 6591 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (mulhu:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP2v16i8:{ *:[v16i8] } (UMULLv8i8_v8i16:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rm, dsub:{ *:[i32] })), (UMULLv16i8_v8i16:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMULLv16i8_v8i16),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i8_v8i16),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6591,
      GIR_EraseRootFromParent_Done,
    // Label 5656: @278367
    GIM_Reject,
    // Label 5652: @278368
    GIM_Reject,
    // Label 49: @278369
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 5661*/ GIMT_Encode4(278852),
    /*GILLT_s64*//*Label 5657*/ GIMT_Encode4(278416), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_v4s32*//*Label 5658*/ GIMT_Encode4(278447), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 5659*/ GIMT_Encode4(278582),
    /*GILLT_v16s8*//*Label 5660*/ GIMT_Encode4(278717),
    // Label 5657: @278416
    GIM_Try, /*On fail goto*//*Label 5662*/ GIMT_Encode4(278446), // Rule ID 139 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (mulhs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SMULHrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULHrr),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 139,
      GIR_Done,
    // Label 5662: @278446
    GIM_Reject,
    // Label 5658: @278447
    GIM_Try, /*On fail goto*//*Label 5663*/ GIMT_Encode4(278581), // Rule ID 6590 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (mulhs:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4i32] } (SMULLv2i32_v2i64:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rm, dsub:{ *:[i32] })), (SMULLv4i32_v2i64:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_v2i64),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_v2i64),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6590,
      GIR_EraseRootFromParent_Done,
    // Label 5663: @278581
    GIM_Reject,
    // Label 5659: @278582
    GIM_Try, /*On fail goto*//*Label 5664*/ GIMT_Encode4(278716), // Rule ID 6589 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (mulhs:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8i16] } (SMULLv4i16_v4i32:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rm, dsub:{ *:[i32] })), (SMULLv8i16_v4i32:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_v4i32),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_v4i32),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6589,
      GIR_EraseRootFromParent_Done,
    // Label 5664: @278716
    GIM_Reject,
    // Label 5660: @278717
    GIM_Try, /*On fail goto*//*Label 5665*/ GIMT_Encode4(278851), // Rule ID 6588 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (mulhs:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP2v16i8:{ *:[v16i8] } (SMULLv8i8_v8i16:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rm, dsub:{ *:[i32] })), (SMULLv16i8_v8i16:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SMULLv16i8_v8i16),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i8_v8i16),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6588,
      GIR_EraseRootFromParent_Done,
    // Label 5665: @278851
    GIM_Reject,
    // Label 5661: @278852
    GIM_Reject,
    // Label 50: @278853
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 5677*/ GIMT_Encode4(279282),
    /*GILLT_v2s32*//*Label 5666*/ GIMT_Encode4(278940),
    /*GILLT_v2s64*//*Label 5667*/ GIMT_Encode4(278974),
    /*GILLT_v4s16*//*Label 5668*/ GIMT_Encode4(279008),
    /*GILLT_v4s32*//*Label 5669*/ GIMT_Encode4(279042),
    /*GILLT_v8s8*//*Label 5670*/ GIMT_Encode4(279076),
    /*GILLT_v8s16*//*Label 5671*/ GIMT_Encode4(279110),
    /*GILLT_v16s8*//*Label 5672*/ GIMT_Encode4(279144), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s64*//*Label 5673*/ GIMT_Encode4(279178), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv4s32*//*Label 5674*/ GIMT_Encode4(279204), GIMT_Encode4(0),
    /*GILLT_nxv8s16*//*Label 5675*/ GIMT_Encode4(279230), GIMT_Encode4(0),
    /*GILLT_nxv16s8*//*Label 5676*/ GIMT_Encode4(279256),
    // Label 5666: @278940
    GIM_Try, /*On fail goto*//*Label 5678*/ GIMT_Encode4(278973), // Rule ID 5059 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (uaddsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (UQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5059,
      GIR_Done,
    // Label 5678: @278973
    GIM_Reject,
    // Label 5667: @278974
    GIM_Try, /*On fail goto*//*Label 5679*/ GIMT_Encode4(279007), // Rule ID 5063 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (uaddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (UQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i64),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5063,
      GIR_Done,
    // Label 5679: @279007
    GIM_Reject,
    // Label 5668: @279008
    GIM_Try, /*On fail goto*//*Label 5680*/ GIMT_Encode4(279041), // Rule ID 5058 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (uaddsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (UQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5058,
      GIR_Done,
    // Label 5680: @279041
    GIM_Reject,
    // Label 5669: @279042
    GIM_Try, /*On fail goto*//*Label 5681*/ GIMT_Encode4(279075), // Rule ID 5062 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (uaddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (UQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5062,
      GIR_Done,
    // Label 5681: @279075
    GIM_Reject,
    // Label 5670: @279076
    GIM_Try, /*On fail goto*//*Label 5682*/ GIMT_Encode4(279109), // Rule ID 5057 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (uaddsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)  =>  (UQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5057,
      GIR_Done,
    // Label 5682: @279109
    GIM_Reject,
    // Label 5671: @279110
    GIM_Try, /*On fail goto*//*Label 5683*/ GIMT_Encode4(279143), // Rule ID 5061 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (uaddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (UQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5061,
      GIR_Done,
    // Label 5683: @279143
    GIM_Reject,
    // Label 5672: @279144
    GIM_Try, /*On fail goto*//*Label 5684*/ GIMT_Encode4(279177), // Rule ID 5060 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (uaddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)  =>  (UQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5060,
      GIR_Done,
    // Label 5684: @279177
    GIM_Reject,
    // Label 5673: @279178
    GIM_Try, /*On fail goto*//*Label 5685*/ GIMT_Encode4(279203), // Rule ID 7580 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (uaddsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UQADD_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_D),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7580,
      GIR_Done,
    // Label 5685: @279203
    GIM_Reject,
    // Label 5674: @279204
    GIM_Try, /*On fail goto*//*Label 5686*/ GIMT_Encode4(279229), // Rule ID 7579 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (uaddsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UQADD_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_S),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7579,
      GIR_Done,
    // Label 5686: @279229
    GIM_Reject,
    // Label 5675: @279230
    GIM_Try, /*On fail goto*//*Label 5687*/ GIMT_Encode4(279255), // Rule ID 7578 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (uaddsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UQADD_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_H),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7578,
      GIR_Done,
    // Label 5687: @279255
    GIM_Reject,
    // Label 5676: @279256
    GIM_Try, /*On fail goto*//*Label 5688*/ GIMT_Encode4(279281), // Rule ID 7577 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (uaddsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UQADD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_B),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7577,
      GIR_Done,
    // Label 5688: @279281
    GIM_Reject,
    // Label 5677: @279282
    GIM_Reject,
    // Label 51: @279283
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 5700*/ GIMT_Encode4(279712),
    /*GILLT_v2s32*//*Label 5689*/ GIMT_Encode4(279370),
    /*GILLT_v2s64*//*Label 5690*/ GIMT_Encode4(279404),
    /*GILLT_v4s16*//*Label 5691*/ GIMT_Encode4(279438),
    /*GILLT_v4s32*//*Label 5692*/ GIMT_Encode4(279472),
    /*GILLT_v8s8*//*Label 5693*/ GIMT_Encode4(279506),
    /*GILLT_v8s16*//*Label 5694*/ GIMT_Encode4(279540),
    /*GILLT_v16s8*//*Label 5695*/ GIMT_Encode4(279574), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s64*//*Label 5696*/ GIMT_Encode4(279608), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv4s32*//*Label 5697*/ GIMT_Encode4(279634), GIMT_Encode4(0),
    /*GILLT_nxv8s16*//*Label 5698*/ GIMT_Encode4(279660), GIMT_Encode4(0),
    /*GILLT_nxv16s8*//*Label 5699*/ GIMT_Encode4(279686),
    // Label 5689: @279370
    GIM_Try, /*On fail goto*//*Label 5701*/ GIMT_Encode4(279403), // Rule ID 2446 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (saddsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (SQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2446,
      GIR_Done,
    // Label 5701: @279403
    GIM_Reject,
    // Label 5690: @279404
    GIM_Try, /*On fail goto*//*Label 5702*/ GIMT_Encode4(279437), // Rule ID 2450 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (saddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (SQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i64),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2450,
      GIR_Done,
    // Label 5702: @279437
    GIM_Reject,
    // Label 5691: @279438
    GIM_Try, /*On fail goto*//*Label 5703*/ GIMT_Encode4(279471), // Rule ID 2445 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (saddsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (SQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2445,
      GIR_Done,
    // Label 5703: @279471
    GIM_Reject,
    // Label 5692: @279472
    GIM_Try, /*On fail goto*//*Label 5704*/ GIMT_Encode4(279505), // Rule ID 2449 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (saddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (SQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2449,
      GIR_Done,
    // Label 5704: @279505
    GIM_Reject,
    // Label 5693: @279506
    GIM_Try, /*On fail goto*//*Label 5705*/ GIMT_Encode4(279539), // Rule ID 2444 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (saddsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)  =>  (SQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2444,
      GIR_Done,
    // Label 5705: @279539
    GIM_Reject,
    // Label 5694: @279540
    GIM_Try, /*On fail goto*//*Label 5706*/ GIMT_Encode4(279573), // Rule ID 2448 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (saddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (SQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2448,
      GIR_Done,
    // Label 5706: @279573
    GIM_Reject,
    // Label 5695: @279574
    GIM_Try, /*On fail goto*//*Label 5707*/ GIMT_Encode4(279607), // Rule ID 2447 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (saddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)  =>  (SQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2447,
      GIR_Done,
    // Label 5707: @279607
    GIM_Reject,
    // Label 5696: @279608
    GIM_Try, /*On fail goto*//*Label 5708*/ GIMT_Encode4(279633), // Rule ID 7576 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (saddsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQADD_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_D),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7576,
      GIR_Done,
    // Label 5708: @279633
    GIM_Reject,
    // Label 5697: @279634
    GIM_Try, /*On fail goto*//*Label 5709*/ GIMT_Encode4(279659), // Rule ID 7575 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (saddsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQADD_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_S),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7575,
      GIR_Done,
    // Label 5709: @279659
    GIM_Reject,
    // Label 5698: @279660
    GIM_Try, /*On fail goto*//*Label 5710*/ GIMT_Encode4(279685), // Rule ID 7574 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (saddsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQADD_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_H),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7574,
      GIR_Done,
    // Label 5710: @279685
    GIM_Reject,
    // Label 5699: @279686
    GIM_Try, /*On fail goto*//*Label 5711*/ GIMT_Encode4(279711), // Rule ID 7573 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (saddsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQADD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_B),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7573,
      GIR_Done,
    // Label 5711: @279711
    GIM_Reject,
    // Label 5700: @279712
    GIM_Reject,
    // Label 52: @279713
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 5723*/ GIMT_Encode4(280142),
    /*GILLT_v2s32*//*Label 5712*/ GIMT_Encode4(279800),
    /*GILLT_v2s64*//*Label 5713*/ GIMT_Encode4(279834),
    /*GILLT_v4s16*//*Label 5714*/ GIMT_Encode4(279868),
    /*GILLT_v4s32*//*Label 5715*/ GIMT_Encode4(279902),
    /*GILLT_v8s8*//*Label 5716*/ GIMT_Encode4(279936),
    /*GILLT_v8s16*//*Label 5717*/ GIMT_Encode4(279970),
    /*GILLT_v16s8*//*Label 5718*/ GIMT_Encode4(280004), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s64*//*Label 5719*/ GIMT_Encode4(280038), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv4s32*//*Label 5720*/ GIMT_Encode4(280064), GIMT_Encode4(0),
    /*GILLT_nxv8s16*//*Label 5721*/ GIMT_Encode4(280090), GIMT_Encode4(0),
    /*GILLT_nxv16s8*//*Label 5722*/ GIMT_Encode4(280116),
    // Label 5712: @279800
    GIM_Try, /*On fail goto*//*Label 5724*/ GIMT_Encode4(279833), // Rule ID 5073 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (usubsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (UQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5073,
      GIR_Done,
    // Label 5724: @279833
    GIM_Reject,
    // Label 5713: @279834
    GIM_Try, /*On fail goto*//*Label 5725*/ GIMT_Encode4(279867), // Rule ID 5077 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (usubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (UQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i64),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5077,
      GIR_Done,
    // Label 5725: @279867
    GIM_Reject,
    // Label 5714: @279868
    GIM_Try, /*On fail goto*//*Label 5726*/ GIMT_Encode4(279901), // Rule ID 5072 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (usubsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (UQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5072,
      GIR_Done,
    // Label 5726: @279901
    GIM_Reject,
    // Label 5715: @279902
    GIM_Try, /*On fail goto*//*Label 5727*/ GIMT_Encode4(279935), // Rule ID 5076 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (usubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (UQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5076,
      GIR_Done,
    // Label 5727: @279935
    GIM_Reject,
    // Label 5716: @279936
    GIM_Try, /*On fail goto*//*Label 5728*/ GIMT_Encode4(279969), // Rule ID 5071 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (usubsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)  =>  (UQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5071,
      GIR_Done,
    // Label 5728: @279969
    GIM_Reject,
    // Label 5717: @279970
    GIM_Try, /*On fail goto*//*Label 5729*/ GIMT_Encode4(280003), // Rule ID 5075 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (usubsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (UQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5075,
      GIR_Done,
    // Label 5729: @280003
    GIM_Reject,
    // Label 5718: @280004
    GIM_Try, /*On fail goto*//*Label 5730*/ GIMT_Encode4(280037), // Rule ID 5074 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (usubsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)  =>  (UQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5074,
      GIR_Done,
    // Label 5730: @280037
    GIM_Reject,
    // Label 5719: @280038
    GIM_Try, /*On fail goto*//*Label 5731*/ GIMT_Encode4(280063), // Rule ID 7588 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (usubsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UQSUB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_D),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7588,
      GIR_Done,
    // Label 5731: @280063
    GIM_Reject,
    // Label 5720: @280064
    GIM_Try, /*On fail goto*//*Label 5732*/ GIMT_Encode4(280089), // Rule ID 7587 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (usubsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UQSUB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_S),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7587,
      GIR_Done,
    // Label 5732: @280089
    GIM_Reject,
    // Label 5721: @280090
    GIM_Try, /*On fail goto*//*Label 5733*/ GIMT_Encode4(280115), // Rule ID 7586 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (usubsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UQSUB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_H),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7586,
      GIR_Done,
    // Label 5733: @280115
    GIM_Reject,
    // Label 5722: @280116
    GIM_Try, /*On fail goto*//*Label 5734*/ GIMT_Encode4(280141), // Rule ID 7585 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (usubsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UQSUB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_B),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7585,
      GIR_Done,
    // Label 5734: @280141
    GIM_Reject,
    // Label 5723: @280142
    GIM_Reject,
    // Label 53: @280143
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 5746*/ GIMT_Encode4(280572),
    /*GILLT_v2s32*//*Label 5735*/ GIMT_Encode4(280230),
    /*GILLT_v2s64*//*Label 5736*/ GIMT_Encode4(280264),
    /*GILLT_v4s16*//*Label 5737*/ GIMT_Encode4(280298),
    /*GILLT_v4s32*//*Label 5738*/ GIMT_Encode4(280332),
    /*GILLT_v8s8*//*Label 5739*/ GIMT_Encode4(280366),
    /*GILLT_v8s16*//*Label 5740*/ GIMT_Encode4(280400),
    /*GILLT_v16s8*//*Label 5741*/ GIMT_Encode4(280434), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s64*//*Label 5742*/ GIMT_Encode4(280468), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv4s32*//*Label 5743*/ GIMT_Encode4(280494), GIMT_Encode4(0),
    /*GILLT_nxv8s16*//*Label 5744*/ GIMT_Encode4(280520), GIMT_Encode4(0),
    /*GILLT_nxv16s8*//*Label 5745*/ GIMT_Encode4(280546),
    // Label 5735: @280230
    GIM_Try, /*On fail goto*//*Label 5747*/ GIMT_Encode4(280263), // Rule ID 5066 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (ssubsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (SQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5066,
      GIR_Done,
    // Label 5747: @280263
    GIM_Reject,
    // Label 5736: @280264
    GIM_Try, /*On fail goto*//*Label 5748*/ GIMT_Encode4(280297), // Rule ID 5070 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (ssubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (SQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i64),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5070,
      GIR_Done,
    // Label 5748: @280297
    GIM_Reject,
    // Label 5737: @280298
    GIM_Try, /*On fail goto*//*Label 5749*/ GIMT_Encode4(280331), // Rule ID 5065 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (ssubsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (SQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5065,
      GIR_Done,
    // Label 5749: @280331
    GIM_Reject,
    // Label 5738: @280332
    GIM_Try, /*On fail goto*//*Label 5750*/ GIMT_Encode4(280365), // Rule ID 5069 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (ssubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (SQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5069,
      GIR_Done,
    // Label 5750: @280365
    GIM_Reject,
    // Label 5739: @280366
    GIM_Try, /*On fail goto*//*Label 5751*/ GIMT_Encode4(280399), // Rule ID 5064 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (ssubsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)  =>  (SQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5064,
      GIR_Done,
    // Label 5751: @280399
    GIM_Reject,
    // Label 5740: @280400
    GIM_Try, /*On fail goto*//*Label 5752*/ GIMT_Encode4(280433), // Rule ID 5068 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (ssubsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (SQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5068,
      GIR_Done,
    // Label 5752: @280433
    GIM_Reject,
    // Label 5741: @280434
    GIM_Try, /*On fail goto*//*Label 5753*/ GIMT_Encode4(280467), // Rule ID 5067 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (ssubsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)  =>  (SQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5067,
      GIR_Done,
    // Label 5753: @280467
    GIM_Reject,
    // Label 5742: @280468
    GIM_Try, /*On fail goto*//*Label 5754*/ GIMT_Encode4(280493), // Rule ID 7584 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (ssubsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQSUB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_D),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7584,
      GIR_Done,
    // Label 5754: @280493
    GIM_Reject,
    // Label 5743: @280494
    GIM_Try, /*On fail goto*//*Label 5755*/ GIMT_Encode4(280519), // Rule ID 7583 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (ssubsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQSUB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_S),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7583,
      GIR_Done,
    // Label 5755: @280519
    GIM_Reject,
    // Label 5744: @280520
    GIM_Try, /*On fail goto*//*Label 5756*/ GIMT_Encode4(280545), // Rule ID 7582 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (ssubsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQSUB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_H),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7582,
      GIR_Done,
    // Label 5756: @280545
    GIM_Reject,
    // Label 5745: @280546
    GIM_Try, /*On fail goto*//*Label 5757*/ GIMT_Encode4(280571), // Rule ID 7581 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (ssubsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQSUB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_B),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7581,
      GIR_Done,
    // Label 5757: @280571
    GIM_Reject,
    // Label 5746: @280572
    GIM_Reject,
    // Label 54: @280573
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 5771*/ GIMT_Encode4(283736),
    /*GILLT_s16*//*Label 5758*/ GIMT_Encode4(280668),
    /*GILLT_s32*//*Label 5759*/ GIMT_Encode4(280894),
    /*GILLT_s64*//*Label 5760*/ GIMT_Encode4(281248), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 5761*/ GIMT_Encode4(281420),
    /*GILLT_v2s64*//*Label 5762*/ GIMT_Encode4(281458),
    /*GILLT_v4s16*//*Label 5763*/ GIMT_Encode4(281634),
    /*GILLT_v4s32*//*Label 5764*/ GIMT_Encode4(281672), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 5765*/ GIMT_Encode4(281848), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s16*//*Label 5766*/ GIMT_Encode4(283585), GIMT_Encode4(0),
    /*GILLT_nxv2s64*//*Label 5767*/ GIMT_Encode4(283611), GIMT_Encode4(0),
    /*GILLT_nxv4s16*//*Label 5768*/ GIMT_Encode4(283637),
    /*GILLT_nxv4s32*//*Label 5769*/ GIMT_Encode4(283663), GIMT_Encode4(0),
    /*GILLT_nxv8s16*//*Label 5770*/ GIMT_Encode4(283689),
    // Label 5758: @280668
    GIM_Try, /*On fail goto*//*Label 5772*/ GIMT_Encode4(280893),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_Try, /*On fail goto*//*Label 5773*/ GIMT_Encode4(280774), // Rule ID 7074 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        // MIs[2] Rn
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7074,
        GIR_EraseRootFromParent_Done,
      // Label 5773: @280774
      GIM_Try, /*On fail goto*//*Label 5774*/ GIMT_Encode4(280865), // Rule ID 14016 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        // MIs[2] Rn
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14016,
        GIR_EraseRootFromParent_Done,
      // Label 5774: @280865
      GIM_Try, /*On fail goto*//*Label 5775*/ GIMT_Encode4(280892), // Rule ID 580 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (fadd:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FADDHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDHrr),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 580,
        GIR_Done,
      // Label 5775: @280892
      GIM_Reject,
    // Label 5772: @280893
    GIM_Reject,
    // Label 5759: @280894
    GIM_Try, /*On fail goto*//*Label 5776*/ GIMT_Encode4(281247),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 5777*/ GIMT_Encode4(281000), // Rule ID 7072 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        // MIs[2] Rn
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7072,
        GIR_EraseRootFromParent_Done,
      // Label 5777: @281000
      GIM_Try, /*On fail goto*//*Label 5778*/ GIMT_Encode4(281064), // Rule ID 13187 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        // MIs[2] Rn
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13187,
        GIR_EraseRootFromParent_Done,
      // Label 5778: @281064
      GIM_Try, /*On fail goto*//*Label 5779*/ GIMT_Encode4(281155), // Rule ID 14014 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        // MIs[2] Rn
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14014,
        GIR_EraseRootFromParent_Done,
      // Label 5779: @281155
      GIM_Try, /*On fail goto*//*Label 5780*/ GIMT_Encode4(281219), // Rule ID 15693 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        // MIs[2] Rn
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15693,
        GIR_EraseRootFromParent_Done,
      // Label 5780: @281219
      GIM_Try, /*On fail goto*//*Label 5781*/ GIMT_Encode4(281246), // Rule ID 582 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (fadd:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FADDSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDSrr),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 582,
        GIR_Done,
      // Label 5781: @281246
      GIM_Reject,
    // Label 5776: @281247
    GIM_Reject,
    // Label 5760: @281248
    GIM_Try, /*On fail goto*//*Label 5782*/ GIMT_Encode4(281419),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 5783*/ GIMT_Encode4(281327), // Rule ID 7070 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        // MIs[2] Rn
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7070,
        GIR_EraseRootFromParent_Done,
      // Label 5783: @281327
      GIM_Try, /*On fail goto*//*Label 5784*/ GIMT_Encode4(281391), // Rule ID 14012 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        // MIs[2] Rn
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14012,
        GIR_EraseRootFromParent_Done,
      // Label 5784: @281391
      GIM_Try, /*On fail goto*//*Label 5785*/ GIMT_Encode4(281418), // Rule ID 584 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (fadd:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FADDDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDDrr),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 584,
        GIR_Done,
      // Label 5785: @281418
      GIM_Reject,
    // Label 5782: @281419
    GIM_Reject,
    // Label 5761: @281420
    GIM_Try, /*On fail goto*//*Label 5786*/ GIMT_Encode4(281457), // Rule ID 1192 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fadd:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1192,
      GIR_Done,
    // Label 5786: @281457
    GIM_Reject,
    // Label 5762: @281458
    GIM_Try, /*On fail goto*//*Label 5787*/ GIMT_Encode4(281633),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 5788*/ GIMT_Encode4(281539), // Rule ID 7092 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP1),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP2),
        // MIs[2] Rn
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[2] Rm
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fadd:{ *:[v2f64] } (AArch64zip1:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm), (AArch64zip2:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm))  =>  (FADDPv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7092,
        GIR_EraseRootFromParent_Done,
      // Label 5788: @281539
      GIM_Try, /*On fail goto*//*Label 5789*/ GIMT_Encode4(281605), // Rule ID 14024 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP2),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP1),
        // MIs[2] Rn
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[2] Rm
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fadd:{ *:[v2f64] } (AArch64zip2:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm), (AArch64zip1:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm))  =>  (FADDPv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14024,
        GIR_EraseRootFromParent_Done,
      // Label 5789: @281605
      GIM_Try, /*On fail goto*//*Label 5790*/ GIMT_Encode4(281632), // Rule ID 1196 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (fadd:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f64),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1196,
        GIR_Done,
      // Label 5790: @281632
      GIM_Reject,
    // Label 5787: @281633
    GIM_Reject,
    // Label 5763: @281634
    GIM_Try, /*On fail goto*//*Label 5791*/ GIMT_Encode4(281671), // Rule ID 1188 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fadd:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1188,
      GIR_Done,
    // Label 5791: @281671
    GIM_Reject,
    // Label 5764: @281672
    GIM_Try, /*On fail goto*//*Label 5792*/ GIMT_Encode4(281847),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 5793*/ GIMT_Encode4(281753), // Rule ID 7093 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
        // MIs[2] Rn
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[2] Rm
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fadd:{ *:[v4f32] } (AArch64uzp1:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm), (AArch64uzp2:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm))  =>  (FADDPv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7093,
        GIR_EraseRootFromParent_Done,
      // Label 5793: @281753
      GIM_Try, /*On fail goto*//*Label 5794*/ GIMT_Encode4(281819), // Rule ID 14025 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
        // MIs[2] Rn
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[2] Rm
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fadd:{ *:[v4f32] } (AArch64uzp2:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm), (AArch64uzp1:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm))  =>  (FADDPv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14025,
        GIR_EraseRootFromParent_Done,
      // Label 5794: @281819
      GIM_Try, /*On fail goto*//*Label 5795*/ GIMT_Encode4(281846), // Rule ID 1194 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (fadd:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1194,
        GIR_Done,
      // Label 5795: @281846
      GIM_Reject,
    // Label 5792: @281847
    GIM_Reject,
    // Label 5765: @281848
    GIM_Try, /*On fail goto*//*Label 5796*/ GIMT_Encode4(283584),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 5797*/ GIMT_Encode4(281932), // Rule ID 7094 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
        // MIs[2] Rn
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[2] Rm
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fadd:{ *:[v8f16] } (AArch64uzp1:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm), (AArch64uzp2:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm))  =>  (FADDPv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7094,
        GIR_EraseRootFromParent_Done,
      // Label 5797: @281932
      GIM_Try, /*On fail goto*//*Label 5798*/ GIMT_Encode4(282001), // Rule ID 14026 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
        // MIs[2] Rn
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[2] Rm
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fadd:{ *:[v8f16] } (AArch64uzp2:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm), (AArch64uzp1:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm))  =>  (FADDPv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14026,
        GIR_EraseRootFromParent_Done,
      // Label 5798: @282001
      GIM_Try, /*On fail goto*//*Label 5799*/ GIMT_Encode4(282028), // Rule ID 1190 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv8f16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1190,
        GIR_Done,
      // Label 5799: @282028
      GIM_Try, /*On fail goto*//*Label 5800*/ GIMT_Encode4(282290), // Rule ID 7185 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FADDv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FADDv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
        GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
        GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
        GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
        GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7185,
        GIR_EraseRootFromParent_Done,
      // Label 5800: @282290
      GIM_Try, /*On fail goto*//*Label 5801*/ GIMT_Encode4(282502), // Rule ID 7187 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (fadd:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)  =>  (BFCVTN2:{ *:[v8bf16] } (BFCVTN:{ *:[v8bf16] } (FADDv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] })))), (FADDv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm)))
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/8,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::BFCVTN),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFCVTN2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7187,
        GIR_EraseRootFromParent_Done,
      // Label 5801: @282502
      GIM_Try, /*On fail goto*//*Label 5802*/ GIMT_Encode4(283583), // Rule ID 7189 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoBF16),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (fadd:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8bf16] } (BSPv16i8:{ *:[f128] } (FCMEQv4f32:{ *:[f128] } (FADDv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] }))), (FADDv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] })))), (ADDv4i32:{ *:[f128] } (ADDv4i32:{ *:[f128] } (FADDv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] }))), (ANDv16i8:{ *:[f128] } (USHRv4i32_shift:{ *:[f128] } V128:{ *:[v8bf16] }:$Rn, 16:{ *:[i32] }), (MOVIv4i32:{ *:[f128] } 1:{ *:[i32] }, 0:{ *:[i32] }))), (MOVIv4s_msl:{ *:[f128] } 127:{ *:[i32] }, 264:{ *:[i32] })), (ORRv4i32:{ *:[f128] } (FADDv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] }))), 64:{ *:[i32] }, 16:{ *:[i32] })), (BSPv16i8:{ *:[f128] } (FCMEQv4f32:{ *:[f128] } (FADDv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm)), (FADDv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm))), (ADDv4i32:{ *:[f128] } (ADDv4i32:{ *:[f128] } (FADDv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm)), (ANDv16i8:{ *:[f128] } (USHRv4i32_shift:{ *:[f128] } V128:{ *:[v8bf16] }:$Rn, 16:{ *:[i32] }), (MOVIv4i32:{ *:[f128] } 1:{ *:[i32] }, 0:{ *:[i32] }))), (MOVIv4s_msl:{ *:[f128] } 127:{ *:[i32] }, 264:{ *:[i32] })), (ORRv4i32:{ *:[f128] } (FADDv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm)), 64:{ *:[i32] }, 16:{ *:[i32] })))
        GIR_MakeTempReg, /*TempRegID*/49, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/50, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/50, /*TempRegID*/49, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/50, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/50,
        GIR_MakeTempReg, /*TempRegID*/48, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/49, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/49, /*TempRegID*/48, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/49, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/49,
        GIR_MakeTempReg, /*TempRegID*/47, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/48, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
        GIR_AddTempRegister, /*InsnID*/48, /*TempRegID*/47, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/48, /*TempRegID*/48,
        GIR_AddSimpleTempRegister, /*InsnID*/48, /*TempRegID*/49,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/48,
        GIR_MakeTempReg, /*TempRegID*/46, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/47, /*Opcode*/GIMT_Encode2(AArch64::ORRv4i32),
        GIR_AddTempRegister, /*InsnID*/47, /*TempRegID*/46, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/47, /*TempRegID*/47,
        GIR_AddImm8, /*InsnID*/47, /*Imm*/64,
        GIR_AddImm8, /*InsnID*/47, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/47,
        GIR_MakeTempReg, /*TempRegID*/45, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/46, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4s_msl),
        GIR_AddTempRegister, /*InsnID*/46, /*TempRegID*/45, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/46, /*Imm*/127,
        GIR_AddImm, /*InsnID*/46, /*Imm*/GIMT_Encode8(264),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/46,
        GIR_MakeTempReg, /*TempRegID*/44, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/45, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i32),
        GIR_AddTempRegister, /*InsnID*/45, /*TempRegID*/44, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/45, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/45, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/45,
        GIR_MakeTempReg, /*TempRegID*/43, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/44, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
        GIR_AddTempRegister, /*InsnID*/44, /*TempRegID*/43, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/44, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/44, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/44,
        GIR_MakeTempReg, /*TempRegID*/42, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/43, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
        GIR_AddTempRegister, /*InsnID*/43, /*TempRegID*/42, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/43, /*TempRegID*/43,
        GIR_AddSimpleTempRegister, /*InsnID*/43, /*TempRegID*/44,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/43,
        GIR_MakeTempReg, /*TempRegID*/41, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/42, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/42, /*TempRegID*/41, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/42, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/42,
        GIR_MakeTempReg, /*TempRegID*/40, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/41, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/41, /*TempRegID*/40, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/41, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/41,
        GIR_MakeTempReg, /*TempRegID*/39, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/40, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
        GIR_AddTempRegister, /*InsnID*/40, /*TempRegID*/39, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/40, /*TempRegID*/40,
        GIR_AddSimpleTempRegister, /*InsnID*/40, /*TempRegID*/41,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/40,
        GIR_MakeTempReg, /*TempRegID*/38, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/39, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/39, /*TempRegID*/38, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/39, /*TempRegID*/39,
        GIR_AddSimpleTempRegister, /*InsnID*/39, /*TempRegID*/42,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/39,
        GIR_MakeTempReg, /*TempRegID*/37, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/38, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/38, /*TempRegID*/37, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/38, /*TempRegID*/38,
        GIR_AddSimpleTempRegister, /*InsnID*/38, /*TempRegID*/45,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/38,
        GIR_MakeTempReg, /*TempRegID*/36, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/37, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/37, /*TempRegID*/36, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/37, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/37,
        GIR_MakeTempReg, /*TempRegID*/35, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/36, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/36, /*TempRegID*/35, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/36, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/36,
        GIR_MakeTempReg, /*TempRegID*/34, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/35, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
        GIR_AddTempRegister, /*InsnID*/35, /*TempRegID*/34, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/35, /*TempRegID*/35,
        GIR_AddSimpleTempRegister, /*InsnID*/35, /*TempRegID*/36,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/35,
        GIR_MakeTempReg, /*TempRegID*/33, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/34, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/34, /*TempRegID*/33, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/34, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/34,
        GIR_MakeTempReg, /*TempRegID*/32, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/33, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/33, /*TempRegID*/32, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/33, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/33,
        GIR_MakeTempReg, /*TempRegID*/31, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/32, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
        GIR_AddTempRegister, /*InsnID*/32, /*TempRegID*/31, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/32, /*TempRegID*/32,
        GIR_AddSimpleTempRegister, /*InsnID*/32, /*TempRegID*/33,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/32,
        GIR_MakeTempReg, /*TempRegID*/30, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/31, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
        GIR_AddTempRegister, /*InsnID*/31, /*TempRegID*/30, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/31, /*TempRegID*/31,
        GIR_AddSimpleTempRegister, /*InsnID*/31, /*TempRegID*/34,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/31,
        GIR_MakeTempReg, /*TempRegID*/29, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/30, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_AddTempRegister, /*InsnID*/30, /*TempRegID*/29, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/30, /*TempRegID*/30,
        GIR_AddSimpleTempRegister, /*InsnID*/30, /*TempRegID*/37,
        GIR_AddSimpleTempRegister, /*InsnID*/30, /*TempRegID*/46,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/30,
        GIR_MakeTempReg, /*TempRegID*/28, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/29, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/29, /*TempRegID*/28, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/29, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/29, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/29, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/27, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/28, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/28, /*TempRegID*/27, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/28, /*TempRegID*/28,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/28,
        GIR_MakeTempReg, /*TempRegID*/26, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/27, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/27, /*TempRegID*/26, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/27, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/27, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/27, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/25, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/26, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/26, /*TempRegID*/25, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/26, /*TempRegID*/26,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/26,
        GIR_MakeTempReg, /*TempRegID*/24, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/25, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
        GIR_AddTempRegister, /*InsnID*/25, /*TempRegID*/24, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/25, /*TempRegID*/25,
        GIR_AddSimpleTempRegister, /*InsnID*/25, /*TempRegID*/27,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/25,
        GIR_MakeTempReg, /*TempRegID*/23, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/24, /*Opcode*/GIMT_Encode2(AArch64::ORRv4i32),
        GIR_AddTempRegister, /*InsnID*/24, /*TempRegID*/23, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/24, /*TempRegID*/24,
        GIR_AddImm8, /*InsnID*/24, /*Imm*/64,
        GIR_AddImm8, /*InsnID*/24, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/24,
        GIR_MakeTempReg, /*TempRegID*/22, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/23, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4s_msl),
        GIR_AddTempRegister, /*InsnID*/23, /*TempRegID*/22, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/23, /*Imm*/127,
        GIR_AddImm, /*InsnID*/23, /*Imm*/GIMT_Encode8(264),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/23,
        GIR_MakeTempReg, /*TempRegID*/21, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/22, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i32),
        GIR_AddTempRegister, /*InsnID*/22, /*TempRegID*/21, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/22, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/22, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/22,
        GIR_MakeTempReg, /*TempRegID*/20, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/21, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
        GIR_AddTempRegister, /*InsnID*/21, /*TempRegID*/20, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/21, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/21, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/21,
        GIR_MakeTempReg, /*TempRegID*/19, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/20, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
        GIR_AddTempRegister, /*InsnID*/20, /*TempRegID*/19, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/20, /*TempRegID*/20,
        GIR_AddSimpleTempRegister, /*InsnID*/20, /*TempRegID*/21,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/20,
        GIR_MakeTempReg, /*TempRegID*/18, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/19, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/19, /*TempRegID*/18, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/19, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/19, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/19, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/17, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/18, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/18, /*TempRegID*/17, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/18, /*TempRegID*/18,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/18,
        GIR_MakeTempReg, /*TempRegID*/16, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/17, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/17, /*TempRegID*/16, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/17, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/17, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/17, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/15, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/16, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/16, /*TempRegID*/15, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/16, /*TempRegID*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/16,
        GIR_MakeTempReg, /*TempRegID*/14, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/15, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
        GIR_AddTempRegister, /*InsnID*/15, /*TempRegID*/14, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/15, /*TempRegID*/15,
        GIR_AddSimpleTempRegister, /*InsnID*/15, /*TempRegID*/17,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/15,
        GIR_MakeTempReg, /*TempRegID*/13, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/14, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/14, /*TempRegID*/13, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/14,
        GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/19,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/14,
        GIR_MakeTempReg, /*TempRegID*/12, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/13, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/13, /*TempRegID*/12, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/13, /*TempRegID*/13,
        GIR_AddSimpleTempRegister, /*InsnID*/13, /*TempRegID*/22,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/13,
        GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/11, /*TempRegID*/11,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
        GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
        GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/10,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/12,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/23,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/29,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7189,
        GIR_EraseRootFromParent_Done,
      // Label 5802: @283583
      GIM_Reject,
    // Label 5796: @283584
    GIM_Reject,
    // Label 5766: @283585
    GIM_Try, /*On fail goto*//*Label 5803*/ GIMT_Encode4(283610), // Rule ID 2794 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEB16B16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (fadd:{ *:[nxv2bf16] } nxv2bf16:{ *:[nxv2bf16] }:$Op1, nxv2bf16:{ *:[nxv2bf16] }:$Op2)  =>  (BFADD_ZZZ:{ *:[nxv2bf16] } ?:{ *:[nxv2bf16] }:$Op1, ?:{ *:[nxv2bf16] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BFADD_ZZZ),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2794,
      GIR_Done,
    // Label 5803: @283610
    GIM_Reject,
    // Label 5767: @283611
    GIM_Try, /*On fail goto*//*Label 5804*/ GIMT_Encode4(283636), // Rule ID 2788 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (fadd:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FADD_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZZZ_D),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2788,
      GIR_Done,
    // Label 5804: @283636
    GIM_Reject,
    // Label 5768: @283637
    GIM_Try, /*On fail goto*//*Label 5805*/ GIMT_Encode4(283662), // Rule ID 2792 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEB16B16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (fadd:{ *:[nxv4bf16] } nxv4bf16:{ *:[nxv4bf16] }:$Op1, nxv4bf16:{ *:[nxv4bf16] }:$Op2)  =>  (BFADD_ZZZ:{ *:[nxv4bf16] } ?:{ *:[nxv4bf16] }:$Op1, ?:{ *:[nxv4bf16] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BFADD_ZZZ),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2792,
      GIR_Done,
    // Label 5805: @283662
    GIM_Reject,
    // Label 5769: @283663
    GIM_Try, /*On fail goto*//*Label 5806*/ GIMT_Encode4(283688), // Rule ID 2786 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (fadd:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FADD_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZZZ_S),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2786,
      GIR_Done,
    // Label 5806: @283688
    GIM_Reject,
    // Label 5770: @283689
    GIM_Try, /*On fail goto*//*Label 5807*/ GIMT_Encode4(283735),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 5808*/ GIMT_Encode4(283719), // Rule ID 2784 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (fadd:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FADD_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZZZ_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2784,
        GIR_Done,
      // Label 5808: @283719
      GIM_Try, /*On fail goto*//*Label 5809*/ GIMT_Encode4(283734), // Rule ID 2790 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEB16B16),
        // (fadd:{ *:[nxv8bf16] } nxv8bf16:{ *:[nxv8bf16] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2)  =>  (BFADD_ZZZ:{ *:[nxv8bf16] } ?:{ *:[nxv8bf16] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BFADD_ZZZ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2790,
        GIR_Done,
      // Label 5809: @283734
      GIM_Reject,
    // Label 5807: @283735
    GIM_Reject,
    // Label 5771: @283736
    GIM_Reject,
    // Label 55: @283737
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 5823*/ GIMT_Encode4(285824),
    /*GILLT_s16*//*Label 5810*/ GIMT_Encode4(283832),
    /*GILLT_s32*//*Label 5811*/ GIMT_Encode4(283870),
    /*GILLT_s64*//*Label 5812*/ GIMT_Encode4(283908), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 5813*/ GIMT_Encode4(283946),
    /*GILLT_v2s64*//*Label 5814*/ GIMT_Encode4(283984),
    /*GILLT_v4s16*//*Label 5815*/ GIMT_Encode4(284022),
    /*GILLT_v4s32*//*Label 5816*/ GIMT_Encode4(284060), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 5817*/ GIMT_Encode4(284098), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s16*//*Label 5818*/ GIMT_Encode4(285673), GIMT_Encode4(0),
    /*GILLT_nxv2s64*//*Label 5819*/ GIMT_Encode4(285699), GIMT_Encode4(0),
    /*GILLT_nxv4s16*//*Label 5820*/ GIMT_Encode4(285725),
    /*GILLT_nxv4s32*//*Label 5821*/ GIMT_Encode4(285751), GIMT_Encode4(0),
    /*GILLT_nxv8s16*//*Label 5822*/ GIMT_Encode4(285777),
    // Label 5810: @283832
    GIM_Try, /*On fail goto*//*Label 5824*/ GIMT_Encode4(283869), // Rule ID 628 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // (fsub:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FSUBHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBHrr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 628,
      GIR_Done,
    // Label 5824: @283869
    GIM_Reject,
    // Label 5811: @283870
    GIM_Try, /*On fail goto*//*Label 5825*/ GIMT_Encode4(283907), // Rule ID 630 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      // (fsub:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FSUBSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBSrr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 630,
      GIR_Done,
    // Label 5825: @283907
    GIM_Reject,
    // Label 5812: @283908
    GIM_Try, /*On fail goto*//*Label 5826*/ GIMT_Encode4(283945), // Rule ID 632 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fsub:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FSUBDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBDrr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 632,
      GIR_Done,
    // Label 5826: @283945
    GIM_Reject,
    // Label 5813: @283946
    GIM_Try, /*On fail goto*//*Label 5827*/ GIMT_Encode4(283983), // Rule ID 1332 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fsub:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FSUBv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1332,
      GIR_Done,
    // Label 5827: @283983
    GIM_Reject,
    // Label 5814: @283984
    GIM_Try, /*On fail goto*//*Label 5828*/ GIMT_Encode4(284021), // Rule ID 1336 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fsub:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FSUBv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f64),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1336,
      GIR_Done,
    // Label 5828: @284021
    GIM_Reject,
    // Label 5815: @284022
    GIM_Try, /*On fail goto*//*Label 5829*/ GIMT_Encode4(284059), // Rule ID 1328 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fsub:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FSUBv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1328,
      GIR_Done,
    // Label 5829: @284059
    GIM_Reject,
    // Label 5816: @284060
    GIM_Try, /*On fail goto*//*Label 5830*/ GIMT_Encode4(284097), // Rule ID 1334 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fsub:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FSUBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1334,
      GIR_Done,
    // Label 5830: @284097
    GIM_Reject,
    // Label 5817: @284098
    GIM_Try, /*On fail goto*//*Label 5831*/ GIMT_Encode4(285672),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 5832*/ GIMT_Encode4(284140), // Rule ID 1330 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        // (fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FSUBv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv8f16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1330,
        GIR_Done,
      // Label 5832: @284140
      GIM_Try, /*On fail goto*//*Label 5833*/ GIMT_Encode4(284394), // Rule ID 7203 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
        // (fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FSUBv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FSUBv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
        GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
        GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
        GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
        GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7203,
        GIR_EraseRootFromParent_Done,
      // Label 5833: @284394
      GIM_Try, /*On fail goto*//*Label 5834*/ GIMT_Encode4(284598), // Rule ID 7205 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16),
        // (fsub:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)  =>  (BFCVTN2:{ *:[v8bf16] } (BFCVTN:{ *:[v8bf16] } (FSUBv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] })))), (FSUBv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm)))
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/8,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::BFCVTN),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFCVTN2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7205,
        GIR_EraseRootFromParent_Done,
      // Label 5834: @284598
      GIM_Try, /*On fail goto*//*Label 5835*/ GIMT_Encode4(285671), // Rule ID 7207 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoBF16),
        // (fsub:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8bf16] } (BSPv16i8:{ *:[f128] } (FCMEQv4f32:{ *:[f128] } (FSUBv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] }))), (FSUBv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] })))), (ADDv4i32:{ *:[f128] } (ADDv4i32:{ *:[f128] } (FSUBv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] }))), (ANDv16i8:{ *:[f128] } (USHRv4i32_shift:{ *:[f128] } V128:{ *:[v8bf16] }:$Rn, 16:{ *:[i32] }), (MOVIv4i32:{ *:[f128] } 1:{ *:[i32] }, 0:{ *:[i32] }))), (MOVIv4s_msl:{ *:[f128] } 127:{ *:[i32] }, 264:{ *:[i32] })), (ORRv4i32:{ *:[f128] } (FSUBv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] }))), 64:{ *:[i32] }, 16:{ *:[i32] })), (BSPv16i8:{ *:[f128] } (FCMEQv4f32:{ *:[f128] } (FSUBv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm)), (FSUBv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm))), (ADDv4i32:{ *:[f128] } (ADDv4i32:{ *:[f128] } (FSUBv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm)), (ANDv16i8:{ *:[f128] } (USHRv4i32_shift:{ *:[f128] } V128:{ *:[v8bf16] }:$Rn, 16:{ *:[i32] }), (MOVIv4i32:{ *:[f128] } 1:{ *:[i32] }, 0:{ *:[i32] }))), (MOVIv4s_msl:{ *:[f128] } 127:{ *:[i32] }, 264:{ *:[i32] })), (ORRv4i32:{ *:[f128] } (FSUBv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm)), 64:{ *:[i32] }, 16:{ *:[i32] })))
        GIR_MakeTempReg, /*TempRegID*/49, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/50, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/50, /*TempRegID*/49, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/50, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/50,
        GIR_MakeTempReg, /*TempRegID*/48, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/49, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/49, /*TempRegID*/48, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/49, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/49,
        GIR_MakeTempReg, /*TempRegID*/47, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/48, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
        GIR_AddTempRegister, /*InsnID*/48, /*TempRegID*/47, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/48, /*TempRegID*/48,
        GIR_AddSimpleTempRegister, /*InsnID*/48, /*TempRegID*/49,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/48,
        GIR_MakeTempReg, /*TempRegID*/46, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/47, /*Opcode*/GIMT_Encode2(AArch64::ORRv4i32),
        GIR_AddTempRegister, /*InsnID*/47, /*TempRegID*/46, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/47, /*TempRegID*/47,
        GIR_AddImm8, /*InsnID*/47, /*Imm*/64,
        GIR_AddImm8, /*InsnID*/47, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/47,
        GIR_MakeTempReg, /*TempRegID*/45, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/46, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4s_msl),
        GIR_AddTempRegister, /*InsnID*/46, /*TempRegID*/45, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/46, /*Imm*/127,
        GIR_AddImm, /*InsnID*/46, /*Imm*/GIMT_Encode8(264),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/46,
        GIR_MakeTempReg, /*TempRegID*/44, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/45, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i32),
        GIR_AddTempRegister, /*InsnID*/45, /*TempRegID*/44, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/45, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/45, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/45,
        GIR_MakeTempReg, /*TempRegID*/43, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/44, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
        GIR_AddTempRegister, /*InsnID*/44, /*TempRegID*/43, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/44, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/44, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/44,
        GIR_MakeTempReg, /*TempRegID*/42, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/43, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
        GIR_AddTempRegister, /*InsnID*/43, /*TempRegID*/42, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/43, /*TempRegID*/43,
        GIR_AddSimpleTempRegister, /*InsnID*/43, /*TempRegID*/44,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/43,
        GIR_MakeTempReg, /*TempRegID*/41, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/42, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/42, /*TempRegID*/41, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/42, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/42,
        GIR_MakeTempReg, /*TempRegID*/40, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/41, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/41, /*TempRegID*/40, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/41, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/41,
        GIR_MakeTempReg, /*TempRegID*/39, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/40, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
        GIR_AddTempRegister, /*InsnID*/40, /*TempRegID*/39, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/40, /*TempRegID*/40,
        GIR_AddSimpleTempRegister, /*InsnID*/40, /*TempRegID*/41,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/40,
        GIR_MakeTempReg, /*TempRegID*/38, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/39, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/39, /*TempRegID*/38, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/39, /*TempRegID*/39,
        GIR_AddSimpleTempRegister, /*InsnID*/39, /*TempRegID*/42,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/39,
        GIR_MakeTempReg, /*TempRegID*/37, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/38, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/38, /*TempRegID*/37, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/38, /*TempRegID*/38,
        GIR_AddSimpleTempRegister, /*InsnID*/38, /*TempRegID*/45,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/38,
        GIR_MakeTempReg, /*TempRegID*/36, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/37, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/37, /*TempRegID*/36, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/37, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/37,
        GIR_MakeTempReg, /*TempRegID*/35, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/36, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/36, /*TempRegID*/35, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/36, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/36,
        GIR_MakeTempReg, /*TempRegID*/34, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/35, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
        GIR_AddTempRegister, /*InsnID*/35, /*TempRegID*/34, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/35, /*TempRegID*/35,
        GIR_AddSimpleTempRegister, /*InsnID*/35, /*TempRegID*/36,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/35,
        GIR_MakeTempReg, /*TempRegID*/33, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/34, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/34, /*TempRegID*/33, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/34, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/34,
        GIR_MakeTempReg, /*TempRegID*/32, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/33, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/33, /*TempRegID*/32, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/33, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/33,
        GIR_MakeTempReg, /*TempRegID*/31, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/32, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
        GIR_AddTempRegister, /*InsnID*/32, /*TempRegID*/31, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/32, /*TempRegID*/32,
        GIR_AddSimpleTempRegister, /*InsnID*/32, /*TempRegID*/33,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/32,
        GIR_MakeTempReg, /*TempRegID*/30, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/31, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
        GIR_AddTempRegister, /*InsnID*/31, /*TempRegID*/30, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/31, /*TempRegID*/31,
        GIR_AddSimpleTempRegister, /*InsnID*/31, /*TempRegID*/34,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/31,
        GIR_MakeTempReg, /*TempRegID*/29, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/30, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_AddTempRegister, /*InsnID*/30, /*TempRegID*/29, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/30, /*TempRegID*/30,
        GIR_AddSimpleTempRegister, /*InsnID*/30, /*TempRegID*/37,
        GIR_AddSimpleTempRegister, /*InsnID*/30, /*TempRegID*/46,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/30,
        GIR_MakeTempReg, /*TempRegID*/28, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/29, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/29, /*TempRegID*/28, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/29, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/29, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/29, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/27, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/28, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/28, /*TempRegID*/27, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/28, /*TempRegID*/28,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/28,
        GIR_MakeTempReg, /*TempRegID*/26, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/27, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/27, /*TempRegID*/26, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/27, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/27, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/27, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/25, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/26, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/26, /*TempRegID*/25, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/26, /*TempRegID*/26,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/26,
        GIR_MakeTempReg, /*TempRegID*/24, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/25, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
        GIR_AddTempRegister, /*InsnID*/25, /*TempRegID*/24, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/25, /*TempRegID*/25,
        GIR_AddSimpleTempRegister, /*InsnID*/25, /*TempRegID*/27,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/25,
        GIR_MakeTempReg, /*TempRegID*/23, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/24, /*Opcode*/GIMT_Encode2(AArch64::ORRv4i32),
        GIR_AddTempRegister, /*InsnID*/24, /*TempRegID*/23, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/24, /*TempRegID*/24,
        GIR_AddImm8, /*InsnID*/24, /*Imm*/64,
        GIR_AddImm8, /*InsnID*/24, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/24,
        GIR_MakeTempReg, /*TempRegID*/22, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/23, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4s_msl),
        GIR_AddTempRegister, /*InsnID*/23, /*TempRegID*/22, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/23, /*Imm*/127,
        GIR_AddImm, /*InsnID*/23, /*Imm*/GIMT_Encode8(264),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/23,
        GIR_MakeTempReg, /*TempRegID*/21, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/22, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i32),
        GIR_AddTempRegister, /*InsnID*/22, /*TempRegID*/21, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/22, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/22, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/22,
        GIR_MakeTempReg, /*TempRegID*/20, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/21, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
        GIR_AddTempRegister, /*InsnID*/21, /*TempRegID*/20, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/21, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/21, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/21,
        GIR_MakeTempReg, /*TempRegID*/19, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/20, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
        GIR_AddTempRegister, /*InsnID*/20, /*TempRegID*/19, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/20, /*TempRegID*/20,
        GIR_AddSimpleTempRegister, /*InsnID*/20, /*TempRegID*/21,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/20,
        GIR_MakeTempReg, /*TempRegID*/18, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/19, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/19, /*TempRegID*/18, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/19, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/19, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/19, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/17, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/18, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/18, /*TempRegID*/17, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/18, /*TempRegID*/18,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/18,
        GIR_MakeTempReg, /*TempRegID*/16, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/17, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/17, /*TempRegID*/16, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/17, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/17, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/17, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/15, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/16, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/16, /*TempRegID*/15, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/16, /*TempRegID*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/16,
        GIR_MakeTempReg, /*TempRegID*/14, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/15, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
        GIR_AddTempRegister, /*InsnID*/15, /*TempRegID*/14, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/15, /*TempRegID*/15,
        GIR_AddSimpleTempRegister, /*InsnID*/15, /*TempRegID*/17,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/15,
        GIR_MakeTempReg, /*TempRegID*/13, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/14, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/14, /*TempRegID*/13, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/14,
        GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/19,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/14,
        GIR_MakeTempReg, /*TempRegID*/12, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/13, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/13, /*TempRegID*/12, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/13, /*TempRegID*/13,
        GIR_AddSimpleTempRegister, /*InsnID*/13, /*TempRegID*/22,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/13,
        GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/11, /*TempRegID*/11,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
        GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
        GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/10,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/12,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/23,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/29,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7207,
        GIR_EraseRootFromParent_Done,
      // Label 5835: @285671
      GIM_Reject,
    // Label 5831: @285672
    GIM_Reject,
    // Label 5818: @285673
    GIM_Try, /*On fail goto*//*Label 5836*/ GIMT_Encode4(285698), // Rule ID 12388 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEB16B16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (fsub:{ *:[nxv2bf16] } nxv2bf16:{ *:[nxv2bf16] }:$Op1, nxv2bf16:{ *:[nxv2bf16] }:$Op2)  =>  (BFSUB_ZZZ:{ *:[nxv2bf16] } ?:{ *:[nxv2bf16] }:$Op1, ?:{ *:[nxv2bf16] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BFSUB_ZZZ),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 12388,
      GIR_Done,
    // Label 5836: @285698
    GIM_Reject,
    // Label 5819: @285699
    GIM_Try, /*On fail goto*//*Label 5837*/ GIMT_Encode4(285724), // Rule ID 8333 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (fsub:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FSUB_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZZZ_D),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8333,
      GIR_Done,
    // Label 5837: @285724
    GIM_Reject,
    // Label 5820: @285725
    GIM_Try, /*On fail goto*//*Label 5838*/ GIMT_Encode4(285750), // Rule ID 12386 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEB16B16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (fsub:{ *:[nxv4bf16] } nxv4bf16:{ *:[nxv4bf16] }:$Op1, nxv4bf16:{ *:[nxv4bf16] }:$Op2)  =>  (BFSUB_ZZZ:{ *:[nxv4bf16] } ?:{ *:[nxv4bf16] }:$Op1, ?:{ *:[nxv4bf16] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BFSUB_ZZZ),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 12386,
      GIR_Done,
    // Label 5838: @285750
    GIM_Reject,
    // Label 5821: @285751
    GIM_Try, /*On fail goto*//*Label 5839*/ GIMT_Encode4(285776), // Rule ID 8331 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (fsub:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FSUB_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZZZ_S),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8331,
      GIR_Done,
    // Label 5839: @285776
    GIM_Reject,
    // Label 5822: @285777
    GIM_Try, /*On fail goto*//*Label 5840*/ GIMT_Encode4(285823),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 5841*/ GIMT_Encode4(285807), // Rule ID 8329 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (fsub:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FSUB_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZZZ_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8329,
        GIR_Done,
      // Label 5841: @285807
      GIM_Try, /*On fail goto*//*Label 5842*/ GIMT_Encode4(285822), // Rule ID 12384 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEB16B16),
        // (fsub:{ *:[nxv8bf16] } nxv8bf16:{ *:[nxv8bf16] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2)  =>  (BFSUB_ZZZ:{ *:[nxv8bf16] } ?:{ *:[nxv8bf16] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BFSUB_ZZZ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12384,
        GIR_Done,
      // Label 5842: @285822
      GIM_Reject,
    // Label 5840: @285823
    GIM_Reject,
    // Label 5823: @285824
    GIM_Reject,
    // Label 56: @285825
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 5856*/ GIMT_Encode4(291286),
    /*GILLT_s16*//*Label 5843*/ GIMT_Encode4(285920),
    /*GILLT_s32*//*Label 5844*/ GIMT_Encode4(286562),
    /*GILLT_s64*//*Label 5845*/ GIMT_Encode4(287192), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 5846*/ GIMT_Encode4(287822),
    /*GILLT_v2s64*//*Label 5847*/ GIMT_Encode4(288352),
    /*GILLT_v4s16*//*Label 5848*/ GIMT_Encode4(288710),
    /*GILLT_v4s32*//*Label 5849*/ GIMT_Encode4(289052), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 5850*/ GIMT_Encode4(289410), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s16*//*Label 5851*/ GIMT_Encode4(291135), GIMT_Encode4(0),
    /*GILLT_nxv2s64*//*Label 5852*/ GIMT_Encode4(291161), GIMT_Encode4(0),
    /*GILLT_nxv4s16*//*Label 5853*/ GIMT_Encode4(291187),
    /*GILLT_nxv4s32*//*Label 5854*/ GIMT_Encode4(291213), GIMT_Encode4(0),
    /*GILLT_nxv8s16*//*Label 5855*/ GIMT_Encode4(291239),
    // Label 5843: @285920
    GIM_Try, /*On fail goto*//*Label 5857*/ GIMT_Encode4(286561),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_Try, /*On fail goto*//*Label 5858*/ GIMT_Encode4(286048), // Rule ID 6285 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6285,
        GIR_EraseRootFromParent_Done,
      // Label 5858: @286048
      GIM_Try, /*On fail goto*//*Label 5859*/ GIMT_Encode4(286161), // Rule ID 13987 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13987,
        GIR_EraseRootFromParent_Done,
      // Label 5859: @286161
      GIM_Try, /*On fail goto*//*Label 5860*/ GIMT_Encode4(286240), // Rule ID 13924 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rn)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13924,
        GIR_EraseRootFromParent_Done,
      // Label 5860: @286240
      GIM_Try, /*On fail goto*//*Label 5861*/ GIMT_Encode4(286319), // Rule ID 4836 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }))  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4836,
        GIR_EraseRootFromParent_Done,
      // Label 5861: @286319
      GIM_Try, /*On fail goto*//*Label 5862*/ GIMT_Encode4(286382), // Rule ID 13539 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16Op:{ *:[f16] }:$Rn)  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13539,
        GIR_EraseRootFromParent_Done,
      // Label 5862: @286382
      GIM_Try, /*On fail goto*//*Label 5863*/ GIMT_Encode4(286445), // Rule ID 2001 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fmul:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2001,
        GIR_EraseRootFromParent_Done,
      // Label 5863: @286445
      GIM_Try, /*On fail goto*//*Label 5864*/ GIMT_Encode4(286489), // Rule ID 4841 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fmul:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$a), FPR16:{ *:[f16] }:$b)  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
        GIR_RootToRootCopy, /*OpIdx*/2, // b
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4841,
        GIR_EraseRootFromParent_Done,
      // Label 5864: @286489
      GIM_Try, /*On fail goto*//*Label 5865*/ GIMT_Encode4(286533), // Rule ID 13929 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$b, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$a))  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
        GIR_RootToRootCopy, /*OpIdx*/1, // b
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13929,
        GIR_EraseRootFromParent_Done,
      // Label 5865: @286533
      GIM_Try, /*On fail goto*//*Label 5866*/ GIMT_Encode4(286560), // Rule ID 616 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 616,
        GIR_Done,
      // Label 5866: @286560
      GIM_Reject,
    // Label 5857: @286561
    GIM_Reject,
    // Label 5844: @286562
    GIM_Try, /*On fail goto*//*Label 5867*/ GIMT_Encode4(287191),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 5868*/ GIMT_Encode4(286690), // Rule ID 6287 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6287,
        GIR_EraseRootFromParent_Done,
      // Label 5868: @286690
      GIM_Try, /*On fail goto*//*Label 5869*/ GIMT_Encode4(286803), // Rule ID 13989 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13989,
        GIR_EraseRootFromParent_Done,
      // Label 5869: @286803
      GIM_Try, /*On fail goto*//*Label 5870*/ GIMT_Encode4(286879), // Rule ID 13926 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rn)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13926,
        GIR_EraseRootFromParent_Done,
      // Label 5870: @286879
      GIM_Try, /*On fail goto*//*Label 5871*/ GIMT_Encode4(286955), // Rule ID 4838 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }))  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4838,
        GIR_EraseRootFromParent_Done,
      // Label 5871: @286955
      GIM_Try, /*On fail goto*//*Label 5872*/ GIMT_Encode4(287018), // Rule ID 13541 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32Op:{ *:[f32] }:$Rn)  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13541,
        GIR_EraseRootFromParent_Done,
      // Label 5872: @287018
      GIM_Try, /*On fail goto*//*Label 5873*/ GIMT_Encode4(287081), // Rule ID 2003 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fmul:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2003,
        GIR_EraseRootFromParent_Done,
      // Label 5873: @287081
      GIM_Try, /*On fail goto*//*Label 5874*/ GIMT_Encode4(287122), // Rule ID 4842 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fmul:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$a), FPR32:{ *:[f32] }:$b)  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
        GIR_RootToRootCopy, /*OpIdx*/2, // b
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4842,
        GIR_EraseRootFromParent_Done,
      // Label 5874: @287122
      GIM_Try, /*On fail goto*//*Label 5875*/ GIMT_Encode4(287163), // Rule ID 13930 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$b, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$a))  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
        GIR_RootToRootCopy, /*OpIdx*/1, // b
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13930,
        GIR_EraseRootFromParent_Done,
      // Label 5875: @287163
      GIM_Try, /*On fail goto*//*Label 5876*/ GIMT_Encode4(287190), // Rule ID 618 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 618,
        GIR_Done,
      // Label 5876: @287190
      GIM_Reject,
    // Label 5867: @287191
    GIM_Reject,
    // Label 5845: @287192
    GIM_Try, /*On fail goto*//*Label 5877*/ GIMT_Encode4(287821),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 5878*/ GIMT_Encode4(287320), // Rule ID 6289 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6289,
        GIR_EraseRootFromParent_Done,
      // Label 5878: @287320
      GIM_Try, /*On fail goto*//*Label 5879*/ GIMT_Encode4(287433), // Rule ID 13991 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13991,
        GIR_EraseRootFromParent_Done,
      // Label 5879: @287433
      GIM_Try, /*On fail goto*//*Label 5880*/ GIMT_Encode4(287509), // Rule ID 13928 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rn)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13928,
        GIR_EraseRootFromParent_Done,
      // Label 5880: @287509
      GIM_Try, /*On fail goto*//*Label 5881*/ GIMT_Encode4(287585), // Rule ID 4840 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }))  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4840,
        GIR_EraseRootFromParent_Done,
      // Label 5881: @287585
      GIM_Try, /*On fail goto*//*Label 5882*/ GIMT_Encode4(287648), // Rule ID 13543 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64Op:{ *:[f64] }:$Rn)  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13543,
        GIR_EraseRootFromParent_Done,
      // Label 5882: @287648
      GIM_Try, /*On fail goto*//*Label 5883*/ GIMT_Encode4(287711), // Rule ID 2005 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fmul:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2005,
        GIR_EraseRootFromParent_Done,
      // Label 5883: @287711
      GIM_Try, /*On fail goto*//*Label 5884*/ GIMT_Encode4(287752), // Rule ID 4843 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fmul:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$a), FPR64:{ *:[f64] }:$b)  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
        GIR_RootToRootCopy, /*OpIdx*/2, // b
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4843,
        GIR_EraseRootFromParent_Done,
      // Label 5884: @287752
      GIM_Try, /*On fail goto*//*Label 5885*/ GIMT_Encode4(287793), // Rule ID 13931 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$b, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$a))  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
        GIR_RootToRootCopy, /*OpIdx*/1, // b
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13931,
        GIR_EraseRootFromParent_Done,
      // Label 5885: @287793
      GIM_Try, /*On fail goto*//*Label 5886*/ GIMT_Encode4(287820), // Rule ID 620 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 620,
        GIR_Done,
      // Label 5886: @287820
      GIM_Reject,
    // Label 5877: @287821
    GIM_Reject,
    // Label 5846: @287822
    GIM_Try, /*On fail goto*//*Label 5887*/ GIMT_Encode4(288351),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 5888*/ GIMT_Encode4(287923), // Rule ID 13532 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fmul:{ *:[v2f32] } (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13532,
        GIR_EraseRootFromParent_Done,
      // Label 5888: @287923
      GIM_Try, /*On fail goto*//*Label 5889*/ GIMT_Encode4(288009), // Rule ID 1994 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1994,
        GIR_EraseRootFromParent_Done,
      // Label 5889: @288009
      GIM_Try, /*On fail goto*//*Label 5890*/ GIMT_Encode4(288072), // Rule ID 13533 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fmul:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13533,
        GIR_EraseRootFromParent_Done,
      // Label 5890: @288072
      GIM_Try, /*On fail goto*//*Label 5891*/ GIMT_Encode4(288135), // Rule ID 1995 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1995,
        GIR_EraseRootFromParent_Done,
      // Label 5891: @288135
      GIM_Try, /*On fail goto*//*Label 5892*/ GIMT_Encode4(288229), // Rule ID 13993 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fmul:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13993,
        GIR_EraseRootFromParent_Done,
      // Label 5892: @288229
      GIM_Try, /*On fail goto*//*Label 5893*/ GIMT_Encode4(288323), // Rule ID 6291 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6291,
        GIR_EraseRootFromParent_Done,
      // Label 5893: @288323
      GIM_Try, /*On fail goto*//*Label 5894*/ GIMT_Encode4(288350), // Rule ID 1312 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMULv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f32),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1312,
        GIR_Done,
      // Label 5894: @288350
      GIM_Reject,
    // Label 5887: @288351
    GIM_Reject,
    // Label 5847: @288352
    GIM_Try, /*On fail goto*//*Label 5895*/ GIMT_Encode4(288709),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 5896*/ GIMT_Encode4(288430), // Rule ID 13537 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fmul:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13537,
        GIR_EraseRootFromParent_Done,
      // Label 5896: @288430
      GIM_Try, /*On fail goto*//*Label 5897*/ GIMT_Encode4(288493), // Rule ID 1999 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1999,
        GIR_EraseRootFromParent_Done,
      // Label 5897: @288493
      GIM_Try, /*On fail goto*//*Label 5898*/ GIMT_Encode4(288587), // Rule ID 13997 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fmul:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13997,
        GIR_EraseRootFromParent_Done,
      // Label 5898: @288587
      GIM_Try, /*On fail goto*//*Label 5899*/ GIMT_Encode4(288681), // Rule ID 6295 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6295,
        GIR_EraseRootFromParent_Done,
      // Label 5899: @288681
      GIM_Try, /*On fail goto*//*Label 5900*/ GIMT_Encode4(288708), // Rule ID 1316 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMULv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f64),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1316,
        GIR_Done,
      // Label 5900: @288708
      GIM_Reject,
    // Label 5895: @288709
    GIM_Reject,
    // Label 5848: @288710
    GIM_Try, /*On fail goto*//*Label 5901*/ GIMT_Encode4(289051),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 5902*/ GIMT_Encode4(288811), // Rule ID 13526 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fmul:{ *:[v4f16] } (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13526,
        GIR_EraseRootFromParent_Done,
      // Label 5902: @288811
      GIM_Try, /*On fail goto*//*Label 5903*/ GIMT_Encode4(288897), // Rule ID 1988 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1988,
        GIR_EraseRootFromParent_Done,
      // Label 5903: @288897
      GIM_Try, /*On fail goto*//*Label 5904*/ GIMT_Encode4(288960), // Rule ID 13527 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fmul:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13527,
        GIR_EraseRootFromParent_Done,
      // Label 5904: @288960
      GIM_Try, /*On fail goto*//*Label 5905*/ GIMT_Encode4(289023), // Rule ID 1989 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1989,
        GIR_EraseRootFromParent_Done,
      // Label 5905: @289023
      GIM_Try, /*On fail goto*//*Label 5906*/ GIMT_Encode4(289050), // Rule ID 1308 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMULv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1308,
        GIR_Done,
      // Label 5906: @289050
      GIM_Reject,
    // Label 5901: @289051
    GIM_Reject,
    // Label 5849: @289052
    GIM_Try, /*On fail goto*//*Label 5907*/ GIMT_Encode4(289409),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 5908*/ GIMT_Encode4(289130), // Rule ID 13535 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fmul:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13535,
        GIR_EraseRootFromParent_Done,
      // Label 5908: @289130
      GIM_Try, /*On fail goto*//*Label 5909*/ GIMT_Encode4(289193), // Rule ID 1997 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1997,
        GIR_EraseRootFromParent_Done,
      // Label 5909: @289193
      GIM_Try, /*On fail goto*//*Label 5910*/ GIMT_Encode4(289287), // Rule ID 13995 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fmul:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13995,
        GIR_EraseRootFromParent_Done,
      // Label 5910: @289287
      GIM_Try, /*On fail goto*//*Label 5911*/ GIMT_Encode4(289381), // Rule ID 6293 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6293,
        GIR_EraseRootFromParent_Done,
      // Label 5911: @289381
      GIM_Try, /*On fail goto*//*Label 5912*/ GIMT_Encode4(289408), // Rule ID 1314 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMULv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1314,
        GIR_Done,
      // Label 5912: @289408
      GIM_Reject,
    // Label 5907: @289409
    GIM_Reject,
    // Label 5850: @289410
    GIM_Try, /*On fail goto*//*Label 5913*/ GIMT_Encode4(291134),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 5914*/ GIMT_Encode4(289488), // Rule ID 13529 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fmul:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn)  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13529,
        GIR_EraseRootFromParent_Done,
      // Label 5914: @289488
      GIM_Try, /*On fail goto*//*Label 5915*/ GIMT_Encode4(289551), // Rule ID 1991 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1991,
        GIR_EraseRootFromParent_Done,
      // Label 5915: @289551
      GIM_Try, /*On fail goto*//*Label 5916*/ GIMT_Encode4(289578), // Rule ID 1310 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMULv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv8f16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1310,
        GIR_Done,
      // Label 5916: @289578
      GIM_Try, /*On fail goto*//*Label 5917*/ GIMT_Encode4(289840), // Rule ID 7197 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FMULv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FMULv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
        GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
        GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
        GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
        GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7197,
        GIR_EraseRootFromParent_Done,
      // Label 5917: @289840
      GIM_Try, /*On fail goto*//*Label 5918*/ GIMT_Encode4(290052), // Rule ID 7199 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (fmul:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)  =>  (BFCVTN2:{ *:[v8bf16] } (BFCVTN:{ *:[v8bf16] } (FMULv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] })))), (FMULv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm)))
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/8,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::BFCVTN),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFCVTN2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7199,
        GIR_EraseRootFromParent_Done,
      // Label 5918: @290052
      GIM_Try, /*On fail goto*//*Label 5919*/ GIMT_Encode4(291133), // Rule ID 7201 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoBF16),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (fmul:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8bf16] } (BSPv16i8:{ *:[f128] } (FCMEQv4f32:{ *:[f128] } (FMULv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] }))), (FMULv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] })))), (ADDv4i32:{ *:[f128] } (ADDv4i32:{ *:[f128] } (FMULv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] }))), (ANDv16i8:{ *:[f128] } (USHRv4i32_shift:{ *:[f128] } V128:{ *:[v8bf16] }:$Rn, 16:{ *:[i32] }), (MOVIv4i32:{ *:[f128] } 1:{ *:[i32] }, 0:{ *:[i32] }))), (MOVIv4s_msl:{ *:[f128] } 127:{ *:[i32] }, 264:{ *:[i32] })), (ORRv4i32:{ *:[f128] } (FMULv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] }))), 64:{ *:[i32] }, 16:{ *:[i32] })), (BSPv16i8:{ *:[f128] } (FCMEQv4f32:{ *:[f128] } (FMULv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm)), (FMULv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm))), (ADDv4i32:{ *:[f128] } (ADDv4i32:{ *:[f128] } (FMULv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm)), (ANDv16i8:{ *:[f128] } (USHRv4i32_shift:{ *:[f128] } V128:{ *:[v8bf16] }:$Rn, 16:{ *:[i32] }), (MOVIv4i32:{ *:[f128] } 1:{ *:[i32] }, 0:{ *:[i32] }))), (MOVIv4s_msl:{ *:[f128] } 127:{ *:[i32] }, 264:{ *:[i32] })), (ORRv4i32:{ *:[f128] } (FMULv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm)), 64:{ *:[i32] }, 16:{ *:[i32] })))
        GIR_MakeTempReg, /*TempRegID*/49, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/50, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/50, /*TempRegID*/49, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/50, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/50,
        GIR_MakeTempReg, /*TempRegID*/48, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/49, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/49, /*TempRegID*/48, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/49, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/49,
        GIR_MakeTempReg, /*TempRegID*/47, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/48, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
        GIR_AddTempRegister, /*InsnID*/48, /*TempRegID*/47, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/48, /*TempRegID*/48,
        GIR_AddSimpleTempRegister, /*InsnID*/48, /*TempRegID*/49,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/48,
        GIR_MakeTempReg, /*TempRegID*/46, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/47, /*Opcode*/GIMT_Encode2(AArch64::ORRv4i32),
        GIR_AddTempRegister, /*InsnID*/47, /*TempRegID*/46, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/47, /*TempRegID*/47,
        GIR_AddImm8, /*InsnID*/47, /*Imm*/64,
        GIR_AddImm8, /*InsnID*/47, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/47,
        GIR_MakeTempReg, /*TempRegID*/45, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/46, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4s_msl),
        GIR_AddTempRegister, /*InsnID*/46, /*TempRegID*/45, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/46, /*Imm*/127,
        GIR_AddImm, /*InsnID*/46, /*Imm*/GIMT_Encode8(264),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/46,
        GIR_MakeTempReg, /*TempRegID*/44, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/45, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i32),
        GIR_AddTempRegister, /*InsnID*/45, /*TempRegID*/44, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/45, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/45, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/45,
        GIR_MakeTempReg, /*TempRegID*/43, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/44, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
        GIR_AddTempRegister, /*InsnID*/44, /*TempRegID*/43, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/44, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/44, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/44,
        GIR_MakeTempReg, /*TempRegID*/42, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/43, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
        GIR_AddTempRegister, /*InsnID*/43, /*TempRegID*/42, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/43, /*TempRegID*/43,
        GIR_AddSimpleTempRegister, /*InsnID*/43, /*TempRegID*/44,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/43,
        GIR_MakeTempReg, /*TempRegID*/41, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/42, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/42, /*TempRegID*/41, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/42, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/42,
        GIR_MakeTempReg, /*TempRegID*/40, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/41, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/41, /*TempRegID*/40, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/41, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/41,
        GIR_MakeTempReg, /*TempRegID*/39, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/40, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
        GIR_AddTempRegister, /*InsnID*/40, /*TempRegID*/39, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/40, /*TempRegID*/40,
        GIR_AddSimpleTempRegister, /*InsnID*/40, /*TempRegID*/41,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/40,
        GIR_MakeTempReg, /*TempRegID*/38, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/39, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/39, /*TempRegID*/38, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/39, /*TempRegID*/39,
        GIR_AddSimpleTempRegister, /*InsnID*/39, /*TempRegID*/42,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/39,
        GIR_MakeTempReg, /*TempRegID*/37, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/38, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/38, /*TempRegID*/37, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/38, /*TempRegID*/38,
        GIR_AddSimpleTempRegister, /*InsnID*/38, /*TempRegID*/45,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/38,
        GIR_MakeTempReg, /*TempRegID*/36, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/37, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/37, /*TempRegID*/36, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/37, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/37,
        GIR_MakeTempReg, /*TempRegID*/35, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/36, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/36, /*TempRegID*/35, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/36, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/36,
        GIR_MakeTempReg, /*TempRegID*/34, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/35, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
        GIR_AddTempRegister, /*InsnID*/35, /*TempRegID*/34, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/35, /*TempRegID*/35,
        GIR_AddSimpleTempRegister, /*InsnID*/35, /*TempRegID*/36,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/35,
        GIR_MakeTempReg, /*TempRegID*/33, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/34, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/34, /*TempRegID*/33, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/34, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/34,
        GIR_MakeTempReg, /*TempRegID*/32, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/33, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/33, /*TempRegID*/32, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/33, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/33,
        GIR_MakeTempReg, /*TempRegID*/31, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/32, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
        GIR_AddTempRegister, /*InsnID*/32, /*TempRegID*/31, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/32, /*TempRegID*/32,
        GIR_AddSimpleTempRegister, /*InsnID*/32, /*TempRegID*/33,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/32,
        GIR_MakeTempReg, /*TempRegID*/30, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/31, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
        GIR_AddTempRegister, /*InsnID*/31, /*TempRegID*/30, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/31, /*TempRegID*/31,
        GIR_AddSimpleTempRegister, /*InsnID*/31, /*TempRegID*/34,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/31,
        GIR_MakeTempReg, /*TempRegID*/29, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/30, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_AddTempRegister, /*InsnID*/30, /*TempRegID*/29, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/30, /*TempRegID*/30,
        GIR_AddSimpleTempRegister, /*InsnID*/30, /*TempRegID*/37,
        GIR_AddSimpleTempRegister, /*InsnID*/30, /*TempRegID*/46,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/30,
        GIR_MakeTempReg, /*TempRegID*/28, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/29, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/29, /*TempRegID*/28, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/29, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/29, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/29, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/27, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/28, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/28, /*TempRegID*/27, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/28, /*TempRegID*/28,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/28,
        GIR_MakeTempReg, /*TempRegID*/26, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/27, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/27, /*TempRegID*/26, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/27, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/27, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/27, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/25, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/26, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/26, /*TempRegID*/25, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/26, /*TempRegID*/26,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/26,
        GIR_MakeTempReg, /*TempRegID*/24, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/25, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
        GIR_AddTempRegister, /*InsnID*/25, /*TempRegID*/24, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/25, /*TempRegID*/25,
        GIR_AddSimpleTempRegister, /*InsnID*/25, /*TempRegID*/27,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/25,
        GIR_MakeTempReg, /*TempRegID*/23, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/24, /*Opcode*/GIMT_Encode2(AArch64::ORRv4i32),
        GIR_AddTempRegister, /*InsnID*/24, /*TempRegID*/23, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/24, /*TempRegID*/24,
        GIR_AddImm8, /*InsnID*/24, /*Imm*/64,
        GIR_AddImm8, /*InsnID*/24, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/24,
        GIR_MakeTempReg, /*TempRegID*/22, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/23, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4s_msl),
        GIR_AddTempRegister, /*InsnID*/23, /*TempRegID*/22, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/23, /*Imm*/127,
        GIR_AddImm, /*InsnID*/23, /*Imm*/GIMT_Encode8(264),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/23,
        GIR_MakeTempReg, /*TempRegID*/21, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/22, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i32),
        GIR_AddTempRegister, /*InsnID*/22, /*TempRegID*/21, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/22, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/22, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/22,
        GIR_MakeTempReg, /*TempRegID*/20, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/21, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
        GIR_AddTempRegister, /*InsnID*/21, /*TempRegID*/20, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/21, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/21, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/21,
        GIR_MakeTempReg, /*TempRegID*/19, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/20, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
        GIR_AddTempRegister, /*InsnID*/20, /*TempRegID*/19, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/20, /*TempRegID*/20,
        GIR_AddSimpleTempRegister, /*InsnID*/20, /*TempRegID*/21,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/20,
        GIR_MakeTempReg, /*TempRegID*/18, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/19, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/19, /*TempRegID*/18, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/19, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/19, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/19, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/17, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/18, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/18, /*TempRegID*/17, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/18, /*TempRegID*/18,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/18,
        GIR_MakeTempReg, /*TempRegID*/16, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/17, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/17, /*TempRegID*/16, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/17, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/17, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/17, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/15, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/16, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/16, /*TempRegID*/15, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/16, /*TempRegID*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/16,
        GIR_MakeTempReg, /*TempRegID*/14, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/15, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
        GIR_AddTempRegister, /*InsnID*/15, /*TempRegID*/14, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/15, /*TempRegID*/15,
        GIR_AddSimpleTempRegister, /*InsnID*/15, /*TempRegID*/17,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/15,
        GIR_MakeTempReg, /*TempRegID*/13, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/14, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/14, /*TempRegID*/13, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/14,
        GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/19,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/14,
        GIR_MakeTempReg, /*TempRegID*/12, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/13, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/13, /*TempRegID*/12, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/13, /*TempRegID*/13,
        GIR_AddSimpleTempRegister, /*InsnID*/13, /*TempRegID*/22,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/13,
        GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/11, /*TempRegID*/11,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
        GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
        GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/10,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/12,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/23,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/29,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7201,
        GIR_EraseRootFromParent_Done,
      // Label 5919: @291133
      GIM_Reject,
    // Label 5913: @291134
    GIM_Reject,
    // Label 5851: @291135
    GIM_Try, /*On fail goto*//*Label 5920*/ GIMT_Encode4(291160), // Rule ID 12394 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEB16B16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (fmul:{ *:[nxv2bf16] } nxv2bf16:{ *:[nxv2bf16] }:$Op1, nxv2bf16:{ *:[nxv2bf16] }:$Op2)  =>  (BFMUL_ZZZ:{ *:[nxv2bf16] } ?:{ *:[nxv2bf16] }:$Op1, ?:{ *:[nxv2bf16] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BFMUL_ZZZ),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 12394,
      GIR_Done,
    // Label 5920: @291160
    GIM_Reject,
    // Label 5852: @291161
    GIM_Try, /*On fail goto*//*Label 5921*/ GIMT_Encode4(291186), // Rule ID 8339 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (fmul:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMUL_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZ_D),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8339,
      GIR_Done,
    // Label 5921: @291186
    GIM_Reject,
    // Label 5853: @291187
    GIM_Try, /*On fail goto*//*Label 5922*/ GIMT_Encode4(291212), // Rule ID 12392 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEB16B16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (fmul:{ *:[nxv4bf16] } nxv4bf16:{ *:[nxv4bf16] }:$Op1, nxv4bf16:{ *:[nxv4bf16] }:$Op2)  =>  (BFMUL_ZZZ:{ *:[nxv4bf16] } ?:{ *:[nxv4bf16] }:$Op1, ?:{ *:[nxv4bf16] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BFMUL_ZZZ),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 12392,
      GIR_Done,
    // Label 5922: @291212
    GIM_Reject,
    // Label 5854: @291213
    GIM_Try, /*On fail goto*//*Label 5923*/ GIMT_Encode4(291238), // Rule ID 8337 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (fmul:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMUL_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZ_S),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8337,
      GIR_Done,
    // Label 5923: @291238
    GIM_Reject,
    // Label 5855: @291239
    GIM_Try, /*On fail goto*//*Label 5924*/ GIMT_Encode4(291285),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 5925*/ GIMT_Encode4(291269), // Rule ID 8335 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (fmul:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMUL_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZ_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8335,
        GIR_Done,
      // Label 5925: @291269
      GIM_Try, /*On fail goto*//*Label 5926*/ GIMT_Encode4(291284), // Rule ID 12390 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEB16B16),
        // (fmul:{ *:[nxv8bf16] } nxv8bf16:{ *:[nxv8bf16] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2)  =>  (BFMUL_ZZZ:{ *:[nxv8bf16] } ?:{ *:[nxv8bf16] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BFMUL_ZZZ),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12390,
        GIR_Done,
      // Label 5926: @291284
      GIM_Reject,
    // Label 5924: @291285
    GIM_Reject,
    // Label 5856: @291286
    GIM_Reject,
    // Label 57: @291287
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 5935*/ GIMT_Encode4(307559),
    /*GILLT_s16*//*Label 5927*/ GIMT_Encode4(291338),
    /*GILLT_s32*//*Label 5928*/ GIMT_Encode4(294342),
    /*GILLT_s64*//*Label 5929*/ GIMT_Encode4(297490), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 5930*/ GIMT_Encode4(300638),
    /*GILLT_v2s64*//*Label 5931*/ GIMT_Encode4(302159),
    /*GILLT_v4s16*//*Label 5932*/ GIMT_Encode4(303680),
    /*GILLT_v4s32*//*Label 5933*/ GIMT_Encode4(304859), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 5934*/ GIMT_Encode4(306380),
    // Label 5927: @291338
    GIM_Try, /*On fail goto*//*Label 5936*/ GIMT_Encode4(294341),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_Try, /*On fail goto*//*Label 5937*/ GIMT_Encode4(291506), // Rule ID 4898 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4898,
        GIR_EraseRootFromParent_Done,
      // Label 5937: @291506
      GIM_Try, /*On fail goto*//*Label 5938*/ GIMT_Encode4(291653), // Rule ID 4862 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4862,
        GIR_EraseRootFromParent_Done,
      // Label 5938: @291653
      GIM_Try, /*On fail goto*//*Label 5939*/ GIMT_Encode4(291800), // Rule ID 13937 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13937,
        GIR_EraseRootFromParent_Done,
      // Label 5939: @291800
      GIM_Try, /*On fail goto*//*Label 5940*/ GIMT_Encode4(291931), // Rule ID 6123 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[4] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6123,
        GIR_EraseRootFromParent_Done,
      // Label 5940: @291931
      GIM_Try, /*On fail goto*//*Label 5941*/ GIMT_Encode4(292062), // Rule ID 6155 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6155,
        GIR_EraseRootFromParent_Done,
      // Label 5941: @292062
      GIM_Try, /*On fail goto*//*Label 5942*/ GIMT_Encode4(292193), // Rule ID 6219 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[4] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6219,
        GIR_EraseRootFromParent_Done,
      // Label 5942: @292193
      GIM_Try, /*On fail goto*//*Label 5943*/ GIMT_Encode4(292324), // Rule ID 6187 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6187,
        GIR_EraseRootFromParent_Done,
      // Label 5943: @292324
      GIM_Try, /*On fail goto*//*Label 5944*/ GIMT_Encode4(292459), // Rule ID 2425 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2425,
        GIR_EraseRootFromParent_Done,
      // Label 5944: @292459
      GIM_Try, /*On fail goto*//*Label 5945*/ GIMT_Encode4(292578), // Rule ID 6091 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6091,
        GIR_EraseRootFromParent_Done,
      // Label 5945: @292578
      GIM_Try, /*On fail goto*//*Label 5946*/ GIMT_Encode4(292697), // Rule ID 2497 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2497,
        GIR_EraseRootFromParent_Done,
      // Label 5946: @292697
      GIM_Try, /*On fail goto*//*Label 5947*/ GIMT_Encode4(292797), // Rule ID 4860 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4860,
        GIR_EraseRootFromParent_Done,
      // Label 5947: @292797
      GIM_Try, /*On fail goto*//*Label 5948*/ GIMT_Encode4(292897), // Rule ID 4896 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4896,
        GIR_EraseRootFromParent_Done,
      // Label 5948: @292897
      GIM_Try, /*On fail goto*//*Label 5949*/ GIMT_Encode4(292994), // Rule ID 13933 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13933,
        GIR_EraseRootFromParent_Done,
      // Label 5949: @292994
      GIM_Try, /*On fail goto*//*Label 5950*/ GIMT_Encode4(293094), // Rule ID 13935 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13935,
        GIR_EraseRootFromParent_Done,
      // Label 5950: @293094
      GIM_Try, /*On fail goto*//*Label 5951*/ GIMT_Encode4(293194), // Rule ID 4894 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4894,
        GIR_EraseRootFromParent_Done,
      // Label 5951: @293194
      GIM_Try, /*On fail goto*//*Label 5952*/ GIMT_Encode4(293291), // Rule ID 4858 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4858,
        GIR_EraseRootFromParent_Done,
      // Label 5952: @293291
      GIM_Try, /*On fail goto*//*Label 5953*/ GIMT_Encode4(293375), // Rule ID 6153 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6153,
        GIR_EraseRootFromParent_Done,
      // Label 5953: @293375
      GIM_Try, /*On fail goto*//*Label 5954*/ GIMT_Encode4(293456), // Rule ID 6185 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6185,
        GIR_EraseRootFromParent_Done,
      // Label 5954: @293456
      GIM_Try, /*On fail goto*//*Label 5955*/ GIMT_Encode4(293540), // Rule ID 6217 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6217,
        GIR_EraseRootFromParent_Done,
      // Label 5955: @293540
      GIM_Try, /*On fail goto*//*Label 5956*/ GIMT_Encode4(293621), // Rule ID 6121 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6121,
        GIR_EraseRootFromParent_Done,
      // Label 5956: @293621
      GIM_Try, /*On fail goto*//*Label 5957*/ GIMT_Encode4(293706), // Rule ID 2423 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2423,
        GIR_EraseRootFromParent_Done,
      // Label 5957: @293706
      GIM_Try, /*On fail goto*//*Label 5958*/ GIMT_Encode4(293791), // Rule ID 2421 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2421,
        GIR_EraseRootFromParent_Done,
      // Label 5958: @293791
      GIM_Try, /*On fail goto*//*Label 5959*/ GIMT_Encode4(293860), // Rule ID 2495 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2495,
        GIR_EraseRootFromParent_Done,
      // Label 5959: @293860
      GIM_Try, /*On fail goto*//*Label 5960*/ GIMT_Encode4(293929), // Rule ID 6089 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6089,
        GIR_EraseRootFromParent_Done,
      // Label 5960: @293929
      GIM_Try, /*On fail goto*//*Label 5961*/ GIMT_Encode4(293994), // Rule ID 4914 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4914,
        GIR_EraseRootFromParent_Done,
      // Label 5961: @293994
      GIM_Try, /*On fail goto*//*Label 5962*/ GIMT_Encode4(294059), // Rule ID 13953 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/1, // Rm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13953,
        GIR_EraseRootFromParent_Done,
      // Label 5962: @294059
      GIM_Try, /*On fail goto*//*Label 5963*/ GIMT_Encode4(294109), // Rule ID 4911 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4911,
        GIR_EraseRootFromParent_Done,
      // Label 5963: @294109
      GIM_Try, /*On fail goto*//*Label 5964*/ GIMT_Encode4(294159), // Rule ID 13379 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13379,
        GIR_EraseRootFromParent_Done,
      // Label 5964: @294159
      GIM_Try, /*On fail goto*//*Label 5965*/ GIMT_Encode4(294209), // Rule ID 640 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 640,
        GIR_EraseRootFromParent_Done,
      // Label 5965: @294209
      GIM_Try, /*On fail goto*//*Label 5966*/ GIMT_Encode4(294259), // Rule ID 13950 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/1, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13950,
        GIR_EraseRootFromParent_Done,
      // Label 5966: @294259
      GIM_Try, /*On fail goto*//*Label 5967*/ GIMT_Encode4(294309), // Rule ID 652 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 652,
        GIR_EraseRootFromParent_Done,
      // Label 5967: @294309
      GIM_Try, /*On fail goto*//*Label 5968*/ GIMT_Encode4(294340), // Rule ID 634 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 634,
        GIR_Done,
      // Label 5968: @294340
      GIM_Reject,
    // Label 5936: @294341
    GIM_Reject,
    // Label 5928: @294342
    GIM_Try, /*On fail goto*//*Label 5969*/ GIMT_Encode4(297489),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 5970*/ GIMT_Encode4(294510), // Rule ID 4904 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4904,
        GIR_EraseRootFromParent_Done,
      // Label 5970: @294510
      GIM_Try, /*On fail goto*//*Label 5971*/ GIMT_Encode4(294657), // Rule ID 4868 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4868,
        GIR_EraseRootFromParent_Done,
      // Label 5971: @294657
      GIM_Try, /*On fail goto*//*Label 5972*/ GIMT_Encode4(294804), // Rule ID 13943 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13943,
        GIR_EraseRootFromParent_Done,
      // Label 5972: @294804
      GIM_Try, /*On fail goto*//*Label 5973*/ GIMT_Encode4(294935), // Rule ID 6139 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[4] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6139,
        GIR_EraseRootFromParent_Done,
      // Label 5973: @294935
      GIM_Try, /*On fail goto*//*Label 5974*/ GIMT_Encode4(295066), // Rule ID 6171 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6171,
        GIR_EraseRootFromParent_Done,
      // Label 5974: @295066
      GIM_Try, /*On fail goto*//*Label 5975*/ GIMT_Encode4(295197), // Rule ID 6235 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[4] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6235,
        GIR_EraseRootFromParent_Done,
      // Label 5975: @295197
      GIM_Try, /*On fail goto*//*Label 5976*/ GIMT_Encode4(295328), // Rule ID 6203 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6203,
        GIR_EraseRootFromParent_Done,
      // Label 5976: @295328
      GIM_Try, /*On fail goto*//*Label 5977*/ GIMT_Encode4(295463), // Rule ID 2431 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2431,
        GIR_EraseRootFromParent_Done,
      // Label 5977: @295463
      GIM_Try, /*On fail goto*//*Label 5978*/ GIMT_Encode4(295582), // Rule ID 6107 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6107,
        GIR_EraseRootFromParent_Done,
      // Label 5978: @295582
      GIM_Try, /*On fail goto*//*Label 5979*/ GIMT_Encode4(295701), // Rule ID 2513 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2513,
        GIR_EraseRootFromParent_Done,
      // Label 5979: @295701
      GIM_Try, /*On fail goto*//*Label 5980*/ GIMT_Encode4(295801), // Rule ID 4866 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4866,
        GIR_EraseRootFromParent_Done,
      // Label 5980: @295801
      GIM_Try, /*On fail goto*//*Label 5981*/ GIMT_Encode4(295901), // Rule ID 4902 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4902,
        GIR_EraseRootFromParent_Done,
      // Label 5981: @295901
      GIM_Try, /*On fail goto*//*Label 5982*/ GIMT_Encode4(295998), // Rule ID 13939 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13939,
        GIR_EraseRootFromParent_Done,
      // Label 5982: @295998
      GIM_Try, /*On fail goto*//*Label 5983*/ GIMT_Encode4(296098), // Rule ID 13941 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13941,
        GIR_EraseRootFromParent_Done,
      // Label 5983: @296098
      GIM_Try, /*On fail goto*//*Label 5984*/ GIMT_Encode4(296198), // Rule ID 4900 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4900,
        GIR_EraseRootFromParent_Done,
      // Label 5984: @296198
      GIM_Try, /*On fail goto*//*Label 5985*/ GIMT_Encode4(296295), // Rule ID 4864 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4864,
        GIR_EraseRootFromParent_Done,
      // Label 5985: @296295
      GIM_Try, /*On fail goto*//*Label 5986*/ GIMT_Encode4(296373), // Rule ID 6257 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6257,
        GIR_EraseRootFromParent_Done,
      // Label 5986: @296373
      GIM_Try, /*On fail goto*//*Label 5987*/ GIMT_Encode4(296457), // Rule ID 6169 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6169,
        GIR_EraseRootFromParent_Done,
      // Label 5987: @296457
      GIM_Try, /*On fail goto*//*Label 5988*/ GIMT_Encode4(296538), // Rule ID 6201 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6201,
        GIR_EraseRootFromParent_Done,
      // Label 5988: @296538
      GIM_Try, /*On fail goto*//*Label 5989*/ GIMT_Encode4(296622), // Rule ID 6233 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6233,
        GIR_EraseRootFromParent_Done,
      // Label 5989: @296622
      GIM_Try, /*On fail goto*//*Label 5990*/ GIMT_Encode4(296700), // Rule ID 6279 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6279,
        GIR_EraseRootFromParent_Done,
      // Label 5990: @296700
      GIM_Try, /*On fail goto*//*Label 5991*/ GIMT_Encode4(296781), // Rule ID 6137 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6137,
        GIR_EraseRootFromParent_Done,
      // Label 5991: @296781
      GIM_Try, /*On fail goto*//*Label 5992*/ GIMT_Encode4(296866), // Rule ID 2429 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2429,
        GIR_EraseRootFromParent_Done,
      // Label 5992: @296866
      GIM_Try, /*On fail goto*//*Label 5993*/ GIMT_Encode4(296951), // Rule ID 2427 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2427,
        GIR_EraseRootFromParent_Done,
      // Label 5993: @296951
      GIM_Try, /*On fail goto*//*Label 5994*/ GIMT_Encode4(297020), // Rule ID 2511 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2511,
        GIR_EraseRootFromParent_Done,
      // Label 5994: @297020
      GIM_Try, /*On fail goto*//*Label 5995*/ GIMT_Encode4(297089), // Rule ID 6105 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6105,
        GIR_EraseRootFromParent_Done,
      // Label 5995: @297089
      GIM_Try, /*On fail goto*//*Label 5996*/ GIMT_Encode4(297151), // Rule ID 4915 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4915,
        GIR_EraseRootFromParent_Done,
      // Label 5996: @297151
      GIM_Try, /*On fail goto*//*Label 5997*/ GIMT_Encode4(297213), // Rule ID 13954 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/1, // Rm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13954,
        GIR_EraseRootFromParent_Done,
      // Label 5997: @297213
      GIM_Try, /*On fail goto*//*Label 5998*/ GIMT_Encode4(297260), // Rule ID 4912 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4912,
        GIR_EraseRootFromParent_Done,
      // Label 5998: @297260
      GIM_Try, /*On fail goto*//*Label 5999*/ GIMT_Encode4(297310), // Rule ID 13381 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13381,
        GIR_EraseRootFromParent_Done,
      // Label 5999: @297310
      GIM_Try, /*On fail goto*//*Label 6000*/ GIMT_Encode4(297360), // Rule ID 642 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 642,
        GIR_EraseRootFromParent_Done,
      // Label 6000: @297360
      GIM_Try, /*On fail goto*//*Label 6001*/ GIMT_Encode4(297407), // Rule ID 13951 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/1, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13951,
        GIR_EraseRootFromParent_Done,
      // Label 6001: @297407
      GIM_Try, /*On fail goto*//*Label 6002*/ GIMT_Encode4(297457), // Rule ID 654 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 654,
        GIR_EraseRootFromParent_Done,
      // Label 6002: @297457
      GIM_Try, /*On fail goto*//*Label 6003*/ GIMT_Encode4(297488), // Rule ID 636 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 636,
        GIR_Done,
      // Label 6003: @297488
      GIM_Reject,
    // Label 5969: @297489
    GIM_Reject,
    // Label 5929: @297490
    GIM_Try, /*On fail goto*//*Label 6004*/ GIMT_Encode4(300637),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 6005*/ GIMT_Encode4(297658), // Rule ID 4910 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4910,
        GIR_EraseRootFromParent_Done,
      // Label 6005: @297658
      GIM_Try, /*On fail goto*//*Label 6006*/ GIMT_Encode4(297805), // Rule ID 4874 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4874,
        GIR_EraseRootFromParent_Done,
      // Label 6006: @297805
      GIM_Try, /*On fail goto*//*Label 6007*/ GIMT_Encode4(297952), // Rule ID 13949 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13949,
        GIR_EraseRootFromParent_Done,
      // Label 6007: @297952
      GIM_Try, /*On fail goto*//*Label 6008*/ GIMT_Encode4(298083), // Rule ID 6143 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[4] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6143,
        GIR_EraseRootFromParent_Done,
      // Label 6008: @298083
      GIM_Try, /*On fail goto*//*Label 6009*/ GIMT_Encode4(298214), // Rule ID 6175 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6175,
        GIR_EraseRootFromParent_Done,
      // Label 6009: @298214
      GIM_Try, /*On fail goto*//*Label 6010*/ GIMT_Encode4(298345), // Rule ID 6239 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[4] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6239,
        GIR_EraseRootFromParent_Done,
      // Label 6010: @298345
      GIM_Try, /*On fail goto*//*Label 6011*/ GIMT_Encode4(298476), // Rule ID 6207 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6207,
        GIR_EraseRootFromParent_Done,
      // Label 6011: @298476
      GIM_Try, /*On fail goto*//*Label 6012*/ GIMT_Encode4(298611), // Rule ID 2437 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2437,
        GIR_EraseRootFromParent_Done,
      // Label 6012: @298611
      GIM_Try, /*On fail goto*//*Label 6013*/ GIMT_Encode4(298730), // Rule ID 6111 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6111,
        GIR_EraseRootFromParent_Done,
      // Label 6013: @298730
      GIM_Try, /*On fail goto*//*Label 6014*/ GIMT_Encode4(298849), // Rule ID 2517 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2517,
        GIR_EraseRootFromParent_Done,
      // Label 6014: @298849
      GIM_Try, /*On fail goto*//*Label 6015*/ GIMT_Encode4(298949), // Rule ID 4872 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4872,
        GIR_EraseRootFromParent_Done,
      // Label 6015: @298949
      GIM_Try, /*On fail goto*//*Label 6016*/ GIMT_Encode4(299049), // Rule ID 4908 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4908,
        GIR_EraseRootFromParent_Done,
      // Label 6016: @299049
      GIM_Try, /*On fail goto*//*Label 6017*/ GIMT_Encode4(299146), // Rule ID 13945 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13945,
        GIR_EraseRootFromParent_Done,
      // Label 6017: @299146
      GIM_Try, /*On fail goto*//*Label 6018*/ GIMT_Encode4(299246), // Rule ID 13947 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13947,
        GIR_EraseRootFromParent_Done,
      // Label 6018: @299246
      GIM_Try, /*On fail goto*//*Label 6019*/ GIMT_Encode4(299346), // Rule ID 4906 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4906,
        GIR_EraseRootFromParent_Done,
      // Label 6019: @299346
      GIM_Try, /*On fail goto*//*Label 6020*/ GIMT_Encode4(299443), // Rule ID 4870 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4870,
        GIR_EraseRootFromParent_Done,
      // Label 6020: @299443
      GIM_Try, /*On fail goto*//*Label 6021*/ GIMT_Encode4(299521), // Rule ID 6261 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6261,
        GIR_EraseRootFromParent_Done,
      // Label 6021: @299521
      GIM_Try, /*On fail goto*//*Label 6022*/ GIMT_Encode4(299605), // Rule ID 6173 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6173,
        GIR_EraseRootFromParent_Done,
      // Label 6022: @299605
      GIM_Try, /*On fail goto*//*Label 6023*/ GIMT_Encode4(299686), // Rule ID 6205 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6205,
        GIR_EraseRootFromParent_Done,
      // Label 6023: @299686
      GIM_Try, /*On fail goto*//*Label 6024*/ GIMT_Encode4(299770), // Rule ID 6237 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6237,
        GIR_EraseRootFromParent_Done,
      // Label 6024: @299770
      GIM_Try, /*On fail goto*//*Label 6025*/ GIMT_Encode4(299848), // Rule ID 6283 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6283,
        GIR_EraseRootFromParent_Done,
      // Label 6025: @299848
      GIM_Try, /*On fail goto*//*Label 6026*/ GIMT_Encode4(299929), // Rule ID 6141 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6141,
        GIR_EraseRootFromParent_Done,
      // Label 6026: @299929
      GIM_Try, /*On fail goto*//*Label 6027*/ GIMT_Encode4(300014), // Rule ID 2435 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2435,
        GIR_EraseRootFromParent_Done,
      // Label 6027: @300014
      GIM_Try, /*On fail goto*//*Label 6028*/ GIMT_Encode4(300099), // Rule ID 2433 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2433,
        GIR_EraseRootFromParent_Done,
      // Label 6028: @300099
      GIM_Try, /*On fail goto*//*Label 6029*/ GIMT_Encode4(300168), // Rule ID 2515 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2515,
        GIR_EraseRootFromParent_Done,
      // Label 6029: @300168
      GIM_Try, /*On fail goto*//*Label 6030*/ GIMT_Encode4(300237), // Rule ID 6109 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6109,
        GIR_EraseRootFromParent_Done,
      // Label 6030: @300237
      GIM_Try, /*On fail goto*//*Label 6031*/ GIMT_Encode4(300299), // Rule ID 4916 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4916,
        GIR_EraseRootFromParent_Done,
      // Label 6031: @300299
      GIM_Try, /*On fail goto*//*Label 6032*/ GIMT_Encode4(300361), // Rule ID 13955 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/1, // Rm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13955,
        GIR_EraseRootFromParent_Done,
      // Label 6032: @300361
      GIM_Try, /*On fail goto*//*Label 6033*/ GIMT_Encode4(300408), // Rule ID 4913 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4913,
        GIR_EraseRootFromParent_Done,
      // Label 6033: @300408
      GIM_Try, /*On fail goto*//*Label 6034*/ GIMT_Encode4(300458), // Rule ID 13383 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13383,
        GIR_EraseRootFromParent_Done,
      // Label 6034: @300458
      GIM_Try, /*On fail goto*//*Label 6035*/ GIMT_Encode4(300508), // Rule ID 644 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 644,
        GIR_EraseRootFromParent_Done,
      // Label 6035: @300508
      GIM_Try, /*On fail goto*//*Label 6036*/ GIMT_Encode4(300555), // Rule ID 13952 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/1, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13952,
        GIR_EraseRootFromParent_Done,
      // Label 6036: @300555
      GIM_Try, /*On fail goto*//*Label 6037*/ GIMT_Encode4(300605), // Rule ID 656 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 656,
        GIR_EraseRootFromParent_Done,
      // Label 6037: @300605
      GIM_Try, /*On fail goto*//*Label 6038*/ GIMT_Encode4(300636), // Rule ID 638 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 638,
        GIR_Done,
      // Label 6038: @300636
      GIM_Reject,
    // Label 6004: @300637
    GIM_Reject,
    // Label 5930: @300638
    GIM_Try, /*On fail goto*//*Label 6039*/ GIMT_Encode4(302158),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 6040*/ GIMT_Encode4(300734), // Rule ID 6241 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6241,
        GIR_EraseRootFromParent_Done,
      // Label 6040: @300734
      GIM_Try, /*On fail goto*//*Label 6041*/ GIMT_Encode4(300818), // Rule ID 6157 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6157,
        GIR_EraseRootFromParent_Done,
      // Label 6041: @300818
      GIM_Try, /*On fail goto*//*Label 6042*/ GIMT_Encode4(300899), // Rule ID 6189 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6189,
        GIR_EraseRootFromParent_Done,
      // Label 6042: @300899
      GIM_Try, /*On fail goto*//*Label 6043*/ GIMT_Encode4(300983), // Rule ID 6221 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6221,
        GIR_EraseRootFromParent_Done,
      // Label 6043: @300983
      GIM_Try, /*On fail goto*//*Label 6044*/ GIMT_Encode4(301061), // Rule ID 6263 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6263,
        GIR_EraseRootFromParent_Done,
      // Label 6044: @301061
      GIM_Try, /*On fail goto*//*Label 6045*/ GIMT_Encode4(301142), // Rule ID 6125 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6125,
        GIR_EraseRootFromParent_Done,
      // Label 6045: @301142
      GIM_Try, /*On fail goto*//*Label 6046*/ GIMT_Encode4(301211), // Rule ID 2499 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2499,
        GIR_EraseRootFromParent_Done,
      // Label 6046: @301211
      GIM_Try, /*On fail goto*//*Label 6047*/ GIMT_Encode4(301280), // Rule ID 6093 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6093,
        GIR_EraseRootFromParent_Done,
      // Label 6047: @301280
      GIM_Try, /*On fail goto*//*Label 6048*/ GIMT_Encode4(301373), // Rule ID 6245 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6245,
        GIR_EraseRootFromParent_Done,
      // Label 6048: @301373
      GIM_Try, /*On fail goto*//*Label 6049*/ GIMT_Encode4(301472), // Rule ID 6159 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6159,
        GIR_EraseRootFromParent_Done,
      // Label 6049: @301472
      GIM_Try, /*On fail goto*//*Label 6050*/ GIMT_Encode4(301568), // Rule ID 6191 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6191,
        GIR_EraseRootFromParent_Done,
      // Label 6050: @301568
      GIM_Try, /*On fail goto*//*Label 6051*/ GIMT_Encode4(301667), // Rule ID 6223 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6223,
        GIR_EraseRootFromParent_Done,
      // Label 6051: @301667
      GIM_Try, /*On fail goto*//*Label 6052*/ GIMT_Encode4(301760), // Rule ID 6267 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6267,
        GIR_EraseRootFromParent_Done,
      // Label 6052: @301760
      GIM_Try, /*On fail goto*//*Label 6053*/ GIMT_Encode4(301856), // Rule ID 6127 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6127,
        GIR_EraseRootFromParent_Done,
      // Label 6053: @301856
      GIM_Try, /*On fail goto*//*Label 6054*/ GIMT_Encode4(301940), // Rule ID 2501 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2501,
        GIR_EraseRootFromParent_Done,
      // Label 6054: @301940
      GIM_Try, /*On fail goto*//*Label 6055*/ GIMT_Encode4(301990), // Rule ID 13413 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13413,
        GIR_EraseRootFromParent_Done,
      // Label 6055: @301990
      GIM_Try, /*On fail goto*//*Label 6056*/ GIMT_Encode4(302074), // Rule ID 6095 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6095,
        GIR_EraseRootFromParent_Done,
      // Label 6056: @302074
      GIM_Try, /*On fail goto*//*Label 6057*/ GIMT_Encode4(302124), // Rule ID 1297 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1297,
        GIR_EraseRootFromParent_Done,
      // Label 6057: @302124
      GIM_Try, /*On fail goto*//*Label 6058*/ GIMT_Encode4(302157), // Rule ID 1287 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1287,
        GIR_EraseRootFromParent_Done,
      // Label 6058: @302157
      GIM_Reject,
    // Label 6039: @302158
    GIM_Reject,
    // Label 5931: @302159
    GIM_Try, /*On fail goto*//*Label 6059*/ GIMT_Encode4(303679),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 6060*/ GIMT_Encode4(302255), // Rule ID 6253 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6253,
        GIR_EraseRootFromParent_Done,
      // Label 6060: @302255
      GIM_Try, /*On fail goto*//*Label 6061*/ GIMT_Encode4(302339), // Rule ID 6165 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6165,
        GIR_EraseRootFromParent_Done,
      // Label 6061: @302339
      GIM_Try, /*On fail goto*//*Label 6062*/ GIMT_Encode4(302420), // Rule ID 6197 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6197,
        GIR_EraseRootFromParent_Done,
      // Label 6062: @302420
      GIM_Try, /*On fail goto*//*Label 6063*/ GIMT_Encode4(302504), // Rule ID 6229 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6229,
        GIR_EraseRootFromParent_Done,
      // Label 6063: @302504
      GIM_Try, /*On fail goto*//*Label 6064*/ GIMT_Encode4(302582), // Rule ID 6275 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6275,
        GIR_EraseRootFromParent_Done,
      // Label 6064: @302582
      GIM_Try, /*On fail goto*//*Label 6065*/ GIMT_Encode4(302663), // Rule ID 6133 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6133,
        GIR_EraseRootFromParent_Done,
      // Label 6065: @302663
      GIM_Try, /*On fail goto*//*Label 6066*/ GIMT_Encode4(302732), // Rule ID 2507 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2507,
        GIR_EraseRootFromParent_Done,
      // Label 6066: @302732
      GIM_Try, /*On fail goto*//*Label 6067*/ GIMT_Encode4(302801), // Rule ID 6101 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6101,
        GIR_EraseRootFromParent_Done,
      // Label 6067: @302801
      GIM_Try, /*On fail goto*//*Label 6068*/ GIMT_Encode4(302894), // Rule ID 6255 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6255,
        GIR_EraseRootFromParent_Done,
      // Label 6068: @302894
      GIM_Try, /*On fail goto*//*Label 6069*/ GIMT_Encode4(302993), // Rule ID 6167 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6167,
        GIR_EraseRootFromParent_Done,
      // Label 6069: @302993
      GIM_Try, /*On fail goto*//*Label 6070*/ GIMT_Encode4(303089), // Rule ID 6199 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6199,
        GIR_EraseRootFromParent_Done,
      // Label 6070: @303089
      GIM_Try, /*On fail goto*//*Label 6071*/ GIMT_Encode4(303188), // Rule ID 6231 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6231,
        GIR_EraseRootFromParent_Done,
      // Label 6071: @303188
      GIM_Try, /*On fail goto*//*Label 6072*/ GIMT_Encode4(303281), // Rule ID 6277 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6277,
        GIR_EraseRootFromParent_Done,
      // Label 6072: @303281
      GIM_Try, /*On fail goto*//*Label 6073*/ GIMT_Encode4(303377), // Rule ID 6135 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6135,
        GIR_EraseRootFromParent_Done,
      // Label 6073: @303377
      GIM_Try, /*On fail goto*//*Label 6074*/ GIMT_Encode4(303461), // Rule ID 2509 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2509,
        GIR_EraseRootFromParent_Done,
      // Label 6074: @303461
      GIM_Try, /*On fail goto*//*Label 6075*/ GIMT_Encode4(303511), // Rule ID 13417 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13417,
        GIR_EraseRootFromParent_Done,
      // Label 6075: @303511
      GIM_Try, /*On fail goto*//*Label 6076*/ GIMT_Encode4(303595), // Rule ID 6103 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6103,
        GIR_EraseRootFromParent_Done,
      // Label 6076: @303595
      GIM_Try, /*On fail goto*//*Label 6077*/ GIMT_Encode4(303645), // Rule ID 1301 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1301,
        GIR_EraseRootFromParent_Done,
      // Label 6077: @303645
      GIM_Try, /*On fail goto*//*Label 6078*/ GIMT_Encode4(303678), // Rule ID 1291 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1291,
        GIR_EraseRootFromParent_Done,
      // Label 6078: @303678
      GIM_Reject,
    // Label 6059: @303679
    GIM_Reject,
    // Label 5932: @303680
    GIM_Try, /*On fail goto*//*Label 6079*/ GIMT_Encode4(304858),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 6080*/ GIMT_Encode4(303782), // Rule ID 6149 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6149,
        GIR_EraseRootFromParent_Done,
      // Label 6080: @303782
      GIM_Try, /*On fail goto*//*Label 6081*/ GIMT_Encode4(303863), // Rule ID 6181 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6181,
        GIR_EraseRootFromParent_Done,
      // Label 6081: @303863
      GIM_Try, /*On fail goto*//*Label 6082*/ GIMT_Encode4(303947), // Rule ID 6213 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6213,
        GIR_EraseRootFromParent_Done,
      // Label 6082: @303947
      GIM_Try, /*On fail goto*//*Label 6083*/ GIMT_Encode4(304028), // Rule ID 6117 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6117,
        GIR_EraseRootFromParent_Done,
      // Label 6083: @304028
      GIM_Try, /*On fail goto*//*Label 6084*/ GIMT_Encode4(304097), // Rule ID 2491 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2491,
        GIR_EraseRootFromParent_Done,
      // Label 6084: @304097
      GIM_Try, /*On fail goto*//*Label 6085*/ GIMT_Encode4(304166), // Rule ID 6085 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6085,
        GIR_EraseRootFromParent_Done,
      // Label 6085: @304166
      GIM_Try, /*On fail goto*//*Label 6086*/ GIMT_Encode4(304265), // Rule ID 6151 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6151,
        GIR_EraseRootFromParent_Done,
      // Label 6086: @304265
      GIM_Try, /*On fail goto*//*Label 6087*/ GIMT_Encode4(304361), // Rule ID 6183 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6183,
        GIR_EraseRootFromParent_Done,
      // Label 6087: @304361
      GIM_Try, /*On fail goto*//*Label 6088*/ GIMT_Encode4(304460), // Rule ID 6215 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6215,
        GIR_EraseRootFromParent_Done,
      // Label 6088: @304460
      GIM_Try, /*On fail goto*//*Label 6089*/ GIMT_Encode4(304556), // Rule ID 6119 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6119,
        GIR_EraseRootFromParent_Done,
      // Label 6089: @304556
      GIM_Try, /*On fail goto*//*Label 6090*/ GIMT_Encode4(304640), // Rule ID 2493 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2493,
        GIR_EraseRootFromParent_Done,
      // Label 6090: @304640
      GIM_Try, /*On fail goto*//*Label 6091*/ GIMT_Encode4(304690), // Rule ID 13409 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13409,
        GIR_EraseRootFromParent_Done,
      // Label 6091: @304690
      GIM_Try, /*On fail goto*//*Label 6092*/ GIMT_Encode4(304774), // Rule ID 6087 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6087,
        GIR_EraseRootFromParent_Done,
      // Label 6092: @304774
      GIM_Try, /*On fail goto*//*Label 6093*/ GIMT_Encode4(304824), // Rule ID 1293 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1293,
        GIR_EraseRootFromParent_Done,
      // Label 6093: @304824
      GIM_Try, /*On fail goto*//*Label 6094*/ GIMT_Encode4(304857), // Rule ID 1283 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1283,
        GIR_EraseRootFromParent_Done,
      // Label 6094: @304857
      GIM_Reject,
    // Label 6079: @304858
    GIM_Reject,
    // Label 5933: @304859
    GIM_Try, /*On fail goto*//*Label 6095*/ GIMT_Encode4(306379),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 6096*/ GIMT_Encode4(304955), // Rule ID 6247 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6247,
        GIR_EraseRootFromParent_Done,
      // Label 6096: @304955
      GIM_Try, /*On fail goto*//*Label 6097*/ GIMT_Encode4(305039), // Rule ID 6161 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6161,
        GIR_EraseRootFromParent_Done,
      // Label 6097: @305039
      GIM_Try, /*On fail goto*//*Label 6098*/ GIMT_Encode4(305120), // Rule ID 6193 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6193,
        GIR_EraseRootFromParent_Done,
      // Label 6098: @305120
      GIM_Try, /*On fail goto*//*Label 6099*/ GIMT_Encode4(305204), // Rule ID 6225 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6225,
        GIR_EraseRootFromParent_Done,
      // Label 6099: @305204
      GIM_Try, /*On fail goto*//*Label 6100*/ GIMT_Encode4(305282), // Rule ID 6269 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6269,
        GIR_EraseRootFromParent_Done,
      // Label 6100: @305282
      GIM_Try, /*On fail goto*//*Label 6101*/ GIMT_Encode4(305363), // Rule ID 6129 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6129,
        GIR_EraseRootFromParent_Done,
      // Label 6101: @305363
      GIM_Try, /*On fail goto*//*Label 6102*/ GIMT_Encode4(305432), // Rule ID 2503 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2503,
        GIR_EraseRootFromParent_Done,
      // Label 6102: @305432
      GIM_Try, /*On fail goto*//*Label 6103*/ GIMT_Encode4(305501), // Rule ID 6097 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6097,
        GIR_EraseRootFromParent_Done,
      // Label 6103: @305501
      GIM_Try, /*On fail goto*//*Label 6104*/ GIMT_Encode4(305594), // Rule ID 6251 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6251,
        GIR_EraseRootFromParent_Done,
      // Label 6104: @305594
      GIM_Try, /*On fail goto*//*Label 6105*/ GIMT_Encode4(305693), // Rule ID 6163 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6163,
        GIR_EraseRootFromParent_Done,
      // Label 6105: @305693
      GIM_Try, /*On fail goto*//*Label 6106*/ GIMT_Encode4(305789), // Rule ID 6195 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6195,
        GIR_EraseRootFromParent_Done,
      // Label 6106: @305789
      GIM_Try, /*On fail goto*//*Label 6107*/ GIMT_Encode4(305888), // Rule ID 6227 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6227,
        GIR_EraseRootFromParent_Done,
      // Label 6107: @305888
      GIM_Try, /*On fail goto*//*Label 6108*/ GIMT_Encode4(305981), // Rule ID 6273 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6273,
        GIR_EraseRootFromParent_Done,
      // Label 6108: @305981
      GIM_Try, /*On fail goto*//*Label 6109*/ GIMT_Encode4(306077), // Rule ID 6131 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6131,
        GIR_EraseRootFromParent_Done,
      // Label 6109: @306077
      GIM_Try, /*On fail goto*//*Label 6110*/ GIMT_Encode4(306161), // Rule ID 2505 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2505,
        GIR_EraseRootFromParent_Done,
      // Label 6110: @306161
      GIM_Try, /*On fail goto*//*Label 6111*/ GIMT_Encode4(306211), // Rule ID 13415 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13415,
        GIR_EraseRootFromParent_Done,
      // Label 6111: @306211
      GIM_Try, /*On fail goto*//*Label 6112*/ GIMT_Encode4(306295), // Rule ID 6099 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6099,
        GIR_EraseRootFromParent_Done,
      // Label 6112: @306295
      GIM_Try, /*On fail goto*//*Label 6113*/ GIMT_Encode4(306345), // Rule ID 1299 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1299,
        GIR_EraseRootFromParent_Done,
      // Label 6113: @306345
      GIM_Try, /*On fail goto*//*Label 6114*/ GIMT_Encode4(306378), // Rule ID 1289 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1289,
        GIR_EraseRootFromParent_Done,
      // Label 6114: @306378
      GIM_Reject,
    // Label 6095: @306379
    GIM_Reject,
    // Label 5934: @306380
    GIM_Try, /*On fail goto*//*Label 6115*/ GIMT_Encode4(307558),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 6116*/ GIMT_Encode4(306482), // Rule ID 6145 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6145,
        GIR_EraseRootFromParent_Done,
      // Label 6116: @306482
      GIM_Try, /*On fail goto*//*Label 6117*/ GIMT_Encode4(306563), // Rule ID 6177 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6177,
        GIR_EraseRootFromParent_Done,
      // Label 6117: @306563
      GIM_Try, /*On fail goto*//*Label 6118*/ GIMT_Encode4(306647), // Rule ID 6209 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6209,
        GIR_EraseRootFromParent_Done,
      // Label 6118: @306647
      GIM_Try, /*On fail goto*//*Label 6119*/ GIMT_Encode4(306728), // Rule ID 6113 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6113,
        GIR_EraseRootFromParent_Done,
      // Label 6119: @306728
      GIM_Try, /*On fail goto*//*Label 6120*/ GIMT_Encode4(306797), // Rule ID 2487 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2487,
        GIR_EraseRootFromParent_Done,
      // Label 6120: @306797
      GIM_Try, /*On fail goto*//*Label 6121*/ GIMT_Encode4(306866), // Rule ID 6081 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6081,
        GIR_EraseRootFromParent_Done,
      // Label 6121: @306866
      GIM_Try, /*On fail goto*//*Label 6122*/ GIMT_Encode4(306965), // Rule ID 6147 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6147,
        GIR_EraseRootFromParent_Done,
      // Label 6122: @306965
      GIM_Try, /*On fail goto*//*Label 6123*/ GIMT_Encode4(307061), // Rule ID 6179 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6179,
        GIR_EraseRootFromParent_Done,
      // Label 6123: @307061
      GIM_Try, /*On fail goto*//*Label 6124*/ GIMT_Encode4(307160), // Rule ID 6211 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6211,
        GIR_EraseRootFromParent_Done,
      // Label 6124: @307160
      GIM_Try, /*On fail goto*//*Label 6125*/ GIMT_Encode4(307256), // Rule ID 6115 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6115,
        GIR_EraseRootFromParent_Done,
      // Label 6125: @307256
      GIM_Try, /*On fail goto*//*Label 6126*/ GIMT_Encode4(307340), // Rule ID 2489 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2489,
        GIR_EraseRootFromParent_Done,
      // Label 6126: @307340
      GIM_Try, /*On fail goto*//*Label 6127*/ GIMT_Encode4(307390), // Rule ID 13411 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13411,
        GIR_EraseRootFromParent_Done,
      // Label 6127: @307390
      GIM_Try, /*On fail goto*//*Label 6128*/ GIMT_Encode4(307474), // Rule ID 6083 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6083,
        GIR_EraseRootFromParent_Done,
      // Label 6128: @307474
      GIM_Try, /*On fail goto*//*Label 6129*/ GIMT_Encode4(307524), // Rule ID 1295 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1295,
        GIR_EraseRootFromParent_Done,
      // Label 6129: @307524
      GIM_Try, /*On fail goto*//*Label 6130*/ GIMT_Encode4(307557), // Rule ID 1285 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1285,
        GIR_EraseRootFromParent_Done,
      // Label 6130: @307557
      GIM_Reject,
    // Label 6115: @307558
    GIM_Reject,
    // Label 5935: @307559
    GIM_Reject,
    // Label 58: @307560
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6139*/ GIMT_Encode4(309452),
    /*GILLT_s16*//*Label 6131*/ GIMT_Encode4(307611),
    /*GILLT_s32*//*Label 6132*/ GIMT_Encode4(307649),
    /*GILLT_s64*//*Label 6133*/ GIMT_Encode4(307687), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 6134*/ GIMT_Encode4(307725),
    /*GILLT_v2s64*//*Label 6135*/ GIMT_Encode4(307763),
    /*GILLT_v4s16*//*Label 6136*/ GIMT_Encode4(307801),
    /*GILLT_v4s32*//*Label 6137*/ GIMT_Encode4(307839), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 6138*/ GIMT_Encode4(307877),
    // Label 6131: @307611
    GIM_Try, /*On fail goto*//*Label 6140*/ GIMT_Encode4(307648), // Rule ID 586 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // (fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FDIVHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVHrr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 586,
      GIR_Done,
    // Label 6140: @307648
    GIM_Reject,
    // Label 6132: @307649
    GIM_Try, /*On fail goto*//*Label 6141*/ GIMT_Encode4(307686), // Rule ID 588 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      // (fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FDIVSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVSrr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 588,
      GIR_Done,
    // Label 6141: @307686
    GIM_Reject,
    // Label 6133: @307687
    GIM_Try, /*On fail goto*//*Label 6142*/ GIMT_Encode4(307724), // Rule ID 590 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FDIVDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVDrr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 590,
      GIR_Done,
    // Label 6142: @307724
    GIM_Reject,
    // Label 6134: @307725
    GIM_Try, /*On fail goto*//*Label 6143*/ GIMT_Encode4(307762), // Rule ID 1217 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fdiv:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FDIVv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1217,
      GIR_Done,
    // Label 6143: @307762
    GIM_Reject,
    // Label 6135: @307763
    GIM_Try, /*On fail goto*//*Label 6144*/ GIMT_Encode4(307800), // Rule ID 1221 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fdiv:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FDIVv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f64),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1221,
      GIR_Done,
    // Label 6144: @307800
    GIM_Reject,
    // Label 6136: @307801
    GIM_Try, /*On fail goto*//*Label 6145*/ GIMT_Encode4(307838), // Rule ID 1213 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fdiv:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FDIVv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1213,
      GIR_Done,
    // Label 6145: @307838
    GIM_Reject,
    // Label 6137: @307839
    GIM_Try, /*On fail goto*//*Label 6146*/ GIMT_Encode4(307876), // Rule ID 1219 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fdiv:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FDIVv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1219,
      GIR_Done,
    // Label 6146: @307876
    GIM_Reject,
    // Label 6138: @307877
    GIM_Try, /*On fail goto*//*Label 6147*/ GIMT_Encode4(309451),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 6148*/ GIMT_Encode4(307919), // Rule ID 1215 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        // (fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FDIVv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv8f16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1215,
        GIR_Done,
      // Label 6148: @307919
      GIM_Try, /*On fail goto*//*Label 6149*/ GIMT_Encode4(308173), // Rule ID 7191 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
        // (fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FDIVv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FDIVv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
        GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
        GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
        GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
        GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7191,
        GIR_EraseRootFromParent_Done,
      // Label 6149: @308173
      GIM_Try, /*On fail goto*//*Label 6150*/ GIMT_Encode4(308377), // Rule ID 7193 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16),
        // (fdiv:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)  =>  (BFCVTN2:{ *:[v8bf16] } (BFCVTN:{ *:[v8bf16] } (FDIVv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] })))), (FDIVv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm)))
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/8,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::BFCVTN),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFCVTN2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7193,
        GIR_EraseRootFromParent_Done,
      // Label 6150: @308377
      GIM_Try, /*On fail goto*//*Label 6151*/ GIMT_Encode4(309450), // Rule ID 7195 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoBF16),
        // (fdiv:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8bf16] } (BSPv16i8:{ *:[f128] } (FCMEQv4f32:{ *:[f128] } (FDIVv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] }))), (FDIVv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] })))), (ADDv4i32:{ *:[f128] } (ADDv4i32:{ *:[f128] } (FDIVv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] }))), (ANDv16i8:{ *:[f128] } (USHRv4i32_shift:{ *:[f128] } V128:{ *:[v8bf16] }:$Rn, 16:{ *:[i32] }), (MOVIv4i32:{ *:[f128] } 1:{ *:[i32] }, 0:{ *:[i32] }))), (MOVIv4s_msl:{ *:[f128] } 127:{ *:[i32] }, 264:{ *:[i32] })), (ORRv4i32:{ *:[f128] } (FDIVv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] }))), 64:{ *:[i32] }, 16:{ *:[i32] })), (BSPv16i8:{ *:[f128] } (FCMEQv4f32:{ *:[f128] } (FDIVv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm)), (FDIVv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm))), (ADDv4i32:{ *:[f128] } (ADDv4i32:{ *:[f128] } (FDIVv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm)), (ANDv16i8:{ *:[f128] } (USHRv4i32_shift:{ *:[f128] } V128:{ *:[v8bf16] }:$Rn, 16:{ *:[i32] }), (MOVIv4i32:{ *:[f128] } 1:{ *:[i32] }, 0:{ *:[i32] }))), (MOVIv4s_msl:{ *:[f128] } 127:{ *:[i32] }, 264:{ *:[i32] })), (ORRv4i32:{ *:[f128] } (FDIVv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm)), 64:{ *:[i32] }, 16:{ *:[i32] })))
        GIR_MakeTempReg, /*TempRegID*/49, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/50, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/50, /*TempRegID*/49, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/50, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/50,
        GIR_MakeTempReg, /*TempRegID*/48, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/49, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/49, /*TempRegID*/48, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/49, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/49,
        GIR_MakeTempReg, /*TempRegID*/47, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/48, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
        GIR_AddTempRegister, /*InsnID*/48, /*TempRegID*/47, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/48, /*TempRegID*/48,
        GIR_AddSimpleTempRegister, /*InsnID*/48, /*TempRegID*/49,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/48,
        GIR_MakeTempReg, /*TempRegID*/46, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/47, /*Opcode*/GIMT_Encode2(AArch64::ORRv4i32),
        GIR_AddTempRegister, /*InsnID*/47, /*TempRegID*/46, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/47, /*TempRegID*/47,
        GIR_AddImm8, /*InsnID*/47, /*Imm*/64,
        GIR_AddImm8, /*InsnID*/47, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/47,
        GIR_MakeTempReg, /*TempRegID*/45, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/46, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4s_msl),
        GIR_AddTempRegister, /*InsnID*/46, /*TempRegID*/45, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/46, /*Imm*/127,
        GIR_AddImm, /*InsnID*/46, /*Imm*/GIMT_Encode8(264),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/46,
        GIR_MakeTempReg, /*TempRegID*/44, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/45, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i32),
        GIR_AddTempRegister, /*InsnID*/45, /*TempRegID*/44, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/45, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/45, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/45,
        GIR_MakeTempReg, /*TempRegID*/43, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/44, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
        GIR_AddTempRegister, /*InsnID*/44, /*TempRegID*/43, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/44, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/44, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/44,
        GIR_MakeTempReg, /*TempRegID*/42, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/43, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
        GIR_AddTempRegister, /*InsnID*/43, /*TempRegID*/42, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/43, /*TempRegID*/43,
        GIR_AddSimpleTempRegister, /*InsnID*/43, /*TempRegID*/44,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/43,
        GIR_MakeTempReg, /*TempRegID*/41, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/42, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/42, /*TempRegID*/41, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/42, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/42,
        GIR_MakeTempReg, /*TempRegID*/40, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/41, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/41, /*TempRegID*/40, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/41, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/41,
        GIR_MakeTempReg, /*TempRegID*/39, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/40, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
        GIR_AddTempRegister, /*InsnID*/40, /*TempRegID*/39, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/40, /*TempRegID*/40,
        GIR_AddSimpleTempRegister, /*InsnID*/40, /*TempRegID*/41,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/40,
        GIR_MakeTempReg, /*TempRegID*/38, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/39, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/39, /*TempRegID*/38, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/39, /*TempRegID*/39,
        GIR_AddSimpleTempRegister, /*InsnID*/39, /*TempRegID*/42,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/39,
        GIR_MakeTempReg, /*TempRegID*/37, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/38, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/38, /*TempRegID*/37, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/38, /*TempRegID*/38,
        GIR_AddSimpleTempRegister, /*InsnID*/38, /*TempRegID*/45,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/38,
        GIR_MakeTempReg, /*TempRegID*/36, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/37, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/37, /*TempRegID*/36, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/37, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/37,
        GIR_MakeTempReg, /*TempRegID*/35, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/36, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/36, /*TempRegID*/35, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/36, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/36,
        GIR_MakeTempReg, /*TempRegID*/34, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/35, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
        GIR_AddTempRegister, /*InsnID*/35, /*TempRegID*/34, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/35, /*TempRegID*/35,
        GIR_AddSimpleTempRegister, /*InsnID*/35, /*TempRegID*/36,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/35,
        GIR_MakeTempReg, /*TempRegID*/33, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/34, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/34, /*TempRegID*/33, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/34, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/34,
        GIR_MakeTempReg, /*TempRegID*/32, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/33, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/33, /*TempRegID*/32, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/33, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/33,
        GIR_MakeTempReg, /*TempRegID*/31, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/32, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
        GIR_AddTempRegister, /*InsnID*/32, /*TempRegID*/31, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/32, /*TempRegID*/32,
        GIR_AddSimpleTempRegister, /*InsnID*/32, /*TempRegID*/33,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/32,
        GIR_MakeTempReg, /*TempRegID*/30, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/31, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
        GIR_AddTempRegister, /*InsnID*/31, /*TempRegID*/30, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/31, /*TempRegID*/31,
        GIR_AddSimpleTempRegister, /*InsnID*/31, /*TempRegID*/34,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/31,
        GIR_MakeTempReg, /*TempRegID*/29, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/30, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_AddTempRegister, /*InsnID*/30, /*TempRegID*/29, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/30, /*TempRegID*/30,
        GIR_AddSimpleTempRegister, /*InsnID*/30, /*TempRegID*/37,
        GIR_AddSimpleTempRegister, /*InsnID*/30, /*TempRegID*/46,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/30,
        GIR_MakeTempReg, /*TempRegID*/28, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/29, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/29, /*TempRegID*/28, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/29, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/29, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/29, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/27, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/28, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/28, /*TempRegID*/27, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/28, /*TempRegID*/28,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/28,
        GIR_MakeTempReg, /*TempRegID*/26, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/27, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/27, /*TempRegID*/26, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/27, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/27, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/27, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/25, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/26, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/26, /*TempRegID*/25, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/26, /*TempRegID*/26,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/26,
        GIR_MakeTempReg, /*TempRegID*/24, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/25, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
        GIR_AddTempRegister, /*InsnID*/25, /*TempRegID*/24, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/25, /*TempRegID*/25,
        GIR_AddSimpleTempRegister, /*InsnID*/25, /*TempRegID*/27,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/25,
        GIR_MakeTempReg, /*TempRegID*/23, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/24, /*Opcode*/GIMT_Encode2(AArch64::ORRv4i32),
        GIR_AddTempRegister, /*InsnID*/24, /*TempRegID*/23, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/24, /*TempRegID*/24,
        GIR_AddImm8, /*InsnID*/24, /*Imm*/64,
        GIR_AddImm8, /*InsnID*/24, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/24,
        GIR_MakeTempReg, /*TempRegID*/22, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/23, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4s_msl),
        GIR_AddTempRegister, /*InsnID*/23, /*TempRegID*/22, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/23, /*Imm*/127,
        GIR_AddImm, /*InsnID*/23, /*Imm*/GIMT_Encode8(264),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/23,
        GIR_MakeTempReg, /*TempRegID*/21, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/22, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i32),
        GIR_AddTempRegister, /*InsnID*/22, /*TempRegID*/21, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/22, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/22, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/22,
        GIR_MakeTempReg, /*TempRegID*/20, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/21, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
        GIR_AddTempRegister, /*InsnID*/21, /*TempRegID*/20, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/21, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/21, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/21,
        GIR_MakeTempReg, /*TempRegID*/19, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/20, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
        GIR_AddTempRegister, /*InsnID*/20, /*TempRegID*/19, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/20, /*TempRegID*/20,
        GIR_AddSimpleTempRegister, /*InsnID*/20, /*TempRegID*/21,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/20,
        GIR_MakeTempReg, /*TempRegID*/18, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/19, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/19, /*TempRegID*/18, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/19, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/19, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/19, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/17, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/18, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/18, /*TempRegID*/17, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/18, /*TempRegID*/18,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/18,
        GIR_MakeTempReg, /*TempRegID*/16, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/17, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/17, /*TempRegID*/16, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/17, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/17, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/17, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/15, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/16, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/16, /*TempRegID*/15, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/16, /*TempRegID*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/16,
        GIR_MakeTempReg, /*TempRegID*/14, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/15, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
        GIR_AddTempRegister, /*InsnID*/15, /*TempRegID*/14, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/15, /*TempRegID*/15,
        GIR_AddSimpleTempRegister, /*InsnID*/15, /*TempRegID*/17,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/15,
        GIR_MakeTempReg, /*TempRegID*/13, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/14, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/14, /*TempRegID*/13, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/14,
        GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/19,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/14,
        GIR_MakeTempReg, /*TempRegID*/12, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/13, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/13, /*TempRegID*/12, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/13, /*TempRegID*/13,
        GIR_AddSimpleTempRegister, /*InsnID*/13, /*TempRegID*/22,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/13,
        GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/11, /*TempRegID*/11,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
        GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
        GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/10,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/12,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/23,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/29,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7195,
        GIR_EraseRootFromParent_Done,
      // Label 6151: @309450
      GIM_Reject,
    // Label 6147: @309451
    GIM_Reject,
    // Label 6139: @309452
    GIM_Reject,
    // Label 59: @309453
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 6163*/ GIMT_Encode4(313332),
    /*GILLT_s16*//*Label 6152*/ GIMT_Encode4(309548),
    /*GILLT_s32*//*Label 6153*/ GIMT_Encode4(310861),
    /*GILLT_s64*//*Label 6154*/ GIMT_Encode4(311884), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 6155*/ GIMT_Encode4(312907),
    /*GILLT_v2s64*//*Label 6156*/ GIMT_Encode4(312934),
    /*GILLT_v4s16*//*Label 6157*/ GIMT_Encode4(312961),
    /*GILLT_v4s32*//*Label 6158*/ GIMT_Encode4(313088), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 6159*/ GIMT_Encode4(313115), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s16*//*Label 6160*/ GIMT_Encode4(313242), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv4s16*//*Label 6161*/ GIMT_Encode4(313272), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv8s16*//*Label 6162*/ GIMT_Encode4(313302),
    // Label 6152: @309548
    GIM_Try, /*On fail goto*//*Label 6164*/ GIMT_Encode4(310860),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_Try, /*On fail goto*//*Label 6165*/ GIMT_Encode4(309718), // Rule ID 4880 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fneg:{ *:[f16] } (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4880,
        GIR_EraseRootFromParent_Done,
      // Label 6165: @309718
      GIM_Try, /*On fail goto*//*Label 6166*/ GIMT_Encode4(309876), // Rule ID 4879 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4879,
        GIR_EraseRootFromParent_Done,
      // Label 6166: @309876
      GIM_Try, /*On fail goto*//*Label 6167*/ GIMT_Encode4(309987), // Rule ID 4878 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fneg:{ *:[f16] } (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4878,
        GIR_EraseRootFromParent_Done,
      // Label 6167: @309987
      GIM_Try, /*On fail goto*//*Label 6168*/ GIMT_Encode4(310098), // Rule ID 4876 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fneg:{ *:[f16] } (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4876,
        GIR_EraseRootFromParent_Done,
      // Label 6168: @310098
      GIM_Try, /*On fail goto*//*Label 6169*/ GIMT_Encode4(310209), // Rule ID 4877 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4877,
        GIR_EraseRootFromParent_Done,
      // Label 6169: @310209
      GIM_Try, /*On fail goto*//*Label 6170*/ GIMT_Encode4(310320), // Rule ID 4875 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4875,
        GIR_EraseRootFromParent_Done,
      // Label 6170: @310320
      GIM_Try, /*On fail goto*//*Label 6171*/ GIMT_Encode4(310384), // Rule ID 646 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fneg:{ *:[f16] } (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 646,
        GIR_EraseRootFromParent_Done,
      // Label 6171: @310384
      GIM_Try, /*On fail goto*//*Label 6172*/ GIMT_Encode4(310448), // Rule ID 645 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 645,
        GIR_EraseRootFromParent_Done,
      // Label 6172: @310448
      GIM_Try, /*On fail goto*//*Label 6173*/ GIMT_Encode4(310499), // Rule ID 622 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fneg:{ *:[f16] } (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm))  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 622,
        GIR_EraseRootFromParent_Done,
      // Label 6173: @310499
      GIM_Try, /*On fail goto*//*Label 6174*/ GIMT_Encode4(310550), // Rule ID 621 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fneg:{ *:[f16] } (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm))  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 621,
        GIR_EraseRootFromParent_Done,
      // Label 6174: @310550
      GIM_Try, /*On fail goto*//*Label 6175*/ GIMT_Encode4(310569), // Rule ID 520 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FNEGHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGHr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 520,
        GIR_Done,
      // Label 6175: @310569
      GIM_Try, /*On fail goto*//*Label 6176*/ GIMT_Encode4(310714), // Rule ID 6424 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[f32] } (EORWri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), GPR32:{ *:[i32] }), (logical_imm32_XFORM:{ *:[i32] } 32768:{ *:[i32] })), FPR32:{ *:[i32] }), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::EORWri),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // 
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 6424,
        GIR_EraseRootFromParent_Done,
      // Label 6176: @310714
      GIM_Try, /*On fail goto*//*Label 6177*/ GIMT_Encode4(310859), // Rule ID 6425 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (fneg:{ *:[bf16] } FPR16:{ *:[bf16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[bf16] } (COPY_TO_REGCLASS:{ *:[f32] } (EORWri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FPR16:{ *:[bf16] }:$Rn, hsub:{ *:[i32] }), GPR32:{ *:[i32] }), (logical_imm32_XFORM:{ *:[i32] } 32768:{ *:[i32] })), FPR32:{ *:[i32] }), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::EORWri),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // 
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 6425,
        GIR_EraseRootFromParent_Done,
      // Label 6177: @310859
      GIM_Reject,
    // Label 6164: @310860
    GIM_Reject,
    // Label 6153: @310861
    GIM_Try, /*On fail goto*//*Label 6178*/ GIMT_Encode4(311883),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 6179*/ GIMT_Encode4(311031), // Rule ID 4886 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fneg:{ *:[f32] } (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4886,
        GIR_EraseRootFromParent_Done,
      // Label 6179: @311031
      GIM_Try, /*On fail goto*//*Label 6180*/ GIMT_Encode4(311189), // Rule ID 4885 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4885,
        GIR_EraseRootFromParent_Done,
      // Label 6180: @311189
      GIM_Try, /*On fail goto*//*Label 6181*/ GIMT_Encode4(311300), // Rule ID 4884 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fneg:{ *:[f32] } (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4884,
        GIR_EraseRootFromParent_Done,
      // Label 6181: @311300
      GIM_Try, /*On fail goto*//*Label 6182*/ GIMT_Encode4(311411), // Rule ID 4882 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fneg:{ *:[f32] } (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4882,
        GIR_EraseRootFromParent_Done,
      // Label 6182: @311411
      GIM_Try, /*On fail goto*//*Label 6183*/ GIMT_Encode4(311522), // Rule ID 4883 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4883,
        GIR_EraseRootFromParent_Done,
      // Label 6183: @311522
      GIM_Try, /*On fail goto*//*Label 6184*/ GIMT_Encode4(311633), // Rule ID 4881 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4881,
        GIR_EraseRootFromParent_Done,
      // Label 6184: @311633
      GIM_Try, /*On fail goto*//*Label 6185*/ GIMT_Encode4(311697), // Rule ID 648 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fneg:{ *:[f32] } (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 648,
        GIR_EraseRootFromParent_Done,
      // Label 6185: @311697
      GIM_Try, /*On fail goto*//*Label 6186*/ GIMT_Encode4(311761), // Rule ID 647 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 647,
        GIR_EraseRootFromParent_Done,
      // Label 6186: @311761
      GIM_Try, /*On fail goto*//*Label 6187*/ GIMT_Encode4(311812), // Rule ID 624 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fneg:{ *:[f32] } (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm))  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 624,
        GIR_EraseRootFromParent_Done,
      // Label 6187: @311812
      GIM_Try, /*On fail goto*//*Label 6188*/ GIMT_Encode4(311863), // Rule ID 623 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fneg:{ *:[f32] } (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm))  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 623,
        GIR_EraseRootFromParent_Done,
      // Label 6188: @311863
      GIM_Try, /*On fail goto*//*Label 6189*/ GIMT_Encode4(311882), // Rule ID 521 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FNEGSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGSr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 521,
        GIR_Done,
      // Label 6189: @311882
      GIM_Reject,
    // Label 6178: @311883
    GIM_Reject,
    // Label 6154: @311884
    GIM_Try, /*On fail goto*//*Label 6190*/ GIMT_Encode4(312906),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 6191*/ GIMT_Encode4(312054), // Rule ID 4892 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fneg:{ *:[f64] } (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4892,
        GIR_EraseRootFromParent_Done,
      // Label 6191: @312054
      GIM_Try, /*On fail goto*//*Label 6192*/ GIMT_Encode4(312212), // Rule ID 4891 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4891,
        GIR_EraseRootFromParent_Done,
      // Label 6192: @312212
      GIM_Try, /*On fail goto*//*Label 6193*/ GIMT_Encode4(312323), // Rule ID 4890 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fneg:{ *:[f64] } (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4890,
        GIR_EraseRootFromParent_Done,
      // Label 6193: @312323
      GIM_Try, /*On fail goto*//*Label 6194*/ GIMT_Encode4(312434), // Rule ID 4888 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fneg:{ *:[f64] } (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4888,
        GIR_EraseRootFromParent_Done,
      // Label 6194: @312434
      GIM_Try, /*On fail goto*//*Label 6195*/ GIMT_Encode4(312545), // Rule ID 4889 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4889,
        GIR_EraseRootFromParent_Done,
      // Label 6195: @312545
      GIM_Try, /*On fail goto*//*Label 6196*/ GIMT_Encode4(312656), // Rule ID 4887 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4887,
        GIR_EraseRootFromParent_Done,
      // Label 6196: @312656
      GIM_Try, /*On fail goto*//*Label 6197*/ GIMT_Encode4(312720), // Rule ID 650 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fneg:{ *:[f64] } (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 650,
        GIR_EraseRootFromParent_Done,
      // Label 6197: @312720
      GIM_Try, /*On fail goto*//*Label 6198*/ GIMT_Encode4(312784), // Rule ID 649 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 649,
        GIR_EraseRootFromParent_Done,
      // Label 6198: @312784
      GIM_Try, /*On fail goto*//*Label 6199*/ GIMT_Encode4(312835), // Rule ID 626 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fneg:{ *:[f64] } (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm))  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 626,
        GIR_EraseRootFromParent_Done,
      // Label 6199: @312835
      GIM_Try, /*On fail goto*//*Label 6200*/ GIMT_Encode4(312886), // Rule ID 625 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fneg:{ *:[f64] } (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm))  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 625,
        GIR_EraseRootFromParent_Done,
      // Label 6200: @312886
      GIM_Try, /*On fail goto*//*Label 6201*/ GIMT_Encode4(312905), // Rule ID 522 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FNEGDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGDr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 522,
        GIR_Done,
      // Label 6201: @312905
      GIM_Reject,
    // Label 6190: @312906
    GIM_Reject,
    // Label 6155: @312907
    GIM_Try, /*On fail goto*//*Label 6202*/ GIMT_Encode4(312933), // Rule ID 849 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FNEGv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv2f32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 849,
      GIR_Done,
    // Label 6202: @312933
    GIM_Reject,
    // Label 6156: @312934
    GIM_Try, /*On fail goto*//*Label 6203*/ GIMT_Encode4(312960), // Rule ID 851 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FNEGv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv2f64),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 851,
      GIR_Done,
    // Label 6203: @312960
    GIM_Reject,
    // Label 6157: @312961
    GIM_Try, /*On fail goto*//*Label 6204*/ GIMT_Encode4(313087),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 6205*/ GIMT_Encode4(312992), // Rule ID 847 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        // (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FNEGv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv4f16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 847,
        GIR_Done,
      // Label 6205: @312992
      GIM_Try, /*On fail goto*//*Label 6206*/ GIMT_Encode4(313039), // Rule ID 6430 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (EORv8i8:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (MOVIv4i16:{ *:[i64] } 128:{ *:[i32] }, 8:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(128),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6430,
        GIR_EraseRootFromParent_Done,
      // Label 6206: @313039
      GIM_Try, /*On fail goto*//*Label 6207*/ GIMT_Encode4(313086), // Rule ID 6431 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (fneg:{ *:[v4bf16] } V64:{ *:[v4bf16] }:$Rn)  =>  (EORv8i8:{ *:[v4bf16] } V64:{ *:[v4bf16] }:$Rn, (MOVIv4i16:{ *:[v4i16] } 128:{ *:[i32] }, 8:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(128),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6431,
        GIR_EraseRootFromParent_Done,
      // Label 6207: @313086
      GIM_Reject,
    // Label 6204: @313087
    GIM_Reject,
    // Label 6158: @313088
    GIM_Try, /*On fail goto*//*Label 6208*/ GIMT_Encode4(313114), // Rule ID 850 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FNEGv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv4f32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 850,
      GIR_Done,
    // Label 6208: @313114
    GIM_Reject,
    // Label 6159: @313115
    GIM_Try, /*On fail goto*//*Label 6209*/ GIMT_Encode4(313241),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 6210*/ GIMT_Encode4(313146), // Rule ID 848 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        // (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FNEGv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv8f16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 848,
        GIR_Done,
      // Label 6210: @313146
      GIM_Try, /*On fail goto*//*Label 6211*/ GIMT_Encode4(313193), // Rule ID 6432 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (EORv16i8:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (MOVIv8i16:{ *:[f128] } 128:{ *:[i32] }, 8:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv8i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(128),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6432,
        GIR_EraseRootFromParent_Done,
      // Label 6211: @313193
      GIM_Try, /*On fail goto*//*Label 6212*/ GIMT_Encode4(313240), // Rule ID 6433 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (fneg:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn)  =>  (EORv16i8:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, (MOVIv8i16:{ *:[v8i16] } 128:{ *:[i32] }, 8:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv8i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(128),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6433,
        GIR_EraseRootFromParent_Done,
      // Label 6212: @313240
      GIM_Reject,
    // Label 6209: @313241
    GIM_Reject,
    // Label 6160: @313242
    GIM_Try, /*On fail goto*//*Label 6213*/ GIMT_Encode4(313271), // Rule ID 7922 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (fneg:{ *:[nxv2bf16] } nxv2bf16:{ *:[nxv2bf16] }:$op)  =>  (EOR_ZI:{ *:[nxv2bf16] } ?:{ *:[nxv2bf16] }:$op, (logical_imm64_XFORM:{ *:[i64] } -9223231297218904064:{ *:[i64] }))
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZI),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
      GIR_RootToRootCopy, /*OpIdx*/1, // op
      GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // 
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7922,
      GIR_EraseRootFromParent_Done,
    // Label 6213: @313271
    GIM_Reject,
    // Label 6161: @313272
    GIM_Try, /*On fail goto*//*Label 6214*/ GIMT_Encode4(313301), // Rule ID 7924 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (fneg:{ *:[nxv4bf16] } nxv4bf16:{ *:[nxv4bf16] }:$op)  =>  (EOR_ZI:{ *:[nxv4bf16] } ?:{ *:[nxv4bf16] }:$op, (logical_imm64_XFORM:{ *:[i64] } -9223231297218904064:{ *:[i64] }))
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZI),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
      GIR_RootToRootCopy, /*OpIdx*/1, // op
      GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // 
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7924,
      GIR_EraseRootFromParent_Done,
    // Label 6214: @313301
    GIM_Reject,
    // Label 6162: @313302
    GIM_Try, /*On fail goto*//*Label 6215*/ GIMT_Encode4(313331), // Rule ID 7926 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (fneg:{ *:[nxv8bf16] } nxv8bf16:{ *:[nxv8bf16] }:$op)  =>  (EOR_ZI:{ *:[nxv8bf16] } ?:{ *:[nxv8bf16] }:$op, (logical_imm64_XFORM:{ *:[i64] } -9223231297218904064:{ *:[i64] }))
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZI),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
      GIR_RootToRootCopy, /*OpIdx*/1, // op
      GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // 
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7926,
      GIR_EraseRootFromParent_Done,
    // Label 6215: @313331
    GIM_Reject,
    // Label 6163: @313332
    GIM_Reject,
    // Label 60: @313333
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(20), /*)*//*default:*//*Label 6222*/ GIMT_Encode4(313696),
    /*GILLT_s32*//*Label 6216*/ GIMT_Encode4(313416),
    /*GILLT_s64*//*Label 6217*/ GIMT_Encode4(313447), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_v2s64*//*Label 6218*/ GIMT_Encode4(313508), GIMT_Encode4(0),
    /*GILLT_v4s32*//*Label 6219*/ GIMT_Encode4(313566), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s32*//*Label 6220*/ GIMT_Encode4(313640), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv4s32*//*Label 6221*/ GIMT_Encode4(313668),
    // Label 6216: @313416
    GIM_Try, /*On fail goto*//*Label 6223*/ GIMT_Encode4(313446), // Rule ID 512 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // (fpextend:{ *:[f32] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTSHr:{ *:[f32] } FPR16:{ *:[f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTSHr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 512,
      GIR_Done,
    // Label 6223: @313446
    GIM_Reject,
    // Label 6217: @313447
    GIM_Try, /*On fail goto*//*Label 6224*/ GIMT_Encode4(313477), // Rule ID 510 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // (fpextend:{ *:[f64] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTDHr:{ *:[f64] } FPR16:{ *:[f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTDHr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 510,
      GIR_Done,
    // Label 6224: @313477
    GIM_Try, /*On fail goto*//*Label 6225*/ GIMT_Encode4(313507), // Rule ID 514 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      // (fpextend:{ *:[f64] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTDSr:{ *:[f64] } FPR32:{ *:[f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTDSr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 514,
      GIR_Done,
    // Label 6225: @313507
    GIM_Reject,
    // Label 6218: @313508
    GIM_Try, /*On fail goto*//*Label 6226*/ GIMT_Encode4(313565),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 6227*/ GIMT_Encode4(313544), // Rule ID 4937 //
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4f32),
        // (fpextend:{ *:[v2f64] } (extract_high_v4f32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn))  =>  (FCVTLv4i32:{ *:[v2f64] } V128:{ *:[v4f32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4937,
        GIR_EraseRootFromParent_Done,
      // Label 6227: @313544
      GIM_Try, /*On fail goto*//*Label 6228*/ GIMT_Encode4(313564), // Rule ID 4935 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (fpextend:{ *:[v2f64] } V64:{ *:[v2f32] }:$Rn)  =>  (FCVTLv2i32:{ *:[v2f64] } V64:{ *:[v2f32] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv2i32),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4935,
        GIR_Done,
      // Label 6228: @313564
      GIM_Reject,
    // Label 6226: @313565
    GIM_Reject,
    // Label 6219: @313566
    GIM_Try, /*On fail goto*//*Label 6229*/ GIMT_Encode4(313639),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 6230*/ GIMT_Encode4(313602), // Rule ID 4941 //
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8f16),
        // (fpextend:{ *:[v4f32] } (extract_high_v8f16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn))  =>  (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4941,
        GIR_EraseRootFromParent_Done,
      // Label 6230: @313602
      GIM_Try, /*On fail goto*//*Label 6231*/ GIMT_Encode4(313622), // Rule ID 4939 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (fpextend:{ *:[v4f32] } V64:{ *:[v4f16] }:$Rn)  =>  (FCVTLv4i16:{ *:[v4f32] } V64:{ *:[v4f16] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4939,
        GIR_Done,
      // Label 6231: @313622
      GIM_Try, /*On fail goto*//*Label 6232*/ GIMT_Encode4(313638), // Rule ID 6412 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (fpextend:{ *:[v4f32] } V64:{ *:[v4bf16] }:$Rn)  =>  (SHLLv4i16:{ *:[v4f32] } V64:{ *:[v4bf16] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6412,
        GIR_Done,
      // Label 6232: @313638
      GIM_Reject,
    // Label 6229: @313639
    GIM_Reject,
    // Label 6220: @313640
    GIM_Try, /*On fail goto*//*Label 6233*/ GIMT_Encode4(313667), // Rule ID 10490 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (fpextend:{ *:[nxv2f32] } nxv2bf16:{ *:[nxv2bf16] }:$op)  =>  (LSL_ZZI_S:{ *:[nxv2f32] } ?:{ *:[nxv2bf16] }:$op, 16:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZZI_S),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
      GIR_RootToRootCopy, /*OpIdx*/1, // op
      GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 10490,
      GIR_EraseRootFromParent_Done,
    // Label 6233: @313667
    GIM_Reject,
    // Label 6221: @313668
    GIM_Try, /*On fail goto*//*Label 6234*/ GIMT_Encode4(313695), // Rule ID 10489 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (fpextend:{ *:[nxv4f32] } nxv4bf16:{ *:[nxv4bf16] }:$op)  =>  (LSL_ZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4bf16] }:$op, 16:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZZI_S),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
      GIR_RootToRootCopy, /*OpIdx*/1, // op
      GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 10489,
      GIR_EraseRootFromParent_Done,
    // Label 6234: @313695
    GIM_Reject,
    // Label 6222: @313696
    GIM_Reject,
    // Label 61: @313697
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(8), /*)*//*default:*//*Label 6239*/ GIMT_Encode4(314016),
    /*GILLT_s16*//*Label 6235*/ GIMT_Encode4(313736),
    /*GILLT_s32*//*Label 6236*/ GIMT_Encode4(313874), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 6237*/ GIMT_Encode4(313905), GIMT_Encode4(0),
    /*GILLT_v4s16*//*Label 6238*/ GIMT_Encode4(313933),
    // Label 6235: @313736
    GIM_Try, /*On fail goto*//*Label 6240*/ GIMT_Encode4(313766), // Rule ID 506 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fpround:{ *:[f16] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTHDr:{ *:[f16] } FPR64:{ *:[f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTHDr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 506,
      GIR_Done,
    // Label 6240: @313766
    GIM_Try, /*On fail goto*//*Label 6241*/ GIMT_Encode4(313796), // Rule ID 516 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      // (fpround:{ *:[f16] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTHSr:{ *:[f16] } FPR32:{ *:[f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTHSr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 516,
      GIR_Done,
    // Label 6241: @313796
    GIM_Try, /*On fail goto*//*Label 6242*/ GIMT_Encode4(313826), // Rule ID 3794 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16_HasNEONandIsStreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      // (fpround:{ *:[bf16] } FPR32:{ *:[f32] }:$Rn)  =>  (BFCVT:{ *:[bf16] } ?:{ *:[f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BFCVT),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3794,
      GIR_Done,
    // Label 6242: @313826
    GIM_Try, /*On fail goto*//*Label 6243*/ GIMT_Encode4(313873), // Rule ID 5288 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16_HasNEONandIsStreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fpround:{ *:[bf16] } FPR64:{ *:[f64] }:$Rn)  =>  (BFCVT:{ *:[bf16] } (FCVTXNv1i64:{ *:[i32] } ?:{ *:[f64] }:$Rn))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNv1i64),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFCVT),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5288,
      GIR_EraseRootFromParent_Done,
    // Label 6243: @313873
    GIM_Reject,
    // Label 6236: @313874
    GIM_Try, /*On fail goto*//*Label 6244*/ GIMT_Encode4(313904), // Rule ID 508 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fpround:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTSDr:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTSDr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 508,
      GIR_Done,
    // Label 6244: @313904
    GIM_Reject,
    // Label 6237: @313905
    GIM_Try, /*On fail goto*//*Label 6245*/ GIMT_Encode4(313932), // Rule ID 4945 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fpround:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn)  =>  (FCVTNv2i32:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv2i32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4945,
      GIR_Done,
    // Label 6245: @313932
    GIM_Reject,
    // Label 6238: @313933
    GIM_Try, /*On fail goto*//*Label 6246*/ GIMT_Encode4(314015),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 6247*/ GIMT_Encode4(313998), // Rule ID 3791 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16_HasNEON),
        // (fpround:{ *:[v4bf16] } V128:{ *:[v4f32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v4bf16] } (BFCVTN:{ *:[f128] } V128:{ *:[v4f32] }:$Rn), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::BFCVTN),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 3791,
        GIR_EraseRootFromParent_Done,
      // Label 6247: @313998
      GIM_Try, /*On fail goto*//*Label 6248*/ GIMT_Encode4(314014), // Rule ID 4947 //
        // (fpround:{ *:[v4f16] } V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNv4i16:{ *:[v4f16] } V128:{ *:[v4f32] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4947,
        GIR_Done,
      // Label 6248: @314014
      GIM_Reject,
    // Label 6246: @314015
    GIM_Reject,
    // Label 6239: @314016
    GIM_Reject,
    // Label 62: @314017
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6256*/ GIMT_Encode4(315079),
    /*GILLT_s32*//*Label 6249*/ GIMT_Encode4(314064),
    /*GILLT_s64*//*Label 6250*/ GIMT_Encode4(314451), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 6251*/ GIMT_Encode4(314838),
    /*GILLT_v2s64*//*Label 6252*/ GIMT_Encode4(314912),
    /*GILLT_v4s16*//*Label 6253*/ GIMT_Encode4(314986),
    /*GILLT_v4s32*//*Label 6254*/ GIMT_Encode4(315017), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 6255*/ GIMT_Encode4(315048),
    // Label 6249: @314064
    GIM_Try, /*On fail goto*//*Label 6257*/ GIMT_Encode4(314101), // Rule ID 4684 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWSr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4684,
      GIR_EraseRootFromParent_Done,
    // Label 6257: @314101
    GIM_Try, /*On fail goto*//*Label 6258*/ GIMT_Encode4(314138), // Rule ID 4686 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWDr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4686,
      GIR_EraseRootFromParent_Done,
    // Label 6258: @314138
    GIM_Try, /*On fail goto*//*Label 6259*/ GIMT_Encode4(314175), // Rule ID 4704 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWSr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4704,
      GIR_EraseRootFromParent_Done,
    // Label 6259: @314175
    GIM_Try, /*On fail goto*//*Label 6260*/ GIMT_Encode4(314212), // Rule ID 4706 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWDr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4706,
      GIR_EraseRootFromParent_Done,
    // Label 6260: @314212
    GIM_Try, /*On fail goto*//*Label 6261*/ GIMT_Encode4(314249), // Rule ID 4744 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (fp_to_sint:{ *:[i32] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTASUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWSr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4744,
      GIR_EraseRootFromParent_Done,
    // Label 6261: @314249
    GIM_Try, /*On fail goto*//*Label 6262*/ GIMT_Encode4(314286), // Rule ID 4746 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (fp_to_sint:{ *:[i32] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTASUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWDr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4746,
      GIR_EraseRootFromParent_Done,
    // Label 6262: @314286
    GIM_Try, /*On fail goto*//*Label 6263*/ GIMT_Encode4(314323), // Rule ID 4724 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (fp_to_sint:{ *:[i32] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4724,
      GIR_EraseRootFromParent_Done,
    // Label 6263: @314323
    GIM_Try, /*On fail goto*//*Label 6264*/ GIMT_Encode4(314360), // Rule ID 4726 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (fp_to_sint:{ *:[i32] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4726,
      GIR_EraseRootFromParent_Done,
    // Label 6264: @314360
    GIM_Try, /*On fail goto*//*Label 6265*/ GIMT_Encode4(314390), // Rule ID 407 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // (fp_to_sint:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 407,
      GIR_Done,
    // Label 6265: @314390
    GIM_Try, /*On fail goto*//*Label 6266*/ GIMT_Encode4(314420), // Rule ID 411 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      // (fp_to_sint:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 411,
      GIR_Done,
    // Label 6266: @314420
    GIM_Try, /*On fail goto*//*Label 6267*/ GIMT_Encode4(314450), // Rule ID 415 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fp_to_sint:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 415,
      GIR_Done,
    // Label 6267: @314450
    GIM_Reject,
    // Label 6250: @314451
    GIM_Try, /*On fail goto*//*Label 6268*/ GIMT_Encode4(314488), // Rule ID 4685 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (fp_to_sint:{ *:[i64] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXSr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4685,
      GIR_EraseRootFromParent_Done,
    // Label 6268: @314488
    GIM_Try, /*On fail goto*//*Label 6269*/ GIMT_Encode4(314525), // Rule ID 4687 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (fp_to_sint:{ *:[i64] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXDr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4687,
      GIR_EraseRootFromParent_Done,
    // Label 6269: @314525
    GIM_Try, /*On fail goto*//*Label 6270*/ GIMT_Encode4(314562), // Rule ID 4705 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (fp_to_sint:{ *:[i64] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXSr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4705,
      GIR_EraseRootFromParent_Done,
    // Label 6270: @314562
    GIM_Try, /*On fail goto*//*Label 6271*/ GIMT_Encode4(314599), // Rule ID 4707 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (fp_to_sint:{ *:[i64] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXDr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4707,
      GIR_EraseRootFromParent_Done,
    // Label 6271: @314599
    GIM_Try, /*On fail goto*//*Label 6272*/ GIMT_Encode4(314636), // Rule ID 4745 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (fp_to_sint:{ *:[i64] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTASUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4745,
      GIR_EraseRootFromParent_Done,
    // Label 6272: @314636
    GIM_Try, /*On fail goto*//*Label 6273*/ GIMT_Encode4(314673), // Rule ID 4747 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (fp_to_sint:{ *:[i64] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTASUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4747,
      GIR_EraseRootFromParent_Done,
    // Label 6273: @314673
    GIM_Try, /*On fail goto*//*Label 6274*/ GIMT_Encode4(314710), // Rule ID 4725 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (fp_to_sint:{ *:[i64] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4725,
      GIR_EraseRootFromParent_Done,
    // Label 6274: @314710
    GIM_Try, /*On fail goto*//*Label 6275*/ GIMT_Encode4(314747), // Rule ID 4727 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (fp_to_sint:{ *:[i64] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4727,
      GIR_EraseRootFromParent_Done,
    // Label 6275: @314747
    GIM_Try, /*On fail goto*//*Label 6276*/ GIMT_Encode4(314777), // Rule ID 409 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // (fp_to_sint:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 409,
      GIR_Done,
    // Label 6276: @314777
    GIM_Try, /*On fail goto*//*Label 6277*/ GIMT_Encode4(314807), // Rule ID 413 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      // (fp_to_sint:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 413,
      GIR_Done,
    // Label 6277: @314807
    GIM_Try, /*On fail goto*//*Label 6278*/ GIMT_Encode4(314837), // Rule ID 417 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fp_to_sint:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 417,
      GIR_Done,
    // Label 6278: @314837
    GIM_Reject,
    // Label 6251: @314838
    GIM_Try, /*On fail goto*//*Label 6279*/ GIMT_Encode4(314868), // Rule ID 832 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fp_to_sint:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCVTZSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 832,
      GIR_Done,
    // Label 6279: @314868
    GIM_Try, /*On fail goto*//*Label 6280*/ GIMT_Encode4(314911), // Rule ID 13194 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fp_to_sint:{ *:[v2i32] } v2f64:{ *:[v2f64] }:$src)  =>  (XTNv2i32:{ *:[v2i32] } (FCVTZSv2f64:{ *:[f128] } V128:{ *:[v2f64] }:$src))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv2i32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 13194,
      GIR_EraseRootFromParent_Done,
    // Label 6280: @314911
    GIM_Reject,
    // Label 6252: @314912
    GIM_Try, /*On fail goto*//*Label 6281*/ GIMT_Encode4(314942), // Rule ID 836 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fp_to_sint:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCVTZSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 836,
      GIR_Done,
    // Label 6281: @314942
    GIM_Try, /*On fail goto*//*Label 6282*/ GIMT_Encode4(314985), // Rule ID 13192 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fp_to_sint:{ *:[v2i64] } v2f32:{ *:[v2f32] }:$src)  =>  (FCVTZSv2f64:{ *:[v2i64] } (FCVTLv2i32:{ *:[f128] } V64:{ *:[v2f32] }:$src))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv2i32),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 13192,
      GIR_EraseRootFromParent_Done,
    // Label 6282: @314985
    GIM_Reject,
    // Label 6253: @314986
    GIM_Try, /*On fail goto*//*Label 6283*/ GIMT_Encode4(315016), // Rule ID 828 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fp_to_sint:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCVTZSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 828,
      GIR_Done,
    // Label 6283: @315016
    GIM_Reject,
    // Label 6254: @315017
    GIM_Try, /*On fail goto*//*Label 6284*/ GIMT_Encode4(315047), // Rule ID 834 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fp_to_sint:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCVTZSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 834,
      GIR_Done,
    // Label 6284: @315047
    GIM_Reject,
    // Label 6255: @315048
    GIM_Try, /*On fail goto*//*Label 6285*/ GIMT_Encode4(315078), // Rule ID 830 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fp_to_sint:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTZSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 830,
      GIR_Done,
    // Label 6285: @315078
    GIM_Reject,
    // Label 6256: @315079
    GIM_Reject,
    // Label 63: @315080
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6293*/ GIMT_Encode4(316142),
    /*GILLT_s32*//*Label 6286*/ GIMT_Encode4(315127),
    /*GILLT_s64*//*Label 6287*/ GIMT_Encode4(315514), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 6288*/ GIMT_Encode4(315901),
    /*GILLT_v2s64*//*Label 6289*/ GIMT_Encode4(315975),
    /*GILLT_v4s16*//*Label 6290*/ GIMT_Encode4(316049),
    /*GILLT_v4s32*//*Label 6291*/ GIMT_Encode4(316080), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 6292*/ GIMT_Encode4(316111),
    // Label 6286: @315127
    GIM_Try, /*On fail goto*//*Label 6294*/ GIMT_Encode4(315164), // Rule ID 4694 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWSr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4694,
      GIR_EraseRootFromParent_Done,
    // Label 6294: @315164
    GIM_Try, /*On fail goto*//*Label 6295*/ GIMT_Encode4(315201), // Rule ID 4696 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWDr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4696,
      GIR_EraseRootFromParent_Done,
    // Label 6295: @315201
    GIM_Try, /*On fail goto*//*Label 6296*/ GIMT_Encode4(315238), // Rule ID 4714 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWSr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4714,
      GIR_EraseRootFromParent_Done,
    // Label 6296: @315238
    GIM_Try, /*On fail goto*//*Label 6297*/ GIMT_Encode4(315275), // Rule ID 4716 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWDr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4716,
      GIR_EraseRootFromParent_Done,
    // Label 6297: @315275
    GIM_Try, /*On fail goto*//*Label 6298*/ GIMT_Encode4(315312), // Rule ID 4754 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (fp_to_uint:{ *:[i32] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTAUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWSr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4754,
      GIR_EraseRootFromParent_Done,
    // Label 6298: @315312
    GIM_Try, /*On fail goto*//*Label 6299*/ GIMT_Encode4(315349), // Rule ID 4756 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (fp_to_uint:{ *:[i32] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTAUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWDr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4756,
      GIR_EraseRootFromParent_Done,
    // Label 6299: @315349
    GIM_Try, /*On fail goto*//*Label 6300*/ GIMT_Encode4(315386), // Rule ID 4734 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (fp_to_uint:{ *:[i32] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4734,
      GIR_EraseRootFromParent_Done,
    // Label 6300: @315386
    GIM_Try, /*On fail goto*//*Label 6301*/ GIMT_Encode4(315423), // Rule ID 4736 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (fp_to_uint:{ *:[i32] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4736,
      GIR_EraseRootFromParent_Done,
    // Label 6301: @315423
    GIM_Try, /*On fail goto*//*Label 6302*/ GIMT_Encode4(315453), // Rule ID 419 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // (fp_to_uint:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWHr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 419,
      GIR_Done,
    // Label 6302: @315453
    GIM_Try, /*On fail goto*//*Label 6303*/ GIMT_Encode4(315483), // Rule ID 423 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      // (fp_to_uint:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 423,
      GIR_Done,
    // Label 6303: @315483
    GIM_Try, /*On fail goto*//*Label 6304*/ GIMT_Encode4(315513), // Rule ID 427 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fp_to_uint:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 427,
      GIR_Done,
    // Label 6304: @315513
    GIM_Reject,
    // Label 6287: @315514
    GIM_Try, /*On fail goto*//*Label 6305*/ GIMT_Encode4(315551), // Rule ID 4695 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (fp_to_uint:{ *:[i64] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXSr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4695,
      GIR_EraseRootFromParent_Done,
    // Label 6305: @315551
    GIM_Try, /*On fail goto*//*Label 6306*/ GIMT_Encode4(315588), // Rule ID 4697 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (fp_to_uint:{ *:[i64] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXDr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4697,
      GIR_EraseRootFromParent_Done,
    // Label 6306: @315588
    GIM_Try, /*On fail goto*//*Label 6307*/ GIMT_Encode4(315625), // Rule ID 4715 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (fp_to_uint:{ *:[i64] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXSr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4715,
      GIR_EraseRootFromParent_Done,
    // Label 6307: @315625
    GIM_Try, /*On fail goto*//*Label 6308*/ GIMT_Encode4(315662), // Rule ID 4717 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (fp_to_uint:{ *:[i64] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXDr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4717,
      GIR_EraseRootFromParent_Done,
    // Label 6308: @315662
    GIM_Try, /*On fail goto*//*Label 6309*/ GIMT_Encode4(315699), // Rule ID 4755 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (fp_to_uint:{ *:[i64] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTAUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXSr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4755,
      GIR_EraseRootFromParent_Done,
    // Label 6309: @315699
    GIM_Try, /*On fail goto*//*Label 6310*/ GIMT_Encode4(315736), // Rule ID 4757 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (fp_to_uint:{ *:[i64] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTAUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXDr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4757,
      GIR_EraseRootFromParent_Done,
    // Label 6310: @315736
    GIM_Try, /*On fail goto*//*Label 6311*/ GIMT_Encode4(315773), // Rule ID 4735 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (fp_to_uint:{ *:[i64] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4735,
      GIR_EraseRootFromParent_Done,
    // Label 6311: @315773
    GIM_Try, /*On fail goto*//*Label 6312*/ GIMT_Encode4(315810), // Rule ID 4737 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (fp_to_uint:{ *:[i64] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4737,
      GIR_EraseRootFromParent_Done,
    // Label 6312: @315810
    GIM_Try, /*On fail goto*//*Label 6313*/ GIMT_Encode4(315840), // Rule ID 421 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // (fp_to_uint:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXHr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 421,
      GIR_Done,
    // Label 6313: @315840
    GIM_Try, /*On fail goto*//*Label 6314*/ GIMT_Encode4(315870), // Rule ID 425 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      // (fp_to_uint:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 425,
      GIR_Done,
    // Label 6314: @315870
    GIM_Try, /*On fail goto*//*Label 6315*/ GIMT_Encode4(315900), // Rule ID 429 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fp_to_uint:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 429,
      GIR_Done,
    // Label 6315: @315900
    GIM_Reject,
    // Label 6288: @315901
    GIM_Try, /*On fail goto*//*Label 6316*/ GIMT_Encode4(315931), // Rule ID 842 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fp_to_uint:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCVTZUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 842,
      GIR_Done,
    // Label 6316: @315931
    GIM_Try, /*On fail goto*//*Label 6317*/ GIMT_Encode4(315974), // Rule ID 13195 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fp_to_uint:{ *:[v2i32] } v2f64:{ *:[v2f64] }:$src)  =>  (XTNv2i32:{ *:[v2i32] } (FCVTZUv2f64:{ *:[f128] } V128:{ *:[v2f64] }:$src))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv2i32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 13195,
      GIR_EraseRootFromParent_Done,
    // Label 6317: @315974
    GIM_Reject,
    // Label 6289: @315975
    GIM_Try, /*On fail goto*//*Label 6318*/ GIMT_Encode4(316005), // Rule ID 846 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fp_to_uint:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCVTZUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 846,
      GIR_Done,
    // Label 6318: @316005
    GIM_Try, /*On fail goto*//*Label 6319*/ GIMT_Encode4(316048), // Rule ID 13193 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fp_to_uint:{ *:[v2i64] } v2f32:{ *:[v2f32] }:$src)  =>  (FCVTZUv2f64:{ *:[v2i64] } (FCVTLv2i32:{ *:[f128] } V64:{ *:[v2f32] }:$src))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv2i32),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 13193,
      GIR_EraseRootFromParent_Done,
    // Label 6319: @316048
    GIM_Reject,
    // Label 6290: @316049
    GIM_Try, /*On fail goto*//*Label 6320*/ GIMT_Encode4(316079), // Rule ID 838 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fp_to_uint:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCVTZUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 838,
      GIR_Done,
    // Label 6320: @316079
    GIM_Reject,
    // Label 6291: @316080
    GIM_Try, /*On fail goto*//*Label 6321*/ GIMT_Encode4(316110), // Rule ID 844 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fp_to_uint:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCVTZUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 844,
      GIR_Done,
    // Label 6321: @316110
    GIM_Reject,
    // Label 6292: @316111
    GIM_Try, /*On fail goto*//*Label 6322*/ GIMT_Encode4(316141), // Rule ID 840 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fp_to_uint:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTZUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 840,
      GIR_Done,
    // Label 6322: @316141
    GIM_Reject,
    // Label 6293: @316142
    GIM_Reject,
    // Label 64: @316143
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6331*/ GIMT_Encode4(320419),
    /*GILLT_s16*//*Label 6323*/ GIMT_Encode4(316194),
    /*GILLT_s32*//*Label 6324*/ GIMT_Encode4(316415),
    /*GILLT_s64*//*Label 6325*/ GIMT_Encode4(318301), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 6326*/ GIMT_Encode4(320175),
    /*GILLT_v2s64*//*Label 6327*/ GIMT_Encode4(320249),
    /*GILLT_v4s16*//*Label 6328*/ GIMT_Encode4(320326),
    /*GILLT_v4s32*//*Label 6329*/ GIMT_Encode4(320357), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 6330*/ GIMT_Encode4(320388),
    // Label 6323: @316194
    GIM_Try, /*On fail goto*//*Label 6332*/ GIMT_Encode4(316297), // Rule ID 5360 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
      GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
      // MIs[1] Operand 2
      GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
      GIM_CheckIsSafeToFold, /*NumInsns*/2,
      // (sint_to_fp:{ *:[f16] } (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), i16:{ *:[Other] }))  =>  (SCVTFv1i16:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR128:{ *:[v8i16] }:$Rn, hsub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5360,
      GIR_EraseRootFromParent_Done,
    // Label 6332: @316297
    GIM_Try, /*On fail goto*//*Label 6333*/ GIMT_Encode4(316354), // Rule ID 5351 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOSI),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (sint_to_fp:{ *:[f16] } (fp_to_sint:{ *:[i32] } f16:{ *:[f16] }:$Rn))  =>  (SCVTFv1i16:{ *:[f16] } (FCVTZSv1f16:{ *:[f16] } f16:{ *:[f16] }:$Rn))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1f16),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5351,
      GIR_EraseRootFromParent_Done,
    // Label 6333: @316354
    GIM_Try, /*On fail goto*//*Label 6334*/ GIMT_Encode4(316384), // Rule ID 455 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // (sint_to_fp:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)  =>  (SCVTFUWHri:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUWHri),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 455,
      GIR_Done,
    // Label 6334: @316384
    GIM_Try, /*On fail goto*//*Label 6335*/ GIMT_Encode4(316414), // Rule ID 461 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (sint_to_fp:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)  =>  (SCVTFUXHri:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUXHri),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 461,
      GIR_Done,
    // Label 6335: @316414
    GIM_Reject,
    // Label 6324: @316415
    GIM_Try, /*On fail goto*//*Label 6336*/ GIMT_Encode4(316653), // Rule ID 6434 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
      // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$ext), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
      GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
      GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
      GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
      GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
      GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
      GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
      GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
      GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
      GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6434,
      GIR_EraseRootFromParent_Done,
    // Label 6336: @316653
    GIM_Try, /*On fail goto*//*Label 6337*/ GIMT_Encode4(316891), // Rule ID 6435 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
      // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$ext), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
      GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
      GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
      GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
      GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
      GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
      GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
      GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
      GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
      GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6435,
      GIR_EraseRootFromParent_Done,
    // Label 6337: @316891
    GIM_Try, /*On fail goto*//*Label 6338*/ GIMT_Encode4(317080), // Rule ID 6438 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
      // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
      GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
      GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
      GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
      GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6438,
      GIR_EraseRootFromParent_Done,
    // Label 6338: @317080
    GIM_Try, /*On fail goto*//*Label 6339*/ GIMT_Encode4(317269), // Rule ID 6439 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
      // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
      GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
      GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
      GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
      GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6439,
      GIR_EraseRootFromParent_Done,
    // Label 6339: @317269
    GIM_Try, /*On fail goto*//*Label 6340*/ GIMT_Encode4(317502), // Rule ID 6436 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
      // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
      GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
      GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
      GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
      GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
      GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
      GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
      GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
      GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6436,
      GIR_EraseRootFromParent_Done,
    // Label 6340: @317502
    GIM_Try, /*On fail goto*//*Label 6341*/ GIMT_Encode4(317735), // Rule ID 6437 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
      // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
      GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
      GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
      GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
      GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
      GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
      GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
      GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
      GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6437,
      GIR_EraseRootFromParent_Done,
    // Label 6341: @317735
    GIM_Try, /*On fail goto*//*Label 6342*/ GIMT_Encode4(317919), // Rule ID 6440 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
      // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
      GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
      GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
      GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6440,
      GIR_EraseRootFromParent_Done,
    // Label 6342: @317919
    GIM_Try, /*On fail goto*//*Label 6343*/ GIMT_Encode4(318103), // Rule ID 6441 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
      // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
      GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
      GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
      GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6441,
      GIR_EraseRootFromParent_Done,
    // Label 6343: @318103
    GIM_Try, /*On fail goto*//*Label 6344*/ GIMT_Encode4(318183), // Rule ID 5356 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (sint_to_fp:{ *:[f32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5356,
      GIR_EraseRootFromParent_Done,
    // Label 6344: @318183
    GIM_Try, /*On fail goto*//*Label 6345*/ GIMT_Encode4(318240), // Rule ID 5339 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOSI),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (sint_to_fp:{ *:[f32] } (fp_to_sint:{ *:[i32] } f32:{ *:[f32] }:$Rn))  =>  (SCVTFv1i32:{ *:[f32] } (FCVTZSv1i32:{ *:[i32] } f32:{ *:[f32] }:$Rn))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1i32),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5339,
      GIR_EraseRootFromParent_Done,
    // Label 6345: @318240
    GIM_Try, /*On fail goto*//*Label 6346*/ GIMT_Encode4(318270), // Rule ID 457 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // (sint_to_fp:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)  =>  (SCVTFUWSri:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUWSri),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 457,
      GIR_Done,
    // Label 6346: @318270
    GIM_Try, /*On fail goto*//*Label 6347*/ GIMT_Encode4(318300), // Rule ID 463 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (sint_to_fp:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)  =>  (SCVTFUXSri:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUXSri),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 463,
      GIR_Done,
    // Label 6347: @318300
    GIM_Reject,
    // Label 6325: @318301
    GIM_Try, /*On fail goto*//*Label 6348*/ GIMT_Encode4(318487), // Rule ID 6446 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
      // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$ext), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
      GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
      GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
      GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
      GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6446,
      GIR_EraseRootFromParent_Done,
    // Label 6348: @318487
    GIM_Try, /*On fail goto*//*Label 6349*/ GIMT_Encode4(318673), // Rule ID 6447 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
      // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$ext), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
      GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
      GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
      GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
      GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6447,
      GIR_EraseRootFromParent_Done,
    // Label 6349: @318673
    GIM_Try, /*On fail goto*//*Label 6350*/ GIMT_Encode4(318911), // Rule ID 6442 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
      // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
      GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
      GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
      GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
      GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
      GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
      GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
      GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6442,
      GIR_EraseRootFromParent_Done,
    // Label 6350: @318911
    GIM_Try, /*On fail goto*//*Label 6351*/ GIMT_Encode4(319149), // Rule ID 6443 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
      // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
      GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
      GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
      GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
      GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
      GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
      GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
      GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6443,
      GIR_EraseRootFromParent_Done,
    // Label 6351: @319149
    GIM_Try, /*On fail goto*//*Label 6352*/ GIMT_Encode4(319330), // Rule ID 6448 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
      // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
      GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
      GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
      GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6448,
      GIR_EraseRootFromParent_Done,
    // Label 6352: @319330
    GIM_Try, /*On fail goto*//*Label 6353*/ GIMT_Encode4(319511), // Rule ID 6449 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
      // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
      GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
      GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
      GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6449,
      GIR_EraseRootFromParent_Done,
    // Label 6353: @319511
    GIM_Try, /*On fail goto*//*Label 6354*/ GIMT_Encode4(319744), // Rule ID 6444 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
      // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
      GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
      GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
      GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
      GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
      GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
      GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6444,
      GIR_EraseRootFromParent_Done,
    // Label 6354: @319744
    GIM_Try, /*On fail goto*//*Label 6355*/ GIMT_Encode4(319977), // Rule ID 6445 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
      // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
      GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
      GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
      GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
      GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
      GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
      GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6445,
      GIR_EraseRootFromParent_Done,
    // Label 6355: @319977
    GIM_Try, /*On fail goto*//*Label 6356*/ GIMT_Encode4(320057), // Rule ID 5358 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (sint_to_fp:{ *:[f64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5358,
      GIR_EraseRootFromParent_Done,
    // Label 6356: @320057
    GIM_Try, /*On fail goto*//*Label 6357*/ GIMT_Encode4(320114), // Rule ID 5335 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOSI),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (sint_to_fp:{ *:[f64] } (fp_to_sint:{ *:[i64] } f64:{ *:[f64] }:$Rn))  =>  (SCVTFv1i64:{ *:[f64] } (FCVTZSv1i64:{ *:[i64] } f64:{ *:[f64] }:$Rn))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1i64),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5335,
      GIR_EraseRootFromParent_Done,
    // Label 6357: @320114
    GIM_Try, /*On fail goto*//*Label 6358*/ GIMT_Encode4(320144), // Rule ID 459 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // (sint_to_fp:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)  =>  (SCVTFUWDri:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUWDri),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 459,
      GIR_Done,
    // Label 6358: @320144
    GIM_Try, /*On fail goto*//*Label 6359*/ GIMT_Encode4(320174), // Rule ID 465 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (sint_to_fp:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)  =>  (SCVTFUXDri:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUXDri),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 465,
      GIR_Done,
    // Label 6359: @320174
    GIM_Reject,
    // Label 6326: @320175
    GIM_Try, /*On fail goto*//*Label 6360*/ GIMT_Encode4(320205), // Rule ID 1006 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (sint_to_fp:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)  =>  (SCVTFv2f32:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1006,
      GIR_Done,
    // Label 6360: @320205
    GIM_Try, /*On fail goto*//*Label 6361*/ GIMT_Encode4(320248), // Rule ID 13190 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (sint_to_fp:{ *:[v2f32] } v2i64:{ *:[v2i64] }:$src)  =>  (FCVTNv2i32:{ *:[v2f32] } (SCVTFv2f64:{ *:[f128] } V128:{ *:[v2i64] }:$src))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2f64),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv2i32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 13190,
      GIR_EraseRootFromParent_Done,
    // Label 6361: @320248
    GIM_Reject,
    // Label 6327: @320249
    GIM_Try, /*On fail goto*//*Label 6362*/ GIMT_Encode4(320279), // Rule ID 1010 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (sint_to_fp:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)  =>  (SCVTFv2f64:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2f64),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1010,
      GIR_Done,
    // Label 6362: @320279
    GIM_Try, /*On fail goto*//*Label 6363*/ GIMT_Encode4(320325), // Rule ID 13188 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (sint_to_fp:{ *:[v2f64] } v2i32:{ *:[v2i32] }:$src)  =>  (SCVTFv2f64:{ *:[v2f64] } (SSHLLv2i32_shift:{ *:[f128] } V64:{ *:[v2i32] }:$src, 0:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2f64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 13188,
      GIR_EraseRootFromParent_Done,
    // Label 6363: @320325
    GIM_Reject,
    // Label 6328: @320326
    GIM_Try, /*On fail goto*//*Label 6364*/ GIMT_Encode4(320356), // Rule ID 1002 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (sint_to_fp:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)  =>  (SCVTFv4f16:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1002,
      GIR_Done,
    // Label 6364: @320356
    GIM_Reject,
    // Label 6329: @320357
    GIM_Try, /*On fail goto*//*Label 6365*/ GIMT_Encode4(320387), // Rule ID 1008 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (sint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)  =>  (SCVTFv4f32:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1008,
      GIR_Done,
    // Label 6365: @320387
    GIM_Reject,
    // Label 6330: @320388
    GIM_Try, /*On fail goto*//*Label 6366*/ GIMT_Encode4(320418), // Rule ID 1004 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (sint_to_fp:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)  =>  (SCVTFv8f16:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv8f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1004,
      GIR_Done,
    // Label 6366: @320418
    GIM_Reject,
    // Label 6331: @320419
    GIM_Reject,
    // Label 65: @320420
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6375*/ GIMT_Encode4(324074),
    /*GILLT_s16*//*Label 6367*/ GIMT_Encode4(320471),
    /*GILLT_s32*//*Label 6368*/ GIMT_Encode4(320696),
    /*GILLT_s64*//*Label 6369*/ GIMT_Encode4(321994), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 6370*/ GIMT_Encode4(323830),
    /*GILLT_v2s64*//*Label 6371*/ GIMT_Encode4(323904),
    /*GILLT_v4s16*//*Label 6372*/ GIMT_Encode4(323981),
    /*GILLT_v4s32*//*Label 6373*/ GIMT_Encode4(324012), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 6374*/ GIMT_Encode4(324043),
    // Label 6367: @320471
    GIM_Try, /*On fail goto*//*Label 6376*/ GIMT_Encode4(320578), // Rule ID 5361 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
      GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
      GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
      GIM_CheckIsSafeToFold, /*NumInsns*/2,
      // (uint_to_fp:{ *:[f16] } (and:{ *:[i32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), 65535:{ *:[i32] }))  =>  (UCVTFv1i16:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR128:{ *:[v8i16] }:$Rn, hsub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5361,
      GIR_EraseRootFromParent_Done,
    // Label 6376: @320578
    GIM_Try, /*On fail goto*//*Label 6377*/ GIMT_Encode4(320635), // Rule ID 5355 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOUI),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (uint_to_fp:{ *:[f16] } (fp_to_uint:{ *:[i32] } f16:{ *:[f16] }:$Rn))  =>  (UCVTFv1i16:{ *:[f16] } (FCVTZUv1f16:{ *:[f16] } f16:{ *:[f16] }:$Rn))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1f16),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5355,
      GIR_EraseRootFromParent_Done,
    // Label 6377: @320635
    GIM_Try, /*On fail goto*//*Label 6378*/ GIMT_Encode4(320665), // Rule ID 479 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // (uint_to_fp:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)  =>  (UCVTFUWHri:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUWHri),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 479,
      GIR_Done,
    // Label 6378: @320665
    GIM_Try, /*On fail goto*//*Label 6379*/ GIMT_Encode4(320695), // Rule ID 485 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (uint_to_fp:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)  =>  (UCVTFUXHri:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUXHri),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 485,
      GIR_Done,
    // Label 6379: @320695
    GIM_Reject,
    // Label 6368: @320696
    GIM_Try, /*On fail goto*//*Label 6380*/ GIMT_Encode4(320836), // Rule ID 5362 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
      // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5362,
      GIR_EraseRootFromParent_Done,
    // Label 6380: @320836
    GIM_Try, /*On fail goto*//*Label 6381*/ GIMT_Encode4(320976), // Rule ID 5363 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
      // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5363,
      GIR_EraseRootFromParent_Done,
    // Label 6381: @320976
    GIM_Try, /*On fail goto*//*Label 6382*/ GIMT_Encode4(321116), // Rule ID 5366 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
      // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5366,
      GIR_EraseRootFromParent_Done,
    // Label 6382: @321116
    GIM_Try, /*On fail goto*//*Label 6383*/ GIMT_Encode4(321256), // Rule ID 5367 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
      // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5367,
      GIR_EraseRootFromParent_Done,
    // Label 6383: @321256
    GIM_Try, /*On fail goto*//*Label 6384*/ GIMT_Encode4(321391), // Rule ID 5364 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
      // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5364,
      GIR_EraseRootFromParent_Done,
    // Label 6384: @321391
    GIM_Try, /*On fail goto*//*Label 6385*/ GIMT_Encode4(321526), // Rule ID 5365 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
      // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5365,
      GIR_EraseRootFromParent_Done,
    // Label 6385: @321526
    GIM_Try, /*On fail goto*//*Label 6386*/ GIMT_Encode4(321661), // Rule ID 5368 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
      // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5368,
      GIR_EraseRootFromParent_Done,
    // Label 6386: @321661
    GIM_Try, /*On fail goto*//*Label 6387*/ GIMT_Encode4(321796), // Rule ID 5369 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
      // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5369,
      GIR_EraseRootFromParent_Done,
    // Label 6387: @321796
    GIM_Try, /*On fail goto*//*Label 6388*/ GIMT_Encode4(321876), // Rule ID 5357 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (uint_to_fp:{ *:[f32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5357,
      GIR_EraseRootFromParent_Done,
    // Label 6388: @321876
    GIM_Try, /*On fail goto*//*Label 6389*/ GIMT_Encode4(321933), // Rule ID 5347 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOUI),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (uint_to_fp:{ *:[f32] } (fp_to_uint:{ *:[i32] } f32:{ *:[f32] }:$Rn))  =>  (UCVTFv1i32:{ *:[f32] } (FCVTZUv1i32:{ *:[i32] } f32:{ *:[f32] }:$Rn))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1i32),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5347,
      GIR_EraseRootFromParent_Done,
    // Label 6389: @321933
    GIM_Try, /*On fail goto*//*Label 6390*/ GIMT_Encode4(321963), // Rule ID 481 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // (uint_to_fp:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)  =>  (UCVTFUWSri:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUWSri),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 481,
      GIR_Done,
    // Label 6390: @321963
    GIM_Try, /*On fail goto*//*Label 6391*/ GIMT_Encode4(321993), // Rule ID 487 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (uint_to_fp:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)  =>  (UCVTFUXSri:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUXSri),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 487,
      GIR_Done,
    // Label 6391: @321993
    GIM_Reject,
    // Label 6369: @321994
    GIM_Try, /*On fail goto*//*Label 6392*/ GIMT_Encode4(322131), // Rule ID 5378 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
      // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5378,
      GIR_EraseRootFromParent_Done,
    // Label 6392: @322131
    GIM_Try, /*On fail goto*//*Label 6393*/ GIMT_Encode4(322268), // Rule ID 5379 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
      // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5379,
      GIR_EraseRootFromParent_Done,
    // Label 6393: @322268
    GIM_Try, /*On fail goto*//*Label 6394*/ GIMT_Encode4(322408), // Rule ID 5370 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
      // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5370,
      GIR_EraseRootFromParent_Done,
    // Label 6394: @322408
    GIM_Try, /*On fail goto*//*Label 6395*/ GIMT_Encode4(322548), // Rule ID 5371 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
      // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5371,
      GIR_EraseRootFromParent_Done,
    // Label 6395: @322548
    GIM_Try, /*On fail goto*//*Label 6396*/ GIMT_Encode4(322688), // Rule ID 5374 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
      // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5374,
      GIR_EraseRootFromParent_Done,
    // Label 6396: @322688
    GIM_Try, /*On fail goto*//*Label 6397*/ GIMT_Encode4(322828), // Rule ID 5375 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
      // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
      GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5375,
      GIR_EraseRootFromParent_Done,
    // Label 6397: @322828
    GIM_Try, /*On fail goto*//*Label 6398*/ GIMT_Encode4(322960), // Rule ID 5380 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
      // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5380,
      GIR_EraseRootFromParent_Done,
    // Label 6398: @322960
    GIM_Try, /*On fail goto*//*Label 6399*/ GIMT_Encode4(323092), // Rule ID 5381 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
      // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5381,
      GIR_EraseRootFromParent_Done,
    // Label 6399: @323092
    GIM_Try, /*On fail goto*//*Label 6400*/ GIMT_Encode4(323227), // Rule ID 5372 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
      // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5372,
      GIR_EraseRootFromParent_Done,
    // Label 6400: @323227
    GIM_Try, /*On fail goto*//*Label 6401*/ GIMT_Encode4(323362), // Rule ID 5373 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
      // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5373,
      GIR_EraseRootFromParent_Done,
    // Label 6401: @323362
    GIM_Try, /*On fail goto*//*Label 6402*/ GIMT_Encode4(323497), // Rule ID 5376 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
      // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5376,
      GIR_EraseRootFromParent_Done,
    // Label 6402: @323497
    GIM_Try, /*On fail goto*//*Label 6403*/ GIMT_Encode4(323632), // Rule ID 5377 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
      // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5377,
      GIR_EraseRootFromParent_Done,
    // Label 6403: @323632
    GIM_Try, /*On fail goto*//*Label 6404*/ GIMT_Encode4(323712), // Rule ID 5359 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (uint_to_fp:{ *:[f64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5359,
      GIR_EraseRootFromParent_Done,
    // Label 6404: @323712
    GIM_Try, /*On fail goto*//*Label 6405*/ GIMT_Encode4(323769), // Rule ID 5343 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOUI),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (uint_to_fp:{ *:[f64] } (fp_to_uint:{ *:[i64] } f64:{ *:[f64] }:$Rn))  =>  (UCVTFv1i64:{ *:[f64] } (FCVTZUv1i64:{ *:[i64] } f64:{ *:[f64] }:$Rn))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1i64),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5343,
      GIR_EraseRootFromParent_Done,
    // Label 6405: @323769
    GIM_Try, /*On fail goto*//*Label 6406*/ GIMT_Encode4(323799), // Rule ID 483 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // (uint_to_fp:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)  =>  (UCVTFUWDri:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUWDri),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 483,
      GIR_Done,
    // Label 6406: @323799
    GIM_Try, /*On fail goto*//*Label 6407*/ GIMT_Encode4(323829), // Rule ID 489 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (uint_to_fp:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)  =>  (UCVTFUXDri:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUXDri),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 489,
      GIR_Done,
    // Label 6407: @323829
    GIM_Reject,
    // Label 6370: @323830
    GIM_Try, /*On fail goto*//*Label 6408*/ GIMT_Encode4(323860), // Rule ID 1067 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (uint_to_fp:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)  =>  (UCVTFv2f32:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1067,
      GIR_Done,
    // Label 6408: @323860
    GIM_Try, /*On fail goto*//*Label 6409*/ GIMT_Encode4(323903), // Rule ID 13191 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (uint_to_fp:{ *:[v2f32] } v2i64:{ *:[v2i64] }:$src)  =>  (FCVTNv2i32:{ *:[v2f32] } (UCVTFv2f64:{ *:[f128] } V128:{ *:[v2i64] }:$src))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2f64),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv2i32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 13191,
      GIR_EraseRootFromParent_Done,
    // Label 6409: @323903
    GIM_Reject,
    // Label 6371: @323904
    GIM_Try, /*On fail goto*//*Label 6410*/ GIMT_Encode4(323934), // Rule ID 1071 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (uint_to_fp:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)  =>  (UCVTFv2f64:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2f64),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1071,
      GIR_Done,
    // Label 6410: @323934
    GIM_Try, /*On fail goto*//*Label 6411*/ GIMT_Encode4(323980), // Rule ID 13189 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (uint_to_fp:{ *:[v2f64] } v2i32:{ *:[v2i32] }:$src)  =>  (UCVTFv2f64:{ *:[v2f64] } (USHLLv2i32_shift:{ *:[f128] } V64:{ *:[v2i32] }:$src, 0:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2f64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 13189,
      GIR_EraseRootFromParent_Done,
    // Label 6411: @323980
    GIM_Reject,
    // Label 6372: @323981
    GIM_Try, /*On fail goto*//*Label 6412*/ GIMT_Encode4(324011), // Rule ID 1063 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (uint_to_fp:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)  =>  (UCVTFv4f16:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1063,
      GIR_Done,
    // Label 6412: @324011
    GIM_Reject,
    // Label 6373: @324012
    GIM_Try, /*On fail goto*//*Label 6413*/ GIMT_Encode4(324042), // Rule ID 1069 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (uint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)  =>  (UCVTFv4f32:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1069,
      GIR_Done,
    // Label 6413: @324042
    GIM_Reject,
    // Label 6374: @324043
    GIM_Try, /*On fail goto*//*Label 6414*/ GIMT_Encode4(324073), // Rule ID 1065 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (uint_to_fp:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)  =>  (UCVTFv8f16:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv8f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1065,
      GIR_Done,
    // Label 6414: @324073
    GIM_Reject,
    // Label 6375: @324074
    GIM_Reject,
    // Label 66: @324075
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6422*/ GIMT_Encode4(324394),
    /*GILLT_s32*//*Label 6415*/ GIMT_Encode4(324122),
    /*GILLT_s64*//*Label 6416*/ GIMT_Encode4(324195), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 6417*/ GIMT_Encode4(324268),
    /*GILLT_v2s64*//*Label 6418*/ GIMT_Encode4(324292),
    /*GILLT_v4s16*//*Label 6419*/ GIMT_Encode4(324316),
    /*GILLT_v4s32*//*Label 6420*/ GIMT_Encode4(324343), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 6421*/ GIMT_Encode4(324367),
    // Label 6415: @324122
    GIM_Try, /*On fail goto*//*Label 6423*/ GIMT_Encode4(324148), // Rule ID 4618 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // (fp_to_sint_sat_gi:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } f16:{ *:[f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4618,
      GIR_Done,
    // Label 6423: @324148
    GIM_Try, /*On fail goto*//*Label 6424*/ GIMT_Encode4(324171), // Rule ID 4620 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // (fp_to_sint_sat_gi:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4620,
      GIR_Done,
    // Label 6424: @324171
    GIM_Try, /*On fail goto*//*Label 6425*/ GIMT_Encode4(324194), // Rule ID 4622 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // (fp_to_sint_sat_gi:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4622,
      GIR_Done,
    // Label 6425: @324194
    GIM_Reject,
    // Label 6416: @324195
    GIM_Try, /*On fail goto*//*Label 6426*/ GIMT_Encode4(324221), // Rule ID 4619 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (fp_to_sint_sat_gi:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4619,
      GIR_Done,
    // Label 6426: @324221
    GIM_Try, /*On fail goto*//*Label 6427*/ GIMT_Encode4(324244), // Rule ID 4621 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (fp_to_sint_sat_gi:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4621,
      GIR_Done,
    // Label 6427: @324244
    GIM_Try, /*On fail goto*//*Label 6428*/ GIMT_Encode4(324267), // Rule ID 4623 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (fp_to_sint_sat_gi:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4623,
      GIR_Done,
    // Label 6428: @324267
    GIM_Reject,
    // Label 6417: @324268
    GIM_Try, /*On fail goto*//*Label 6429*/ GIMT_Encode4(324291), // Rule ID 4959 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fp_to_sint_sat_gi:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZSv2f32:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4959,
      GIR_Done,
    // Label 6429: @324291
    GIM_Reject,
    // Label 6418: @324292
    GIM_Try, /*On fail goto*//*Label 6430*/ GIMT_Encode4(324315), // Rule ID 4961 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fp_to_sint_sat_gi:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZSv2f64:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4961,
      GIR_Done,
    // Label 6430: @324315
    GIM_Reject,
    // Label 6419: @324316
    GIM_Try, /*On fail goto*//*Label 6431*/ GIMT_Encode4(324342), // Rule ID 4954 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fp_to_sint_sat_gi:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZSv4f16:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4954,
      GIR_Done,
    // Label 6431: @324342
    GIM_Reject,
    // Label 6420: @324343
    GIM_Try, /*On fail goto*//*Label 6432*/ GIMT_Encode4(324366), // Rule ID 4960 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fp_to_sint_sat_gi:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZSv4f32:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4960,
      GIR_Done,
    // Label 6432: @324366
    GIM_Reject,
    // Label 6421: @324367
    GIM_Try, /*On fail goto*//*Label 6433*/ GIMT_Encode4(324393), // Rule ID 4955 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fp_to_sint_sat_gi:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZSv8f16:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4955,
      GIR_Done,
    // Label 6433: @324393
    GIM_Reject,
    // Label 6422: @324394
    GIM_Reject,
    // Label 67: @324395
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6441*/ GIMT_Encode4(324714),
    /*GILLT_s32*//*Label 6434*/ GIMT_Encode4(324442),
    /*GILLT_s64*//*Label 6435*/ GIMT_Encode4(324515), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 6436*/ GIMT_Encode4(324588),
    /*GILLT_v2s64*//*Label 6437*/ GIMT_Encode4(324612),
    /*GILLT_v4s16*//*Label 6438*/ GIMT_Encode4(324636),
    /*GILLT_v4s32*//*Label 6439*/ GIMT_Encode4(324663), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 6440*/ GIMT_Encode4(324687),
    // Label 6434: @324442
    GIM_Try, /*On fail goto*//*Label 6442*/ GIMT_Encode4(324468), // Rule ID 4642 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // (fp_to_uint_sat_gi:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUWHr:{ *:[i32] } f16:{ *:[f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWHr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4642,
      GIR_Done,
    // Label 6442: @324468
    GIM_Try, /*On fail goto*//*Label 6443*/ GIMT_Encode4(324491), // Rule ID 4644 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // (fp_to_uint_sat_gi:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4644,
      GIR_Done,
    // Label 6443: @324491
    GIM_Try, /*On fail goto*//*Label 6444*/ GIMT_Encode4(324514), // Rule ID 4646 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // (fp_to_uint_sat_gi:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4646,
      GIR_Done,
    // Label 6444: @324514
    GIM_Reject,
    // Label 6435: @324515
    GIM_Try, /*On fail goto*//*Label 6445*/ GIMT_Encode4(324541), // Rule ID 4643 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (fp_to_uint_sat_gi:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXHr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4643,
      GIR_Done,
    // Label 6445: @324541
    GIM_Try, /*On fail goto*//*Label 6446*/ GIMT_Encode4(324564), // Rule ID 4645 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (fp_to_uint_sat_gi:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4645,
      GIR_Done,
    // Label 6446: @324564
    GIM_Try, /*On fail goto*//*Label 6447*/ GIMT_Encode4(324587), // Rule ID 4647 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (fp_to_uint_sat_gi:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4647,
      GIR_Done,
    // Label 6447: @324587
    GIM_Reject,
    // Label 6436: @324588
    GIM_Try, /*On fail goto*//*Label 6448*/ GIMT_Encode4(324611), // Rule ID 4969 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fp_to_uint_sat_gi:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZUv2f32:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4969,
      GIR_Done,
    // Label 6448: @324611
    GIM_Reject,
    // Label 6437: @324612
    GIM_Try, /*On fail goto*//*Label 6449*/ GIMT_Encode4(324635), // Rule ID 4971 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fp_to_uint_sat_gi:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZUv2f64:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4971,
      GIR_Done,
    // Label 6449: @324635
    GIM_Reject,
    // Label 6438: @324636
    GIM_Try, /*On fail goto*//*Label 6450*/ GIMT_Encode4(324662), // Rule ID 4964 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fp_to_uint_sat_gi:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZUv4f16:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4964,
      GIR_Done,
    // Label 6450: @324662
    GIM_Reject,
    // Label 6439: @324663
    GIM_Try, /*On fail goto*//*Label 6451*/ GIMT_Encode4(324686), // Rule ID 4970 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fp_to_uint_sat_gi:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZUv4f32:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4970,
      GIR_Done,
    // Label 6451: @324686
    GIM_Reject,
    // Label 6440: @324687
    GIM_Try, /*On fail goto*//*Label 6452*/ GIMT_Encode4(324713), // Rule ID 4965 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fp_to_uint_sat_gi:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZUv8f16:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4965,
      GIR_Done,
    // Label 6452: @324713
    GIM_Reject,
    // Label 6441: @324714
    GIM_Reject,
    // Label 68: @324715
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 6464*/ GIMT_Encode4(325918),
    /*GILLT_s16*//*Label 6453*/ GIMT_Encode4(324810),
    /*GILLT_s32*//*Label 6454*/ GIMT_Encode4(325174),
    /*GILLT_s64*//*Label 6455*/ GIMT_Encode4(325248), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 6456*/ GIMT_Encode4(325322),
    /*GILLT_v2s64*//*Label 6457*/ GIMT_Encode4(325396),
    /*GILLT_v4s16*//*Label 6458*/ GIMT_Encode4(325470),
    /*GILLT_v4s32*//*Label 6459*/ GIMT_Encode4(325612), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 6460*/ GIMT_Encode4(325686), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s16*//*Label 6461*/ GIMT_Encode4(325828), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv4s16*//*Label 6462*/ GIMT_Encode4(325858), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv8s16*//*Label 6463*/ GIMT_Encode4(325888),
    // Label 6453: @324810
    GIM_Try, /*On fail goto*//*Label 6465*/ GIMT_Encode4(325173),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_Try, /*On fail goto*//*Label 6466*/ GIMT_Encode4(324863), // Rule ID 5244 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fabs:{ *:[f16] } (fsub:{ *:[f16] } f16:{ *:[f16] }:$Rn, f16:{ *:[f16] }:$Rm))  =>  (FABD16:{ *:[f16] } f16:{ *:[f16] }:$Rn, f16:{ *:[f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5244,
        GIR_EraseRootFromParent_Done,
      // Label 6466: @324863
      GIM_Try, /*On fail goto*//*Label 6467*/ GIMT_Encode4(324882), // Rule ID 517 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (fabs:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FABSHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSHr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 517,
        GIR_Done,
      // Label 6467: @324882
      GIM_Try, /*On fail goto*//*Label 6468*/ GIMT_Encode4(325027), // Rule ID 6422 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (fabs:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[f32] } (ANDWri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), GPR32:{ *:[i32] }), (logical_imm32_XFORM:{ *:[i32] } 32767:{ *:[i32] })), FPR32:{ *:[i32] }), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::ANDWri),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // 
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 6422,
        GIR_EraseRootFromParent_Done,
      // Label 6468: @325027
      GIM_Try, /*On fail goto*//*Label 6469*/ GIMT_Encode4(325172), // Rule ID 6423 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (fabs:{ *:[bf16] } FPR16:{ *:[bf16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[bf16] } (COPY_TO_REGCLASS:{ *:[f32] } (ANDWri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FPR16:{ *:[bf16] }:$Rn, hsub:{ *:[i32] }), GPR32:{ *:[i32] }), (logical_imm32_XFORM:{ *:[i32] } 32767:{ *:[i32] })), FPR32:{ *:[i32] }), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::ANDWri),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // 
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 6423,
        GIR_EraseRootFromParent_Done,
      // Label 6469: @325172
      GIM_Reject,
    // Label 6465: @325173
    GIM_Reject,
    // Label 6454: @325174
    GIM_Try, /*On fail goto*//*Label 6470*/ GIMT_Encode4(325247),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 6471*/ GIMT_Encode4(325227), // Rule ID 5245 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fabs:{ *:[f32] } (fsub:{ *:[f32] } f32:{ *:[f32] }:$Rn, f32:{ *:[f32] }:$Rm))  =>  (FABD32:{ *:[f32] } f32:{ *:[f32] }:$Rn, f32:{ *:[f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5245,
        GIR_EraseRootFromParent_Done,
      // Label 6471: @325227
      GIM_Try, /*On fail goto*//*Label 6472*/ GIMT_Encode4(325246), // Rule ID 518 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (fabs:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FABSSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSSr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 518,
        GIR_Done,
      // Label 6472: @325246
      GIM_Reject,
    // Label 6470: @325247
    GIM_Reject,
    // Label 6455: @325248
    GIM_Try, /*On fail goto*//*Label 6473*/ GIMT_Encode4(325321),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 6474*/ GIMT_Encode4(325301), // Rule ID 5246 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fabs:{ *:[f64] } (fsub:{ *:[f64] } f64:{ *:[f64] }:$Rn, f64:{ *:[f64] }:$Rm))  =>  (FABD64:{ *:[f64] } f64:{ *:[f64] }:$Rn, f64:{ *:[f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5246,
        GIR_EraseRootFromParent_Done,
      // Label 6474: @325301
      GIM_Try, /*On fail goto*//*Label 6475*/ GIMT_Encode4(325320), // Rule ID 519 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (fabs:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FABSDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSDr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 519,
        GIR_Done,
      // Label 6475: @325320
      GIM_Reject,
    // Label 6473: @325321
    GIM_Reject,
    // Label 6456: @325322
    GIM_Try, /*On fail goto*//*Label 6476*/ GIMT_Encode4(325395),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 6477*/ GIMT_Encode4(325375), // Rule ID 5037 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fabs:{ *:[v2f32] } (fsub:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$Rn, v2f32:{ *:[v2f32] }:$Rm))  =>  (FABDv2f32:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$Rn, v2f32:{ *:[v2f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5037,
        GIR_EraseRootFromParent_Done,
      // Label 6477: @325375
      GIM_Try, /*On fail goto*//*Label 6478*/ GIMT_Encode4(325394), // Rule ID 757 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FABSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv2f32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 757,
        GIR_Done,
      // Label 6478: @325394
      GIM_Reject,
    // Label 6476: @325395
    GIM_Reject,
    // Label 6457: @325396
    GIM_Try, /*On fail goto*//*Label 6479*/ GIMT_Encode4(325469),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 6480*/ GIMT_Encode4(325449), // Rule ID 5039 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fabs:{ *:[v2f64] } (fsub:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, v2f64:{ *:[v2f64] }:$Rm))  =>  (FABDv2f64:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, v2f64:{ *:[v2f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5039,
        GIR_EraseRootFromParent_Done,
      // Label 6480: @325449
      GIM_Try, /*On fail goto*//*Label 6481*/ GIMT_Encode4(325468), // Rule ID 759 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FABSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv2f64),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 759,
        GIR_Done,
      // Label 6481: @325468
      GIM_Reject,
    // Label 6479: @325469
    GIM_Reject,
    // Label 6458: @325470
    GIM_Try, /*On fail goto*//*Label 6482*/ GIMT_Encode4(325611),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 6483*/ GIMT_Encode4(325523), // Rule ID 5040 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fabs:{ *:[v4f16] } (fsub:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$Rn, v4f16:{ *:[v4f16] }:$Rm))  =>  (FABDv4f16:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$Rn, v4f16:{ *:[v4f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5040,
        GIR_EraseRootFromParent_Done,
      // Label 6483: @325523
      GIM_Try, /*On fail goto*//*Label 6484*/ GIMT_Encode4(325542), // Rule ID 755 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FABSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv4f16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 755,
        GIR_Done,
      // Label 6484: @325542
      GIM_Try, /*On fail goto*//*Label 6485*/ GIMT_Encode4(325576), // Rule ID 6426 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (BICv4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, 128:{ *:[i32] }, 8:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(128),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6426,
        GIR_EraseRootFromParent_Done,
      // Label 6485: @325576
      GIM_Try, /*On fail goto*//*Label 6486*/ GIMT_Encode4(325610), // Rule ID 6427 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (fabs:{ *:[v4bf16] } V64:{ *:[v4bf16] }:$Rn)  =>  (BICv4i16:{ *:[v4bf16] } V64:{ *:[v4bf16] }:$Rn, 128:{ *:[i32] }, 8:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv4i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(128),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6427,
        GIR_EraseRootFromParent_Done,
      // Label 6486: @325610
      GIM_Reject,
    // Label 6482: @325611
    GIM_Reject,
    // Label 6459: @325612
    GIM_Try, /*On fail goto*//*Label 6487*/ GIMT_Encode4(325685),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 6488*/ GIMT_Encode4(325665), // Rule ID 5038 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fabs:{ *:[v4f32] } (fsub:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$Rn, v4f32:{ *:[v4f32] }:$Rm))  =>  (FABDv4f32:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$Rn, v4f32:{ *:[v4f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5038,
        GIR_EraseRootFromParent_Done,
      // Label 6488: @325665
      GIM_Try, /*On fail goto*//*Label 6489*/ GIMT_Encode4(325684), // Rule ID 758 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FABSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv4f32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 758,
        GIR_Done,
      // Label 6489: @325684
      GIM_Reject,
    // Label 6487: @325685
    GIM_Reject,
    // Label 6460: @325686
    GIM_Try, /*On fail goto*//*Label 6490*/ GIMT_Encode4(325827),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 6491*/ GIMT_Encode4(325739), // Rule ID 5041 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fabs:{ *:[v8f16] } (fsub:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$Rn, v8f16:{ *:[v8f16] }:$Rm))  =>  (FABDv8f16:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$Rn, v8f16:{ *:[v8f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5041,
        GIR_EraseRootFromParent_Done,
      // Label 6491: @325739
      GIM_Try, /*On fail goto*//*Label 6492*/ GIMT_Encode4(325758), // Rule ID 756 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FABSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv8f16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 756,
        GIR_Done,
      // Label 6492: @325758
      GIM_Try, /*On fail goto*//*Label 6493*/ GIMT_Encode4(325792), // Rule ID 6428 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (BICv8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, 128:{ *:[i32] }, 8:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(128),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6428,
        GIR_EraseRootFromParent_Done,
      // Label 6493: @325792
      GIM_Try, /*On fail goto*//*Label 6494*/ GIMT_Encode4(325826), // Rule ID 6429 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (fabs:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn)  =>  (BICv8i16:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, 128:{ *:[i32] }, 8:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(128),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6429,
        GIR_EraseRootFromParent_Done,
      // Label 6494: @325826
      GIM_Reject,
    // Label 6490: @325827
    GIM_Reject,
    // Label 6461: @325828
    GIM_Try, /*On fail goto*//*Label 6495*/ GIMT_Encode4(325857), // Rule ID 7921 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (fabs:{ *:[nxv2bf16] } nxv2bf16:{ *:[nxv2bf16] }:$op)  =>  (AND_ZI:{ *:[nxv2bf16] } ?:{ *:[nxv2bf16] }:$op, (logical_imm64_XFORM:{ *:[i64] } 9223231297218904063:{ *:[i64] }))
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_ZI),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
      GIR_RootToRootCopy, /*OpIdx*/1, // op
      GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // 
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7921,
      GIR_EraseRootFromParent_Done,
    // Label 6495: @325857
    GIM_Reject,
    // Label 6462: @325858
    GIM_Try, /*On fail goto*//*Label 6496*/ GIMT_Encode4(325887), // Rule ID 7923 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (fabs:{ *:[nxv4bf16] } nxv4bf16:{ *:[nxv4bf16] }:$op)  =>  (AND_ZI:{ *:[nxv4bf16] } ?:{ *:[nxv4bf16] }:$op, (logical_imm64_XFORM:{ *:[i64] } 9223231297218904063:{ *:[i64] }))
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_ZI),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
      GIR_RootToRootCopy, /*OpIdx*/1, // op
      GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // 
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7923,
      GIR_EraseRootFromParent_Done,
    // Label 6496: @325887
    GIM_Reject,
    // Label 6463: @325888
    GIM_Try, /*On fail goto*//*Label 6497*/ GIMT_Encode4(325917), // Rule ID 7925 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (fabs:{ *:[nxv8bf16] } nxv8bf16:{ *:[nxv8bf16] }:$op)  =>  (AND_ZI:{ *:[nxv8bf16] } ?:{ *:[nxv8bf16] }:$op, (logical_imm64_XFORM:{ *:[i64] } 9223231297218904063:{ *:[i64] }))
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_ZI),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
      GIR_RootToRootCopy, /*OpIdx*/1, // op
      GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // 
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7925,
      GIR_EraseRootFromParent_Done,
    // Label 6497: @325917
    GIM_Reject,
    // Label 6464: @325918
    GIM_Reject,
    // Label 69: @325919
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6506*/ GIMT_Encode4(326200),
    /*GILLT_s16*//*Label 6498*/ GIMT_Encode4(325970),
    /*GILLT_s32*//*Label 6499*/ GIMT_Encode4(325997),
    /*GILLT_s64*//*Label 6500*/ GIMT_Encode4(326021), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 6501*/ GIMT_Encode4(326045),
    /*GILLT_v2s64*//*Label 6502*/ GIMT_Encode4(326076),
    /*GILLT_v4s16*//*Label 6503*/ GIMT_Encode4(326107),
    /*GILLT_v4s32*//*Label 6504*/ GIMT_Encode4(326138), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 6505*/ GIMT_Encode4(326169),
    // Label 6498: @325970
    GIM_Try, /*On fail goto*//*Label 6507*/ GIMT_Encode4(325996), // Rule ID 4856 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // (fcanonicalize:{ *:[f16] } f16:{ *:[f16] }:$a)  =>  (FMINNMHrr:{ *:[f16] } f16:{ *:[f16] }:$a, f16:{ *:[f16] }:$a)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMHrr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // a
      GIR_RootToRootCopy, /*OpIdx*/1, // a
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4856,
      GIR_EraseRootFromParent_Done,
    // Label 6507: @325996
    GIM_Reject,
    // Label 6499: @325997
    GIM_Try, /*On fail goto*//*Label 6508*/ GIMT_Encode4(326020), // Rule ID 4853 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      // (fcanonicalize:{ *:[f32] } f32:{ *:[f32] }:$a)  =>  (FMINNMSrr:{ *:[f32] } f32:{ *:[f32] }:$a, f32:{ *:[f32] }:$a)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMSrr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // a
      GIR_RootToRootCopy, /*OpIdx*/1, // a
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4853,
      GIR_EraseRootFromParent_Done,
    // Label 6508: @326020
    GIM_Reject,
    // Label 6500: @326021
    GIM_Try, /*On fail goto*//*Label 6509*/ GIMT_Encode4(326044), // Rule ID 4850 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fcanonicalize:{ *:[f64] } f64:{ *:[f64] }:$a)  =>  (FMINNMDrr:{ *:[f64] } f64:{ *:[f64] }:$a, f64:{ *:[f64] }:$a)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // a
      GIR_RootToRootCopy, /*OpIdx*/1, // a
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4850,
      GIR_EraseRootFromParent_Done,
    // Label 6509: @326044
    GIM_Reject,
    // Label 6501: @326045
    GIM_Try, /*On fail goto*//*Label 6510*/ GIMT_Encode4(326075), // Rule ID 5050 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fcanonicalize:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMINNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5050,
      GIR_EraseRootFromParent_Done,
    // Label 6510: @326075
    GIM_Reject,
    // Label 6502: @326076
    GIM_Try, /*On fail goto*//*Label 6511*/ GIMT_Encode4(326106), // Rule ID 5044 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fcanonicalize:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMINNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5044,
      GIR_EraseRootFromParent_Done,
    // Label 6511: @326106
    GIM_Reject,
    // Label 6503: @326107
    GIM_Try, /*On fail goto*//*Label 6512*/ GIMT_Encode4(326137), // Rule ID 5056 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fcanonicalize:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMINNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5056,
      GIR_EraseRootFromParent_Done,
    // Label 6512: @326137
    GIM_Reject,
    // Label 6504: @326138
    GIM_Try, /*On fail goto*//*Label 6513*/ GIMT_Encode4(326168), // Rule ID 5047 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fcanonicalize:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMINNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5047,
      GIR_EraseRootFromParent_Done,
    // Label 6513: @326168
    GIM_Reject,
    // Label 6505: @326169
    GIM_Try, /*On fail goto*//*Label 6514*/ GIMT_Encode4(326199), // Rule ID 5053 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fcanonicalize:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMINNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv8f16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5053,
      GIR_EraseRootFromParent_Done,
    // Label 6514: @326199
    GIM_Reject,
    // Label 6506: @326200
    GIM_Reject,
    // Label 70: @326201
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6523*/ GIMT_Encode4(326578),
    /*GILLT_s16*//*Label 6515*/ GIMT_Encode4(326252),
    /*GILLT_s32*//*Label 6516*/ GIMT_Encode4(326290),
    /*GILLT_s64*//*Label 6517*/ GIMT_Encode4(326328), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 6518*/ GIMT_Encode4(326388),
    /*GILLT_v2s64*//*Label 6519*/ GIMT_Encode4(326426),
    /*GILLT_v4s16*//*Label 6520*/ GIMT_Encode4(326464),
    /*GILLT_v4s32*//*Label 6521*/ GIMT_Encode4(326502), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 6522*/ GIMT_Encode4(326540),
    // Label 6515: @326252
    GIM_Try, /*On fail goto*//*Label 6524*/ GIMT_Encode4(326289), // Rule ID 604 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // (fminnum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMINNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMHrr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 604,
      GIR_Done,
    // Label 6524: @326289
    GIM_Reject,
    // Label 6516: @326290
    GIM_Try, /*On fail goto*//*Label 6525*/ GIMT_Encode4(326327), // Rule ID 606 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      // (fminnum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMINNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMSrr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 606,
      GIR_Done,
    // Label 6525: @326327
    GIM_Reject,
    // Label 6517: @326328
    GIM_Try, /*On fail goto*//*Label 6526*/ GIMT_Encode4(326387),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 6527*/ GIMT_Encode4(326370), // Rule ID 608 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        // (fminnum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMINNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 608,
        GIR_Done,
      // Label 6527: @326370
      GIM_Try, /*On fail goto*//*Label 6528*/ GIMT_Encode4(326386), // Rule ID 4847 //
        // (fminnum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMINNMDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4847,
        GIR_Done,
      // Label 6528: @326386
      GIM_Reject,
    // Label 6526: @326387
    GIM_Reject,
    // Label 6518: @326388
    GIM_Try, /*On fail goto*//*Label 6529*/ GIMT_Encode4(326425), // Rule ID 1262 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fminnum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1262,
      GIR_Done,
    // Label 6529: @326425
    GIM_Reject,
    // Label 6519: @326426
    GIM_Try, /*On fail goto*//*Label 6530*/ GIMT_Encode4(326463), // Rule ID 1266 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fminnum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f64),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1266,
      GIR_Done,
    // Label 6530: @326463
    GIM_Reject,
    // Label 6520: @326464
    GIM_Try, /*On fail goto*//*Label 6531*/ GIMT_Encode4(326501), // Rule ID 1258 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fminnum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1258,
      GIR_Done,
    // Label 6531: @326501
    GIM_Reject,
    // Label 6521: @326502
    GIM_Try, /*On fail goto*//*Label 6532*/ GIMT_Encode4(326539), // Rule ID 1264 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fminnum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1264,
      GIR_Done,
    // Label 6532: @326539
    GIM_Reject,
    // Label 6522: @326540
    GIM_Try, /*On fail goto*//*Label 6533*/ GIMT_Encode4(326577), // Rule ID 1260 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fminnum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv8f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1260,
      GIR_Done,
    // Label 6533: @326577
    GIM_Reject,
    // Label 6523: @326578
    GIM_Reject,
    // Label 71: @326579
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6542*/ GIMT_Encode4(326956),
    /*GILLT_s16*//*Label 6534*/ GIMT_Encode4(326630),
    /*GILLT_s32*//*Label 6535*/ GIMT_Encode4(326668),
    /*GILLT_s64*//*Label 6536*/ GIMT_Encode4(326706), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 6537*/ GIMT_Encode4(326766),
    /*GILLT_v2s64*//*Label 6538*/ GIMT_Encode4(326804),
    /*GILLT_v4s16*//*Label 6539*/ GIMT_Encode4(326842),
    /*GILLT_v4s32*//*Label 6540*/ GIMT_Encode4(326880), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 6541*/ GIMT_Encode4(326918),
    // Label 6534: @326630
    GIM_Try, /*On fail goto*//*Label 6543*/ GIMT_Encode4(326667), // Rule ID 592 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // (fmaxnum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMAXNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMHrr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 592,
      GIR_Done,
    // Label 6543: @326667
    GIM_Reject,
    // Label 6535: @326668
    GIM_Try, /*On fail goto*//*Label 6544*/ GIMT_Encode4(326705), // Rule ID 594 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      // (fmaxnum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMAXNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMSrr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 594,
      GIR_Done,
    // Label 6544: @326705
    GIM_Reject,
    // Label 6536: @326706
    GIM_Try, /*On fail goto*//*Label 6545*/ GIMT_Encode4(326765),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 6546*/ GIMT_Encode4(326748), // Rule ID 596 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        // (fmaxnum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMAXNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMDrr),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 596,
        GIR_Done,
      // Label 6546: @326748
      GIM_Try, /*On fail goto*//*Label 6547*/ GIMT_Encode4(326764), // Rule ID 4846 //
        // (fmaxnum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMAXNMDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMDrr),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4846,
        GIR_Done,
      // Label 6547: @326764
      GIM_Reject,
    // Label 6545: @326765
    GIM_Reject,
    // Label 6537: @326766
    GIM_Try, /*On fail goto*//*Label 6548*/ GIMT_Encode4(326803), // Rule ID 1232 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fmaxnum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1232,
      GIR_Done,
    // Label 6548: @326803
    GIM_Reject,
    // Label 6538: @326804
    GIM_Try, /*On fail goto*//*Label 6549*/ GIMT_Encode4(326841), // Rule ID 1236 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fmaxnum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f64),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1236,
      GIR_Done,
    // Label 6549: @326841
    GIM_Reject,
    // Label 6539: @326842
    GIM_Try, /*On fail goto*//*Label 6550*/ GIMT_Encode4(326879), // Rule ID 1228 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fmaxnum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1228,
      GIR_Done,
    // Label 6550: @326879
    GIM_Reject,
    // Label 6540: @326880
    GIM_Try, /*On fail goto*//*Label 6551*/ GIMT_Encode4(326917), // Rule ID 1234 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fmaxnum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1234,
      GIR_Done,
    // Label 6551: @326917
    GIM_Reject,
    // Label 6541: @326918
    GIM_Try, /*On fail goto*//*Label 6552*/ GIMT_Encode4(326955), // Rule ID 1230 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fmaxnum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv8f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1230,
      GIR_Done,
    // Label 6552: @326955
    GIM_Reject,
    // Label 6542: @326956
    GIM_Reject,
    // Label 72: @326957
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6561*/ GIMT_Encode4(327306),
    /*GILLT_s16*//*Label 6553*/ GIMT_Encode4(327008),
    /*GILLT_s32*//*Label 6554*/ GIMT_Encode4(327046),
    /*GILLT_s64*//*Label 6555*/ GIMT_Encode4(327081), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 6556*/ GIMT_Encode4(327116),
    /*GILLT_v2s64*//*Label 6557*/ GIMT_Encode4(327154),
    /*GILLT_v4s16*//*Label 6558*/ GIMT_Encode4(327192),
    /*GILLT_v4s32*//*Label 6559*/ GIMT_Encode4(327230), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 6560*/ GIMT_Encode4(327268),
    // Label 6553: @327008
    GIM_Try, /*On fail goto*//*Label 6562*/ GIMT_Encode4(327045), // Rule ID 4854 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // (fminnum_ieee:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)  =>  (FMINNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMHrr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4854,
      GIR_Done,
    // Label 6562: @327045
    GIM_Reject,
    // Label 6554: @327046
    GIM_Try, /*On fail goto*//*Label 6563*/ GIMT_Encode4(327080), // Rule ID 4851 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      // (fminnum_ieee:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)  =>  (FMINNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMSrr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4851,
      GIR_Done,
    // Label 6563: @327080
    GIM_Reject,
    // Label 6555: @327081
    GIM_Try, /*On fail goto*//*Label 6564*/ GIMT_Encode4(327115), // Rule ID 4848 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fminnum_ieee:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)  =>  (FMINNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4848,
      GIR_Done,
    // Label 6564: @327115
    GIM_Reject,
    // Label 6556: @327116
    GIM_Try, /*On fail goto*//*Label 6565*/ GIMT_Encode4(327153), // Rule ID 5048 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fminnum_ieee:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5048,
      GIR_Done,
    // Label 6565: @327153
    GIM_Reject,
    // Label 6557: @327154
    GIM_Try, /*On fail goto*//*Label 6566*/ GIMT_Encode4(327191), // Rule ID 5042 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fminnum_ieee:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f64),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5042,
      GIR_Done,
    // Label 6566: @327191
    GIM_Reject,
    // Label 6558: @327192
    GIM_Try, /*On fail goto*//*Label 6567*/ GIMT_Encode4(327229), // Rule ID 5054 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fminnum_ieee:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5054,
      GIR_Done,
    // Label 6567: @327229
    GIM_Reject,
    // Label 6559: @327230
    GIM_Try, /*On fail goto*//*Label 6568*/ GIMT_Encode4(327267), // Rule ID 5045 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fminnum_ieee:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5045,
      GIR_Done,
    // Label 6568: @327267
    GIM_Reject,
    // Label 6560: @327268
    GIM_Try, /*On fail goto*//*Label 6569*/ GIMT_Encode4(327305), // Rule ID 5051 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fminnum_ieee:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv8f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5051,
      GIR_Done,
    // Label 6569: @327305
    GIM_Reject,
    // Label 6561: @327306
    GIM_Reject,
    // Label 73: @327307
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6578*/ GIMT_Encode4(327656),
    /*GILLT_s16*//*Label 6570*/ GIMT_Encode4(327358),
    /*GILLT_s32*//*Label 6571*/ GIMT_Encode4(327396),
    /*GILLT_s64*//*Label 6572*/ GIMT_Encode4(327431), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 6573*/ GIMT_Encode4(327466),
    /*GILLT_v2s64*//*Label 6574*/ GIMT_Encode4(327504),
    /*GILLT_v4s16*//*Label 6575*/ GIMT_Encode4(327542),
    /*GILLT_v4s32*//*Label 6576*/ GIMT_Encode4(327580), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 6577*/ GIMT_Encode4(327618),
    // Label 6570: @327358
    GIM_Try, /*On fail goto*//*Label 6579*/ GIMT_Encode4(327395), // Rule ID 4855 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // (fmaxnum_ieee:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)  =>  (FMAXNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMHrr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4855,
      GIR_Done,
    // Label 6579: @327395
    GIM_Reject,
    // Label 6571: @327396
    GIM_Try, /*On fail goto*//*Label 6580*/ GIMT_Encode4(327430), // Rule ID 4852 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      // (fmaxnum_ieee:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)  =>  (FMAXNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMSrr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4852,
      GIR_Done,
    // Label 6580: @327430
    GIM_Reject,
    // Label 6572: @327431
    GIM_Try, /*On fail goto*//*Label 6581*/ GIMT_Encode4(327465), // Rule ID 4849 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fmaxnum_ieee:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)  =>  (FMAXNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMDrr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4849,
      GIR_Done,
    // Label 6581: @327465
    GIM_Reject,
    // Label 6573: @327466
    GIM_Try, /*On fail goto*//*Label 6582*/ GIMT_Encode4(327503), // Rule ID 5049 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fmaxnum_ieee:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5049,
      GIR_Done,
    // Label 6582: @327503
    GIM_Reject,
    // Label 6574: @327504
    GIM_Try, /*On fail goto*//*Label 6583*/ GIMT_Encode4(327541), // Rule ID 5043 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fmaxnum_ieee:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f64),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5043,
      GIR_Done,
    // Label 6583: @327541
    GIM_Reject,
    // Label 6575: @327542
    GIM_Try, /*On fail goto*//*Label 6584*/ GIMT_Encode4(327579), // Rule ID 5055 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fmaxnum_ieee:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5055,
      GIR_Done,
    // Label 6584: @327579
    GIM_Reject,
    // Label 6576: @327580
    GIM_Try, /*On fail goto*//*Label 6585*/ GIMT_Encode4(327617), // Rule ID 5046 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fmaxnum_ieee:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5046,
      GIR_Done,
    // Label 6585: @327617
    GIM_Reject,
    // Label 6577: @327618
    GIM_Try, /*On fail goto*//*Label 6586*/ GIMT_Encode4(327655), // Rule ID 5052 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fmaxnum_ieee:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv8f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5052,
      GIR_Done,
    // Label 6586: @327655
    GIM_Reject,
    // Label 6578: @327656
    GIM_Reject,
    // Label 74: @327657
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6595*/ GIMT_Encode4(328359),
    /*GILLT_s16*//*Label 6587*/ GIMT_Encode4(327708),
    /*GILLT_s32*//*Label 6588*/ GIMT_Encode4(327746),
    /*GILLT_s64*//*Label 6589*/ GIMT_Encode4(327784), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 6590*/ GIMT_Encode4(327844),
    /*GILLT_v2s64*//*Label 6591*/ GIMT_Encode4(327947),
    /*GILLT_v4s16*//*Label 6592*/ GIMT_Encode4(328050),
    /*GILLT_v4s32*//*Label 6593*/ GIMT_Encode4(328153), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 6594*/ GIMT_Encode4(328256),
    // Label 6587: @327708
    GIM_Try, /*On fail goto*//*Label 6596*/ GIMT_Encode4(327745), // Rule ID 610 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // (fminimum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMINHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINHrr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 610,
      GIR_Done,
    // Label 6596: @327745
    GIM_Reject,
    // Label 6588: @327746
    GIM_Try, /*On fail goto*//*Label 6597*/ GIMT_Encode4(327783), // Rule ID 612 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      // (fminimum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMINSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINSrr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 612,
      GIR_Done,
    // Label 6597: @327783
    GIM_Reject,
    // Label 6589: @327784
    GIM_Try, /*On fail goto*//*Label 6598*/ GIMT_Encode4(327843),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 6599*/ GIMT_Encode4(327826), // Rule ID 614 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        // (fminimum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMINDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINDrr),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 614,
        GIR_Done,
      // Label 6599: @327826
      GIM_Try, /*On fail goto*//*Label 6600*/ GIMT_Encode4(327842), // Rule ID 4845 //
        // (fminimum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMINDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINDrr),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4845,
        GIR_Done,
      // Label 6600: @327842
      GIM_Reject,
    // Label 6598: @327843
    GIM_Reject,
    // Label 6590: @327844
    GIM_Try, /*On fail goto*//*Label 6601*/ GIMT_Encode4(327946),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 6602*/ GIMT_Encode4(327918), // Rule ID 2353 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fminimum:{ *:[v2f32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FAMINv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2353,
        GIR_EraseRootFromParent_Done,
      // Label 6602: @327918
      GIM_Try, /*On fail goto*//*Label 6603*/ GIMT_Encode4(327945), // Rule ID 1277 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (fminimum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv2f32),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1277,
        GIR_Done,
      // Label 6603: @327945
      GIM_Reject,
    // Label 6601: @327946
    GIM_Reject,
    // Label 6591: @327947
    GIM_Try, /*On fail goto*//*Label 6604*/ GIMT_Encode4(328049),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 6605*/ GIMT_Encode4(328021), // Rule ID 2359 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fminimum:{ *:[v2f64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FAMINv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2359,
        GIR_EraseRootFromParent_Done,
      // Label 6605: @328021
      GIM_Try, /*On fail goto*//*Label 6606*/ GIMT_Encode4(328048), // Rule ID 1281 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (fminimum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv2f64),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1281,
        GIR_Done,
      // Label 6606: @328048
      GIM_Reject,
    // Label 6604: @328049
    GIM_Reject,
    // Label 6592: @328050
    GIM_Try, /*On fail goto*//*Label 6607*/ GIMT_Encode4(328152),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 6608*/ GIMT_Encode4(328124), // Rule ID 2347 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fminimum:{ *:[v4f16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FAMINv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2347,
        GIR_EraseRootFromParent_Done,
      // Label 6608: @328124
      GIM_Try, /*On fail goto*//*Label 6609*/ GIMT_Encode4(328151), // Rule ID 1273 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (fminimum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv4f16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1273,
        GIR_Done,
      // Label 6609: @328151
      GIM_Reject,
    // Label 6607: @328152
    GIM_Reject,
    // Label 6593: @328153
    GIM_Try, /*On fail goto*//*Label 6610*/ GIMT_Encode4(328255),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 6611*/ GIMT_Encode4(328227), // Rule ID 2356 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fminimum:{ *:[v4f32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FAMINv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2356,
        GIR_EraseRootFromParent_Done,
      // Label 6611: @328227
      GIM_Try, /*On fail goto*//*Label 6612*/ GIMT_Encode4(328254), // Rule ID 1279 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (fminimum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv4f32),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1279,
        GIR_Done,
      // Label 6612: @328254
      GIM_Reject,
    // Label 6610: @328255
    GIM_Reject,
    // Label 6594: @328256
    GIM_Try, /*On fail goto*//*Label 6613*/ GIMT_Encode4(328358),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 6614*/ GIMT_Encode4(328330), // Rule ID 2350 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fminimum:{ *:[v8f16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FAMINv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2350,
        GIR_EraseRootFromParent_Done,
      // Label 6614: @328330
      GIM_Try, /*On fail goto*//*Label 6615*/ GIMT_Encode4(328357), // Rule ID 1275 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (fminimum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv8f16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1275,
        GIR_Done,
      // Label 6615: @328357
      GIM_Reject,
    // Label 6613: @328358
    GIM_Reject,
    // Label 6595: @328359
    GIM_Reject,
    // Label 75: @328360
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6624*/ GIMT_Encode4(329062),
    /*GILLT_s16*//*Label 6616*/ GIMT_Encode4(328411),
    /*GILLT_s32*//*Label 6617*/ GIMT_Encode4(328449),
    /*GILLT_s64*//*Label 6618*/ GIMT_Encode4(328487), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 6619*/ GIMT_Encode4(328547),
    /*GILLT_v2s64*//*Label 6620*/ GIMT_Encode4(328650),
    /*GILLT_v4s16*//*Label 6621*/ GIMT_Encode4(328753),
    /*GILLT_v4s32*//*Label 6622*/ GIMT_Encode4(328856), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 6623*/ GIMT_Encode4(328959),
    // Label 6616: @328411
    GIM_Try, /*On fail goto*//*Label 6625*/ GIMT_Encode4(328448), // Rule ID 598 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // (fmaximum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMAXHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXHrr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 598,
      GIR_Done,
    // Label 6625: @328448
    GIM_Reject,
    // Label 6617: @328449
    GIM_Try, /*On fail goto*//*Label 6626*/ GIMT_Encode4(328486), // Rule ID 600 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      // (fmaximum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMAXSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXSrr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 600,
      GIR_Done,
    // Label 6626: @328486
    GIM_Reject,
    // Label 6618: @328487
    GIM_Try, /*On fail goto*//*Label 6627*/ GIMT_Encode4(328546),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 6628*/ GIMT_Encode4(328529), // Rule ID 602 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        // (fmaximum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMAXDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXDrr),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 602,
        GIR_Done,
      // Label 6628: @328529
      GIM_Try, /*On fail goto*//*Label 6629*/ GIMT_Encode4(328545), // Rule ID 4844 //
        // (fmaximum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMAXDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXDrr),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4844,
        GIR_Done,
      // Label 6629: @328545
      GIM_Reject,
    // Label 6627: @328546
    GIM_Reject,
    // Label 6619: @328547
    GIM_Try, /*On fail goto*//*Label 6630*/ GIMT_Encode4(328649),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 6631*/ GIMT_Encode4(328621), // Rule ID 2338 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fmaximum:{ *:[v2f32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FAMAXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2338,
        GIR_EraseRootFromParent_Done,
      // Label 6631: @328621
      GIM_Try, /*On fail goto*//*Label 6632*/ GIMT_Encode4(328648), // Rule ID 1247 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (fmaximum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv2f32),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1247,
        GIR_Done,
      // Label 6632: @328648
      GIM_Reject,
    // Label 6630: @328649
    GIM_Reject,
    // Label 6620: @328650
    GIM_Try, /*On fail goto*//*Label 6633*/ GIMT_Encode4(328752),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 6634*/ GIMT_Encode4(328724), // Rule ID 2344 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fmaximum:{ *:[v2f64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FAMAXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2344,
        GIR_EraseRootFromParent_Done,
      // Label 6634: @328724
      GIM_Try, /*On fail goto*//*Label 6635*/ GIMT_Encode4(328751), // Rule ID 1251 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (fmaximum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv2f64),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1251,
        GIR_Done,
      // Label 6635: @328751
      GIM_Reject,
    // Label 6633: @328752
    GIM_Reject,
    // Label 6621: @328753
    GIM_Try, /*On fail goto*//*Label 6636*/ GIMT_Encode4(328855),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 6637*/ GIMT_Encode4(328827), // Rule ID 2332 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fmaximum:{ *:[v4f16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FAMAXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2332,
        GIR_EraseRootFromParent_Done,
      // Label 6637: @328827
      GIM_Try, /*On fail goto*//*Label 6638*/ GIMT_Encode4(328854), // Rule ID 1243 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (fmaximum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv4f16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1243,
        GIR_Done,
      // Label 6638: @328854
      GIM_Reject,
    // Label 6636: @328855
    GIM_Reject,
    // Label 6622: @328856
    GIM_Try, /*On fail goto*//*Label 6639*/ GIMT_Encode4(328958),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 6640*/ GIMT_Encode4(328930), // Rule ID 2341 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fmaximum:{ *:[v4f32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FAMAXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2341,
        GIR_EraseRootFromParent_Done,
      // Label 6640: @328930
      GIM_Try, /*On fail goto*//*Label 6641*/ GIMT_Encode4(328957), // Rule ID 1249 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (fmaximum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv4f32),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1249,
        GIR_Done,
      // Label 6641: @328957
      GIM_Reject,
    // Label 6639: @328958
    GIM_Reject,
    // Label 6623: @328959
    GIM_Try, /*On fail goto*//*Label 6642*/ GIMT_Encode4(329061),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 6643*/ GIMT_Encode4(329033), // Rule ID 2335 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fmaximum:{ *:[v8f16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FAMAXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2335,
        GIR_EraseRootFromParent_Done,
      // Label 6643: @329033
      GIM_Try, /*On fail goto*//*Label 6644*/ GIMT_Encode4(329060), // Rule ID 1245 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (fmaximum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv8f16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1245,
        GIR_Done,
      // Label 6644: @329060
      GIM_Reject,
    // Label 6642: @329061
    GIM_Reject,
    // Label 6624: @329062
    GIM_Reject,
    // Label 76: @329063
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6653*/ GIMT_Encode4(329466),
    /*GILLT_s32*//*Label 6645*/ GIMT_Encode4(329114),
    /*GILLT_s64*//*Label 6646*/ GIMT_Encode4(329188), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 6647*/ GIMT_Encode4(329262), GIMT_Encode4(0),
    /*GILLT_v4s16*//*Label 6648*/ GIMT_Encode4(329296),
    /*GILLT_v4s32*//*Label 6649*/ GIMT_Encode4(329330),
    /*GILLT_v8s8*//*Label 6650*/ GIMT_Encode4(329364),
    /*GILLT_v8s16*//*Label 6651*/ GIMT_Encode4(329398),
    /*GILLT_v16s8*//*Label 6652*/ GIMT_Encode4(329432),
    // Label 6645: @329114
    GIM_Try, /*On fail goto*//*Label 6654*/ GIMT_Encode4(329187),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 6655*/ GIMT_Encode4(329167), // Rule ID 2315 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_32b),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (smin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_simm8_32b>>:$imm)  =>  (SMINWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINWri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2315,
        GIR_EraseRootFromParent_Done,
      // Label 6655: @329167
      GIM_Try, /*On fail goto*//*Label 6656*/ GIMT_Encode4(329186), // Rule ID 2314 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (smin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SMINWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINWrr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2314,
        GIR_Done,
      // Label 6656: @329186
      GIM_Reject,
    // Label 6654: @329187
    GIM_Reject,
    // Label 6646: @329188
    GIM_Try, /*On fail goto*//*Label 6657*/ GIMT_Encode4(329261),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 6658*/ GIMT_Encode4(329241), // Rule ID 2317 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_64b),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (smin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm8_64b>>:$imm)  =>  (SMINXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINXri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2317,
        GIR_EraseRootFromParent_Done,
      // Label 6658: @329241
      GIM_Try, /*On fail goto*//*Label 6659*/ GIMT_Encode4(329260), // Rule ID 2316 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (smin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SMINXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINXrr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2316,
        GIR_Done,
      // Label 6659: @329260
      GIM_Reject,
    // Label 6657: @329261
    GIM_Reject,
    // Label 6647: @329262
    GIM_Try, /*On fail goto*//*Label 6660*/ GIMT_Encode4(329295), // Rule ID 1403 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (smin:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMINv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv2i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1403,
      GIR_Done,
    // Label 6660: @329295
    GIM_Reject,
    // Label 6648: @329296
    GIM_Try, /*On fail goto*//*Label 6661*/ GIMT_Encode4(329329), // Rule ID 1401 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (smin:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMINv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1401,
      GIR_Done,
    // Label 6661: @329329
    GIM_Reject,
    // Label 6649: @329330
    GIM_Try, /*On fail goto*//*Label 6662*/ GIMT_Encode4(329363), // Rule ID 1404 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (smin:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMINv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv4i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1404,
      GIR_Done,
    // Label 6662: @329363
    GIM_Reject,
    // Label 6650: @329364
    GIM_Try, /*On fail goto*//*Label 6663*/ GIMT_Encode4(329397), // Rule ID 1399 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (smin:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMINv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1399,
      GIR_Done,
    // Label 6663: @329397
    GIM_Reject,
    // Label 6651: @329398
    GIM_Try, /*On fail goto*//*Label 6664*/ GIMT_Encode4(329431), // Rule ID 1402 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (smin:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMINv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1402,
      GIR_Done,
    // Label 6664: @329431
    GIM_Reject,
    // Label 6652: @329432
    GIM_Try, /*On fail goto*//*Label 6665*/ GIMT_Encode4(329465), // Rule ID 1400 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (smin:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMINv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1400,
      GIR_Done,
    // Label 6665: @329465
    GIM_Reject,
    // Label 6653: @329466
    GIM_Reject,
    // Label 77: @329467
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6674*/ GIMT_Encode4(329870),
    /*GILLT_s32*//*Label 6666*/ GIMT_Encode4(329518),
    /*GILLT_s64*//*Label 6667*/ GIMT_Encode4(329592), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 6668*/ GIMT_Encode4(329666), GIMT_Encode4(0),
    /*GILLT_v4s16*//*Label 6669*/ GIMT_Encode4(329700),
    /*GILLT_v4s32*//*Label 6670*/ GIMT_Encode4(329734),
    /*GILLT_v8s8*//*Label 6671*/ GIMT_Encode4(329768),
    /*GILLT_v8s16*//*Label 6672*/ GIMT_Encode4(329802),
    /*GILLT_v16s8*//*Label 6673*/ GIMT_Encode4(329836),
    // Label 6666: @329518
    GIM_Try, /*On fail goto*//*Label 6675*/ GIMT_Encode4(329591),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 6676*/ GIMT_Encode4(329571), // Rule ID 2311 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_32b),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (smax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_simm8_32b>>:$imm)  =>  (SMAXWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXWri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2311,
        GIR_EraseRootFromParent_Done,
      // Label 6676: @329571
      GIM_Try, /*On fail goto*//*Label 6677*/ GIMT_Encode4(329590), // Rule ID 2310 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (smax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SMAXWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXWrr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2310,
        GIR_Done,
      // Label 6677: @329590
      GIM_Reject,
    // Label 6675: @329591
    GIM_Reject,
    // Label 6667: @329592
    GIM_Try, /*On fail goto*//*Label 6678*/ GIMT_Encode4(329665),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 6679*/ GIMT_Encode4(329645), // Rule ID 2313 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_64b),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (smax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm8_64b>>:$imm)  =>  (SMAXXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXXri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2313,
        GIR_EraseRootFromParent_Done,
      // Label 6679: @329645
      GIM_Try, /*On fail goto*//*Label 6680*/ GIMT_Encode4(329664), // Rule ID 2312 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (smax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SMAXXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXXrr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2312,
        GIR_Done,
      // Label 6680: @329664
      GIM_Reject,
    // Label 6678: @329665
    GIM_Reject,
    // Label 6668: @329666
    GIM_Try, /*On fail goto*//*Label 6681*/ GIMT_Encode4(329699), // Rule ID 1391 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (smax:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMAXv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv2i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1391,
      GIR_Done,
    // Label 6681: @329699
    GIM_Reject,
    // Label 6669: @329700
    GIM_Try, /*On fail goto*//*Label 6682*/ GIMT_Encode4(329733), // Rule ID 1389 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (smax:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMAXv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1389,
      GIR_Done,
    // Label 6682: @329733
    GIM_Reject,
    // Label 6670: @329734
    GIM_Try, /*On fail goto*//*Label 6683*/ GIMT_Encode4(329767), // Rule ID 1392 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (smax:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMAXv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv4i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1392,
      GIR_Done,
    // Label 6683: @329767
    GIM_Reject,
    // Label 6671: @329768
    GIM_Try, /*On fail goto*//*Label 6684*/ GIMT_Encode4(329801), // Rule ID 1387 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (smax:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMAXv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1387,
      GIR_Done,
    // Label 6684: @329801
    GIM_Reject,
    // Label 6672: @329802
    GIM_Try, /*On fail goto*//*Label 6685*/ GIMT_Encode4(329835), // Rule ID 1390 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (smax:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMAXv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1390,
      GIR_Done,
    // Label 6685: @329835
    GIM_Reject,
    // Label 6673: @329836
    GIM_Try, /*On fail goto*//*Label 6686*/ GIMT_Encode4(329869), // Rule ID 1388 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (smax:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMAXv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1388,
      GIR_Done,
    // Label 6686: @329869
    GIM_Reject,
    // Label 6674: @329870
    GIM_Reject,
    // Label 78: @329871
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6695*/ GIMT_Encode4(330274),
    /*GILLT_s32*//*Label 6687*/ GIMT_Encode4(329922),
    /*GILLT_s64*//*Label 6688*/ GIMT_Encode4(329996), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 6689*/ GIMT_Encode4(330070), GIMT_Encode4(0),
    /*GILLT_v4s16*//*Label 6690*/ GIMT_Encode4(330104),
    /*GILLT_v4s32*//*Label 6691*/ GIMT_Encode4(330138),
    /*GILLT_v8s8*//*Label 6692*/ GIMT_Encode4(330172),
    /*GILLT_v8s16*//*Label 6693*/ GIMT_Encode4(330206),
    /*GILLT_v16s8*//*Label 6694*/ GIMT_Encode4(330240),
    // Label 6687: @329922
    GIM_Try, /*On fail goto*//*Label 6696*/ GIMT_Encode4(329995),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 6697*/ GIMT_Encode4(329975), // Rule ID 2323 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_32b),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (umin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_uimm8_32b>>:$imm)  =>  (UMINWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINWri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2323,
        GIR_EraseRootFromParent_Done,
      // Label 6697: @329975
      GIM_Try, /*On fail goto*//*Label 6698*/ GIMT_Encode4(329994), // Rule ID 2322 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (umin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UMINWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINWrr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2322,
        GIR_Done,
      // Label 6698: @329994
      GIM_Reject,
    // Label 6696: @329995
    GIM_Reject,
    // Label 6688: @329996
    GIM_Try, /*On fail goto*//*Label 6699*/ GIMT_Encode4(330069),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 6700*/ GIMT_Encode4(330049), // Rule ID 2325 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_64b),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (umin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_uimm8_64b>>:$imm)  =>  (UMINXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINXri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2325,
        GIR_EraseRootFromParent_Done,
      // Label 6700: @330049
      GIM_Try, /*On fail goto*//*Label 6701*/ GIMT_Encode4(330068), // Rule ID 2324 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (umin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UMINXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINXrr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2324,
        GIR_Done,
      // Label 6701: @330068
      GIM_Reject,
    // Label 6699: @330069
    GIM_Reject,
    // Label 6689: @330070
    GIM_Try, /*On fail goto*//*Label 6702*/ GIMT_Encode4(330103), // Rule ID 1526 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (umin:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMINv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv2i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1526,
      GIR_Done,
    // Label 6702: @330103
    GIM_Reject,
    // Label 6690: @330104
    GIM_Try, /*On fail goto*//*Label 6703*/ GIMT_Encode4(330137), // Rule ID 1524 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (umin:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMINv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1524,
      GIR_Done,
    // Label 6703: @330137
    GIM_Reject,
    // Label 6691: @330138
    GIM_Try, /*On fail goto*//*Label 6704*/ GIMT_Encode4(330171), // Rule ID 1527 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (umin:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMINv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv4i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1527,
      GIR_Done,
    // Label 6704: @330171
    GIM_Reject,
    // Label 6692: @330172
    GIM_Try, /*On fail goto*//*Label 6705*/ GIMT_Encode4(330205), // Rule ID 1522 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (umin:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMINv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1522,
      GIR_Done,
    // Label 6705: @330205
    GIM_Reject,
    // Label 6693: @330206
    GIM_Try, /*On fail goto*//*Label 6706*/ GIMT_Encode4(330239), // Rule ID 1525 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (umin:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMINv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1525,
      GIR_Done,
    // Label 6706: @330239
    GIM_Reject,
    // Label 6694: @330240
    GIM_Try, /*On fail goto*//*Label 6707*/ GIMT_Encode4(330273), // Rule ID 1523 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (umin:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMINv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1523,
      GIR_Done,
    // Label 6707: @330273
    GIM_Reject,
    // Label 6695: @330274
    GIM_Reject,
    // Label 79: @330275
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6716*/ GIMT_Encode4(330678),
    /*GILLT_s32*//*Label 6708*/ GIMT_Encode4(330326),
    /*GILLT_s64*//*Label 6709*/ GIMT_Encode4(330400), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 6710*/ GIMT_Encode4(330474), GIMT_Encode4(0),
    /*GILLT_v4s16*//*Label 6711*/ GIMT_Encode4(330508),
    /*GILLT_v4s32*//*Label 6712*/ GIMT_Encode4(330542),
    /*GILLT_v8s8*//*Label 6713*/ GIMT_Encode4(330576),
    /*GILLT_v8s16*//*Label 6714*/ GIMT_Encode4(330610),
    /*GILLT_v16s8*//*Label 6715*/ GIMT_Encode4(330644),
    // Label 6708: @330326
    GIM_Try, /*On fail goto*//*Label 6717*/ GIMT_Encode4(330399),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 6718*/ GIMT_Encode4(330379), // Rule ID 2319 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_32b),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (umax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_uimm8_32b>>:$imm)  =>  (UMAXWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXWri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2319,
        GIR_EraseRootFromParent_Done,
      // Label 6718: @330379
      GIM_Try, /*On fail goto*//*Label 6719*/ GIMT_Encode4(330398), // Rule ID 2318 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (umax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UMAXWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXWrr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2318,
        GIR_Done,
      // Label 6719: @330398
      GIM_Reject,
    // Label 6717: @330399
    GIM_Reject,
    // Label 6709: @330400
    GIM_Try, /*On fail goto*//*Label 6720*/ GIMT_Encode4(330473),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 6721*/ GIMT_Encode4(330453), // Rule ID 2321 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_64b),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (umax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_uimm8_64b>>:$imm)  =>  (UMAXXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXXri),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2321,
        GIR_EraseRootFromParent_Done,
      // Label 6721: @330453
      GIM_Try, /*On fail goto*//*Label 6722*/ GIMT_Encode4(330472), // Rule ID 2320 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (umax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UMAXXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXXrr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2320,
        GIR_Done,
      // Label 6722: @330472
      GIM_Reject,
    // Label 6720: @330473
    GIM_Reject,
    // Label 6710: @330474
    GIM_Try, /*On fail goto*//*Label 6723*/ GIMT_Encode4(330507), // Rule ID 1514 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (umax:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMAXv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv2i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1514,
      GIR_Done,
    // Label 6723: @330507
    GIM_Reject,
    // Label 6711: @330508
    GIM_Try, /*On fail goto*//*Label 6724*/ GIMT_Encode4(330541), // Rule ID 1512 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (umax:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMAXv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1512,
      GIR_Done,
    // Label 6724: @330541
    GIM_Reject,
    // Label 6712: @330542
    GIM_Try, /*On fail goto*//*Label 6725*/ GIMT_Encode4(330575), // Rule ID 1515 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (umax:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMAXv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv4i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1515,
      GIR_Done,
    // Label 6725: @330575
    GIM_Reject,
    // Label 6713: @330576
    GIM_Try, /*On fail goto*//*Label 6726*/ GIMT_Encode4(330609), // Rule ID 1510 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (umax:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMAXv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1510,
      GIR_Done,
    // Label 6726: @330609
    GIM_Reject,
    // Label 6714: @330610
    GIM_Try, /*On fail goto*//*Label 6727*/ GIMT_Encode4(330643), // Rule ID 1513 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (umax:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMAXv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1513,
      GIR_Done,
    // Label 6727: @330643
    GIM_Reject,
    // Label 6715: @330644
    GIM_Try, /*On fail goto*//*Label 6728*/ GIMT_Encode4(330677), // Rule ID 1511 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (umax:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMAXv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1511,
      GIR_Done,
    // Label 6728: @330677
    GIM_Reject,
    // Label 6716: @330678
    GIM_Reject,
    // Label 80: @330679
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6738*/ GIMT_Encode4(331493),
    /*GILLT_s32*//*Label 6729*/ GIMT_Encode4(330730),
    /*GILLT_s64*//*Label 6730*/ GIMT_Encode4(330757), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 6731*/ GIMT_Encode4(330836),
    /*GILLT_v2s64*//*Label 6732*/ GIMT_Encode4(330863),
    /*GILLT_v4s16*//*Label 6733*/ GIMT_Encode4(331046),
    /*GILLT_v4s32*//*Label 6734*/ GIMT_Encode4(331073),
    /*GILLT_v8s8*//*Label 6735*/ GIMT_Encode4(331256),
    /*GILLT_v8s16*//*Label 6736*/ GIMT_Encode4(331283),
    /*GILLT_v16s8*//*Label 6737*/ GIMT_Encode4(331466),
    // Label 6729: @330730
    GIM_Try, /*On fail goto*//*Label 6739*/ GIMT_Encode4(330756), // Rule ID 2304 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // (abs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (ABSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSWr),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2304,
      GIR_Done,
    // Label 6739: @330756
    GIM_Reject,
    // Label 6730: @330757
    GIM_Try, /*On fail goto*//*Label 6740*/ GIMT_Encode4(330835),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 6741*/ GIMT_Encode4(330788), // Rule ID 1641 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (abs:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)  =>  (ABSv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv1i64),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1641,
        GIR_Done,
      // Label 6741: @330788
      GIM_Try, /*On fail goto*//*Label 6742*/ GIMT_Encode4(330811), // Rule ID 2305 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (abs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (ABSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSXr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2305,
        GIR_Done,
      // Label 6742: @330811
      GIM_Try, /*On fail goto*//*Label 6743*/ GIMT_Encode4(330834), // Rule ID 2479 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoCSSC),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (abs:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)  =>  (ABSv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv1i64),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2479,
        GIR_Done,
      // Label 6743: @330834
      GIM_Reject,
    // Label 6740: @330835
    GIM_Reject,
    // Label 6731: @330836
    GIM_Try, /*On fail goto*//*Label 6744*/ GIMT_Encode4(330862), // Rule ID 703 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (abs:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (ABSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv2i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 703,
      GIR_Done,
    // Label 6744: @330862
    GIM_Reject,
    // Label 6732: @330863
    GIM_Try, /*On fail goto*//*Label 6745*/ GIMT_Encode4(331045),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 6746*/ GIMT_Encode4(330953), // Rule ID 4924 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (abs:{ *:[v2i64] } (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$opA)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$opB))))  =>  (UABDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$opA, V128:{ *:[v4i32] }:$opB)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // opA
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // opB
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4924,
        GIR_EraseRootFromParent_Done,
      // Label 6746: @330953
      GIM_Try, /*On fail goto*//*Label 6747*/ GIMT_Encode4(331025), // Rule ID 4923 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (abs:{ *:[v2i64] } (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$opA), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$opB)))  =>  (UABDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$opA, V64:{ *:[v2i32] }:$opB)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv2i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // opA
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // opB
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4923,
        GIR_EraseRootFromParent_Done,
      // Label 6747: @331025
      GIM_Try, /*On fail goto*//*Label 6748*/ GIMT_Encode4(331044), // Rule ID 705 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (abs:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)  =>  (ABSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv2i64),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 705,
        GIR_Done,
      // Label 6748: @331044
      GIM_Reject,
    // Label 6745: @331045
    GIM_Reject,
    // Label 6733: @331046
    GIM_Try, /*On fail goto*//*Label 6749*/ GIMT_Encode4(331072), // Rule ID 701 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (abs:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (ABSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 701,
      GIR_Done,
    // Label 6749: @331072
    GIM_Reject,
    // Label 6734: @331073
    GIM_Try, /*On fail goto*//*Label 6750*/ GIMT_Encode4(331255),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 6751*/ GIMT_Encode4(331163), // Rule ID 4922 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (abs:{ *:[v4i32] } (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$opA)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$opB))))  =>  (UABDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$opA, V128:{ *:[v8i16] }:$opB)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // opA
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // opB
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4922,
        GIR_EraseRootFromParent_Done,
      // Label 6751: @331163
      GIM_Try, /*On fail goto*//*Label 6752*/ GIMT_Encode4(331235), // Rule ID 4921 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (abs:{ *:[v4i32] } (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$opA), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$opB)))  =>  (UABDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$opA, V64:{ *:[v4i16] }:$opB)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // opA
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // opB
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4921,
        GIR_EraseRootFromParent_Done,
      // Label 6752: @331235
      GIM_Try, /*On fail goto*//*Label 6753*/ GIMT_Encode4(331254), // Rule ID 704 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (abs:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (ABSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv4i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 704,
        GIR_Done,
      // Label 6753: @331254
      GIM_Reject,
    // Label 6750: @331255
    GIM_Reject,
    // Label 6735: @331256
    GIM_Try, /*On fail goto*//*Label 6754*/ GIMT_Encode4(331282), // Rule ID 699 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (abs:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (ABSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 699,
      GIR_Done,
    // Label 6754: @331282
    GIM_Reject,
    // Label 6736: @331283
    GIM_Try, /*On fail goto*//*Label 6755*/ GIMT_Encode4(331465),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 6756*/ GIMT_Encode4(331373), // Rule ID 4920 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (abs:{ *:[v8i16] } (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$opA)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$opB))))  =>  (UABDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$opA, V128:{ *:[v16i8] }:$opB)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // opA
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // opB
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4920,
        GIR_EraseRootFromParent_Done,
      // Label 6756: @331373
      GIM_Try, /*On fail goto*//*Label 6757*/ GIMT_Encode4(331445), // Rule ID 4919 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (abs:{ *:[v8i16] } (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$opA), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$opB)))  =>  (UABDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$opA, V64:{ *:[v8i8] }:$opB)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // opA
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // opB
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4919,
        GIR_EraseRootFromParent_Done,
      // Label 6757: @331445
      GIM_Try, /*On fail goto*//*Label 6758*/ GIMT_Encode4(331464), // Rule ID 702 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (abs:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (ABSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv8i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 702,
        GIR_Done,
      // Label 6758: @331464
      GIM_Reject,
    // Label 6755: @331465
    GIM_Reject,
    // Label 6737: @331466
    GIM_Try, /*On fail goto*//*Label 6759*/ GIMT_Encode4(331492), // Rule ID 700 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (abs:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (ABSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 700,
      GIR_Done,
    // Label 6759: @331492
    GIM_Reject,
    // Label 6738: @331493
    GIM_Reject,
    // Label 81: @331494
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 6762*/ GIMT_Encode4(331659),
    /*GILLT_s32*//*Label 6760*/ GIMT_Encode4(331513),
    /*GILLT_s64*//*Label 6761*/ GIMT_Encode4(331586),
    // Label 6760: @331513
    GIM_Try, /*On fail goto*//*Label 6763*/ GIMT_Encode4(331539), // Rule ID 4765 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // (lround:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTASUWHr:{ *:[i32] } f16:{ *:[f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWHr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4765,
      GIR_Done,
    // Label 6763: @331539
    GIM_Try, /*On fail goto*//*Label 6764*/ GIMT_Encode4(331562), // Rule ID 4771 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // (lround:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTASUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWSr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4771,
      GIR_Done,
    // Label 6764: @331562
    GIM_Try, /*On fail goto*//*Label 6765*/ GIMT_Encode4(331585), // Rule ID 4773 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // (lround:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTASUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWDr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4773,
      GIR_Done,
    // Label 6765: @331585
    GIM_Reject,
    // Label 6761: @331586
    GIM_Try, /*On fail goto*//*Label 6766*/ GIMT_Encode4(331612), // Rule ID 4767 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (lround:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTASUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXHr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4767,
      GIR_Done,
    // Label 6766: @331612
    GIM_Try, /*On fail goto*//*Label 6767*/ GIMT_Encode4(331635), // Rule ID 4775 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (lround:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTASUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4775,
      GIR_Done,
    // Label 6767: @331635
    GIM_Try, /*On fail goto*//*Label 6768*/ GIMT_Encode4(331658), // Rule ID 4777 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (lround:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTASUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4777,
      GIR_Done,
    // Label 6768: @331658
    GIM_Reject,
    // Label 6762: @331659
    GIM_Reject,
    // Label 82: @331660
    GIM_Try, /*On fail goto*//*Label 6769*/ GIMT_Encode4(331758),
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
      GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 6773*/ GIMT_Encode4(331757),
      /*GILLT_s16*//*Label 6770*/ GIMT_Encode4(331691),
      /*GILLT_s32*//*Label 6771*/ GIMT_Encode4(331715),
      /*GILLT_s64*//*Label 6772*/ GIMT_Encode4(331736),
      // Label 6770: @331691
      GIM_Try, /*On fail goto*//*Label 6774*/ GIMT_Encode4(331714), // Rule ID 4769 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (llround:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTASUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXHr),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4769,
        GIR_Done,
      // Label 6774: @331714
      GIM_Reject,
      // Label 6771: @331715
      GIM_Try, /*On fail goto*//*Label 6775*/ GIMT_Encode4(331735), // Rule ID 4779 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (llround:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTASUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4779,
        GIR_Done,
      // Label 6775: @331735
      GIM_Reject,
      // Label 6772: @331736
      GIM_Try, /*On fail goto*//*Label 6776*/ GIMT_Encode4(331756), // Rule ID 4781 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (llround:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTASUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4781,
        GIR_Done,
      // Label 6776: @331756
      GIM_Reject,
      // Label 6773: @331757
      GIM_Reject,
    // Label 6769: @331758
    GIM_Reject,
    // Label 83: @331759
    GIM_Try, /*On fail goto*//*Label 6777*/ GIMT_Encode4(331774), // Rule ID 237 //
      // MIs[0] addr
      GIM_CheckIsMBB, /*MI*/0, /*Op*/0,
      // (br (bb:{ *:[Other] }):$addr)  =>  (B (bb:{ *:[Other] }):$addr)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::B),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 237,
      GIR_Done,
    // Label 6777: @331774
    GIM_Reject,
    // Label 84: @331775
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(21), /*)*//*default:*//*Label 6789*/ GIMT_Encode4(337230),
    /*GILLT_s64*//*Label 6778*/ GIMT_Encode4(331858), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 6779*/ GIMT_Encode4(332140), GIMT_Encode4(0),
    /*GILLT_v4s16*//*Label 6780*/ GIMT_Encode4(332422), GIMT_Encode4(0),
    /*GILLT_v8s8*//*Label 6781*/ GIMT_Encode4(332806), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv1s1*//*Label 6782*/ GIMT_Encode4(332986),
    /*GILLT_nxv2s1*//*Label 6783*/ GIMT_Encode4(335249),
    /*GILLT_nxv2s16*//*Label 6784*/ GIMT_Encode4(336104),
    /*GILLT_nxv2s32*//*Label 6785*/ GIMT_Encode4(336677), GIMT_Encode4(0),
    /*GILLT_nxv4s1*//*Label 6786*/ GIMT_Encode4(336747),
    /*GILLT_nxv4s16*//*Label 6787*/ GIMT_Encode4(337034), GIMT_Encode4(0),
    /*GILLT_nxv8s1*//*Label 6788*/ GIMT_Encode4(337160),
    // Label 6778: @331858
    GIM_Try, /*On fail goto*//*Label 6790*/ GIMT_Encode4(332139),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 6791*/ GIMT_Encode4(331938), // Rule ID 5495 //
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
        // (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5495,
        GIR_EraseRootFromParent_Done,
      // Label 6791: @331938
      GIM_Try, /*On fail goto*//*Label 6792*/ GIMT_Encode4(332002), // Rule ID 5500 //
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
        // (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5500,
        GIR_EraseRootFromParent_Done,
      // Label 6792: @332002
      GIM_Try, /*On fail goto*//*Label 6793*/ GIMT_Encode4(332040), // Rule ID 7046 //
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
        // (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 7046,
        GIR_EraseRootFromParent_Done,
      // Label 6793: @332040
      GIM_Try, /*On fail goto*//*Label 6794*/ GIMT_Encode4(332078), // Rule ID 7047 //
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
        // (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 7047,
        GIR_EraseRootFromParent_Done,
      // Label 6794: @332078
      GIM_Try, /*On fail goto*//*Label 6795*/ GIMT_Encode4(332138), // Rule ID 7051 //
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
        // (extract_subvector:{ *:[v1i64] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 7051,
        GIR_EraseRootFromParent_Done,
      // Label 6795: @332138
      GIM_Reject,
    // Label 6790: @332139
    GIM_Reject,
    // Label 6779: @332140
    GIM_Try, /*On fail goto*//*Label 6796*/ GIMT_Encode4(332421),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 6797*/ GIMT_Encode4(332220), // Rule ID 5485 //
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
        // (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5485,
        GIR_EraseRootFromParent_Done,
      // Label 6797: @332220
      GIM_Try, /*On fail goto*//*Label 6798*/ GIMT_Encode4(332284), // Rule ID 5490 //
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
        // (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 2:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5490,
        GIR_EraseRootFromParent_Done,
      // Label 6798: @332284
      GIM_Try, /*On fail goto*//*Label 6799*/ GIMT_Encode4(332322), // Rule ID 7042 //
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
        // (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 7042,
        GIR_EraseRootFromParent_Done,
      // Label 6799: @332322
      GIM_Try, /*On fail goto*//*Label 6800*/ GIMT_Encode4(332360), // Rule ID 7045 //
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
        // (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, dsub:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 7045,
        GIR_EraseRootFromParent_Done,
      // Label 6800: @332360
      GIM_Try, /*On fail goto*//*Label 6801*/ GIMT_Encode4(332420), // Rule ID 7050 //
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
        // (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v4i32] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 7050,
        GIR_EraseRootFromParent_Done,
      // Label 6801: @332420
      GIM_Reject,
    // Label 6796: @332421
    GIM_Reject,
    // Label 6780: @332422
    GIM_Try, /*On fail goto*//*Label 6802*/ GIMT_Encode4(332805),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 6803*/ GIMT_Encode4(332502), // Rule ID 5470 //
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
        // (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5470,
        GIR_EraseRootFromParent_Done,
      // Label 6803: @332502
      GIM_Try, /*On fail goto*//*Label 6804*/ GIMT_Encode4(332566), // Rule ID 5475 //
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
        // (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 4:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5475,
        GIR_EraseRootFromParent_Done,
      // Label 6804: @332566
      GIM_Try, /*On fail goto*//*Label 6805*/ GIMT_Encode4(332630), // Rule ID 5480 //
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
        // (extract_subvector:{ *:[v4bf16] } V128:{ *:[v8bf16] }:$Rn, 4:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4bf16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5480,
        GIR_EraseRootFromParent_Done,
      // Label 6805: @332630
      GIM_Try, /*On fail goto*//*Label 6806*/ GIMT_Encode4(332668), // Rule ID 7040 //
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
        // (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, dsub:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 7040,
        GIR_EraseRootFromParent_Done,
      // Label 6806: @332668
      GIM_Try, /*On fail goto*//*Label 6807*/ GIMT_Encode4(332706), // Rule ID 7043 //
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
        // (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 7043,
        GIR_EraseRootFromParent_Done,
      // Label 6807: @332706
      GIM_Try, /*On fail goto*//*Label 6808*/ GIMT_Encode4(332744), // Rule ID 7044 //
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
        // (extract_subvector:{ *:[v4bf16] } V128:{ *:[v8bf16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4bf16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 7044,
        GIR_EraseRootFromParent_Done,
      // Label 6808: @332744
      GIM_Try, /*On fail goto*//*Label 6809*/ GIMT_Encode4(332804), // Rule ID 7049 //
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
        // (extract_subvector:{ *:[v4i16] } FPR128:{ *:[v8i16] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v8i16] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 7049,
        GIR_EraseRootFromParent_Done,
      // Label 6809: @332804
      GIM_Reject,
    // Label 6802: @332805
    GIM_Reject,
    // Label 6781: @332806
    GIM_Try, /*On fail goto*//*Label 6810*/ GIMT_Encode4(332985),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 6811*/ GIMT_Encode4(332886), // Rule ID 5465 //
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
        // (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 8:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (EXTv16i8:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5465,
        GIR_EraseRootFromParent_Done,
      // Label 6811: @332886
      GIM_Try, /*On fail goto*//*Label 6812*/ GIMT_Encode4(332924), // Rule ID 7041 //
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
        // (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, dsub:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 7041,
        GIR_EraseRootFromParent_Done,
      // Label 6812: @332924
      GIM_Try, /*On fail goto*//*Label 6813*/ GIMT_Encode4(332984), // Rule ID 7048 //
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
        // (extract_subvector:{ *:[v8i8] } FPR128:{ *:[v16i8] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v16i8] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 7048,
        GIR_EraseRootFromParent_Done,
      // Label 6813: @332984
      GIM_Reject,
    // Label 6810: @332985
    GIM_Reject,
    // Label 6782: @332986
    GIM_Try, /*On fail goto*//*Label 6814*/ GIMT_Encode4(333021), // Rule ID 9157 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
      // (extract_subvector:{ *:[nxv1i1] } nxv2i1:{ *:[nxv2i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv2i1] }:$Ps)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Ps
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9157,
      GIR_EraseRootFromParent_Done,
    // Label 6814: @333021
    GIM_Try, /*On fail goto*//*Label 6815*/ GIMT_Encode4(333056), // Rule ID 9158 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
      // (extract_subvector:{ *:[nxv1i1] } nxv2i1:{ *:[nxv2i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv2i1] }:$Ps)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Ps
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9158,
      GIR_EraseRootFromParent_Done,
    // Label 6815: @333056
    GIM_Try, /*On fail goto*//*Label 6816*/ GIMT_Encode4(333110), // Rule ID 9165 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
      // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9165,
      GIR_EraseRootFromParent_Done,
    // Label 6816: @333110
    GIM_Try, /*On fail goto*//*Label 6817*/ GIMT_Encode4(333164), // Rule ID 9166 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
      // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9166,
      GIR_EraseRootFromParent_Done,
    // Label 6817: @333164
    GIM_Try, /*On fail goto*//*Label 6818*/ GIMT_Encode4(333218), // Rule ID 9167 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
      // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9167,
      GIR_EraseRootFromParent_Done,
    // Label 6818: @333218
    GIM_Try, /*On fail goto*//*Label 6819*/ GIMT_Encode4(333272), // Rule ID 9168 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(3),
      // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 3:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9168,
      GIR_EraseRootFromParent_Done,
    // Label 6819: @333272
    GIM_Try, /*On fail goto*//*Label 6820*/ GIMT_Encode4(333343), // Rule ID 9177 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
      // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9177,
      GIR_EraseRootFromParent_Done,
    // Label 6820: @333343
    GIM_Try, /*On fail goto*//*Label 6821*/ GIMT_Encode4(333414), // Rule ID 9178 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
      // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9178,
      GIR_EraseRootFromParent_Done,
    // Label 6821: @333414
    GIM_Try, /*On fail goto*//*Label 6822*/ GIMT_Encode4(333485), // Rule ID 9179 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
      // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9179,
      GIR_EraseRootFromParent_Done,
    // Label 6822: @333485
    GIM_Try, /*On fail goto*//*Label 6823*/ GIMT_Encode4(333556), // Rule ID 9180 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(3),
      // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 3:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9180,
      GIR_EraseRootFromParent_Done,
    // Label 6823: @333556
    GIM_Try, /*On fail goto*//*Label 6824*/ GIMT_Encode4(333627), // Rule ID 9181 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
      // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9181,
      GIR_EraseRootFromParent_Done,
    // Label 6824: @333627
    GIM_Try, /*On fail goto*//*Label 6825*/ GIMT_Encode4(333698), // Rule ID 9182 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(5),
      // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 5:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9182,
      GIR_EraseRootFromParent_Done,
    // Label 6825: @333698
    GIM_Try, /*On fail goto*//*Label 6826*/ GIMT_Encode4(333769), // Rule ID 9183 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
      // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9183,
      GIR_EraseRootFromParent_Done,
    // Label 6826: @333769
    GIM_Try, /*On fail goto*//*Label 6827*/ GIMT_Encode4(333840), // Rule ID 9184 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
      // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 7:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9184,
      GIR_EraseRootFromParent_Done,
    // Label 6827: @333840
    GIM_Try, /*On fail goto*//*Label 6828*/ GIMT_Encode4(333928), // Rule ID 9193 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
      // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9193,
      GIR_EraseRootFromParent_Done,
    // Label 6828: @333928
    GIM_Try, /*On fail goto*//*Label 6829*/ GIMT_Encode4(334016), // Rule ID 9194 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
      // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9194,
      GIR_EraseRootFromParent_Done,
    // Label 6829: @334016
    GIM_Try, /*On fail goto*//*Label 6830*/ GIMT_Encode4(334104), // Rule ID 9195 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
      // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9195,
      GIR_EraseRootFromParent_Done,
    // Label 6830: @334104
    GIM_Try, /*On fail goto*//*Label 6831*/ GIMT_Encode4(334192), // Rule ID 9196 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(3),
      // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 3:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9196,
      GIR_EraseRootFromParent_Done,
    // Label 6831: @334192
    GIM_Try, /*On fail goto*//*Label 6832*/ GIMT_Encode4(334280), // Rule ID 9197 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
      // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9197,
      GIR_EraseRootFromParent_Done,
    // Label 6832: @334280
    GIM_Try, /*On fail goto*//*Label 6833*/ GIMT_Encode4(334368), // Rule ID 9198 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(5),
      // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 5:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9198,
      GIR_EraseRootFromParent_Done,
    // Label 6833: @334368
    GIM_Try, /*On fail goto*//*Label 6834*/ GIMT_Encode4(334456), // Rule ID 9199 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
      // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9199,
      GIR_EraseRootFromParent_Done,
    // Label 6834: @334456
    GIM_Try, /*On fail goto*//*Label 6835*/ GIMT_Encode4(334544), // Rule ID 9200 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
      // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 7:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9200,
      GIR_EraseRootFromParent_Done,
    // Label 6835: @334544
    GIM_Try, /*On fail goto*//*Label 6836*/ GIMT_Encode4(334632), // Rule ID 9201 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
      // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9201,
      GIR_EraseRootFromParent_Done,
    // Label 6836: @334632
    GIM_Try, /*On fail goto*//*Label 6837*/ GIMT_Encode4(334720), // Rule ID 9202 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(9),
      // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 9:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9202,
      GIR_EraseRootFromParent_Done,
    // Label 6837: @334720
    GIM_Try, /*On fail goto*//*Label 6838*/ GIMT_Encode4(334808), // Rule ID 9203 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(10),
      // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 10:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9203,
      GIR_EraseRootFromParent_Done,
    // Label 6838: @334808
    GIM_Try, /*On fail goto*//*Label 6839*/ GIMT_Encode4(334896), // Rule ID 9204 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(11),
      // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 11:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9204,
      GIR_EraseRootFromParent_Done,
    // Label 6839: @334896
    GIM_Try, /*On fail goto*//*Label 6840*/ GIMT_Encode4(334984), // Rule ID 9205 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(12),
      // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 12:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9205,
      GIR_EraseRootFromParent_Done,
    // Label 6840: @334984
    GIM_Try, /*On fail goto*//*Label 6841*/ GIMT_Encode4(335072), // Rule ID 9206 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(13),
      // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 13:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9206,
      GIR_EraseRootFromParent_Done,
    // Label 6841: @335072
    GIM_Try, /*On fail goto*//*Label 6842*/ GIMT_Encode4(335160), // Rule ID 9207 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(14),
      // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 14:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9207,
      GIR_EraseRootFromParent_Done,
    // Label 6842: @335160
    GIM_Try, /*On fail goto*//*Label 6843*/ GIMT_Encode4(335248), // Rule ID 9208 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(15),
      // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 15:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9208,
      GIR_EraseRootFromParent_Done,
    // Label 6843: @335248
    GIM_Reject,
    // Label 6783: @335249
    GIM_Try, /*On fail goto*//*Label 6844*/ GIMT_Encode4(335284), // Rule ID 9159 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
      // (extract_subvector:{ *:[nxv2i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } PPR:{ *:[nxv4i1] }:$Ps)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Ps
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9159,
      GIR_EraseRootFromParent_Done,
    // Label 6844: @335284
    GIM_Try, /*On fail goto*//*Label 6845*/ GIMT_Encode4(335319), // Rule ID 9160 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
      // (extract_subvector:{ *:[nxv2i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } PPR:{ *:[nxv4i1] }:$Ps)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Ps
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9160,
      GIR_EraseRootFromParent_Done,
    // Label 6845: @335319
    GIM_Try, /*On fail goto*//*Label 6846*/ GIMT_Encode4(335373), // Rule ID 9169 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
      // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9169,
      GIR_EraseRootFromParent_Done,
    // Label 6846: @335373
    GIM_Try, /*On fail goto*//*Label 6847*/ GIMT_Encode4(335427), // Rule ID 9170 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
      // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9170,
      GIR_EraseRootFromParent_Done,
    // Label 6847: @335427
    GIM_Try, /*On fail goto*//*Label 6848*/ GIMT_Encode4(335481), // Rule ID 9171 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
      // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9171,
      GIR_EraseRootFromParent_Done,
    // Label 6848: @335481
    GIM_Try, /*On fail goto*//*Label 6849*/ GIMT_Encode4(335535), // Rule ID 9172 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
      // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9172,
      GIR_EraseRootFromParent_Done,
    // Label 6849: @335535
    GIM_Try, /*On fail goto*//*Label 6850*/ GIMT_Encode4(335606), // Rule ID 9185 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
      // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9185,
      GIR_EraseRootFromParent_Done,
    // Label 6850: @335606
    GIM_Try, /*On fail goto*//*Label 6851*/ GIMT_Encode4(335677), // Rule ID 9186 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
      // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9186,
      GIR_EraseRootFromParent_Done,
    // Label 6851: @335677
    GIM_Try, /*On fail goto*//*Label 6852*/ GIMT_Encode4(335748), // Rule ID 9187 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
      // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9187,
      GIR_EraseRootFromParent_Done,
    // Label 6852: @335748
    GIM_Try, /*On fail goto*//*Label 6853*/ GIMT_Encode4(335819), // Rule ID 9188 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
      // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9188,
      GIR_EraseRootFromParent_Done,
    // Label 6853: @335819
    GIM_Try, /*On fail goto*//*Label 6854*/ GIMT_Encode4(335890), // Rule ID 9189 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
      // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9189,
      GIR_EraseRootFromParent_Done,
    // Label 6854: @335890
    GIM_Try, /*On fail goto*//*Label 6855*/ GIMT_Encode4(335961), // Rule ID 9190 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(10),
      // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 10:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9190,
      GIR_EraseRootFromParent_Done,
    // Label 6855: @335961
    GIM_Try, /*On fail goto*//*Label 6856*/ GIMT_Encode4(336032), // Rule ID 9191 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(12),
      // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 12:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9191,
      GIR_EraseRootFromParent_Done,
    // Label 6856: @336032
    GIM_Try, /*On fail goto*//*Label 6857*/ GIMT_Encode4(336103), // Rule ID 9192 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(14),
      // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 14:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9192,
      GIR_EraseRootFromParent_Done,
    // Label 6857: @336103
    GIM_Reject,
    // Label 6784: @336104
    GIM_Try, /*On fail goto*//*Label 6858*/ GIMT_Encode4(336139), // Rule ID 9209 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
      // (extract_subvector:{ *:[nxv2f16] } nxv4f16:{ *:[nxv4f16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f16] } ZPR:{ *:[nxv4f16] }:$Zs)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Zs
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9209,
      GIR_EraseRootFromParent_Done,
    // Label 6858: @336139
    GIM_Try, /*On fail goto*//*Label 6859*/ GIMT_Encode4(336174), // Rule ID 9210 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
      // (extract_subvector:{ *:[nxv2f16] } nxv4f16:{ *:[nxv4f16] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f16] } ZPR:{ *:[nxv4f16] }:$Zs)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Zs
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9210,
      GIR_EraseRootFromParent_Done,
    // Label 6859: @336174
    GIM_Try, /*On fail goto*//*Label 6860*/ GIMT_Encode4(336209), // Rule ID 9215 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
      // (extract_subvector:{ *:[nxv2bf16] } nxv4bf16:{ *:[nxv4bf16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2bf16] } ZPR:{ *:[nxv4bf16] }:$Zs)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Zs
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9215,
      GIR_EraseRootFromParent_Done,
    // Label 6860: @336209
    GIM_Try, /*On fail goto*//*Label 6861*/ GIMT_Encode4(336244), // Rule ID 9216 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
      // (extract_subvector:{ *:[nxv2bf16] } nxv4bf16:{ *:[nxv4bf16] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2bf16] } ZPR:{ *:[nxv4bf16] }:$Zs)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Zs
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9216,
      GIR_EraseRootFromParent_Done,
    // Label 6861: @336244
    GIM_Try, /*On fail goto*//*Label 6862*/ GIMT_Encode4(336298), // Rule ID 9219 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
      // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f16] } (UUNPKLO_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9219,
      GIR_EraseRootFromParent_Done,
    // Label 6862: @336298
    GIM_Try, /*On fail goto*//*Label 6863*/ GIMT_Encode4(336352), // Rule ID 9220 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
      // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f16] } (UUNPKLO_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9220,
      GIR_EraseRootFromParent_Done,
    // Label 6863: @336352
    GIM_Try, /*On fail goto*//*Label 6864*/ GIMT_Encode4(336406), // Rule ID 9221 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
      // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 4:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f16] } (UUNPKHI_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9221,
      GIR_EraseRootFromParent_Done,
    // Label 6864: @336406
    GIM_Try, /*On fail goto*//*Label 6865*/ GIMT_Encode4(336460), // Rule ID 9222 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
      // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 6:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f16] } (UUNPKHI_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9222,
      GIR_EraseRootFromParent_Done,
    // Label 6865: @336460
    GIM_Try, /*On fail goto*//*Label 6866*/ GIMT_Encode4(336514), // Rule ID 9223 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
      // (extract_subvector:{ *:[nxv2bf16] } nxv8bf16:{ *:[nxv8bf16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2bf16] } (UUNPKLO_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8bf16] }:$Zs))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9223,
      GIR_EraseRootFromParent_Done,
    // Label 6866: @336514
    GIM_Try, /*On fail goto*//*Label 6867*/ GIMT_Encode4(336568), // Rule ID 9224 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
      // (extract_subvector:{ *:[nxv2bf16] } nxv8bf16:{ *:[nxv8bf16] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2bf16] } (UUNPKLO_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8bf16] }:$Zs))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9224,
      GIR_EraseRootFromParent_Done,
    // Label 6867: @336568
    GIM_Try, /*On fail goto*//*Label 6868*/ GIMT_Encode4(336622), // Rule ID 9225 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
      // (extract_subvector:{ *:[nxv2bf16] } nxv8bf16:{ *:[nxv8bf16] }:$Zs, 4:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2bf16] } (UUNPKHI_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8bf16] }:$Zs))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9225,
      GIR_EraseRootFromParent_Done,
    // Label 6868: @336622
    GIM_Try, /*On fail goto*//*Label 6869*/ GIMT_Encode4(336676), // Rule ID 9226 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
      // (extract_subvector:{ *:[nxv2bf16] } nxv8bf16:{ *:[nxv8bf16] }:$Zs, 6:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2bf16] } (UUNPKHI_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8bf16] }:$Zs))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9226,
      GIR_EraseRootFromParent_Done,
    // Label 6869: @336676
    GIM_Reject,
    // Label 6785: @336677
    GIM_Try, /*On fail goto*//*Label 6870*/ GIMT_Encode4(336746),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 6871*/ GIMT_Encode4(336717), // Rule ID 9213 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
        // (extract_subvector:{ *:[nxv2f32] } nxv4f32:{ *:[nxv4f32] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f32] } ZPR:{ *:[nxv4f32] }:$Zs)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Zs
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9213,
        GIR_EraseRootFromParent_Done,
      // Label 6871: @336717
      GIM_Try, /*On fail goto*//*Label 6872*/ GIMT_Encode4(336745), // Rule ID 9214 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
        // (extract_subvector:{ *:[nxv2f32] } nxv4f32:{ *:[nxv4f32] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f32] } ZPR:{ *:[nxv4f32] }:$Zs)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Zs
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9214,
        GIR_EraseRootFromParent_Done,
      // Label 6872: @336745
      GIM_Reject,
    // Label 6870: @336746
    GIM_Reject,
    // Label 6786: @336747
    GIM_Try, /*On fail goto*//*Label 6873*/ GIMT_Encode4(336782), // Rule ID 9161 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
      // (extract_subvector:{ *:[nxv4i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv4i1] } PPR:{ *:[nxv8i1] }:$Ps)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Ps
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9161,
      GIR_EraseRootFromParent_Done,
    // Label 6873: @336782
    GIM_Try, /*On fail goto*//*Label 6874*/ GIMT_Encode4(336817), // Rule ID 9162 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
      // (extract_subvector:{ *:[nxv4i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv4i1] } PPR:{ *:[nxv8i1] }:$Ps)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Ps
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9162,
      GIR_EraseRootFromParent_Done,
    // Label 6874: @336817
    GIM_Try, /*On fail goto*//*Label 6875*/ GIMT_Encode4(336871), // Rule ID 9173 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
      // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv4i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9173,
      GIR_EraseRootFromParent_Done,
    // Label 6875: @336871
    GIM_Try, /*On fail goto*//*Label 6876*/ GIMT_Encode4(336925), // Rule ID 9174 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
      // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv4i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9174,
      GIR_EraseRootFromParent_Done,
    // Label 6876: @336925
    GIM_Try, /*On fail goto*//*Label 6877*/ GIMT_Encode4(336979), // Rule ID 9175 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
      // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv4i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9175,
      GIR_EraseRootFromParent_Done,
    // Label 6877: @336979
    GIM_Try, /*On fail goto*//*Label 6878*/ GIMT_Encode4(337033), // Rule ID 9176 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // MIs[0] Operand 2
      GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(12),
      // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 12:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv4i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9176,
      GIR_EraseRootFromParent_Done,
    // Label 6878: @337033
    GIM_Reject,
    // Label 6787: @337034
    GIM_Try, /*On fail goto*//*Label 6879*/ GIMT_Encode4(337159),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 6880*/ GIMT_Encode4(337074), // Rule ID 9211 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
        // (extract_subvector:{ *:[nxv4f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_S:{ *:[nxv4f16] } ZPR:{ *:[nxv8f16] }:$Zs)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Zs
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9211,
        GIR_EraseRootFromParent_Done,
      // Label 6880: @337074
      GIM_Try, /*On fail goto*//*Label 6881*/ GIMT_Encode4(337102), // Rule ID 9212 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
        // (extract_subvector:{ *:[nxv4f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 4:{ *:[i64] })  =>  (UUNPKHI_ZZ_S:{ *:[nxv4f16] } ZPR:{ *:[nxv8f16] }:$Zs)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Zs
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9212,
        GIR_EraseRootFromParent_Done,
      // Label 6881: @337102
      GIM_Try, /*On fail goto*//*Label 6882*/ GIMT_Encode4(337130), // Rule ID 9217 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
        // (extract_subvector:{ *:[nxv4bf16] } nxv8bf16:{ *:[nxv8bf16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_S:{ *:[nxv4bf16] } ZPR:{ *:[nxv8bf16] }:$Zs)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Zs
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9217,
        GIR_EraseRootFromParent_Done,
      // Label 6882: @337130
      GIM_Try, /*On fail goto*//*Label 6883*/ GIMT_Encode4(337158), // Rule ID 9218 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
        // (extract_subvector:{ *:[nxv4bf16] } nxv8bf16:{ *:[nxv8bf16] }:$Zs, 4:{ *:[i64] })  =>  (UUNPKHI_ZZ_S:{ *:[nxv4bf16] } ZPR:{ *:[nxv8bf16] }:$Zs)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Zs
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9218,
        GIR_EraseRootFromParent_Done,
      // Label 6883: @337158
      GIM_Reject,
    // Label 6879: @337159
    GIM_Reject,
    // Label 6788: @337160
    GIM_Try, /*On fail goto*//*Label 6884*/ GIMT_Encode4(337229),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 6885*/ GIMT_Encode4(337200), // Rule ID 9163 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
        // (extract_subvector:{ *:[nxv8i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv8i1] } PPR:{ *:[nxv16i1] }:$Ps)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Ps
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9163,
        GIR_EraseRootFromParent_Done,
      // Label 6885: @337200
      GIM_Try, /*On fail goto*//*Label 6886*/ GIMT_Encode4(337228), // Rule ID 9164 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
        // (extract_subvector:{ *:[nxv8i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv8i1] } PPR:{ *:[nxv16i1] }:$Ps)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Ps
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9164,
        GIR_EraseRootFromParent_Done,
      // Label 6886: @337228
      GIM_Reject,
    // Label 6884: @337229
    GIM_Reject,
    // Label 6789: @337230
    GIM_Reject,
    // Label 85: @337231
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 6902*/ GIMT_Encode4(369083),
    /*GILLT_s64*//*Label 6887*/ GIMT_Encode4(337326), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 6888*/ GIMT_Encode4(338036),
    /*GILLT_v2s64*//*Label 6889*/ GIMT_Encode4(341567),
    /*GILLT_v4s16*//*Label 6890*/ GIMT_Encode4(344396),
    /*GILLT_v4s32*//*Label 6891*/ GIMT_Encode4(349745),
    /*GILLT_v8s8*//*Label 6892*/ GIMT_Encode4(352409),
    /*GILLT_v8s16*//*Label 6893*/ GIMT_Encode4(354253),
    /*GILLT_v16s8*//*Label 6894*/ GIMT_Encode4(358666), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s16*//*Label 6895*/ GIMT_Encode4(360246),
    /*GILLT_nxv2s32*//*Label 6896*/ GIMT_Encode4(360480),
    /*GILLT_nxv2s64*//*Label 6897*/ GIMT_Encode4(360605), GIMT_Encode4(0),
    /*GILLT_nxv4s16*//*Label 6898*/ GIMT_Encode4(362519),
    /*GILLT_nxv4s32*//*Label 6899*/ GIMT_Encode4(362807), GIMT_Encode4(0),
    /*GILLT_nxv8s16*//*Label 6900*/ GIMT_Encode4(364775), GIMT_Encode4(0),
    /*GILLT_nxv16s8*//*Label 6901*/ GIMT_Encode4(368033),
    // Label 6887: @337326
    GIM_Try, /*On fail goto*//*Label 6903*/ GIMT_Encode4(338035),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 6904*/ GIMT_Encode4(337474), // Rule ID 5794 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v1f64] } V64:{ *:[v1f64] }:$src, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5794,
        GIR_EraseRootFromParent_Done,
      // Label 6904: @337474
      GIM_Try, /*On fail goto*//*Label 6905*/ GIMT_Encode4(337635), // Rule ID 5795 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v1f64] } V64:{ *:[v1f64] }:$src, (vector_extract:{ *:[f64] } V64:{ *:[v1f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5795,
        GIR_EraseRootFromParent_Done,
      // Label 6905: @337635
      GIM_Try, /*On fail goto*//*Label 6906*/ GIMT_Encode4(337765), // Rule ID 5818 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v1i64] } V64:{ *:[v1i64] }:$src, (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5818,
        GIR_EraseRootFromParent_Done,
      // Label 6906: @337765
      GIM_Try, /*On fail goto*//*Label 6907*/ GIMT_Encode4(337926), // Rule ID 5819 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v1i64] } V64:{ *:[v1i64] }:$src, (vector_extract:{ *:[i64] } V64:{ *:[v1i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5819,
        GIR_EraseRootFromParent_Done,
      // Label 6907: @337926
      GIM_Try, /*On fail goto*//*Label 6908*/ GIMT_Encode4(337962), // Rule ID 6767 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v1i64] } (undef:{ *:[v1i64] }), GPR64:{ *:[i64] }:$Xn, 0:{ *:[i64] })  =>  (COPY_TO_REGCLASS:{ *:[v1i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Xn
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 6767,
        GIR_EraseRootFromParent_Done,
      // Label 6908: @337962
      GIM_Try, /*On fail goto*//*Label 6909*/ GIMT_Encode4(337998), // Rule ID 6769 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v1f64] } (undef:{ *:[v1f64] }), GPR64:{ *:[i64] }:$Xn, 0:{ *:[i64] })  =>  (COPY_TO_REGCLASS:{ *:[v1f64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/2, // Xn
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 6769,
        GIR_EraseRootFromParent_Done,
      // Label 6909: @337998
      GIM_Try, /*On fail goto*//*Label 6910*/ GIMT_Encode4(338034), // Rule ID 6771 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v1f64] } (undef:{ *:[v1f64] }), FPR64:{ *:[f64] }:$Xn, 0:{ *:[i64] })  =>  FPR64:{ *:[v1f64] }:$Xn
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // dst
        GIR_RootToRootCopy, /*OpIdx*/2, // Xn
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 6771,
        GIR_EraseRootFromParent_Done,
      // Label 6910: @338034
      GIM_Reject,
    // Label 6903: @338035
    GIM_Reject,
    // Label 6888: @338036
    GIM_Try, /*On fail goto*//*Label 6911*/ GIMT_Encode4(341566),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 6912*/ GIMT_Encode4(338163), // Rule ID 4260 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
        // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4260,
        GIR_EraseRootFromParent_Done,
      // Label 6912: @338163
      GIM_Try, /*On fail goto*//*Label 6913*/ GIMT_Encode4(338272), // Rule ID 4261 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
        // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4261,
        GIR_EraseRootFromParent_Done,
      // Label 6913: @338272
      GIM_Try, /*On fail goto*//*Label 6914*/ GIMT_Encode4(338381), // Rule ID 4404 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
        // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4404,
        GIR_EraseRootFromParent_Done,
      // Label 6914: @338381
      GIM_Try, /*On fail goto*//*Label 6915*/ GIMT_Encode4(338490), // Rule ID 4405 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
        // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4405,
        GIR_EraseRootFromParent_Done,
      // Label 6915: @338490
      GIM_Try, /*On fail goto*//*Label 6916*/ GIMT_Encode4(338595), // Rule ID 4266 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
        // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4266,
        GIR_EraseRootFromParent_Done,
      // Label 6916: @338595
      GIM_Try, /*On fail goto*//*Label 6917*/ GIMT_Encode4(338700), // Rule ID 4268 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
        // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4268,
        GIR_EraseRootFromParent_Done,
      // Label 6917: @338700
      GIM_Try, /*On fail goto*//*Label 6918*/ GIMT_Encode4(338805), // Rule ID 4410 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
        // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4410,
        GIR_EraseRootFromParent_Done,
      // Label 6918: @338805
      GIM_Try, /*On fail goto*//*Label 6919*/ GIMT_Encode4(338910), // Rule ID 4412 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
        // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4412,
        GIR_EraseRootFromParent_Done,
      // Label 6919: @338910
      GIM_Try, /*On fail goto*//*Label 6920*/ GIMT_Encode4(339014), // Rule ID 4258 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
        // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4258,
        GIR_EraseRootFromParent_Done,
      // Label 6920: @339014
      GIM_Try, /*On fail goto*//*Label 6921*/ GIMT_Encode4(339118), // Rule ID 4259 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
        // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4259,
        GIR_EraseRootFromParent_Done,
      // Label 6921: @339118
      GIM_Try, /*On fail goto*//*Label 6922*/ GIMT_Encode4(339222), // Rule ID 4402 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
        // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4402,
        GIR_EraseRootFromParent_Done,
      // Label 6922: @339222
      GIM_Try, /*On fail goto*//*Label 6923*/ GIMT_Encode4(339326), // Rule ID 4403 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
        // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4403,
        GIR_EraseRootFromParent_Done,
      // Label 6923: @339326
      GIM_Try, /*On fail goto*//*Label 6924*/ GIMT_Encode4(339426), // Rule ID 4262 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
        // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4262,
        GIR_EraseRootFromParent_Done,
      // Label 6924: @339426
      GIM_Try, /*On fail goto*//*Label 6925*/ GIMT_Encode4(339526), // Rule ID 4264 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
        // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4264,
        GIR_EraseRootFromParent_Done,
      // Label 6925: @339526
      GIM_Try, /*On fail goto*//*Label 6926*/ GIMT_Encode4(339626), // Rule ID 4406 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
        // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4406,
        GIR_EraseRootFromParent_Done,
      // Label 6926: @339626
      GIM_Try, /*On fail goto*//*Label 6927*/ GIMT_Encode4(339726), // Rule ID 4408 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
        // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4408,
        GIR_EraseRootFromParent_Done,
      // Label 6927: @339726
      GIM_Try, /*On fail goto*//*Label 6928*/ GIMT_Encode4(339846), // Rule ID 6503 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        // MIs[2] Rn
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (LD1i16:{ *:[f128] } (IMPLICIT_DEF:{ *:[v8i16] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 6503,
        GIR_EraseRootFromParent_Done,
      // Label 6928: @339846
      GIM_Try, /*On fail goto*//*Label 6929*/ GIMT_Encode4(339966), // Rule ID 6505 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        // MIs[2] Rn
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (LD1i8:{ *:[f128] } (IMPLICIT_DEF:{ *:[v16i8] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 6505,
        GIR_EraseRootFromParent_Done,
      // Label 6929: @339966
      GIM_Try, /*On fail goto*//*Label 6930*/ GIMT_Encode4(340096), // Rule ID 5788 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$src, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5788,
        GIR_EraseRootFromParent_Done,
      // Label 6930: @340096
      GIM_Try, /*On fail goto*//*Label 6931*/ GIMT_Encode4(340257), // Rule ID 5789 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$src, (vector_extract:{ *:[f32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5789,
        GIR_EraseRootFromParent_Done,
      // Label 6931: @340257
      GIM_Try, /*On fail goto*//*Label 6932*/ GIMT_Encode4(340387), // Rule ID 5812 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v2i32] } V64:{ *:[v2i32] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5812,
        GIR_EraseRootFromParent_Done,
      // Label 6932: @340387
      GIM_Try, /*On fail goto*//*Label 6933*/ GIMT_Encode4(340548), // Rule ID 5813 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v2i32] } V64:{ *:[v2i32] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5813,
        GIR_EraseRootFromParent_Done,
      // Label 6933: @340548
      GIM_Try, /*On fail goto*//*Label 6934*/ GIMT_Encode4(340614), // Rule ID 5731 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), FPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2i32] } (IMPLICIT_DEF:{ *:[v2i32] }), FPR32:{ *:[i32] }:$Rn, ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 5731,
        GIR_EraseRootFromParent_Done,
      // Label 6934: @340614
      GIM_Try, /*On fail goto*//*Label 6935*/ GIMT_Encode4(340680), // Rule ID 5747 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), FPR32:{ *:[f32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 5747,
        GIR_EraseRootFromParent_Done,
      // Label 6935: @340680
      GIM_Try, /*On fail goto*//*Label 6936*/ GIMT_Encode4(340815), // Rule ID 5755 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, WZR:{ *:[i32] }), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5755,
        GIR_EraseRootFromParent_Done,
      // Label 6936: @340815
      GIM_Try, /*On fail goto*//*Label 6937*/ GIMT_Encode4(340947), // Rule ID 6511 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        // MIs[1] Rn
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (vector_insert:{ *:[v2i32] } VecListOne64:{ *:[v2i32] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (LD1i32:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 6511,
        GIR_EraseRootFromParent_Done,
      // Label 6937: @340947
      GIM_Try, /*On fail goto*//*Label 6938*/ GIMT_Encode4(341079), // Rule ID 6512 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        // MIs[1] Rn
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (vector_insert:{ *:[v2f32] } VecListOne64:{ *:[v2f32] }:$Rd, (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (LD1i32:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 6512,
        GIR_EraseRootFromParent_Done,
      // Label 6938: @341079
      GIM_Try, /*On fail goto*//*Label 6939*/ GIMT_Encode4(341262), // Rule ID 5821 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (vector_insert:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$src, (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$Sn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), FPR32:{ *:[f32] }:$Sn, ssub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, // Sn
        GIR_AddImm8, /*InsnID*/4, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immd
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5821,
        GIR_EraseRootFromParent_Done,
      // Label 6939: @341262
      GIM_Try, /*On fail goto*//*Label 6940*/ GIMT_Encode4(341440), // Rule ID 5760 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_AddImm8, /*InsnID*/4, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5760,
        GIR_EraseRootFromParent_Done,
      // Label 6940: @341440
      GIM_Try, /*On fail goto*//*Label 6941*/ GIMT_Encode4(341565), // Rule ID 5763 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, GPR32:{ *:[i32] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5763,
        GIR_EraseRootFromParent_Done,
      // Label 6941: @341565
      GIM_Reject,
    // Label 6911: @341566
    GIM_Reject,
    // Label 6889: @341567
    GIM_Try, /*On fail goto*//*Label 6942*/ GIMT_Encode4(344395),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 6943*/ GIMT_Encode4(341694), // Rule ID 4284 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
        // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 4284,
        GIR_EraseRootFromParent_Done,
      // Label 6943: @341694
      GIM_Try, /*On fail goto*//*Label 6944*/ GIMT_Encode4(341803), // Rule ID 4285 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
        // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 4285,
        GIR_EraseRootFromParent_Done,
      // Label 6944: @341803
      GIM_Try, /*On fail goto*//*Label 6945*/ GIMT_Encode4(341912), // Rule ID 4428 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
        // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 4428,
        GIR_EraseRootFromParent_Done,
      // Label 6945: @341912
      GIM_Try, /*On fail goto*//*Label 6946*/ GIMT_Encode4(342021), // Rule ID 4429 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
        // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 4429,
        GIR_EraseRootFromParent_Done,
      // Label 6946: @342021
      GIM_Try, /*On fail goto*//*Label 6947*/ GIMT_Encode4(342126), // Rule ID 4290 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
        // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 4290,
        GIR_EraseRootFromParent_Done,
      // Label 6947: @342126
      GIM_Try, /*On fail goto*//*Label 6948*/ GIMT_Encode4(342231), // Rule ID 4292 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
        // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 4292,
        GIR_EraseRootFromParent_Done,
      // Label 6948: @342231
      GIM_Try, /*On fail goto*//*Label 6949*/ GIMT_Encode4(342336), // Rule ID 4434 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
        // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 4434,
        GIR_EraseRootFromParent_Done,
      // Label 6949: @342336
      GIM_Try, /*On fail goto*//*Label 6950*/ GIMT_Encode4(342441), // Rule ID 4436 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
        // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 4436,
        GIR_EraseRootFromParent_Done,
      // Label 6950: @342441
      GIM_Try, /*On fail goto*//*Label 6951*/ GIMT_Encode4(342545), // Rule ID 4282 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
        // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 4282,
        GIR_EraseRootFromParent_Done,
      // Label 6951: @342545
      GIM_Try, /*On fail goto*//*Label 6952*/ GIMT_Encode4(342649), // Rule ID 4283 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
        // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 4283,
        GIR_EraseRootFromParent_Done,
      // Label 6952: @342649
      GIM_Try, /*On fail goto*//*Label 6953*/ GIMT_Encode4(342753), // Rule ID 4426 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
        // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 4426,
        GIR_EraseRootFromParent_Done,
      // Label 6953: @342753
      GIM_Try, /*On fail goto*//*Label 6954*/ GIMT_Encode4(342857), // Rule ID 4427 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
        // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 4427,
        GIR_EraseRootFromParent_Done,
      // Label 6954: @342857
      GIM_Try, /*On fail goto*//*Label 6955*/ GIMT_Encode4(342957), // Rule ID 4286 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
        // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 4286,
        GIR_EraseRootFromParent_Done,
      // Label 6955: @342957
      GIM_Try, /*On fail goto*//*Label 6956*/ GIMT_Encode4(343057), // Rule ID 4288 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
        // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 4288,
        GIR_EraseRootFromParent_Done,
      // Label 6956: @343057
      GIM_Try, /*On fail goto*//*Label 6957*/ GIMT_Encode4(343157), // Rule ID 4430 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
        // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 4430,
        GIR_EraseRootFromParent_Done,
      // Label 6957: @343157
      GIM_Try, /*On fail goto*//*Label 6958*/ GIMT_Encode4(343257), // Rule ID 4432 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
        // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 4432,
        GIR_EraseRootFromParent_Done,
      // Label 6958: @343257
      GIM_Try, /*On fail goto*//*Label 6959*/ GIMT_Encode4(343335), // Rule ID 1930 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1930,
        GIR_EraseRootFromParent_Done,
      // Label 6959: @343335
      GIM_Try, /*On fail goto*//*Label 6960*/ GIMT_Encode4(343426), // Rule ID 7553 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
        // MIs[2] Rn
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15315>>), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LDAP1:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAP1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7553,
        GIR_EraseRootFromParent_Done,
      // Label 6960: @343426
      GIM_Try, /*On fail goto*//*Label 6961*/ GIMT_Encode4(343493), // Rule ID 5792 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5792,
        GIR_EraseRootFromParent_Done,
      // Label 6961: @343493
      GIM_Try, /*On fail goto*//*Label 6962*/ GIMT_Encode4(343591), // Rule ID 5793 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (vector_extract:{ *:[f64] } V64:{ *:[v1f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5793,
        GIR_EraseRootFromParent_Done,
      // Label 6962: @343591
      GIM_Try, /*On fail goto*//*Label 6963*/ GIMT_Encode4(343658), // Rule ID 5816 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5816,
        GIR_EraseRootFromParent_Done,
      // Label 6963: @343658
      GIM_Try, /*On fail goto*//*Label 6964*/ GIMT_Encode4(343756), // Rule ID 5817 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (vector_extract:{ *:[i64] } V64:{ *:[v1i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5817,
        GIR_EraseRootFromParent_Done,
      // Label 6964: @343756
      GIM_Try, /*On fail goto*//*Label 6965*/ GIMT_Encode4(343822), // Rule ID 5735 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), FPR64:{ *:[i64] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), FPR64:{ *:[i64] }:$Rn, dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 5735,
        GIR_EraseRootFromParent_Done,
      // Label 6965: @343822
      GIM_Try, /*On fail goto*//*Label 6966*/ GIMT_Encode4(343888), // Rule ID 5749 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), FPR64:{ *:[f64] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), FPR64:{ *:[f64] }:$Rn, dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 5749,
        GIR_EraseRootFromParent_Done,
      // Label 6966: @343888
      GIM_Try, /*On fail goto*//*Label 6967*/ GIMT_Encode4(343966), // Rule ID 7552 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
        GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
        GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
        // MIs[1] Rn
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (vector_insert:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15315>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LDAP1:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAP1),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7552,
        GIR_EraseRootFromParent_Done,
      // Label 6967: @343966
      GIM_Try, /*On fail goto*//*Label 6968*/ GIMT_Encode4(344035), // Rule ID 6493 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        // MIs[1] Rn
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (vector_insert:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LD1i64:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6493,
        GIR_EraseRootFromParent_Done,
      // Label 6968: @344035
      GIM_Try, /*On fail goto*//*Label 6969*/ GIMT_Encode4(344104), // Rule ID 6494 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        // MIs[1] Rn
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (vector_insert:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (ld:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LD1i64:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6494,
        GIR_EraseRootFromParent_Done,
      // Label 6969: @344104
      GIM_Try, /*On fail goto*//*Label 6970*/ GIMT_Encode4(344153), // Rule ID 5756 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (vector_insert:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)  =>  (INSvi64gpr:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, XZR:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64gpr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5756,
        GIR_EraseRootFromParent_Done,
      // Label 6970: @344153
      GIM_Try, /*On fail goto*//*Label 6971*/ GIMT_Encode4(344254), // Rule ID 5822 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (vector_insert:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$src, (bitconvert:{ *:[i64] } FPR64:{ *:[f64] }:$Sn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (imm:{ *:[i64] }):$Immd, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), FPR64:{ *:[f64] }:$Sn, dsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Sn
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5822,
        GIR_EraseRootFromParent_Done,
      // Label 6971: @344254
      GIM_Try, /*On fail goto*//*Label 6972*/ GIMT_Encode4(344298), // Rule ID 1926 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (INSvi64gpr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] }):$idx, GPR64:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64gpr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1926,
        GIR_EraseRootFromParent_Done,
      // Label 6972: @344298
      GIM_Try, /*On fail goto*//*Label 6973*/ GIMT_Encode4(344394), // Rule ID 5762 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)  =>  (INSvi64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm, (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5762,
        GIR_EraseRootFromParent_Done,
      // Label 6973: @344394
      GIM_Reject,
    // Label 6942: @344395
    GIM_Reject,
    // Label 6890: @344396
    GIM_Try, /*On fail goto*//*Label 6974*/ GIMT_Encode4(349744),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_Try, /*On fail goto*//*Label 6975*/ GIMT_Encode4(344523), // Rule ID 4332 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
        // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4332,
        GIR_EraseRootFromParent_Done,
      // Label 6975: @344523
      GIM_Try, /*On fail goto*//*Label 6976*/ GIMT_Encode4(344642), // Rule ID 4333 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
        // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4333,
        GIR_EraseRootFromParent_Done,
      // Label 6976: @344642
      GIM_Try, /*On fail goto*//*Label 6977*/ GIMT_Encode4(344761), // Rule ID 4368 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
        // (vector_insert:{ *:[v4bf16] } immAllZerosV:{ *:[v4bf16] }, (ld:{ *:[bf16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4bf16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4368,
        GIR_EraseRootFromParent_Done,
      // Label 6977: @344761
      GIM_Try, /*On fail goto*//*Label 6978*/ GIMT_Encode4(344880), // Rule ID 4369 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
        // (vector_insert:{ *:[v4bf16] } immAllZerosV:{ *:[v4bf16] }, (ld:{ *:[bf16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4bf16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4369,
        GIR_EraseRootFromParent_Done,
      // Label 6978: @344880
      GIM_Try, /*On fail goto*//*Label 6979*/ GIMT_Encode4(345006), // Rule ID 4224 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
        // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4224,
        GIR_EraseRootFromParent_Done,
      // Label 6979: @345006
      GIM_Try, /*On fail goto*//*Label 6980*/ GIMT_Encode4(345132), // Rule ID 4225 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
        // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4225,
        GIR_EraseRootFromParent_Done,
      // Label 6980: @345132
      GIM_Try, /*On fail goto*//*Label 6981*/ GIMT_Encode4(345247), // Rule ID 4338 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
        // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4338,
        GIR_EraseRootFromParent_Done,
      // Label 6981: @345247
      GIM_Try, /*On fail goto*//*Label 6982*/ GIMT_Encode4(345362), // Rule ID 4340 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
        // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4340,
        GIR_EraseRootFromParent_Done,
      // Label 6982: @345362
      GIM_Try, /*On fail goto*//*Label 6983*/ GIMT_Encode4(345477), // Rule ID 4374 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
        // (vector_insert:{ *:[v4bf16] } (undef:{ *:[v4bf16] }), (ld:{ *:[bf16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4bf16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4374,
        GIR_EraseRootFromParent_Done,
      // Label 6983: @345477
      GIM_Try, /*On fail goto*//*Label 6984*/ GIMT_Encode4(345592), // Rule ID 4376 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
        // (vector_insert:{ *:[v4bf16] } (undef:{ *:[v4bf16] }), (ld:{ *:[bf16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4bf16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4376,
        GIR_EraseRootFromParent_Done,
      // Label 6984: @345592
      GIM_Try, /*On fail goto*//*Label 6985*/ GIMT_Encode4(345714), // Rule ID 4230 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
        // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4230,
        GIR_EraseRootFromParent_Done,
      // Label 6985: @345714
      GIM_Try, /*On fail goto*//*Label 6986*/ GIMT_Encode4(345836), // Rule ID 4232 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
        // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4232,
        GIR_EraseRootFromParent_Done,
      // Label 6986: @345836
      GIM_Try, /*On fail goto*//*Label 6987*/ GIMT_Encode4(345950), // Rule ID 4330 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
        // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4330,
        GIR_EraseRootFromParent_Done,
      // Label 6987: @345950
      GIM_Try, /*On fail goto*//*Label 6988*/ GIMT_Encode4(346064), // Rule ID 4331 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
        // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4331,
        GIR_EraseRootFromParent_Done,
      // Label 6988: @346064
      GIM_Try, /*On fail goto*//*Label 6989*/ GIMT_Encode4(346178), // Rule ID 4366 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
        // (vector_insert:{ *:[v4bf16] } immAllZerosV:{ *:[v4bf16] }, (ld:{ *:[bf16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4bf16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4366,
        GIR_EraseRootFromParent_Done,
      // Label 6989: @346178
      GIM_Try, /*On fail goto*//*Label 6990*/ GIMT_Encode4(346292), // Rule ID 4367 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
        // (vector_insert:{ *:[v4bf16] } immAllZerosV:{ *:[v4bf16] }, (ld:{ *:[bf16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4bf16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4367,
        GIR_EraseRootFromParent_Done,
      // Label 6990: @346292
      GIM_Try, /*On fail goto*//*Label 6991*/ GIMT_Encode4(346413), // Rule ID 4222 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
        // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4222,
        GIR_EraseRootFromParent_Done,
      // Label 6991: @346413
      GIM_Try, /*On fail goto*//*Label 6992*/ GIMT_Encode4(346534), // Rule ID 4223 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
        // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4223,
        GIR_EraseRootFromParent_Done,
      // Label 6992: @346534
      GIM_Try, /*On fail goto*//*Label 6993*/ GIMT_Encode4(346644), // Rule ID 4334 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
        // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4334,
        GIR_EraseRootFromParent_Done,
      // Label 6993: @346644
      GIM_Try, /*On fail goto*//*Label 6994*/ GIMT_Encode4(346754), // Rule ID 4336 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
        // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4336,
        GIR_EraseRootFromParent_Done,
      // Label 6994: @346754
      GIM_Try, /*On fail goto*//*Label 6995*/ GIMT_Encode4(346864), // Rule ID 4370 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
        // (vector_insert:{ *:[v4bf16] } (undef:{ *:[v4bf16] }), (ld:{ *:[bf16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4bf16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4370,
        GIR_EraseRootFromParent_Done,
      // Label 6995: @346864
      GIM_Try, /*On fail goto*//*Label 6996*/ GIMT_Encode4(346974), // Rule ID 4372 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
        // (vector_insert:{ *:[v4bf16] } (undef:{ *:[v4bf16] }), (ld:{ *:[bf16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4bf16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4372,
        GIR_EraseRootFromParent_Done,
      // Label 6996: @346974
      GIM_Try, /*On fail goto*//*Label 6997*/ GIMT_Encode4(347091), // Rule ID 4226 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
        // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4226,
        GIR_EraseRootFromParent_Done,
      // Label 6997: @347091
      GIM_Try, /*On fail goto*//*Label 6998*/ GIMT_Encode4(347208), // Rule ID 4228 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
        // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4228,
        GIR_EraseRootFromParent_Done,
      // Label 6998: @347208
      GIM_Try, /*On fail goto*//*Label 6999*/ GIMT_Encode4(347338), // Rule ID 6507 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        // MIs[2] Rn
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (LD1i8:{ *:[f128] } (IMPLICIT_DEF:{ *:[v16i8] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 6507,
        GIR_EraseRootFromParent_Done,
      // Label 6999: @347338
      GIM_Try, /*On fail goto*//*Label 7000*/ GIMT_Encode4(347478), // Rule ID 5776 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$src, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5776,
        GIR_EraseRootFromParent_Done,
      // Label 7000: @347478
      GIM_Try, /*On fail goto*//*Label 7001*/ GIMT_Encode4(347649), // Rule ID 5777 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$src, (vector_extract:{ *:[f16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5777,
        GIR_EraseRootFromParent_Done,
      // Label 7001: @347649
      GIM_Try, /*On fail goto*//*Label 7002*/ GIMT_Encode4(347789), // Rule ID 5782 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v4bf16] } V64:{ *:[v4bf16] }:$src, (vector_extract:{ *:[bf16] } V128:{ *:[v8bf16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4bf16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4bf16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v8bf16] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5782,
        GIR_EraseRootFromParent_Done,
      // Label 7002: @347789
      GIM_Try, /*On fail goto*//*Label 7003*/ GIMT_Encode4(347960), // Rule ID 5783 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v4bf16] } V64:{ *:[v4bf16] }:$src, (vector_extract:{ *:[bf16] } V64:{ *:[v4bf16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4bf16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4bf16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4bf16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5783,
        GIR_EraseRootFromParent_Done,
      // Label 7003: @347960
      GIM_Try, /*On fail goto*//*Label 7004*/ GIMT_Encode4(348100), // Rule ID 5806 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v4i16] } V64:{ *:[v4i16] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5806,
        GIR_EraseRootFromParent_Done,
      // Label 7004: @348100
      GIM_Try, /*On fail goto*//*Label 7005*/ GIMT_Encode4(348271), // Rule ID 5807 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v4i16] } V64:{ *:[v4i16] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5807,
        GIR_EraseRootFromParent_Done,
      // Label 7005: @348271
      GIM_Try, /*On fail goto*//*Label 7006*/ GIMT_Encode4(348350), // Rule ID 5721 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 5721,
        GIR_EraseRootFromParent_Done,
      // Label 7006: @348350
      GIM_Try, /*On fail goto*//*Label 7007*/ GIMT_Encode4(348426), // Rule ID 5723 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 5723,
        GIR_EraseRootFromParent_Done,
      // Label 7007: @348426
      GIM_Try, /*On fail goto*//*Label 7008*/ GIMT_Encode4(348502), // Rule ID 5727 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v4bf16] } (undef:{ *:[v4bf16] }), FPR16:{ *:[bf16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4bf16] } (IMPLICIT_DEF:{ *:[v4bf16] }), FPR16:{ *:[bf16] }:$Rn, hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 5727,
        GIR_EraseRootFromParent_Done,
      // Label 7008: @348502
      GIM_Try, /*On fail goto*//*Label 7009*/ GIMT_Encode4(348578), // Rule ID 5737 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 5737,
        GIR_EraseRootFromParent_Done,
      // Label 7009: @348578
      GIM_Try, /*On fail goto*//*Label 7010*/ GIMT_Encode4(348654), // Rule ID 5741 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v4bf16] } (undef:{ *:[v4bf16] }), FPR16:{ *:[bf16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4bf16] } (IMPLICIT_DEF:{ *:[v4bf16] }), FPR16:{ *:[bf16] }:$Rn, hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 5741,
        GIR_EraseRootFromParent_Done,
      // Label 7010: @348654
      GIM_Try, /*On fail goto*//*Label 7011*/ GIMT_Encode4(348799), // Rule ID 5753 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, WZR:{ *:[i32] }), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5753,
        GIR_EraseRootFromParent_Done,
      // Label 7011: @348799
      GIM_Try, /*On fail goto*//*Label 7012*/ GIMT_Encode4(348941), // Rule ID 6513 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        // MIs[1] Rn
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (vector_insert:{ *:[v4f16] } VecListOne64:{ *:[v4f16] }:$Rd, (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (LD1i16:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4f16] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 6513,
        GIR_EraseRootFromParent_Done,
      // Label 7012: @348941
      GIM_Try, /*On fail goto*//*Label 7013*/ GIMT_Encode4(349083), // Rule ID 6514 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        // MIs[1] Rn
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (vector_insert:{ *:[v4bf16] } VecListOne64:{ *:[v4bf16] }:$Rd, (ld:{ *:[bf16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v4bf16] } (LD1i16:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4bf16] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 6514,
        GIR_EraseRootFromParent_Done,
      // Label 7013: @349083
      GIM_Try, /*On fail goto*//*Label 7014*/ GIMT_Encode4(349232), // Rule ID 6510 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        // MIs[1] Rn
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (vector_insert:{ *:[v4i16] } VecListOne64:{ *:[v4i16] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (LD1i16:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 6510,
        GIR_EraseRootFromParent_Done,
      // Label 7014: @349232
      GIM_Try, /*On fail goto*//*Label 7015*/ GIMT_Encode4(349420), // Rule ID 5751 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5751,
        GIR_EraseRootFromParent_Done,
      // Label 7015: @349420
      GIM_Try, /*On fail goto*//*Label 7016*/ GIMT_Encode4(349608), // Rule ID 5758 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v4bf16] } V64:{ *:[v4bf16] }:$Rn, FPR16:{ *:[bf16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v4bf16] } (INSvi16lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v8bf16] } (IMPLICIT_DEF:{ *:[v8bf16] }), V64:{ *:[v4bf16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, (INSERT_SUBREG:{ *:[v8bf16] } (IMPLICIT_DEF:{ *:[v8bf16] }), FPR16:{ *:[bf16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5758,
        GIR_EraseRootFromParent_Done,
      // Label 7016: @349608
      GIM_Try, /*On fail goto*//*Label 7017*/ GIMT_Encode4(349743), // Rule ID 5764 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (INSvi16gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, GPR32:{ *:[i32] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5764,
        GIR_EraseRootFromParent_Done,
      // Label 7017: @349743
      GIM_Reject,
    // Label 6974: @349744
    GIM_Reject,
    // Label 6891: @349745
    GIM_Try, /*On fail goto*//*Label 7018*/ GIMT_Encode4(352408),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 7019*/ GIMT_Encode4(349872), // Rule ID 4248 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
        // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4248,
        GIR_EraseRootFromParent_Done,
      // Label 7019: @349872
      GIM_Try, /*On fail goto*//*Label 7020*/ GIMT_Encode4(349981), // Rule ID 4249 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
        // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4249,
        GIR_EraseRootFromParent_Done,
      // Label 7020: @349981
      GIM_Try, /*On fail goto*//*Label 7021*/ GIMT_Encode4(350090), // Rule ID 4392 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
        // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4392,
        GIR_EraseRootFromParent_Done,
      // Label 7021: @350090
      GIM_Try, /*On fail goto*//*Label 7022*/ GIMT_Encode4(350199), // Rule ID 4393 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
        // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4393,
        GIR_EraseRootFromParent_Done,
      // Label 7022: @350199
      GIM_Try, /*On fail goto*//*Label 7023*/ GIMT_Encode4(350304), // Rule ID 4254 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
        // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4254,
        GIR_EraseRootFromParent_Done,
      // Label 7023: @350304
      GIM_Try, /*On fail goto*//*Label 7024*/ GIMT_Encode4(350409), // Rule ID 4256 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
        // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4256,
        GIR_EraseRootFromParent_Done,
      // Label 7024: @350409
      GIM_Try, /*On fail goto*//*Label 7025*/ GIMT_Encode4(350514), // Rule ID 4398 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
        // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4398,
        GIR_EraseRootFromParent_Done,
      // Label 7025: @350514
      GIM_Try, /*On fail goto*//*Label 7026*/ GIMT_Encode4(350619), // Rule ID 4400 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
        // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4400,
        GIR_EraseRootFromParent_Done,
      // Label 7026: @350619
      GIM_Try, /*On fail goto*//*Label 7027*/ GIMT_Encode4(350723), // Rule ID 4246 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
        // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4246,
        GIR_EraseRootFromParent_Done,
      // Label 7027: @350723
      GIM_Try, /*On fail goto*//*Label 7028*/ GIMT_Encode4(350827), // Rule ID 4247 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
        // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4247,
        GIR_EraseRootFromParent_Done,
      // Label 7028: @350827
      GIM_Try, /*On fail goto*//*Label 7029*/ GIMT_Encode4(350931), // Rule ID 4390 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
        // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4390,
        GIR_EraseRootFromParent_Done,
      // Label 7029: @350931
      GIM_Try, /*On fail goto*//*Label 7030*/ GIMT_Encode4(351035), // Rule ID 4391 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
        // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4391,
        GIR_EraseRootFromParent_Done,
      // Label 7030: @351035
      GIM_Try, /*On fail goto*//*Label 7031*/ GIMT_Encode4(351135), // Rule ID 4250 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
        // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4250,
        GIR_EraseRootFromParent_Done,
      // Label 7031: @351135
      GIM_Try, /*On fail goto*//*Label 7032*/ GIMT_Encode4(351235), // Rule ID 4252 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
        // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4252,
        GIR_EraseRootFromParent_Done,
      // Label 7032: @351235
      GIM_Try, /*On fail goto*//*Label 7033*/ GIMT_Encode4(351335), // Rule ID 4394 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
        // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4394,
        GIR_EraseRootFromParent_Done,
      // Label 7033: @351335
      GIM_Try, /*On fail goto*//*Label 7034*/ GIMT_Encode4(351435), // Rule ID 4396 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
        // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4396,
        GIR_EraseRootFromParent_Done,
      // Label 7034: @351435
      GIM_Try, /*On fail goto*//*Label 7035*/ GIMT_Encode4(351513), // Rule ID 1929 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1929,
        GIR_EraseRootFromParent_Done,
      // Label 7035: @351513
      GIM_Try, /*On fail goto*//*Label 7036*/ GIMT_Encode4(351580), // Rule ID 5786 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5786,
        GIR_EraseRootFromParent_Done,
      // Label 7036: @351580
      GIM_Try, /*On fail goto*//*Label 7037*/ GIMT_Encode4(351678), // Rule ID 5787 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (vector_extract:{ *:[f32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5787,
        GIR_EraseRootFromParent_Done,
      // Label 7037: @351678
      GIM_Try, /*On fail goto*//*Label 7038*/ GIMT_Encode4(351745), // Rule ID 5810 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5810,
        GIR_EraseRootFromParent_Done,
      // Label 7038: @351745
      GIM_Try, /*On fail goto*//*Label 7039*/ GIMT_Encode4(351843), // Rule ID 5811 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5811,
        GIR_EraseRootFromParent_Done,
      // Label 7039: @351843
      GIM_Try, /*On fail goto*//*Label 7040*/ GIMT_Encode4(351909), // Rule ID 5733 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), FPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[i32] }:$Rn, ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 5733,
        GIR_EraseRootFromParent_Done,
      // Label 7040: @351909
      GIM_Try, /*On fail goto*//*Label 7041*/ GIMT_Encode4(351975), // Rule ID 5745 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 5745,
        GIR_EraseRootFromParent_Done,
      // Label 7041: @351975
      GIM_Try, /*On fail goto*//*Label 7042*/ GIMT_Encode4(352028), // Rule ID 5754 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (INSvi32gpr:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, WZR:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5754,
        GIR_EraseRootFromParent_Done,
      // Label 7042: @352028
      GIM_Try, /*On fail goto*//*Label 7043*/ GIMT_Encode4(352097), // Rule ID 6491 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        // MIs[1] Rn
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (vector_insert:{ *:[v4i32] } VecListOne128:{ *:[v4i32] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (LD1i32:{ *:[v4i32] } VecListOne128:{ *:[v4i32] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6491,
        GIR_EraseRootFromParent_Done,
      // Label 7043: @352097
      GIM_Try, /*On fail goto*//*Label 7044*/ GIMT_Encode4(352166), // Rule ID 6492 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        // MIs[1] Rn
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (vector_insert:{ *:[v4f32] } VecListOne128:{ *:[v4f32] }:$Rd, (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (LD1i32:{ *:[v4f32] } VecListOne128:{ *:[v4f32] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6492,
        GIR_EraseRootFromParent_Done,
      // Label 7044: @352166
      GIM_Try, /*On fail goto*//*Label 7045*/ GIMT_Encode4(352267), // Rule ID 5820 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (vector_insert:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src, (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$Sn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (imm:{ *:[i64] }):$Immd, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), FPR32:{ *:[f32] }:$Sn, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Sn
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5820,
        GIR_EraseRootFromParent_Done,
      // Label 7045: @352267
      GIM_Try, /*On fail goto*//*Label 7046*/ GIMT_Encode4(352311), // Rule ID 1925 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (INSvi32gpr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (imm:{ *:[i64] }):$idx, GPR32:{ *:[i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1925,
        GIR_EraseRootFromParent_Done,
      // Label 7046: @352311
      GIM_Try, /*On fail goto*//*Label 7047*/ GIMT_Encode4(352407), // Rule ID 5761 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (INSvi32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5761,
        GIR_EraseRootFromParent_Done,
      // Label 7047: @352407
      GIM_Reject,
    // Label 7018: @352408
    GIM_Reject,
    // Label 6892: @352409
    GIM_Try, /*On fail goto*//*Label 7048*/ GIMT_Encode4(354252),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_Try, /*On fail goto*//*Label 7049*/ GIMT_Encode4(352543), // Rule ID 4188 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
        // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
        // GIR_Coverage, 4188,
        GIR_EraseRootFromParent_Done,
      // Label 7049: @352543
      GIM_Try, /*On fail goto*//*Label 7050*/ GIMT_Encode4(352669), // Rule ID 4189 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
        // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
        // GIR_Coverage, 4189,
        GIR_EraseRootFromParent_Done,
      // Label 7050: @352669
      GIM_Try, /*On fail goto*//*Label 7051*/ GIMT_Encode4(352791), // Rule ID 4194 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
        // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
        // GIR_Coverage, 4194,
        GIR_EraseRootFromParent_Done,
      // Label 7051: @352791
      GIM_Try, /*On fail goto*//*Label 7052*/ GIMT_Encode4(352913), // Rule ID 4196 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
        // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
        // GIR_Coverage, 4196,
        GIR_EraseRootFromParent_Done,
      // Label 7052: @352913
      GIM_Try, /*On fail goto*//*Label 7053*/ GIMT_Encode4(353034), // Rule ID 4186 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
        // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
        // GIR_Coverage, 4186,
        GIR_EraseRootFromParent_Done,
      // Label 7053: @353034
      GIM_Try, /*On fail goto*//*Label 7054*/ GIMT_Encode4(353155), // Rule ID 4187 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
        // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
        // GIR_Coverage, 4187,
        GIR_EraseRootFromParent_Done,
      // Label 7054: @353155
      GIM_Try, /*On fail goto*//*Label 7055*/ GIMT_Encode4(353272), // Rule ID 4190 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
        // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
        // GIR_Coverage, 4190,
        GIR_EraseRootFromParent_Done,
      // Label 7055: @353272
      GIM_Try, /*On fail goto*//*Label 7056*/ GIMT_Encode4(353389), // Rule ID 4192 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
        // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
        // GIR_Coverage, 4192,
        GIR_EraseRootFromParent_Done,
      // Label 7056: @353389
      GIM_Try, /*On fail goto*//*Label 7057*/ GIMT_Encode4(353529), // Rule ID 5800 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5800,
        GIR_EraseRootFromParent_Done,
      // Label 7057: @353529
      GIM_Try, /*On fail goto*//*Label 7058*/ GIMT_Encode4(353700), // Rule ID 5801 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5801,
        GIR_EraseRootFromParent_Done,
      // Label 7058: @353700
      GIM_Try, /*On fail goto*//*Label 7059*/ GIMT_Encode4(353779), // Rule ID 5716 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 5716,
        GIR_EraseRootFromParent_Done,
      // Label 7059: @353779
      GIM_Try, /*On fail goto*//*Label 7060*/ GIMT_Encode4(353928), // Rule ID 6509 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        // MIs[1] Rn
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (vector_insert:{ *:[v8i8] } VecListOne64:{ *:[v8i8] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (LD1i8:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 6509,
        GIR_EraseRootFromParent_Done,
      // Label 7060: @353928
      GIM_Try, /*On fail goto*//*Label 7061*/ GIMT_Encode4(354063), // Rule ID 5765 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm, GPR32:{ *:[i32] }:$Rm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8gpr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5765,
        GIR_EraseRootFromParent_Done,
      // Label 7061: @354063
      GIM_Try, /*On fail goto*//*Label 7062*/ GIMT_Encode4(354251), // Rule ID 5766 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, FPR8:{ *:[i8] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm, (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), FPR8:{ *:[i8] }:$Rm, bsub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5766,
        GIR_EraseRootFromParent_Done,
      // Label 7062: @354251
      GIM_Reject,
    // Label 7048: @354252
    GIM_Reject,
    // Label 6893: @354253
    GIM_Try, /*On fail goto*//*Label 7063*/ GIMT_Encode4(358665),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_Try, /*On fail goto*//*Label 7064*/ GIMT_Encode4(354380), // Rule ID 4320 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
        // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4320,
        GIR_EraseRootFromParent_Done,
      // Label 7064: @354380
      GIM_Try, /*On fail goto*//*Label 7065*/ GIMT_Encode4(354499), // Rule ID 4321 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
        // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4321,
        GIR_EraseRootFromParent_Done,
      // Label 7065: @354499
      GIM_Try, /*On fail goto*//*Label 7066*/ GIMT_Encode4(354618), // Rule ID 4356 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
        // (vector_insert:{ *:[v8bf16] } immAllZerosV:{ *:[v8bf16] }, (ld:{ *:[bf16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8bf16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4356,
        GIR_EraseRootFromParent_Done,
      // Label 7066: @354618
      GIM_Try, /*On fail goto*//*Label 7067*/ GIMT_Encode4(354737), // Rule ID 4357 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
        // (vector_insert:{ *:[v8bf16] } immAllZerosV:{ *:[v8bf16] }, (ld:{ *:[bf16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8bf16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4357,
        GIR_EraseRootFromParent_Done,
      // Label 7067: @354737
      GIM_Try, /*On fail goto*//*Label 7068*/ GIMT_Encode4(354863), // Rule ID 4212 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
        // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4212,
        GIR_EraseRootFromParent_Done,
      // Label 7068: @354863
      GIM_Try, /*On fail goto*//*Label 7069*/ GIMT_Encode4(354989), // Rule ID 4213 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
        // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4213,
        GIR_EraseRootFromParent_Done,
      // Label 7069: @354989
      GIM_Try, /*On fail goto*//*Label 7070*/ GIMT_Encode4(355104), // Rule ID 4326 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
        // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4326,
        GIR_EraseRootFromParent_Done,
      // Label 7070: @355104
      GIM_Try, /*On fail goto*//*Label 7071*/ GIMT_Encode4(355219), // Rule ID 4328 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
        // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4328,
        GIR_EraseRootFromParent_Done,
      // Label 7071: @355219
      GIM_Try, /*On fail goto*//*Label 7072*/ GIMT_Encode4(355334), // Rule ID 4362 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
        // (vector_insert:{ *:[v8bf16] } (undef:{ *:[v8bf16] }), (ld:{ *:[bf16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8bf16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4362,
        GIR_EraseRootFromParent_Done,
      // Label 7072: @355334
      GIM_Try, /*On fail goto*//*Label 7073*/ GIMT_Encode4(355449), // Rule ID 4364 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
        // (vector_insert:{ *:[v8bf16] } (undef:{ *:[v8bf16] }), (ld:{ *:[bf16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8bf16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4364,
        GIR_EraseRootFromParent_Done,
      // Label 7073: @355449
      GIM_Try, /*On fail goto*//*Label 7074*/ GIMT_Encode4(355571), // Rule ID 4218 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
        // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4218,
        GIR_EraseRootFromParent_Done,
      // Label 7074: @355571
      GIM_Try, /*On fail goto*//*Label 7075*/ GIMT_Encode4(355693), // Rule ID 4220 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
        // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4220,
        GIR_EraseRootFromParent_Done,
      // Label 7075: @355693
      GIM_Try, /*On fail goto*//*Label 7076*/ GIMT_Encode4(355807), // Rule ID 4318 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
        // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4318,
        GIR_EraseRootFromParent_Done,
      // Label 7076: @355807
      GIM_Try, /*On fail goto*//*Label 7077*/ GIMT_Encode4(355921), // Rule ID 4319 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
        // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4319,
        GIR_EraseRootFromParent_Done,
      // Label 7077: @355921
      GIM_Try, /*On fail goto*//*Label 7078*/ GIMT_Encode4(356035), // Rule ID 4354 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
        // (vector_insert:{ *:[v8bf16] } immAllZerosV:{ *:[v8bf16] }, (ld:{ *:[bf16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8bf16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4354,
        GIR_EraseRootFromParent_Done,
      // Label 7078: @356035
      GIM_Try, /*On fail goto*//*Label 7079*/ GIMT_Encode4(356149), // Rule ID 4355 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
        // (vector_insert:{ *:[v8bf16] } immAllZerosV:{ *:[v8bf16] }, (ld:{ *:[bf16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8bf16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4355,
        GIR_EraseRootFromParent_Done,
      // Label 7079: @356149
      GIM_Try, /*On fail goto*//*Label 7080*/ GIMT_Encode4(356270), // Rule ID 4210 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
        // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4210,
        GIR_EraseRootFromParent_Done,
      // Label 7080: @356270
      GIM_Try, /*On fail goto*//*Label 7081*/ GIMT_Encode4(356391), // Rule ID 4211 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
        // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4211,
        GIR_EraseRootFromParent_Done,
      // Label 7081: @356391
      GIM_Try, /*On fail goto*//*Label 7082*/ GIMT_Encode4(356501), // Rule ID 4322 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
        // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4322,
        GIR_EraseRootFromParent_Done,
      // Label 7082: @356501
      GIM_Try, /*On fail goto*//*Label 7083*/ GIMT_Encode4(356611), // Rule ID 4324 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
        // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4324,
        GIR_EraseRootFromParent_Done,
      // Label 7083: @356611
      GIM_Try, /*On fail goto*//*Label 7084*/ GIMT_Encode4(356721), // Rule ID 4358 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
        // (vector_insert:{ *:[v8bf16] } (undef:{ *:[v8bf16] }), (ld:{ *:[bf16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8bf16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4358,
        GIR_EraseRootFromParent_Done,
      // Label 7084: @356721
      GIM_Try, /*On fail goto*//*Label 7085*/ GIMT_Encode4(356831), // Rule ID 4360 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
        // (vector_insert:{ *:[v8bf16] } (undef:{ *:[v8bf16] }), (ld:{ *:[bf16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8bf16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4360,
        GIR_EraseRootFromParent_Done,
      // Label 7085: @356831
      GIM_Try, /*On fail goto*//*Label 7086*/ GIMT_Encode4(356948), // Rule ID 4214 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
        // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4214,
        GIR_EraseRootFromParent_Done,
      // Label 7086: @356948
      GIM_Try, /*On fail goto*//*Label 7087*/ GIMT_Encode4(357065), // Rule ID 4216 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
        // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4216,
        GIR_EraseRootFromParent_Done,
      // Label 7087: @357065
      GIM_Try, /*On fail goto*//*Label 7088*/ GIMT_Encode4(357153), // Rule ID 1928 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1928,
        GIR_EraseRootFromParent_Done,
      // Label 7088: @357153
      GIM_Try, /*On fail goto*//*Label 7089*/ GIMT_Encode4(357230), // Rule ID 5774 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5774,
        GIR_EraseRootFromParent_Done,
      // Label 7089: @357230
      GIM_Try, /*On fail goto*//*Label 7090*/ GIMT_Encode4(357338), // Rule ID 5775 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (vector_extract:{ *:[f16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5775,
        GIR_EraseRootFromParent_Done,
      // Label 7090: @357338
      GIM_Try, /*On fail goto*//*Label 7091*/ GIMT_Encode4(357415), // Rule ID 5780 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$src, (vector_extract:{ *:[bf16] } V128:{ *:[v8bf16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v8bf16] }:$Rn, (imm:{ *:[i64] }):$Immn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5780,
        GIR_EraseRootFromParent_Done,
      // Label 7091: @357415
      GIM_Try, /*On fail goto*//*Label 7092*/ GIMT_Encode4(357523), // Rule ID 5781 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$src, (vector_extract:{ *:[bf16] } V64:{ *:[v4bf16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4bf16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5781,
        GIR_EraseRootFromParent_Done,
      // Label 7092: @357523
      GIM_Try, /*On fail goto*//*Label 7093*/ GIMT_Encode4(357600), // Rule ID 5804 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5804,
        GIR_EraseRootFromParent_Done,
      // Label 7093: @357600
      GIM_Try, /*On fail goto*//*Label 7094*/ GIMT_Encode4(357708), // Rule ID 5805 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5805,
        GIR_EraseRootFromParent_Done,
      // Label 7094: @357708
      GIM_Try, /*On fail goto*//*Label 7095*/ GIMT_Encode4(357787), // Rule ID 5719 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 5719,
        GIR_EraseRootFromParent_Done,
      // Label 7095: @357787
      GIM_Try, /*On fail goto*//*Label 7096*/ GIMT_Encode4(357863), // Rule ID 5725 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 5725,
        GIR_EraseRootFromParent_Done,
      // Label 7096: @357863
      GIM_Try, /*On fail goto*//*Label 7097*/ GIMT_Encode4(357939), // Rule ID 5729 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v8bf16] } (undef:{ *:[v8bf16] }), FPR16:{ *:[bf16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8bf16] } (IMPLICIT_DEF:{ *:[v8bf16] }), FPR16:{ *:[bf16] }:$Rn, hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 5729,
        GIR_EraseRootFromParent_Done,
      // Label 7097: @357939
      GIM_Try, /*On fail goto*//*Label 7098*/ GIMT_Encode4(358015), // Rule ID 5739 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 5739,
        GIR_EraseRootFromParent_Done,
      // Label 7098: @358015
      GIM_Try, /*On fail goto*//*Label 7099*/ GIMT_Encode4(358091), // Rule ID 5743 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v8bf16] } (undef:{ *:[v8bf16] }), FPR16:{ *:[bf16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8bf16] } (IMPLICIT_DEF:{ *:[v8bf16] }), FPR16:{ *:[bf16] }:$Rn, hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 5743,
        GIR_EraseRootFromParent_Done,
      // Label 7099: @358091
      GIM_Try, /*On fail goto*//*Label 7100*/ GIMT_Encode4(358154), // Rule ID 5752 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (INSvi16gpr:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, WZR:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5752,
        GIR_EraseRootFromParent_Done,
      // Label 7100: @358154
      GIM_Try, /*On fail goto*//*Label 7101*/ GIMT_Encode4(358233), // Rule ID 6495 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        // MIs[1] Rn
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (vector_insert:{ *:[v8f16] } VecListOne128:{ *:[v8f16] }:$Rd, (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (LD1i16:{ *:[v8f16] } VecListOne128:{ *:[v8f16] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6495,
        GIR_EraseRootFromParent_Done,
      // Label 7101: @358233
      GIM_Try, /*On fail goto*//*Label 7102*/ GIMT_Encode4(358312), // Rule ID 6496 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        // MIs[1] Rn
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (vector_insert:{ *:[v8bf16] } VecListOne128:{ *:[v8bf16] }:$Rd, (ld:{ *:[bf16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (LD1i16:{ *:[v8bf16] } VecListOne128:{ *:[v8bf16] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6496,
        GIR_EraseRootFromParent_Done,
      // Label 7102: @358312
      GIM_Try, /*On fail goto*//*Label 7103*/ GIMT_Encode4(358398), // Rule ID 6490 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        // MIs[1] Rn
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (vector_insert:{ *:[v8i16] } VecListOne128:{ *:[v8i16] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (LD1i16:{ *:[v8i16] } VecListOne128:{ *:[v8i16] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6490,
        GIR_EraseRootFromParent_Done,
      // Label 7103: @358398
      GIM_Try, /*On fail goto*//*Label 7104*/ GIMT_Encode4(358452), // Rule ID 1924 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (INSvi16gpr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (imm:{ *:[i64] }):$idx, GPR32:{ *:[i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1924,
        GIR_EraseRootFromParent_Done,
      // Label 7104: @358452
      GIM_Try, /*On fail goto*//*Label 7105*/ GIMT_Encode4(358558), // Rule ID 5757 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (INSvi16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5757,
        GIR_EraseRootFromParent_Done,
      // Label 7105: @358558
      GIM_Try, /*On fail goto*//*Label 7106*/ GIMT_Encode4(358664), // Rule ID 5759 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, FPR16:{ *:[bf16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (INSvi16lane:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, (INSERT_SUBREG:{ *:[v8bf16] } (IMPLICIT_DEF:{ *:[v8bf16] }), FPR16:{ *:[bf16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5759,
        GIR_EraseRootFromParent_Done,
      // Label 7106: @358664
      GIM_Reject,
    // Label 7063: @358665
    GIM_Reject,
    // Label 6894: @358666
    GIM_Try, /*On fail goto*//*Label 7107*/ GIMT_Encode4(360245),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_Try, /*On fail goto*//*Label 7108*/ GIMT_Encode4(358800), // Rule ID 4176 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
        // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
        // GIR_Coverage, 4176,
        GIR_EraseRootFromParent_Done,
      // Label 7108: @358800
      GIM_Try, /*On fail goto*//*Label 7109*/ GIMT_Encode4(358926), // Rule ID 4177 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
        // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
        // GIR_Coverage, 4177,
        GIR_EraseRootFromParent_Done,
      // Label 7109: @358926
      GIM_Try, /*On fail goto*//*Label 7110*/ GIMT_Encode4(359048), // Rule ID 4182 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
        // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
        // GIR_Coverage, 4182,
        GIR_EraseRootFromParent_Done,
      // Label 7110: @359048
      GIM_Try, /*On fail goto*//*Label 7111*/ GIMT_Encode4(359170), // Rule ID 4184 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
        // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
        // GIR_Coverage, 4184,
        GIR_EraseRootFromParent_Done,
      // Label 7111: @359170
      GIM_Try, /*On fail goto*//*Label 7112*/ GIMT_Encode4(359291), // Rule ID 4174 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
        // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
        // GIR_Coverage, 4174,
        GIR_EraseRootFromParent_Done,
      // Label 7112: @359291
      GIM_Try, /*On fail goto*//*Label 7113*/ GIMT_Encode4(359412), // Rule ID 4175 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
        // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
        // GIR_Coverage, 4175,
        GIR_EraseRootFromParent_Done,
      // Label 7113: @359412
      GIM_Try, /*On fail goto*//*Label 7114*/ GIMT_Encode4(359529), // Rule ID 4178 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
        // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
        // GIR_Coverage, 4178,
        GIR_EraseRootFromParent_Done,
      // Label 7114: @359529
      GIM_Try, /*On fail goto*//*Label 7115*/ GIMT_Encode4(359646), // Rule ID 4180 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
        // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
        // GIR_Coverage, 4180,
        GIR_EraseRootFromParent_Done,
      // Label 7115: @359646
      GIM_Try, /*On fail goto*//*Label 7116*/ GIMT_Encode4(359734), // Rule ID 1927 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1927,
        GIR_EraseRootFromParent_Done,
      // Label 7116: @359734
      GIM_Try, /*On fail goto*//*Label 7117*/ GIMT_Encode4(359811), // Rule ID 5798 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5798,
        GIR_EraseRootFromParent_Done,
      // Label 7117: @359811
      GIM_Try, /*On fail goto*//*Label 7118*/ GIMT_Encode4(359919), // Rule ID 5799 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5799,
        GIR_EraseRootFromParent_Done,
      // Label 7118: @359919
      GIM_Try, /*On fail goto*//*Label 7119*/ GIMT_Encode4(359998), // Rule ID 5714 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 5714,
        GIR_EraseRootFromParent_Done,
      // Label 7119: @359998
      GIM_Try, /*On fail goto*//*Label 7120*/ GIMT_Encode4(360084), // Rule ID 6489 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        // MIs[1] Rn
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (vector_insert:{ *:[v16i8] } VecListOne128:{ *:[v16i8] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (LD1i8:{ *:[v16i8] } VecListOne128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6489,
        GIR_EraseRootFromParent_Done,
      // Label 7120: @360084
      GIM_Try, /*On fail goto*//*Label 7121*/ GIMT_Encode4(360138), // Rule ID 1923 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (INSvi8gpr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] }):$idx, GPR32:{ *:[i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8gpr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1923,
        GIR_EraseRootFromParent_Done,
      // Label 7121: @360138
      GIM_Try, /*On fail goto*//*Label 7122*/ GIMT_Encode4(360244), // Rule ID 5767 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, FPR8:{ *:[i8] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm, (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), FPR8:{ *:[i8] }:$Rm, bsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5767,
        GIR_EraseRootFromParent_Done,
      // Label 7122: @360244
      GIM_Reject,
    // Label 7107: @360245
    GIM_Reject,
    // Label 6895: @360246
    GIM_Try, /*On fail goto*//*Label 7123*/ GIMT_Encode4(360479),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 7124*/ GIMT_Encode4(360375), // Rule ID 11462 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (vector_insert:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$vec, FPR16:{ *:[f16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv2f16] } ZPR:{ *:[nxv2f16] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$index)), ?:{ *:[f16] }:$src)
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
        GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/1, // vec
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11462,
        GIR_EraseRootFromParent_Done,
      // Label 7124: @360375
      GIM_Try, /*On fail goto*//*Label 7125*/ GIMT_Encode4(360478), // Rule ID 11465 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (vector_insert:{ *:[nxv2bf16] } nxv2bf16:{ *:[nxv2bf16] }:$vec, FPR16:{ *:[bf16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv2bf16] } ZPR:{ *:[nxv2bf16] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$index)), ?:{ *:[bf16] }:$src)
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
        GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/1, // vec
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11465,
        GIR_EraseRootFromParent_Done,
      // Label 7125: @360478
      GIM_Reject,
    // Label 7123: @360479
    GIM_Reject,
    // Label 6896: @360480
    GIM_Try, /*On fail goto*//*Label 7126*/ GIMT_Encode4(360604), // Rule ID 11468 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (vector_insert:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$vec, FPR32:{ *:[f32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_S:{ *:[nxv2f32] } ZPR:{ *:[nxv2f32] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$index)), ?:{ *:[f32] }:$src)
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
      GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_S),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
      GIR_RootToRootCopy, /*OpIdx*/1, // vec
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/2, // src
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 11468,
      GIR_EraseRootFromParent_Done,
    // Label 7126: @360604
    GIM_Reject,
    // Label 6897: @360605
    GIM_Try, /*On fail goto*//*Label 7127*/ GIMT_Encode4(362518),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 7128*/ GIMT_Encode4(360732), // Rule ID 4308 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
        // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 4308,
        GIR_EraseRootFromParent_Done,
      // Label 7128: @360732
      GIM_Try, /*On fail goto*//*Label 7129*/ GIMT_Encode4(360841), // Rule ID 4309 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
        // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 4309,
        GIR_EraseRootFromParent_Done,
      // Label 7129: @360841
      GIM_Try, /*On fail goto*//*Label 7130*/ GIMT_Encode4(360950), // Rule ID 4452 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
        // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 4452,
        GIR_EraseRootFromParent_Done,
      // Label 7130: @360950
      GIM_Try, /*On fail goto*//*Label 7131*/ GIMT_Encode4(361059), // Rule ID 4453 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
        // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 4453,
        GIR_EraseRootFromParent_Done,
      // Label 7131: @361059
      GIM_Try, /*On fail goto*//*Label 7132*/ GIMT_Encode4(361164), // Rule ID 4314 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
        // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 4314,
        GIR_EraseRootFromParent_Done,
      // Label 7132: @361164
      GIM_Try, /*On fail goto*//*Label 7133*/ GIMT_Encode4(361269), // Rule ID 4316 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
        // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 4316,
        GIR_EraseRootFromParent_Done,
      // Label 7133: @361269
      GIM_Try, /*On fail goto*//*Label 7134*/ GIMT_Encode4(361374), // Rule ID 4458 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
        // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 4458,
        GIR_EraseRootFromParent_Done,
      // Label 7134: @361374
      GIM_Try, /*On fail goto*//*Label 7135*/ GIMT_Encode4(361479), // Rule ID 4460 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
        // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 4460,
        GIR_EraseRootFromParent_Done,
      // Label 7135: @361479
      GIM_Try, /*On fail goto*//*Label 7136*/ GIMT_Encode4(361583), // Rule ID 4306 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
        // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 4306,
        GIR_EraseRootFromParent_Done,
      // Label 7136: @361583
      GIM_Try, /*On fail goto*//*Label 7137*/ GIMT_Encode4(361687), // Rule ID 4307 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
        // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 4307,
        GIR_EraseRootFromParent_Done,
      // Label 7137: @361687
      GIM_Try, /*On fail goto*//*Label 7138*/ GIMT_Encode4(361791), // Rule ID 4450 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
        // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 4450,
        GIR_EraseRootFromParent_Done,
      // Label 7138: @361791
      GIM_Try, /*On fail goto*//*Label 7139*/ GIMT_Encode4(361895), // Rule ID 4451 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
        // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 4451,
        GIR_EraseRootFromParent_Done,
      // Label 7139: @361895
      GIM_Try, /*On fail goto*//*Label 7140*/ GIMT_Encode4(361995), // Rule ID 4310 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
        // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 4310,
        GIR_EraseRootFromParent_Done,
      // Label 7140: @361995
      GIM_Try, /*On fail goto*//*Label 7141*/ GIMT_Encode4(362095), // Rule ID 4312 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
        // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 4312,
        GIR_EraseRootFromParent_Done,
      // Label 7141: @362095
      GIM_Try, /*On fail goto*//*Label 7142*/ GIMT_Encode4(362195), // Rule ID 4454 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
        // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 4454,
        GIR_EraseRootFromParent_Done,
      // Label 7142: @362195
      GIM_Try, /*On fail goto*//*Label 7143*/ GIMT_Encode4(362295), // Rule ID 4456 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
        // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 4456,
        GIR_EraseRootFromParent_Done,
      // Label 7143: @362295
      GIM_Try, /*On fail goto*//*Label 7144*/ GIMT_Encode4(362406), // Rule ID 11461 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (vector_insert:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$vec, GPR64:{ *:[i64] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_D:{ *:[nxv2i64] } ZPR:{ *:[nxv2i64] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$index)), GPR64:{ *:[i64] }:$src)
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
        GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/1, // vec
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11461,
        GIR_EraseRootFromParent_Done,
      // Label 7144: @362406
      GIM_Try, /*On fail goto*//*Label 7145*/ GIMT_Encode4(362517), // Rule ID 11470 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (vector_insert:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$vec, FPR64:{ *:[f64] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_D:{ *:[nxv2f64] } ZPR:{ *:[nxv2f64] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } ?:{ *:[i64] }:$index)), ?:{ *:[f64] }:$src)
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
        GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/1, // vec
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11470,
        GIR_EraseRootFromParent_Done,
      // Label 7145: @362517
      GIM_Reject,
    // Label 7127: @362518
    GIM_Reject,
    // Label 6898: @362519
    GIM_Try, /*On fail goto*//*Label 7146*/ GIMT_Encode4(362806),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 7147*/ GIMT_Encode4(362675), // Rule ID 11463 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (vector_insert:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$vec, FPR16:{ *:[f16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv4f16] } ZPR:{ *:[nxv4f16] }:$vec, (CMPEQ_PPzZZ_S:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_S:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_S:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[f16] }:$src)
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_S),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_S),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
        GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/1, // vec
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11463,
        GIR_EraseRootFromParent_Done,
      // Label 7147: @362675
      GIM_Try, /*On fail goto*//*Label 7148*/ GIMT_Encode4(362805), // Rule ID 11466 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (vector_insert:{ *:[nxv4bf16] } nxv4bf16:{ *:[nxv4bf16] }:$vec, FPR16:{ *:[bf16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv4bf16] } ZPR:{ *:[nxv4bf16] }:$vec, (CMPEQ_PPzZZ_S:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_S:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_S:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[bf16] }:$src)
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_S),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_S),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
        GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/1, // vec
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11466,
        GIR_EraseRootFromParent_Done,
      // Label 7148: @362805
      GIM_Reject,
    // Label 7146: @362806
    GIM_Reject,
    // Label 6899: @362807
    GIM_Try, /*On fail goto*//*Label 7149*/ GIMT_Encode4(364774),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 7150*/ GIMT_Encode4(362934), // Rule ID 4272 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
        // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4272,
        GIR_EraseRootFromParent_Done,
      // Label 7150: @362934
      GIM_Try, /*On fail goto*//*Label 7151*/ GIMT_Encode4(363043), // Rule ID 4273 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
        // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4273,
        GIR_EraseRootFromParent_Done,
      // Label 7151: @363043
      GIM_Try, /*On fail goto*//*Label 7152*/ GIMT_Encode4(363152), // Rule ID 4416 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
        // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4416,
        GIR_EraseRootFromParent_Done,
      // Label 7152: @363152
      GIM_Try, /*On fail goto*//*Label 7153*/ GIMT_Encode4(363261), // Rule ID 4417 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
        // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4417,
        GIR_EraseRootFromParent_Done,
      // Label 7153: @363261
      GIM_Try, /*On fail goto*//*Label 7154*/ GIMT_Encode4(363366), // Rule ID 4278 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
        // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4278,
        GIR_EraseRootFromParent_Done,
      // Label 7154: @363366
      GIM_Try, /*On fail goto*//*Label 7155*/ GIMT_Encode4(363471), // Rule ID 4280 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
        // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4280,
        GIR_EraseRootFromParent_Done,
      // Label 7155: @363471
      GIM_Try, /*On fail goto*//*Label 7156*/ GIMT_Encode4(363576), // Rule ID 4422 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
        // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4422,
        GIR_EraseRootFromParent_Done,
      // Label 7156: @363576
      GIM_Try, /*On fail goto*//*Label 7157*/ GIMT_Encode4(363681), // Rule ID 4424 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
        // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4424,
        GIR_EraseRootFromParent_Done,
      // Label 7157: @363681
      GIM_Try, /*On fail goto*//*Label 7158*/ GIMT_Encode4(363785), // Rule ID 4270 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
        // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4270,
        GIR_EraseRootFromParent_Done,
      // Label 7158: @363785
      GIM_Try, /*On fail goto*//*Label 7159*/ GIMT_Encode4(363889), // Rule ID 4271 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
        // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4271,
        GIR_EraseRootFromParent_Done,
      // Label 7159: @363889
      GIM_Try, /*On fail goto*//*Label 7160*/ GIMT_Encode4(363993), // Rule ID 4414 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
        // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4414,
        GIR_EraseRootFromParent_Done,
      // Label 7160: @363993
      GIM_Try, /*On fail goto*//*Label 7161*/ GIMT_Encode4(364097), // Rule ID 4415 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
        // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4415,
        GIR_EraseRootFromParent_Done,
      // Label 7161: @364097
      GIM_Try, /*On fail goto*//*Label 7162*/ GIMT_Encode4(364197), // Rule ID 4274 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
        // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4274,
        GIR_EraseRootFromParent_Done,
      // Label 7162: @364197
      GIM_Try, /*On fail goto*//*Label 7163*/ GIMT_Encode4(364297), // Rule ID 4276 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
        // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4276,
        GIR_EraseRootFromParent_Done,
      // Label 7163: @364297
      GIM_Try, /*On fail goto*//*Label 7164*/ GIMT_Encode4(364397), // Rule ID 4418 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
        // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4418,
        GIR_EraseRootFromParent_Done,
      // Label 7164: @364397
      GIM_Try, /*On fail goto*//*Label 7165*/ GIMT_Encode4(364497), // Rule ID 4420 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
        // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        // GIR_Coverage, 4420,
        GIR_EraseRootFromParent_Done,
      // Label 7165: @364497
      GIM_Try, /*On fail goto*//*Label 7166*/ GIMT_Encode4(364635), // Rule ID 11460 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (vector_insert:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$vec, GPR32:{ *:[i32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_S:{ *:[nxv4i32] } ZPR:{ *:[nxv4i32] }:$vec, (CMPEQ_PPzZZ_S:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_S:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_S:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), GPR32:{ *:[i32] }:$src)
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_S),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_S),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
        GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/1, // vec
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11460,
        GIR_EraseRootFromParent_Done,
      // Label 7166: @364635
      GIM_Try, /*On fail goto*//*Label 7167*/ GIMT_Encode4(364773), // Rule ID 11469 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (vector_insert:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$vec, FPR32:{ *:[f32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_S:{ *:[nxv4f32] } ZPR:{ *:[nxv4f32] }:$vec, (CMPEQ_PPzZZ_S:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_S:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_S:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[f32] }:$src)
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_S),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_S),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
        GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/1, // vec
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11469,
        GIR_EraseRootFromParent_Done,
      // Label 7167: @364773
      GIM_Reject,
    // Label 7149: @364774
    GIM_Reject,
    // Label 6900: @364775
    GIM_Try, /*On fail goto*//*Label 7168*/ GIMT_Encode4(368032),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_Try, /*On fail goto*//*Label 7169*/ GIMT_Encode4(364902), // Rule ID 4344 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
        // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4344,
        GIR_EraseRootFromParent_Done,
      // Label 7169: @364902
      GIM_Try, /*On fail goto*//*Label 7170*/ GIMT_Encode4(365021), // Rule ID 4345 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
        // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4345,
        GIR_EraseRootFromParent_Done,
      // Label 7170: @365021
      GIM_Try, /*On fail goto*//*Label 7171*/ GIMT_Encode4(365140), // Rule ID 4380 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
        // (vector_insert:{ *:[nxv8bf16] } immAllZerosV:{ *:[nxv8bf16] }, (ld:{ *:[bf16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8bf16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4380,
        GIR_EraseRootFromParent_Done,
      // Label 7171: @365140
      GIM_Try, /*On fail goto*//*Label 7172*/ GIMT_Encode4(365259), // Rule ID 4381 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
        // (vector_insert:{ *:[nxv8bf16] } immAllZerosV:{ *:[nxv8bf16] }, (ld:{ *:[bf16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8bf16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4381,
        GIR_EraseRootFromParent_Done,
      // Label 7172: @365259
      GIM_Try, /*On fail goto*//*Label 7173*/ GIMT_Encode4(365385), // Rule ID 4236 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
        // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4236,
        GIR_EraseRootFromParent_Done,
      // Label 7173: @365385
      GIM_Try, /*On fail goto*//*Label 7174*/ GIMT_Encode4(365511), // Rule ID 4237 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
        // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4237,
        GIR_EraseRootFromParent_Done,
      // Label 7174: @365511
      GIM_Try, /*On fail goto*//*Label 7175*/ GIMT_Encode4(365626), // Rule ID 4350 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
        // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4350,
        GIR_EraseRootFromParent_Done,
      // Label 7175: @365626
      GIM_Try, /*On fail goto*//*Label 7176*/ GIMT_Encode4(365741), // Rule ID 4352 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
        // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4352,
        GIR_EraseRootFromParent_Done,
      // Label 7176: @365741
      GIM_Try, /*On fail goto*//*Label 7177*/ GIMT_Encode4(365856), // Rule ID 4386 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
        // (vector_insert:{ *:[nxv8bf16] } (undef:{ *:[nxv8bf16] }), (ld:{ *:[bf16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8bf16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4386,
        GIR_EraseRootFromParent_Done,
      // Label 7177: @365856
      GIM_Try, /*On fail goto*//*Label 7178*/ GIMT_Encode4(365971), // Rule ID 4388 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
        // (vector_insert:{ *:[nxv8bf16] } (undef:{ *:[nxv8bf16] }), (ld:{ *:[bf16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8bf16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4388,
        GIR_EraseRootFromParent_Done,
      // Label 7178: @365971
      GIM_Try, /*On fail goto*//*Label 7179*/ GIMT_Encode4(366093), // Rule ID 4242 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
        // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4242,
        GIR_EraseRootFromParent_Done,
      // Label 7179: @366093
      GIM_Try, /*On fail goto*//*Label 7180*/ GIMT_Encode4(366215), // Rule ID 4244 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
        // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4244,
        GIR_EraseRootFromParent_Done,
      // Label 7180: @366215
      GIM_Try, /*On fail goto*//*Label 7181*/ GIMT_Encode4(366329), // Rule ID 4342 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
        // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4342,
        GIR_EraseRootFromParent_Done,
      // Label 7181: @366329
      GIM_Try, /*On fail goto*//*Label 7182*/ GIMT_Encode4(366443), // Rule ID 4343 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
        // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4343,
        GIR_EraseRootFromParent_Done,
      // Label 7182: @366443
      GIM_Try, /*On fail goto*//*Label 7183*/ GIMT_Encode4(366557), // Rule ID 4378 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
        // (vector_insert:{ *:[nxv8bf16] } immAllZerosV:{ *:[nxv8bf16] }, (ld:{ *:[bf16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8bf16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4378,
        GIR_EraseRootFromParent_Done,
      // Label 7183: @366557
      GIM_Try, /*On fail goto*//*Label 7184*/ GIMT_Encode4(366671), // Rule ID 4379 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
        // (vector_insert:{ *:[nxv8bf16] } immAllZerosV:{ *:[nxv8bf16] }, (ld:{ *:[bf16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8bf16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4379,
        GIR_EraseRootFromParent_Done,
      // Label 7184: @366671
      GIM_Try, /*On fail goto*//*Label 7185*/ GIMT_Encode4(366792), // Rule ID 4234 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
        // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4234,
        GIR_EraseRootFromParent_Done,
      // Label 7185: @366792
      GIM_Try, /*On fail goto*//*Label 7186*/ GIMT_Encode4(366913), // Rule ID 4235 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
        // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4235,
        GIR_EraseRootFromParent_Done,
      // Label 7186: @366913
      GIM_Try, /*On fail goto*//*Label 7187*/ GIMT_Encode4(367023), // Rule ID 4346 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
        // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4346,
        GIR_EraseRootFromParent_Done,
      // Label 7187: @367023
      GIM_Try, /*On fail goto*//*Label 7188*/ GIMT_Encode4(367133), // Rule ID 4348 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
        // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4348,
        GIR_EraseRootFromParent_Done,
      // Label 7188: @367133
      GIM_Try, /*On fail goto*//*Label 7189*/ GIMT_Encode4(367243), // Rule ID 4382 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
        // (vector_insert:{ *:[nxv8bf16] } (undef:{ *:[nxv8bf16] }), (ld:{ *:[bf16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8bf16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4382,
        GIR_EraseRootFromParent_Done,
      // Label 7189: @367243
      GIM_Try, /*On fail goto*//*Label 7190*/ GIMT_Encode4(367353), // Rule ID 4384 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
        // (vector_insert:{ *:[nxv8bf16] } (undef:{ *:[nxv8bf16] }), (ld:{ *:[bf16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8bf16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4384,
        GIR_EraseRootFromParent_Done,
      // Label 7190: @367353
      GIM_Try, /*On fail goto*//*Label 7191*/ GIMT_Encode4(367470), // Rule ID 4238 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
        // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4238,
        GIR_EraseRootFromParent_Done,
      // Label 7191: @367470
      GIM_Try, /*On fail goto*//*Label 7192*/ GIMT_Encode4(367587), // Rule ID 4240 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
        // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        // GIR_Coverage, 4240,
        GIR_EraseRootFromParent_Done,
      // Label 7192: @367587
      GIM_Try, /*On fail goto*//*Label 7193*/ GIMT_Encode4(367735), // Rule ID 11459 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (vector_insert:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$vec, GPR32:{ *:[i32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_H:{ *:[nxv8i16] } ZPR:{ *:[nxv8i16] }:$vec, (CMPEQ_PPzZZ_H:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_H:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_H:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), GPR32:{ *:[i32] }:$src)
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_H),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_H),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_H),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
        GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/1, // vec
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11459,
        GIR_EraseRootFromParent_Done,
      // Label 7193: @367735
      GIM_Try, /*On fail goto*//*Label 7194*/ GIMT_Encode4(367883), // Rule ID 11464 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (vector_insert:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$vec, FPR16:{ *:[f16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv8f16] } ZPR:{ *:[nxv8f16] }:$vec, (CMPEQ_PPzZZ_H:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_H:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_H:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[f16] }:$src)
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_H),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_H),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_H),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
        GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/1, // vec
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11464,
        GIR_EraseRootFromParent_Done,
      // Label 7194: @367883
      GIM_Try, /*On fail goto*//*Label 7195*/ GIMT_Encode4(368031), // Rule ID 11467 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (vector_insert:{ *:[nxv8bf16] } nxv8bf16:{ *:[nxv8bf16] }:$vec, FPR16:{ *:[bf16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv8bf16] } ZPR:{ *:[nxv8bf16] }:$vec, (CMPEQ_PPzZZ_H:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_H:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_H:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[bf16] }:$src)
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_H),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_H),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_H),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
        GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/1, // vec
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11467,
        GIR_EraseRootFromParent_Done,
      // Label 7195: @368031
      GIM_Reject,
    // Label 7168: @368032
    GIM_Reject,
    // Label 6901: @368033
    GIM_Try, /*On fail goto*//*Label 7196*/ GIMT_Encode4(369082),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 7197*/ GIMT_Encode4(368167), // Rule ID 4200 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
        // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
        // GIR_Coverage, 4200,
        GIR_EraseRootFromParent_Done,
      // Label 7197: @368167
      GIM_Try, /*On fail goto*//*Label 7198*/ GIMT_Encode4(368283), // Rule ID 4201 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
        // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
        // GIR_Coverage, 4201,
        GIR_EraseRootFromParent_Done,
      // Label 7198: @368283
      GIM_Try, /*On fail goto*//*Label 7199*/ GIMT_Encode4(368395), // Rule ID 4206 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
        // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
        // GIR_Coverage, 4206,
        GIR_EraseRootFromParent_Done,
      // Label 7199: @368395
      GIM_Try, /*On fail goto*//*Label 7200*/ GIMT_Encode4(368507), // Rule ID 4208 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
        // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
        // GIR_Coverage, 4208,
        GIR_EraseRootFromParent_Done,
      // Label 7200: @368507
      GIM_Try, /*On fail goto*//*Label 7201*/ GIMT_Encode4(368618), // Rule ID 4198 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
        // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
        // GIR_Coverage, 4198,
        GIR_EraseRootFromParent_Done,
      // Label 7201: @368618
      GIM_Try, /*On fail goto*//*Label 7202*/ GIMT_Encode4(368729), // Rule ID 4199 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
        // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
        // GIR_Coverage, 4199,
        GIR_EraseRootFromParent_Done,
      // Label 7202: @368729
      GIM_Try, /*On fail goto*//*Label 7203*/ GIMT_Encode4(368836), // Rule ID 4202 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
        // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
        // GIR_Coverage, 4202,
        GIR_EraseRootFromParent_Done,
      // Label 7203: @368836
      GIM_Try, /*On fail goto*//*Label 7204*/ GIMT_Encode4(368943), // Rule ID 4204 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
        GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
        // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
        // GIR_Coverage, 4204,
        GIR_EraseRootFromParent_Done,
      // Label 7204: @368943
      GIM_Try, /*On fail goto*//*Label 7205*/ GIMT_Encode4(369081), // Rule ID 11458 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (vector_insert:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$vec, GPR32:{ *:[i32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (CMPEQ_PPzZZ_B:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_B:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_B:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), GPR32:{ *:[i32] }:$src)
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_B),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_B),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_B),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
        GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_RootToRootCopy, /*OpIdx*/1, // vec
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11458,
        GIR_EraseRootFromParent_Done,
      // Label 7205: @369081
      GIM_Reject,
    // Label 7196: @369082
    GIM_Reject,
    // Label 6902: @369083
    GIM_Reject,
    // Label 86: @369084
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7209*/ GIMT_Encode4(372634),
    /*GILLT_s16*//*Label 7206*/ GIMT_Encode4(369107),
    /*GILLT_s32*//*Label 7207*/ GIMT_Encode4(370374),
    /*GILLT_s64*//*Label 7208*/ GIMT_Encode4(371967),
    // Label 7206: @369107
    GIM_Try, /*On fail goto*//*Label 7210*/ GIMT_Encode4(369151), // Rule ID 11512 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
      // (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$Zs, hsub:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 11512,
      GIR_EraseRootFromParent_Done,
    // Label 7210: @369151
    GIM_Try, /*On fail goto*//*Label 7211*/ GIMT_Encode4(369195), // Rule ID 11513 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
      // (vector_extract:{ *:[f16] } nxv4f16:{ *:[nxv4f16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } ZPR:{ *:[nxv4f16] }:$Zs, hsub:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 11513,
      GIR_EraseRootFromParent_Done,
    // Label 7211: @369195
    GIM_Try, /*On fail goto*//*Label 7212*/ GIMT_Encode4(369239), // Rule ID 11514 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
      // (vector_extract:{ *:[f16] } nxv2f16:{ *:[nxv2f16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } ZPR:{ *:[nxv2f16] }:$Zs, hsub:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 11514,
      GIR_EraseRootFromParent_Done,
    // Label 7212: @369239
    GIM_Try, /*On fail goto*//*Label 7213*/ GIMT_Encode4(369283), // Rule ID 11515 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
      // (vector_extract:{ *:[bf16] } nxv8bf16:{ *:[nxv8bf16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[bf16] } ZPR:{ *:[nxv8bf16] }:$Zs, hsub:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 11515,
      GIR_EraseRootFromParent_Done,
    // Label 7213: @369283
    GIM_Try, /*On fail goto*//*Label 7214*/ GIMT_Encode4(369327), // Rule ID 11516 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
      // (vector_extract:{ *:[bf16] } nxv4bf16:{ *:[nxv4bf16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[bf16] } ZPR:{ *:[nxv4bf16] }:$Zs, hsub:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 11516,
      GIR_EraseRootFromParent_Done,
    // Label 7214: @369327
    GIM_Try, /*On fail goto*//*Label 7215*/ GIMT_Encode4(369371), // Rule ID 11517 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
      // (vector_extract:{ *:[bf16] } nxv2bf16:{ *:[nxv2bf16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[bf16] } ZPR:{ *:[nxv2bf16] }:$Zs, hsub:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 11517,
      GIR_EraseRootFromParent_Done,
    // Label 7215: @369371
    GIM_Try, /*On fail goto*//*Label 7216*/ GIMT_Encode4(369416), // Rule ID 5829 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
      // (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 5829,
      GIR_EraseRootFromParent_Done,
    // Label 7216: @369416
    GIM_Try, /*On fail goto*//*Label 7217*/ GIMT_Encode4(369461), // Rule ID 5830 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
      // (vector_extract:{ *:[bf16] } V128:{ *:[v8bf16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[bf16] } V128:{ *:[v8bf16] }:$Rn, hsub:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 5830,
      GIR_EraseRootFromParent_Done,
    // Label 7217: @369461
    GIM_Try, /*On fail goto*//*Label 7218*/ GIMT_Encode4(369506), // Rule ID 5833 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (DUPi16:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPi16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5833,
      GIR_EraseRootFromParent_Done,
    // Label 7218: @369506
    GIM_Try, /*On fail goto*//*Label 7219*/ GIMT_Encode4(369551), // Rule ID 5834 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vector_extract:{ *:[bf16] } V128:{ *:[v8bf16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (DUPi16:{ *:[bf16] } V128:{ *:[v8bf16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPi16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5834,
      GIR_EraseRootFromParent_Done,
    // Label 7219: @369551
    GIM_Try, /*On fail goto*//*Label 7220*/ GIMT_Encode4(369627), // Rule ID 11488 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f16] } (DUP_ZZI_H:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index), hsub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
      GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 11488,
      GIR_EraseRootFromParent_Done,
    // Label 7220: @369627
    GIM_Try, /*On fail goto*//*Label 7221*/ GIMT_Encode4(369703), // Rule ID 11489 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vector_extract:{ *:[f16] } nxv4f16:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f16] } (DUP_ZZI_S:{ *:[nxv16i8] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index), hsub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
      GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 11489,
      GIR_EraseRootFromParent_Done,
    // Label 7221: @369703
    GIM_Try, /*On fail goto*//*Label 7222*/ GIMT_Encode4(369779), // Rule ID 11490 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vector_extract:{ *:[f16] } nxv2f16:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f16] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), hsub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
      GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 11490,
      GIR_EraseRootFromParent_Done,
    // Label 7222: @369779
    GIM_Try, /*On fail goto*//*Label 7223*/ GIMT_Encode4(369855), // Rule ID 11491 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vector_extract:{ *:[bf16] } nxv8bf16:{ *:[nxv8bf16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)  =>  (EXTRACT_SUBREG:{ *:[bf16] } (DUP_ZZI_H:{ *:[nxv16i8] } ZPR:{ *:[nxv8bf16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index), hsub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
      GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 11491,
      GIR_EraseRootFromParent_Done,
    // Label 7223: @369855
    GIM_Try, /*On fail goto*//*Label 7224*/ GIMT_Encode4(369931), // Rule ID 11492 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vector_extract:{ *:[bf16] } nxv4bf16:{ *:[nxv4bf16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)  =>  (EXTRACT_SUBREG:{ *:[bf16] } (DUP_ZZI_S:{ *:[nxv16i8] } ZPR:{ *:[nxv4bf16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index), hsub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
      GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 11492,
      GIR_EraseRootFromParent_Done,
    // Label 7224: @369931
    GIM_Try, /*On fail goto*//*Label 7225*/ GIMT_Encode4(370007), // Rule ID 11493 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vector_extract:{ *:[bf16] } nxv2bf16:{ *:[nxv2bf16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[bf16] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2bf16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), hsub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
      GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 11493,
      GIR_EraseRootFromParent_Done,
    // Label 7225: @370007
    GIM_Try, /*On fail goto*//*Label 7226*/ GIMT_Encode4(370068), // Rule ID 11475 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[f16] } (WHILELS_PXX_H:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv8f16] }:$vec)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_H),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
      GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // vec
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 11475,
      GIR_EraseRootFromParent_Done,
    // Label 7226: @370068
    GIM_Try, /*On fail goto*//*Label 7227*/ GIMT_Encode4(370129), // Rule ID 11476 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (vector_extract:{ *:[f16] } nxv4f16:{ *:[nxv4f16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[f16] } (WHILELS_PXX_S:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv4f16] }:$vec)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
      GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // vec
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 11476,
      GIR_EraseRootFromParent_Done,
    // Label 7227: @370129
    GIM_Try, /*On fail goto*//*Label 7228*/ GIMT_Encode4(370190), // Rule ID 11477 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (vector_extract:{ *:[f16] } nxv2f16:{ *:[nxv2f16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[f16] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2f16] }:$vec)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
      GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // vec
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 11477,
      GIR_EraseRootFromParent_Done,
    // Label 7228: @370190
    GIM_Try, /*On fail goto*//*Label 7229*/ GIMT_Encode4(370251), // Rule ID 11478 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (vector_extract:{ *:[bf16] } nxv8bf16:{ *:[nxv8bf16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[bf16] } (WHILELS_PXX_H:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv8bf16] }:$vec)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_H),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
      GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // vec
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 11478,
      GIR_EraseRootFromParent_Done,
    // Label 7229: @370251
    GIM_Try, /*On fail goto*//*Label 7230*/ GIMT_Encode4(370312), // Rule ID 11479 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (vector_extract:{ *:[bf16] } nxv4bf16:{ *:[nxv4bf16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[bf16] } (WHILELS_PXX_S:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv4bf16] }:$vec)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
      GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // vec
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 11479,
      GIR_EraseRootFromParent_Done,
    // Label 7230: @370312
    GIM_Try, /*On fail goto*//*Label 7231*/ GIMT_Encode4(370373), // Rule ID 11480 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (vector_extract:{ *:[bf16] } nxv2bf16:{ *:[nxv2bf16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[bf16] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2bf16] }:$vec)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
      GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // vec
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 11480,
      GIR_EraseRootFromParent_Done,
    // Label 7231: @370373
    GIM_Reject,
    // Label 7207: @370374
    GIM_Try, /*On fail goto*//*Label 7232*/ GIMT_Encode4(370419), // Rule ID 7117 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
      // (extractelt:{ *:[i32] } V128:{ *:[v4i32] }:$V, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4i32] }:$V, ssub:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // V
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 7117,
      GIR_EraseRootFromParent_Done,
    // Label 7232: @370419
    GIM_Try, /*On fail goto*//*Label 7233*/ GIMT_Encode4(370464), // Rule ID 7118 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
      // (extractelt:{ *:[i32] } V64:{ *:[v2i32] }:$V, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } V64:{ *:[v2i32] }:$V, ssub:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // V
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 7118,
      GIR_EraseRootFromParent_Done,
    // Label 7233: @370464
    GIM_Try, /*On fail goto*//*Label 7234*/ GIMT_Encode4(370508), // Rule ID 11508 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
      // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } ZPR:{ *:[nxv16i8] }:$Zs, ssub:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 11508,
      GIR_EraseRootFromParent_Done,
    // Label 7234: @370508
    GIM_Try, /*On fail goto*//*Label 7235*/ GIMT_Encode4(370552), // Rule ID 11509 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
      // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } ZPR:{ *:[nxv8i16] }:$Zs, ssub:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 11509,
      GIR_EraseRootFromParent_Done,
    // Label 7235: @370552
    GIM_Try, /*On fail goto*//*Label 7236*/ GIMT_Encode4(370596), // Rule ID 11510 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
      // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } ZPR:{ *:[nxv4i32] }:$Zs, ssub:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 11510,
      GIR_EraseRootFromParent_Done,
    // Label 7236: @370596
    GIM_Try, /*On fail goto*//*Label 7237*/ GIMT_Encode4(370640), // Rule ID 11518 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
      // (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f32] } ZPR:{ *:[nxv4f32] }:$Zs, ssub:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 11518,
      GIR_EraseRootFromParent_Done,
    // Label 7237: @370640
    GIM_Try, /*On fail goto*//*Label 7238*/ GIMT_Encode4(370684), // Rule ID 11519 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
      // (vector_extract:{ *:[f32] } nxv2f32:{ *:[nxv2f32] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f32] } ZPR:{ *:[nxv2f32] }:$Zs, ssub:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 11519,
      GIR_EraseRootFromParent_Done,
    // Label 7238: @370684
    GIM_Try, /*On fail goto*//*Label 7239*/ GIMT_Encode4(370729), // Rule ID 5828 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
      // (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 5828,
      GIR_EraseRootFromParent_Done,
    // Label 7239: @370729
    GIM_Try, /*On fail goto*//*Label 7240*/ GIMT_Encode4(370802), // Rule ID 11497 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)  =>  (UMOVvi8:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 11497,
      GIR_EraseRootFromParent_Done,
    // Label 7240: @370802
    GIM_Try, /*On fail goto*//*Label 7241*/ GIMT_Encode4(370875), // Rule ID 11498 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)  =>  (UMOVvi16:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 11498,
      GIR_EraseRootFromParent_Done,
    // Label 7241: @370875
    GIM_Try, /*On fail goto*//*Label 7242*/ GIMT_Encode4(370948), // Rule ID 11499 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index)  =>  (UMOVvi32:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v4i32] } ZPR:{ *:[nxv4i32] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 11499,
      GIR_EraseRootFromParent_Done,
    // Label 7242: @370948
    GIM_Try, /*On fail goto*//*Label 7243*/ GIMT_Encode4(370996), // Rule ID 1915 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi8_idx0:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8_idx0),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1915,
      GIR_EraseRootFromParent_Done,
    // Label 7243: @370996
    GIM_Try, /*On fail goto*//*Label 7244*/ GIMT_Encode4(371044), // Rule ID 1916 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi16_idx0:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16_idx0),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1916,
      GIR_EraseRootFromParent_Done,
    // Label 7244: @371044
    GIM_Try, /*On fail goto*//*Label 7245*/ GIMT_Encode4(371092), // Rule ID 1917 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi32_idx0:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi32_idx0),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1917,
      GIR_EraseRootFromParent_Done,
    // Label 7245: @371092
    GIM_Try, /*On fail goto*//*Label 7246*/ GIMT_Encode4(371140), // Rule ID 1919 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (UMOVvi8:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1919,
      GIR_EraseRootFromParent_Done,
    // Label 7246: @371140
    GIM_Try, /*On fail goto*//*Label 7247*/ GIMT_Encode4(371188), // Rule ID 1920 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (UMOVvi16:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1920,
      GIR_EraseRootFromParent_Done,
    // Label 7247: @371188
    GIM_Try, /*On fail goto*//*Label 7248*/ GIMT_Encode4(371236), // Rule ID 1921 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (UMOVvi32:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1921,
      GIR_EraseRootFromParent_Done,
    // Label 7248: @371236
    GIM_Try, /*On fail goto*//*Label 7249*/ GIMT_Encode4(371281), // Rule ID 5832 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (DUPi32:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPi32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5832,
      GIR_EraseRootFromParent_Done,
    // Label 7249: @371281
    GIM_Try, /*On fail goto*//*Label 7250*/ GIMT_Encode4(371357), // Rule ID 11484 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_b),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i32] } (DUP_ZZI_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index), ssub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_B),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
      GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 11484,
      GIR_EraseRootFromParent_Done,
    // Label 7250: @371357
    GIM_Try, /*On fail goto*//*Label 7251*/ GIMT_Encode4(371433), // Rule ID 11485 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i32] } (DUP_ZZI_H:{ *:[nxv16i8] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index), ssub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
      GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 11485,
      GIR_EraseRootFromParent_Done,
    // Label 7251: @371433
    GIM_Try, /*On fail goto*//*Label 7252*/ GIMT_Encode4(371509), // Rule ID 11486 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i32] } (DUP_ZZI_S:{ *:[nxv16i8] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index), ssub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
      GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 11486,
      GIR_EraseRootFromParent_Done,
    // Label 7252: @371509
    GIM_Try, /*On fail goto*//*Label 7253*/ GIMT_Encode4(371585), // Rule ID 11494 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f32] } (DUP_ZZI_S:{ *:[nxv16i8] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index), ssub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
      GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 11494,
      GIR_EraseRootFromParent_Done,
    // Label 7253: @371585
    GIM_Try, /*On fail goto*//*Label 7254*/ GIMT_Encode4(371661), // Rule ID 11495 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vector_extract:{ *:[f32] } nxv2f32:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f32] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), ssub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
      GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 11495,
      GIR_EraseRootFromParent_Done,
    // Label 7254: @371661
    GIM_Try, /*On fail goto*//*Label 7255*/ GIMT_Encode4(371722), // Rule ID 11471 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_B:{ *:[i32] } (WHILELS_PXX_B:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv16i8] }:$vec)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_B),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
      GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_B),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // vec
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 11471,
      GIR_EraseRootFromParent_Done,
    // Label 7255: @371722
    GIM_Try, /*On fail goto*//*Label 7256*/ GIMT_Encode4(371783), // Rule ID 11472 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_H:{ *:[i32] } (WHILELS_PXX_H:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv8i16] }:$vec)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_H),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
      GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_H),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // vec
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 11472,
      GIR_EraseRootFromParent_Done,
    // Label 7256: @371783
    GIM_Try, /*On fail goto*//*Label 7257*/ GIMT_Encode4(371844), // Rule ID 11473 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_S:{ *:[i32] } (WHILELS_PXX_S:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv4i32] }:$vec)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
      GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_S),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // vec
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 11473,
      GIR_EraseRootFromParent_Done,
    // Label 7257: @371844
    GIM_Try, /*On fail goto*//*Label 7258*/ GIMT_Encode4(371905), // Rule ID 11481 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_S:{ *:[f32] } (WHILELS_PXX_S:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv4f32] }:$vec)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
      GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_S),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // vec
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 11481,
      GIR_EraseRootFromParent_Done,
    // Label 7258: @371905
    GIM_Try, /*On fail goto*//*Label 7259*/ GIMT_Encode4(371966), // Rule ID 11482 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (vector_extract:{ *:[f32] } nxv2f32:{ *:[nxv2f32] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_S:{ *:[f32] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2f32] }:$vec)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
      GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_S),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // vec
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 11482,
      GIR_EraseRootFromParent_Done,
    // Label 7259: @371966
    GIM_Reject,
    // Label 7208: @371967
    GIM_Try, /*On fail goto*//*Label 7260*/ GIMT_Encode4(372012), // Rule ID 7116 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
      // (extractelt:{ *:[i64] } V128:{ *:[v2i64] }:$V, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2i64] }:$V, dsub:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // V
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 7116,
      GIR_EraseRootFromParent_Done,
    // Label 7260: @372012
    GIM_Try, /*On fail goto*//*Label 7261*/ GIMT_Encode4(372056), // Rule ID 11511 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
      // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i64] } ZPR:{ *:[nxv2i64] }:$Zs, dsub:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Zs
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 11511,
      GIR_EraseRootFromParent_Done,
    // Label 7261: @372056
    GIM_Try, /*On fail goto*//*Label 7262*/ GIMT_Encode4(372100), // Rule ID 11520 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
      // (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f64] } ZPR:{ *:[nxv2f64] }:$Zs, dsub:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Zs
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 11520,
      GIR_EraseRootFromParent_Done,
    // Label 7262: @372100
    GIM_Try, /*On fail goto*//*Label 7263*/ GIMT_Encode4(372145), // Rule ID 5827 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
      // (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      // GIR_Coverage, 5827,
      GIR_EraseRootFromParent_Done,
    // Label 7263: @372145
    GIM_Try, /*On fail goto*//*Label 7264*/ GIMT_Encode4(372218), // Rule ID 11500 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$index)  =>  (UMOVvi64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v2i64] } ZPR:{ *:[nxv2i64] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$index)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 11500,
      GIR_EraseRootFromParent_Done,
    // Label 7264: @372218
    GIM_Try, /*On fail goto*//*Label 7265*/ GIMT_Encode4(372266), // Rule ID 1918 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi64_idx0:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi64_idx0),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1918,
      GIR_EraseRootFromParent_Done,
    // Label 7265: @372266
    GIM_Try, /*On fail goto*//*Label 7266*/ GIMT_Encode4(372314), // Rule ID 1922 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (UMOVvi64:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1922,
      GIR_EraseRootFromParent_Done,
    // Label 7266: @372314
    GIM_Try, /*On fail goto*//*Label 7267*/ GIMT_Encode4(372359), // Rule ID 5831 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (DUPi64:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPi64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5831,
      GIR_EraseRootFromParent_Done,
    // Label 7267: @372359
    GIM_Try, /*On fail goto*//*Label 7268*/ GIMT_Encode4(372435), // Rule ID 11487 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i64] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), dsub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
      GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 11487,
      GIR_EraseRootFromParent_Done,
    // Label 7268: @372435
    GIM_Try, /*On fail goto*//*Label 7269*/ GIMT_Encode4(372511), // Rule ID 11496 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f64] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), dsub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
      GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
      // GIR_Coverage, 11496,
      GIR_EraseRootFromParent_Done,
    // Label 7269: @372511
    GIM_Try, /*On fail goto*//*Label 7270*/ GIMT_Encode4(372572), // Rule ID 11474 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_D:{ *:[i64] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2i64] }:$vec)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
      GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_D),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // vec
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 11474,
      GIR_EraseRootFromParent_Done,
    // Label 7270: @372572
    GIM_Try, /*On fail goto*//*Label 7271*/ GIMT_Encode4(372633), // Rule ID 11483 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_D:{ *:[f64] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2f64] }:$vec)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
      GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_D),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // vec
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 11483,
      GIR_EraseRootFromParent_Done,
    // Label 7271: @372633
    GIM_Reject,
    // Label 7209: @372634
    GIM_Reject,
    // Label 87: @372635
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(14), GIMT_Encode2(24), /*)*//*default:*//*Label 7279*/ GIMT_Encode4(374924),
    /*GILLT_nxv2s16*//*Label 7272*/ GIMT_Encode4(372686),
    /*GILLT_nxv2s32*//*Label 7273*/ GIMT_Encode4(373228),
    /*GILLT_nxv2s64*//*Label 7274*/ GIMT_Encode4(373466), GIMT_Encode4(0),
    /*GILLT_nxv4s16*//*Label 7275*/ GIMT_Encode4(373723),
    /*GILLT_nxv4s32*//*Label 7276*/ GIMT_Encode4(374151), GIMT_Encode4(0),
    /*GILLT_nxv8s16*//*Label 7277*/ GIMT_Encode4(374408), GIMT_Encode4(0),
    /*GILLT_nxv16s8*//*Label 7278*/ GIMT_Encode4(374834),
    // Label 7272: @372686
    GIM_Try, /*On fail goto*//*Label 7280*/ GIMT_Encode4(373227),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 7281*/ GIMT_Encode4(372755), // Rule ID 2627 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (splat_vector:{ *:[nxv2f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv2f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2627,
        GIR_EraseRootFromParent_Done,
      // Label 7281: @372755
      GIM_Try, /*On fail goto*//*Label 7282*/ GIMT_Encode4(372812), // Rule ID 2629 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (splat_vector:{ *:[nxv2f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2f16] } ZPR:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2629,
        GIR_EraseRootFromParent_Done,
      // Label 7282: @372812
      GIM_Try, /*On fail goto*//*Label 7283*/ GIMT_Encode4(372869), // Rule ID 8476 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (splat_vector:{ *:[nxv2f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv2f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8476,
        GIR_EraseRootFromParent_Done,
      // Label 7283: @372869
      GIM_Try, /*On fail goto*//*Label 7284*/ GIMT_Encode4(372926), // Rule ID 8485 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (splat_vector:{ *:[nxv2bf16] } (vector_extract:{ *:[bf16] } ZPR:{ *:[nxv8bf16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv2bf16] } ZPR:{ *:[nxv8bf16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8485,
        GIR_EraseRootFromParent_Done,
      // Label 7284: @372926
      GIM_Try, /*On fail goto*//*Label 7285*/ GIMT_Encode4(372983), // Rule ID 8503 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (splat_vector:{ *:[nxv2bf16] } (vector_extract:{ *:[bf16] } ZPR:{ *:[nxv4bf16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv2bf16] } ZPR:{ *:[nxv4bf16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8503,
        GIR_EraseRootFromParent_Done,
      // Label 7285: @372983
      GIM_Try, /*On fail goto*//*Label 7286*/ GIMT_Encode4(373040), // Rule ID 8506 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (splat_vector:{ *:[nxv2bf16] } (vector_extract:{ *:[bf16] } ZPR:{ *:[nxv2bf16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2bf16] } ZPR:{ *:[nxv2bf16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8506,
        GIR_EraseRootFromParent_Done,
      // Label 7286: @373040
      GIM_Try, /*On fail goto*//*Label 7287*/ GIMT_Encode4(373074), // Rule ID 8537 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (splat_vector:{ *:[nxv2f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8)  =>  (FDUP_ZI_H:{ *:[nxv2f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8537,
        GIR_EraseRootFromParent_Done,
      // Label 7287: @373074
      GIM_Try, /*On fail goto*//*Label 7288*/ GIMT_Encode4(373150), // Rule ID 8509 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (splat_vector:{ *:[nxv2f16] } FPR16:{ *:[f16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv2f16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[f16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8509,
        GIR_EraseRootFromParent_Done,
      // Label 7288: @373150
      GIM_Try, /*On fail goto*//*Label 7289*/ GIMT_Encode4(373226), // Rule ID 8515 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (splat_vector:{ *:[nxv2bf16] } FPR16:{ *:[bf16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv2bf16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[bf16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8515,
        GIR_EraseRootFromParent_Done,
      // Label 7289: @373226
      GIM_Reject,
    // Label 7280: @373227
    GIM_Reject,
    // Label 7273: @373228
    GIM_Try, /*On fail goto*//*Label 7290*/ GIMT_Encode4(373465),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 7291*/ GIMT_Encode4(373297), // Rule ID 8494 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (splat_vector:{ *:[nxv2f32] } (vector_extract:{ *:[f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv2f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8494,
        GIR_EraseRootFromParent_Done,
      // Label 7291: @373297
      GIM_Try, /*On fail goto*//*Label 7292*/ GIMT_Encode4(373354), // Rule ID 8505 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (splat_vector:{ *:[nxv2f32] } (vector_extract:{ *:[f32] } ZPR:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2f32] } ZPR:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8505,
        GIR_EraseRootFromParent_Done,
      // Label 7292: @373354
      GIM_Try, /*On fail goto*//*Label 7293*/ GIMT_Encode4(373388), // Rule ID 8539 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (splat_vector:{ *:[nxv2f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8)  =>  (FDUP_ZI_S:{ *:[nxv2f32] } (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8539,
        GIR_EraseRootFromParent_Done,
      // Label 7293: @373388
      GIM_Try, /*On fail goto*//*Label 7294*/ GIMT_Encode4(373464), // Rule ID 8511 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (splat_vector:{ *:[nxv2f32] } FPR32:{ *:[f32] }:$src)  =>  (DUP_ZZI_S:{ *:[nxv2f32] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR32:{ *:[f32] }:$src, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8511,
        GIR_EraseRootFromParent_Done,
      // Label 7294: @373464
      GIM_Reject,
    // Label 7290: @373465
    GIM_Reject,
    // Label 7274: @373466
    GIM_Try, /*On fail goto*//*Label 7295*/ GIMT_Encode4(373722),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 7296*/ GIMT_Encode4(373535), // Rule ID 2624 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (splat_vector:{ *:[nxv2i64] } (vector_extract:{ *:[i64] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2i64] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2624,
        GIR_EraseRootFromParent_Done,
      // Label 7296: @373535
      GIM_Try, /*On fail goto*//*Label 7297*/ GIMT_Encode4(373592), // Rule ID 8500 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (splat_vector:{ *:[nxv2f64] } (vector_extract:{ *:[f64] } ZPR:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2f64] } ZPR:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8500,
        GIR_EraseRootFromParent_Done,
      // Label 7297: @373592
      GIM_Try, /*On fail goto*//*Label 7298*/ GIMT_Encode4(373626), // Rule ID 8540 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm64),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>><<X:fpimm64XForm>>:$imm8)  =>  (FDUP_ZI_D:{ *:[nxv2f64] } (fpimm64XForm:{ *:[f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>>:$imm8))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm64), // imm8
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8540,
        GIR_EraseRootFromParent_Done,
      // Label 7298: @373626
      GIM_Try, /*On fail goto*//*Label 7299*/ GIMT_Encode4(373645), // Rule ID 2368 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        // (splat_vector:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$Rn)  =>  (DUP_ZR_D:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2368,
        GIR_Done,
      // Label 7299: @373645
      GIM_Try, /*On fail goto*//*Label 7300*/ GIMT_Encode4(373721), // Rule ID 8512 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (splat_vector:{ *:[nxv2f64] } FPR64:{ *:[f64] }:$src)  =>  (DUP_ZZI_D:{ *:[nxv2f64] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR64:{ *:[f64] }:$src, dsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8512,
        GIR_EraseRootFromParent_Done,
      // Label 7300: @373721
      GIM_Reject,
    // Label 7295: @373722
    GIM_Reject,
    // Label 7275: @373723
    GIM_Try, /*On fail goto*//*Label 7301*/ GIMT_Encode4(374150),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 7302*/ GIMT_Encode4(373792), // Rule ID 2628 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (splat_vector:{ *:[nxv4f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv4f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2628,
        GIR_EraseRootFromParent_Done,
      // Label 7302: @373792
      GIM_Try, /*On fail goto*//*Label 7303*/ GIMT_Encode4(373849), // Rule ID 8479 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (splat_vector:{ *:[nxv4f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv4f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8479,
        GIR_EraseRootFromParent_Done,
      // Label 7303: @373849
      GIM_Try, /*On fail goto*//*Label 7304*/ GIMT_Encode4(373906), // Rule ID 8488 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (splat_vector:{ *:[nxv4bf16] } (vector_extract:{ *:[bf16] } ZPR:{ *:[nxv8bf16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv4bf16] } ZPR:{ *:[nxv8bf16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8488,
        GIR_EraseRootFromParent_Done,
      // Label 7304: @373906
      GIM_Try, /*On fail goto*//*Label 7305*/ GIMT_Encode4(373963), // Rule ID 8504 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (splat_vector:{ *:[nxv4bf16] } (vector_extract:{ *:[bf16] } ZPR:{ *:[nxv4bf16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv4bf16] } ZPR:{ *:[nxv4bf16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8504,
        GIR_EraseRootFromParent_Done,
      // Label 7305: @373963
      GIM_Try, /*On fail goto*//*Label 7306*/ GIMT_Encode4(373997), // Rule ID 8536 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (splat_vector:{ *:[nxv4f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8)  =>  (FDUP_ZI_H:{ *:[nxv4f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8536,
        GIR_EraseRootFromParent_Done,
      // Label 7306: @373997
      GIM_Try, /*On fail goto*//*Label 7307*/ GIMT_Encode4(374073), // Rule ID 8508 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (splat_vector:{ *:[nxv4f16] } FPR16:{ *:[f16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv4f16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[f16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8508,
        GIR_EraseRootFromParent_Done,
      // Label 7307: @374073
      GIM_Try, /*On fail goto*//*Label 7308*/ GIMT_Encode4(374149), // Rule ID 8514 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (splat_vector:{ *:[nxv4bf16] } FPR16:{ *:[bf16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv4bf16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[bf16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8514,
        GIR_EraseRootFromParent_Done,
      // Label 7308: @374149
      GIM_Reject,
    // Label 7301: @374150
    GIM_Reject,
    // Label 7276: @374151
    GIM_Try, /*On fail goto*//*Label 7309*/ GIMT_Encode4(374407),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 7310*/ GIMT_Encode4(374220), // Rule ID 2621 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (splat_vector:{ *:[nxv4i32] } (vector_extract:{ *:[i32] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv4i32] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2621,
        GIR_EraseRootFromParent_Done,
      // Label 7310: @374220
      GIM_Try, /*On fail goto*//*Label 7311*/ GIMT_Encode4(374277), // Rule ID 8497 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (splat_vector:{ *:[nxv4f32] } (vector_extract:{ *:[f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv4f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8497,
        GIR_EraseRootFromParent_Done,
      // Label 7311: @374277
      GIM_Try, /*On fail goto*//*Label 7312*/ GIMT_Encode4(374311), // Rule ID 8538 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8)  =>  (FDUP_ZI_S:{ *:[nxv4f32] } (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8538,
        GIR_EraseRootFromParent_Done,
      // Label 7312: @374311
      GIM_Try, /*On fail goto*//*Label 7313*/ GIMT_Encode4(374330), // Rule ID 2367 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
        // (splat_vector:{ *:[nxv4i32] } GPR32sp:{ *:[i32] }:$Rn)  =>  (DUP_ZR_S:{ *:[nxv4i32] } GPR32sp:{ *:[i32] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2367,
        GIR_Done,
      // Label 7313: @374330
      GIM_Try, /*On fail goto*//*Label 7314*/ GIMT_Encode4(374406), // Rule ID 8510 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (splat_vector:{ *:[nxv4f32] } FPR32:{ *:[f32] }:$src)  =>  (DUP_ZZI_S:{ *:[nxv4f32] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR32:{ *:[f32] }:$src, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8510,
        GIR_EraseRootFromParent_Done,
      // Label 7314: @374406
      GIM_Reject,
    // Label 7309: @374407
    GIM_Reject,
    // Label 7277: @374408
    GIM_Try, /*On fail goto*//*Label 7315*/ GIMT_Encode4(374472), // Rule ID 2618 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
      GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
      // MIs[2] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/2,
      // (splat_vector:{ *:[nxv8i16] } (vector_extract:{ *:[i32] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv8i16] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2618,
      GIR_EraseRootFromParent_Done,
    // Label 7315: @374472
    GIM_Try, /*On fail goto*//*Label 7316*/ GIMT_Encode4(374536), // Rule ID 8482 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
      GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
      // MIs[2] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/2,
      // (splat_vector:{ *:[nxv8f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv8f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8482,
      GIR_EraseRootFromParent_Done,
    // Label 7316: @374536
    GIM_Try, /*On fail goto*//*Label 7317*/ GIMT_Encode4(374600), // Rule ID 8491 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
      GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
      // MIs[2] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/2,
      // (splat_vector:{ *:[nxv8bf16] } (vector_extract:{ *:[bf16] } ZPR:{ *:[nxv8bf16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv8bf16] } ZPR:{ *:[nxv8bf16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8491,
      GIR_EraseRootFromParent_Done,
    // Label 7317: @374600
    GIM_Try, /*On fail goto*//*Label 7318*/ GIMT_Encode4(374641), // Rule ID 8535 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
      GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8)  =>  (FDUP_ZI_H:{ *:[nxv8f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_H),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
      GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8535,
      GIR_EraseRootFromParent_Done,
    // Label 7318: @374641
    GIM_Try, /*On fail goto*//*Label 7319*/ GIMT_Encode4(374667), // Rule ID 2366 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
      // (splat_vector:{ *:[nxv8i16] } GPR32sp:{ *:[i32] }:$Rn)  =>  (DUP_ZR_H:{ *:[nxv8i16] } GPR32sp:{ *:[i32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_H),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2366,
      GIR_Done,
    // Label 7319: @374667
    GIM_Try, /*On fail goto*//*Label 7320*/ GIMT_Encode4(374750), // Rule ID 8507 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // (splat_vector:{ *:[nxv8f16] } FPR16:{ *:[f16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv8f16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[f16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8507,
      GIR_EraseRootFromParent_Done,
    // Label 7320: @374750
    GIM_Try, /*On fail goto*//*Label 7321*/ GIMT_Encode4(374833), // Rule ID 8513 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // (splat_vector:{ *:[nxv8bf16] } FPR16:{ *:[bf16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv8bf16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[bf16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8513,
      GIR_EraseRootFromParent_Done,
    // Label 7321: @374833
    GIM_Reject,
    // Label 7278: @374834
    GIM_Try, /*On fail goto*//*Label 7322*/ GIMT_Encode4(374923),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 7323*/ GIMT_Encode4(374903), // Rule ID 2615 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_b),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (splat_vector:{ *:[nxv16i8] } (vector_extract:{ *:[i32] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index))  =>  (DUP_ZZI_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_B),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2615,
        GIR_EraseRootFromParent_Done,
      // Label 7323: @374903
      GIM_Try, /*On fail goto*//*Label 7324*/ GIMT_Encode4(374922), // Rule ID 2365 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
        // (splat_vector:{ *:[nxv16i8] } GPR32sp:{ *:[i32] }:$Rn)  =>  (DUP_ZR_B:{ *:[nxv16i8] } GPR32sp:{ *:[i32] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_B),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2365,
        GIR_Done,
      // Label 7324: @374922
      GIM_Reject,
    // Label 7322: @374923
    GIM_Reject,
    // Label 7279: @374924
    GIM_Reject,
    // Label 88: @374925
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 7327*/ GIMT_Encode4(375076),
    /*GILLT_s32*//*Label 7325*/ GIMT_Encode4(374944),
    /*GILLT_s64*//*Label 7326*/ GIMT_Encode4(375010),
    // Label 7325: @374944
    GIM_Try, /*On fail goto*//*Label 7328*/ GIMT_Encode4(375009),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 7329*/ GIMT_Encode4(374975), // Rule ID 2308 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
        // (cttz:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CTZWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CTZWr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2308,
        GIR_Done,
      // Label 7329: @374975
      GIM_Try, /*On fail goto*//*Label 7330*/ GIMT_Encode4(375008), // Rule ID 3985 //
        // (cttz:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CLZWr:{ *:[i32] } (RBITWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::RBITWr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLZWr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3985,
        GIR_EraseRootFromParent_Done,
      // Label 7330: @375008
      GIM_Reject,
    // Label 7328: @375009
    GIM_Reject,
    // Label 7326: @375010
    GIM_Try, /*On fail goto*//*Label 7331*/ GIMT_Encode4(375075),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 7332*/ GIMT_Encode4(375041), // Rule ID 2309 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
        // (cttz:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CTZXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CTZXr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2309,
        GIR_Done,
      // Label 7332: @375041
      GIM_Try, /*On fail goto*//*Label 7333*/ GIMT_Encode4(375074), // Rule ID 3986 //
        // (cttz:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CLZXr:{ *:[i64] } (RBITXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::RBITXr),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLZXr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3986,
        GIR_EraseRootFromParent_Done,
      // Label 7333: @375074
      GIM_Reject,
    // Label 7331: @375075
    GIM_Reject,
    // Label 7327: @375076
    GIM_Reject,
    // Label 89: @375077
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7342*/ GIMT_Encode4(375750),
    /*GILLT_s32*//*Label 7334*/ GIMT_Encode4(375128),
    /*GILLT_s64*//*Label 7335*/ GIMT_Encode4(375358), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 7336*/ GIMT_Encode4(375588), GIMT_Encode4(0),
    /*GILLT_v4s16*//*Label 7337*/ GIMT_Encode4(375615),
    /*GILLT_v4s32*//*Label 7338*/ GIMT_Encode4(375642),
    /*GILLT_v8s8*//*Label 7339*/ GIMT_Encode4(375669),
    /*GILLT_v8s16*//*Label 7340*/ GIMT_Encode4(375696),
    /*GILLT_v16s8*//*Label 7341*/ GIMT_Encode4(375723),
    // Label 7334: @375128
    GIM_Try, /*On fail goto*//*Label 7343*/ GIMT_Encode4(375357),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 7344*/ GIMT_Encode4(375240), // Rule ID 3987 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 31,
        // MIs[3] Rn
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (ctlz:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (xor:{ *:[i32] } (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, 31:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn), 1:{ *:[i64] }), 1:{ *:[i32] }))  =>  (CLSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSWr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3987,
        GIR_EraseRootFromParent_Done,
      // Label 7344: @375240
      GIM_Try, /*On fail goto*//*Label 7345*/ GIMT_Encode4(375340), // Rule ID 13874 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
        // MIs[4] Rn
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 31,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (ctlz:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, 31:{ *:[i64] })), 1:{ *:[i64] }), 1:{ *:[i32] }))  =>  (CLSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSWr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13874,
        GIR_EraseRootFromParent_Done,
      // Label 7345: @375340
      GIM_Try, /*On fail goto*//*Label 7346*/ GIMT_Encode4(375356), // Rule ID 192 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (ctlz:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CLZWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZWr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 192,
        GIR_Done,
      // Label 7346: @375356
      GIM_Reject,
    // Label 7343: @375357
    GIM_Reject,
    // Label 7335: @375358
    GIM_Try, /*On fail goto*//*Label 7347*/ GIMT_Encode4(375587),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 7348*/ GIMT_Encode4(375470), // Rule ID 3988 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 63,
        // MIs[3] Rn
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (ctlz:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (xor:{ *:[i64] } (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 63:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn), 1:{ *:[i64] }), 1:{ *:[i64] }))  =>  (CLSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSXr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3988,
        GIR_EraseRootFromParent_Done,
      // Label 7348: @375470
      GIM_Try, /*On fail goto*//*Label 7349*/ GIMT_Encode4(375570), // Rule ID 13875 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
        // MIs[4] Rn
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 63,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (ctlz:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 63:{ *:[i64] })), 1:{ *:[i64] }), 1:{ *:[i64] }))  =>  (CLSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSXr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13875,
        GIR_EraseRootFromParent_Done,
      // Label 7349: @375570
      GIM_Try, /*On fail goto*//*Label 7350*/ GIMT_Encode4(375586), // Rule ID 193 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (ctlz:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CLZXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZXr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 193,
        GIR_Done,
      // Label 7350: @375586
      GIM_Reject,
    // Label 7347: @375587
    GIM_Reject,
    // Label 7336: @375588
    GIM_Try, /*On fail goto*//*Label 7351*/ GIMT_Encode4(375614), // Rule ID 716 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (ctlz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (CLZv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv2i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 716,
      GIR_Done,
    // Label 7351: @375614
    GIM_Reject,
    // Label 7337: @375615
    GIM_Try, /*On fail goto*//*Label 7352*/ GIMT_Encode4(375641), // Rule ID 714 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (ctlz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (CLZv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 714,
      GIR_Done,
    // Label 7352: @375641
    GIM_Reject,
    // Label 7338: @375642
    GIM_Try, /*On fail goto*//*Label 7353*/ GIMT_Encode4(375668), // Rule ID 717 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (ctlz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (CLZv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv4i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 717,
      GIR_Done,
    // Label 7353: @375668
    GIM_Reject,
    // Label 7339: @375669
    GIM_Try, /*On fail goto*//*Label 7354*/ GIMT_Encode4(375695), // Rule ID 712 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (ctlz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (CLZv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 712,
      GIR_Done,
    // Label 7354: @375695
    GIM_Reject,
    // Label 7340: @375696
    GIM_Try, /*On fail goto*//*Label 7355*/ GIMT_Encode4(375722), // Rule ID 715 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (ctlz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (CLZv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 715,
      GIR_Done,
    // Label 7355: @375722
    GIM_Reject,
    // Label 7341: @375723
    GIM_Try, /*On fail goto*//*Label 7356*/ GIMT_Encode4(375749), // Rule ID 713 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (ctlz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (CLZv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 713,
      GIR_Done,
    // Label 7356: @375749
    GIM_Reject,
    // Label 7342: @375750
    GIM_Reject,
    // Label 90: @375751
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7361*/ GIMT_Encode4(375910),
    /*GILLT_s32*//*Label 7357*/ GIMT_Encode4(375802),
    /*GILLT_s64*//*Label 7358*/ GIMT_Encode4(375829), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_v8s8*//*Label 7359*/ GIMT_Encode4(375856), GIMT_Encode4(0),
    /*GILLT_v16s8*//*Label 7360*/ GIMT_Encode4(375883),
    // Label 7357: @375802
    GIM_Try, /*On fail goto*//*Label 7362*/ GIMT_Encode4(375828), // Rule ID 2306 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // (ctpop:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CNTWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTWr),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2306,
      GIR_Done,
    // Label 7362: @375828
    GIM_Reject,
    // Label 7358: @375829
    GIM_Try, /*On fail goto*//*Label 7363*/ GIMT_Encode4(375855), // Rule ID 2307 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (ctpop:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CNTXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTXr),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2307,
      GIR_Done,
    // Label 7363: @375855
    GIM_Reject,
    // Label 7359: @375856
    GIM_Try, /*On fail goto*//*Label 7364*/ GIMT_Encode4(375882), // Rule ID 753 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (ctpop:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (CNTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTv8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 753,
      GIR_Done,
    // Label 7364: @375882
    GIM_Reject,
    // Label 7360: @375883
    GIM_Try, /*On fail goto*//*Label 7365*/ GIMT_Encode4(375909), // Rule ID 754 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (ctpop:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (CNTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTv16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 754,
      GIR_Done,
    // Label 7365: @375909
    GIM_Reject,
    // Label 7361: @375910
    GIM_Reject,
    // Label 91: @375911
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 7373*/ GIMT_Encode4(376224),
    /*GILLT_s32*//*Label 7366*/ GIMT_Encode4(375958),
    /*GILLT_s64*//*Label 7367*/ GIMT_Encode4(376031), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 7368*/ GIMT_Encode4(376104),
    /*GILLT_v2s64*//*Label 7369*/ GIMT_Encode4(376128),
    /*GILLT_v4s16*//*Label 7370*/ GIMT_Encode4(376152),
    /*GILLT_v4s32*//*Label 7371*/ GIMT_Encode4(376176), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 7372*/ GIMT_Encode4(376200),
    // Label 7366: @375958
    GIM_Try, /*On fail goto*//*Label 7374*/ GIMT_Encode4(376030),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 7375*/ GIMT_Encode4(376013), // Rule ID 3991 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (bswap:{ *:[i32] } (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, 16:{ *:[i64] }))  =>  (REV16Wr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Wr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3991,
        GIR_EraseRootFromParent_Done,
      // Label 7375: @376013
      GIM_Try, /*On fail goto*//*Label 7376*/ GIMT_Encode4(376029), // Rule ID 197 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (bswap:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (REVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REVWr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 197,
        GIR_Done,
      // Label 7376: @376029
      GIM_Reject,
    // Label 7374: @376030
    GIM_Reject,
    // Label 7367: @376031
    GIM_Try, /*On fail goto*//*Label 7377*/ GIMT_Encode4(376103),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 7378*/ GIMT_Encode4(376086), // Rule ID 3992 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 32,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (bswap:{ *:[i64] } (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 32:{ *:[i64] }))  =>  (REV32Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV32Xr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3992,
        GIR_EraseRootFromParent_Done,
      // Label 7378: @376086
      GIM_Try, /*On fail goto*//*Label 7379*/ GIMT_Encode4(376102), // Rule ID 198 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (bswap:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (REVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REVXr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 198,
        GIR_Done,
      // Label 7379: @376102
      GIM_Reject,
    // Label 7377: @376103
    GIM_Reject,
    // Label 7368: @376104
    GIM_Try, /*On fail goto*//*Label 7380*/ GIMT_Encode4(376127), // Rule ID 5027 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bswap:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (REV32v8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5027,
      GIR_Done,
    // Label 7380: @376127
    GIM_Reject,
    // Label 7369: @376128
    GIM_Try, /*On fail goto*//*Label 7381*/ GIMT_Encode4(376151), // Rule ID 5029 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bswap:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)  =>  (REV64v16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5029,
      GIR_Done,
    // Label 7381: @376151
    GIM_Reject,
    // Label 7370: @376152
    GIM_Try, /*On fail goto*//*Label 7382*/ GIMT_Encode4(376175), // Rule ID 5025 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bswap:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (REV16v8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5025,
      GIR_Done,
    // Label 7382: @376175
    GIM_Reject,
    // Label 7371: @376176
    GIM_Try, /*On fail goto*//*Label 7383*/ GIMT_Encode4(376199), // Rule ID 5028 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bswap:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (REV32v16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5028,
      GIR_Done,
    // Label 7383: @376199
    GIM_Reject,
    // Label 7372: @376200
    GIM_Try, /*On fail goto*//*Label 7384*/ GIMT_Encode4(376223), // Rule ID 5026 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bswap:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (REV16v16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5026,
      GIR_Done,
    // Label 7384: @376223
    GIM_Reject,
    // Label 7373: @376224
    GIM_Reject,
    // Label 92: @376225
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7389*/ GIMT_Encode4(376378),
    /*GILLT_s32*//*Label 7385*/ GIMT_Encode4(376276),
    /*GILLT_s64*//*Label 7386*/ GIMT_Encode4(376300), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_v8s8*//*Label 7387*/ GIMT_Encode4(376324), GIMT_Encode4(0),
    /*GILLT_v16s8*//*Label 7388*/ GIMT_Encode4(376351),
    // Label 7385: @376276
    GIM_Try, /*On fail goto*//*Label 7390*/ GIMT_Encode4(376299), // Rule ID 194 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // (bitreverse:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (RBITWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITWr),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 194,
      GIR_Done,
    // Label 7390: @376299
    GIM_Reject,
    // Label 7386: @376300
    GIM_Try, /*On fail goto*//*Label 7391*/ GIMT_Encode4(376323), // Rule ID 195 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
      // (bitreverse:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (RBITXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITXr),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 195,
      GIR_Done,
    // Label 7391: @376323
    GIM_Reject,
    // Label 7387: @376324
    GIM_Try, /*On fail goto*//*Label 7392*/ GIMT_Encode4(376350), // Rule ID 963 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (bitreverse:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (RBITv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITv8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 963,
      GIR_Done,
    // Label 7392: @376350
    GIM_Reject,
    // Label 7388: @376351
    GIM_Try, /*On fail goto*//*Label 7393*/ GIMT_Encode4(376377), // Rule ID 964 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (bitreverse:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (RBITv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITv16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 964,
      GIR_Done,
    // Label 7393: @376377
    GIM_Reject,
    // Label 7389: @376378
    GIM_Reject,
    // Label 93: @376379
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7402*/ GIMT_Encode4(377801),
    /*GILLT_s16*//*Label 7394*/ GIMT_Encode4(376430),
    /*GILLT_s32*//*Label 7395*/ GIMT_Encode4(376461),
    /*GILLT_s64*//*Label 7396*/ GIMT_Encode4(376492), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 7397*/ GIMT_Encode4(376523),
    /*GILLT_v2s64*//*Label 7398*/ GIMT_Encode4(376554),
    /*GILLT_v4s16*//*Label 7399*/ GIMT_Encode4(376585),
    /*GILLT_v4s32*//*Label 7400*/ GIMT_Encode4(376616), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 7401*/ GIMT_Encode4(376647),
    // Label 7394: @376430
    GIM_Try, /*On fail goto*//*Label 7403*/ GIMT_Encode4(376460), // Rule ID 548 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // (fceil:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTPHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPHr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 548,
      GIR_Done,
    // Label 7403: @376460
    GIM_Reject,
    // Label 7395: @376461
    GIM_Try, /*On fail goto*//*Label 7404*/ GIMT_Encode4(376491), // Rule ID 550 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      // (fceil:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTPSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPSr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 550,
      GIR_Done,
    // Label 7404: @376491
    GIM_Reject,
    // Label 7396: @376492
    GIM_Try, /*On fail goto*//*Label 7405*/ GIMT_Encode4(376522), // Rule ID 552 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fceil:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTPDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPDr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 552,
      GIR_Done,
    // Label 7405: @376522
    GIM_Reject,
    // Label 7397: @376523
    GIM_Try, /*On fail goto*//*Label 7406*/ GIMT_Encode4(376553), // Rule ID 902 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fceil:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv2f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 902,
      GIR_Done,
    // Label 7406: @376553
    GIM_Reject,
    // Label 7398: @376554
    GIM_Try, /*On fail goto*//*Label 7407*/ GIMT_Encode4(376584), // Rule ID 906 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fceil:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv2f64),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 906,
      GIR_Done,
    // Label 7407: @376584
    GIM_Reject,
    // Label 7399: @376585
    GIM_Try, /*On fail goto*//*Label 7408*/ GIMT_Encode4(376615), // Rule ID 898 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fceil:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 898,
      GIR_Done,
    // Label 7408: @376615
    GIM_Reject,
    // Label 7400: @376616
    GIM_Try, /*On fail goto*//*Label 7409*/ GIMT_Encode4(376646), // Rule ID 904 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fceil:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 904,
      GIR_Done,
    // Label 7409: @376646
    GIM_Reject,
    // Label 7401: @376647
    GIM_Try, /*On fail goto*//*Label 7410*/ GIMT_Encode4(377800),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 7411*/ GIMT_Encode4(376682), // Rule ID 900 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        // (fceil:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv8f16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 900,
        GIR_Done,
      // Label 7411: @376682
      GIM_Try, /*On fail goto*//*Label 7412*/ GIMT_Encode4(376867), // Rule ID 7143 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
        // (fceil:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTPv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTPv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7143,
        GIR_EraseRootFromParent_Done,
      // Label 7412: @376867
      GIM_Try, /*On fail goto*//*Label 7413*/ GIMT_Encode4(377002), // Rule ID 7145 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16),
        // (fceil:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn)  =>  (BFCVTN2:{ *:[v8bf16] } (BFCVTN:{ *:[v8bf16] } (FRINTPv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })))), (FRINTPv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn)))
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::BFCVTN),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFCVTN2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7145,
        GIR_EraseRootFromParent_Done,
      // Label 7413: @377002
      GIM_Try, /*On fail goto*//*Label 7414*/ GIMT_Encode4(377799), // Rule ID 7147 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoBF16),
        // (fceil:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn)  =>  (UZP2v8i16:{ *:[v8bf16] } (BSPv16i8:{ *:[f128] } (FCMEQv4f32:{ *:[f128] } (FRINTPv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] }))), (FRINTPv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })))), (ADDv4i32:{ *:[f128] } (ADDv4i32:{ *:[f128] } (FRINTPv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] }))), (ANDv16i8:{ *:[f128] } (USHRv4i32_shift:{ *:[f128] } V128:{ *:[v8bf16] }:$Rn, 16:{ *:[i32] }), (MOVIv4i32:{ *:[f128] } 1:{ *:[i32] }, 0:{ *:[i32] }))), (MOVIv4s_msl:{ *:[f128] } 127:{ *:[i32] }, 264:{ *:[i32] })), (ORRv4i32:{ *:[f128] } (FRINTPv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] }))), 64:{ *:[i32] }, 16:{ *:[i32] })), (BSPv16i8:{ *:[f128] } (FCMEQv4f32:{ *:[f128] } (FRINTPv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn)), (FRINTPv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn))), (ADDv4i32:{ *:[f128] } (ADDv4i32:{ *:[f128] } (FRINTPv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn)), (ANDv16i8:{ *:[f128] } (USHRv4i32_shift:{ *:[f128] } V128:{ *:[v8bf16] }:$Rn, 16:{ *:[i32] }), (MOVIv4i32:{ *:[f128] } 1:{ *:[i32] }, 0:{ *:[i32] }))), (MOVIv4s_msl:{ *:[f128] } 127:{ *:[i32] }, 264:{ *:[i32] })), (ORRv4i32:{ *:[f128] } (FRINTPv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn)), 64:{ *:[i32] }, 16:{ *:[i32] })))
        GIR_MakeTempReg, /*TempRegID*/37, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/38, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/38, /*TempRegID*/37, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/38, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/38,
        GIR_MakeTempReg, /*TempRegID*/36, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/37, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
        GIR_AddTempRegister, /*InsnID*/37, /*TempRegID*/36, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/37, /*TempRegID*/37,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/37,
        GIR_MakeTempReg, /*TempRegID*/35, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/36, /*Opcode*/GIMT_Encode2(AArch64::ORRv4i32),
        GIR_AddTempRegister, /*InsnID*/36, /*TempRegID*/35, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/36, /*TempRegID*/36,
        GIR_AddImm8, /*InsnID*/36, /*Imm*/64,
        GIR_AddImm8, /*InsnID*/36, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/36,
        GIR_MakeTempReg, /*TempRegID*/34, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/35, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4s_msl),
        GIR_AddTempRegister, /*InsnID*/35, /*TempRegID*/34, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/35, /*Imm*/127,
        GIR_AddImm, /*InsnID*/35, /*Imm*/GIMT_Encode8(264),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/35,
        GIR_MakeTempReg, /*TempRegID*/33, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/34, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i32),
        GIR_AddTempRegister, /*InsnID*/34, /*TempRegID*/33, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/34, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/34, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/34,
        GIR_MakeTempReg, /*TempRegID*/32, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/33, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
        GIR_AddTempRegister, /*InsnID*/33, /*TempRegID*/32, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/33, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/33, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/33,
        GIR_MakeTempReg, /*TempRegID*/31, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/32, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
        GIR_AddTempRegister, /*InsnID*/32, /*TempRegID*/31, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/32, /*TempRegID*/32,
        GIR_AddSimpleTempRegister, /*InsnID*/32, /*TempRegID*/33,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/32,
        GIR_MakeTempReg, /*TempRegID*/30, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/31, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/31, /*TempRegID*/30, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/31, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/31,
        GIR_MakeTempReg, /*TempRegID*/29, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/30, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
        GIR_AddTempRegister, /*InsnID*/30, /*TempRegID*/29, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/30, /*TempRegID*/30,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/30,
        GIR_MakeTempReg, /*TempRegID*/28, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/29, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/29, /*TempRegID*/28, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/29, /*TempRegID*/29,
        GIR_AddSimpleTempRegister, /*InsnID*/29, /*TempRegID*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/29,
        GIR_MakeTempReg, /*TempRegID*/27, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/28, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/28, /*TempRegID*/27, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/28, /*TempRegID*/28,
        GIR_AddSimpleTempRegister, /*InsnID*/28, /*TempRegID*/34,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/28,
        GIR_MakeTempReg, /*TempRegID*/26, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/27, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/27, /*TempRegID*/26, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/27, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/27,
        GIR_MakeTempReg, /*TempRegID*/25, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/26, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
        GIR_AddTempRegister, /*InsnID*/26, /*TempRegID*/25, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/26, /*TempRegID*/26,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/26,
        GIR_MakeTempReg, /*TempRegID*/24, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/25, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/25, /*TempRegID*/24, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/25, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/25,
        GIR_MakeTempReg, /*TempRegID*/23, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/24, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
        GIR_AddTempRegister, /*InsnID*/24, /*TempRegID*/23, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/24, /*TempRegID*/24,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/24,
        GIR_MakeTempReg, /*TempRegID*/22, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/23, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
        GIR_AddTempRegister, /*InsnID*/23, /*TempRegID*/22, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/23, /*TempRegID*/23,
        GIR_AddSimpleTempRegister, /*InsnID*/23, /*TempRegID*/25,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/23,
        GIR_MakeTempReg, /*TempRegID*/21, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/22, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_AddTempRegister, /*InsnID*/22, /*TempRegID*/21, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/22, /*TempRegID*/22,
        GIR_AddSimpleTempRegister, /*InsnID*/22, /*TempRegID*/27,
        GIR_AddSimpleTempRegister, /*InsnID*/22, /*TempRegID*/35,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/22,
        GIR_MakeTempReg, /*TempRegID*/20, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/21, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/21, /*TempRegID*/20, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/21, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/21, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/21, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/19, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/20, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/20, /*TempRegID*/19, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/20, /*TempRegID*/20,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/20,
        GIR_MakeTempReg, /*TempRegID*/18, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/19, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
        GIR_AddTempRegister, /*InsnID*/19, /*TempRegID*/18, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/19, /*TempRegID*/19,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/19,
        GIR_MakeTempReg, /*TempRegID*/17, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/18, /*Opcode*/GIMT_Encode2(AArch64::ORRv4i32),
        GIR_AddTempRegister, /*InsnID*/18, /*TempRegID*/17, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/18, /*TempRegID*/18,
        GIR_AddImm8, /*InsnID*/18, /*Imm*/64,
        GIR_AddImm8, /*InsnID*/18, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/18,
        GIR_MakeTempReg, /*TempRegID*/16, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/17, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4s_msl),
        GIR_AddTempRegister, /*InsnID*/17, /*TempRegID*/16, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/17, /*Imm*/127,
        GIR_AddImm, /*InsnID*/17, /*Imm*/GIMT_Encode8(264),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/17,
        GIR_MakeTempReg, /*TempRegID*/15, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/16, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i32),
        GIR_AddTempRegister, /*InsnID*/16, /*TempRegID*/15, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/16, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/16, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/16,
        GIR_MakeTempReg, /*TempRegID*/14, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/15, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
        GIR_AddTempRegister, /*InsnID*/15, /*TempRegID*/14, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/15, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/15, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/15,
        GIR_MakeTempReg, /*TempRegID*/13, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/14, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
        GIR_AddTempRegister, /*InsnID*/14, /*TempRegID*/13, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/14,
        GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/15,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/14,
        GIR_MakeTempReg, /*TempRegID*/12, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/13, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/13, /*TempRegID*/12, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/13, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/13, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/13, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/12, /*TempRegID*/12,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/12,
        GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
        GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/11, /*TempRegID*/11,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
        GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
        GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/13,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/8,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/17,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/21,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7147,
        GIR_EraseRootFromParent_Done,
      // Label 7414: @377799
      GIM_Reject,
    // Label 7410: @377800
    GIM_Reject,
    // Label 7402: @377801
    GIM_Reject,
    // Label 94: @377802
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7423*/ GIMT_Encode4(378101),
    /*GILLT_s16*//*Label 7415*/ GIMT_Encode4(377853),
    /*GILLT_s32*//*Label 7416*/ GIMT_Encode4(377884),
    /*GILLT_s64*//*Label 7417*/ GIMT_Encode4(377915), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 7418*/ GIMT_Encode4(377946),
    /*GILLT_v2s64*//*Label 7419*/ GIMT_Encode4(377977),
    /*GILLT_v4s16*//*Label 7420*/ GIMT_Encode4(378008),
    /*GILLT_v4s32*//*Label 7421*/ GIMT_Encode4(378039), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 7422*/ GIMT_Encode4(378070),
    // Label 7415: @377853
    GIM_Try, /*On fail goto*//*Label 7424*/ GIMT_Encode4(377883), // Rule ID 566 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // (fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FSQRTHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTHr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 566,
      GIR_Done,
    // Label 7424: @377883
    GIM_Reject,
    // Label 7416: @377884
    GIM_Try, /*On fail goto*//*Label 7425*/ GIMT_Encode4(377914), // Rule ID 568 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      // (fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FSQRTSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTSr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 568,
      GIR_Done,
    // Label 7425: @377914
    GIM_Reject,
    // Label 7417: @377915
    GIM_Try, /*On fail goto*//*Label 7426*/ GIMT_Encode4(377945), // Rule ID 570 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FSQRTDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTDr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 570,
      GIR_Done,
    // Label 7426: @377945
    GIM_Reject,
    // Label 7418: @377946
    GIM_Try, /*On fail goto*//*Label 7427*/ GIMT_Encode4(377976), // Rule ID 949 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fsqrt:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FSQRTv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 949,
      GIR_Done,
    // Label 7427: @377976
    GIM_Reject,
    // Label 7419: @377977
    GIM_Try, /*On fail goto*//*Label 7428*/ GIMT_Encode4(378007), // Rule ID 953 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fsqrt:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FSQRTv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f64),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 953,
      GIR_Done,
    // Label 7428: @378007
    GIM_Reject,
    // Label 7420: @378008
    GIM_Try, /*On fail goto*//*Label 7429*/ GIMT_Encode4(378038), // Rule ID 945 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fsqrt:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FSQRTv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 945,
      GIR_Done,
    // Label 7429: @378038
    GIM_Reject,
    // Label 7421: @378039
    GIM_Try, /*On fail goto*//*Label 7430*/ GIMT_Encode4(378069), // Rule ID 951 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fsqrt:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FSQRTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 951,
      GIR_Done,
    // Label 7430: @378069
    GIM_Reject,
    // Label 7422: @378070
    GIM_Try, /*On fail goto*//*Label 7431*/ GIMT_Encode4(378100), // Rule ID 947 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fsqrt:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FSQRTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv8f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 947,
      GIR_Done,
    // Label 7431: @378100
    GIM_Reject,
    // Label 7423: @378101
    GIM_Reject,
    // Label 95: @378102
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7440*/ GIMT_Encode4(379524),
    /*GILLT_s16*//*Label 7432*/ GIMT_Encode4(378153),
    /*GILLT_s32*//*Label 7433*/ GIMT_Encode4(378184),
    /*GILLT_s64*//*Label 7434*/ GIMT_Encode4(378215), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 7435*/ GIMT_Encode4(378246),
    /*GILLT_v2s64*//*Label 7436*/ GIMT_Encode4(378277),
    /*GILLT_v4s16*//*Label 7437*/ GIMT_Encode4(378308),
    /*GILLT_v4s32*//*Label 7438*/ GIMT_Encode4(378339), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 7439*/ GIMT_Encode4(378370),
    // Label 7432: @378153
    GIM_Try, /*On fail goto*//*Label 7441*/ GIMT_Encode4(378183), // Rule ID 536 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // (ffloor:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTMHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMHr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 536,
      GIR_Done,
    // Label 7441: @378183
    GIM_Reject,
    // Label 7433: @378184
    GIM_Try, /*On fail goto*//*Label 7442*/ GIMT_Encode4(378214), // Rule ID 538 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      // (ffloor:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTMSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMSr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 538,
      GIR_Done,
    // Label 7442: @378214
    GIM_Reject,
    // Label 7434: @378215
    GIM_Try, /*On fail goto*//*Label 7443*/ GIMT_Encode4(378245), // Rule ID 540 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (ffloor:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTMDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMDr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 540,
      GIR_Done,
    // Label 7443: @378245
    GIM_Reject,
    // Label 7435: @378246
    GIM_Try, /*On fail goto*//*Label 7444*/ GIMT_Encode4(378276), // Rule ID 882 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (ffloor:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv2f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 882,
      GIR_Done,
    // Label 7444: @378276
    GIM_Reject,
    // Label 7436: @378277
    GIM_Try, /*On fail goto*//*Label 7445*/ GIMT_Encode4(378307), // Rule ID 886 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (ffloor:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv2f64),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 886,
      GIR_Done,
    // Label 7445: @378307
    GIM_Reject,
    // Label 7437: @378308
    GIM_Try, /*On fail goto*//*Label 7446*/ GIMT_Encode4(378338), // Rule ID 878 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (ffloor:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 878,
      GIR_Done,
    // Label 7446: @378338
    GIM_Reject,
    // Label 7438: @378339
    GIM_Try, /*On fail goto*//*Label 7447*/ GIMT_Encode4(378369), // Rule ID 884 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (ffloor:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 884,
      GIR_Done,
    // Label 7447: @378369
    GIM_Reject,
    // Label 7439: @378370
    GIM_Try, /*On fail goto*//*Label 7448*/ GIMT_Encode4(379523),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 7449*/ GIMT_Encode4(378405), // Rule ID 880 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        // (ffloor:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv8f16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 880,
        GIR_Done,
      // Label 7449: @378405
      GIM_Try, /*On fail goto*//*Label 7450*/ GIMT_Encode4(378590), // Rule ID 7149 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
        // (ffloor:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTMv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTMv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7149,
        GIR_EraseRootFromParent_Done,
      // Label 7450: @378590
      GIM_Try, /*On fail goto*//*Label 7451*/ GIMT_Encode4(378725), // Rule ID 7151 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16),
        // (ffloor:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn)  =>  (BFCVTN2:{ *:[v8bf16] } (BFCVTN:{ *:[v8bf16] } (FRINTMv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })))), (FRINTMv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn)))
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::BFCVTN),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFCVTN2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7151,
        GIR_EraseRootFromParent_Done,
      // Label 7451: @378725
      GIM_Try, /*On fail goto*//*Label 7452*/ GIMT_Encode4(379522), // Rule ID 7153 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoBF16),
        // (ffloor:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn)  =>  (UZP2v8i16:{ *:[v8bf16] } (BSPv16i8:{ *:[f128] } (FCMEQv4f32:{ *:[f128] } (FRINTMv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] }))), (FRINTMv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })))), (ADDv4i32:{ *:[f128] } (ADDv4i32:{ *:[f128] } (FRINTMv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] }))), (ANDv16i8:{ *:[f128] } (USHRv4i32_shift:{ *:[f128] } V128:{ *:[v8bf16] }:$Rn, 16:{ *:[i32] }), (MOVIv4i32:{ *:[f128] } 1:{ *:[i32] }, 0:{ *:[i32] }))), (MOVIv4s_msl:{ *:[f128] } 127:{ *:[i32] }, 264:{ *:[i32] })), (ORRv4i32:{ *:[f128] } (FRINTMv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] }))), 64:{ *:[i32] }, 16:{ *:[i32] })), (BSPv16i8:{ *:[f128] } (FCMEQv4f32:{ *:[f128] } (FRINTMv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn)), (FRINTMv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn))), (ADDv4i32:{ *:[f128] } (ADDv4i32:{ *:[f128] } (FRINTMv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn)), (ANDv16i8:{ *:[f128] } (USHRv4i32_shift:{ *:[f128] } V128:{ *:[v8bf16] }:$Rn, 16:{ *:[i32] }), (MOVIv4i32:{ *:[f128] } 1:{ *:[i32] }, 0:{ *:[i32] }))), (MOVIv4s_msl:{ *:[f128] } 127:{ *:[i32] }, 264:{ *:[i32] })), (ORRv4i32:{ *:[f128] } (FRINTMv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn)), 64:{ *:[i32] }, 16:{ *:[i32] })))
        GIR_MakeTempReg, /*TempRegID*/37, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/38, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/38, /*TempRegID*/37, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/38, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/38,
        GIR_MakeTempReg, /*TempRegID*/36, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/37, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
        GIR_AddTempRegister, /*InsnID*/37, /*TempRegID*/36, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/37, /*TempRegID*/37,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/37,
        GIR_MakeTempReg, /*TempRegID*/35, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/36, /*Opcode*/GIMT_Encode2(AArch64::ORRv4i32),
        GIR_AddTempRegister, /*InsnID*/36, /*TempRegID*/35, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/36, /*TempRegID*/36,
        GIR_AddImm8, /*InsnID*/36, /*Imm*/64,
        GIR_AddImm8, /*InsnID*/36, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/36,
        GIR_MakeTempReg, /*TempRegID*/34, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/35, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4s_msl),
        GIR_AddTempRegister, /*InsnID*/35, /*TempRegID*/34, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/35, /*Imm*/127,
        GIR_AddImm, /*InsnID*/35, /*Imm*/GIMT_Encode8(264),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/35,
        GIR_MakeTempReg, /*TempRegID*/33, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/34, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i32),
        GIR_AddTempRegister, /*InsnID*/34, /*TempRegID*/33, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/34, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/34, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/34,
        GIR_MakeTempReg, /*TempRegID*/32, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/33, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
        GIR_AddTempRegister, /*InsnID*/33, /*TempRegID*/32, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/33, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/33, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/33,
        GIR_MakeTempReg, /*TempRegID*/31, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/32, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
        GIR_AddTempRegister, /*InsnID*/32, /*TempRegID*/31, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/32, /*TempRegID*/32,
        GIR_AddSimpleTempRegister, /*InsnID*/32, /*TempRegID*/33,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/32,
        GIR_MakeTempReg, /*TempRegID*/30, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/31, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/31, /*TempRegID*/30, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/31, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/31,
        GIR_MakeTempReg, /*TempRegID*/29, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/30, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
        GIR_AddTempRegister, /*InsnID*/30, /*TempRegID*/29, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/30, /*TempRegID*/30,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/30,
        GIR_MakeTempReg, /*TempRegID*/28, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/29, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/29, /*TempRegID*/28, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/29, /*TempRegID*/29,
        GIR_AddSimpleTempRegister, /*InsnID*/29, /*TempRegID*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/29,
        GIR_MakeTempReg, /*TempRegID*/27, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/28, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/28, /*TempRegID*/27, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/28, /*TempRegID*/28,
        GIR_AddSimpleTempRegister, /*InsnID*/28, /*TempRegID*/34,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/28,
        GIR_MakeTempReg, /*TempRegID*/26, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/27, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/27, /*TempRegID*/26, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/27, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/27,
        GIR_MakeTempReg, /*TempRegID*/25, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/26, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
        GIR_AddTempRegister, /*InsnID*/26, /*TempRegID*/25, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/26, /*TempRegID*/26,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/26,
        GIR_MakeTempReg, /*TempRegID*/24, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/25, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/25, /*TempRegID*/24, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/25, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/25,
        GIR_MakeTempReg, /*TempRegID*/23, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/24, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
        GIR_AddTempRegister, /*InsnID*/24, /*TempRegID*/23, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/24, /*TempRegID*/24,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/24,
        GIR_MakeTempReg, /*TempRegID*/22, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/23, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
        GIR_AddTempRegister, /*InsnID*/23, /*TempRegID*/22, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/23, /*TempRegID*/23,
        GIR_AddSimpleTempRegister, /*InsnID*/23, /*TempRegID*/25,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/23,
        GIR_MakeTempReg, /*TempRegID*/21, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/22, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_AddTempRegister, /*InsnID*/22, /*TempRegID*/21, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/22, /*TempRegID*/22,
        GIR_AddSimpleTempRegister, /*InsnID*/22, /*TempRegID*/27,
        GIR_AddSimpleTempRegister, /*InsnID*/22, /*TempRegID*/35,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/22,
        GIR_MakeTempReg, /*TempRegID*/20, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/21, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/21, /*TempRegID*/20, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/21, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/21, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/21, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/19, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/20, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/20, /*TempRegID*/19, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/20, /*TempRegID*/20,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/20,
        GIR_MakeTempReg, /*TempRegID*/18, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/19, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
        GIR_AddTempRegister, /*InsnID*/19, /*TempRegID*/18, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/19, /*TempRegID*/19,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/19,
        GIR_MakeTempReg, /*TempRegID*/17, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/18, /*Opcode*/GIMT_Encode2(AArch64::ORRv4i32),
        GIR_AddTempRegister, /*InsnID*/18, /*TempRegID*/17, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/18, /*TempRegID*/18,
        GIR_AddImm8, /*InsnID*/18, /*Imm*/64,
        GIR_AddImm8, /*InsnID*/18, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/18,
        GIR_MakeTempReg, /*TempRegID*/16, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/17, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4s_msl),
        GIR_AddTempRegister, /*InsnID*/17, /*TempRegID*/16, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/17, /*Imm*/127,
        GIR_AddImm, /*InsnID*/17, /*Imm*/GIMT_Encode8(264),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/17,
        GIR_MakeTempReg, /*TempRegID*/15, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/16, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i32),
        GIR_AddTempRegister, /*InsnID*/16, /*TempRegID*/15, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/16, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/16, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/16,
        GIR_MakeTempReg, /*TempRegID*/14, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/15, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
        GIR_AddTempRegister, /*InsnID*/15, /*TempRegID*/14, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/15, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/15, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/15,
        GIR_MakeTempReg, /*TempRegID*/13, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/14, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
        GIR_AddTempRegister, /*InsnID*/14, /*TempRegID*/13, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/14,
        GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/15,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/14,
        GIR_MakeTempReg, /*TempRegID*/12, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/13, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/13, /*TempRegID*/12, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/13, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/13, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/13, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/12, /*TempRegID*/12,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/12,
        GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
        GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/11, /*TempRegID*/11,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
        GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
        GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/13,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/8,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/17,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/21,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7153,
        GIR_EraseRootFromParent_Done,
      // Label 7452: @379522
      GIM_Reject,
    // Label 7448: @379523
    GIM_Reject,
    // Label 7440: @379524
    GIM_Reject,
    // Label 96: @379525
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7461*/ GIMT_Encode4(380947),
    /*GILLT_s16*//*Label 7453*/ GIMT_Encode4(379576),
    /*GILLT_s32*//*Label 7454*/ GIMT_Encode4(379607),
    /*GILLT_s64*//*Label 7455*/ GIMT_Encode4(379638), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 7456*/ GIMT_Encode4(379669),
    /*GILLT_v2s64*//*Label 7457*/ GIMT_Encode4(379700),
    /*GILLT_v4s16*//*Label 7458*/ GIMT_Encode4(379731),
    /*GILLT_v4s32*//*Label 7459*/ GIMT_Encode4(379762), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 7460*/ GIMT_Encode4(379793),
    // Label 7453: @379576
    GIM_Try, /*On fail goto*//*Label 7462*/ GIMT_Encode4(379606), // Rule ID 554 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // (frint:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTXHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 554,
      GIR_Done,
    // Label 7462: @379606
    GIM_Reject,
    // Label 7454: @379607
    GIM_Try, /*On fail goto*//*Label 7463*/ GIMT_Encode4(379637), // Rule ID 556 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      // (frint:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTXSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 556,
      GIR_Done,
    // Label 7463: @379637
    GIM_Reject,
    // Label 7455: @379638
    GIM_Try, /*On fail goto*//*Label 7464*/ GIMT_Encode4(379668), // Rule ID 558 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (frint:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTXDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 558,
      GIR_Done,
    // Label 7464: @379668
    GIM_Reject,
    // Label 7456: @379669
    GIM_Try, /*On fail goto*//*Label 7465*/ GIMT_Encode4(379699), // Rule ID 912 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (frint:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv2f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 912,
      GIR_Done,
    // Label 7465: @379699
    GIM_Reject,
    // Label 7457: @379700
    GIM_Try, /*On fail goto*//*Label 7466*/ GIMT_Encode4(379730), // Rule ID 916 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (frint:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv2f64),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 916,
      GIR_Done,
    // Label 7466: @379730
    GIM_Reject,
    // Label 7458: @379731
    GIM_Try, /*On fail goto*//*Label 7467*/ GIMT_Encode4(379761), // Rule ID 908 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (frint:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 908,
      GIR_Done,
    // Label 7467: @379761
    GIM_Reject,
    // Label 7459: @379762
    GIM_Try, /*On fail goto*//*Label 7468*/ GIMT_Encode4(379792), // Rule ID 914 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (frint:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 914,
      GIR_Done,
    // Label 7468: @379792
    GIM_Reject,
    // Label 7460: @379793
    GIM_Try, /*On fail goto*//*Label 7469*/ GIMT_Encode4(380946),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 7470*/ GIMT_Encode4(379828), // Rule ID 910 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        // (frint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv8f16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 910,
        GIR_Done,
      // Label 7470: @379828
      GIM_Try, /*On fail goto*//*Label 7471*/ GIMT_Encode4(380013), // Rule ID 7173 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
        // (frint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTXv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTXv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7173,
        GIR_EraseRootFromParent_Done,
      // Label 7471: @380013
      GIM_Try, /*On fail goto*//*Label 7472*/ GIMT_Encode4(380148), // Rule ID 7175 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16),
        // (frint:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn)  =>  (BFCVTN2:{ *:[v8bf16] } (BFCVTN:{ *:[v8bf16] } (FRINTXv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })))), (FRINTXv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn)))
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::BFCVTN),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFCVTN2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7175,
        GIR_EraseRootFromParent_Done,
      // Label 7472: @380148
      GIM_Try, /*On fail goto*//*Label 7473*/ GIMT_Encode4(380945), // Rule ID 7177 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoBF16),
        // (frint:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn)  =>  (UZP2v8i16:{ *:[v8bf16] } (BSPv16i8:{ *:[f128] } (FCMEQv4f32:{ *:[f128] } (FRINTXv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] }))), (FRINTXv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })))), (ADDv4i32:{ *:[f128] } (ADDv4i32:{ *:[f128] } (FRINTXv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] }))), (ANDv16i8:{ *:[f128] } (USHRv4i32_shift:{ *:[f128] } V128:{ *:[v8bf16] }:$Rn, 16:{ *:[i32] }), (MOVIv4i32:{ *:[f128] } 1:{ *:[i32] }, 0:{ *:[i32] }))), (MOVIv4s_msl:{ *:[f128] } 127:{ *:[i32] }, 264:{ *:[i32] })), (ORRv4i32:{ *:[f128] } (FRINTXv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] }))), 64:{ *:[i32] }, 16:{ *:[i32] })), (BSPv16i8:{ *:[f128] } (FCMEQv4f32:{ *:[f128] } (FRINTXv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn)), (FRINTXv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn))), (ADDv4i32:{ *:[f128] } (ADDv4i32:{ *:[f128] } (FRINTXv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn)), (ANDv16i8:{ *:[f128] } (USHRv4i32_shift:{ *:[f128] } V128:{ *:[v8bf16] }:$Rn, 16:{ *:[i32] }), (MOVIv4i32:{ *:[f128] } 1:{ *:[i32] }, 0:{ *:[i32] }))), (MOVIv4s_msl:{ *:[f128] } 127:{ *:[i32] }, 264:{ *:[i32] })), (ORRv4i32:{ *:[f128] } (FRINTXv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn)), 64:{ *:[i32] }, 16:{ *:[i32] })))
        GIR_MakeTempReg, /*TempRegID*/37, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/38, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/38, /*TempRegID*/37, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/38, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/38,
        GIR_MakeTempReg, /*TempRegID*/36, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/37, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
        GIR_AddTempRegister, /*InsnID*/37, /*TempRegID*/36, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/37, /*TempRegID*/37,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/37,
        GIR_MakeTempReg, /*TempRegID*/35, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/36, /*Opcode*/GIMT_Encode2(AArch64::ORRv4i32),
        GIR_AddTempRegister, /*InsnID*/36, /*TempRegID*/35, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/36, /*TempRegID*/36,
        GIR_AddImm8, /*InsnID*/36, /*Imm*/64,
        GIR_AddImm8, /*InsnID*/36, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/36,
        GIR_MakeTempReg, /*TempRegID*/34, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/35, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4s_msl),
        GIR_AddTempRegister, /*InsnID*/35, /*TempRegID*/34, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/35, /*Imm*/127,
        GIR_AddImm, /*InsnID*/35, /*Imm*/GIMT_Encode8(264),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/35,
        GIR_MakeTempReg, /*TempRegID*/33, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/34, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i32),
        GIR_AddTempRegister, /*InsnID*/34, /*TempRegID*/33, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/34, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/34, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/34,
        GIR_MakeTempReg, /*TempRegID*/32, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/33, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
        GIR_AddTempRegister, /*InsnID*/33, /*TempRegID*/32, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/33, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/33, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/33,
        GIR_MakeTempReg, /*TempRegID*/31, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/32, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
        GIR_AddTempRegister, /*InsnID*/32, /*TempRegID*/31, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/32, /*TempRegID*/32,
        GIR_AddSimpleTempRegister, /*InsnID*/32, /*TempRegID*/33,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/32,
        GIR_MakeTempReg, /*TempRegID*/30, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/31, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/31, /*TempRegID*/30, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/31, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/31,
        GIR_MakeTempReg, /*TempRegID*/29, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/30, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
        GIR_AddTempRegister, /*InsnID*/30, /*TempRegID*/29, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/30, /*TempRegID*/30,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/30,
        GIR_MakeTempReg, /*TempRegID*/28, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/29, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/29, /*TempRegID*/28, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/29, /*TempRegID*/29,
        GIR_AddSimpleTempRegister, /*InsnID*/29, /*TempRegID*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/29,
        GIR_MakeTempReg, /*TempRegID*/27, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/28, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/28, /*TempRegID*/27, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/28, /*TempRegID*/28,
        GIR_AddSimpleTempRegister, /*InsnID*/28, /*TempRegID*/34,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/28,
        GIR_MakeTempReg, /*TempRegID*/26, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/27, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/27, /*TempRegID*/26, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/27, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/27,
        GIR_MakeTempReg, /*TempRegID*/25, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/26, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
        GIR_AddTempRegister, /*InsnID*/26, /*TempRegID*/25, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/26, /*TempRegID*/26,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/26,
        GIR_MakeTempReg, /*TempRegID*/24, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/25, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/25, /*TempRegID*/24, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/25, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/25,
        GIR_MakeTempReg, /*TempRegID*/23, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/24, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
        GIR_AddTempRegister, /*InsnID*/24, /*TempRegID*/23, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/24, /*TempRegID*/24,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/24,
        GIR_MakeTempReg, /*TempRegID*/22, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/23, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
        GIR_AddTempRegister, /*InsnID*/23, /*TempRegID*/22, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/23, /*TempRegID*/23,
        GIR_AddSimpleTempRegister, /*InsnID*/23, /*TempRegID*/25,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/23,
        GIR_MakeTempReg, /*TempRegID*/21, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/22, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_AddTempRegister, /*InsnID*/22, /*TempRegID*/21, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/22, /*TempRegID*/22,
        GIR_AddSimpleTempRegister, /*InsnID*/22, /*TempRegID*/27,
        GIR_AddSimpleTempRegister, /*InsnID*/22, /*TempRegID*/35,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/22,
        GIR_MakeTempReg, /*TempRegID*/20, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/21, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/21, /*TempRegID*/20, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/21, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/21, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/21, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/19, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/20, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/20, /*TempRegID*/19, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/20, /*TempRegID*/20,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/20,
        GIR_MakeTempReg, /*TempRegID*/18, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/19, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
        GIR_AddTempRegister, /*InsnID*/19, /*TempRegID*/18, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/19, /*TempRegID*/19,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/19,
        GIR_MakeTempReg, /*TempRegID*/17, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/18, /*Opcode*/GIMT_Encode2(AArch64::ORRv4i32),
        GIR_AddTempRegister, /*InsnID*/18, /*TempRegID*/17, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/18, /*TempRegID*/18,
        GIR_AddImm8, /*InsnID*/18, /*Imm*/64,
        GIR_AddImm8, /*InsnID*/18, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/18,
        GIR_MakeTempReg, /*TempRegID*/16, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/17, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4s_msl),
        GIR_AddTempRegister, /*InsnID*/17, /*TempRegID*/16, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/17, /*Imm*/127,
        GIR_AddImm, /*InsnID*/17, /*Imm*/GIMT_Encode8(264),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/17,
        GIR_MakeTempReg, /*TempRegID*/15, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/16, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i32),
        GIR_AddTempRegister, /*InsnID*/16, /*TempRegID*/15, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/16, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/16, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/16,
        GIR_MakeTempReg, /*TempRegID*/14, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/15, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
        GIR_AddTempRegister, /*InsnID*/15, /*TempRegID*/14, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/15, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/15, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/15,
        GIR_MakeTempReg, /*TempRegID*/13, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/14, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
        GIR_AddTempRegister, /*InsnID*/14, /*TempRegID*/13, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/14,
        GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/15,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/14,
        GIR_MakeTempReg, /*TempRegID*/12, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/13, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/13, /*TempRegID*/12, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/13, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/13, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/13, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/12, /*TempRegID*/12,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/12,
        GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
        GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/11, /*TempRegID*/11,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
        GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
        GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/13,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/8,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/17,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/21,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7177,
        GIR_EraseRootFromParent_Done,
      // Label 7473: @380945
      GIM_Reject,
    // Label 7469: @380946
    GIM_Reject,
    // Label 7461: @380947
    GIM_Reject,
    // Label 97: @380948
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7482*/ GIMT_Encode4(382370),
    /*GILLT_s16*//*Label 7474*/ GIMT_Encode4(380999),
    /*GILLT_s32*//*Label 7475*/ GIMT_Encode4(381030),
    /*GILLT_s64*//*Label 7476*/ GIMT_Encode4(381061), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 7477*/ GIMT_Encode4(381092),
    /*GILLT_v2s64*//*Label 7478*/ GIMT_Encode4(381123),
    /*GILLT_v4s16*//*Label 7479*/ GIMT_Encode4(381154),
    /*GILLT_v4s32*//*Label 7480*/ GIMT_Encode4(381185), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 7481*/ GIMT_Encode4(381216),
    // Label 7474: @380999
    GIM_Try, /*On fail goto*//*Label 7483*/ GIMT_Encode4(381029), // Rule ID 530 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // (fnearbyint:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTIHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIHr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 530,
      GIR_Done,
    // Label 7483: @381029
    GIM_Reject,
    // Label 7475: @381030
    GIM_Try, /*On fail goto*//*Label 7484*/ GIMT_Encode4(381060), // Rule ID 532 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      // (fnearbyint:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTISr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTISr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 532,
      GIR_Done,
    // Label 7484: @381060
    GIM_Reject,
    // Label 7476: @381061
    GIM_Try, /*On fail goto*//*Label 7485*/ GIMT_Encode4(381091), // Rule ID 534 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fnearbyint:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTIDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIDr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 534,
      GIR_Done,
    // Label 7485: @381091
    GIM_Reject,
    // Label 7477: @381092
    GIM_Try, /*On fail goto*//*Label 7486*/ GIMT_Encode4(381122), // Rule ID 872 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fnearbyint:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTIv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv2f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 872,
      GIR_Done,
    // Label 7486: @381122
    GIM_Reject,
    // Label 7478: @381123
    GIM_Try, /*On fail goto*//*Label 7487*/ GIMT_Encode4(381153), // Rule ID 876 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fnearbyint:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTIv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv2f64),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 876,
      GIR_Done,
    // Label 7487: @381153
    GIM_Reject,
    // Label 7479: @381154
    GIM_Try, /*On fail goto*//*Label 7488*/ GIMT_Encode4(381184), // Rule ID 868 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (fnearbyint:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTIv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 868,
      GIR_Done,
    // Label 7488: @381184
    GIM_Reject,
    // Label 7480: @381185
    GIM_Try, /*On fail goto*//*Label 7489*/ GIMT_Encode4(381215), // Rule ID 874 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (fnearbyint:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTIv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 874,
      GIR_Done,
    // Label 7489: @381215
    GIM_Reject,
    // Label 7481: @381216
    GIM_Try, /*On fail goto*//*Label 7490*/ GIMT_Encode4(382369),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 7491*/ GIMT_Encode4(381251), // Rule ID 870 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        // (fnearbyint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTIv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv8f16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 870,
        GIR_Done,
      // Label 7491: @381251
      GIM_Try, /*On fail goto*//*Label 7492*/ GIMT_Encode4(381436), // Rule ID 7155 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
        // (fnearbyint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTIv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTIv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7155,
        GIR_EraseRootFromParent_Done,
      // Label 7492: @381436
      GIM_Try, /*On fail goto*//*Label 7493*/ GIMT_Encode4(381571), // Rule ID 7157 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16),
        // (fnearbyint:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn)  =>  (BFCVTN2:{ *:[v8bf16] } (BFCVTN:{ *:[v8bf16] } (FRINTIv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })))), (FRINTIv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn)))
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::BFCVTN),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFCVTN2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7157,
        GIR_EraseRootFromParent_Done,
      // Label 7493: @381571
      GIM_Try, /*On fail goto*//*Label 7494*/ GIMT_Encode4(382368), // Rule ID 7159 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoBF16),
        // (fnearbyint:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn)  =>  (UZP2v8i16:{ *:[v8bf16] } (BSPv16i8:{ *:[f128] } (FCMEQv4f32:{ *:[f128] } (FRINTIv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] }))), (FRINTIv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })))), (ADDv4i32:{ *:[f128] } (ADDv4i32:{ *:[f128] } (FRINTIv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] }))), (ANDv16i8:{ *:[f128] } (USHRv4i32_shift:{ *:[f128] } V128:{ *:[v8bf16] }:$Rn, 16:{ *:[i32] }), (MOVIv4i32:{ *:[f128] } 1:{ *:[i32] }, 0:{ *:[i32] }))), (MOVIv4s_msl:{ *:[f128] } 127:{ *:[i32] }, 264:{ *:[i32] })), (ORRv4i32:{ *:[f128] } (FRINTIv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] }))), 64:{ *:[i32] }, 16:{ *:[i32] })), (BSPv16i8:{ *:[f128] } (FCMEQv4f32:{ *:[f128] } (FRINTIv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn)), (FRINTIv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn))), (ADDv4i32:{ *:[f128] } (ADDv4i32:{ *:[f128] } (FRINTIv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn)), (ANDv16i8:{ *:[f128] } (USHRv4i32_shift:{ *:[f128] } V128:{ *:[v8bf16] }:$Rn, 16:{ *:[i32] }), (MOVIv4i32:{ *:[f128] } 1:{ *:[i32] }, 0:{ *:[i32] }))), (MOVIv4s_msl:{ *:[f128] } 127:{ *:[i32] }, 264:{ *:[i32] })), (ORRv4i32:{ *:[f128] } (FRINTIv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn)), 64:{ *:[i32] }, 16:{ *:[i32] })))
        GIR_MakeTempReg, /*TempRegID*/37, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/38, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/38, /*TempRegID*/37, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/38, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/38,
        GIR_MakeTempReg, /*TempRegID*/36, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/37, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
        GIR_AddTempRegister, /*InsnID*/37, /*TempRegID*/36, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/37, /*TempRegID*/37,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/37,
        GIR_MakeTempReg, /*TempRegID*/35, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/36, /*Opcode*/GIMT_Encode2(AArch64::ORRv4i32),
        GIR_AddTempRegister, /*InsnID*/36, /*TempRegID*/35, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/36, /*TempRegID*/36,
        GIR_AddImm8, /*InsnID*/36, /*Imm*/64,
        GIR_AddImm8, /*InsnID*/36, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/36,
        GIR_MakeTempReg, /*TempRegID*/34, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/35, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4s_msl),
        GIR_AddTempRegister, /*InsnID*/35, /*TempRegID*/34, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/35, /*Imm*/127,
        GIR_AddImm, /*InsnID*/35, /*Imm*/GIMT_Encode8(264),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/35,
        GIR_MakeTempReg, /*TempRegID*/33, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/34, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i32),
        GIR_AddTempRegister, /*InsnID*/34, /*TempRegID*/33, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/34, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/34, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/34,
        GIR_MakeTempReg, /*TempRegID*/32, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/33, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
        GIR_AddTempRegister, /*InsnID*/33, /*TempRegID*/32, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/33, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/33, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/33,
        GIR_MakeTempReg, /*TempRegID*/31, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/32, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
        GIR_AddTempRegister, /*InsnID*/32, /*TempRegID*/31, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/32, /*TempRegID*/32,
        GIR_AddSimpleTempRegister, /*InsnID*/32, /*TempRegID*/33,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/32,
        GIR_MakeTempReg, /*TempRegID*/30, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/31, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/31, /*TempRegID*/30, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/31, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/31,
        GIR_MakeTempReg, /*TempRegID*/29, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/30, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
        GIR_AddTempRegister, /*InsnID*/30, /*TempRegID*/29, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/30, /*TempRegID*/30,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/30,
        GIR_MakeTempReg, /*TempRegID*/28, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/29, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/29, /*TempRegID*/28, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/29, /*TempRegID*/29,
        GIR_AddSimpleTempRegister, /*InsnID*/29, /*TempRegID*/31,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/29,
        GIR_MakeTempReg, /*TempRegID*/27, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/28, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/28, /*TempRegID*/27, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/28, /*TempRegID*/28,
        GIR_AddSimpleTempRegister, /*InsnID*/28, /*TempRegID*/34,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/28,
        GIR_MakeTempReg, /*TempRegID*/26, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/27, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/27, /*TempRegID*/26, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/27, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/27,
        GIR_MakeTempReg, /*TempRegID*/25, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/26, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
        GIR_AddTempRegister, /*InsnID*/26, /*TempRegID*/25, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/26, /*TempRegID*/26,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/26,
        GIR_MakeTempReg, /*TempRegID*/24, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/25, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/25, /*TempRegID*/24, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/25, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/25,
        GIR_MakeTempReg, /*TempRegID*/23, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/24, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
        GIR_AddTempRegister, /*InsnID*/24, /*TempRegID*/23, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/24, /*TempRegID*/24,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/24,
        GIR_MakeTempReg, /*TempRegID*/22, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/23, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
        GIR_AddTempRegister, /*InsnID*/23, /*TempRegID*/22, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/23, /*TempRegID*/23,
        GIR_AddSimpleTempRegister, /*InsnID*/23, /*TempRegID*/25,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/23,
        GIR_MakeTempReg, /*TempRegID*/21, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/22, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_AddTempRegister, /*InsnID*/22, /*TempRegID*/21, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/22, /*TempRegID*/22,
        GIR_AddSimpleTempRegister, /*InsnID*/22, /*TempRegID*/27,
        GIR_AddSimpleTempRegister, /*InsnID*/22, /*TempRegID*/35,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/22,
        GIR_MakeTempReg, /*TempRegID*/20, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/21, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/21, /*TempRegID*/20, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/21, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/21, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/21, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/19, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/20, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/20, /*TempRegID*/19, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/20, /*TempRegID*/20,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/20,
        GIR_MakeTempReg, /*TempRegID*/18, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/19, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
        GIR_AddTempRegister, /*InsnID*/19, /*TempRegID*/18, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/19, /*TempRegID*/19,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/19,
        GIR_MakeTempReg, /*TempRegID*/17, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/18, /*Opcode*/GIMT_Encode2(AArch64::ORRv4i32),
        GIR_AddTempRegister, /*InsnID*/18, /*TempRegID*/17, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/18, /*TempRegID*/18,
        GIR_AddImm8, /*InsnID*/18, /*Imm*/64,
        GIR_AddImm8, /*InsnID*/18, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/18,
        GIR_MakeTempReg, /*TempRegID*/16, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/17, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4s_msl),
        GIR_AddTempRegister, /*InsnID*/17, /*TempRegID*/16, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/17, /*Imm*/127,
        GIR_AddImm, /*InsnID*/17, /*Imm*/GIMT_Encode8(264),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/17,
        GIR_MakeTempReg, /*TempRegID*/15, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/16, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i32),
        GIR_AddTempRegister, /*InsnID*/16, /*TempRegID*/15, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/16, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/16, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/16,
        GIR_MakeTempReg, /*TempRegID*/14, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/15, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
        GIR_AddTempRegister, /*InsnID*/15, /*TempRegID*/14, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/15, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/15, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/15,
        GIR_MakeTempReg, /*TempRegID*/13, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/14, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
        GIR_AddTempRegister, /*InsnID*/14, /*TempRegID*/13, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/14,
        GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/15,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/14,
        GIR_MakeTempReg, /*TempRegID*/12, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/13, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/13, /*TempRegID*/12, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/13, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/13, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/13, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/12, /*TempRegID*/12,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/12,
        GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
        GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/11, /*TempRegID*/11,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
        GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
        GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/13,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/8,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/17,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/21,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7159,
        GIR_EraseRootFromParent_Done,
      // Label 7494: @382368
      GIM_Reject,
    // Label 7490: @382369
    GIM_Reject,
    // Label 7482: @382370
    GIM_Reject,
    // Label 98: @382371
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7503*/ GIMT_Encode4(384773),
    /*GILLT_s16*//*Label 7495*/ GIMT_Encode4(382422),
    /*GILLT_s32*//*Label 7496*/ GIMT_Encode4(382648),
    /*GILLT_s64*//*Label 7497*/ GIMT_Encode4(382874), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 7498*/ GIMT_Encode4(383046),
    /*GILLT_v2s64*//*Label 7499*/ GIMT_Encode4(383084),
    /*GILLT_v4s16*//*Label 7500*/ GIMT_Encode4(383122),
    /*GILLT_v4s32*//*Label 7501*/ GIMT_Encode4(383160), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 7502*/ GIMT_Encode4(383198),
    // Label 7495: @382422
    GIM_Try, /*On fail goto*//*Label 7504*/ GIMT_Encode4(382647),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_Try, /*On fail goto*//*Label 7505*/ GIMT_Encode4(382528), // Rule ID 7073 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        // MIs[2] Rn
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7073,
        GIR_EraseRootFromParent_Done,
      // Label 7505: @382528
      GIM_Try, /*On fail goto*//*Label 7506*/ GIMT_Encode4(382619), // Rule ID 14015 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        // MIs[2] Rn
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14015,
        GIR_EraseRootFromParent_Done,
      // Label 7506: @382619
      GIM_Try, /*On fail goto*//*Label 7507*/ GIMT_Encode4(382646), // Rule ID 579 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (strict_fadd:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FADDHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDHrr),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 579,
        GIR_Done,
      // Label 7507: @382646
      GIM_Reject,
    // Label 7504: @382647
    GIM_Reject,
    // Label 7496: @382648
    GIM_Try, /*On fail goto*//*Label 7508*/ GIMT_Encode4(382873),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 7509*/ GIMT_Encode4(382754), // Rule ID 7071 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        // MIs[2] Rn
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7071,
        GIR_EraseRootFromParent_Done,
      // Label 7509: @382754
      GIM_Try, /*On fail goto*//*Label 7510*/ GIMT_Encode4(382845), // Rule ID 14013 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        // MIs[2] Rn
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14013,
        GIR_EraseRootFromParent_Done,
      // Label 7510: @382845
      GIM_Try, /*On fail goto*//*Label 7511*/ GIMT_Encode4(382872), // Rule ID 581 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (strict_fadd:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FADDSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDSrr),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 581,
        GIR_Done,
      // Label 7511: @382872
      GIM_Reject,
    // Label 7508: @382873
    GIM_Reject,
    // Label 7497: @382874
    GIM_Try, /*On fail goto*//*Label 7512*/ GIMT_Encode4(383045),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 7513*/ GIMT_Encode4(382953), // Rule ID 7069 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        // MIs[2] Rn
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7069,
        GIR_EraseRootFromParent_Done,
      // Label 7513: @382953
      GIM_Try, /*On fail goto*//*Label 7514*/ GIMT_Encode4(383017), // Rule ID 14011 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        // MIs[2] Rn
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14011,
        GIR_EraseRootFromParent_Done,
      // Label 7514: @383017
      GIM_Try, /*On fail goto*//*Label 7515*/ GIMT_Encode4(383044), // Rule ID 583 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (strict_fadd:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FADDDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDDrr),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 583,
        GIR_Done,
      // Label 7515: @383044
      GIM_Reject,
    // Label 7512: @383045
    GIM_Reject,
    // Label 7498: @383046
    GIM_Try, /*On fail goto*//*Label 7516*/ GIMT_Encode4(383083), // Rule ID 1191 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (strict_fadd:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1191,
      GIR_Done,
    // Label 7516: @383083
    GIM_Reject,
    // Label 7499: @383084
    GIM_Try, /*On fail goto*//*Label 7517*/ GIMT_Encode4(383121), // Rule ID 1195 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (strict_fadd:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f64),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1195,
      GIR_Done,
    // Label 7517: @383121
    GIM_Reject,
    // Label 7500: @383122
    GIM_Try, /*On fail goto*//*Label 7518*/ GIMT_Encode4(383159), // Rule ID 1187 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (strict_fadd:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1187,
      GIR_Done,
    // Label 7518: @383159
    GIM_Reject,
    // Label 7501: @383160
    GIM_Try, /*On fail goto*//*Label 7519*/ GIMT_Encode4(383197), // Rule ID 1193 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (strict_fadd:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1193,
      GIR_Done,
    // Label 7519: @383197
    GIM_Reject,
    // Label 7502: @383198
    GIM_Try, /*On fail goto*//*Label 7520*/ GIMT_Encode4(384772),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 7521*/ GIMT_Encode4(383240), // Rule ID 1189 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        // (strict_fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv8f16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1189,
        GIR_Done,
      // Label 7521: @383240
      GIM_Try, /*On fail goto*//*Label 7522*/ GIMT_Encode4(383494), // Rule ID 7184 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
        // (strict_fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FADDv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FADDv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
        GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
        GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
        GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
        GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7184,
        GIR_EraseRootFromParent_Done,
      // Label 7522: @383494
      GIM_Try, /*On fail goto*//*Label 7523*/ GIMT_Encode4(383698), // Rule ID 7186 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16),
        // (strict_fadd:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)  =>  (BFCVTN2:{ *:[v8bf16] } (BFCVTN:{ *:[v8bf16] } (FADDv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] })))), (FADDv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm)))
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/8,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::BFCVTN),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFCVTN2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7186,
        GIR_EraseRootFromParent_Done,
      // Label 7523: @383698
      GIM_Try, /*On fail goto*//*Label 7524*/ GIMT_Encode4(384771), // Rule ID 7188 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoBF16),
        // (strict_fadd:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8bf16] } (BSPv16i8:{ *:[f128] } (FCMEQv4f32:{ *:[f128] } (FADDv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] }))), (FADDv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] })))), (ADDv4i32:{ *:[f128] } (ADDv4i32:{ *:[f128] } (FADDv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] }))), (ANDv16i8:{ *:[f128] } (USHRv4i32_shift:{ *:[f128] } V128:{ *:[v8bf16] }:$Rn, 16:{ *:[i32] }), (MOVIv4i32:{ *:[f128] } 1:{ *:[i32] }, 0:{ *:[i32] }))), (MOVIv4s_msl:{ *:[f128] } 127:{ *:[i32] }, 264:{ *:[i32] })), (ORRv4i32:{ *:[f128] } (FADDv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] }))), 64:{ *:[i32] }, 16:{ *:[i32] })), (BSPv16i8:{ *:[f128] } (FCMEQv4f32:{ *:[f128] } (FADDv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm)), (FADDv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm))), (ADDv4i32:{ *:[f128] } (ADDv4i32:{ *:[f128] } (FADDv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm)), (ANDv16i8:{ *:[f128] } (USHRv4i32_shift:{ *:[f128] } V128:{ *:[v8bf16] }:$Rn, 16:{ *:[i32] }), (MOVIv4i32:{ *:[f128] } 1:{ *:[i32] }, 0:{ *:[i32] }))), (MOVIv4s_msl:{ *:[f128] } 127:{ *:[i32] }, 264:{ *:[i32] })), (ORRv4i32:{ *:[f128] } (FADDv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm)), 64:{ *:[i32] }, 16:{ *:[i32] })))
        GIR_MakeTempReg, /*TempRegID*/49, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/50, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/50, /*TempRegID*/49, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/50, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/50,
        GIR_MakeTempReg, /*TempRegID*/48, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/49, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/49, /*TempRegID*/48, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/49, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/49,
        GIR_MakeTempReg, /*TempRegID*/47, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/48, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
        GIR_AddTempRegister, /*InsnID*/48, /*TempRegID*/47, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/48, /*TempRegID*/48,
        GIR_AddSimpleTempRegister, /*InsnID*/48, /*TempRegID*/49,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/48,
        GIR_MakeTempReg, /*TempRegID*/46, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/47, /*Opcode*/GIMT_Encode2(AArch64::ORRv4i32),
        GIR_AddTempRegister, /*InsnID*/47, /*TempRegID*/46, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/47, /*TempRegID*/47,
        GIR_AddImm8, /*InsnID*/47, /*Imm*/64,
        GIR_AddImm8, /*InsnID*/47, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/47,
        GIR_MakeTempReg, /*TempRegID*/45, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/46, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4s_msl),
        GIR_AddTempRegister, /*InsnID*/46, /*TempRegID*/45, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/46, /*Imm*/127,
        GIR_AddImm, /*InsnID*/46, /*Imm*/GIMT_Encode8(264),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/46,
        GIR_MakeTempReg, /*TempRegID*/44, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/45, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i32),
        GIR_AddTempRegister, /*InsnID*/45, /*TempRegID*/44, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/45, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/45, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/45,
        GIR_MakeTempReg, /*TempRegID*/43, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/44, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
        GIR_AddTempRegister, /*InsnID*/44, /*TempRegID*/43, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/44, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/44, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/44,
        GIR_MakeTempReg, /*TempRegID*/42, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/43, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
        GIR_AddTempRegister, /*InsnID*/43, /*TempRegID*/42, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/43, /*TempRegID*/43,
        GIR_AddSimpleTempRegister, /*InsnID*/43, /*TempRegID*/44,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/43,
        GIR_MakeTempReg, /*TempRegID*/41, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/42, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/42, /*TempRegID*/41, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/42, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/42,
        GIR_MakeTempReg, /*TempRegID*/40, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/41, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/41, /*TempRegID*/40, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/41, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/41,
        GIR_MakeTempReg, /*TempRegID*/39, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/40, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
        GIR_AddTempRegister, /*InsnID*/40, /*TempRegID*/39, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/40, /*TempRegID*/40,
        GIR_AddSimpleTempRegister, /*InsnID*/40, /*TempRegID*/41,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/40,
        GIR_MakeTempReg, /*TempRegID*/38, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/39, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/39, /*TempRegID*/38, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/39, /*TempRegID*/39,
        GIR_AddSimpleTempRegister, /*InsnID*/39, /*TempRegID*/42,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/39,
        GIR_MakeTempReg, /*TempRegID*/37, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/38, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/38, /*TempRegID*/37, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/38, /*TempRegID*/38,
        GIR_AddSimpleTempRegister, /*InsnID*/38, /*TempRegID*/45,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/38,
        GIR_MakeTempReg, /*TempRegID*/36, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/37, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/37, /*TempRegID*/36, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/37, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/37,
        GIR_MakeTempReg, /*TempRegID*/35, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/36, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/36, /*TempRegID*/35, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/36, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/36,
        GIR_MakeTempReg, /*TempRegID*/34, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/35, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
        GIR_AddTempRegister, /*InsnID*/35, /*TempRegID*/34, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/35, /*TempRegID*/35,
        GIR_AddSimpleTempRegister, /*InsnID*/35, /*TempRegID*/36,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/35,
        GIR_MakeTempReg, /*TempRegID*/33, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/34, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/34, /*TempRegID*/33, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/34, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/34,
        GIR_MakeTempReg, /*TempRegID*/32, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/33, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/33, /*TempRegID*/32, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/33, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/33,
        GIR_MakeTempReg, /*TempRegID*/31, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/32, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
        GIR_AddTempRegister, /*InsnID*/32, /*TempRegID*/31, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/32, /*TempRegID*/32,
        GIR_AddSimpleTempRegister, /*InsnID*/32, /*TempRegID*/33,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/32,
        GIR_MakeTempReg, /*TempRegID*/30, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/31, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
        GIR_AddTempRegister, /*InsnID*/31, /*TempRegID*/30, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/31, /*TempRegID*/31,
        GIR_AddSimpleTempRegister, /*InsnID*/31, /*TempRegID*/34,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/31,
        GIR_MakeTempReg, /*TempRegID*/29, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/30, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_AddTempRegister, /*InsnID*/30, /*TempRegID*/29, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/30, /*TempRegID*/30,
        GIR_AddSimpleTempRegister, /*InsnID*/30, /*TempRegID*/37,
        GIR_AddSimpleTempRegister, /*InsnID*/30, /*TempRegID*/46,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/30,
        GIR_MakeTempReg, /*TempRegID*/28, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/29, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/29, /*TempRegID*/28, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/29, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/29, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/29, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/27, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/28, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/28, /*TempRegID*/27, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/28, /*TempRegID*/28,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/28,
        GIR_MakeTempReg, /*TempRegID*/26, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/27, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/27, /*TempRegID*/26, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/27, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/27, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/27, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/25, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/26, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/26, /*TempRegID*/25, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/26, /*TempRegID*/26,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/26,
        GIR_MakeTempReg, /*TempRegID*/24, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/25, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
        GIR_AddTempRegister, /*InsnID*/25, /*TempRegID*/24, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/25, /*TempRegID*/25,
        GIR_AddSimpleTempRegister, /*InsnID*/25, /*TempRegID*/27,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/25,
        GIR_MakeTempReg, /*TempRegID*/23, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/24, /*Opcode*/GIMT_Encode2(AArch64::ORRv4i32),
        GIR_AddTempRegister, /*InsnID*/24, /*TempRegID*/23, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/24, /*TempRegID*/24,
        GIR_AddImm8, /*InsnID*/24, /*Imm*/64,
        GIR_AddImm8, /*InsnID*/24, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/24,
        GIR_MakeTempReg, /*TempRegID*/22, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/23, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4s_msl),
        GIR_AddTempRegister, /*InsnID*/23, /*TempRegID*/22, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/23, /*Imm*/127,
        GIR_AddImm, /*InsnID*/23, /*Imm*/GIMT_Encode8(264),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/23,
        GIR_MakeTempReg, /*TempRegID*/21, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/22, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i32),
        GIR_AddTempRegister, /*InsnID*/22, /*TempRegID*/21, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/22, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/22, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/22,
        GIR_MakeTempReg, /*TempRegID*/20, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/21, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
        GIR_AddTempRegister, /*InsnID*/21, /*TempRegID*/20, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/21, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/21, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/21,
        GIR_MakeTempReg, /*TempRegID*/19, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/20, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
        GIR_AddTempRegister, /*InsnID*/20, /*TempRegID*/19, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/20, /*TempRegID*/20,
        GIR_AddSimpleTempRegister, /*InsnID*/20, /*TempRegID*/21,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/20,
        GIR_MakeTempReg, /*TempRegID*/18, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/19, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/19, /*TempRegID*/18, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/19, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/19, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/19, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/17, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/18, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/18, /*TempRegID*/17, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/18, /*TempRegID*/18,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/18,
        GIR_MakeTempReg, /*TempRegID*/16, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/17, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/17, /*TempRegID*/16, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/17, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/17, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/17, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/15, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/16, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/16, /*TempRegID*/15, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/16, /*TempRegID*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/16,
        GIR_MakeTempReg, /*TempRegID*/14, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/15, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
        GIR_AddTempRegister, /*InsnID*/15, /*TempRegID*/14, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/15, /*TempRegID*/15,
        GIR_AddSimpleTempRegister, /*InsnID*/15, /*TempRegID*/17,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/15,
        GIR_MakeTempReg, /*TempRegID*/13, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/14, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/14, /*TempRegID*/13, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/14,
        GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/19,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/14,
        GIR_MakeTempReg, /*TempRegID*/12, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/13, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/13, /*TempRegID*/12, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/13, /*TempRegID*/13,
        GIR_AddSimpleTempRegister, /*InsnID*/13, /*TempRegID*/22,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/13,
        GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/11, /*TempRegID*/11,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
        GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
        GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/10,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/12,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/23,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/29,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7188,
        GIR_EraseRootFromParent_Done,
      // Label 7524: @384771
      GIM_Reject,
    // Label 7520: @384772
    GIM_Reject,
    // Label 7503: @384773
    GIM_Reject,
    // Label 99: @384774
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7533*/ GIMT_Encode4(386666),
    /*GILLT_s16*//*Label 7525*/ GIMT_Encode4(384825),
    /*GILLT_s32*//*Label 7526*/ GIMT_Encode4(384863),
    /*GILLT_s64*//*Label 7527*/ GIMT_Encode4(384901), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 7528*/ GIMT_Encode4(384939),
    /*GILLT_v2s64*//*Label 7529*/ GIMT_Encode4(384977),
    /*GILLT_v4s16*//*Label 7530*/ GIMT_Encode4(385015),
    /*GILLT_v4s32*//*Label 7531*/ GIMT_Encode4(385053), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 7532*/ GIMT_Encode4(385091),
    // Label 7525: @384825
    GIM_Try, /*On fail goto*//*Label 7534*/ GIMT_Encode4(384862), // Rule ID 627 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // (strict_fsub:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FSUBHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBHrr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 627,
      GIR_Done,
    // Label 7534: @384862
    GIM_Reject,
    // Label 7526: @384863
    GIM_Try, /*On fail goto*//*Label 7535*/ GIMT_Encode4(384900), // Rule ID 629 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      // (strict_fsub:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FSUBSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBSrr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 629,
      GIR_Done,
    // Label 7535: @384900
    GIM_Reject,
    // Label 7527: @384901
    GIM_Try, /*On fail goto*//*Label 7536*/ GIMT_Encode4(384938), // Rule ID 631 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (strict_fsub:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FSUBDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBDrr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 631,
      GIR_Done,
    // Label 7536: @384938
    GIM_Reject,
    // Label 7528: @384939
    GIM_Try, /*On fail goto*//*Label 7537*/ GIMT_Encode4(384976), // Rule ID 1331 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (strict_fsub:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FSUBv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1331,
      GIR_Done,
    // Label 7537: @384976
    GIM_Reject,
    // Label 7529: @384977
    GIM_Try, /*On fail goto*//*Label 7538*/ GIMT_Encode4(385014), // Rule ID 1335 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (strict_fsub:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FSUBv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f64),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1335,
      GIR_Done,
    // Label 7538: @385014
    GIM_Reject,
    // Label 7530: @385015
    GIM_Try, /*On fail goto*//*Label 7539*/ GIMT_Encode4(385052), // Rule ID 1327 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (strict_fsub:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FSUBv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1327,
      GIR_Done,
    // Label 7539: @385052
    GIM_Reject,
    // Label 7531: @385053
    GIM_Try, /*On fail goto*//*Label 7540*/ GIMT_Encode4(385090), // Rule ID 1333 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (strict_fsub:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FSUBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1333,
      GIR_Done,
    // Label 7540: @385090
    GIM_Reject,
    // Label 7532: @385091
    GIM_Try, /*On fail goto*//*Label 7541*/ GIMT_Encode4(386665),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 7542*/ GIMT_Encode4(385133), // Rule ID 1329 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        // (strict_fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FSUBv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv8f16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1329,
        GIR_Done,
      // Label 7542: @385133
      GIM_Try, /*On fail goto*//*Label 7543*/ GIMT_Encode4(385387), // Rule ID 7202 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
        // (strict_fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FSUBv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FSUBv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
        GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
        GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
        GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
        GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7202,
        GIR_EraseRootFromParent_Done,
      // Label 7543: @385387
      GIM_Try, /*On fail goto*//*Label 7544*/ GIMT_Encode4(385591), // Rule ID 7204 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16),
        // (strict_fsub:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)  =>  (BFCVTN2:{ *:[v8bf16] } (BFCVTN:{ *:[v8bf16] } (FSUBv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] })))), (FSUBv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm)))
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/8,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::BFCVTN),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFCVTN2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7204,
        GIR_EraseRootFromParent_Done,
      // Label 7544: @385591
      GIM_Try, /*On fail goto*//*Label 7545*/ GIMT_Encode4(386664), // Rule ID 7206 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoBF16),
        // (strict_fsub:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8bf16] } (BSPv16i8:{ *:[f128] } (FCMEQv4f32:{ *:[f128] } (FSUBv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] }))), (FSUBv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] })))), (ADDv4i32:{ *:[f128] } (ADDv4i32:{ *:[f128] } (FSUBv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] }))), (ANDv16i8:{ *:[f128] } (USHRv4i32_shift:{ *:[f128] } V128:{ *:[v8bf16] }:$Rn, 16:{ *:[i32] }), (MOVIv4i32:{ *:[f128] } 1:{ *:[i32] }, 0:{ *:[i32] }))), (MOVIv4s_msl:{ *:[f128] } 127:{ *:[i32] }, 264:{ *:[i32] })), (ORRv4i32:{ *:[f128] } (FSUBv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] }))), 64:{ *:[i32] }, 16:{ *:[i32] })), (BSPv16i8:{ *:[f128] } (FCMEQv4f32:{ *:[f128] } (FSUBv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm)), (FSUBv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm))), (ADDv4i32:{ *:[f128] } (ADDv4i32:{ *:[f128] } (FSUBv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm)), (ANDv16i8:{ *:[f128] } (USHRv4i32_shift:{ *:[f128] } V128:{ *:[v8bf16] }:$Rn, 16:{ *:[i32] }), (MOVIv4i32:{ *:[f128] } 1:{ *:[i32] }, 0:{ *:[i32] }))), (MOVIv4s_msl:{ *:[f128] } 127:{ *:[i32] }, 264:{ *:[i32] })), (ORRv4i32:{ *:[f128] } (FSUBv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm)), 64:{ *:[i32] }, 16:{ *:[i32] })))
        GIR_MakeTempReg, /*TempRegID*/49, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/50, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/50, /*TempRegID*/49, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/50, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/50,
        GIR_MakeTempReg, /*TempRegID*/48, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/49, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/49, /*TempRegID*/48, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/49, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/49,
        GIR_MakeTempReg, /*TempRegID*/47, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/48, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
        GIR_AddTempRegister, /*InsnID*/48, /*TempRegID*/47, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/48, /*TempRegID*/48,
        GIR_AddSimpleTempRegister, /*InsnID*/48, /*TempRegID*/49,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/48,
        GIR_MakeTempReg, /*TempRegID*/46, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/47, /*Opcode*/GIMT_Encode2(AArch64::ORRv4i32),
        GIR_AddTempRegister, /*InsnID*/47, /*TempRegID*/46, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/47, /*TempRegID*/47,
        GIR_AddImm8, /*InsnID*/47, /*Imm*/64,
        GIR_AddImm8, /*InsnID*/47, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/47,
        GIR_MakeTempReg, /*TempRegID*/45, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/46, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4s_msl),
        GIR_AddTempRegister, /*InsnID*/46, /*TempRegID*/45, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/46, /*Imm*/127,
        GIR_AddImm, /*InsnID*/46, /*Imm*/GIMT_Encode8(264),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/46,
        GIR_MakeTempReg, /*TempRegID*/44, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/45, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i32),
        GIR_AddTempRegister, /*InsnID*/45, /*TempRegID*/44, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/45, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/45, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/45,
        GIR_MakeTempReg, /*TempRegID*/43, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/44, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
        GIR_AddTempRegister, /*InsnID*/44, /*TempRegID*/43, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/44, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/44, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/44,
        GIR_MakeTempReg, /*TempRegID*/42, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/43, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
        GIR_AddTempRegister, /*InsnID*/43, /*TempRegID*/42, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/43, /*TempRegID*/43,
        GIR_AddSimpleTempRegister, /*InsnID*/43, /*TempRegID*/44,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/43,
        GIR_MakeTempReg, /*TempRegID*/41, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/42, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/42, /*TempRegID*/41, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/42, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/42,
        GIR_MakeTempReg, /*TempRegID*/40, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/41, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/41, /*TempRegID*/40, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/41, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/41,
        GIR_MakeTempReg, /*TempRegID*/39, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/40, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
        GIR_AddTempRegister, /*InsnID*/40, /*TempRegID*/39, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/40, /*TempRegID*/40,
        GIR_AddSimpleTempRegister, /*InsnID*/40, /*TempRegID*/41,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/40,
        GIR_MakeTempReg, /*TempRegID*/38, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/39, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/39, /*TempRegID*/38, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/39, /*TempRegID*/39,
        GIR_AddSimpleTempRegister, /*InsnID*/39, /*TempRegID*/42,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/39,
        GIR_MakeTempReg, /*TempRegID*/37, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/38, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/38, /*TempRegID*/37, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/38, /*TempRegID*/38,
        GIR_AddSimpleTempRegister, /*InsnID*/38, /*TempRegID*/45,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/38,
        GIR_MakeTempReg, /*TempRegID*/36, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/37, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/37, /*TempRegID*/36, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/37, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/37,
        GIR_MakeTempReg, /*TempRegID*/35, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/36, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/36, /*TempRegID*/35, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/36, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/36,
        GIR_MakeTempReg, /*TempRegID*/34, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/35, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
        GIR_AddTempRegister, /*InsnID*/35, /*TempRegID*/34, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/35, /*TempRegID*/35,
        GIR_AddSimpleTempRegister, /*InsnID*/35, /*TempRegID*/36,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/35,
        GIR_MakeTempReg, /*TempRegID*/33, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/34, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/34, /*TempRegID*/33, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/34, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/34,
        GIR_MakeTempReg, /*TempRegID*/32, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/33, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/33, /*TempRegID*/32, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/33, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/33,
        GIR_MakeTempReg, /*TempRegID*/31, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/32, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
        GIR_AddTempRegister, /*InsnID*/32, /*TempRegID*/31, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/32, /*TempRegID*/32,
        GIR_AddSimpleTempRegister, /*InsnID*/32, /*TempRegID*/33,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/32,
        GIR_MakeTempReg, /*TempRegID*/30, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/31, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
        GIR_AddTempRegister, /*InsnID*/31, /*TempRegID*/30, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/31, /*TempRegID*/31,
        GIR_AddSimpleTempRegister, /*InsnID*/31, /*TempRegID*/34,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/31,
        GIR_MakeTempReg, /*TempRegID*/29, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/30, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_AddTempRegister, /*InsnID*/30, /*TempRegID*/29, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/30, /*TempRegID*/30,
        GIR_AddSimpleTempRegister, /*InsnID*/30, /*TempRegID*/37,
        GIR_AddSimpleTempRegister, /*InsnID*/30, /*TempRegID*/46,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/30,
        GIR_MakeTempReg, /*TempRegID*/28, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/29, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/29, /*TempRegID*/28, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/29, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/29, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/29, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/27, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/28, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/28, /*TempRegID*/27, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/28, /*TempRegID*/28,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/28,
        GIR_MakeTempReg, /*TempRegID*/26, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/27, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/27, /*TempRegID*/26, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/27, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/27, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/27, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/25, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/26, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/26, /*TempRegID*/25, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/26, /*TempRegID*/26,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/26,
        GIR_MakeTempReg, /*TempRegID*/24, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/25, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
        GIR_AddTempRegister, /*InsnID*/25, /*TempRegID*/24, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/25, /*TempRegID*/25,
        GIR_AddSimpleTempRegister, /*InsnID*/25, /*TempRegID*/27,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/25,
        GIR_MakeTempReg, /*TempRegID*/23, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/24, /*Opcode*/GIMT_Encode2(AArch64::ORRv4i32),
        GIR_AddTempRegister, /*InsnID*/24, /*TempRegID*/23, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/24, /*TempRegID*/24,
        GIR_AddImm8, /*InsnID*/24, /*Imm*/64,
        GIR_AddImm8, /*InsnID*/24, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/24,
        GIR_MakeTempReg, /*TempRegID*/22, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/23, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4s_msl),
        GIR_AddTempRegister, /*InsnID*/23, /*TempRegID*/22, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/23, /*Imm*/127,
        GIR_AddImm, /*InsnID*/23, /*Imm*/GIMT_Encode8(264),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/23,
        GIR_MakeTempReg, /*TempRegID*/21, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/22, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i32),
        GIR_AddTempRegister, /*InsnID*/22, /*TempRegID*/21, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/22, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/22, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/22,
        GIR_MakeTempReg, /*TempRegID*/20, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/21, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
        GIR_AddTempRegister, /*InsnID*/21, /*TempRegID*/20, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/21, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/21, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/21,
        GIR_MakeTempReg, /*TempRegID*/19, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/20, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
        GIR_AddTempRegister, /*InsnID*/20, /*TempRegID*/19, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/20, /*TempRegID*/20,
        GIR_AddSimpleTempRegister, /*InsnID*/20, /*TempRegID*/21,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/20,
        GIR_MakeTempReg, /*TempRegID*/18, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/19, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/19, /*TempRegID*/18, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/19, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/19, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/19, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/17, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/18, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/18, /*TempRegID*/17, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/18, /*TempRegID*/18,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/18,
        GIR_MakeTempReg, /*TempRegID*/16, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/17, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/17, /*TempRegID*/16, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/17, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/17, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/17, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/15, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/16, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/16, /*TempRegID*/15, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/16, /*TempRegID*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/16,
        GIR_MakeTempReg, /*TempRegID*/14, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/15, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
        GIR_AddTempRegister, /*InsnID*/15, /*TempRegID*/14, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/15, /*TempRegID*/15,
        GIR_AddSimpleTempRegister, /*InsnID*/15, /*TempRegID*/17,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/15,
        GIR_MakeTempReg, /*TempRegID*/13, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/14, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/14, /*TempRegID*/13, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/14,
        GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/19,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/14,
        GIR_MakeTempReg, /*TempRegID*/12, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/13, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/13, /*TempRegID*/12, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/13, /*TempRegID*/13,
        GIR_AddSimpleTempRegister, /*InsnID*/13, /*TempRegID*/22,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/13,
        GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/11, /*TempRegID*/11,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
        GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
        GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/10,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/12,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/23,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/29,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7206,
        GIR_EraseRootFromParent_Done,
      // Label 7545: @386664
      GIM_Reject,
    // Label 7541: @386665
    GIM_Reject,
    // Label 7533: @386666
    GIM_Reject,
    // Label 100: @386667
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7554*/ GIMT_Encode4(391681),
    /*GILLT_s16*//*Label 7546*/ GIMT_Encode4(386718),
    /*GILLT_s32*//*Label 7547*/ GIMT_Encode4(387272),
    /*GILLT_s64*//*Label 7548*/ GIMT_Encode4(387820), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 7549*/ GIMT_Encode4(388368),
    /*GILLT_v2s64*//*Label 7550*/ GIMT_Encode4(388898),
    /*GILLT_v4s16*//*Label 7551*/ GIMT_Encode4(389256),
    /*GILLT_v4s32*//*Label 7552*/ GIMT_Encode4(389598), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 7553*/ GIMT_Encode4(389956),
    // Label 7546: @386718
    GIM_Try, /*On fail goto*//*Label 7555*/ GIMT_Encode4(387271),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_Try, /*On fail goto*//*Label 7556*/ GIMT_Encode4(386846), // Rule ID 6284 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6284,
        GIR_EraseRootFromParent_Done,
      // Label 7556: @386846
      GIM_Try, /*On fail goto*//*Label 7557*/ GIMT_Encode4(386959), // Rule ID 13986 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13986,
        GIR_EraseRootFromParent_Done,
      // Label 7557: @386959
      GIM_Try, /*On fail goto*//*Label 7558*/ GIMT_Encode4(387038), // Rule ID 13923 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rn)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13923,
        GIR_EraseRootFromParent_Done,
      // Label 7558: @387038
      GIM_Try, /*On fail goto*//*Label 7559*/ GIMT_Encode4(387117), // Rule ID 4835 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }))  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4835,
        GIR_EraseRootFromParent_Done,
      // Label 7559: @387117
      GIM_Try, /*On fail goto*//*Label 7560*/ GIMT_Encode4(387180), // Rule ID 13538 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16Op:{ *:[f16] }:$Rn)  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13538,
        GIR_EraseRootFromParent_Done,
      // Label 7560: @387180
      GIM_Try, /*On fail goto*//*Label 7561*/ GIMT_Encode4(387243), // Rule ID 2000 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fmul:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2000,
        GIR_EraseRootFromParent_Done,
      // Label 7561: @387243
      GIM_Try, /*On fail goto*//*Label 7562*/ GIMT_Encode4(387270), // Rule ID 615 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 615,
        GIR_Done,
      // Label 7562: @387270
      GIM_Reject,
    // Label 7555: @387271
    GIM_Reject,
    // Label 7547: @387272
    GIM_Try, /*On fail goto*//*Label 7563*/ GIMT_Encode4(387819),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 7564*/ GIMT_Encode4(387400), // Rule ID 6286 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6286,
        GIR_EraseRootFromParent_Done,
      // Label 7564: @387400
      GIM_Try, /*On fail goto*//*Label 7565*/ GIMT_Encode4(387513), // Rule ID 13988 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13988,
        GIR_EraseRootFromParent_Done,
      // Label 7565: @387513
      GIM_Try, /*On fail goto*//*Label 7566*/ GIMT_Encode4(387589), // Rule ID 13925 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rn)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13925,
        GIR_EraseRootFromParent_Done,
      // Label 7566: @387589
      GIM_Try, /*On fail goto*//*Label 7567*/ GIMT_Encode4(387665), // Rule ID 4837 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }))  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4837,
        GIR_EraseRootFromParent_Done,
      // Label 7567: @387665
      GIM_Try, /*On fail goto*//*Label 7568*/ GIMT_Encode4(387728), // Rule ID 13540 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32Op:{ *:[f32] }:$Rn)  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13540,
        GIR_EraseRootFromParent_Done,
      // Label 7568: @387728
      GIM_Try, /*On fail goto*//*Label 7569*/ GIMT_Encode4(387791), // Rule ID 2002 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fmul:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2002,
        GIR_EraseRootFromParent_Done,
      // Label 7569: @387791
      GIM_Try, /*On fail goto*//*Label 7570*/ GIMT_Encode4(387818), // Rule ID 617 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 617,
        GIR_Done,
      // Label 7570: @387818
      GIM_Reject,
    // Label 7563: @387819
    GIM_Reject,
    // Label 7548: @387820
    GIM_Try, /*On fail goto*//*Label 7571*/ GIMT_Encode4(388367),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 7572*/ GIMT_Encode4(387948), // Rule ID 6288 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6288,
        GIR_EraseRootFromParent_Done,
      // Label 7572: @387948
      GIM_Try, /*On fail goto*//*Label 7573*/ GIMT_Encode4(388061), // Rule ID 13990 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13990,
        GIR_EraseRootFromParent_Done,
      // Label 7573: @388061
      GIM_Try, /*On fail goto*//*Label 7574*/ GIMT_Encode4(388137), // Rule ID 13927 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rn)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13927,
        GIR_EraseRootFromParent_Done,
      // Label 7574: @388137
      GIM_Try, /*On fail goto*//*Label 7575*/ GIMT_Encode4(388213), // Rule ID 4839 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }))  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4839,
        GIR_EraseRootFromParent_Done,
      // Label 7575: @388213
      GIM_Try, /*On fail goto*//*Label 7576*/ GIMT_Encode4(388276), // Rule ID 13542 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64Op:{ *:[f64] }:$Rn)  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13542,
        GIR_EraseRootFromParent_Done,
      // Label 7576: @388276
      GIM_Try, /*On fail goto*//*Label 7577*/ GIMT_Encode4(388339), // Rule ID 2004 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fmul:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2004,
        GIR_EraseRootFromParent_Done,
      // Label 7577: @388339
      GIM_Try, /*On fail goto*//*Label 7578*/ GIMT_Encode4(388366), // Rule ID 619 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 619,
        GIR_Done,
      // Label 7578: @388366
      GIM_Reject,
    // Label 7571: @388367
    GIM_Reject,
    // Label 7549: @388368
    GIM_Try, /*On fail goto*//*Label 7579*/ GIMT_Encode4(388897),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 7580*/ GIMT_Encode4(388469), // Rule ID 13530 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fmul:{ *:[v2f32] } (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13530,
        GIR_EraseRootFromParent_Done,
      // Label 7580: @388469
      GIM_Try, /*On fail goto*//*Label 7581*/ GIMT_Encode4(388555), // Rule ID 1992 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1992,
        GIR_EraseRootFromParent_Done,
      // Label 7581: @388555
      GIM_Try, /*On fail goto*//*Label 7582*/ GIMT_Encode4(388618), // Rule ID 13531 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fmul:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13531,
        GIR_EraseRootFromParent_Done,
      // Label 7582: @388618
      GIM_Try, /*On fail goto*//*Label 7583*/ GIMT_Encode4(388681), // Rule ID 1993 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1993,
        GIR_EraseRootFromParent_Done,
      // Label 7583: @388681
      GIM_Try, /*On fail goto*//*Label 7584*/ GIMT_Encode4(388775), // Rule ID 13992 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fmul:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13992,
        GIR_EraseRootFromParent_Done,
      // Label 7584: @388775
      GIM_Try, /*On fail goto*//*Label 7585*/ GIMT_Encode4(388869), // Rule ID 6290 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6290,
        GIR_EraseRootFromParent_Done,
      // Label 7585: @388869
      GIM_Try, /*On fail goto*//*Label 7586*/ GIMT_Encode4(388896), // Rule ID 1311 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMULv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f32),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1311,
        GIR_Done,
      // Label 7586: @388896
      GIM_Reject,
    // Label 7579: @388897
    GIM_Reject,
    // Label 7550: @388898
    GIM_Try, /*On fail goto*//*Label 7587*/ GIMT_Encode4(389255),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 7588*/ GIMT_Encode4(388976), // Rule ID 13536 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fmul:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13536,
        GIR_EraseRootFromParent_Done,
      // Label 7588: @388976
      GIM_Try, /*On fail goto*//*Label 7589*/ GIMT_Encode4(389039), // Rule ID 1998 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1998,
        GIR_EraseRootFromParent_Done,
      // Label 7589: @389039
      GIM_Try, /*On fail goto*//*Label 7590*/ GIMT_Encode4(389133), // Rule ID 13996 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fmul:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13996,
        GIR_EraseRootFromParent_Done,
      // Label 7590: @389133
      GIM_Try, /*On fail goto*//*Label 7591*/ GIMT_Encode4(389227), // Rule ID 6294 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6294,
        GIR_EraseRootFromParent_Done,
      // Label 7591: @389227
      GIM_Try, /*On fail goto*//*Label 7592*/ GIMT_Encode4(389254), // Rule ID 1315 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (strict_fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMULv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f64),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1315,
        GIR_Done,
      // Label 7592: @389254
      GIM_Reject,
    // Label 7587: @389255
    GIM_Reject,
    // Label 7551: @389256
    GIM_Try, /*On fail goto*//*Label 7593*/ GIMT_Encode4(389597),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 7594*/ GIMT_Encode4(389357), // Rule ID 13524 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fmul:{ *:[v4f16] } (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13524,
        GIR_EraseRootFromParent_Done,
      // Label 7594: @389357
      GIM_Try, /*On fail goto*//*Label 7595*/ GIMT_Encode4(389443), // Rule ID 1986 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1986,
        GIR_EraseRootFromParent_Done,
      // Label 7595: @389443
      GIM_Try, /*On fail goto*//*Label 7596*/ GIMT_Encode4(389506), // Rule ID 13525 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fmul:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13525,
        GIR_EraseRootFromParent_Done,
      // Label 7596: @389506
      GIM_Try, /*On fail goto*//*Label 7597*/ GIMT_Encode4(389569), // Rule ID 1987 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1987,
        GIR_EraseRootFromParent_Done,
      // Label 7597: @389569
      GIM_Try, /*On fail goto*//*Label 7598*/ GIMT_Encode4(389596), // Rule ID 1307 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (strict_fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMULv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1307,
        GIR_Done,
      // Label 7598: @389596
      GIM_Reject,
    // Label 7593: @389597
    GIM_Reject,
    // Label 7552: @389598
    GIM_Try, /*On fail goto*//*Label 7599*/ GIMT_Encode4(389955),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 7600*/ GIMT_Encode4(389676), // Rule ID 13534 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fmul:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13534,
        GIR_EraseRootFromParent_Done,
      // Label 7600: @389676
      GIM_Try, /*On fail goto*//*Label 7601*/ GIMT_Encode4(389739), // Rule ID 1996 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1996,
        GIR_EraseRootFromParent_Done,
      // Label 7601: @389739
      GIM_Try, /*On fail goto*//*Label 7602*/ GIMT_Encode4(389833), // Rule ID 13994 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fmul:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13994,
        GIR_EraseRootFromParent_Done,
      // Label 7602: @389833
      GIM_Try, /*On fail goto*//*Label 7603*/ GIMT_Encode4(389927), // Rule ID 6292 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6292,
        GIR_EraseRootFromParent_Done,
      // Label 7603: @389927
      GIM_Try, /*On fail goto*//*Label 7604*/ GIMT_Encode4(389954), // Rule ID 1313 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (strict_fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMULv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1313,
        GIR_Done,
      // Label 7604: @389954
      GIM_Reject,
    // Label 7599: @389955
    GIM_Reject,
    // Label 7553: @389956
    GIM_Try, /*On fail goto*//*Label 7605*/ GIMT_Encode4(391680),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 7606*/ GIMT_Encode4(390034), // Rule ID 13528 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fmul:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn)  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13528,
        GIR_EraseRootFromParent_Done,
      // Label 7606: @390034
      GIM_Try, /*On fail goto*//*Label 7607*/ GIMT_Encode4(390097), // Rule ID 1990 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1990,
        GIR_EraseRootFromParent_Done,
      // Label 7607: @390097
      GIM_Try, /*On fail goto*//*Label 7608*/ GIMT_Encode4(390124), // Rule ID 1309 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (strict_fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMULv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv8f16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1309,
        GIR_Done,
      // Label 7608: @390124
      GIM_Try, /*On fail goto*//*Label 7609*/ GIMT_Encode4(390386), // Rule ID 7196 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (strict_fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FMULv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FMULv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
        GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
        GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
        GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
        GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7196,
        GIR_EraseRootFromParent_Done,
      // Label 7609: @390386
      GIM_Try, /*On fail goto*//*Label 7610*/ GIMT_Encode4(390598), // Rule ID 7198 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (strict_fmul:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)  =>  (BFCVTN2:{ *:[v8bf16] } (BFCVTN:{ *:[v8bf16] } (FMULv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] })))), (FMULv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm)))
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/8,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::BFCVTN),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFCVTN2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7198,
        GIR_EraseRootFromParent_Done,
      // Label 7610: @390598
      GIM_Try, /*On fail goto*//*Label 7611*/ GIMT_Encode4(391679), // Rule ID 7200 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoBF16),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (strict_fmul:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8bf16] } (BSPv16i8:{ *:[f128] } (FCMEQv4f32:{ *:[f128] } (FMULv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] }))), (FMULv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] })))), (ADDv4i32:{ *:[f128] } (ADDv4i32:{ *:[f128] } (FMULv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] }))), (ANDv16i8:{ *:[f128] } (USHRv4i32_shift:{ *:[f128] } V128:{ *:[v8bf16] }:$Rn, 16:{ *:[i32] }), (MOVIv4i32:{ *:[f128] } 1:{ *:[i32] }, 0:{ *:[i32] }))), (MOVIv4s_msl:{ *:[f128] } 127:{ *:[i32] }, 264:{ *:[i32] })), (ORRv4i32:{ *:[f128] } (FMULv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] }))), 64:{ *:[i32] }, 16:{ *:[i32] })), (BSPv16i8:{ *:[f128] } (FCMEQv4f32:{ *:[f128] } (FMULv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm)), (FMULv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm))), (ADDv4i32:{ *:[f128] } (ADDv4i32:{ *:[f128] } (FMULv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm)), (ANDv16i8:{ *:[f128] } (USHRv4i32_shift:{ *:[f128] } V128:{ *:[v8bf16] }:$Rn, 16:{ *:[i32] }), (MOVIv4i32:{ *:[f128] } 1:{ *:[i32] }, 0:{ *:[i32] }))), (MOVIv4s_msl:{ *:[f128] } 127:{ *:[i32] }, 264:{ *:[i32] })), (ORRv4i32:{ *:[f128] } (FMULv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm)), 64:{ *:[i32] }, 16:{ *:[i32] })))
        GIR_MakeTempReg, /*TempRegID*/49, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/50, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/50, /*TempRegID*/49, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/50, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/50,
        GIR_MakeTempReg, /*TempRegID*/48, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/49, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/49, /*TempRegID*/48, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/49, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/49,
        GIR_MakeTempReg, /*TempRegID*/47, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/48, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
        GIR_AddTempRegister, /*InsnID*/48, /*TempRegID*/47, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/48, /*TempRegID*/48,
        GIR_AddSimpleTempRegister, /*InsnID*/48, /*TempRegID*/49,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/48,
        GIR_MakeTempReg, /*TempRegID*/46, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/47, /*Opcode*/GIMT_Encode2(AArch64::ORRv4i32),
        GIR_AddTempRegister, /*InsnID*/47, /*TempRegID*/46, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/47, /*TempRegID*/47,
        GIR_AddImm8, /*InsnID*/47, /*Imm*/64,
        GIR_AddImm8, /*InsnID*/47, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/47,
        GIR_MakeTempReg, /*TempRegID*/45, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/46, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4s_msl),
        GIR_AddTempRegister, /*InsnID*/46, /*TempRegID*/45, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/46, /*Imm*/127,
        GIR_AddImm, /*InsnID*/46, /*Imm*/GIMT_Encode8(264),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/46,
        GIR_MakeTempReg, /*TempRegID*/44, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/45, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i32),
        GIR_AddTempRegister, /*InsnID*/45, /*TempRegID*/44, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/45, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/45, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/45,
        GIR_MakeTempReg, /*TempRegID*/43, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/44, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
        GIR_AddTempRegister, /*InsnID*/44, /*TempRegID*/43, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/44, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/44, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/44,
        GIR_MakeTempReg, /*TempRegID*/42, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/43, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
        GIR_AddTempRegister, /*InsnID*/43, /*TempRegID*/42, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/43, /*TempRegID*/43,
        GIR_AddSimpleTempRegister, /*InsnID*/43, /*TempRegID*/44,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/43,
        GIR_MakeTempReg, /*TempRegID*/41, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/42, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/42, /*TempRegID*/41, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/42, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/42,
        GIR_MakeTempReg, /*TempRegID*/40, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/41, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/41, /*TempRegID*/40, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/41, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/41,
        GIR_MakeTempReg, /*TempRegID*/39, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/40, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
        GIR_AddTempRegister, /*InsnID*/40, /*TempRegID*/39, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/40, /*TempRegID*/40,
        GIR_AddSimpleTempRegister, /*InsnID*/40, /*TempRegID*/41,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/40,
        GIR_MakeTempReg, /*TempRegID*/38, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/39, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/39, /*TempRegID*/38, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/39, /*TempRegID*/39,
        GIR_AddSimpleTempRegister, /*InsnID*/39, /*TempRegID*/42,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/39,
        GIR_MakeTempReg, /*TempRegID*/37, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/38, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/38, /*TempRegID*/37, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/38, /*TempRegID*/38,
        GIR_AddSimpleTempRegister, /*InsnID*/38, /*TempRegID*/45,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/38,
        GIR_MakeTempReg, /*TempRegID*/36, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/37, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/37, /*TempRegID*/36, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/37, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/37,
        GIR_MakeTempReg, /*TempRegID*/35, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/36, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/36, /*TempRegID*/35, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/36, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/36,
        GIR_MakeTempReg, /*TempRegID*/34, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/35, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
        GIR_AddTempRegister, /*InsnID*/35, /*TempRegID*/34, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/35, /*TempRegID*/35,
        GIR_AddSimpleTempRegister, /*InsnID*/35, /*TempRegID*/36,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/35,
        GIR_MakeTempReg, /*TempRegID*/33, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/34, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/34, /*TempRegID*/33, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/34, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/34,
        GIR_MakeTempReg, /*TempRegID*/32, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/33, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/33, /*TempRegID*/32, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/33, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/33,
        GIR_MakeTempReg, /*TempRegID*/31, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/32, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
        GIR_AddTempRegister, /*InsnID*/32, /*TempRegID*/31, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/32, /*TempRegID*/32,
        GIR_AddSimpleTempRegister, /*InsnID*/32, /*TempRegID*/33,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/32,
        GIR_MakeTempReg, /*TempRegID*/30, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/31, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
        GIR_AddTempRegister, /*InsnID*/31, /*TempRegID*/30, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/31, /*TempRegID*/31,
        GIR_AddSimpleTempRegister, /*InsnID*/31, /*TempRegID*/34,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/31,
        GIR_MakeTempReg, /*TempRegID*/29, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/30, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_AddTempRegister, /*InsnID*/30, /*TempRegID*/29, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/30, /*TempRegID*/30,
        GIR_AddSimpleTempRegister, /*InsnID*/30, /*TempRegID*/37,
        GIR_AddSimpleTempRegister, /*InsnID*/30, /*TempRegID*/46,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/30,
        GIR_MakeTempReg, /*TempRegID*/28, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/29, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/29, /*TempRegID*/28, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/29, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/29, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/29, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/27, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/28, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/28, /*TempRegID*/27, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/28, /*TempRegID*/28,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/28,
        GIR_MakeTempReg, /*TempRegID*/26, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/27, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/27, /*TempRegID*/26, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/27, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/27, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/27, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/25, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/26, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/26, /*TempRegID*/25, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/26, /*TempRegID*/26,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/26,
        GIR_MakeTempReg, /*TempRegID*/24, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/25, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
        GIR_AddTempRegister, /*InsnID*/25, /*TempRegID*/24, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/25, /*TempRegID*/25,
        GIR_AddSimpleTempRegister, /*InsnID*/25, /*TempRegID*/27,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/25,
        GIR_MakeTempReg, /*TempRegID*/23, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/24, /*Opcode*/GIMT_Encode2(AArch64::ORRv4i32),
        GIR_AddTempRegister, /*InsnID*/24, /*TempRegID*/23, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/24, /*TempRegID*/24,
        GIR_AddImm8, /*InsnID*/24, /*Imm*/64,
        GIR_AddImm8, /*InsnID*/24, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/24,
        GIR_MakeTempReg, /*TempRegID*/22, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/23, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4s_msl),
        GIR_AddTempRegister, /*InsnID*/23, /*TempRegID*/22, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/23, /*Imm*/127,
        GIR_AddImm, /*InsnID*/23, /*Imm*/GIMT_Encode8(264),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/23,
        GIR_MakeTempReg, /*TempRegID*/21, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/22, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i32),
        GIR_AddTempRegister, /*InsnID*/22, /*TempRegID*/21, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/22, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/22, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/22,
        GIR_MakeTempReg, /*TempRegID*/20, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/21, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
        GIR_AddTempRegister, /*InsnID*/21, /*TempRegID*/20, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/21, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/21, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/21,
        GIR_MakeTempReg, /*TempRegID*/19, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/20, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
        GIR_AddTempRegister, /*InsnID*/20, /*TempRegID*/19, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/20, /*TempRegID*/20,
        GIR_AddSimpleTempRegister, /*InsnID*/20, /*TempRegID*/21,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/20,
        GIR_MakeTempReg, /*TempRegID*/18, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/19, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/19, /*TempRegID*/18, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/19, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/19, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/19, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/17, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/18, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/18, /*TempRegID*/17, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/18, /*TempRegID*/18,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/18,
        GIR_MakeTempReg, /*TempRegID*/16, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/17, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/17, /*TempRegID*/16, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/17, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/17, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/17, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/15, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/16, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/16, /*TempRegID*/15, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/16, /*TempRegID*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/16,
        GIR_MakeTempReg, /*TempRegID*/14, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/15, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
        GIR_AddTempRegister, /*InsnID*/15, /*TempRegID*/14, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/15, /*TempRegID*/15,
        GIR_AddSimpleTempRegister, /*InsnID*/15, /*TempRegID*/17,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/15,
        GIR_MakeTempReg, /*TempRegID*/13, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/14, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/14, /*TempRegID*/13, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/14,
        GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/19,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/14,
        GIR_MakeTempReg, /*TempRegID*/12, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/13, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/13, /*TempRegID*/12, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/13, /*TempRegID*/13,
        GIR_AddSimpleTempRegister, /*InsnID*/13, /*TempRegID*/22,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/13,
        GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/11, /*TempRegID*/11,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
        GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
        GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/10,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/12,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/23,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/29,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7200,
        GIR_EraseRootFromParent_Done,
      // Label 7611: @391679
      GIM_Reject,
    // Label 7605: @391680
    GIM_Reject,
    // Label 7554: @391681
    GIM_Reject,
    // Label 101: @391682
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7620*/ GIMT_Encode4(393574),
    /*GILLT_s16*//*Label 7612*/ GIMT_Encode4(391733),
    /*GILLT_s32*//*Label 7613*/ GIMT_Encode4(391771),
    /*GILLT_s64*//*Label 7614*/ GIMT_Encode4(391809), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 7615*/ GIMT_Encode4(391847),
    /*GILLT_v2s64*//*Label 7616*/ GIMT_Encode4(391885),
    /*GILLT_v4s16*//*Label 7617*/ GIMT_Encode4(391923),
    /*GILLT_v4s32*//*Label 7618*/ GIMT_Encode4(391961), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 7619*/ GIMT_Encode4(391999),
    // Label 7612: @391733
    GIM_Try, /*On fail goto*//*Label 7621*/ GIMT_Encode4(391770), // Rule ID 585 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // (strict_fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FDIVHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVHrr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 585,
      GIR_Done,
    // Label 7621: @391770
    GIM_Reject,
    // Label 7613: @391771
    GIM_Try, /*On fail goto*//*Label 7622*/ GIMT_Encode4(391808), // Rule ID 587 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      // (strict_fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FDIVSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVSrr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 587,
      GIR_Done,
    // Label 7622: @391808
    GIM_Reject,
    // Label 7614: @391809
    GIM_Try, /*On fail goto*//*Label 7623*/ GIMT_Encode4(391846), // Rule ID 589 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (strict_fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FDIVDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVDrr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 589,
      GIR_Done,
    // Label 7623: @391846
    GIM_Reject,
    // Label 7615: @391847
    GIM_Try, /*On fail goto*//*Label 7624*/ GIMT_Encode4(391884), // Rule ID 1216 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (strict_fdiv:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FDIVv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1216,
      GIR_Done,
    // Label 7624: @391884
    GIM_Reject,
    // Label 7616: @391885
    GIM_Try, /*On fail goto*//*Label 7625*/ GIMT_Encode4(391922), // Rule ID 1220 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (strict_fdiv:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FDIVv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f64),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1220,
      GIR_Done,
    // Label 7625: @391922
    GIM_Reject,
    // Label 7617: @391923
    GIM_Try, /*On fail goto*//*Label 7626*/ GIMT_Encode4(391960), // Rule ID 1212 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (strict_fdiv:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FDIVv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1212,
      GIR_Done,
    // Label 7626: @391960
    GIM_Reject,
    // Label 7618: @391961
    GIM_Try, /*On fail goto*//*Label 7627*/ GIMT_Encode4(391998), // Rule ID 1218 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (strict_fdiv:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FDIVv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1218,
      GIR_Done,
    // Label 7627: @391998
    GIM_Reject,
    // Label 7619: @391999
    GIM_Try, /*On fail goto*//*Label 7628*/ GIMT_Encode4(393573),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 7629*/ GIMT_Encode4(392041), // Rule ID 1214 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        // (strict_fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FDIVv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv8f16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1214,
        GIR_Done,
      // Label 7629: @392041
      GIM_Try, /*On fail goto*//*Label 7630*/ GIMT_Encode4(392295), // Rule ID 7190 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
        // (strict_fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FDIVv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FDIVv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
        GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
        GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
        GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
        GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7190,
        GIR_EraseRootFromParent_Done,
      // Label 7630: @392295
      GIM_Try, /*On fail goto*//*Label 7631*/ GIMT_Encode4(392499), // Rule ID 7192 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16),
        // (strict_fdiv:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)  =>  (BFCVTN2:{ *:[v8bf16] } (BFCVTN:{ *:[v8bf16] } (FDIVv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] })))), (FDIVv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm)))
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/8,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::BFCVTN),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFCVTN2),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7192,
        GIR_EraseRootFromParent_Done,
      // Label 7631: @392499
      GIM_Try, /*On fail goto*//*Label 7632*/ GIMT_Encode4(393572), // Rule ID 7194 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoBF16),
        // (strict_fdiv:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8bf16] } (BSPv16i8:{ *:[f128] } (FCMEQv4f32:{ *:[f128] } (FDIVv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] }))), (FDIVv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] })))), (ADDv4i32:{ *:[f128] } (ADDv4i32:{ *:[f128] } (FDIVv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] }))), (ANDv16i8:{ *:[f128] } (USHRv4i32_shift:{ *:[f128] } V128:{ *:[v8bf16] }:$Rn, 16:{ *:[i32] }), (MOVIv4i32:{ *:[f128] } 1:{ *:[i32] }, 0:{ *:[i32] }))), (MOVIv4s_msl:{ *:[f128] } 127:{ *:[i32] }, 264:{ *:[i32] })), (ORRv4i32:{ *:[f128] } (FDIVv4f32:{ *:[v4f32] } (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rn, dsub:{ *:[i32] })), (SHLLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8bf16] }:$Rm, dsub:{ *:[i32] }))), 64:{ *:[i32] }, 16:{ *:[i32] })), (BSPv16i8:{ *:[f128] } (FCMEQv4f32:{ *:[f128] } (FDIVv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm)), (FDIVv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm))), (ADDv4i32:{ *:[f128] } (ADDv4i32:{ *:[f128] } (FDIVv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm)), (ANDv16i8:{ *:[f128] } (USHRv4i32_shift:{ *:[f128] } V128:{ *:[v8bf16] }:$Rn, 16:{ *:[i32] }), (MOVIv4i32:{ *:[f128] } 1:{ *:[i32] }, 0:{ *:[i32] }))), (MOVIv4s_msl:{ *:[f128] } 127:{ *:[i32] }, 264:{ *:[i32] })), (ORRv4i32:{ *:[f128] } (FDIVv4f32:{ *:[v4f32] } (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rn), (SHLLv8i16:{ *:[v4f32] } V128:{ *:[v8bf16] }:$Rm)), 64:{ *:[i32] }, 16:{ *:[i32] })))
        GIR_MakeTempReg, /*TempRegID*/49, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/50, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/50, /*TempRegID*/49, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/50, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/50,
        GIR_MakeTempReg, /*TempRegID*/48, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/49, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/49, /*TempRegID*/48, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/49, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/49,
        GIR_MakeTempReg, /*TempRegID*/47, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/48, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
        GIR_AddTempRegister, /*InsnID*/48, /*TempRegID*/47, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/48, /*TempRegID*/48,
        GIR_AddSimpleTempRegister, /*InsnID*/48, /*TempRegID*/49,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/48,
        GIR_MakeTempReg, /*TempRegID*/46, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/47, /*Opcode*/GIMT_Encode2(AArch64::ORRv4i32),
        GIR_AddTempRegister, /*InsnID*/47, /*TempRegID*/46, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/47, /*TempRegID*/47,
        GIR_AddImm8, /*InsnID*/47, /*Imm*/64,
        GIR_AddImm8, /*InsnID*/47, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/47,
        GIR_MakeTempReg, /*TempRegID*/45, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/46, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4s_msl),
        GIR_AddTempRegister, /*InsnID*/46, /*TempRegID*/45, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/46, /*Imm*/127,
        GIR_AddImm, /*InsnID*/46, /*Imm*/GIMT_Encode8(264),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/46,
        GIR_MakeTempReg, /*TempRegID*/44, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/45, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i32),
        GIR_AddTempRegister, /*InsnID*/45, /*TempRegID*/44, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/45, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/45, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/45,
        GIR_MakeTempReg, /*TempRegID*/43, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/44, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
        GIR_AddTempRegister, /*InsnID*/44, /*TempRegID*/43, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/44, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/44, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/44,
        GIR_MakeTempReg, /*TempRegID*/42, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/43, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
        GIR_AddTempRegister, /*InsnID*/43, /*TempRegID*/42, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/43, /*TempRegID*/43,
        GIR_AddSimpleTempRegister, /*InsnID*/43, /*TempRegID*/44,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/43,
        GIR_MakeTempReg, /*TempRegID*/41, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/42, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/42, /*TempRegID*/41, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/42, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/42,
        GIR_MakeTempReg, /*TempRegID*/40, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/41, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/41, /*TempRegID*/40, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/41, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/41,
        GIR_MakeTempReg, /*TempRegID*/39, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/40, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
        GIR_AddTempRegister, /*InsnID*/40, /*TempRegID*/39, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/40, /*TempRegID*/40,
        GIR_AddSimpleTempRegister, /*InsnID*/40, /*TempRegID*/41,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/40,
        GIR_MakeTempReg, /*TempRegID*/38, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/39, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/39, /*TempRegID*/38, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/39, /*TempRegID*/39,
        GIR_AddSimpleTempRegister, /*InsnID*/39, /*TempRegID*/42,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/39,
        GIR_MakeTempReg, /*TempRegID*/37, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/38, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/38, /*TempRegID*/37, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/38, /*TempRegID*/38,
        GIR_AddSimpleTempRegister, /*InsnID*/38, /*TempRegID*/45,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/38,
        GIR_MakeTempReg, /*TempRegID*/36, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/37, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/37, /*TempRegID*/36, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/37, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/37,
        GIR_MakeTempReg, /*TempRegID*/35, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/36, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/36, /*TempRegID*/35, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/36, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/36,
        GIR_MakeTempReg, /*TempRegID*/34, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/35, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
        GIR_AddTempRegister, /*InsnID*/35, /*TempRegID*/34, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/35, /*TempRegID*/35,
        GIR_AddSimpleTempRegister, /*InsnID*/35, /*TempRegID*/36,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/35,
        GIR_MakeTempReg, /*TempRegID*/33, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/34, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/34, /*TempRegID*/33, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/34, /*OldInsnID*/0, /*OpIdx*/2, // Rm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/34,
        GIR_MakeTempReg, /*TempRegID*/32, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/33, /*Opcode*/GIMT_Encode2(AArch64::SHLLv8i16),
        GIR_AddTempRegister, /*InsnID*/33, /*TempRegID*/32, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/33, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_ConstrainSelectedInstOperands, /*InsnID*/33,
        GIR_MakeTempReg, /*TempRegID*/31, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/32, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
        GIR_AddTempRegister, /*InsnID*/32, /*TempRegID*/31, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/32, /*TempRegID*/32,
        GIR_AddSimpleTempRegister, /*InsnID*/32, /*TempRegID*/33,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/32,
        GIR_MakeTempReg, /*TempRegID*/30, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/31, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
        GIR_AddTempRegister, /*InsnID*/31, /*TempRegID*/30, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/31, /*TempRegID*/31,
        GIR_AddSimpleTempRegister, /*InsnID*/31, /*TempRegID*/34,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/31,
        GIR_MakeTempReg, /*TempRegID*/29, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/30, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_AddTempRegister, /*InsnID*/30, /*TempRegID*/29, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/30, /*TempRegID*/30,
        GIR_AddSimpleTempRegister, /*InsnID*/30, /*TempRegID*/37,
        GIR_AddSimpleTempRegister, /*InsnID*/30, /*TempRegID*/46,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/30,
        GIR_MakeTempReg, /*TempRegID*/28, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/29, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/29, /*TempRegID*/28, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/29, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/29, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/29, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/27, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/28, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/28, /*TempRegID*/27, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/28, /*TempRegID*/28,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/28,
        GIR_MakeTempReg, /*TempRegID*/26, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/27, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/27, /*TempRegID*/26, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/27, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/27, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/27, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/25, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/26, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/26, /*TempRegID*/25, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/26, /*TempRegID*/26,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/26,
        GIR_MakeTempReg, /*TempRegID*/24, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/25, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
        GIR_AddTempRegister, /*InsnID*/25, /*TempRegID*/24, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/25, /*TempRegID*/25,
        GIR_AddSimpleTempRegister, /*InsnID*/25, /*TempRegID*/27,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/25,
        GIR_MakeTempReg, /*TempRegID*/23, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/24, /*Opcode*/GIMT_Encode2(AArch64::ORRv4i32),
        GIR_AddTempRegister, /*InsnID*/24, /*TempRegID*/23, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/24, /*TempRegID*/24,
        GIR_AddImm8, /*InsnID*/24, /*Imm*/64,
        GIR_AddImm8, /*InsnID*/24, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/24,
        GIR_MakeTempReg, /*TempRegID*/22, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/23, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4s_msl),
        GIR_AddTempRegister, /*InsnID*/23, /*TempRegID*/22, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/23, /*Imm*/127,
        GIR_AddImm, /*InsnID*/23, /*Imm*/GIMT_Encode8(264),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/23,
        GIR_MakeTempReg, /*TempRegID*/21, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/22, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i32),
        GIR_AddTempRegister, /*InsnID*/22, /*TempRegID*/21, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/22, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/22, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/22,
        GIR_MakeTempReg, /*TempRegID*/20, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/21, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
        GIR_AddTempRegister, /*InsnID*/21, /*TempRegID*/20, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/21, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/21, /*Imm*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/21,
        GIR_MakeTempReg, /*TempRegID*/19, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/20, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
        GIR_AddTempRegister, /*InsnID*/20, /*TempRegID*/19, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/20, /*TempRegID*/20,
        GIR_AddSimpleTempRegister, /*InsnID*/20, /*TempRegID*/21,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/20,
        GIR_MakeTempReg, /*TempRegID*/18, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/19, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/19, /*TempRegID*/18, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/19, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/19, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/19, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/17, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/18, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/18, /*TempRegID*/17, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/18, /*TempRegID*/18,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/18,
        GIR_MakeTempReg, /*TempRegID*/16, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/17, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/17, /*TempRegID*/16, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/17, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/17, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/17, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/15, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/16, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/16, /*TempRegID*/15, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/16, /*TempRegID*/16,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/16,
        GIR_MakeTempReg, /*TempRegID*/14, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/15, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
        GIR_AddTempRegister, /*InsnID*/15, /*TempRegID*/14, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/15, /*TempRegID*/15,
        GIR_AddSimpleTempRegister, /*InsnID*/15, /*TempRegID*/17,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/15,
        GIR_MakeTempReg, /*TempRegID*/13, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/14, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/14, /*TempRegID*/13, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/14,
        GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/19,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/14,
        GIR_MakeTempReg, /*TempRegID*/12, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/13, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
        GIR_AddTempRegister, /*InsnID*/13, /*TempRegID*/12, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/13, /*TempRegID*/13,
        GIR_AddSimpleTempRegister, /*InsnID*/13, /*TempRegID*/22,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/13,
        GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/11, /*TempRegID*/11,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
        GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
        GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/10,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s16,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SHLLv4i16),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/12,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/23,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/29,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7194,
        GIR_EraseRootFromParent_Done,
      // Label 7632: @393572
      GIM_Reject,
    // Label 7628: @393573
    GIM_Reject,
    // Label 7620: @393574
    GIM_Reject,
    // Label 102: @393575
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7641*/ GIMT_Encode4(409181),
    /*GILLT_s16*//*Label 7633*/ GIMT_Encode4(393626),
    /*GILLT_s32*//*Label 7634*/ GIMT_Encode4(396400),
    /*GILLT_s64*//*Label 7635*/ GIMT_Encode4(399330), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 7636*/ GIMT_Encode4(402260),
    /*GILLT_v2s64*//*Label 7637*/ GIMT_Encode4(403781),
    /*GILLT_v4s16*//*Label 7638*/ GIMT_Encode4(405302),
    /*GILLT_v4s32*//*Label 7639*/ GIMT_Encode4(406481), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 7640*/ GIMT_Encode4(408002),
    // Label 7633: @393626
    GIM_Try, /*On fail goto*//*Label 7642*/ GIMT_Encode4(396399),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_Try, /*On fail goto*//*Label 7643*/ GIMT_Encode4(393794), // Rule ID 4897 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4897,
        GIR_EraseRootFromParent_Done,
      // Label 7643: @393794
      GIM_Try, /*On fail goto*//*Label 7644*/ GIMT_Encode4(393941), // Rule ID 4861 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4861,
        GIR_EraseRootFromParent_Done,
      // Label 7644: @393941
      GIM_Try, /*On fail goto*//*Label 7645*/ GIMT_Encode4(394088), // Rule ID 13936 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13936,
        GIR_EraseRootFromParent_Done,
      // Label 7645: @394088
      GIM_Try, /*On fail goto*//*Label 7646*/ GIMT_Encode4(394219), // Rule ID 6122 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[4] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6122,
        GIR_EraseRootFromParent_Done,
      // Label 7646: @394219
      GIM_Try, /*On fail goto*//*Label 7647*/ GIMT_Encode4(394350), // Rule ID 6154 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6154,
        GIR_EraseRootFromParent_Done,
      // Label 7647: @394350
      GIM_Try, /*On fail goto*//*Label 7648*/ GIMT_Encode4(394481), // Rule ID 6218 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[4] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6218,
        GIR_EraseRootFromParent_Done,
      // Label 7648: @394481
      GIM_Try, /*On fail goto*//*Label 7649*/ GIMT_Encode4(394612), // Rule ID 6186 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6186,
        GIR_EraseRootFromParent_Done,
      // Label 7649: @394612
      GIM_Try, /*On fail goto*//*Label 7650*/ GIMT_Encode4(394747), // Rule ID 2424 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2424,
        GIR_EraseRootFromParent_Done,
      // Label 7650: @394747
      GIM_Try, /*On fail goto*//*Label 7651*/ GIMT_Encode4(394866), // Rule ID 6090 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6090,
        GIR_EraseRootFromParent_Done,
      // Label 7651: @394866
      GIM_Try, /*On fail goto*//*Label 7652*/ GIMT_Encode4(394985), // Rule ID 2496 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2496,
        GIR_EraseRootFromParent_Done,
      // Label 7652: @394985
      GIM_Try, /*On fail goto*//*Label 7653*/ GIMT_Encode4(395085), // Rule ID 4859 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4859,
        GIR_EraseRootFromParent_Done,
      // Label 7653: @395085
      GIM_Try, /*On fail goto*//*Label 7654*/ GIMT_Encode4(395185), // Rule ID 4895 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4895,
        GIR_EraseRootFromParent_Done,
      // Label 7654: @395185
      GIM_Try, /*On fail goto*//*Label 7655*/ GIMT_Encode4(395282), // Rule ID 13932 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13932,
        GIR_EraseRootFromParent_Done,
      // Label 7655: @395282
      GIM_Try, /*On fail goto*//*Label 7656*/ GIMT_Encode4(395382), // Rule ID 13934 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13934,
        GIR_EraseRootFromParent_Done,
      // Label 7656: @395382
      GIM_Try, /*On fail goto*//*Label 7657*/ GIMT_Encode4(395482), // Rule ID 4893 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4893,
        GIR_EraseRootFromParent_Done,
      // Label 7657: @395482
      GIM_Try, /*On fail goto*//*Label 7658*/ GIMT_Encode4(395579), // Rule ID 4857 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4857,
        GIR_EraseRootFromParent_Done,
      // Label 7658: @395579
      GIM_Try, /*On fail goto*//*Label 7659*/ GIMT_Encode4(395663), // Rule ID 6152 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6152,
        GIR_EraseRootFromParent_Done,
      // Label 7659: @395663
      GIM_Try, /*On fail goto*//*Label 7660*/ GIMT_Encode4(395744), // Rule ID 6184 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6184,
        GIR_EraseRootFromParent_Done,
      // Label 7660: @395744
      GIM_Try, /*On fail goto*//*Label 7661*/ GIMT_Encode4(395828), // Rule ID 6216 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6216,
        GIR_EraseRootFromParent_Done,
      // Label 7661: @395828
      GIM_Try, /*On fail goto*//*Label 7662*/ GIMT_Encode4(395909), // Rule ID 6120 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6120,
        GIR_EraseRootFromParent_Done,
      // Label 7662: @395909
      GIM_Try, /*On fail goto*//*Label 7663*/ GIMT_Encode4(395994), // Rule ID 2422 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2422,
        GIR_EraseRootFromParent_Done,
      // Label 7663: @395994
      GIM_Try, /*On fail goto*//*Label 7664*/ GIMT_Encode4(396079), // Rule ID 2420 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2420,
        GIR_EraseRootFromParent_Done,
      // Label 7664: @396079
      GIM_Try, /*On fail goto*//*Label 7665*/ GIMT_Encode4(396148), // Rule ID 2494 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2494,
        GIR_EraseRootFromParent_Done,
      // Label 7665: @396148
      GIM_Try, /*On fail goto*//*Label 7666*/ GIMT_Encode4(396217), // Rule ID 6088 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6088,
        GIR_EraseRootFromParent_Done,
      // Label 7666: @396217
      GIM_Try, /*On fail goto*//*Label 7667*/ GIMT_Encode4(396267), // Rule ID 13378 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13378,
        GIR_EraseRootFromParent_Done,
      // Label 7667: @396267
      GIM_Try, /*On fail goto*//*Label 7668*/ GIMT_Encode4(396317), // Rule ID 639 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 639,
        GIR_EraseRootFromParent_Done,
      // Label 7668: @396317
      GIM_Try, /*On fail goto*//*Label 7669*/ GIMT_Encode4(396367), // Rule ID 651 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 651,
        GIR_EraseRootFromParent_Done,
      // Label 7669: @396367
      GIM_Try, /*On fail goto*//*Label 7670*/ GIMT_Encode4(396398), // Rule ID 633 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
        // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 633,
        GIR_Done,
      // Label 7670: @396398
      GIM_Reject,
    // Label 7642: @396399
    GIM_Reject,
    // Label 7634: @396400
    GIM_Try, /*On fail goto*//*Label 7671*/ GIMT_Encode4(399329),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 7672*/ GIMT_Encode4(396568), // Rule ID 4903 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4903,
        GIR_EraseRootFromParent_Done,
      // Label 7672: @396568
      GIM_Try, /*On fail goto*//*Label 7673*/ GIMT_Encode4(396715), // Rule ID 4867 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4867,
        GIR_EraseRootFromParent_Done,
      // Label 7673: @396715
      GIM_Try, /*On fail goto*//*Label 7674*/ GIMT_Encode4(396862), // Rule ID 13942 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13942,
        GIR_EraseRootFromParent_Done,
      // Label 7674: @396862
      GIM_Try, /*On fail goto*//*Label 7675*/ GIMT_Encode4(396993), // Rule ID 6138 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[4] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6138,
        GIR_EraseRootFromParent_Done,
      // Label 7675: @396993
      GIM_Try, /*On fail goto*//*Label 7676*/ GIMT_Encode4(397124), // Rule ID 6170 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6170,
        GIR_EraseRootFromParent_Done,
      // Label 7676: @397124
      GIM_Try, /*On fail goto*//*Label 7677*/ GIMT_Encode4(397255), // Rule ID 6234 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[4] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6234,
        GIR_EraseRootFromParent_Done,
      // Label 7677: @397255
      GIM_Try, /*On fail goto*//*Label 7678*/ GIMT_Encode4(397386), // Rule ID 6202 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6202,
        GIR_EraseRootFromParent_Done,
      // Label 7678: @397386
      GIM_Try, /*On fail goto*//*Label 7679*/ GIMT_Encode4(397521), // Rule ID 2430 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2430,
        GIR_EraseRootFromParent_Done,
      // Label 7679: @397521
      GIM_Try, /*On fail goto*//*Label 7680*/ GIMT_Encode4(397640), // Rule ID 6106 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6106,
        GIR_EraseRootFromParent_Done,
      // Label 7680: @397640
      GIM_Try, /*On fail goto*//*Label 7681*/ GIMT_Encode4(397759), // Rule ID 2512 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2512,
        GIR_EraseRootFromParent_Done,
      // Label 7681: @397759
      GIM_Try, /*On fail goto*//*Label 7682*/ GIMT_Encode4(397859), // Rule ID 4865 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4865,
        GIR_EraseRootFromParent_Done,
      // Label 7682: @397859
      GIM_Try, /*On fail goto*//*Label 7683*/ GIMT_Encode4(397959), // Rule ID 4901 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4901,
        GIR_EraseRootFromParent_Done,
      // Label 7683: @397959
      GIM_Try, /*On fail goto*//*Label 7684*/ GIMT_Encode4(398056), // Rule ID 13938 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13938,
        GIR_EraseRootFromParent_Done,
      // Label 7684: @398056
      GIM_Try, /*On fail goto*//*Label 7685*/ GIMT_Encode4(398156), // Rule ID 13940 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13940,
        GIR_EraseRootFromParent_Done,
      // Label 7685: @398156
      GIM_Try, /*On fail goto*//*Label 7686*/ GIMT_Encode4(398256), // Rule ID 4899 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4899,
        GIR_EraseRootFromParent_Done,
      // Label 7686: @398256
      GIM_Try, /*On fail goto*//*Label 7687*/ GIMT_Encode4(398353), // Rule ID 4863 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4863,
        GIR_EraseRootFromParent_Done,
      // Label 7687: @398353
      GIM_Try, /*On fail goto*//*Label 7688*/ GIMT_Encode4(398431), // Rule ID 6256 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6256,
        GIR_EraseRootFromParent_Done,
      // Label 7688: @398431
      GIM_Try, /*On fail goto*//*Label 7689*/ GIMT_Encode4(398515), // Rule ID 6168 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6168,
        GIR_EraseRootFromParent_Done,
      // Label 7689: @398515
      GIM_Try, /*On fail goto*//*Label 7690*/ GIMT_Encode4(398596), // Rule ID 6200 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6200,
        GIR_EraseRootFromParent_Done,
      // Label 7690: @398596
      GIM_Try, /*On fail goto*//*Label 7691*/ GIMT_Encode4(398680), // Rule ID 6232 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6232,
        GIR_EraseRootFromParent_Done,
      // Label 7691: @398680
      GIM_Try, /*On fail goto*//*Label 7692*/ GIMT_Encode4(398758), // Rule ID 6278 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6278,
        GIR_EraseRootFromParent_Done,
      // Label 7692: @398758
      GIM_Try, /*On fail goto*//*Label 7693*/ GIMT_Encode4(398839), // Rule ID 6136 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6136,
        GIR_EraseRootFromParent_Done,
      // Label 7693: @398839
      GIM_Try, /*On fail goto*//*Label 7694*/ GIMT_Encode4(398924), // Rule ID 2428 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2428,
        GIR_EraseRootFromParent_Done,
      // Label 7694: @398924
      GIM_Try, /*On fail goto*//*Label 7695*/ GIMT_Encode4(399009), // Rule ID 2426 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2426,
        GIR_EraseRootFromParent_Done,
      // Label 7695: @399009
      GIM_Try, /*On fail goto*//*Label 7696*/ GIMT_Encode4(399078), // Rule ID 2510 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2510,
        GIR_EraseRootFromParent_Done,
      // Label 7696: @399078
      GIM_Try, /*On fail goto*//*Label 7697*/ GIMT_Encode4(399147), // Rule ID 6104 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6104,
        GIR_EraseRootFromParent_Done,
      // Label 7697: @399147
      GIM_Try, /*On fail goto*//*Label 7698*/ GIMT_Encode4(399197), // Rule ID 13380 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13380,
        GIR_EraseRootFromParent_Done,
      // Label 7698: @399197
      GIM_Try, /*On fail goto*//*Label 7699*/ GIMT_Encode4(399247), // Rule ID 641 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 641,
        GIR_EraseRootFromParent_Done,
      // Label 7699: @399247
      GIM_Try, /*On fail goto*//*Label 7700*/ GIMT_Encode4(399297), // Rule ID 653 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 653,
        GIR_EraseRootFromParent_Done,
      // Label 7700: @399297
      GIM_Try, /*On fail goto*//*Label 7701*/ GIMT_Encode4(399328), // Rule ID 635 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 635,
        GIR_Done,
      // Label 7701: @399328
      GIM_Reject,
    // Label 7671: @399329
    GIM_Reject,
    // Label 7635: @399330
    GIM_Try, /*On fail goto*//*Label 7702*/ GIMT_Encode4(402259),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 7703*/ GIMT_Encode4(399498), // Rule ID 4909 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4909,
        GIR_EraseRootFromParent_Done,
      // Label 7703: @399498
      GIM_Try, /*On fail goto*//*Label 7704*/ GIMT_Encode4(399645), // Rule ID 4873 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4873,
        GIR_EraseRootFromParent_Done,
      // Label 7704: @399645
      GIM_Try, /*On fail goto*//*Label 7705*/ GIMT_Encode4(399792), // Rule ID 13948 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13948,
        GIR_EraseRootFromParent_Done,
      // Label 7705: @399792
      GIM_Try, /*On fail goto*//*Label 7706*/ GIMT_Encode4(399923), // Rule ID 6142 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[4] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6142,
        GIR_EraseRootFromParent_Done,
      // Label 7706: @399923
      GIM_Try, /*On fail goto*//*Label 7707*/ GIMT_Encode4(400054), // Rule ID 6174 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6174,
        GIR_EraseRootFromParent_Done,
      // Label 7707: @400054
      GIM_Try, /*On fail goto*//*Label 7708*/ GIMT_Encode4(400185), // Rule ID 6238 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[4] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6238,
        GIR_EraseRootFromParent_Done,
      // Label 7708: @400185
      GIM_Try, /*On fail goto*//*Label 7709*/ GIMT_Encode4(400316), // Rule ID 6206 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6206,
        GIR_EraseRootFromParent_Done,
      // Label 7709: @400316
      GIM_Try, /*On fail goto*//*Label 7710*/ GIMT_Encode4(400451), // Rule ID 2436 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2436,
        GIR_EraseRootFromParent_Done,
      // Label 7710: @400451
      GIM_Try, /*On fail goto*//*Label 7711*/ GIMT_Encode4(400570), // Rule ID 6110 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6110,
        GIR_EraseRootFromParent_Done,
      // Label 7711: @400570
      GIM_Try, /*On fail goto*//*Label 7712*/ GIMT_Encode4(400689), // Rule ID 2516 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2516,
        GIR_EraseRootFromParent_Done,
      // Label 7712: @400689
      GIM_Try, /*On fail goto*//*Label 7713*/ GIMT_Encode4(400789), // Rule ID 4871 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4871,
        GIR_EraseRootFromParent_Done,
      // Label 7713: @400789
      GIM_Try, /*On fail goto*//*Label 7714*/ GIMT_Encode4(400889), // Rule ID 4907 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4907,
        GIR_EraseRootFromParent_Done,
      // Label 7714: @400889
      GIM_Try, /*On fail goto*//*Label 7715*/ GIMT_Encode4(400986), // Rule ID 13944 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13944,
        GIR_EraseRootFromParent_Done,
      // Label 7715: @400986
      GIM_Try, /*On fail goto*//*Label 7716*/ GIMT_Encode4(401086), // Rule ID 13946 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13946,
        GIR_EraseRootFromParent_Done,
      // Label 7716: @401086
      GIM_Try, /*On fail goto*//*Label 7717*/ GIMT_Encode4(401186), // Rule ID 4905 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4905,
        GIR_EraseRootFromParent_Done,
      // Label 7717: @401186
      GIM_Try, /*On fail goto*//*Label 7718*/ GIMT_Encode4(401283), // Rule ID 4869 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4869,
        GIR_EraseRootFromParent_Done,
      // Label 7718: @401283
      GIM_Try, /*On fail goto*//*Label 7719*/ GIMT_Encode4(401361), // Rule ID 6260 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6260,
        GIR_EraseRootFromParent_Done,
      // Label 7719: @401361
      GIM_Try, /*On fail goto*//*Label 7720*/ GIMT_Encode4(401445), // Rule ID 6172 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6172,
        GIR_EraseRootFromParent_Done,
      // Label 7720: @401445
      GIM_Try, /*On fail goto*//*Label 7721*/ GIMT_Encode4(401526), // Rule ID 6204 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6204,
        GIR_EraseRootFromParent_Done,
      // Label 7721: @401526
      GIM_Try, /*On fail goto*//*Label 7722*/ GIMT_Encode4(401610), // Rule ID 6236 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6236,
        GIR_EraseRootFromParent_Done,
      // Label 7722: @401610
      GIM_Try, /*On fail goto*//*Label 7723*/ GIMT_Encode4(401688), // Rule ID 6282 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6282,
        GIR_EraseRootFromParent_Done,
      // Label 7723: @401688
      GIM_Try, /*On fail goto*//*Label 7724*/ GIMT_Encode4(401769), // Rule ID 6140 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6140,
        GIR_EraseRootFromParent_Done,
      // Label 7724: @401769
      GIM_Try, /*On fail goto*//*Label 7725*/ GIMT_Encode4(401854), // Rule ID 2434 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2434,
        GIR_EraseRootFromParent_Done,
      // Label 7725: @401854
      GIM_Try, /*On fail goto*//*Label 7726*/ GIMT_Encode4(401939), // Rule ID 2432 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2432,
        GIR_EraseRootFromParent_Done,
      // Label 7726: @401939
      GIM_Try, /*On fail goto*//*Label 7727*/ GIMT_Encode4(402008), // Rule ID 2514 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2514,
        GIR_EraseRootFromParent_Done,
      // Label 7727: @402008
      GIM_Try, /*On fail goto*//*Label 7728*/ GIMT_Encode4(402077), // Rule ID 6108 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6108,
        GIR_EraseRootFromParent_Done,
      // Label 7728: @402077
      GIM_Try, /*On fail goto*//*Label 7729*/ GIMT_Encode4(402127), // Rule ID 13382 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13382,
        GIR_EraseRootFromParent_Done,
      // Label 7729: @402127
      GIM_Try, /*On fail goto*//*Label 7730*/ GIMT_Encode4(402177), // Rule ID 643 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootToRootCopy, /*OpIdx*/3, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 643,
        GIR_EraseRootFromParent_Done,
      // Label 7730: @402177
      GIM_Try, /*On fail goto*//*Label 7731*/ GIMT_Encode4(402227), // Rule ID 655 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 655,
        GIR_EraseRootFromParent_Done,
      // Label 7731: @402227
      GIM_Try, /*On fail goto*//*Label 7732*/ GIMT_Encode4(402258), // Rule ID 637 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 637,
        GIR_Done,
      // Label 7732: @402258
      GIM_Reject,
    // Label 7702: @402259
    GIM_Reject,
    // Label 7636: @402260
    GIM_Try, /*On fail goto*//*Label 7733*/ GIMT_Encode4(403780),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 7734*/ GIMT_Encode4(402356), // Rule ID 6240 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6240,
        GIR_EraseRootFromParent_Done,
      // Label 7734: @402356
      GIM_Try, /*On fail goto*//*Label 7735*/ GIMT_Encode4(402440), // Rule ID 6156 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6156,
        GIR_EraseRootFromParent_Done,
      // Label 7735: @402440
      GIM_Try, /*On fail goto*//*Label 7736*/ GIMT_Encode4(402521), // Rule ID 6188 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6188,
        GIR_EraseRootFromParent_Done,
      // Label 7736: @402521
      GIM_Try, /*On fail goto*//*Label 7737*/ GIMT_Encode4(402605), // Rule ID 6220 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6220,
        GIR_EraseRootFromParent_Done,
      // Label 7737: @402605
      GIM_Try, /*On fail goto*//*Label 7738*/ GIMT_Encode4(402683), // Rule ID 6262 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6262,
        GIR_EraseRootFromParent_Done,
      // Label 7738: @402683
      GIM_Try, /*On fail goto*//*Label 7739*/ GIMT_Encode4(402764), // Rule ID 6124 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6124,
        GIR_EraseRootFromParent_Done,
      // Label 7739: @402764
      GIM_Try, /*On fail goto*//*Label 7740*/ GIMT_Encode4(402833), // Rule ID 2498 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2498,
        GIR_EraseRootFromParent_Done,
      // Label 7740: @402833
      GIM_Try, /*On fail goto*//*Label 7741*/ GIMT_Encode4(402902), // Rule ID 6092 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6092,
        GIR_EraseRootFromParent_Done,
      // Label 7741: @402902
      GIM_Try, /*On fail goto*//*Label 7742*/ GIMT_Encode4(402995), // Rule ID 6244 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6244,
        GIR_EraseRootFromParent_Done,
      // Label 7742: @402995
      GIM_Try, /*On fail goto*//*Label 7743*/ GIMT_Encode4(403094), // Rule ID 6158 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6158,
        GIR_EraseRootFromParent_Done,
      // Label 7743: @403094
      GIM_Try, /*On fail goto*//*Label 7744*/ GIMT_Encode4(403190), // Rule ID 6190 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6190,
        GIR_EraseRootFromParent_Done,
      // Label 7744: @403190
      GIM_Try, /*On fail goto*//*Label 7745*/ GIMT_Encode4(403289), // Rule ID 6222 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6222,
        GIR_EraseRootFromParent_Done,
      // Label 7745: @403289
      GIM_Try, /*On fail goto*//*Label 7746*/ GIMT_Encode4(403382), // Rule ID 6266 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6266,
        GIR_EraseRootFromParent_Done,
      // Label 7746: @403382
      GIM_Try, /*On fail goto*//*Label 7747*/ GIMT_Encode4(403478), // Rule ID 6126 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6126,
        GIR_EraseRootFromParent_Done,
      // Label 7747: @403478
      GIM_Try, /*On fail goto*//*Label 7748*/ GIMT_Encode4(403562), // Rule ID 2500 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2500,
        GIR_EraseRootFromParent_Done,
      // Label 7748: @403562
      GIM_Try, /*On fail goto*//*Label 7749*/ GIMT_Encode4(403612), // Rule ID 13412 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13412,
        GIR_EraseRootFromParent_Done,
      // Label 7749: @403612
      GIM_Try, /*On fail goto*//*Label 7750*/ GIMT_Encode4(403696), // Rule ID 6094 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6094,
        GIR_EraseRootFromParent_Done,
      // Label 7750: @403696
      GIM_Try, /*On fail goto*//*Label 7751*/ GIMT_Encode4(403746), // Rule ID 1296 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1296,
        GIR_EraseRootFromParent_Done,
      // Label 7751: @403746
      GIM_Try, /*On fail goto*//*Label 7752*/ GIMT_Encode4(403779), // Rule ID 1286 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1286,
        GIR_EraseRootFromParent_Done,
      // Label 7752: @403779
      GIM_Reject,
    // Label 7733: @403780
    GIM_Reject,
    // Label 7637: @403781
    GIM_Try, /*On fail goto*//*Label 7753*/ GIMT_Encode4(405301),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 7754*/ GIMT_Encode4(403877), // Rule ID 6252 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6252,
        GIR_EraseRootFromParent_Done,
      // Label 7754: @403877
      GIM_Try, /*On fail goto*//*Label 7755*/ GIMT_Encode4(403961), // Rule ID 6164 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6164,
        GIR_EraseRootFromParent_Done,
      // Label 7755: @403961
      GIM_Try, /*On fail goto*//*Label 7756*/ GIMT_Encode4(404042), // Rule ID 6196 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6196,
        GIR_EraseRootFromParent_Done,
      // Label 7756: @404042
      GIM_Try, /*On fail goto*//*Label 7757*/ GIMT_Encode4(404126), // Rule ID 6228 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6228,
        GIR_EraseRootFromParent_Done,
      // Label 7757: @404126
      GIM_Try, /*On fail goto*//*Label 7758*/ GIMT_Encode4(404204), // Rule ID 6274 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6274,
        GIR_EraseRootFromParent_Done,
      // Label 7758: @404204
      GIM_Try, /*On fail goto*//*Label 7759*/ GIMT_Encode4(404285), // Rule ID 6132 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6132,
        GIR_EraseRootFromParent_Done,
      // Label 7759: @404285
      GIM_Try, /*On fail goto*//*Label 7760*/ GIMT_Encode4(404354), // Rule ID 2506 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2506,
        GIR_EraseRootFromParent_Done,
      // Label 7760: @404354
      GIM_Try, /*On fail goto*//*Label 7761*/ GIMT_Encode4(404423), // Rule ID 6100 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6100,
        GIR_EraseRootFromParent_Done,
      // Label 7761: @404423
      GIM_Try, /*On fail goto*//*Label 7762*/ GIMT_Encode4(404516), // Rule ID 6254 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6254,
        GIR_EraseRootFromParent_Done,
      // Label 7762: @404516
      GIM_Try, /*On fail goto*//*Label 7763*/ GIMT_Encode4(404615), // Rule ID 6166 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6166,
        GIR_EraseRootFromParent_Done,
      // Label 7763: @404615
      GIM_Try, /*On fail goto*//*Label 7764*/ GIMT_Encode4(404711), // Rule ID 6198 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6198,
        GIR_EraseRootFromParent_Done,
      // Label 7764: @404711
      GIM_Try, /*On fail goto*//*Label 7765*/ GIMT_Encode4(404810), // Rule ID 6230 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6230,
        GIR_EraseRootFromParent_Done,
      // Label 7765: @404810
      GIM_Try, /*On fail goto*//*Label 7766*/ GIMT_Encode4(404903), // Rule ID 6276 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6276,
        GIR_EraseRootFromParent_Done,
      // Label 7766: @404903
      GIM_Try, /*On fail goto*//*Label 7767*/ GIMT_Encode4(404999), // Rule ID 6134 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6134,
        GIR_EraseRootFromParent_Done,
      // Label 7767: @404999
      GIM_Try, /*On fail goto*//*Label 7768*/ GIMT_Encode4(405083), // Rule ID 2508 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2508,
        GIR_EraseRootFromParent_Done,
      // Label 7768: @405083
      GIM_Try, /*On fail goto*//*Label 7769*/ GIMT_Encode4(405133), // Rule ID 13416 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13416,
        GIR_EraseRootFromParent_Done,
      // Label 7769: @405133
      GIM_Try, /*On fail goto*//*Label 7770*/ GIMT_Encode4(405217), // Rule ID 6102 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6102,
        GIR_EraseRootFromParent_Done,
      // Label 7770: @405217
      GIM_Try, /*On fail goto*//*Label 7771*/ GIMT_Encode4(405267), // Rule ID 1300 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1300,
        GIR_EraseRootFromParent_Done,
      // Label 7771: @405267
      GIM_Try, /*On fail goto*//*Label 7772*/ GIMT_Encode4(405300), // Rule ID 1290 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1290,
        GIR_EraseRootFromParent_Done,
      // Label 7772: @405300
      GIM_Reject,
    // Label 7753: @405301
    GIM_Reject,
    // Label 7638: @405302
    GIM_Try, /*On fail goto*//*Label 7773*/ GIMT_Encode4(406480),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 7774*/ GIMT_Encode4(405404), // Rule ID 6148 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6148,
        GIR_EraseRootFromParent_Done,
      // Label 7774: @405404
      GIM_Try, /*On fail goto*//*Label 7775*/ GIMT_Encode4(405485), // Rule ID 6180 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6180,
        GIR_EraseRootFromParent_Done,
      // Label 7775: @405485
      GIM_Try, /*On fail goto*//*Label 7776*/ GIMT_Encode4(405569), // Rule ID 6212 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6212,
        GIR_EraseRootFromParent_Done,
      // Label 7776: @405569
      GIM_Try, /*On fail goto*//*Label 7777*/ GIMT_Encode4(405650), // Rule ID 6116 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6116,
        GIR_EraseRootFromParent_Done,
      // Label 7777: @405650
      GIM_Try, /*On fail goto*//*Label 7778*/ GIMT_Encode4(405719), // Rule ID 2490 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2490,
        GIR_EraseRootFromParent_Done,
      // Label 7778: @405719
      GIM_Try, /*On fail goto*//*Label 7779*/ GIMT_Encode4(405788), // Rule ID 6084 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6084,
        GIR_EraseRootFromParent_Done,
      // Label 7779: @405788
      GIM_Try, /*On fail goto*//*Label 7780*/ GIMT_Encode4(405887), // Rule ID 6150 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6150,
        GIR_EraseRootFromParent_Done,
      // Label 7780: @405887
      GIM_Try, /*On fail goto*//*Label 7781*/ GIMT_Encode4(405983), // Rule ID 6182 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6182,
        GIR_EraseRootFromParent_Done,
      // Label 7781: @405983
      GIM_Try, /*On fail goto*//*Label 7782*/ GIMT_Encode4(406082), // Rule ID 6214 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6214,
        GIR_EraseRootFromParent_Done,
      // Label 7782: @406082
      GIM_Try, /*On fail goto*//*Label 7783*/ GIMT_Encode4(406178), // Rule ID 6118 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6118,
        GIR_EraseRootFromParent_Done,
      // Label 7783: @406178
      GIM_Try, /*On fail goto*//*Label 7784*/ GIMT_Encode4(406262), // Rule ID 2492 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2492,
        GIR_EraseRootFromParent_Done,
      // Label 7784: @406262
      GIM_Try, /*On fail goto*//*Label 7785*/ GIMT_Encode4(406312), // Rule ID 13408 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13408,
        GIR_EraseRootFromParent_Done,
      // Label 7785: @406312
      GIM_Try, /*On fail goto*//*Label 7786*/ GIMT_Encode4(406396), // Rule ID 6086 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6086,
        GIR_EraseRootFromParent_Done,
      // Label 7786: @406396
      GIM_Try, /*On fail goto*//*Label 7787*/ GIMT_Encode4(406446), // Rule ID 1292 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1292,
        GIR_EraseRootFromParent_Done,
      // Label 7787: @406446
      GIM_Try, /*On fail goto*//*Label 7788*/ GIMT_Encode4(406479), // Rule ID 1282 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1282,
        GIR_EraseRootFromParent_Done,
      // Label 7788: @406479
      GIM_Reject,
    // Label 7773: @406480
    GIM_Reject,
    // Label 7639: @406481
    GIM_Try, /*On fail goto*//*Label 7789*/ GIMT_Encode4(408001),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 7790*/ GIMT_Encode4(406577), // Rule ID 6246 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6246,
        GIR_EraseRootFromParent_Done,
      // Label 7790: @406577
      GIM_Try, /*On fail goto*//*Label 7791*/ GIMT_Encode4(406661), // Rule ID 6160 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6160,
        GIR_EraseRootFromParent_Done,
      // Label 7791: @406661
      GIM_Try, /*On fail goto*//*Label 7792*/ GIMT_Encode4(406742), // Rule ID 6192 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6192,
        GIR_EraseRootFromParent_Done,
      // Label 7792: @406742
      GIM_Try, /*On fail goto*//*Label 7793*/ GIMT_Encode4(406826), // Rule ID 6224 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6224,
        GIR_EraseRootFromParent_Done,
      // Label 7793: @406826
      GIM_Try, /*On fail goto*//*Label 7794*/ GIMT_Encode4(406904), // Rule ID 6268 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6268,
        GIR_EraseRootFromParent_Done,
      // Label 7794: @406904
      GIM_Try, /*On fail goto*//*Label 7795*/ GIMT_Encode4(406985), // Rule ID 6128 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6128,
        GIR_EraseRootFromParent_Done,
      // Label 7795: @406985
      GIM_Try, /*On fail goto*//*Label 7796*/ GIMT_Encode4(407054), // Rule ID 2502 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2502,
        GIR_EraseRootFromParent_Done,
      // Label 7796: @407054
      GIM_Try, /*On fail goto*//*Label 7797*/ GIMT_Encode4(407123), // Rule ID 6096 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6096,
        GIR_EraseRootFromParent_Done,
      // Label 7797: @407123
      GIM_Try, /*On fail goto*//*Label 7798*/ GIMT_Encode4(407216), // Rule ID 6250 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6250,
        GIR_EraseRootFromParent_Done,
      // Label 7798: @407216
      GIM_Try, /*On fail goto*//*Label 7799*/ GIMT_Encode4(407315), // Rule ID 6162 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6162,
        GIR_EraseRootFromParent_Done,
      // Label 7799: @407315
      GIM_Try, /*On fail goto*//*Label 7800*/ GIMT_Encode4(407411), // Rule ID 6194 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6194,
        GIR_EraseRootFromParent_Done,
      // Label 7800: @407411
      GIM_Try, /*On fail goto*//*Label 7801*/ GIMT_Encode4(407510), // Rule ID 6226 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6226,
        GIR_EraseRootFromParent_Done,
      // Label 7801: @407510
      GIM_Try, /*On fail goto*//*Label 7802*/ GIMT_Encode4(407603), // Rule ID 6272 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6272,
        GIR_EraseRootFromParent_Done,
      // Label 7802: @407603
      GIM_Try, /*On fail goto*//*Label 7803*/ GIMT_Encode4(407699), // Rule ID 6130 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6130,
        GIR_EraseRootFromParent_Done,
      // Label 7803: @407699
      GIM_Try, /*On fail goto*//*Label 7804*/ GIMT_Encode4(407783), // Rule ID 2504 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2504,
        GIR_EraseRootFromParent_Done,
      // Label 7804: @407783
      GIM_Try, /*On fail goto*//*Label 7805*/ GIMT_Encode4(407833), // Rule ID 13414 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13414,
        GIR_EraseRootFromParent_Done,
      // Label 7805: @407833
      GIM_Try, /*On fail goto*//*Label 7806*/ GIMT_Encode4(407917), // Rule ID 6098 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6098,
        GIR_EraseRootFromParent_Done,
      // Label 7806: @407917
      GIM_Try, /*On fail goto*//*Label 7807*/ GIMT_Encode4(407967), // Rule ID 1298 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1298,
        GIR_EraseRootFromParent_Done,
      // Label 7807: @407967
      GIM_Try, /*On fail goto*//*Label 7808*/ GIMT_Encode4(408000), // Rule ID 1288 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1288,
        GIR_EraseRootFromParent_Done,
      // Label 7808: @408000
      GIM_Reject,
    // Label 7789: @408001
    GIM_Reject,
    // Label 7640: @408002
    GIM_Try, /*On fail goto*//*Label 7809*/ GIMT_Encode4(409180),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 7810*/ GIMT_Encode4(408104), // Rule ID 6144 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6144,
        GIR_EraseRootFromParent_Done,
      // Label 7810: @408104
      GIM_Try, /*On fail goto*//*Label 7811*/ GIMT_Encode4(408185), // Rule ID 6176 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6176,
        GIR_EraseRootFromParent_Done,
      // Label 7811: @408185
      GIM_Try, /*On fail goto*//*Label 7812*/ GIMT_Encode4(408269), // Rule ID 6208 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6208,
        GIR_EraseRootFromParent_Done,
      // Label 7812: @408269
      GIM_Try, /*On fail goto*//*Label 7813*/ GIMT_Encode4(408350), // Rule ID 6112 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6112,
        GIR_EraseRootFromParent_Done,
      // Label 7813: @408350
      GIM_Try, /*On fail goto*//*Label 7814*/ GIMT_Encode4(408419), // Rule ID 2486 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2486,
        GIR_EraseRootFromParent_Done,
      // Label 7814: @408419
      GIM_Try, /*On fail goto*//*Label 7815*/ GIMT_Encode4(408488), // Rule ID 6080 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6080,
        GIR_EraseRootFromParent_Done,
      // Label 7815: @408488
      GIM_Try, /*On fail goto*//*Label 7816*/ GIMT_Encode4(408587), // Rule ID 6146 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6146,
        GIR_EraseRootFromParent_Done,
      // Label 7816: @408587
      GIM_Try, /*On fail goto*//*Label 7817*/ GIMT_Encode4(408683), // Rule ID 6178 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6178,
        GIR_EraseRootFromParent_Done,
      // Label 7817: @408683
      GIM_Try, /*On fail goto*//*Label 7818*/ GIMT_Encode4(408782), // Rule ID 6210 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6210,
        GIR_EraseRootFromParent_Done,
      // Label 7818: @408782
      GIM_Try, /*On fail goto*//*Label 7819*/ GIMT_Encode4(408878), // Rule ID 6114 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6114,
        GIR_EraseRootFromParent_Done,
      // Label 7819: @408878
      GIM_Try, /*On fail goto*//*Label 7820*/ GIMT_Encode4(408962), // Rule ID 2488 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2488,
        GIR_EraseRootFromParent_Done,
      // Label 7820: @408962
      GIM_Try, /*On fail goto*//*Label 7821*/ GIMT_Encode4(409012), // Rule ID 13410 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13410,
        GIR_EraseRootFromParent_Done,
      // Label 7821: @409012
      GIM_Try, /*On fail goto*//*Label 7822*/ GIMT_Encode4(409096), // Rule ID 6082 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6082,
        GIR_EraseRootFromParent_Done,
      // Label 7822: @409096
      GIM_Try, /*On fail goto*//*Label 7823*/ GIMT_Encode4(409146), // Rule ID 1294 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1294,
        GIR_EraseRootFromParent_Done,
      // Label 7823: @409146
      GIM_Try, /*On fail goto*//*Label 7824*/ GIMT_Encode4(409179), // Rule ID 1284 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/3, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_RootToRootCopy, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1284,
        GIR_EraseRootFromParent_Done,
      // Label 7824: @409179
      GIM_Reject,
    // Label 7809: @409180
    GIM_Reject,
    // Label 7641: @409181
    GIM_Reject,
    // Label 103: @409182
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7833*/ GIMT_Encode4(409481),
    /*GILLT_s16*//*Label 7825*/ GIMT_Encode4(409233),
    /*GILLT_s32*//*Label 7826*/ GIMT_Encode4(409264),
    /*GILLT_s64*//*Label 7827*/ GIMT_Encode4(409295), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 7828*/ GIMT_Encode4(409326),
    /*GILLT_v2s64*//*Label 7829*/ GIMT_Encode4(409357),
    /*GILLT_v4s16*//*Label 7830*/ GIMT_Encode4(409388),
    /*GILLT_v4s32*//*Label 7831*/ GIMT_Encode4(409419), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 7832*/ GIMT_Encode4(409450),
    // Label 7825: @409233
    GIM_Try, /*On fail goto*//*Label 7834*/ GIMT_Encode4(409263), // Rule ID 565 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // (strict_fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FSQRTHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTHr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 565,
      GIR_Done,
    // Label 7834: @409263
    GIM_Reject,
    // Label 7826: @409264
    GIM_Try, /*On fail goto*//*Label 7835*/ GIMT_Encode4(409294), // Rule ID 567 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      // (strict_fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FSQRTSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTSr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 567,
      GIR_Done,
    // Label 7835: @409294
    GIM_Reject,
    // Label 7827: @409295
    GIM_Try, /*On fail goto*//*Label 7836*/ GIMT_Encode4(409325), // Rule ID 569 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (strict_fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FSQRTDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTDr),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 569,
      GIR_Done,
    // Label 7836: @409325
    GIM_Reject,
    // Label 7828: @409326
    GIM_Try, /*On fail goto*//*Label 7837*/ GIMT_Encode4(409356), // Rule ID 948 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (strict_fsqrt:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FSQRTv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 948,
      GIR_Done,
    // Label 7837: @409356
    GIM_Reject,
    // Label 7829: @409357
    GIM_Try, /*On fail goto*//*Label 7838*/ GIMT_Encode4(409387), // Rule ID 952 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (strict_fsqrt:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FSQRTv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f64),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 952,
      GIR_Done,
    // Label 7838: @409387
    GIM_Reject,
    // Label 7830: @409388
    GIM_Try, /*On fail goto*//*Label 7839*/ GIMT_Encode4(409418), // Rule ID 944 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (strict_fsqrt:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FSQRTv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 944,
      GIR_Done,
    // Label 7839: @409418
    GIM_Reject,
    // Label 7831: @409419
    GIM_Try, /*On fail goto*//*Label 7840*/ GIMT_Encode4(409449), // Rule ID 950 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (strict_fsqrt:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FSQRTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 950,
      GIR_Done,
    // Label 7840: @409449
    GIM_Reject,
    // Label 7832: @409450
    GIM_Try, /*On fail goto*//*Label 7841*/ GIMT_Encode4(409480), // Rule ID 946 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (strict_fsqrt:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FSQRTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv8f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 946,
      GIR_Done,
    // Label 7841: @409480
    GIM_Reject,
    // Label 7833: @409481
    GIM_Reject,
    // Label 104: @409482
    GIM_Try, /*On fail goto*//*Label 7842*/ GIMT_Encode4(409495), // Rule ID 6585 //
      // (trap)  =>  (BRK 1:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6585,
      GIR_EraseRootFromParent_Done,
    // Label 7842: @409495
    GIM_Reject,
    // Label 105: @409496
    GIM_Try, /*On fail goto*//*Label 7843*/ GIMT_Encode4(409516), // Rule ID 6586 //
      // (debugtrap)  =>  (BRK 61440:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
      GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(61440),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6586,
      GIR_EraseRootFromParent_Done,
    // Label 7843: @409516
    GIM_Reject,
    // Label 106: @409517
    GIM_Try, /*On fail goto*//*Label 7844*/ GIMT_Encode4(409541), // Rule ID 6587 //
      // MIs[0] kind
      GIM_CheckIsImm, /*MI*/0, /*Op*/0,
      GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_ubsan_trap_imm),
      // (ubsantrap (timm:{ *:[i32] })<<P:Predicate_ubsan_trap_imm>><<X:ubsan_trap_xform>>:$kind)  =>  (BRK (ubsan_trap_xform:{ *:[i32] } (timm:{ *:[i32] })<<P:Predicate_ubsan_trap_imm>>:$kind))
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
      GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, /*OperandRenderer*/GIMT_Encode2(GICR_renderUbsanTrap), // kind
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6587,
      GIR_EraseRootFromParent_Done,
    // Label 7844: @409541
    GIM_Reject,
    // Label 107: @409542
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7848*/ GIMT_Encode4(409851),
    /*GILLT_s16*//*Label 7845*/ GIMT_Encode4(409565),
    /*GILLT_s32*//*Label 7846*/ GIMT_Encode4(409718),
    /*GILLT_s64*//*Label 7847*/ GIMT_Encode4(409823),
    // Label 7845: @409565
    GIM_Try, /*On fail goto*//*Label 7849*/ GIMT_Encode4(409666), // Rule ID 5652 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (vecreduce_fadd:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } (FADDPv8f16:{ *:[f128] } (FADDPv8f16:{ *:[f128] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rn), dsub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5652,
      GIR_EraseRootFromParent_Done,
    // Label 7849: @409666
    GIM_Try, /*On fail goto*//*Label 7850*/ GIMT_Encode4(409717), // Rule ID 5653 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (vecreduce_fadd:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FADDPv2i16p:{ *:[f16] } (FADDPv4f16:{ *:[i64] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rn))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f16),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5653,
      GIR_EraseRootFromParent_Done,
    // Label 7850: @409717
    GIM_Reject,
    // Label 7846: @409718
    GIM_Try, /*On fail goto*//*Label 7851*/ GIMT_Encode4(409795), // Rule ID 5654 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (vecreduce_fadd:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } (FADDPv4f32:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn), dsub:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5654,
      GIR_EraseRootFromParent_Done,
    // Label 7851: @409795
    GIM_Try, /*On fail goto*//*Label 7852*/ GIMT_Encode4(409822), // Rule ID 5655 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (vecreduce_fadd:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5655,
      GIR_Done,
    // Label 7852: @409822
    GIM_Reject,
    // Label 7847: @409823
    GIM_Try, /*On fail goto*//*Label 7853*/ GIMT_Encode4(409850), // Rule ID 5656 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (vecreduce_fadd:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FADDPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5656,
      GIR_Done,
    // Label 7853: @409850
    GIM_Reject,
    // Label 7848: @409851
    GIM_Reject,
    // Label 108: @409852
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7857*/ GIMT_Encode4(410022),
    /*GILLT_s16*//*Label 7854*/ GIMT_Encode4(409875),
    /*GILLT_s32*//*Label 7855*/ GIMT_Encode4(409936),
    /*GILLT_s64*//*Label 7856*/ GIMT_Encode4(409994),
    // Label 7854: @409875
    GIM_Try, /*On fail goto*//*Label 7858*/ GIMT_Encode4(409905), // Rule ID 1931 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (vecreduce_fmax:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMAXNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i16v),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1931,
      GIR_Done,
    // Label 7858: @409905
    GIM_Try, /*On fail goto*//*Label 7859*/ GIMT_Encode4(409935), // Rule ID 1933 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (vecreduce_fmax:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMAXNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv8i16v),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1933,
      GIR_Done,
    // Label 7859: @409935
    GIM_Reject,
    // Label 7855: @409936
    GIM_Try, /*On fail goto*//*Label 7860*/ GIMT_Encode4(409966), // Rule ID 1935 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (vecreduce_fmax:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMAXNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i32v),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1935,
      GIR_Done,
    // Label 7860: @409966
    GIM_Try, /*On fail goto*//*Label 7861*/ GIMT_Encode4(409993), // Rule ID 5662 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (vecreduce_fmax:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMAXNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i32p),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5662,
      GIR_Done,
    // Label 7861: @409993
    GIM_Reject,
    // Label 7856: @409994
    GIM_Try, /*On fail goto*//*Label 7862*/ GIMT_Encode4(410021), // Rule ID 5664 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (vecreduce_fmax:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMAXNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i64p),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5664,
      GIR_Done,
    // Label 7862: @410021
    GIM_Reject,
    // Label 7857: @410022
    GIM_Reject,
    // Label 109: @410023
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7866*/ GIMT_Encode4(410193),
    /*GILLT_s16*//*Label 7863*/ GIMT_Encode4(410046),
    /*GILLT_s32*//*Label 7864*/ GIMT_Encode4(410107),
    /*GILLT_s64*//*Label 7865*/ GIMT_Encode4(410165),
    // Label 7863: @410046
    GIM_Try, /*On fail goto*//*Label 7867*/ GIMT_Encode4(410076), // Rule ID 1943 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (vecreduce_fmin:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMINNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i16v),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1943,
      GIR_Done,
    // Label 7867: @410076
    GIM_Try, /*On fail goto*//*Label 7868*/ GIMT_Encode4(410106), // Rule ID 1945 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (vecreduce_fmin:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMINNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv8i16v),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1945,
      GIR_Done,
    // Label 7868: @410106
    GIM_Reject,
    // Label 7864: @410107
    GIM_Try, /*On fail goto*//*Label 7869*/ GIMT_Encode4(410137), // Rule ID 1947 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (vecreduce_fmin:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMINNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i32v),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1947,
      GIR_Done,
    // Label 7869: @410137
    GIM_Try, /*On fail goto*//*Label 7870*/ GIMT_Encode4(410164), // Rule ID 5670 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (vecreduce_fmin:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMINNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i32p),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5670,
      GIR_Done,
    // Label 7870: @410164
    GIM_Reject,
    // Label 7865: @410165
    GIM_Try, /*On fail goto*//*Label 7871*/ GIMT_Encode4(410192), // Rule ID 5672 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (vecreduce_fmin:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMINNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i64p),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5672,
      GIR_Done,
    // Label 7871: @410192
    GIM_Reject,
    // Label 7866: @410193
    GIM_Reject,
    // Label 110: @410194
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7875*/ GIMT_Encode4(410364),
    /*GILLT_s16*//*Label 7872*/ GIMT_Encode4(410217),
    /*GILLT_s32*//*Label 7873*/ GIMT_Encode4(410278),
    /*GILLT_s64*//*Label 7874*/ GIMT_Encode4(410336),
    // Label 7872: @410217
    GIM_Try, /*On fail goto*//*Label 7876*/ GIMT_Encode4(410247), // Rule ID 1937 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (vecreduce_fmaximum:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMAXVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i16v),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1937,
      GIR_Done,
    // Label 7876: @410247
    GIM_Try, /*On fail goto*//*Label 7877*/ GIMT_Encode4(410277), // Rule ID 1939 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (vecreduce_fmaximum:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMAXVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv8i16v),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1939,
      GIR_Done,
    // Label 7877: @410277
    GIM_Reject,
    // Label 7873: @410278
    GIM_Try, /*On fail goto*//*Label 7878*/ GIMT_Encode4(410308), // Rule ID 1941 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (vecreduce_fmaximum:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMAXVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i32v),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1941,
      GIR_Done,
    // Label 7878: @410308
    GIM_Try, /*On fail goto*//*Label 7879*/ GIMT_Encode4(410335), // Rule ID 5666 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (vecreduce_fmaximum:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMAXPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i32p),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5666,
      GIR_Done,
    // Label 7879: @410335
    GIM_Reject,
    // Label 7874: @410336
    GIM_Try, /*On fail goto*//*Label 7880*/ GIMT_Encode4(410363), // Rule ID 5668 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (vecreduce_fmaximum:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMAXPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i64p),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5668,
      GIR_Done,
    // Label 7880: @410363
    GIM_Reject,
    // Label 7875: @410364
    GIM_Reject,
    // Label 111: @410365
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7884*/ GIMT_Encode4(410535),
    /*GILLT_s16*//*Label 7881*/ GIMT_Encode4(410388),
    /*GILLT_s32*//*Label 7882*/ GIMT_Encode4(410449),
    /*GILLT_s64*//*Label 7883*/ GIMT_Encode4(410507),
    // Label 7881: @410388
    GIM_Try, /*On fail goto*//*Label 7885*/ GIMT_Encode4(410418), // Rule ID 1949 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (vecreduce_fminimum:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMINVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i16v),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1949,
      GIR_Done,
    // Label 7885: @410418
    GIM_Try, /*On fail goto*//*Label 7886*/ GIMT_Encode4(410448), // Rule ID 1951 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (vecreduce_fminimum:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMINVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINVv8i16v),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1951,
      GIR_Done,
    // Label 7886: @410448
    GIM_Reject,
    // Label 7882: @410449
    GIM_Try, /*On fail goto*//*Label 7887*/ GIMT_Encode4(410479), // Rule ID 1953 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (vecreduce_fminimum:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMINVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i32v),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1953,
      GIR_Done,
    // Label 7887: @410479
    GIM_Try, /*On fail goto*//*Label 7888*/ GIMT_Encode4(410506), // Rule ID 5674 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (vecreduce_fminimum:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMINPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i32p),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5674,
      GIR_Done,
    // Label 7888: @410506
    GIM_Reject,
    // Label 7883: @410507
    GIM_Try, /*On fail goto*//*Label 7889*/ GIMT_Encode4(410534), // Rule ID 5676 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (vecreduce_fminimum:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMINPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i64p),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5676,
      GIR_Done,
    // Label 7889: @410534
    GIM_Reject,
    // Label 7884: @410535
    GIM_Reject,
    // Label 112: @410536
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(4), /*)*//*default:*//*Label 7894*/ GIMT_Encode4(411664),
    /*GILLT_s8*//*Label 7890*/ GIMT_Encode4(410563),
    /*GILLT_s16*//*Label 7891*/ GIMT_Encode4(410610),
    /*GILLT_s32*//*Label 7892*/ GIMT_Encode4(411025),
    /*GILLT_s64*//*Label 7893*/ GIMT_Encode4(411478),
    // Label 7890: @410563
    GIM_Try, /*On fail goto*//*Label 7895*/ GIMT_Encode4(410586), // Rule ID 5941 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (vecreduce_add:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)  =>  (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5941,
      GIR_Done,
    // Label 7895: @410586
    GIM_Try, /*On fail goto*//*Label 7896*/ GIMT_Encode4(410609), // Rule ID 5942 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (vecreduce_add:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)  =>  (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5942,
      GIR_Done,
    // Label 7896: @410609
    GIM_Reject,
    // Label 7891: @410610
    GIM_Try, /*On fail goto*//*Label 7897*/ GIMT_Encode4(410660), // Rule ID 5888 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v4i16] } 700:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5888,
      GIR_EraseRootFromParent_Done,
    // Label 7897: @410660
    GIM_Try, /*On fail goto*//*Label 7898*/ GIMT_Encode4(410710), // Rule ID 5890 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v8i16] } 700:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5890,
      GIR_EraseRootFromParent_Done,
    // Label 7898: @410710
    GIM_Try, /*On fail goto*//*Label 7899*/ GIMT_Encode4(410760), // Rule ID 5898 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v4i16] } 635:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i8v),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5898,
      GIR_EraseRootFromParent_Done,
    // Label 7899: @410760
    GIM_Try, /*On fail goto*//*Label 7900*/ GIMT_Encode4(410810), // Rule ID 5900 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v8i16] } 635:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv16i8v),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5900,
      GIR_EraseRootFromParent_Done,
    // Label 7900: @410810
    GIM_Try, /*On fail goto*//*Label 7901*/ GIMT_Encode4(410852), // Rule ID 5897 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vecreduce_add:{ *:[i16] } (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (SADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i8v),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5897,
      GIR_EraseRootFromParent_Done,
    // Label 7901: @410852
    GIM_Try, /*On fail goto*//*Label 7902*/ GIMT_Encode4(410894), // Rule ID 5899 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vecreduce_add:{ *:[i16] } (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (SADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv16i8v),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5899,
      GIR_EraseRootFromParent_Done,
    // Label 7902: @410894
    GIM_Try, /*On fail goto*//*Label 7903*/ GIMT_Encode4(410936), // Rule ID 5887 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vecreduce_add:{ *:[i16] } (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5887,
      GIR_EraseRootFromParent_Done,
    // Label 7903: @410936
    GIM_Try, /*On fail goto*//*Label 7904*/ GIMT_Encode4(410978), // Rule ID 5889 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vecreduce_add:{ *:[i16] } (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5889,
      GIR_EraseRootFromParent_Done,
    // Label 7904: @410978
    GIM_Try, /*On fail goto*//*Label 7905*/ GIMT_Encode4(411001), // Rule ID 5943 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (vecreduce_add:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)  =>  (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5943,
      GIR_Done,
    // Label 7905: @411001
    GIM_Try, /*On fail goto*//*Label 7906*/ GIMT_Encode4(411024), // Rule ID 5944 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (vecreduce_add:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)  =>  (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5944,
      GIR_Done,
    // Label 7906: @411024
    GIM_Reject,
    // Label 7892: @411025
    GIM_Try, /*On fail goto*//*Label 7907*/ GIMT_Encode4(411075), // Rule ID 5892 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 700:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5892,
      GIR_EraseRootFromParent_Done,
    // Label 7907: @411075
    GIM_Try, /*On fail goto*//*Label 7908*/ GIMT_Encode4(411125), // Rule ID 5894 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v2i32] } 700:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (UADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i16v),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5894,
      GIR_EraseRootFromParent_Done,
    // Label 7908: @411125
    GIM_Try, /*On fail goto*//*Label 7909*/ GIMT_Encode4(411175), // Rule ID 5902 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 635:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i16v),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5902,
      GIR_EraseRootFromParent_Done,
    // Label 7909: @411175
    GIM_Try, /*On fail goto*//*Label 7910*/ GIMT_Encode4(411225), // Rule ID 5904 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v2i32] } 635:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i16v),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5904,
      GIR_EraseRootFromParent_Done,
    // Label 7910: @411225
    GIM_Try, /*On fail goto*//*Label 7911*/ GIMT_Encode4(411267), // Rule ID 5901 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vecreduce_add:{ *:[i32] } (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (SADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i16v),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5901,
      GIR_EraseRootFromParent_Done,
    // Label 7911: @411267
    GIM_Try, /*On fail goto*//*Label 7912*/ GIMT_Encode4(411309), // Rule ID 5903 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vecreduce_add:{ *:[i32] } (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (SADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i16v),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5903,
      GIR_EraseRootFromParent_Done,
    // Label 7912: @411309
    GIM_Try, /*On fail goto*//*Label 7913*/ GIMT_Encode4(411351), // Rule ID 5891 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vecreduce_add:{ *:[i32] } (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5891,
      GIR_EraseRootFromParent_Done,
    // Label 7913: @411351
    GIM_Try, /*On fail goto*//*Label 7914*/ GIMT_Encode4(411393), // Rule ID 5893 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (vecreduce_add:{ *:[i32] } (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (UADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i16v),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5893,
      GIR_EraseRootFromParent_Done,
    // Label 7914: @411393
    GIM_Try, /*On fail goto*//*Label 7915*/ GIMT_Encode4(411454), // Rule ID 5945 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (vecreduce_add:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (ADDPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 5945,
      GIR_EraseRootFromParent_Done,
    // Label 7915: @411454
    GIM_Try, /*On fail goto*//*Label 7916*/ GIMT_Encode4(411477), // Rule ID 5946 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (vecreduce_add:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (ADDVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i32v),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5946,
      GIR_Done,
    // Label 7916: @411477
    GIM_Reject,
    // Label 7893: @411478
    GIM_Try, /*On fail goto*//*Label 7917*/ GIMT_Encode4(411663),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 7918*/ GIMT_Encode4(411533), // Rule ID 5896 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vecreduce_add:{ *:[i64] } (intrinsic_wo_chain:{ *:[v2i64] } 700:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (UADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i32v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5896,
        GIR_EraseRootFromParent_Done,
      // Label 7918: @411533
      GIM_Try, /*On fail goto*//*Label 7919*/ GIMT_Encode4(411576), // Rule ID 5906 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vecreduce_add:{ *:[i64] } (intrinsic_wo_chain:{ *:[v2i64] } 635:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (SADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i32v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5906,
        GIR_EraseRootFromParent_Done,
      // Label 7919: @411576
      GIM_Try, /*On fail goto*//*Label 7920*/ GIMT_Encode4(411611), // Rule ID 5905 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vecreduce_add:{ *:[i64] } (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (SADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i32v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5905,
        GIR_EraseRootFromParent_Done,
      // Label 7920: @411611
      GIM_Try, /*On fail goto*//*Label 7921*/ GIMT_Encode4(411646), // Rule ID 5895 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (vecreduce_add:{ *:[i64] } (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (UADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i32v),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5895,
        GIR_EraseRootFromParent_Done,
      // Label 7921: @411646
      GIM_Try, /*On fail goto*//*Label 7922*/ GIMT_Encode4(411662), // Rule ID 5947 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (vecreduce_add:{ *:[i64] } V128:{ *:[v2i64] }:$Rn)  =>  (ADDPv2i64p:{ *:[i64] } V128:{ *:[v2i64] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5947,
        GIR_Done,
      // Label 7922: @411662
      GIM_Reject,
    // Label 7917: @411663
    GIM_Reject,
    // Label 7894: @411664
    GIM_Reject,
    // Label 113: @411665
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 7926*/ GIMT_Encode4(411867),
    /*GILLT_s8*//*Label 7923*/ GIMT_Encode4(411688),
    /*GILLT_s16*//*Label 7924*/ GIMT_Encode4(411735),
    /*GILLT_s32*//*Label 7925*/ GIMT_Encode4(411782),
    // Label 7923: @411688
    GIM_Try, /*On fail goto*//*Label 7927*/ GIMT_Encode4(411711), // Rule ID 6038 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (vecreduce_smax:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (SMAXVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i8v),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6038,
      GIR_Done,
    // Label 7927: @411711
    GIM_Try, /*On fail goto*//*Label 7928*/ GIMT_Encode4(411734), // Rule ID 6039 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (vecreduce_smax:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (SMAXVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv16i8v),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6039,
      GIR_Done,
    // Label 7928: @411734
    GIM_Reject,
    // Label 7924: @411735
    GIM_Try, /*On fail goto*//*Label 7929*/ GIMT_Encode4(411758), // Rule ID 6040 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (vecreduce_smax:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (SMAXVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i16v),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6040,
      GIR_Done,
    // Label 7929: @411758
    GIM_Try, /*On fail goto*//*Label 7930*/ GIMT_Encode4(411781), // Rule ID 6041 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (vecreduce_smax:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (SMAXVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i16v),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6041,
      GIR_Done,
    // Label 7930: @411781
    GIM_Reject,
    // Label 7925: @411782
    GIM_Try, /*On fail goto*//*Label 7931*/ GIMT_Encode4(411805), // Rule ID 6042 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (vecreduce_smax:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (SMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i32v),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6042,
      GIR_Done,
    // Label 7931: @411805
    GIM_Try, /*On fail goto*//*Label 7932*/ GIMT_Encode4(411866), // Rule ID 6043 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (vecreduce_smax:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (SMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv2i32),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6043,
      GIR_EraseRootFromParent_Done,
    // Label 7932: @411866
    GIM_Reject,
    // Label 7926: @411867
    GIM_Reject,
    // Label 114: @411868
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 7936*/ GIMT_Encode4(412070),
    /*GILLT_s8*//*Label 7933*/ GIMT_Encode4(411891),
    /*GILLT_s16*//*Label 7934*/ GIMT_Encode4(411938),
    /*GILLT_s32*//*Label 7935*/ GIMT_Encode4(411985),
    // Label 7933: @411891
    GIM_Try, /*On fail goto*//*Label 7937*/ GIMT_Encode4(411914), // Rule ID 6032 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (vecreduce_smin:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (SMINVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i8v),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6032,
      GIR_Done,
    // Label 7937: @411914
    GIM_Try, /*On fail goto*//*Label 7938*/ GIMT_Encode4(411937), // Rule ID 6033 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (vecreduce_smin:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (SMINVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv16i8v),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6033,
      GIR_Done,
    // Label 7938: @411937
    GIM_Reject,
    // Label 7934: @411938
    GIM_Try, /*On fail goto*//*Label 7939*/ GIMT_Encode4(411961), // Rule ID 6034 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (vecreduce_smin:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (SMINVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i16v),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6034,
      GIR_Done,
    // Label 7939: @411961
    GIM_Try, /*On fail goto*//*Label 7940*/ GIMT_Encode4(411984), // Rule ID 6035 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (vecreduce_smin:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (SMINVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i16v),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6035,
      GIR_Done,
    // Label 7940: @411984
    GIM_Reject,
    // Label 7935: @411985
    GIM_Try, /*On fail goto*//*Label 7941*/ GIMT_Encode4(412008), // Rule ID 6036 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (vecreduce_smin:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (SMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i32v),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6036,
      GIR_Done,
    // Label 7941: @412008
    GIM_Try, /*On fail goto*//*Label 7942*/ GIMT_Encode4(412069), // Rule ID 6037 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (vecreduce_smin:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (SMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMINPv2i32),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6037,
      GIR_EraseRootFromParent_Done,
    // Label 7942: @412069
    GIM_Reject,
    // Label 7936: @412070
    GIM_Reject,
    // Label 115: @412071
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 7946*/ GIMT_Encode4(412273),
    /*GILLT_s8*//*Label 7943*/ GIMT_Encode4(412094),
    /*GILLT_s16*//*Label 7944*/ GIMT_Encode4(412141),
    /*GILLT_s32*//*Label 7945*/ GIMT_Encode4(412188),
    // Label 7943: @412094
    GIM_Try, /*On fail goto*//*Label 7947*/ GIMT_Encode4(412117), // Rule ID 6026 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (vecreduce_umax:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (UMAXVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i8v),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6026,
      GIR_Done,
    // Label 7947: @412117
    GIM_Try, /*On fail goto*//*Label 7948*/ GIMT_Encode4(412140), // Rule ID 6027 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (vecreduce_umax:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (UMAXVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv16i8v),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6027,
      GIR_Done,
    // Label 7948: @412140
    GIM_Reject,
    // Label 7944: @412141
    GIM_Try, /*On fail goto*//*Label 7949*/ GIMT_Encode4(412164), // Rule ID 6028 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (vecreduce_umax:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (UMAXVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i16v),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6028,
      GIR_Done,
    // Label 7949: @412164
    GIM_Try, /*On fail goto*//*Label 7950*/ GIMT_Encode4(412187), // Rule ID 6029 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (vecreduce_umax:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (UMAXVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i16v),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6029,
      GIR_Done,
    // Label 7950: @412187
    GIM_Reject,
    // Label 7945: @412188
    GIM_Try, /*On fail goto*//*Label 7951*/ GIMT_Encode4(412211), // Rule ID 6030 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (vecreduce_umax:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (UMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i32v),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6030,
      GIR_Done,
    // Label 7951: @412211
    GIM_Try, /*On fail goto*//*Label 7952*/ GIMT_Encode4(412272), // Rule ID 6031 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (vecreduce_umax:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (UMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv2i32),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6031,
      GIR_EraseRootFromParent_Done,
    // Label 7952: @412272
    GIM_Reject,
    // Label 7946: @412273
    GIM_Reject,
    // Label 116: @412274
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 7956*/ GIMT_Encode4(412476),
    /*GILLT_s8*//*Label 7953*/ GIMT_Encode4(412297),
    /*GILLT_s16*//*Label 7954*/ GIMT_Encode4(412344),
    /*GILLT_s32*//*Label 7955*/ GIMT_Encode4(412391),
    // Label 7953: @412297
    GIM_Try, /*On fail goto*//*Label 7957*/ GIMT_Encode4(412320), // Rule ID 6020 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (vecreduce_umin:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (UMINVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i8v),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6020,
      GIR_Done,
    // Label 7957: @412320
    GIM_Try, /*On fail goto*//*Label 7958*/ GIMT_Encode4(412343), // Rule ID 6021 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (vecreduce_umin:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (UMINVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv16i8v),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6021,
      GIR_Done,
    // Label 7958: @412343
    GIM_Reject,
    // Label 7954: @412344
    GIM_Try, /*On fail goto*//*Label 7959*/ GIMT_Encode4(412367), // Rule ID 6022 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (vecreduce_umin:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (UMINVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i16v),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6022,
      GIR_Done,
    // Label 7959: @412367
    GIM_Try, /*On fail goto*//*Label 7960*/ GIMT_Encode4(412390), // Rule ID 6023 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (vecreduce_umin:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (UMINVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i16v),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6023,
      GIR_Done,
    // Label 7960: @412390
    GIM_Reject,
    // Label 7955: @412391
    GIM_Try, /*On fail goto*//*Label 7961*/ GIMT_Encode4(412414), // Rule ID 6024 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (vecreduce_umin:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (UMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i32v),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6024,
      GIR_Done,
    // Label 7961: @412414
    GIM_Try, /*On fail goto*//*Label 7962*/ GIMT_Encode4(412475), // Rule ID 6025 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (vecreduce_umin:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (UMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMINPv2i32),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6025,
      GIR_EraseRootFromParent_Done,
    // Label 7962: @412475
    GIM_Reject,
    // Label 7956: @412476
    GIM_Reject,
    // Label 117: @412477
    GIM_Try, /*On fail goto*//*Label 7963*/ GIMT_Encode4(412616),
      GIM_CheckIsImm, /*MI*/0, /*Op*/0,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_Try, /*On fail goto*//*Label 7964*/ GIMT_Encode4(412523), // Rule ID 269 //
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
        // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))  =>  (PRFMroW (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFMroW),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 269,
        GIR_EraseRootFromParent_Done,
      // Label 7964: @412523
      GIM_Try, /*On fail goto*//*Label 7965*/ GIMT_Encode4(412557), // Rule ID 270 //
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
        // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))  =>  (PRFMroX (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFMroX),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 270,
        GIR_EraseRootFromParent_Done,
      // Label 7965: @412557
      GIM_Try, /*On fail goto*//*Label 7966*/ GIMT_Encode4(412586), // Rule ID 285 //
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
        // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))  =>  (PRFMui (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFMui),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 285,
        GIR_EraseRootFromParent_Done,
      // Label 7966: @412586
      GIM_Try, /*On fail goto*//*Label 7967*/ GIMT_Encode4(412615), // Rule ID 306 //
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
        // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))  =>  (PRFUMi (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFUMi),
        GIR_RootToRootCopy, /*OpIdx*/0, // Rt
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 306,
        GIR_EraseRootFromParent_Done,
      // Label 7967: @412615
      GIM_Reject,
    // Label 7963: @412616
    GIM_Reject,
    // Label 118: @412617
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 7980*/ GIMT_Encode4(413156),
    /*GILLT_s64*//*Label 7968*/ GIMT_Encode4(412712), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 7969*/ GIMT_Encode4(412750),
    /*GILLT_v2s64*//*Label 7970*/ GIMT_Encode4(412788),
    /*GILLT_v4s16*//*Label 7971*/ GIMT_Encode4(412826),
    /*GILLT_v4s32*//*Label 7972*/ GIMT_Encode4(412864),
    /*GILLT_v8s8*//*Label 7973*/ GIMT_Encode4(412902),
    /*GILLT_v8s16*//*Label 7974*/ GIMT_Encode4(412940),
    /*GILLT_v16s8*//*Label 7975*/ GIMT_Encode4(412978), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s64*//*Label 7976*/ GIMT_Encode4(413016), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv4s32*//*Label 7977*/ GIMT_Encode4(413051), GIMT_Encode4(0),
    /*GILLT_nxv8s16*//*Label 7978*/ GIMT_Encode4(413086), GIMT_Encode4(0),
    /*GILLT_nxv16s8*//*Label 7979*/ GIMT_Encode4(413121),
    // Label 7968: @412712
    GIM_Try, /*On fail goto*//*Label 7981*/ GIMT_Encode4(412749), // Rule ID 5105 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64bsp:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm)  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5105,
      GIR_Done,
    // Label 7981: @412749
    GIM_Reject,
    // Label 7969: @412750
    GIM_Try, /*On fail goto*//*Label 7982*/ GIMT_Encode4(412787), // Rule ID 5104 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64bsp:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5104,
      GIR_Done,
    // Label 7982: @412787
    GIM_Reject,
    // Label 7970: @412788
    GIM_Try, /*On fail goto*//*Label 7983*/ GIMT_Encode4(412825), // Rule ID 5109 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64bsp:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5109,
      GIR_Done,
    // Label 7983: @412825
    GIM_Reject,
    // Label 7971: @412826
    GIM_Try, /*On fail goto*//*Label 7984*/ GIMT_Encode4(412863), // Rule ID 5103 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64bsp:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5103,
      GIR_Done,
    // Label 7984: @412863
    GIM_Reject,
    // Label 7972: @412864
    GIM_Try, /*On fail goto*//*Label 7985*/ GIMT_Encode4(412901), // Rule ID 5108 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64bsp:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5108,
      GIR_Done,
    // Label 7985: @412901
    GIM_Reject,
    // Label 7973: @412902
    GIM_Try, /*On fail goto*//*Label 7986*/ GIMT_Encode4(412939), // Rule ID 5102 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64bsp:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5102,
      GIR_Done,
    // Label 7986: @412939
    GIM_Reject,
    // Label 7974: @412940
    GIM_Try, /*On fail goto*//*Label 7987*/ GIMT_Encode4(412977), // Rule ID 5107 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64bsp:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5107,
      GIR_Done,
    // Label 7987: @412977
    GIM_Reject,
    // Label 7975: @412978
    GIM_Try, /*On fail goto*//*Label 7988*/ GIMT_Encode4(413015), // Rule ID 5106 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64bsp:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5106,
      GIR_Done,
    // Label 7988: @413015
    GIM_Reject,
    // Label 7976: @413016
    GIM_Try, /*On fail goto*//*Label 7989*/ GIMT_Encode4(413050), // Rule ID 12157 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (AArch64bsp:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
      GIR_RootToRootCopy, /*OpIdx*/2, // Op1
      GIR_RootToRootCopy, /*OpIdx*/3, // Op2
      GIR_RootToRootCopy, /*OpIdx*/1, // Op3
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 12157,
      GIR_EraseRootFromParent_Done,
    // Label 7989: @413050
    GIM_Reject,
    // Label 7977: @413051
    GIM_Try, /*On fail goto*//*Label 7990*/ GIMT_Encode4(413085), // Rule ID 12155 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (AArch64bsp:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
      GIR_RootToRootCopy, /*OpIdx*/2, // Op1
      GIR_RootToRootCopy, /*OpIdx*/3, // Op2
      GIR_RootToRootCopy, /*OpIdx*/1, // Op3
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 12155,
      GIR_EraseRootFromParent_Done,
    // Label 7990: @413085
    GIM_Reject,
    // Label 7978: @413086
    GIM_Try, /*On fail goto*//*Label 7991*/ GIMT_Encode4(413120), // Rule ID 12153 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (AArch64bsp:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
      GIR_RootToRootCopy, /*OpIdx*/2, // Op1
      GIR_RootToRootCopy, /*OpIdx*/3, // Op2
      GIR_RootToRootCopy, /*OpIdx*/1, // Op3
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 12153,
      GIR_EraseRootFromParent_Done,
    // Label 7991: @413120
    GIM_Reject,
    // Label 7979: @413121
    GIM_Try, /*On fail goto*//*Label 7992*/ GIMT_Encode4(413155), // Rule ID 12151 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2orSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (AArch64bsp:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
      GIR_RootToRootCopy, /*OpIdx*/2, // Op1
      GIR_RootToRootCopy, /*OpIdx*/3, // Op2
      GIR_RootToRootCopy, /*OpIdx*/1, // Op3
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 12151,
      GIR_EraseRootFromParent_Done,
    // Label 7992: @413155
    GIM_Reject,
    // Label 7980: @413156
    GIM_Reject,
    // Label 119: @413157
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 8001*/ GIMT_Encode4(415247),
    /*GILLT_s64*//*Label 7993*/ GIMT_Encode4(413204), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 7994*/ GIMT_Encode4(413399),
    /*GILLT_v2s64*//*Label 7995*/ GIMT_Encode4(413646),
    /*GILLT_v4s16*//*Label 7996*/ GIMT_Encode4(413893),
    /*GILLT_v4s32*//*Label 7997*/ GIMT_Encode4(414303),
    /*GILLT_v8s8*//*Label 7998*/ GIMT_Encode4(414550),
    /*GILLT_v8s16*//*Label 7999*/ GIMT_Encode4(414695),
    /*GILLT_v16s8*//*Label 8000*/ GIMT_Encode4(415105),
    // Label 7993: @413204
    GIM_Try, /*On fail goto*//*Label 8002*/ GIMT_Encode4(413398),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8003*/ GIMT_Encode4(413263), // Rule ID 6473 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        // MIs[1] Rn
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64dup:{ *:[v1i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv1d:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv1d),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6473,
        GIR_EraseRootFromParent_Done,
      // Label 8003: @413263
      GIM_Try, /*On fail goto*//*Label 8004*/ GIMT_Encode4(413310), // Rule ID 6484 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        // MIs[1] Rn
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64dup:{ *:[v1f64] } (ld:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv1d:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv1d),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6484,
        GIR_EraseRootFromParent_Done,
      // Label 8004: @413310
      GIM_Try, /*On fail goto*//*Label 8005*/ GIMT_Encode4(413357), // Rule ID 13281 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        // MIs[1] Rn
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64dup:{ *:[v1i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv1d:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv1d),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13281,
        GIR_EraseRootFromParent_Done,
      // Label 8005: @413357
      GIM_Try, /*On fail goto*//*Label 8006*/ GIMT_Encode4(413377), // Rule ID 5678 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (AArch64dup:{ *:[v1i64] } GPR64:{ *:[i64] }:$Rn)  =>  (COPY_TO_REGCLASS:{ *:[v1i64] } GPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i32] })
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 5678,
        GIR_Done,
      // Label 8006: @413377
      GIM_Try, /*On fail goto*//*Label 8007*/ GIMT_Encode4(413397), // Rule ID 5679 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (AArch64dup:{ *:[v1f64] } FPR64:{ *:[f64] }:$Rn)  =>  (COPY_TO_REGCLASS:{ *:[v1f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[i32] })
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        // GIR_Coverage, 5679,
        GIR_Done,
      // Label 8007: @413397
      GIM_Reject,
    // Label 8002: @413398
    GIM_Reject,
    // Label 7994: @413399
    GIM_Try, /*On fail goto*//*Label 8008*/ GIMT_Encode4(413645),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8009*/ GIMT_Encode4(413458), // Rule ID 6470 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        // MIs[1] Rn
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64dup:{ *:[v2i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2s:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2s),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6470,
        GIR_EraseRootFromParent_Done,
      // Label 8009: @413458
      GIM_Try, /*On fail goto*//*Label 8010*/ GIMT_Encode4(413505), // Rule ID 6481 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        // MIs[1] Rn
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64dup:{ *:[v2f32] } (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2s:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2s),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6481,
        GIR_EraseRootFromParent_Done,
      // Label 8010: @413505
      GIM_Try, /*On fail goto*//*Label 8011*/ GIMT_Encode4(413552), // Rule ID 13278 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        // MIs[1] Rn
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64dup:{ *:[v2i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2s:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2s),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13278,
        GIR_EraseRootFromParent_Done,
      // Label 8011: @413552
      GIM_Try, /*On fail goto*//*Label 8012*/ GIMT_Encode4(413571), // Rule ID 1905 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (AArch64dup:{ *:[v2i32] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv2i32gpr:{ *:[v2i32] } GPR32:{ *:[i32] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32gpr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1905,
        GIR_Done,
      // Label 8012: @413571
      GIM_Try, /*On fail goto*//*Label 8013*/ GIMT_Encode4(413644), // Rule ID 5680 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rn)  =>  (DUPv2i32lane:{ *:[v2f32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5680,
        GIR_EraseRootFromParent_Done,
      // Label 8013: @413644
      GIM_Reject,
    // Label 8008: @413645
    GIM_Reject,
    // Label 7995: @413646
    GIM_Try, /*On fail goto*//*Label 8014*/ GIMT_Encode4(413892),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8015*/ GIMT_Encode4(413705), // Rule ID 6472 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        // MIs[1] Rn
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64dup:{ *:[v2i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6472,
        GIR_EraseRootFromParent_Done,
      // Label 8015: @413705
      GIM_Try, /*On fail goto*//*Label 8016*/ GIMT_Encode4(413752), // Rule ID 6483 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        // MIs[1] Rn
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64dup:{ *:[v2f64] } (ld:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2d:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6483,
        GIR_EraseRootFromParent_Done,
      // Label 8016: @413752
      GIM_Try, /*On fail goto*//*Label 8017*/ GIMT_Encode4(413799), // Rule ID 13280 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        // MIs[1] Rn
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64dup:{ *:[v2i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13280,
        GIR_EraseRootFromParent_Done,
      // Label 8017: @413799
      GIM_Try, /*On fail goto*//*Label 8018*/ GIMT_Encode4(413818), // Rule ID 1907 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
        // (AArch64dup:{ *:[v2i64] } GPR64:{ *:[i64] }:$Rn)  =>  (DUPv2i64gpr:{ *:[v2i64] } GPR64:{ *:[i64] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64gpr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1907,
        GIR_Done,
      // Label 8018: @413818
      GIM_Try, /*On fail goto*//*Label 8019*/ GIMT_Encode4(413891), // Rule ID 5682 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rn)  =>  (DUPv2i64lane:{ *:[v2f64] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5682,
        GIR_EraseRootFromParent_Done,
      // Label 8019: @413891
      GIM_Reject,
    // Label 8014: @413892
    GIM_Reject,
    // Label 7996: @413893
    GIM_Try, /*On fail goto*//*Label 8020*/ GIMT_Encode4(413947), // Rule ID 6485 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      // MIs[1] Rn
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (AArch64dup:{ *:[v4f16] } (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4h:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4h),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6485,
      GIR_EraseRootFromParent_Done,
    // Label 8020: @413947
    GIM_Try, /*On fail goto*//*Label 8021*/ GIMT_Encode4(414001), // Rule ID 6487 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      // MIs[1] Rn
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (AArch64dup:{ *:[v4bf16] } (ld:{ *:[bf16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4h:{ *:[v4bf16] } GPR64sp:{ *:[i64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4h),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6487,
      GIR_EraseRootFromParent_Done,
    // Label 8021: @414001
    GIM_Try, /*On fail goto*//*Label 8022*/ GIMT_Encode4(414055), // Rule ID 13276 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      // MIs[1] Rn
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (AArch64dup:{ *:[v4i16] } (ld:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4h:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4h),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 13276,
      GIR_EraseRootFromParent_Done,
    // Label 8022: @414055
    GIM_Try, /*On fail goto*//*Label 8023*/ GIMT_Encode4(414116), // Rule ID 6468 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      // MIs[1] Rn
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (AArch64dup:{ *:[v4i16] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>)  =>  (LD1Rv4h:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4h),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6468,
      GIR_EraseRootFromParent_Done,
    // Label 8023: @414116
    GIM_Try, /*On fail goto*//*Label 8024*/ GIMT_Encode4(414142), // Rule ID 1903 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // (AArch64dup:{ *:[v4i16] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv4i16gpr:{ *:[v4i16] } GPR32:{ *:[i32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16gpr),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1903,
      GIR_Done,
    // Label 8024: @414142
    GIM_Try, /*On fail goto*//*Label 8025*/ GIMT_Encode4(414222), // Rule ID 5683 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // (AArch64dup:{ *:[v4f16] } FPR16:{ *:[f16] }:$Rn)  =>  (DUPv4i16lane:{ *:[v4f16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), 0:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5683,
      GIR_EraseRootFromParent_Done,
    // Label 8025: @414222
    GIM_Try, /*On fail goto*//*Label 8026*/ GIMT_Encode4(414302), // Rule ID 5684 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // (AArch64dup:{ *:[v4bf16] } FPR16:{ *:[bf16] }:$Rn)  =>  (DUPv4i16lane:{ *:[v4bf16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), FPR16:{ *:[bf16] }:$Rn, hsub:{ *:[i32] }), 0:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5684,
      GIR_EraseRootFromParent_Done,
    // Label 8026: @414302
    GIM_Reject,
    // Label 7997: @414303
    GIM_Try, /*On fail goto*//*Label 8027*/ GIMT_Encode4(414549),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8028*/ GIMT_Encode4(414362), // Rule ID 6471 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        // MIs[1] Rn
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64dup:{ *:[v4i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6471,
        GIR_EraseRootFromParent_Done,
      // Label 8028: @414362
      GIM_Try, /*On fail goto*//*Label 8029*/ GIMT_Encode4(414409), // Rule ID 6482 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        // MIs[1] Rn
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64dup:{ *:[v4f32] } (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4s:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6482,
        GIR_EraseRootFromParent_Done,
      // Label 8029: @414409
      GIM_Try, /*On fail goto*//*Label 8030*/ GIMT_Encode4(414456), // Rule ID 13279 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        // MIs[1] Rn
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64dup:{ *:[v4i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13279,
        GIR_EraseRootFromParent_Done,
      // Label 8030: @414456
      GIM_Try, /*On fail goto*//*Label 8031*/ GIMT_Encode4(414475), // Rule ID 1906 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
        // (AArch64dup:{ *:[v4i32] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv4i32gpr:{ *:[v4i32] } GPR32:{ *:[i32] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32gpr),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1906,
        GIR_Done,
      // Label 8031: @414475
      GIM_Try, /*On fail goto*//*Label 8032*/ GIMT_Encode4(414548), // Rule ID 5681 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
        // (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rn)  =>  (DUPv4i32lane:{ *:[v4f32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] }), 0:{ *:[i64] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
        GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5681,
        GIR_EraseRootFromParent_Done,
      // Label 8032: @414548
      GIM_Reject,
    // Label 8027: @414549
    GIM_Reject,
    // Label 7998: @414550
    GIM_Try, /*On fail goto*//*Label 8033*/ GIMT_Encode4(414607), // Rule ID 13274 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
      // (AArch64dup:{ *:[v8i8] } (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv8b:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8b),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 13274,
      GIR_EraseRootFromParent_Done,
    // Label 8033: @414607
    GIM_Try, /*On fail goto*//*Label 8034*/ GIMT_Encode4(414668), // Rule ID 6466 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      // MIs[1] Rn
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (AArch64dup:{ *:[v8i8] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>)  =>  (LD1Rv8b:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8b),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6466,
      GIR_EraseRootFromParent_Done,
    // Label 8034: @414668
    GIM_Try, /*On fail goto*//*Label 8035*/ GIMT_Encode4(414694), // Rule ID 1901 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // (AArch64dup:{ *:[v8i8] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv8i8gpr:{ *:[v8i8] } GPR32:{ *:[i32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i8gpr),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1901,
      GIR_Done,
    // Label 8035: @414694
    GIM_Reject,
    // Label 7999: @414695
    GIM_Try, /*On fail goto*//*Label 8036*/ GIMT_Encode4(414749), // Rule ID 6486 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      // MIs[1] Rn
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (AArch64dup:{ *:[v8f16] } (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv8h:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6486,
      GIR_EraseRootFromParent_Done,
    // Label 8036: @414749
    GIM_Try, /*On fail goto*//*Label 8037*/ GIMT_Encode4(414803), // Rule ID 6488 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      // MIs[1] Rn
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (AArch64dup:{ *:[v8bf16] } (ld:{ *:[bf16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv8h:{ *:[v8bf16] } GPR64sp:{ *:[i64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6488,
      GIR_EraseRootFromParent_Done,
    // Label 8037: @414803
    GIM_Try, /*On fail goto*//*Label 8038*/ GIMT_Encode4(414857), // Rule ID 13277 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      // MIs[1] Rn
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (AArch64dup:{ *:[v8i16] } (ld:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 13277,
      GIR_EraseRootFromParent_Done,
    // Label 8038: @414857
    GIM_Try, /*On fail goto*//*Label 8039*/ GIMT_Encode4(414918), // Rule ID 6469 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      // MIs[1] Rn
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (AArch64dup:{ *:[v8i16] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>)  =>  (LD1Rv8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6469,
      GIR_EraseRootFromParent_Done,
    // Label 8039: @414918
    GIM_Try, /*On fail goto*//*Label 8040*/ GIMT_Encode4(414944), // Rule ID 1904 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // (AArch64dup:{ *:[v8i16] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv8i16gpr:{ *:[v8i16] } GPR32:{ *:[i32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16gpr),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1904,
      GIR_Done,
    // Label 8040: @414944
    GIM_Try, /*On fail goto*//*Label 8041*/ GIMT_Encode4(415024), // Rule ID 5685 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // (AArch64dup:{ *:[v8f16] } FPR16:{ *:[f16] }:$Rn)  =>  (DUPv8i16lane:{ *:[v8f16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), 0:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5685,
      GIR_EraseRootFromParent_Done,
    // Label 8041: @415024
    GIM_Try, /*On fail goto*//*Label 8042*/ GIMT_Encode4(415104), // Rule ID 5686 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // (AArch64dup:{ *:[v8bf16] } FPR16:{ *:[bf16] }:$Rn)  =>  (DUPv8i16lane:{ *:[v8bf16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), FPR16:{ *:[bf16] }:$Rn, hsub:{ *:[i32] }), 0:{ *:[i64] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5686,
      GIR_EraseRootFromParent_Done,
    // Label 8042: @415104
    GIM_Reject,
    // Label 8000: @415105
    GIM_Try, /*On fail goto*//*Label 8043*/ GIMT_Encode4(415159), // Rule ID 13275 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      // MIs[1] Rn
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (AArch64dup:{ *:[v16i8] } (ld:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv16b),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 13275,
      GIR_EraseRootFromParent_Done,
    // Label 8043: @415159
    GIM_Try, /*On fail goto*//*Label 8044*/ GIMT_Encode4(415220), // Rule ID 6467 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      // MIs[1] Rn
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (AArch64dup:{ *:[v16i8] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>)  =>  (LD1Rv16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv16b),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6467,
      GIR_EraseRootFromParent_Done,
    // Label 8044: @415220
    GIM_Try, /*On fail goto*//*Label 8045*/ GIMT_Encode4(415246), // Rule ID 1902 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
      // (AArch64dup:{ *:[v16i8] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv16i8gpr:{ *:[v16i8] } GPR32:{ *:[i32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv16i8gpr),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1902,
      GIR_Done,
    // Label 8045: @415246
    GIM_Reject,
    // Label 8001: @415247
    GIM_Reject,
    // Label 120: @415248
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(11), /*)*//*default:*//*Label 8048*/ GIMT_Encode4(415568),
    /*GILLT_v4s16*//*Label 8046*/ GIMT_Encode4(415275), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 8047*/ GIMT_Encode4(415392),
    // Label 8046: @415275
    GIM_Try, /*On fail goto*//*Label 8049*/ GIMT_Encode4(415391),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8050*/ GIMT_Encode4(415328), // Rule ID 1911 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64duplane16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (DUPv4i16lane:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1911,
        GIR_EraseRootFromParent_Done,
      // Label 8050: @415328
      GIM_Try, /*On fail goto*//*Label 8051*/ GIMT_Encode4(415359), // Rule ID 5687 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64duplane16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (DUPv4i16lane:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5687,
        GIR_EraseRootFromParent_Done,
      // Label 8051: @415359
      GIM_Try, /*On fail goto*//*Label 8052*/ GIMT_Encode4(415390), // Rule ID 5689 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64duplane16:{ *:[v4bf16] } V128:{ *:[v8bf16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (DUPv4i16lane:{ *:[v4bf16] } V128:{ *:[v8bf16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5689,
        GIR_EraseRootFromParent_Done,
      // Label 8052: @415390
      GIM_Reject,
    // Label 8049: @415391
    GIM_Reject,
    // Label 8047: @415392
    GIM_Try, /*On fail goto*//*Label 8053*/ GIMT_Encode4(415567),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8054*/ GIMT_Encode4(415458), // Rule ID 6477 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        // MIs[1] Rn
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64duplane16:{ *:[v8i16] } (ld:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6477,
        GIR_EraseRootFromParent_Done,
      // Label 8054: @415458
      GIM_Try, /*On fail goto*//*Label 8055*/ GIMT_Encode4(415496), // Rule ID 1912 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64duplane16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (DUPv8i16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1912,
        GIR_EraseRootFromParent_Done,
      // Label 8055: @415496
      GIM_Try, /*On fail goto*//*Label 8056*/ GIMT_Encode4(415531), // Rule ID 5688 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64duplane16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (DUPv8i16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5688,
        GIR_EraseRootFromParent_Done,
      // Label 8056: @415531
      GIM_Try, /*On fail goto*//*Label 8057*/ GIMT_Encode4(415566), // Rule ID 5690 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64duplane16:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (DUPv8i16lane:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5690,
        GIR_EraseRootFromParent_Done,
      // Label 8057: @415566
      GIM_Reject,
    // Label 8053: @415567
    GIM_Reject,
    // Label 8048: @415568
    GIM_Reject,
    // Label 121: @415569
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(9), /*)*//*default:*//*Label 8060*/ GIMT_Encode4(415823),
    /*GILLT_v2s32*//*Label 8058*/ GIMT_Encode4(415596), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_v4s32*//*Label 8059*/ GIMT_Encode4(415682),
    // Label 8058: @415596
    GIM_Try, /*On fail goto*//*Label 8061*/ GIMT_Encode4(415681),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8062*/ GIMT_Encode4(415649), // Rule ID 1909 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (DUPv2i32lane:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1909,
        GIR_EraseRootFromParent_Done,
      // Label 8062: @415649
      GIM_Try, /*On fail goto*//*Label 8063*/ GIMT_Encode4(415680), // Rule ID 5691 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (DUPv2i32lane:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5691,
        GIR_EraseRootFromParent_Done,
      // Label 8063: @415680
      GIM_Reject,
    // Label 8061: @415681
    GIM_Reject,
    // Label 8059: @415682
    GIM_Try, /*On fail goto*//*Label 8064*/ GIMT_Encode4(415822),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8065*/ GIMT_Encode4(415748), // Rule ID 6479 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        // MIs[1] Rn
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64duplane32:{ *:[v4i32] } (ld:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6479,
        GIR_EraseRootFromParent_Done,
      // Label 8065: @415748
      GIM_Try, /*On fail goto*//*Label 8066*/ GIMT_Encode4(415786), // Rule ID 1910 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (DUPv4i32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1910,
        GIR_EraseRootFromParent_Done,
      // Label 8066: @415786
      GIM_Try, /*On fail goto*//*Label 8067*/ GIMT_Encode4(415821), // Rule ID 5692 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (DUPv4i32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5692,
        GIR_EraseRootFromParent_Done,
      // Label 8067: @415821
      GIM_Reject,
    // Label 8064: @415822
    GIM_Reject,
    // Label 8060: @415823
    GIM_Reject,
    // Label 122: @415824
    GIM_Try, /*On fail goto*//*Label 8068*/ GIMT_Encode4(415969),
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8069*/ GIMT_Encode4(415893), // Rule ID 6480 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        // MIs[1] Rn
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64duplane64:{ *:[v2i64] } (ld:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6480,
        GIR_EraseRootFromParent_Done,
      // Label 8069: @415893
      GIM_Try, /*On fail goto*//*Label 8070*/ GIMT_Encode4(415968),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_Try, /*On fail goto*//*Label 8071*/ GIMT_Encode4(415936), // Rule ID 1908 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
          GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
          // MIs[1] Operand 1
          // No operand predicates
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (DUPv2i64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
          GIR_RootToRootCopy, /*OpIdx*/1, // Rn
          GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 1908,
          GIR_EraseRootFromParent_Done,
        // Label 8071: @415936
        GIM_Try, /*On fail goto*//*Label 8072*/ GIMT_Encode4(415967), // Rule ID 5693 //
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
          GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
          // MIs[1] Operand 1
          // No operand predicates
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)  =>  (DUPv2i64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
          GIR_RootToRootCopy, /*OpIdx*/1, // Rn
          GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5693,
          GIR_EraseRootFromParent_Done,
        // Label 8072: @415967
        GIM_Reject,
      // Label 8070: @415968
      GIM_Reject,
    // Label 8068: @415969
    GIM_Reject,
    // Label 123: @415970
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(12), /*)*//*default:*//*Label 8075*/ GIMT_Encode4(416148),
    /*GILLT_v8s8*//*Label 8073*/ GIMT_Encode4(415993), GIMT_Encode4(0),
    /*GILLT_v16s8*//*Label 8074*/ GIMT_Encode4(416042),
    // Label 8073: @415993
    GIM_Try, /*On fail goto*//*Label 8076*/ GIMT_Encode4(416041), // Rule ID 1913 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (AArch64duplane8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (DUPv8i8lane:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i8lane),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1913,
      GIR_EraseRootFromParent_Done,
    // Label 8076: @416041
    GIM_Reject,
    // Label 8074: @416042
    GIM_Try, /*On fail goto*//*Label 8077*/ GIMT_Encode4(416147),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8078*/ GIMT_Encode4(416108), // Rule ID 6475 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
        GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
        GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        // MIs[1] Rn
        GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64duplane8:{ *:[v16i8] } (ld:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv16b),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6475,
        GIR_EraseRootFromParent_Done,
      // Label 8078: @416108
      GIM_Try, /*On fail goto*//*Label 8079*/ GIMT_Encode4(416146), // Rule ID 1914 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64duplane8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (DUPv16i8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv16i8lane),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1914,
        GIR_EraseRootFromParent_Done,
      // Label 8079: @416146
      GIM_Reject,
    // Label 8077: @416147
    GIM_Reject,
    // Label 8075: @416148
    GIM_Reject,
    // Label 124: @416149
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 8089*/ GIMT_Encode4(417979),
    /*GILLT_s64*//*Label 8080*/ GIMT_Encode4(416244), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 8081*/ GIMT_Encode4(416565),
    /*GILLT_v2s64*//*Label 8082*/ GIMT_Encode4(416886),
    /*GILLT_v4s16*//*Label 8083*/ GIMT_Encode4(416969),
    /*GILLT_v4s32*//*Label 8084*/ GIMT_Encode4(417442),
    /*GILLT_v8s8*//*Label 8085*/ GIMT_Encode4(417525),
    /*GILLT_v8s16*//*Label 8086*/ GIMT_Encode4(417734),
    /*GILLT_v16s8*//*Label 8087*/ GIMT_Encode4(417846), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv16s8*//*Label 8088*/ GIMT_Encode4(417932),
    // Label 8080: @416244
    GIM_Try, /*On fail goto*//*Label 8090*/ GIMT_Encode4(416564),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8091*/ GIMT_Encode4(416374), // Rule ID 5496 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        // MIs[2] Rn
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(1),
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (AArch64ext:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5496,
        GIR_EraseRootFromParent_Done,
      // Label 8091: @416374
      GIM_Try, /*On fail goto*//*Label 8092*/ GIMT_Encode4(416489), // Rule ID 5501 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        // MIs[2] Rn
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(1),
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (AArch64ext:{ *:[v1f64] } (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5501,
        GIR_EraseRootFromParent_Done,
      // Label 8092: @416489
      GIM_Try, /*On fail goto*//*Label 8093*/ GIMT_Encode4(416526), // Rule ID 5493 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64ext:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5493,
        GIR_EraseRootFromParent_Done,
      // Label 8093: @416526
      GIM_Try, /*On fail goto*//*Label 8094*/ GIMT_Encode4(416563), // Rule ID 5498 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64ext:{ *:[v1f64] } V64:{ *:[v1f64] }:$Rn, V64:{ *:[v1f64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v1f64] } V64:{ *:[v1f64] }:$Rn, V64:{ *:[v1f64] }:$Rm, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5498,
        GIR_EraseRootFromParent_Done,
      // Label 8094: @416563
      GIM_Reject,
    // Label 8090: @416564
    GIM_Reject,
    // Label 8081: @416565
    GIM_Try, /*On fail goto*//*Label 8095*/ GIMT_Encode4(416885),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8096*/ GIMT_Encode4(416695), // Rule ID 5486 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        // MIs[2] Rn
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (AArch64ext:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5486,
        GIR_EraseRootFromParent_Done,
      // Label 8096: @416695
      GIM_Try, /*On fail goto*//*Label 8097*/ GIMT_Encode4(416810), // Rule ID 5491 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        // MIs[2] Rn
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (AArch64ext:{ *:[v2f32] } (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 2:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5491,
        GIR_EraseRootFromParent_Done,
      // Label 8097: @416810
      GIM_Try, /*On fail goto*//*Label 8098*/ GIMT_Encode4(416847), // Rule ID 5483 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64ext:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5483,
        GIR_EraseRootFromParent_Done,
      // Label 8098: @416847
      GIM_Try, /*On fail goto*//*Label 8099*/ GIMT_Encode4(416884), // Rule ID 5488 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64ext:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5488,
        GIR_EraseRootFromParent_Done,
      // Label 8099: @416884
      GIM_Reject,
    // Label 8095: @416885
    GIM_Reject,
    // Label 8082: @416886
    GIM_Try, /*On fail goto*//*Label 8100*/ GIMT_Encode4(416968),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8101*/ GIMT_Encode4(416938), // Rule ID 5494 //
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64ext:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5494,
        GIR_EraseRootFromParent_Done,
      // Label 8101: @416938
      GIM_Try, /*On fail goto*//*Label 8102*/ GIMT_Encode4(416967), // Rule ID 5499 //
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64ext:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5499,
        GIR_EraseRootFromParent_Done,
      // Label 8102: @416967
      GIM_Reject,
    // Label 8100: @416968
    GIM_Reject,
    // Label 8083: @416969
    GIM_Try, /*On fail goto*//*Label 8103*/ GIMT_Encode4(417441),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8104*/ GIMT_Encode4(417099), // Rule ID 5471 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        // MIs[2] Rn
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (AArch64ext:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5471,
        GIR_EraseRootFromParent_Done,
      // Label 8104: @417099
      GIM_Try, /*On fail goto*//*Label 8105*/ GIMT_Encode4(417214), // Rule ID 5476 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        // MIs[2] Rn
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (AArch64ext:{ *:[v4f16] } (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 4:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5476,
        GIR_EraseRootFromParent_Done,
      // Label 8105: @417214
      GIM_Try, /*On fail goto*//*Label 8106*/ GIMT_Encode4(417329), // Rule ID 5481 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        // MIs[2] Rn
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (AArch64ext:{ *:[v4bf16] } (extract_subvector:{ *:[v4bf16] } V128:{ *:[v8bf16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4bf16] } V128:{ *:[v8bf16] }:$Rn, 4:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v4bf16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5481,
        GIR_EraseRootFromParent_Done,
      // Label 8106: @417329
      GIM_Try, /*On fail goto*//*Label 8107*/ GIMT_Encode4(417366), // Rule ID 5468 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64ext:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5468,
        GIR_EraseRootFromParent_Done,
      // Label 8107: @417366
      GIM_Try, /*On fail goto*//*Label 8108*/ GIMT_Encode4(417403), // Rule ID 5473 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64ext:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5473,
        GIR_EraseRootFromParent_Done,
      // Label 8108: @417403
      GIM_Try, /*On fail goto*//*Label 8109*/ GIMT_Encode4(417440), // Rule ID 5478 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64ext:{ *:[v4bf16] } V64:{ *:[v4bf16] }:$Rn, V64:{ *:[v4bf16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v4bf16] } V64:{ *:[v4bf16] }:$Rn, V64:{ *:[v4bf16] }:$Rm, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5478,
        GIR_EraseRootFromParent_Done,
      // Label 8109: @417440
      GIM_Reject,
    // Label 8103: @417441
    GIM_Reject,
    // Label 8084: @417442
    GIM_Try, /*On fail goto*//*Label 8110*/ GIMT_Encode4(417524),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8111*/ GIMT_Encode4(417494), // Rule ID 5484 //
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64ext:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5484,
        GIR_EraseRootFromParent_Done,
      // Label 8111: @417494
      GIM_Try, /*On fail goto*//*Label 8112*/ GIMT_Encode4(417523), // Rule ID 5489 //
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64ext:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5489,
        GIR_EraseRootFromParent_Done,
      // Label 8112: @417523
      GIM_Reject,
    // Label 8110: @417524
    GIM_Reject,
    // Label 8085: @417525
    GIM_Try, /*On fail goto*//*Label 8113*/ GIMT_Encode4(417733),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8114*/ GIMT_Encode4(417655), // Rule ID 5466 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        // MIs[2] Rn
        GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (AArch64ext:{ *:[v8i8] } (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 8:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (EXTv16i8:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
        // GIR_Coverage, 5466,
        GIR_EraseRootFromParent_Done,
      // Label 8114: @417655
      GIM_Try, /*On fail goto*//*Label 8115*/ GIMT_Encode4(417695), // Rule ID 1857 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64ext:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1857,
        GIR_EraseRootFromParent_Done,
      // Label 8115: @417695
      GIM_Try, /*On fail goto*//*Label 8116*/ GIMT_Encode4(417732), // Rule ID 5463 //
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64ext:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5463,
        GIR_EraseRootFromParent_Done,
      // Label 8116: @417732
      GIM_Reject,
    // Label 8113: @417733
    GIM_Reject,
    // Label 8086: @417734
    GIM_Try, /*On fail goto*//*Label 8117*/ GIMT_Encode4(417845),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8118*/ GIMT_Encode4(417786), // Rule ID 5469 //
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64ext:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5469,
        GIR_EraseRootFromParent_Done,
      // Label 8118: @417786
      GIM_Try, /*On fail goto*//*Label 8119*/ GIMT_Encode4(417815), // Rule ID 5474 //
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64ext:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5474,
        GIR_EraseRootFromParent_Done,
      // Label 8119: @417815
      GIM_Try, /*On fail goto*//*Label 8120*/ GIMT_Encode4(417844), // Rule ID 5479 //
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64ext:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5479,
        GIR_EraseRootFromParent_Done,
      // Label 8120: @417844
      GIM_Reject,
    // Label 8117: @417845
    GIM_Reject,
    // Label 8087: @417846
    GIM_Try, /*On fail goto*//*Label 8121*/ GIMT_Encode4(417931),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8122*/ GIMT_Encode4(417901), // Rule ID 1858 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64ext:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1858,
        GIR_EraseRootFromParent_Done,
      // Label 8122: @417901
      GIM_Try, /*On fail goto*//*Label 8123*/ GIMT_Encode4(417930), // Rule ID 5464 //
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64ext:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootToRootCopy, /*OpIdx*/2, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5464,
        GIR_EraseRootFromParent_Done,
      // Label 8123: @417930
      GIM_Reject,
    // Label 8121: @417931
    GIM_Reject,
    // Label 8088: @417932
    GIM_Try, /*On fail goto*//*Label 8124*/ GIMT_Encode4(417978), // Rule ID 2693 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // MIs[0] Op3
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_255),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (AArch64ext:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (imm:{ *:[i32] })<<P:Predicate_imm0_255>>:$Op3)  =>  (EXT_ZZI:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (imm:{ *:[i32] })<<P:Predicate_imm0_255>>:$Op3)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXT_ZZI),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
      GIR_RootToRootCopy, /*OpIdx*/1, // Op1
      GIR_RootToRootCopy, /*OpIdx*/2, // Op2
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // Op3
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2693,
      GIR_EraseRootFromParent_Done,
    // Label 8124: @417978
    GIM_Reject,
    // Label 8089: @417979
    GIM_Reject,
    // Label 125: @417980
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 8132*/ GIMT_Encode4(418318),
    /*GILLT_s32*//*Label 8125*/ GIMT_Encode4(418027),
    /*GILLT_s64*//*Label 8126*/ GIMT_Encode4(418065), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 8127*/ GIMT_Encode4(418128),
    /*GILLT_v2s64*//*Label 8128*/ GIMT_Encode4(418166),
    /*GILLT_v4s16*//*Label 8129*/ GIMT_Encode4(418204),
    /*GILLT_v4s32*//*Label 8130*/ GIMT_Encode4(418242), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 8131*/ GIMT_Encode4(418280),
    // Label 8125: @418027
    GIM_Try, /*On fail goto*//*Label 8133*/ GIMT_Encode4(418064), // Rule ID 1611 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      // (AArch64fcmeq:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FCMEQ32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQ32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1611,
      GIR_Done,
    // Label 8133: @418064
    GIM_Reject,
    // Label 8126: @418065
    GIM_Try, /*On fail goto*//*Label 8134*/ GIMT_Encode4(418127),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8135*/ GIMT_Encode4(418107), // Rule ID 1610 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64fcmeq:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FCMEQ64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQ64),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1610,
        GIR_Done,
      // Label 8135: @418107
      GIM_Try, /*On fail goto*//*Label 8136*/ GIMT_Encode4(418126), // Rule ID 5248 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64fcmeq:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FCMEQ64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQ64),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5248,
        GIR_Done,
      // Label 8136: @418126
      GIM_Reject,
    // Label 8134: @418127
    GIM_Reject,
    // Label 8127: @418128
    GIM_Try, /*On fail goto*//*Label 8137*/ GIMT_Encode4(418165), // Rule ID 1199 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64fcmeq:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMEQv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1199,
      GIR_Done,
    // Label 8137: @418165
    GIM_Reject,
    // Label 8128: @418166
    GIM_Try, /*On fail goto*//*Label 8138*/ GIMT_Encode4(418203), // Rule ID 1201 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64fcmeq:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMEQv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2f64),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1201,
      GIR_Done,
    // Label 8138: @418203
    GIM_Reject,
    // Label 8129: @418204
    GIM_Try, /*On fail goto*//*Label 8139*/ GIMT_Encode4(418241), // Rule ID 1197 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64fcmeq:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMEQv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1197,
      GIR_Done,
    // Label 8139: @418241
    GIM_Reject,
    // Label 8130: @418242
    GIM_Try, /*On fail goto*//*Label 8140*/ GIMT_Encode4(418279), // Rule ID 1200 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64fcmeq:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMEQv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1200,
      GIR_Done,
    // Label 8140: @418279
    GIM_Reject,
    // Label 8131: @418280
    GIM_Try, /*On fail goto*//*Label 8141*/ GIMT_Encode4(418317), // Rule ID 1198 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64fcmeq:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMEQv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv8f16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1198,
      GIR_Done,
    // Label 8141: @418317
    GIM_Reject,
    // Label 8132: @418318
    GIM_Reject,
    // Label 126: @418319
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8148*/ GIMT_Encode4(418548),
    /*GILLT_s64*//*Label 8142*/ GIMT_Encode4(418362), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 8143*/ GIMT_Encode4(418393),
    /*GILLT_v2s64*//*Label 8144*/ GIMT_Encode4(418424),
    /*GILLT_v4s16*//*Label 8145*/ GIMT_Encode4(418455),
    /*GILLT_v4s32*//*Label 8146*/ GIMT_Encode4(418486), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 8147*/ GIMT_Encode4(418517),
    // Label 8142: @418362
    GIM_Try, /*On fail goto*//*Label 8149*/ GIMT_Encode4(418392), // Rule ID 2478 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64fcmeqz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMEQv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv1i64rz),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2478,
      GIR_Done,
    // Label 8149: @418392
    GIM_Reject,
    // Label 8143: @418393
    GIM_Try, /*On fail goto*//*Label 8150*/ GIMT_Encode4(418423), // Rule ID 762 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64fcmeqz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2i32rz),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 762,
      GIR_Done,
    // Label 8150: @418423
    GIM_Reject,
    // Label 8144: @418424
    GIM_Try, /*On fail goto*//*Label 8151*/ GIMT_Encode4(418454), // Rule ID 764 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64fcmeqz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2i64rz),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 764,
      GIR_Done,
    // Label 8151: @418454
    GIM_Reject,
    // Label 8145: @418455
    GIM_Try, /*On fail goto*//*Label 8152*/ GIMT_Encode4(418485), // Rule ID 760 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64fcmeqz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4i16rz),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 760,
      GIR_Done,
    // Label 8152: @418485
    GIM_Reject,
    // Label 8146: @418486
    GIM_Try, /*On fail goto*//*Label 8153*/ GIMT_Encode4(418516), // Rule ID 763 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64fcmeqz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4i32rz),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 763,
      GIR_Done,
    // Label 8153: @418516
    GIM_Reject,
    // Label 8147: @418517
    GIM_Try, /*On fail goto*//*Label 8154*/ GIMT_Encode4(418547), // Rule ID 761 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64fcmeqz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv8i16rz),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 761,
      GIR_Done,
    // Label 8154: @418547
    GIM_Reject,
    // Label 8148: @418548
    GIM_Reject,
    // Label 127: @418549
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 8162*/ GIMT_Encode4(419212),
    /*GILLT_s32*//*Label 8155*/ GIMT_Encode4(418596),
    /*GILLT_s64*//*Label 8156*/ GIMT_Encode4(418634), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 8157*/ GIMT_Encode4(418697),
    /*GILLT_v2s64*//*Label 8158*/ GIMT_Encode4(418800),
    /*GILLT_v4s16*//*Label 8159*/ GIMT_Encode4(418903),
    /*GILLT_v4s32*//*Label 8160*/ GIMT_Encode4(419006), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 8161*/ GIMT_Encode4(419109),
    // Label 8155: @418596
    GIM_Try, /*On fail goto*//*Label 8163*/ GIMT_Encode4(418633), // Rule ID 1613 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      // (AArch64fcmge:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FCMGE32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGE32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1613,
      GIR_Done,
    // Label 8163: @418633
    GIM_Reject,
    // Label 8156: @418634
    GIM_Try, /*On fail goto*//*Label 8164*/ GIMT_Encode4(418696),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8165*/ GIMT_Encode4(418676), // Rule ID 1612 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64fcmge:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FCMGE64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGE64),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1612,
        GIR_Done,
      // Label 8165: @418676
      GIM_Try, /*On fail goto*//*Label 8166*/ GIMT_Encode4(418695), // Rule ID 5249 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64fcmge:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FCMGE64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGE64),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5249,
        GIR_Done,
      // Label 8166: @418695
      GIM_Reject,
    // Label 8164: @418696
    GIM_Reject,
    // Label 8157: @418697
    GIM_Try, /*On fail goto*//*Label 8167*/ GIMT_Encode4(418799),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8168*/ GIMT_Encode4(418771), // Rule ID 1161 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (AArch64fcmge:{ *:[v2i32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FACGEv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1161,
        GIR_EraseRootFromParent_Done,
      // Label 8168: @418771
      GIM_Try, /*On fail goto*//*Label 8169*/ GIMT_Encode4(418798), // Rule ID 1204 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (AArch64fcmge:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMGEv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2f32),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1204,
        GIR_Done,
      // Label 8169: @418798
      GIM_Reject,
    // Label 8167: @418799
    GIM_Reject,
    // Label 8158: @418800
    GIM_Try, /*On fail goto*//*Label 8170*/ GIMT_Encode4(418902),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8171*/ GIMT_Encode4(418874), // Rule ID 1165 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (AArch64fcmge:{ *:[v2i64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FACGEv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1165,
        GIR_EraseRootFromParent_Done,
      // Label 8171: @418874
      GIM_Try, /*On fail goto*//*Label 8172*/ GIMT_Encode4(418901), // Rule ID 1206 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (AArch64fcmge:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMGEv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2f64),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1206,
        GIR_Done,
      // Label 8172: @418901
      GIM_Reject,
    // Label 8170: @418902
    GIM_Reject,
    // Label 8159: @418903
    GIM_Try, /*On fail goto*//*Label 8173*/ GIMT_Encode4(419005),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8174*/ GIMT_Encode4(418977), // Rule ID 1157 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (AArch64fcmge:{ *:[v4i16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FACGEv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1157,
        GIR_EraseRootFromParent_Done,
      // Label 8174: @418977
      GIM_Try, /*On fail goto*//*Label 8175*/ GIMT_Encode4(419004), // Rule ID 1202 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (AArch64fcmge:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMGEv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4f16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1202,
        GIR_Done,
      // Label 8175: @419004
      GIM_Reject,
    // Label 8173: @419005
    GIM_Reject,
    // Label 8160: @419006
    GIM_Try, /*On fail goto*//*Label 8176*/ GIMT_Encode4(419108),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8177*/ GIMT_Encode4(419080), // Rule ID 1163 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (AArch64fcmge:{ *:[v4i32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FACGEv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1163,
        GIR_EraseRootFromParent_Done,
      // Label 8177: @419080
      GIM_Try, /*On fail goto*//*Label 8178*/ GIMT_Encode4(419107), // Rule ID 1205 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (AArch64fcmge:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMGEv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4f32),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1205,
        GIR_Done,
      // Label 8178: @419107
      GIM_Reject,
    // Label 8176: @419108
    GIM_Reject,
    // Label 8161: @419109
    GIM_Try, /*On fail goto*//*Label 8179*/ GIMT_Encode4(419211),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8180*/ GIMT_Encode4(419183), // Rule ID 1159 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (AArch64fcmge:{ *:[v8i16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FACGEv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1159,
        GIR_EraseRootFromParent_Done,
      // Label 8180: @419183
      GIM_Try, /*On fail goto*//*Label 8181*/ GIMT_Encode4(419210), // Rule ID 1203 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (AArch64fcmge:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMGEv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv8f16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1203,
        GIR_Done,
      // Label 8181: @419210
      GIM_Reject,
    // Label 8179: @419211
    GIM_Reject,
    // Label 8162: @419212
    GIM_Reject,
    // Label 128: @419213
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8188*/ GIMT_Encode4(419442),
    /*GILLT_s64*//*Label 8182*/ GIMT_Encode4(419256), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 8183*/ GIMT_Encode4(419287),
    /*GILLT_v2s64*//*Label 8184*/ GIMT_Encode4(419318),
    /*GILLT_v4s16*//*Label 8185*/ GIMT_Encode4(419349),
    /*GILLT_v4s32*//*Label 8186*/ GIMT_Encode4(419380), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 8187*/ GIMT_Encode4(419411),
    // Label 8182: @419256
    GIM_Try, /*On fail goto*//*Label 8189*/ GIMT_Encode4(419286), // Rule ID 5279 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64fcmgez:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMGEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv1i64rz),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5279,
      GIR_Done,
    // Label 8189: @419286
    GIM_Reject,
    // Label 8183: @419287
    GIM_Try, /*On fail goto*//*Label 8190*/ GIMT_Encode4(419317), // Rule ID 767 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64fcmgez:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2i32rz),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 767,
      GIR_Done,
    // Label 8190: @419317
    GIM_Reject,
    // Label 8184: @419318
    GIM_Try, /*On fail goto*//*Label 8191*/ GIMT_Encode4(419348), // Rule ID 769 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64fcmgez:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2i64rz),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 769,
      GIR_Done,
    // Label 8191: @419348
    GIM_Reject,
    // Label 8185: @419349
    GIM_Try, /*On fail goto*//*Label 8192*/ GIMT_Encode4(419379), // Rule ID 765 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64fcmgez:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4i16rz),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 765,
      GIR_Done,
    // Label 8192: @419379
    GIM_Reject,
    // Label 8186: @419380
    GIM_Try, /*On fail goto*//*Label 8193*/ GIMT_Encode4(419410), // Rule ID 768 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64fcmgez:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4i32rz),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 768,
      GIR_Done,
    // Label 8193: @419410
    GIM_Reject,
    // Label 8187: @419411
    GIM_Try, /*On fail goto*//*Label 8194*/ GIMT_Encode4(419441), // Rule ID 766 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64fcmgez:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv8i16rz),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 766,
      GIR_Done,
    // Label 8194: @419441
    GIM_Reject,
    // Label 8188: @419442
    GIM_Reject,
    // Label 129: @419443
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 8202*/ GIMT_Encode4(420106),
    /*GILLT_s32*//*Label 8195*/ GIMT_Encode4(419490),
    /*GILLT_s64*//*Label 8196*/ GIMT_Encode4(419528), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 8197*/ GIMT_Encode4(419591),
    /*GILLT_v2s64*//*Label 8198*/ GIMT_Encode4(419694),
    /*GILLT_v4s16*//*Label 8199*/ GIMT_Encode4(419797),
    /*GILLT_v4s32*//*Label 8200*/ GIMT_Encode4(419900), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 8201*/ GIMT_Encode4(420003),
    // Label 8195: @419490
    GIM_Try, /*On fail goto*//*Label 8203*/ GIMT_Encode4(419527), // Rule ID 1615 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      // (AArch64fcmgt:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FCMGT32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGT32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1615,
      GIR_Done,
    // Label 8203: @419527
    GIM_Reject,
    // Label 8196: @419528
    GIM_Try, /*On fail goto*//*Label 8204*/ GIMT_Encode4(419590),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8205*/ GIMT_Encode4(419570), // Rule ID 1614 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64fcmgt:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FCMGT64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGT64),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1614,
        GIR_Done,
      // Label 8205: @419570
      GIM_Try, /*On fail goto*//*Label 8206*/ GIMT_Encode4(419589), // Rule ID 5250 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64fcmgt:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FCMGT64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGT64),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5250,
        GIR_Done,
      // Label 8206: @419589
      GIM_Reject,
    // Label 8204: @419590
    GIM_Reject,
    // Label 8197: @419591
    GIM_Try, /*On fail goto*//*Label 8207*/ GIMT_Encode4(419693),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8208*/ GIMT_Encode4(419665), // Rule ID 1171 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (AArch64fcmgt:{ *:[v2i32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FACGTv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1171,
        GIR_EraseRootFromParent_Done,
      // Label 8208: @419665
      GIM_Try, /*On fail goto*//*Label 8209*/ GIMT_Encode4(419692), // Rule ID 1209 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (AArch64fcmgt:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMGTv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2f32),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1209,
        GIR_Done,
      // Label 8209: @419692
      GIM_Reject,
    // Label 8207: @419693
    GIM_Reject,
    // Label 8198: @419694
    GIM_Try, /*On fail goto*//*Label 8210*/ GIMT_Encode4(419796),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8211*/ GIMT_Encode4(419768), // Rule ID 1175 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (AArch64fcmgt:{ *:[v2i64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FACGTv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1175,
        GIR_EraseRootFromParent_Done,
      // Label 8211: @419768
      GIM_Try, /*On fail goto*//*Label 8212*/ GIMT_Encode4(419795), // Rule ID 1211 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (AArch64fcmgt:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMGTv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2f64),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1211,
        GIR_Done,
      // Label 8212: @419795
      GIM_Reject,
    // Label 8210: @419796
    GIM_Reject,
    // Label 8199: @419797
    GIM_Try, /*On fail goto*//*Label 8213*/ GIMT_Encode4(419899),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8214*/ GIMT_Encode4(419871), // Rule ID 1167 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (AArch64fcmgt:{ *:[v4i16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FACGTv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1167,
        GIR_EraseRootFromParent_Done,
      // Label 8214: @419871
      GIM_Try, /*On fail goto*//*Label 8215*/ GIMT_Encode4(419898), // Rule ID 1207 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (AArch64fcmgt:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMGTv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4f16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1207,
        GIR_Done,
      // Label 8215: @419898
      GIM_Reject,
    // Label 8213: @419899
    GIM_Reject,
    // Label 8200: @419900
    GIM_Try, /*On fail goto*//*Label 8216*/ GIMT_Encode4(420002),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8217*/ GIMT_Encode4(419974), // Rule ID 1173 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (AArch64fcmgt:{ *:[v4i32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FACGTv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1173,
        GIR_EraseRootFromParent_Done,
      // Label 8217: @419974
      GIM_Try, /*On fail goto*//*Label 8218*/ GIMT_Encode4(420001), // Rule ID 1210 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (AArch64fcmgt:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMGTv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4f32),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1210,
        GIR_Done,
      // Label 8218: @420001
      GIM_Reject,
    // Label 8216: @420002
    GIM_Reject,
    // Label 8201: @420003
    GIM_Try, /*On fail goto*//*Label 8219*/ GIMT_Encode4(420105),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8220*/ GIMT_Encode4(420077), // Rule ID 1169 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (AArch64fcmgt:{ *:[v8i16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FACGTv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv8f16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1169,
        GIR_EraseRootFromParent_Done,
      // Label 8220: @420077
      GIM_Try, /*On fail goto*//*Label 8221*/ GIMT_Encode4(420104), // Rule ID 1208 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (AArch64fcmgt:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMGTv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv8f16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1208,
        GIR_Done,
      // Label 8221: @420104
      GIM_Reject,
    // Label 8219: @420105
    GIM_Reject,
    // Label 8202: @420106
    GIM_Reject,
    // Label 130: @420107
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8228*/ GIMT_Encode4(420336),
    /*GILLT_s64*//*Label 8222*/ GIMT_Encode4(420150), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 8223*/ GIMT_Encode4(420181),
    /*GILLT_v2s64*//*Label 8224*/ GIMT_Encode4(420212),
    /*GILLT_v4s16*//*Label 8225*/ GIMT_Encode4(420243),
    /*GILLT_v4s32*//*Label 8226*/ GIMT_Encode4(420274), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 8227*/ GIMT_Encode4(420305),
    // Label 8222: @420150
    GIM_Try, /*On fail goto*//*Label 8229*/ GIMT_Encode4(420180), // Rule ID 5280 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64fcmgtz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMGTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv1i64rz),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5280,
      GIR_Done,
    // Label 8229: @420180
    GIM_Reject,
    // Label 8223: @420181
    GIM_Try, /*On fail goto*//*Label 8230*/ GIMT_Encode4(420211), // Rule ID 772 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64fcmgtz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2i32rz),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 772,
      GIR_Done,
    // Label 8230: @420211
    GIM_Reject,
    // Label 8224: @420212
    GIM_Try, /*On fail goto*//*Label 8231*/ GIMT_Encode4(420242), // Rule ID 774 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64fcmgtz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2i64rz),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 774,
      GIR_Done,
    // Label 8231: @420242
    GIM_Reject,
    // Label 8225: @420243
    GIM_Try, /*On fail goto*//*Label 8232*/ GIMT_Encode4(420273), // Rule ID 770 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64fcmgtz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4i16rz),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 770,
      GIR_Done,
    // Label 8232: @420273
    GIM_Reject,
    // Label 8226: @420274
    GIM_Try, /*On fail goto*//*Label 8233*/ GIMT_Encode4(420304), // Rule ID 773 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64fcmgtz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4i32rz),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 773,
      GIR_Done,
    // Label 8233: @420304
    GIM_Reject,
    // Label 8227: @420305
    GIM_Try, /*On fail goto*//*Label 8234*/ GIMT_Encode4(420335), // Rule ID 771 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64fcmgtz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv8i16rz),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 771,
      GIR_Done,
    // Label 8234: @420335
    GIM_Reject,
    // Label 8228: @420336
    GIM_Reject,
    // Label 131: @420337
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8241*/ GIMT_Encode4(420566),
    /*GILLT_s64*//*Label 8235*/ GIMT_Encode4(420380), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 8236*/ GIMT_Encode4(420411),
    /*GILLT_v2s64*//*Label 8237*/ GIMT_Encode4(420442),
    /*GILLT_v4s16*//*Label 8238*/ GIMT_Encode4(420473),
    /*GILLT_v4s32*//*Label 8239*/ GIMT_Encode4(420504), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 8240*/ GIMT_Encode4(420535),
    // Label 8235: @420380
    GIM_Try, /*On fail goto*//*Label 8242*/ GIMT_Encode4(420410), // Rule ID 5281 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64fcmlez:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMLEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv1i64rz),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5281,
      GIR_Done,
    // Label 8242: @420410
    GIM_Reject,
    // Label 8236: @420411
    GIM_Try, /*On fail goto*//*Label 8243*/ GIMT_Encode4(420441), // Rule ID 777 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64fcmlez:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv2i32rz),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 777,
      GIR_Done,
    // Label 8243: @420441
    GIM_Reject,
    // Label 8237: @420442
    GIM_Try, /*On fail goto*//*Label 8244*/ GIMT_Encode4(420472), // Rule ID 779 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64fcmlez:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv2i64rz),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 779,
      GIR_Done,
    // Label 8244: @420472
    GIM_Reject,
    // Label 8238: @420473
    GIM_Try, /*On fail goto*//*Label 8245*/ GIMT_Encode4(420503), // Rule ID 775 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64fcmlez:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv4i16rz),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 775,
      GIR_Done,
    // Label 8245: @420503
    GIM_Reject,
    // Label 8239: @420504
    GIM_Try, /*On fail goto*//*Label 8246*/ GIMT_Encode4(420534), // Rule ID 778 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64fcmlez:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv4i32rz),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 778,
      GIR_Done,
    // Label 8246: @420534
    GIM_Reject,
    // Label 8240: @420535
    GIM_Try, /*On fail goto*//*Label 8247*/ GIMT_Encode4(420565), // Rule ID 776 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64fcmlez:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv8i16rz),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 776,
      GIR_Done,
    // Label 8247: @420565
    GIM_Reject,
    // Label 8241: @420566
    GIM_Reject,
    // Label 132: @420567
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8254*/ GIMT_Encode4(420796),
    /*GILLT_s64*//*Label 8248*/ GIMT_Encode4(420610), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 8249*/ GIMT_Encode4(420641),
    /*GILLT_v2s64*//*Label 8250*/ GIMT_Encode4(420672),
    /*GILLT_v4s16*//*Label 8251*/ GIMT_Encode4(420703),
    /*GILLT_v4s32*//*Label 8252*/ GIMT_Encode4(420734), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 8253*/ GIMT_Encode4(420765),
    // Label 8248: @420610
    GIM_Try, /*On fail goto*//*Label 8255*/ GIMT_Encode4(420640), // Rule ID 5282 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64fcmltz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMLTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv1i64rz),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 5282,
      GIR_Done,
    // Label 8255: @420640
    GIM_Reject,
    // Label 8249: @420641
    GIM_Try, /*On fail goto*//*Label 8256*/ GIMT_Encode4(420671), // Rule ID 782 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64fcmltz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv2i32rz),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 782,
      GIR_Done,
    // Label 8256: @420671
    GIM_Reject,
    // Label 8250: @420672
    GIM_Try, /*On fail goto*//*Label 8257*/ GIMT_Encode4(420702), // Rule ID 784 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64fcmltz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv2i64rz),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 784,
      GIR_Done,
    // Label 8257: @420702
    GIM_Reject,
    // Label 8251: @420703
    GIM_Try, /*On fail goto*//*Label 8258*/ GIMT_Encode4(420733), // Rule ID 780 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64fcmltz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv4i16rz),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 780,
      GIR_Done,
    // Label 8258: @420733
    GIM_Reject,
    // Label 8252: @420734
    GIM_Try, /*On fail goto*//*Label 8259*/ GIMT_Encode4(420764), // Rule ID 783 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64fcmltz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv4i32rz),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 783,
      GIR_Done,
    // Label 8259: @420764
    GIM_Reject,
    // Label 8253: @420765
    GIM_Try, /*On fail goto*//*Label 8260*/ GIMT_Encode4(420795), // Rule ID 781 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64fcmltz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv8i16rz),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 781,
      GIR_Done,
    // Label 8260: @420795
    GIM_Reject,
    // Label 8254: @420796
    GIM_Reject,
    // Label 133: @420797
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(12), /*)*//*default:*//*Label 8263*/ GIMT_Encode4(420874),
    /*GILLT_v8s8*//*Label 8261*/ GIMT_Encode4(420820), GIMT_Encode4(0),
    /*GILLT_v16s8*//*Label 8262*/ GIMT_Encode4(420847),
    // Label 8261: @420820
    GIM_Try, /*On fail goto*//*Label 8264*/ GIMT_Encode4(420846), // Rule ID 965 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64rev16:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (REV16v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 965,
      GIR_Done,
    // Label 8264: @420846
    GIM_Reject,
    // Label 8262: @420847
    GIM_Try, /*On fail goto*//*Label 8265*/ GIMT_Encode4(420873), // Rule ID 966 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64rev16:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (REV16v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 966,
      GIR_Done,
    // Label 8265: @420873
    GIM_Reject,
    // Label 8263: @420874
    GIM_Reject,
    // Label 134: @420875
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(12), /*)*//*default:*//*Label 8270*/ GIMT_Encode4(421074),
    /*GILLT_v4s16*//*Label 8266*/ GIMT_Encode4(420906), GIMT_Encode4(0),
    /*GILLT_v8s8*//*Label 8267*/ GIMT_Encode4(420963),
    /*GILLT_v8s16*//*Label 8268*/ GIMT_Encode4(420990),
    /*GILLT_v16s8*//*Label 8269*/ GIMT_Encode4(421047),
    // Label 8266: @420906
    GIM_Try, /*On fail goto*//*Label 8271*/ GIMT_Encode4(420962),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8272*/ GIMT_Encode4(420937), // Rule ID 969 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64rev32:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (REV32v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 969,
        GIR_Done,
      // Label 8272: @420937
      GIM_Try, /*On fail goto*//*Label 8273*/ GIMT_Encode4(420949), // Rule ID 4997 //
        // (AArch64rev32:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (REV32v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4997,
        GIR_Done,
      // Label 8273: @420949
      GIM_Try, /*On fail goto*//*Label 8274*/ GIMT_Encode4(420961), // Rule ID 4999 //
        // (AArch64rev32:{ *:[v4bf16] } V64:{ *:[v4bf16] }:$Rn)  =>  (REV32v4i16:{ *:[v4bf16] } V64:{ *:[v4bf16] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4999,
        GIR_Done,
      // Label 8274: @420961
      GIM_Reject,
    // Label 8271: @420962
    GIM_Reject,
    // Label 8267: @420963
    GIM_Try, /*On fail goto*//*Label 8275*/ GIMT_Encode4(420989), // Rule ID 967 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64rev32:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (REV32v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 967,
      GIR_Done,
    // Label 8275: @420989
    GIM_Reject,
    // Label 8268: @420990
    GIM_Try, /*On fail goto*//*Label 8276*/ GIMT_Encode4(421046),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8277*/ GIMT_Encode4(421021), // Rule ID 970 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64rev32:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (REV32v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 970,
        GIR_Done,
      // Label 8277: @421021
      GIM_Try, /*On fail goto*//*Label 8278*/ GIMT_Encode4(421033), // Rule ID 5001 //
        // (AArch64rev32:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (REV32v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5001,
        GIR_Done,
      // Label 8278: @421033
      GIM_Try, /*On fail goto*//*Label 8279*/ GIMT_Encode4(421045), // Rule ID 5003 //
        // (AArch64rev32:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn)  =>  (REV32v8i16:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5003,
        GIR_Done,
      // Label 8279: @421045
      GIM_Reject,
    // Label 8276: @421046
    GIM_Reject,
    // Label 8269: @421047
    GIM_Try, /*On fail goto*//*Label 8280*/ GIMT_Encode4(421073), // Rule ID 968 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64rev32:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (REV32v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 968,
      GIR_Done,
    // Label 8280: @421073
    GIM_Reject,
    // Label 8270: @421074
    GIM_Reject,
    // Label 135: @421075
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(12), /*)*//*default:*//*Label 8287*/ GIMT_Encode4(421372),
    /*GILLT_v2s32*//*Label 8281*/ GIMT_Encode4(421114), GIMT_Encode4(0),
    /*GILLT_v4s16*//*Label 8282*/ GIMT_Encode4(421159),
    /*GILLT_v4s32*//*Label 8283*/ GIMT_Encode4(421216),
    /*GILLT_v8s8*//*Label 8284*/ GIMT_Encode4(421261),
    /*GILLT_v8s16*//*Label 8285*/ GIMT_Encode4(421288),
    /*GILLT_v16s8*//*Label 8286*/ GIMT_Encode4(421345),
    // Label 8281: @421114
    GIM_Try, /*On fail goto*//*Label 8288*/ GIMT_Encode4(421158),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8289*/ GIMT_Encode4(421145), // Rule ID 975 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64rev64:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (REV64v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 975,
        GIR_Done,
      // Label 8289: @421145
      GIM_Try, /*On fail goto*//*Label 8290*/ GIMT_Encode4(421157), // Rule ID 5005 //
        // (AArch64rev64:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (REV64v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5005,
        GIR_Done,
      // Label 8290: @421157
      GIM_Reject,
    // Label 8288: @421158
    GIM_Reject,
    // Label 8282: @421159
    GIM_Try, /*On fail goto*//*Label 8291*/ GIMT_Encode4(421215),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8292*/ GIMT_Encode4(421190), // Rule ID 973 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64rev64:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (REV64v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 973,
        GIR_Done,
      // Label 8292: @421190
      GIM_Try, /*On fail goto*//*Label 8293*/ GIMT_Encode4(421202), // Rule ID 4998 //
        // (AArch64rev64:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (REV64v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4998,
        GIR_Done,
      // Label 8293: @421202
      GIM_Try, /*On fail goto*//*Label 8294*/ GIMT_Encode4(421214), // Rule ID 5000 //
        // (AArch64rev64:{ *:[v4bf16] } V64:{ *:[v4bf16] }:$Rn)  =>  (REV64v4i16:{ *:[v4bf16] } V64:{ *:[v4bf16] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5000,
        GIR_Done,
      // Label 8294: @421214
      GIM_Reject,
    // Label 8291: @421215
    GIM_Reject,
    // Label 8283: @421216
    GIM_Try, /*On fail goto*//*Label 8295*/ GIMT_Encode4(421260),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8296*/ GIMT_Encode4(421247), // Rule ID 976 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64rev64:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (REV64v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 976,
        GIR_Done,
      // Label 8296: @421247
      GIM_Try, /*On fail goto*//*Label 8297*/ GIMT_Encode4(421259), // Rule ID 5006 //
        // (AArch64rev64:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (REV64v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5006,
        GIR_Done,
      // Label 8297: @421259
      GIM_Reject,
    // Label 8295: @421260
    GIM_Reject,
    // Label 8284: @421261
    GIM_Try, /*On fail goto*//*Label 8298*/ GIMT_Encode4(421287), // Rule ID 971 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64rev64:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (REV64v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 971,
      GIR_Done,
    // Label 8298: @421287
    GIM_Reject,
    // Label 8285: @421288
    GIM_Try, /*On fail goto*//*Label 8299*/ GIMT_Encode4(421344),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8300*/ GIMT_Encode4(421319), // Rule ID 974 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64rev64:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (REV64v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 974,
        GIR_Done,
      // Label 8300: @421319
      GIM_Try, /*On fail goto*//*Label 8301*/ GIMT_Encode4(421331), // Rule ID 5002 //
        // (AArch64rev64:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (REV64v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5002,
        GIR_Done,
      // Label 8301: @421331
      GIM_Try, /*On fail goto*//*Label 8302*/ GIMT_Encode4(421343), // Rule ID 5004 //
        // (AArch64rev64:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn)  =>  (REV64v8i16:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5004,
        GIR_Done,
      // Label 8302: @421343
      GIM_Reject,
    // Label 8299: @421344
    GIM_Reject,
    // Label 8286: @421345
    GIM_Try, /*On fail goto*//*Label 8303*/ GIMT_Encode4(421371), // Rule ID 972 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64rev64:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (REV64v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 972,
      GIR_Done,
    // Label 8303: @421371
    GIM_Reject,
    // Label 8287: @421372
    GIM_Reject,
    // Label 136: @421373
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8310*/ GIMT_Encode4(421578),
    /*GILLT_s64*//*Label 8304*/ GIMT_Encode4(421416), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 8305*/ GIMT_Encode4(421443),
    /*GILLT_v2s64*//*Label 8306*/ GIMT_Encode4(421470),
    /*GILLT_v4s16*//*Label 8307*/ GIMT_Encode4(421497),
    /*GILLT_v4s32*//*Label 8308*/ GIMT_Encode4(421524), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 8309*/ GIMT_Encode4(421551),
    // Label 8304: @421416
    GIM_Try, /*On fail goto*//*Label 8311*/ GIMT_Encode4(421442), // Rule ID 997 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64saddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)  =>  (SADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv2i32_v1i64),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 997,
      GIR_Done,
    // Label 8311: @421442
    GIM_Reject,
    // Label 8305: @421443
    GIM_Try, /*On fail goto*//*Label 8312*/ GIMT_Encode4(421469), // Rule ID 993 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i16_v2i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 993,
      GIR_Done,
    // Label 8312: @421469
    GIM_Reject,
    // Label 8306: @421470
    GIM_Try, /*On fail goto*//*Label 8313*/ GIMT_Encode4(421496), // Rule ID 999 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (SADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i32_v2i64),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 999,
      GIR_Done,
    // Label 8313: @421496
    GIM_Reject,
    // Label 8307: @421497
    GIM_Try, /*On fail goto*//*Label 8314*/ GIMT_Encode4(421523), // Rule ID 989 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)  =>  (SADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i8_v4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 989,
      GIR_Done,
    // Label 8314: @421523
    GIM_Reject,
    // Label 8308: @421524
    GIM_Try, /*On fail goto*//*Label 8315*/ GIMT_Encode4(421550), // Rule ID 995 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (SADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i16_v4i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 995,
      GIR_Done,
    // Label 8315: @421550
    GIM_Reject,
    // Label 8309: @421551
    GIM_Try, /*On fail goto*//*Label 8316*/ GIMT_Encode4(421577), // Rule ID 991 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)  =>  (SADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv16i8_v8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 991,
      GIR_Done,
    // Label 8316: @421577
    GIM_Reject,
    // Label 8310: @421578
    GIM_Reject,
    // Label 137: @421579
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(9), /*)*//*default:*//*Label 8319*/ GIMT_Encode4(421977),
    /*GILLT_v2s64*//*Label 8317*/ GIMT_Encode4(421602), GIMT_Encode4(0),
    /*GILLT_v4s32*//*Label 8318*/ GIMT_Encode4(421740),
    // Label 8317: @421602
    GIM_Try, /*On fail goto*//*Label 8320*/ GIMT_Encode4(421661), // Rule ID 5922 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64saddlv:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (SADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i32v),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 5922,
      GIR_EraseRootFromParent_Done,
    // Label 8320: @421661
    GIM_Try, /*On fail goto*//*Label 8321*/ GIMT_Encode4(421739), // Rule ID 6044 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64saddlv:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (SADDLPv2i32_v1i64:{ *:[i64] } V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv2i32_v1i64),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6044,
      GIR_EraseRootFromParent_Done,
    // Label 8321: @421739
    GIM_Reject,
    // Label 8318: @421740
    GIM_Try, /*On fail goto*//*Label 8322*/ GIMT_Encode4(421799), // Rule ID 5918 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64saddlv:{ *:[v4i32] } V64:{ *:[v8i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn), hsub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i8v),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      // GIR_Coverage, 5918,
      GIR_EraseRootFromParent_Done,
    // Label 8322: @421799
    GIM_Try, /*On fail goto*//*Label 8323*/ GIMT_Encode4(421858), // Rule ID 5919 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64saddlv:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn), ssub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i16v),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
      // GIR_Coverage, 5919,
      GIR_EraseRootFromParent_Done,
    // Label 8323: @421858
    GIM_Try, /*On fail goto*//*Label 8324*/ GIMT_Encode4(421917), // Rule ID 5920 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64saddlv:{ *:[v4i32] } V128:{ *:[v16i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn), hsub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv16i8v),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      // GIR_Coverage, 5920,
      GIR_EraseRootFromParent_Done,
    // Label 8324: @421917
    GIM_Try, /*On fail goto*//*Label 8325*/ GIMT_Encode4(421976), // Rule ID 5921 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64saddlv:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn), ssub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i16v),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
      // GIR_Coverage, 5921,
      GIR_EraseRootFromParent_Done,
    // Label 8325: @421976
    GIM_Reject,
    // Label 8319: @421977
    GIM_Reject,
    // Label 138: @421978
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(20), /*)*//*default:*//*Label 8330*/ GIMT_Encode4(422347),
    /*GILLT_v2s32*//*Label 8326*/ GIMT_Encode4(422049), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_v4s32*//*Label 8327*/ GIMT_Encode4(422169), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s64*//*Label 8328*/ GIMT_Encode4(422289), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv4s32*//*Label 8329*/ GIMT_Encode4(422318),
    // Label 8326: @422049
    GIM_Try, /*On fail goto*//*Label 8331*/ GIMT_Encode4(422168),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8332*/ GIMT_Encode4(422148), // Rule ID 26 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (AArch64sdot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, (bitconvert:{ *:[v8i8] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SDOTlanev8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOTlanev8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 26,
        GIR_EraseRootFromParent_Done,
      // Label 8332: @422148
      GIM_Try, /*On fail goto*//*Label 8333*/ GIMT_Encode4(422167), // Rule ID 22 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (AArch64sdot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SDOTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOTv8i8),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22,
        GIR_Done,
      // Label 8333: @422167
      GIM_Reject,
    // Label 8331: @422168
    GIM_Reject,
    // Label 8327: @422169
    GIM_Try, /*On fail goto*//*Label 8334*/ GIMT_Encode4(422288),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8335*/ GIMT_Encode4(422268), // Rule ID 27 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (AArch64sdot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, (bitconvert:{ *:[v16i8] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SDOTlanev16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOTlanev16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 27,
        GIR_EraseRootFromParent_Done,
      // Label 8335: @422268
      GIM_Try, /*On fail goto*//*Label 8336*/ GIMT_Encode4(422287), // Rule ID 23 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (AArch64sdot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SDOTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOTv16i8),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23,
        GIR_Done,
      // Label 8336: @422287
      GIM_Reject,
    // Label 8334: @422288
    GIM_Reject,
    // Label 8328: @422289
    GIM_Try, /*On fail goto*//*Label 8337*/ GIMT_Encode4(422317), // Rule ID 2964 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (AArch64sdot:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SDOT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZ_D),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2964,
      GIR_Done,
    // Label 8337: @422317
    GIM_Reject,
    // Label 8329: @422318
    GIM_Try, /*On fail goto*//*Label 8338*/ GIMT_Encode4(422346), // Rule ID 2963 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (AArch64sdot:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SDOT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZ_S),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2963,
      GIR_Done,
    // Label 8338: @422346
    GIM_Reject,
    // Label 8330: @422347
    GIM_Reject,
    // Label 139: @422348
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8342*/ GIMT_Encode4(422464),
    /*GILLT_s16*//*Label 8339*/ GIMT_Encode4(422371),
    /*GILLT_s32*//*Label 8340*/ GIMT_Encode4(422402),
    /*GILLT_s64*//*Label 8341*/ GIMT_Encode4(422433),
    // Label 8339: @422371
    GIM_Try, /*On fail goto*//*Label 8343*/ GIMT_Encode4(422401), // Rule ID 1647 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // (AArch64sitof:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (SCVTFv1i16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1647,
      GIR_Done,
    // Label 8343: @422401
    GIM_Reject,
    // Label 8340: @422402
    GIM_Try, /*On fail goto*//*Label 8344*/ GIMT_Encode4(422432), // Rule ID 1646 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      // (AArch64sitof:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (SCVTFv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1646,
      GIR_Done,
    // Label 8344: @422432
    GIM_Reject,
    // Label 8341: @422433
    GIM_Try, /*On fail goto*//*Label 8345*/ GIMT_Encode4(422463), // Rule ID 1645 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64sitof:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (SCVTFv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1645,
      GIR_Done,
    // Label 8345: @422463
    GIM_Reject,
    // Label 8342: @422464
    GIM_Reject,
    // Label 140: @422465
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(11), /*)*//*default:*//*Label 8349*/ GIMT_Encode4(423697),
    /*GILLT_v2s64*//*Label 8346*/ GIMT_Encode4(422496), GIMT_Encode4(0),
    /*GILLT_v4s32*//*Label 8347*/ GIMT_Encode4(423057), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 8348*/ GIMT_Encode4(423618),
    // Label 8346: @422496
    GIM_Try, /*On fail goto*//*Label 8350*/ GIMT_Encode4(423056),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8351*/ GIMT_Encode4(422603), // Rule ID 2043 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }))  =>  (SMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2043,
        GIR_EraseRootFromParent_Done,
      // Label 8351: @422603
      GIM_Try, /*On fail goto*//*Label 8352*/ GIMT_Encode4(422695), // Rule ID 13579 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (SMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13579,
        GIR_EraseRootFromParent_Done,
      // Label 8352: @422695
      GIM_Try, /*On fail goto*//*Label 8353*/ GIMT_Encode4(422781), // Rule ID 13577 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13577,
        GIR_EraseRootFromParent_Done,
      // Label 8353: @422781
      GIM_Try, /*On fail goto*//*Label 8354*/ GIMT_Encode4(422867), // Rule ID 2041 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2041,
        GIR_EraseRootFromParent_Done,
      // Label 8354: @422867
      GIM_Try, /*On fail goto*//*Label 8355*/ GIMT_Encode4(422906), // Rule ID 1730 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (SMULLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1730,
        GIR_EraseRootFromParent_Done,
      // Label 8355: @422906
      GIM_Try, /*On fail goto*//*Label 8356*/ GIMT_Encode4(422969), // Rule ID 13578 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn)  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13578,
        GIR_EraseRootFromParent_Done,
      // Label 8356: @422969
      GIM_Try, /*On fail goto*//*Label 8357*/ GIMT_Encode4(423032), // Rule ID 2042 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2042,
        GIR_EraseRootFromParent_Done,
      // Label 8357: @423032
      GIM_Try, /*On fail goto*//*Label 8358*/ GIMT_Encode4(423055), // Rule ID 1729 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMULLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_v2i64),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1729,
        GIR_Done,
      // Label 8358: @423055
      GIM_Reject,
    // Label 8350: @423056
    GIM_Reject,
    // Label 8347: @423057
    GIM_Try, /*On fail goto*//*Label 8359*/ GIMT_Encode4(423617),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8360*/ GIMT_Encode4(423164), // Rule ID 2040 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }))  =>  (SMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2040,
        GIR_EraseRootFromParent_Done,
      // Label 8360: @423164
      GIM_Try, /*On fail goto*//*Label 8361*/ GIMT_Encode4(423256), // Rule ID 13576 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (SMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13576,
        GIR_EraseRootFromParent_Done,
      // Label 8361: @423256
      GIM_Try, /*On fail goto*//*Label 8362*/ GIMT_Encode4(423342), // Rule ID 13574 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13574,
        GIR_EraseRootFromParent_Done,
      // Label 8362: @423342
      GIM_Try, /*On fail goto*//*Label 8363*/ GIMT_Encode4(423428), // Rule ID 2038 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2038,
        GIR_EraseRootFromParent_Done,
      // Label 8363: @423428
      GIM_Try, /*On fail goto*//*Label 8364*/ GIMT_Encode4(423467), // Rule ID 1728 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (SMULLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1728,
        GIR_EraseRootFromParent_Done,
      // Label 8364: @423467
      GIM_Try, /*On fail goto*//*Label 8365*/ GIMT_Encode4(423530), // Rule ID 13575 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn)  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13575,
        GIR_EraseRootFromParent_Done,
      // Label 8365: @423530
      GIM_Try, /*On fail goto*//*Label 8366*/ GIMT_Encode4(423593), // Rule ID 2039 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2039,
        GIR_EraseRootFromParent_Done,
      // Label 8366: @423593
      GIM_Try, /*On fail goto*//*Label 8367*/ GIMT_Encode4(423616), // Rule ID 1727 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMULLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_v4i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1727,
        GIR_Done,
      // Label 8367: @423616
      GIM_Reject,
    // Label 8359: @423617
    GIM_Reject,
    // Label 8348: @423618
    GIM_Try, /*On fail goto*//*Label 8368*/ GIMT_Encode4(423696),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8369*/ GIMT_Encode4(423672), // Rule ID 1726 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))  =>  (SMULLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1726,
        GIR_EraseRootFromParent_Done,
      // Label 8369: @423672
      GIM_Try, /*On fail goto*//*Label 8370*/ GIMT_Encode4(423695), // Rule ID 1725 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMULLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i8_v8i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1725,
        GIR_Done,
      // Label 8370: @423695
      GIM_Reject,
    // Label 8368: @423696
    GIM_Reject,
    // Label 8349: @423697
    GIM_Reject,
    // Label 141: @423698
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8389*/ GIMT_Encode4(424522),
    /*GILLT_v2s32*//*Label 8371*/ GIMT_Encode4(423785),
    /*GILLT_v2s64*//*Label 8372*/ GIMT_Encode4(423840),
    /*GILLT_v4s16*//*Label 8373*/ GIMT_Encode4(423895),
    /*GILLT_v4s32*//*Label 8374*/ GIMT_Encode4(423965),
    /*GILLT_v8s8*//*Label 8375*/ GIMT_Encode4(424020),
    /*GILLT_v8s16*//*Label 8376*/ GIMT_Encode4(424054),
    /*GILLT_v16s8*//*Label 8377*/ GIMT_Encode4(424124), GIMT_Encode4(0),
    /*GILLT_nxv2s1*//*Label 8378*/ GIMT_Encode4(424158),
    /*GILLT_nxv2s16*//*Label 8379*/ GIMT_Encode4(424184),
    /*GILLT_nxv2s32*//*Label 8380*/ GIMT_Encode4(424210),
    /*GILLT_nxv2s64*//*Label 8381*/ GIMT_Encode4(424236),
    /*GILLT_nxv4s1*//*Label 8382*/ GIMT_Encode4(424283),
    /*GILLT_nxv4s16*//*Label 8383*/ GIMT_Encode4(424309),
    /*GILLT_nxv4s32*//*Label 8384*/ GIMT_Encode4(424335),
    /*GILLT_nxv8s1*//*Label 8385*/ GIMT_Encode4(424382),
    /*GILLT_nxv8s16*//*Label 8386*/ GIMT_Encode4(424408),
    /*GILLT_nxv16s1*//*Label 8387*/ GIMT_Encode4(424470),
    /*GILLT_nxv16s8*//*Label 8388*/ GIMT_Encode4(424496),
    // Label 8371: @423785
    GIM_Try, /*On fail goto*//*Label 8390*/ GIMT_Encode4(423839),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8391*/ GIMT_Encode4(423823), // Rule ID 1863 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64trn1:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (TRN1v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1863,
        GIR_Done,
      // Label 8391: @423823
      GIM_Try, /*On fail goto*//*Label 8392*/ GIMT_Encode4(423838), // Rule ID 2470 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64trn1:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (TRN1v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2470,
        GIR_Done,
      // Label 8392: @423838
      GIM_Reject,
    // Label 8390: @423839
    GIM_Reject,
    // Label 8372: @423840
    GIM_Try, /*On fail goto*//*Label 8393*/ GIMT_Encode4(423894),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8394*/ GIMT_Encode4(423878), // Rule ID 1865 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64trn1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (TRN1v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i64),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1865,
        GIR_Done,
      // Label 8394: @423878
      GIM_Try, /*On fail goto*//*Label 8395*/ GIMT_Encode4(423893), // Rule ID 2472 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64trn1:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (TRN1v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i64),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2472,
        GIR_Done,
      // Label 8395: @423893
      GIM_Reject,
    // Label 8393: @423894
    GIM_Reject,
    // Label 8373: @423895
    GIM_Try, /*On fail goto*//*Label 8396*/ GIMT_Encode4(423964),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8397*/ GIMT_Encode4(423933), // Rule ID 1861 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64trn1:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (TRN1v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1861,
        GIR_Done,
      // Label 8397: @423933
      GIM_Try, /*On fail goto*//*Label 8398*/ GIMT_Encode4(423948), // Rule ID 2466 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64trn1:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (TRN1v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2466,
        GIR_Done,
      // Label 8398: @423948
      GIM_Try, /*On fail goto*//*Label 8399*/ GIMT_Encode4(423963), // Rule ID 2467 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64trn1:{ *:[v4bf16] } V64:{ *:[v4bf16] }:$Rn, V64:{ *:[v4bf16] }:$Rm)  =>  (TRN1v4i16:{ *:[v4bf16] } V64:{ *:[v4bf16] }:$Rn, V64:{ *:[v4bf16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2467,
        GIR_Done,
      // Label 8399: @423963
      GIM_Reject,
    // Label 8396: @423964
    GIM_Reject,
    // Label 8374: @423965
    GIM_Try, /*On fail goto*//*Label 8400*/ GIMT_Encode4(424019),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8401*/ GIMT_Encode4(424003), // Rule ID 1864 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64trn1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (TRN1v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1864,
        GIR_Done,
      // Label 8401: @424003
      GIM_Try, /*On fail goto*//*Label 8402*/ GIMT_Encode4(424018), // Rule ID 2471 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64trn1:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (TRN1v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2471,
        GIR_Done,
      // Label 8402: @424018
      GIM_Reject,
    // Label 8400: @424019
    GIM_Reject,
    // Label 8375: @424020
    GIM_Try, /*On fail goto*//*Label 8403*/ GIMT_Encode4(424053), // Rule ID 1859 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64trn1:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (TRN1v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1859,
      GIR_Done,
    // Label 8403: @424053
    GIM_Reject,
    // Label 8376: @424054
    GIM_Try, /*On fail goto*//*Label 8404*/ GIMT_Encode4(424123),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8405*/ GIMT_Encode4(424092), // Rule ID 1862 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64trn1:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (TRN1v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v8i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1862,
        GIR_Done,
      // Label 8405: @424092
      GIM_Try, /*On fail goto*//*Label 8406*/ GIMT_Encode4(424107), // Rule ID 2468 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64trn1:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (TRN1v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v8i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2468,
        GIR_Done,
      // Label 8406: @424107
      GIM_Try, /*On fail goto*//*Label 8407*/ GIMT_Encode4(424122), // Rule ID 2469 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64trn1:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)  =>  (TRN1v8i16:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v8i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2469,
        GIR_Done,
      // Label 8407: @424122
      GIM_Reject,
    // Label 8404: @424123
    GIM_Reject,
    // Label 8377: @424124
    GIM_Try, /*On fail goto*//*Label 8408*/ GIMT_Encode4(424157), // Rule ID 1860 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64trn1:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (TRN1v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1860,
      GIR_Done,
    // Label 8408: @424157
    GIM_Reject,
    // Label 8378: @424158
    GIM_Try, /*On fail goto*//*Label 8409*/ GIMT_Encode4(424183), // Rule ID 9153 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // (AArch64trn1:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (TRN1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_D),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9153,
      GIR_Done,
    // Label 8409: @424183
    GIM_Reject,
    // Label 8379: @424184
    GIM_Try, /*On fail goto*//*Label 8410*/ GIMT_Encode4(424209), // Rule ID 9127 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (AArch64trn1:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9127,
      GIR_Done,
    // Label 8410: @424209
    GIM_Reject,
    // Label 8380: @424210
    GIM_Try, /*On fail goto*//*Label 8411*/ GIMT_Encode4(424235), // Rule ID 9128 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (AArch64trn1:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9128,
      GIR_Done,
    // Label 8411: @424235
    GIM_Reject,
    // Label 8381: @424236
    GIM_Try, /*On fail goto*//*Label 8412*/ GIMT_Encode4(424282),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 8413*/ GIMT_Encode4(424266), // Rule ID 9123 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64trn1:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9123,
        GIR_Done,
      // Label 8413: @424266
      GIM_Try, /*On fail goto*//*Label 8414*/ GIMT_Encode4(424281), // Rule ID 9129 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64trn1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9129,
        GIR_Done,
      // Label 8414: @424281
      GIM_Reject,
    // Label 8412: @424282
    GIM_Reject,
    // Label 8382: @424283
    GIM_Try, /*On fail goto*//*Label 8415*/ GIMT_Encode4(424308), // Rule ID 9152 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // (AArch64trn1:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (TRN1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_S),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9152,
      GIR_Done,
    // Label 8415: @424308
    GIM_Reject,
    // Label 8383: @424309
    GIM_Try, /*On fail goto*//*Label 8416*/ GIMT_Encode4(424334), // Rule ID 9125 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (AArch64trn1:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (TRN1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_S),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9125,
      GIR_Done,
    // Label 8416: @424334
    GIM_Reject,
    // Label 8384: @424335
    GIM_Try, /*On fail goto*//*Label 8417*/ GIMT_Encode4(424381),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 8418*/ GIMT_Encode4(424365), // Rule ID 9122 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64trn1:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_S),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9122,
        GIR_Done,
      // Label 8418: @424365
      GIM_Try, /*On fail goto*//*Label 8419*/ GIMT_Encode4(424380), // Rule ID 9126 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64trn1:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_S),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9126,
        GIR_Done,
      // Label 8419: @424380
      GIM_Reject,
    // Label 8417: @424381
    GIM_Reject,
    // Label 8385: @424382
    GIM_Try, /*On fail goto*//*Label 8420*/ GIMT_Encode4(424407), // Rule ID 9151 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // (AArch64trn1:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (TRN1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_H),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9151,
      GIR_Done,
    // Label 8420: @424407
    GIM_Reject,
    // Label 8386: @424408
    GIM_Try, /*On fail goto*//*Label 8421*/ GIMT_Encode4(424469),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 8422*/ GIMT_Encode4(424438), // Rule ID 9121 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64trn1:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9121,
        GIR_Done,
      // Label 8422: @424438
      GIM_Try, /*On fail goto*//*Label 8423*/ GIMT_Encode4(424453), // Rule ID 9124 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64trn1:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9124,
        GIR_Done,
      // Label 8423: @424453
      GIM_Try, /*On fail goto*//*Label 8424*/ GIMT_Encode4(424468), // Rule ID 9130 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64trn1:{ *:[nxv8bf16] } nxv8bf16:{ *:[nxv8bf16] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2)  =>  (TRN1_ZZZ_H:{ *:[nxv8bf16] } ?:{ *:[nxv8bf16] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9130,
        GIR_Done,
      // Label 8424: @424468
      GIM_Reject,
    // Label 8421: @424469
    GIM_Reject,
    // Label 8387: @424470
    GIM_Try, /*On fail goto*//*Label 8425*/ GIMT_Encode4(424495), // Rule ID 2391 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // (AArch64trn1:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_B),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2391,
      GIR_Done,
    // Label 8425: @424495
    GIM_Reject,
    // Label 8388: @424496
    GIM_Try, /*On fail goto*//*Label 8426*/ GIMT_Encode4(424521), // Rule ID 9120 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (AArch64trn1:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_B),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9120,
      GIR_Done,
    // Label 8426: @424521
    GIM_Reject,
    // Label 8389: @424522
    GIM_Reject,
    // Label 142: @424523
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8445*/ GIMT_Encode4(425347),
    /*GILLT_v2s32*//*Label 8427*/ GIMT_Encode4(424610),
    /*GILLT_v2s64*//*Label 8428*/ GIMT_Encode4(424665),
    /*GILLT_v4s16*//*Label 8429*/ GIMT_Encode4(424720),
    /*GILLT_v4s32*//*Label 8430*/ GIMT_Encode4(424790),
    /*GILLT_v8s8*//*Label 8431*/ GIMT_Encode4(424845),
    /*GILLT_v8s16*//*Label 8432*/ GIMT_Encode4(424879),
    /*GILLT_v16s8*//*Label 8433*/ GIMT_Encode4(424949), GIMT_Encode4(0),
    /*GILLT_nxv2s1*//*Label 8434*/ GIMT_Encode4(424983),
    /*GILLT_nxv2s16*//*Label 8435*/ GIMT_Encode4(425009),
    /*GILLT_nxv2s32*//*Label 8436*/ GIMT_Encode4(425035),
    /*GILLT_nxv2s64*//*Label 8437*/ GIMT_Encode4(425061),
    /*GILLT_nxv4s1*//*Label 8438*/ GIMT_Encode4(425108),
    /*GILLT_nxv4s16*//*Label 8439*/ GIMT_Encode4(425134),
    /*GILLT_nxv4s32*//*Label 8440*/ GIMT_Encode4(425160),
    /*GILLT_nxv8s1*//*Label 8441*/ GIMT_Encode4(425207),
    /*GILLT_nxv8s16*//*Label 8442*/ GIMT_Encode4(425233),
    /*GILLT_nxv16s1*//*Label 8443*/ GIMT_Encode4(425295),
    /*GILLT_nxv16s8*//*Label 8444*/ GIMT_Encode4(425321),
    // Label 8427: @424610
    GIM_Try, /*On fail goto*//*Label 8446*/ GIMT_Encode4(424664),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8447*/ GIMT_Encode4(424648), // Rule ID 1870 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64trn2:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (TRN2v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1870,
        GIR_Done,
      // Label 8447: @424648
      GIM_Try, /*On fail goto*//*Label 8448*/ GIMT_Encode4(424663), // Rule ID 5507 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64trn2:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (TRN2v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5507,
        GIR_Done,
      // Label 8448: @424663
      GIM_Reject,
    // Label 8446: @424664
    GIM_Reject,
    // Label 8428: @424665
    GIM_Try, /*On fail goto*//*Label 8449*/ GIMT_Encode4(424719),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8450*/ GIMT_Encode4(424703), // Rule ID 1872 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64trn2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (TRN2v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i64),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1872,
        GIR_Done,
      // Label 8450: @424703
      GIM_Try, /*On fail goto*//*Label 8451*/ GIMT_Encode4(424718), // Rule ID 5509 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64trn2:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (TRN2v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i64),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5509,
        GIR_Done,
      // Label 8451: @424718
      GIM_Reject,
    // Label 8449: @424719
    GIM_Reject,
    // Label 8429: @424720
    GIM_Try, /*On fail goto*//*Label 8452*/ GIMT_Encode4(424789),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8453*/ GIMT_Encode4(424758), // Rule ID 1868 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64trn2:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (TRN2v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1868,
        GIR_Done,
      // Label 8453: @424758
      GIM_Try, /*On fail goto*//*Label 8454*/ GIMT_Encode4(424773), // Rule ID 5503 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64trn2:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (TRN2v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5503,
        GIR_Done,
      // Label 8454: @424773
      GIM_Try, /*On fail goto*//*Label 8455*/ GIMT_Encode4(424788), // Rule ID 5504 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64trn2:{ *:[v4bf16] } V64:{ *:[v4bf16] }:$Rn, V64:{ *:[v4bf16] }:$Rm)  =>  (TRN2v4i16:{ *:[v4bf16] } V64:{ *:[v4bf16] }:$Rn, V64:{ *:[v4bf16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5504,
        GIR_Done,
      // Label 8455: @424788
      GIM_Reject,
    // Label 8452: @424789
    GIM_Reject,
    // Label 8430: @424790
    GIM_Try, /*On fail goto*//*Label 8456*/ GIMT_Encode4(424844),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8457*/ GIMT_Encode4(424828), // Rule ID 1871 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64trn2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (TRN2v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1871,
        GIR_Done,
      // Label 8457: @424828
      GIM_Try, /*On fail goto*//*Label 8458*/ GIMT_Encode4(424843), // Rule ID 5508 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64trn2:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (TRN2v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5508,
        GIR_Done,
      // Label 8458: @424843
      GIM_Reject,
    // Label 8456: @424844
    GIM_Reject,
    // Label 8431: @424845
    GIM_Try, /*On fail goto*//*Label 8459*/ GIMT_Encode4(424878), // Rule ID 1866 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64trn2:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (TRN2v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1866,
      GIR_Done,
    // Label 8459: @424878
    GIM_Reject,
    // Label 8432: @424879
    GIM_Try, /*On fail goto*//*Label 8460*/ GIMT_Encode4(424948),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8461*/ GIMT_Encode4(424917), // Rule ID 1869 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64trn2:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (TRN2v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v8i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1869,
        GIR_Done,
      // Label 8461: @424917
      GIM_Try, /*On fail goto*//*Label 8462*/ GIMT_Encode4(424932), // Rule ID 5505 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64trn2:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (TRN2v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v8i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5505,
        GIR_Done,
      // Label 8462: @424932
      GIM_Try, /*On fail goto*//*Label 8463*/ GIMT_Encode4(424947), // Rule ID 5506 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64trn2:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)  =>  (TRN2v8i16:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v8i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5506,
        GIR_Done,
      // Label 8463: @424947
      GIM_Reject,
    // Label 8460: @424948
    GIM_Reject,
    // Label 8433: @424949
    GIM_Try, /*On fail goto*//*Label 8464*/ GIMT_Encode4(424982), // Rule ID 1867 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64trn2:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (TRN2v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1867,
      GIR_Done,
    // Label 8464: @424982
    GIM_Reject,
    // Label 8434: @424983
    GIM_Try, /*On fail goto*//*Label 8465*/ GIMT_Encode4(425008), // Rule ID 9156 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // (AArch64trn2:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (TRN2_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_D),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9156,
      GIR_Done,
    // Label 8465: @425008
    GIM_Reject,
    // Label 8435: @425009
    GIM_Try, /*On fail goto*//*Label 8466*/ GIMT_Encode4(425034), // Rule ID 9138 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (AArch64trn2:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9138,
      GIR_Done,
    // Label 8466: @425034
    GIM_Reject,
    // Label 8436: @425035
    GIM_Try, /*On fail goto*//*Label 8467*/ GIMT_Encode4(425060), // Rule ID 9139 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (AArch64trn2:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9139,
      GIR_Done,
    // Label 8467: @425060
    GIM_Reject,
    // Label 8437: @425061
    GIM_Try, /*On fail goto*//*Label 8468*/ GIMT_Encode4(425107),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 8469*/ GIMT_Encode4(425091), // Rule ID 9134 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64trn2:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9134,
        GIR_Done,
      // Label 8469: @425091
      GIM_Try, /*On fail goto*//*Label 8470*/ GIMT_Encode4(425106), // Rule ID 9140 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64trn2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9140,
        GIR_Done,
      // Label 8470: @425106
      GIM_Reject,
    // Label 8468: @425107
    GIM_Reject,
    // Label 8438: @425108
    GIM_Try, /*On fail goto*//*Label 8471*/ GIMT_Encode4(425133), // Rule ID 9155 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // (AArch64trn2:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (TRN2_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_S),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9155,
      GIR_Done,
    // Label 8471: @425133
    GIM_Reject,
    // Label 8439: @425134
    GIM_Try, /*On fail goto*//*Label 8472*/ GIMT_Encode4(425159), // Rule ID 9136 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (AArch64trn2:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (TRN2_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_S),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9136,
      GIR_Done,
    // Label 8472: @425159
    GIM_Reject,
    // Label 8440: @425160
    GIM_Try, /*On fail goto*//*Label 8473*/ GIMT_Encode4(425206),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 8474*/ GIMT_Encode4(425190), // Rule ID 9133 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64trn2:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_S),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9133,
        GIR_Done,
      // Label 8474: @425190
      GIM_Try, /*On fail goto*//*Label 8475*/ GIMT_Encode4(425205), // Rule ID 9137 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64trn2:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_S),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9137,
        GIR_Done,
      // Label 8475: @425205
      GIM_Reject,
    // Label 8473: @425206
    GIM_Reject,
    // Label 8441: @425207
    GIM_Try, /*On fail goto*//*Label 8476*/ GIMT_Encode4(425232), // Rule ID 9154 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // (AArch64trn2:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (TRN2_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_H),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9154,
      GIR_Done,
    // Label 8476: @425232
    GIM_Reject,
    // Label 8442: @425233
    GIM_Try, /*On fail goto*//*Label 8477*/ GIMT_Encode4(425294),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 8478*/ GIMT_Encode4(425263), // Rule ID 9132 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64trn2:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9132,
        GIR_Done,
      // Label 8478: @425263
      GIM_Try, /*On fail goto*//*Label 8479*/ GIMT_Encode4(425278), // Rule ID 9135 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64trn2:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9135,
        GIR_Done,
      // Label 8479: @425278
      GIM_Try, /*On fail goto*//*Label 8480*/ GIMT_Encode4(425293), // Rule ID 9141 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64trn2:{ *:[nxv8bf16] } nxv8bf16:{ *:[nxv8bf16] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2)  =>  (TRN2_ZZZ_H:{ *:[nxv8bf16] } ?:{ *:[nxv8bf16] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9141,
        GIR_Done,
      // Label 8480: @425293
      GIM_Reject,
    // Label 8477: @425294
    GIM_Reject,
    // Label 8443: @425295
    GIM_Try, /*On fail goto*//*Label 8481*/ GIMT_Encode4(425320), // Rule ID 2395 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // (AArch64trn2:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_B),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2395,
      GIR_Done,
    // Label 8481: @425320
    GIM_Reject,
    // Label 8444: @425321
    GIM_Try, /*On fail goto*//*Label 8482*/ GIMT_Encode4(425346), // Rule ID 9131 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (AArch64trn2:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_B),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9131,
      GIR_Done,
    // Label 8482: @425346
    GIM_Reject,
    // Label 8445: @425347
    GIM_Reject,
    // Label 143: @425348
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8489*/ GIMT_Encode4(425553),
    /*GILLT_s64*//*Label 8483*/ GIMT_Encode4(425391), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 8484*/ GIMT_Encode4(425418),
    /*GILLT_v2s64*//*Label 8485*/ GIMT_Encode4(425445),
    /*GILLT_v4s16*//*Label 8486*/ GIMT_Encode4(425472),
    /*GILLT_v4s32*//*Label 8487*/ GIMT_Encode4(425499), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 8488*/ GIMT_Encode4(425526),
    // Label 8483: @425391
    GIM_Try, /*On fail goto*//*Label 8490*/ GIMT_Encode4(425417), // Rule ID 1058 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64uaddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)  =>  (UADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv2i32_v1i64),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1058,
      GIR_Done,
    // Label 8490: @425417
    GIM_Reject,
    // Label 8484: @425418
    GIM_Try, /*On fail goto*//*Label 8491*/ GIMT_Encode4(425444), // Rule ID 1054 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)  =>  (UADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i16_v2i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1054,
      GIR_Done,
    // Label 8491: @425444
    GIM_Reject,
    // Label 8485: @425445
    GIM_Try, /*On fail goto*//*Label 8492*/ GIMT_Encode4(425471), // Rule ID 1060 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (UADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i32_v2i64),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1060,
      GIR_Done,
    // Label 8492: @425471
    GIM_Reject,
    // Label 8486: @425472
    GIM_Try, /*On fail goto*//*Label 8493*/ GIMT_Encode4(425498), // Rule ID 1050 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)  =>  (UADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i8_v4i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1050,
      GIR_Done,
    // Label 8493: @425498
    GIM_Reject,
    // Label 8487: @425499
    GIM_Try, /*On fail goto*//*Label 8494*/ GIMT_Encode4(425525), // Rule ID 1056 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (UADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i16_v4i32),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1056,
      GIR_Done,
    // Label 8494: @425525
    GIM_Reject,
    // Label 8488: @425526
    GIM_Try, /*On fail goto*//*Label 8495*/ GIMT_Encode4(425552), // Rule ID 1052 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)  =>  (UADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv16i8_v8i16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1052,
      GIR_Done,
    // Label 8495: @425552
    GIM_Reject,
    // Label 8489: @425553
    GIM_Reject,
    // Label 144: @425554
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(9), /*)*//*default:*//*Label 8498*/ GIMT_Encode4(426420),
    /*GILLT_v2s64*//*Label 8496*/ GIMT_Encode4(425577), GIMT_Encode4(0),
    /*GILLT_v4s32*//*Label 8497*/ GIMT_Encode4(425871),
    // Label 8496: @425577
    GIM_Try, /*On fail goto*//*Label 8499*/ GIMT_Encode4(425659), // Rule ID 5908 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (AArch64uaddlv:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v4i32] } 700:{ *:[iPTR] }, V128:{ *:[v8i16] }:$op))  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$op), ssub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // op
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
      // GIR_Coverage, 5908,
      GIR_EraseRootFromParent_Done,
    // Label 8499: @425659
    GIM_Try, /*On fail goto*//*Label 8500*/ GIMT_Encode4(425733), // Rule ID 5907 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (AArch64uaddlv:{ *:[v2i64] } (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$op))  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$op), ssub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // op
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
      // GIR_Coverage, 5907,
      GIR_EraseRootFromParent_Done,
    // Label 8500: @425733
    GIM_Try, /*On fail goto*//*Label 8501*/ GIMT_Encode4(425792), // Rule ID 5917 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64uaddlv:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (UADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i32v),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 5917,
      GIR_EraseRootFromParent_Done,
    // Label 8501: @425792
    GIM_Try, /*On fail goto*//*Label 8502*/ GIMT_Encode4(425870), // Rule ID 6045 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64uaddlv:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (UADDLPv2i32_v1i64:{ *:[i64] } V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv2i32_v1i64),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
      // GIR_Coverage, 6045,
      GIR_EraseRootFromParent_Done,
    // Label 8502: @425870
    GIM_Reject,
    // Label 8497: @425871
    GIM_Try, /*On fail goto*//*Label 8503*/ GIMT_Encode4(425953), // Rule ID 5910 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (AArch64uaddlv:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v8i16] } 700:{ *:[iPTR] }, V128:{ *:[v16i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$op), hsub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // op
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      // GIR_Coverage, 5910,
      GIR_EraseRootFromParent_Done,
    // Label 8503: @425953
    GIM_Try, /*On fail goto*//*Label 8504*/ GIMT_Encode4(426035), // Rule ID 5912 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
      GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
      GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (AArch64uaddlv:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 700:{ *:[iPTR] }, V64:{ *:[v8i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$op), hsub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // op
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      // GIR_Coverage, 5912,
      GIR_EraseRootFromParent_Done,
    // Label 8504: @426035
    GIM_Try, /*On fail goto*//*Label 8505*/ GIMT_Encode4(426109), // Rule ID 5909 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (AArch64uaddlv:{ *:[v4i32] } (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$op), hsub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // op
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      // GIR_Coverage, 5909,
      GIR_EraseRootFromParent_Done,
    // Label 8505: @426109
    GIM_Try, /*On fail goto*//*Label 8506*/ GIMT_Encode4(426183), // Rule ID 5911 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (AArch64uaddlv:{ *:[v4i32] } (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$op), hsub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // op
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      // GIR_Coverage, 5911,
      GIR_EraseRootFromParent_Done,
    // Label 8506: @426183
    GIM_Try, /*On fail goto*//*Label 8507*/ GIMT_Encode4(426242), // Rule ID 5913 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64uaddlv:{ *:[v4i32] } V64:{ *:[v8i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn), hsub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      // GIR_Coverage, 5913,
      GIR_EraseRootFromParent_Done,
    // Label 8507: @426242
    GIM_Try, /*On fail goto*//*Label 8508*/ GIMT_Encode4(426301), // Rule ID 5914 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64uaddlv:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn), ssub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i16v),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
      // GIR_Coverage, 5914,
      GIR_EraseRootFromParent_Done,
    // Label 8508: @426301
    GIM_Try, /*On fail goto*//*Label 8509*/ GIMT_Encode4(426360), // Rule ID 5915 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64uaddlv:{ *:[v4i32] } V128:{ *:[v16i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn), hsub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
      // GIR_Coverage, 5915,
      GIR_EraseRootFromParent_Done,
    // Label 8509: @426360
    GIM_Try, /*On fail goto*//*Label 8510*/ GIMT_Encode4(426419), // Rule ID 5916 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64uaddlv:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn), ssub:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
      // GIR_Coverage, 5916,
      GIR_EraseRootFromParent_Done,
    // Label 8510: @426419
    GIM_Reject,
    // Label 8498: @426420
    GIM_Reject,
    // Label 145: @426421
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(20), /*)*//*default:*//*Label 8515*/ GIMT_Encode4(426790),
    /*GILLT_v2s32*//*Label 8511*/ GIMT_Encode4(426492), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_v4s32*//*Label 8512*/ GIMT_Encode4(426612), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv2s64*//*Label 8513*/ GIMT_Encode4(426732), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_nxv4s32*//*Label 8514*/ GIMT_Encode4(426761),
    // Label 8511: @426492
    GIM_Try, /*On fail goto*//*Label 8516*/ GIMT_Encode4(426611),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8517*/ GIMT_Encode4(426591), // Rule ID 28 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (AArch64udot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, (bitconvert:{ *:[v8i8] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UDOTlanev8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOTlanev8i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 28,
        GIR_EraseRootFromParent_Done,
      // Label 8517: @426591
      GIM_Try, /*On fail goto*//*Label 8518*/ GIMT_Encode4(426610), // Rule ID 24 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (AArch64udot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UDOTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOTv8i8),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24,
        GIR_Done,
      // Label 8518: @426610
      GIM_Reject,
    // Label 8516: @426611
    GIM_Reject,
    // Label 8512: @426612
    GIM_Try, /*On fail goto*//*Label 8519*/ GIMT_Encode4(426731),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8520*/ GIMT_Encode4(426711), // Rule ID 29 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (AArch64udot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, (bitconvert:{ *:[v16i8] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UDOTlanev16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOTlanev16i8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rd
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 29,
        GIR_EraseRootFromParent_Done,
      // Label 8520: @426711
      GIM_Try, /*On fail goto*//*Label 8521*/ GIMT_Encode4(426730), // Rule ID 25 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        // (AArch64udot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UDOTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOTv16i8),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 25,
        GIR_Done,
      // Label 8521: @426730
      GIM_Reject,
    // Label 8519: @426731
    GIM_Reject,
    // Label 8513: @426732
    GIM_Try, /*On fail goto*//*Label 8522*/ GIMT_Encode4(426760), // Rule ID 7786 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (AArch64udot:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UDOT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZ_D),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7786,
      GIR_Done,
    // Label 8522: @426760
    GIM_Reject,
    // Label 8514: @426761
    GIM_Try, /*On fail goto*//*Label 8523*/ GIMT_Encode4(426789), // Rule ID 7785 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (AArch64udot:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UDOT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZ_S),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7785,
      GIR_Done,
    // Label 8523: @426789
    GIM_Reject,
    // Label 8515: @426790
    GIM_Reject,
    // Label 146: @426791
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8527*/ GIMT_Encode4(426907),
    /*GILLT_s16*//*Label 8524*/ GIMT_Encode4(426814),
    /*GILLT_s32*//*Label 8525*/ GIMT_Encode4(426845),
    /*GILLT_s64*//*Label 8526*/ GIMT_Encode4(426876),
    // Label 8524: @426814
    GIM_Try, /*On fail goto*//*Label 8528*/ GIMT_Encode4(426844), // Rule ID 1658 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
      // (AArch64uitof:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (UCVTFv1i16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i16),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1658,
      GIR_Done,
    // Label 8528: @426844
    GIM_Reject,
    // Label 8525: @426845
    GIM_Try, /*On fail goto*//*Label 8529*/ GIMT_Encode4(426875), // Rule ID 1657 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
      // (AArch64uitof:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (UCVTFv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1657,
      GIR_Done,
    // Label 8529: @426875
    GIM_Reject,
    // Label 8526: @426876
    GIM_Try, /*On fail goto*//*Label 8530*/ GIMT_Encode4(426906), // Rule ID 1656 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64uitof:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (UCVTFv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1656,
      GIR_Done,
    // Label 8530: @426906
    GIM_Reject,
    // Label 8527: @426907
    GIM_Reject,
    // Label 147: @426908
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(11), /*)*//*default:*//*Label 8534*/ GIMT_Encode4(428140),
    /*GILLT_v2s64*//*Label 8531*/ GIMT_Encode4(426939), GIMT_Encode4(0),
    /*GILLT_v4s32*//*Label 8532*/ GIMT_Encode4(427500), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 8533*/ GIMT_Encode4(428061),
    // Label 8531: @426939
    GIM_Try, /*On fail goto*//*Label 8535*/ GIMT_Encode4(427499),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8536*/ GIMT_Encode4(427046), // Rule ID 2095 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }))  =>  (UMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2095,
        GIR_EraseRootFromParent_Done,
      // Label 8536: @427046
      GIM_Try, /*On fail goto*//*Label 8537*/ GIMT_Encode4(427138), // Rule ID 13609 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (UMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13609,
        GIR_EraseRootFromParent_Done,
      // Label 8537: @427138
      GIM_Try, /*On fail goto*//*Label 8538*/ GIMT_Encode4(427224), // Rule ID 13607 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13607,
        GIR_EraseRootFromParent_Done,
      // Label 8538: @427224
      GIM_Try, /*On fail goto*//*Label 8539*/ GIMT_Encode4(427310), // Rule ID 2093 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2093,
        GIR_EraseRootFromParent_Done,
      // Label 8539: @427310
      GIM_Try, /*On fail goto*//*Label 8540*/ GIMT_Encode4(427349), // Rule ID 1820 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
        // (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (UMULLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_v2i64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1820,
        GIR_EraseRootFromParent_Done,
      // Label 8540: @427349
      GIM_Try, /*On fail goto*//*Label 8541*/ GIMT_Encode4(427412), // Rule ID 13608 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn)  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13608,
        GIR_EraseRootFromParent_Done,
      // Label 8541: @427412
      GIM_Try, /*On fail goto*//*Label 8542*/ GIMT_Encode4(427475), // Rule ID 2094 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2094,
        GIR_EraseRootFromParent_Done,
      // Label 8542: @427475
      GIM_Try, /*On fail goto*//*Label 8543*/ GIMT_Encode4(427498), // Rule ID 1819 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMULLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_v2i64),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1819,
        GIR_Done,
      // Label 8543: @427498
      GIM_Reject,
    // Label 8535: @427499
    GIM_Reject,
    // Label 8532: @427500
    GIM_Try, /*On fail goto*//*Label 8544*/ GIMT_Encode4(428060),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8545*/ GIMT_Encode4(427607), // Rule ID 2092 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }))  =>  (UMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2092,
        GIR_EraseRootFromParent_Done,
      // Label 8545: @427607
      GIM_Try, /*On fail goto*//*Label 8546*/ GIMT_Encode4(427699), // Rule ID 13606 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (UMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13606,
        GIR_EraseRootFromParent_Done,
      // Label 8546: @427699
      GIM_Try, /*On fail goto*//*Label 8547*/ GIMT_Encode4(427785), // Rule ID 13604 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13604,
        GIR_EraseRootFromParent_Done,
      // Label 8547: @427785
      GIM_Try, /*On fail goto*//*Label 8548*/ GIMT_Encode4(427871), // Rule ID 2090 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[3] Operand 1
        // No operand predicates
        // MIs[1] Operand 2
        GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2090,
        GIR_EraseRootFromParent_Done,
      // Label 8548: @427871
      GIM_Try, /*On fail goto*//*Label 8549*/ GIMT_Encode4(427910), // Rule ID 1818 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
        // (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (UMULLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_v4i32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1818,
        GIR_EraseRootFromParent_Done,
      // Label 8549: @427910
      GIM_Try, /*On fail goto*//*Label 8550*/ GIMT_Encode4(427973), // Rule ID 13605 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn)  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/2, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13605,
        GIR_EraseRootFromParent_Done,
      // Label 8550: @427973
      GIM_Try, /*On fail goto*//*Label 8551*/ GIMT_Encode4(428036), // Rule ID 2091 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2091,
        GIR_EraseRootFromParent_Done,
      // Label 8551: @428036
      GIM_Try, /*On fail goto*//*Label 8552*/ GIMT_Encode4(428059), // Rule ID 1817 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMULLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_v4i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1817,
        GIR_Done,
      // Label 8552: @428059
      GIM_Reject,
    // Label 8544: @428060
    GIM_Reject,
    // Label 8533: @428061
    GIM_Try, /*On fail goto*//*Label 8553*/ GIMT_Encode4(428139),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8554*/ GIMT_Encode4(428115), // Rule ID 1816 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
        // (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))  =>  (UMULLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv16i8_v8i16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1816,
        GIR_EraseRootFromParent_Done,
      // Label 8554: @428115
      GIM_Try, /*On fail goto*//*Label 8555*/ GIMT_Encode4(428138), // Rule ID 1815 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
        // (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMULLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i8_v8i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1815,
        GIR_Done,
      // Label 8555: @428138
      GIM_Reject,
    // Label 8553: @428139
    GIM_Reject,
    // Label 8534: @428140
    GIM_Reject,
    // Label 148: @428141
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8574*/ GIMT_Encode4(428965),
    /*GILLT_v2s32*//*Label 8556*/ GIMT_Encode4(428228),
    /*GILLT_v2s64*//*Label 8557*/ GIMT_Encode4(428283),
    /*GILLT_v4s16*//*Label 8558*/ GIMT_Encode4(428338),
    /*GILLT_v4s32*//*Label 8559*/ GIMT_Encode4(428408),
    /*GILLT_v8s8*//*Label 8560*/ GIMT_Encode4(428463),
    /*GILLT_v8s16*//*Label 8561*/ GIMT_Encode4(428497),
    /*GILLT_v16s8*//*Label 8562*/ GIMT_Encode4(428567), GIMT_Encode4(0),
    /*GILLT_nxv2s1*//*Label 8563*/ GIMT_Encode4(428601),
    /*GILLT_nxv2s16*//*Label 8564*/ GIMT_Encode4(428627),
    /*GILLT_nxv2s32*//*Label 8565*/ GIMT_Encode4(428653),
    /*GILLT_nxv2s64*//*Label 8566*/ GIMT_Encode4(428679),
    /*GILLT_nxv4s1*//*Label 8567*/ GIMT_Encode4(428726),
    /*GILLT_nxv4s16*//*Label 8568*/ GIMT_Encode4(428752),
    /*GILLT_nxv4s32*//*Label 8569*/ GIMT_Encode4(428778),
    /*GILLT_nxv8s1*//*Label 8570*/ GIMT_Encode4(428825),
    /*GILLT_nxv8s16*//*Label 8571*/ GIMT_Encode4(428851),
    /*GILLT_nxv16s1*//*Label 8572*/ GIMT_Encode4(428913),
    /*GILLT_nxv16s8*//*Label 8573*/ GIMT_Encode4(428939),
    // Label 8556: @428228
    GIM_Try, /*On fail goto*//*Label 8575*/ GIMT_Encode4(428282),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8576*/ GIMT_Encode4(428266), // Rule ID 1877 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64uzp1:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UZP1v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1877,
        GIR_Done,
      // Label 8576: @428266
      GIM_Try, /*On fail goto*//*Label 8577*/ GIMT_Encode4(428281), // Rule ID 5514 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64uzp1:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (UZP1v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5514,
        GIR_Done,
      // Label 8577: @428281
      GIM_Reject,
    // Label 8575: @428282
    GIM_Reject,
    // Label 8557: @428283
    GIM_Try, /*On fail goto*//*Label 8578*/ GIMT_Encode4(428337),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8579*/ GIMT_Encode4(428321), // Rule ID 1879 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64uzp1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UZP1v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i64),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1879,
        GIR_Done,
      // Label 8579: @428321
      GIM_Try, /*On fail goto*//*Label 8580*/ GIMT_Encode4(428336), // Rule ID 5516 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64uzp1:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (UZP1v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i64),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5516,
        GIR_Done,
      // Label 8580: @428336
      GIM_Reject,
    // Label 8578: @428337
    GIM_Reject,
    // Label 8558: @428338
    GIM_Try, /*On fail goto*//*Label 8581*/ GIMT_Encode4(428407),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8582*/ GIMT_Encode4(428376), // Rule ID 1875 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64uzp1:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UZP1v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1875,
        GIR_Done,
      // Label 8582: @428376
      GIM_Try, /*On fail goto*//*Label 8583*/ GIMT_Encode4(428391), // Rule ID 5510 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64uzp1:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (UZP1v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5510,
        GIR_Done,
      // Label 8583: @428391
      GIM_Try, /*On fail goto*//*Label 8584*/ GIMT_Encode4(428406), // Rule ID 5511 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64uzp1:{ *:[v4bf16] } V64:{ *:[v4bf16] }:$Rn, V64:{ *:[v4bf16] }:$Rm)  =>  (UZP1v4i16:{ *:[v4bf16] } V64:{ *:[v4bf16] }:$Rn, V64:{ *:[v4bf16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5511,
        GIR_Done,
      // Label 8584: @428406
      GIM_Reject,
    // Label 8581: @428407
    GIM_Reject,
    // Label 8559: @428408
    GIM_Try, /*On fail goto*//*Label 8585*/ GIMT_Encode4(428462),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8586*/ GIMT_Encode4(428446), // Rule ID 1878 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64uzp1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP1v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1878,
        GIR_Done,
      // Label 8586: @428446
      GIM_Try, /*On fail goto*//*Label 8587*/ GIMT_Encode4(428461), // Rule ID 5515 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64uzp1:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (UZP1v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5515,
        GIR_Done,
      // Label 8587: @428461
      GIM_Reject,
    // Label 8585: @428462
    GIM_Reject,
    // Label 8560: @428463
    GIM_Try, /*On fail goto*//*Label 8588*/ GIMT_Encode4(428496), // Rule ID 1873 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64uzp1:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UZP1v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1873,
      GIR_Done,
    // Label 8588: @428496
    GIM_Reject,
    // Label 8561: @428497
    GIM_Try, /*On fail goto*//*Label 8589*/ GIMT_Encode4(428566),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8590*/ GIMT_Encode4(428535), // Rule ID 1876 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64uzp1:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP1v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1876,
        GIR_Done,
      // Label 8590: @428535
      GIM_Try, /*On fail goto*//*Label 8591*/ GIMT_Encode4(428550), // Rule ID 5512 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64uzp1:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (UZP1v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5512,
        GIR_Done,
      // Label 8591: @428550
      GIM_Try, /*On fail goto*//*Label 8592*/ GIMT_Encode4(428565), // Rule ID 5513 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64uzp1:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)  =>  (UZP1v8i16:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5513,
        GIR_Done,
      // Label 8592: @428565
      GIM_Reject,
    // Label 8589: @428566
    GIM_Reject,
    // Label 8562: @428567
    GIM_Try, /*On fail goto*//*Label 8593*/ GIMT_Encode4(428600), // Rule ID 1874 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64uzp1:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP1v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1874,
      GIR_Done,
    // Label 8593: @428600
    GIM_Reject,
    // Label 8563: @428601
    GIM_Try, /*On fail goto*//*Label 8594*/ GIMT_Encode4(428626), // Rule ID 9147 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // (AArch64uzp1:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UZP1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_D),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9147,
      GIR_Done,
    // Label 8594: @428626
    GIM_Reject,
    // Label 8564: @428627
    GIM_Try, /*On fail goto*//*Label 8595*/ GIMT_Encode4(428652), // Rule ID 9105 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (AArch64uzp1:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9105,
      GIR_Done,
    // Label 8595: @428652
    GIM_Reject,
    // Label 8565: @428653
    GIM_Try, /*On fail goto*//*Label 8596*/ GIMT_Encode4(428678), // Rule ID 9106 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (AArch64uzp1:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9106,
      GIR_Done,
    // Label 8596: @428678
    GIM_Reject,
    // Label 8566: @428679
    GIM_Try, /*On fail goto*//*Label 8597*/ GIMT_Encode4(428725),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 8598*/ GIMT_Encode4(428709), // Rule ID 9101 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64uzp1:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9101,
        GIR_Done,
      // Label 8598: @428709
      GIM_Try, /*On fail goto*//*Label 8599*/ GIMT_Encode4(428724), // Rule ID 9107 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64uzp1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9107,
        GIR_Done,
      // Label 8599: @428724
      GIM_Reject,
    // Label 8597: @428725
    GIM_Reject,
    // Label 8567: @428726
    GIM_Try, /*On fail goto*//*Label 8600*/ GIMT_Encode4(428751), // Rule ID 9146 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // (AArch64uzp1:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UZP1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_S),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9146,
      GIR_Done,
    // Label 8600: @428751
    GIM_Reject,
    // Label 8568: @428752
    GIM_Try, /*On fail goto*//*Label 8601*/ GIMT_Encode4(428777), // Rule ID 9103 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (AArch64uzp1:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9103,
      GIR_Done,
    // Label 8601: @428777
    GIM_Reject,
    // Label 8569: @428778
    GIM_Try, /*On fail goto*//*Label 8602*/ GIMT_Encode4(428824),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 8603*/ GIMT_Encode4(428808), // Rule ID 9100 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64uzp1:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9100,
        GIR_Done,
      // Label 8603: @428808
      GIM_Try, /*On fail goto*//*Label 8604*/ GIMT_Encode4(428823), // Rule ID 9104 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64uzp1:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9104,
        GIR_Done,
      // Label 8604: @428823
      GIM_Reject,
    // Label 8602: @428824
    GIM_Reject,
    // Label 8570: @428825
    GIM_Try, /*On fail goto*//*Label 8605*/ GIMT_Encode4(428850), // Rule ID 9145 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // (AArch64uzp1:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UZP1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_H),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9145,
      GIR_Done,
    // Label 8605: @428850
    GIM_Reject,
    // Label 8571: @428851
    GIM_Try, /*On fail goto*//*Label 8606*/ GIMT_Encode4(428912),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 8607*/ GIMT_Encode4(428881), // Rule ID 9099 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64uzp1:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9099,
        GIR_Done,
      // Label 8607: @428881
      GIM_Try, /*On fail goto*//*Label 8608*/ GIMT_Encode4(428896), // Rule ID 9102 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64uzp1:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9102,
        GIR_Done,
      // Label 8608: @428896
      GIM_Try, /*On fail goto*//*Label 8609*/ GIMT_Encode4(428911), // Rule ID 9108 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64uzp1:{ *:[nxv8bf16] } nxv8bf16:{ *:[nxv8bf16] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2)  =>  (UZP1_ZZZ_H:{ *:[nxv8bf16] } ?:{ *:[nxv8bf16] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9108,
        GIR_Done,
      // Label 8609: @428911
      GIM_Reject,
    // Label 8606: @428912
    GIM_Reject,
    // Label 8572: @428913
    GIM_Try, /*On fail goto*//*Label 8610*/ GIMT_Encode4(428938), // Rule ID 2383 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // (AArch64uzp1:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_B),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2383,
      GIR_Done,
    // Label 8610: @428938
    GIM_Reject,
    // Label 8573: @428939
    GIM_Try, /*On fail goto*//*Label 8611*/ GIMT_Encode4(428964), // Rule ID 9098 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (AArch64uzp1:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_B),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9098,
      GIR_Done,
    // Label 8611: @428964
    GIM_Reject,
    // Label 8574: @428965
    GIM_Reject,
    // Label 149: @428966
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8630*/ GIMT_Encode4(429790),
    /*GILLT_v2s32*//*Label 8612*/ GIMT_Encode4(429053),
    /*GILLT_v2s64*//*Label 8613*/ GIMT_Encode4(429108),
    /*GILLT_v4s16*//*Label 8614*/ GIMT_Encode4(429163),
    /*GILLT_v4s32*//*Label 8615*/ GIMT_Encode4(429233),
    /*GILLT_v8s8*//*Label 8616*/ GIMT_Encode4(429288),
    /*GILLT_v8s16*//*Label 8617*/ GIMT_Encode4(429322),
    /*GILLT_v16s8*//*Label 8618*/ GIMT_Encode4(429392), GIMT_Encode4(0),
    /*GILLT_nxv2s1*//*Label 8619*/ GIMT_Encode4(429426),
    /*GILLT_nxv2s16*//*Label 8620*/ GIMT_Encode4(429452),
    /*GILLT_nxv2s32*//*Label 8621*/ GIMT_Encode4(429478),
    /*GILLT_nxv2s64*//*Label 8622*/ GIMT_Encode4(429504),
    /*GILLT_nxv4s1*//*Label 8623*/ GIMT_Encode4(429551),
    /*GILLT_nxv4s16*//*Label 8624*/ GIMT_Encode4(429577),
    /*GILLT_nxv4s32*//*Label 8625*/ GIMT_Encode4(429603),
    /*GILLT_nxv8s1*//*Label 8626*/ GIMT_Encode4(429650),
    /*GILLT_nxv8s16*//*Label 8627*/ GIMT_Encode4(429676),
    /*GILLT_nxv16s1*//*Label 8628*/ GIMT_Encode4(429738),
    /*GILLT_nxv16s8*//*Label 8629*/ GIMT_Encode4(429764),
    // Label 8612: @429053
    GIM_Try, /*On fail goto*//*Label 8631*/ GIMT_Encode4(429107),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8632*/ GIMT_Encode4(429091), // Rule ID 1884 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64uzp2:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UZP2v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1884,
        GIR_Done,
      // Label 8632: @429091
      GIM_Try, /*On fail goto*//*Label 8633*/ GIMT_Encode4(429106), // Rule ID 5521 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64uzp2:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (UZP2v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5521,
        GIR_Done,
      // Label 8633: @429106
      GIM_Reject,
    // Label 8631: @429107
    GIM_Reject,
    // Label 8613: @429108
    GIM_Try, /*On fail goto*//*Label 8634*/ GIMT_Encode4(429162),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8635*/ GIMT_Encode4(429146), // Rule ID 1886 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64uzp2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UZP2v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i64),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1886,
        GIR_Done,
      // Label 8635: @429146
      GIM_Try, /*On fail goto*//*Label 8636*/ GIMT_Encode4(429161), // Rule ID 5523 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64uzp2:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (UZP2v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i64),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5523,
        GIR_Done,
      // Label 8636: @429161
      GIM_Reject,
    // Label 8634: @429162
    GIM_Reject,
    // Label 8614: @429163
    GIM_Try, /*On fail goto*//*Label 8637*/ GIMT_Encode4(429232),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8638*/ GIMT_Encode4(429201), // Rule ID 1882 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64uzp2:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UZP2v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1882,
        GIR_Done,
      // Label 8638: @429201
      GIM_Try, /*On fail goto*//*Label 8639*/ GIMT_Encode4(429216), // Rule ID 5517 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64uzp2:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (UZP2v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5517,
        GIR_Done,
      // Label 8639: @429216
      GIM_Try, /*On fail goto*//*Label 8640*/ GIMT_Encode4(429231), // Rule ID 5518 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64uzp2:{ *:[v4bf16] } V64:{ *:[v4bf16] }:$Rn, V64:{ *:[v4bf16] }:$Rm)  =>  (UZP2v4i16:{ *:[v4bf16] } V64:{ *:[v4bf16] }:$Rn, V64:{ *:[v4bf16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5518,
        GIR_Done,
      // Label 8640: @429231
      GIM_Reject,
    // Label 8637: @429232
    GIM_Reject,
    // Label 8615: @429233
    GIM_Try, /*On fail goto*//*Label 8641*/ GIMT_Encode4(429287),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8642*/ GIMT_Encode4(429271), // Rule ID 1885 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64uzp2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1885,
        GIR_Done,
      // Label 8642: @429271
      GIM_Try, /*On fail goto*//*Label 8643*/ GIMT_Encode4(429286), // Rule ID 5522 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64uzp2:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5522,
        GIR_Done,
      // Label 8643: @429286
      GIM_Reject,
    // Label 8641: @429287
    GIM_Reject,
    // Label 8616: @429288
    GIM_Try, /*On fail goto*//*Label 8644*/ GIMT_Encode4(429321), // Rule ID 1880 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64uzp2:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UZP2v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1880,
      GIR_Done,
    // Label 8644: @429321
    GIM_Reject,
    // Label 8617: @429322
    GIM_Try, /*On fail goto*//*Label 8645*/ GIMT_Encode4(429391),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8646*/ GIMT_Encode4(429360), // Rule ID 1883 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64uzp2:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1883,
        GIR_Done,
      // Label 8646: @429360
      GIM_Try, /*On fail goto*//*Label 8647*/ GIMT_Encode4(429375), // Rule ID 5519 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64uzp2:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5519,
        GIR_Done,
      // Label 8647: @429375
      GIM_Try, /*On fail goto*//*Label 8648*/ GIMT_Encode4(429390), // Rule ID 5520 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64uzp2:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5520,
        GIR_Done,
      // Label 8648: @429390
      GIM_Reject,
    // Label 8645: @429391
    GIM_Reject,
    // Label 8618: @429392
    GIM_Try, /*On fail goto*//*Label 8649*/ GIMT_Encode4(429425), // Rule ID 1881 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64uzp2:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP2v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1881,
      GIR_Done,
    // Label 8649: @429425
    GIM_Reject,
    // Label 8619: @429426
    GIM_Try, /*On fail goto*//*Label 8650*/ GIMT_Encode4(429451), // Rule ID 9150 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // (AArch64uzp2:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UZP2_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_D),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9150,
      GIR_Done,
    // Label 8650: @429451
    GIM_Reject,
    // Label 8620: @429452
    GIM_Try, /*On fail goto*//*Label 8651*/ GIMT_Encode4(429477), // Rule ID 9116 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (AArch64uzp2:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9116,
      GIR_Done,
    // Label 8651: @429477
    GIM_Reject,
    // Label 8621: @429478
    GIM_Try, /*On fail goto*//*Label 8652*/ GIMT_Encode4(429503), // Rule ID 9117 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (AArch64uzp2:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9117,
      GIR_Done,
    // Label 8652: @429503
    GIM_Reject,
    // Label 8622: @429504
    GIM_Try, /*On fail goto*//*Label 8653*/ GIMT_Encode4(429550),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 8654*/ GIMT_Encode4(429534), // Rule ID 9112 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64uzp2:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9112,
        GIR_Done,
      // Label 8654: @429534
      GIM_Try, /*On fail goto*//*Label 8655*/ GIMT_Encode4(429549), // Rule ID 9118 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64uzp2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9118,
        GIR_Done,
      // Label 8655: @429549
      GIM_Reject,
    // Label 8653: @429550
    GIM_Reject,
    // Label 8623: @429551
    GIM_Try, /*On fail goto*//*Label 8656*/ GIMT_Encode4(429576), // Rule ID 9149 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // (AArch64uzp2:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UZP2_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_S),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9149,
      GIR_Done,
    // Label 8656: @429576
    GIM_Reject,
    // Label 8624: @429577
    GIM_Try, /*On fail goto*//*Label 8657*/ GIMT_Encode4(429602), // Rule ID 9114 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (AArch64uzp2:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (UZP2_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_S),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9114,
      GIR_Done,
    // Label 8657: @429602
    GIM_Reject,
    // Label 8625: @429603
    GIM_Try, /*On fail goto*//*Label 8658*/ GIMT_Encode4(429649),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 8659*/ GIMT_Encode4(429633), // Rule ID 9111 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64uzp2:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_S),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9111,
        GIR_Done,
      // Label 8659: @429633
      GIM_Try, /*On fail goto*//*Label 8660*/ GIMT_Encode4(429648), // Rule ID 9115 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64uzp2:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_S),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9115,
        GIR_Done,
      // Label 8660: @429648
      GIM_Reject,
    // Label 8658: @429649
    GIM_Reject,
    // Label 8626: @429650
    GIM_Try, /*On fail goto*//*Label 8661*/ GIMT_Encode4(429675), // Rule ID 9148 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // (AArch64uzp2:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UZP2_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_H),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9148,
      GIR_Done,
    // Label 8661: @429675
    GIM_Reject,
    // Label 8627: @429676
    GIM_Try, /*On fail goto*//*Label 8662*/ GIMT_Encode4(429737),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 8663*/ GIMT_Encode4(429706), // Rule ID 9110 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64uzp2:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9110,
        GIR_Done,
      // Label 8663: @429706
      GIM_Try, /*On fail goto*//*Label 8664*/ GIMT_Encode4(429721), // Rule ID 9113 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64uzp2:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9113,
        GIR_Done,
      // Label 8664: @429721
      GIM_Try, /*On fail goto*//*Label 8665*/ GIMT_Encode4(429736), // Rule ID 9119 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64uzp2:{ *:[nxv8bf16] } nxv8bf16:{ *:[nxv8bf16] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2)  =>  (UZP2_ZZZ_H:{ *:[nxv8bf16] } ?:{ *:[nxv8bf16] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9119,
        GIR_Done,
      // Label 8665: @429736
      GIM_Reject,
    // Label 8662: @429737
    GIM_Reject,
    // Label 8628: @429738
    GIM_Try, /*On fail goto*//*Label 8666*/ GIMT_Encode4(429763), // Rule ID 2387 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // (AArch64uzp2:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_B),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2387,
      GIR_Done,
    // Label 8666: @429763
    GIM_Reject,
    // Label 8629: @429764
    GIM_Try, /*On fail goto*//*Label 8667*/ GIMT_Encode4(429789), // Rule ID 9109 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (AArch64uzp2:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_B),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9109,
      GIR_Done,
    // Label 8667: @429789
    GIM_Reject,
    // Label 8630: @429790
    GIM_Reject,
    // Label 150: @429791
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 8676*/ GIMT_Encode4(430488),
    /*GILLT_s64*//*Label 8668*/ GIMT_Encode4(429838), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 8669*/ GIMT_Encode4(429949),
    /*GILLT_v2s64*//*Label 8670*/ GIMT_Encode4(430026),
    /*GILLT_v4s16*//*Label 8671*/ GIMT_Encode4(430103),
    /*GILLT_v4s32*//*Label 8672*/ GIMT_Encode4(430180),
    /*GILLT_v8s8*//*Label 8673*/ GIMT_Encode4(430257),
    /*GILLT_v8s16*//*Label 8674*/ GIMT_Encode4(430334),
    /*GILLT_v16s8*//*Label 8675*/ GIMT_Encode4(430411),
    // Label 8668: @429838
    GIM_Try, /*On fail goto*//*Label 8677*/ GIMT_Encode4(429948),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8678*/ GIMT_Encode4(429879), // Rule ID 5286 //
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(63),
        // (AArch64vashr:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, 63:{ *:[i32] })  =>  (CMLTv1i64rz:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv1i64rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5286,
        GIR_EraseRootFromParent_Done,
      // Label 8678: @429879
      GIM_Try, /*On fail goto*//*Label 8679*/ GIMT_Encode4(429913), // Rule ID 2107 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64vashr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SSHRd:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRd),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2107,
        GIR_EraseRootFromParent_Done,
      // Label 8679: @429913
      GIM_Try, /*On fail goto*//*Label 8680*/ GIMT_Encode4(429947), // Rule ID 6334 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SSHRd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRd),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6334,
        GIR_EraseRootFromParent_Done,
      // Label 8680: @429947
      GIM_Reject,
    // Label 8677: @429948
    GIM_Reject,
    // Label 8669: @429949
    GIM_Try, /*On fail goto*//*Label 8681*/ GIMT_Encode4(430025),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8682*/ GIMT_Encode4(429990), // Rule ID 4927 //
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(31),
        // (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, 31:{ *:[i32] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4927,
        GIR_EraseRootFromParent_Done,
      // Label 8682: @429990
      GIM_Try, /*On fail goto*//*Label 8683*/ GIMT_Encode4(430024), // Rule ID 2214 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SSHRv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv2i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2214,
        GIR_EraseRootFromParent_Done,
      // Label 8683: @430024
      GIM_Reject,
    // Label 8681: @430025
    GIM_Reject,
    // Label 8670: @430026
    GIM_Try, /*On fail goto*//*Label 8684*/ GIMT_Encode4(430102),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8685*/ GIMT_Encode4(430067), // Rule ID 4931 //
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(63),
        // (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, 63:{ *:[i32] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4931,
        GIR_EraseRootFromParent_Done,
      // Label 8685: @430067
      GIM_Try, /*On fail goto*//*Label 8686*/ GIMT_Encode4(430101), // Rule ID 2216 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SSHRv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv2i64_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2216,
        GIR_EraseRootFromParent_Done,
      // Label 8686: @430101
      GIM_Reject,
    // Label 8684: @430102
    GIM_Reject,
    // Label 8671: @430103
    GIM_Try, /*On fail goto*//*Label 8687*/ GIMT_Encode4(430179),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8688*/ GIMT_Encode4(430144), // Rule ID 4926 //
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(15),
        // (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, 15:{ *:[i32] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4926,
        GIR_EraseRootFromParent_Done,
      // Label 8688: @430144
      GIM_Try, /*On fail goto*//*Label 8689*/ GIMT_Encode4(430178), // Rule ID 2212 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SSHRv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv4i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2212,
        GIR_EraseRootFromParent_Done,
      // Label 8689: @430178
      GIM_Reject,
    // Label 8687: @430179
    GIM_Reject,
    // Label 8672: @430180
    GIM_Try, /*On fail goto*//*Label 8690*/ GIMT_Encode4(430256),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8691*/ GIMT_Encode4(430221), // Rule ID 4930 //
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(31),
        // (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, 31:{ *:[i32] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4930,
        GIR_EraseRootFromParent_Done,
      // Label 8691: @430221
      GIM_Try, /*On fail goto*//*Label 8692*/ GIMT_Encode4(430255), // Rule ID 2215 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SSHRv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv4i32_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2215,
        GIR_EraseRootFromParent_Done,
      // Label 8692: @430255
      GIM_Reject,
    // Label 8690: @430256
    GIM_Reject,
    // Label 8673: @430257
    GIM_Try, /*On fail goto*//*Label 8693*/ GIMT_Encode4(430333),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8694*/ GIMT_Encode4(430298), // Rule ID 4925 //
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
        // (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, 7:{ *:[i32] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4925,
        GIR_EraseRootFromParent_Done,
      // Label 8694: @430298
      GIM_Try, /*On fail goto*//*Label 8695*/ GIMT_Encode4(430332), // Rule ID 2210 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (SSHRv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv8i8_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2210,
        GIR_EraseRootFromParent_Done,
      // Label 8695: @430332
      GIM_Reject,
    // Label 8693: @430333
    GIM_Reject,
    // Label 8674: @430334
    GIM_Try, /*On fail goto*//*Label 8696*/ GIMT_Encode4(430410),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8697*/ GIMT_Encode4(430375), // Rule ID 4929 //
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(15),
        // (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, 15:{ *:[i32] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4929,
        GIR_EraseRootFromParent_Done,
      // Label 8697: @430375
      GIM_Try, /*On fail goto*//*Label 8698*/ GIMT_Encode4(430409), // Rule ID 2213 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SSHRv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv8i16_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2213,
        GIR_EraseRootFromParent_Done,
      // Label 8698: @430409
      GIM_Reject,
    // Label 8696: @430410
    GIM_Reject,
    // Label 8675: @430411
    GIM_Try, /*On fail goto*//*Label 8699*/ GIMT_Encode4(430487),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8700*/ GIMT_Encode4(430452), // Rule ID 4928 //
        // MIs[0] Operand 2
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
        // (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, 7:{ *:[i32] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4928,
        GIR_EraseRootFromParent_Done,
      // Label 8700: @430452
      GIM_Try, /*On fail goto*//*Label 8701*/ GIMT_Encode4(430486), // Rule ID 2211 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (SSHRv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv16i8_shift),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2211,
        GIR_EraseRootFromParent_Done,
      // Label 8701: @430486
      GIM_Reject,
    // Label 8699: @430487
    GIM_Reject,
    // Label 8676: @430488
    GIM_Reject,
    // Label 151: @430489
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 8710*/ GIMT_Encode4(430944),
    /*GILLT_s64*//*Label 8702*/ GIMT_Encode4(430536), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 8703*/ GIMT_Encode4(430622),
    /*GILLT_v2s64*//*Label 8704*/ GIMT_Encode4(430668),
    /*GILLT_v4s16*//*Label 8705*/ GIMT_Encode4(430714),
    /*GILLT_v4s32*//*Label 8706*/ GIMT_Encode4(430760),
    /*GILLT_v8s8*//*Label 8707*/ GIMT_Encode4(430806),
    /*GILLT_v8s16*//*Label 8708*/ GIMT_Encode4(430852),
    /*GILLT_v16s8*//*Label 8709*/ GIMT_Encode4(430898),
    // Label 8702: @430536
    GIM_Try, /*On fail goto*//*Label 8711*/ GIMT_Encode4(430621),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8712*/ GIMT_Encode4(430586), // Rule ID 2116 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64vlshr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (USHRd:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRd),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2116,
        GIR_EraseRootFromParent_Done,
      // Label 8712: @430586
      GIM_Try, /*On fail goto*//*Label 8713*/ GIMT_Encode4(430620), // Rule ID 6340 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // MIs[0] imm
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (USHRd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRd),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
        GIR_RootToRootCopy, /*OpIdx*/1, // Rn
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6340,
        GIR_EraseRootFromParent_Done,
      // Label 8713: @430620
      GIM_Reject,
    // Label 8711: @430621
    GIM_Reject,
    // Label 8703: @430622
    GIM_Try, /*On fail goto*//*Label 8714*/ GIMT_Encode4(430667), // Rule ID 2273 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // MIs[0] imm
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (USHRv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv2i32_shift),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2273,
      GIR_EraseRootFromParent_Done,
    // Label 8714: @430667
    GIM_Reject,
    // Label 8704: @430668
    GIM_Try, /*On fail goto*//*Label 8715*/ GIMT_Encode4(430713), // Rule ID 2275 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // MIs[0] imm
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (USHRv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv2i64_shift),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2275,
      GIR_EraseRootFromParent_Done,
    // Label 8715: @430713
    GIM_Reject,
    // Label 8705: @430714
    GIM_Try, /*On fail goto*//*Label 8716*/ GIMT_Encode4(430759), // Rule ID 2271 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // MIs[0] imm
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (USHRv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i16_shift),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2271,
      GIR_EraseRootFromParent_Done,
    // Label 8716: @430759
    GIM_Reject,
    // Label 8706: @430760
    GIM_Try, /*On fail goto*//*Label 8717*/ GIMT_Encode4(430805), // Rule ID 2274 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // MIs[0] imm
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (USHRv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2274,
      GIR_EraseRootFromParent_Done,
    // Label 8717: @430805
    GIM_Reject,
    // Label 8707: @430806
    GIM_Try, /*On fail goto*//*Label 8718*/ GIMT_Encode4(430851), // Rule ID 2269 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // MIs[0] imm
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (USHRv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv8i8_shift),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2269,
      GIR_EraseRootFromParent_Done,
    // Label 8718: @430851
    GIM_Reject,
    // Label 8708: @430852
    GIM_Try, /*On fail goto*//*Label 8719*/ GIMT_Encode4(430897), // Rule ID 2272 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // MIs[0] imm
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (USHRv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv8i16_shift),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2272,
      GIR_EraseRootFromParent_Done,
    // Label 8719: @430897
    GIM_Reject,
    // Label 8709: @430898
    GIM_Try, /*On fail goto*//*Label 8720*/ GIMT_Encode4(430943), // Rule ID 2270 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // MIs[0] imm
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
      // MIs[1] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (USHRv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv16i8_shift),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
      GIR_RootToRootCopy, /*OpIdx*/1, // Rn
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2270,
      GIR_EraseRootFromParent_Done,
    // Label 8720: @430943
    GIM_Reject,
    // Label 8710: @430944
    GIM_Reject,
    // Label 152: @430945
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8739*/ GIMT_Encode4(431769),
    /*GILLT_v2s32*//*Label 8721*/ GIMT_Encode4(431032),
    /*GILLT_v2s64*//*Label 8722*/ GIMT_Encode4(431087),
    /*GILLT_v4s16*//*Label 8723*/ GIMT_Encode4(431142),
    /*GILLT_v4s32*//*Label 8724*/ GIMT_Encode4(431212),
    /*GILLT_v8s8*//*Label 8725*/ GIMT_Encode4(431267),
    /*GILLT_v8s16*//*Label 8726*/ GIMT_Encode4(431301),
    /*GILLT_v16s8*//*Label 8727*/ GIMT_Encode4(431371), GIMT_Encode4(0),
    /*GILLT_nxv2s1*//*Label 8728*/ GIMT_Encode4(431405),
    /*GILLT_nxv2s16*//*Label 8729*/ GIMT_Encode4(431431),
    /*GILLT_nxv2s32*//*Label 8730*/ GIMT_Encode4(431457),
    /*GILLT_nxv2s64*//*Label 8731*/ GIMT_Encode4(431483),
    /*GILLT_nxv4s1*//*Label 8732*/ GIMT_Encode4(431530),
    /*GILLT_nxv4s16*//*Label 8733*/ GIMT_Encode4(431556),
    /*GILLT_nxv4s32*//*Label 8734*/ GIMT_Encode4(431582),
    /*GILLT_nxv8s1*//*Label 8735*/ GIMT_Encode4(431629),
    /*GILLT_nxv8s16*//*Label 8736*/ GIMT_Encode4(431655),
    /*GILLT_nxv16s1*//*Label 8737*/ GIMT_Encode4(431717),
    /*GILLT_nxv16s8*//*Label 8738*/ GIMT_Encode4(431743),
    // Label 8721: @431032
    GIM_Try, /*On fail goto*//*Label 8740*/ GIMT_Encode4(431086),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8741*/ GIMT_Encode4(431070), // Rule ID 1891 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64zip1:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ZIP1v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1891,
        GIR_Done,
      // Label 8741: @431070
      GIM_Try, /*On fail goto*//*Label 8742*/ GIMT_Encode4(431085), // Rule ID 5528 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64zip1:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (ZIP1v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5528,
        GIR_Done,
      // Label 8742: @431085
      GIM_Reject,
    // Label 8740: @431086
    GIM_Reject,
    // Label 8722: @431087
    GIM_Try, /*On fail goto*//*Label 8743*/ GIMT_Encode4(431141),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8744*/ GIMT_Encode4(431125), // Rule ID 1893 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64zip1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ZIP1v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i64),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1893,
        GIR_Done,
      // Label 8744: @431125
      GIM_Try, /*On fail goto*//*Label 8745*/ GIMT_Encode4(431140), // Rule ID 5530 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64zip1:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (ZIP1v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i64),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5530,
        GIR_Done,
      // Label 8745: @431140
      GIM_Reject,
    // Label 8743: @431141
    GIM_Reject,
    // Label 8723: @431142
    GIM_Try, /*On fail goto*//*Label 8746*/ GIMT_Encode4(431211),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8747*/ GIMT_Encode4(431180), // Rule ID 1889 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64zip1:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ZIP1v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1889,
        GIR_Done,
      // Label 8747: @431180
      GIM_Try, /*On fail goto*//*Label 8748*/ GIMT_Encode4(431195), // Rule ID 5524 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64zip1:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (ZIP1v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5524,
        GIR_Done,
      // Label 8748: @431195
      GIM_Try, /*On fail goto*//*Label 8749*/ GIMT_Encode4(431210), // Rule ID 5525 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64zip1:{ *:[v4bf16] } V64:{ *:[v4bf16] }:$Rn, V64:{ *:[v4bf16] }:$Rm)  =>  (ZIP1v4i16:{ *:[v4bf16] } V64:{ *:[v4bf16] }:$Rn, V64:{ *:[v4bf16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5525,
        GIR_Done,
      // Label 8749: @431210
      GIM_Reject,
    // Label 8746: @431211
    GIM_Reject,
    // Label 8724: @431212
    GIM_Try, /*On fail goto*//*Label 8750*/ GIMT_Encode4(431266),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8751*/ GIMT_Encode4(431250), // Rule ID 1892 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64zip1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ZIP1v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1892,
        GIR_Done,
      // Label 8751: @431250
      GIM_Try, /*On fail goto*//*Label 8752*/ GIMT_Encode4(431265), // Rule ID 5529 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64zip1:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (ZIP1v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5529,
        GIR_Done,
      // Label 8752: @431265
      GIM_Reject,
    // Label 8750: @431266
    GIM_Reject,
    // Label 8725: @431267
    GIM_Try, /*On fail goto*//*Label 8753*/ GIMT_Encode4(431300), // Rule ID 1887 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64zip1:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ZIP1v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1887,
      GIR_Done,
    // Label 8753: @431300
    GIM_Reject,
    // Label 8726: @431301
    GIM_Try, /*On fail goto*//*Label 8754*/ GIMT_Encode4(431370),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8755*/ GIMT_Encode4(431339), // Rule ID 1890 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64zip1:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ZIP1v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1890,
        GIR_Done,
      // Label 8755: @431339
      GIM_Try, /*On fail goto*//*Label 8756*/ GIMT_Encode4(431354), // Rule ID 5526 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64zip1:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (ZIP1v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5526,
        GIR_Done,
      // Label 8756: @431354
      GIM_Try, /*On fail goto*//*Label 8757*/ GIMT_Encode4(431369), // Rule ID 5527 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64zip1:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)  =>  (ZIP1v8i16:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5527,
        GIR_Done,
      // Label 8757: @431369
      GIM_Reject,
    // Label 8754: @431370
    GIM_Reject,
    // Label 8727: @431371
    GIM_Try, /*On fail goto*//*Label 8758*/ GIMT_Encode4(431404), // Rule ID 1888 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64zip1:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ZIP1v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1888,
      GIR_Done,
    // Label 8758: @431404
    GIM_Reject,
    // Label 8728: @431405
    GIM_Try, /*On fail goto*//*Label 8759*/ GIMT_Encode4(431430), // Rule ID 3320 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // (AArch64zip1:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (ZIP1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_D),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3320,
      GIR_Done,
    // Label 8759: @431430
    GIM_Reject,
    // Label 8729: @431431
    GIM_Try, /*On fail goto*//*Label 8760*/ GIMT_Encode4(431456), // Rule ID 2856 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (AArch64zip1:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2856,
      GIR_Done,
    // Label 8760: @431456
    GIM_Reject,
    // Label 8730: @431457
    GIM_Try, /*On fail goto*//*Label 8761*/ GIMT_Encode4(431482), // Rule ID 2857 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (AArch64zip1:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2857,
      GIR_Done,
    // Label 8761: @431482
    GIM_Reject,
    // Label 8731: @431483
    GIM_Try, /*On fail goto*//*Label 8762*/ GIMT_Encode4(431529),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 8763*/ GIMT_Encode4(431513), // Rule ID 2852 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64zip1:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2852,
        GIR_Done,
      // Label 8763: @431513
      GIM_Try, /*On fail goto*//*Label 8764*/ GIMT_Encode4(431528), // Rule ID 2858 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64zip1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2858,
        GIR_Done,
      // Label 8764: @431528
      GIM_Reject,
    // Label 8762: @431529
    GIM_Reject,
    // Label 8732: @431530
    GIM_Try, /*On fail goto*//*Label 8765*/ GIMT_Encode4(431555), // Rule ID 3319 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // (AArch64zip1:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (ZIP1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_S),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3319,
      GIR_Done,
    // Label 8765: @431555
    GIM_Reject,
    // Label 8733: @431556
    GIM_Try, /*On fail goto*//*Label 8766*/ GIMT_Encode4(431581), // Rule ID 2854 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (AArch64zip1:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (ZIP1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_S),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2854,
      GIR_Done,
    // Label 8766: @431581
    GIM_Reject,
    // Label 8734: @431582
    GIM_Try, /*On fail goto*//*Label 8767*/ GIMT_Encode4(431628),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 8768*/ GIMT_Encode4(431612), // Rule ID 2851 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64zip1:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_S),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2851,
        GIR_Done,
      // Label 8768: @431612
      GIM_Try, /*On fail goto*//*Label 8769*/ GIMT_Encode4(431627), // Rule ID 2855 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64zip1:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_S),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2855,
        GIR_Done,
      // Label 8769: @431627
      GIM_Reject,
    // Label 8767: @431628
    GIM_Reject,
    // Label 8735: @431629
    GIM_Try, /*On fail goto*//*Label 8770*/ GIMT_Encode4(431654), // Rule ID 3318 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // (AArch64zip1:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (ZIP1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_H),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3318,
      GIR_Done,
    // Label 8770: @431654
    GIM_Reject,
    // Label 8736: @431655
    GIM_Try, /*On fail goto*//*Label 8771*/ GIMT_Encode4(431716),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 8772*/ GIMT_Encode4(431685), // Rule ID 2850 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64zip1:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2850,
        GIR_Done,
      // Label 8772: @431685
      GIM_Try, /*On fail goto*//*Label 8773*/ GIMT_Encode4(431700), // Rule ID 2853 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64zip1:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2853,
        GIR_Done,
      // Label 8773: @431700
      GIM_Try, /*On fail goto*//*Label 8774*/ GIMT_Encode4(431715), // Rule ID 2859 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64zip1:{ *:[nxv8bf16] } nxv8bf16:{ *:[nxv8bf16] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2)  =>  (ZIP1_ZZZ_H:{ *:[nxv8bf16] } ?:{ *:[nxv8bf16] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2859,
        GIR_Done,
      // Label 8774: @431715
      GIM_Reject,
    // Label 8771: @431716
    GIM_Reject,
    // Label 8737: @431717
    GIM_Try, /*On fail goto*//*Label 8775*/ GIMT_Encode4(431742), // Rule ID 2375 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // (AArch64zip1:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_B),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2375,
      GIR_Done,
    // Label 8775: @431742
    GIM_Reject,
    // Label 8738: @431743
    GIM_Try, /*On fail goto*//*Label 8776*/ GIMT_Encode4(431768), // Rule ID 2849 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (AArch64zip1:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_B),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2849,
      GIR_Done,
    // Label 8776: @431768
    GIM_Reject,
    // Label 8739: @431769
    GIM_Reject,
    // Label 153: @431770
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8795*/ GIMT_Encode4(432594),
    /*GILLT_v2s32*//*Label 8777*/ GIMT_Encode4(431857),
    /*GILLT_v2s64*//*Label 8778*/ GIMT_Encode4(431912),
    /*GILLT_v4s16*//*Label 8779*/ GIMT_Encode4(431967),
    /*GILLT_v4s32*//*Label 8780*/ GIMT_Encode4(432037),
    /*GILLT_v8s8*//*Label 8781*/ GIMT_Encode4(432092),
    /*GILLT_v8s16*//*Label 8782*/ GIMT_Encode4(432126),
    /*GILLT_v16s8*//*Label 8783*/ GIMT_Encode4(432196), GIMT_Encode4(0),
    /*GILLT_nxv2s1*//*Label 8784*/ GIMT_Encode4(432230),
    /*GILLT_nxv2s16*//*Label 8785*/ GIMT_Encode4(432256),
    /*GILLT_nxv2s32*//*Label 8786*/ GIMT_Encode4(432282),
    /*GILLT_nxv2s64*//*Label 8787*/ GIMT_Encode4(432308),
    /*GILLT_nxv4s1*//*Label 8788*/ GIMT_Encode4(432355),
    /*GILLT_nxv4s16*//*Label 8789*/ GIMT_Encode4(432381),
    /*GILLT_nxv4s32*//*Label 8790*/ GIMT_Encode4(432407),
    /*GILLT_nxv8s1*//*Label 8791*/ GIMT_Encode4(432454),
    /*GILLT_nxv8s16*//*Label 8792*/ GIMT_Encode4(432480),
    /*GILLT_nxv16s1*//*Label 8793*/ GIMT_Encode4(432542),
    /*GILLT_nxv16s8*//*Label 8794*/ GIMT_Encode4(432568),
    // Label 8777: @431857
    GIM_Try, /*On fail goto*//*Label 8796*/ GIMT_Encode4(431911),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8797*/ GIMT_Encode4(431895), // Rule ID 1898 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64zip2:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ZIP2v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1898,
        GIR_Done,
      // Label 8797: @431895
      GIM_Try, /*On fail goto*//*Label 8798*/ GIMT_Encode4(431910), // Rule ID 5535 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64zip2:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (ZIP2v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5535,
        GIR_Done,
      // Label 8798: @431910
      GIM_Reject,
    // Label 8796: @431911
    GIM_Reject,
    // Label 8778: @431912
    GIM_Try, /*On fail goto*//*Label 8799*/ GIMT_Encode4(431966),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8800*/ GIMT_Encode4(431950), // Rule ID 1900 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64zip2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ZIP2v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i64),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1900,
        GIR_Done,
      // Label 8800: @431950
      GIM_Try, /*On fail goto*//*Label 8801*/ GIMT_Encode4(431965), // Rule ID 5537 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64zip2:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (ZIP2v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i64),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5537,
        GIR_Done,
      // Label 8801: @431965
      GIM_Reject,
    // Label 8799: @431966
    GIM_Reject,
    // Label 8779: @431967
    GIM_Try, /*On fail goto*//*Label 8802*/ GIMT_Encode4(432036),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8803*/ GIMT_Encode4(432005), // Rule ID 1896 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64zip2:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ZIP2v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1896,
        GIR_Done,
      // Label 8803: @432005
      GIM_Try, /*On fail goto*//*Label 8804*/ GIMT_Encode4(432020), // Rule ID 5531 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64zip2:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (ZIP2v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5531,
        GIR_Done,
      // Label 8804: @432020
      GIM_Try, /*On fail goto*//*Label 8805*/ GIMT_Encode4(432035), // Rule ID 5532 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64zip2:{ *:[v4bf16] } V64:{ *:[v4bf16] }:$Rn, V64:{ *:[v4bf16] }:$Rm)  =>  (ZIP2v4i16:{ *:[v4bf16] } V64:{ *:[v4bf16] }:$Rn, V64:{ *:[v4bf16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5532,
        GIR_Done,
      // Label 8805: @432035
      GIM_Reject,
    // Label 8802: @432036
    GIM_Reject,
    // Label 8780: @432037
    GIM_Try, /*On fail goto*//*Label 8806*/ GIMT_Encode4(432091),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8807*/ GIMT_Encode4(432075), // Rule ID 1899 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64zip2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ZIP2v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1899,
        GIR_Done,
      // Label 8807: @432075
      GIM_Try, /*On fail goto*//*Label 8808*/ GIMT_Encode4(432090), // Rule ID 5536 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64zip2:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (ZIP2v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5536,
        GIR_Done,
      // Label 8808: @432090
      GIM_Reject,
    // Label 8806: @432091
    GIM_Reject,
    // Label 8781: @432092
    GIM_Try, /*On fail goto*//*Label 8809*/ GIMT_Encode4(432125), // Rule ID 1894 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
      // (AArch64zip2:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ZIP2v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1894,
      GIR_Done,
    // Label 8809: @432125
    GIM_Reject,
    // Label 8782: @432126
    GIM_Try, /*On fail goto*//*Label 8810*/ GIMT_Encode4(432195),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8811*/ GIMT_Encode4(432164), // Rule ID 1897 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64zip2:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ZIP2v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1897,
        GIR_Done,
      // Label 8811: @432164
      GIM_Try, /*On fail goto*//*Label 8812*/ GIMT_Encode4(432179), // Rule ID 5533 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64zip2:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (ZIP2v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5533,
        GIR_Done,
      // Label 8812: @432179
      GIM_Try, /*On fail goto*//*Label 8813*/ GIMT_Encode4(432194), // Rule ID 5534 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
        // (AArch64zip2:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)  =>  (ZIP2v8i16:{ *:[v8bf16] } V128:{ *:[v8bf16] }:$Rn, V128:{ *:[v8bf16] }:$Rm)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5534,
        GIR_Done,
      // Label 8813: @432194
      GIM_Reject,
    // Label 8810: @432195
    GIM_Reject,
    // Label 8783: @432196
    GIM_Try, /*On fail goto*//*Label 8814*/ GIMT_Encode4(432229), // Rule ID 1895 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
      // (AArch64zip2:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ZIP2v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v16i8),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1895,
      GIR_Done,
    // Label 8814: @432229
    GIM_Reject,
    // Label 8784: @432230
    GIM_Try, /*On fail goto*//*Label 8815*/ GIMT_Encode4(432255), // Rule ID 9144 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // (AArch64zip2:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (ZIP2_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_D),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9144,
      GIR_Done,
    // Label 8815: @432255
    GIM_Reject,
    // Label 8785: @432256
    GIM_Try, /*On fail goto*//*Label 8816*/ GIMT_Encode4(432281), // Rule ID 9094 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (AArch64zip2:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9094,
      GIR_Done,
    // Label 8816: @432281
    GIM_Reject,
    // Label 8786: @432282
    GIM_Try, /*On fail goto*//*Label 8817*/ GIMT_Encode4(432307), // Rule ID 9095 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (AArch64zip2:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9095,
      GIR_Done,
    // Label 8817: @432307
    GIM_Reject,
    // Label 8787: @432308
    GIM_Try, /*On fail goto*//*Label 8818*/ GIMT_Encode4(432354),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 8819*/ GIMT_Encode4(432338), // Rule ID 9090 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64zip2:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9090,
        GIR_Done,
      // Label 8819: @432338
      GIM_Try, /*On fail goto*//*Label 8820*/ GIMT_Encode4(432353), // Rule ID 9096 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64zip2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9096,
        GIR_Done,
      // Label 8820: @432353
      GIM_Reject,
    // Label 8818: @432354
    GIM_Reject,
    // Label 8788: @432355
    GIM_Try, /*On fail goto*//*Label 8821*/ GIMT_Encode4(432380), // Rule ID 9143 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // (AArch64zip2:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (ZIP2_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_S),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9143,
      GIR_Done,
    // Label 8821: @432380
    GIM_Reject,
    // Label 8789: @432381
    GIM_Try, /*On fail goto*//*Label 8822*/ GIMT_Encode4(432406), // Rule ID 9092 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (AArch64zip2:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (ZIP2_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_S),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9092,
      GIR_Done,
    // Label 8822: @432406
    GIM_Reject,
    // Label 8790: @432407
    GIM_Try, /*On fail goto*//*Label 8823*/ GIMT_Encode4(432453),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 8824*/ GIMT_Encode4(432437), // Rule ID 9089 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64zip2:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_S),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9089,
        GIR_Done,
      // Label 8824: @432437
      GIM_Try, /*On fail goto*//*Label 8825*/ GIMT_Encode4(432452), // Rule ID 9093 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64zip2:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_S),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9093,
        GIR_Done,
      // Label 8825: @432452
      GIM_Reject,
    // Label 8823: @432453
    GIM_Reject,
    // Label 8791: @432454
    GIM_Try, /*On fail goto*//*Label 8826*/ GIMT_Encode4(432479), // Rule ID 9142 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // (AArch64zip2:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (ZIP2_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_H),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9142,
      GIR_Done,
    // Label 8826: @432479
    GIM_Reject,
    // Label 8792: @432480
    GIM_Try, /*On fail goto*//*Label 8827*/ GIMT_Encode4(432541),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      GIM_Try, /*On fail goto*//*Label 8828*/ GIMT_Encode4(432510), // Rule ID 9088 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64zip2:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9088,
        GIR_Done,
      // Label 8828: @432510
      GIM_Try, /*On fail goto*//*Label 8829*/ GIMT_Encode4(432525), // Rule ID 9091 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64zip2:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9091,
        GIR_Done,
      // Label 8829: @432525
      GIM_Try, /*On fail goto*//*Label 8830*/ GIMT_Encode4(432540), // Rule ID 9097 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
        // (AArch64zip2:{ *:[nxv8bf16] } nxv8bf16:{ *:[nxv8bf16] }:$Op1, nxv8bf16:{ *:[nxv8bf16] }:$Op2)  =>  (ZIP2_ZZZ_H:{ *:[nxv8bf16] } ?:{ *:[nxv8bf16] }:$Op1, ?:{ *:[nxv8bf16] }:$Op2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_H),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9097,
        GIR_Done,
      // Label 8830: @432540
      GIM_Reject,
    // Label 8827: @432541
    GIM_Reject,
    // Label 8793: @432542
    GIM_Try, /*On fail goto*//*Label 8831*/ GIMT_Encode4(432567), // Rule ID 2379 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
      // (AArch64zip2:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_B),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2379,
      GIR_Done,
    // Label 8831: @432567
    GIM_Reject,
    // Label 8794: @432568
    GIM_Try, /*On fail goto*//*Label 8832*/ GIMT_Encode4(432593), // Rule ID 9087 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVEorSME),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
      // (AArch64zip2:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_B),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 9087,
      GIR_Done,
    // Label 8832: @432593
    GIM_Reject,
    // Label 8795: @432594
    GIM_Reject,
    // Label 154: @432595
    GIM_Reject,
    }; // Size: 432596 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const AArch64Subtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const AArch64Subtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
